# -*- coding: UTF-8 -*-
# Code automatically generated by pycrate_asn1c

from pycrate_asn1rt.utils            import *
from pycrate_asn1rt.err              import *
from pycrate_asn1rt.glob             import make_GLOBAL, GLOBAL
from pycrate_asn1rt.dictobj          import ASN1Dict
from pycrate_asn1rt.refobj           import *
from pycrate_asn1rt.setobj           import *
from pycrate_asn1rt.asnobj_basic     import *
from pycrate_asn1rt.asnobj_str       import *
from pycrate_asn1rt.asnobj_construct import *
from pycrate_asn1rt.asnobj_class     import *
from pycrate_asn1rt.asnobj_ext       import *
from pycrate_asn1rt.init             import init_modules

class X2AP_CommonDataTypes:

    _name_  = 'X2AP-CommonDataTypes'
    _oid_   = [0, 4, 0, 0, 21, 3, 2, 1, 3]
    
    _obj_ = [
        'maxPrivateIEs',
        'maxProtocolExtensions',
        'maxProtocolIEs',
        'Criticality',
        'Presence',
        'PrivateIE-ID',
        'ProcedureCode',
        'ProtocolIE-ID',
        'TriggeringMessage',
        ]
    _type_ = [
        'Criticality',
        'Presence',
        'PrivateIE-ID',
        'ProcedureCode',
        'ProtocolIE-ID',
        'TriggeringMessage',
        ]
    _set_ = [
        ]
    _val_ = [
        'maxPrivateIEs',
        'maxProtocolExtensions',
        'maxProtocolIEs',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< maxPrivateIEs >-----#
    maxPrivateIEs = INT(name='maxPrivateIEs', mode=MODE_VALUE)
    maxPrivateIEs._val = 65535
    
    #-----< maxProtocolExtensions >-----#
    maxProtocolExtensions = INT(name='maxProtocolExtensions', mode=MODE_VALUE)
    maxProtocolExtensions._val = 65535
    
    #-----< maxProtocolIEs >-----#
    maxProtocolIEs = INT(name='maxProtocolIEs', mode=MODE_VALUE)
    maxProtocolIEs._val = 65535
    
    #-----< Criticality >-----#
    Criticality = ENUM(name='Criticality', mode=MODE_TYPE)
    Criticality._cont = ASN1Dict([('reject', 0), ('ignore', 1), ('notify', 2)])
    Criticality._ext = None
    
    #-----< Presence >-----#
    Presence = ENUM(name='Presence', mode=MODE_TYPE)
    Presence._cont = ASN1Dict([('optional', 0), ('conditional', 1), ('mandatory', 2)])
    Presence._ext = None
    
    #-----< PrivateIE-ID >-----#
    PrivateIE_ID = CHOICE(name='PrivateIE-ID', mode=MODE_TYPE)
    _PrivateIE_ID_local = INT(name='local', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PrivateIE_ID_local._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _PrivateIE_ID_global_ = OID(name='global', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    PrivateIE_ID._cont = ASN1Dict([
        ('local', _PrivateIE_ID_local),
        ('global', _PrivateIE_ID_global_),
        ])
    PrivateIE_ID._ext = None
    
    #-----< ProcedureCode >-----#
    ProcedureCode = INT(name='ProcedureCode', mode=MODE_TYPE)
    ProcedureCode._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< ProtocolIE-ID >-----#
    ProtocolIE_ID = INT(name='ProtocolIE-ID', mode=MODE_TYPE)
    ProtocolIE_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< TriggeringMessage >-----#
    TriggeringMessage = ENUM(name='TriggeringMessage', mode=MODE_TYPE)
    TriggeringMessage._cont = ASN1Dict([('initiating-message', 0), ('successful-outcome', 1), ('unsuccessful-outcome', 2)])
    TriggeringMessage._ext = None
    
    _all_ = [
        maxPrivateIEs,
        maxProtocolExtensions,
        maxProtocolIEs,
        Criticality,
        Presence,
        _PrivateIE_ID_local,
        _PrivateIE_ID_global_,
        PrivateIE_ID,
        ProcedureCode,
        ProtocolIE_ID,
        TriggeringMessage,
    ]

class X2AP_Constants:

    _name_  = 'X2AP-Constants'
    _oid_   = [0, 4, 0, 0, 21, 3, 2, 1, 4]
    
    _obj_ = [
        'id-handoverPreparation',
        'id-handoverCancel',
        'id-loadIndication',
        'id-errorIndication',
        'id-snStatusTransfer',
        'id-uEContextRelease',
        'id-x2Setup',
        'id-reset',
        'id-eNBConfigurationUpdate',
        'id-resourceStatusReportingInitiation',
        'id-resourceStatusReporting',
        'id-privateMessage',
        'id-mobilitySettingsChange',
        'id-rLFIndication',
        'id-handoverReport',
        'id-cellActivation',
        'id-x2Release',
        'id-x2APMessageTransfer',
        'id-x2Removal',
        'id-seNBAdditionPreparation',
        'id-seNBReconfigurationCompletion',
        'id-meNBinitiatedSeNBModificationPreparation',
        'id-seNBinitiatedSeNBModification',
        'id-meNBinitiatedSeNBRelease',
        'id-seNBinitiatedSeNBRelease',
        'id-seNBCounterCheck',
        'id-retrieveUEContext',
        'id-sgNBAdditionPreparation',
        'id-sgNBReconfigurationCompletion',
        'id-meNBinitiatedSgNBModificationPreparation',
        'id-sgNBinitiatedSgNBModification',
        'id-meNBinitiatedSgNBRelease',
        'id-sgNBinitiatedSgNBRelease',
        'id-sgNBCounterCheck',
        'id-sgNBChange',
        'id-rRCTransfer',
        'id-endcX2Setup',
        'id-endcConfigurationUpdate',
        'id-secondaryRATDataUsageReport',
        'id-endcCellActivation',
        'id-endcPartialReset',
        'id-eUTRANRCellResourceCoordination',
        'id-SgNBActivityNotification',
        'id-endcX2Removal',
        'id-dataForwardingAddressIndication',
        'id-gNBStatusIndication',
        'id-deactivateTrace',
        'id-traceStart',
        'id-endcConfigurationTransfer',
        'id-handoverSuccess',
        'id-conditionalHandoverCancel',
        'id-earlyStatusTransfer',
        'id-cellTrafficTrace',
        'id-endcresourceStatusReporting',
        'id-endcresourceStatusReportingInitiation',
        'id-f1CTrafficTransfer',
        'id-UERadioCapabilityIDMapping',
        'id-accessAndMobilityIndication',
        'id-procedure-code-58-not-to-be-used',
        'id-CPC-cancel',
        'maxEARFCN',
        'maxEARFCNPlusOne',
        'newmaxEARFCN',
        'maxInterfaces',
        'maxCellineNB',
        'maxnoofBands',
        'maxnoofBearers',
        'maxNrOfErrors',
        'maxnoofPDCP-SN',
        'maxnoofEPLMNs',
        'maxnoofEPLMNsPlusOne',
        'maxnoofForbLACs',
        'maxnoofForbTACs',
        'maxnoofBPLMNs',
        'maxnoofAdditionalPLMNs',
        'maxnoofNeighbours',
        'maxnoofPRBs',
        'maxPools',
        'maxnoofCells',
        'maxnoofMBSFN',
        'maxFailedMeasObjects',
        'maxnoofCellIDforMDT',
        'maxnoofTAforMDT',
        'maxnoofMBMSServiceAreaIdentities',
        'maxnoofMDTPLMNs',
        'maxnoofCoMPHypothesisSet',
        'maxnoofCoMPCells',
        'maxUEReport',
        'maxCellReport',
        'maxnoofPA',
        'maxCSIProcess',
        'maxCSIReport',
        'maxSubband',
        'maxofNRNeighbours',
        'maxCellinengNB',
        'maxnooftimeperiods',
        'maxnoofCellIDforQMC',
        'maxnoofTAforQMC',
        'maxnoofPLMNforQMC',
        'maxUEsinengNBDU',
        'maxnoofProtectedResourcePatterns',
        'maxnoNRcellsSpectrumSharingWithE-UTRA',
        'maxnoofNrCellBands',
        'maxnoofBluetoothName',
        'maxnoofWLANName',
        'maxnoofextBPLMNs',
        'maxnoofTLAs',
        'maxnoofGTPTLAs',
        'maxnoofTNLAssociations',
        'maxnoofCellsinCHO',
        'maxnoofPC5QoSFlows',
        'maxnoofSSBAreas',
        'maxnoofNRSCSs',
        'maxnoofNRPhysicalResourceBlocks',
        'maxnoofNonAnchorCarrierFreqConfig',
        'maxnoofRACHReports',
        'maxnoofPSCellsPerSN',
        'maxnoofPSCellsPerPrimaryCellinUEHistoryInfo',
        'maxnoofReportedNRCellsPossiblyAggregated',
        'maxnoofPSCellCandidates',
        'maxnoofTargetSgNBs',
        'maxnoofMTCItems',
        'maxnoofCSIRSconfigurations',
        'maxnoofCSIRSneighbourCells',
        'maxnoofCSIRSneighbourCellsInMTC',
        'maxnoofSensorName',
        'maxnoofTargetSgNBsMinusOne',
        'id-E-RABs-Admitted-Item',
        'id-E-RABs-Admitted-List',
        'id-E-RAB-Item',
        'id-E-RABs-NotAdmitted-List',
        'id-E-RABs-ToBeSetup-Item',
        'id-Cause',
        'id-CellInformation',
        'id-CellInformation-Item',
        'id-New-eNB-UE-X2AP-ID',
        'id-Old-eNB-UE-X2AP-ID',
        'id-TargetCell-ID',
        'id-TargeteNBtoSource-eNBTransparentContainer',
        'id-TraceActivation',
        'id-UE-ContextInformation',
        'id-UE-HistoryInformation',
        'id-UE-X2AP-ID',
        'id-CriticalityDiagnostics',
        'id-E-RABs-SubjectToStatusTransfer-List',
        'id-E-RABs-SubjectToStatusTransfer-Item',
        'id-ServedCells',
        'id-GlobalENB-ID',
        'id-TimeToWait',
        'id-GUMMEI-ID',
        'id-GUGroupIDList',
        'id-ServedCellsToAdd',
        'id-ServedCellsToModify',
        'id-ServedCellsToDelete',
        'id-Registration-Request',
        'id-CellToReport',
        'id-ReportingPeriodicity',
        'id-CellToReport-Item',
        'id-CellMeasurementResult',
        'id-CellMeasurementResult-Item',
        'id-GUGroupIDToAddList',
        'id-GUGroupIDToDeleteList',
        'id-SRVCCOperationPossible',
        'id-Measurement-ID',
        'id-ReportCharacteristics',
        'id-ENB1-Measurement-ID',
        'id-ENB2-Measurement-ID',
        'id-Number-of-Antennaports',
        'id-CompositeAvailableCapacityGroup',
        'id-ENB1-Cell-ID',
        'id-ENB2-Cell-ID',
        'id-ENB2-Proposed-Mobility-Parameters',
        'id-ENB1-Mobility-Parameters',
        'id-ENB2-Mobility-Parameters-Modification-Range',
        'id-FailureCellPCI',
        'id-Re-establishmentCellECGI',
        'id-FailureCellCRNTI',
        'id-ShortMAC-I',
        'id-SourceCellECGI',
        'id-FailureCellECGI',
        'id-HandoverReportType',
        'id-PRACH-Configuration',
        'id-MBSFN-Subframe-Info',
        'id-ServedCellsToActivate',
        'id-ActivatedCellList',
        'id-DeactivationIndication',
        'id-UE-RLF-Report-Container',
        'id-ABSInformation',
        'id-InvokeIndication',
        'id-ABS-Status',
        'id-PartialSuccessIndicator',
        'id-MeasurementInitiationResult-List',
        'id-MeasurementInitiationResult-Item',
        'id-MeasurementFailureCause-Item',
        'id-CompleteFailureCauseInformation-List',
        'id-CompleteFailureCauseInformation-Item',
        'id-CSG-Id',
        'id-CSGMembershipStatus',
        'id-MDTConfiguration',
        'id-ManagementBasedMDTallowed',
        'id-RRCConnSetupIndicator',
        'id-NeighbourTAC',
        'id-Time-UE-StayedInCell-EnhancedGranularity',
        'id-RRCConnReestabIndicator',
        'id-MBMS-Service-Area-List',
        'id-HO-cause',
        'id-TargetCellInUTRAN',
        'id-MobilityInformation',
        'id-SourceCellCRNTI',
        'id-MultibandInfoList',
        'id-M3Configuration',
        'id-M4Configuration',
        'id-M5Configuration',
        'id-MDT-Location-Info',
        'id-ManagementBasedMDTPLMNList',
        'id-SignallingBasedMDTPLMNList',
        'id-ReceiveStatusOfULPDCPSDUsExtended',
        'id-ULCOUNTValueExtended',
        'id-DLCOUNTValueExtended',
        'id-eARFCNExtension',
        'id-UL-EARFCNExtension',
        'id-DL-EARFCNExtension',
        'id-AdditionalSpecialSubframe-Info',
        'id-Masked-IMEISV',
        'id-IntendedULDLConfiguration',
        'id-ExtendedULInterferenceOverloadInfo',
        'id-RNL-Header',
        'id-x2APMessage',
        'id-ProSeAuthorized',
        'id-ExpectedUEBehaviour',
        'id-UE-HistoryInformationFromTheUE',
        'id-DynamicDLTransmissionInformation',
        'id-UE-RLF-Report-Container-for-extended-bands',
        'id-CoMPInformation',
        'id-ReportingPeriodicityRSRPMR',
        'id-RSRPMRList',
        'id-MeNB-UE-X2AP-ID',
        'id-SeNB-UE-X2AP-ID',
        'id-UE-SecurityCapabilities',
        'id-SeNBSecurityKey',
        'id-SeNBUEAggregateMaximumBitRate',
        'id-ServingPLMN',
        'id-E-RABs-ToBeAdded-List',
        'id-E-RABs-ToBeAdded-Item',
        'id-MeNBtoSeNBContainer',
        'id-E-RABs-Admitted-ToBeAdded-List',
        'id-E-RABs-Admitted-ToBeAdded-Item',
        'id-SeNBtoMeNBContainer',
        'id-ResponseInformationSeNBReconfComp',
        'id-UE-ContextInformationSeNBModReq',
        'id-E-RABs-ToBeAdded-ModReqItem',
        'id-E-RABs-ToBeModified-ModReqItem',
        'id-E-RABs-ToBeReleased-ModReqItem',
        'id-E-RABs-Admitted-ToBeAdded-ModAckList',
        'id-E-RABs-Admitted-ToBeModified-ModAckList',
        'id-E-RABs-Admitted-ToBeReleased-ModAckList',
        'id-E-RABs-Admitted-ToBeAdded-ModAckItem',
        'id-E-RABs-Admitted-ToBeModified-ModAckItem',
        'id-E-RABs-Admitted-ToBeReleased-ModAckItem',
        'id-E-RABs-ToBeReleased-ModReqd',
        'id-E-RABs-ToBeReleased-ModReqdItem',
        'id-SCGChangeIndication',
        'id-E-RABs-ToBeReleased-List-RelReq',
        'id-E-RABs-ToBeReleased-RelReqItem',
        'id-E-RABs-ToBeReleased-List-RelConf',
        'id-E-RABs-ToBeReleased-RelConfItem',
        'id-E-RABs-SubjectToCounterCheck-List',
        'id-E-RABs-SubjectToCounterCheckItem',
        'id-CoverageModificationList',
        'id-ReportingPeriodicityCSIR',
        'id-CSIReportList',
        'id-UEID',
        'id-enhancedRNTP',
        'id-ProSeUEtoNetworkRelaying',
        'id-ReceiveStatusOfULPDCPSDUsPDCP-SNlength18',
        'id-ULCOUNTValuePDCP-SNlength18',
        'id-DLCOUNTValuePDCP-SNlength18',
        'id-UE-ContextReferenceAtSeNB',
        'id-UE-ContextKeptIndicator',
        'id-New-eNB-UE-X2AP-ID-Extension',
        'id-Old-eNB-UE-X2AP-ID-Extension',
        'id-MeNB-UE-X2AP-ID-Extension',
        'id-SeNB-UE-X2AP-ID-Extension',
        'id-LHN-ID',
        'id-FreqBandIndicatorPriority',
        'id-M6Configuration',
        'id-M7Configuration',
        'id-Tunnel-Information-for-BBF',
        'id-SIPTO-BearerDeactivationIndication',
        'id-GW-TransportLayerAddress',
        'id-Correlation-ID',
        'id-SIPTO-Correlation-ID',
        'id-SIPTO-L-GW-TransportLayerAddress',
        'id-X2RemovalThreshold',
        'id-CellReportingIndicator',
        'id-BearerType',
        'id-resumeID',
        'id-UE-ContextInformationRetrieve',
        'id-E-RABs-ToBeSetupRetrieve-Item',
        'id-NewEUTRANCellIdentifier',
        'id-V2XServicesAuthorized',
        'id-OffsetOfNbiotChannelNumberToDL-EARFCN',
        'id-OffsetOfNbiotChannelNumberToUL-EARFCN',
        'id-AdditionalSpecialSubframeExtension-Info',
        'id-BandwidthReducedSI',
        'id-MakeBeforeBreakIndicator',
        'id-UE-ContextReferenceAtWT',
        'id-WT-UE-ContextKeptIndicator',
        'id-UESidelinkAggregateMaximumBitRate',
        'id-uL-GTPtunnelEndpoint',
        'id-DL-scheduling-PDCCH-CCE-usage',
        'id-UL-scheduling-PDCCH-CCE-usage',
        'id-UEAppLayerMeasConfig',
        'id-extended-e-RAB-MaximumBitrateDL',
        'id-extended-e-RAB-MaximumBitrateUL',
        'id-extended-e-RAB-GuaranteedBitrateDL',
        'id-extended-e-RAB-GuaranteedBitrateUL',
        'id-extended-uEaggregateMaximumBitRateDownlink',
        'id-extended-uEaggregateMaximumBitRateUplink',
        'id-NRrestrictioninEPSasSecondaryRAT',
        'id-SgNBSecurityKey',
        'id-SgNBUEAggregateMaximumBitRate',
        'id-E-RABs-ToBeAdded-SgNBAddReqList',
        'id-MeNBtoSgNBContainer',
        'id-SgNB-UE-X2AP-ID',
        'id-RequestedSplitSRBs',
        'id-E-RABs-ToBeAdded-SgNBAddReq-Item',
        'id-E-RABs-Admitted-ToBeAdded-SgNBAddReqAckList',
        'id-SgNBtoMeNBContainer',
        'id-AdmittedSplitSRBs',
        'id-E-RABs-Admitted-ToBeAdded-SgNBAddReqAck-Item',
        'id-ResponseInformationSgNBReconfComp',
        'id-UE-ContextInformation-SgNBModReq',
        'id-E-RABs-ToBeAdded-SgNBModReq-Item',
        'id-E-RABs-ToBeModified-SgNBModReq-Item',
        'id-E-RABs-ToBeReleased-SgNBModReq-Item',
        'id-E-RABs-Admitted-ToBeAdded-SgNBModAckList',
        'id-E-RABs-Admitted-ToBeModified-SgNBModAckList',
        'id-E-RABs-Admitted-ToBeReleased-SgNBModAckList',
        'id-E-RABs-Admitted-ToBeAdded-SgNBModAck-Item',
        'id-E-RABs-Admitted-ToBeModified-SgNBModAck-Item',
        'id-E-RABs-Admitted-ToBeReleased-SgNBModAck-Item',
        'id-E-RABs-ToBeReleased-SgNBModReqdList',
        'id-E-RABs-ToBeModified-SgNBModReqdList',
        'id-E-RABs-ToBeReleased-SgNBModReqd-Item',
        'id-E-RABs-ToBeModified-SgNBModReqd-Item',
        'id-E-RABs-ToBeReleased-SgNBChaConfList',
        'id-E-RABs-ToBeReleased-SgNBChaConf-Item',
        'id-E-RABs-ToBeReleased-SgNBRelReqList',
        'id-E-RABs-ToBeReleased-SgNBRelReq-Item',
        'id-E-RABs-ToBeReleased-SgNBRelConfList',
        'id-E-RABs-ToBeReleased-SgNBRelConf-Item',
        'id-E-RABs-SubjectToSgNBCounterCheck-List',
        'id-E-RABs-SubjectToSgNBCounterCheck-Item',
        'id-RRCContainer',
        'id-SRBType',
        'id-Target-SgNB-ID',
        'id-HandoverRestrictionList',
        'id-SCGConfigurationQuery',
        'id-SplitSRB',
        'id-NRUeReport',
        'id-InitiatingNodeType-EndcX2Setup',
        'id-InitiatingNodeType-EndcConfigUpdate',
        'id-RespondingNodeType-EndcX2Setup',
        'id-RespondingNodeType-EndcConfigUpdate',
        'id-NRUESecurityCapabilities',
        'id-PDCPChangeIndication',
        'id-ServedEUTRAcellsENDCX2ManagementList',
        'id-CellAssistanceInformation',
        'id-Globalen-gNB-ID',
        'id-ServedNRcellsENDCX2ManagementList',
        'id-UE-ContextReferenceAtSgNB',
        'id-SecondaryRATUsageReport',
        'id-ActivationID',
        'id-MeNBResourceCoordinationInformation',
        'id-SgNBResourceCoordinationInformation',
        'id-ServedEUTRAcellsToModifyListENDCConfUpd',
        'id-ServedEUTRAcellsToDeleteListENDCConfUpd',
        'id-ServedNRcellsToModifyListENDCConfUpd',
        'id-ServedNRcellsToDeleteListENDCConfUpd',
        'id-E-RABUsageReport-Item',
        'id-Old-SgNB-UE-X2AP-ID',
        'id-SecondaryRATUsageReportList',
        'id-SecondaryRATUsageReport-Item',
        'id-ServedNRCellsToActivate',
        'id-ActivatedNRCellList',
        'id-SelectedPLMN',
        'id-UEs-ToBeReset',
        'id-UEs-Admitted-ToBeReset',
        'id-RRCConfigIndication',
        'id-DownlinkPacketLossRate',
        'id-UplinkPacketLossRate',
        'id-SubscriberProfileIDforRFP',
        'id-serviceType',
        'id-AerialUEsubscriptionInformation',
        'id-SGNB-Addition-Trigger-Ind',
        'id-MeNBCell-ID',
        'id-RequestedSplitSRBsrelease',
        'id-AdmittedSplitSRBsrelease',
        'id-NRS-NSSS-PowerOffset',
        'id-NSSS-NumOccasionDifferentPrecoder',
        'id-ProtectedEUTRAResourceIndication',
        'id-InitiatingNodeType-EutranrCellResourceCoordination',
        'id-RespondingNodeType-EutranrCellResourceCoordination',
        'id-DataTrafficResourceIndication',
        'id-SpectrumSharingGroupID',
        'id-ListofEUTRACellsinEUTRACoordinationReq',
        'id-ListofEUTRACellsinEUTRACoordinationResp',
        'id-ListofEUTRACellsinNRCoordinationReq',
        'id-ListofNRCellsinNRCoordinationReq',
        'id-ListofNRCellsinNRCoordinationResp',
        'id-E-RABs-AdmittedToBeModified-SgNBModConfList',
        'id-E-RABs-AdmittedToBeModified-SgNBModConf-Item',
        'id-UEContextLevelUserPlaneActivity',
        'id-ERABActivityNotifyItemList',
        'id-InitiatingNodeType-EndcX2Removal',
        'id-RespondingNodeType-EndcX2Removal',
        'id-RLC-Status',
        'id-CNTypeRestrictions',
        'id-uLpDCPSnLength',
        'id-BluetoothMeasurementConfiguration',
        'id-WLANMeasurementConfiguration',
        'id-NRrestrictionin5GS',
        'id-dL-Forwarding',
        'id-E-RABs-DataForwardingAddress-List',
        'id-E-RABs-DataForwardingAddress-Item',
        'id-Subscription-Based-UE-DifferentiationInfo',
        'id-GNBOverloadInformation',
        'id-dLPDCPSnLength',
        'id-secondarysgNBDLGTPTEIDatPDCP',
        'id-secondarymeNBULGTPTEIDatPDCP',
        'id-lCID',
        'id-duplicationActivation',
        'id-ECGI',
        'id-RLCMode-transferred',
        'id-E-RABs-Admitted-ToBeReleased-SgNBRelReqAckList',
        'id-E-RABs-Admitted-ToBeReleased-SgNBRelReqAck-Item',
        'id-E-RABs-ToBeReleased-SgNBRelReqdList',
        'id-E-RABs-ToBeReleased-SgNBRelReqd-Item',
        'id-NRCGI',
        'id-MeNBCoordinationAssistanceInformation',
        'id-SgNBCoordinationAssistanceInformation',
        'id-new-drb-ID-req',
        'id-endcSONConfigurationTransfer',
        'id-NRNeighbourInfoToAdd',
        'id-NRNeighbourInfoToModify',
        'id-DesiredActNotificationLevel',
        'id-LocationInformationSgNBReporting',
        'id-LocationInformationSgNB',
        'id-LastNG-RANPLMNIdentity',
        'id-EUTRANTraceID',
        'id-additionalPLMNs-Item',
        'id-InterfaceInstanceIndication',
        'id-BPLMN-ID-Info-EUTRA',
        'id-BPLMN-ID-Info-NR',
        'id-NBIoT-UL-DL-AlignmentOffset',
        'id-ERABs-transferred-to-MeNB',
        'id-AdditionalRRMPriorityIndex',
        'id-LowerLayerPresenceStatusChange',
        'id-FastMCGRecovery-SN-to-MN',
        'id-RequestedFastMCGRecoveryViaSRB3',
        'id-AvailableFastMCGRecoveryViaSRB3',
        'id-RequestedFastMCGRecoveryViaSRB3Release',
        'id-ReleaseFastMCGRecoveryViaSRB3',
        'id-FastMCGRecovery-MN-to-SN',
        'id-PartialListIndicator',
        'id-MaximumCellListSize',
        'id-MessageOversizeNotification',
        'id-CellandCapacityAssistInfo',
        'id-TNLConfigurationInfo',
        'id-TNLA-To-Add-List',
        'id-TNLA-To-Update-List',
        'id-TNLA-To-Remove-List',
        'id-TNLA-Setup-List',
        'id-TNLA-Failed-To-Setup-List',
        'id-UnlicensedSpectrumRestriction',
        'id-UEContextReferenceatSourceNGRAN',
        'id-EPCHandoverRestrictionListContainer',
        'id-CHOinformation-REQ',
        'id-CHOinformation-ACK',
        'id-DAPSRequestInfo',
        'id-RequestedTargetCellID',
        'id-CandidateCellsToBeCancelledList',
        'id-DAPSResponseInfo',
        'id-ProcedureStage',
        'id-CHO-DC-Indicator',
        'id-Ethernet-Type',
        'id-NRV2XServicesAuthorized',
        'id-NRUESidelinkAggregateMaximumBitRate',
        'id-PC5QoSParameters',
        'id-NPRACHConfiguration',
        'id-NBIoT-RLF-Report-Container',
        'id-MDTConfigurationNR',
        'id-PrivacyIndicator',
        'id-TraceCollectionEntityIPAddress',
        'id-UERadioCapabilityID',
        'id-SNtriggered',
        'id-CSI-RSTransmissionIndication',
        'id-DLCarrierList',
        'id-TargetCellInNGRAN',
        'id-E-UTRAN-Node1-Measurement-ID',
        'id-E-UTRAN-Node2-Measurement-ID',
        'id-TDDULDLConfigurationCommonNR',
        'id-CarrierList',
        'id-ULCarrierList',
        'id-FrequencyShift7p5khz',
        'id-SSB-PositionsInBurst',
        'id-NRCellPRACHConfig',
        'id-CellToReport-NR-ENDC',
        'id-CellToReport-NR-ENDC-Item',
        'id-CellMeasurementResult-NR-ENDC',
        'id-CellMeasurementResult-NR-ENDC-Item',
        'id-IABNodeIndication',
        'id-QoS-Mapping-Information',
        'id-F1CTrafficContainer',
        'id-IntendedTDD-DL-ULConfiguration-NR',
        'id-UERadioCapability',
        'id-CellMeasurementResult-E-UTRA-ENDC',
        'id-CellMeasurementResult-E-UTRA-ENDC-Item',
        'id-CellToReport-E-UTRA-ENDC',
        'id-CellToReport-E-UTRA-ENDC-Item',
        'id-TraceCollectionEntityURI',
        'id-SFN-Offset',
        'id-CHO-DC-EarlyDataForwarding',
        'id-IMSvoiceEPSfallbackfrom5G',
        'id-AdditionLocationInformation',
        'id-DirectForwardingPathAvailability',
        'id-sourceNG-RAN-node-id',
        'id-SourceDLForwardingIPAddress',
        'id-SourceNodeDLForwardingIPAddress',
        'id-NRRACHReportInformation',
        'id-SCG-UE-HistoryInformation',
        'id-PSCellHistoryInformationRetrieve',
        'id-MeasurementResultforNRCellsPossiblyAggregated',
        'id-PSCell-UE-HistoryInformation',
        'id-PSCellChangeHistory',
        'id-CHOinformation-AddReq',
        'id-CHOinformation-ModReq',
        'id-SCGActivationStatus',
        'id-SCGActivationRequest',
        'id-CPAinformation-REQ',
        'id-CPAinformation-REQ-ACK',
        'id-CPAinformation-MOD',
        'id-CPAinformation-MOD-ACK',
        'id-CPACinformation-REQD',
        'id-CPCinformation-REQD',
        'id-CPCinformation-CONF',
        'id-CPCinformation-NOTIFY',
        'id-CPCupdate-MOD',
        'id-Additional-Measurement-Timing-Configuration-List',
        'id-ServedCellSpecificInfoReq-NR',
        'id-SecurityIndication',
        'id-SecurityResult',
        'id-RAT-Restrictions',
        'id-SCGreconfigNotification',
        'id-MIMOPRBusageInformation',
        'id-SensorMeasurementConfiguration',
        'id-AdditionalListofForwardingGTPTunnelEndpoint',
        ]
    _type_ = [
        ]
    _set_ = [
        ]
    _val_ = [
        'id-handoverPreparation',
        'id-handoverCancel',
        'id-loadIndication',
        'id-errorIndication',
        'id-snStatusTransfer',
        'id-uEContextRelease',
        'id-x2Setup',
        'id-reset',
        'id-eNBConfigurationUpdate',
        'id-resourceStatusReportingInitiation',
        'id-resourceStatusReporting',
        'id-privateMessage',
        'id-mobilitySettingsChange',
        'id-rLFIndication',
        'id-handoverReport',
        'id-cellActivation',
        'id-x2Release',
        'id-x2APMessageTransfer',
        'id-x2Removal',
        'id-seNBAdditionPreparation',
        'id-seNBReconfigurationCompletion',
        'id-meNBinitiatedSeNBModificationPreparation',
        'id-seNBinitiatedSeNBModification',
        'id-meNBinitiatedSeNBRelease',
        'id-seNBinitiatedSeNBRelease',
        'id-seNBCounterCheck',
        'id-retrieveUEContext',
        'id-sgNBAdditionPreparation',
        'id-sgNBReconfigurationCompletion',
        'id-meNBinitiatedSgNBModificationPreparation',
        'id-sgNBinitiatedSgNBModification',
        'id-meNBinitiatedSgNBRelease',
        'id-sgNBinitiatedSgNBRelease',
        'id-sgNBCounterCheck',
        'id-sgNBChange',
        'id-rRCTransfer',
        'id-endcX2Setup',
        'id-endcConfigurationUpdate',
        'id-secondaryRATDataUsageReport',
        'id-endcCellActivation',
        'id-endcPartialReset',
        'id-eUTRANRCellResourceCoordination',
        'id-SgNBActivityNotification',
        'id-endcX2Removal',
        'id-dataForwardingAddressIndication',
        'id-gNBStatusIndication',
        'id-deactivateTrace',
        'id-traceStart',
        'id-endcConfigurationTransfer',
        'id-handoverSuccess',
        'id-conditionalHandoverCancel',
        'id-earlyStatusTransfer',
        'id-cellTrafficTrace',
        'id-endcresourceStatusReporting',
        'id-endcresourceStatusReportingInitiation',
        'id-f1CTrafficTransfer',
        'id-UERadioCapabilityIDMapping',
        'id-accessAndMobilityIndication',
        'id-procedure-code-58-not-to-be-used',
        'id-CPC-cancel',
        'maxEARFCN',
        'maxEARFCNPlusOne',
        'newmaxEARFCN',
        'maxInterfaces',
        'maxCellineNB',
        'maxnoofBands',
        'maxnoofBearers',
        'maxNrOfErrors',
        'maxnoofPDCP-SN',
        'maxnoofEPLMNs',
        'maxnoofEPLMNsPlusOne',
        'maxnoofForbLACs',
        'maxnoofForbTACs',
        'maxnoofBPLMNs',
        'maxnoofAdditionalPLMNs',
        'maxnoofNeighbours',
        'maxnoofPRBs',
        'maxPools',
        'maxnoofCells',
        'maxnoofMBSFN',
        'maxFailedMeasObjects',
        'maxnoofCellIDforMDT',
        'maxnoofTAforMDT',
        'maxnoofMBMSServiceAreaIdentities',
        'maxnoofMDTPLMNs',
        'maxnoofCoMPHypothesisSet',
        'maxnoofCoMPCells',
        'maxUEReport',
        'maxCellReport',
        'maxnoofPA',
        'maxCSIProcess',
        'maxCSIReport',
        'maxSubband',
        'maxofNRNeighbours',
        'maxCellinengNB',
        'maxnooftimeperiods',
        'maxnoofCellIDforQMC',
        'maxnoofTAforQMC',
        'maxnoofPLMNforQMC',
        'maxUEsinengNBDU',
        'maxnoofProtectedResourcePatterns',
        'maxnoNRcellsSpectrumSharingWithE-UTRA',
        'maxnoofNrCellBands',
        'maxnoofBluetoothName',
        'maxnoofWLANName',
        'maxnoofextBPLMNs',
        'maxnoofTLAs',
        'maxnoofGTPTLAs',
        'maxnoofTNLAssociations',
        'maxnoofCellsinCHO',
        'maxnoofPC5QoSFlows',
        'maxnoofSSBAreas',
        'maxnoofNRSCSs',
        'maxnoofNRPhysicalResourceBlocks',
        'maxnoofNonAnchorCarrierFreqConfig',
        'maxnoofRACHReports',
        'maxnoofPSCellsPerSN',
        'maxnoofPSCellsPerPrimaryCellinUEHistoryInfo',
        'maxnoofReportedNRCellsPossiblyAggregated',
        'maxnoofPSCellCandidates',
        'maxnoofTargetSgNBs',
        'maxnoofMTCItems',
        'maxnoofCSIRSconfigurations',
        'maxnoofCSIRSneighbourCells',
        'maxnoofCSIRSneighbourCellsInMTC',
        'maxnoofSensorName',
        'maxnoofTargetSgNBsMinusOne',
        'id-E-RABs-Admitted-Item',
        'id-E-RABs-Admitted-List',
        'id-E-RAB-Item',
        'id-E-RABs-NotAdmitted-List',
        'id-E-RABs-ToBeSetup-Item',
        'id-Cause',
        'id-CellInformation',
        'id-CellInformation-Item',
        'id-New-eNB-UE-X2AP-ID',
        'id-Old-eNB-UE-X2AP-ID',
        'id-TargetCell-ID',
        'id-TargeteNBtoSource-eNBTransparentContainer',
        'id-TraceActivation',
        'id-UE-ContextInformation',
        'id-UE-HistoryInformation',
        'id-UE-X2AP-ID',
        'id-CriticalityDiagnostics',
        'id-E-RABs-SubjectToStatusTransfer-List',
        'id-E-RABs-SubjectToStatusTransfer-Item',
        'id-ServedCells',
        'id-GlobalENB-ID',
        'id-TimeToWait',
        'id-GUMMEI-ID',
        'id-GUGroupIDList',
        'id-ServedCellsToAdd',
        'id-ServedCellsToModify',
        'id-ServedCellsToDelete',
        'id-Registration-Request',
        'id-CellToReport',
        'id-ReportingPeriodicity',
        'id-CellToReport-Item',
        'id-CellMeasurementResult',
        'id-CellMeasurementResult-Item',
        'id-GUGroupIDToAddList',
        'id-GUGroupIDToDeleteList',
        'id-SRVCCOperationPossible',
        'id-Measurement-ID',
        'id-ReportCharacteristics',
        'id-ENB1-Measurement-ID',
        'id-ENB2-Measurement-ID',
        'id-Number-of-Antennaports',
        'id-CompositeAvailableCapacityGroup',
        'id-ENB1-Cell-ID',
        'id-ENB2-Cell-ID',
        'id-ENB2-Proposed-Mobility-Parameters',
        'id-ENB1-Mobility-Parameters',
        'id-ENB2-Mobility-Parameters-Modification-Range',
        'id-FailureCellPCI',
        'id-Re-establishmentCellECGI',
        'id-FailureCellCRNTI',
        'id-ShortMAC-I',
        'id-SourceCellECGI',
        'id-FailureCellECGI',
        'id-HandoverReportType',
        'id-PRACH-Configuration',
        'id-MBSFN-Subframe-Info',
        'id-ServedCellsToActivate',
        'id-ActivatedCellList',
        'id-DeactivationIndication',
        'id-UE-RLF-Report-Container',
        'id-ABSInformation',
        'id-InvokeIndication',
        'id-ABS-Status',
        'id-PartialSuccessIndicator',
        'id-MeasurementInitiationResult-List',
        'id-MeasurementInitiationResult-Item',
        'id-MeasurementFailureCause-Item',
        'id-CompleteFailureCauseInformation-List',
        'id-CompleteFailureCauseInformation-Item',
        'id-CSG-Id',
        'id-CSGMembershipStatus',
        'id-MDTConfiguration',
        'id-ManagementBasedMDTallowed',
        'id-RRCConnSetupIndicator',
        'id-NeighbourTAC',
        'id-Time-UE-StayedInCell-EnhancedGranularity',
        'id-RRCConnReestabIndicator',
        'id-MBMS-Service-Area-List',
        'id-HO-cause',
        'id-TargetCellInUTRAN',
        'id-MobilityInformation',
        'id-SourceCellCRNTI',
        'id-MultibandInfoList',
        'id-M3Configuration',
        'id-M4Configuration',
        'id-M5Configuration',
        'id-MDT-Location-Info',
        'id-ManagementBasedMDTPLMNList',
        'id-SignallingBasedMDTPLMNList',
        'id-ReceiveStatusOfULPDCPSDUsExtended',
        'id-ULCOUNTValueExtended',
        'id-DLCOUNTValueExtended',
        'id-eARFCNExtension',
        'id-UL-EARFCNExtension',
        'id-DL-EARFCNExtension',
        'id-AdditionalSpecialSubframe-Info',
        'id-Masked-IMEISV',
        'id-IntendedULDLConfiguration',
        'id-ExtendedULInterferenceOverloadInfo',
        'id-RNL-Header',
        'id-x2APMessage',
        'id-ProSeAuthorized',
        'id-ExpectedUEBehaviour',
        'id-UE-HistoryInformationFromTheUE',
        'id-DynamicDLTransmissionInformation',
        'id-UE-RLF-Report-Container-for-extended-bands',
        'id-CoMPInformation',
        'id-ReportingPeriodicityRSRPMR',
        'id-RSRPMRList',
        'id-MeNB-UE-X2AP-ID',
        'id-SeNB-UE-X2AP-ID',
        'id-UE-SecurityCapabilities',
        'id-SeNBSecurityKey',
        'id-SeNBUEAggregateMaximumBitRate',
        'id-ServingPLMN',
        'id-E-RABs-ToBeAdded-List',
        'id-E-RABs-ToBeAdded-Item',
        'id-MeNBtoSeNBContainer',
        'id-E-RABs-Admitted-ToBeAdded-List',
        'id-E-RABs-Admitted-ToBeAdded-Item',
        'id-SeNBtoMeNBContainer',
        'id-ResponseInformationSeNBReconfComp',
        'id-UE-ContextInformationSeNBModReq',
        'id-E-RABs-ToBeAdded-ModReqItem',
        'id-E-RABs-ToBeModified-ModReqItem',
        'id-E-RABs-ToBeReleased-ModReqItem',
        'id-E-RABs-Admitted-ToBeAdded-ModAckList',
        'id-E-RABs-Admitted-ToBeModified-ModAckList',
        'id-E-RABs-Admitted-ToBeReleased-ModAckList',
        'id-E-RABs-Admitted-ToBeAdded-ModAckItem',
        'id-E-RABs-Admitted-ToBeModified-ModAckItem',
        'id-E-RABs-Admitted-ToBeReleased-ModAckItem',
        'id-E-RABs-ToBeReleased-ModReqd',
        'id-E-RABs-ToBeReleased-ModReqdItem',
        'id-SCGChangeIndication',
        'id-E-RABs-ToBeReleased-List-RelReq',
        'id-E-RABs-ToBeReleased-RelReqItem',
        'id-E-RABs-ToBeReleased-List-RelConf',
        'id-E-RABs-ToBeReleased-RelConfItem',
        'id-E-RABs-SubjectToCounterCheck-List',
        'id-E-RABs-SubjectToCounterCheckItem',
        'id-CoverageModificationList',
        'id-ReportingPeriodicityCSIR',
        'id-CSIReportList',
        'id-UEID',
        'id-enhancedRNTP',
        'id-ProSeUEtoNetworkRelaying',
        'id-ReceiveStatusOfULPDCPSDUsPDCP-SNlength18',
        'id-ULCOUNTValuePDCP-SNlength18',
        'id-DLCOUNTValuePDCP-SNlength18',
        'id-UE-ContextReferenceAtSeNB',
        'id-UE-ContextKeptIndicator',
        'id-New-eNB-UE-X2AP-ID-Extension',
        'id-Old-eNB-UE-X2AP-ID-Extension',
        'id-MeNB-UE-X2AP-ID-Extension',
        'id-SeNB-UE-X2AP-ID-Extension',
        'id-LHN-ID',
        'id-FreqBandIndicatorPriority',
        'id-M6Configuration',
        'id-M7Configuration',
        'id-Tunnel-Information-for-BBF',
        'id-SIPTO-BearerDeactivationIndication',
        'id-GW-TransportLayerAddress',
        'id-Correlation-ID',
        'id-SIPTO-Correlation-ID',
        'id-SIPTO-L-GW-TransportLayerAddress',
        'id-X2RemovalThreshold',
        'id-CellReportingIndicator',
        'id-BearerType',
        'id-resumeID',
        'id-UE-ContextInformationRetrieve',
        'id-E-RABs-ToBeSetupRetrieve-Item',
        'id-NewEUTRANCellIdentifier',
        'id-V2XServicesAuthorized',
        'id-OffsetOfNbiotChannelNumberToDL-EARFCN',
        'id-OffsetOfNbiotChannelNumberToUL-EARFCN',
        'id-AdditionalSpecialSubframeExtension-Info',
        'id-BandwidthReducedSI',
        'id-MakeBeforeBreakIndicator',
        'id-UE-ContextReferenceAtWT',
        'id-WT-UE-ContextKeptIndicator',
        'id-UESidelinkAggregateMaximumBitRate',
        'id-uL-GTPtunnelEndpoint',
        'id-DL-scheduling-PDCCH-CCE-usage',
        'id-UL-scheduling-PDCCH-CCE-usage',
        'id-UEAppLayerMeasConfig',
        'id-extended-e-RAB-MaximumBitrateDL',
        'id-extended-e-RAB-MaximumBitrateUL',
        'id-extended-e-RAB-GuaranteedBitrateDL',
        'id-extended-e-RAB-GuaranteedBitrateUL',
        'id-extended-uEaggregateMaximumBitRateDownlink',
        'id-extended-uEaggregateMaximumBitRateUplink',
        'id-NRrestrictioninEPSasSecondaryRAT',
        'id-SgNBSecurityKey',
        'id-SgNBUEAggregateMaximumBitRate',
        'id-E-RABs-ToBeAdded-SgNBAddReqList',
        'id-MeNBtoSgNBContainer',
        'id-SgNB-UE-X2AP-ID',
        'id-RequestedSplitSRBs',
        'id-E-RABs-ToBeAdded-SgNBAddReq-Item',
        'id-E-RABs-Admitted-ToBeAdded-SgNBAddReqAckList',
        'id-SgNBtoMeNBContainer',
        'id-AdmittedSplitSRBs',
        'id-E-RABs-Admitted-ToBeAdded-SgNBAddReqAck-Item',
        'id-ResponseInformationSgNBReconfComp',
        'id-UE-ContextInformation-SgNBModReq',
        'id-E-RABs-ToBeAdded-SgNBModReq-Item',
        'id-E-RABs-ToBeModified-SgNBModReq-Item',
        'id-E-RABs-ToBeReleased-SgNBModReq-Item',
        'id-E-RABs-Admitted-ToBeAdded-SgNBModAckList',
        'id-E-RABs-Admitted-ToBeModified-SgNBModAckList',
        'id-E-RABs-Admitted-ToBeReleased-SgNBModAckList',
        'id-E-RABs-Admitted-ToBeAdded-SgNBModAck-Item',
        'id-E-RABs-Admitted-ToBeModified-SgNBModAck-Item',
        'id-E-RABs-Admitted-ToBeReleased-SgNBModAck-Item',
        'id-E-RABs-ToBeReleased-SgNBModReqdList',
        'id-E-RABs-ToBeModified-SgNBModReqdList',
        'id-E-RABs-ToBeReleased-SgNBModReqd-Item',
        'id-E-RABs-ToBeModified-SgNBModReqd-Item',
        'id-E-RABs-ToBeReleased-SgNBChaConfList',
        'id-E-RABs-ToBeReleased-SgNBChaConf-Item',
        'id-E-RABs-ToBeReleased-SgNBRelReqList',
        'id-E-RABs-ToBeReleased-SgNBRelReq-Item',
        'id-E-RABs-ToBeReleased-SgNBRelConfList',
        'id-E-RABs-ToBeReleased-SgNBRelConf-Item',
        'id-E-RABs-SubjectToSgNBCounterCheck-List',
        'id-E-RABs-SubjectToSgNBCounterCheck-Item',
        'id-RRCContainer',
        'id-SRBType',
        'id-Target-SgNB-ID',
        'id-HandoverRestrictionList',
        'id-SCGConfigurationQuery',
        'id-SplitSRB',
        'id-NRUeReport',
        'id-InitiatingNodeType-EndcX2Setup',
        'id-InitiatingNodeType-EndcConfigUpdate',
        'id-RespondingNodeType-EndcX2Setup',
        'id-RespondingNodeType-EndcConfigUpdate',
        'id-NRUESecurityCapabilities',
        'id-PDCPChangeIndication',
        'id-ServedEUTRAcellsENDCX2ManagementList',
        'id-CellAssistanceInformation',
        'id-Globalen-gNB-ID',
        'id-ServedNRcellsENDCX2ManagementList',
        'id-UE-ContextReferenceAtSgNB',
        'id-SecondaryRATUsageReport',
        'id-ActivationID',
        'id-MeNBResourceCoordinationInformation',
        'id-SgNBResourceCoordinationInformation',
        'id-ServedEUTRAcellsToModifyListENDCConfUpd',
        'id-ServedEUTRAcellsToDeleteListENDCConfUpd',
        'id-ServedNRcellsToModifyListENDCConfUpd',
        'id-ServedNRcellsToDeleteListENDCConfUpd',
        'id-E-RABUsageReport-Item',
        'id-Old-SgNB-UE-X2AP-ID',
        'id-SecondaryRATUsageReportList',
        'id-SecondaryRATUsageReport-Item',
        'id-ServedNRCellsToActivate',
        'id-ActivatedNRCellList',
        'id-SelectedPLMN',
        'id-UEs-ToBeReset',
        'id-UEs-Admitted-ToBeReset',
        'id-RRCConfigIndication',
        'id-DownlinkPacketLossRate',
        'id-UplinkPacketLossRate',
        'id-SubscriberProfileIDforRFP',
        'id-serviceType',
        'id-AerialUEsubscriptionInformation',
        'id-SGNB-Addition-Trigger-Ind',
        'id-MeNBCell-ID',
        'id-RequestedSplitSRBsrelease',
        'id-AdmittedSplitSRBsrelease',
        'id-NRS-NSSS-PowerOffset',
        'id-NSSS-NumOccasionDifferentPrecoder',
        'id-ProtectedEUTRAResourceIndication',
        'id-InitiatingNodeType-EutranrCellResourceCoordination',
        'id-RespondingNodeType-EutranrCellResourceCoordination',
        'id-DataTrafficResourceIndication',
        'id-SpectrumSharingGroupID',
        'id-ListofEUTRACellsinEUTRACoordinationReq',
        'id-ListofEUTRACellsinEUTRACoordinationResp',
        'id-ListofEUTRACellsinNRCoordinationReq',
        'id-ListofNRCellsinNRCoordinationReq',
        'id-ListofNRCellsinNRCoordinationResp',
        'id-E-RABs-AdmittedToBeModified-SgNBModConfList',
        'id-E-RABs-AdmittedToBeModified-SgNBModConf-Item',
        'id-UEContextLevelUserPlaneActivity',
        'id-ERABActivityNotifyItemList',
        'id-InitiatingNodeType-EndcX2Removal',
        'id-RespondingNodeType-EndcX2Removal',
        'id-RLC-Status',
        'id-CNTypeRestrictions',
        'id-uLpDCPSnLength',
        'id-BluetoothMeasurementConfiguration',
        'id-WLANMeasurementConfiguration',
        'id-NRrestrictionin5GS',
        'id-dL-Forwarding',
        'id-E-RABs-DataForwardingAddress-List',
        'id-E-RABs-DataForwardingAddress-Item',
        'id-Subscription-Based-UE-DifferentiationInfo',
        'id-GNBOverloadInformation',
        'id-dLPDCPSnLength',
        'id-secondarysgNBDLGTPTEIDatPDCP',
        'id-secondarymeNBULGTPTEIDatPDCP',
        'id-lCID',
        'id-duplicationActivation',
        'id-ECGI',
        'id-RLCMode-transferred',
        'id-E-RABs-Admitted-ToBeReleased-SgNBRelReqAckList',
        'id-E-RABs-Admitted-ToBeReleased-SgNBRelReqAck-Item',
        'id-E-RABs-ToBeReleased-SgNBRelReqdList',
        'id-E-RABs-ToBeReleased-SgNBRelReqd-Item',
        'id-NRCGI',
        'id-MeNBCoordinationAssistanceInformation',
        'id-SgNBCoordinationAssistanceInformation',
        'id-new-drb-ID-req',
        'id-endcSONConfigurationTransfer',
        'id-NRNeighbourInfoToAdd',
        'id-NRNeighbourInfoToModify',
        'id-DesiredActNotificationLevel',
        'id-LocationInformationSgNBReporting',
        'id-LocationInformationSgNB',
        'id-LastNG-RANPLMNIdentity',
        'id-EUTRANTraceID',
        'id-additionalPLMNs-Item',
        'id-InterfaceInstanceIndication',
        'id-BPLMN-ID-Info-EUTRA',
        'id-BPLMN-ID-Info-NR',
        'id-NBIoT-UL-DL-AlignmentOffset',
        'id-ERABs-transferred-to-MeNB',
        'id-AdditionalRRMPriorityIndex',
        'id-LowerLayerPresenceStatusChange',
        'id-FastMCGRecovery-SN-to-MN',
        'id-RequestedFastMCGRecoveryViaSRB3',
        'id-AvailableFastMCGRecoveryViaSRB3',
        'id-RequestedFastMCGRecoveryViaSRB3Release',
        'id-ReleaseFastMCGRecoveryViaSRB3',
        'id-FastMCGRecovery-MN-to-SN',
        'id-PartialListIndicator',
        'id-MaximumCellListSize',
        'id-MessageOversizeNotification',
        'id-CellandCapacityAssistInfo',
        'id-TNLConfigurationInfo',
        'id-TNLA-To-Add-List',
        'id-TNLA-To-Update-List',
        'id-TNLA-To-Remove-List',
        'id-TNLA-Setup-List',
        'id-TNLA-Failed-To-Setup-List',
        'id-UnlicensedSpectrumRestriction',
        'id-UEContextReferenceatSourceNGRAN',
        'id-EPCHandoverRestrictionListContainer',
        'id-CHOinformation-REQ',
        'id-CHOinformation-ACK',
        'id-DAPSRequestInfo',
        'id-RequestedTargetCellID',
        'id-CandidateCellsToBeCancelledList',
        'id-DAPSResponseInfo',
        'id-ProcedureStage',
        'id-CHO-DC-Indicator',
        'id-Ethernet-Type',
        'id-NRV2XServicesAuthorized',
        'id-NRUESidelinkAggregateMaximumBitRate',
        'id-PC5QoSParameters',
        'id-NPRACHConfiguration',
        'id-NBIoT-RLF-Report-Container',
        'id-MDTConfigurationNR',
        'id-PrivacyIndicator',
        'id-TraceCollectionEntityIPAddress',
        'id-UERadioCapabilityID',
        'id-SNtriggered',
        'id-CSI-RSTransmissionIndication',
        'id-DLCarrierList',
        'id-TargetCellInNGRAN',
        'id-E-UTRAN-Node1-Measurement-ID',
        'id-E-UTRAN-Node2-Measurement-ID',
        'id-TDDULDLConfigurationCommonNR',
        'id-CarrierList',
        'id-ULCarrierList',
        'id-FrequencyShift7p5khz',
        'id-SSB-PositionsInBurst',
        'id-NRCellPRACHConfig',
        'id-CellToReport-NR-ENDC',
        'id-CellToReport-NR-ENDC-Item',
        'id-CellMeasurementResult-NR-ENDC',
        'id-CellMeasurementResult-NR-ENDC-Item',
        'id-IABNodeIndication',
        'id-QoS-Mapping-Information',
        'id-F1CTrafficContainer',
        'id-IntendedTDD-DL-ULConfiguration-NR',
        'id-UERadioCapability',
        'id-CellMeasurementResult-E-UTRA-ENDC',
        'id-CellMeasurementResult-E-UTRA-ENDC-Item',
        'id-CellToReport-E-UTRA-ENDC',
        'id-CellToReport-E-UTRA-ENDC-Item',
        'id-TraceCollectionEntityURI',
        'id-SFN-Offset',
        'id-CHO-DC-EarlyDataForwarding',
        'id-IMSvoiceEPSfallbackfrom5G',
        'id-AdditionLocationInformation',
        'id-DirectForwardingPathAvailability',
        'id-sourceNG-RAN-node-id',
        'id-SourceDLForwardingIPAddress',
        'id-SourceNodeDLForwardingIPAddress',
        'id-NRRACHReportInformation',
        'id-SCG-UE-HistoryInformation',
        'id-PSCellHistoryInformationRetrieve',
        'id-MeasurementResultforNRCellsPossiblyAggregated',
        'id-PSCell-UE-HistoryInformation',
        'id-PSCellChangeHistory',
        'id-CHOinformation-AddReq',
        'id-CHOinformation-ModReq',
        'id-SCGActivationStatus',
        'id-SCGActivationRequest',
        'id-CPAinformation-REQ',
        'id-CPAinformation-REQ-ACK',
        'id-CPAinformation-MOD',
        'id-CPAinformation-MOD-ACK',
        'id-CPACinformation-REQD',
        'id-CPCinformation-REQD',
        'id-CPCinformation-CONF',
        'id-CPCinformation-NOTIFY',
        'id-CPCupdate-MOD',
        'id-Additional-Measurement-Timing-Configuration-List',
        'id-ServedCellSpecificInfoReq-NR',
        'id-SecurityIndication',
        'id-SecurityResult',
        'id-RAT-Restrictions',
        'id-SCGreconfigNotification',
        'id-MIMOPRBusageInformation',
        'id-SensorMeasurementConfiguration',
        'id-AdditionalListofForwardingGTPTunnelEndpoint',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< id-handoverPreparation >-----#
    id_handoverPreparation = INT(name='id-handoverPreparation', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_handoverPreparation._val = 0
    
    #-----< id-handoverCancel >-----#
    id_handoverCancel = INT(name='id-handoverCancel', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_handoverCancel._val = 1
    
    #-----< id-loadIndication >-----#
    id_loadIndication = INT(name='id-loadIndication', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_loadIndication._val = 2
    
    #-----< id-errorIndication >-----#
    id_errorIndication = INT(name='id-errorIndication', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_errorIndication._val = 3
    
    #-----< id-snStatusTransfer >-----#
    id_snStatusTransfer = INT(name='id-snStatusTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_snStatusTransfer._val = 4
    
    #-----< id-uEContextRelease >-----#
    id_uEContextRelease = INT(name='id-uEContextRelease', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_uEContextRelease._val = 5
    
    #-----< id-x2Setup >-----#
    id_x2Setup = INT(name='id-x2Setup', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_x2Setup._val = 6
    
    #-----< id-reset >-----#
    id_reset = INT(name='id-reset', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_reset._val = 7
    
    #-----< id-eNBConfigurationUpdate >-----#
    id_eNBConfigurationUpdate = INT(name='id-eNBConfigurationUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_eNBConfigurationUpdate._val = 8
    
    #-----< id-resourceStatusReportingInitiation >-----#
    id_resourceStatusReportingInitiation = INT(name='id-resourceStatusReportingInitiation', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_resourceStatusReportingInitiation._val = 9
    
    #-----< id-resourceStatusReporting >-----#
    id_resourceStatusReporting = INT(name='id-resourceStatusReporting', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_resourceStatusReporting._val = 10
    
    #-----< id-privateMessage >-----#
    id_privateMessage = INT(name='id-privateMessage', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_privateMessage._val = 11
    
    #-----< id-mobilitySettingsChange >-----#
    id_mobilitySettingsChange = INT(name='id-mobilitySettingsChange', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_mobilitySettingsChange._val = 12
    
    #-----< id-rLFIndication >-----#
    id_rLFIndication = INT(name='id-rLFIndication', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_rLFIndication._val = 13
    
    #-----< id-handoverReport >-----#
    id_handoverReport = INT(name='id-handoverReport', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_handoverReport._val = 14
    
    #-----< id-cellActivation >-----#
    id_cellActivation = INT(name='id-cellActivation', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_cellActivation._val = 15
    
    #-----< id-x2Release >-----#
    id_x2Release = INT(name='id-x2Release', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_x2Release._val = 16
    
    #-----< id-x2APMessageTransfer >-----#
    id_x2APMessageTransfer = INT(name='id-x2APMessageTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_x2APMessageTransfer._val = 17
    
    #-----< id-x2Removal >-----#
    id_x2Removal = INT(name='id-x2Removal', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_x2Removal._val = 18
    
    #-----< id-seNBAdditionPreparation >-----#
    id_seNBAdditionPreparation = INT(name='id-seNBAdditionPreparation', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_seNBAdditionPreparation._val = 19
    
    #-----< id-seNBReconfigurationCompletion >-----#
    id_seNBReconfigurationCompletion = INT(name='id-seNBReconfigurationCompletion', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_seNBReconfigurationCompletion._val = 20
    
    #-----< id-meNBinitiatedSeNBModificationPreparation >-----#
    id_meNBinitiatedSeNBModificationPreparation = INT(name='id-meNBinitiatedSeNBModificationPreparation', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_meNBinitiatedSeNBModificationPreparation._val = 21
    
    #-----< id-seNBinitiatedSeNBModification >-----#
    id_seNBinitiatedSeNBModification = INT(name='id-seNBinitiatedSeNBModification', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_seNBinitiatedSeNBModification._val = 22
    
    #-----< id-meNBinitiatedSeNBRelease >-----#
    id_meNBinitiatedSeNBRelease = INT(name='id-meNBinitiatedSeNBRelease', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_meNBinitiatedSeNBRelease._val = 23
    
    #-----< id-seNBinitiatedSeNBRelease >-----#
    id_seNBinitiatedSeNBRelease = INT(name='id-seNBinitiatedSeNBRelease', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_seNBinitiatedSeNBRelease._val = 24
    
    #-----< id-seNBCounterCheck >-----#
    id_seNBCounterCheck = INT(name='id-seNBCounterCheck', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_seNBCounterCheck._val = 25
    
    #-----< id-retrieveUEContext >-----#
    id_retrieveUEContext = INT(name='id-retrieveUEContext', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_retrieveUEContext._val = 26
    
    #-----< id-sgNBAdditionPreparation >-----#
    id_sgNBAdditionPreparation = INT(name='id-sgNBAdditionPreparation', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_sgNBAdditionPreparation._val = 27
    
    #-----< id-sgNBReconfigurationCompletion >-----#
    id_sgNBReconfigurationCompletion = INT(name='id-sgNBReconfigurationCompletion', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_sgNBReconfigurationCompletion._val = 28
    
    #-----< id-meNBinitiatedSgNBModificationPreparation >-----#
    id_meNBinitiatedSgNBModificationPreparation = INT(name='id-meNBinitiatedSgNBModificationPreparation', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_meNBinitiatedSgNBModificationPreparation._val = 29
    
    #-----< id-sgNBinitiatedSgNBModification >-----#
    id_sgNBinitiatedSgNBModification = INT(name='id-sgNBinitiatedSgNBModification', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_sgNBinitiatedSgNBModification._val = 30
    
    #-----< id-meNBinitiatedSgNBRelease >-----#
    id_meNBinitiatedSgNBRelease = INT(name='id-meNBinitiatedSgNBRelease', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_meNBinitiatedSgNBRelease._val = 31
    
    #-----< id-sgNBinitiatedSgNBRelease >-----#
    id_sgNBinitiatedSgNBRelease = INT(name='id-sgNBinitiatedSgNBRelease', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_sgNBinitiatedSgNBRelease._val = 32
    
    #-----< id-sgNBCounterCheck >-----#
    id_sgNBCounterCheck = INT(name='id-sgNBCounterCheck', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_sgNBCounterCheck._val = 33
    
    #-----< id-sgNBChange >-----#
    id_sgNBChange = INT(name='id-sgNBChange', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_sgNBChange._val = 34
    
    #-----< id-rRCTransfer >-----#
    id_rRCTransfer = INT(name='id-rRCTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_rRCTransfer._val = 35
    
    #-----< id-endcX2Setup >-----#
    id_endcX2Setup = INT(name='id-endcX2Setup', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_endcX2Setup._val = 36
    
    #-----< id-endcConfigurationUpdate >-----#
    id_endcConfigurationUpdate = INT(name='id-endcConfigurationUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_endcConfigurationUpdate._val = 37
    
    #-----< id-secondaryRATDataUsageReport >-----#
    id_secondaryRATDataUsageReport = INT(name='id-secondaryRATDataUsageReport', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_secondaryRATDataUsageReport._val = 38
    
    #-----< id-endcCellActivation >-----#
    id_endcCellActivation = INT(name='id-endcCellActivation', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_endcCellActivation._val = 39
    
    #-----< id-endcPartialReset >-----#
    id_endcPartialReset = INT(name='id-endcPartialReset', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_endcPartialReset._val = 40
    
    #-----< id-eUTRANRCellResourceCoordination >-----#
    id_eUTRANRCellResourceCoordination = INT(name='id-eUTRANRCellResourceCoordination', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_eUTRANRCellResourceCoordination._val = 41
    
    #-----< id-SgNBActivityNotification >-----#
    id_SgNBActivityNotification = INT(name='id-SgNBActivityNotification', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_SgNBActivityNotification._val = 42
    
    #-----< id-endcX2Removal >-----#
    id_endcX2Removal = INT(name='id-endcX2Removal', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_endcX2Removal._val = 43
    
    #-----< id-dataForwardingAddressIndication >-----#
    id_dataForwardingAddressIndication = INT(name='id-dataForwardingAddressIndication', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_dataForwardingAddressIndication._val = 44
    
    #-----< id-gNBStatusIndication >-----#
    id_gNBStatusIndication = INT(name='id-gNBStatusIndication', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_gNBStatusIndication._val = 45
    
    #-----< id-deactivateTrace >-----#
    id_deactivateTrace = INT(name='id-deactivateTrace', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_deactivateTrace._val = 46
    
    #-----< id-traceStart >-----#
    id_traceStart = INT(name='id-traceStart', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_traceStart._val = 47
    
    #-----< id-endcConfigurationTransfer >-----#
    id_endcConfigurationTransfer = INT(name='id-endcConfigurationTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_endcConfigurationTransfer._val = 48
    
    #-----< id-handoverSuccess >-----#
    id_handoverSuccess = INT(name='id-handoverSuccess', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_handoverSuccess._val = 49
    
    #-----< id-conditionalHandoverCancel >-----#
    id_conditionalHandoverCancel = INT(name='id-conditionalHandoverCancel', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_conditionalHandoverCancel._val = 50
    
    #-----< id-earlyStatusTransfer >-----#
    id_earlyStatusTransfer = INT(name='id-earlyStatusTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_earlyStatusTransfer._val = 51
    
    #-----< id-cellTrafficTrace >-----#
    id_cellTrafficTrace = INT(name='id-cellTrafficTrace', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_cellTrafficTrace._val = 52
    
    #-----< id-endcresourceStatusReporting >-----#
    id_endcresourceStatusReporting = INT(name='id-endcresourceStatusReporting', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_endcresourceStatusReporting._val = 53
    
    #-----< id-endcresourceStatusReportingInitiation >-----#
    id_endcresourceStatusReportingInitiation = INT(name='id-endcresourceStatusReportingInitiation', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_endcresourceStatusReportingInitiation._val = 54
    
    #-----< id-f1CTrafficTransfer >-----#
    id_f1CTrafficTransfer = INT(name='id-f1CTrafficTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_f1CTrafficTransfer._val = 55
    
    #-----< id-UERadioCapabilityIDMapping >-----#
    id_UERadioCapabilityIDMapping = INT(name='id-UERadioCapabilityIDMapping', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_UERadioCapabilityIDMapping._val = 56
    
    #-----< id-accessAndMobilityIndication >-----#
    id_accessAndMobilityIndication = INT(name='id-accessAndMobilityIndication', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_accessAndMobilityIndication._val = 57
    
    #-----< id-procedure-code-58-not-to-be-used >-----#
    id_procedure_code_58_not_to_be_used = INT(name='id-procedure-code-58-not-to-be-used', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_procedure_code_58_not_to_be_used._val = 58
    
    #-----< id-CPC-cancel >-----#
    id_CPC_cancel = INT(name='id-CPC-cancel', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')))
    id_CPC_cancel._val = 59
    
    #-----< maxEARFCN >-----#
    maxEARFCN = INT(name='maxEARFCN', mode=MODE_VALUE)
    maxEARFCN._val = 65535
    
    #-----< maxEARFCNPlusOne >-----#
    maxEARFCNPlusOne = INT(name='maxEARFCNPlusOne', mode=MODE_VALUE)
    maxEARFCNPlusOne._val = 65536
    
    #-----< newmaxEARFCN >-----#
    newmaxEARFCN = INT(name='newmaxEARFCN', mode=MODE_VALUE)
    newmaxEARFCN._val = 262143
    
    #-----< maxInterfaces >-----#
    maxInterfaces = INT(name='maxInterfaces', mode=MODE_VALUE)
    maxInterfaces._val = 16
    
    #-----< maxCellineNB >-----#
    maxCellineNB = INT(name='maxCellineNB', mode=MODE_VALUE)
    maxCellineNB._val = 256
    
    #-----< maxnoofBands >-----#
    maxnoofBands = INT(name='maxnoofBands', mode=MODE_VALUE)
    maxnoofBands._val = 16
    
    #-----< maxnoofBearers >-----#
    maxnoofBearers = INT(name='maxnoofBearers', mode=MODE_VALUE)
    maxnoofBearers._val = 256
    
    #-----< maxNrOfErrors >-----#
    maxNrOfErrors = INT(name='maxNrOfErrors', mode=MODE_VALUE)
    maxNrOfErrors._val = 256
    
    #-----< maxnoofPDCP-SN >-----#
    maxnoofPDCP_SN = INT(name='maxnoofPDCP-SN', mode=MODE_VALUE)
    maxnoofPDCP_SN._val = 16
    
    #-----< maxnoofEPLMNs >-----#
    maxnoofEPLMNs = INT(name='maxnoofEPLMNs', mode=MODE_VALUE)
    maxnoofEPLMNs._val = 15
    
    #-----< maxnoofEPLMNsPlusOne >-----#
    maxnoofEPLMNsPlusOne = INT(name='maxnoofEPLMNsPlusOne', mode=MODE_VALUE)
    maxnoofEPLMNsPlusOne._val = 16
    
    #-----< maxnoofForbLACs >-----#
    maxnoofForbLACs = INT(name='maxnoofForbLACs', mode=MODE_VALUE)
    maxnoofForbLACs._val = 4096
    
    #-----< maxnoofForbTACs >-----#
    maxnoofForbTACs = INT(name='maxnoofForbTACs', mode=MODE_VALUE)
    maxnoofForbTACs._val = 4096
    
    #-----< maxnoofBPLMNs >-----#
    maxnoofBPLMNs = INT(name='maxnoofBPLMNs', mode=MODE_VALUE)
    maxnoofBPLMNs._val = 6
    
    #-----< maxnoofAdditionalPLMNs >-----#
    maxnoofAdditionalPLMNs = INT(name='maxnoofAdditionalPLMNs', mode=MODE_VALUE)
    maxnoofAdditionalPLMNs._val = 6
    
    #-----< maxnoofNeighbours >-----#
    maxnoofNeighbours = INT(name='maxnoofNeighbours', mode=MODE_VALUE)
    maxnoofNeighbours._val = 512
    
    #-----< maxnoofPRBs >-----#
    maxnoofPRBs = INT(name='maxnoofPRBs', mode=MODE_VALUE)
    maxnoofPRBs._val = 110
    
    #-----< maxPools >-----#
    maxPools = INT(name='maxPools', mode=MODE_VALUE)
    maxPools._val = 16
    
    #-----< maxnoofCells >-----#
    maxnoofCells = INT(name='maxnoofCells', mode=MODE_VALUE)
    maxnoofCells._val = 16
    
    #-----< maxnoofMBSFN >-----#
    maxnoofMBSFN = INT(name='maxnoofMBSFN', mode=MODE_VALUE)
    maxnoofMBSFN._val = 8
    
    #-----< maxFailedMeasObjects >-----#
    maxFailedMeasObjects = INT(name='maxFailedMeasObjects', mode=MODE_VALUE)
    maxFailedMeasObjects._val = 32
    
    #-----< maxnoofCellIDforMDT >-----#
    maxnoofCellIDforMDT = INT(name='maxnoofCellIDforMDT', mode=MODE_VALUE)
    maxnoofCellIDforMDT._val = 32
    
    #-----< maxnoofTAforMDT >-----#
    maxnoofTAforMDT = INT(name='maxnoofTAforMDT', mode=MODE_VALUE)
    maxnoofTAforMDT._val = 8
    
    #-----< maxnoofMBMSServiceAreaIdentities >-----#
    maxnoofMBMSServiceAreaIdentities = INT(name='maxnoofMBMSServiceAreaIdentities', mode=MODE_VALUE)
    maxnoofMBMSServiceAreaIdentities._val = 256
    
    #-----< maxnoofMDTPLMNs >-----#
    maxnoofMDTPLMNs = INT(name='maxnoofMDTPLMNs', mode=MODE_VALUE)
    maxnoofMDTPLMNs._val = 16
    
    #-----< maxnoofCoMPHypothesisSet >-----#
    maxnoofCoMPHypothesisSet = INT(name='maxnoofCoMPHypothesisSet', mode=MODE_VALUE)
    maxnoofCoMPHypothesisSet._val = 256
    
    #-----< maxnoofCoMPCells >-----#
    maxnoofCoMPCells = INT(name='maxnoofCoMPCells', mode=MODE_VALUE)
    maxnoofCoMPCells._val = 32
    
    #-----< maxUEReport >-----#
    maxUEReport = INT(name='maxUEReport', mode=MODE_VALUE)
    maxUEReport._val = 128
    
    #-----< maxCellReport >-----#
    maxCellReport = INT(name='maxCellReport', mode=MODE_VALUE)
    maxCellReport._val = 9
    
    #-----< maxnoofPA >-----#
    maxnoofPA = INT(name='maxnoofPA', mode=MODE_VALUE)
    maxnoofPA._val = 3
    
    #-----< maxCSIProcess >-----#
    maxCSIProcess = INT(name='maxCSIProcess', mode=MODE_VALUE)
    maxCSIProcess._val = 4
    
    #-----< maxCSIReport >-----#
    maxCSIReport = INT(name='maxCSIReport', mode=MODE_VALUE)
    maxCSIReport._val = 2
    
    #-----< maxSubband >-----#
    maxSubband = INT(name='maxSubband', mode=MODE_VALUE)
    maxSubband._val = 14
    
    #-----< maxofNRNeighbours >-----#
    maxofNRNeighbours = INT(name='maxofNRNeighbours', mode=MODE_VALUE)
    maxofNRNeighbours._val = 1024
    
    #-----< maxCellinengNB >-----#
    maxCellinengNB = INT(name='maxCellinengNB', mode=MODE_VALUE)
    maxCellinengNB._val = 16384
    
    #-----< maxnooftimeperiods >-----#
    maxnooftimeperiods = INT(name='maxnooftimeperiods', mode=MODE_VALUE)
    maxnooftimeperiods._val = 2
    
    #-----< maxnoofCellIDforQMC >-----#
    maxnoofCellIDforQMC = INT(name='maxnoofCellIDforQMC', mode=MODE_VALUE)
    maxnoofCellIDforQMC._val = 32
    
    #-----< maxnoofTAforQMC >-----#
    maxnoofTAforQMC = INT(name='maxnoofTAforQMC', mode=MODE_VALUE)
    maxnoofTAforQMC._val = 8
    
    #-----< maxnoofPLMNforQMC >-----#
    maxnoofPLMNforQMC = INT(name='maxnoofPLMNforQMC', mode=MODE_VALUE)
    maxnoofPLMNforQMC._val = 16
    
    #-----< maxUEsinengNBDU >-----#
    maxUEsinengNBDU = INT(name='maxUEsinengNBDU', mode=MODE_VALUE)
    maxUEsinengNBDU._val = 8192
    
    #-----< maxnoofProtectedResourcePatterns >-----#
    maxnoofProtectedResourcePatterns = INT(name='maxnoofProtectedResourcePatterns', mode=MODE_VALUE)
    maxnoofProtectedResourcePatterns._val = 16
    
    #-----< maxnoNRcellsSpectrumSharingWithE-UTRA >-----#
    maxnoNRcellsSpectrumSharingWithE_UTRA = INT(name='maxnoNRcellsSpectrumSharingWithE-UTRA', mode=MODE_VALUE)
    maxnoNRcellsSpectrumSharingWithE_UTRA._val = 64
    
    #-----< maxnoofNrCellBands >-----#
    maxnoofNrCellBands = INT(name='maxnoofNrCellBands', mode=MODE_VALUE)
    maxnoofNrCellBands._val = 32
    
    #-----< maxnoofBluetoothName >-----#
    maxnoofBluetoothName = INT(name='maxnoofBluetoothName', mode=MODE_VALUE)
    maxnoofBluetoothName._val = 4
    
    #-----< maxnoofWLANName >-----#
    maxnoofWLANName = INT(name='maxnoofWLANName', mode=MODE_VALUE)
    maxnoofWLANName._val = 4
    
    #-----< maxnoofextBPLMNs >-----#
    maxnoofextBPLMNs = INT(name='maxnoofextBPLMNs', mode=MODE_VALUE)
    maxnoofextBPLMNs._val = 12
    
    #-----< maxnoofTLAs >-----#
    maxnoofTLAs = INT(name='maxnoofTLAs', mode=MODE_VALUE)
    maxnoofTLAs._val = 16
    
    #-----< maxnoofGTPTLAs >-----#
    maxnoofGTPTLAs = INT(name='maxnoofGTPTLAs', mode=MODE_VALUE)
    maxnoofGTPTLAs._val = 16
    
    #-----< maxnoofTNLAssociations >-----#
    maxnoofTNLAssociations = INT(name='maxnoofTNLAssociations', mode=MODE_VALUE)
    maxnoofTNLAssociations._val = 32
    
    #-----< maxnoofCellsinCHO >-----#
    maxnoofCellsinCHO = INT(name='maxnoofCellsinCHO', mode=MODE_VALUE)
    maxnoofCellsinCHO._val = 8
    
    #-----< maxnoofPC5QoSFlows >-----#
    maxnoofPC5QoSFlows = INT(name='maxnoofPC5QoSFlows', mode=MODE_VALUE)
    maxnoofPC5QoSFlows._val = 2048
    
    #-----< maxnoofSSBAreas >-----#
    maxnoofSSBAreas = INT(name='maxnoofSSBAreas', mode=MODE_VALUE)
    maxnoofSSBAreas._val = 64
    
    #-----< maxnoofNRSCSs >-----#
    maxnoofNRSCSs = INT(name='maxnoofNRSCSs', mode=MODE_VALUE)
    maxnoofNRSCSs._val = 5
    
    #-----< maxnoofNRPhysicalResourceBlocks >-----#
    maxnoofNRPhysicalResourceBlocks = INT(name='maxnoofNRPhysicalResourceBlocks', mode=MODE_VALUE)
    maxnoofNRPhysicalResourceBlocks._val = 275
    
    #-----< maxnoofNonAnchorCarrierFreqConfig >-----#
    maxnoofNonAnchorCarrierFreqConfig = INT(name='maxnoofNonAnchorCarrierFreqConfig', mode=MODE_VALUE)
    maxnoofNonAnchorCarrierFreqConfig._val = 15
    
    #-----< maxnoofRACHReports >-----#
    maxnoofRACHReports = INT(name='maxnoofRACHReports', mode=MODE_VALUE)
    maxnoofRACHReports._val = 64
    
    #-----< maxnoofPSCellsPerSN >-----#
    maxnoofPSCellsPerSN = INT(name='maxnoofPSCellsPerSN', mode=MODE_VALUE)
    maxnoofPSCellsPerSN._val = 8
    
    #-----< maxnoofPSCellsPerPrimaryCellinUEHistoryInfo >-----#
    maxnoofPSCellsPerPrimaryCellinUEHistoryInfo = INT(name='maxnoofPSCellsPerPrimaryCellinUEHistoryInfo', mode=MODE_VALUE)
    maxnoofPSCellsPerPrimaryCellinUEHistoryInfo._val = 8
    
    #-----< maxnoofReportedNRCellsPossiblyAggregated >-----#
    maxnoofReportedNRCellsPossiblyAggregated = INT(name='maxnoofReportedNRCellsPossiblyAggregated', mode=MODE_VALUE)
    maxnoofReportedNRCellsPossiblyAggregated._val = 16
    
    #-----< maxnoofPSCellCandidates >-----#
    maxnoofPSCellCandidates = INT(name='maxnoofPSCellCandidates', mode=MODE_VALUE)
    maxnoofPSCellCandidates._val = 8
    
    #-----< maxnoofTargetSgNBs >-----#
    maxnoofTargetSgNBs = INT(name='maxnoofTargetSgNBs', mode=MODE_VALUE)
    maxnoofTargetSgNBs._val = 8
    
    #-----< maxnoofMTCItems >-----#
    maxnoofMTCItems = INT(name='maxnoofMTCItems', mode=MODE_VALUE)
    maxnoofMTCItems._val = 16
    
    #-----< maxnoofCSIRSconfigurations >-----#
    maxnoofCSIRSconfigurations = INT(name='maxnoofCSIRSconfigurations', mode=MODE_VALUE)
    maxnoofCSIRSconfigurations._val = 96
    
    #-----< maxnoofCSIRSneighbourCells >-----#
    maxnoofCSIRSneighbourCells = INT(name='maxnoofCSIRSneighbourCells', mode=MODE_VALUE)
    maxnoofCSIRSneighbourCells._val = 16
    
    #-----< maxnoofCSIRSneighbourCellsInMTC >-----#
    maxnoofCSIRSneighbourCellsInMTC = INT(name='maxnoofCSIRSneighbourCellsInMTC', mode=MODE_VALUE)
    maxnoofCSIRSneighbourCellsInMTC._val = 16
    
    #-----< maxnoofSensorName >-----#
    maxnoofSensorName = INT(name='maxnoofSensorName', mode=MODE_VALUE)
    maxnoofSensorName._val = 3
    
    #-----< maxnoofTargetSgNBsMinusOne >-----#
    maxnoofTargetSgNBsMinusOne = INT(name='maxnoofTargetSgNBsMinusOne', mode=MODE_VALUE)
    maxnoofTargetSgNBsMinusOne._val = 7
    
    #-----< id-E-RABs-Admitted-Item >-----#
    id_E_RABs_Admitted_Item = INT(name='id-E-RABs-Admitted-Item', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_Admitted_Item._val = 0
    
    #-----< id-E-RABs-Admitted-List >-----#
    id_E_RABs_Admitted_List = INT(name='id-E-RABs-Admitted-List', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_Admitted_List._val = 1
    
    #-----< id-E-RAB-Item >-----#
    id_E_RAB_Item = INT(name='id-E-RAB-Item', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RAB_Item._val = 2
    
    #-----< id-E-RABs-NotAdmitted-List >-----#
    id_E_RABs_NotAdmitted_List = INT(name='id-E-RABs-NotAdmitted-List', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_NotAdmitted_List._val = 3
    
    #-----< id-E-RABs-ToBeSetup-Item >-----#
    id_E_RABs_ToBeSetup_Item = INT(name='id-E-RABs-ToBeSetup-Item', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_ToBeSetup_Item._val = 4
    
    #-----< id-Cause >-----#
    id_Cause = INT(name='id-Cause', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cause._val = 5
    
    #-----< id-CellInformation >-----#
    id_CellInformation = INT(name='id-CellInformation', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CellInformation._val = 6
    
    #-----< id-CellInformation-Item >-----#
    id_CellInformation_Item = INT(name='id-CellInformation-Item', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CellInformation_Item._val = 7
    
    #-----< id-New-eNB-UE-X2AP-ID >-----#
    id_New_eNB_UE_X2AP_ID = INT(name='id-New-eNB-UE-X2AP-ID', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_New_eNB_UE_X2AP_ID._val = 9
    
    #-----< id-Old-eNB-UE-X2AP-ID >-----#
    id_Old_eNB_UE_X2AP_ID = INT(name='id-Old-eNB-UE-X2AP-ID', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Old_eNB_UE_X2AP_ID._val = 10
    
    #-----< id-TargetCell-ID >-----#
    id_TargetCell_ID = INT(name='id-TargetCell-ID', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TargetCell_ID._val = 11
    
    #-----< id-TargeteNBtoSource-eNBTransparentContainer >-----#
    id_TargeteNBtoSource_eNBTransparentContainer = INT(name='id-TargeteNBtoSource-eNBTransparentContainer', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TargeteNBtoSource_eNBTransparentContainer._val = 12
    
    #-----< id-TraceActivation >-----#
    id_TraceActivation = INT(name='id-TraceActivation', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TraceActivation._val = 13
    
    #-----< id-UE-ContextInformation >-----#
    id_UE_ContextInformation = INT(name='id-UE-ContextInformation', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_ContextInformation._val = 14
    
    #-----< id-UE-HistoryInformation >-----#
    id_UE_HistoryInformation = INT(name='id-UE-HistoryInformation', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_HistoryInformation._val = 15
    
    #-----< id-UE-X2AP-ID >-----#
    id_UE_X2AP_ID = INT(name='id-UE-X2AP-ID', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_X2AP_ID._val = 16
    
    #-----< id-CriticalityDiagnostics >-----#
    id_CriticalityDiagnostics = INT(name='id-CriticalityDiagnostics', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CriticalityDiagnostics._val = 17
    
    #-----< id-E-RABs-SubjectToStatusTransfer-List >-----#
    id_E_RABs_SubjectToStatusTransfer_List = INT(name='id-E-RABs-SubjectToStatusTransfer-List', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_SubjectToStatusTransfer_List._val = 18
    
    #-----< id-E-RABs-SubjectToStatusTransfer-Item >-----#
    id_E_RABs_SubjectToStatusTransfer_Item = INT(name='id-E-RABs-SubjectToStatusTransfer-Item', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_SubjectToStatusTransfer_Item._val = 19
    
    #-----< id-ServedCells >-----#
    id_ServedCells = INT(name='id-ServedCells', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ServedCells._val = 20
    
    #-----< id-GlobalENB-ID >-----#
    id_GlobalENB_ID = INT(name='id-GlobalENB-ID', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GlobalENB_ID._val = 21
    
    #-----< id-TimeToWait >-----#
    id_TimeToWait = INT(name='id-TimeToWait', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TimeToWait._val = 22
    
    #-----< id-GUMMEI-ID >-----#
    id_GUMMEI_ID = INT(name='id-GUMMEI-ID', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GUMMEI_ID._val = 23
    
    #-----< id-GUGroupIDList >-----#
    id_GUGroupIDList = INT(name='id-GUGroupIDList', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GUGroupIDList._val = 24
    
    #-----< id-ServedCellsToAdd >-----#
    id_ServedCellsToAdd = INT(name='id-ServedCellsToAdd', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ServedCellsToAdd._val = 25
    
    #-----< id-ServedCellsToModify >-----#
    id_ServedCellsToModify = INT(name='id-ServedCellsToModify', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ServedCellsToModify._val = 26
    
    #-----< id-ServedCellsToDelete >-----#
    id_ServedCellsToDelete = INT(name='id-ServedCellsToDelete', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ServedCellsToDelete._val = 27
    
    #-----< id-Registration-Request >-----#
    id_Registration_Request = INT(name='id-Registration-Request', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Registration_Request._val = 28
    
    #-----< id-CellToReport >-----#
    id_CellToReport = INT(name='id-CellToReport', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CellToReport._val = 29
    
    #-----< id-ReportingPeriodicity >-----#
    id_ReportingPeriodicity = INT(name='id-ReportingPeriodicity', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ReportingPeriodicity._val = 30
    
    #-----< id-CellToReport-Item >-----#
    id_CellToReport_Item = INT(name='id-CellToReport-Item', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CellToReport_Item._val = 31
    
    #-----< id-CellMeasurementResult >-----#
    id_CellMeasurementResult = INT(name='id-CellMeasurementResult', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CellMeasurementResult._val = 32
    
    #-----< id-CellMeasurementResult-Item >-----#
    id_CellMeasurementResult_Item = INT(name='id-CellMeasurementResult-Item', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CellMeasurementResult_Item._val = 33
    
    #-----< id-GUGroupIDToAddList >-----#
    id_GUGroupIDToAddList = INT(name='id-GUGroupIDToAddList', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GUGroupIDToAddList._val = 34
    
    #-----< id-GUGroupIDToDeleteList >-----#
    id_GUGroupIDToDeleteList = INT(name='id-GUGroupIDToDeleteList', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GUGroupIDToDeleteList._val = 35
    
    #-----< id-SRVCCOperationPossible >-----#
    id_SRVCCOperationPossible = INT(name='id-SRVCCOperationPossible', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRVCCOperationPossible._val = 36
    
    #-----< id-Measurement-ID >-----#
    id_Measurement_ID = INT(name='id-Measurement-ID', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Measurement_ID._val = 37
    
    #-----< id-ReportCharacteristics >-----#
    id_ReportCharacteristics = INT(name='id-ReportCharacteristics', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ReportCharacteristics._val = 38
    
    #-----< id-ENB1-Measurement-ID >-----#
    id_ENB1_Measurement_ID = INT(name='id-ENB1-Measurement-ID', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ENB1_Measurement_ID._val = 39
    
    #-----< id-ENB2-Measurement-ID >-----#
    id_ENB2_Measurement_ID = INT(name='id-ENB2-Measurement-ID', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ENB2_Measurement_ID._val = 40
    
    #-----< id-Number-of-Antennaports >-----#
    id_Number_of_Antennaports = INT(name='id-Number-of-Antennaports', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Number_of_Antennaports._val = 41
    
    #-----< id-CompositeAvailableCapacityGroup >-----#
    id_CompositeAvailableCapacityGroup = INT(name='id-CompositeAvailableCapacityGroup', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CompositeAvailableCapacityGroup._val = 42
    
    #-----< id-ENB1-Cell-ID >-----#
    id_ENB1_Cell_ID = INT(name='id-ENB1-Cell-ID', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ENB1_Cell_ID._val = 43
    
    #-----< id-ENB2-Cell-ID >-----#
    id_ENB2_Cell_ID = INT(name='id-ENB2-Cell-ID', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ENB2_Cell_ID._val = 44
    
    #-----< id-ENB2-Proposed-Mobility-Parameters >-----#
    id_ENB2_Proposed_Mobility_Parameters = INT(name='id-ENB2-Proposed-Mobility-Parameters', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ENB2_Proposed_Mobility_Parameters._val = 45
    
    #-----< id-ENB1-Mobility-Parameters >-----#
    id_ENB1_Mobility_Parameters = INT(name='id-ENB1-Mobility-Parameters', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ENB1_Mobility_Parameters._val = 46
    
    #-----< id-ENB2-Mobility-Parameters-Modification-Range >-----#
    id_ENB2_Mobility_Parameters_Modification_Range = INT(name='id-ENB2-Mobility-Parameters-Modification-Range', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ENB2_Mobility_Parameters_Modification_Range._val = 47
    
    #-----< id-FailureCellPCI >-----#
    id_FailureCellPCI = INT(name='id-FailureCellPCI', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_FailureCellPCI._val = 48
    
    #-----< id-Re-establishmentCellECGI >-----#
    id_Re_establishmentCellECGI = INT(name='id-Re-establishmentCellECGI', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Re_establishmentCellECGI._val = 49
    
    #-----< id-FailureCellCRNTI >-----#
    id_FailureCellCRNTI = INT(name='id-FailureCellCRNTI', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_FailureCellCRNTI._val = 50
    
    #-----< id-ShortMAC-I >-----#
    id_ShortMAC_I = INT(name='id-ShortMAC-I', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ShortMAC_I._val = 51
    
    #-----< id-SourceCellECGI >-----#
    id_SourceCellECGI = INT(name='id-SourceCellECGI', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SourceCellECGI._val = 52
    
    #-----< id-FailureCellECGI >-----#
    id_FailureCellECGI = INT(name='id-FailureCellECGI', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_FailureCellECGI._val = 53
    
    #-----< id-HandoverReportType >-----#
    id_HandoverReportType = INT(name='id-HandoverReportType', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HandoverReportType._val = 54
    
    #-----< id-PRACH-Configuration >-----#
    id_PRACH_Configuration = INT(name='id-PRACH-Configuration', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PRACH_Configuration._val = 55
    
    #-----< id-MBSFN-Subframe-Info >-----#
    id_MBSFN_Subframe_Info = INT(name='id-MBSFN-Subframe-Info', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MBSFN_Subframe_Info._val = 56
    
    #-----< id-ServedCellsToActivate >-----#
    id_ServedCellsToActivate = INT(name='id-ServedCellsToActivate', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ServedCellsToActivate._val = 57
    
    #-----< id-ActivatedCellList >-----#
    id_ActivatedCellList = INT(name='id-ActivatedCellList', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ActivatedCellList._val = 58
    
    #-----< id-DeactivationIndication >-----#
    id_DeactivationIndication = INT(name='id-DeactivationIndication', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DeactivationIndication._val = 59
    
    #-----< id-UE-RLF-Report-Container >-----#
    id_UE_RLF_Report_Container = INT(name='id-UE-RLF-Report-Container', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_RLF_Report_Container._val = 60
    
    #-----< id-ABSInformation >-----#
    id_ABSInformation = INT(name='id-ABSInformation', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ABSInformation._val = 61
    
    #-----< id-InvokeIndication >-----#
    id_InvokeIndication = INT(name='id-InvokeIndication', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_InvokeIndication._val = 62
    
    #-----< id-ABS-Status >-----#
    id_ABS_Status = INT(name='id-ABS-Status', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ABS_Status._val = 63
    
    #-----< id-PartialSuccessIndicator >-----#
    id_PartialSuccessIndicator = INT(name='id-PartialSuccessIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PartialSuccessIndicator._val = 64
    
    #-----< id-MeasurementInitiationResult-List >-----#
    id_MeasurementInitiationResult_List = INT(name='id-MeasurementInitiationResult-List', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MeasurementInitiationResult_List._val = 65
    
    #-----< id-MeasurementInitiationResult-Item >-----#
    id_MeasurementInitiationResult_Item = INT(name='id-MeasurementInitiationResult-Item', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MeasurementInitiationResult_Item._val = 66
    
    #-----< id-MeasurementFailureCause-Item >-----#
    id_MeasurementFailureCause_Item = INT(name='id-MeasurementFailureCause-Item', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MeasurementFailureCause_Item._val = 67
    
    #-----< id-CompleteFailureCauseInformation-List >-----#
    id_CompleteFailureCauseInformation_List = INT(name='id-CompleteFailureCauseInformation-List', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CompleteFailureCauseInformation_List._val = 68
    
    #-----< id-CompleteFailureCauseInformation-Item >-----#
    id_CompleteFailureCauseInformation_Item = INT(name='id-CompleteFailureCauseInformation-Item', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CompleteFailureCauseInformation_Item._val = 69
    
    #-----< id-CSG-Id >-----#
    id_CSG_Id = INT(name='id-CSG-Id', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CSG_Id._val = 70
    
    #-----< id-CSGMembershipStatus >-----#
    id_CSGMembershipStatus = INT(name='id-CSGMembershipStatus', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CSGMembershipStatus._val = 71
    
    #-----< id-MDTConfiguration >-----#
    id_MDTConfiguration = INT(name='id-MDTConfiguration', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MDTConfiguration._val = 72
    
    #-----< id-ManagementBasedMDTallowed >-----#
    id_ManagementBasedMDTallowed = INT(name='id-ManagementBasedMDTallowed', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ManagementBasedMDTallowed._val = 74
    
    #-----< id-RRCConnSetupIndicator >-----#
    id_RRCConnSetupIndicator = INT(name='id-RRCConnSetupIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RRCConnSetupIndicator._val = 75
    
    #-----< id-NeighbourTAC >-----#
    id_NeighbourTAC = INT(name='id-NeighbourTAC', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NeighbourTAC._val = 76
    
    #-----< id-Time-UE-StayedInCell-EnhancedGranularity >-----#
    id_Time_UE_StayedInCell_EnhancedGranularity = INT(name='id-Time-UE-StayedInCell-EnhancedGranularity', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Time_UE_StayedInCell_EnhancedGranularity._val = 77
    
    #-----< id-RRCConnReestabIndicator >-----#
    id_RRCConnReestabIndicator = INT(name='id-RRCConnReestabIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RRCConnReestabIndicator._val = 78
    
    #-----< id-MBMS-Service-Area-List >-----#
    id_MBMS_Service_Area_List = INT(name='id-MBMS-Service-Area-List', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MBMS_Service_Area_List._val = 79
    
    #-----< id-HO-cause >-----#
    id_HO_cause = INT(name='id-HO-cause', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HO_cause._val = 80
    
    #-----< id-TargetCellInUTRAN >-----#
    id_TargetCellInUTRAN = INT(name='id-TargetCellInUTRAN', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TargetCellInUTRAN._val = 81
    
    #-----< id-MobilityInformation >-----#
    id_MobilityInformation = INT(name='id-MobilityInformation', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MobilityInformation._val = 82
    
    #-----< id-SourceCellCRNTI >-----#
    id_SourceCellCRNTI = INT(name='id-SourceCellCRNTI', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SourceCellCRNTI._val = 83
    
    #-----< id-MultibandInfoList >-----#
    id_MultibandInfoList = INT(name='id-MultibandInfoList', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MultibandInfoList._val = 84
    
    #-----< id-M3Configuration >-----#
    id_M3Configuration = INT(name='id-M3Configuration', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_M3Configuration._val = 85
    
    #-----< id-M4Configuration >-----#
    id_M4Configuration = INT(name='id-M4Configuration', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_M4Configuration._val = 86
    
    #-----< id-M5Configuration >-----#
    id_M5Configuration = INT(name='id-M5Configuration', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_M5Configuration._val = 87
    
    #-----< id-MDT-Location-Info >-----#
    id_MDT_Location_Info = INT(name='id-MDT-Location-Info', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MDT_Location_Info._val = 88
    
    #-----< id-ManagementBasedMDTPLMNList >-----#
    id_ManagementBasedMDTPLMNList = INT(name='id-ManagementBasedMDTPLMNList', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ManagementBasedMDTPLMNList._val = 89
    
    #-----< id-SignallingBasedMDTPLMNList >-----#
    id_SignallingBasedMDTPLMNList = INT(name='id-SignallingBasedMDTPLMNList', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SignallingBasedMDTPLMNList._val = 90
    
    #-----< id-ReceiveStatusOfULPDCPSDUsExtended >-----#
    id_ReceiveStatusOfULPDCPSDUsExtended = INT(name='id-ReceiveStatusOfULPDCPSDUsExtended', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ReceiveStatusOfULPDCPSDUsExtended._val = 91
    
    #-----< id-ULCOUNTValueExtended >-----#
    id_ULCOUNTValueExtended = INT(name='id-ULCOUNTValueExtended', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ULCOUNTValueExtended._val = 92
    
    #-----< id-DLCOUNTValueExtended >-----#
    id_DLCOUNTValueExtended = INT(name='id-DLCOUNTValueExtended', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DLCOUNTValueExtended._val = 93
    
    #-----< id-eARFCNExtension >-----#
    id_eARFCNExtension = INT(name='id-eARFCNExtension', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_eARFCNExtension._val = 94
    
    #-----< id-UL-EARFCNExtension >-----#
    id_UL_EARFCNExtension = INT(name='id-UL-EARFCNExtension', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_EARFCNExtension._val = 95
    
    #-----< id-DL-EARFCNExtension >-----#
    id_DL_EARFCNExtension = INT(name='id-DL-EARFCNExtension', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_EARFCNExtension._val = 96
    
    #-----< id-AdditionalSpecialSubframe-Info >-----#
    id_AdditionalSpecialSubframe_Info = INT(name='id-AdditionalSpecialSubframe-Info', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AdditionalSpecialSubframe_Info._val = 97
    
    #-----< id-Masked-IMEISV >-----#
    id_Masked_IMEISV = INT(name='id-Masked-IMEISV', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Masked_IMEISV._val = 98
    
    #-----< id-IntendedULDLConfiguration >-----#
    id_IntendedULDLConfiguration = INT(name='id-IntendedULDLConfiguration', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IntendedULDLConfiguration._val = 99
    
    #-----< id-ExtendedULInterferenceOverloadInfo >-----#
    id_ExtendedULInterferenceOverloadInfo = INT(name='id-ExtendedULInterferenceOverloadInfo', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ExtendedULInterferenceOverloadInfo._val = 100
    
    #-----< id-RNL-Header >-----#
    id_RNL_Header = INT(name='id-RNL-Header', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RNL_Header._val = 101
    
    #-----< id-x2APMessage >-----#
    id_x2APMessage = INT(name='id-x2APMessage', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_x2APMessage._val = 102
    
    #-----< id-ProSeAuthorized >-----#
    id_ProSeAuthorized = INT(name='id-ProSeAuthorized', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ProSeAuthorized._val = 103
    
    #-----< id-ExpectedUEBehaviour >-----#
    id_ExpectedUEBehaviour = INT(name='id-ExpectedUEBehaviour', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ExpectedUEBehaviour._val = 104
    
    #-----< id-UE-HistoryInformationFromTheUE >-----#
    id_UE_HistoryInformationFromTheUE = INT(name='id-UE-HistoryInformationFromTheUE', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_HistoryInformationFromTheUE._val = 105
    
    #-----< id-DynamicDLTransmissionInformation >-----#
    id_DynamicDLTransmissionInformation = INT(name='id-DynamicDLTransmissionInformation', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DynamicDLTransmissionInformation._val = 106
    
    #-----< id-UE-RLF-Report-Container-for-extended-bands >-----#
    id_UE_RLF_Report_Container_for_extended_bands = INT(name='id-UE-RLF-Report-Container-for-extended-bands', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_RLF_Report_Container_for_extended_bands._val = 107
    
    #-----< id-CoMPInformation >-----#
    id_CoMPInformation = INT(name='id-CoMPInformation', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CoMPInformation._val = 108
    
    #-----< id-ReportingPeriodicityRSRPMR >-----#
    id_ReportingPeriodicityRSRPMR = INT(name='id-ReportingPeriodicityRSRPMR', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ReportingPeriodicityRSRPMR._val = 109
    
    #-----< id-RSRPMRList >-----#
    id_RSRPMRList = INT(name='id-RSRPMRList', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RSRPMRList._val = 110
    
    #-----< id-MeNB-UE-X2AP-ID >-----#
    id_MeNB_UE_X2AP_ID = INT(name='id-MeNB-UE-X2AP-ID', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MeNB_UE_X2AP_ID._val = 111
    
    #-----< id-SeNB-UE-X2AP-ID >-----#
    id_SeNB_UE_X2AP_ID = INT(name='id-SeNB-UE-X2AP-ID', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SeNB_UE_X2AP_ID._val = 112
    
    #-----< id-UE-SecurityCapabilities >-----#
    id_UE_SecurityCapabilities = INT(name='id-UE-SecurityCapabilities', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_SecurityCapabilities._val = 113
    
    #-----< id-SeNBSecurityKey >-----#
    id_SeNBSecurityKey = INT(name='id-SeNBSecurityKey', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SeNBSecurityKey._val = 114
    
    #-----< id-SeNBUEAggregateMaximumBitRate >-----#
    id_SeNBUEAggregateMaximumBitRate = INT(name='id-SeNBUEAggregateMaximumBitRate', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SeNBUEAggregateMaximumBitRate._val = 115
    
    #-----< id-ServingPLMN >-----#
    id_ServingPLMN = INT(name='id-ServingPLMN', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ServingPLMN._val = 116
    
    #-----< id-E-RABs-ToBeAdded-List >-----#
    id_E_RABs_ToBeAdded_List = INT(name='id-E-RABs-ToBeAdded-List', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_ToBeAdded_List._val = 117
    
    #-----< id-E-RABs-ToBeAdded-Item >-----#
    id_E_RABs_ToBeAdded_Item = INT(name='id-E-RABs-ToBeAdded-Item', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_ToBeAdded_Item._val = 118
    
    #-----< id-MeNBtoSeNBContainer >-----#
    id_MeNBtoSeNBContainer = INT(name='id-MeNBtoSeNBContainer', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MeNBtoSeNBContainer._val = 119
    
    #-----< id-E-RABs-Admitted-ToBeAdded-List >-----#
    id_E_RABs_Admitted_ToBeAdded_List = INT(name='id-E-RABs-Admitted-ToBeAdded-List', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_Admitted_ToBeAdded_List._val = 120
    
    #-----< id-E-RABs-Admitted-ToBeAdded-Item >-----#
    id_E_RABs_Admitted_ToBeAdded_Item = INT(name='id-E-RABs-Admitted-ToBeAdded-Item', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_Admitted_ToBeAdded_Item._val = 121
    
    #-----< id-SeNBtoMeNBContainer >-----#
    id_SeNBtoMeNBContainer = INT(name='id-SeNBtoMeNBContainer', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SeNBtoMeNBContainer._val = 122
    
    #-----< id-ResponseInformationSeNBReconfComp >-----#
    id_ResponseInformationSeNBReconfComp = INT(name='id-ResponseInformationSeNBReconfComp', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ResponseInformationSeNBReconfComp._val = 123
    
    #-----< id-UE-ContextInformationSeNBModReq >-----#
    id_UE_ContextInformationSeNBModReq = INT(name='id-UE-ContextInformationSeNBModReq', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_ContextInformationSeNBModReq._val = 124
    
    #-----< id-E-RABs-ToBeAdded-ModReqItem >-----#
    id_E_RABs_ToBeAdded_ModReqItem = INT(name='id-E-RABs-ToBeAdded-ModReqItem', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_ToBeAdded_ModReqItem._val = 125
    
    #-----< id-E-RABs-ToBeModified-ModReqItem >-----#
    id_E_RABs_ToBeModified_ModReqItem = INT(name='id-E-RABs-ToBeModified-ModReqItem', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_ToBeModified_ModReqItem._val = 126
    
    #-----< id-E-RABs-ToBeReleased-ModReqItem >-----#
    id_E_RABs_ToBeReleased_ModReqItem = INT(name='id-E-RABs-ToBeReleased-ModReqItem', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_ToBeReleased_ModReqItem._val = 127
    
    #-----< id-E-RABs-Admitted-ToBeAdded-ModAckList >-----#
    id_E_RABs_Admitted_ToBeAdded_ModAckList = INT(name='id-E-RABs-Admitted-ToBeAdded-ModAckList', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_Admitted_ToBeAdded_ModAckList._val = 128
    
    #-----< id-E-RABs-Admitted-ToBeModified-ModAckList >-----#
    id_E_RABs_Admitted_ToBeModified_ModAckList = INT(name='id-E-RABs-Admitted-ToBeModified-ModAckList', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_Admitted_ToBeModified_ModAckList._val = 129
    
    #-----< id-E-RABs-Admitted-ToBeReleased-ModAckList >-----#
    id_E_RABs_Admitted_ToBeReleased_ModAckList = INT(name='id-E-RABs-Admitted-ToBeReleased-ModAckList', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_Admitted_ToBeReleased_ModAckList._val = 130
    
    #-----< id-E-RABs-Admitted-ToBeAdded-ModAckItem >-----#
    id_E_RABs_Admitted_ToBeAdded_ModAckItem = INT(name='id-E-RABs-Admitted-ToBeAdded-ModAckItem', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_Admitted_ToBeAdded_ModAckItem._val = 131
    
    #-----< id-E-RABs-Admitted-ToBeModified-ModAckItem >-----#
    id_E_RABs_Admitted_ToBeModified_ModAckItem = INT(name='id-E-RABs-Admitted-ToBeModified-ModAckItem', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_Admitted_ToBeModified_ModAckItem._val = 132
    
    #-----< id-E-RABs-Admitted-ToBeReleased-ModAckItem >-----#
    id_E_RABs_Admitted_ToBeReleased_ModAckItem = INT(name='id-E-RABs-Admitted-ToBeReleased-ModAckItem', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_Admitted_ToBeReleased_ModAckItem._val = 133
    
    #-----< id-E-RABs-ToBeReleased-ModReqd >-----#
    id_E_RABs_ToBeReleased_ModReqd = INT(name='id-E-RABs-ToBeReleased-ModReqd', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_ToBeReleased_ModReqd._val = 134
    
    #-----< id-E-RABs-ToBeReleased-ModReqdItem >-----#
    id_E_RABs_ToBeReleased_ModReqdItem = INT(name='id-E-RABs-ToBeReleased-ModReqdItem', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_ToBeReleased_ModReqdItem._val = 135
    
    #-----< id-SCGChangeIndication >-----#
    id_SCGChangeIndication = INT(name='id-SCGChangeIndication', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SCGChangeIndication._val = 136
    
    #-----< id-E-RABs-ToBeReleased-List-RelReq >-----#
    id_E_RABs_ToBeReleased_List_RelReq = INT(name='id-E-RABs-ToBeReleased-List-RelReq', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_ToBeReleased_List_RelReq._val = 137
    
    #-----< id-E-RABs-ToBeReleased-RelReqItem >-----#
    id_E_RABs_ToBeReleased_RelReqItem = INT(name='id-E-RABs-ToBeReleased-RelReqItem', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_ToBeReleased_RelReqItem._val = 138
    
    #-----< id-E-RABs-ToBeReleased-List-RelConf >-----#
    id_E_RABs_ToBeReleased_List_RelConf = INT(name='id-E-RABs-ToBeReleased-List-RelConf', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_ToBeReleased_List_RelConf._val = 139
    
    #-----< id-E-RABs-ToBeReleased-RelConfItem >-----#
    id_E_RABs_ToBeReleased_RelConfItem = INT(name='id-E-RABs-ToBeReleased-RelConfItem', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_ToBeReleased_RelConfItem._val = 140
    
    #-----< id-E-RABs-SubjectToCounterCheck-List >-----#
    id_E_RABs_SubjectToCounterCheck_List = INT(name='id-E-RABs-SubjectToCounterCheck-List', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_SubjectToCounterCheck_List._val = 141
    
    #-----< id-E-RABs-SubjectToCounterCheckItem >-----#
    id_E_RABs_SubjectToCounterCheckItem = INT(name='id-E-RABs-SubjectToCounterCheckItem', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_SubjectToCounterCheckItem._val = 142
    
    #-----< id-CoverageModificationList >-----#
    id_CoverageModificationList = INT(name='id-CoverageModificationList', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CoverageModificationList._val = 143
    
    #-----< id-ReportingPeriodicityCSIR >-----#
    id_ReportingPeriodicityCSIR = INT(name='id-ReportingPeriodicityCSIR', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ReportingPeriodicityCSIR._val = 145
    
    #-----< id-CSIReportList >-----#
    id_CSIReportList = INT(name='id-CSIReportList', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CSIReportList._val = 146
    
    #-----< id-UEID >-----#
    id_UEID = INT(name='id-UEID', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UEID._val = 147
    
    #-----< id-enhancedRNTP >-----#
    id_enhancedRNTP = INT(name='id-enhancedRNTP', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_enhancedRNTP._val = 148
    
    #-----< id-ProSeUEtoNetworkRelaying >-----#
    id_ProSeUEtoNetworkRelaying = INT(name='id-ProSeUEtoNetworkRelaying', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ProSeUEtoNetworkRelaying._val = 149
    
    #-----< id-ReceiveStatusOfULPDCPSDUsPDCP-SNlength18 >-----#
    id_ReceiveStatusOfULPDCPSDUsPDCP_SNlength18 = INT(name='id-ReceiveStatusOfULPDCPSDUsPDCP-SNlength18', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ReceiveStatusOfULPDCPSDUsPDCP_SNlength18._val = 150
    
    #-----< id-ULCOUNTValuePDCP-SNlength18 >-----#
    id_ULCOUNTValuePDCP_SNlength18 = INT(name='id-ULCOUNTValuePDCP-SNlength18', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ULCOUNTValuePDCP_SNlength18._val = 151
    
    #-----< id-DLCOUNTValuePDCP-SNlength18 >-----#
    id_DLCOUNTValuePDCP_SNlength18 = INT(name='id-DLCOUNTValuePDCP-SNlength18', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DLCOUNTValuePDCP_SNlength18._val = 152
    
    #-----< id-UE-ContextReferenceAtSeNB >-----#
    id_UE_ContextReferenceAtSeNB = INT(name='id-UE-ContextReferenceAtSeNB', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_ContextReferenceAtSeNB._val = 153
    
    #-----< id-UE-ContextKeptIndicator >-----#
    id_UE_ContextKeptIndicator = INT(name='id-UE-ContextKeptIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_ContextKeptIndicator._val = 154
    
    #-----< id-New-eNB-UE-X2AP-ID-Extension >-----#
    id_New_eNB_UE_X2AP_ID_Extension = INT(name='id-New-eNB-UE-X2AP-ID-Extension', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_New_eNB_UE_X2AP_ID_Extension._val = 155
    
    #-----< id-Old-eNB-UE-X2AP-ID-Extension >-----#
    id_Old_eNB_UE_X2AP_ID_Extension = INT(name='id-Old-eNB-UE-X2AP-ID-Extension', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Old_eNB_UE_X2AP_ID_Extension._val = 156
    
    #-----< id-MeNB-UE-X2AP-ID-Extension >-----#
    id_MeNB_UE_X2AP_ID_Extension = INT(name='id-MeNB-UE-X2AP-ID-Extension', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MeNB_UE_X2AP_ID_Extension._val = 157
    
    #-----< id-SeNB-UE-X2AP-ID-Extension >-----#
    id_SeNB_UE_X2AP_ID_Extension = INT(name='id-SeNB-UE-X2AP-ID-Extension', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SeNB_UE_X2AP_ID_Extension._val = 158
    
    #-----< id-LHN-ID >-----#
    id_LHN_ID = INT(name='id-LHN-ID', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_LHN_ID._val = 159
    
    #-----< id-FreqBandIndicatorPriority >-----#
    id_FreqBandIndicatorPriority = INT(name='id-FreqBandIndicatorPriority', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_FreqBandIndicatorPriority._val = 160
    
    #-----< id-M6Configuration >-----#
    id_M6Configuration = INT(name='id-M6Configuration', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_M6Configuration._val = 161
    
    #-----< id-M7Configuration >-----#
    id_M7Configuration = INT(name='id-M7Configuration', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_M7Configuration._val = 162
    
    #-----< id-Tunnel-Information-for-BBF >-----#
    id_Tunnel_Information_for_BBF = INT(name='id-Tunnel-Information-for-BBF', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Tunnel_Information_for_BBF._val = 163
    
    #-----< id-SIPTO-BearerDeactivationIndication >-----#
    id_SIPTO_BearerDeactivationIndication = INT(name='id-SIPTO-BearerDeactivationIndication', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SIPTO_BearerDeactivationIndication._val = 164
    
    #-----< id-GW-TransportLayerAddress >-----#
    id_GW_TransportLayerAddress = INT(name='id-GW-TransportLayerAddress', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GW_TransportLayerAddress._val = 165
    
    #-----< id-Correlation-ID >-----#
    id_Correlation_ID = INT(name='id-Correlation-ID', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Correlation_ID._val = 166
    
    #-----< id-SIPTO-Correlation-ID >-----#
    id_SIPTO_Correlation_ID = INT(name='id-SIPTO-Correlation-ID', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SIPTO_Correlation_ID._val = 167
    
    #-----< id-SIPTO-L-GW-TransportLayerAddress >-----#
    id_SIPTO_L_GW_TransportLayerAddress = INT(name='id-SIPTO-L-GW-TransportLayerAddress', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SIPTO_L_GW_TransportLayerAddress._val = 168
    
    #-----< id-X2RemovalThreshold >-----#
    id_X2RemovalThreshold = INT(name='id-X2RemovalThreshold', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_X2RemovalThreshold._val = 169
    
    #-----< id-CellReportingIndicator >-----#
    id_CellReportingIndicator = INT(name='id-CellReportingIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CellReportingIndicator._val = 170
    
    #-----< id-BearerType >-----#
    id_BearerType = INT(name='id-BearerType', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BearerType._val = 171
    
    #-----< id-resumeID >-----#
    id_resumeID = INT(name='id-resumeID', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_resumeID._val = 172
    
    #-----< id-UE-ContextInformationRetrieve >-----#
    id_UE_ContextInformationRetrieve = INT(name='id-UE-ContextInformationRetrieve', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_ContextInformationRetrieve._val = 173
    
    #-----< id-E-RABs-ToBeSetupRetrieve-Item >-----#
    id_E_RABs_ToBeSetupRetrieve_Item = INT(name='id-E-RABs-ToBeSetupRetrieve-Item', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_ToBeSetupRetrieve_Item._val = 174
    
    #-----< id-NewEUTRANCellIdentifier >-----#
    id_NewEUTRANCellIdentifier = INT(name='id-NewEUTRANCellIdentifier', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NewEUTRANCellIdentifier._val = 175
    
    #-----< id-V2XServicesAuthorized >-----#
    id_V2XServicesAuthorized = INT(name='id-V2XServicesAuthorized', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_V2XServicesAuthorized._val = 176
    
    #-----< id-OffsetOfNbiotChannelNumberToDL-EARFCN >-----#
    id_OffsetOfNbiotChannelNumberToDL_EARFCN = INT(name='id-OffsetOfNbiotChannelNumberToDL-EARFCN', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_OffsetOfNbiotChannelNumberToDL_EARFCN._val = 177
    
    #-----< id-OffsetOfNbiotChannelNumberToUL-EARFCN >-----#
    id_OffsetOfNbiotChannelNumberToUL_EARFCN = INT(name='id-OffsetOfNbiotChannelNumberToUL-EARFCN', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_OffsetOfNbiotChannelNumberToUL_EARFCN._val = 178
    
    #-----< id-AdditionalSpecialSubframeExtension-Info >-----#
    id_AdditionalSpecialSubframeExtension_Info = INT(name='id-AdditionalSpecialSubframeExtension-Info', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AdditionalSpecialSubframeExtension_Info._val = 179
    
    #-----< id-BandwidthReducedSI >-----#
    id_BandwidthReducedSI = INT(name='id-BandwidthReducedSI', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BandwidthReducedSI._val = 180
    
    #-----< id-MakeBeforeBreakIndicator >-----#
    id_MakeBeforeBreakIndicator = INT(name='id-MakeBeforeBreakIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MakeBeforeBreakIndicator._val = 181
    
    #-----< id-UE-ContextReferenceAtWT >-----#
    id_UE_ContextReferenceAtWT = INT(name='id-UE-ContextReferenceAtWT', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_ContextReferenceAtWT._val = 182
    
    #-----< id-WT-UE-ContextKeptIndicator >-----#
    id_WT_UE_ContextKeptIndicator = INT(name='id-WT-UE-ContextKeptIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_WT_UE_ContextKeptIndicator._val = 183
    
    #-----< id-UESidelinkAggregateMaximumBitRate >-----#
    id_UESidelinkAggregateMaximumBitRate = INT(name='id-UESidelinkAggregateMaximumBitRate', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UESidelinkAggregateMaximumBitRate._val = 184
    
    #-----< id-uL-GTPtunnelEndpoint >-----#
    id_uL_GTPtunnelEndpoint = INT(name='id-uL-GTPtunnelEndpoint', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_uL_GTPtunnelEndpoint._val = 185
    
    #-----< id-DL-scheduling-PDCCH-CCE-usage >-----#
    id_DL_scheduling_PDCCH_CCE_usage = INT(name='id-DL-scheduling-PDCCH-CCE-usage', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_scheduling_PDCCH_CCE_usage._val = 193
    
    #-----< id-UL-scheduling-PDCCH-CCE-usage >-----#
    id_UL_scheduling_PDCCH_CCE_usage = INT(name='id-UL-scheduling-PDCCH-CCE-usage', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_scheduling_PDCCH_CCE_usage._val = 194
    
    #-----< id-UEAppLayerMeasConfig >-----#
    id_UEAppLayerMeasConfig = INT(name='id-UEAppLayerMeasConfig', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UEAppLayerMeasConfig._val = 195
    
    #-----< id-extended-e-RAB-MaximumBitrateDL >-----#
    id_extended_e_RAB_MaximumBitrateDL = INT(name='id-extended-e-RAB-MaximumBitrateDL', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_extended_e_RAB_MaximumBitrateDL._val = 196
    
    #-----< id-extended-e-RAB-MaximumBitrateUL >-----#
    id_extended_e_RAB_MaximumBitrateUL = INT(name='id-extended-e-RAB-MaximumBitrateUL', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_extended_e_RAB_MaximumBitrateUL._val = 197
    
    #-----< id-extended-e-RAB-GuaranteedBitrateDL >-----#
    id_extended_e_RAB_GuaranteedBitrateDL = INT(name='id-extended-e-RAB-GuaranteedBitrateDL', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_extended_e_RAB_GuaranteedBitrateDL._val = 198
    
    #-----< id-extended-e-RAB-GuaranteedBitrateUL >-----#
    id_extended_e_RAB_GuaranteedBitrateUL = INT(name='id-extended-e-RAB-GuaranteedBitrateUL', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_extended_e_RAB_GuaranteedBitrateUL._val = 199
    
    #-----< id-extended-uEaggregateMaximumBitRateDownlink >-----#
    id_extended_uEaggregateMaximumBitRateDownlink = INT(name='id-extended-uEaggregateMaximumBitRateDownlink', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_extended_uEaggregateMaximumBitRateDownlink._val = 200
    
    #-----< id-extended-uEaggregateMaximumBitRateUplink >-----#
    id_extended_uEaggregateMaximumBitRateUplink = INT(name='id-extended-uEaggregateMaximumBitRateUplink', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_extended_uEaggregateMaximumBitRateUplink._val = 201
    
    #-----< id-NRrestrictioninEPSasSecondaryRAT >-----#
    id_NRrestrictioninEPSasSecondaryRAT = INT(name='id-NRrestrictioninEPSasSecondaryRAT', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NRrestrictioninEPSasSecondaryRAT._val = 202
    
    #-----< id-SgNBSecurityKey >-----#
    id_SgNBSecurityKey = INT(name='id-SgNBSecurityKey', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SgNBSecurityKey._val = 203
    
    #-----< id-SgNBUEAggregateMaximumBitRate >-----#
    id_SgNBUEAggregateMaximumBitRate = INT(name='id-SgNBUEAggregateMaximumBitRate', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SgNBUEAggregateMaximumBitRate._val = 204
    
    #-----< id-E-RABs-ToBeAdded-SgNBAddReqList >-----#
    id_E_RABs_ToBeAdded_SgNBAddReqList = INT(name='id-E-RABs-ToBeAdded-SgNBAddReqList', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_ToBeAdded_SgNBAddReqList._val = 205
    
    #-----< id-MeNBtoSgNBContainer >-----#
    id_MeNBtoSgNBContainer = INT(name='id-MeNBtoSgNBContainer', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MeNBtoSgNBContainer._val = 206
    
    #-----< id-SgNB-UE-X2AP-ID >-----#
    id_SgNB_UE_X2AP_ID = INT(name='id-SgNB-UE-X2AP-ID', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SgNB_UE_X2AP_ID._val = 207
    
    #-----< id-RequestedSplitSRBs >-----#
    id_RequestedSplitSRBs = INT(name='id-RequestedSplitSRBs', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RequestedSplitSRBs._val = 208
    
    #-----< id-E-RABs-ToBeAdded-SgNBAddReq-Item >-----#
    id_E_RABs_ToBeAdded_SgNBAddReq_Item = INT(name='id-E-RABs-ToBeAdded-SgNBAddReq-Item', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_ToBeAdded_SgNBAddReq_Item._val = 209
    
    #-----< id-E-RABs-Admitted-ToBeAdded-SgNBAddReqAckList >-----#
    id_E_RABs_Admitted_ToBeAdded_SgNBAddReqAckList = INT(name='id-E-RABs-Admitted-ToBeAdded-SgNBAddReqAckList', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_Admitted_ToBeAdded_SgNBAddReqAckList._val = 210
    
    #-----< id-SgNBtoMeNBContainer >-----#
    id_SgNBtoMeNBContainer = INT(name='id-SgNBtoMeNBContainer', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SgNBtoMeNBContainer._val = 211
    
    #-----< id-AdmittedSplitSRBs >-----#
    id_AdmittedSplitSRBs = INT(name='id-AdmittedSplitSRBs', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AdmittedSplitSRBs._val = 212
    
    #-----< id-E-RABs-Admitted-ToBeAdded-SgNBAddReqAck-Item >-----#
    id_E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item = INT(name='id-E-RABs-Admitted-ToBeAdded-SgNBAddReqAck-Item', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item._val = 213
    
    #-----< id-ResponseInformationSgNBReconfComp >-----#
    id_ResponseInformationSgNBReconfComp = INT(name='id-ResponseInformationSgNBReconfComp', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ResponseInformationSgNBReconfComp._val = 214
    
    #-----< id-UE-ContextInformation-SgNBModReq >-----#
    id_UE_ContextInformation_SgNBModReq = INT(name='id-UE-ContextInformation-SgNBModReq', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_ContextInformation_SgNBModReq._val = 215
    
    #-----< id-E-RABs-ToBeAdded-SgNBModReq-Item >-----#
    id_E_RABs_ToBeAdded_SgNBModReq_Item = INT(name='id-E-RABs-ToBeAdded-SgNBModReq-Item', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_ToBeAdded_SgNBModReq_Item._val = 216
    
    #-----< id-E-RABs-ToBeModified-SgNBModReq-Item >-----#
    id_E_RABs_ToBeModified_SgNBModReq_Item = INT(name='id-E-RABs-ToBeModified-SgNBModReq-Item', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_ToBeModified_SgNBModReq_Item._val = 217
    
    #-----< id-E-RABs-ToBeReleased-SgNBModReq-Item >-----#
    id_E_RABs_ToBeReleased_SgNBModReq_Item = INT(name='id-E-RABs-ToBeReleased-SgNBModReq-Item', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_ToBeReleased_SgNBModReq_Item._val = 218
    
    #-----< id-E-RABs-Admitted-ToBeAdded-SgNBModAckList >-----#
    id_E_RABs_Admitted_ToBeAdded_SgNBModAckList = INT(name='id-E-RABs-Admitted-ToBeAdded-SgNBModAckList', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_Admitted_ToBeAdded_SgNBModAckList._val = 219
    
    #-----< id-E-RABs-Admitted-ToBeModified-SgNBModAckList >-----#
    id_E_RABs_Admitted_ToBeModified_SgNBModAckList = INT(name='id-E-RABs-Admitted-ToBeModified-SgNBModAckList', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_Admitted_ToBeModified_SgNBModAckList._val = 220
    
    #-----< id-E-RABs-Admitted-ToBeReleased-SgNBModAckList >-----#
    id_E_RABs_Admitted_ToBeReleased_SgNBModAckList = INT(name='id-E-RABs-Admitted-ToBeReleased-SgNBModAckList', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_Admitted_ToBeReleased_SgNBModAckList._val = 221
    
    #-----< id-E-RABs-Admitted-ToBeAdded-SgNBModAck-Item >-----#
    id_E_RABs_Admitted_ToBeAdded_SgNBModAck_Item = INT(name='id-E-RABs-Admitted-ToBeAdded-SgNBModAck-Item', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_Admitted_ToBeAdded_SgNBModAck_Item._val = 222
    
    #-----< id-E-RABs-Admitted-ToBeModified-SgNBModAck-Item >-----#
    id_E_RABs_Admitted_ToBeModified_SgNBModAck_Item = INT(name='id-E-RABs-Admitted-ToBeModified-SgNBModAck-Item', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_Admitted_ToBeModified_SgNBModAck_Item._val = 223
    
    #-----< id-E-RABs-Admitted-ToBeReleased-SgNBModAck-Item >-----#
    id_E_RABs_Admitted_ToBeReleased_SgNBModAck_Item = INT(name='id-E-RABs-Admitted-ToBeReleased-SgNBModAck-Item', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_Admitted_ToBeReleased_SgNBModAck_Item._val = 224
    
    #-----< id-E-RABs-ToBeReleased-SgNBModReqdList >-----#
    id_E_RABs_ToBeReleased_SgNBModReqdList = INT(name='id-E-RABs-ToBeReleased-SgNBModReqdList', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_ToBeReleased_SgNBModReqdList._val = 225
    
    #-----< id-E-RABs-ToBeModified-SgNBModReqdList >-----#
    id_E_RABs_ToBeModified_SgNBModReqdList = INT(name='id-E-RABs-ToBeModified-SgNBModReqdList', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_ToBeModified_SgNBModReqdList._val = 226
    
    #-----< id-E-RABs-ToBeReleased-SgNBModReqd-Item >-----#
    id_E_RABs_ToBeReleased_SgNBModReqd_Item = INT(name='id-E-RABs-ToBeReleased-SgNBModReqd-Item', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_ToBeReleased_SgNBModReqd_Item._val = 227
    
    #-----< id-E-RABs-ToBeModified-SgNBModReqd-Item >-----#
    id_E_RABs_ToBeModified_SgNBModReqd_Item = INT(name='id-E-RABs-ToBeModified-SgNBModReqd-Item', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_ToBeModified_SgNBModReqd_Item._val = 228
    
    #-----< id-E-RABs-ToBeReleased-SgNBChaConfList >-----#
    id_E_RABs_ToBeReleased_SgNBChaConfList = INT(name='id-E-RABs-ToBeReleased-SgNBChaConfList', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_ToBeReleased_SgNBChaConfList._val = 229
    
    #-----< id-E-RABs-ToBeReleased-SgNBChaConf-Item >-----#
    id_E_RABs_ToBeReleased_SgNBChaConf_Item = INT(name='id-E-RABs-ToBeReleased-SgNBChaConf-Item', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_ToBeReleased_SgNBChaConf_Item._val = 230
    
    #-----< id-E-RABs-ToBeReleased-SgNBRelReqList >-----#
    id_E_RABs_ToBeReleased_SgNBRelReqList = INT(name='id-E-RABs-ToBeReleased-SgNBRelReqList', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_ToBeReleased_SgNBRelReqList._val = 231
    
    #-----< id-E-RABs-ToBeReleased-SgNBRelReq-Item >-----#
    id_E_RABs_ToBeReleased_SgNBRelReq_Item = INT(name='id-E-RABs-ToBeReleased-SgNBRelReq-Item', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_ToBeReleased_SgNBRelReq_Item._val = 232
    
    #-----< id-E-RABs-ToBeReleased-SgNBRelConfList >-----#
    id_E_RABs_ToBeReleased_SgNBRelConfList = INT(name='id-E-RABs-ToBeReleased-SgNBRelConfList', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_ToBeReleased_SgNBRelConfList._val = 233
    
    #-----< id-E-RABs-ToBeReleased-SgNBRelConf-Item >-----#
    id_E_RABs_ToBeReleased_SgNBRelConf_Item = INT(name='id-E-RABs-ToBeReleased-SgNBRelConf-Item', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_ToBeReleased_SgNBRelConf_Item._val = 234
    
    #-----< id-E-RABs-SubjectToSgNBCounterCheck-List >-----#
    id_E_RABs_SubjectToSgNBCounterCheck_List = INT(name='id-E-RABs-SubjectToSgNBCounterCheck-List', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_SubjectToSgNBCounterCheck_List._val = 235
    
    #-----< id-E-RABs-SubjectToSgNBCounterCheck-Item >-----#
    id_E_RABs_SubjectToSgNBCounterCheck_Item = INT(name='id-E-RABs-SubjectToSgNBCounterCheck-Item', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_SubjectToSgNBCounterCheck_Item._val = 236
    
    #-----< id-RRCContainer >-----#
    id_RRCContainer = INT(name='id-RRCContainer', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RRCContainer._val = 237
    
    #-----< id-SRBType >-----#
    id_SRBType = INT(name='id-SRBType', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRBType._val = 238
    
    #-----< id-Target-SgNB-ID >-----#
    id_Target_SgNB_ID = INT(name='id-Target-SgNB-ID', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Target_SgNB_ID._val = 239
    
    #-----< id-HandoverRestrictionList >-----#
    id_HandoverRestrictionList = INT(name='id-HandoverRestrictionList', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HandoverRestrictionList._val = 240
    
    #-----< id-SCGConfigurationQuery >-----#
    id_SCGConfigurationQuery = INT(name='id-SCGConfigurationQuery', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SCGConfigurationQuery._val = 241
    
    #-----< id-SplitSRB >-----#
    id_SplitSRB = INT(name='id-SplitSRB', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SplitSRB._val = 242
    
    #-----< id-NRUeReport >-----#
    id_NRUeReport = INT(name='id-NRUeReport', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NRUeReport._val = 243
    
    #-----< id-InitiatingNodeType-EndcX2Setup >-----#
    id_InitiatingNodeType_EndcX2Setup = INT(name='id-InitiatingNodeType-EndcX2Setup', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_InitiatingNodeType_EndcX2Setup._val = 244
    
    #-----< id-InitiatingNodeType-EndcConfigUpdate >-----#
    id_InitiatingNodeType_EndcConfigUpdate = INT(name='id-InitiatingNodeType-EndcConfigUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_InitiatingNodeType_EndcConfigUpdate._val = 245
    
    #-----< id-RespondingNodeType-EndcX2Setup >-----#
    id_RespondingNodeType_EndcX2Setup = INT(name='id-RespondingNodeType-EndcX2Setup', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RespondingNodeType_EndcX2Setup._val = 246
    
    #-----< id-RespondingNodeType-EndcConfigUpdate >-----#
    id_RespondingNodeType_EndcConfigUpdate = INT(name='id-RespondingNodeType-EndcConfigUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RespondingNodeType_EndcConfigUpdate._val = 247
    
    #-----< id-NRUESecurityCapabilities >-----#
    id_NRUESecurityCapabilities = INT(name='id-NRUESecurityCapabilities', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NRUESecurityCapabilities._val = 248
    
    #-----< id-PDCPChangeIndication >-----#
    id_PDCPChangeIndication = INT(name='id-PDCPChangeIndication', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDCPChangeIndication._val = 249
    
    #-----< id-ServedEUTRAcellsENDCX2ManagementList >-----#
    id_ServedEUTRAcellsENDCX2ManagementList = INT(name='id-ServedEUTRAcellsENDCX2ManagementList', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ServedEUTRAcellsENDCX2ManagementList._val = 250
    
    #-----< id-CellAssistanceInformation >-----#
    id_CellAssistanceInformation = INT(name='id-CellAssistanceInformation', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CellAssistanceInformation._val = 251
    
    #-----< id-Globalen-gNB-ID >-----#
    id_Globalen_gNB_ID = INT(name='id-Globalen-gNB-ID', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Globalen_gNB_ID._val = 252
    
    #-----< id-ServedNRcellsENDCX2ManagementList >-----#
    id_ServedNRcellsENDCX2ManagementList = INT(name='id-ServedNRcellsENDCX2ManagementList', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ServedNRcellsENDCX2ManagementList._val = 253
    
    #-----< id-UE-ContextReferenceAtSgNB >-----#
    id_UE_ContextReferenceAtSgNB = INT(name='id-UE-ContextReferenceAtSgNB', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_ContextReferenceAtSgNB._val = 254
    
    #-----< id-SecondaryRATUsageReport >-----#
    id_SecondaryRATUsageReport = INT(name='id-SecondaryRATUsageReport', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SecondaryRATUsageReport._val = 255
    
    #-----< id-ActivationID >-----#
    id_ActivationID = INT(name='id-ActivationID', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ActivationID._val = 256
    
    #-----< id-MeNBResourceCoordinationInformation >-----#
    id_MeNBResourceCoordinationInformation = INT(name='id-MeNBResourceCoordinationInformation', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MeNBResourceCoordinationInformation._val = 257
    
    #-----< id-SgNBResourceCoordinationInformation >-----#
    id_SgNBResourceCoordinationInformation = INT(name='id-SgNBResourceCoordinationInformation', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SgNBResourceCoordinationInformation._val = 258
    
    #-----< id-ServedEUTRAcellsToModifyListENDCConfUpd >-----#
    id_ServedEUTRAcellsToModifyListENDCConfUpd = INT(name='id-ServedEUTRAcellsToModifyListENDCConfUpd', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ServedEUTRAcellsToModifyListENDCConfUpd._val = 259
    
    #-----< id-ServedEUTRAcellsToDeleteListENDCConfUpd >-----#
    id_ServedEUTRAcellsToDeleteListENDCConfUpd = INT(name='id-ServedEUTRAcellsToDeleteListENDCConfUpd', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ServedEUTRAcellsToDeleteListENDCConfUpd._val = 260
    
    #-----< id-ServedNRcellsToModifyListENDCConfUpd >-----#
    id_ServedNRcellsToModifyListENDCConfUpd = INT(name='id-ServedNRcellsToModifyListENDCConfUpd', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ServedNRcellsToModifyListENDCConfUpd._val = 261
    
    #-----< id-ServedNRcellsToDeleteListENDCConfUpd >-----#
    id_ServedNRcellsToDeleteListENDCConfUpd = INT(name='id-ServedNRcellsToDeleteListENDCConfUpd', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ServedNRcellsToDeleteListENDCConfUpd._val = 262
    
    #-----< id-E-RABUsageReport-Item >-----#
    id_E_RABUsageReport_Item = INT(name='id-E-RABUsageReport-Item', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABUsageReport_Item._val = 263
    
    #-----< id-Old-SgNB-UE-X2AP-ID >-----#
    id_Old_SgNB_UE_X2AP_ID = INT(name='id-Old-SgNB-UE-X2AP-ID', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Old_SgNB_UE_X2AP_ID._val = 264
    
    #-----< id-SecondaryRATUsageReportList >-----#
    id_SecondaryRATUsageReportList = INT(name='id-SecondaryRATUsageReportList', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SecondaryRATUsageReportList._val = 265
    
    #-----< id-SecondaryRATUsageReport-Item >-----#
    id_SecondaryRATUsageReport_Item = INT(name='id-SecondaryRATUsageReport-Item', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SecondaryRATUsageReport_Item._val = 266
    
    #-----< id-ServedNRCellsToActivate >-----#
    id_ServedNRCellsToActivate = INT(name='id-ServedNRCellsToActivate', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ServedNRCellsToActivate._val = 267
    
    #-----< id-ActivatedNRCellList >-----#
    id_ActivatedNRCellList = INT(name='id-ActivatedNRCellList', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ActivatedNRCellList._val = 268
    
    #-----< id-SelectedPLMN >-----#
    id_SelectedPLMN = INT(name='id-SelectedPLMN', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SelectedPLMN._val = 269
    
    #-----< id-UEs-ToBeReset >-----#
    id_UEs_ToBeReset = INT(name='id-UEs-ToBeReset', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UEs_ToBeReset._val = 270
    
    #-----< id-UEs-Admitted-ToBeReset >-----#
    id_UEs_Admitted_ToBeReset = INT(name='id-UEs-Admitted-ToBeReset', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UEs_Admitted_ToBeReset._val = 271
    
    #-----< id-RRCConfigIndication >-----#
    id_RRCConfigIndication = INT(name='id-RRCConfigIndication', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RRCConfigIndication._val = 272
    
    #-----< id-DownlinkPacketLossRate >-----#
    id_DownlinkPacketLossRate = INT(name='id-DownlinkPacketLossRate', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DownlinkPacketLossRate._val = 273
    
    #-----< id-UplinkPacketLossRate >-----#
    id_UplinkPacketLossRate = INT(name='id-UplinkPacketLossRate', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UplinkPacketLossRate._val = 274
    
    #-----< id-SubscriberProfileIDforRFP >-----#
    id_SubscriberProfileIDforRFP = INT(name='id-SubscriberProfileIDforRFP', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SubscriberProfileIDforRFP._val = 275
    
    #-----< id-serviceType >-----#
    id_serviceType = INT(name='id-serviceType', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_serviceType._val = 276
    
    #-----< id-AerialUEsubscriptionInformation >-----#
    id_AerialUEsubscriptionInformation = INT(name='id-AerialUEsubscriptionInformation', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AerialUEsubscriptionInformation._val = 277
    
    #-----< id-SGNB-Addition-Trigger-Ind >-----#
    id_SGNB_Addition_Trigger_Ind = INT(name='id-SGNB-Addition-Trigger-Ind', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SGNB_Addition_Trigger_Ind._val = 278
    
    #-----< id-MeNBCell-ID >-----#
    id_MeNBCell_ID = INT(name='id-MeNBCell-ID', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MeNBCell_ID._val = 279
    
    #-----< id-RequestedSplitSRBsrelease >-----#
    id_RequestedSplitSRBsrelease = INT(name='id-RequestedSplitSRBsrelease', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RequestedSplitSRBsrelease._val = 280
    
    #-----< id-AdmittedSplitSRBsrelease >-----#
    id_AdmittedSplitSRBsrelease = INT(name='id-AdmittedSplitSRBsrelease', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AdmittedSplitSRBsrelease._val = 281
    
    #-----< id-NRS-NSSS-PowerOffset >-----#
    id_NRS_NSSS_PowerOffset = INT(name='id-NRS-NSSS-PowerOffset', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NRS_NSSS_PowerOffset._val = 282
    
    #-----< id-NSSS-NumOccasionDifferentPrecoder >-----#
    id_NSSS_NumOccasionDifferentPrecoder = INT(name='id-NSSS-NumOccasionDifferentPrecoder', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NSSS_NumOccasionDifferentPrecoder._val = 283
    
    #-----< id-ProtectedEUTRAResourceIndication >-----#
    id_ProtectedEUTRAResourceIndication = INT(name='id-ProtectedEUTRAResourceIndication', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ProtectedEUTRAResourceIndication._val = 284
    
    #-----< id-InitiatingNodeType-EutranrCellResourceCoordination >-----#
    id_InitiatingNodeType_EutranrCellResourceCoordination = INT(name='id-InitiatingNodeType-EutranrCellResourceCoordination', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_InitiatingNodeType_EutranrCellResourceCoordination._val = 285
    
    #-----< id-RespondingNodeType-EutranrCellResourceCoordination >-----#
    id_RespondingNodeType_EutranrCellResourceCoordination = INT(name='id-RespondingNodeType-EutranrCellResourceCoordination', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RespondingNodeType_EutranrCellResourceCoordination._val = 286
    
    #-----< id-DataTrafficResourceIndication >-----#
    id_DataTrafficResourceIndication = INT(name='id-DataTrafficResourceIndication', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DataTrafficResourceIndication._val = 287
    
    #-----< id-SpectrumSharingGroupID >-----#
    id_SpectrumSharingGroupID = INT(name='id-SpectrumSharingGroupID', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SpectrumSharingGroupID._val = 288
    
    #-----< id-ListofEUTRACellsinEUTRACoordinationReq >-----#
    id_ListofEUTRACellsinEUTRACoordinationReq = INT(name='id-ListofEUTRACellsinEUTRACoordinationReq', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ListofEUTRACellsinEUTRACoordinationReq._val = 289
    
    #-----< id-ListofEUTRACellsinEUTRACoordinationResp >-----#
    id_ListofEUTRACellsinEUTRACoordinationResp = INT(name='id-ListofEUTRACellsinEUTRACoordinationResp', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ListofEUTRACellsinEUTRACoordinationResp._val = 290
    
    #-----< id-ListofEUTRACellsinNRCoordinationReq >-----#
    id_ListofEUTRACellsinNRCoordinationReq = INT(name='id-ListofEUTRACellsinNRCoordinationReq', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ListofEUTRACellsinNRCoordinationReq._val = 291
    
    #-----< id-ListofNRCellsinNRCoordinationReq >-----#
    id_ListofNRCellsinNRCoordinationReq = INT(name='id-ListofNRCellsinNRCoordinationReq', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ListofNRCellsinNRCoordinationReq._val = 292
    
    #-----< id-ListofNRCellsinNRCoordinationResp >-----#
    id_ListofNRCellsinNRCoordinationResp = INT(name='id-ListofNRCellsinNRCoordinationResp', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ListofNRCellsinNRCoordinationResp._val = 293
    
    #-----< id-E-RABs-AdmittedToBeModified-SgNBModConfList >-----#
    id_E_RABs_AdmittedToBeModified_SgNBModConfList = INT(name='id-E-RABs-AdmittedToBeModified-SgNBModConfList', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_AdmittedToBeModified_SgNBModConfList._val = 294
    
    #-----< id-E-RABs-AdmittedToBeModified-SgNBModConf-Item >-----#
    id_E_RABs_AdmittedToBeModified_SgNBModConf_Item = INT(name='id-E-RABs-AdmittedToBeModified-SgNBModConf-Item', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_AdmittedToBeModified_SgNBModConf_Item._val = 295
    
    #-----< id-UEContextLevelUserPlaneActivity >-----#
    id_UEContextLevelUserPlaneActivity = INT(name='id-UEContextLevelUserPlaneActivity', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UEContextLevelUserPlaneActivity._val = 296
    
    #-----< id-ERABActivityNotifyItemList >-----#
    id_ERABActivityNotifyItemList = INT(name='id-ERABActivityNotifyItemList', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ERABActivityNotifyItemList._val = 297
    
    #-----< id-InitiatingNodeType-EndcX2Removal >-----#
    id_InitiatingNodeType_EndcX2Removal = INT(name='id-InitiatingNodeType-EndcX2Removal', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_InitiatingNodeType_EndcX2Removal._val = 298
    
    #-----< id-RespondingNodeType-EndcX2Removal >-----#
    id_RespondingNodeType_EndcX2Removal = INT(name='id-RespondingNodeType-EndcX2Removal', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RespondingNodeType_EndcX2Removal._val = 299
    
    #-----< id-RLC-Status >-----#
    id_RLC_Status = INT(name='id-RLC-Status', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RLC_Status._val = 300
    
    #-----< id-CNTypeRestrictions >-----#
    id_CNTypeRestrictions = INT(name='id-CNTypeRestrictions', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CNTypeRestrictions._val = 301
    
    #-----< id-uLpDCPSnLength >-----#
    id_uLpDCPSnLength = INT(name='id-uLpDCPSnLength', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_uLpDCPSnLength._val = 302
    
    #-----< id-BluetoothMeasurementConfiguration >-----#
    id_BluetoothMeasurementConfiguration = INT(name='id-BluetoothMeasurementConfiguration', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BluetoothMeasurementConfiguration._val = 303
    
    #-----< id-WLANMeasurementConfiguration >-----#
    id_WLANMeasurementConfiguration = INT(name='id-WLANMeasurementConfiguration', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_WLANMeasurementConfiguration._val = 304
    
    #-----< id-NRrestrictionin5GS >-----#
    id_NRrestrictionin5GS = INT(name='id-NRrestrictionin5GS', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NRrestrictionin5GS._val = 305
    
    #-----< id-dL-Forwarding >-----#
    id_dL_Forwarding = INT(name='id-dL-Forwarding', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_dL_Forwarding._val = 306
    
    #-----< id-E-RABs-DataForwardingAddress-List >-----#
    id_E_RABs_DataForwardingAddress_List = INT(name='id-E-RABs-DataForwardingAddress-List', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_DataForwardingAddress_List._val = 307
    
    #-----< id-E-RABs-DataForwardingAddress-Item >-----#
    id_E_RABs_DataForwardingAddress_Item = INT(name='id-E-RABs-DataForwardingAddress-Item', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_DataForwardingAddress_Item._val = 308
    
    #-----< id-Subscription-Based-UE-DifferentiationInfo >-----#
    id_Subscription_Based_UE_DifferentiationInfo = INT(name='id-Subscription-Based-UE-DifferentiationInfo', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Subscription_Based_UE_DifferentiationInfo._val = 309
    
    #-----< id-GNBOverloadInformation >-----#
    id_GNBOverloadInformation = INT(name='id-GNBOverloadInformation', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GNBOverloadInformation._val = 310
    
    #-----< id-dLPDCPSnLength >-----#
    id_dLPDCPSnLength = INT(name='id-dLPDCPSnLength', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_dLPDCPSnLength._val = 311
    
    #-----< id-secondarysgNBDLGTPTEIDatPDCP >-----#
    id_secondarysgNBDLGTPTEIDatPDCP = INT(name='id-secondarysgNBDLGTPTEIDatPDCP', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_secondarysgNBDLGTPTEIDatPDCP._val = 312
    
    #-----< id-secondarymeNBULGTPTEIDatPDCP >-----#
    id_secondarymeNBULGTPTEIDatPDCP = INT(name='id-secondarymeNBULGTPTEIDatPDCP', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_secondarymeNBULGTPTEIDatPDCP._val = 313
    
    #-----< id-lCID >-----#
    id_lCID = INT(name='id-lCID', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_lCID._val = 314
    
    #-----< id-duplicationActivation >-----#
    id_duplicationActivation = INT(name='id-duplicationActivation', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_duplicationActivation._val = 315
    
    #-----< id-ECGI >-----#
    id_ECGI = INT(name='id-ECGI', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ECGI._val = 316
    
    #-----< id-RLCMode-transferred >-----#
    id_RLCMode_transferred = INT(name='id-RLCMode-transferred', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RLCMode_transferred._val = 317
    
    #-----< id-E-RABs-Admitted-ToBeReleased-SgNBRelReqAckList >-----#
    id_E_RABs_Admitted_ToBeReleased_SgNBRelReqAckList = INT(name='id-E-RABs-Admitted-ToBeReleased-SgNBRelReqAckList', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_Admitted_ToBeReleased_SgNBRelReqAckList._val = 318
    
    #-----< id-E-RABs-Admitted-ToBeReleased-SgNBRelReqAck-Item >-----#
    id_E_RABs_Admitted_ToBeReleased_SgNBRelReqAck_Item = INT(name='id-E-RABs-Admitted-ToBeReleased-SgNBRelReqAck-Item', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_Admitted_ToBeReleased_SgNBRelReqAck_Item._val = 319
    
    #-----< id-E-RABs-ToBeReleased-SgNBRelReqdList >-----#
    id_E_RABs_ToBeReleased_SgNBRelReqdList = INT(name='id-E-RABs-ToBeReleased-SgNBRelReqdList', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_ToBeReleased_SgNBRelReqdList._val = 320
    
    #-----< id-E-RABs-ToBeReleased-SgNBRelReqd-Item >-----#
    id_E_RABs_ToBeReleased_SgNBRelReqd_Item = INT(name='id-E-RABs-ToBeReleased-SgNBRelReqd-Item', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_ToBeReleased_SgNBRelReqd_Item._val = 321
    
    #-----< id-NRCGI >-----#
    id_NRCGI = INT(name='id-NRCGI', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NRCGI._val = 322
    
    #-----< id-MeNBCoordinationAssistanceInformation >-----#
    id_MeNBCoordinationAssistanceInformation = INT(name='id-MeNBCoordinationAssistanceInformation', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MeNBCoordinationAssistanceInformation._val = 323
    
    #-----< id-SgNBCoordinationAssistanceInformation >-----#
    id_SgNBCoordinationAssistanceInformation = INT(name='id-SgNBCoordinationAssistanceInformation', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SgNBCoordinationAssistanceInformation._val = 324
    
    #-----< id-new-drb-ID-req >-----#
    id_new_drb_ID_req = INT(name='id-new-drb-ID-req', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_new_drb_ID_req._val = 325
    
    #-----< id-endcSONConfigurationTransfer >-----#
    id_endcSONConfigurationTransfer = INT(name='id-endcSONConfigurationTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_endcSONConfigurationTransfer._val = 326
    
    #-----< id-NRNeighbourInfoToAdd >-----#
    id_NRNeighbourInfoToAdd = INT(name='id-NRNeighbourInfoToAdd', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NRNeighbourInfoToAdd._val = 327
    
    #-----< id-NRNeighbourInfoToModify >-----#
    id_NRNeighbourInfoToModify = INT(name='id-NRNeighbourInfoToModify', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NRNeighbourInfoToModify._val = 328
    
    #-----< id-DesiredActNotificationLevel >-----#
    id_DesiredActNotificationLevel = INT(name='id-DesiredActNotificationLevel', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DesiredActNotificationLevel._val = 329
    
    #-----< id-LocationInformationSgNBReporting >-----#
    id_LocationInformationSgNBReporting = INT(name='id-LocationInformationSgNBReporting', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_LocationInformationSgNBReporting._val = 330
    
    #-----< id-LocationInformationSgNB >-----#
    id_LocationInformationSgNB = INT(name='id-LocationInformationSgNB', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_LocationInformationSgNB._val = 331
    
    #-----< id-LastNG-RANPLMNIdentity >-----#
    id_LastNG_RANPLMNIdentity = INT(name='id-LastNG-RANPLMNIdentity', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_LastNG_RANPLMNIdentity._val = 332
    
    #-----< id-EUTRANTraceID >-----#
    id_EUTRANTraceID = INT(name='id-EUTRANTraceID', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EUTRANTraceID._val = 333
    
    #-----< id-additionalPLMNs-Item >-----#
    id_additionalPLMNs_Item = INT(name='id-additionalPLMNs-Item', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_additionalPLMNs_Item._val = 334
    
    #-----< id-InterfaceInstanceIndication >-----#
    id_InterfaceInstanceIndication = INT(name='id-InterfaceInstanceIndication', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_InterfaceInstanceIndication._val = 335
    
    #-----< id-BPLMN-ID-Info-EUTRA >-----#
    id_BPLMN_ID_Info_EUTRA = INT(name='id-BPLMN-ID-Info-EUTRA', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BPLMN_ID_Info_EUTRA._val = 336
    
    #-----< id-BPLMN-ID-Info-NR >-----#
    id_BPLMN_ID_Info_NR = INT(name='id-BPLMN-ID-Info-NR', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BPLMN_ID_Info_NR._val = 337
    
    #-----< id-NBIoT-UL-DL-AlignmentOffset >-----#
    id_NBIoT_UL_DL_AlignmentOffset = INT(name='id-NBIoT-UL-DL-AlignmentOffset', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NBIoT_UL_DL_AlignmentOffset._val = 338
    
    #-----< id-ERABs-transferred-to-MeNB >-----#
    id_ERABs_transferred_to_MeNB = INT(name='id-ERABs-transferred-to-MeNB', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ERABs_transferred_to_MeNB._val = 339
    
    #-----< id-AdditionalRRMPriorityIndex >-----#
    id_AdditionalRRMPriorityIndex = INT(name='id-AdditionalRRMPriorityIndex', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AdditionalRRMPriorityIndex._val = 340
    
    #-----< id-LowerLayerPresenceStatusChange >-----#
    id_LowerLayerPresenceStatusChange = INT(name='id-LowerLayerPresenceStatusChange', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_LowerLayerPresenceStatusChange._val = 341
    
    #-----< id-FastMCGRecovery-SN-to-MN >-----#
    id_FastMCGRecovery_SN_to_MN = INT(name='id-FastMCGRecovery-SN-to-MN', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_FastMCGRecovery_SN_to_MN._val = 342
    
    #-----< id-RequestedFastMCGRecoveryViaSRB3 >-----#
    id_RequestedFastMCGRecoveryViaSRB3 = INT(name='id-RequestedFastMCGRecoveryViaSRB3', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RequestedFastMCGRecoveryViaSRB3._val = 343
    
    #-----< id-AvailableFastMCGRecoveryViaSRB3 >-----#
    id_AvailableFastMCGRecoveryViaSRB3 = INT(name='id-AvailableFastMCGRecoveryViaSRB3', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AvailableFastMCGRecoveryViaSRB3._val = 344
    
    #-----< id-RequestedFastMCGRecoveryViaSRB3Release >-----#
    id_RequestedFastMCGRecoveryViaSRB3Release = INT(name='id-RequestedFastMCGRecoveryViaSRB3Release', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RequestedFastMCGRecoveryViaSRB3Release._val = 345
    
    #-----< id-ReleaseFastMCGRecoveryViaSRB3 >-----#
    id_ReleaseFastMCGRecoveryViaSRB3 = INT(name='id-ReleaseFastMCGRecoveryViaSRB3', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ReleaseFastMCGRecoveryViaSRB3._val = 346
    
    #-----< id-FastMCGRecovery-MN-to-SN >-----#
    id_FastMCGRecovery_MN_to_SN = INT(name='id-FastMCGRecovery-MN-to-SN', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_FastMCGRecovery_MN_to_SN._val = 347
    
    #-----< id-PartialListIndicator >-----#
    id_PartialListIndicator = INT(name='id-PartialListIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PartialListIndicator._val = 348
    
    #-----< id-MaximumCellListSize >-----#
    id_MaximumCellListSize = INT(name='id-MaximumCellListSize', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MaximumCellListSize._val = 349
    
    #-----< id-MessageOversizeNotification >-----#
    id_MessageOversizeNotification = INT(name='id-MessageOversizeNotification', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MessageOversizeNotification._val = 350
    
    #-----< id-CellandCapacityAssistInfo >-----#
    id_CellandCapacityAssistInfo = INT(name='id-CellandCapacityAssistInfo', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CellandCapacityAssistInfo._val = 351
    
    #-----< id-TNLConfigurationInfo >-----#
    id_TNLConfigurationInfo = INT(name='id-TNLConfigurationInfo', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TNLConfigurationInfo._val = 352
    
    #-----< id-TNLA-To-Add-List >-----#
    id_TNLA_To_Add_List = INT(name='id-TNLA-To-Add-List', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TNLA_To_Add_List._val = 353
    
    #-----< id-TNLA-To-Update-List >-----#
    id_TNLA_To_Update_List = INT(name='id-TNLA-To-Update-List', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TNLA_To_Update_List._val = 354
    
    #-----< id-TNLA-To-Remove-List >-----#
    id_TNLA_To_Remove_List = INT(name='id-TNLA-To-Remove-List', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TNLA_To_Remove_List._val = 355
    
    #-----< id-TNLA-Setup-List >-----#
    id_TNLA_Setup_List = INT(name='id-TNLA-Setup-List', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TNLA_Setup_List._val = 356
    
    #-----< id-TNLA-Failed-To-Setup-List >-----#
    id_TNLA_Failed_To_Setup_List = INT(name='id-TNLA-Failed-To-Setup-List', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TNLA_Failed_To_Setup_List._val = 357
    
    #-----< id-UnlicensedSpectrumRestriction >-----#
    id_UnlicensedSpectrumRestriction = INT(name='id-UnlicensedSpectrumRestriction', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UnlicensedSpectrumRestriction._val = 358
    
    #-----< id-UEContextReferenceatSourceNGRAN >-----#
    id_UEContextReferenceatSourceNGRAN = INT(name='id-UEContextReferenceatSourceNGRAN', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UEContextReferenceatSourceNGRAN._val = 359
    
    #-----< id-EPCHandoverRestrictionListContainer >-----#
    id_EPCHandoverRestrictionListContainer = INT(name='id-EPCHandoverRestrictionListContainer', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EPCHandoverRestrictionListContainer._val = 360
    
    #-----< id-CHOinformation-REQ >-----#
    id_CHOinformation_REQ = INT(name='id-CHOinformation-REQ', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CHOinformation_REQ._val = 361
    
    #-----< id-CHOinformation-ACK >-----#
    id_CHOinformation_ACK = INT(name='id-CHOinformation-ACK', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CHOinformation_ACK._val = 362
    
    #-----< id-DAPSRequestInfo >-----#
    id_DAPSRequestInfo = INT(name='id-DAPSRequestInfo', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DAPSRequestInfo._val = 363
    
    #-----< id-RequestedTargetCellID >-----#
    id_RequestedTargetCellID = INT(name='id-RequestedTargetCellID', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RequestedTargetCellID._val = 364
    
    #-----< id-CandidateCellsToBeCancelledList >-----#
    id_CandidateCellsToBeCancelledList = INT(name='id-CandidateCellsToBeCancelledList', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CandidateCellsToBeCancelledList._val = 365
    
    #-----< id-DAPSResponseInfo >-----#
    id_DAPSResponseInfo = INT(name='id-DAPSResponseInfo', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DAPSResponseInfo._val = 366
    
    #-----< id-ProcedureStage >-----#
    id_ProcedureStage = INT(name='id-ProcedureStage', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ProcedureStage._val = 367
    
    #-----< id-CHO-DC-Indicator >-----#
    id_CHO_DC_Indicator = INT(name='id-CHO-DC-Indicator', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CHO_DC_Indicator._val = 368
    
    #-----< id-Ethernet-Type >-----#
    id_Ethernet_Type = INT(name='id-Ethernet-Type', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Ethernet_Type._val = 369
    
    #-----< id-NRV2XServicesAuthorized >-----#
    id_NRV2XServicesAuthorized = INT(name='id-NRV2XServicesAuthorized', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NRV2XServicesAuthorized._val = 370
    
    #-----< id-NRUESidelinkAggregateMaximumBitRate >-----#
    id_NRUESidelinkAggregateMaximumBitRate = INT(name='id-NRUESidelinkAggregateMaximumBitRate', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NRUESidelinkAggregateMaximumBitRate._val = 371
    
    #-----< id-PC5QoSParameters >-----#
    id_PC5QoSParameters = INT(name='id-PC5QoSParameters', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PC5QoSParameters._val = 372
    
    #-----< id-NPRACHConfiguration >-----#
    id_NPRACHConfiguration = INT(name='id-NPRACHConfiguration', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NPRACHConfiguration._val = 373
    
    #-----< id-NBIoT-RLF-Report-Container >-----#
    id_NBIoT_RLF_Report_Container = INT(name='id-NBIoT-RLF-Report-Container', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NBIoT_RLF_Report_Container._val = 374
    
    #-----< id-MDTConfigurationNR >-----#
    id_MDTConfigurationNR = INT(name='id-MDTConfigurationNR', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MDTConfigurationNR._val = 375
    
    #-----< id-PrivacyIndicator >-----#
    id_PrivacyIndicator = INT(name='id-PrivacyIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PrivacyIndicator._val = 376
    
    #-----< id-TraceCollectionEntityIPAddress >-----#
    id_TraceCollectionEntityIPAddress = INT(name='id-TraceCollectionEntityIPAddress', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TraceCollectionEntityIPAddress._val = 377
    
    #-----< id-UERadioCapabilityID >-----#
    id_UERadioCapabilityID = INT(name='id-UERadioCapabilityID', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UERadioCapabilityID._val = 378
    
    #-----< id-SNtriggered >-----#
    id_SNtriggered = INT(name='id-SNtriggered', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SNtriggered._val = 379
    
    #-----< id-CSI-RSTransmissionIndication >-----#
    id_CSI_RSTransmissionIndication = INT(name='id-CSI-RSTransmissionIndication', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CSI_RSTransmissionIndication._val = 380
    
    #-----< id-DLCarrierList >-----#
    id_DLCarrierList = INT(name='id-DLCarrierList', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DLCarrierList._val = 381
    
    #-----< id-TargetCellInNGRAN >-----#
    id_TargetCellInNGRAN = INT(name='id-TargetCellInNGRAN', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TargetCellInNGRAN._val = 382
    
    #-----< id-E-UTRAN-Node1-Measurement-ID >-----#
    id_E_UTRAN_Node1_Measurement_ID = INT(name='id-E-UTRAN-Node1-Measurement-ID', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_UTRAN_Node1_Measurement_ID._val = 383
    
    #-----< id-E-UTRAN-Node2-Measurement-ID >-----#
    id_E_UTRAN_Node2_Measurement_ID = INT(name='id-E-UTRAN-Node2-Measurement-ID', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_UTRAN_Node2_Measurement_ID._val = 384
    
    #-----< id-TDDULDLConfigurationCommonNR >-----#
    id_TDDULDLConfigurationCommonNR = INT(name='id-TDDULDLConfigurationCommonNR', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TDDULDLConfigurationCommonNR._val = 385
    
    #-----< id-CarrierList >-----#
    id_CarrierList = INT(name='id-CarrierList', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CarrierList._val = 386
    
    #-----< id-ULCarrierList >-----#
    id_ULCarrierList = INT(name='id-ULCarrierList', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ULCarrierList._val = 387
    
    #-----< id-FrequencyShift7p5khz >-----#
    id_FrequencyShift7p5khz = INT(name='id-FrequencyShift7p5khz', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_FrequencyShift7p5khz._val = 388
    
    #-----< id-SSB-PositionsInBurst >-----#
    id_SSB_PositionsInBurst = INT(name='id-SSB-PositionsInBurst', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SSB_PositionsInBurst._val = 389
    
    #-----< id-NRCellPRACHConfig >-----#
    id_NRCellPRACHConfig = INT(name='id-NRCellPRACHConfig', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NRCellPRACHConfig._val = 390
    
    #-----< id-CellToReport-NR-ENDC >-----#
    id_CellToReport_NR_ENDC = INT(name='id-CellToReport-NR-ENDC', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CellToReport_NR_ENDC._val = 391
    
    #-----< id-CellToReport-NR-ENDC-Item >-----#
    id_CellToReport_NR_ENDC_Item = INT(name='id-CellToReport-NR-ENDC-Item', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CellToReport_NR_ENDC_Item._val = 392
    
    #-----< id-CellMeasurementResult-NR-ENDC >-----#
    id_CellMeasurementResult_NR_ENDC = INT(name='id-CellMeasurementResult-NR-ENDC', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CellMeasurementResult_NR_ENDC._val = 393
    
    #-----< id-CellMeasurementResult-NR-ENDC-Item >-----#
    id_CellMeasurementResult_NR_ENDC_Item = INT(name='id-CellMeasurementResult-NR-ENDC-Item', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CellMeasurementResult_NR_ENDC_Item._val = 394
    
    #-----< id-IABNodeIndication >-----#
    id_IABNodeIndication = INT(name='id-IABNodeIndication', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IABNodeIndication._val = 395
    
    #-----< id-QoS-Mapping-Information >-----#
    id_QoS_Mapping_Information = INT(name='id-QoS-Mapping-Information', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_QoS_Mapping_Information._val = 396
    
    #-----< id-F1CTrafficContainer >-----#
    id_F1CTrafficContainer = INT(name='id-F1CTrafficContainer', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_F1CTrafficContainer._val = 397
    
    #-----< id-IntendedTDD-DL-ULConfiguration-NR >-----#
    id_IntendedTDD_DL_ULConfiguration_NR = INT(name='id-IntendedTDD-DL-ULConfiguration-NR', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IntendedTDD_DL_ULConfiguration_NR._val = 399
    
    #-----< id-UERadioCapability >-----#
    id_UERadioCapability = INT(name='id-UERadioCapability', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UERadioCapability._val = 400
    
    #-----< id-CellMeasurementResult-E-UTRA-ENDC >-----#
    id_CellMeasurementResult_E_UTRA_ENDC = INT(name='id-CellMeasurementResult-E-UTRA-ENDC', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CellMeasurementResult_E_UTRA_ENDC._val = 401
    
    #-----< id-CellMeasurementResult-E-UTRA-ENDC-Item >-----#
    id_CellMeasurementResult_E_UTRA_ENDC_Item = INT(name='id-CellMeasurementResult-E-UTRA-ENDC-Item', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CellMeasurementResult_E_UTRA_ENDC_Item._val = 402
    
    #-----< id-CellToReport-E-UTRA-ENDC >-----#
    id_CellToReport_E_UTRA_ENDC = INT(name='id-CellToReport-E-UTRA-ENDC', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CellToReport_E_UTRA_ENDC._val = 403
    
    #-----< id-CellToReport-E-UTRA-ENDC-Item >-----#
    id_CellToReport_E_UTRA_ENDC_Item = INT(name='id-CellToReport-E-UTRA-ENDC-Item', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CellToReport_E_UTRA_ENDC_Item._val = 404
    
    #-----< id-TraceCollectionEntityURI >-----#
    id_TraceCollectionEntityURI = INT(name='id-TraceCollectionEntityURI', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TraceCollectionEntityURI._val = 405
    
    #-----< id-SFN-Offset >-----#
    id_SFN_Offset = INT(name='id-SFN-Offset', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SFN_Offset._val = 406
    
    #-----< id-CHO-DC-EarlyDataForwarding >-----#
    id_CHO_DC_EarlyDataForwarding = INT(name='id-CHO-DC-EarlyDataForwarding', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CHO_DC_EarlyDataForwarding._val = 407
    
    #-----< id-IMSvoiceEPSfallbackfrom5G >-----#
    id_IMSvoiceEPSfallbackfrom5G = INT(name='id-IMSvoiceEPSfallbackfrom5G', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IMSvoiceEPSfallbackfrom5G._val = 408
    
    #-----< id-AdditionLocationInformation >-----#
    id_AdditionLocationInformation = INT(name='id-AdditionLocationInformation', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AdditionLocationInformation._val = 409
    
    #-----< id-DirectForwardingPathAvailability >-----#
    id_DirectForwardingPathAvailability = INT(name='id-DirectForwardingPathAvailability', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DirectForwardingPathAvailability._val = 410
    
    #-----< id-sourceNG-RAN-node-id >-----#
    id_sourceNG_RAN_node_id = INT(name='id-sourceNG-RAN-node-id', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_sourceNG_RAN_node_id._val = 411
    
    #-----< id-SourceDLForwardingIPAddress >-----#
    id_SourceDLForwardingIPAddress = INT(name='id-SourceDLForwardingIPAddress', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SourceDLForwardingIPAddress._val = 412
    
    #-----< id-SourceNodeDLForwardingIPAddress >-----#
    id_SourceNodeDLForwardingIPAddress = INT(name='id-SourceNodeDLForwardingIPAddress', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SourceNodeDLForwardingIPAddress._val = 413
    
    #-----< id-NRRACHReportInformation >-----#
    id_NRRACHReportInformation = INT(name='id-NRRACHReportInformation', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NRRACHReportInformation._val = 414
    
    #-----< id-SCG-UE-HistoryInformation >-----#
    id_SCG_UE_HistoryInformation = INT(name='id-SCG-UE-HistoryInformation', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SCG_UE_HistoryInformation._val = 415
    
    #-----< id-PSCellHistoryInformationRetrieve >-----#
    id_PSCellHistoryInformationRetrieve = INT(name='id-PSCellHistoryInformationRetrieve', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PSCellHistoryInformationRetrieve._val = 416
    
    #-----< id-MeasurementResultforNRCellsPossiblyAggregated >-----#
    id_MeasurementResultforNRCellsPossiblyAggregated = INT(name='id-MeasurementResultforNRCellsPossiblyAggregated', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MeasurementResultforNRCellsPossiblyAggregated._val = 417
    
    #-----< id-PSCell-UE-HistoryInformation >-----#
    id_PSCell_UE_HistoryInformation = INT(name='id-PSCell-UE-HistoryInformation', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PSCell_UE_HistoryInformation._val = 418
    
    #-----< id-PSCellChangeHistory >-----#
    id_PSCellChangeHistory = INT(name='id-PSCellChangeHistory', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PSCellChangeHistory._val = 419
    
    #-----< id-CHOinformation-AddReq >-----#
    id_CHOinformation_AddReq = INT(name='id-CHOinformation-AddReq', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CHOinformation_AddReq._val = 420
    
    #-----< id-CHOinformation-ModReq >-----#
    id_CHOinformation_ModReq = INT(name='id-CHOinformation-ModReq', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CHOinformation_ModReq._val = 421
    
    #-----< id-SCGActivationStatus >-----#
    id_SCGActivationStatus = INT(name='id-SCGActivationStatus', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SCGActivationStatus._val = 422
    
    #-----< id-SCGActivationRequest >-----#
    id_SCGActivationRequest = INT(name='id-SCGActivationRequest', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SCGActivationRequest._val = 423
    
    #-----< id-CPAinformation-REQ >-----#
    id_CPAinformation_REQ = INT(name='id-CPAinformation-REQ', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CPAinformation_REQ._val = 424
    
    #-----< id-CPAinformation-REQ-ACK >-----#
    id_CPAinformation_REQ_ACK = INT(name='id-CPAinformation-REQ-ACK', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CPAinformation_REQ_ACK._val = 425
    
    #-----< id-CPAinformation-MOD >-----#
    id_CPAinformation_MOD = INT(name='id-CPAinformation-MOD', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CPAinformation_MOD._val = 426
    
    #-----< id-CPAinformation-MOD-ACK >-----#
    id_CPAinformation_MOD_ACK = INT(name='id-CPAinformation-MOD-ACK', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CPAinformation_MOD_ACK._val = 427
    
    #-----< id-CPACinformation-REQD >-----#
    id_CPACinformation_REQD = INT(name='id-CPACinformation-REQD', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CPACinformation_REQD._val = 428
    
    #-----< id-CPCinformation-REQD >-----#
    id_CPCinformation_REQD = INT(name='id-CPCinformation-REQD', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CPCinformation_REQD._val = 429
    
    #-----< id-CPCinformation-CONF >-----#
    id_CPCinformation_CONF = INT(name='id-CPCinformation-CONF', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CPCinformation_CONF._val = 430
    
    #-----< id-CPCinformation-NOTIFY >-----#
    id_CPCinformation_NOTIFY = INT(name='id-CPCinformation-NOTIFY', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CPCinformation_NOTIFY._val = 431
    
    #-----< id-CPCupdate-MOD >-----#
    id_CPCupdate_MOD = INT(name='id-CPCupdate-MOD', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CPCupdate_MOD._val = 432
    
    #-----< id-Additional-Measurement-Timing-Configuration-List >-----#
    id_Additional_Measurement_Timing_Configuration_List = INT(name='id-Additional-Measurement-Timing-Configuration-List', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Additional_Measurement_Timing_Configuration_List._val = 433
    
    #-----< id-ServedCellSpecificInfoReq-NR >-----#
    id_ServedCellSpecificInfoReq_NR = INT(name='id-ServedCellSpecificInfoReq-NR', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ServedCellSpecificInfoReq_NR._val = 434
    
    #-----< id-SecurityIndication >-----#
    id_SecurityIndication = INT(name='id-SecurityIndication', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SecurityIndication._val = 435
    
    #-----< id-SecurityResult >-----#
    id_SecurityResult = INT(name='id-SecurityResult', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SecurityResult._val = 436
    
    #-----< id-RAT-Restrictions >-----#
    id_RAT_Restrictions = INT(name='id-RAT-Restrictions', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RAT_Restrictions._val = 437
    
    #-----< id-SCGreconfigNotification >-----#
    id_SCGreconfigNotification = INT(name='id-SCGreconfigNotification', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SCGreconfigNotification._val = 438
    
    #-----< id-MIMOPRBusageInformation >-----#
    id_MIMOPRBusageInformation = INT(name='id-MIMOPRBusageInformation', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MIMOPRBusageInformation._val = 439
    
    #-----< id-SensorMeasurementConfiguration >-----#
    id_SensorMeasurementConfiguration = INT(name='id-SensorMeasurementConfiguration', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SensorMeasurementConfiguration._val = 440
    
    #-----< id-AdditionalListofForwardingGTPTunnelEndpoint >-----#
    id_AdditionalListofForwardingGTPTunnelEndpoint = INT(name='id-AdditionalListofForwardingGTPTunnelEndpoint', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AdditionalListofForwardingGTPTunnelEndpoint._val = 441
    
    _all_ = [
        id_handoverPreparation,
        id_handoverCancel,
        id_loadIndication,
        id_errorIndication,
        id_snStatusTransfer,
        id_uEContextRelease,
        id_x2Setup,
        id_reset,
        id_eNBConfigurationUpdate,
        id_resourceStatusReportingInitiation,
        id_resourceStatusReporting,
        id_privateMessage,
        id_mobilitySettingsChange,
        id_rLFIndication,
        id_handoverReport,
        id_cellActivation,
        id_x2Release,
        id_x2APMessageTransfer,
        id_x2Removal,
        id_seNBAdditionPreparation,
        id_seNBReconfigurationCompletion,
        id_meNBinitiatedSeNBModificationPreparation,
        id_seNBinitiatedSeNBModification,
        id_meNBinitiatedSeNBRelease,
        id_seNBinitiatedSeNBRelease,
        id_seNBCounterCheck,
        id_retrieveUEContext,
        id_sgNBAdditionPreparation,
        id_sgNBReconfigurationCompletion,
        id_meNBinitiatedSgNBModificationPreparation,
        id_sgNBinitiatedSgNBModification,
        id_meNBinitiatedSgNBRelease,
        id_sgNBinitiatedSgNBRelease,
        id_sgNBCounterCheck,
        id_sgNBChange,
        id_rRCTransfer,
        id_endcX2Setup,
        id_endcConfigurationUpdate,
        id_secondaryRATDataUsageReport,
        id_endcCellActivation,
        id_endcPartialReset,
        id_eUTRANRCellResourceCoordination,
        id_SgNBActivityNotification,
        id_endcX2Removal,
        id_dataForwardingAddressIndication,
        id_gNBStatusIndication,
        id_deactivateTrace,
        id_traceStart,
        id_endcConfigurationTransfer,
        id_handoverSuccess,
        id_conditionalHandoverCancel,
        id_earlyStatusTransfer,
        id_cellTrafficTrace,
        id_endcresourceStatusReporting,
        id_endcresourceStatusReportingInitiation,
        id_f1CTrafficTransfer,
        id_UERadioCapabilityIDMapping,
        id_accessAndMobilityIndication,
        id_procedure_code_58_not_to_be_used,
        id_CPC_cancel,
        maxEARFCN,
        maxEARFCNPlusOne,
        newmaxEARFCN,
        maxInterfaces,
        maxCellineNB,
        maxnoofBands,
        maxnoofBearers,
        maxNrOfErrors,
        maxnoofPDCP_SN,
        maxnoofEPLMNs,
        maxnoofEPLMNsPlusOne,
        maxnoofForbLACs,
        maxnoofForbTACs,
        maxnoofBPLMNs,
        maxnoofAdditionalPLMNs,
        maxnoofNeighbours,
        maxnoofPRBs,
        maxPools,
        maxnoofCells,
        maxnoofMBSFN,
        maxFailedMeasObjects,
        maxnoofCellIDforMDT,
        maxnoofTAforMDT,
        maxnoofMBMSServiceAreaIdentities,
        maxnoofMDTPLMNs,
        maxnoofCoMPHypothesisSet,
        maxnoofCoMPCells,
        maxUEReport,
        maxCellReport,
        maxnoofPA,
        maxCSIProcess,
        maxCSIReport,
        maxSubband,
        maxofNRNeighbours,
        maxCellinengNB,
        maxnooftimeperiods,
        maxnoofCellIDforQMC,
        maxnoofTAforQMC,
        maxnoofPLMNforQMC,
        maxUEsinengNBDU,
        maxnoofProtectedResourcePatterns,
        maxnoNRcellsSpectrumSharingWithE_UTRA,
        maxnoofNrCellBands,
        maxnoofBluetoothName,
        maxnoofWLANName,
        maxnoofextBPLMNs,
        maxnoofTLAs,
        maxnoofGTPTLAs,
        maxnoofTNLAssociations,
        maxnoofCellsinCHO,
        maxnoofPC5QoSFlows,
        maxnoofSSBAreas,
        maxnoofNRSCSs,
        maxnoofNRPhysicalResourceBlocks,
        maxnoofNonAnchorCarrierFreqConfig,
        maxnoofRACHReports,
        maxnoofPSCellsPerSN,
        maxnoofPSCellsPerPrimaryCellinUEHistoryInfo,
        maxnoofReportedNRCellsPossiblyAggregated,
        maxnoofPSCellCandidates,
        maxnoofTargetSgNBs,
        maxnoofMTCItems,
        maxnoofCSIRSconfigurations,
        maxnoofCSIRSneighbourCells,
        maxnoofCSIRSneighbourCellsInMTC,
        maxnoofSensorName,
        maxnoofTargetSgNBsMinusOne,
        id_E_RABs_Admitted_Item,
        id_E_RABs_Admitted_List,
        id_E_RAB_Item,
        id_E_RABs_NotAdmitted_List,
        id_E_RABs_ToBeSetup_Item,
        id_Cause,
        id_CellInformation,
        id_CellInformation_Item,
        id_New_eNB_UE_X2AP_ID,
        id_Old_eNB_UE_X2AP_ID,
        id_TargetCell_ID,
        id_TargeteNBtoSource_eNBTransparentContainer,
        id_TraceActivation,
        id_UE_ContextInformation,
        id_UE_HistoryInformation,
        id_UE_X2AP_ID,
        id_CriticalityDiagnostics,
        id_E_RABs_SubjectToStatusTransfer_List,
        id_E_RABs_SubjectToStatusTransfer_Item,
        id_ServedCells,
        id_GlobalENB_ID,
        id_TimeToWait,
        id_GUMMEI_ID,
        id_GUGroupIDList,
        id_ServedCellsToAdd,
        id_ServedCellsToModify,
        id_ServedCellsToDelete,
        id_Registration_Request,
        id_CellToReport,
        id_ReportingPeriodicity,
        id_CellToReport_Item,
        id_CellMeasurementResult,
        id_CellMeasurementResult_Item,
        id_GUGroupIDToAddList,
        id_GUGroupIDToDeleteList,
        id_SRVCCOperationPossible,
        id_Measurement_ID,
        id_ReportCharacteristics,
        id_ENB1_Measurement_ID,
        id_ENB2_Measurement_ID,
        id_Number_of_Antennaports,
        id_CompositeAvailableCapacityGroup,
        id_ENB1_Cell_ID,
        id_ENB2_Cell_ID,
        id_ENB2_Proposed_Mobility_Parameters,
        id_ENB1_Mobility_Parameters,
        id_ENB2_Mobility_Parameters_Modification_Range,
        id_FailureCellPCI,
        id_Re_establishmentCellECGI,
        id_FailureCellCRNTI,
        id_ShortMAC_I,
        id_SourceCellECGI,
        id_FailureCellECGI,
        id_HandoverReportType,
        id_PRACH_Configuration,
        id_MBSFN_Subframe_Info,
        id_ServedCellsToActivate,
        id_ActivatedCellList,
        id_DeactivationIndication,
        id_UE_RLF_Report_Container,
        id_ABSInformation,
        id_InvokeIndication,
        id_ABS_Status,
        id_PartialSuccessIndicator,
        id_MeasurementInitiationResult_List,
        id_MeasurementInitiationResult_Item,
        id_MeasurementFailureCause_Item,
        id_CompleteFailureCauseInformation_List,
        id_CompleteFailureCauseInformation_Item,
        id_CSG_Id,
        id_CSGMembershipStatus,
        id_MDTConfiguration,
        id_ManagementBasedMDTallowed,
        id_RRCConnSetupIndicator,
        id_NeighbourTAC,
        id_Time_UE_StayedInCell_EnhancedGranularity,
        id_RRCConnReestabIndicator,
        id_MBMS_Service_Area_List,
        id_HO_cause,
        id_TargetCellInUTRAN,
        id_MobilityInformation,
        id_SourceCellCRNTI,
        id_MultibandInfoList,
        id_M3Configuration,
        id_M4Configuration,
        id_M5Configuration,
        id_MDT_Location_Info,
        id_ManagementBasedMDTPLMNList,
        id_SignallingBasedMDTPLMNList,
        id_ReceiveStatusOfULPDCPSDUsExtended,
        id_ULCOUNTValueExtended,
        id_DLCOUNTValueExtended,
        id_eARFCNExtension,
        id_UL_EARFCNExtension,
        id_DL_EARFCNExtension,
        id_AdditionalSpecialSubframe_Info,
        id_Masked_IMEISV,
        id_IntendedULDLConfiguration,
        id_ExtendedULInterferenceOverloadInfo,
        id_RNL_Header,
        id_x2APMessage,
        id_ProSeAuthorized,
        id_ExpectedUEBehaviour,
        id_UE_HistoryInformationFromTheUE,
        id_DynamicDLTransmissionInformation,
        id_UE_RLF_Report_Container_for_extended_bands,
        id_CoMPInformation,
        id_ReportingPeriodicityRSRPMR,
        id_RSRPMRList,
        id_MeNB_UE_X2AP_ID,
        id_SeNB_UE_X2AP_ID,
        id_UE_SecurityCapabilities,
        id_SeNBSecurityKey,
        id_SeNBUEAggregateMaximumBitRate,
        id_ServingPLMN,
        id_E_RABs_ToBeAdded_List,
        id_E_RABs_ToBeAdded_Item,
        id_MeNBtoSeNBContainer,
        id_E_RABs_Admitted_ToBeAdded_List,
        id_E_RABs_Admitted_ToBeAdded_Item,
        id_SeNBtoMeNBContainer,
        id_ResponseInformationSeNBReconfComp,
        id_UE_ContextInformationSeNBModReq,
        id_E_RABs_ToBeAdded_ModReqItem,
        id_E_RABs_ToBeModified_ModReqItem,
        id_E_RABs_ToBeReleased_ModReqItem,
        id_E_RABs_Admitted_ToBeAdded_ModAckList,
        id_E_RABs_Admitted_ToBeModified_ModAckList,
        id_E_RABs_Admitted_ToBeReleased_ModAckList,
        id_E_RABs_Admitted_ToBeAdded_ModAckItem,
        id_E_RABs_Admitted_ToBeModified_ModAckItem,
        id_E_RABs_Admitted_ToBeReleased_ModAckItem,
        id_E_RABs_ToBeReleased_ModReqd,
        id_E_RABs_ToBeReleased_ModReqdItem,
        id_SCGChangeIndication,
        id_E_RABs_ToBeReleased_List_RelReq,
        id_E_RABs_ToBeReleased_RelReqItem,
        id_E_RABs_ToBeReleased_List_RelConf,
        id_E_RABs_ToBeReleased_RelConfItem,
        id_E_RABs_SubjectToCounterCheck_List,
        id_E_RABs_SubjectToCounterCheckItem,
        id_CoverageModificationList,
        id_ReportingPeriodicityCSIR,
        id_CSIReportList,
        id_UEID,
        id_enhancedRNTP,
        id_ProSeUEtoNetworkRelaying,
        id_ReceiveStatusOfULPDCPSDUsPDCP_SNlength18,
        id_ULCOUNTValuePDCP_SNlength18,
        id_DLCOUNTValuePDCP_SNlength18,
        id_UE_ContextReferenceAtSeNB,
        id_UE_ContextKeptIndicator,
        id_New_eNB_UE_X2AP_ID_Extension,
        id_Old_eNB_UE_X2AP_ID_Extension,
        id_MeNB_UE_X2AP_ID_Extension,
        id_SeNB_UE_X2AP_ID_Extension,
        id_LHN_ID,
        id_FreqBandIndicatorPriority,
        id_M6Configuration,
        id_M7Configuration,
        id_Tunnel_Information_for_BBF,
        id_SIPTO_BearerDeactivationIndication,
        id_GW_TransportLayerAddress,
        id_Correlation_ID,
        id_SIPTO_Correlation_ID,
        id_SIPTO_L_GW_TransportLayerAddress,
        id_X2RemovalThreshold,
        id_CellReportingIndicator,
        id_BearerType,
        id_resumeID,
        id_UE_ContextInformationRetrieve,
        id_E_RABs_ToBeSetupRetrieve_Item,
        id_NewEUTRANCellIdentifier,
        id_V2XServicesAuthorized,
        id_OffsetOfNbiotChannelNumberToDL_EARFCN,
        id_OffsetOfNbiotChannelNumberToUL_EARFCN,
        id_AdditionalSpecialSubframeExtension_Info,
        id_BandwidthReducedSI,
        id_MakeBeforeBreakIndicator,
        id_UE_ContextReferenceAtWT,
        id_WT_UE_ContextKeptIndicator,
        id_UESidelinkAggregateMaximumBitRate,
        id_uL_GTPtunnelEndpoint,
        id_DL_scheduling_PDCCH_CCE_usage,
        id_UL_scheduling_PDCCH_CCE_usage,
        id_UEAppLayerMeasConfig,
        id_extended_e_RAB_MaximumBitrateDL,
        id_extended_e_RAB_MaximumBitrateUL,
        id_extended_e_RAB_GuaranteedBitrateDL,
        id_extended_e_RAB_GuaranteedBitrateUL,
        id_extended_uEaggregateMaximumBitRateDownlink,
        id_extended_uEaggregateMaximumBitRateUplink,
        id_NRrestrictioninEPSasSecondaryRAT,
        id_SgNBSecurityKey,
        id_SgNBUEAggregateMaximumBitRate,
        id_E_RABs_ToBeAdded_SgNBAddReqList,
        id_MeNBtoSgNBContainer,
        id_SgNB_UE_X2AP_ID,
        id_RequestedSplitSRBs,
        id_E_RABs_ToBeAdded_SgNBAddReq_Item,
        id_E_RABs_Admitted_ToBeAdded_SgNBAddReqAckList,
        id_SgNBtoMeNBContainer,
        id_AdmittedSplitSRBs,
        id_E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item,
        id_ResponseInformationSgNBReconfComp,
        id_UE_ContextInformation_SgNBModReq,
        id_E_RABs_ToBeAdded_SgNBModReq_Item,
        id_E_RABs_ToBeModified_SgNBModReq_Item,
        id_E_RABs_ToBeReleased_SgNBModReq_Item,
        id_E_RABs_Admitted_ToBeAdded_SgNBModAckList,
        id_E_RABs_Admitted_ToBeModified_SgNBModAckList,
        id_E_RABs_Admitted_ToBeReleased_SgNBModAckList,
        id_E_RABs_Admitted_ToBeAdded_SgNBModAck_Item,
        id_E_RABs_Admitted_ToBeModified_SgNBModAck_Item,
        id_E_RABs_Admitted_ToBeReleased_SgNBModAck_Item,
        id_E_RABs_ToBeReleased_SgNBModReqdList,
        id_E_RABs_ToBeModified_SgNBModReqdList,
        id_E_RABs_ToBeReleased_SgNBModReqd_Item,
        id_E_RABs_ToBeModified_SgNBModReqd_Item,
        id_E_RABs_ToBeReleased_SgNBChaConfList,
        id_E_RABs_ToBeReleased_SgNBChaConf_Item,
        id_E_RABs_ToBeReleased_SgNBRelReqList,
        id_E_RABs_ToBeReleased_SgNBRelReq_Item,
        id_E_RABs_ToBeReleased_SgNBRelConfList,
        id_E_RABs_ToBeReleased_SgNBRelConf_Item,
        id_E_RABs_SubjectToSgNBCounterCheck_List,
        id_E_RABs_SubjectToSgNBCounterCheck_Item,
        id_RRCContainer,
        id_SRBType,
        id_Target_SgNB_ID,
        id_HandoverRestrictionList,
        id_SCGConfigurationQuery,
        id_SplitSRB,
        id_NRUeReport,
        id_InitiatingNodeType_EndcX2Setup,
        id_InitiatingNodeType_EndcConfigUpdate,
        id_RespondingNodeType_EndcX2Setup,
        id_RespondingNodeType_EndcConfigUpdate,
        id_NRUESecurityCapabilities,
        id_PDCPChangeIndication,
        id_ServedEUTRAcellsENDCX2ManagementList,
        id_CellAssistanceInformation,
        id_Globalen_gNB_ID,
        id_ServedNRcellsENDCX2ManagementList,
        id_UE_ContextReferenceAtSgNB,
        id_SecondaryRATUsageReport,
        id_ActivationID,
        id_MeNBResourceCoordinationInformation,
        id_SgNBResourceCoordinationInformation,
        id_ServedEUTRAcellsToModifyListENDCConfUpd,
        id_ServedEUTRAcellsToDeleteListENDCConfUpd,
        id_ServedNRcellsToModifyListENDCConfUpd,
        id_ServedNRcellsToDeleteListENDCConfUpd,
        id_E_RABUsageReport_Item,
        id_Old_SgNB_UE_X2AP_ID,
        id_SecondaryRATUsageReportList,
        id_SecondaryRATUsageReport_Item,
        id_ServedNRCellsToActivate,
        id_ActivatedNRCellList,
        id_SelectedPLMN,
        id_UEs_ToBeReset,
        id_UEs_Admitted_ToBeReset,
        id_RRCConfigIndication,
        id_DownlinkPacketLossRate,
        id_UplinkPacketLossRate,
        id_SubscriberProfileIDforRFP,
        id_serviceType,
        id_AerialUEsubscriptionInformation,
        id_SGNB_Addition_Trigger_Ind,
        id_MeNBCell_ID,
        id_RequestedSplitSRBsrelease,
        id_AdmittedSplitSRBsrelease,
        id_NRS_NSSS_PowerOffset,
        id_NSSS_NumOccasionDifferentPrecoder,
        id_ProtectedEUTRAResourceIndication,
        id_InitiatingNodeType_EutranrCellResourceCoordination,
        id_RespondingNodeType_EutranrCellResourceCoordination,
        id_DataTrafficResourceIndication,
        id_SpectrumSharingGroupID,
        id_ListofEUTRACellsinEUTRACoordinationReq,
        id_ListofEUTRACellsinEUTRACoordinationResp,
        id_ListofEUTRACellsinNRCoordinationReq,
        id_ListofNRCellsinNRCoordinationReq,
        id_ListofNRCellsinNRCoordinationResp,
        id_E_RABs_AdmittedToBeModified_SgNBModConfList,
        id_E_RABs_AdmittedToBeModified_SgNBModConf_Item,
        id_UEContextLevelUserPlaneActivity,
        id_ERABActivityNotifyItemList,
        id_InitiatingNodeType_EndcX2Removal,
        id_RespondingNodeType_EndcX2Removal,
        id_RLC_Status,
        id_CNTypeRestrictions,
        id_uLpDCPSnLength,
        id_BluetoothMeasurementConfiguration,
        id_WLANMeasurementConfiguration,
        id_NRrestrictionin5GS,
        id_dL_Forwarding,
        id_E_RABs_DataForwardingAddress_List,
        id_E_RABs_DataForwardingAddress_Item,
        id_Subscription_Based_UE_DifferentiationInfo,
        id_GNBOverloadInformation,
        id_dLPDCPSnLength,
        id_secondarysgNBDLGTPTEIDatPDCP,
        id_secondarymeNBULGTPTEIDatPDCP,
        id_lCID,
        id_duplicationActivation,
        id_ECGI,
        id_RLCMode_transferred,
        id_E_RABs_Admitted_ToBeReleased_SgNBRelReqAckList,
        id_E_RABs_Admitted_ToBeReleased_SgNBRelReqAck_Item,
        id_E_RABs_ToBeReleased_SgNBRelReqdList,
        id_E_RABs_ToBeReleased_SgNBRelReqd_Item,
        id_NRCGI,
        id_MeNBCoordinationAssistanceInformation,
        id_SgNBCoordinationAssistanceInformation,
        id_new_drb_ID_req,
        id_endcSONConfigurationTransfer,
        id_NRNeighbourInfoToAdd,
        id_NRNeighbourInfoToModify,
        id_DesiredActNotificationLevel,
        id_LocationInformationSgNBReporting,
        id_LocationInformationSgNB,
        id_LastNG_RANPLMNIdentity,
        id_EUTRANTraceID,
        id_additionalPLMNs_Item,
        id_InterfaceInstanceIndication,
        id_BPLMN_ID_Info_EUTRA,
        id_BPLMN_ID_Info_NR,
        id_NBIoT_UL_DL_AlignmentOffset,
        id_ERABs_transferred_to_MeNB,
        id_AdditionalRRMPriorityIndex,
        id_LowerLayerPresenceStatusChange,
        id_FastMCGRecovery_SN_to_MN,
        id_RequestedFastMCGRecoveryViaSRB3,
        id_AvailableFastMCGRecoveryViaSRB3,
        id_RequestedFastMCGRecoveryViaSRB3Release,
        id_ReleaseFastMCGRecoveryViaSRB3,
        id_FastMCGRecovery_MN_to_SN,
        id_PartialListIndicator,
        id_MaximumCellListSize,
        id_MessageOversizeNotification,
        id_CellandCapacityAssistInfo,
        id_TNLConfigurationInfo,
        id_TNLA_To_Add_List,
        id_TNLA_To_Update_List,
        id_TNLA_To_Remove_List,
        id_TNLA_Setup_List,
        id_TNLA_Failed_To_Setup_List,
        id_UnlicensedSpectrumRestriction,
        id_UEContextReferenceatSourceNGRAN,
        id_EPCHandoverRestrictionListContainer,
        id_CHOinformation_REQ,
        id_CHOinformation_ACK,
        id_DAPSRequestInfo,
        id_RequestedTargetCellID,
        id_CandidateCellsToBeCancelledList,
        id_DAPSResponseInfo,
        id_ProcedureStage,
        id_CHO_DC_Indicator,
        id_Ethernet_Type,
        id_NRV2XServicesAuthorized,
        id_NRUESidelinkAggregateMaximumBitRate,
        id_PC5QoSParameters,
        id_NPRACHConfiguration,
        id_NBIoT_RLF_Report_Container,
        id_MDTConfigurationNR,
        id_PrivacyIndicator,
        id_TraceCollectionEntityIPAddress,
        id_UERadioCapabilityID,
        id_SNtriggered,
        id_CSI_RSTransmissionIndication,
        id_DLCarrierList,
        id_TargetCellInNGRAN,
        id_E_UTRAN_Node1_Measurement_ID,
        id_E_UTRAN_Node2_Measurement_ID,
        id_TDDULDLConfigurationCommonNR,
        id_CarrierList,
        id_ULCarrierList,
        id_FrequencyShift7p5khz,
        id_SSB_PositionsInBurst,
        id_NRCellPRACHConfig,
        id_CellToReport_NR_ENDC,
        id_CellToReport_NR_ENDC_Item,
        id_CellMeasurementResult_NR_ENDC,
        id_CellMeasurementResult_NR_ENDC_Item,
        id_IABNodeIndication,
        id_QoS_Mapping_Information,
        id_F1CTrafficContainer,
        id_IntendedTDD_DL_ULConfiguration_NR,
        id_UERadioCapability,
        id_CellMeasurementResult_E_UTRA_ENDC,
        id_CellMeasurementResult_E_UTRA_ENDC_Item,
        id_CellToReport_E_UTRA_ENDC,
        id_CellToReport_E_UTRA_ENDC_Item,
        id_TraceCollectionEntityURI,
        id_SFN_Offset,
        id_CHO_DC_EarlyDataForwarding,
        id_IMSvoiceEPSfallbackfrom5G,
        id_AdditionLocationInformation,
        id_DirectForwardingPathAvailability,
        id_sourceNG_RAN_node_id,
        id_SourceDLForwardingIPAddress,
        id_SourceNodeDLForwardingIPAddress,
        id_NRRACHReportInformation,
        id_SCG_UE_HistoryInformation,
        id_PSCellHistoryInformationRetrieve,
        id_MeasurementResultforNRCellsPossiblyAggregated,
        id_PSCell_UE_HistoryInformation,
        id_PSCellChangeHistory,
        id_CHOinformation_AddReq,
        id_CHOinformation_ModReq,
        id_SCGActivationStatus,
        id_SCGActivationRequest,
        id_CPAinformation_REQ,
        id_CPAinformation_REQ_ACK,
        id_CPAinformation_MOD,
        id_CPAinformation_MOD_ACK,
        id_CPACinformation_REQD,
        id_CPCinformation_REQD,
        id_CPCinformation_CONF,
        id_CPCinformation_NOTIFY,
        id_CPCupdate_MOD,
        id_Additional_Measurement_Timing_Configuration_List,
        id_ServedCellSpecificInfoReq_NR,
        id_SecurityIndication,
        id_SecurityResult,
        id_RAT_Restrictions,
        id_SCGreconfigNotification,
        id_MIMOPRBusageInformation,
        id_SensorMeasurementConfiguration,
        id_AdditionalListofForwardingGTPTunnelEndpoint,
    ]

class X2AP_Containers:

    _name_  = 'X2AP-Containers'
    _oid_   = [0, 4, 0, 0, 21, 3, 2, 1, 5]
    
    _obj_ = [
        'X2AP-PROTOCOL-IES',
        'X2AP-PROTOCOL-IES-PAIR',
        'X2AP-PROTOCOL-EXTENSION',
        'X2AP-PRIVATE-IES',
        'ProtocolIE-Container',
        'ProtocolIE-Single-Container',
        'ProtocolIE-Field',
        'ProtocolIE-ContainerPair',
        'ProtocolIE-FieldPair',
        'ProtocolIE-ContainerList',
        'ProtocolIE-ContainerPairList',
        'ProtocolExtensionContainer',
        'ProtocolExtensionField',
        'PrivateIE-Container',
        'PrivateIE-Field',
        ]
    _type_ = [
        'X2AP-PROTOCOL-IES',
        'X2AP-PROTOCOL-IES-PAIR',
        'X2AP-PROTOCOL-EXTENSION',
        'X2AP-PRIVATE-IES',
        'ProtocolIE-Container',
        'ProtocolIE-Single-Container',
        'ProtocolIE-Field',
        'ProtocolIE-ContainerPair',
        'ProtocolIE-FieldPair',
        'ProtocolIE-ContainerList',
        'ProtocolIE-ContainerPairList',
        'ProtocolExtensionContainer',
        'ProtocolExtensionField',
        'PrivateIE-Container',
        'PrivateIE-Field',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        'X2AP-PROTOCOL-IES',
        'X2AP-PROTOCOL-IES-PAIR',
        'X2AP-PROTOCOL-EXTENSION',
        'X2AP-PRIVATE-IES',
        ]
    _param_ = [
        'ProtocolIE-Container',
        'ProtocolIE-Single-Container',
        'ProtocolIE-Field',
        'ProtocolIE-ContainerPair',
        'ProtocolIE-FieldPair',
        'ProtocolIE-ContainerList',
        'ProtocolIE-ContainerPairList',
        'ProtocolExtensionContainer',
        'ProtocolExtensionField',
        'PrivateIE-Container',
        'PrivateIE-Field',
        ]
    
    #-----< X2AP-PROTOCOL-IES >-----#
    X2AP_PROTOCOL_IES = CLASS(name='X2AP-PROTOCOL-IES', mode=MODE_TYPE)
    _X2AP_PROTOCOL_IES_id = INT(name='id', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')), uniq=True)
    _X2AP_PROTOCOL_IES_criticality = ENUM(name='criticality', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'Criticality')))
    _X2AP_PROTOCOL_IES_Value = OPEN(name='Value', mode=MODE_TYPE)
    _X2AP_PROTOCOL_IES_presence = ENUM(name='presence', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'Presence')))
    X2AP_PROTOCOL_IES._cont = ASN1Dict([
        ('id', _X2AP_PROTOCOL_IES_id),
        ('criticality', _X2AP_PROTOCOL_IES_criticality),
        ('Value', _X2AP_PROTOCOL_IES_Value),
        ('presence', _X2AP_PROTOCOL_IES_presence),
        ])
    
    #-----< X2AP-PROTOCOL-IES-PAIR >-----#
    X2AP_PROTOCOL_IES_PAIR = CLASS(name='X2AP-PROTOCOL-IES-PAIR', mode=MODE_TYPE)
    _X2AP_PROTOCOL_IES_PAIR_id = INT(name='id', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')), uniq=True)
    _X2AP_PROTOCOL_IES_PAIR_firstCriticality = ENUM(name='firstCriticality', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'Criticality')))
    _X2AP_PROTOCOL_IES_PAIR_FirstValue = OPEN(name='FirstValue', mode=MODE_TYPE)
    _X2AP_PROTOCOL_IES_PAIR_secondCriticality = ENUM(name='secondCriticality', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'Criticality')))
    _X2AP_PROTOCOL_IES_PAIR_SecondValue = OPEN(name='SecondValue', mode=MODE_TYPE)
    _X2AP_PROTOCOL_IES_PAIR_presence = ENUM(name='presence', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'Presence')))
    X2AP_PROTOCOL_IES_PAIR._cont = ASN1Dict([
        ('id', _X2AP_PROTOCOL_IES_PAIR_id),
        ('firstCriticality', _X2AP_PROTOCOL_IES_PAIR_firstCriticality),
        ('FirstValue', _X2AP_PROTOCOL_IES_PAIR_FirstValue),
        ('secondCriticality', _X2AP_PROTOCOL_IES_PAIR_secondCriticality),
        ('SecondValue', _X2AP_PROTOCOL_IES_PAIR_SecondValue),
        ('presence', _X2AP_PROTOCOL_IES_PAIR_presence),
        ])
    
    #-----< X2AP-PROTOCOL-EXTENSION >-----#
    X2AP_PROTOCOL_EXTENSION = CLASS(name='X2AP-PROTOCOL-EXTENSION', mode=MODE_TYPE)
    _X2AP_PROTOCOL_EXTENSION_id = INT(name='id', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')), uniq=True)
    _X2AP_PROTOCOL_EXTENSION_criticality = ENUM(name='criticality', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'Criticality')))
    _X2AP_PROTOCOL_EXTENSION_Extension = OPEN(name='Extension', mode=MODE_TYPE)
    _X2AP_PROTOCOL_EXTENSION_presence = ENUM(name='presence', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'Presence')))
    X2AP_PROTOCOL_EXTENSION._cont = ASN1Dict([
        ('id', _X2AP_PROTOCOL_EXTENSION_id),
        ('criticality', _X2AP_PROTOCOL_EXTENSION_criticality),
        ('Extension', _X2AP_PROTOCOL_EXTENSION_Extension),
        ('presence', _X2AP_PROTOCOL_EXTENSION_presence),
        ])
    
    #-----< X2AP-PRIVATE-IES >-----#
    X2AP_PRIVATE_IES = CLASS(name='X2AP-PRIVATE-IES', mode=MODE_TYPE)
    _X2AP_PRIVATE_IES_id = CHOICE(name='id', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'PrivateIE-ID')))
    _X2AP_PRIVATE_IES_criticality = ENUM(name='criticality', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'Criticality')))
    _X2AP_PRIVATE_IES_Value = OPEN(name='Value', mode=MODE_TYPE)
    _X2AP_PRIVATE_IES_presence = ENUM(name='presence', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'Presence')))
    X2AP_PRIVATE_IES._cont = ASN1Dict([
        ('id', _X2AP_PRIVATE_IES_id),
        ('criticality', _X2AP_PRIVATE_IES_criticality),
        ('Value', _X2AP_PRIVATE_IES_Value),
        ('presence', _X2AP_PRIVATE_IES_presence),
        ])
    
    #-----< ProtocolIE-Container >-----#
    ProtocolIE_Container = SEQ_OF(name='ProtocolIE-Container', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-Single-Container >-----#
    ProtocolIE_Single_Container = SEQ(name='ProtocolIE-Single-Container', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')), param=True)
    
    #-----< ProtocolIE-Field >-----#
    ProtocolIE_Field = SEQ(name='ProtocolIE-Field', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-ContainerPair >-----#
    ProtocolIE_ContainerPair = SEQ_OF(name='ProtocolIE-ContainerPair', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-FieldPair >-----#
    ProtocolIE_FieldPair = SEQ(name='ProtocolIE-FieldPair', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-ContainerList >-----#
    ProtocolIE_ContainerList = SEQ_OF(name='ProtocolIE-ContainerList', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-ContainerPairList >-----#
    ProtocolIE_ContainerPairList = SEQ_OF(name='ProtocolIE-ContainerPairList', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolExtensionContainer >-----#
    ProtocolExtensionContainer = SEQ_OF(name='ProtocolExtensionContainer', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolExtensionField >-----#
    ProtocolExtensionField = SEQ(name='ProtocolExtensionField', mode=MODE_TYPE, param=True)
    
    #-----< PrivateIE-Container >-----#
    PrivateIE_Container = SEQ_OF(name='PrivateIE-Container', mode=MODE_TYPE, param=True)
    
    #-----< PrivateIE-Field >-----#
    PrivateIE_Field = SEQ(name='PrivateIE-Field', mode=MODE_TYPE, param=True)
    
    _all_ = [
        _X2AP_PROTOCOL_IES_id,
        _X2AP_PROTOCOL_IES_criticality,
        _X2AP_PROTOCOL_IES_Value,
        _X2AP_PROTOCOL_IES_presence,
        X2AP_PROTOCOL_IES,
        _X2AP_PROTOCOL_IES_PAIR_id,
        _X2AP_PROTOCOL_IES_PAIR_firstCriticality,
        _X2AP_PROTOCOL_IES_PAIR_FirstValue,
        _X2AP_PROTOCOL_IES_PAIR_secondCriticality,
        _X2AP_PROTOCOL_IES_PAIR_SecondValue,
        _X2AP_PROTOCOL_IES_PAIR_presence,
        X2AP_PROTOCOL_IES_PAIR,
        _X2AP_PROTOCOL_EXTENSION_id,
        _X2AP_PROTOCOL_EXTENSION_criticality,
        _X2AP_PROTOCOL_EXTENSION_Extension,
        _X2AP_PROTOCOL_EXTENSION_presence,
        X2AP_PROTOCOL_EXTENSION,
        _X2AP_PRIVATE_IES_id,
        _X2AP_PRIVATE_IES_criticality,
        _X2AP_PRIVATE_IES_Value,
        _X2AP_PRIVATE_IES_presence,
        X2AP_PRIVATE_IES,
    ]

class X2AP_IEs:

    _name_  = 'X2AP-IEs'
    _oid_   = [0, 4, 0, 0, 21, 3, 2, 1, 2]
    
    _obj_ = [
        'ABSInformation',
        'ABSInformationFDD',
        'ABSInformationFDD-ExtIEs',
        'ABSInformationTDD',
        'ABSInformationTDD-ExtIEs',
        'ABS-Status',
        'ABS-Status-ExtIEs',
        'ActivationID',
        'Additional-Measurement-Timing-Configuration-List',
        'Additional-Measurement-Timing-Configuration-Item',
        'Additional-Measurement-Timing-Configuration-Item-ExtIEs',
        'CSI-RS-MTC-Configuration-List',
        'CSI-RS-MTC-Configuration-Item',
        'CSI-RS-MTC-Configuration-Item-ExtIEs',
        'CSI-RS-Neighbour-List',
        'CSI-RS-Neighbour-Item',
        'CSI-RS-Neighbour-Item-ExtIEs',
        'CSI-RS-MTC-Neighbour-List',
        'CSI-RS-MTC-Neighbour-Item',
        'CSI-RS-MTC-Neighbour-Item-ExtIEs',
        'AdditionalListofForwardingGTPTunnelEndpoint',
        'AdditionalListofForwardingGTPTunnelEndpoint-Item',
        'AdditionalListofForwardingGTPTunnelEndpoint-Item-ExtIEs',
        'AdditionLocationInformation',
        'AdditionalRRMPriorityIndex',
        'AdditionalSpecialSubframe-Info',
        'AdditionalSpecialSubframe-Info-ExtIEs',
        'AdditionalSpecialSubframePatterns',
        'AdditionalSpecialSubframeExtension-Info',
        'AdditionalSpecialSubframeExtension-Info-ExtIEs',
        'AdditionalSpecialSubframePatternsExtension',
        'AvailableFastMCGRecoveryViaSRB3',
        'AerialUEsubscriptionInformation',
        'AllocationAndRetentionPriority',
        'AllocationAndRetentionPriority-ExtIEs',
        'AreaScopeOfMDT',
        'AreaScopeOfQMC',
        'AS-SecurityInformation',
        'AS-SecurityInformation-ExtIEs',
        'AdditionalPLMNs-Item',
        'BandwidthReducedSI',
        'BearerType',
        'BenefitMetric',
        'BitRate',
        'BroadcastPLMNs-Item',
        'BluetoothMeasurementConfiguration',
        'BluetoothMeasurementConfiguration-ExtIEs',
        'BluetoothMeasConfigNameList',
        'BluetoothMeasConfig',
        'BluetoothName',
        'BPLMN-ID-Info-EUTRA',
        'BPLMN-ID-Info-EUTRA-Item',
        'BPLMN-ID-Info-EUTRA-Item-ExtIEs',
        'BPLMN-ID-Info-NR',
        'BPLMN-ID-Info-NR-Item',
        'BPLMN-ID-Info-NR-Item-ExtIEs',
        'BroadcastextPLMNs',
        'CapacityValue',
        'Cause',
        'CauseMisc',
        'CauseProtocol',
        'CauseRadioNetwork',
        'CauseTransport',
        'CellBasedMDT',
        'CellBasedMDT-ExtIEs',
        'CellBasedQMC',
        'CellBasedQMC-ExtIEs',
        'CellCapacityClassValue',
        'CellDeploymentStatusIndicator',
        'CellIdListforMDT',
        'CellIdListforQMC',
        'CellReplacingInfo',
        'CellReplacingInfo-ExtIEs',
        'CellReportingIndicator',
        'Cell-Size',
        'CellType',
        'CellType-ExtIEs',
        'CPACcandidatePSCells-list',
        'CPACcandidatePSCells-item',
        'CPACcandidatePSCells-item-ExtIEs',
        'CPCindicator',
        'CPCdataforwarding',
        'CPAinformation-REQ',
        'CPAinformation-REQ-ExtIEs',
        'CPAinformation-REQ-ACK',
        'CPAinformation-REQ-ACK-ExtIEs',
        'CPCinformation-REQD',
        'CPCinformation-REQD-ExtIEs',
        'CPC-target-SgNB-reqd-list',
        'CPC-target-SgNB-reqd-item',
        'CPC-target-SgNB-reqd-item-ExtIEs',
        'CPCinformation-CONF',
        'CPCinformation-CONF-ExtIEs',
        'CPC-target-SgNB-conf-list',
        'CPC-target-SgNB-conf-item',
        'CPC-target-SgNB-conf-item-ExtIEs',
        'CPCinformation-NOTIFY',
        'CPCinformation-NOTIFY-ExtIEs',
        'CPAinformation-MOD',
        'CPAinformation-MOD-ExtIEs',
        'CPCupdate-MOD',
        'CPCupdate-MOD-ExtIEs',
        'CPC-target-SgNB-mod-list',
        'CPC-target-SgNB-mod-item',
        'CPC-target-SgNB-mod-item-ExtIEs',
        'CPAinformation-MOD-ACK',
        'CPAinformation-MOD-ACK-ExtIEs',
        'CPACinformation-REQD',
        'CPACinformation-REQD-ExtIEs',
        'CHO-DC-EarlyDataForwarding',
        'CHO-DC-Indicator',
        'CNTypeRestrictions',
        'CNTypeRestrictionsItem',
        'CNTypeRestrictionsItem-ExtIEs',
        'CoMPHypothesisSet',
        'CoMPHypothesisSetItem',
        'CoMPHypothesisSetItem-ExtIEs',
        'CoMPInformation',
        'CoMPInformation-ExtIEs',
        'CoMPInformationItem',
        'CoMPInformationItem-ExtIEs',
        'CoMPInformationStartTime',
        'CoMPInformationStartTime-ExtIEs',
        'CompositeAvailableCapacity',
        'CompositeAvailableCapacity-ExtIEs',
        'CompositeAvailableCapacityGroup',
        'CompositeAvailableCapacityGroup-ExtIEs',
        'Correlation-ID',
        'COUNTvalue',
        'COUNTvalue-ExtIEs',
        'COUNTValueExtended',
        'COUNTValueExtended-ExtIEs',
        'COUNTvaluePDCP-SNlength18',
        'COUNTvaluePDCP-SNlength18-ExtIEs',
        'CoverageModificationList',
        'CoverageModification-Item',
        'CPTransportLayerInformation',
        'CriticalityDiagnostics',
        'CriticalityDiagnostics-ExtIEs',
        'CriticalityDiagnostics-IE-List',
        'CriticalityDiagnostics-IE-List-ExtIEs',
        'CRNTI',
        'CSGMembershipStatus',
        'CSG-Id',
        'CSIReportList',
        'CSIReportList-ExtIEs',
        'CSIReportPerCSIProcess',
        'CSIReportPerCSIProcess-ExtIEs',
        'CSIReportPerCSIProcessItem',
        'CSIReportPerCSIProcessItem-ExtIEs',
        'CyclicPrefixDL',
        'CyclicPrefixUL',
        'CHOtrigger',
        'CHOinformation-REQ',
        'CHOinformation-REQ-ExtIEs',
        'CHOinformation-ACK',
        'CHOinformation-ACK-ExtIEs',
        'CandidateCellsToBeCancelledList',
        'CHO-Probability',
        'CHOinformation-AddReq',
        'CHOinformation-AddReq-ExtIEs',
        'CHOinformation-ModReq',
        'CHOinformation-ModReq-ExtIEs',
        'CSI-RSTransmissionIndication',
        'DataTrafficResources',
        'DataTrafficResourceIndication',
        'DataTrafficResourceIndication-ExtIEs',
        'DAPSRequestInfo',
        'DAPSRequestInfo-ExtIEs',
        'DAPSResponseInfo',
        'DAPSResponseInfo-ExtIEs',
        'DeactivationIndication',
        'DeliveryStatus',
        'DeliveryStatus-ExtIEs',
        'DesiredActNotificationLevel',
        'DirectForwardingPathAvailability',
        'DL-ABS-status',
        'DL-Forwarding',
        'DL-GBR-PRB-usage',
        'DL-GBR-PRB-usage-for-MIMO',
        'DL-non-GBR-PRB-usage',
        'DL-non-GBR-PRB-usage-for-MIMO',
        'DLResourceBitmapULandDLSharing',
        'DLResourcesULandDLSharing',
        'DL-scheduling-PDCCH-CCE-usage',
        'DL-Total-PRB-usage',
        'DL-Total-PRB-usage-for-MIMO',
        'DRB-ID',
        'DuplicationActivation',
        'DynamicDLTransmissionInformation',
        'DynamicNAICSInformation',
        'DynamicNAICSInformation-ExtIEs',
        'EARFCN',
        'EARFCNExtension',
        'ECGI',
        'ECGI-ExtIEs',
        'EndcSONConfigurationTransfer',
        'EnhancedRNTP',
        'EnhancedRNTP-ExtIEs',
        'EnhancedRNTPStartTime',
        'EnhancedRNTPStartTime-ExtIEs',
        'ENB-ID',
        'EncryptionAlgorithms',
        'EN-DC-ResourceConfiguration',
        'EN-DC-ResourceConfigurationExtIEs',
        'EPCHandoverRestrictionListContainer',
        'EPLMNs',
        'ERABActivityNotifyItemList',
        'ERABActivityNotifyItem',
        'ERABActivityNotifyItem-ExtIEs',
        'E-RAB-ID',
        'E-RAB-Level-QoS-Parameters',
        'E-RAB-Level-QoS-Parameters-ExtIEs',
        'E-RAB-List',
        'E-RAB-ItemIEs',
        'E-RAB-Item',
        'E-RAB-Item-ExtIEs',
        'E-RABsSubjectToEarlyStatusTransfer-List',
        'E-RABsSubjectToEarlyStatusTransfer-Item',
        'E-RABsSubjectToEarlyStatusTransfer-Item-ExtIEs',
        'E-RABsSubjectToDLDiscarding-List',
        'E-RABsSubjectToDLDiscarding-Item',
        'E-RABsSubjectToDLDiscarding-Item-ExtIEs',
        'E-RABUsageReportList',
        'E-RABUsageReport-ItemIEs',
        'E-RABUsageReport-Item',
        'E-RABUsageReport-Item-ExtIEs',
        'Ethernet-Type',
        'EUTRA-Mode-Info',
        'EUTRANCellIdentifier',
        'EUTRANTraceID',
        'EventType',
        'ExpectedUEBehaviour',
        'ExpectedUEBehaviour-ExtIEs',
        'ExpectedUEActivityBehaviour',
        'ExpectedUEActivityBehaviour-ExtIEs',
        'ExpectedActivityPeriod',
        'ExpectedIdlePeriod',
        'ExpectedHOInterval',
        'ExtendedULInterferenceOverloadInfo',
        'ExtendedULInterferenceOverloadInfo-ExtIEs',
        'ExtendedBitRate',
        'F1CTrafficContainer',
        'FastMCGRecovery',
        'FastMCGRecovery-ExtIEs',
        'FDD-Info',
        'FDD-Info-ExtIEs',
        'FDD-InfoNeighbourServedNRCell-Information',
        'FDD-InfoNeighbourServedNRCell-Information-ExtIEs',
        'FiveQI',
        'ForbiddenInterRATs',
        'ForbiddenTAs',
        'ForbiddenTAs-Item',
        'ForbiddenTAs-Item-ExtIEs',
        'ForbiddenTACs',
        'ForbiddenLAs',
        'ForbiddenLAs-Item',
        'ForbiddenLAs-Item-ExtIEs',
        'ForbiddenLACs',
        'Fourframes',
        'FreqBandIndicator',
        'FreqBandIndicatorPriority',
        'FreqBandNrItem',
        'FreqBandNrItem-ExtIEs',
        'FrequencyShift7p5khz',
        'GBR-QosInformation',
        'GBR-QosInformation-ExtIEs',
        'GlobalENB-ID',
        'GlobalENB-ID-ExtIEs',
        'GlobalGNB-ID',
        'GlobalGNB-ID-ExtIEs',
        'Global-RAN-NODE-ID',
        'Global-RAN-NODE-ID-ExtIEs',
        'GNBOverloadInformation',
        'GTPTLAs',
        'GTPTLA-Item',
        'GTPTLA-Item-ExtIEs',
        'GTPtunnelEndpoint',
        'GTPtunnelEndpoint-ExtIEs',
        'GTP-TEI',
        'GUGroupIDList',
        'GU-Group-ID',
        'GU-Group-ID-ExtIEs',
        'GUMMEI',
        'GUMMEI-ExtIEs',
        'GNB-ID',
        'HandoverReportType',
        'HandoverRestrictionList',
        'HandoverRestrictionList-ExtIEs',
        'HFN',
        'HFNModified',
        'HFNforPDCP-SNlength18',
        'HWLoadIndicator',
        'HWLoadIndicator-ExtIEs',
        'IABNodeIndication',
        'IMSvoiceEPSfallbackfrom5G',
        'IntegrityProtectionAlgorithms',
        'IntegrityProtectionIndication',
        'IntegrityProtectionResult',
        'IntendedTDD-DL-ULConfiguration-NR',
        'InterfaceInstanceIndication',
        'InterfacesToTrace',
        'InvokeIndication',
        'Key-eNodeB-Star',
        'LastVisitedPSCell-Item',
        'LAC',
        'LastVisitedCell-Item',
        'LastVisitedEUTRANCellInformation',
        'LastVisitedEUTRANCellInformation-ExtIEs',
        'LastVisitedGERANCellInformation',
        'LastVisitedNGRANCellInformation',
        'LastVisitedUTRANCellInformation',
        'LCID',
        'LHN-ID',
        'Links-to-log',
        'LoadIndicator',
        'LocationInformationSgNB',
        'LocationInformationSgNB-ExtIEs',
        'LocationInformationSgNBReporting',
        'LocationReportingInformation',
        'LocationReportingInformation-ExtIEs',
        'LowerLayerPresenceStatusChange',
        'M1PeriodicReporting',
        'M1PeriodicReporting-ExtIEs',
        'M1ReportingTrigger',
        'M1ThresholdEventA2',
        'M1ThresholdEventA2-ExtIEs',
        'M3Configuration',
        'M3Configuration-ExtIEs',
        'M3period',
        'M4Configuration',
        'M4Configuration-ExtIEs',
        'M4period',
        'M5Configuration',
        'M5Configuration-ExtIEs',
        'M5period',
        'M6Configuration',
        'M6Configuration-ExtIEs',
        'M6report-interval',
        'M6delay-threshold',
        'M7Configuration',
        'M7Configuration-ExtIEs',
        'M7period',
        'MakeBeforeBreakIndicator',
        'ManagementBasedMDTallowed',
        'Masked-IMEISV',
        'MaxCHOpreparations',
        'MDT-Activation',
        'MDT-Configuration',
        'MDT-Configuration-ExtIEs',
        'MDTPLMNList',
        'MDT-Location-Info',
        'Measurement-ID',
        'Measurement-ID-ENDC',
        'MeasurementsToActivate',
        'MeasurementThresholdA2',
        'MeNBCoordinationAssistanceInformation',
        'MeNBResourceCoordinationInformation',
        'MeNBResourceCoordinationInformationExtIEs',
        'MeNBtoSeNBContainer',
        'MME-Group-ID',
        'MME-Code',
        'MBMS-Service-Area-Identity-List',
        'MBMS-Service-Area-Identity',
        'MBSFN-Subframe-Infolist',
        'MBSFN-Subframe-Info',
        'MBSFN-Subframe-Info-ExtIEs',
        'MDT-ConfigurationNR',
        'MobilityParametersModificationRange',
        'MobilityParametersInformation',
        'MultibandInfoList',
        'MessageOversizeNotification',
        'MessageOversizeNotification-ExtIEs',
        'MaximumCellListSize',
        'BandInfo',
        'BandInfo-ExtIEs',
        'MeNBtoSgNBContainer',
        'SplitSRBs',
        'SplitSRB',
        'SplitSRB-ExtIEs',
        'NBIoT-UL-DL-AlignmentOffset',
        'NBIoT-RLF-Report-Container',
        'Neighbour-Information',
        'Neighbour-Information-ExtIEs',
        'NextHopChainingCount',
        'NewDRBIDrequest',
        'Number-of-Antennaports',
        'NRCapacityValue',
        'NRCapacityValue-ExtIEs',
        'NRCarrierList',
        'NRCarrierItem',
        'NRCarrierItem-ExtIEs',
        'NRCellCapacityClassValue',
        'NRCellPRACHConfig',
        'NRCompositeAvailableCapacityGroup',
        'NRCompositeAvailableCapacityGroup-ExtIEs',
        'NRCompositeAvailableCapacity',
        'NRCompositeAvailableCapacity-ExtIEs',
        'NRFreqInfo',
        'NRFreqInfo-ExtIEs',
        'NRCellIdentifier',
        'NRCGI',
        'NRCGI-ExtIEs',
        'NRRACHReportContainer',
        'NRRACHReportInformation',
        'NRRACHReportList-Item',
        'NRRACHReportList-Item-ExtIEs',
        'NRNeighbour-Information',
        'NRNeighbour-Information-ExtIEs',
        'NPRACHConfiguration',
        'NPRACHConfiguration-ExtIEs',
        'NPRACHConfiguration-FDD',
        'NPRACHConfiguration-FDD-ExtIEs',
        'NPRACHConfiguration-TDD',
        'NPRACHConfiguration-TDD-ExtIEs',
        'NPRACH-CP-Length',
        'NPRACH-preambleFormat',
        'Non-AnchorCarrierFrequencylist',
        'Non-AnchorCarrierFrequencylist-ExtIEs',
        'NRPCI',
        'NRrestrictioninEPSasSecondaryRAT',
        'MeasurementResultforNRCellsPossiblyAggregated',
        'MeasurementResultforNRCellsPossiblyAggregated-Item',
        'MeasurementResultforNRCellsPossiblyAggregated-Item-ExtIEs',
        'NRRadioResourceStatus',
        'NRRadioResourceStatus-ExtIEs',
        'MIMOPRBusageInformation',
        'MIMOPRBusageInformation-ExtIEs',
        'NRrestrictionin5GS',
        'NRencryptionAlgorithms',
        'NRintegrityProtectionAlgorithms',
        'NR-TxBW',
        'NR-TxBW-ExtIEs',
        'NRNRB',
        'NRSCS',
        'NRS-NSSS-PowerOffset',
        'FiveGS-TAC',
        'NRUeReport',
        'NRUeReport-ExtIEs',
        'NRUESidelinkAggregateMaximumBitRate',
        'NRUESidelinkAggregateMaximumBitRate-ExtIEs',
        'NRUESecurityCapabilities',
        'NRUESecurityCapabilities-ExtIEs',
        'NSSS-NumOccasionDifferentPrecoder',
        'NRV2XServicesAuthorized',
        'NRV2XServicesAuthorized-ExtIEs',
        'OffsetOfNbiotChannelNumberToEARFCN',
        'Oneframe',
        'Packet-LossRate',
        'PA-Values',
        'PC5QoSParameters',
        'PC5QoSParameters-ExtIEs',
        'PC5QoSFlowList',
        'PC5QoSFlowItem',
        'PC5QoSFlowItem-ExtIEs',
        'PC5FlowBitRates',
        'PC5FlowBitRates-ExtIEs',
        'PDCPChangeIndication',
        'PDCP-SN',
        'PDCP-SNExtended',
        'PDCP-SNlength18',
        'PDCPSnLength',
        'PCI',
        'PLMN-Identity',
        'Port-Number',
        'PRACH-Configuration',
        'PLMNAreaBasedQMC',
        'PLMNAreaBasedQMC-ExtIEs',
        'PLMNListforQMC',
        'PRACH-Configuration-ExtIEs',
        'Pre-emptionCapability',
        'Pre-emptionVulnerability',
        'PriorityLevel',
        'ProSeAuthorized',
        'ProSeAuthorized-ExtIEs',
        'ProSeDirectDiscovery',
        'ProSeDirectCommunication',
        'ProSeUEtoNetworkRelaying',
        'ProtectedEUTRAResourceIndication',
        'ProtectedEUTRAResourceIndication-ExtIEs',
        'ProtectedFootprintTimePattern',
        'ProtectedFootprintTimePattern-ExtIEs',
        'ProtectedResourceList',
        'ProtectedResourceList-Item',
        'ProtectedResourceList-Item-ExtIEs',
        'PartialListIndicator',
        'PrivacyIndicator',
        'PSCellHistoryInformationRetrieve',
        'PSCell-UE-HistoryInformation',
        'PSCellChangeHistory',
        'QCI',
        'QoS-Mapping-Information',
        'QoS-Mapping-Information-ExtIEs',
        'RadioframeAllocationOffset',
        'RadioframeAllocationPeriod',
        'RadioResourceStatus',
        'RadioResourceStatus-ExtIEs',
        'Range',
        'RAN-UE-NGAP-ID',
        'RAT-Restrictions',
        'RAT-RestrictionsItem',
        'RAT-RestrictionsItem-ExtIEs',
        'ReceiveStatusofULPDCPSDUs',
        'ReceiveStatusOfULPDCPSDUsExtended',
        'ReceiveStatusOfULPDCPSDUsPDCP-SNlength18',
        'ReleaseFastMCGRecoveryViaSRB3',
        'Reestablishment-Indication',
        'Registration-Request',
        'Registration-Request-ENDC',
        'RelativeNarrowbandTxPower',
        'RelativeNarrowbandTxPower-ExtIEs',
        'ReplacingCellsList',
        'ReplacingCellsList-Item',
        'ReportAmountMDT',
        'ReportArea',
        'ReportCharacteristics',
        'ReportingPeriodicityCSIR',
        'ReportCharacteristics-ENDC',
        'ReportingPeriodicityRSRPMR',
        'ReportIntervalMDT',
        'RequestedFastMCGRecoveryViaSRB3',
        'RequestedFastMCGRecoveryViaSRB3Release',
        'ReservedSubframePattern',
        'ReservedSubframePattern-ExtIEs',
        'ResourceType',
        'ResumeID',
        'RLCMode',
        'RLC-Status',
        'RLC-Status-ExtIEs',
        'RNTP-Threshold',
        'RRC-Config-Ind',
        'RRC-Context',
        'RRCConnReestabIndicator',
        'RRCConnSetupIndicator',
        'RSRPMeasurementResult',
        'RSRPMeasurementResult-ExtIEs',
        'RSRPMRList',
        'RSRPMRList-ExtIEs',
        'RRCContainer',
        'S1TNLLoadIndicator',
        'S1TNLLoadIndicator-ExtIEs',
        'SCGActivationStatus',
        'SCGActivationRequest',
        'SCGChangeIndication',
        'SCGreconfigNotification',
        'SCG-UE-HistoryInformation',
        'SecondaryRATUsageReportList',
        'SecondaryRATUsageReport-ItemIEs',
        'SecondaryRATUsageReport-Item',
        'SecondaryRATUsageReport-Item-ExtIEs',
        'SecurityIndication',
        'SecurityIndication-ExtIEs',
        'SecurityResult',
        'SecurityResult-ExtIEs',
        'SeNBSecurityKey',
        'SeNBtoMeNBContainer',
        'SensorMeasurementConfiguration',
        'SensorMeasurementConfiguration-ExtIEs',
        'SensorMeasConfigNameList',
        'SensorMeasConfigNameItem',
        'SensorMeasConfigNameItem-ExtIEs',
        'SensorMeasConfig',
        'SensorNameConfig',
        'SensorNameConfig-ExtIEs',
        'ServedCells',
        'ServedCell-ExtIEs',
        'ServedCell-Information',
        'ServedCell-Information-ExtIEs',
        'ServedCellSpecificInfoReq-NR',
        'ServedCellSpecificInfoReq-NR-Item',
        'ServedCellSpecificInfoReq-NR-Item-ExtIEs',
        'ServiceType',
        'SgNBCoordinationAssistanceInformation',
        'SgNBResourceCoordinationInformation',
        'SgNBResourceCoordinationInformationExtIEs',
        'SgNB-UE-X2AP-ID',
        'SIPTOBearerDeactivationIndication',
        'SharedResourceType',
        'ShortMAC-I',
        'SGNB-Addition-Trigger-Ind',
        'SNtriggered',
        'SourceOfUEActivityBehaviourInformation',
        'SpecialSubframe-Info',
        'SpecialSubframe-Info-ExtIEs',
        'SpecialSubframePatterns',
        'SpectrumSharingGroupID',
        'SubbandCQI',
        'Subscription-Based-UE-DifferentiationInfo',
        'Subscription-Based-UE-DifferentiationInfo-ExtIEs',
        'ScheduledCommunicationTime',
        'ScheduledCommunicationTime-ExtIEs',
        'SRVCCOperationPossible',
        'SSBAreaCapacityValue-List',
        'SSBAreaCapacityValue-Item',
        'SSBAreaCapacityValue-ExtIEs',
        'SSBAreaRadioResourceStatus-List',
        'SSBAreaRadioResourceStatus-Item',
        'SSBAreaRadioResourceStatus-ExtIEs',
        'SSBIndex',
        'SSB-PositionsInBurst',
        'SSB-PositionsInBurst-ExtIEs',
        'SubbandCQI-ExtIEs',
        'SubbandCQICodeword0',
        'SubbandCQICodeword1',
        'SubbandCQIList',
        'SubbandCQIItem',
        'SubbandCQIItem-ExtIEs',
        'SubbandSize',
        'SubscriberProfileIDforRFP',
        'SubframeAllocation',
        'SubframeAssignment',
        'SubframeType',
        'SgNBSecurityKey',
        'SgNBtoMeNBContainer',
        'SRBType',
        'SCGConfigurationQuery',
        'SULInformation',
        'SupportedSULFreqBandItem',
        'SupportedSULFreqBandItem-ExtIEs',
        'SULInformation-ExtIEs',
        'SFN-Offset',
        'SFN-Offset-ExtIEs',
        'TABasedMDT',
        'TABasedMDT-ExtIEs',
        'TAC',
        'TAIBasedMDT',
        'TAIBasedMDT-ExtIEs',
        'TAIListforMDT',
        'TAI-Item',
        'TAI-Item-ExtIEs',
        'TAListforMDT',
        'TABasedQMC',
        'TABasedQMC-ExtIEs',
        'TAListforQMC',
        'TAIBasedQMC',
        'TAIBasedQMC-ExtIEs',
        'TAIListforQMC',
        'TargetCellInNGRAN',
        'TargetCellInUTRAN',
        'TargeteNBtoSource-eNBTransparentContainer',
        'TDD-Info',
        'TDD-Info-ExtIEs',
        'TDD-InfoNeighbourServedNRCell-Information',
        'TDD-InfoNeighbourServedNRCell-Information-ExtIEs',
        'TDDULDLConfigurationCommonNR',
        'Threshold-RSRP',
        'Threshold-RSRQ',
        'TimeToWait',
        'Time-UE-StayedInCell',
        'Time-UE-StayedInCell-EnhancedGranularity',
        'TNLA-To-Add-List',
        'TNLA-To-Add-Item',
        'TNLA-To-Add-Item-ExtIEs',
        'TNLA-To-Update-List',
        'TNLA-To-Update-Item',
        'TNLA-To-Update-Item-ExtIEs',
        'TNLA-To-Remove-List',
        'TNLA-To-Remove-Item',
        'TNLA-To-Remove-Item-ExtIEs',
        'TNLA-Setup-List',
        'TNLA-Setup-Item',
        'TNLA-Setup-Item-ExtIEs',
        'TNLA-Failed-To-Setup-List',
        'TNLA-Failed-To-Setup-Item',
        'TNLA-Failed-To-Setup-Item-ExtIEs',
        'TNLAssociationUsage',
        'TNLCapacityIndicator',
        'TNLCapacityIndicator-ExtIEs',
        'Transport-UP-Layer-Addresses-Info-To-Add-List',
        'Transport-UP-Layer-Addresses-Info-To-Add-Item',
        'Transport-UP-Layer-Addresses-Info-To-Add-ItemExtIEs',
        'Transport-UP-Layer-Addresses-Info-To-Remove-List',
        'Transport-UP-Layer-Addresses-Info-To-Remove-Item',
        'Transport-UP-Layer-Addresses-Info-To-Remove-ItemExtIEs',
        'TNLConfigurationInfo',
        'TNLConfigurationInfo-ExtIEs',
        'TraceActivation',
        'TraceActivation-ExtIEs',
        'TraceCollectionEntityIPAddress',
        'TraceDepth',
        'Transmission-Bandwidth',
        'TransportLayerAddress',
        'TransportLayerAddressAndPort',
        'TunnelInformation',
        'Tunnel-Information-ExtIEs',
        'TypeOfError',
        'UEAggregateMaximumBitRate',
        'UEAggregate-MaximumBitrate-ExtIEs',
        'UEAppLayerMeasConfig',
        'UEAppLayerMeasConfig-ExtIEs',
        'UE-ContextKeptIndicator',
        'UEID',
        'UE-HistoryInformation',
        'UE-HistoryInformationFromTheUE',
        'UE-S1AP-ID',
        'UE-X2AP-ID',
        'UE-X2AP-ID-Extension',
        'UERadioCapability',
        'UERadioCapabilityID',
        'UE-RLF-Report-Container',
        'UE-RLF-Report-Container-for-extended-bands',
        'UESecurityCapabilities',
        'UESecurityCapabilities-ExtIEs',
        'UESidelinkAggregateMaximumBitRate',
        'UE-Sidelink-Aggregate-MaximumBitRate-ExtIEs',
        'UEsToBeResetList',
        'UEsToBeResetList-Item',
        'UEsToBeResetList-Item-ExtIEs',
        'ULandDLSharing',
        'ULandDLSharing-ExtIEs',
        'ULConfiguration',
        'ULConfiguration-ExtIEs',
        'UL-UE-Configuration',
        'UL-GBR-PRB-usage',
        'UL-GBR-PRB-usage-for-MIMO',
        'UL-HighInterferenceIndicationInfo',
        'UL-HighInterferenceIndicationInfo-Item',
        'UL-HighInterferenceIndicationInfo-Item-ExtIEs',
        'UL-HighInterferenceIndication',
        'UL-InterferenceOverloadIndication',
        'UL-InterferenceOverloadIndication-Item',
        'UL-non-GBR-PRB-usage',
        'UL-non-GBR-PRB-usage-for-MIMO',
        'ULOnlySharing',
        'ULOnlySharing-ExtIEs',
        'ULResourceBitmapULandDLSharing',
        'ULResourcesULandDLSharing',
        'UL-scheduling-PDCCH-CCE-usage',
        'UL-Total-PRB-usage',
        'UL-Total-PRB-usage-for-MIMO',
        'UnlicensedSpectrumRestriction',
        'URI-Address',
        'UsableABSInformation',
        'UsableABSInformationFDD',
        'UsableABSInformationFDD-ExtIEs',
        'UsableABSInformationTDD',
        'UsableABSInformationTDD-ExtIEs',
        'UserPlaneTrafficActivityReport',
        'V2XServicesAuthorized',
        'V2XServicesAuthorized-ExtIEs',
        'VehicleUE',
        'PedestrianUE',
        'WidebandCQI',
        'WidebandCQI-ExtIEs',
        'WidebandCQICodeword1',
        'WLANMeasurementConfiguration',
        'WLANMeasurementConfiguration-ExtIEs',
        'WLANMeasConfigNameList',
        'WLANMeasConfig',
        'WLANName',
        'WTID',
        'WTID-Type1',
        'WTID-Long-Type2',
        'WT-UE-XwAP-ID',
        'X2BenefitValue',
        ]
    _type_ = [
        'ABSInformation',
        'ABSInformationFDD',
        'ABSInformationTDD',
        'ABS-Status',
        'ActivationID',
        'Additional-Measurement-Timing-Configuration-List',
        'Additional-Measurement-Timing-Configuration-Item',
        'CSI-RS-MTC-Configuration-List',
        'CSI-RS-MTC-Configuration-Item',
        'CSI-RS-Neighbour-List',
        'CSI-RS-Neighbour-Item',
        'CSI-RS-MTC-Neighbour-List',
        'CSI-RS-MTC-Neighbour-Item',
        'AdditionalListofForwardingGTPTunnelEndpoint',
        'AdditionalListofForwardingGTPTunnelEndpoint-Item',
        'AdditionLocationInformation',
        'AdditionalRRMPriorityIndex',
        'AdditionalSpecialSubframe-Info',
        'AdditionalSpecialSubframePatterns',
        'AdditionalSpecialSubframeExtension-Info',
        'AdditionalSpecialSubframePatternsExtension',
        'AvailableFastMCGRecoveryViaSRB3',
        'AerialUEsubscriptionInformation',
        'AllocationAndRetentionPriority',
        'AreaScopeOfMDT',
        'AreaScopeOfQMC',
        'AS-SecurityInformation',
        'AdditionalPLMNs-Item',
        'BandwidthReducedSI',
        'BearerType',
        'BenefitMetric',
        'BitRate',
        'BroadcastPLMNs-Item',
        'BluetoothMeasurementConfiguration',
        'BluetoothMeasConfigNameList',
        'BluetoothMeasConfig',
        'BluetoothName',
        'BPLMN-ID-Info-EUTRA',
        'BPLMN-ID-Info-EUTRA-Item',
        'BPLMN-ID-Info-NR',
        'BPLMN-ID-Info-NR-Item',
        'BroadcastextPLMNs',
        'CapacityValue',
        'Cause',
        'CauseMisc',
        'CauseProtocol',
        'CauseRadioNetwork',
        'CauseTransport',
        'CellBasedMDT',
        'CellBasedQMC',
        'CellCapacityClassValue',
        'CellDeploymentStatusIndicator',
        'CellIdListforMDT',
        'CellIdListforQMC',
        'CellReplacingInfo',
        'CellReportingIndicator',
        'Cell-Size',
        'CellType',
        'CPACcandidatePSCells-list',
        'CPACcandidatePSCells-item',
        'CPCindicator',
        'CPCdataforwarding',
        'CPAinformation-REQ',
        'CPAinformation-REQ-ACK',
        'CPCinformation-REQD',
        'CPC-target-SgNB-reqd-list',
        'CPC-target-SgNB-reqd-item',
        'CPCinformation-CONF',
        'CPC-target-SgNB-conf-list',
        'CPC-target-SgNB-conf-item',
        'CPCinformation-NOTIFY',
        'CPAinformation-MOD',
        'CPCupdate-MOD',
        'CPC-target-SgNB-mod-list',
        'CPC-target-SgNB-mod-item',
        'CPAinformation-MOD-ACK',
        'CPACinformation-REQD',
        'CHO-DC-EarlyDataForwarding',
        'CHO-DC-Indicator',
        'CNTypeRestrictions',
        'CNTypeRestrictionsItem',
        'CoMPHypothesisSet',
        'CoMPHypothesisSetItem',
        'CoMPInformation',
        'CoMPInformationItem',
        'CoMPInformationStartTime',
        'CompositeAvailableCapacity',
        'CompositeAvailableCapacityGroup',
        'Correlation-ID',
        'COUNTvalue',
        'COUNTValueExtended',
        'COUNTvaluePDCP-SNlength18',
        'CoverageModificationList',
        'CoverageModification-Item',
        'CPTransportLayerInformation',
        'CriticalityDiagnostics',
        'CriticalityDiagnostics-IE-List',
        'CRNTI',
        'CSGMembershipStatus',
        'CSG-Id',
        'CSIReportList',
        'CSIReportPerCSIProcess',
        'CSIReportPerCSIProcessItem',
        'CyclicPrefixDL',
        'CyclicPrefixUL',
        'CHOtrigger',
        'CHOinformation-REQ',
        'CHOinformation-ACK',
        'CandidateCellsToBeCancelledList',
        'CHO-Probability',
        'CHOinformation-AddReq',
        'CHOinformation-ModReq',
        'CSI-RSTransmissionIndication',
        'DataTrafficResources',
        'DataTrafficResourceIndication',
        'DAPSRequestInfo',
        'DAPSResponseInfo',
        'DeactivationIndication',
        'DeliveryStatus',
        'DesiredActNotificationLevel',
        'DirectForwardingPathAvailability',
        'DL-ABS-status',
        'DL-Forwarding',
        'DL-GBR-PRB-usage',
        'DL-GBR-PRB-usage-for-MIMO',
        'DL-non-GBR-PRB-usage',
        'DL-non-GBR-PRB-usage-for-MIMO',
        'DLResourceBitmapULandDLSharing',
        'DLResourcesULandDLSharing',
        'DL-scheduling-PDCCH-CCE-usage',
        'DL-Total-PRB-usage',
        'DL-Total-PRB-usage-for-MIMO',
        'DRB-ID',
        'DuplicationActivation',
        'DynamicDLTransmissionInformation',
        'DynamicNAICSInformation',
        'EARFCN',
        'EARFCNExtension',
        'ECGI',
        'EndcSONConfigurationTransfer',
        'EnhancedRNTP',
        'EnhancedRNTPStartTime',
        'ENB-ID',
        'EncryptionAlgorithms',
        'EN-DC-ResourceConfiguration',
        'EPCHandoverRestrictionListContainer',
        'EPLMNs',
        'ERABActivityNotifyItemList',
        'ERABActivityNotifyItem',
        'E-RAB-ID',
        'E-RAB-Level-QoS-Parameters',
        'E-RAB-List',
        'E-RAB-Item',
        'E-RABsSubjectToEarlyStatusTransfer-List',
        'E-RABsSubjectToEarlyStatusTransfer-Item',
        'E-RABsSubjectToDLDiscarding-List',
        'E-RABsSubjectToDLDiscarding-Item',
        'E-RABUsageReportList',
        'E-RABUsageReport-Item',
        'Ethernet-Type',
        'EUTRA-Mode-Info',
        'EUTRANCellIdentifier',
        'EUTRANTraceID',
        'EventType',
        'ExpectedUEBehaviour',
        'ExpectedUEActivityBehaviour',
        'ExpectedActivityPeriod',
        'ExpectedIdlePeriod',
        'ExpectedHOInterval',
        'ExtendedULInterferenceOverloadInfo',
        'ExtendedBitRate',
        'F1CTrafficContainer',
        'FastMCGRecovery',
        'FDD-Info',
        'FDD-InfoNeighbourServedNRCell-Information',
        'FiveQI',
        'ForbiddenInterRATs',
        'ForbiddenTAs',
        'ForbiddenTAs-Item',
        'ForbiddenTACs',
        'ForbiddenLAs',
        'ForbiddenLAs-Item',
        'ForbiddenLACs',
        'Fourframes',
        'FreqBandIndicator',
        'FreqBandIndicatorPriority',
        'FreqBandNrItem',
        'FrequencyShift7p5khz',
        'GBR-QosInformation',
        'GlobalENB-ID',
        'GlobalGNB-ID',
        'Global-RAN-NODE-ID',
        'GNBOverloadInformation',
        'GTPTLAs',
        'GTPTLA-Item',
        'GTPtunnelEndpoint',
        'GTP-TEI',
        'GUGroupIDList',
        'GU-Group-ID',
        'GUMMEI',
        'GNB-ID',
        'HandoverReportType',
        'HandoverRestrictionList',
        'HFN',
        'HFNModified',
        'HFNforPDCP-SNlength18',
        'HWLoadIndicator',
        'IABNodeIndication',
        'IMSvoiceEPSfallbackfrom5G',
        'IntegrityProtectionAlgorithms',
        'IntegrityProtectionIndication',
        'IntegrityProtectionResult',
        'IntendedTDD-DL-ULConfiguration-NR',
        'InterfaceInstanceIndication',
        'InterfacesToTrace',
        'InvokeIndication',
        'Key-eNodeB-Star',
        'LastVisitedPSCell-Item',
        'LAC',
        'LastVisitedCell-Item',
        'LastVisitedEUTRANCellInformation',
        'LastVisitedGERANCellInformation',
        'LastVisitedNGRANCellInformation',
        'LastVisitedUTRANCellInformation',
        'LCID',
        'LHN-ID',
        'Links-to-log',
        'LoadIndicator',
        'LocationInformationSgNB',
        'LocationInformationSgNBReporting',
        'LocationReportingInformation',
        'LowerLayerPresenceStatusChange',
        'M1PeriodicReporting',
        'M1ReportingTrigger',
        'M1ThresholdEventA2',
        'M3Configuration',
        'M3period',
        'M4Configuration',
        'M4period',
        'M5Configuration',
        'M5period',
        'M6Configuration',
        'M6report-interval',
        'M6delay-threshold',
        'M7Configuration',
        'M7period',
        'MakeBeforeBreakIndicator',
        'ManagementBasedMDTallowed',
        'Masked-IMEISV',
        'MaxCHOpreparations',
        'MDT-Activation',
        'MDT-Configuration',
        'MDTPLMNList',
        'MDT-Location-Info',
        'Measurement-ID',
        'Measurement-ID-ENDC',
        'MeasurementsToActivate',
        'MeasurementThresholdA2',
        'MeNBCoordinationAssistanceInformation',
        'MeNBResourceCoordinationInformation',
        'MeNBtoSeNBContainer',
        'MME-Group-ID',
        'MME-Code',
        'MBMS-Service-Area-Identity-List',
        'MBMS-Service-Area-Identity',
        'MBSFN-Subframe-Infolist',
        'MBSFN-Subframe-Info',
        'MDT-ConfigurationNR',
        'MobilityParametersModificationRange',
        'MobilityParametersInformation',
        'MultibandInfoList',
        'MessageOversizeNotification',
        'MaximumCellListSize',
        'BandInfo',
        'MeNBtoSgNBContainer',
        'SplitSRBs',
        'SplitSRB',
        'NBIoT-UL-DL-AlignmentOffset',
        'NBIoT-RLF-Report-Container',
        'Neighbour-Information',
        'NextHopChainingCount',
        'NewDRBIDrequest',
        'Number-of-Antennaports',
        'NRCapacityValue',
        'NRCarrierList',
        'NRCarrierItem',
        'NRCellCapacityClassValue',
        'NRCellPRACHConfig',
        'NRCompositeAvailableCapacityGroup',
        'NRCompositeAvailableCapacity',
        'NRFreqInfo',
        'NRCellIdentifier',
        'NRCGI',
        'NRRACHReportContainer',
        'NRRACHReportInformation',
        'NRRACHReportList-Item',
        'NRNeighbour-Information',
        'NPRACHConfiguration',
        'NPRACHConfiguration-FDD',
        'NPRACHConfiguration-TDD',
        'NPRACH-CP-Length',
        'NPRACH-preambleFormat',
        'Non-AnchorCarrierFrequencylist',
        'NRPCI',
        'NRrestrictioninEPSasSecondaryRAT',
        'MeasurementResultforNRCellsPossiblyAggregated',
        'MeasurementResultforNRCellsPossiblyAggregated-Item',
        'NRRadioResourceStatus',
        'MIMOPRBusageInformation',
        'NRrestrictionin5GS',
        'NRencryptionAlgorithms',
        'NRintegrityProtectionAlgorithms',
        'NR-TxBW',
        'NRNRB',
        'NRSCS',
        'NRS-NSSS-PowerOffset',
        'FiveGS-TAC',
        'NRUeReport',
        'NRUESidelinkAggregateMaximumBitRate',
        'NRUESecurityCapabilities',
        'NSSS-NumOccasionDifferentPrecoder',
        'NRV2XServicesAuthorized',
        'OffsetOfNbiotChannelNumberToEARFCN',
        'Oneframe',
        'Packet-LossRate',
        'PA-Values',
        'PC5QoSParameters',
        'PC5QoSFlowList',
        'PC5QoSFlowItem',
        'PC5FlowBitRates',
        'PDCPChangeIndication',
        'PDCP-SN',
        'PDCP-SNExtended',
        'PDCP-SNlength18',
        'PDCPSnLength',
        'PCI',
        'PLMN-Identity',
        'Port-Number',
        'PRACH-Configuration',
        'PLMNAreaBasedQMC',
        'PLMNListforQMC',
        'Pre-emptionCapability',
        'Pre-emptionVulnerability',
        'PriorityLevel',
        'ProSeAuthorized',
        'ProSeDirectDiscovery',
        'ProSeDirectCommunication',
        'ProSeUEtoNetworkRelaying',
        'ProtectedEUTRAResourceIndication',
        'ProtectedFootprintTimePattern',
        'ProtectedResourceList',
        'ProtectedResourceList-Item',
        'PartialListIndicator',
        'PrivacyIndicator',
        'PSCellHistoryInformationRetrieve',
        'PSCell-UE-HistoryInformation',
        'PSCellChangeHistory',
        'QCI',
        'QoS-Mapping-Information',
        'RadioframeAllocationOffset',
        'RadioframeAllocationPeriod',
        'RadioResourceStatus',
        'Range',
        'RAN-UE-NGAP-ID',
        'RAT-Restrictions',
        'RAT-RestrictionsItem',
        'ReceiveStatusofULPDCPSDUs',
        'ReceiveStatusOfULPDCPSDUsExtended',
        'ReceiveStatusOfULPDCPSDUsPDCP-SNlength18',
        'ReleaseFastMCGRecoveryViaSRB3',
        'Reestablishment-Indication',
        'Registration-Request',
        'Registration-Request-ENDC',
        'RelativeNarrowbandTxPower',
        'ReplacingCellsList',
        'ReplacingCellsList-Item',
        'ReportAmountMDT',
        'ReportArea',
        'ReportCharacteristics',
        'ReportingPeriodicityCSIR',
        'ReportCharacteristics-ENDC',
        'ReportingPeriodicityRSRPMR',
        'ReportIntervalMDT',
        'RequestedFastMCGRecoveryViaSRB3',
        'RequestedFastMCGRecoveryViaSRB3Release',
        'ReservedSubframePattern',
        'ResourceType',
        'ResumeID',
        'RLCMode',
        'RLC-Status',
        'RNTP-Threshold',
        'RRC-Config-Ind',
        'RRC-Context',
        'RRCConnReestabIndicator',
        'RRCConnSetupIndicator',
        'RSRPMeasurementResult',
        'RSRPMRList',
        'RRCContainer',
        'S1TNLLoadIndicator',
        'SCGActivationStatus',
        'SCGActivationRequest',
        'SCGChangeIndication',
        'SCGreconfigNotification',
        'SCG-UE-HistoryInformation',
        'SecondaryRATUsageReportList',
        'SecondaryRATUsageReport-Item',
        'SecurityIndication',
        'SecurityResult',
        'SeNBSecurityKey',
        'SeNBtoMeNBContainer',
        'SensorMeasurementConfiguration',
        'SensorMeasConfigNameList',
        'SensorMeasConfigNameItem',
        'SensorMeasConfig',
        'SensorNameConfig',
        'ServedCells',
        'ServedCell-Information',
        'ServedCellSpecificInfoReq-NR',
        'ServedCellSpecificInfoReq-NR-Item',
        'ServiceType',
        'SgNBCoordinationAssistanceInformation',
        'SgNBResourceCoordinationInformation',
        'SgNB-UE-X2AP-ID',
        'SIPTOBearerDeactivationIndication',
        'SharedResourceType',
        'ShortMAC-I',
        'SGNB-Addition-Trigger-Ind',
        'SNtriggered',
        'SourceOfUEActivityBehaviourInformation',
        'SpecialSubframe-Info',
        'SpecialSubframePatterns',
        'SpectrumSharingGroupID',
        'SubbandCQI',
        'Subscription-Based-UE-DifferentiationInfo',
        'ScheduledCommunicationTime',
        'SRVCCOperationPossible',
        'SSBAreaCapacityValue-List',
        'SSBAreaCapacityValue-Item',
        'SSBAreaRadioResourceStatus-List',
        'SSBAreaRadioResourceStatus-Item',
        'SSBIndex',
        'SSB-PositionsInBurst',
        'SubbandCQICodeword0',
        'SubbandCQICodeword1',
        'SubbandCQIList',
        'SubbandCQIItem',
        'SubbandSize',
        'SubscriberProfileIDforRFP',
        'SubframeAllocation',
        'SubframeAssignment',
        'SubframeType',
        'SgNBSecurityKey',
        'SgNBtoMeNBContainer',
        'SRBType',
        'SCGConfigurationQuery',
        'SULInformation',
        'SupportedSULFreqBandItem',
        'SFN-Offset',
        'TABasedMDT',
        'TAC',
        'TAIBasedMDT',
        'TAIListforMDT',
        'TAI-Item',
        'TAListforMDT',
        'TABasedQMC',
        'TAListforQMC',
        'TAIBasedQMC',
        'TAIListforQMC',
        'TargetCellInNGRAN',
        'TargetCellInUTRAN',
        'TargeteNBtoSource-eNBTransparentContainer',
        'TDD-Info',
        'TDD-InfoNeighbourServedNRCell-Information',
        'TDDULDLConfigurationCommonNR',
        'Threshold-RSRP',
        'Threshold-RSRQ',
        'TimeToWait',
        'Time-UE-StayedInCell',
        'Time-UE-StayedInCell-EnhancedGranularity',
        'TNLA-To-Add-List',
        'TNLA-To-Add-Item',
        'TNLA-To-Update-List',
        'TNLA-To-Update-Item',
        'TNLA-To-Remove-List',
        'TNLA-To-Remove-Item',
        'TNLA-Setup-List',
        'TNLA-Setup-Item',
        'TNLA-Failed-To-Setup-List',
        'TNLA-Failed-To-Setup-Item',
        'TNLAssociationUsage',
        'TNLCapacityIndicator',
        'Transport-UP-Layer-Addresses-Info-To-Add-List',
        'Transport-UP-Layer-Addresses-Info-To-Add-Item',
        'Transport-UP-Layer-Addresses-Info-To-Remove-List',
        'Transport-UP-Layer-Addresses-Info-To-Remove-Item',
        'TNLConfigurationInfo',
        'TraceActivation',
        'TraceCollectionEntityIPAddress',
        'TraceDepth',
        'Transmission-Bandwidth',
        'TransportLayerAddress',
        'TransportLayerAddressAndPort',
        'TunnelInformation',
        'TypeOfError',
        'UEAggregateMaximumBitRate',
        'UEAppLayerMeasConfig',
        'UE-ContextKeptIndicator',
        'UEID',
        'UE-HistoryInformation',
        'UE-HistoryInformationFromTheUE',
        'UE-S1AP-ID',
        'UE-X2AP-ID',
        'UE-X2AP-ID-Extension',
        'UERadioCapability',
        'UERadioCapabilityID',
        'UE-RLF-Report-Container',
        'UE-RLF-Report-Container-for-extended-bands',
        'UESecurityCapabilities',
        'UESidelinkAggregateMaximumBitRate',
        'UEsToBeResetList',
        'UEsToBeResetList-Item',
        'ULandDLSharing',
        'ULConfiguration',
        'UL-UE-Configuration',
        'UL-GBR-PRB-usage',
        'UL-GBR-PRB-usage-for-MIMO',
        'UL-HighInterferenceIndicationInfo',
        'UL-HighInterferenceIndicationInfo-Item',
        'UL-HighInterferenceIndication',
        'UL-InterferenceOverloadIndication',
        'UL-InterferenceOverloadIndication-Item',
        'UL-non-GBR-PRB-usage',
        'UL-non-GBR-PRB-usage-for-MIMO',
        'ULOnlySharing',
        'ULResourceBitmapULandDLSharing',
        'ULResourcesULandDLSharing',
        'UL-scheduling-PDCCH-CCE-usage',
        'UL-Total-PRB-usage',
        'UL-Total-PRB-usage-for-MIMO',
        'UnlicensedSpectrumRestriction',
        'URI-Address',
        'UsableABSInformation',
        'UsableABSInformationFDD',
        'UsableABSInformationTDD',
        'UserPlaneTrafficActivityReport',
        'V2XServicesAuthorized',
        'VehicleUE',
        'PedestrianUE',
        'WidebandCQI',
        'WidebandCQICodeword1',
        'WLANMeasurementConfiguration',
        'WLANMeasConfigNameList',
        'WLANMeasConfig',
        'WLANName',
        'WTID',
        'WTID-Type1',
        'WTID-Long-Type2',
        'WT-UE-XwAP-ID',
        'X2BenefitValue',
        ]
    _set_ = [
        'ABSInformationFDD-ExtIEs',
        'ABSInformationTDD-ExtIEs',
        'ABS-Status-ExtIEs',
        'Additional-Measurement-Timing-Configuration-Item-ExtIEs',
        'CSI-RS-MTC-Configuration-Item-ExtIEs',
        'CSI-RS-Neighbour-Item-ExtIEs',
        'CSI-RS-MTC-Neighbour-Item-ExtIEs',
        'AdditionalListofForwardingGTPTunnelEndpoint-Item-ExtIEs',
        'AdditionalSpecialSubframe-Info-ExtIEs',
        'AdditionalSpecialSubframeExtension-Info-ExtIEs',
        'AllocationAndRetentionPriority-ExtIEs',
        'AS-SecurityInformation-ExtIEs',
        'BluetoothMeasurementConfiguration-ExtIEs',
        'BPLMN-ID-Info-EUTRA-Item-ExtIEs',
        'BPLMN-ID-Info-NR-Item-ExtIEs',
        'CellBasedMDT-ExtIEs',
        'CellBasedQMC-ExtIEs',
        'CellReplacingInfo-ExtIEs',
        'CellType-ExtIEs',
        'CPACcandidatePSCells-item-ExtIEs',
        'CPAinformation-REQ-ExtIEs',
        'CPAinformation-REQ-ACK-ExtIEs',
        'CPCinformation-REQD-ExtIEs',
        'CPC-target-SgNB-reqd-item-ExtIEs',
        'CPCinformation-CONF-ExtIEs',
        'CPC-target-SgNB-conf-item-ExtIEs',
        'CPCinformation-NOTIFY-ExtIEs',
        'CPAinformation-MOD-ExtIEs',
        'CPCupdate-MOD-ExtIEs',
        'CPC-target-SgNB-mod-item-ExtIEs',
        'CPAinformation-MOD-ACK-ExtIEs',
        'CPACinformation-REQD-ExtIEs',
        'CNTypeRestrictionsItem-ExtIEs',
        'CoMPHypothesisSetItem-ExtIEs',
        'CoMPInformation-ExtIEs',
        'CoMPInformationItem-ExtIEs',
        'CoMPInformationStartTime-ExtIEs',
        'CompositeAvailableCapacity-ExtIEs',
        'CompositeAvailableCapacityGroup-ExtIEs',
        'COUNTvalue-ExtIEs',
        'COUNTValueExtended-ExtIEs',
        'COUNTvaluePDCP-SNlength18-ExtIEs',
        'CriticalityDiagnostics-ExtIEs',
        'CriticalityDiagnostics-IE-List-ExtIEs',
        'CSIReportList-ExtIEs',
        'CSIReportPerCSIProcess-ExtIEs',
        'CSIReportPerCSIProcessItem-ExtIEs',
        'CHOinformation-REQ-ExtIEs',
        'CHOinformation-ACK-ExtIEs',
        'CHOinformation-AddReq-ExtIEs',
        'CHOinformation-ModReq-ExtIEs',
        'DataTrafficResourceIndication-ExtIEs',
        'DAPSRequestInfo-ExtIEs',
        'DAPSResponseInfo-ExtIEs',
        'DeliveryStatus-ExtIEs',
        'DynamicNAICSInformation-ExtIEs',
        'ECGI-ExtIEs',
        'EnhancedRNTP-ExtIEs',
        'EnhancedRNTPStartTime-ExtIEs',
        'EN-DC-ResourceConfigurationExtIEs',
        'ERABActivityNotifyItem-ExtIEs',
        'E-RAB-Level-QoS-Parameters-ExtIEs',
        'E-RAB-ItemIEs',
        'E-RAB-Item-ExtIEs',
        'E-RABsSubjectToEarlyStatusTransfer-Item-ExtIEs',
        'E-RABsSubjectToDLDiscarding-Item-ExtIEs',
        'E-RABUsageReport-ItemIEs',
        'E-RABUsageReport-Item-ExtIEs',
        'ExpectedUEBehaviour-ExtIEs',
        'ExpectedUEActivityBehaviour-ExtIEs',
        'ExtendedULInterferenceOverloadInfo-ExtIEs',
        'FastMCGRecovery-ExtIEs',
        'FDD-Info-ExtIEs',
        'FDD-InfoNeighbourServedNRCell-Information-ExtIEs',
        'ForbiddenTAs-Item-ExtIEs',
        'ForbiddenLAs-Item-ExtIEs',
        'FreqBandNrItem-ExtIEs',
        'GBR-QosInformation-ExtIEs',
        'GlobalENB-ID-ExtIEs',
        'GlobalGNB-ID-ExtIEs',
        'Global-RAN-NODE-ID-ExtIEs',
        'GTPTLA-Item-ExtIEs',
        'GTPtunnelEndpoint-ExtIEs',
        'GU-Group-ID-ExtIEs',
        'GUMMEI-ExtIEs',
        'HandoverRestrictionList-ExtIEs',
        'HWLoadIndicator-ExtIEs',
        'LastVisitedEUTRANCellInformation-ExtIEs',
        'LocationInformationSgNB-ExtIEs',
        'LocationReportingInformation-ExtIEs',
        'M1PeriodicReporting-ExtIEs',
        'M1ThresholdEventA2-ExtIEs',
        'M3Configuration-ExtIEs',
        'M4Configuration-ExtIEs',
        'M5Configuration-ExtIEs',
        'M6Configuration-ExtIEs',
        'M7Configuration-ExtIEs',
        'MDT-Configuration-ExtIEs',
        'MeNBResourceCoordinationInformationExtIEs',
        'MBSFN-Subframe-Info-ExtIEs',
        'MessageOversizeNotification-ExtIEs',
        'BandInfo-ExtIEs',
        'SplitSRB-ExtIEs',
        'Neighbour-Information-ExtIEs',
        'NRCapacityValue-ExtIEs',
        'NRCarrierItem-ExtIEs',
        'NRCompositeAvailableCapacityGroup-ExtIEs',
        'NRCompositeAvailableCapacity-ExtIEs',
        'NRFreqInfo-ExtIEs',
        'NRCGI-ExtIEs',
        'NRRACHReportList-Item-ExtIEs',
        'NRNeighbour-Information-ExtIEs',
        'NPRACHConfiguration-ExtIEs',
        'NPRACHConfiguration-FDD-ExtIEs',
        'NPRACHConfiguration-TDD-ExtIEs',
        'Non-AnchorCarrierFrequencylist-ExtIEs',
        'MeasurementResultforNRCellsPossiblyAggregated-Item-ExtIEs',
        'NRRadioResourceStatus-ExtIEs',
        'MIMOPRBusageInformation-ExtIEs',
        'NR-TxBW-ExtIEs',
        'NRUeReport-ExtIEs',
        'NRUESidelinkAggregateMaximumBitRate-ExtIEs',
        'NRUESecurityCapabilities-ExtIEs',
        'NRV2XServicesAuthorized-ExtIEs',
        'PC5QoSParameters-ExtIEs',
        'PC5QoSFlowItem-ExtIEs',
        'PC5FlowBitRates-ExtIEs',
        'PLMNAreaBasedQMC-ExtIEs',
        'PRACH-Configuration-ExtIEs',
        'ProSeAuthorized-ExtIEs',
        'ProtectedEUTRAResourceIndication-ExtIEs',
        'ProtectedFootprintTimePattern-ExtIEs',
        'ProtectedResourceList-Item-ExtIEs',
        'QoS-Mapping-Information-ExtIEs',
        'RadioResourceStatus-ExtIEs',
        'RAT-RestrictionsItem-ExtIEs',
        'RelativeNarrowbandTxPower-ExtIEs',
        'ReservedSubframePattern-ExtIEs',
        'RLC-Status-ExtIEs',
        'RSRPMeasurementResult-ExtIEs',
        'RSRPMRList-ExtIEs',
        'S1TNLLoadIndicator-ExtIEs',
        'SecondaryRATUsageReport-ItemIEs',
        'SecondaryRATUsageReport-Item-ExtIEs',
        'SecurityIndication-ExtIEs',
        'SecurityResult-ExtIEs',
        'SensorMeasurementConfiguration-ExtIEs',
        'SensorMeasConfigNameItem-ExtIEs',
        'SensorNameConfig-ExtIEs',
        'ServedCell-ExtIEs',
        'ServedCell-Information-ExtIEs',
        'ServedCellSpecificInfoReq-NR-Item-ExtIEs',
        'SgNBResourceCoordinationInformationExtIEs',
        'SpecialSubframe-Info-ExtIEs',
        'Subscription-Based-UE-DifferentiationInfo-ExtIEs',
        'ScheduledCommunicationTime-ExtIEs',
        'SSBAreaCapacityValue-ExtIEs',
        'SSBAreaRadioResourceStatus-ExtIEs',
        'SSB-PositionsInBurst-ExtIEs',
        'SubbandCQI-ExtIEs',
        'SubbandCQIItem-ExtIEs',
        'SupportedSULFreqBandItem-ExtIEs',
        'SULInformation-ExtIEs',
        'SFN-Offset-ExtIEs',
        'TABasedMDT-ExtIEs',
        'TAIBasedMDT-ExtIEs',
        'TAI-Item-ExtIEs',
        'TABasedQMC-ExtIEs',
        'TAIBasedQMC-ExtIEs',
        'TDD-Info-ExtIEs',
        'TDD-InfoNeighbourServedNRCell-Information-ExtIEs',
        'TNLA-To-Add-Item-ExtIEs',
        'TNLA-To-Update-Item-ExtIEs',
        'TNLA-To-Remove-Item-ExtIEs',
        'TNLA-Setup-Item-ExtIEs',
        'TNLA-Failed-To-Setup-Item-ExtIEs',
        'TNLCapacityIndicator-ExtIEs',
        'Transport-UP-Layer-Addresses-Info-To-Add-ItemExtIEs',
        'Transport-UP-Layer-Addresses-Info-To-Remove-ItemExtIEs',
        'TNLConfigurationInfo-ExtIEs',
        'TraceActivation-ExtIEs',
        'Tunnel-Information-ExtIEs',
        'UEAggregate-MaximumBitrate-ExtIEs',
        'UEAppLayerMeasConfig-ExtIEs',
        'UESecurityCapabilities-ExtIEs',
        'UE-Sidelink-Aggregate-MaximumBitRate-ExtIEs',
        'UEsToBeResetList-Item-ExtIEs',
        'ULandDLSharing-ExtIEs',
        'ULConfiguration-ExtIEs',
        'UL-HighInterferenceIndicationInfo-Item-ExtIEs',
        'ULOnlySharing-ExtIEs',
        'UsableABSInformationFDD-ExtIEs',
        'UsableABSInformationTDD-ExtIEs',
        'V2XServicesAuthorized-ExtIEs',
        'WidebandCQI-ExtIEs',
        'WLANMeasurementConfiguration-ExtIEs',
        ]
    _val_ = [
        ]
    _class_ = [
        'ABSInformationFDD-ExtIEs',
        'ABSInformationTDD-ExtIEs',
        'ABS-Status-ExtIEs',
        'Additional-Measurement-Timing-Configuration-Item-ExtIEs',
        'CSI-RS-MTC-Configuration-Item-ExtIEs',
        'CSI-RS-Neighbour-Item-ExtIEs',
        'CSI-RS-MTC-Neighbour-Item-ExtIEs',
        'AdditionalListofForwardingGTPTunnelEndpoint-Item-ExtIEs',
        'AdditionalSpecialSubframe-Info-ExtIEs',
        'AdditionalSpecialSubframeExtension-Info-ExtIEs',
        'AllocationAndRetentionPriority-ExtIEs',
        'AS-SecurityInformation-ExtIEs',
        'BluetoothMeasurementConfiguration-ExtIEs',
        'BPLMN-ID-Info-EUTRA-Item-ExtIEs',
        'BPLMN-ID-Info-NR-Item-ExtIEs',
        'CellBasedMDT-ExtIEs',
        'CellBasedQMC-ExtIEs',
        'CellReplacingInfo-ExtIEs',
        'CellType-ExtIEs',
        'CPACcandidatePSCells-item-ExtIEs',
        'CPAinformation-REQ-ExtIEs',
        'CPAinformation-REQ-ACK-ExtIEs',
        'CPCinformation-REQD-ExtIEs',
        'CPC-target-SgNB-reqd-item-ExtIEs',
        'CPCinformation-CONF-ExtIEs',
        'CPC-target-SgNB-conf-item-ExtIEs',
        'CPCinformation-NOTIFY-ExtIEs',
        'CPAinformation-MOD-ExtIEs',
        'CPCupdate-MOD-ExtIEs',
        'CPC-target-SgNB-mod-item-ExtIEs',
        'CPAinformation-MOD-ACK-ExtIEs',
        'CPACinformation-REQD-ExtIEs',
        'CNTypeRestrictionsItem-ExtIEs',
        'CoMPHypothesisSetItem-ExtIEs',
        'CoMPInformation-ExtIEs',
        'CoMPInformationItem-ExtIEs',
        'CoMPInformationStartTime-ExtIEs',
        'CompositeAvailableCapacity-ExtIEs',
        'CompositeAvailableCapacityGroup-ExtIEs',
        'COUNTvalue-ExtIEs',
        'COUNTValueExtended-ExtIEs',
        'COUNTvaluePDCP-SNlength18-ExtIEs',
        'CriticalityDiagnostics-ExtIEs',
        'CriticalityDiagnostics-IE-List-ExtIEs',
        'CSIReportList-ExtIEs',
        'CSIReportPerCSIProcess-ExtIEs',
        'CSIReportPerCSIProcessItem-ExtIEs',
        'CHOinformation-REQ-ExtIEs',
        'CHOinformation-ACK-ExtIEs',
        'CHOinformation-AddReq-ExtIEs',
        'CHOinformation-ModReq-ExtIEs',
        'DataTrafficResourceIndication-ExtIEs',
        'DAPSRequestInfo-ExtIEs',
        'DAPSResponseInfo-ExtIEs',
        'DeliveryStatus-ExtIEs',
        'DynamicNAICSInformation-ExtIEs',
        'ECGI-ExtIEs',
        'EnhancedRNTP-ExtIEs',
        'EnhancedRNTPStartTime-ExtIEs',
        'EN-DC-ResourceConfigurationExtIEs',
        'ERABActivityNotifyItem-ExtIEs',
        'E-RAB-Level-QoS-Parameters-ExtIEs',
        'E-RAB-ItemIEs',
        'E-RAB-Item-ExtIEs',
        'E-RABsSubjectToEarlyStatusTransfer-Item-ExtIEs',
        'E-RABsSubjectToDLDiscarding-Item-ExtIEs',
        'E-RABUsageReport-ItemIEs',
        'E-RABUsageReport-Item-ExtIEs',
        'ExpectedUEBehaviour-ExtIEs',
        'ExpectedUEActivityBehaviour-ExtIEs',
        'ExtendedULInterferenceOverloadInfo-ExtIEs',
        'FastMCGRecovery-ExtIEs',
        'FDD-Info-ExtIEs',
        'FDD-InfoNeighbourServedNRCell-Information-ExtIEs',
        'ForbiddenTAs-Item-ExtIEs',
        'ForbiddenLAs-Item-ExtIEs',
        'FreqBandNrItem-ExtIEs',
        'GBR-QosInformation-ExtIEs',
        'GlobalENB-ID-ExtIEs',
        'GlobalGNB-ID-ExtIEs',
        'Global-RAN-NODE-ID-ExtIEs',
        'GTPTLA-Item-ExtIEs',
        'GTPtunnelEndpoint-ExtIEs',
        'GU-Group-ID-ExtIEs',
        'GUMMEI-ExtIEs',
        'HandoverRestrictionList-ExtIEs',
        'HWLoadIndicator-ExtIEs',
        'LastVisitedEUTRANCellInformation-ExtIEs',
        'LocationInformationSgNB-ExtIEs',
        'LocationReportingInformation-ExtIEs',
        'M1PeriodicReporting-ExtIEs',
        'M1ThresholdEventA2-ExtIEs',
        'M3Configuration-ExtIEs',
        'M4Configuration-ExtIEs',
        'M5Configuration-ExtIEs',
        'M6Configuration-ExtIEs',
        'M7Configuration-ExtIEs',
        'MDT-Configuration-ExtIEs',
        'MeNBResourceCoordinationInformationExtIEs',
        'MBSFN-Subframe-Info-ExtIEs',
        'MessageOversizeNotification-ExtIEs',
        'BandInfo-ExtIEs',
        'SplitSRB-ExtIEs',
        'Neighbour-Information-ExtIEs',
        'NRCapacityValue-ExtIEs',
        'NRCarrierItem-ExtIEs',
        'NRCompositeAvailableCapacityGroup-ExtIEs',
        'NRCompositeAvailableCapacity-ExtIEs',
        'NRFreqInfo-ExtIEs',
        'NRCGI-ExtIEs',
        'NRRACHReportList-Item-ExtIEs',
        'NRNeighbour-Information-ExtIEs',
        'NPRACHConfiguration-ExtIEs',
        'NPRACHConfiguration-FDD-ExtIEs',
        'NPRACHConfiguration-TDD-ExtIEs',
        'Non-AnchorCarrierFrequencylist-ExtIEs',
        'MeasurementResultforNRCellsPossiblyAggregated-Item-ExtIEs',
        'NRRadioResourceStatus-ExtIEs',
        'MIMOPRBusageInformation-ExtIEs',
        'NR-TxBW-ExtIEs',
        'NRUeReport-ExtIEs',
        'NRUESidelinkAggregateMaximumBitRate-ExtIEs',
        'NRUESecurityCapabilities-ExtIEs',
        'NRV2XServicesAuthorized-ExtIEs',
        'PC5QoSParameters-ExtIEs',
        'PC5QoSFlowItem-ExtIEs',
        'PC5FlowBitRates-ExtIEs',
        'PLMNAreaBasedQMC-ExtIEs',
        'PRACH-Configuration-ExtIEs',
        'ProSeAuthorized-ExtIEs',
        'ProtectedEUTRAResourceIndication-ExtIEs',
        'ProtectedFootprintTimePattern-ExtIEs',
        'ProtectedResourceList-Item-ExtIEs',
        'QoS-Mapping-Information-ExtIEs',
        'RadioResourceStatus-ExtIEs',
        'RAT-RestrictionsItem-ExtIEs',
        'RelativeNarrowbandTxPower-ExtIEs',
        'ReservedSubframePattern-ExtIEs',
        'RLC-Status-ExtIEs',
        'RSRPMeasurementResult-ExtIEs',
        'RSRPMRList-ExtIEs',
        'S1TNLLoadIndicator-ExtIEs',
        'SecondaryRATUsageReport-ItemIEs',
        'SecondaryRATUsageReport-Item-ExtIEs',
        'SecurityIndication-ExtIEs',
        'SecurityResult-ExtIEs',
        'SensorMeasurementConfiguration-ExtIEs',
        'SensorMeasConfigNameItem-ExtIEs',
        'SensorNameConfig-ExtIEs',
        'ServedCell-ExtIEs',
        'ServedCell-Information-ExtIEs',
        'ServedCellSpecificInfoReq-NR-Item-ExtIEs',
        'SgNBResourceCoordinationInformationExtIEs',
        'SpecialSubframe-Info-ExtIEs',
        'Subscription-Based-UE-DifferentiationInfo-ExtIEs',
        'ScheduledCommunicationTime-ExtIEs',
        'SSBAreaCapacityValue-ExtIEs',
        'SSBAreaRadioResourceStatus-ExtIEs',
        'SSB-PositionsInBurst-ExtIEs',
        'SubbandCQI-ExtIEs',
        'SubbandCQIItem-ExtIEs',
        'SupportedSULFreqBandItem-ExtIEs',
        'SULInformation-ExtIEs',
        'SFN-Offset-ExtIEs',
        'TABasedMDT-ExtIEs',
        'TAIBasedMDT-ExtIEs',
        'TAI-Item-ExtIEs',
        'TABasedQMC-ExtIEs',
        'TAIBasedQMC-ExtIEs',
        'TDD-Info-ExtIEs',
        'TDD-InfoNeighbourServedNRCell-Information-ExtIEs',
        'TNLA-To-Add-Item-ExtIEs',
        'TNLA-To-Update-Item-ExtIEs',
        'TNLA-To-Remove-Item-ExtIEs',
        'TNLA-Setup-Item-ExtIEs',
        'TNLA-Failed-To-Setup-Item-ExtIEs',
        'TNLCapacityIndicator-ExtIEs',
        'Transport-UP-Layer-Addresses-Info-To-Add-ItemExtIEs',
        'Transport-UP-Layer-Addresses-Info-To-Remove-ItemExtIEs',
        'TNLConfigurationInfo-ExtIEs',
        'TraceActivation-ExtIEs',
        'Tunnel-Information-ExtIEs',
        'UEAggregate-MaximumBitrate-ExtIEs',
        'UEAppLayerMeasConfig-ExtIEs',
        'UESecurityCapabilities-ExtIEs',
        'UE-Sidelink-Aggregate-MaximumBitRate-ExtIEs',
        'UEsToBeResetList-Item-ExtIEs',
        'ULandDLSharing-ExtIEs',
        'ULConfiguration-ExtIEs',
        'UL-HighInterferenceIndicationInfo-Item-ExtIEs',
        'ULOnlySharing-ExtIEs',
        'UsableABSInformationFDD-ExtIEs',
        'UsableABSInformationTDD-ExtIEs',
        'V2XServicesAuthorized-ExtIEs',
        'WidebandCQI-ExtIEs',
        'WLANMeasurementConfiguration-ExtIEs',
        ]
    _param_ = [
        ]
    
    #-----< ABSInformation >-----#
    ABSInformation = CHOICE(name='ABSInformation', mode=MODE_TYPE)
    _ABSInformation_fdd = SEQ(name='fdd', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ABSInformationFDD')))
    _ABSInformation_tdd = SEQ(name='tdd', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ABSInformationTDD')))
    _ABSInformation_abs_inactive = NULL(name='abs-inactive', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ABSInformation._cont = ASN1Dict([
        ('fdd', _ABSInformation_fdd),
        ('tdd', _ABSInformation_tdd),
        ('abs-inactive', _ABSInformation_abs_inactive),
        ])
    ABSInformation._ext = []
    
    #-----< ABSInformationFDD >-----#
    ABSInformationFDD = SEQ(name='ABSInformationFDD', mode=MODE_TYPE)
    _ABSInformationFDD_abs_pattern_info = BIT_STR(name='abs-pattern-info', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ABSInformationFDD_abs_pattern_info._const_sz = ASN1Set(rv=[40], rr=[], ev=None, er=[])
    _ABSInformationFDD_numberOfCellSpecificAntennaPorts = ENUM(name='numberOfCellSpecificAntennaPorts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ABSInformationFDD_numberOfCellSpecificAntennaPorts._cont = ASN1Dict([('one', 0), ('two', 1), ('four', 2)])
    _ABSInformationFDD_numberOfCellSpecificAntennaPorts._ext = []
    _ABSInformationFDD_measurement_subset = BIT_STR(name='measurement-subset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ABSInformationFDD_measurement_subset._const_sz = ASN1Set(rv=[40], rr=[], ev=None, er=[])
    _ABSInformationFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ABSInformationFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___ABSInformationFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____ABSInformationFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ABSInformationFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ABSInformationFDD_iE_Extensions__item__id._const_tab = ____ABSInformationFDD_iE_Extensions__item__id_tab
    ___ABSInformationFDD_iE_Extensions__item__id._const_tab_at = None
    ___ABSInformationFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___ABSInformationFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ABSInformationFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ABSInformationFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ABSInformationFDD_iE_Extensions__item__criticality._const_tab = ____ABSInformationFDD_iE_Extensions__item__criticality_tab
    ___ABSInformationFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ABSInformationFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ABSInformationFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ABSInformationFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ABSInformationFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ABSInformationFDD_iE_Extensions__item__extensionValue._const_tab = ____ABSInformationFDD_iE_Extensions__item__extensionValue_tab
    ___ABSInformationFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ABSInformationFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ABSInformationFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ABSInformationFDD_iE_Extensions__item__id),
        ('criticality', ___ABSInformationFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___ABSInformationFDD_iE_Extensions__item__extensionValue),
        ])
    __ABSInformationFDD_iE_Extensions__item_._ext = None
    _ABSInformationFDD_iE_Extensions._cont = __ABSInformationFDD_iE_Extensions__item_
    _ABSInformationFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ABSInformationFDD._cont = ASN1Dict([
        ('abs-pattern-info', _ABSInformationFDD_abs_pattern_info),
        ('numberOfCellSpecificAntennaPorts', _ABSInformationFDD_numberOfCellSpecificAntennaPorts),
        ('measurement-subset', _ABSInformationFDD_measurement_subset),
        ('iE-Extensions', _ABSInformationFDD_iE_Extensions),
        ])
    ABSInformationFDD._ext = []
    
    #-----< ABSInformationFDD-ExtIEs >-----#
    ABSInformationFDD_ExtIEs = CLASS(name='ABSInformationFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ABSInformationFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ABSInformationTDD >-----#
    ABSInformationTDD = SEQ(name='ABSInformationTDD', mode=MODE_TYPE)
    _ABSInformationTDD_abs_pattern_info = BIT_STR(name='abs-pattern-info', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ABSInformationTDD_abs_pattern_info._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=70)], ev=[], er=[])
    _ABSInformationTDD_numberOfCellSpecificAntennaPorts = ENUM(name='numberOfCellSpecificAntennaPorts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ABSInformationTDD_numberOfCellSpecificAntennaPorts._cont = ASN1Dict([('one', 0), ('two', 1), ('four', 2)])
    _ABSInformationTDD_numberOfCellSpecificAntennaPorts._ext = []
    _ABSInformationTDD_measurement_subset = BIT_STR(name='measurement-subset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ABSInformationTDD_measurement_subset._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=70)], ev=[], er=[])
    _ABSInformationTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ABSInformationTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___ABSInformationTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____ABSInformationTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ABSInformationTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ABSInformationTDD_iE_Extensions__item__id._const_tab = ____ABSInformationTDD_iE_Extensions__item__id_tab
    ___ABSInformationTDD_iE_Extensions__item__id._const_tab_at = None
    ___ABSInformationTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___ABSInformationTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ABSInformationTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ABSInformationTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ABSInformationTDD_iE_Extensions__item__criticality._const_tab = ____ABSInformationTDD_iE_Extensions__item__criticality_tab
    ___ABSInformationTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ABSInformationTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ABSInformationTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ABSInformationTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ABSInformationTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ABSInformationTDD_iE_Extensions__item__extensionValue._const_tab = ____ABSInformationTDD_iE_Extensions__item__extensionValue_tab
    ___ABSInformationTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ABSInformationTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ABSInformationTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ABSInformationTDD_iE_Extensions__item__id),
        ('criticality', ___ABSInformationTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___ABSInformationTDD_iE_Extensions__item__extensionValue),
        ])
    __ABSInformationTDD_iE_Extensions__item_._ext = None
    _ABSInformationTDD_iE_Extensions._cont = __ABSInformationTDD_iE_Extensions__item_
    _ABSInformationTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ABSInformationTDD._cont = ASN1Dict([
        ('abs-pattern-info', _ABSInformationTDD_abs_pattern_info),
        ('numberOfCellSpecificAntennaPorts', _ABSInformationTDD_numberOfCellSpecificAntennaPorts),
        ('measurement-subset', _ABSInformationTDD_measurement_subset),
        ('iE-Extensions', _ABSInformationTDD_iE_Extensions),
        ])
    ABSInformationTDD._ext = []
    
    #-----< ABSInformationTDD-ExtIEs >-----#
    ABSInformationTDD_ExtIEs = CLASS(name='ABSInformationTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ABSInformationTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ABS-Status >-----#
    ABS_Status = SEQ(name='ABS-Status', mode=MODE_TYPE)
    _ABS_Status_dL_ABS_status = INT(name='dL-ABS-status', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'DL-ABS-status')))
    _ABS_Status_usableABSInformation = CHOICE(name='usableABSInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'UsableABSInformation')))
    _ABS_Status_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ABS_Status_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___ABS_Status_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____ABS_Status_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ABS_Status_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ABS_Status_iE_Extensions__item__id._const_tab = ____ABS_Status_iE_Extensions__item__id_tab
    ___ABS_Status_iE_Extensions__item__id._const_tab_at = None
    ___ABS_Status_iE_Extensions__item__id._const_tab_id = 'id'
    ___ABS_Status_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ABS_Status_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ABS_Status_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ABS_Status_iE_Extensions__item__criticality._const_tab = ____ABS_Status_iE_Extensions__item__criticality_tab
    ___ABS_Status_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ABS_Status_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ABS_Status_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ABS_Status_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ABS_Status_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ABS_Status_iE_Extensions__item__extensionValue._const_tab = ____ABS_Status_iE_Extensions__item__extensionValue_tab
    ___ABS_Status_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ABS_Status_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ABS_Status_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ABS_Status_iE_Extensions__item__id),
        ('criticality', ___ABS_Status_iE_Extensions__item__criticality),
        ('extensionValue', ___ABS_Status_iE_Extensions__item__extensionValue),
        ])
    __ABS_Status_iE_Extensions__item_._ext = None
    _ABS_Status_iE_Extensions._cont = __ABS_Status_iE_Extensions__item_
    _ABS_Status_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ABS_Status._cont = ASN1Dict([
        ('dL-ABS-status', _ABS_Status_dL_ABS_status),
        ('usableABSInformation', _ABS_Status_usableABSInformation),
        ('iE-Extensions', _ABS_Status_iE_Extensions),
        ])
    ABS_Status._ext = []
    
    #-----< ABS-Status-ExtIEs >-----#
    ABS_Status_ExtIEs = CLASS(name='ABS-Status-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ABS_Status_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ActivationID >-----#
    ActivationID = INT(name='ActivationID', mode=MODE_TYPE)
    ActivationID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< Additional-Measurement-Timing-Configuration-List >-----#
    Additional_Measurement_Timing_Configuration_List = SEQ_OF(name='Additional-Measurement-Timing-Configuration-List', mode=MODE_TYPE)
    _Additional_Measurement_Timing_Configuration_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Additional-Measurement-Timing-Configuration-Item')))
    Additional_Measurement_Timing_Configuration_List._cont = _Additional_Measurement_Timing_Configuration_List__item_
    Additional_Measurement_Timing_Configuration_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< Additional-Measurement-Timing-Configuration-Item >-----#
    Additional_Measurement_Timing_Configuration_Item = SEQ(name='Additional-Measurement-Timing-Configuration-Item', mode=MODE_TYPE)
    _Additional_Measurement_Timing_Configuration_Item_additionalMeasurementTimingConfiguration = INT(name='additionalMeasurementTimingConfiguration', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Additional_Measurement_Timing_Configuration_Item_additionalMeasurementTimingConfiguration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16)], ev=None, er=[])
    _Additional_Measurement_Timing_Configuration_Item_csi_RS_MTC_Configuration_List = SEQ_OF(name='csi-RS-MTC-Configuration-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CSI-RS-MTC-Configuration-List')))
    _Additional_Measurement_Timing_Configuration_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_Measurement_Timing_Configuration_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___Additional_Measurement_Timing_Configuration_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____Additional_Measurement_Timing_Configuration_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____Additional_Measurement_Timing_Configuration_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_Measurement_Timing_Configuration_Item_iE_Extensions__item__id._const_tab = ____Additional_Measurement_Timing_Configuration_Item_iE_Extensions__item__id_tab
    ___Additional_Measurement_Timing_Configuration_Item_iE_Extensions__item__id._const_tab_at = None
    ___Additional_Measurement_Timing_Configuration_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___Additional_Measurement_Timing_Configuration_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Additional_Measurement_Timing_Configuration_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____Additional_Measurement_Timing_Configuration_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_Measurement_Timing_Configuration_Item_iE_Extensions__item__criticality._const_tab = ____Additional_Measurement_Timing_Configuration_Item_iE_Extensions__item__criticality_tab
    ___Additional_Measurement_Timing_Configuration_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Additional_Measurement_Timing_Configuration_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Additional_Measurement_Timing_Configuration_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Additional_Measurement_Timing_Configuration_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____Additional_Measurement_Timing_Configuration_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_Measurement_Timing_Configuration_Item_iE_Extensions__item__extensionValue._const_tab = ____Additional_Measurement_Timing_Configuration_Item_iE_Extensions__item__extensionValue_tab
    ___Additional_Measurement_Timing_Configuration_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Additional_Measurement_Timing_Configuration_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Additional_Measurement_Timing_Configuration_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Additional_Measurement_Timing_Configuration_Item_iE_Extensions__item__id),
        ('criticality', ___Additional_Measurement_Timing_Configuration_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___Additional_Measurement_Timing_Configuration_Item_iE_Extensions__item__extensionValue),
        ])
    __Additional_Measurement_Timing_Configuration_Item_iE_Extensions__item_._ext = None
    _Additional_Measurement_Timing_Configuration_Item_iE_Extensions._cont = __Additional_Measurement_Timing_Configuration_Item_iE_Extensions__item_
    _Additional_Measurement_Timing_Configuration_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_Measurement_Timing_Configuration_Item._cont = ASN1Dict([
        ('additionalMeasurementTimingConfiguration', _Additional_Measurement_Timing_Configuration_Item_additionalMeasurementTimingConfiguration),
        ('csi-RS-MTC-Configuration-List', _Additional_Measurement_Timing_Configuration_Item_csi_RS_MTC_Configuration_List),
        ('iE-Extensions', _Additional_Measurement_Timing_Configuration_Item_iE_Extensions),
        ])
    Additional_Measurement_Timing_Configuration_Item._ext = []
    
    #-----< Additional-Measurement-Timing-Configuration-Item-ExtIEs >-----#
    Additional_Measurement_Timing_Configuration_Item_ExtIEs = CLASS(name='Additional-Measurement-Timing-Configuration-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    Additional_Measurement_Timing_Configuration_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CSI-RS-MTC-Configuration-List >-----#
    CSI_RS_MTC_Configuration_List = SEQ_OF(name='CSI-RS-MTC-Configuration-List', mode=MODE_TYPE)
    _CSI_RS_MTC_Configuration_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CSI-RS-MTC-Configuration-Item')))
    CSI_RS_MTC_Configuration_List._cont = _CSI_RS_MTC_Configuration_List__item_
    CSI_RS_MTC_Configuration_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=96)], ev=None, er=[])
    
    #-----< CSI-RS-MTC-Configuration-Item >-----#
    CSI_RS_MTC_Configuration_Item = SEQ(name='CSI-RS-MTC-Configuration-Item', mode=MODE_TYPE)
    _CSI_RS_MTC_Configuration_Item_csi_RS_Index = INT(name='csi-RS-Index', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CSI_RS_MTC_Configuration_Item_csi_RS_Index._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=95)], ev=None, er=[])
    _CSI_RS_MTC_Configuration_Item_csi_RS_Status = ENUM(name='csi-RS-Status', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CSI_RS_MTC_Configuration_Item_csi_RS_Status._cont = ASN1Dict([('activated', 0), ('deactivated', 1)])
    _CSI_RS_MTC_Configuration_Item_csi_RS_Status._ext = []
    _CSI_RS_MTC_Configuration_Item_csi_RS_Neighbour_List = SEQ_OF(name='csi-RS-Neighbour-List', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CSI-RS-Neighbour-List')), opt=True)
    _CSI_RS_MTC_Configuration_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CSI_RS_MTC_Configuration_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___CSI_RS_MTC_Configuration_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____CSI_RS_MTC_Configuration_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CSI_RS_MTC_Configuration_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CSI_RS_MTC_Configuration_Item_iE_Extensions__item__id._const_tab = ____CSI_RS_MTC_Configuration_Item_iE_Extensions__item__id_tab
    ___CSI_RS_MTC_Configuration_Item_iE_Extensions__item__id._const_tab_at = None
    ___CSI_RS_MTC_Configuration_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___CSI_RS_MTC_Configuration_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CSI_RS_MTC_Configuration_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CSI_RS_MTC_Configuration_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CSI_RS_MTC_Configuration_Item_iE_Extensions__item__criticality._const_tab = ____CSI_RS_MTC_Configuration_Item_iE_Extensions__item__criticality_tab
    ___CSI_RS_MTC_Configuration_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CSI_RS_MTC_Configuration_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CSI_RS_MTC_Configuration_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CSI_RS_MTC_Configuration_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CSI_RS_MTC_Configuration_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CSI_RS_MTC_Configuration_Item_iE_Extensions__item__extensionValue._const_tab = ____CSI_RS_MTC_Configuration_Item_iE_Extensions__item__extensionValue_tab
    ___CSI_RS_MTC_Configuration_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CSI_RS_MTC_Configuration_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CSI_RS_MTC_Configuration_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CSI_RS_MTC_Configuration_Item_iE_Extensions__item__id),
        ('criticality', ___CSI_RS_MTC_Configuration_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___CSI_RS_MTC_Configuration_Item_iE_Extensions__item__extensionValue),
        ])
    __CSI_RS_MTC_Configuration_Item_iE_Extensions__item_._ext = None
    _CSI_RS_MTC_Configuration_Item_iE_Extensions._cont = __CSI_RS_MTC_Configuration_Item_iE_Extensions__item_
    _CSI_RS_MTC_Configuration_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CSI_RS_MTC_Configuration_Item._cont = ASN1Dict([
        ('csi-RS-Index', _CSI_RS_MTC_Configuration_Item_csi_RS_Index),
        ('csi-RS-Status', _CSI_RS_MTC_Configuration_Item_csi_RS_Status),
        ('csi-RS-Neighbour-List', _CSI_RS_MTC_Configuration_Item_csi_RS_Neighbour_List),
        ('iE-Extensions', _CSI_RS_MTC_Configuration_Item_iE_Extensions),
        ])
    CSI_RS_MTC_Configuration_Item._ext = []
    
    #-----< CSI-RS-MTC-Configuration-Item-ExtIEs >-----#
    CSI_RS_MTC_Configuration_Item_ExtIEs = CLASS(name='CSI-RS-MTC-Configuration-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    CSI_RS_MTC_Configuration_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CSI-RS-Neighbour-List >-----#
    CSI_RS_Neighbour_List = SEQ_OF(name='CSI-RS-Neighbour-List', mode=MODE_TYPE)
    _CSI_RS_Neighbour_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CSI-RS-Neighbour-Item')))
    CSI_RS_Neighbour_List._cont = _CSI_RS_Neighbour_List__item_
    CSI_RS_Neighbour_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< CSI-RS-Neighbour-Item >-----#
    CSI_RS_Neighbour_Item = SEQ(name='CSI-RS-Neighbour-Item', mode=MODE_TYPE)
    _CSI_RS_Neighbour_Item_nr_cgi = SEQ(name='nr-cgi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'NRCGI')))
    _CSI_RS_Neighbour_Item_csi_RS_MTC_Neighbour_List = SEQ_OF(name='csi-RS-MTC-Neighbour-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CSI-RS-MTC-Neighbour-List')), opt=True)
    _CSI_RS_Neighbour_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CSI_RS_Neighbour_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___CSI_RS_Neighbour_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____CSI_RS_Neighbour_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CSI_RS_Neighbour_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CSI_RS_Neighbour_Item_iE_Extensions__item__id._const_tab = ____CSI_RS_Neighbour_Item_iE_Extensions__item__id_tab
    ___CSI_RS_Neighbour_Item_iE_Extensions__item__id._const_tab_at = None
    ___CSI_RS_Neighbour_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___CSI_RS_Neighbour_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CSI_RS_Neighbour_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CSI_RS_Neighbour_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CSI_RS_Neighbour_Item_iE_Extensions__item__criticality._const_tab = ____CSI_RS_Neighbour_Item_iE_Extensions__item__criticality_tab
    ___CSI_RS_Neighbour_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CSI_RS_Neighbour_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CSI_RS_Neighbour_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CSI_RS_Neighbour_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CSI_RS_Neighbour_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CSI_RS_Neighbour_Item_iE_Extensions__item__extensionValue._const_tab = ____CSI_RS_Neighbour_Item_iE_Extensions__item__extensionValue_tab
    ___CSI_RS_Neighbour_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CSI_RS_Neighbour_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CSI_RS_Neighbour_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CSI_RS_Neighbour_Item_iE_Extensions__item__id),
        ('criticality', ___CSI_RS_Neighbour_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___CSI_RS_Neighbour_Item_iE_Extensions__item__extensionValue),
        ])
    __CSI_RS_Neighbour_Item_iE_Extensions__item_._ext = None
    _CSI_RS_Neighbour_Item_iE_Extensions._cont = __CSI_RS_Neighbour_Item_iE_Extensions__item_
    _CSI_RS_Neighbour_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CSI_RS_Neighbour_Item._cont = ASN1Dict([
        ('nr-cgi', _CSI_RS_Neighbour_Item_nr_cgi),
        ('csi-RS-MTC-Neighbour-List', _CSI_RS_Neighbour_Item_csi_RS_MTC_Neighbour_List),
        ('iE-Extensions', _CSI_RS_Neighbour_Item_iE_Extensions),
        ])
    CSI_RS_Neighbour_Item._ext = []
    
    #-----< CSI-RS-Neighbour-Item-ExtIEs >-----#
    CSI_RS_Neighbour_Item_ExtIEs = CLASS(name='CSI-RS-Neighbour-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    CSI_RS_Neighbour_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CSI-RS-MTC-Neighbour-List >-----#
    CSI_RS_MTC_Neighbour_List = SEQ_OF(name='CSI-RS-MTC-Neighbour-List', mode=MODE_TYPE)
    _CSI_RS_MTC_Neighbour_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CSI-RS-MTC-Neighbour-Item')))
    CSI_RS_MTC_Neighbour_List._cont = _CSI_RS_MTC_Neighbour_List__item_
    CSI_RS_MTC_Neighbour_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< CSI-RS-MTC-Neighbour-Item >-----#
    CSI_RS_MTC_Neighbour_Item = SEQ(name='CSI-RS-MTC-Neighbour-Item', mode=MODE_TYPE)
    _CSI_RS_MTC_Neighbour_Item_csi_RS_Index = INT(name='csi-RS-Index', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CSI_RS_MTC_Neighbour_Item_csi_RS_Index._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=95)], ev=None, er=[])
    _CSI_RS_MTC_Neighbour_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CSI_RS_MTC_Neighbour_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___CSI_RS_MTC_Neighbour_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____CSI_RS_MTC_Neighbour_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CSI_RS_MTC_Neighbour_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CSI_RS_MTC_Neighbour_Item_iE_Extensions__item__id._const_tab = ____CSI_RS_MTC_Neighbour_Item_iE_Extensions__item__id_tab
    ___CSI_RS_MTC_Neighbour_Item_iE_Extensions__item__id._const_tab_at = None
    ___CSI_RS_MTC_Neighbour_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___CSI_RS_MTC_Neighbour_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CSI_RS_MTC_Neighbour_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CSI_RS_MTC_Neighbour_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CSI_RS_MTC_Neighbour_Item_iE_Extensions__item__criticality._const_tab = ____CSI_RS_MTC_Neighbour_Item_iE_Extensions__item__criticality_tab
    ___CSI_RS_MTC_Neighbour_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CSI_RS_MTC_Neighbour_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CSI_RS_MTC_Neighbour_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CSI_RS_MTC_Neighbour_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CSI_RS_MTC_Neighbour_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CSI_RS_MTC_Neighbour_Item_iE_Extensions__item__extensionValue._const_tab = ____CSI_RS_MTC_Neighbour_Item_iE_Extensions__item__extensionValue_tab
    ___CSI_RS_MTC_Neighbour_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CSI_RS_MTC_Neighbour_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CSI_RS_MTC_Neighbour_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CSI_RS_MTC_Neighbour_Item_iE_Extensions__item__id),
        ('criticality', ___CSI_RS_MTC_Neighbour_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___CSI_RS_MTC_Neighbour_Item_iE_Extensions__item__extensionValue),
        ])
    __CSI_RS_MTC_Neighbour_Item_iE_Extensions__item_._ext = None
    _CSI_RS_MTC_Neighbour_Item_iE_Extensions._cont = __CSI_RS_MTC_Neighbour_Item_iE_Extensions__item_
    _CSI_RS_MTC_Neighbour_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CSI_RS_MTC_Neighbour_Item._cont = ASN1Dict([
        ('csi-RS-Index', _CSI_RS_MTC_Neighbour_Item_csi_RS_Index),
        ('iE-Extensions', _CSI_RS_MTC_Neighbour_Item_iE_Extensions),
        ])
    CSI_RS_MTC_Neighbour_Item._ext = []
    
    #-----< CSI-RS-MTC-Neighbour-Item-ExtIEs >-----#
    CSI_RS_MTC_Neighbour_Item_ExtIEs = CLASS(name='CSI-RS-MTC-Neighbour-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    CSI_RS_MTC_Neighbour_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AdditionalListofForwardingGTPTunnelEndpoint >-----#
    AdditionalListofForwardingGTPTunnelEndpoint = SEQ_OF(name='AdditionalListofForwardingGTPTunnelEndpoint', mode=MODE_TYPE)
    _AdditionalListofForwardingGTPTunnelEndpoint__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'AdditionalListofForwardingGTPTunnelEndpoint-Item')))
    AdditionalListofForwardingGTPTunnelEndpoint._cont = _AdditionalListofForwardingGTPTunnelEndpoint__item_
    AdditionalListofForwardingGTPTunnelEndpoint._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=7)], ev=None, er=[])
    
    #-----< AdditionalListofForwardingGTPTunnelEndpoint-Item >-----#
    AdditionalListofForwardingGTPTunnelEndpoint_Item = SEQ(name='AdditionalListofForwardingGTPTunnelEndpoint-Item', mode=MODE_TYPE)
    _AdditionalListofForwardingGTPTunnelEndpoint_Item_uL_GTPtunnelEndpoint = SEQ(name='uL-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _AdditionalListofForwardingGTPTunnelEndpoint_Item_dL_GTPtunnelEndpoint = SEQ(name='dL-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _AdditionalListofForwardingGTPTunnelEndpoint_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AdditionalListofForwardingGTPTunnelEndpoint_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___AdditionalListofForwardingGTPTunnelEndpoint_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____AdditionalListofForwardingGTPTunnelEndpoint_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____AdditionalListofForwardingGTPTunnelEndpoint_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AdditionalListofForwardingGTPTunnelEndpoint_Item_iE_Extensions__item__id._const_tab = ____AdditionalListofForwardingGTPTunnelEndpoint_Item_iE_Extensions__item__id_tab
    ___AdditionalListofForwardingGTPTunnelEndpoint_Item_iE_Extensions__item__id._const_tab_at = None
    ___AdditionalListofForwardingGTPTunnelEndpoint_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___AdditionalListofForwardingGTPTunnelEndpoint_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____AdditionalListofForwardingGTPTunnelEndpoint_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____AdditionalListofForwardingGTPTunnelEndpoint_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AdditionalListofForwardingGTPTunnelEndpoint_Item_iE_Extensions__item__criticality._const_tab = ____AdditionalListofForwardingGTPTunnelEndpoint_Item_iE_Extensions__item__criticality_tab
    ___AdditionalListofForwardingGTPTunnelEndpoint_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AdditionalListofForwardingGTPTunnelEndpoint_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AdditionalListofForwardingGTPTunnelEndpoint_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____AdditionalListofForwardingGTPTunnelEndpoint_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____AdditionalListofForwardingGTPTunnelEndpoint_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AdditionalListofForwardingGTPTunnelEndpoint_Item_iE_Extensions__item__extensionValue._const_tab = ____AdditionalListofForwardingGTPTunnelEndpoint_Item_iE_Extensions__item__extensionValue_tab
    ___AdditionalListofForwardingGTPTunnelEndpoint_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AdditionalListofForwardingGTPTunnelEndpoint_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AdditionalListofForwardingGTPTunnelEndpoint_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AdditionalListofForwardingGTPTunnelEndpoint_Item_iE_Extensions__item__id),
        ('criticality', ___AdditionalListofForwardingGTPTunnelEndpoint_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___AdditionalListofForwardingGTPTunnelEndpoint_Item_iE_Extensions__item__extensionValue),
        ])
    __AdditionalListofForwardingGTPTunnelEndpoint_Item_iE_Extensions__item_._ext = None
    _AdditionalListofForwardingGTPTunnelEndpoint_Item_iE_Extensions._cont = __AdditionalListofForwardingGTPTunnelEndpoint_Item_iE_Extensions__item_
    _AdditionalListofForwardingGTPTunnelEndpoint_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AdditionalListofForwardingGTPTunnelEndpoint_Item._cont = ASN1Dict([
        ('uL-GTPtunnelEndpoint', _AdditionalListofForwardingGTPTunnelEndpoint_Item_uL_GTPtunnelEndpoint),
        ('dL-GTPtunnelEndpoint', _AdditionalListofForwardingGTPTunnelEndpoint_Item_dL_GTPtunnelEndpoint),
        ('iE-Extensions', _AdditionalListofForwardingGTPTunnelEndpoint_Item_iE_Extensions),
        ])
    AdditionalListofForwardingGTPTunnelEndpoint_Item._ext = []
    
    #-----< AdditionalListofForwardingGTPTunnelEndpoint-Item-ExtIEs >-----#
    AdditionalListofForwardingGTPTunnelEndpoint_Item_ExtIEs = CLASS(name='AdditionalListofForwardingGTPTunnelEndpoint-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    AdditionalListofForwardingGTPTunnelEndpoint_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AdditionLocationInformation >-----#
    AdditionLocationInformation = ENUM(name='AdditionLocationInformation', mode=MODE_TYPE)
    AdditionLocationInformation._cont = ASN1Dict([('includePSCell', 0)])
    AdditionLocationInformation._ext = []
    
    #-----< AdditionalRRMPriorityIndex >-----#
    AdditionalRRMPriorityIndex = BIT_STR(name='AdditionalRRMPriorityIndex', mode=MODE_TYPE)
    AdditionalRRMPriorityIndex._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    
    #-----< AdditionalSpecialSubframe-Info >-----#
    AdditionalSpecialSubframe_Info = SEQ(name='AdditionalSpecialSubframe-Info', mode=MODE_TYPE)
    _AdditionalSpecialSubframe_Info_additionalspecialSubframePatterns = ENUM(name='additionalspecialSubframePatterns', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'AdditionalSpecialSubframePatterns')))
    _AdditionalSpecialSubframe_Info_cyclicPrefixDL = ENUM(name='cyclicPrefixDL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CyclicPrefixDL')))
    _AdditionalSpecialSubframe_Info_cyclicPrefixUL = ENUM(name='cyclicPrefixUL', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CyclicPrefixUL')))
    _AdditionalSpecialSubframe_Info_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AdditionalSpecialSubframe_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___AdditionalSpecialSubframe_Info_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____AdditionalSpecialSubframe_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____AdditionalSpecialSubframe_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AdditionalSpecialSubframe_Info_iE_Extensions__item__id._const_tab = ____AdditionalSpecialSubframe_Info_iE_Extensions__item__id_tab
    ___AdditionalSpecialSubframe_Info_iE_Extensions__item__id._const_tab_at = None
    ___AdditionalSpecialSubframe_Info_iE_Extensions__item__id._const_tab_id = 'id'
    ___AdditionalSpecialSubframe_Info_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____AdditionalSpecialSubframe_Info_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____AdditionalSpecialSubframe_Info_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AdditionalSpecialSubframe_Info_iE_Extensions__item__criticality._const_tab = ____AdditionalSpecialSubframe_Info_iE_Extensions__item__criticality_tab
    ___AdditionalSpecialSubframe_Info_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AdditionalSpecialSubframe_Info_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AdditionalSpecialSubframe_Info_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____AdditionalSpecialSubframe_Info_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____AdditionalSpecialSubframe_Info_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AdditionalSpecialSubframe_Info_iE_Extensions__item__extensionValue._const_tab = ____AdditionalSpecialSubframe_Info_iE_Extensions__item__extensionValue_tab
    ___AdditionalSpecialSubframe_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AdditionalSpecialSubframe_Info_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AdditionalSpecialSubframe_Info_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AdditionalSpecialSubframe_Info_iE_Extensions__item__id),
        ('criticality', ___AdditionalSpecialSubframe_Info_iE_Extensions__item__criticality),
        ('extensionValue', ___AdditionalSpecialSubframe_Info_iE_Extensions__item__extensionValue),
        ])
    __AdditionalSpecialSubframe_Info_iE_Extensions__item_._ext = None
    _AdditionalSpecialSubframe_Info_iE_Extensions._cont = __AdditionalSpecialSubframe_Info_iE_Extensions__item_
    _AdditionalSpecialSubframe_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AdditionalSpecialSubframe_Info._cont = ASN1Dict([
        ('additionalspecialSubframePatterns', _AdditionalSpecialSubframe_Info_additionalspecialSubframePatterns),
        ('cyclicPrefixDL', _AdditionalSpecialSubframe_Info_cyclicPrefixDL),
        ('cyclicPrefixUL', _AdditionalSpecialSubframe_Info_cyclicPrefixUL),
        ('iE-Extensions', _AdditionalSpecialSubframe_Info_iE_Extensions),
        ])
    AdditionalSpecialSubframe_Info._ext = []
    
    #-----< AdditionalSpecialSubframe-Info-ExtIEs >-----#
    AdditionalSpecialSubframe_Info_ExtIEs = CLASS(name='AdditionalSpecialSubframe-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    AdditionalSpecialSubframe_Info_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AdditionalSpecialSubframePatterns >-----#
    AdditionalSpecialSubframePatterns = ENUM(name='AdditionalSpecialSubframePatterns', mode=MODE_TYPE)
    AdditionalSpecialSubframePatterns._cont = ASN1Dict([('ssp0', 0), ('ssp1', 1), ('ssp2', 2), ('ssp3', 3), ('ssp4', 4), ('ssp5', 5), ('ssp6', 6), ('ssp7', 7), ('ssp8', 8), ('ssp9', 9)])
    AdditionalSpecialSubframePatterns._ext = []
    
    #-----< AdditionalSpecialSubframeExtension-Info >-----#
    AdditionalSpecialSubframeExtension_Info = SEQ(name='AdditionalSpecialSubframeExtension-Info', mode=MODE_TYPE)
    _AdditionalSpecialSubframeExtension_Info_additionalspecialSubframePatternsExtension = ENUM(name='additionalspecialSubframePatternsExtension', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'AdditionalSpecialSubframePatternsExtension')))
    _AdditionalSpecialSubframeExtension_Info_cyclicPrefixDL = ENUM(name='cyclicPrefixDL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CyclicPrefixDL')))
    _AdditionalSpecialSubframeExtension_Info_cyclicPrefixUL = ENUM(name='cyclicPrefixUL', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CyclicPrefixUL')))
    _AdditionalSpecialSubframeExtension_Info_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AdditionalSpecialSubframeExtension_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___AdditionalSpecialSubframeExtension_Info_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____AdditionalSpecialSubframeExtension_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____AdditionalSpecialSubframeExtension_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AdditionalSpecialSubframeExtension_Info_iE_Extensions__item__id._const_tab = ____AdditionalSpecialSubframeExtension_Info_iE_Extensions__item__id_tab
    ___AdditionalSpecialSubframeExtension_Info_iE_Extensions__item__id._const_tab_at = None
    ___AdditionalSpecialSubframeExtension_Info_iE_Extensions__item__id._const_tab_id = 'id'
    ___AdditionalSpecialSubframeExtension_Info_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____AdditionalSpecialSubframeExtension_Info_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____AdditionalSpecialSubframeExtension_Info_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AdditionalSpecialSubframeExtension_Info_iE_Extensions__item__criticality._const_tab = ____AdditionalSpecialSubframeExtension_Info_iE_Extensions__item__criticality_tab
    ___AdditionalSpecialSubframeExtension_Info_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AdditionalSpecialSubframeExtension_Info_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AdditionalSpecialSubframeExtension_Info_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____AdditionalSpecialSubframeExtension_Info_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____AdditionalSpecialSubframeExtension_Info_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AdditionalSpecialSubframeExtension_Info_iE_Extensions__item__extensionValue._const_tab = ____AdditionalSpecialSubframeExtension_Info_iE_Extensions__item__extensionValue_tab
    ___AdditionalSpecialSubframeExtension_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AdditionalSpecialSubframeExtension_Info_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AdditionalSpecialSubframeExtension_Info_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AdditionalSpecialSubframeExtension_Info_iE_Extensions__item__id),
        ('criticality', ___AdditionalSpecialSubframeExtension_Info_iE_Extensions__item__criticality),
        ('extensionValue', ___AdditionalSpecialSubframeExtension_Info_iE_Extensions__item__extensionValue),
        ])
    __AdditionalSpecialSubframeExtension_Info_iE_Extensions__item_._ext = None
    _AdditionalSpecialSubframeExtension_Info_iE_Extensions._cont = __AdditionalSpecialSubframeExtension_Info_iE_Extensions__item_
    _AdditionalSpecialSubframeExtension_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AdditionalSpecialSubframeExtension_Info._cont = ASN1Dict([
        ('additionalspecialSubframePatternsExtension', _AdditionalSpecialSubframeExtension_Info_additionalspecialSubframePatternsExtension),
        ('cyclicPrefixDL', _AdditionalSpecialSubframeExtension_Info_cyclicPrefixDL),
        ('cyclicPrefixUL', _AdditionalSpecialSubframeExtension_Info_cyclicPrefixUL),
        ('iE-Extensions', _AdditionalSpecialSubframeExtension_Info_iE_Extensions),
        ])
    AdditionalSpecialSubframeExtension_Info._ext = []
    
    #-----< AdditionalSpecialSubframeExtension-Info-ExtIEs >-----#
    AdditionalSpecialSubframeExtension_Info_ExtIEs = CLASS(name='AdditionalSpecialSubframeExtension-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    AdditionalSpecialSubframeExtension_Info_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AdditionalSpecialSubframePatternsExtension >-----#
    AdditionalSpecialSubframePatternsExtension = ENUM(name='AdditionalSpecialSubframePatternsExtension', mode=MODE_TYPE)
    AdditionalSpecialSubframePatternsExtension._cont = ASN1Dict([('ssp10', 0)])
    AdditionalSpecialSubframePatternsExtension._ext = []
    
    #-----< AvailableFastMCGRecoveryViaSRB3 >-----#
    AvailableFastMCGRecoveryViaSRB3 = ENUM(name='AvailableFastMCGRecoveryViaSRB3', mode=MODE_TYPE)
    AvailableFastMCGRecoveryViaSRB3._cont = ASN1Dict([('true', 0)])
    AvailableFastMCGRecoveryViaSRB3._ext = []
    
    #-----< AerialUEsubscriptionInformation >-----#
    AerialUEsubscriptionInformation = ENUM(name='AerialUEsubscriptionInformation', mode=MODE_TYPE)
    AerialUEsubscriptionInformation._cont = ASN1Dict([('allowed', 0), ('not-allowed', 1)])
    AerialUEsubscriptionInformation._ext = []
    
    #-----< AllocationAndRetentionPriority >-----#
    AllocationAndRetentionPriority = SEQ(name='AllocationAndRetentionPriority', mode=MODE_TYPE)
    _AllocationAndRetentionPriority_priorityLevel = INT(name='priorityLevel', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'PriorityLevel')))
    _AllocationAndRetentionPriority_pre_emptionCapability = ENUM(name='pre-emptionCapability', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'Pre-emptionCapability')))
    _AllocationAndRetentionPriority_pre_emptionVulnerability = ENUM(name='pre-emptionVulnerability', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'Pre-emptionVulnerability')))
    _AllocationAndRetentionPriority_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AllocationAndRetentionPriority_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___AllocationAndRetentionPriority_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____AllocationAndRetentionPriority_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____AllocationAndRetentionPriority_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AllocationAndRetentionPriority_iE_Extensions__item__id._const_tab = ____AllocationAndRetentionPriority_iE_Extensions__item__id_tab
    ___AllocationAndRetentionPriority_iE_Extensions__item__id._const_tab_at = None
    ___AllocationAndRetentionPriority_iE_Extensions__item__id._const_tab_id = 'id'
    ___AllocationAndRetentionPriority_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____AllocationAndRetentionPriority_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____AllocationAndRetentionPriority_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AllocationAndRetentionPriority_iE_Extensions__item__criticality._const_tab = ____AllocationAndRetentionPriority_iE_Extensions__item__criticality_tab
    ___AllocationAndRetentionPriority_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AllocationAndRetentionPriority_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AllocationAndRetentionPriority_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____AllocationAndRetentionPriority_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____AllocationAndRetentionPriority_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AllocationAndRetentionPriority_iE_Extensions__item__extensionValue._const_tab = ____AllocationAndRetentionPriority_iE_Extensions__item__extensionValue_tab
    ___AllocationAndRetentionPriority_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AllocationAndRetentionPriority_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AllocationAndRetentionPriority_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AllocationAndRetentionPriority_iE_Extensions__item__id),
        ('criticality', ___AllocationAndRetentionPriority_iE_Extensions__item__criticality),
        ('extensionValue', ___AllocationAndRetentionPriority_iE_Extensions__item__extensionValue),
        ])
    __AllocationAndRetentionPriority_iE_Extensions__item_._ext = None
    _AllocationAndRetentionPriority_iE_Extensions._cont = __AllocationAndRetentionPriority_iE_Extensions__item_
    _AllocationAndRetentionPriority_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AllocationAndRetentionPriority._cont = ASN1Dict([
        ('priorityLevel', _AllocationAndRetentionPriority_priorityLevel),
        ('pre-emptionCapability', _AllocationAndRetentionPriority_pre_emptionCapability),
        ('pre-emptionVulnerability', _AllocationAndRetentionPriority_pre_emptionVulnerability),
        ('iE-Extensions', _AllocationAndRetentionPriority_iE_Extensions),
        ])
    AllocationAndRetentionPriority._ext = []
    
    #-----< AllocationAndRetentionPriority-ExtIEs >-----#
    AllocationAndRetentionPriority_ExtIEs = CLASS(name='AllocationAndRetentionPriority-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    AllocationAndRetentionPriority_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AreaScopeOfMDT >-----#
    AreaScopeOfMDT = CHOICE(name='AreaScopeOfMDT', mode=MODE_TYPE)
    _AreaScopeOfMDT_cellBased = SEQ(name='cellBased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CellBasedMDT')))
    _AreaScopeOfMDT_tABased = SEQ(name='tABased', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'TABasedMDT')))
    _AreaScopeOfMDT_pLMNWide = NULL(name='pLMNWide', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AreaScopeOfMDT_tAIBased = SEQ(name='tAIBased', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'TAIBasedMDT')))
    AreaScopeOfMDT._cont = ASN1Dict([
        ('cellBased', _AreaScopeOfMDT_cellBased),
        ('tABased', _AreaScopeOfMDT_tABased),
        ('pLMNWide', _AreaScopeOfMDT_pLMNWide),
        ('tAIBased', _AreaScopeOfMDT_tAIBased),
        ])
    AreaScopeOfMDT._ext = ['tAIBased']
    
    #-----< AreaScopeOfQMC >-----#
    AreaScopeOfQMC = CHOICE(name='AreaScopeOfQMC', mode=MODE_TYPE)
    _AreaScopeOfQMC_cellBased = SEQ(name='cellBased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CellBasedQMC')))
    _AreaScopeOfQMC_tABased = SEQ(name='tABased', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'TABasedQMC')))
    _AreaScopeOfQMC_tAIBased = SEQ(name='tAIBased', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'TAIBasedQMC')))
    _AreaScopeOfQMC_pLMNAreaBased = SEQ(name='pLMNAreaBased', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'PLMNAreaBasedQMC')))
    AreaScopeOfQMC._cont = ASN1Dict([
        ('cellBased', _AreaScopeOfQMC_cellBased),
        ('tABased', _AreaScopeOfQMC_tABased),
        ('tAIBased', _AreaScopeOfQMC_tAIBased),
        ('pLMNAreaBased', _AreaScopeOfQMC_pLMNAreaBased),
        ])
    AreaScopeOfQMC._ext = []
    
    #-----< AS-SecurityInformation >-----#
    AS_SecurityInformation = SEQ(name='AS-SecurityInformation', mode=MODE_TYPE)
    _AS_SecurityInformation_key_eNodeB_star = BIT_STR(name='key-eNodeB-star', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'Key-eNodeB-Star')))
    _AS_SecurityInformation_nextHopChainingCount = INT(name='nextHopChainingCount', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'NextHopChainingCount')))
    _AS_SecurityInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AS_SecurityInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___AS_SecurityInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____AS_SecurityInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____AS_SecurityInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AS_SecurityInformation_iE_Extensions__item__id._const_tab = ____AS_SecurityInformation_iE_Extensions__item__id_tab
    ___AS_SecurityInformation_iE_Extensions__item__id._const_tab_at = None
    ___AS_SecurityInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___AS_SecurityInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____AS_SecurityInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____AS_SecurityInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AS_SecurityInformation_iE_Extensions__item__criticality._const_tab = ____AS_SecurityInformation_iE_Extensions__item__criticality_tab
    ___AS_SecurityInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AS_SecurityInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AS_SecurityInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____AS_SecurityInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____AS_SecurityInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AS_SecurityInformation_iE_Extensions__item__extensionValue._const_tab = ____AS_SecurityInformation_iE_Extensions__item__extensionValue_tab
    ___AS_SecurityInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AS_SecurityInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AS_SecurityInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AS_SecurityInformation_iE_Extensions__item__id),
        ('criticality', ___AS_SecurityInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___AS_SecurityInformation_iE_Extensions__item__extensionValue),
        ])
    __AS_SecurityInformation_iE_Extensions__item_._ext = None
    _AS_SecurityInformation_iE_Extensions._cont = __AS_SecurityInformation_iE_Extensions__item_
    _AS_SecurityInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AS_SecurityInformation._cont = ASN1Dict([
        ('key-eNodeB-star', _AS_SecurityInformation_key_eNodeB_star),
        ('nextHopChainingCount', _AS_SecurityInformation_nextHopChainingCount),
        ('iE-Extensions', _AS_SecurityInformation_iE_Extensions),
        ])
    AS_SecurityInformation._ext = []
    
    #-----< AS-SecurityInformation-ExtIEs >-----#
    AS_SecurityInformation_ExtIEs = CLASS(name='AS-SecurityInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    AS_SecurityInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AdditionalPLMNs-Item >-----#
    AdditionalPLMNs_Item = SEQ_OF(name='AdditionalPLMNs-Item', mode=MODE_TYPE)
    _AdditionalPLMNs_Item__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PLMN-Identity')))
    AdditionalPLMNs_Item._cont = _AdditionalPLMNs_Item__item_
    AdditionalPLMNs_Item._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    
    #-----< BandwidthReducedSI >-----#
    BandwidthReducedSI = ENUM(name='BandwidthReducedSI', mode=MODE_TYPE)
    BandwidthReducedSI._cont = ASN1Dict([('scheduled', 0)])
    BandwidthReducedSI._ext = []
    
    #-----< BearerType >-----#
    BearerType = ENUM(name='BearerType', mode=MODE_TYPE)
    BearerType._cont = ASN1Dict([('non-IP', 0)])
    BearerType._ext = []
    
    #-----< BenefitMetric >-----#
    BenefitMetric = INT(name='BenefitMetric', mode=MODE_TYPE)
    BenefitMetric._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-101, ub=100)], ev=[], er=[])
    
    #-----< BitRate >-----#
    BitRate = INT(name='BitRate', mode=MODE_TYPE)
    BitRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=10000000000)], ev=None, er=[])
    
    #-----< BroadcastPLMNs-Item >-----#
    BroadcastPLMNs_Item = SEQ_OF(name='BroadcastPLMNs-Item', mode=MODE_TYPE)
    _BroadcastPLMNs_Item__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PLMN-Identity')))
    BroadcastPLMNs_Item._cont = _BroadcastPLMNs_Item__item_
    BroadcastPLMNs_Item._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    
    #-----< BluetoothMeasurementConfiguration >-----#
    BluetoothMeasurementConfiguration = SEQ(name='BluetoothMeasurementConfiguration', mode=MODE_TYPE)
    _BluetoothMeasurementConfiguration_bluetoothMeasConfig = ENUM(name='bluetoothMeasConfig', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'BluetoothMeasConfig')))
    _BluetoothMeasurementConfiguration_bluetoothMeasConfigNameList = SEQ_OF(name='bluetoothMeasConfigNameList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'BluetoothMeasConfigNameList')), opt=True)
    _BluetoothMeasurementConfiguration_bt_rssi = ENUM(name='bt-rssi', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _BluetoothMeasurementConfiguration_bt_rssi._cont = ASN1Dict([('true', 0)])
    _BluetoothMeasurementConfiguration_bt_rssi._ext = []
    _BluetoothMeasurementConfiguration_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BluetoothMeasurementConfiguration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___BluetoothMeasurementConfiguration_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____BluetoothMeasurementConfiguration_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____BluetoothMeasurementConfiguration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BluetoothMeasurementConfiguration_iE_Extensions__item__id._const_tab = ____BluetoothMeasurementConfiguration_iE_Extensions__item__id_tab
    ___BluetoothMeasurementConfiguration_iE_Extensions__item__id._const_tab_at = None
    ___BluetoothMeasurementConfiguration_iE_Extensions__item__id._const_tab_id = 'id'
    ___BluetoothMeasurementConfiguration_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____BluetoothMeasurementConfiguration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____BluetoothMeasurementConfiguration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BluetoothMeasurementConfiguration_iE_Extensions__item__criticality._const_tab = ____BluetoothMeasurementConfiguration_iE_Extensions__item__criticality_tab
    ___BluetoothMeasurementConfiguration_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___BluetoothMeasurementConfiguration_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___BluetoothMeasurementConfiguration_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____BluetoothMeasurementConfiguration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____BluetoothMeasurementConfiguration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BluetoothMeasurementConfiguration_iE_Extensions__item__extensionValue._const_tab = ____BluetoothMeasurementConfiguration_iE_Extensions__item__extensionValue_tab
    ___BluetoothMeasurementConfiguration_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___BluetoothMeasurementConfiguration_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __BluetoothMeasurementConfiguration_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___BluetoothMeasurementConfiguration_iE_Extensions__item__id),
        ('criticality', ___BluetoothMeasurementConfiguration_iE_Extensions__item__criticality),
        ('extensionValue', ___BluetoothMeasurementConfiguration_iE_Extensions__item__extensionValue),
        ])
    __BluetoothMeasurementConfiguration_iE_Extensions__item_._ext = None
    _BluetoothMeasurementConfiguration_iE_Extensions._cont = __BluetoothMeasurementConfiguration_iE_Extensions__item_
    _BluetoothMeasurementConfiguration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BluetoothMeasurementConfiguration._cont = ASN1Dict([
        ('bluetoothMeasConfig', _BluetoothMeasurementConfiguration_bluetoothMeasConfig),
        ('bluetoothMeasConfigNameList', _BluetoothMeasurementConfiguration_bluetoothMeasConfigNameList),
        ('bt-rssi', _BluetoothMeasurementConfiguration_bt_rssi),
        ('iE-Extensions', _BluetoothMeasurementConfiguration_iE_Extensions),
        ])
    BluetoothMeasurementConfiguration._ext = []
    
    #-----< BluetoothMeasurementConfiguration-ExtIEs >-----#
    BluetoothMeasurementConfiguration_ExtIEs = CLASS(name='BluetoothMeasurementConfiguration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    BluetoothMeasurementConfiguration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BluetoothMeasConfigNameList >-----#
    BluetoothMeasConfigNameList = SEQ_OF(name='BluetoothMeasConfigNameList', mode=MODE_TYPE)
    _BluetoothMeasConfigNameList__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'BluetoothName')))
    BluetoothMeasConfigNameList._cont = _BluetoothMeasConfigNameList__item_
    BluetoothMeasConfigNameList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< BluetoothMeasConfig >-----#
    BluetoothMeasConfig = ENUM(name='BluetoothMeasConfig', mode=MODE_TYPE)
    BluetoothMeasConfig._cont = ASN1Dict([('setup', 0)])
    BluetoothMeasConfig._ext = []
    
    #-----< BluetoothName >-----#
    BluetoothName = OCT_STR(name='BluetoothName', mode=MODE_TYPE)
    BluetoothName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=248)], ev=None, er=[])
    
    #-----< BPLMN-ID-Info-EUTRA >-----#
    BPLMN_ID_Info_EUTRA = SEQ_OF(name='BPLMN-ID-Info-EUTRA', mode=MODE_TYPE)
    _BPLMN_ID_Info_EUTRA__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'BPLMN-ID-Info-EUTRA-Item')))
    BPLMN_ID_Info_EUTRA._cont = _BPLMN_ID_Info_EUTRA__item_
    BPLMN_ID_Info_EUTRA._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    
    #-----< BPLMN-ID-Info-EUTRA-Item >-----#
    BPLMN_ID_Info_EUTRA_Item = SEQ(name='BPLMN-ID-Info-EUTRA-Item', mode=MODE_TYPE)
    _BPLMN_ID_Info_EUTRA_Item_broadcastPLMNs = SEQ_OF(name='broadcastPLMNs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'BroadcastPLMNs-Item')))
    _BPLMN_ID_Info_EUTRA_Item_tac = OCT_STR(name='tac', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'TAC')))
    _BPLMN_ID_Info_EUTRA_Item_e_utraCI = BIT_STR(name='e-utraCI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'EUTRANCellIdentifier')))
    _BPLMN_ID_Info_EUTRA_Item_iE_Extension = SEQ_OF(name='iE-Extension', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BPLMN_ID_Info_EUTRA_Item_iE_Extension__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___BPLMN_ID_Info_EUTRA_Item_iE_Extension__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____BPLMN_ID_Info_EUTRA_Item_iE_Extension__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____BPLMN_ID_Info_EUTRA_Item_iE_Extension__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BPLMN_ID_Info_EUTRA_Item_iE_Extension__item__id._const_tab = ____BPLMN_ID_Info_EUTRA_Item_iE_Extension__item__id_tab
    ___BPLMN_ID_Info_EUTRA_Item_iE_Extension__item__id._const_tab_at = None
    ___BPLMN_ID_Info_EUTRA_Item_iE_Extension__item__id._const_tab_id = 'id'
    ___BPLMN_ID_Info_EUTRA_Item_iE_Extension__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____BPLMN_ID_Info_EUTRA_Item_iE_Extension__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____BPLMN_ID_Info_EUTRA_Item_iE_Extension__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BPLMN_ID_Info_EUTRA_Item_iE_Extension__item__criticality._const_tab = ____BPLMN_ID_Info_EUTRA_Item_iE_Extension__item__criticality_tab
    ___BPLMN_ID_Info_EUTRA_Item_iE_Extension__item__criticality._const_tab_at = ('..', 'id')
    ___BPLMN_ID_Info_EUTRA_Item_iE_Extension__item__criticality._const_tab_id = 'criticality'
    ___BPLMN_ID_Info_EUTRA_Item_iE_Extension__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____BPLMN_ID_Info_EUTRA_Item_iE_Extension__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____BPLMN_ID_Info_EUTRA_Item_iE_Extension__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BPLMN_ID_Info_EUTRA_Item_iE_Extension__item__extensionValue._const_tab = ____BPLMN_ID_Info_EUTRA_Item_iE_Extension__item__extensionValue_tab
    ___BPLMN_ID_Info_EUTRA_Item_iE_Extension__item__extensionValue._const_tab_at = ('..', 'id')
    ___BPLMN_ID_Info_EUTRA_Item_iE_Extension__item__extensionValue._const_tab_id = 'Extension'
    __BPLMN_ID_Info_EUTRA_Item_iE_Extension__item_._cont = ASN1Dict([
        ('id', ___BPLMN_ID_Info_EUTRA_Item_iE_Extension__item__id),
        ('criticality', ___BPLMN_ID_Info_EUTRA_Item_iE_Extension__item__criticality),
        ('extensionValue', ___BPLMN_ID_Info_EUTRA_Item_iE_Extension__item__extensionValue),
        ])
    __BPLMN_ID_Info_EUTRA_Item_iE_Extension__item_._ext = None
    _BPLMN_ID_Info_EUTRA_Item_iE_Extension._cont = __BPLMN_ID_Info_EUTRA_Item_iE_Extension__item_
    _BPLMN_ID_Info_EUTRA_Item_iE_Extension._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BPLMN_ID_Info_EUTRA_Item._cont = ASN1Dict([
        ('broadcastPLMNs', _BPLMN_ID_Info_EUTRA_Item_broadcastPLMNs),
        ('tac', _BPLMN_ID_Info_EUTRA_Item_tac),
        ('e-utraCI', _BPLMN_ID_Info_EUTRA_Item_e_utraCI),
        ('iE-Extension', _BPLMN_ID_Info_EUTRA_Item_iE_Extension),
        ])
    BPLMN_ID_Info_EUTRA_Item._ext = []
    
    #-----< BPLMN-ID-Info-EUTRA-Item-ExtIEs >-----#
    BPLMN_ID_Info_EUTRA_Item_ExtIEs = CLASS(name='BPLMN-ID-Info-EUTRA-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    BPLMN_ID_Info_EUTRA_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BPLMN-ID-Info-NR >-----#
    BPLMN_ID_Info_NR = SEQ_OF(name='BPLMN-ID-Info-NR', mode=MODE_TYPE)
    _BPLMN_ID_Info_NR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'BPLMN-ID-Info-NR-Item')))
    BPLMN_ID_Info_NR._cont = _BPLMN_ID_Info_NR__item_
    BPLMN_ID_Info_NR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=12)], ev=None, er=[])
    
    #-----< BPLMN-ID-Info-NR-Item >-----#
    BPLMN_ID_Info_NR_Item = SEQ(name='BPLMN-ID-Info-NR-Item', mode=MODE_TYPE)
    _BPLMN_ID_Info_NR_Item_broadcastPLMNs = SEQ_OF(name='broadcastPLMNs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'BroadcastextPLMNs')))
    _BPLMN_ID_Info_NR_Item_fiveGS_TAC = OCT_STR(name='fiveGS-TAC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'FiveGS-TAC')), opt=True)
    _BPLMN_ID_Info_NR_Item_nr_CI = BIT_STR(name='nr-CI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'NRCellIdentifier')))
    _BPLMN_ID_Info_NR_Item_iE_Extension = SEQ_OF(name='iE-Extension', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BPLMN_ID_Info_NR_Item_iE_Extension__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___BPLMN_ID_Info_NR_Item_iE_Extension__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____BPLMN_ID_Info_NR_Item_iE_Extension__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____BPLMN_ID_Info_NR_Item_iE_Extension__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BPLMN_ID_Info_NR_Item_iE_Extension__item__id._const_tab = ____BPLMN_ID_Info_NR_Item_iE_Extension__item__id_tab
    ___BPLMN_ID_Info_NR_Item_iE_Extension__item__id._const_tab_at = None
    ___BPLMN_ID_Info_NR_Item_iE_Extension__item__id._const_tab_id = 'id'
    ___BPLMN_ID_Info_NR_Item_iE_Extension__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____BPLMN_ID_Info_NR_Item_iE_Extension__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____BPLMN_ID_Info_NR_Item_iE_Extension__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BPLMN_ID_Info_NR_Item_iE_Extension__item__criticality._const_tab = ____BPLMN_ID_Info_NR_Item_iE_Extension__item__criticality_tab
    ___BPLMN_ID_Info_NR_Item_iE_Extension__item__criticality._const_tab_at = ('..', 'id')
    ___BPLMN_ID_Info_NR_Item_iE_Extension__item__criticality._const_tab_id = 'criticality'
    ___BPLMN_ID_Info_NR_Item_iE_Extension__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____BPLMN_ID_Info_NR_Item_iE_Extension__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____BPLMN_ID_Info_NR_Item_iE_Extension__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BPLMN_ID_Info_NR_Item_iE_Extension__item__extensionValue._const_tab = ____BPLMN_ID_Info_NR_Item_iE_Extension__item__extensionValue_tab
    ___BPLMN_ID_Info_NR_Item_iE_Extension__item__extensionValue._const_tab_at = ('..', 'id')
    ___BPLMN_ID_Info_NR_Item_iE_Extension__item__extensionValue._const_tab_id = 'Extension'
    __BPLMN_ID_Info_NR_Item_iE_Extension__item_._cont = ASN1Dict([
        ('id', ___BPLMN_ID_Info_NR_Item_iE_Extension__item__id),
        ('criticality', ___BPLMN_ID_Info_NR_Item_iE_Extension__item__criticality),
        ('extensionValue', ___BPLMN_ID_Info_NR_Item_iE_Extension__item__extensionValue),
        ])
    __BPLMN_ID_Info_NR_Item_iE_Extension__item_._ext = None
    _BPLMN_ID_Info_NR_Item_iE_Extension._cont = __BPLMN_ID_Info_NR_Item_iE_Extension__item_
    _BPLMN_ID_Info_NR_Item_iE_Extension._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BPLMN_ID_Info_NR_Item._cont = ASN1Dict([
        ('broadcastPLMNs', _BPLMN_ID_Info_NR_Item_broadcastPLMNs),
        ('fiveGS-TAC', _BPLMN_ID_Info_NR_Item_fiveGS_TAC),
        ('nr-CI', _BPLMN_ID_Info_NR_Item_nr_CI),
        ('iE-Extension', _BPLMN_ID_Info_NR_Item_iE_Extension),
        ])
    BPLMN_ID_Info_NR_Item._ext = []
    
    #-----< BPLMN-ID-Info-NR-Item-ExtIEs >-----#
    BPLMN_ID_Info_NR_Item_ExtIEs = CLASS(name='BPLMN-ID-Info-NR-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    BPLMN_ID_Info_NR_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BroadcastextPLMNs >-----#
    BroadcastextPLMNs = SEQ_OF(name='BroadcastextPLMNs', mode=MODE_TYPE)
    _BroadcastextPLMNs__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PLMN-Identity')))
    BroadcastextPLMNs._cont = _BroadcastextPLMNs__item_
    BroadcastextPLMNs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=12)], ev=None, er=[])
    
    #-----< CapacityValue >-----#
    CapacityValue = INT(name='CapacityValue', mode=MODE_TYPE)
    CapacityValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    
    #-----< Cause >-----#
    Cause = CHOICE(name='Cause', mode=MODE_TYPE)
    _Cause_radioNetwork = ENUM(name='radioNetwork', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CauseRadioNetwork')))
    _Cause_transport = ENUM(name='transport', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CauseTransport')))
    _Cause_protocol = ENUM(name='protocol', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CauseProtocol')))
    _Cause_misc = ENUM(name='misc', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CauseMisc')))
    Cause._cont = ASN1Dict([
        ('radioNetwork', _Cause_radioNetwork),
        ('transport', _Cause_transport),
        ('protocol', _Cause_protocol),
        ('misc', _Cause_misc),
        ])
    Cause._ext = []
    
    #-----< CauseMisc >-----#
    CauseMisc = ENUM(name='CauseMisc', mode=MODE_TYPE)
    CauseMisc._cont = ASN1Dict([('control-processing-overload', 0), ('hardware-failure', 1), ('om-intervention', 2), ('not-enough-user-plane-processing-resources', 3), ('unspecified', 4)])
    CauseMisc._ext = []
    
    #-----< CauseProtocol >-----#
    CauseProtocol = ENUM(name='CauseProtocol', mode=MODE_TYPE)
    CauseProtocol._cont = ASN1Dict([('transfer-syntax-error', 0), ('abstract-syntax-error-reject', 1), ('abstract-syntax-error-ignore-and-notify', 2), ('message-not-compatible-with-receiver-state', 3), ('semantic-error', 4), ('unspecified', 5), ('abstract-syntax-error-falsely-constructed-message', 6)])
    CauseProtocol._ext = []
    
    #-----< CauseRadioNetwork >-----#
    CauseRadioNetwork = ENUM(name='CauseRadioNetwork', mode=MODE_TYPE)
    CauseRadioNetwork._cont = ASN1Dict([('handover-desirable-for-radio-reasons', 0), ('time-critical-handover', 1), ('resource-optimisation-handover', 2), ('reduce-load-in-serving-cell', 3), ('partial-handover', 4), ('unknown-new-eNB-UE-X2AP-ID', 5), ('unknown-old-eNB-UE-X2AP-ID', 6), ('unknown-pair-of-UE-X2AP-ID', 7), ('ho-target-not-allowed', 8), ('tx2relocoverall-expiry', 9), ('trelocprep-expiry', 10), ('cell-not-available', 11), ('no-radio-resources-available-in-target-cell', 12), ('invalid-MME-GroupID', 13), ('unknown-MME-Code', 14), ('encryption-and-or-integrity-protection-algorithms-not-supported', 15), ('reportCharacteristicsEmpty', 16), ('noReportPeriodicity', 17), ('existingMeasurementID', 18), ('unknown-eNB-Measurement-ID', 19), ('measurement-temporarily-not-available', 20), ('unspecified', 21), ('load-balancing', 22), ('handover-optimisation', 23), ('value-out-of-allowed-range', 24), ('multiple-E-RAB-ID-instances', 25), ('switch-off-ongoing', 26), ('not-supported-QCI-value', 27), ('measurement-not-supported-for-the-object', 28), ('tDCoverall-expiry', 29), ('tDCprep-expiry', 30), ('action-desirable-for-radio-reasons', 31), ('reduce-load', 32), ('resource-optimisation', 33), ('time-critical-action', 34), ('target-not-allowed', 35), ('no-radio-resources-available', 36), ('invalid-QoS-combination', 37), ('encryption-algorithms-not-supported', 38), ('procedure-cancelled', 39), ('rRM-purpose', 40), ('improve-user-bit-rate', 41), ('user-inactivity', 42), ('radio-connection-with-UE-lost', 43), ('failure-in-the-radio-interface-procedure', 44), ('bearer-option-not-supported', 45), ('mCG-Mobility', 46), ('sCG-Mobility', 47), ('count-reaches-max-value', 48), ('unknown-old-en-gNB-UE-X2AP-ID', 49), ('pDCP-Overload', 50), ('cho-cpc-resources-tobechanged', 51), ('ue-power-saving', 52), ('insufficient-ue-capabilities', 53), ('normal-release', 54), ('unknown-E-UTRAN-Node-Measurement-ID', 55), ('sCG-activation-deactivation-failure', 56), ('sCG-deactivation-failure-due-to-data-transmission', 57), ('up-integrity-protection-not-possible', 58)])
    CauseRadioNetwork._ext = ['load-balancing', 'handover-optimisation', 'value-out-of-allowed-range', 'multiple-E-RAB-ID-instances', 'switch-off-ongoing', 'not-supported-QCI-value', 'measurement-not-supported-for-the-object', 'tDCoverall-expiry', 'tDCprep-expiry', 'action-desirable-for-radio-reasons', 'reduce-load', 'resource-optimisation', 'time-critical-action', 'target-not-allowed', 'no-radio-resources-available', 'invalid-QoS-combination', 'encryption-algorithms-not-supported', 'procedure-cancelled', 'rRM-purpose', 'improve-user-bit-rate', 'user-inactivity', 'radio-connection-with-UE-lost', 'failure-in-the-radio-interface-procedure', 'bearer-option-not-supported', 'mCG-Mobility', 'sCG-Mobility', 'count-reaches-max-value', 'unknown-old-en-gNB-UE-X2AP-ID', 'pDCP-Overload', 'cho-cpc-resources-tobechanged', 'ue-power-saving', 'insufficient-ue-capabilities', 'normal-release', 'unknown-E-UTRAN-Node-Measurement-ID', 'sCG-activation-deactivation-failure', 'sCG-deactivation-failure-due-to-data-transmission', 'up-integrity-protection-not-possible']
    
    #-----< CauseTransport >-----#
    CauseTransport = ENUM(name='CauseTransport', mode=MODE_TYPE)
    CauseTransport._cont = ASN1Dict([('transport-resource-unavailable', 0), ('unspecified', 1)])
    CauseTransport._ext = []
    
    #-----< CellBasedMDT >-----#
    CellBasedMDT = SEQ(name='CellBasedMDT', mode=MODE_TYPE)
    _CellBasedMDT_cellIdListforMDT = SEQ_OF(name='cellIdListforMDT', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CellIdListforMDT')))
    _CellBasedMDT_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellBasedMDT_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___CellBasedMDT_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____CellBasedMDT_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CellBasedMDT_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellBasedMDT_iE_Extensions__item__id._const_tab = ____CellBasedMDT_iE_Extensions__item__id_tab
    ___CellBasedMDT_iE_Extensions__item__id._const_tab_at = None
    ___CellBasedMDT_iE_Extensions__item__id._const_tab_id = 'id'
    ___CellBasedMDT_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CellBasedMDT_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CellBasedMDT_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellBasedMDT_iE_Extensions__item__criticality._const_tab = ____CellBasedMDT_iE_Extensions__item__criticality_tab
    ___CellBasedMDT_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CellBasedMDT_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CellBasedMDT_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CellBasedMDT_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CellBasedMDT_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellBasedMDT_iE_Extensions__item__extensionValue._const_tab = ____CellBasedMDT_iE_Extensions__item__extensionValue_tab
    ___CellBasedMDT_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellBasedMDT_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CellBasedMDT_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CellBasedMDT_iE_Extensions__item__id),
        ('criticality', ___CellBasedMDT_iE_Extensions__item__criticality),
        ('extensionValue', ___CellBasedMDT_iE_Extensions__item__extensionValue),
        ])
    __CellBasedMDT_iE_Extensions__item_._ext = None
    _CellBasedMDT_iE_Extensions._cont = __CellBasedMDT_iE_Extensions__item_
    _CellBasedMDT_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellBasedMDT._cont = ASN1Dict([
        ('cellIdListforMDT', _CellBasedMDT_cellIdListforMDT),
        ('iE-Extensions', _CellBasedMDT_iE_Extensions),
        ])
    CellBasedMDT._ext = []
    
    #-----< CellBasedMDT-ExtIEs >-----#
    CellBasedMDT_ExtIEs = CLASS(name='CellBasedMDT-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    CellBasedMDT_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellBasedQMC >-----#
    CellBasedQMC = SEQ(name='CellBasedQMC', mode=MODE_TYPE)
    _CellBasedQMC_cellIdListforQMC = SEQ_OF(name='cellIdListforQMC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CellIdListforQMC')))
    _CellBasedQMC_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellBasedQMC_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___CellBasedQMC_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____CellBasedQMC_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CellBasedQMC_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellBasedQMC_iE_Extensions__item__id._const_tab = ____CellBasedQMC_iE_Extensions__item__id_tab
    ___CellBasedQMC_iE_Extensions__item__id._const_tab_at = None
    ___CellBasedQMC_iE_Extensions__item__id._const_tab_id = 'id'
    ___CellBasedQMC_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CellBasedQMC_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CellBasedQMC_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellBasedQMC_iE_Extensions__item__criticality._const_tab = ____CellBasedQMC_iE_Extensions__item__criticality_tab
    ___CellBasedQMC_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CellBasedQMC_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CellBasedQMC_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CellBasedQMC_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CellBasedQMC_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellBasedQMC_iE_Extensions__item__extensionValue._const_tab = ____CellBasedQMC_iE_Extensions__item__extensionValue_tab
    ___CellBasedQMC_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellBasedQMC_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CellBasedQMC_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CellBasedQMC_iE_Extensions__item__id),
        ('criticality', ___CellBasedQMC_iE_Extensions__item__criticality),
        ('extensionValue', ___CellBasedQMC_iE_Extensions__item__extensionValue),
        ])
    __CellBasedQMC_iE_Extensions__item_._ext = None
    _CellBasedQMC_iE_Extensions._cont = __CellBasedQMC_iE_Extensions__item_
    _CellBasedQMC_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellBasedQMC._cont = ASN1Dict([
        ('cellIdListforQMC', _CellBasedQMC_cellIdListforQMC),
        ('iE-Extensions', _CellBasedQMC_iE_Extensions),
        ])
    CellBasedQMC._ext = []
    
    #-----< CellBasedQMC-ExtIEs >-----#
    CellBasedQMC_ExtIEs = CLASS(name='CellBasedQMC-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    CellBasedQMC_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellCapacityClassValue >-----#
    CellCapacityClassValue = INT(name='CellCapacityClassValue', mode=MODE_TYPE)
    CellCapacityClassValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=[], er=[])
    
    #-----< CellDeploymentStatusIndicator >-----#
    CellDeploymentStatusIndicator = ENUM(name='CellDeploymentStatusIndicator', mode=MODE_TYPE)
    CellDeploymentStatusIndicator._cont = ASN1Dict([('pre-change-notification', 0)])
    CellDeploymentStatusIndicator._ext = []
    
    #-----< CellIdListforMDT >-----#
    CellIdListforMDT = SEQ_OF(name='CellIdListforMDT', mode=MODE_TYPE)
    _CellIdListforMDT__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    CellIdListforMDT._cont = _CellIdListforMDT__item_
    CellIdListforMDT._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< CellIdListforQMC >-----#
    CellIdListforQMC = SEQ_OF(name='CellIdListforQMC', mode=MODE_TYPE)
    _CellIdListforQMC__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    CellIdListforQMC._cont = _CellIdListforQMC__item_
    CellIdListforQMC._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< CellReplacingInfo >-----#
    CellReplacingInfo = SEQ(name='CellReplacingInfo', mode=MODE_TYPE)
    _CellReplacingInfo_replacingCellsList = SEQ_OF(name='replacingCellsList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ReplacingCellsList')))
    _CellReplacingInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellReplacingInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___CellReplacingInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____CellReplacingInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CellReplacingInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellReplacingInfo_iE_Extensions__item__id._const_tab = ____CellReplacingInfo_iE_Extensions__item__id_tab
    ___CellReplacingInfo_iE_Extensions__item__id._const_tab_at = None
    ___CellReplacingInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___CellReplacingInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CellReplacingInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CellReplacingInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellReplacingInfo_iE_Extensions__item__criticality._const_tab = ____CellReplacingInfo_iE_Extensions__item__criticality_tab
    ___CellReplacingInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CellReplacingInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CellReplacingInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CellReplacingInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CellReplacingInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellReplacingInfo_iE_Extensions__item__extensionValue._const_tab = ____CellReplacingInfo_iE_Extensions__item__extensionValue_tab
    ___CellReplacingInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellReplacingInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CellReplacingInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CellReplacingInfo_iE_Extensions__item__id),
        ('criticality', ___CellReplacingInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___CellReplacingInfo_iE_Extensions__item__extensionValue),
        ])
    __CellReplacingInfo_iE_Extensions__item_._ext = None
    _CellReplacingInfo_iE_Extensions._cont = __CellReplacingInfo_iE_Extensions__item_
    _CellReplacingInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellReplacingInfo._cont = ASN1Dict([
        ('replacingCellsList', _CellReplacingInfo_replacingCellsList),
        ('iE-Extensions', _CellReplacingInfo_iE_Extensions),
        ])
    CellReplacingInfo._ext = []
    
    #-----< CellReplacingInfo-ExtIEs >-----#
    CellReplacingInfo_ExtIEs = CLASS(name='CellReplacingInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    CellReplacingInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellReportingIndicator >-----#
    CellReportingIndicator = ENUM(name='CellReportingIndicator', mode=MODE_TYPE)
    CellReportingIndicator._cont = ASN1Dict([('stop-request', 0)])
    CellReportingIndicator._ext = []
    
    #-----< Cell-Size >-----#
    Cell_Size = ENUM(name='Cell-Size', mode=MODE_TYPE)
    Cell_Size._cont = ASN1Dict([('verysmall', 0), ('small', 1), ('medium', 2), ('large', 3)])
    Cell_Size._ext = []
    
    #-----< CellType >-----#
    CellType = SEQ(name='CellType', mode=MODE_TYPE)
    _CellType_cell_Size = ENUM(name='cell-Size', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'Cell-Size')))
    _CellType_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellType_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___CellType_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____CellType_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CellType_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellType_iE_Extensions__item__id._const_tab = ____CellType_iE_Extensions__item__id_tab
    ___CellType_iE_Extensions__item__id._const_tab_at = None
    ___CellType_iE_Extensions__item__id._const_tab_id = 'id'
    ___CellType_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CellType_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CellType_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellType_iE_Extensions__item__criticality._const_tab = ____CellType_iE_Extensions__item__criticality_tab
    ___CellType_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CellType_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CellType_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CellType_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CellType_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellType_iE_Extensions__item__extensionValue._const_tab = ____CellType_iE_Extensions__item__extensionValue_tab
    ___CellType_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellType_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CellType_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CellType_iE_Extensions__item__id),
        ('criticality', ___CellType_iE_Extensions__item__criticality),
        ('extensionValue', ___CellType_iE_Extensions__item__extensionValue),
        ])
    __CellType_iE_Extensions__item_._ext = None
    _CellType_iE_Extensions._cont = __CellType_iE_Extensions__item_
    _CellType_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellType._cont = ASN1Dict([
        ('cell-Size', _CellType_cell_Size),
        ('iE-Extensions', _CellType_iE_Extensions),
        ])
    CellType._ext = []
    
    #-----< CellType-ExtIEs >-----#
    CellType_ExtIEs = CLASS(name='CellType-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    CellType_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CPACcandidatePSCells-list >-----#
    CPACcandidatePSCells_list = SEQ_OF(name='CPACcandidatePSCells-list', mode=MODE_TYPE)
    _CPACcandidatePSCells_list__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CPACcandidatePSCells-item')))
    CPACcandidatePSCells_list._cont = _CPACcandidatePSCells_list__item_
    CPACcandidatePSCells_list._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< CPACcandidatePSCells-item >-----#
    CPACcandidatePSCells_item = SEQ(name='CPACcandidatePSCells-item', mode=MODE_TYPE)
    _CPACcandidatePSCells_item_pscell_id = SEQ(name='pscell-id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'NRCGI')))
    _CPACcandidatePSCells_item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CPACcandidatePSCells_item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___CPACcandidatePSCells_item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____CPACcandidatePSCells_item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CPACcandidatePSCells_item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CPACcandidatePSCells_item_iE_Extensions__item__id._const_tab = ____CPACcandidatePSCells_item_iE_Extensions__item__id_tab
    ___CPACcandidatePSCells_item_iE_Extensions__item__id._const_tab_at = None
    ___CPACcandidatePSCells_item_iE_Extensions__item__id._const_tab_id = 'id'
    ___CPACcandidatePSCells_item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CPACcandidatePSCells_item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CPACcandidatePSCells_item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CPACcandidatePSCells_item_iE_Extensions__item__criticality._const_tab = ____CPACcandidatePSCells_item_iE_Extensions__item__criticality_tab
    ___CPACcandidatePSCells_item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CPACcandidatePSCells_item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CPACcandidatePSCells_item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CPACcandidatePSCells_item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CPACcandidatePSCells_item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CPACcandidatePSCells_item_iE_Extensions__item__extensionValue._const_tab = ____CPACcandidatePSCells_item_iE_Extensions__item__extensionValue_tab
    ___CPACcandidatePSCells_item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CPACcandidatePSCells_item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CPACcandidatePSCells_item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CPACcandidatePSCells_item_iE_Extensions__item__id),
        ('criticality', ___CPACcandidatePSCells_item_iE_Extensions__item__criticality),
        ('extensionValue', ___CPACcandidatePSCells_item_iE_Extensions__item__extensionValue),
        ])
    __CPACcandidatePSCells_item_iE_Extensions__item_._ext = None
    _CPACcandidatePSCells_item_iE_Extensions._cont = __CPACcandidatePSCells_item_iE_Extensions__item_
    _CPACcandidatePSCells_item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CPACcandidatePSCells_item._cont = ASN1Dict([
        ('pscell-id', _CPACcandidatePSCells_item_pscell_id),
        ('iE-Extensions', _CPACcandidatePSCells_item_iE_Extensions),
        ])
    CPACcandidatePSCells_item._ext = []
    
    #-----< CPACcandidatePSCells-item-ExtIEs >-----#
    CPACcandidatePSCells_item_ExtIEs = CLASS(name='CPACcandidatePSCells-item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    CPACcandidatePSCells_item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CPCindicator >-----#
    CPCindicator = ENUM(name='CPCindicator', mode=MODE_TYPE)
    CPCindicator._cont = ASN1Dict([('cpc-initiation', 0), ('cpc-modification', 1), ('cpc-cancel', 2)])
    CPCindicator._ext = []
    
    #-----< CPCdataforwarding >-----#
    CPCdataforwarding = ENUM(name='CPCdataforwarding', mode=MODE_TYPE)
    CPCdataforwarding._cont = ASN1Dict([('cpc-triggered', 0), ('early-data-transmission-stop', 1), ('coordination-only', 2)])
    CPCdataforwarding._ext = ['coordination-only']
    
    #-----< CPAinformation-REQ >-----#
    CPAinformation_REQ = SEQ(name='CPAinformation-REQ', mode=MODE_TYPE)
    _CPAinformation_REQ_max_no_of_pscells = INT(name='max-no-of-pscells', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CPAinformation_REQ_max_no_of_pscells._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    _CPAinformation_REQ_estimatedArrivalProbability = INT(name='estimatedArrivalProbability', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CHO-Probability')), opt=True)
    _CPAinformation_REQ_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CPAinformation_REQ_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___CPAinformation_REQ_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____CPAinformation_REQ_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CPAinformation_REQ_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CPAinformation_REQ_iE_Extensions__item__id._const_tab = ____CPAinformation_REQ_iE_Extensions__item__id_tab
    ___CPAinformation_REQ_iE_Extensions__item__id._const_tab_at = None
    ___CPAinformation_REQ_iE_Extensions__item__id._const_tab_id = 'id'
    ___CPAinformation_REQ_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CPAinformation_REQ_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CPAinformation_REQ_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CPAinformation_REQ_iE_Extensions__item__criticality._const_tab = ____CPAinformation_REQ_iE_Extensions__item__criticality_tab
    ___CPAinformation_REQ_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CPAinformation_REQ_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CPAinformation_REQ_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CPAinformation_REQ_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CPAinformation_REQ_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CPAinformation_REQ_iE_Extensions__item__extensionValue._const_tab = ____CPAinformation_REQ_iE_Extensions__item__extensionValue_tab
    ___CPAinformation_REQ_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CPAinformation_REQ_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CPAinformation_REQ_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CPAinformation_REQ_iE_Extensions__item__id),
        ('criticality', ___CPAinformation_REQ_iE_Extensions__item__criticality),
        ('extensionValue', ___CPAinformation_REQ_iE_Extensions__item__extensionValue),
        ])
    __CPAinformation_REQ_iE_Extensions__item_._ext = None
    _CPAinformation_REQ_iE_Extensions._cont = __CPAinformation_REQ_iE_Extensions__item_
    _CPAinformation_REQ_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CPAinformation_REQ._cont = ASN1Dict([
        ('max-no-of-pscells', _CPAinformation_REQ_max_no_of_pscells),
        ('estimatedArrivalProbability', _CPAinformation_REQ_estimatedArrivalProbability),
        ('iE-Extensions', _CPAinformation_REQ_iE_Extensions),
        ])
    CPAinformation_REQ._ext = []
    
    #-----< CPAinformation-REQ-ExtIEs >-----#
    CPAinformation_REQ_ExtIEs = CLASS(name='CPAinformation-REQ-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    CPAinformation_REQ_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CPAinformation-REQ-ACK >-----#
    CPAinformation_REQ_ACK = SEQ(name='CPAinformation-REQ-ACK', mode=MODE_TYPE)
    _CPAinformation_REQ_ACK_candidate_pscells = SEQ_OF(name='candidate-pscells', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CPACcandidatePSCells-list')))
    _CPAinformation_REQ_ACK_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CPAinformation_REQ_ACK_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___CPAinformation_REQ_ACK_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____CPAinformation_REQ_ACK_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CPAinformation_REQ_ACK_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CPAinformation_REQ_ACK_iE_Extensions__item__id._const_tab = ____CPAinformation_REQ_ACK_iE_Extensions__item__id_tab
    ___CPAinformation_REQ_ACK_iE_Extensions__item__id._const_tab_at = None
    ___CPAinformation_REQ_ACK_iE_Extensions__item__id._const_tab_id = 'id'
    ___CPAinformation_REQ_ACK_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CPAinformation_REQ_ACK_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CPAinformation_REQ_ACK_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CPAinformation_REQ_ACK_iE_Extensions__item__criticality._const_tab = ____CPAinformation_REQ_ACK_iE_Extensions__item__criticality_tab
    ___CPAinformation_REQ_ACK_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CPAinformation_REQ_ACK_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CPAinformation_REQ_ACK_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CPAinformation_REQ_ACK_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CPAinformation_REQ_ACK_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CPAinformation_REQ_ACK_iE_Extensions__item__extensionValue._const_tab = ____CPAinformation_REQ_ACK_iE_Extensions__item__extensionValue_tab
    ___CPAinformation_REQ_ACK_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CPAinformation_REQ_ACK_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CPAinformation_REQ_ACK_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CPAinformation_REQ_ACK_iE_Extensions__item__id),
        ('criticality', ___CPAinformation_REQ_ACK_iE_Extensions__item__criticality),
        ('extensionValue', ___CPAinformation_REQ_ACK_iE_Extensions__item__extensionValue),
        ])
    __CPAinformation_REQ_ACK_iE_Extensions__item_._ext = None
    _CPAinformation_REQ_ACK_iE_Extensions._cont = __CPAinformation_REQ_ACK_iE_Extensions__item_
    _CPAinformation_REQ_ACK_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CPAinformation_REQ_ACK._cont = ASN1Dict([
        ('candidate-pscells', _CPAinformation_REQ_ACK_candidate_pscells),
        ('iE-Extensions', _CPAinformation_REQ_ACK_iE_Extensions),
        ])
    CPAinformation_REQ_ACK._ext = []
    
    #-----< CPAinformation-REQ-ACK-ExtIEs >-----#
    CPAinformation_REQ_ACK_ExtIEs = CLASS(name='CPAinformation-REQ-ACK-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    CPAinformation_REQ_ACK_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CPCinformation-REQD >-----#
    CPCinformation_REQD = SEQ(name='CPCinformation-REQD', mode=MODE_TYPE)
    _CPCinformation_REQD_cpc_target_sgnb_list = SEQ_OF(name='cpc-target-sgnb-list', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CPC-target-SgNB-reqd-list')))
    _CPCinformation_REQD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CPCinformation_REQD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___CPCinformation_REQD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____CPCinformation_REQD_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CPCinformation_REQD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CPCinformation_REQD_iE_Extensions__item__id._const_tab = ____CPCinformation_REQD_iE_Extensions__item__id_tab
    ___CPCinformation_REQD_iE_Extensions__item__id._const_tab_at = None
    ___CPCinformation_REQD_iE_Extensions__item__id._const_tab_id = 'id'
    ___CPCinformation_REQD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CPCinformation_REQD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CPCinformation_REQD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CPCinformation_REQD_iE_Extensions__item__criticality._const_tab = ____CPCinformation_REQD_iE_Extensions__item__criticality_tab
    ___CPCinformation_REQD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CPCinformation_REQD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CPCinformation_REQD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CPCinformation_REQD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CPCinformation_REQD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CPCinformation_REQD_iE_Extensions__item__extensionValue._const_tab = ____CPCinformation_REQD_iE_Extensions__item__extensionValue_tab
    ___CPCinformation_REQD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CPCinformation_REQD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CPCinformation_REQD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CPCinformation_REQD_iE_Extensions__item__id),
        ('criticality', ___CPCinformation_REQD_iE_Extensions__item__criticality),
        ('extensionValue', ___CPCinformation_REQD_iE_Extensions__item__extensionValue),
        ])
    __CPCinformation_REQD_iE_Extensions__item_._ext = None
    _CPCinformation_REQD_iE_Extensions._cont = __CPCinformation_REQD_iE_Extensions__item_
    _CPCinformation_REQD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CPCinformation_REQD._cont = ASN1Dict([
        ('cpc-target-sgnb-list', _CPCinformation_REQD_cpc_target_sgnb_list),
        ('iE-Extensions', _CPCinformation_REQD_iE_Extensions),
        ])
    CPCinformation_REQD._ext = []
    
    #-----< CPCinformation-REQD-ExtIEs >-----#
    CPCinformation_REQD_ExtIEs = CLASS(name='CPCinformation-REQD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    CPCinformation_REQD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CPC-target-SgNB-reqd-list >-----#
    CPC_target_SgNB_reqd_list = SEQ_OF(name='CPC-target-SgNB-reqd-list', mode=MODE_TYPE)
    _CPC_target_SgNB_reqd_list__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CPC-target-SgNB-reqd-item')))
    CPC_target_SgNB_reqd_list._cont = _CPC_target_SgNB_reqd_list__item_
    CPC_target_SgNB_reqd_list._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< CPC-target-SgNB-reqd-item >-----#
    CPC_target_SgNB_reqd_item = SEQ(name='CPC-target-SgNB-reqd-item', mode=MODE_TYPE)
    _CPC_target_SgNB_reqd_item_target_SgNB_ID = SEQ(name='target-SgNB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GlobalGNB-ID')))
    _CPC_target_SgNB_reqd_item_cpc_indicator = ENUM(name='cpc-indicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CPCindicator')))
    _CPC_target_SgNB_reqd_item_max_no_of_pscells = INT(name='max-no-of-pscells', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CPC_target_SgNB_reqd_item_max_no_of_pscells._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    _CPC_target_SgNB_reqd_item_estimatedArrivalProbability = INT(name='estimatedArrivalProbability', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CHO-Probability')), opt=True)
    _CPC_target_SgNB_reqd_item_sgNBtoMeNBContainer = OCT_STR(name='sgNBtoMeNBContainer', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'SgNBtoMeNBContainer')))
    _CPC_target_SgNB_reqd_item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CPC_target_SgNB_reqd_item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___CPC_target_SgNB_reqd_item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____CPC_target_SgNB_reqd_item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CPC_target_SgNB_reqd_item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CPC_target_SgNB_reqd_item_iE_Extensions__item__id._const_tab = ____CPC_target_SgNB_reqd_item_iE_Extensions__item__id_tab
    ___CPC_target_SgNB_reqd_item_iE_Extensions__item__id._const_tab_at = None
    ___CPC_target_SgNB_reqd_item_iE_Extensions__item__id._const_tab_id = 'id'
    ___CPC_target_SgNB_reqd_item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CPC_target_SgNB_reqd_item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CPC_target_SgNB_reqd_item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CPC_target_SgNB_reqd_item_iE_Extensions__item__criticality._const_tab = ____CPC_target_SgNB_reqd_item_iE_Extensions__item__criticality_tab
    ___CPC_target_SgNB_reqd_item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CPC_target_SgNB_reqd_item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CPC_target_SgNB_reqd_item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CPC_target_SgNB_reqd_item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CPC_target_SgNB_reqd_item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CPC_target_SgNB_reqd_item_iE_Extensions__item__extensionValue._const_tab = ____CPC_target_SgNB_reqd_item_iE_Extensions__item__extensionValue_tab
    ___CPC_target_SgNB_reqd_item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CPC_target_SgNB_reqd_item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CPC_target_SgNB_reqd_item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CPC_target_SgNB_reqd_item_iE_Extensions__item__id),
        ('criticality', ___CPC_target_SgNB_reqd_item_iE_Extensions__item__criticality),
        ('extensionValue', ___CPC_target_SgNB_reqd_item_iE_Extensions__item__extensionValue),
        ])
    __CPC_target_SgNB_reqd_item_iE_Extensions__item_._ext = None
    _CPC_target_SgNB_reqd_item_iE_Extensions._cont = __CPC_target_SgNB_reqd_item_iE_Extensions__item_
    _CPC_target_SgNB_reqd_item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CPC_target_SgNB_reqd_item._cont = ASN1Dict([
        ('target-SgNB-ID', _CPC_target_SgNB_reqd_item_target_SgNB_ID),
        ('cpc-indicator', _CPC_target_SgNB_reqd_item_cpc_indicator),
        ('max-no-of-pscells', _CPC_target_SgNB_reqd_item_max_no_of_pscells),
        ('estimatedArrivalProbability', _CPC_target_SgNB_reqd_item_estimatedArrivalProbability),
        ('sgNBtoMeNBContainer', _CPC_target_SgNB_reqd_item_sgNBtoMeNBContainer),
        ('iE-Extensions', _CPC_target_SgNB_reqd_item_iE_Extensions),
        ])
    CPC_target_SgNB_reqd_item._ext = []
    
    #-----< CPC-target-SgNB-reqd-item-ExtIEs >-----#
    CPC_target_SgNB_reqd_item_ExtIEs = CLASS(name='CPC-target-SgNB-reqd-item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    CPC_target_SgNB_reqd_item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CPCinformation-CONF >-----#
    CPCinformation_CONF = SEQ(name='CPCinformation-CONF', mode=MODE_TYPE)
    _CPCinformation_CONF_cpc_target_sgnb_list = SEQ_OF(name='cpc-target-sgnb-list', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CPC-target-SgNB-conf-list')))
    _CPCinformation_CONF_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CPCinformation_CONF_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___CPCinformation_CONF_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____CPCinformation_CONF_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CPCinformation_CONF_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CPCinformation_CONF_iE_Extensions__item__id._const_tab = ____CPCinformation_CONF_iE_Extensions__item__id_tab
    ___CPCinformation_CONF_iE_Extensions__item__id._const_tab_at = None
    ___CPCinformation_CONF_iE_Extensions__item__id._const_tab_id = 'id'
    ___CPCinformation_CONF_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CPCinformation_CONF_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CPCinformation_CONF_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CPCinformation_CONF_iE_Extensions__item__criticality._const_tab = ____CPCinformation_CONF_iE_Extensions__item__criticality_tab
    ___CPCinformation_CONF_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CPCinformation_CONF_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CPCinformation_CONF_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CPCinformation_CONF_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CPCinformation_CONF_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CPCinformation_CONF_iE_Extensions__item__extensionValue._const_tab = ____CPCinformation_CONF_iE_Extensions__item__extensionValue_tab
    ___CPCinformation_CONF_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CPCinformation_CONF_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CPCinformation_CONF_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CPCinformation_CONF_iE_Extensions__item__id),
        ('criticality', ___CPCinformation_CONF_iE_Extensions__item__criticality),
        ('extensionValue', ___CPCinformation_CONF_iE_Extensions__item__extensionValue),
        ])
    __CPCinformation_CONF_iE_Extensions__item_._ext = None
    _CPCinformation_CONF_iE_Extensions._cont = __CPCinformation_CONF_iE_Extensions__item_
    _CPCinformation_CONF_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CPCinformation_CONF._cont = ASN1Dict([
        ('cpc-target-sgnb-list', _CPCinformation_CONF_cpc_target_sgnb_list),
        ('iE-Extensions', _CPCinformation_CONF_iE_Extensions),
        ])
    CPCinformation_CONF._ext = []
    
    #-----< CPCinformation-CONF-ExtIEs >-----#
    CPCinformation_CONF_ExtIEs = CLASS(name='CPCinformation-CONF-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    CPCinformation_CONF_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CPC-target-SgNB-conf-list >-----#
    CPC_target_SgNB_conf_list = SEQ_OF(name='CPC-target-SgNB-conf-list', mode=MODE_TYPE)
    _CPC_target_SgNB_conf_list__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CPC-target-SgNB-conf-item')))
    CPC_target_SgNB_conf_list._cont = _CPC_target_SgNB_conf_list__item_
    CPC_target_SgNB_conf_list._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< CPC-target-SgNB-conf-item >-----#
    CPC_target_SgNB_conf_item = SEQ(name='CPC-target-SgNB-conf-item', mode=MODE_TYPE)
    _CPC_target_SgNB_conf_item_target_SgNB_ID = SEQ(name='target-SgNB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GlobalGNB-ID')))
    _CPC_target_SgNB_conf_item_candidate_pscells = SEQ_OF(name='candidate-pscells', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CPACcandidatePSCells-list')))
    _CPC_target_SgNB_conf_item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CPC_target_SgNB_conf_item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___CPC_target_SgNB_conf_item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____CPC_target_SgNB_conf_item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CPC_target_SgNB_conf_item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CPC_target_SgNB_conf_item_iE_Extensions__item__id._const_tab = ____CPC_target_SgNB_conf_item_iE_Extensions__item__id_tab
    ___CPC_target_SgNB_conf_item_iE_Extensions__item__id._const_tab_at = None
    ___CPC_target_SgNB_conf_item_iE_Extensions__item__id._const_tab_id = 'id'
    ___CPC_target_SgNB_conf_item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CPC_target_SgNB_conf_item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CPC_target_SgNB_conf_item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CPC_target_SgNB_conf_item_iE_Extensions__item__criticality._const_tab = ____CPC_target_SgNB_conf_item_iE_Extensions__item__criticality_tab
    ___CPC_target_SgNB_conf_item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CPC_target_SgNB_conf_item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CPC_target_SgNB_conf_item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CPC_target_SgNB_conf_item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CPC_target_SgNB_conf_item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CPC_target_SgNB_conf_item_iE_Extensions__item__extensionValue._const_tab = ____CPC_target_SgNB_conf_item_iE_Extensions__item__extensionValue_tab
    ___CPC_target_SgNB_conf_item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CPC_target_SgNB_conf_item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CPC_target_SgNB_conf_item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CPC_target_SgNB_conf_item_iE_Extensions__item__id),
        ('criticality', ___CPC_target_SgNB_conf_item_iE_Extensions__item__criticality),
        ('extensionValue', ___CPC_target_SgNB_conf_item_iE_Extensions__item__extensionValue),
        ])
    __CPC_target_SgNB_conf_item_iE_Extensions__item_._ext = None
    _CPC_target_SgNB_conf_item_iE_Extensions._cont = __CPC_target_SgNB_conf_item_iE_Extensions__item_
    _CPC_target_SgNB_conf_item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CPC_target_SgNB_conf_item._cont = ASN1Dict([
        ('target-SgNB-ID', _CPC_target_SgNB_conf_item_target_SgNB_ID),
        ('candidate-pscells', _CPC_target_SgNB_conf_item_candidate_pscells),
        ('iE-Extensions', _CPC_target_SgNB_conf_item_iE_Extensions),
        ])
    CPC_target_SgNB_conf_item._ext = []
    
    #-----< CPC-target-SgNB-conf-item-ExtIEs >-----#
    CPC_target_SgNB_conf_item_ExtIEs = CLASS(name='CPC-target-SgNB-conf-item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    CPC_target_SgNB_conf_item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CPCinformation-NOTIFY >-----#
    CPCinformation_NOTIFY = SEQ(name='CPCinformation-NOTIFY', mode=MODE_TYPE)
    _CPCinformation_NOTIFY_cpc_indicator = ENUM(name='cpc-indicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CPCdataforwarding')))
    _CPCinformation_NOTIFY_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CPCinformation_NOTIFY_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___CPCinformation_NOTIFY_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____CPCinformation_NOTIFY_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CPCinformation_NOTIFY_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CPCinformation_NOTIFY_iE_Extensions__item__id._const_tab = ____CPCinformation_NOTIFY_iE_Extensions__item__id_tab
    ___CPCinformation_NOTIFY_iE_Extensions__item__id._const_tab_at = None
    ___CPCinformation_NOTIFY_iE_Extensions__item__id._const_tab_id = 'id'
    ___CPCinformation_NOTIFY_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CPCinformation_NOTIFY_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CPCinformation_NOTIFY_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CPCinformation_NOTIFY_iE_Extensions__item__criticality._const_tab = ____CPCinformation_NOTIFY_iE_Extensions__item__criticality_tab
    ___CPCinformation_NOTIFY_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CPCinformation_NOTIFY_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CPCinformation_NOTIFY_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CPCinformation_NOTIFY_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CPCinformation_NOTIFY_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CPCinformation_NOTIFY_iE_Extensions__item__extensionValue._const_tab = ____CPCinformation_NOTIFY_iE_Extensions__item__extensionValue_tab
    ___CPCinformation_NOTIFY_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CPCinformation_NOTIFY_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CPCinformation_NOTIFY_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CPCinformation_NOTIFY_iE_Extensions__item__id),
        ('criticality', ___CPCinformation_NOTIFY_iE_Extensions__item__criticality),
        ('extensionValue', ___CPCinformation_NOTIFY_iE_Extensions__item__extensionValue),
        ])
    __CPCinformation_NOTIFY_iE_Extensions__item_._ext = None
    _CPCinformation_NOTIFY_iE_Extensions._cont = __CPCinformation_NOTIFY_iE_Extensions__item_
    _CPCinformation_NOTIFY_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CPCinformation_NOTIFY._cont = ASN1Dict([
        ('cpc-indicator', _CPCinformation_NOTIFY_cpc_indicator),
        ('iE-Extensions', _CPCinformation_NOTIFY_iE_Extensions),
        ])
    CPCinformation_NOTIFY._ext = []
    
    #-----< CPCinformation-NOTIFY-ExtIEs >-----#
    CPCinformation_NOTIFY_ExtIEs = CLASS(name='CPCinformation-NOTIFY-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    CPCinformation_NOTIFY_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CPAinformation-MOD >-----#
    CPAinformation_MOD = SEQ(name='CPAinformation-MOD', mode=MODE_TYPE)
    _CPAinformation_MOD_max_no_of_pscells = INT(name='max-no-of-pscells', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CPAinformation_MOD_max_no_of_pscells._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    _CPAinformation_MOD_estimatedArrivalProbability = INT(name='estimatedArrivalProbability', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CHO-Probability')), opt=True)
    _CPAinformation_MOD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CPAinformation_MOD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___CPAinformation_MOD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____CPAinformation_MOD_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CPAinformation_MOD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CPAinformation_MOD_iE_Extensions__item__id._const_tab = ____CPAinformation_MOD_iE_Extensions__item__id_tab
    ___CPAinformation_MOD_iE_Extensions__item__id._const_tab_at = None
    ___CPAinformation_MOD_iE_Extensions__item__id._const_tab_id = 'id'
    ___CPAinformation_MOD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CPAinformation_MOD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CPAinformation_MOD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CPAinformation_MOD_iE_Extensions__item__criticality._const_tab = ____CPAinformation_MOD_iE_Extensions__item__criticality_tab
    ___CPAinformation_MOD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CPAinformation_MOD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CPAinformation_MOD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CPAinformation_MOD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CPAinformation_MOD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CPAinformation_MOD_iE_Extensions__item__extensionValue._const_tab = ____CPAinformation_MOD_iE_Extensions__item__extensionValue_tab
    ___CPAinformation_MOD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CPAinformation_MOD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CPAinformation_MOD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CPAinformation_MOD_iE_Extensions__item__id),
        ('criticality', ___CPAinformation_MOD_iE_Extensions__item__criticality),
        ('extensionValue', ___CPAinformation_MOD_iE_Extensions__item__extensionValue),
        ])
    __CPAinformation_MOD_iE_Extensions__item_._ext = None
    _CPAinformation_MOD_iE_Extensions._cont = __CPAinformation_MOD_iE_Extensions__item_
    _CPAinformation_MOD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CPAinformation_MOD._cont = ASN1Dict([
        ('max-no-of-pscells', _CPAinformation_MOD_max_no_of_pscells),
        ('estimatedArrivalProbability', _CPAinformation_MOD_estimatedArrivalProbability),
        ('iE-Extensions', _CPAinformation_MOD_iE_Extensions),
        ])
    CPAinformation_MOD._ext = []
    
    #-----< CPAinformation-MOD-ExtIEs >-----#
    CPAinformation_MOD_ExtIEs = CLASS(name='CPAinformation-MOD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    CPAinformation_MOD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CPCupdate-MOD >-----#
    CPCupdate_MOD = SEQ(name='CPCupdate-MOD', mode=MODE_TYPE)
    _CPCupdate_MOD_cpc_target_sgnb_list = SEQ_OF(name='cpc-target-sgnb-list', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CPC-target-SgNB-mod-list')))
    _CPCupdate_MOD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CPCupdate_MOD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___CPCupdate_MOD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____CPCupdate_MOD_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CPCupdate_MOD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CPCupdate_MOD_iE_Extensions__item__id._const_tab = ____CPCupdate_MOD_iE_Extensions__item__id_tab
    ___CPCupdate_MOD_iE_Extensions__item__id._const_tab_at = None
    ___CPCupdate_MOD_iE_Extensions__item__id._const_tab_id = 'id'
    ___CPCupdate_MOD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CPCupdate_MOD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CPCupdate_MOD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CPCupdate_MOD_iE_Extensions__item__criticality._const_tab = ____CPCupdate_MOD_iE_Extensions__item__criticality_tab
    ___CPCupdate_MOD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CPCupdate_MOD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CPCupdate_MOD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CPCupdate_MOD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CPCupdate_MOD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CPCupdate_MOD_iE_Extensions__item__extensionValue._const_tab = ____CPCupdate_MOD_iE_Extensions__item__extensionValue_tab
    ___CPCupdate_MOD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CPCupdate_MOD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CPCupdate_MOD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CPCupdate_MOD_iE_Extensions__item__id),
        ('criticality', ___CPCupdate_MOD_iE_Extensions__item__criticality),
        ('extensionValue', ___CPCupdate_MOD_iE_Extensions__item__extensionValue),
        ])
    __CPCupdate_MOD_iE_Extensions__item_._ext = None
    _CPCupdate_MOD_iE_Extensions._cont = __CPCupdate_MOD_iE_Extensions__item_
    _CPCupdate_MOD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CPCupdate_MOD._cont = ASN1Dict([
        ('cpc-target-sgnb-list', _CPCupdate_MOD_cpc_target_sgnb_list),
        ('iE-Extensions', _CPCupdate_MOD_iE_Extensions),
        ])
    CPCupdate_MOD._ext = []
    
    #-----< CPCupdate-MOD-ExtIEs >-----#
    CPCupdate_MOD_ExtIEs = CLASS(name='CPCupdate-MOD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    CPCupdate_MOD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CPC-target-SgNB-mod-list >-----#
    CPC_target_SgNB_mod_list = SEQ_OF(name='CPC-target-SgNB-mod-list', mode=MODE_TYPE)
    _CPC_target_SgNB_mod_list__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CPC-target-SgNB-mod-item')))
    CPC_target_SgNB_mod_list._cont = _CPC_target_SgNB_mod_list__item_
    CPC_target_SgNB_mod_list._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< CPC-target-SgNB-mod-item >-----#
    CPC_target_SgNB_mod_item = SEQ(name='CPC-target-SgNB-mod-item', mode=MODE_TYPE)
    _CPC_target_SgNB_mod_item_target_SgNB_ID = SEQ(name='target-SgNB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GlobalGNB-ID')))
    _CPC_target_SgNB_mod_item_candidate_pscells = SEQ_OF(name='candidate-pscells', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CPACcandidatePSCells-list')))
    _CPC_target_SgNB_mod_item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CPC_target_SgNB_mod_item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___CPC_target_SgNB_mod_item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____CPC_target_SgNB_mod_item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CPC_target_SgNB_mod_item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CPC_target_SgNB_mod_item_iE_Extensions__item__id._const_tab = ____CPC_target_SgNB_mod_item_iE_Extensions__item__id_tab
    ___CPC_target_SgNB_mod_item_iE_Extensions__item__id._const_tab_at = None
    ___CPC_target_SgNB_mod_item_iE_Extensions__item__id._const_tab_id = 'id'
    ___CPC_target_SgNB_mod_item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CPC_target_SgNB_mod_item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CPC_target_SgNB_mod_item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CPC_target_SgNB_mod_item_iE_Extensions__item__criticality._const_tab = ____CPC_target_SgNB_mod_item_iE_Extensions__item__criticality_tab
    ___CPC_target_SgNB_mod_item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CPC_target_SgNB_mod_item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CPC_target_SgNB_mod_item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CPC_target_SgNB_mod_item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CPC_target_SgNB_mod_item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CPC_target_SgNB_mod_item_iE_Extensions__item__extensionValue._const_tab = ____CPC_target_SgNB_mod_item_iE_Extensions__item__extensionValue_tab
    ___CPC_target_SgNB_mod_item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CPC_target_SgNB_mod_item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CPC_target_SgNB_mod_item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CPC_target_SgNB_mod_item_iE_Extensions__item__id),
        ('criticality', ___CPC_target_SgNB_mod_item_iE_Extensions__item__criticality),
        ('extensionValue', ___CPC_target_SgNB_mod_item_iE_Extensions__item__extensionValue),
        ])
    __CPC_target_SgNB_mod_item_iE_Extensions__item_._ext = None
    _CPC_target_SgNB_mod_item_iE_Extensions._cont = __CPC_target_SgNB_mod_item_iE_Extensions__item_
    _CPC_target_SgNB_mod_item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CPC_target_SgNB_mod_item._cont = ASN1Dict([
        ('target-SgNB-ID', _CPC_target_SgNB_mod_item_target_SgNB_ID),
        ('candidate-pscells', _CPC_target_SgNB_mod_item_candidate_pscells),
        ('iE-Extensions', _CPC_target_SgNB_mod_item_iE_Extensions),
        ])
    CPC_target_SgNB_mod_item._ext = []
    
    #-----< CPC-target-SgNB-mod-item-ExtIEs >-----#
    CPC_target_SgNB_mod_item_ExtIEs = CLASS(name='CPC-target-SgNB-mod-item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    CPC_target_SgNB_mod_item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CPAinformation-MOD-ACK >-----#
    CPAinformation_MOD_ACK = SEQ(name='CPAinformation-MOD-ACK', mode=MODE_TYPE)
    _CPAinformation_MOD_ACK_candidate_pscells = SEQ_OF(name='candidate-pscells', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CPACcandidatePSCells-list')))
    _CPAinformation_MOD_ACK_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CPAinformation_MOD_ACK_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___CPAinformation_MOD_ACK_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____CPAinformation_MOD_ACK_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CPAinformation_MOD_ACK_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CPAinformation_MOD_ACK_iE_Extensions__item__id._const_tab = ____CPAinformation_MOD_ACK_iE_Extensions__item__id_tab
    ___CPAinformation_MOD_ACK_iE_Extensions__item__id._const_tab_at = None
    ___CPAinformation_MOD_ACK_iE_Extensions__item__id._const_tab_id = 'id'
    ___CPAinformation_MOD_ACK_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CPAinformation_MOD_ACK_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CPAinformation_MOD_ACK_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CPAinformation_MOD_ACK_iE_Extensions__item__criticality._const_tab = ____CPAinformation_MOD_ACK_iE_Extensions__item__criticality_tab
    ___CPAinformation_MOD_ACK_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CPAinformation_MOD_ACK_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CPAinformation_MOD_ACK_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CPAinformation_MOD_ACK_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CPAinformation_MOD_ACK_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CPAinformation_MOD_ACK_iE_Extensions__item__extensionValue._const_tab = ____CPAinformation_MOD_ACK_iE_Extensions__item__extensionValue_tab
    ___CPAinformation_MOD_ACK_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CPAinformation_MOD_ACK_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CPAinformation_MOD_ACK_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CPAinformation_MOD_ACK_iE_Extensions__item__id),
        ('criticality', ___CPAinformation_MOD_ACK_iE_Extensions__item__criticality),
        ('extensionValue', ___CPAinformation_MOD_ACK_iE_Extensions__item__extensionValue),
        ])
    __CPAinformation_MOD_ACK_iE_Extensions__item_._ext = None
    _CPAinformation_MOD_ACK_iE_Extensions._cont = __CPAinformation_MOD_ACK_iE_Extensions__item_
    _CPAinformation_MOD_ACK_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CPAinformation_MOD_ACK._cont = ASN1Dict([
        ('candidate-pscells', _CPAinformation_MOD_ACK_candidate_pscells),
        ('iE-Extensions', _CPAinformation_MOD_ACK_iE_Extensions),
        ])
    CPAinformation_MOD_ACK._ext = []
    
    #-----< CPAinformation-MOD-ACK-ExtIEs >-----#
    CPAinformation_MOD_ACK_ExtIEs = CLASS(name='CPAinformation-MOD-ACK-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    CPAinformation_MOD_ACK_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CPACinformation-REQD >-----#
    CPACinformation_REQD = SEQ(name='CPACinformation-REQD', mode=MODE_TYPE)
    _CPACinformation_REQD_candidate_pscells = SEQ_OF(name='candidate-pscells', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CPACcandidatePSCells-list')))
    _CPACinformation_REQD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CPACinformation_REQD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___CPACinformation_REQD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____CPACinformation_REQD_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CPACinformation_REQD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CPACinformation_REQD_iE_Extensions__item__id._const_tab = ____CPACinformation_REQD_iE_Extensions__item__id_tab
    ___CPACinformation_REQD_iE_Extensions__item__id._const_tab_at = None
    ___CPACinformation_REQD_iE_Extensions__item__id._const_tab_id = 'id'
    ___CPACinformation_REQD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CPACinformation_REQD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CPACinformation_REQD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CPACinformation_REQD_iE_Extensions__item__criticality._const_tab = ____CPACinformation_REQD_iE_Extensions__item__criticality_tab
    ___CPACinformation_REQD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CPACinformation_REQD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CPACinformation_REQD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CPACinformation_REQD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CPACinformation_REQD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CPACinformation_REQD_iE_Extensions__item__extensionValue._const_tab = ____CPACinformation_REQD_iE_Extensions__item__extensionValue_tab
    ___CPACinformation_REQD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CPACinformation_REQD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CPACinformation_REQD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CPACinformation_REQD_iE_Extensions__item__id),
        ('criticality', ___CPACinformation_REQD_iE_Extensions__item__criticality),
        ('extensionValue', ___CPACinformation_REQD_iE_Extensions__item__extensionValue),
        ])
    __CPACinformation_REQD_iE_Extensions__item_._ext = None
    _CPACinformation_REQD_iE_Extensions._cont = __CPACinformation_REQD_iE_Extensions__item_
    _CPACinformation_REQD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CPACinformation_REQD._cont = ASN1Dict([
        ('candidate-pscells', _CPACinformation_REQD_candidate_pscells),
        ('iE-Extensions', _CPACinformation_REQD_iE_Extensions),
        ])
    CPACinformation_REQD._ext = []
    
    #-----< CPACinformation-REQD-ExtIEs >-----#
    CPACinformation_REQD_ExtIEs = CLASS(name='CPACinformation-REQD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    CPACinformation_REQD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CHO-DC-EarlyDataForwarding >-----#
    CHO_DC_EarlyDataForwarding = ENUM(name='CHO-DC-EarlyDataForwarding', mode=MODE_TYPE)
    CHO_DC_EarlyDataForwarding._cont = ASN1Dict([('stop', 0)])
    CHO_DC_EarlyDataForwarding._ext = []
    
    #-----< CHO-DC-Indicator >-----#
    CHO_DC_Indicator = ENUM(name='CHO-DC-Indicator', mode=MODE_TYPE)
    CHO_DC_Indicator._cont = ASN1Dict([('true', 0), ('coordination-only', 1)])
    CHO_DC_Indicator._ext = ['coordination-only']
    
    #-----< CNTypeRestrictions >-----#
    CNTypeRestrictions = SEQ_OF(name='CNTypeRestrictions', mode=MODE_TYPE)
    _CNTypeRestrictions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CNTypeRestrictionsItem')))
    CNTypeRestrictions._cont = _CNTypeRestrictions__item_
    CNTypeRestrictions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< CNTypeRestrictionsItem >-----#
    CNTypeRestrictionsItem = SEQ(name='CNTypeRestrictionsItem', mode=MODE_TYPE)
    _CNTypeRestrictionsItem_plmn_Id = OCT_STR(name='plmn-Id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'PLMN-Identity')))
    _CNTypeRestrictionsItem_cn_type = ENUM(name='cn-type', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CNTypeRestrictionsItem_cn_type._cont = ASN1Dict([('fiveGC-forbidden', 0), ('epc-forbidden', 1)])
    _CNTypeRestrictionsItem_cn_type._ext = ['epc-forbidden']
    _CNTypeRestrictionsItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CNTypeRestrictionsItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___CNTypeRestrictionsItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____CNTypeRestrictionsItem_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CNTypeRestrictionsItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CNTypeRestrictionsItem_iE_Extensions__item__id._const_tab = ____CNTypeRestrictionsItem_iE_Extensions__item__id_tab
    ___CNTypeRestrictionsItem_iE_Extensions__item__id._const_tab_at = None
    ___CNTypeRestrictionsItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___CNTypeRestrictionsItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CNTypeRestrictionsItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CNTypeRestrictionsItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CNTypeRestrictionsItem_iE_Extensions__item__criticality._const_tab = ____CNTypeRestrictionsItem_iE_Extensions__item__criticality_tab
    ___CNTypeRestrictionsItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CNTypeRestrictionsItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CNTypeRestrictionsItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CNTypeRestrictionsItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CNTypeRestrictionsItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CNTypeRestrictionsItem_iE_Extensions__item__extensionValue._const_tab = ____CNTypeRestrictionsItem_iE_Extensions__item__extensionValue_tab
    ___CNTypeRestrictionsItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CNTypeRestrictionsItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CNTypeRestrictionsItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CNTypeRestrictionsItem_iE_Extensions__item__id),
        ('criticality', ___CNTypeRestrictionsItem_iE_Extensions__item__criticality),
        ('extensionValue', ___CNTypeRestrictionsItem_iE_Extensions__item__extensionValue),
        ])
    __CNTypeRestrictionsItem_iE_Extensions__item_._ext = None
    _CNTypeRestrictionsItem_iE_Extensions._cont = __CNTypeRestrictionsItem_iE_Extensions__item_
    _CNTypeRestrictionsItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CNTypeRestrictionsItem._cont = ASN1Dict([
        ('plmn-Id', _CNTypeRestrictionsItem_plmn_Id),
        ('cn-type', _CNTypeRestrictionsItem_cn_type),
        ('iE-Extensions', _CNTypeRestrictionsItem_iE_Extensions),
        ])
    CNTypeRestrictionsItem._ext = []
    
    #-----< CNTypeRestrictionsItem-ExtIEs >-----#
    CNTypeRestrictionsItem_ExtIEs = CLASS(name='CNTypeRestrictionsItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    CNTypeRestrictionsItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CoMPHypothesisSet >-----#
    CoMPHypothesisSet = SEQ_OF(name='CoMPHypothesisSet', mode=MODE_TYPE)
    _CoMPHypothesisSet__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CoMPHypothesisSetItem')))
    CoMPHypothesisSet._cont = _CoMPHypothesisSet__item_
    CoMPHypothesisSet._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< CoMPHypothesisSetItem >-----#
    CoMPHypothesisSetItem = SEQ(name='CoMPHypothesisSetItem', mode=MODE_TYPE)
    _CoMPHypothesisSetItem_coMPCellID = SEQ(name='coMPCellID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _CoMPHypothesisSetItem_coMPHypothesis = BIT_STR(name='coMPHypothesis', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CoMPHypothesisSetItem_coMPHypothesis._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=6, ub=4400)], ev=[], er=[])
    _CoMPHypothesisSetItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CoMPHypothesisSetItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___CoMPHypothesisSetItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____CoMPHypothesisSetItem_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CoMPHypothesisSetItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CoMPHypothesisSetItem_iE_Extensions__item__id._const_tab = ____CoMPHypothesisSetItem_iE_Extensions__item__id_tab
    ___CoMPHypothesisSetItem_iE_Extensions__item__id._const_tab_at = None
    ___CoMPHypothesisSetItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___CoMPHypothesisSetItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CoMPHypothesisSetItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CoMPHypothesisSetItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CoMPHypothesisSetItem_iE_Extensions__item__criticality._const_tab = ____CoMPHypothesisSetItem_iE_Extensions__item__criticality_tab
    ___CoMPHypothesisSetItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CoMPHypothesisSetItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CoMPHypothesisSetItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CoMPHypothesisSetItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CoMPHypothesisSetItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CoMPHypothesisSetItem_iE_Extensions__item__extensionValue._const_tab = ____CoMPHypothesisSetItem_iE_Extensions__item__extensionValue_tab
    ___CoMPHypothesisSetItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CoMPHypothesisSetItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CoMPHypothesisSetItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CoMPHypothesisSetItem_iE_Extensions__item__id),
        ('criticality', ___CoMPHypothesisSetItem_iE_Extensions__item__criticality),
        ('extensionValue', ___CoMPHypothesisSetItem_iE_Extensions__item__extensionValue),
        ])
    __CoMPHypothesisSetItem_iE_Extensions__item_._ext = None
    _CoMPHypothesisSetItem_iE_Extensions._cont = __CoMPHypothesisSetItem_iE_Extensions__item_
    _CoMPHypothesisSetItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CoMPHypothesisSetItem._cont = ASN1Dict([
        ('coMPCellID', _CoMPHypothesisSetItem_coMPCellID),
        ('coMPHypothesis', _CoMPHypothesisSetItem_coMPHypothesis),
        ('iE-Extensions', _CoMPHypothesisSetItem_iE_Extensions),
        ])
    CoMPHypothesisSetItem._ext = []
    
    #-----< CoMPHypothesisSetItem-ExtIEs >-----#
    CoMPHypothesisSetItem_ExtIEs = CLASS(name='CoMPHypothesisSetItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    CoMPHypothesisSetItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CoMPInformation >-----#
    CoMPInformation = SEQ(name='CoMPInformation', mode=MODE_TYPE)
    _CoMPInformation_coMPInformationItem = SEQ_OF(name='coMPInformationItem', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CoMPInformationItem')))
    _CoMPInformation_coMPInformationStartTime = SEQ_OF(name='coMPInformationStartTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CoMPInformationStartTime')))
    _CoMPInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CoMPInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___CoMPInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____CoMPInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CoMPInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CoMPInformation_iE_Extensions__item__id._const_tab = ____CoMPInformation_iE_Extensions__item__id_tab
    ___CoMPInformation_iE_Extensions__item__id._const_tab_at = None
    ___CoMPInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___CoMPInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CoMPInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CoMPInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CoMPInformation_iE_Extensions__item__criticality._const_tab = ____CoMPInformation_iE_Extensions__item__criticality_tab
    ___CoMPInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CoMPInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CoMPInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CoMPInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CoMPInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CoMPInformation_iE_Extensions__item__extensionValue._const_tab = ____CoMPInformation_iE_Extensions__item__extensionValue_tab
    ___CoMPInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CoMPInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CoMPInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CoMPInformation_iE_Extensions__item__id),
        ('criticality', ___CoMPInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___CoMPInformation_iE_Extensions__item__extensionValue),
        ])
    __CoMPInformation_iE_Extensions__item_._ext = None
    _CoMPInformation_iE_Extensions._cont = __CoMPInformation_iE_Extensions__item_
    _CoMPInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CoMPInformation._cont = ASN1Dict([
        ('coMPInformationItem', _CoMPInformation_coMPInformationItem),
        ('coMPInformationStartTime', _CoMPInformation_coMPInformationStartTime),
        ('iE-Extensions', _CoMPInformation_iE_Extensions),
        ])
    CoMPInformation._ext = []
    
    #-----< CoMPInformation-ExtIEs >-----#
    CoMPInformation_ExtIEs = CLASS(name='CoMPInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    CoMPInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CoMPInformationItem >-----#
    CoMPInformationItem = SEQ_OF(name='CoMPInformationItem', mode=MODE_TYPE)
    _CoMPInformationItem__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __CoMPInformationItem__item__coMPHypothesisSet = SEQ_OF(name='coMPHypothesisSet', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CoMPHypothesisSet')))
    __CoMPInformationItem__item__benefitMetric = INT(name='benefitMetric', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'BenefitMetric')))
    __CoMPInformationItem__item__iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___CoMPInformationItem__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ____CoMPInformationItem__item__iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    _____CoMPInformationItem__item__iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____CoMPInformationItem__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____CoMPInformationItem__item__iE_Extensions__item__id._const_tab = _____CoMPInformationItem__item__iE_Extensions__item__id_tab
    ____CoMPInformationItem__item__iE_Extensions__item__id._const_tab_at = None
    ____CoMPInformationItem__item__iE_Extensions__item__id._const_tab_id = 'id'
    ____CoMPInformationItem__item__iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    _____CoMPInformationItem__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____CoMPInformationItem__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____CoMPInformationItem__item__iE_Extensions__item__criticality._const_tab = _____CoMPInformationItem__item__iE_Extensions__item__criticality_tab
    ____CoMPInformationItem__item__iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____CoMPInformationItem__item__iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____CoMPInformationItem__item__iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    _____CoMPInformationItem__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____CoMPInformationItem__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____CoMPInformationItem__item__iE_Extensions__item__extensionValue._const_tab = _____CoMPInformationItem__item__iE_Extensions__item__extensionValue_tab
    ____CoMPInformationItem__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____CoMPInformationItem__item__iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___CoMPInformationItem__item__iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____CoMPInformationItem__item__iE_Extensions__item__id),
        ('criticality', ____CoMPInformationItem__item__iE_Extensions__item__criticality),
        ('extensionValue', ____CoMPInformationItem__item__iE_Extensions__item__extensionValue),
        ])
    ___CoMPInformationItem__item__iE_Extensions__item_._ext = None
    __CoMPInformationItem__item__iE_Extensions._cont = ___CoMPInformationItem__item__iE_Extensions__item_
    __CoMPInformationItem__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _CoMPInformationItem__item_._cont = ASN1Dict([
        ('coMPHypothesisSet', __CoMPInformationItem__item__coMPHypothesisSet),
        ('benefitMetric', __CoMPInformationItem__item__benefitMetric),
        ('iE-Extensions', __CoMPInformationItem__item__iE_Extensions),
        ])
    _CoMPInformationItem__item_._ext = []
    CoMPInformationItem._cont = _CoMPInformationItem__item_
    CoMPInformationItem._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< CoMPInformationItem-ExtIEs >-----#
    CoMPInformationItem_ExtIEs = CLASS(name='CoMPInformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    CoMPInformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CoMPInformationStartTime >-----#
    CoMPInformationStartTime = SEQ_OF(name='CoMPInformationStartTime', mode=MODE_TYPE)
    _CoMPInformationStartTime__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __CoMPInformationStartTime__item__startSFN = INT(name='startSFN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __CoMPInformationStartTime__item__startSFN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1023)], ev=[], er=[])
    __CoMPInformationStartTime__item__startSubframeNumber = INT(name='startSubframeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __CoMPInformationStartTime__item__startSubframeNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=[], er=[])
    __CoMPInformationStartTime__item__iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___CoMPInformationStartTime__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ____CoMPInformationStartTime__item__iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    _____CoMPInformationStartTime__item__iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____CoMPInformationStartTime__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____CoMPInformationStartTime__item__iE_Extensions__item__id._const_tab = _____CoMPInformationStartTime__item__iE_Extensions__item__id_tab
    ____CoMPInformationStartTime__item__iE_Extensions__item__id._const_tab_at = None
    ____CoMPInformationStartTime__item__iE_Extensions__item__id._const_tab_id = 'id'
    ____CoMPInformationStartTime__item__iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    _____CoMPInformationStartTime__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____CoMPInformationStartTime__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____CoMPInformationStartTime__item__iE_Extensions__item__criticality._const_tab = _____CoMPInformationStartTime__item__iE_Extensions__item__criticality_tab
    ____CoMPInformationStartTime__item__iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____CoMPInformationStartTime__item__iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____CoMPInformationStartTime__item__iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    _____CoMPInformationStartTime__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____CoMPInformationStartTime__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____CoMPInformationStartTime__item__iE_Extensions__item__extensionValue._const_tab = _____CoMPInformationStartTime__item__iE_Extensions__item__extensionValue_tab
    ____CoMPInformationStartTime__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____CoMPInformationStartTime__item__iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___CoMPInformationStartTime__item__iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____CoMPInformationStartTime__item__iE_Extensions__item__id),
        ('criticality', ____CoMPInformationStartTime__item__iE_Extensions__item__criticality),
        ('extensionValue', ____CoMPInformationStartTime__item__iE_Extensions__item__extensionValue),
        ])
    ___CoMPInformationStartTime__item__iE_Extensions__item_._ext = None
    __CoMPInformationStartTime__item__iE_Extensions._cont = ___CoMPInformationStartTime__item__iE_Extensions__item_
    __CoMPInformationStartTime__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _CoMPInformationStartTime__item_._cont = ASN1Dict([
        ('startSFN', __CoMPInformationStartTime__item__startSFN),
        ('startSubframeNumber', __CoMPInformationStartTime__item__startSubframeNumber),
        ('iE-Extensions', __CoMPInformationStartTime__item__iE_Extensions),
        ])
    _CoMPInformationStartTime__item_._ext = []
    CoMPInformationStartTime._cont = _CoMPInformationStartTime__item_
    CoMPInformationStartTime._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1)], ev=None, er=[])
    
    #-----< CoMPInformationStartTime-ExtIEs >-----#
    CoMPInformationStartTime_ExtIEs = CLASS(name='CoMPInformationStartTime-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    CoMPInformationStartTime_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CompositeAvailableCapacity >-----#
    CompositeAvailableCapacity = SEQ(name='CompositeAvailableCapacity', mode=MODE_TYPE)
    _CompositeAvailableCapacity_cellCapacityClassValue = INT(name='cellCapacityClassValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CellCapacityClassValue')), opt=True)
    _CompositeAvailableCapacity_capacityValue = INT(name='capacityValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CapacityValue')))
    _CompositeAvailableCapacity_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CompositeAvailableCapacity_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___CompositeAvailableCapacity_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____CompositeAvailableCapacity_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CompositeAvailableCapacity_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompositeAvailableCapacity_iE_Extensions__item__id._const_tab = ____CompositeAvailableCapacity_iE_Extensions__item__id_tab
    ___CompositeAvailableCapacity_iE_Extensions__item__id._const_tab_at = None
    ___CompositeAvailableCapacity_iE_Extensions__item__id._const_tab_id = 'id'
    ___CompositeAvailableCapacity_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CompositeAvailableCapacity_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CompositeAvailableCapacity_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompositeAvailableCapacity_iE_Extensions__item__criticality._const_tab = ____CompositeAvailableCapacity_iE_Extensions__item__criticality_tab
    ___CompositeAvailableCapacity_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CompositeAvailableCapacity_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CompositeAvailableCapacity_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CompositeAvailableCapacity_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CompositeAvailableCapacity_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompositeAvailableCapacity_iE_Extensions__item__extensionValue._const_tab = ____CompositeAvailableCapacity_iE_Extensions__item__extensionValue_tab
    ___CompositeAvailableCapacity_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CompositeAvailableCapacity_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CompositeAvailableCapacity_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CompositeAvailableCapacity_iE_Extensions__item__id),
        ('criticality', ___CompositeAvailableCapacity_iE_Extensions__item__criticality),
        ('extensionValue', ___CompositeAvailableCapacity_iE_Extensions__item__extensionValue),
        ])
    __CompositeAvailableCapacity_iE_Extensions__item_._ext = None
    _CompositeAvailableCapacity_iE_Extensions._cont = __CompositeAvailableCapacity_iE_Extensions__item_
    _CompositeAvailableCapacity_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CompositeAvailableCapacity._cont = ASN1Dict([
        ('cellCapacityClassValue', _CompositeAvailableCapacity_cellCapacityClassValue),
        ('capacityValue', _CompositeAvailableCapacity_capacityValue),
        ('iE-Extensions', _CompositeAvailableCapacity_iE_Extensions),
        ])
    CompositeAvailableCapacity._ext = []
    
    #-----< CompositeAvailableCapacity-ExtIEs >-----#
    CompositeAvailableCapacity_ExtIEs = CLASS(name='CompositeAvailableCapacity-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    CompositeAvailableCapacity_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CompositeAvailableCapacityGroup >-----#
    CompositeAvailableCapacityGroup = SEQ(name='CompositeAvailableCapacityGroup', mode=MODE_TYPE)
    _CompositeAvailableCapacityGroup_dL_CompositeAvailableCapacity = SEQ(name='dL-CompositeAvailableCapacity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CompositeAvailableCapacity')))
    _CompositeAvailableCapacityGroup_uL_CompositeAvailableCapacity = SEQ(name='uL-CompositeAvailableCapacity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CompositeAvailableCapacity')))
    _CompositeAvailableCapacityGroup_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CompositeAvailableCapacityGroup_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___CompositeAvailableCapacityGroup_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____CompositeAvailableCapacityGroup_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CompositeAvailableCapacityGroup_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompositeAvailableCapacityGroup_iE_Extensions__item__id._const_tab = ____CompositeAvailableCapacityGroup_iE_Extensions__item__id_tab
    ___CompositeAvailableCapacityGroup_iE_Extensions__item__id._const_tab_at = None
    ___CompositeAvailableCapacityGroup_iE_Extensions__item__id._const_tab_id = 'id'
    ___CompositeAvailableCapacityGroup_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CompositeAvailableCapacityGroup_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CompositeAvailableCapacityGroup_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompositeAvailableCapacityGroup_iE_Extensions__item__criticality._const_tab = ____CompositeAvailableCapacityGroup_iE_Extensions__item__criticality_tab
    ___CompositeAvailableCapacityGroup_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CompositeAvailableCapacityGroup_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CompositeAvailableCapacityGroup_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CompositeAvailableCapacityGroup_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CompositeAvailableCapacityGroup_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompositeAvailableCapacityGroup_iE_Extensions__item__extensionValue._const_tab = ____CompositeAvailableCapacityGroup_iE_Extensions__item__extensionValue_tab
    ___CompositeAvailableCapacityGroup_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CompositeAvailableCapacityGroup_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CompositeAvailableCapacityGroup_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CompositeAvailableCapacityGroup_iE_Extensions__item__id),
        ('criticality', ___CompositeAvailableCapacityGroup_iE_Extensions__item__criticality),
        ('extensionValue', ___CompositeAvailableCapacityGroup_iE_Extensions__item__extensionValue),
        ])
    __CompositeAvailableCapacityGroup_iE_Extensions__item_._ext = None
    _CompositeAvailableCapacityGroup_iE_Extensions._cont = __CompositeAvailableCapacityGroup_iE_Extensions__item_
    _CompositeAvailableCapacityGroup_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CompositeAvailableCapacityGroup._cont = ASN1Dict([
        ('dL-CompositeAvailableCapacity', _CompositeAvailableCapacityGroup_dL_CompositeAvailableCapacity),
        ('uL-CompositeAvailableCapacity', _CompositeAvailableCapacityGroup_uL_CompositeAvailableCapacity),
        ('iE-Extensions', _CompositeAvailableCapacityGroup_iE_Extensions),
        ])
    CompositeAvailableCapacityGroup._ext = []
    
    #-----< CompositeAvailableCapacityGroup-ExtIEs >-----#
    CompositeAvailableCapacityGroup_ExtIEs = CLASS(name='CompositeAvailableCapacityGroup-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    CompositeAvailableCapacityGroup_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Correlation-ID >-----#
    Correlation_ID = OCT_STR(name='Correlation-ID', mode=MODE_TYPE)
    Correlation_ID._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< COUNTvalue >-----#
    COUNTvalue = SEQ(name='COUNTvalue', mode=MODE_TYPE)
    _COUNTvalue_pDCP_SN = INT(name='pDCP-SN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'PDCP-SN')))
    _COUNTvalue_hFN = INT(name='hFN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'HFN')))
    _COUNTvalue_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __COUNTvalue_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___COUNTvalue_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____COUNTvalue_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____COUNTvalue_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___COUNTvalue_iE_Extensions__item__id._const_tab = ____COUNTvalue_iE_Extensions__item__id_tab
    ___COUNTvalue_iE_Extensions__item__id._const_tab_at = None
    ___COUNTvalue_iE_Extensions__item__id._const_tab_id = 'id'
    ___COUNTvalue_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____COUNTvalue_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____COUNTvalue_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___COUNTvalue_iE_Extensions__item__criticality._const_tab = ____COUNTvalue_iE_Extensions__item__criticality_tab
    ___COUNTvalue_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___COUNTvalue_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___COUNTvalue_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____COUNTvalue_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____COUNTvalue_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___COUNTvalue_iE_Extensions__item__extensionValue._const_tab = ____COUNTvalue_iE_Extensions__item__extensionValue_tab
    ___COUNTvalue_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___COUNTvalue_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __COUNTvalue_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___COUNTvalue_iE_Extensions__item__id),
        ('criticality', ___COUNTvalue_iE_Extensions__item__criticality),
        ('extensionValue', ___COUNTvalue_iE_Extensions__item__extensionValue),
        ])
    __COUNTvalue_iE_Extensions__item_._ext = None
    _COUNTvalue_iE_Extensions._cont = __COUNTvalue_iE_Extensions__item_
    _COUNTvalue_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    COUNTvalue._cont = ASN1Dict([
        ('pDCP-SN', _COUNTvalue_pDCP_SN),
        ('hFN', _COUNTvalue_hFN),
        ('iE-Extensions', _COUNTvalue_iE_Extensions),
        ])
    COUNTvalue._ext = []
    
    #-----< COUNTvalue-ExtIEs >-----#
    COUNTvalue_ExtIEs = CLASS(name='COUNTvalue-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    COUNTvalue_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< COUNTValueExtended >-----#
    COUNTValueExtended = SEQ(name='COUNTValueExtended', mode=MODE_TYPE)
    _COUNTValueExtended_pDCP_SNExtended = INT(name='pDCP-SNExtended', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'PDCP-SNExtended')))
    _COUNTValueExtended_hFNModified = INT(name='hFNModified', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'HFNModified')))
    _COUNTValueExtended_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __COUNTValueExtended_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___COUNTValueExtended_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____COUNTValueExtended_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____COUNTValueExtended_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___COUNTValueExtended_iE_Extensions__item__id._const_tab = ____COUNTValueExtended_iE_Extensions__item__id_tab
    ___COUNTValueExtended_iE_Extensions__item__id._const_tab_at = None
    ___COUNTValueExtended_iE_Extensions__item__id._const_tab_id = 'id'
    ___COUNTValueExtended_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____COUNTValueExtended_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____COUNTValueExtended_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___COUNTValueExtended_iE_Extensions__item__criticality._const_tab = ____COUNTValueExtended_iE_Extensions__item__criticality_tab
    ___COUNTValueExtended_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___COUNTValueExtended_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___COUNTValueExtended_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____COUNTValueExtended_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____COUNTValueExtended_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___COUNTValueExtended_iE_Extensions__item__extensionValue._const_tab = ____COUNTValueExtended_iE_Extensions__item__extensionValue_tab
    ___COUNTValueExtended_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___COUNTValueExtended_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __COUNTValueExtended_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___COUNTValueExtended_iE_Extensions__item__id),
        ('criticality', ___COUNTValueExtended_iE_Extensions__item__criticality),
        ('extensionValue', ___COUNTValueExtended_iE_Extensions__item__extensionValue),
        ])
    __COUNTValueExtended_iE_Extensions__item_._ext = None
    _COUNTValueExtended_iE_Extensions._cont = __COUNTValueExtended_iE_Extensions__item_
    _COUNTValueExtended_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    COUNTValueExtended._cont = ASN1Dict([
        ('pDCP-SNExtended', _COUNTValueExtended_pDCP_SNExtended),
        ('hFNModified', _COUNTValueExtended_hFNModified),
        ('iE-Extensions', _COUNTValueExtended_iE_Extensions),
        ])
    COUNTValueExtended._ext = []
    
    #-----< COUNTValueExtended-ExtIEs >-----#
    COUNTValueExtended_ExtIEs = CLASS(name='COUNTValueExtended-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    COUNTValueExtended_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< COUNTvaluePDCP-SNlength18 >-----#
    COUNTvaluePDCP_SNlength18 = SEQ(name='COUNTvaluePDCP-SNlength18', mode=MODE_TYPE)
    _COUNTvaluePDCP_SNlength18_pDCP_SNlength18 = INT(name='pDCP-SNlength18', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'PDCP-SNlength18')))
    _COUNTvaluePDCP_SNlength18_hFNforPDCP_SNlength18 = INT(name='hFNforPDCP-SNlength18', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'HFNforPDCP-SNlength18')))
    _COUNTvaluePDCP_SNlength18_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __COUNTvaluePDCP_SNlength18_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____COUNTvaluePDCP_SNlength18_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____COUNTvaluePDCP_SNlength18_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__id._const_tab = ____COUNTvaluePDCP_SNlength18_iE_Extensions__item__id_tab
    ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__id._const_tab_at = None
    ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__id._const_tab_id = 'id'
    ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____COUNTvaluePDCP_SNlength18_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____COUNTvaluePDCP_SNlength18_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__criticality._const_tab = ____COUNTvaluePDCP_SNlength18_iE_Extensions__item__criticality_tab
    ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____COUNTvaluePDCP_SNlength18_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____COUNTvaluePDCP_SNlength18_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__extensionValue._const_tab = ____COUNTvaluePDCP_SNlength18_iE_Extensions__item__extensionValue_tab
    ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __COUNTvaluePDCP_SNlength18_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__id),
        ('criticality', ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__criticality),
        ('extensionValue', ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__extensionValue),
        ])
    __COUNTvaluePDCP_SNlength18_iE_Extensions__item_._ext = None
    _COUNTvaluePDCP_SNlength18_iE_Extensions._cont = __COUNTvaluePDCP_SNlength18_iE_Extensions__item_
    _COUNTvaluePDCP_SNlength18_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    COUNTvaluePDCP_SNlength18._cont = ASN1Dict([
        ('pDCP-SNlength18', _COUNTvaluePDCP_SNlength18_pDCP_SNlength18),
        ('hFNforPDCP-SNlength18', _COUNTvaluePDCP_SNlength18_hFNforPDCP_SNlength18),
        ('iE-Extensions', _COUNTvaluePDCP_SNlength18_iE_Extensions),
        ])
    COUNTvaluePDCP_SNlength18._ext = []
    
    #-----< COUNTvaluePDCP-SNlength18-ExtIEs >-----#
    COUNTvaluePDCP_SNlength18_ExtIEs = CLASS(name='COUNTvaluePDCP-SNlength18-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    COUNTvaluePDCP_SNlength18_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CoverageModificationList >-----#
    CoverageModificationList = SEQ_OF(name='CoverageModificationList', mode=MODE_TYPE)
    _CoverageModificationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CoverageModification-Item')))
    CoverageModificationList._cont = _CoverageModificationList__item_
    CoverageModificationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< CoverageModification-Item >-----#
    CoverageModification_Item = SEQ(name='CoverageModification-Item', mode=MODE_TYPE)
    _CoverageModification_Item_eCGI = SEQ(name='eCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _CoverageModification_Item_coverageState = INT(name='coverageState', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CoverageModification_Item_coverageState._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=[], er=[])
    _CoverageModification_Item_cellDeploymentStatusIndicator = ENUM(name='cellDeploymentStatusIndicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CellDeploymentStatusIndicator')), opt=True)
    _CoverageModification_Item_cellReplacingInfo = SEQ(name='cellReplacingInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CellReplacingInfo')), opt=True)
    CoverageModification_Item._cont = ASN1Dict([
        ('eCGI', _CoverageModification_Item_eCGI),
        ('coverageState', _CoverageModification_Item_coverageState),
        ('cellDeploymentStatusIndicator', _CoverageModification_Item_cellDeploymentStatusIndicator),
        ('cellReplacingInfo', _CoverageModification_Item_cellReplacingInfo),
        ])
    CoverageModification_Item._ext = []
    
    #-----< CPTransportLayerInformation >-----#
    CPTransportLayerInformation = CHOICE(name='CPTransportLayerInformation', mode=MODE_TYPE)
    _CPTransportLayerInformation_endpointIPAddress = BIT_STR(name='endpointIPAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'TransportLayerAddress')))
    _CPTransportLayerInformation_endpointIPAddressAndPort = SEQ(name='endpointIPAddressAndPort', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'TransportLayerAddressAndPort')))
    CPTransportLayerInformation._cont = ASN1Dict([
        ('endpointIPAddress', _CPTransportLayerInformation_endpointIPAddress),
        ('endpointIPAddressAndPort', _CPTransportLayerInformation_endpointIPAddressAndPort),
        ])
    CPTransportLayerInformation._ext = []
    
    #-----< CriticalityDiagnostics >-----#
    CriticalityDiagnostics = SEQ(name='CriticalityDiagnostics', mode=MODE_TYPE)
    _CriticalityDiagnostics_procedureCode = INT(name='procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')), opt=True)
    _CriticalityDiagnostics_triggeringMessage = ENUM(name='triggeringMessage', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-CommonDataTypes', 'TriggeringMessage')), opt=True)
    _CriticalityDiagnostics_procedureCriticality = ENUM(name='procedureCriticality', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-CommonDataTypes', 'Criticality')), opt=True)
    _CriticalityDiagnostics_iEsCriticalityDiagnostics = SEQ_OF(name='iEsCriticalityDiagnostics', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics-IE-List')), opt=True)
    _CriticalityDiagnostics_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CriticalityDiagnostics_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___CriticalityDiagnostics_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____CriticalityDiagnostics_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_iE_Extensions__item__id._const_tab = ____CriticalityDiagnostics_iE_Extensions__item__id_tab
    ___CriticalityDiagnostics_iE_Extensions__item__id._const_tab_at = None
    ___CriticalityDiagnostics_iE_Extensions__item__id._const_tab_id = 'id'
    ___CriticalityDiagnostics_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_iE_Extensions__item__criticality._const_tab = ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab
    ___CriticalityDiagnostics_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CriticalityDiagnostics_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue._const_tab = ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CriticalityDiagnostics_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CriticalityDiagnostics_iE_Extensions__item__id),
        ('criticality', ___CriticalityDiagnostics_iE_Extensions__item__criticality),
        ('extensionValue', ___CriticalityDiagnostics_iE_Extensions__item__extensionValue),
        ])
    __CriticalityDiagnostics_iE_Extensions__item_._ext = None
    _CriticalityDiagnostics_iE_Extensions._cont = __CriticalityDiagnostics_iE_Extensions__item_
    _CriticalityDiagnostics_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CriticalityDiagnostics._cont = ASN1Dict([
        ('procedureCode', _CriticalityDiagnostics_procedureCode),
        ('triggeringMessage', _CriticalityDiagnostics_triggeringMessage),
        ('procedureCriticality', _CriticalityDiagnostics_procedureCriticality),
        ('iEsCriticalityDiagnostics', _CriticalityDiagnostics_iEsCriticalityDiagnostics),
        ('iE-Extensions', _CriticalityDiagnostics_iE_Extensions),
        ])
    CriticalityDiagnostics._ext = []
    
    #-----< CriticalityDiagnostics-ExtIEs >-----#
    CriticalityDiagnostics_ExtIEs = CLASS(name='CriticalityDiagnostics-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    CriticalityDiagnostics_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CriticalityDiagnostics-IE-List >-----#
    CriticalityDiagnostics_IE_List = SEQ_OF(name='CriticalityDiagnostics-IE-List', mode=MODE_TYPE)
    _CriticalityDiagnostics_IE_List__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __CriticalityDiagnostics_IE_List__item__iECriticality = ENUM(name='iECriticality', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-CommonDataTypes', 'Criticality')))
    __CriticalityDiagnostics_IE_List__item__iE_ID = INT(name='iE-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProtocolIE-ID')))
    __CriticalityDiagnostics_IE_List__item__typeOfError = ENUM(name='typeOfError', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'TypeOfError')))
    __CriticalityDiagnostics_IE_List__item__iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___CriticalityDiagnostics_IE_List__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id._const_tab = _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id._const_tab_at = None
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id._const_tab_id = 'id'
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality._const_tab = _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality_tab
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue._const_tab = _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue_tab
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___CriticalityDiagnostics_IE_List__item__iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id),
        ('criticality', ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality),
        ('extensionValue', ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue),
        ])
    ___CriticalityDiagnostics_IE_List__item__iE_Extensions__item_._ext = None
    __CriticalityDiagnostics_IE_List__item__iE_Extensions._cont = ___CriticalityDiagnostics_IE_List__item__iE_Extensions__item_
    __CriticalityDiagnostics_IE_List__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _CriticalityDiagnostics_IE_List__item_._cont = ASN1Dict([
        ('iECriticality', __CriticalityDiagnostics_IE_List__item__iECriticality),
        ('iE-ID', __CriticalityDiagnostics_IE_List__item__iE_ID),
        ('typeOfError', __CriticalityDiagnostics_IE_List__item__typeOfError),
        ('iE-Extensions', __CriticalityDiagnostics_IE_List__item__iE_Extensions),
        ])
    _CriticalityDiagnostics_IE_List__item_._ext = []
    CriticalityDiagnostics_IE_List._cont = _CriticalityDiagnostics_IE_List__item_
    CriticalityDiagnostics_IE_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< CriticalityDiagnostics-IE-List-ExtIEs >-----#
    CriticalityDiagnostics_IE_List_ExtIEs = CLASS(name='CriticalityDiagnostics-IE-List-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    CriticalityDiagnostics_IE_List_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CRNTI >-----#
    CRNTI = BIT_STR(name='CRNTI', mode=MODE_TYPE)
    CRNTI._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< CSGMembershipStatus >-----#
    CSGMembershipStatus = ENUM(name='CSGMembershipStatus', mode=MODE_TYPE)
    CSGMembershipStatus._cont = ASN1Dict([('member', 0), ('not-member', 1)])
    CSGMembershipStatus._ext = None
    
    #-----< CSG-Id >-----#
    CSG_Id = BIT_STR(name='CSG-Id', mode=MODE_TYPE)
    CSG_Id._const_sz = ASN1Set(rv=[27], rr=[], ev=None, er=[])
    
    #-----< CSIReportList >-----#
    CSIReportList = SEQ_OF(name='CSIReportList', mode=MODE_TYPE)
    _CSIReportList__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __CSIReportList__item__uEID = BIT_STR(name='uEID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'UEID')))
    __CSIReportList__item__cSIReportPerCSIProcess = SEQ_OF(name='cSIReportPerCSIProcess', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CSIReportPerCSIProcess')))
    __CSIReportList__item__iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___CSIReportList__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ____CSIReportList__item__iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    _____CSIReportList__item__iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____CSIReportList__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____CSIReportList__item__iE_Extensions__item__id._const_tab = _____CSIReportList__item__iE_Extensions__item__id_tab
    ____CSIReportList__item__iE_Extensions__item__id._const_tab_at = None
    ____CSIReportList__item__iE_Extensions__item__id._const_tab_id = 'id'
    ____CSIReportList__item__iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    _____CSIReportList__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____CSIReportList__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____CSIReportList__item__iE_Extensions__item__criticality._const_tab = _____CSIReportList__item__iE_Extensions__item__criticality_tab
    ____CSIReportList__item__iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____CSIReportList__item__iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____CSIReportList__item__iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    _____CSIReportList__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____CSIReportList__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____CSIReportList__item__iE_Extensions__item__extensionValue._const_tab = _____CSIReportList__item__iE_Extensions__item__extensionValue_tab
    ____CSIReportList__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____CSIReportList__item__iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___CSIReportList__item__iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____CSIReportList__item__iE_Extensions__item__id),
        ('criticality', ____CSIReportList__item__iE_Extensions__item__criticality),
        ('extensionValue', ____CSIReportList__item__iE_Extensions__item__extensionValue),
        ])
    ___CSIReportList__item__iE_Extensions__item_._ext = None
    __CSIReportList__item__iE_Extensions._cont = ___CSIReportList__item__iE_Extensions__item_
    __CSIReportList__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _CSIReportList__item_._cont = ASN1Dict([
        ('uEID', __CSIReportList__item__uEID),
        ('cSIReportPerCSIProcess', __CSIReportList__item__cSIReportPerCSIProcess),
        ('iE-Extensions', __CSIReportList__item__iE_Extensions),
        ])
    _CSIReportList__item_._ext = []
    CSIReportList._cont = _CSIReportList__item_
    CSIReportList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< CSIReportList-ExtIEs >-----#
    CSIReportList_ExtIEs = CLASS(name='CSIReportList-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    CSIReportList_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CSIReportPerCSIProcess >-----#
    CSIReportPerCSIProcess = SEQ_OF(name='CSIReportPerCSIProcess', mode=MODE_TYPE)
    _CSIReportPerCSIProcess__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __CSIReportPerCSIProcess__item__cSIProcessConfigurationIndex = INT(name='cSIProcessConfigurationIndex', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __CSIReportPerCSIProcess__item__cSIProcessConfigurationIndex._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=7)], ev=[], er=[])
    __CSIReportPerCSIProcess__item__cSIReportPerCSIProcessItem = SEQ_OF(name='cSIReportPerCSIProcessItem', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CSIReportPerCSIProcessItem')))
    __CSIReportPerCSIProcess__item__iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___CSIReportPerCSIProcess__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ____CSIReportPerCSIProcess__item__iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    _____CSIReportPerCSIProcess__item__iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____CSIReportPerCSIProcess__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____CSIReportPerCSIProcess__item__iE_Extensions__item__id._const_tab = _____CSIReportPerCSIProcess__item__iE_Extensions__item__id_tab
    ____CSIReportPerCSIProcess__item__iE_Extensions__item__id._const_tab_at = None
    ____CSIReportPerCSIProcess__item__iE_Extensions__item__id._const_tab_id = 'id'
    ____CSIReportPerCSIProcess__item__iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    _____CSIReportPerCSIProcess__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____CSIReportPerCSIProcess__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____CSIReportPerCSIProcess__item__iE_Extensions__item__criticality._const_tab = _____CSIReportPerCSIProcess__item__iE_Extensions__item__criticality_tab
    ____CSIReportPerCSIProcess__item__iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____CSIReportPerCSIProcess__item__iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____CSIReportPerCSIProcess__item__iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    _____CSIReportPerCSIProcess__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____CSIReportPerCSIProcess__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____CSIReportPerCSIProcess__item__iE_Extensions__item__extensionValue._const_tab = _____CSIReportPerCSIProcess__item__iE_Extensions__item__extensionValue_tab
    ____CSIReportPerCSIProcess__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____CSIReportPerCSIProcess__item__iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___CSIReportPerCSIProcess__item__iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____CSIReportPerCSIProcess__item__iE_Extensions__item__id),
        ('criticality', ____CSIReportPerCSIProcess__item__iE_Extensions__item__criticality),
        ('extensionValue', ____CSIReportPerCSIProcess__item__iE_Extensions__item__extensionValue),
        ])
    ___CSIReportPerCSIProcess__item__iE_Extensions__item_._ext = None
    __CSIReportPerCSIProcess__item__iE_Extensions._cont = ___CSIReportPerCSIProcess__item__iE_Extensions__item_
    __CSIReportPerCSIProcess__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _CSIReportPerCSIProcess__item_._cont = ASN1Dict([
        ('cSIProcessConfigurationIndex', __CSIReportPerCSIProcess__item__cSIProcessConfigurationIndex),
        ('cSIReportPerCSIProcessItem', __CSIReportPerCSIProcess__item__cSIReportPerCSIProcessItem),
        ('iE-Extensions', __CSIReportPerCSIProcess__item__iE_Extensions),
        ])
    _CSIReportPerCSIProcess__item_._ext = []
    CSIReportPerCSIProcess._cont = _CSIReportPerCSIProcess__item_
    CSIReportPerCSIProcess._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< CSIReportPerCSIProcess-ExtIEs >-----#
    CSIReportPerCSIProcess_ExtIEs = CLASS(name='CSIReportPerCSIProcess-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    CSIReportPerCSIProcess_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CSIReportPerCSIProcessItem >-----#
    CSIReportPerCSIProcessItem = SEQ_OF(name='CSIReportPerCSIProcessItem', mode=MODE_TYPE)
    _CSIReportPerCSIProcessItem__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __CSIReportPerCSIProcessItem__item__rI = INT(name='rI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __CSIReportPerCSIProcessItem__item__rI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=[], er=[])
    __CSIReportPerCSIProcessItem__item__widebandCQI = SEQ(name='widebandCQI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'WidebandCQI')))
    __CSIReportPerCSIProcessItem__item__subbandSize = ENUM(name='subbandSize', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'SubbandSize')))
    __CSIReportPerCSIProcessItem__item__subbandCQIList = SEQ_OF(name='subbandCQIList', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'SubbandCQIList')), opt=True)
    __CSIReportPerCSIProcessItem__item__iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___CSIReportPerCSIProcessItem__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ____CSIReportPerCSIProcessItem__item__iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    _____CSIReportPerCSIProcessItem__item__iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____CSIReportPerCSIProcessItem__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____CSIReportPerCSIProcessItem__item__iE_Extensions__item__id._const_tab = _____CSIReportPerCSIProcessItem__item__iE_Extensions__item__id_tab
    ____CSIReportPerCSIProcessItem__item__iE_Extensions__item__id._const_tab_at = None
    ____CSIReportPerCSIProcessItem__item__iE_Extensions__item__id._const_tab_id = 'id'
    ____CSIReportPerCSIProcessItem__item__iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    _____CSIReportPerCSIProcessItem__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____CSIReportPerCSIProcessItem__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____CSIReportPerCSIProcessItem__item__iE_Extensions__item__criticality._const_tab = _____CSIReportPerCSIProcessItem__item__iE_Extensions__item__criticality_tab
    ____CSIReportPerCSIProcessItem__item__iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____CSIReportPerCSIProcessItem__item__iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____CSIReportPerCSIProcessItem__item__iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    _____CSIReportPerCSIProcessItem__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____CSIReportPerCSIProcessItem__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____CSIReportPerCSIProcessItem__item__iE_Extensions__item__extensionValue._const_tab = _____CSIReportPerCSIProcessItem__item__iE_Extensions__item__extensionValue_tab
    ____CSIReportPerCSIProcessItem__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____CSIReportPerCSIProcessItem__item__iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___CSIReportPerCSIProcessItem__item__iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____CSIReportPerCSIProcessItem__item__iE_Extensions__item__id),
        ('criticality', ____CSIReportPerCSIProcessItem__item__iE_Extensions__item__criticality),
        ('extensionValue', ____CSIReportPerCSIProcessItem__item__iE_Extensions__item__extensionValue),
        ])
    ___CSIReportPerCSIProcessItem__item__iE_Extensions__item_._ext = None
    __CSIReportPerCSIProcessItem__item__iE_Extensions._cont = ___CSIReportPerCSIProcessItem__item__iE_Extensions__item_
    __CSIReportPerCSIProcessItem__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _CSIReportPerCSIProcessItem__item_._cont = ASN1Dict([
        ('rI', __CSIReportPerCSIProcessItem__item__rI),
        ('widebandCQI', __CSIReportPerCSIProcessItem__item__widebandCQI),
        ('subbandSize', __CSIReportPerCSIProcessItem__item__subbandSize),
        ('subbandCQIList', __CSIReportPerCSIProcessItem__item__subbandCQIList),
        ('iE-Extensions', __CSIReportPerCSIProcessItem__item__iE_Extensions),
        ])
    _CSIReportPerCSIProcessItem__item_._ext = []
    CSIReportPerCSIProcessItem._cont = _CSIReportPerCSIProcessItem__item_
    CSIReportPerCSIProcessItem._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< CSIReportPerCSIProcessItem-ExtIEs >-----#
    CSIReportPerCSIProcessItem_ExtIEs = CLASS(name='CSIReportPerCSIProcessItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    CSIReportPerCSIProcessItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CyclicPrefixDL >-----#
    CyclicPrefixDL = ENUM(name='CyclicPrefixDL', mode=MODE_TYPE)
    CyclicPrefixDL._cont = ASN1Dict([('normal', 0), ('extended', 1)])
    CyclicPrefixDL._ext = []
    
    #-----< CyclicPrefixUL >-----#
    CyclicPrefixUL = ENUM(name='CyclicPrefixUL', mode=MODE_TYPE)
    CyclicPrefixUL._cont = ASN1Dict([('normal', 0), ('extended', 1)])
    CyclicPrefixUL._ext = []
    
    #-----< CHOtrigger >-----#
    CHOtrigger = ENUM(name='CHOtrigger', mode=MODE_TYPE)
    CHOtrigger._cont = ASN1Dict([('cho-initiation', 0), ('cho-replace', 1)])
    CHOtrigger._ext = []
    
    #-----< CHOinformation-REQ >-----#
    CHOinformation_REQ = SEQ(name='CHOinformation-REQ', mode=MODE_TYPE)
    _CHOinformation_REQ_cho_trigger = ENUM(name='cho-trigger', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CHOtrigger')))
    _CHOinformation_REQ_new_eNB_UE_X2AP_ID = INT(name='new-eNB-UE-X2AP-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')), opt=True)
    _CHOinformation_REQ_new_eNB_UE_X2AP_ID_Extension = INT(name='new-eNB-UE-X2AP-ID-Extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')), opt=True)
    _CHOinformation_REQ_cHO_EstimatedArrivalProbability = INT(name='cHO-EstimatedArrivalProbability', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CHO-Probability')), opt=True)
    _CHOinformation_REQ_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CHOinformation_REQ_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___CHOinformation_REQ_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____CHOinformation_REQ_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CHOinformation_REQ_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CHOinformation_REQ_iE_Extensions__item__id._const_tab = ____CHOinformation_REQ_iE_Extensions__item__id_tab
    ___CHOinformation_REQ_iE_Extensions__item__id._const_tab_at = None
    ___CHOinformation_REQ_iE_Extensions__item__id._const_tab_id = 'id'
    ___CHOinformation_REQ_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CHOinformation_REQ_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CHOinformation_REQ_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CHOinformation_REQ_iE_Extensions__item__criticality._const_tab = ____CHOinformation_REQ_iE_Extensions__item__criticality_tab
    ___CHOinformation_REQ_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CHOinformation_REQ_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CHOinformation_REQ_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CHOinformation_REQ_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CHOinformation_REQ_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CHOinformation_REQ_iE_Extensions__item__extensionValue._const_tab = ____CHOinformation_REQ_iE_Extensions__item__extensionValue_tab
    ___CHOinformation_REQ_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CHOinformation_REQ_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CHOinformation_REQ_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CHOinformation_REQ_iE_Extensions__item__id),
        ('criticality', ___CHOinformation_REQ_iE_Extensions__item__criticality),
        ('extensionValue', ___CHOinformation_REQ_iE_Extensions__item__extensionValue),
        ])
    __CHOinformation_REQ_iE_Extensions__item_._ext = None
    _CHOinformation_REQ_iE_Extensions._cont = __CHOinformation_REQ_iE_Extensions__item_
    _CHOinformation_REQ_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CHOinformation_REQ._cont = ASN1Dict([
        ('cho-trigger', _CHOinformation_REQ_cho_trigger),
        ('new-eNB-UE-X2AP-ID', _CHOinformation_REQ_new_eNB_UE_X2AP_ID),
        ('new-eNB-UE-X2AP-ID-Extension', _CHOinformation_REQ_new_eNB_UE_X2AP_ID_Extension),
        ('cHO-EstimatedArrivalProbability', _CHOinformation_REQ_cHO_EstimatedArrivalProbability),
        ('iE-Extensions', _CHOinformation_REQ_iE_Extensions),
        ])
    CHOinformation_REQ._ext = []
    
    #-----< CHOinformation-REQ-ExtIEs >-----#
    CHOinformation_REQ_ExtIEs = CLASS(name='CHOinformation-REQ-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    CHOinformation_REQ_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CHOinformation-ACK >-----#
    CHOinformation_ACK = SEQ(name='CHOinformation-ACK', mode=MODE_TYPE)
    _CHOinformation_ACK_requestedTargetCellID = SEQ(name='requestedTargetCellID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _CHOinformation_ACK_maxCHOpreparations = INT(name='maxCHOpreparations', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'MaxCHOpreparations')), opt=True)
    _CHOinformation_ACK_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CHOinformation_ACK_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___CHOinformation_ACK_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____CHOinformation_ACK_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CHOinformation_ACK_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CHOinformation_ACK_iE_Extensions__item__id._const_tab = ____CHOinformation_ACK_iE_Extensions__item__id_tab
    ___CHOinformation_ACK_iE_Extensions__item__id._const_tab_at = None
    ___CHOinformation_ACK_iE_Extensions__item__id._const_tab_id = 'id'
    ___CHOinformation_ACK_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CHOinformation_ACK_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CHOinformation_ACK_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CHOinformation_ACK_iE_Extensions__item__criticality._const_tab = ____CHOinformation_ACK_iE_Extensions__item__criticality_tab
    ___CHOinformation_ACK_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CHOinformation_ACK_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CHOinformation_ACK_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CHOinformation_ACK_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CHOinformation_ACK_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CHOinformation_ACK_iE_Extensions__item__extensionValue._const_tab = ____CHOinformation_ACK_iE_Extensions__item__extensionValue_tab
    ___CHOinformation_ACK_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CHOinformation_ACK_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CHOinformation_ACK_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CHOinformation_ACK_iE_Extensions__item__id),
        ('criticality', ___CHOinformation_ACK_iE_Extensions__item__criticality),
        ('extensionValue', ___CHOinformation_ACK_iE_Extensions__item__extensionValue),
        ])
    __CHOinformation_ACK_iE_Extensions__item_._ext = None
    _CHOinformation_ACK_iE_Extensions._cont = __CHOinformation_ACK_iE_Extensions__item_
    _CHOinformation_ACK_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CHOinformation_ACK._cont = ASN1Dict([
        ('requestedTargetCellID', _CHOinformation_ACK_requestedTargetCellID),
        ('maxCHOpreparations', _CHOinformation_ACK_maxCHOpreparations),
        ('iE-Extensions', _CHOinformation_ACK_iE_Extensions),
        ])
    CHOinformation_ACK._ext = []
    
    #-----< CHOinformation-ACK-ExtIEs >-----#
    CHOinformation_ACK_ExtIEs = CLASS(name='CHOinformation-ACK-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    CHOinformation_ACK_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CandidateCellsToBeCancelledList >-----#
    CandidateCellsToBeCancelledList = SEQ_OF(name='CandidateCellsToBeCancelledList', mode=MODE_TYPE)
    _CandidateCellsToBeCancelledList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    CandidateCellsToBeCancelledList._cont = _CandidateCellsToBeCancelledList__item_
    CandidateCellsToBeCancelledList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< CHO-Probability >-----#
    CHO_Probability = INT(name='CHO-Probability', mode=MODE_TYPE)
    CHO_Probability._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    
    #-----< CHOinformation-AddReq >-----#
    CHOinformation_AddReq = SEQ(name='CHOinformation-AddReq', mode=MODE_TYPE)
    _CHOinformation_AddReq_source_eNB_ID = SEQ(name='source-eNB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GlobalENB-ID')))
    _CHOinformation_AddReq_source_eNB_UE_X2AP_ID = INT(name='source-eNB-UE-X2AP-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _CHOinformation_AddReq_source_eNB_UE_X2AP_ID_Ext = INT(name='source-eNB-UE-X2AP-ID-Ext', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')), opt=True)
    _CHOinformation_AddReq_cHO_EstimatedArrivalProbability = INT(name='cHO-EstimatedArrivalProbability', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CHO-Probability')), opt=True)
    _CHOinformation_AddReq_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CHOinformation_AddReq_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___CHOinformation_AddReq_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____CHOinformation_AddReq_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CHOinformation_AddReq_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CHOinformation_AddReq_iE_Extensions__item__id._const_tab = ____CHOinformation_AddReq_iE_Extensions__item__id_tab
    ___CHOinformation_AddReq_iE_Extensions__item__id._const_tab_at = None
    ___CHOinformation_AddReq_iE_Extensions__item__id._const_tab_id = 'id'
    ___CHOinformation_AddReq_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CHOinformation_AddReq_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CHOinformation_AddReq_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CHOinformation_AddReq_iE_Extensions__item__criticality._const_tab = ____CHOinformation_AddReq_iE_Extensions__item__criticality_tab
    ___CHOinformation_AddReq_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CHOinformation_AddReq_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CHOinformation_AddReq_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CHOinformation_AddReq_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CHOinformation_AddReq_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CHOinformation_AddReq_iE_Extensions__item__extensionValue._const_tab = ____CHOinformation_AddReq_iE_Extensions__item__extensionValue_tab
    ___CHOinformation_AddReq_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CHOinformation_AddReq_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CHOinformation_AddReq_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CHOinformation_AddReq_iE_Extensions__item__id),
        ('criticality', ___CHOinformation_AddReq_iE_Extensions__item__criticality),
        ('extensionValue', ___CHOinformation_AddReq_iE_Extensions__item__extensionValue),
        ])
    __CHOinformation_AddReq_iE_Extensions__item_._ext = None
    _CHOinformation_AddReq_iE_Extensions._cont = __CHOinformation_AddReq_iE_Extensions__item_
    _CHOinformation_AddReq_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CHOinformation_AddReq._cont = ASN1Dict([
        ('source-eNB-ID', _CHOinformation_AddReq_source_eNB_ID),
        ('source-eNB-UE-X2AP-ID', _CHOinformation_AddReq_source_eNB_UE_X2AP_ID),
        ('source-eNB-UE-X2AP-ID-Ext', _CHOinformation_AddReq_source_eNB_UE_X2AP_ID_Ext),
        ('cHO-EstimatedArrivalProbability', _CHOinformation_AddReq_cHO_EstimatedArrivalProbability),
        ('iE-Extensions', _CHOinformation_AddReq_iE_Extensions),
        ])
    CHOinformation_AddReq._ext = []
    
    #-----< CHOinformation-AddReq-ExtIEs >-----#
    CHOinformation_AddReq_ExtIEs = CLASS(name='CHOinformation-AddReq-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    CHOinformation_AddReq_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CHOinformation-ModReq >-----#
    CHOinformation_ModReq = SEQ(name='CHOinformation-ModReq', mode=MODE_TYPE)
    _CHOinformation_ModReq_conditionalReconfig = ENUM(name='conditionalReconfig', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CHOinformation_ModReq_conditionalReconfig._cont = ASN1Dict([('intra-mn-cho', 0)])
    _CHOinformation_ModReq_conditionalReconfig._ext = []
    _CHOinformation_ModReq_cHO_EstimatedArrivalProbability = INT(name='cHO-EstimatedArrivalProbability', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CHO-Probability')), opt=True)
    _CHOinformation_ModReq_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CHOinformation_ModReq_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___CHOinformation_ModReq_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____CHOinformation_ModReq_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CHOinformation_ModReq_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CHOinformation_ModReq_iE_Extensions__item__id._const_tab = ____CHOinformation_ModReq_iE_Extensions__item__id_tab
    ___CHOinformation_ModReq_iE_Extensions__item__id._const_tab_at = None
    ___CHOinformation_ModReq_iE_Extensions__item__id._const_tab_id = 'id'
    ___CHOinformation_ModReq_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CHOinformation_ModReq_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CHOinformation_ModReq_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CHOinformation_ModReq_iE_Extensions__item__criticality._const_tab = ____CHOinformation_ModReq_iE_Extensions__item__criticality_tab
    ___CHOinformation_ModReq_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CHOinformation_ModReq_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CHOinformation_ModReq_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CHOinformation_ModReq_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CHOinformation_ModReq_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CHOinformation_ModReq_iE_Extensions__item__extensionValue._const_tab = ____CHOinformation_ModReq_iE_Extensions__item__extensionValue_tab
    ___CHOinformation_ModReq_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CHOinformation_ModReq_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CHOinformation_ModReq_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CHOinformation_ModReq_iE_Extensions__item__id),
        ('criticality', ___CHOinformation_ModReq_iE_Extensions__item__criticality),
        ('extensionValue', ___CHOinformation_ModReq_iE_Extensions__item__extensionValue),
        ])
    __CHOinformation_ModReq_iE_Extensions__item_._ext = None
    _CHOinformation_ModReq_iE_Extensions._cont = __CHOinformation_ModReq_iE_Extensions__item_
    _CHOinformation_ModReq_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CHOinformation_ModReq._cont = ASN1Dict([
        ('conditionalReconfig', _CHOinformation_ModReq_conditionalReconfig),
        ('cHO-EstimatedArrivalProbability', _CHOinformation_ModReq_cHO_EstimatedArrivalProbability),
        ('iE-Extensions', _CHOinformation_ModReq_iE_Extensions),
        ])
    CHOinformation_ModReq._ext = []
    
    #-----< CHOinformation-ModReq-ExtIEs >-----#
    CHOinformation_ModReq_ExtIEs = CLASS(name='CHOinformation-ModReq-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    CHOinformation_ModReq_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CSI-RSTransmissionIndication >-----#
    CSI_RSTransmissionIndication = ENUM(name='CSI-RSTransmissionIndication', mode=MODE_TYPE)
    CSI_RSTransmissionIndication._cont = ASN1Dict([('activated', 0), ('deactivated', 1)])
    CSI_RSTransmissionIndication._ext = []
    
    #-----< DataTrafficResources >-----#
    DataTrafficResources = BIT_STR(name='DataTrafficResources', mode=MODE_TYPE)
    DataTrafficResources._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=6, ub=17600)], ev=None, er=[])
    
    #-----< DataTrafficResourceIndication >-----#
    DataTrafficResourceIndication = SEQ(name='DataTrafficResourceIndication', mode=MODE_TYPE)
    _DataTrafficResourceIndication_activationSFN = INT(name='activationSFN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DataTrafficResourceIndication_activationSFN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1023)], ev=None, er=[])
    _DataTrafficResourceIndication_sharedResourceType = CHOICE(name='sharedResourceType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'SharedResourceType')))
    _DataTrafficResourceIndication_reservedSubframePattern = SEQ(name='reservedSubframePattern', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ReservedSubframePattern')), opt=True)
    _DataTrafficResourceIndication_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DataTrafficResourceIndication_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___DataTrafficResourceIndication_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____DataTrafficResourceIndication_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____DataTrafficResourceIndication_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DataTrafficResourceIndication_iE_Extensions__item__id._const_tab = ____DataTrafficResourceIndication_iE_Extensions__item__id_tab
    ___DataTrafficResourceIndication_iE_Extensions__item__id._const_tab_at = None
    ___DataTrafficResourceIndication_iE_Extensions__item__id._const_tab_id = 'id'
    ___DataTrafficResourceIndication_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DataTrafficResourceIndication_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____DataTrafficResourceIndication_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DataTrafficResourceIndication_iE_Extensions__item__criticality._const_tab = ____DataTrafficResourceIndication_iE_Extensions__item__criticality_tab
    ___DataTrafficResourceIndication_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DataTrafficResourceIndication_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DataTrafficResourceIndication_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DataTrafficResourceIndication_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____DataTrafficResourceIndication_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DataTrafficResourceIndication_iE_Extensions__item__extensionValue._const_tab = ____DataTrafficResourceIndication_iE_Extensions__item__extensionValue_tab
    ___DataTrafficResourceIndication_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DataTrafficResourceIndication_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DataTrafficResourceIndication_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DataTrafficResourceIndication_iE_Extensions__item__id),
        ('criticality', ___DataTrafficResourceIndication_iE_Extensions__item__criticality),
        ('extensionValue', ___DataTrafficResourceIndication_iE_Extensions__item__extensionValue),
        ])
    __DataTrafficResourceIndication_iE_Extensions__item_._ext = None
    _DataTrafficResourceIndication_iE_Extensions._cont = __DataTrafficResourceIndication_iE_Extensions__item_
    _DataTrafficResourceIndication_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DataTrafficResourceIndication._cont = ASN1Dict([
        ('activationSFN', _DataTrafficResourceIndication_activationSFN),
        ('sharedResourceType', _DataTrafficResourceIndication_sharedResourceType),
        ('reservedSubframePattern', _DataTrafficResourceIndication_reservedSubframePattern),
        ('iE-Extensions', _DataTrafficResourceIndication_iE_Extensions),
        ])
    DataTrafficResourceIndication._ext = []
    
    #-----< DataTrafficResourceIndication-ExtIEs >-----#
    DataTrafficResourceIndication_ExtIEs = CLASS(name='DataTrafficResourceIndication-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    DataTrafficResourceIndication_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DAPSRequestInfo >-----#
    DAPSRequestInfo = SEQ(name='DAPSRequestInfo', mode=MODE_TYPE)
    _DAPSRequestInfo_dAPSIndicator = ENUM(name='dAPSIndicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DAPSRequestInfo_dAPSIndicator._cont = ASN1Dict([('daps-HO-required', 0)])
    _DAPSRequestInfo_dAPSIndicator._ext = []
    _DAPSRequestInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DAPSRequestInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___DAPSRequestInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____DAPSRequestInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____DAPSRequestInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DAPSRequestInfo_iE_Extensions__item__id._const_tab = ____DAPSRequestInfo_iE_Extensions__item__id_tab
    ___DAPSRequestInfo_iE_Extensions__item__id._const_tab_at = None
    ___DAPSRequestInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___DAPSRequestInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DAPSRequestInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____DAPSRequestInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DAPSRequestInfo_iE_Extensions__item__criticality._const_tab = ____DAPSRequestInfo_iE_Extensions__item__criticality_tab
    ___DAPSRequestInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DAPSRequestInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DAPSRequestInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DAPSRequestInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____DAPSRequestInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DAPSRequestInfo_iE_Extensions__item__extensionValue._const_tab = ____DAPSRequestInfo_iE_Extensions__item__extensionValue_tab
    ___DAPSRequestInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DAPSRequestInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DAPSRequestInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DAPSRequestInfo_iE_Extensions__item__id),
        ('criticality', ___DAPSRequestInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___DAPSRequestInfo_iE_Extensions__item__extensionValue),
        ])
    __DAPSRequestInfo_iE_Extensions__item_._ext = None
    _DAPSRequestInfo_iE_Extensions._cont = __DAPSRequestInfo_iE_Extensions__item_
    _DAPSRequestInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DAPSRequestInfo._cont = ASN1Dict([
        ('dAPSIndicator', _DAPSRequestInfo_dAPSIndicator),
        ('iE-Extensions', _DAPSRequestInfo_iE_Extensions),
        ])
    DAPSRequestInfo._ext = []
    
    #-----< DAPSRequestInfo-ExtIEs >-----#
    DAPSRequestInfo_ExtIEs = CLASS(name='DAPSRequestInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    DAPSRequestInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DAPSResponseInfo >-----#
    DAPSResponseInfo = SEQ(name='DAPSResponseInfo', mode=MODE_TYPE)
    _DAPSResponseInfo_dAPSResponseIndicator = ENUM(name='dAPSResponseIndicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DAPSResponseInfo_dAPSResponseIndicator._cont = ASN1Dict([('daps-HO-accepted', 0), ('daps-HO-not-accepted', 1)])
    _DAPSResponseInfo_dAPSResponseIndicator._ext = []
    _DAPSResponseInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DAPSResponseInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___DAPSResponseInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____DAPSResponseInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____DAPSResponseInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DAPSResponseInfo_iE_Extensions__item__id._const_tab = ____DAPSResponseInfo_iE_Extensions__item__id_tab
    ___DAPSResponseInfo_iE_Extensions__item__id._const_tab_at = None
    ___DAPSResponseInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___DAPSResponseInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DAPSResponseInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____DAPSResponseInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DAPSResponseInfo_iE_Extensions__item__criticality._const_tab = ____DAPSResponseInfo_iE_Extensions__item__criticality_tab
    ___DAPSResponseInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DAPSResponseInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DAPSResponseInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DAPSResponseInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____DAPSResponseInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DAPSResponseInfo_iE_Extensions__item__extensionValue._const_tab = ____DAPSResponseInfo_iE_Extensions__item__extensionValue_tab
    ___DAPSResponseInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DAPSResponseInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DAPSResponseInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DAPSResponseInfo_iE_Extensions__item__id),
        ('criticality', ___DAPSResponseInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___DAPSResponseInfo_iE_Extensions__item__extensionValue),
        ])
    __DAPSResponseInfo_iE_Extensions__item_._ext = None
    _DAPSResponseInfo_iE_Extensions._cont = __DAPSResponseInfo_iE_Extensions__item_
    _DAPSResponseInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DAPSResponseInfo._cont = ASN1Dict([
        ('dAPSResponseIndicator', _DAPSResponseInfo_dAPSResponseIndicator),
        ('iE-Extensions', _DAPSResponseInfo_iE_Extensions),
        ])
    DAPSResponseInfo._ext = []
    
    #-----< DAPSResponseInfo-ExtIEs >-----#
    DAPSResponseInfo_ExtIEs = CLASS(name='DAPSResponseInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    DAPSResponseInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DeactivationIndication >-----#
    DeactivationIndication = ENUM(name='DeactivationIndication', mode=MODE_TYPE)
    DeactivationIndication._cont = ASN1Dict([('deactivated', 0)])
    DeactivationIndication._ext = []
    
    #-----< DeliveryStatus >-----#
    DeliveryStatus = SEQ(name='DeliveryStatus', mode=MODE_TYPE)
    _DeliveryStatus_highestSuccessDeliveredPDCPSN = INT(name='highestSuccessDeliveredPDCPSN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DeliveryStatus_highestSuccessDeliveredPDCPSN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    _DeliveryStatus_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DeliveryStatus_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___DeliveryStatus_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____DeliveryStatus_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____DeliveryStatus_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DeliveryStatus_iE_Extensions__item__id._const_tab = ____DeliveryStatus_iE_Extensions__item__id_tab
    ___DeliveryStatus_iE_Extensions__item__id._const_tab_at = None
    ___DeliveryStatus_iE_Extensions__item__id._const_tab_id = 'id'
    ___DeliveryStatus_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DeliveryStatus_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____DeliveryStatus_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DeliveryStatus_iE_Extensions__item__criticality._const_tab = ____DeliveryStatus_iE_Extensions__item__criticality_tab
    ___DeliveryStatus_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DeliveryStatus_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DeliveryStatus_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DeliveryStatus_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____DeliveryStatus_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DeliveryStatus_iE_Extensions__item__extensionValue._const_tab = ____DeliveryStatus_iE_Extensions__item__extensionValue_tab
    ___DeliveryStatus_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DeliveryStatus_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DeliveryStatus_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DeliveryStatus_iE_Extensions__item__id),
        ('criticality', ___DeliveryStatus_iE_Extensions__item__criticality),
        ('extensionValue', ___DeliveryStatus_iE_Extensions__item__extensionValue),
        ])
    __DeliveryStatus_iE_Extensions__item_._ext = None
    _DeliveryStatus_iE_Extensions._cont = __DeliveryStatus_iE_Extensions__item_
    _DeliveryStatus_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DeliveryStatus._cont = ASN1Dict([
        ('highestSuccessDeliveredPDCPSN', _DeliveryStatus_highestSuccessDeliveredPDCPSN),
        ('iE-Extensions', _DeliveryStatus_iE_Extensions),
        ])
    DeliveryStatus._ext = []
    
    #-----< DeliveryStatus-ExtIEs >-----#
    DeliveryStatus_ExtIEs = CLASS(name='DeliveryStatus-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    DeliveryStatus_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DesiredActNotificationLevel >-----#
    DesiredActNotificationLevel = ENUM(name='DesiredActNotificationLevel', mode=MODE_TYPE)
    DesiredActNotificationLevel._cont = ASN1Dict([('none', 0), ('e-rab', 1), ('ue-level', 2)])
    DesiredActNotificationLevel._ext = []
    
    #-----< DirectForwardingPathAvailability >-----#
    DirectForwardingPathAvailability = ENUM(name='DirectForwardingPathAvailability', mode=MODE_TYPE)
    DirectForwardingPathAvailability._cont = ASN1Dict([('direct-path-available', 0)])
    DirectForwardingPathAvailability._ext = []
    
    #-----< DL-ABS-status >-----#
    DL_ABS_status = INT(name='DL-ABS-status', mode=MODE_TYPE)
    DL_ABS_status._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    
    #-----< DL-Forwarding >-----#
    DL_Forwarding = ENUM(name='DL-Forwarding', mode=MODE_TYPE)
    DL_Forwarding._cont = ASN1Dict([('dL-forwardingProposed', 0)])
    DL_Forwarding._ext = []
    
    #-----< DL-GBR-PRB-usage >-----#
    DL_GBR_PRB_usage = INT(name='DL-GBR-PRB-usage', mode=MODE_TYPE)
    DL_GBR_PRB_usage._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    
    #-----< DL-GBR-PRB-usage-for-MIMO >-----#
    DL_GBR_PRB_usage_for_MIMO = INT(name='DL-GBR-PRB-usage-for-MIMO', mode=MODE_TYPE)
    DL_GBR_PRB_usage_for_MIMO._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    
    #-----< DL-non-GBR-PRB-usage >-----#
    DL_non_GBR_PRB_usage = INT(name='DL-non-GBR-PRB-usage', mode=MODE_TYPE)
    DL_non_GBR_PRB_usage._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    
    #-----< DL-non-GBR-PRB-usage-for-MIMO >-----#
    DL_non_GBR_PRB_usage_for_MIMO = INT(name='DL-non-GBR-PRB-usage-for-MIMO', mode=MODE_TYPE)
    DL_non_GBR_PRB_usage_for_MIMO._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    
    #-----< DLResourceBitmapULandDLSharing >-----#
    DLResourceBitmapULandDLSharing = BIT_STR(name='DLResourceBitmapULandDLSharing', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'DataTrafficResources')))
    
    #-----< DLResourcesULandDLSharing >-----#
    DLResourcesULandDLSharing = CHOICE(name='DLResourcesULandDLSharing', mode=MODE_TYPE)
    _DLResourcesULandDLSharing_unchanged = NULL(name='unchanged', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DLResourcesULandDLSharing_changed = BIT_STR(name='changed', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'DLResourceBitmapULandDLSharing')))
    DLResourcesULandDLSharing._cont = ASN1Dict([
        ('unchanged', _DLResourcesULandDLSharing_unchanged),
        ('changed', _DLResourcesULandDLSharing_changed),
        ])
    DLResourcesULandDLSharing._ext = []
    
    #-----< DL-scheduling-PDCCH-CCE-usage >-----#
    DL_scheduling_PDCCH_CCE_usage = INT(name='DL-scheduling-PDCCH-CCE-usage', mode=MODE_TYPE)
    DL_scheduling_PDCCH_CCE_usage._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    
    #-----< DL-Total-PRB-usage >-----#
    DL_Total_PRB_usage = INT(name='DL-Total-PRB-usage', mode=MODE_TYPE)
    DL_Total_PRB_usage._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    
    #-----< DL-Total-PRB-usage-for-MIMO >-----#
    DL_Total_PRB_usage_for_MIMO = INT(name='DL-Total-PRB-usage-for-MIMO', mode=MODE_TYPE)
    DL_Total_PRB_usage_for_MIMO._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    
    #-----< DRB-ID >-----#
    DRB_ID = INT(name='DRB-ID', mode=MODE_TYPE)
    DRB_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< DuplicationActivation >-----#
    DuplicationActivation = ENUM(name='DuplicationActivation', mode=MODE_TYPE)
    DuplicationActivation._cont = ASN1Dict([('active', 0), ('inactive', 1)])
    DuplicationActivation._ext = []
    
    #-----< DynamicDLTransmissionInformation >-----#
    DynamicDLTransmissionInformation = CHOICE(name='DynamicDLTransmissionInformation', mode=MODE_TYPE)
    _DynamicDLTransmissionInformation_naics_active = SEQ(name='naics-active', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'DynamicNAICSInformation')))
    _DynamicDLTransmissionInformation_naics_inactive = NULL(name='naics-inactive', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    DynamicDLTransmissionInformation._cont = ASN1Dict([
        ('naics-active', _DynamicDLTransmissionInformation_naics_active),
        ('naics-inactive', _DynamicDLTransmissionInformation_naics_inactive),
        ])
    DynamicDLTransmissionInformation._ext = []
    
    #-----< DynamicNAICSInformation >-----#
    DynamicNAICSInformation = SEQ(name='DynamicNAICSInformation', mode=MODE_TYPE)
    _DynamicNAICSInformation_transmissionModes = BIT_STR(name='transmissionModes', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DynamicNAICSInformation_transmissionModes._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _DynamicNAICSInformation_pB_information = INT(name='pB-information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DynamicNAICSInformation_pB_information._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=None, er=[])
    _DynamicNAICSInformation_pA_list = SEQ_OF(name='pA-list', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __DynamicNAICSInformation_pA_list__item_ = ENUM(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PA-Values')))
    _DynamicNAICSInformation_pA_list._cont = __DynamicNAICSInformation_pA_list__item_
    _DynamicNAICSInformation_pA_list._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=None, er=[])
    _DynamicNAICSInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DynamicNAICSInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___DynamicNAICSInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____DynamicNAICSInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____DynamicNAICSInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DynamicNAICSInformation_iE_Extensions__item__id._const_tab = ____DynamicNAICSInformation_iE_Extensions__item__id_tab
    ___DynamicNAICSInformation_iE_Extensions__item__id._const_tab_at = None
    ___DynamicNAICSInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___DynamicNAICSInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DynamicNAICSInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____DynamicNAICSInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DynamicNAICSInformation_iE_Extensions__item__criticality._const_tab = ____DynamicNAICSInformation_iE_Extensions__item__criticality_tab
    ___DynamicNAICSInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DynamicNAICSInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DynamicNAICSInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DynamicNAICSInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____DynamicNAICSInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DynamicNAICSInformation_iE_Extensions__item__extensionValue._const_tab = ____DynamicNAICSInformation_iE_Extensions__item__extensionValue_tab
    ___DynamicNAICSInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DynamicNAICSInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DynamicNAICSInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DynamicNAICSInformation_iE_Extensions__item__id),
        ('criticality', ___DynamicNAICSInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___DynamicNAICSInformation_iE_Extensions__item__extensionValue),
        ])
    __DynamicNAICSInformation_iE_Extensions__item_._ext = None
    _DynamicNAICSInformation_iE_Extensions._cont = __DynamicNAICSInformation_iE_Extensions__item_
    _DynamicNAICSInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DynamicNAICSInformation._cont = ASN1Dict([
        ('transmissionModes', _DynamicNAICSInformation_transmissionModes),
        ('pB-information', _DynamicNAICSInformation_pB_information),
        ('pA-list', _DynamicNAICSInformation_pA_list),
        ('iE-Extensions', _DynamicNAICSInformation_iE_Extensions),
        ])
    DynamicNAICSInformation._ext = []
    
    #-----< DynamicNAICSInformation-ExtIEs >-----#
    DynamicNAICSInformation_ExtIEs = CLASS(name='DynamicNAICSInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    DynamicNAICSInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EARFCN >-----#
    EARFCN = INT(name='EARFCN', mode=MODE_TYPE)
    EARFCN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< EARFCNExtension >-----#
    EARFCNExtension = INT(name='EARFCNExtension', mode=MODE_TYPE)
    EARFCNExtension._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=65536, ub=262143)], ev=[], er=[])
    
    #-----< ECGI >-----#
    ECGI = SEQ(name='ECGI', mode=MODE_TYPE)
    _ECGI_pLMN_Identity = OCT_STR(name='pLMN-Identity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'PLMN-Identity')))
    _ECGI_eUTRANcellIdentifier = BIT_STR(name='eUTRANcellIdentifier', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'EUTRANCellIdentifier')))
    _ECGI_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ECGI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___ECGI_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____ECGI_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ECGI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ECGI_iE_Extensions__item__id._const_tab = ____ECGI_iE_Extensions__item__id_tab
    ___ECGI_iE_Extensions__item__id._const_tab_at = None
    ___ECGI_iE_Extensions__item__id._const_tab_id = 'id'
    ___ECGI_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ECGI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ECGI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ECGI_iE_Extensions__item__criticality._const_tab = ____ECGI_iE_Extensions__item__criticality_tab
    ___ECGI_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ECGI_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ECGI_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ECGI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ECGI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ECGI_iE_Extensions__item__extensionValue._const_tab = ____ECGI_iE_Extensions__item__extensionValue_tab
    ___ECGI_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ECGI_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ECGI_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ECGI_iE_Extensions__item__id),
        ('criticality', ___ECGI_iE_Extensions__item__criticality),
        ('extensionValue', ___ECGI_iE_Extensions__item__extensionValue),
        ])
    __ECGI_iE_Extensions__item_._ext = None
    _ECGI_iE_Extensions._cont = __ECGI_iE_Extensions__item_
    _ECGI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ECGI._cont = ASN1Dict([
        ('pLMN-Identity', _ECGI_pLMN_Identity),
        ('eUTRANcellIdentifier', _ECGI_eUTRANcellIdentifier),
        ('iE-Extensions', _ECGI_iE_Extensions),
        ])
    ECGI._ext = []
    
    #-----< ECGI-ExtIEs >-----#
    ECGI_ExtIEs = CLASS(name='ECGI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ECGI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EndcSONConfigurationTransfer >-----#
    EndcSONConfigurationTransfer = OCT_STR(name='EndcSONConfigurationTransfer', mode=MODE_TYPE)
    
    #-----< EnhancedRNTP >-----#
    EnhancedRNTP = SEQ(name='EnhancedRNTP', mode=MODE_TYPE)
    _EnhancedRNTP_enhancedRNTPBitmap = BIT_STR(name='enhancedRNTPBitmap', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EnhancedRNTP_enhancedRNTPBitmap._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=12, ub=8800)], ev=[], er=[])
    _EnhancedRNTP_rNTP_High_Power_Threshold = ENUM(name='rNTP-High-Power-Threshold', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'RNTP-Threshold')))
    _EnhancedRNTP_enhancedRNTPStartTime = SEQ(name='enhancedRNTPStartTime', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'EnhancedRNTPStartTime')), opt=True)
    _EnhancedRNTP_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EnhancedRNTP_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___EnhancedRNTP_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____EnhancedRNTP_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____EnhancedRNTP_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EnhancedRNTP_iE_Extensions__item__id._const_tab = ____EnhancedRNTP_iE_Extensions__item__id_tab
    ___EnhancedRNTP_iE_Extensions__item__id._const_tab_at = None
    ___EnhancedRNTP_iE_Extensions__item__id._const_tab_id = 'id'
    ___EnhancedRNTP_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____EnhancedRNTP_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____EnhancedRNTP_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EnhancedRNTP_iE_Extensions__item__criticality._const_tab = ____EnhancedRNTP_iE_Extensions__item__criticality_tab
    ___EnhancedRNTP_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___EnhancedRNTP_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___EnhancedRNTP_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____EnhancedRNTP_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____EnhancedRNTP_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EnhancedRNTP_iE_Extensions__item__extensionValue._const_tab = ____EnhancedRNTP_iE_Extensions__item__extensionValue_tab
    ___EnhancedRNTP_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___EnhancedRNTP_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __EnhancedRNTP_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___EnhancedRNTP_iE_Extensions__item__id),
        ('criticality', ___EnhancedRNTP_iE_Extensions__item__criticality),
        ('extensionValue', ___EnhancedRNTP_iE_Extensions__item__extensionValue),
        ])
    __EnhancedRNTP_iE_Extensions__item_._ext = None
    _EnhancedRNTP_iE_Extensions._cont = __EnhancedRNTP_iE_Extensions__item_
    _EnhancedRNTP_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EnhancedRNTP._cont = ASN1Dict([
        ('enhancedRNTPBitmap', _EnhancedRNTP_enhancedRNTPBitmap),
        ('rNTP-High-Power-Threshold', _EnhancedRNTP_rNTP_High_Power_Threshold),
        ('enhancedRNTPStartTime', _EnhancedRNTP_enhancedRNTPStartTime),
        ('iE-Extensions', _EnhancedRNTP_iE_Extensions),
        ])
    EnhancedRNTP._ext = []
    
    #-----< EnhancedRNTP-ExtIEs >-----#
    EnhancedRNTP_ExtIEs = CLASS(name='EnhancedRNTP-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    EnhancedRNTP_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EnhancedRNTPStartTime >-----#
    EnhancedRNTPStartTime = SEQ(name='EnhancedRNTPStartTime', mode=MODE_TYPE)
    _EnhancedRNTPStartTime_startSFN = INT(name='startSFN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EnhancedRNTPStartTime_startSFN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1023)], ev=[], er=[])
    _EnhancedRNTPStartTime_startSubframeNumber = INT(name='startSubframeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EnhancedRNTPStartTime_startSubframeNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=[], er=[])
    _EnhancedRNTPStartTime_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EnhancedRNTPStartTime_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___EnhancedRNTPStartTime_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____EnhancedRNTPStartTime_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____EnhancedRNTPStartTime_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EnhancedRNTPStartTime_iE_Extensions__item__id._const_tab = ____EnhancedRNTPStartTime_iE_Extensions__item__id_tab
    ___EnhancedRNTPStartTime_iE_Extensions__item__id._const_tab_at = None
    ___EnhancedRNTPStartTime_iE_Extensions__item__id._const_tab_id = 'id'
    ___EnhancedRNTPStartTime_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____EnhancedRNTPStartTime_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____EnhancedRNTPStartTime_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EnhancedRNTPStartTime_iE_Extensions__item__criticality._const_tab = ____EnhancedRNTPStartTime_iE_Extensions__item__criticality_tab
    ___EnhancedRNTPStartTime_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___EnhancedRNTPStartTime_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___EnhancedRNTPStartTime_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____EnhancedRNTPStartTime_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____EnhancedRNTPStartTime_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EnhancedRNTPStartTime_iE_Extensions__item__extensionValue._const_tab = ____EnhancedRNTPStartTime_iE_Extensions__item__extensionValue_tab
    ___EnhancedRNTPStartTime_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___EnhancedRNTPStartTime_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __EnhancedRNTPStartTime_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___EnhancedRNTPStartTime_iE_Extensions__item__id),
        ('criticality', ___EnhancedRNTPStartTime_iE_Extensions__item__criticality),
        ('extensionValue', ___EnhancedRNTPStartTime_iE_Extensions__item__extensionValue),
        ])
    __EnhancedRNTPStartTime_iE_Extensions__item_._ext = None
    _EnhancedRNTPStartTime_iE_Extensions._cont = __EnhancedRNTPStartTime_iE_Extensions__item_
    _EnhancedRNTPStartTime_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EnhancedRNTPStartTime._cont = ASN1Dict([
        ('startSFN', _EnhancedRNTPStartTime_startSFN),
        ('startSubframeNumber', _EnhancedRNTPStartTime_startSubframeNumber),
        ('iE-Extensions', _EnhancedRNTPStartTime_iE_Extensions),
        ])
    EnhancedRNTPStartTime._ext = []
    
    #-----< EnhancedRNTPStartTime-ExtIEs >-----#
    EnhancedRNTPStartTime_ExtIEs = CLASS(name='EnhancedRNTPStartTime-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    EnhancedRNTPStartTime_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ENB-ID >-----#
    ENB_ID = CHOICE(name='ENB-ID', mode=MODE_TYPE)
    _ENB_ID_macro_eNB_ID = BIT_STR(name='macro-eNB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ENB_ID_macro_eNB_ID._const_sz = ASN1Set(rv=[20], rr=[], ev=None, er=[])
    _ENB_ID_home_eNB_ID = BIT_STR(name='home-eNB-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ENB_ID_home_eNB_ID._const_sz = ASN1Set(rv=[28], rr=[], ev=None, er=[])
    _ENB_ID_short_Macro_eNB_ID = BIT_STR(name='short-Macro-eNB-ID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ENB_ID_short_Macro_eNB_ID._const_sz = ASN1Set(rv=[18], rr=[], ev=None, er=[])
    _ENB_ID_long_Macro_eNB_ID = BIT_STR(name='long-Macro-eNB-ID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ENB_ID_long_Macro_eNB_ID._const_sz = ASN1Set(rv=[21], rr=[], ev=None, er=[])
    ENB_ID._cont = ASN1Dict([
        ('macro-eNB-ID', _ENB_ID_macro_eNB_ID),
        ('home-eNB-ID', _ENB_ID_home_eNB_ID),
        ('short-Macro-eNB-ID', _ENB_ID_short_Macro_eNB_ID),
        ('long-Macro-eNB-ID', _ENB_ID_long_Macro_eNB_ID),
        ])
    ENB_ID._ext = ['short-Macro-eNB-ID', 'long-Macro-eNB-ID']
    
    #-----< EncryptionAlgorithms >-----#
    EncryptionAlgorithms = BIT_STR(name='EncryptionAlgorithms', mode=MODE_TYPE)
    EncryptionAlgorithms._const_sz = ASN1Set(rv=[16], rr=[], ev=[], er=[])
    
    #-----< EN-DC-ResourceConfiguration >-----#
    EN_DC_ResourceConfiguration = SEQ(name='EN-DC-ResourceConfiguration', mode=MODE_TYPE)
    _EN_DC_ResourceConfiguration_pDCPatSgNB = ENUM(name='pDCPatSgNB', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EN_DC_ResourceConfiguration_pDCPatSgNB._cont = ASN1Dict([('present', 0), ('not-present', 1)])
    _EN_DC_ResourceConfiguration_pDCPatSgNB._ext = []
    _EN_DC_ResourceConfiguration_mCGresources = ENUM(name='mCGresources', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EN_DC_ResourceConfiguration_mCGresources._cont = ASN1Dict([('present', 0), ('not-present', 1)])
    _EN_DC_ResourceConfiguration_mCGresources._ext = []
    _EN_DC_ResourceConfiguration_sCGresources = ENUM(name='sCGresources', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EN_DC_ResourceConfiguration_sCGresources._cont = ASN1Dict([('present', 0), ('not-present', 1)])
    _EN_DC_ResourceConfiguration_sCGresources._ext = []
    _EN_DC_ResourceConfiguration_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EN_DC_ResourceConfiguration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___EN_DC_ResourceConfiguration_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____EN_DC_ResourceConfiguration_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____EN_DC_ResourceConfiguration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EN_DC_ResourceConfiguration_iE_Extensions__item__id._const_tab = ____EN_DC_ResourceConfiguration_iE_Extensions__item__id_tab
    ___EN_DC_ResourceConfiguration_iE_Extensions__item__id._const_tab_at = None
    ___EN_DC_ResourceConfiguration_iE_Extensions__item__id._const_tab_id = 'id'
    ___EN_DC_ResourceConfiguration_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____EN_DC_ResourceConfiguration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____EN_DC_ResourceConfiguration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EN_DC_ResourceConfiguration_iE_Extensions__item__criticality._const_tab = ____EN_DC_ResourceConfiguration_iE_Extensions__item__criticality_tab
    ___EN_DC_ResourceConfiguration_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___EN_DC_ResourceConfiguration_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___EN_DC_ResourceConfiguration_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____EN_DC_ResourceConfiguration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____EN_DC_ResourceConfiguration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EN_DC_ResourceConfiguration_iE_Extensions__item__extensionValue._const_tab = ____EN_DC_ResourceConfiguration_iE_Extensions__item__extensionValue_tab
    ___EN_DC_ResourceConfiguration_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___EN_DC_ResourceConfiguration_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __EN_DC_ResourceConfiguration_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___EN_DC_ResourceConfiguration_iE_Extensions__item__id),
        ('criticality', ___EN_DC_ResourceConfiguration_iE_Extensions__item__criticality),
        ('extensionValue', ___EN_DC_ResourceConfiguration_iE_Extensions__item__extensionValue),
        ])
    __EN_DC_ResourceConfiguration_iE_Extensions__item_._ext = None
    _EN_DC_ResourceConfiguration_iE_Extensions._cont = __EN_DC_ResourceConfiguration_iE_Extensions__item_
    _EN_DC_ResourceConfiguration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EN_DC_ResourceConfiguration._cont = ASN1Dict([
        ('pDCPatSgNB', _EN_DC_ResourceConfiguration_pDCPatSgNB),
        ('mCGresources', _EN_DC_ResourceConfiguration_mCGresources),
        ('sCGresources', _EN_DC_ResourceConfiguration_sCGresources),
        ('iE-Extensions', _EN_DC_ResourceConfiguration_iE_Extensions),
        ])
    EN_DC_ResourceConfiguration._ext = []
    
    #-----< EN-DC-ResourceConfigurationExtIEs >-----#
    EN_DC_ResourceConfigurationExtIEs = CLASS(name='EN-DC-ResourceConfigurationExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    EN_DC_ResourceConfigurationExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EPCHandoverRestrictionListContainer >-----#
    EPCHandoverRestrictionListContainer = OCT_STR(name='EPCHandoverRestrictionListContainer', mode=MODE_TYPE)
    
    #-----< EPLMNs >-----#
    EPLMNs = SEQ_OF(name='EPLMNs', mode=MODE_TYPE)
    _EPLMNs__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PLMN-Identity')))
    EPLMNs._cont = _EPLMNs__item_
    EPLMNs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< ERABActivityNotifyItemList >-----#
    ERABActivityNotifyItemList = SEQ_OF(name='ERABActivityNotifyItemList', mode=MODE_TYPE)
    _ERABActivityNotifyItemList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ERABActivityNotifyItem')))
    ERABActivityNotifyItemList._cont = _ERABActivityNotifyItemList__item_
    ERABActivityNotifyItemList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=256)], ev=None, er=[])
    
    #-----< ERABActivityNotifyItem >-----#
    ERABActivityNotifyItem = SEQ(name='ERABActivityNotifyItem', mode=MODE_TYPE)
    _ERABActivityNotifyItem_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _ERABActivityNotifyItem_activityReport = ENUM(name='activityReport', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'UserPlaneTrafficActivityReport')))
    _ERABActivityNotifyItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ERABActivityNotifyItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___ERABActivityNotifyItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____ERABActivityNotifyItem_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ERABActivityNotifyItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ERABActivityNotifyItem_iE_Extensions__item__id._const_tab = ____ERABActivityNotifyItem_iE_Extensions__item__id_tab
    ___ERABActivityNotifyItem_iE_Extensions__item__id._const_tab_at = None
    ___ERABActivityNotifyItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___ERABActivityNotifyItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ERABActivityNotifyItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ERABActivityNotifyItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ERABActivityNotifyItem_iE_Extensions__item__criticality._const_tab = ____ERABActivityNotifyItem_iE_Extensions__item__criticality_tab
    ___ERABActivityNotifyItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ERABActivityNotifyItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ERABActivityNotifyItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ERABActivityNotifyItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ERABActivityNotifyItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ERABActivityNotifyItem_iE_Extensions__item__extensionValue._const_tab = ____ERABActivityNotifyItem_iE_Extensions__item__extensionValue_tab
    ___ERABActivityNotifyItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ERABActivityNotifyItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ERABActivityNotifyItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ERABActivityNotifyItem_iE_Extensions__item__id),
        ('criticality', ___ERABActivityNotifyItem_iE_Extensions__item__criticality),
        ('extensionValue', ___ERABActivityNotifyItem_iE_Extensions__item__extensionValue),
        ])
    __ERABActivityNotifyItem_iE_Extensions__item_._ext = None
    _ERABActivityNotifyItem_iE_Extensions._cont = __ERABActivityNotifyItem_iE_Extensions__item_
    _ERABActivityNotifyItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ERABActivityNotifyItem._cont = ASN1Dict([
        ('e-RAB-ID', _ERABActivityNotifyItem_e_RAB_ID),
        ('activityReport', _ERABActivityNotifyItem_activityReport),
        ('iE-Extensions', _ERABActivityNotifyItem_iE_Extensions),
        ])
    ERABActivityNotifyItem._ext = []
    
    #-----< ERABActivityNotifyItem-ExtIEs >-----#
    ERABActivityNotifyItem_ExtIEs = CLASS(name='ERABActivityNotifyItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ERABActivityNotifyItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RAB-ID >-----#
    E_RAB_ID = INT(name='E-RAB-ID', mode=MODE_TYPE)
    E_RAB_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=[], er=[])
    
    #-----< E-RAB-Level-QoS-Parameters >-----#
    E_RAB_Level_QoS_Parameters = SEQ(name='E-RAB-Level-QoS-Parameters', mode=MODE_TYPE)
    _E_RAB_Level_QoS_Parameters_qCI = INT(name='qCI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'QCI')))
    _E_RAB_Level_QoS_Parameters_allocationAndRetentionPriority = SEQ(name='allocationAndRetentionPriority', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'AllocationAndRetentionPriority')))
    _E_RAB_Level_QoS_Parameters_gbrQosInformation = SEQ(name='gbrQosInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GBR-QosInformation')), opt=True)
    _E_RAB_Level_QoS_Parameters_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RAB_Level_QoS_Parameters_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RAB_Level_QoS_Parameters_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RAB_Level_QoS_Parameters_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____E_RAB_Level_QoS_Parameters_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Packet-LossRate')))
    _____E_RAB_Level_QoS_Parameters_iE_Extensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Packet-LossRate')))
    ____E_RAB_Level_QoS_Parameters_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 273), ('criticality', 'ignore'), ('Extension', _____E_RAB_Level_QoS_Parameters_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 274), ('criticality', 'ignore'), ('Extension', _____E_RAB_Level_QoS_Parameters_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_RAB_Level_QoS_Parameters_iE_Extensions__item__id._const_tab = ____E_RAB_Level_QoS_Parameters_iE_Extensions__item__id_tab
    ___E_RAB_Level_QoS_Parameters_iE_Extensions__item__id._const_tab_at = None
    ___E_RAB_Level_QoS_Parameters_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RAB_Level_QoS_Parameters_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___E_RAB_Level_QoS_Parameters_iE_Extensions__item__criticality._const_tab = ____E_RAB_Level_QoS_Parameters_iE_Extensions__item__id_tab
    ___E_RAB_Level_QoS_Parameters_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RAB_Level_QoS_Parameters_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RAB_Level_QoS_Parameters_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___E_RAB_Level_QoS_Parameters_iE_Extensions__item__extensionValue._const_tab = ____E_RAB_Level_QoS_Parameters_iE_Extensions__item__id_tab
    ___E_RAB_Level_QoS_Parameters_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RAB_Level_QoS_Parameters_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RAB_Level_QoS_Parameters_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RAB_Level_QoS_Parameters_iE_Extensions__item__id),
        ('criticality', ___E_RAB_Level_QoS_Parameters_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RAB_Level_QoS_Parameters_iE_Extensions__item__extensionValue),
        ])
    __E_RAB_Level_QoS_Parameters_iE_Extensions__item_._ext = None
    _E_RAB_Level_QoS_Parameters_iE_Extensions._cont = __E_RAB_Level_QoS_Parameters_iE_Extensions__item_
    _E_RAB_Level_QoS_Parameters_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RAB_Level_QoS_Parameters._cont = ASN1Dict([
        ('qCI', _E_RAB_Level_QoS_Parameters_qCI),
        ('allocationAndRetentionPriority', _E_RAB_Level_QoS_Parameters_allocationAndRetentionPriority),
        ('gbrQosInformation', _E_RAB_Level_QoS_Parameters_gbrQosInformation),
        ('iE-Extensions', _E_RAB_Level_QoS_Parameters_iE_Extensions),
        ])
    E_RAB_Level_QoS_Parameters._ext = []
    
    #-----< E-RAB-Level-QoS-Parameters-ExtIEs >-----#
    E_RAB_Level_QoS_Parameters_ExtIEs = CLASS(name='E-RAB-Level-QoS-Parameters-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _E_RAB_Level_QoS_Parameters_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Packet-LossRate')))
    _E_RAB_Level_QoS_Parameters_ExtIEs_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Packet-LossRate')))
    E_RAB_Level_QoS_Parameters_ExtIEs._val = ASN1Set(rv=[dict([('id', 273), ('criticality', 'ignore'), ('Extension', _E_RAB_Level_QoS_Parameters_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 274), ('criticality', 'ignore'), ('Extension', _E_RAB_Level_QoS_Parameters_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RAB-List >-----#
    E_RAB_List = SEQ_OF(name='E-RAB-List', mode=MODE_TYPE)
    _E_RAB_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __E_RAB_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ___E_RAB_List__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____E_RAB_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-Item')))
    ___E_RAB_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'ignore'), ('Value', ____E_RAB_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E_RAB_List__item__id._const_tab = ___E_RAB_List__item__id_tab
    __E_RAB_List__item__id._const_tab_at = None
    __E_RAB_List__item__id._const_tab_id = 'id'
    __E_RAB_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    __E_RAB_List__item__criticality._const_tab = ___E_RAB_List__item__id_tab
    __E_RAB_List__item__criticality._const_tab_at = ('..', 'id')
    __E_RAB_List__item__criticality._const_tab_id = 'criticality'
    __E_RAB_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    __E_RAB_List__item__value._const_tab = ___E_RAB_List__item__id_tab
    __E_RAB_List__item__value._const_tab_at = ('..', 'id')
    __E_RAB_List__item__value._const_tab_id = 'Value'
    _E_RAB_List__item_._cont = ASN1Dict([
        ('id', __E_RAB_List__item__id),
        ('criticality', __E_RAB_List__item__criticality),
        ('value', __E_RAB_List__item__value),
        ])
    _E_RAB_List__item_._ext = None
    E_RAB_List._cont = _E_RAB_List__item_
    E_RAB_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RAB-ItemIEs >-----#
    E_RAB_ItemIEs = CLASS(name='E-RAB-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _E_RAB_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-Item')))
    E_RAB_ItemIEs._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'ignore'), ('Value', _E_RAB_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RAB-Item >-----#
    E_RAB_Item = SEQ(name='E-RAB-Item', mode=MODE_TYPE)
    _E_RAB_Item_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RAB_Item_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _E_RAB_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RAB_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RAB_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RAB_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RAB_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RAB_Item_iE_Extensions__item__id._const_tab = ____E_RAB_Item_iE_Extensions__item__id_tab
    ___E_RAB_Item_iE_Extensions__item__id._const_tab_at = None
    ___E_RAB_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RAB_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_RAB_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RAB_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RAB_Item_iE_Extensions__item__criticality._const_tab = ____E_RAB_Item_iE_Extensions__item__criticality_tab
    ___E_RAB_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RAB_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RAB_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_RAB_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RAB_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RAB_Item_iE_Extensions__item__extensionValue._const_tab = ____E_RAB_Item_iE_Extensions__item__extensionValue_tab
    ___E_RAB_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RAB_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RAB_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RAB_Item_iE_Extensions__item__id),
        ('criticality', ___E_RAB_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RAB_Item_iE_Extensions__item__extensionValue),
        ])
    __E_RAB_Item_iE_Extensions__item_._ext = None
    _E_RAB_Item_iE_Extensions._cont = __E_RAB_Item_iE_Extensions__item_
    _E_RAB_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RAB_Item._cont = ASN1Dict([
        ('e-RAB-ID', _E_RAB_Item_e_RAB_ID),
        ('cause', _E_RAB_Item_cause),
        ('iE-Extensions', _E_RAB_Item_iE_Extensions),
        ])
    E_RAB_Item._ext = []
    
    #-----< E-RAB-Item-ExtIEs >-----#
    E_RAB_Item_ExtIEs = CLASS(name='E-RAB-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    E_RAB_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RABsSubjectToEarlyStatusTransfer-List >-----#
    E_RABsSubjectToEarlyStatusTransfer_List = SEQ_OF(name='E-RABsSubjectToEarlyStatusTransfer-List', mode=MODE_TYPE)
    _E_RABsSubjectToEarlyStatusTransfer_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'E-RABsSubjectToEarlyStatusTransfer-Item')))
    E_RABsSubjectToEarlyStatusTransfer_List._cont = _E_RABsSubjectToEarlyStatusTransfer_List__item_
    E_RABsSubjectToEarlyStatusTransfer_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABsSubjectToEarlyStatusTransfer-Item >-----#
    E_RABsSubjectToEarlyStatusTransfer_Item = SEQ(name='E-RABsSubjectToEarlyStatusTransfer-Item', mode=MODE_TYPE)
    _E_RABsSubjectToEarlyStatusTransfer_Item_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABsSubjectToEarlyStatusTransfer_Item_fIRST_DL_COUNTValue = SEQ(name='fIRST-DL-COUNTValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'COUNTvalue')))
    _E_RABsSubjectToEarlyStatusTransfer_Item_fIRST_DL_COUNTValueExtended = SEQ(name='fIRST-DL-COUNTValueExtended', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'COUNTValueExtended')), opt=True)
    _E_RABsSubjectToEarlyStatusTransfer_Item_fIRST_DL_COUNTValueforPDCPSNLength18 = SEQ(name='fIRST-DL-COUNTValueforPDCPSNLength18', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'COUNTvaluePDCP-SNlength18')), opt=True)
    _E_RABsSubjectToEarlyStatusTransfer_Item_iE_Extension = SEQ_OF(name='iE-Extension', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABsSubjectToEarlyStatusTransfer_Item_iE_Extension__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__id._const_tab = ____E_RABsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__id_tab
    ___E_RABsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__id._const_tab_at = None
    ___E_RABsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__id._const_tab_id = 'id'
    ___E_RABsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_RABsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__criticality._const_tab = ____E_RABsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__criticality_tab
    ___E_RABsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__criticality._const_tab_id = 'criticality'
    ___E_RABsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_RABsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__extensionValue._const_tab = ____E_RABsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__extensionValue_tab
    ___E_RABsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__extensionValue._const_tab_id = 'Extension'
    __E_RABsSubjectToEarlyStatusTransfer_Item_iE_Extension__item_._cont = ASN1Dict([
        ('id', ___E_RABsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__id),
        ('criticality', ___E_RABsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__criticality),
        ('extensionValue', ___E_RABsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__extensionValue),
        ])
    __E_RABsSubjectToEarlyStatusTransfer_Item_iE_Extension__item_._ext = None
    _E_RABsSubjectToEarlyStatusTransfer_Item_iE_Extension._cont = __E_RABsSubjectToEarlyStatusTransfer_Item_iE_Extension__item_
    _E_RABsSubjectToEarlyStatusTransfer_Item_iE_Extension._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABsSubjectToEarlyStatusTransfer_Item._cont = ASN1Dict([
        ('e-RAB-ID', _E_RABsSubjectToEarlyStatusTransfer_Item_e_RAB_ID),
        ('fIRST-DL-COUNTValue', _E_RABsSubjectToEarlyStatusTransfer_Item_fIRST_DL_COUNTValue),
        ('fIRST-DL-COUNTValueExtended', _E_RABsSubjectToEarlyStatusTransfer_Item_fIRST_DL_COUNTValueExtended),
        ('fIRST-DL-COUNTValueforPDCPSNLength18', _E_RABsSubjectToEarlyStatusTransfer_Item_fIRST_DL_COUNTValueforPDCPSNLength18),
        ('iE-Extension', _E_RABsSubjectToEarlyStatusTransfer_Item_iE_Extension),
        ])
    E_RABsSubjectToEarlyStatusTransfer_Item._ext = []
    
    #-----< E-RABsSubjectToEarlyStatusTransfer-Item-ExtIEs >-----#
    E_RABsSubjectToEarlyStatusTransfer_Item_ExtIEs = CLASS(name='E-RABsSubjectToEarlyStatusTransfer-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    E_RABsSubjectToEarlyStatusTransfer_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RABsSubjectToDLDiscarding-List >-----#
    E_RABsSubjectToDLDiscarding_List = SEQ_OF(name='E-RABsSubjectToDLDiscarding-List', mode=MODE_TYPE)
    _E_RABsSubjectToDLDiscarding_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'E-RABsSubjectToDLDiscarding-Item')))
    E_RABsSubjectToDLDiscarding_List._cont = _E_RABsSubjectToDLDiscarding_List__item_
    E_RABsSubjectToDLDiscarding_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABsSubjectToDLDiscarding-Item >-----#
    E_RABsSubjectToDLDiscarding_Item = SEQ(name='E-RABsSubjectToDLDiscarding-Item', mode=MODE_TYPE)
    _E_RABsSubjectToDLDiscarding_Item_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABsSubjectToDLDiscarding_Item_dISCARD_DL_COUNTValue = SEQ(name='dISCARD-DL-COUNTValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'COUNTvalue')))
    _E_RABsSubjectToDLDiscarding_Item_dISCARD_DL_COUNTValueExtended = SEQ(name='dISCARD-DL-COUNTValueExtended', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'COUNTValueExtended')), opt=True)
    _E_RABsSubjectToDLDiscarding_Item_dISCARD_DL_COUNTValueforPDCPSNLength18 = SEQ(name='dISCARD-DL-COUNTValueforPDCPSNLength18', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'COUNTvaluePDCP-SNlength18')), opt=True)
    _E_RABsSubjectToDLDiscarding_Item_iE_Extension = SEQ_OF(name='iE-Extension', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABsSubjectToDLDiscarding_Item_iE_Extension__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABsSubjectToDLDiscarding_Item_iE_Extension__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABsSubjectToDLDiscarding_Item_iE_Extension__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABsSubjectToDLDiscarding_Item_iE_Extension__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABsSubjectToDLDiscarding_Item_iE_Extension__item__id._const_tab = ____E_RABsSubjectToDLDiscarding_Item_iE_Extension__item__id_tab
    ___E_RABsSubjectToDLDiscarding_Item_iE_Extension__item__id._const_tab_at = None
    ___E_RABsSubjectToDLDiscarding_Item_iE_Extension__item__id._const_tab_id = 'id'
    ___E_RABsSubjectToDLDiscarding_Item_iE_Extension__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_RABsSubjectToDLDiscarding_Item_iE_Extension__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABsSubjectToDLDiscarding_Item_iE_Extension__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABsSubjectToDLDiscarding_Item_iE_Extension__item__criticality._const_tab = ____E_RABsSubjectToDLDiscarding_Item_iE_Extension__item__criticality_tab
    ___E_RABsSubjectToDLDiscarding_Item_iE_Extension__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABsSubjectToDLDiscarding_Item_iE_Extension__item__criticality._const_tab_id = 'criticality'
    ___E_RABsSubjectToDLDiscarding_Item_iE_Extension__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_RABsSubjectToDLDiscarding_Item_iE_Extension__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABsSubjectToDLDiscarding_Item_iE_Extension__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABsSubjectToDLDiscarding_Item_iE_Extension__item__extensionValue._const_tab = ____E_RABsSubjectToDLDiscarding_Item_iE_Extension__item__extensionValue_tab
    ___E_RABsSubjectToDLDiscarding_Item_iE_Extension__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABsSubjectToDLDiscarding_Item_iE_Extension__item__extensionValue._const_tab_id = 'Extension'
    __E_RABsSubjectToDLDiscarding_Item_iE_Extension__item_._cont = ASN1Dict([
        ('id', ___E_RABsSubjectToDLDiscarding_Item_iE_Extension__item__id),
        ('criticality', ___E_RABsSubjectToDLDiscarding_Item_iE_Extension__item__criticality),
        ('extensionValue', ___E_RABsSubjectToDLDiscarding_Item_iE_Extension__item__extensionValue),
        ])
    __E_RABsSubjectToDLDiscarding_Item_iE_Extension__item_._ext = None
    _E_RABsSubjectToDLDiscarding_Item_iE_Extension._cont = __E_RABsSubjectToDLDiscarding_Item_iE_Extension__item_
    _E_RABsSubjectToDLDiscarding_Item_iE_Extension._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABsSubjectToDLDiscarding_Item._cont = ASN1Dict([
        ('e-RAB-ID', _E_RABsSubjectToDLDiscarding_Item_e_RAB_ID),
        ('dISCARD-DL-COUNTValue', _E_RABsSubjectToDLDiscarding_Item_dISCARD_DL_COUNTValue),
        ('dISCARD-DL-COUNTValueExtended', _E_RABsSubjectToDLDiscarding_Item_dISCARD_DL_COUNTValueExtended),
        ('dISCARD-DL-COUNTValueforPDCPSNLength18', _E_RABsSubjectToDLDiscarding_Item_dISCARD_DL_COUNTValueforPDCPSNLength18),
        ('iE-Extension', _E_RABsSubjectToDLDiscarding_Item_iE_Extension),
        ])
    E_RABsSubjectToDLDiscarding_Item._ext = []
    
    #-----< E-RABsSubjectToDLDiscarding-Item-ExtIEs >-----#
    E_RABsSubjectToDLDiscarding_Item_ExtIEs = CLASS(name='E-RABsSubjectToDLDiscarding-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    E_RABsSubjectToDLDiscarding_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RABUsageReportList >-----#
    E_RABUsageReportList = SEQ_OF(name='E-RABUsageReportList', mode=MODE_TYPE)
    _E_RABUsageReportList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __E_RABUsageReportList__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ___E_RABUsageReportList__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____E_RABUsageReportList__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'E-RABUsageReport-Item')))
    ___E_RABUsageReportList__item__id_tab._val = ASN1Set(rv=[dict([('id', 263), ('criticality', 'ignore'), ('Value', ____E_RABUsageReportList__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E_RABUsageReportList__item__id._const_tab = ___E_RABUsageReportList__item__id_tab
    __E_RABUsageReportList__item__id._const_tab_at = None
    __E_RABUsageReportList__item__id._const_tab_id = 'id'
    __E_RABUsageReportList__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    __E_RABUsageReportList__item__criticality._const_tab = ___E_RABUsageReportList__item__id_tab
    __E_RABUsageReportList__item__criticality._const_tab_at = ('..', 'id')
    __E_RABUsageReportList__item__criticality._const_tab_id = 'criticality'
    __E_RABUsageReportList__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    __E_RABUsageReportList__item__value._const_tab = ___E_RABUsageReportList__item__id_tab
    __E_RABUsageReportList__item__value._const_tab_at = ('..', 'id')
    __E_RABUsageReportList__item__value._const_tab_id = 'Value'
    _E_RABUsageReportList__item_._cont = ASN1Dict([
        ('id', __E_RABUsageReportList__item__id),
        ('criticality', __E_RABUsageReportList__item__criticality),
        ('value', __E_RABUsageReportList__item__value),
        ])
    _E_RABUsageReportList__item_._ext = None
    E_RABUsageReportList._cont = _E_RABUsageReportList__item_
    E_RABUsageReportList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< E-RABUsageReport-ItemIEs >-----#
    E_RABUsageReport_ItemIEs = CLASS(name='E-RABUsageReport-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _E_RABUsageReport_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'E-RABUsageReport-Item')))
    E_RABUsageReport_ItemIEs._val = ASN1Set(rv=[dict([('id', 263), ('criticality', 'ignore'), ('Value', _E_RABUsageReport_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABUsageReport-Item >-----#
    E_RABUsageReport_Item = SEQ(name='E-RABUsageReport-Item', mode=MODE_TYPE)
    _E_RABUsageReport_Item_startTimeStamp = OCT_STR(name='startTimeStamp', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _E_RABUsageReport_Item_startTimeStamp._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _E_RABUsageReport_Item_endTimeStamp = OCT_STR(name='endTimeStamp', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _E_RABUsageReport_Item_endTimeStamp._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _E_RABUsageReport_Item_usageCountUL = INT(name='usageCountUL', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _E_RABUsageReport_Item_usageCountUL._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=18446744073709551615)], ev=None, er=[])
    _E_RABUsageReport_Item_usageCountDL = INT(name='usageCountDL', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _E_RABUsageReport_Item_usageCountDL._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=18446744073709551615)], ev=None, er=[])
    _E_RABUsageReport_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABUsageReport_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABUsageReport_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABUsageReport_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABUsageReport_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABUsageReport_Item_iE_Extensions__item__id._const_tab = ____E_RABUsageReport_Item_iE_Extensions__item__id_tab
    ___E_RABUsageReport_Item_iE_Extensions__item__id._const_tab_at = None
    ___E_RABUsageReport_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABUsageReport_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_RABUsageReport_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABUsageReport_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABUsageReport_Item_iE_Extensions__item__criticality._const_tab = ____E_RABUsageReport_Item_iE_Extensions__item__criticality_tab
    ___E_RABUsageReport_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABUsageReport_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABUsageReport_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_RABUsageReport_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABUsageReport_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABUsageReport_Item_iE_Extensions__item__extensionValue._const_tab = ____E_RABUsageReport_Item_iE_Extensions__item__extensionValue_tab
    ___E_RABUsageReport_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABUsageReport_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABUsageReport_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABUsageReport_Item_iE_Extensions__item__id),
        ('criticality', ___E_RABUsageReport_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABUsageReport_Item_iE_Extensions__item__extensionValue),
        ])
    __E_RABUsageReport_Item_iE_Extensions__item_._ext = None
    _E_RABUsageReport_Item_iE_Extensions._cont = __E_RABUsageReport_Item_iE_Extensions__item_
    _E_RABUsageReport_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABUsageReport_Item._cont = ASN1Dict([
        ('startTimeStamp', _E_RABUsageReport_Item_startTimeStamp),
        ('endTimeStamp', _E_RABUsageReport_Item_endTimeStamp),
        ('usageCountUL', _E_RABUsageReport_Item_usageCountUL),
        ('usageCountDL', _E_RABUsageReport_Item_usageCountDL),
        ('iE-Extensions', _E_RABUsageReport_Item_iE_Extensions),
        ])
    E_RABUsageReport_Item._ext = []
    
    #-----< E-RABUsageReport-Item-ExtIEs >-----#
    E_RABUsageReport_Item_ExtIEs = CLASS(name='E-RABUsageReport-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    E_RABUsageReport_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Ethernet-Type >-----#
    Ethernet_Type = ENUM(name='Ethernet-Type', mode=MODE_TYPE)
    Ethernet_Type._cont = ASN1Dict([('true', 0)])
    Ethernet_Type._ext = []
    
    #-----< EUTRA-Mode-Info >-----#
    EUTRA_Mode_Info = CHOICE(name='EUTRA-Mode-Info', mode=MODE_TYPE)
    _EUTRA_Mode_Info_fDD = SEQ(name='fDD', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'FDD-Info')))
    _EUTRA_Mode_Info_tDD = SEQ(name='tDD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'TDD-Info')))
    EUTRA_Mode_Info._cont = ASN1Dict([
        ('fDD', _EUTRA_Mode_Info_fDD),
        ('tDD', _EUTRA_Mode_Info_tDD),
        ])
    EUTRA_Mode_Info._ext = []
    
    #-----< EUTRANCellIdentifier >-----#
    EUTRANCellIdentifier = BIT_STR(name='EUTRANCellIdentifier', mode=MODE_TYPE)
    EUTRANCellIdentifier._const_sz = ASN1Set(rv=[28], rr=[], ev=None, er=[])
    
    #-----< EUTRANTraceID >-----#
    EUTRANTraceID = OCT_STR(name='EUTRANTraceID', mode=MODE_TYPE)
    EUTRANTraceID._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< EventType >-----#
    EventType = ENUM(name='EventType', mode=MODE_TYPE)
    EventType._cont = ASN1Dict([('change-of-serving-cell', 0)])
    EventType._ext = []
    
    #-----< ExpectedUEBehaviour >-----#
    ExpectedUEBehaviour = SEQ(name='ExpectedUEBehaviour', mode=MODE_TYPE)
    _ExpectedUEBehaviour_expectedActivity = SEQ(name='expectedActivity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ExpectedUEActivityBehaviour')), opt=True)
    _ExpectedUEBehaviour_expectedHOInterval = ENUM(name='expectedHOInterval', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ExpectedHOInterval')), opt=True)
    _ExpectedUEBehaviour_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ExpectedUEBehaviour_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___ExpectedUEBehaviour_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____ExpectedUEBehaviour_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ExpectedUEBehaviour_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExpectedUEBehaviour_iE_Extensions__item__id._const_tab = ____ExpectedUEBehaviour_iE_Extensions__item__id_tab
    ___ExpectedUEBehaviour_iE_Extensions__item__id._const_tab_at = None
    ___ExpectedUEBehaviour_iE_Extensions__item__id._const_tab_id = 'id'
    ___ExpectedUEBehaviour_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ExpectedUEBehaviour_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ExpectedUEBehaviour_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExpectedUEBehaviour_iE_Extensions__item__criticality._const_tab = ____ExpectedUEBehaviour_iE_Extensions__item__criticality_tab
    ___ExpectedUEBehaviour_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ExpectedUEBehaviour_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ExpectedUEBehaviour_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ExpectedUEBehaviour_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ExpectedUEBehaviour_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExpectedUEBehaviour_iE_Extensions__item__extensionValue._const_tab = ____ExpectedUEBehaviour_iE_Extensions__item__extensionValue_tab
    ___ExpectedUEBehaviour_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ExpectedUEBehaviour_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ExpectedUEBehaviour_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ExpectedUEBehaviour_iE_Extensions__item__id),
        ('criticality', ___ExpectedUEBehaviour_iE_Extensions__item__criticality),
        ('extensionValue', ___ExpectedUEBehaviour_iE_Extensions__item__extensionValue),
        ])
    __ExpectedUEBehaviour_iE_Extensions__item_._ext = None
    _ExpectedUEBehaviour_iE_Extensions._cont = __ExpectedUEBehaviour_iE_Extensions__item_
    _ExpectedUEBehaviour_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ExpectedUEBehaviour._cont = ASN1Dict([
        ('expectedActivity', _ExpectedUEBehaviour_expectedActivity),
        ('expectedHOInterval', _ExpectedUEBehaviour_expectedHOInterval),
        ('iE-Extensions', _ExpectedUEBehaviour_iE_Extensions),
        ])
    ExpectedUEBehaviour._ext = []
    
    #-----< ExpectedUEBehaviour-ExtIEs >-----#
    ExpectedUEBehaviour_ExtIEs = CLASS(name='ExpectedUEBehaviour-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ExpectedUEBehaviour_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ExpectedUEActivityBehaviour >-----#
    ExpectedUEActivityBehaviour = SEQ(name='ExpectedUEActivityBehaviour', mode=MODE_TYPE)
    _ExpectedUEActivityBehaviour_expectedActivityPeriod = INT(name='expectedActivityPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ExpectedActivityPeriod')), opt=True)
    _ExpectedUEActivityBehaviour_expectedIdlePeriod = INT(name='expectedIdlePeriod', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ExpectedIdlePeriod')), opt=True)
    _ExpectedUEActivityBehaviour_sourceofUEActivityBehaviourInformation = ENUM(name='sourceofUEActivityBehaviourInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'SourceOfUEActivityBehaviourInformation')), opt=True)
    _ExpectedUEActivityBehaviour_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ExpectedUEActivityBehaviour_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____ExpectedUEActivityBehaviour_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ExpectedUEActivityBehaviour_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__id._const_tab = ____ExpectedUEActivityBehaviour_iE_Extensions__item__id_tab
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__id._const_tab_at = None
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__id._const_tab_id = 'id'
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ExpectedUEActivityBehaviour_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ExpectedUEActivityBehaviour_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__criticality._const_tab = ____ExpectedUEActivityBehaviour_iE_Extensions__item__criticality_tab
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ExpectedUEActivityBehaviour_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ExpectedUEActivityBehaviour_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__extensionValue._const_tab = ____ExpectedUEActivityBehaviour_iE_Extensions__item__extensionValue_tab
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ExpectedUEActivityBehaviour_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ExpectedUEActivityBehaviour_iE_Extensions__item__id),
        ('criticality', ___ExpectedUEActivityBehaviour_iE_Extensions__item__criticality),
        ('extensionValue', ___ExpectedUEActivityBehaviour_iE_Extensions__item__extensionValue),
        ])
    __ExpectedUEActivityBehaviour_iE_Extensions__item_._ext = None
    _ExpectedUEActivityBehaviour_iE_Extensions._cont = __ExpectedUEActivityBehaviour_iE_Extensions__item_
    _ExpectedUEActivityBehaviour_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ExpectedUEActivityBehaviour._cont = ASN1Dict([
        ('expectedActivityPeriod', _ExpectedUEActivityBehaviour_expectedActivityPeriod),
        ('expectedIdlePeriod', _ExpectedUEActivityBehaviour_expectedIdlePeriod),
        ('sourceofUEActivityBehaviourInformation', _ExpectedUEActivityBehaviour_sourceofUEActivityBehaviourInformation),
        ('iE-Extensions', _ExpectedUEActivityBehaviour_iE_Extensions),
        ])
    ExpectedUEActivityBehaviour._ext = []
    
    #-----< ExpectedUEActivityBehaviour-ExtIEs >-----#
    ExpectedUEActivityBehaviour_ExtIEs = CLASS(name='ExpectedUEActivityBehaviour-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ExpectedUEActivityBehaviour_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ExpectedActivityPeriod >-----#
    ExpectedActivityPeriod = INT(name='ExpectedActivityPeriod', mode=MODE_TYPE)
    ExpectedActivityPeriod._const_val = ASN1Set(rv=[40, 50, 60, 80, 100, 120, 150, 180, 181], rr=[ASN1RangeInt(lb=1, ub=30)], ev=[], er=[])
    
    #-----< ExpectedIdlePeriod >-----#
    ExpectedIdlePeriod = INT(name='ExpectedIdlePeriod', mode=MODE_TYPE)
    ExpectedIdlePeriod._const_val = ASN1Set(rv=[40, 50, 60, 80, 100, 120, 150, 180, 181], rr=[ASN1RangeInt(lb=1, ub=30)], ev=[], er=[])
    
    #-----< ExpectedHOInterval >-----#
    ExpectedHOInterval = ENUM(name='ExpectedHOInterval', mode=MODE_TYPE)
    ExpectedHOInterval._cont = ASN1Dict([('sec15', 0), ('sec30', 1), ('sec60', 2), ('sec90', 3), ('sec120', 4), ('sec180', 5), ('long-time', 6)])
    ExpectedHOInterval._ext = []
    
    #-----< ExtendedULInterferenceOverloadInfo >-----#
    ExtendedULInterferenceOverloadInfo = SEQ(name='ExtendedULInterferenceOverloadInfo', mode=MODE_TYPE)
    _ExtendedULInterferenceOverloadInfo_associatedSubframes = BIT_STR(name='associatedSubframes', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ExtendedULInterferenceOverloadInfo_associatedSubframes._const_sz = ASN1Set(rv=[5], rr=[], ev=None, er=[])
    _ExtendedULInterferenceOverloadInfo_extended_ul_InterferenceOverloadIndication = SEQ_OF(name='extended-ul-InterferenceOverloadIndication', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'UL-InterferenceOverloadIndication')))
    _ExtendedULInterferenceOverloadInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ExtendedULInterferenceOverloadInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___ExtendedULInterferenceOverloadInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____ExtendedULInterferenceOverloadInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ExtendedULInterferenceOverloadInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExtendedULInterferenceOverloadInfo_iE_Extensions__item__id._const_tab = ____ExtendedULInterferenceOverloadInfo_iE_Extensions__item__id_tab
    ___ExtendedULInterferenceOverloadInfo_iE_Extensions__item__id._const_tab_at = None
    ___ExtendedULInterferenceOverloadInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___ExtendedULInterferenceOverloadInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ExtendedULInterferenceOverloadInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ExtendedULInterferenceOverloadInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExtendedULInterferenceOverloadInfo_iE_Extensions__item__criticality._const_tab = ____ExtendedULInterferenceOverloadInfo_iE_Extensions__item__criticality_tab
    ___ExtendedULInterferenceOverloadInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ExtendedULInterferenceOverloadInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ExtendedULInterferenceOverloadInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ExtendedULInterferenceOverloadInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ExtendedULInterferenceOverloadInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExtendedULInterferenceOverloadInfo_iE_Extensions__item__extensionValue._const_tab = ____ExtendedULInterferenceOverloadInfo_iE_Extensions__item__extensionValue_tab
    ___ExtendedULInterferenceOverloadInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ExtendedULInterferenceOverloadInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ExtendedULInterferenceOverloadInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ExtendedULInterferenceOverloadInfo_iE_Extensions__item__id),
        ('criticality', ___ExtendedULInterferenceOverloadInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___ExtendedULInterferenceOverloadInfo_iE_Extensions__item__extensionValue),
        ])
    __ExtendedULInterferenceOverloadInfo_iE_Extensions__item_._ext = None
    _ExtendedULInterferenceOverloadInfo_iE_Extensions._cont = __ExtendedULInterferenceOverloadInfo_iE_Extensions__item_
    _ExtendedULInterferenceOverloadInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ExtendedULInterferenceOverloadInfo._cont = ASN1Dict([
        ('associatedSubframes', _ExtendedULInterferenceOverloadInfo_associatedSubframes),
        ('extended-ul-InterferenceOverloadIndication', _ExtendedULInterferenceOverloadInfo_extended_ul_InterferenceOverloadIndication),
        ('iE-Extensions', _ExtendedULInterferenceOverloadInfo_iE_Extensions),
        ])
    ExtendedULInterferenceOverloadInfo._ext = []
    
    #-----< ExtendedULInterferenceOverloadInfo-ExtIEs >-----#
    ExtendedULInterferenceOverloadInfo_ExtIEs = CLASS(name='ExtendedULInterferenceOverloadInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ExtendedULInterferenceOverloadInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ExtendedBitRate >-----#
    ExtendedBitRate = INT(name='ExtendedBitRate', mode=MODE_TYPE)
    ExtendedBitRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=10000000001, ub=4000000000000)], ev=[], er=[])
    
    #-----< F1CTrafficContainer >-----#
    F1CTrafficContainer = OCT_STR(name='F1CTrafficContainer', mode=MODE_TYPE)
    
    #-----< FastMCGRecovery >-----#
    FastMCGRecovery = SEQ(name='FastMCGRecovery', mode=MODE_TYPE)
    _FastMCGRecovery_rrcContainer = OCT_STR(name='rrcContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'RRCContainer')), opt=True)
    _FastMCGRecovery_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __FastMCGRecovery_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___FastMCGRecovery_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____FastMCGRecovery_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____FastMCGRecovery_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FastMCGRecovery_iE_Extensions__item__id._const_tab = ____FastMCGRecovery_iE_Extensions__item__id_tab
    ___FastMCGRecovery_iE_Extensions__item__id._const_tab_at = None
    ___FastMCGRecovery_iE_Extensions__item__id._const_tab_id = 'id'
    ___FastMCGRecovery_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____FastMCGRecovery_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____FastMCGRecovery_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FastMCGRecovery_iE_Extensions__item__criticality._const_tab = ____FastMCGRecovery_iE_Extensions__item__criticality_tab
    ___FastMCGRecovery_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___FastMCGRecovery_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___FastMCGRecovery_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____FastMCGRecovery_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____FastMCGRecovery_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FastMCGRecovery_iE_Extensions__item__extensionValue._const_tab = ____FastMCGRecovery_iE_Extensions__item__extensionValue_tab
    ___FastMCGRecovery_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___FastMCGRecovery_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __FastMCGRecovery_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___FastMCGRecovery_iE_Extensions__item__id),
        ('criticality', ___FastMCGRecovery_iE_Extensions__item__criticality),
        ('extensionValue', ___FastMCGRecovery_iE_Extensions__item__extensionValue),
        ])
    __FastMCGRecovery_iE_Extensions__item_._ext = None
    _FastMCGRecovery_iE_Extensions._cont = __FastMCGRecovery_iE_Extensions__item_
    _FastMCGRecovery_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    FastMCGRecovery._cont = ASN1Dict([
        ('rrcContainer', _FastMCGRecovery_rrcContainer),
        ('iE-Extensions', _FastMCGRecovery_iE_Extensions),
        ])
    FastMCGRecovery._ext = []
    
    #-----< FastMCGRecovery-ExtIEs >-----#
    FastMCGRecovery_ExtIEs = CLASS(name='FastMCGRecovery-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    FastMCGRecovery_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< FDD-Info >-----#
    FDD_Info = SEQ(name='FDD-Info', mode=MODE_TYPE)
    _FDD_Info_uL_EARFCN = INT(name='uL-EARFCN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'EARFCN')))
    _FDD_Info_dL_EARFCN = INT(name='dL-EARFCN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'EARFCN')))
    _FDD_Info_uL_Transmission_Bandwidth = ENUM(name='uL-Transmission-Bandwidth', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'Transmission-Bandwidth')))
    _FDD_Info_dL_Transmission_Bandwidth = ENUM(name='dL-Transmission-Bandwidth', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'Transmission-Bandwidth')))
    _FDD_Info_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __FDD_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___FDD_Info_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____FDD_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____FDD_Info_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'EARFCNExtension')))
    _____FDD_Info_iE_Extensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'EARFCNExtension')))
    _____FDD_Info_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'OffsetOfNbiotChannelNumberToEARFCN')))
    _____FDD_Info_iE_Extensions__item__id_tab_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'OffsetOfNbiotChannelNumberToEARFCN')))
    _____FDD_Info_iE_Extensions__item__id_tab_val_Extension_4 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'NRS-NSSS-PowerOffset')))
    _____FDD_Info_iE_Extensions__item__id_tab_val_Extension_5 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'NSSS-NumOccasionDifferentPrecoder')))
    ____FDD_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 95), ('criticality', 'reject'), ('Extension', _____FDD_Info_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 96), ('criticality', 'reject'), ('Extension', _____FDD_Info_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 177), ('criticality', 'reject'), ('Extension', _____FDD_Info_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 178), ('criticality', 'reject'), ('Extension', _____FDD_Info_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 282), ('criticality', 'ignore'), ('Extension', _____FDD_Info_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 283), ('criticality', 'ignore'), ('Extension', _____FDD_Info_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___FDD_Info_iE_Extensions__item__id._const_tab = ____FDD_Info_iE_Extensions__item__id_tab
    ___FDD_Info_iE_Extensions__item__id._const_tab_at = None
    ___FDD_Info_iE_Extensions__item__id._const_tab_id = 'id'
    ___FDD_Info_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___FDD_Info_iE_Extensions__item__criticality._const_tab = ____FDD_Info_iE_Extensions__item__id_tab
    ___FDD_Info_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___FDD_Info_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___FDD_Info_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___FDD_Info_iE_Extensions__item__extensionValue._const_tab = ____FDD_Info_iE_Extensions__item__id_tab
    ___FDD_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___FDD_Info_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __FDD_Info_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___FDD_Info_iE_Extensions__item__id),
        ('criticality', ___FDD_Info_iE_Extensions__item__criticality),
        ('extensionValue', ___FDD_Info_iE_Extensions__item__extensionValue),
        ])
    __FDD_Info_iE_Extensions__item_._ext = None
    _FDD_Info_iE_Extensions._cont = __FDD_Info_iE_Extensions__item_
    _FDD_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    FDD_Info._cont = ASN1Dict([
        ('uL-EARFCN', _FDD_Info_uL_EARFCN),
        ('dL-EARFCN', _FDD_Info_dL_EARFCN),
        ('uL-Transmission-Bandwidth', _FDD_Info_uL_Transmission_Bandwidth),
        ('dL-Transmission-Bandwidth', _FDD_Info_dL_Transmission_Bandwidth),
        ('iE-Extensions', _FDD_Info_iE_Extensions),
        ])
    FDD_Info._ext = []
    
    #-----< FDD-Info-ExtIEs >-----#
    FDD_Info_ExtIEs = CLASS(name='FDD-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _FDD_Info_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'EARFCNExtension')))
    _FDD_Info_ExtIEs_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'EARFCNExtension')))
    _FDD_Info_ExtIEs_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'OffsetOfNbiotChannelNumberToEARFCN')))
    _FDD_Info_ExtIEs_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'OffsetOfNbiotChannelNumberToEARFCN')))
    _FDD_Info_ExtIEs_val_Extension_4 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'NRS-NSSS-PowerOffset')))
    _FDD_Info_ExtIEs_val_Extension_5 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'NSSS-NumOccasionDifferentPrecoder')))
    FDD_Info_ExtIEs._val = ASN1Set(rv=[dict([('id', 95), ('criticality', 'reject'), ('Extension', _FDD_Info_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 96), ('criticality', 'reject'), ('Extension', _FDD_Info_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 177), ('criticality', 'reject'), ('Extension', _FDD_Info_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 178), ('criticality', 'reject'), ('Extension', _FDD_Info_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 282), ('criticality', 'ignore'), ('Extension', _FDD_Info_ExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 283), ('criticality', 'ignore'), ('Extension', _FDD_Info_ExtIEs_val_Extension_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< FDD-InfoNeighbourServedNRCell-Information >-----#
    FDD_InfoNeighbourServedNRCell_Information = SEQ(name='FDD-InfoNeighbourServedNRCell-Information', mode=MODE_TYPE)
    _FDD_InfoNeighbourServedNRCell_Information_ul_NRFreqInfo = SEQ(name='ul-NRFreqInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'NRFreqInfo')))
    _FDD_InfoNeighbourServedNRCell_Information_dl_NRFreqInfo = SEQ(name='dl-NRFreqInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'NRFreqInfo')))
    _FDD_InfoNeighbourServedNRCell_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __FDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___FDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____FDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____FDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'NRCarrierList')))
    ____FDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 387), ('criticality', 'ignore'), ('Extension', _____FDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___FDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item__id._const_tab = ____FDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item__id_tab
    ___FDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item__id._const_tab_at = None
    ___FDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___FDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___FDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item__criticality._const_tab = ____FDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item__id_tab
    ___FDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___FDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___FDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___FDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item__extensionValue._const_tab = ____FDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item__id_tab
    ___FDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___FDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __FDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___FDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item__id),
        ('criticality', ___FDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___FDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item__extensionValue),
        ])
    __FDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item_._ext = None
    _FDD_InfoNeighbourServedNRCell_Information_iE_Extensions._cont = __FDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item_
    _FDD_InfoNeighbourServedNRCell_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    FDD_InfoNeighbourServedNRCell_Information._cont = ASN1Dict([
        ('ul-NRFreqInfo', _FDD_InfoNeighbourServedNRCell_Information_ul_NRFreqInfo),
        ('dl-NRFreqInfo', _FDD_InfoNeighbourServedNRCell_Information_dl_NRFreqInfo),
        ('iE-Extensions', _FDD_InfoNeighbourServedNRCell_Information_iE_Extensions),
        ])
    FDD_InfoNeighbourServedNRCell_Information._ext = []
    
    #-----< FDD-InfoNeighbourServedNRCell-Information-ExtIEs >-----#
    FDD_InfoNeighbourServedNRCell_Information_ExtIEs = CLASS(name='FDD-InfoNeighbourServedNRCell-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _FDD_InfoNeighbourServedNRCell_Information_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'NRCarrierList')))
    FDD_InfoNeighbourServedNRCell_Information_ExtIEs._val = ASN1Set(rv=[dict([('id', 387), ('criticality', 'ignore'), ('Extension', _FDD_InfoNeighbourServedNRCell_Information_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< FiveQI >-----#
    FiveQI = INT(name='FiveQI', mode=MODE_TYPE)
    FiveQI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=[], er=[])
    
    #-----< ForbiddenInterRATs >-----#
    ForbiddenInterRATs = ENUM(name='ForbiddenInterRATs', mode=MODE_TYPE)
    ForbiddenInterRATs._cont = ASN1Dict([('all', 0), ('geran', 1), ('utran', 2), ('cdma2000', 3), ('geranandutran', 4), ('cdma2000andutran', 5)])
    ForbiddenInterRATs._ext = ['geranandutran', 'cdma2000andutran']
    
    #-----< ForbiddenTAs >-----#
    ForbiddenTAs = SEQ_OF(name='ForbiddenTAs', mode=MODE_TYPE)
    _ForbiddenTAs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ForbiddenTAs-Item')))
    ForbiddenTAs._cont = _ForbiddenTAs__item_
    ForbiddenTAs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< ForbiddenTAs-Item >-----#
    ForbiddenTAs_Item = SEQ(name='ForbiddenTAs-Item', mode=MODE_TYPE)
    _ForbiddenTAs_Item_pLMN_Identity = OCT_STR(name='pLMN-Identity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'PLMN-Identity')))
    _ForbiddenTAs_Item_forbiddenTACs = SEQ_OF(name='forbiddenTACs', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ForbiddenTACs')))
    _ForbiddenTAs_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ForbiddenTAs_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___ForbiddenTAs_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____ForbiddenTAs_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ForbiddenTAs_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ForbiddenTAs_Item_iE_Extensions__item__id._const_tab = ____ForbiddenTAs_Item_iE_Extensions__item__id_tab
    ___ForbiddenTAs_Item_iE_Extensions__item__id._const_tab_at = None
    ___ForbiddenTAs_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___ForbiddenTAs_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ForbiddenTAs_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ForbiddenTAs_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ForbiddenTAs_Item_iE_Extensions__item__criticality._const_tab = ____ForbiddenTAs_Item_iE_Extensions__item__criticality_tab
    ___ForbiddenTAs_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ForbiddenTAs_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ForbiddenTAs_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ForbiddenTAs_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ForbiddenTAs_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ForbiddenTAs_Item_iE_Extensions__item__extensionValue._const_tab = ____ForbiddenTAs_Item_iE_Extensions__item__extensionValue_tab
    ___ForbiddenTAs_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ForbiddenTAs_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ForbiddenTAs_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ForbiddenTAs_Item_iE_Extensions__item__id),
        ('criticality', ___ForbiddenTAs_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___ForbiddenTAs_Item_iE_Extensions__item__extensionValue),
        ])
    __ForbiddenTAs_Item_iE_Extensions__item_._ext = None
    _ForbiddenTAs_Item_iE_Extensions._cont = __ForbiddenTAs_Item_iE_Extensions__item_
    _ForbiddenTAs_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ForbiddenTAs_Item._cont = ASN1Dict([
        ('pLMN-Identity', _ForbiddenTAs_Item_pLMN_Identity),
        ('forbiddenTACs', _ForbiddenTAs_Item_forbiddenTACs),
        ('iE-Extensions', _ForbiddenTAs_Item_iE_Extensions),
        ])
    ForbiddenTAs_Item._ext = []
    
    #-----< ForbiddenTAs-Item-ExtIEs >-----#
    ForbiddenTAs_Item_ExtIEs = CLASS(name='ForbiddenTAs-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ForbiddenTAs_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ForbiddenTACs >-----#
    ForbiddenTACs = SEQ_OF(name='ForbiddenTACs', mode=MODE_TYPE)
    _ForbiddenTACs__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TAC')))
    ForbiddenTACs._cont = _ForbiddenTACs__item_
    ForbiddenTACs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4096)], ev=None, er=[])
    
    #-----< ForbiddenLAs >-----#
    ForbiddenLAs = SEQ_OF(name='ForbiddenLAs', mode=MODE_TYPE)
    _ForbiddenLAs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ForbiddenLAs-Item')))
    ForbiddenLAs._cont = _ForbiddenLAs__item_
    ForbiddenLAs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< ForbiddenLAs-Item >-----#
    ForbiddenLAs_Item = SEQ(name='ForbiddenLAs-Item', mode=MODE_TYPE)
    _ForbiddenLAs_Item_pLMN_Identity = OCT_STR(name='pLMN-Identity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'PLMN-Identity')))
    _ForbiddenLAs_Item_forbiddenLACs = SEQ_OF(name='forbiddenLACs', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ForbiddenLACs')))
    _ForbiddenLAs_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ForbiddenLAs_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___ForbiddenLAs_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____ForbiddenLAs_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ForbiddenLAs_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ForbiddenLAs_Item_iE_Extensions__item__id._const_tab = ____ForbiddenLAs_Item_iE_Extensions__item__id_tab
    ___ForbiddenLAs_Item_iE_Extensions__item__id._const_tab_at = None
    ___ForbiddenLAs_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___ForbiddenLAs_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ForbiddenLAs_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ForbiddenLAs_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ForbiddenLAs_Item_iE_Extensions__item__criticality._const_tab = ____ForbiddenLAs_Item_iE_Extensions__item__criticality_tab
    ___ForbiddenLAs_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ForbiddenLAs_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ForbiddenLAs_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ForbiddenLAs_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ForbiddenLAs_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ForbiddenLAs_Item_iE_Extensions__item__extensionValue._const_tab = ____ForbiddenLAs_Item_iE_Extensions__item__extensionValue_tab
    ___ForbiddenLAs_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ForbiddenLAs_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ForbiddenLAs_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ForbiddenLAs_Item_iE_Extensions__item__id),
        ('criticality', ___ForbiddenLAs_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___ForbiddenLAs_Item_iE_Extensions__item__extensionValue),
        ])
    __ForbiddenLAs_Item_iE_Extensions__item_._ext = None
    _ForbiddenLAs_Item_iE_Extensions._cont = __ForbiddenLAs_Item_iE_Extensions__item_
    _ForbiddenLAs_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ForbiddenLAs_Item._cont = ASN1Dict([
        ('pLMN-Identity', _ForbiddenLAs_Item_pLMN_Identity),
        ('forbiddenLACs', _ForbiddenLAs_Item_forbiddenLACs),
        ('iE-Extensions', _ForbiddenLAs_Item_iE_Extensions),
        ])
    ForbiddenLAs_Item._ext = []
    
    #-----< ForbiddenLAs-Item-ExtIEs >-----#
    ForbiddenLAs_Item_ExtIEs = CLASS(name='ForbiddenLAs-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ForbiddenLAs_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ForbiddenLACs >-----#
    ForbiddenLACs = SEQ_OF(name='ForbiddenLACs', mode=MODE_TYPE)
    _ForbiddenLACs__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'LAC')))
    ForbiddenLACs._cont = _ForbiddenLACs__item_
    ForbiddenLACs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4096)], ev=None, er=[])
    
    #-----< Fourframes >-----#
    Fourframes = BIT_STR(name='Fourframes', mode=MODE_TYPE)
    Fourframes._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    
    #-----< FreqBandIndicator >-----#
    FreqBandIndicator = INT(name='FreqBandIndicator', mode=MODE_TYPE)
    FreqBandIndicator._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=[], er=[])
    
    #-----< FreqBandIndicatorPriority >-----#
    FreqBandIndicatorPriority = ENUM(name='FreqBandIndicatorPriority', mode=MODE_TYPE)
    FreqBandIndicatorPriority._cont = ASN1Dict([('not-broadcasted', 0), ('broadcasted', 1)])
    FreqBandIndicatorPriority._ext = []
    
    #-----< FreqBandNrItem >-----#
    FreqBandNrItem = SEQ(name='FreqBandNrItem', mode=MODE_TYPE)
    _FreqBandNrItem_freqBandIndicatorNr = INT(name='freqBandIndicatorNr', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _FreqBandNrItem_freqBandIndicatorNr._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=[], er=[])
    _FreqBandNrItem_supportedSULBandList = SEQ_OF(name='supportedSULBandList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __FreqBandNrItem_supportedSULBandList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SupportedSULFreqBandItem')))
    _FreqBandNrItem_supportedSULBandList._cont = __FreqBandNrItem_supportedSULBandList__item_
    _FreqBandNrItem_supportedSULBandList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32)], ev=None, er=[])
    _FreqBandNrItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __FreqBandNrItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___FreqBandNrItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____FreqBandNrItem_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____FreqBandNrItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FreqBandNrItem_iE_Extensions__item__id._const_tab = ____FreqBandNrItem_iE_Extensions__item__id_tab
    ___FreqBandNrItem_iE_Extensions__item__id._const_tab_at = None
    ___FreqBandNrItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___FreqBandNrItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____FreqBandNrItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____FreqBandNrItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FreqBandNrItem_iE_Extensions__item__criticality._const_tab = ____FreqBandNrItem_iE_Extensions__item__criticality_tab
    ___FreqBandNrItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___FreqBandNrItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___FreqBandNrItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____FreqBandNrItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____FreqBandNrItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FreqBandNrItem_iE_Extensions__item__extensionValue._const_tab = ____FreqBandNrItem_iE_Extensions__item__extensionValue_tab
    ___FreqBandNrItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___FreqBandNrItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __FreqBandNrItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___FreqBandNrItem_iE_Extensions__item__id),
        ('criticality', ___FreqBandNrItem_iE_Extensions__item__criticality),
        ('extensionValue', ___FreqBandNrItem_iE_Extensions__item__extensionValue),
        ])
    __FreqBandNrItem_iE_Extensions__item_._ext = None
    _FreqBandNrItem_iE_Extensions._cont = __FreqBandNrItem_iE_Extensions__item_
    _FreqBandNrItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    FreqBandNrItem._cont = ASN1Dict([
        ('freqBandIndicatorNr', _FreqBandNrItem_freqBandIndicatorNr),
        ('supportedSULBandList', _FreqBandNrItem_supportedSULBandList),
        ('iE-Extensions', _FreqBandNrItem_iE_Extensions),
        ])
    FreqBandNrItem._ext = []
    
    #-----< FreqBandNrItem-ExtIEs >-----#
    FreqBandNrItem_ExtIEs = CLASS(name='FreqBandNrItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    FreqBandNrItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< FrequencyShift7p5khz >-----#
    FrequencyShift7p5khz = ENUM(name='FrequencyShift7p5khz', mode=MODE_TYPE)
    FrequencyShift7p5khz._cont = ASN1Dict([('false', 0), ('true', 1)])
    FrequencyShift7p5khz._ext = []
    
    #-----< GBR-QosInformation >-----#
    GBR_QosInformation = SEQ(name='GBR-QosInformation', mode=MODE_TYPE)
    _GBR_QosInformation_e_RAB_MaximumBitrateDL = INT(name='e-RAB-MaximumBitrateDL', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'BitRate')))
    _GBR_QosInformation_e_RAB_MaximumBitrateUL = INT(name='e-RAB-MaximumBitrateUL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'BitRate')))
    _GBR_QosInformation_e_RAB_GuaranteedBitrateDL = INT(name='e-RAB-GuaranteedBitrateDL', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'BitRate')))
    _GBR_QosInformation_e_RAB_GuaranteedBitrateUL = INT(name='e-RAB-GuaranteedBitrateUL', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'BitRate')))
    _GBR_QosInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GBR_QosInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___GBR_QosInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____GBR_QosInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____GBR_QosInformation_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ExtendedBitRate')))
    _____GBR_QosInformation_iE_Extensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ExtendedBitRate')))
    _____GBR_QosInformation_iE_Extensions__item__id_tab_val_Extension_2 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ExtendedBitRate')))
    _____GBR_QosInformation_iE_Extensions__item__id_tab_val_Extension_3 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ExtendedBitRate')))
    ____GBR_QosInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 196), ('criticality', 'ignore'), ('Extension', _____GBR_QosInformation_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 197), ('criticality', 'ignore'), ('Extension', _____GBR_QosInformation_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 198), ('criticality', 'ignore'), ('Extension', _____GBR_QosInformation_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 199), ('criticality', 'ignore'), ('Extension', _____GBR_QosInformation_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___GBR_QosInformation_iE_Extensions__item__id._const_tab = ____GBR_QosInformation_iE_Extensions__item__id_tab
    ___GBR_QosInformation_iE_Extensions__item__id._const_tab_at = None
    ___GBR_QosInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___GBR_QosInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___GBR_QosInformation_iE_Extensions__item__criticality._const_tab = ____GBR_QosInformation_iE_Extensions__item__id_tab
    ___GBR_QosInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GBR_QosInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GBR_QosInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___GBR_QosInformation_iE_Extensions__item__extensionValue._const_tab = ____GBR_QosInformation_iE_Extensions__item__id_tab
    ___GBR_QosInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GBR_QosInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GBR_QosInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GBR_QosInformation_iE_Extensions__item__id),
        ('criticality', ___GBR_QosInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___GBR_QosInformation_iE_Extensions__item__extensionValue),
        ])
    __GBR_QosInformation_iE_Extensions__item_._ext = None
    _GBR_QosInformation_iE_Extensions._cont = __GBR_QosInformation_iE_Extensions__item_
    _GBR_QosInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GBR_QosInformation._cont = ASN1Dict([
        ('e-RAB-MaximumBitrateDL', _GBR_QosInformation_e_RAB_MaximumBitrateDL),
        ('e-RAB-MaximumBitrateUL', _GBR_QosInformation_e_RAB_MaximumBitrateUL),
        ('e-RAB-GuaranteedBitrateDL', _GBR_QosInformation_e_RAB_GuaranteedBitrateDL),
        ('e-RAB-GuaranteedBitrateUL', _GBR_QosInformation_e_RAB_GuaranteedBitrateUL),
        ('iE-Extensions', _GBR_QosInformation_iE_Extensions),
        ])
    GBR_QosInformation._ext = []
    
    #-----< GBR-QosInformation-ExtIEs >-----#
    GBR_QosInformation_ExtIEs = CLASS(name='GBR-QosInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _GBR_QosInformation_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ExtendedBitRate')))
    _GBR_QosInformation_ExtIEs_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ExtendedBitRate')))
    _GBR_QosInformation_ExtIEs_val_Extension_2 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ExtendedBitRate')))
    _GBR_QosInformation_ExtIEs_val_Extension_3 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ExtendedBitRate')))
    GBR_QosInformation_ExtIEs._val = ASN1Set(rv=[dict([('id', 196), ('criticality', 'ignore'), ('Extension', _GBR_QosInformation_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 197), ('criticality', 'ignore'), ('Extension', _GBR_QosInformation_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 198), ('criticality', 'ignore'), ('Extension', _GBR_QosInformation_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 199), ('criticality', 'ignore'), ('Extension', _GBR_QosInformation_ExtIEs_val_Extension_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< GlobalENB-ID >-----#
    GlobalENB_ID = SEQ(name='GlobalENB-ID', mode=MODE_TYPE)
    _GlobalENB_ID_pLMN_Identity = OCT_STR(name='pLMN-Identity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'PLMN-Identity')))
    _GlobalENB_ID_eNB_ID = CHOICE(name='eNB-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ENB-ID')))
    _GlobalENB_ID_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GlobalENB_ID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___GlobalENB_ID_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____GlobalENB_ID_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____GlobalENB_ID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GlobalENB_ID_iE_Extensions__item__id._const_tab = ____GlobalENB_ID_iE_Extensions__item__id_tab
    ___GlobalENB_ID_iE_Extensions__item__id._const_tab_at = None
    ___GlobalENB_ID_iE_Extensions__item__id._const_tab_id = 'id'
    ___GlobalENB_ID_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GlobalENB_ID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____GlobalENB_ID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GlobalENB_ID_iE_Extensions__item__criticality._const_tab = ____GlobalENB_ID_iE_Extensions__item__criticality_tab
    ___GlobalENB_ID_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GlobalENB_ID_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GlobalENB_ID_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GlobalENB_ID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____GlobalENB_ID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GlobalENB_ID_iE_Extensions__item__extensionValue._const_tab = ____GlobalENB_ID_iE_Extensions__item__extensionValue_tab
    ___GlobalENB_ID_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GlobalENB_ID_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GlobalENB_ID_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GlobalENB_ID_iE_Extensions__item__id),
        ('criticality', ___GlobalENB_ID_iE_Extensions__item__criticality),
        ('extensionValue', ___GlobalENB_ID_iE_Extensions__item__extensionValue),
        ])
    __GlobalENB_ID_iE_Extensions__item_._ext = None
    _GlobalENB_ID_iE_Extensions._cont = __GlobalENB_ID_iE_Extensions__item_
    _GlobalENB_ID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GlobalENB_ID._cont = ASN1Dict([
        ('pLMN-Identity', _GlobalENB_ID_pLMN_Identity),
        ('eNB-ID', _GlobalENB_ID_eNB_ID),
        ('iE-Extensions', _GlobalENB_ID_iE_Extensions),
        ])
    GlobalENB_ID._ext = []
    
    #-----< GlobalENB-ID-ExtIEs >-----#
    GlobalENB_ID_ExtIEs = CLASS(name='GlobalENB-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    GlobalENB_ID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GlobalGNB-ID >-----#
    GlobalGNB_ID = SEQ(name='GlobalGNB-ID', mode=MODE_TYPE)
    _GlobalGNB_ID_pLMN_Identity = OCT_STR(name='pLMN-Identity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'PLMN-Identity')))
    _GlobalGNB_ID_gNB_ID = CHOICE(name='gNB-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GNB-ID')))
    _GlobalGNB_ID_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GlobalGNB_ID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___GlobalGNB_ID_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____GlobalGNB_ID_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____GlobalGNB_ID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GlobalGNB_ID_iE_Extensions__item__id._const_tab = ____GlobalGNB_ID_iE_Extensions__item__id_tab
    ___GlobalGNB_ID_iE_Extensions__item__id._const_tab_at = None
    ___GlobalGNB_ID_iE_Extensions__item__id._const_tab_id = 'id'
    ___GlobalGNB_ID_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GlobalGNB_ID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____GlobalGNB_ID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GlobalGNB_ID_iE_Extensions__item__criticality._const_tab = ____GlobalGNB_ID_iE_Extensions__item__criticality_tab
    ___GlobalGNB_ID_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GlobalGNB_ID_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GlobalGNB_ID_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GlobalGNB_ID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____GlobalGNB_ID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GlobalGNB_ID_iE_Extensions__item__extensionValue._const_tab = ____GlobalGNB_ID_iE_Extensions__item__extensionValue_tab
    ___GlobalGNB_ID_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GlobalGNB_ID_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GlobalGNB_ID_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GlobalGNB_ID_iE_Extensions__item__id),
        ('criticality', ___GlobalGNB_ID_iE_Extensions__item__criticality),
        ('extensionValue', ___GlobalGNB_ID_iE_Extensions__item__extensionValue),
        ])
    __GlobalGNB_ID_iE_Extensions__item_._ext = None
    _GlobalGNB_ID_iE_Extensions._cont = __GlobalGNB_ID_iE_Extensions__item_
    _GlobalGNB_ID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GlobalGNB_ID._cont = ASN1Dict([
        ('pLMN-Identity', _GlobalGNB_ID_pLMN_Identity),
        ('gNB-ID', _GlobalGNB_ID_gNB_ID),
        ('iE-Extensions', _GlobalGNB_ID_iE_Extensions),
        ])
    GlobalGNB_ID._ext = []
    
    #-----< GlobalGNB-ID-ExtIEs >-----#
    GlobalGNB_ID_ExtIEs = CLASS(name='GlobalGNB-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    GlobalGNB_ID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Global-RAN-NODE-ID >-----#
    Global_RAN_NODE_ID = CHOICE(name='Global-RAN-NODE-ID', mode=MODE_TYPE)
    _Global_RAN_NODE_ID_gNB = SEQ(name='gNB', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GlobalGNB-ID')))
    _Global_RAN_NODE_ID_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __Global_RAN_NODE_ID_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ___Global_RAN_NODE_ID_choice_extension_id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ___Global_RAN_NODE_ID_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Global_RAN_NODE_ID_choice_extension_id._const_tab = ___Global_RAN_NODE_ID_choice_extension_id_tab
    __Global_RAN_NODE_ID_choice_extension_id._const_tab_at = None
    __Global_RAN_NODE_ID_choice_extension_id._const_tab_id = 'id'
    __Global_RAN_NODE_ID_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___Global_RAN_NODE_ID_choice_extension_criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ___Global_RAN_NODE_ID_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Global_RAN_NODE_ID_choice_extension_criticality._const_tab = ___Global_RAN_NODE_ID_choice_extension_criticality_tab
    __Global_RAN_NODE_ID_choice_extension_criticality._const_tab_at = ('..', 'id')
    __Global_RAN_NODE_ID_choice_extension_criticality._const_tab_id = 'criticality'
    __Global_RAN_NODE_ID_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___Global_RAN_NODE_ID_choice_extension_value_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ___Global_RAN_NODE_ID_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Global_RAN_NODE_ID_choice_extension_value._const_tab = ___Global_RAN_NODE_ID_choice_extension_value_tab
    __Global_RAN_NODE_ID_choice_extension_value._const_tab_at = ('..', 'id')
    __Global_RAN_NODE_ID_choice_extension_value._const_tab_id = 'Value'
    _Global_RAN_NODE_ID_choice_extension._cont = ASN1Dict([
        ('id', __Global_RAN_NODE_ID_choice_extension_id),
        ('criticality', __Global_RAN_NODE_ID_choice_extension_criticality),
        ('value', __Global_RAN_NODE_ID_choice_extension_value),
        ])
    _Global_RAN_NODE_ID_choice_extension._ext = None
    Global_RAN_NODE_ID._cont = ASN1Dict([
        ('gNB', _Global_RAN_NODE_ID_gNB),
        ('choice-extension', _Global_RAN_NODE_ID_choice_extension),
        ])
    Global_RAN_NODE_ID._ext = None
    
    #-----< Global-RAN-NODE-ID-ExtIEs >-----#
    Global_RAN_NODE_ID_ExtIEs = CLASS(name='Global-RAN-NODE-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    Global_RAN_NODE_ID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GNBOverloadInformation >-----#
    GNBOverloadInformation = ENUM(name='GNBOverloadInformation', mode=MODE_TYPE)
    GNBOverloadInformation._cont = ASN1Dict([('overloaded', 0), ('not-overloaded', 1)])
    GNBOverloadInformation._ext = []
    
    #-----< GTPTLAs >-----#
    GTPTLAs = SEQ_OF(name='GTPTLAs', mode=MODE_TYPE)
    _GTPTLAs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GTPTLA-Item')))
    GTPTLAs._cont = _GTPTLAs__item_
    GTPTLAs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< GTPTLA-Item >-----#
    GTPTLA_Item = SEQ(name='GTPTLA-Item', mode=MODE_TYPE)
    _GTPTLA_Item_gTPTransportLayerAddresses = BIT_STR(name='gTPTransportLayerAddresses', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'TransportLayerAddress')))
    _GTPTLA_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GTPTLA_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___GTPTLA_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____GTPTLA_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____GTPTLA_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GTPTLA_Item_iE_Extensions__item__id._const_tab = ____GTPTLA_Item_iE_Extensions__item__id_tab
    ___GTPTLA_Item_iE_Extensions__item__id._const_tab_at = None
    ___GTPTLA_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___GTPTLA_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GTPTLA_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____GTPTLA_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GTPTLA_Item_iE_Extensions__item__criticality._const_tab = ____GTPTLA_Item_iE_Extensions__item__criticality_tab
    ___GTPTLA_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GTPTLA_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GTPTLA_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GTPTLA_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____GTPTLA_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GTPTLA_Item_iE_Extensions__item__extensionValue._const_tab = ____GTPTLA_Item_iE_Extensions__item__extensionValue_tab
    ___GTPTLA_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GTPTLA_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GTPTLA_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GTPTLA_Item_iE_Extensions__item__id),
        ('criticality', ___GTPTLA_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___GTPTLA_Item_iE_Extensions__item__extensionValue),
        ])
    __GTPTLA_Item_iE_Extensions__item_._ext = None
    _GTPTLA_Item_iE_Extensions._cont = __GTPTLA_Item_iE_Extensions__item_
    _GTPTLA_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GTPTLA_Item._cont = ASN1Dict([
        ('gTPTransportLayerAddresses', _GTPTLA_Item_gTPTransportLayerAddresses),
        ('iE-Extensions', _GTPTLA_Item_iE_Extensions),
        ])
    GTPTLA_Item._ext = []
    
    #-----< GTPTLA-Item-ExtIEs >-----#
    GTPTLA_Item_ExtIEs = CLASS(name='GTPTLA-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    GTPTLA_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GTPtunnelEndpoint >-----#
    GTPtunnelEndpoint = SEQ(name='GTPtunnelEndpoint', mode=MODE_TYPE)
    _GTPtunnelEndpoint_transportLayerAddress = BIT_STR(name='transportLayerAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'TransportLayerAddress')))
    _GTPtunnelEndpoint_gTP_TEID = OCT_STR(name='gTP-TEID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTP-TEI')))
    _GTPtunnelEndpoint_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GTPtunnelEndpoint_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___GTPtunnelEndpoint_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____GTPtunnelEndpoint_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____GTPtunnelEndpoint_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'QoS-Mapping-Information')))
    ____GTPtunnelEndpoint_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 396), ('criticality', 'reject'), ('Extension', _____GTPtunnelEndpoint_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___GTPtunnelEndpoint_iE_Extensions__item__id._const_tab = ____GTPtunnelEndpoint_iE_Extensions__item__id_tab
    ___GTPtunnelEndpoint_iE_Extensions__item__id._const_tab_at = None
    ___GTPtunnelEndpoint_iE_Extensions__item__id._const_tab_id = 'id'
    ___GTPtunnelEndpoint_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___GTPtunnelEndpoint_iE_Extensions__item__criticality._const_tab = ____GTPtunnelEndpoint_iE_Extensions__item__id_tab
    ___GTPtunnelEndpoint_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GTPtunnelEndpoint_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GTPtunnelEndpoint_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___GTPtunnelEndpoint_iE_Extensions__item__extensionValue._const_tab = ____GTPtunnelEndpoint_iE_Extensions__item__id_tab
    ___GTPtunnelEndpoint_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GTPtunnelEndpoint_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GTPtunnelEndpoint_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GTPtunnelEndpoint_iE_Extensions__item__id),
        ('criticality', ___GTPtunnelEndpoint_iE_Extensions__item__criticality),
        ('extensionValue', ___GTPtunnelEndpoint_iE_Extensions__item__extensionValue),
        ])
    __GTPtunnelEndpoint_iE_Extensions__item_._ext = None
    _GTPtunnelEndpoint_iE_Extensions._cont = __GTPtunnelEndpoint_iE_Extensions__item_
    _GTPtunnelEndpoint_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GTPtunnelEndpoint._cont = ASN1Dict([
        ('transportLayerAddress', _GTPtunnelEndpoint_transportLayerAddress),
        ('gTP-TEID', _GTPtunnelEndpoint_gTP_TEID),
        ('iE-Extensions', _GTPtunnelEndpoint_iE_Extensions),
        ])
    GTPtunnelEndpoint._ext = []
    
    #-----< GTPtunnelEndpoint-ExtIEs >-----#
    GTPtunnelEndpoint_ExtIEs = CLASS(name='GTPtunnelEndpoint-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _GTPtunnelEndpoint_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'QoS-Mapping-Information')))
    GTPtunnelEndpoint_ExtIEs._val = ASN1Set(rv=[dict([('id', 396), ('criticality', 'reject'), ('Extension', _GTPtunnelEndpoint_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< GTP-TEI >-----#
    GTP_TEI = OCT_STR(name='GTP-TEI', mode=MODE_TYPE)
    GTP_TEI._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< GUGroupIDList >-----#
    GUGroupIDList = SEQ_OF(name='GUGroupIDList', mode=MODE_TYPE)
    _GUGroupIDList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GU-Group-ID')))
    GUGroupIDList._cont = _GUGroupIDList__item_
    GUGroupIDList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< GU-Group-ID >-----#
    GU_Group_ID = SEQ(name='GU-Group-ID', mode=MODE_TYPE)
    _GU_Group_ID_pLMN_Identity = OCT_STR(name='pLMN-Identity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'PLMN-Identity')))
    _GU_Group_ID_mME_Group_ID = OCT_STR(name='mME-Group-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'MME-Group-ID')))
    _GU_Group_ID_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GU_Group_ID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___GU_Group_ID_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____GU_Group_ID_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____GU_Group_ID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GU_Group_ID_iE_Extensions__item__id._const_tab = ____GU_Group_ID_iE_Extensions__item__id_tab
    ___GU_Group_ID_iE_Extensions__item__id._const_tab_at = None
    ___GU_Group_ID_iE_Extensions__item__id._const_tab_id = 'id'
    ___GU_Group_ID_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GU_Group_ID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____GU_Group_ID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GU_Group_ID_iE_Extensions__item__criticality._const_tab = ____GU_Group_ID_iE_Extensions__item__criticality_tab
    ___GU_Group_ID_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GU_Group_ID_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GU_Group_ID_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GU_Group_ID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____GU_Group_ID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GU_Group_ID_iE_Extensions__item__extensionValue._const_tab = ____GU_Group_ID_iE_Extensions__item__extensionValue_tab
    ___GU_Group_ID_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GU_Group_ID_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GU_Group_ID_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GU_Group_ID_iE_Extensions__item__id),
        ('criticality', ___GU_Group_ID_iE_Extensions__item__criticality),
        ('extensionValue', ___GU_Group_ID_iE_Extensions__item__extensionValue),
        ])
    __GU_Group_ID_iE_Extensions__item_._ext = None
    _GU_Group_ID_iE_Extensions._cont = __GU_Group_ID_iE_Extensions__item_
    _GU_Group_ID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GU_Group_ID._cont = ASN1Dict([
        ('pLMN-Identity', _GU_Group_ID_pLMN_Identity),
        ('mME-Group-ID', _GU_Group_ID_mME_Group_ID),
        ('iE-Extensions', _GU_Group_ID_iE_Extensions),
        ])
    GU_Group_ID._ext = []
    
    #-----< GU-Group-ID-ExtIEs >-----#
    GU_Group_ID_ExtIEs = CLASS(name='GU-Group-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    GU_Group_ID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GUMMEI >-----#
    GUMMEI = SEQ(name='GUMMEI', mode=MODE_TYPE)
    _GUMMEI_gU_Group_ID = SEQ(name='gU-Group-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GU-Group-ID')))
    _GUMMEI_mME_Code = OCT_STR(name='mME-Code', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'MME-Code')))
    _GUMMEI_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GUMMEI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___GUMMEI_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____GUMMEI_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____GUMMEI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GUMMEI_iE_Extensions__item__id._const_tab = ____GUMMEI_iE_Extensions__item__id_tab
    ___GUMMEI_iE_Extensions__item__id._const_tab_at = None
    ___GUMMEI_iE_Extensions__item__id._const_tab_id = 'id'
    ___GUMMEI_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GUMMEI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____GUMMEI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GUMMEI_iE_Extensions__item__criticality._const_tab = ____GUMMEI_iE_Extensions__item__criticality_tab
    ___GUMMEI_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GUMMEI_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GUMMEI_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GUMMEI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____GUMMEI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GUMMEI_iE_Extensions__item__extensionValue._const_tab = ____GUMMEI_iE_Extensions__item__extensionValue_tab
    ___GUMMEI_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GUMMEI_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GUMMEI_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GUMMEI_iE_Extensions__item__id),
        ('criticality', ___GUMMEI_iE_Extensions__item__criticality),
        ('extensionValue', ___GUMMEI_iE_Extensions__item__extensionValue),
        ])
    __GUMMEI_iE_Extensions__item_._ext = None
    _GUMMEI_iE_Extensions._cont = __GUMMEI_iE_Extensions__item_
    _GUMMEI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GUMMEI._cont = ASN1Dict([
        ('gU-Group-ID', _GUMMEI_gU_Group_ID),
        ('mME-Code', _GUMMEI_mME_Code),
        ('iE-Extensions', _GUMMEI_iE_Extensions),
        ])
    GUMMEI._ext = []
    
    #-----< GUMMEI-ExtIEs >-----#
    GUMMEI_ExtIEs = CLASS(name='GUMMEI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    GUMMEI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GNB-ID >-----#
    GNB_ID = CHOICE(name='GNB-ID', mode=MODE_TYPE)
    _GNB_ID_gNB_ID = BIT_STR(name='gNB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNB_ID_gNB_ID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=22, ub=32)], ev=None, er=[])
    GNB_ID._cont = ASN1Dict([
        ('gNB-ID', _GNB_ID_gNB_ID),
        ])
    GNB_ID._ext = []
    
    #-----< HandoverReportType >-----#
    HandoverReportType = ENUM(name='HandoverReportType', mode=MODE_TYPE)
    HandoverReportType._cont = ASN1Dict([('hoTooEarly', 0), ('hoToWrongCell', 1), ('interRATpingpong', 2), ('interSystemPingpong', 3)])
    HandoverReportType._ext = ['interRATpingpong', 'interSystemPingpong']
    
    #-----< HandoverRestrictionList >-----#
    HandoverRestrictionList = SEQ(name='HandoverRestrictionList', mode=MODE_TYPE)
    _HandoverRestrictionList_servingPLMN = OCT_STR(name='servingPLMN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'PLMN-Identity')))
    _HandoverRestrictionList_equivalentPLMNs = SEQ_OF(name='equivalentPLMNs', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'EPLMNs')), opt=True)
    _HandoverRestrictionList_forbiddenTAs = SEQ_OF(name='forbiddenTAs', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ForbiddenTAs')), opt=True)
    _HandoverRestrictionList_forbiddenLAs = SEQ_OF(name='forbiddenLAs', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ForbiddenLAs')), opt=True)
    _HandoverRestrictionList_forbiddenInterRATs = ENUM(name='forbiddenInterRATs', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ForbiddenInterRATs')), opt=True)
    _HandoverRestrictionList_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HandoverRestrictionList_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___HandoverRestrictionList_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____HandoverRestrictionList_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____HandoverRestrictionList_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'NRrestrictioninEPSasSecondaryRAT')))
    _____HandoverRestrictionList_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CNTypeRestrictions')))
    _____HandoverRestrictionList_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'NRrestrictionin5GS')))
    _____HandoverRestrictionList_iE_Extensions__item__id_tab_val_Extension_3 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PLMN-Identity')))
    _____HandoverRestrictionList_iE_Extensions__item__id_tab_val_Extension_4 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UnlicensedSpectrumRestriction')))
    _____HandoverRestrictionList_iE_Extensions__item__id_tab_val_Extension_5 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'RAT-Restrictions')))
    ____HandoverRestrictionList_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 202), ('criticality', 'ignore'), ('Extension', _____HandoverRestrictionList_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 301), ('criticality', 'ignore'), ('Extension', _____HandoverRestrictionList_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 305), ('criticality', 'ignore'), ('Extension', _____HandoverRestrictionList_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 332), ('criticality', 'ignore'), ('Extension', _____HandoverRestrictionList_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 358), ('criticality', 'ignore'), ('Extension', _____HandoverRestrictionList_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 437), ('criticality', 'ignore'), ('Extension', _____HandoverRestrictionList_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___HandoverRestrictionList_iE_Extensions__item__id._const_tab = ____HandoverRestrictionList_iE_Extensions__item__id_tab
    ___HandoverRestrictionList_iE_Extensions__item__id._const_tab_at = None
    ___HandoverRestrictionList_iE_Extensions__item__id._const_tab_id = 'id'
    ___HandoverRestrictionList_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___HandoverRestrictionList_iE_Extensions__item__criticality._const_tab = ____HandoverRestrictionList_iE_Extensions__item__id_tab
    ___HandoverRestrictionList_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HandoverRestrictionList_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HandoverRestrictionList_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___HandoverRestrictionList_iE_Extensions__item__extensionValue._const_tab = ____HandoverRestrictionList_iE_Extensions__item__id_tab
    ___HandoverRestrictionList_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HandoverRestrictionList_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HandoverRestrictionList_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HandoverRestrictionList_iE_Extensions__item__id),
        ('criticality', ___HandoverRestrictionList_iE_Extensions__item__criticality),
        ('extensionValue', ___HandoverRestrictionList_iE_Extensions__item__extensionValue),
        ])
    __HandoverRestrictionList_iE_Extensions__item_._ext = None
    _HandoverRestrictionList_iE_Extensions._cont = __HandoverRestrictionList_iE_Extensions__item_
    _HandoverRestrictionList_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HandoverRestrictionList._cont = ASN1Dict([
        ('servingPLMN', _HandoverRestrictionList_servingPLMN),
        ('equivalentPLMNs', _HandoverRestrictionList_equivalentPLMNs),
        ('forbiddenTAs', _HandoverRestrictionList_forbiddenTAs),
        ('forbiddenLAs', _HandoverRestrictionList_forbiddenLAs),
        ('forbiddenInterRATs', _HandoverRestrictionList_forbiddenInterRATs),
        ('iE-Extensions', _HandoverRestrictionList_iE_Extensions),
        ])
    HandoverRestrictionList._ext = []
    
    #-----< HandoverRestrictionList-ExtIEs >-----#
    HandoverRestrictionList_ExtIEs = CLASS(name='HandoverRestrictionList-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _HandoverRestrictionList_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'NRrestrictioninEPSasSecondaryRAT')))
    _HandoverRestrictionList_ExtIEs_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CNTypeRestrictions')))
    _HandoverRestrictionList_ExtIEs_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'NRrestrictionin5GS')))
    _HandoverRestrictionList_ExtIEs_val_Extension_3 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PLMN-Identity')))
    _HandoverRestrictionList_ExtIEs_val_Extension_4 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UnlicensedSpectrumRestriction')))
    _HandoverRestrictionList_ExtIEs_val_Extension_5 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'RAT-Restrictions')))
    HandoverRestrictionList_ExtIEs._val = ASN1Set(rv=[dict([('id', 202), ('criticality', 'ignore'), ('Extension', _HandoverRestrictionList_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 301), ('criticality', 'ignore'), ('Extension', _HandoverRestrictionList_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 305), ('criticality', 'ignore'), ('Extension', _HandoverRestrictionList_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 332), ('criticality', 'ignore'), ('Extension', _HandoverRestrictionList_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 358), ('criticality', 'ignore'), ('Extension', _HandoverRestrictionList_ExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 437), ('criticality', 'ignore'), ('Extension', _HandoverRestrictionList_ExtIEs_val_Extension_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< HFN >-----#
    HFN = INT(name='HFN', mode=MODE_TYPE)
    HFN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1048575)], ev=None, er=[])
    
    #-----< HFNModified >-----#
    HFNModified = INT(name='HFNModified', mode=MODE_TYPE)
    HFNModified._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=131071)], ev=None, er=[])
    
    #-----< HFNforPDCP-SNlength18 >-----#
    HFNforPDCP_SNlength18 = INT(name='HFNforPDCP-SNlength18', mode=MODE_TYPE)
    HFNforPDCP_SNlength18._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16383)], ev=None, er=[])
    
    #-----< HWLoadIndicator >-----#
    HWLoadIndicator = SEQ(name='HWLoadIndicator', mode=MODE_TYPE)
    _HWLoadIndicator_dLHWLoadIndicator = ENUM(name='dLHWLoadIndicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'LoadIndicator')))
    _HWLoadIndicator_uLHWLoadIndicator = ENUM(name='uLHWLoadIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'LoadIndicator')))
    _HWLoadIndicator_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HWLoadIndicator_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___HWLoadIndicator_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____HWLoadIndicator_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____HWLoadIndicator_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HWLoadIndicator_iE_Extensions__item__id._const_tab = ____HWLoadIndicator_iE_Extensions__item__id_tab
    ___HWLoadIndicator_iE_Extensions__item__id._const_tab_at = None
    ___HWLoadIndicator_iE_Extensions__item__id._const_tab_id = 'id'
    ___HWLoadIndicator_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HWLoadIndicator_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____HWLoadIndicator_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HWLoadIndicator_iE_Extensions__item__criticality._const_tab = ____HWLoadIndicator_iE_Extensions__item__criticality_tab
    ___HWLoadIndicator_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HWLoadIndicator_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HWLoadIndicator_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HWLoadIndicator_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____HWLoadIndicator_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HWLoadIndicator_iE_Extensions__item__extensionValue._const_tab = ____HWLoadIndicator_iE_Extensions__item__extensionValue_tab
    ___HWLoadIndicator_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HWLoadIndicator_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HWLoadIndicator_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HWLoadIndicator_iE_Extensions__item__id),
        ('criticality', ___HWLoadIndicator_iE_Extensions__item__criticality),
        ('extensionValue', ___HWLoadIndicator_iE_Extensions__item__extensionValue),
        ])
    __HWLoadIndicator_iE_Extensions__item_._ext = None
    _HWLoadIndicator_iE_Extensions._cont = __HWLoadIndicator_iE_Extensions__item_
    _HWLoadIndicator_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HWLoadIndicator._cont = ASN1Dict([
        ('dLHWLoadIndicator', _HWLoadIndicator_dLHWLoadIndicator),
        ('uLHWLoadIndicator', _HWLoadIndicator_uLHWLoadIndicator),
        ('iE-Extensions', _HWLoadIndicator_iE_Extensions),
        ])
    HWLoadIndicator._ext = []
    
    #-----< HWLoadIndicator-ExtIEs >-----#
    HWLoadIndicator_ExtIEs = CLASS(name='HWLoadIndicator-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    HWLoadIndicator_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IABNodeIndication >-----#
    IABNodeIndication = ENUM(name='IABNodeIndication', mode=MODE_TYPE)
    IABNodeIndication._cont = ASN1Dict([('true', 0)])
    IABNodeIndication._ext = []
    
    #-----< IMSvoiceEPSfallbackfrom5G >-----#
    IMSvoiceEPSfallbackfrom5G = ENUM(name='IMSvoiceEPSfallbackfrom5G', mode=MODE_TYPE)
    IMSvoiceEPSfallbackfrom5G._cont = ASN1Dict([('true', 0)])
    IMSvoiceEPSfallbackfrom5G._ext = []
    
    #-----< IntegrityProtectionAlgorithms >-----#
    IntegrityProtectionAlgorithms = BIT_STR(name='IntegrityProtectionAlgorithms', mode=MODE_TYPE)
    IntegrityProtectionAlgorithms._const_sz = ASN1Set(rv=[16], rr=[], ev=[], er=[])
    
    #-----< IntegrityProtectionIndication >-----#
    IntegrityProtectionIndication = ENUM(name='IntegrityProtectionIndication', mode=MODE_TYPE)
    IntegrityProtectionIndication._cont = ASN1Dict([('required', 0), ('preferred', 1), ('notneeded', 2)])
    IntegrityProtectionIndication._ext = []
    
    #-----< IntegrityProtectionResult >-----#
    IntegrityProtectionResult = ENUM(name='IntegrityProtectionResult', mode=MODE_TYPE)
    IntegrityProtectionResult._cont = ASN1Dict([('performed', 0), ('notperformed', 1)])
    IntegrityProtectionResult._ext = []
    
    #-----< IntendedTDD-DL-ULConfiguration-NR >-----#
    IntendedTDD_DL_ULConfiguration_NR = OCT_STR(name='IntendedTDD-DL-ULConfiguration-NR', mode=MODE_TYPE)
    
    #-----< InterfaceInstanceIndication >-----#
    InterfaceInstanceIndication = INT(name='InterfaceInstanceIndication', mode=MODE_TYPE)
    InterfaceInstanceIndication._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=[], er=[])
    
    #-----< InterfacesToTrace >-----#
    InterfacesToTrace = BIT_STR(name='InterfacesToTrace', mode=MODE_TYPE)
    InterfacesToTrace._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< InvokeIndication >-----#
    InvokeIndication = ENUM(name='InvokeIndication', mode=MODE_TYPE)
    InvokeIndication._cont = ASN1Dict([('abs-information', 0), ('naics-information-start', 1), ('naics-information-stop', 2)])
    InvokeIndication._ext = ['naics-information-start', 'naics-information-stop']
    
    #-----< Key-eNodeB-Star >-----#
    Key_eNodeB_Star = BIT_STR(name='Key-eNodeB-Star', mode=MODE_TYPE)
    Key_eNodeB_Star._const_sz = ASN1Set(rv=[256], rr=[], ev=None, er=[])
    
    #-----< LastVisitedPSCell-Item >-----#
    LastVisitedPSCell_Item = OCT_STR(name='LastVisitedPSCell-Item', mode=MODE_TYPE)
    
    #-----< LAC >-----#
    LAC = OCT_STR(name='LAC', mode=MODE_TYPE)
    LAC._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< LastVisitedCell-Item >-----#
    LastVisitedCell_Item = CHOICE(name='LastVisitedCell-Item', mode=MODE_TYPE)
    _LastVisitedCell_Item_e_UTRAN_Cell = SEQ(name='e-UTRAN-Cell', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'LastVisitedEUTRANCellInformation')))
    _LastVisitedCell_Item_uTRAN_Cell = OCT_STR(name='uTRAN-Cell', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'LastVisitedUTRANCellInformation')))
    _LastVisitedCell_Item_gERAN_Cell = CHOICE(name='gERAN-Cell', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'LastVisitedGERANCellInformation')))
    _LastVisitedCell_Item_nG_RAN_Cell = OCT_STR(name='nG-RAN-Cell', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'LastVisitedNGRANCellInformation')))
    LastVisitedCell_Item._cont = ASN1Dict([
        ('e-UTRAN-Cell', _LastVisitedCell_Item_e_UTRAN_Cell),
        ('uTRAN-Cell', _LastVisitedCell_Item_uTRAN_Cell),
        ('gERAN-Cell', _LastVisitedCell_Item_gERAN_Cell),
        ('nG-RAN-Cell', _LastVisitedCell_Item_nG_RAN_Cell),
        ])
    LastVisitedCell_Item._ext = ['nG-RAN-Cell']
    
    #-----< LastVisitedEUTRANCellInformation >-----#
    LastVisitedEUTRANCellInformation = SEQ(name='LastVisitedEUTRANCellInformation', mode=MODE_TYPE)
    _LastVisitedEUTRANCellInformation_global_Cell_ID = SEQ(name='global-Cell-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _LastVisitedEUTRANCellInformation_cellType = SEQ(name='cellType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CellType')))
    _LastVisitedEUTRANCellInformation_time_UE_StayedInCell = INT(name='time-UE-StayedInCell', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'Time-UE-StayedInCell')))
    _LastVisitedEUTRANCellInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LastVisitedEUTRANCellInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___LastVisitedEUTRANCellInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____LastVisitedEUTRANCellInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____LastVisitedEUTRANCellInformation_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Time-UE-StayedInCell-EnhancedGranularity')))
    _____LastVisitedEUTRANCellInformation_iE_Extensions__item__id_tab_val_Extension_1 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _____LastVisitedEUTRANCellInformation_iE_Extensions__item__id_tab_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PSCell-UE-HistoryInformation')))
    ____LastVisitedEUTRANCellInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 77), ('criticality', 'ignore'), ('Extension', _____LastVisitedEUTRANCellInformation_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 80), ('criticality', 'ignore'), ('Extension', _____LastVisitedEUTRANCellInformation_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 418), ('criticality', 'ignore'), ('Extension', _____LastVisitedEUTRANCellInformation_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___LastVisitedEUTRANCellInformation_iE_Extensions__item__id._const_tab = ____LastVisitedEUTRANCellInformation_iE_Extensions__item__id_tab
    ___LastVisitedEUTRANCellInformation_iE_Extensions__item__id._const_tab_at = None
    ___LastVisitedEUTRANCellInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___LastVisitedEUTRANCellInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___LastVisitedEUTRANCellInformation_iE_Extensions__item__criticality._const_tab = ____LastVisitedEUTRANCellInformation_iE_Extensions__item__id_tab
    ___LastVisitedEUTRANCellInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___LastVisitedEUTRANCellInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___LastVisitedEUTRANCellInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___LastVisitedEUTRANCellInformation_iE_Extensions__item__extensionValue._const_tab = ____LastVisitedEUTRANCellInformation_iE_Extensions__item__id_tab
    ___LastVisitedEUTRANCellInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___LastVisitedEUTRANCellInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __LastVisitedEUTRANCellInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___LastVisitedEUTRANCellInformation_iE_Extensions__item__id),
        ('criticality', ___LastVisitedEUTRANCellInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___LastVisitedEUTRANCellInformation_iE_Extensions__item__extensionValue),
        ])
    __LastVisitedEUTRANCellInformation_iE_Extensions__item_._ext = None
    _LastVisitedEUTRANCellInformation_iE_Extensions._cont = __LastVisitedEUTRANCellInformation_iE_Extensions__item_
    _LastVisitedEUTRANCellInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LastVisitedEUTRANCellInformation._cont = ASN1Dict([
        ('global-Cell-ID', _LastVisitedEUTRANCellInformation_global_Cell_ID),
        ('cellType', _LastVisitedEUTRANCellInformation_cellType),
        ('time-UE-StayedInCell', _LastVisitedEUTRANCellInformation_time_UE_StayedInCell),
        ('iE-Extensions', _LastVisitedEUTRANCellInformation_iE_Extensions),
        ])
    LastVisitedEUTRANCellInformation._ext = []
    
    #-----< LastVisitedEUTRANCellInformation-ExtIEs >-----#
    LastVisitedEUTRANCellInformation_ExtIEs = CLASS(name='LastVisitedEUTRANCellInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _LastVisitedEUTRANCellInformation_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Time-UE-StayedInCell-EnhancedGranularity')))
    _LastVisitedEUTRANCellInformation_ExtIEs_val_Extension_1 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _LastVisitedEUTRANCellInformation_ExtIEs_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PSCell-UE-HistoryInformation')))
    LastVisitedEUTRANCellInformation_ExtIEs._val = ASN1Set(rv=[dict([('id', 77), ('criticality', 'ignore'), ('Extension', _LastVisitedEUTRANCellInformation_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 80), ('criticality', 'ignore'), ('Extension', _LastVisitedEUTRANCellInformation_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 418), ('criticality', 'ignore'), ('Extension', _LastVisitedEUTRANCellInformation_ExtIEs_val_Extension_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< LastVisitedGERANCellInformation >-----#
    LastVisitedGERANCellInformation = CHOICE(name='LastVisitedGERANCellInformation', mode=MODE_TYPE)
    _LastVisitedGERANCellInformation_undefined = NULL(name='undefined', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    LastVisitedGERANCellInformation._cont = ASN1Dict([
        ('undefined', _LastVisitedGERANCellInformation_undefined),
        ])
    LastVisitedGERANCellInformation._ext = []
    
    #-----< LastVisitedNGRANCellInformation >-----#
    LastVisitedNGRANCellInformation = OCT_STR(name='LastVisitedNGRANCellInformation', mode=MODE_TYPE)
    
    #-----< LastVisitedUTRANCellInformation >-----#
    LastVisitedUTRANCellInformation = OCT_STR(name='LastVisitedUTRANCellInformation', mode=MODE_TYPE)
    
    #-----< LCID >-----#
    LCID = INT(name='LCID', mode=MODE_TYPE)
    LCID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=[], er=[])
    
    #-----< LHN-ID >-----#
    LHN_ID = OCT_STR(name='LHN-ID', mode=MODE_TYPE)
    LHN_ID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=32, ub=256)], ev=None, er=[])
    
    #-----< Links-to-log >-----#
    Links_to_log = ENUM(name='Links-to-log', mode=MODE_TYPE)
    Links_to_log._cont = ASN1Dict([('uplink', 0), ('downlink', 1), ('both-uplink-and-downlink', 2)])
    Links_to_log._ext = []
    
    #-----< LoadIndicator >-----#
    LoadIndicator = ENUM(name='LoadIndicator', mode=MODE_TYPE)
    LoadIndicator._cont = ASN1Dict([('lowLoad', 0), ('mediumLoad', 1), ('highLoad', 2), ('overLoad', 3)])
    LoadIndicator._ext = []
    
    #-----< LocationInformationSgNB >-----#
    LocationInformationSgNB = SEQ(name='LocationInformationSgNB', mode=MODE_TYPE)
    _LocationInformationSgNB_pSCell_id = SEQ(name='pSCell-id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'NRCGI')))
    _LocationInformationSgNB_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LocationInformationSgNB_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___LocationInformationSgNB_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____LocationInformationSgNB_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____LocationInformationSgNB_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LocationInformationSgNB_iE_Extensions__item__id._const_tab = ____LocationInformationSgNB_iE_Extensions__item__id_tab
    ___LocationInformationSgNB_iE_Extensions__item__id._const_tab_at = None
    ___LocationInformationSgNB_iE_Extensions__item__id._const_tab_id = 'id'
    ___LocationInformationSgNB_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____LocationInformationSgNB_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____LocationInformationSgNB_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LocationInformationSgNB_iE_Extensions__item__criticality._const_tab = ____LocationInformationSgNB_iE_Extensions__item__criticality_tab
    ___LocationInformationSgNB_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___LocationInformationSgNB_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___LocationInformationSgNB_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____LocationInformationSgNB_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____LocationInformationSgNB_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LocationInformationSgNB_iE_Extensions__item__extensionValue._const_tab = ____LocationInformationSgNB_iE_Extensions__item__extensionValue_tab
    ___LocationInformationSgNB_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___LocationInformationSgNB_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __LocationInformationSgNB_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___LocationInformationSgNB_iE_Extensions__item__id),
        ('criticality', ___LocationInformationSgNB_iE_Extensions__item__criticality),
        ('extensionValue', ___LocationInformationSgNB_iE_Extensions__item__extensionValue),
        ])
    __LocationInformationSgNB_iE_Extensions__item_._ext = None
    _LocationInformationSgNB_iE_Extensions._cont = __LocationInformationSgNB_iE_Extensions__item_
    _LocationInformationSgNB_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LocationInformationSgNB._cont = ASN1Dict([
        ('pSCell-id', _LocationInformationSgNB_pSCell_id),
        ('iE-Extensions', _LocationInformationSgNB_iE_Extensions),
        ])
    LocationInformationSgNB._ext = []
    
    #-----< LocationInformationSgNB-ExtIEs >-----#
    LocationInformationSgNB_ExtIEs = CLASS(name='LocationInformationSgNB-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    LocationInformationSgNB_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< LocationInformationSgNBReporting >-----#
    LocationInformationSgNBReporting = ENUM(name='LocationInformationSgNBReporting', mode=MODE_TYPE)
    LocationInformationSgNBReporting._cont = ASN1Dict([('pSCell', 0)])
    LocationInformationSgNBReporting._ext = []
    
    #-----< LocationReportingInformation >-----#
    LocationReportingInformation = SEQ(name='LocationReportingInformation', mode=MODE_TYPE)
    _LocationReportingInformation_eventType = ENUM(name='eventType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'EventType')))
    _LocationReportingInformation_reportArea = ENUM(name='reportArea', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ReportArea')))
    _LocationReportingInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LocationReportingInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___LocationReportingInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____LocationReportingInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____LocationReportingInformation_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'AdditionLocationInformation')))
    ____LocationReportingInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 409), ('criticality', 'ignore'), ('Extension', _____LocationReportingInformation_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___LocationReportingInformation_iE_Extensions__item__id._const_tab = ____LocationReportingInformation_iE_Extensions__item__id_tab
    ___LocationReportingInformation_iE_Extensions__item__id._const_tab_at = None
    ___LocationReportingInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___LocationReportingInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___LocationReportingInformation_iE_Extensions__item__criticality._const_tab = ____LocationReportingInformation_iE_Extensions__item__id_tab
    ___LocationReportingInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___LocationReportingInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___LocationReportingInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___LocationReportingInformation_iE_Extensions__item__extensionValue._const_tab = ____LocationReportingInformation_iE_Extensions__item__id_tab
    ___LocationReportingInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___LocationReportingInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __LocationReportingInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___LocationReportingInformation_iE_Extensions__item__id),
        ('criticality', ___LocationReportingInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___LocationReportingInformation_iE_Extensions__item__extensionValue),
        ])
    __LocationReportingInformation_iE_Extensions__item_._ext = None
    _LocationReportingInformation_iE_Extensions._cont = __LocationReportingInformation_iE_Extensions__item_
    _LocationReportingInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LocationReportingInformation._cont = ASN1Dict([
        ('eventType', _LocationReportingInformation_eventType),
        ('reportArea', _LocationReportingInformation_reportArea),
        ('iE-Extensions', _LocationReportingInformation_iE_Extensions),
        ])
    LocationReportingInformation._ext = []
    
    #-----< LocationReportingInformation-ExtIEs >-----#
    LocationReportingInformation_ExtIEs = CLASS(name='LocationReportingInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _LocationReportingInformation_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'AdditionLocationInformation')))
    LocationReportingInformation_ExtIEs._val = ASN1Set(rv=[dict([('id', 409), ('criticality', 'ignore'), ('Extension', _LocationReportingInformation_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< LowerLayerPresenceStatusChange >-----#
    LowerLayerPresenceStatusChange = ENUM(name='LowerLayerPresenceStatusChange', mode=MODE_TYPE)
    LowerLayerPresenceStatusChange._cont = ASN1Dict([('release-lower-layers', 0), ('re-establish-lower-layers', 1), ('suspend-lower-layers', 2), ('resume-lower-layers', 3)])
    LowerLayerPresenceStatusChange._ext = []
    
    #-----< M1PeriodicReporting >-----#
    M1PeriodicReporting = SEQ(name='M1PeriodicReporting', mode=MODE_TYPE)
    _M1PeriodicReporting_reportInterval = ENUM(name='reportInterval', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ReportIntervalMDT')))
    _M1PeriodicReporting_reportAmount = ENUM(name='reportAmount', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ReportAmountMDT')))
    _M1PeriodicReporting_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __M1PeriodicReporting_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___M1PeriodicReporting_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____M1PeriodicReporting_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____M1PeriodicReporting_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M1PeriodicReporting_iE_Extensions__item__id._const_tab = ____M1PeriodicReporting_iE_Extensions__item__id_tab
    ___M1PeriodicReporting_iE_Extensions__item__id._const_tab_at = None
    ___M1PeriodicReporting_iE_Extensions__item__id._const_tab_id = 'id'
    ___M1PeriodicReporting_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____M1PeriodicReporting_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____M1PeriodicReporting_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M1PeriodicReporting_iE_Extensions__item__criticality._const_tab = ____M1PeriodicReporting_iE_Extensions__item__criticality_tab
    ___M1PeriodicReporting_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___M1PeriodicReporting_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___M1PeriodicReporting_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____M1PeriodicReporting_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____M1PeriodicReporting_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M1PeriodicReporting_iE_Extensions__item__extensionValue._const_tab = ____M1PeriodicReporting_iE_Extensions__item__extensionValue_tab
    ___M1PeriodicReporting_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___M1PeriodicReporting_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __M1PeriodicReporting_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___M1PeriodicReporting_iE_Extensions__item__id),
        ('criticality', ___M1PeriodicReporting_iE_Extensions__item__criticality),
        ('extensionValue', ___M1PeriodicReporting_iE_Extensions__item__extensionValue),
        ])
    __M1PeriodicReporting_iE_Extensions__item_._ext = None
    _M1PeriodicReporting_iE_Extensions._cont = __M1PeriodicReporting_iE_Extensions__item_
    _M1PeriodicReporting_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    M1PeriodicReporting._cont = ASN1Dict([
        ('reportInterval', _M1PeriodicReporting_reportInterval),
        ('reportAmount', _M1PeriodicReporting_reportAmount),
        ('iE-Extensions', _M1PeriodicReporting_iE_Extensions),
        ])
    M1PeriodicReporting._ext = []
    
    #-----< M1PeriodicReporting-ExtIEs >-----#
    M1PeriodicReporting_ExtIEs = CLASS(name='M1PeriodicReporting-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    M1PeriodicReporting_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< M1ReportingTrigger >-----#
    M1ReportingTrigger = ENUM(name='M1ReportingTrigger', mode=MODE_TYPE)
    M1ReportingTrigger._cont = ASN1Dict([('periodic', 0), ('a2eventtriggered', 1), ('a2eventtriggered-periodic', 2)])
    M1ReportingTrigger._ext = ['a2eventtriggered-periodic']
    
    #-----< M1ThresholdEventA2 >-----#
    M1ThresholdEventA2 = SEQ(name='M1ThresholdEventA2', mode=MODE_TYPE)
    _M1ThresholdEventA2_measurementThreshold = CHOICE(name='measurementThreshold', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'MeasurementThresholdA2')))
    _M1ThresholdEventA2_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __M1ThresholdEventA2_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___M1ThresholdEventA2_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____M1ThresholdEventA2_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____M1ThresholdEventA2_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M1ThresholdEventA2_iE_Extensions__item__id._const_tab = ____M1ThresholdEventA2_iE_Extensions__item__id_tab
    ___M1ThresholdEventA2_iE_Extensions__item__id._const_tab_at = None
    ___M1ThresholdEventA2_iE_Extensions__item__id._const_tab_id = 'id'
    ___M1ThresholdEventA2_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____M1ThresholdEventA2_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____M1ThresholdEventA2_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M1ThresholdEventA2_iE_Extensions__item__criticality._const_tab = ____M1ThresholdEventA2_iE_Extensions__item__criticality_tab
    ___M1ThresholdEventA2_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___M1ThresholdEventA2_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___M1ThresholdEventA2_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____M1ThresholdEventA2_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____M1ThresholdEventA2_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M1ThresholdEventA2_iE_Extensions__item__extensionValue._const_tab = ____M1ThresholdEventA2_iE_Extensions__item__extensionValue_tab
    ___M1ThresholdEventA2_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___M1ThresholdEventA2_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __M1ThresholdEventA2_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___M1ThresholdEventA2_iE_Extensions__item__id),
        ('criticality', ___M1ThresholdEventA2_iE_Extensions__item__criticality),
        ('extensionValue', ___M1ThresholdEventA2_iE_Extensions__item__extensionValue),
        ])
    __M1ThresholdEventA2_iE_Extensions__item_._ext = None
    _M1ThresholdEventA2_iE_Extensions._cont = __M1ThresholdEventA2_iE_Extensions__item_
    _M1ThresholdEventA2_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    M1ThresholdEventA2._cont = ASN1Dict([
        ('measurementThreshold', _M1ThresholdEventA2_measurementThreshold),
        ('iE-Extensions', _M1ThresholdEventA2_iE_Extensions),
        ])
    M1ThresholdEventA2._ext = []
    
    #-----< M1ThresholdEventA2-ExtIEs >-----#
    M1ThresholdEventA2_ExtIEs = CLASS(name='M1ThresholdEventA2-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    M1ThresholdEventA2_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< M3Configuration >-----#
    M3Configuration = SEQ(name='M3Configuration', mode=MODE_TYPE)
    _M3Configuration_m3period = ENUM(name='m3period', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'M3period')))
    _M3Configuration_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __M3Configuration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___M3Configuration_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____M3Configuration_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____M3Configuration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M3Configuration_iE_Extensions__item__id._const_tab = ____M3Configuration_iE_Extensions__item__id_tab
    ___M3Configuration_iE_Extensions__item__id._const_tab_at = None
    ___M3Configuration_iE_Extensions__item__id._const_tab_id = 'id'
    ___M3Configuration_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____M3Configuration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____M3Configuration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M3Configuration_iE_Extensions__item__criticality._const_tab = ____M3Configuration_iE_Extensions__item__criticality_tab
    ___M3Configuration_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___M3Configuration_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___M3Configuration_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____M3Configuration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____M3Configuration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M3Configuration_iE_Extensions__item__extensionValue._const_tab = ____M3Configuration_iE_Extensions__item__extensionValue_tab
    ___M3Configuration_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___M3Configuration_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __M3Configuration_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___M3Configuration_iE_Extensions__item__id),
        ('criticality', ___M3Configuration_iE_Extensions__item__criticality),
        ('extensionValue', ___M3Configuration_iE_Extensions__item__extensionValue),
        ])
    __M3Configuration_iE_Extensions__item_._ext = None
    _M3Configuration_iE_Extensions._cont = __M3Configuration_iE_Extensions__item_
    _M3Configuration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    M3Configuration._cont = ASN1Dict([
        ('m3period', _M3Configuration_m3period),
        ('iE-Extensions', _M3Configuration_iE_Extensions),
        ])
    M3Configuration._ext = []
    
    #-----< M3Configuration-ExtIEs >-----#
    M3Configuration_ExtIEs = CLASS(name='M3Configuration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    M3Configuration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< M3period >-----#
    M3period = ENUM(name='M3period', mode=MODE_TYPE)
    M3period._cont = ASN1Dict([('ms100', 0), ('ms1000', 1), ('ms10000', 2)])
    M3period._ext = []
    
    #-----< M4Configuration >-----#
    M4Configuration = SEQ(name='M4Configuration', mode=MODE_TYPE)
    _M4Configuration_m4period = ENUM(name='m4period', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'M4period')))
    _M4Configuration_m4_links_to_log = ENUM(name='m4-links-to-log', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'Links-to-log')))
    _M4Configuration_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __M4Configuration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___M4Configuration_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____M4Configuration_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____M4Configuration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M4Configuration_iE_Extensions__item__id._const_tab = ____M4Configuration_iE_Extensions__item__id_tab
    ___M4Configuration_iE_Extensions__item__id._const_tab_at = None
    ___M4Configuration_iE_Extensions__item__id._const_tab_id = 'id'
    ___M4Configuration_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____M4Configuration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____M4Configuration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M4Configuration_iE_Extensions__item__criticality._const_tab = ____M4Configuration_iE_Extensions__item__criticality_tab
    ___M4Configuration_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___M4Configuration_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___M4Configuration_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____M4Configuration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____M4Configuration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M4Configuration_iE_Extensions__item__extensionValue._const_tab = ____M4Configuration_iE_Extensions__item__extensionValue_tab
    ___M4Configuration_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___M4Configuration_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __M4Configuration_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___M4Configuration_iE_Extensions__item__id),
        ('criticality', ___M4Configuration_iE_Extensions__item__criticality),
        ('extensionValue', ___M4Configuration_iE_Extensions__item__extensionValue),
        ])
    __M4Configuration_iE_Extensions__item_._ext = None
    _M4Configuration_iE_Extensions._cont = __M4Configuration_iE_Extensions__item_
    _M4Configuration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    M4Configuration._cont = ASN1Dict([
        ('m4period', _M4Configuration_m4period),
        ('m4-links-to-log', _M4Configuration_m4_links_to_log),
        ('iE-Extensions', _M4Configuration_iE_Extensions),
        ])
    M4Configuration._ext = []
    
    #-----< M4Configuration-ExtIEs >-----#
    M4Configuration_ExtIEs = CLASS(name='M4Configuration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    M4Configuration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< M4period >-----#
    M4period = ENUM(name='M4period', mode=MODE_TYPE)
    M4period._cont = ASN1Dict([('ms1024', 0), ('ms2048', 1), ('ms5120', 2), ('ms10240', 3), ('min1', 4)])
    M4period._ext = []
    
    #-----< M5Configuration >-----#
    M5Configuration = SEQ(name='M5Configuration', mode=MODE_TYPE)
    _M5Configuration_m5period = ENUM(name='m5period', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'M5period')))
    _M5Configuration_m5_links_to_log = ENUM(name='m5-links-to-log', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'Links-to-log')))
    _M5Configuration_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __M5Configuration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___M5Configuration_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____M5Configuration_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____M5Configuration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M5Configuration_iE_Extensions__item__id._const_tab = ____M5Configuration_iE_Extensions__item__id_tab
    ___M5Configuration_iE_Extensions__item__id._const_tab_at = None
    ___M5Configuration_iE_Extensions__item__id._const_tab_id = 'id'
    ___M5Configuration_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____M5Configuration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____M5Configuration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M5Configuration_iE_Extensions__item__criticality._const_tab = ____M5Configuration_iE_Extensions__item__criticality_tab
    ___M5Configuration_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___M5Configuration_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___M5Configuration_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____M5Configuration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____M5Configuration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M5Configuration_iE_Extensions__item__extensionValue._const_tab = ____M5Configuration_iE_Extensions__item__extensionValue_tab
    ___M5Configuration_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___M5Configuration_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __M5Configuration_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___M5Configuration_iE_Extensions__item__id),
        ('criticality', ___M5Configuration_iE_Extensions__item__criticality),
        ('extensionValue', ___M5Configuration_iE_Extensions__item__extensionValue),
        ])
    __M5Configuration_iE_Extensions__item_._ext = None
    _M5Configuration_iE_Extensions._cont = __M5Configuration_iE_Extensions__item_
    _M5Configuration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    M5Configuration._cont = ASN1Dict([
        ('m5period', _M5Configuration_m5period),
        ('m5-links-to-log', _M5Configuration_m5_links_to_log),
        ('iE-Extensions', _M5Configuration_iE_Extensions),
        ])
    M5Configuration._ext = []
    
    #-----< M5Configuration-ExtIEs >-----#
    M5Configuration_ExtIEs = CLASS(name='M5Configuration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    M5Configuration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< M5period >-----#
    M5period = ENUM(name='M5period', mode=MODE_TYPE)
    M5period._cont = ASN1Dict([('ms1024', 0), ('ms2048', 1), ('ms5120', 2), ('ms10240', 3), ('min1', 4)])
    M5period._ext = []
    
    #-----< M6Configuration >-----#
    M6Configuration = SEQ(name='M6Configuration', mode=MODE_TYPE)
    _M6Configuration_m6report_interval = ENUM(name='m6report-interval', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'M6report-interval')))
    _M6Configuration_m6delay_threshold = ENUM(name='m6delay-threshold', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'M6delay-threshold')), opt=True)
    _M6Configuration_m6_links_to_log = ENUM(name='m6-links-to-log', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'Links-to-log')))
    _M6Configuration_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __M6Configuration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___M6Configuration_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____M6Configuration_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____M6Configuration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M6Configuration_iE_Extensions__item__id._const_tab = ____M6Configuration_iE_Extensions__item__id_tab
    ___M6Configuration_iE_Extensions__item__id._const_tab_at = None
    ___M6Configuration_iE_Extensions__item__id._const_tab_id = 'id'
    ___M6Configuration_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____M6Configuration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____M6Configuration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M6Configuration_iE_Extensions__item__criticality._const_tab = ____M6Configuration_iE_Extensions__item__criticality_tab
    ___M6Configuration_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___M6Configuration_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___M6Configuration_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____M6Configuration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____M6Configuration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M6Configuration_iE_Extensions__item__extensionValue._const_tab = ____M6Configuration_iE_Extensions__item__extensionValue_tab
    ___M6Configuration_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___M6Configuration_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __M6Configuration_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___M6Configuration_iE_Extensions__item__id),
        ('criticality', ___M6Configuration_iE_Extensions__item__criticality),
        ('extensionValue', ___M6Configuration_iE_Extensions__item__extensionValue),
        ])
    __M6Configuration_iE_Extensions__item_._ext = None
    _M6Configuration_iE_Extensions._cont = __M6Configuration_iE_Extensions__item_
    _M6Configuration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    M6Configuration._cont = ASN1Dict([
        ('m6report-interval', _M6Configuration_m6report_interval),
        ('m6delay-threshold', _M6Configuration_m6delay_threshold),
        ('m6-links-to-log', _M6Configuration_m6_links_to_log),
        ('iE-Extensions', _M6Configuration_iE_Extensions),
        ])
    M6Configuration._ext = []
    
    #-----< M6Configuration-ExtIEs >-----#
    M6Configuration_ExtIEs = CLASS(name='M6Configuration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    M6Configuration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< M6report-interval >-----#
    M6report_interval = ENUM(name='M6report-interval', mode=MODE_TYPE)
    M6report_interval._cont = ASN1Dict([('ms1024', 0), ('ms2048', 1), ('ms5120', 2), ('ms10240', 3)])
    M6report_interval._ext = []
    
    #-----< M6delay-threshold >-----#
    M6delay_threshold = ENUM(name='M6delay-threshold', mode=MODE_TYPE)
    M6delay_threshold._cont = ASN1Dict([('ms30', 0), ('ms40', 1), ('ms50', 2), ('ms60', 3), ('ms70', 4), ('ms80', 5), ('ms90', 6), ('ms100', 7), ('ms150', 8), ('ms300', 9), ('ms500', 10), ('ms750', 11)])
    M6delay_threshold._ext = []
    
    #-----< M7Configuration >-----#
    M7Configuration = SEQ(name='M7Configuration', mode=MODE_TYPE)
    _M7Configuration_m7period = INT(name='m7period', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'M7period')))
    _M7Configuration_m7_links_to_log = ENUM(name='m7-links-to-log', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'Links-to-log')))
    _M7Configuration_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __M7Configuration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___M7Configuration_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____M7Configuration_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____M7Configuration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M7Configuration_iE_Extensions__item__id._const_tab = ____M7Configuration_iE_Extensions__item__id_tab
    ___M7Configuration_iE_Extensions__item__id._const_tab_at = None
    ___M7Configuration_iE_Extensions__item__id._const_tab_id = 'id'
    ___M7Configuration_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____M7Configuration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____M7Configuration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M7Configuration_iE_Extensions__item__criticality._const_tab = ____M7Configuration_iE_Extensions__item__criticality_tab
    ___M7Configuration_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___M7Configuration_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___M7Configuration_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____M7Configuration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____M7Configuration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M7Configuration_iE_Extensions__item__extensionValue._const_tab = ____M7Configuration_iE_Extensions__item__extensionValue_tab
    ___M7Configuration_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___M7Configuration_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __M7Configuration_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___M7Configuration_iE_Extensions__item__id),
        ('criticality', ___M7Configuration_iE_Extensions__item__criticality),
        ('extensionValue', ___M7Configuration_iE_Extensions__item__extensionValue),
        ])
    __M7Configuration_iE_Extensions__item_._ext = None
    _M7Configuration_iE_Extensions._cont = __M7Configuration_iE_Extensions__item_
    _M7Configuration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    M7Configuration._cont = ASN1Dict([
        ('m7period', _M7Configuration_m7period),
        ('m7-links-to-log', _M7Configuration_m7_links_to_log),
        ('iE-Extensions', _M7Configuration_iE_Extensions),
        ])
    M7Configuration._ext = []
    
    #-----< M7Configuration-ExtIEs >-----#
    M7Configuration_ExtIEs = CLASS(name='M7Configuration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    M7Configuration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< M7period >-----#
    M7period = INT(name='M7period', mode=MODE_TYPE)
    M7period._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=60)], ev=[], er=[])
    
    #-----< MakeBeforeBreakIndicator >-----#
    MakeBeforeBreakIndicator = ENUM(name='MakeBeforeBreakIndicator', mode=MODE_TYPE)
    MakeBeforeBreakIndicator._cont = ASN1Dict([('true', 0)])
    MakeBeforeBreakIndicator._ext = []
    
    #-----< ManagementBasedMDTallowed >-----#
    ManagementBasedMDTallowed = ENUM(name='ManagementBasedMDTallowed', mode=MODE_TYPE)
    ManagementBasedMDTallowed._cont = ASN1Dict([('allowed', 0)])
    ManagementBasedMDTallowed._ext = []
    
    #-----< Masked-IMEISV >-----#
    Masked_IMEISV = BIT_STR(name='Masked-IMEISV', mode=MODE_TYPE)
    Masked_IMEISV._const_sz = ASN1Set(rv=[64], rr=[], ev=None, er=[])
    
    #-----< MaxCHOpreparations >-----#
    MaxCHOpreparations = INT(name='MaxCHOpreparations', mode=MODE_TYPE)
    MaxCHOpreparations._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=[], er=[])
    
    #-----< MDT-Activation >-----#
    MDT_Activation = ENUM(name='MDT-Activation', mode=MODE_TYPE)
    MDT_Activation._cont = ASN1Dict([('immediate-MDT-only', 0), ('immediate-MDT-and-Trace', 1)])
    MDT_Activation._ext = []
    
    #-----< MDT-Configuration >-----#
    MDT_Configuration = SEQ(name='MDT-Configuration', mode=MODE_TYPE)
    _MDT_Configuration_mdt_Activation = ENUM(name='mdt-Activation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'MDT-Activation')))
    _MDT_Configuration_areaScopeOfMDT = CHOICE(name='areaScopeOfMDT', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'AreaScopeOfMDT')))
    _MDT_Configuration_measurementsToActivate = BIT_STR(name='measurementsToActivate', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'MeasurementsToActivate')))
    _MDT_Configuration_m1reportingTrigger = ENUM(name='m1reportingTrigger', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'M1ReportingTrigger')))
    _MDT_Configuration_m1thresholdeventA2 = SEQ(name='m1thresholdeventA2', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'M1ThresholdEventA2')), opt=True)
    _MDT_Configuration_m1periodicReporting = SEQ(name='m1periodicReporting', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'M1PeriodicReporting')), opt=True)
    _MDT_Configuration_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MDT_Configuration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___MDT_Configuration_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____MDT_Configuration_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____MDT_Configuration_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'M3Configuration')))
    _____MDT_Configuration_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'M4Configuration')))
    _____MDT_Configuration_iE_Extensions__item__id_tab_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'M5Configuration')))
    _____MDT_Configuration_iE_Extensions__item__id_tab_val_Extension_3 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MDT-Location-Info')))
    _____MDT_Configuration_iE_Extensions__item__id_tab_val_Extension_4 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MDTPLMNList')))
    _____MDT_Configuration_iE_Extensions__item__id_tab_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'M6Configuration')))
    _____MDT_Configuration_iE_Extensions__item__id_tab_val_Extension_6 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'M7Configuration')))
    _____MDT_Configuration_iE_Extensions__item__id_tab_val_Extension_7 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'BluetoothMeasurementConfiguration')))
    _____MDT_Configuration_iE_Extensions__item__id_tab_val_Extension_8 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'WLANMeasurementConfiguration')))
    _____MDT_Configuration_iE_Extensions__item__id_tab_val_Extension_9 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SensorMeasurementConfiguration')))
    ____MDT_Configuration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 85), ('criticality', 'ignore'), ('Extension', _____MDT_Configuration_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'conditional')]), dict([('id', 86), ('criticality', 'ignore'), ('Extension', _____MDT_Configuration_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'conditional')]), dict([('id', 87), ('criticality', 'ignore'), ('Extension', _____MDT_Configuration_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'conditional')]), dict([('id', 88), ('criticality', 'ignore'), ('Extension', _____MDT_Configuration_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 90), ('criticality', 'ignore'), ('Extension', _____MDT_Configuration_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 161), ('criticality', 'ignore'), ('Extension', _____MDT_Configuration_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'conditional')]), dict([('id', 162), ('criticality', 'ignore'), ('Extension', _____MDT_Configuration_iE_Extensions__item__id_tab_val_Extension_6), ('presence', 'conditional')]), dict([('id', 303), ('criticality', 'ignore'), ('Extension', _____MDT_Configuration_iE_Extensions__item__id_tab_val_Extension_7), ('presence', 'optional')]), dict([('id', 304), ('criticality', 'ignore'), ('Extension', _____MDT_Configuration_iE_Extensions__item__id_tab_val_Extension_8), ('presence', 'optional')]), dict([('id', 440), ('criticality', 'ignore'), ('Extension', _____MDT_Configuration_iE_Extensions__item__id_tab_val_Extension_9), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MDT_Configuration_iE_Extensions__item__id._const_tab = ____MDT_Configuration_iE_Extensions__item__id_tab
    ___MDT_Configuration_iE_Extensions__item__id._const_tab_at = None
    ___MDT_Configuration_iE_Extensions__item__id._const_tab_id = 'id'
    ___MDT_Configuration_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___MDT_Configuration_iE_Extensions__item__criticality._const_tab = ____MDT_Configuration_iE_Extensions__item__id_tab
    ___MDT_Configuration_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MDT_Configuration_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MDT_Configuration_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___MDT_Configuration_iE_Extensions__item__extensionValue._const_tab = ____MDT_Configuration_iE_Extensions__item__id_tab
    ___MDT_Configuration_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MDT_Configuration_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MDT_Configuration_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MDT_Configuration_iE_Extensions__item__id),
        ('criticality', ___MDT_Configuration_iE_Extensions__item__criticality),
        ('extensionValue', ___MDT_Configuration_iE_Extensions__item__extensionValue),
        ])
    __MDT_Configuration_iE_Extensions__item_._ext = None
    _MDT_Configuration_iE_Extensions._cont = __MDT_Configuration_iE_Extensions__item_
    _MDT_Configuration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MDT_Configuration._cont = ASN1Dict([
        ('mdt-Activation', _MDT_Configuration_mdt_Activation),
        ('areaScopeOfMDT', _MDT_Configuration_areaScopeOfMDT),
        ('measurementsToActivate', _MDT_Configuration_measurementsToActivate),
        ('m1reportingTrigger', _MDT_Configuration_m1reportingTrigger),
        ('m1thresholdeventA2', _MDT_Configuration_m1thresholdeventA2),
        ('m1periodicReporting', _MDT_Configuration_m1periodicReporting),
        ('iE-Extensions', _MDT_Configuration_iE_Extensions),
        ])
    MDT_Configuration._ext = []
    
    #-----< MDT-Configuration-ExtIEs >-----#
    MDT_Configuration_ExtIEs = CLASS(name='MDT-Configuration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _MDT_Configuration_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'M3Configuration')))
    _MDT_Configuration_ExtIEs_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'M4Configuration')))
    _MDT_Configuration_ExtIEs_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'M5Configuration')))
    _MDT_Configuration_ExtIEs_val_Extension_3 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MDT-Location-Info')))
    _MDT_Configuration_ExtIEs_val_Extension_4 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MDTPLMNList')))
    _MDT_Configuration_ExtIEs_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'M6Configuration')))
    _MDT_Configuration_ExtIEs_val_Extension_6 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'M7Configuration')))
    _MDT_Configuration_ExtIEs_val_Extension_7 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'BluetoothMeasurementConfiguration')))
    _MDT_Configuration_ExtIEs_val_Extension_8 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'WLANMeasurementConfiguration')))
    _MDT_Configuration_ExtIEs_val_Extension_9 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SensorMeasurementConfiguration')))
    MDT_Configuration_ExtIEs._val = ASN1Set(rv=[dict([('id', 85), ('criticality', 'ignore'), ('Extension', _MDT_Configuration_ExtIEs_val_Extension_0), ('presence', 'conditional')]), dict([('id', 86), ('criticality', 'ignore'), ('Extension', _MDT_Configuration_ExtIEs_val_Extension_1), ('presence', 'conditional')]), dict([('id', 87), ('criticality', 'ignore'), ('Extension', _MDT_Configuration_ExtIEs_val_Extension_2), ('presence', 'conditional')]), dict([('id', 88), ('criticality', 'ignore'), ('Extension', _MDT_Configuration_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 90), ('criticality', 'ignore'), ('Extension', _MDT_Configuration_ExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 161), ('criticality', 'ignore'), ('Extension', _MDT_Configuration_ExtIEs_val_Extension_5), ('presence', 'conditional')]), dict([('id', 162), ('criticality', 'ignore'), ('Extension', _MDT_Configuration_ExtIEs_val_Extension_6), ('presence', 'conditional')]), dict([('id', 303), ('criticality', 'ignore'), ('Extension', _MDT_Configuration_ExtIEs_val_Extension_7), ('presence', 'optional')]), dict([('id', 304), ('criticality', 'ignore'), ('Extension', _MDT_Configuration_ExtIEs_val_Extension_8), ('presence', 'optional')]), dict([('id', 440), ('criticality', 'ignore'), ('Extension', _MDT_Configuration_ExtIEs_val_Extension_9), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MDTPLMNList >-----#
    MDTPLMNList = SEQ_OF(name='MDTPLMNList', mode=MODE_TYPE)
    _MDTPLMNList__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PLMN-Identity')))
    MDTPLMNList._cont = _MDTPLMNList__item_
    MDTPLMNList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< MDT-Location-Info >-----#
    MDT_Location_Info = BIT_STR(name='MDT-Location-Info', mode=MODE_TYPE)
    MDT_Location_Info._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< Measurement-ID >-----#
    Measurement_ID = INT(name='Measurement-ID', mode=MODE_TYPE)
    Measurement_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4095)], ev=[], er=[])
    
    #-----< Measurement-ID-ENDC >-----#
    Measurement_ID_ENDC = INT(name='Measurement-ID-ENDC', mode=MODE_TYPE)
    Measurement_ID_ENDC._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4095)], ev=[], er=[])
    
    #-----< MeasurementsToActivate >-----#
    MeasurementsToActivate = BIT_STR(name='MeasurementsToActivate', mode=MODE_TYPE)
    MeasurementsToActivate._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< MeasurementThresholdA2 >-----#
    MeasurementThresholdA2 = CHOICE(name='MeasurementThresholdA2', mode=MODE_TYPE)
    _MeasurementThresholdA2_threshold_RSRP = INT(name='threshold-RSRP', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'Threshold-RSRP')))
    _MeasurementThresholdA2_threshold_RSRQ = INT(name='threshold-RSRQ', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'Threshold-RSRQ')))
    MeasurementThresholdA2._cont = ASN1Dict([
        ('threshold-RSRP', _MeasurementThresholdA2_threshold_RSRP),
        ('threshold-RSRQ', _MeasurementThresholdA2_threshold_RSRQ),
        ])
    MeasurementThresholdA2._ext = []
    
    #-----< MeNBCoordinationAssistanceInformation >-----#
    MeNBCoordinationAssistanceInformation = ENUM(name='MeNBCoordinationAssistanceInformation', mode=MODE_TYPE)
    MeNBCoordinationAssistanceInformation._cont = ASN1Dict([('coordination-not-required', 0)])
    MeNBCoordinationAssistanceInformation._ext = []
    
    #-----< MeNBResourceCoordinationInformation >-----#
    MeNBResourceCoordinationInformation = SEQ(name='MeNBResourceCoordinationInformation', mode=MODE_TYPE)
    _MeNBResourceCoordinationInformation_eUTRA_Cell_ID = SEQ(name='eUTRA-Cell-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _MeNBResourceCoordinationInformation_uLCoordinationInformation = BIT_STR(name='uLCoordinationInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MeNBResourceCoordinationInformation_uLCoordinationInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=6, ub=4400)], ev=[], er=[])
    _MeNBResourceCoordinationInformation_dLCoordinationInformation = BIT_STR(name='dLCoordinationInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MeNBResourceCoordinationInformation_dLCoordinationInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=6, ub=4400)], ev=[], er=[])
    _MeNBResourceCoordinationInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MeNBResourceCoordinationInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___MeNBResourceCoordinationInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____MeNBResourceCoordinationInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____MeNBResourceCoordinationInformation_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'NRCGI')))
    _____MeNBResourceCoordinationInformation_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MeNBCoordinationAssistanceInformation')))
    ____MeNBResourceCoordinationInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 322), ('criticality', 'ignore'), ('Extension', _____MeNBResourceCoordinationInformation_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 323), ('criticality', 'reject'), ('Extension', _____MeNBResourceCoordinationInformation_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MeNBResourceCoordinationInformation_iE_Extensions__item__id._const_tab = ____MeNBResourceCoordinationInformation_iE_Extensions__item__id_tab
    ___MeNBResourceCoordinationInformation_iE_Extensions__item__id._const_tab_at = None
    ___MeNBResourceCoordinationInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___MeNBResourceCoordinationInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___MeNBResourceCoordinationInformation_iE_Extensions__item__criticality._const_tab = ____MeNBResourceCoordinationInformation_iE_Extensions__item__id_tab
    ___MeNBResourceCoordinationInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MeNBResourceCoordinationInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MeNBResourceCoordinationInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___MeNBResourceCoordinationInformation_iE_Extensions__item__extensionValue._const_tab = ____MeNBResourceCoordinationInformation_iE_Extensions__item__id_tab
    ___MeNBResourceCoordinationInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MeNBResourceCoordinationInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MeNBResourceCoordinationInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MeNBResourceCoordinationInformation_iE_Extensions__item__id),
        ('criticality', ___MeNBResourceCoordinationInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___MeNBResourceCoordinationInformation_iE_Extensions__item__extensionValue),
        ])
    __MeNBResourceCoordinationInformation_iE_Extensions__item_._ext = None
    _MeNBResourceCoordinationInformation_iE_Extensions._cont = __MeNBResourceCoordinationInformation_iE_Extensions__item_
    _MeNBResourceCoordinationInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MeNBResourceCoordinationInformation._cont = ASN1Dict([
        ('eUTRA-Cell-ID', _MeNBResourceCoordinationInformation_eUTRA_Cell_ID),
        ('uLCoordinationInformation', _MeNBResourceCoordinationInformation_uLCoordinationInformation),
        ('dLCoordinationInformation', _MeNBResourceCoordinationInformation_dLCoordinationInformation),
        ('iE-Extensions', _MeNBResourceCoordinationInformation_iE_Extensions),
        ])
    MeNBResourceCoordinationInformation._ext = []
    
    #-----< MeNBResourceCoordinationInformationExtIEs >-----#
    MeNBResourceCoordinationInformationExtIEs = CLASS(name='MeNBResourceCoordinationInformationExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _MeNBResourceCoordinationInformationExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'NRCGI')))
    _MeNBResourceCoordinationInformationExtIEs_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MeNBCoordinationAssistanceInformation')))
    MeNBResourceCoordinationInformationExtIEs._val = ASN1Set(rv=[dict([('id', 322), ('criticality', 'ignore'), ('Extension', _MeNBResourceCoordinationInformationExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 323), ('criticality', 'reject'), ('Extension', _MeNBResourceCoordinationInformationExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MeNBtoSeNBContainer >-----#
    MeNBtoSeNBContainer = OCT_STR(name='MeNBtoSeNBContainer', mode=MODE_TYPE)
    
    #-----< MME-Group-ID >-----#
    MME_Group_ID = OCT_STR(name='MME-Group-ID', mode=MODE_TYPE)
    MME_Group_ID._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< MME-Code >-----#
    MME_Code = OCT_STR(name='MME-Code', mode=MODE_TYPE)
    MME_Code._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< MBMS-Service-Area-Identity-List >-----#
    MBMS_Service_Area_Identity_List = SEQ_OF(name='MBMS-Service-Area-Identity-List', mode=MODE_TYPE)
    _MBMS_Service_Area_Identity_List__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MBMS-Service-Area-Identity')))
    MBMS_Service_Area_Identity_List._cont = _MBMS_Service_Area_Identity_List__item_
    MBMS_Service_Area_Identity_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< MBMS-Service-Area-Identity >-----#
    MBMS_Service_Area_Identity = OCT_STR(name='MBMS-Service-Area-Identity', mode=MODE_TYPE)
    MBMS_Service_Area_Identity._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< MBSFN-Subframe-Infolist >-----#
    MBSFN_Subframe_Infolist = SEQ_OF(name='MBSFN-Subframe-Infolist', mode=MODE_TYPE)
    _MBSFN_Subframe_Infolist__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MBSFN-Subframe-Info')))
    MBSFN_Subframe_Infolist._cont = _MBSFN_Subframe_Infolist__item_
    MBSFN_Subframe_Infolist._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< MBSFN-Subframe-Info >-----#
    MBSFN_Subframe_Info = SEQ(name='MBSFN-Subframe-Info', mode=MODE_TYPE)
    _MBSFN_Subframe_Info_radioframeAllocationPeriod = ENUM(name='radioframeAllocationPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'RadioframeAllocationPeriod')))
    _MBSFN_Subframe_Info_radioframeAllocationOffset = INT(name='radioframeAllocationOffset', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'RadioframeAllocationOffset')))
    _MBSFN_Subframe_Info_subframeAllocation = CHOICE(name='subframeAllocation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'SubframeAllocation')))
    _MBSFN_Subframe_Info_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBSFN_Subframe_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___MBSFN_Subframe_Info_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____MBSFN_Subframe_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____MBSFN_Subframe_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSFN_Subframe_Info_iE_Extensions__item__id._const_tab = ____MBSFN_Subframe_Info_iE_Extensions__item__id_tab
    ___MBSFN_Subframe_Info_iE_Extensions__item__id._const_tab_at = None
    ___MBSFN_Subframe_Info_iE_Extensions__item__id._const_tab_id = 'id'
    ___MBSFN_Subframe_Info_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MBSFN_Subframe_Info_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____MBSFN_Subframe_Info_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSFN_Subframe_Info_iE_Extensions__item__criticality._const_tab = ____MBSFN_Subframe_Info_iE_Extensions__item__criticality_tab
    ___MBSFN_Subframe_Info_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MBSFN_Subframe_Info_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MBSFN_Subframe_Info_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MBSFN_Subframe_Info_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____MBSFN_Subframe_Info_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSFN_Subframe_Info_iE_Extensions__item__extensionValue._const_tab = ____MBSFN_Subframe_Info_iE_Extensions__item__extensionValue_tab
    ___MBSFN_Subframe_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MBSFN_Subframe_Info_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MBSFN_Subframe_Info_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MBSFN_Subframe_Info_iE_Extensions__item__id),
        ('criticality', ___MBSFN_Subframe_Info_iE_Extensions__item__criticality),
        ('extensionValue', ___MBSFN_Subframe_Info_iE_Extensions__item__extensionValue),
        ])
    __MBSFN_Subframe_Info_iE_Extensions__item_._ext = None
    _MBSFN_Subframe_Info_iE_Extensions._cont = __MBSFN_Subframe_Info_iE_Extensions__item_
    _MBSFN_Subframe_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBSFN_Subframe_Info._cont = ASN1Dict([
        ('radioframeAllocationPeriod', _MBSFN_Subframe_Info_radioframeAllocationPeriod),
        ('radioframeAllocationOffset', _MBSFN_Subframe_Info_radioframeAllocationOffset),
        ('subframeAllocation', _MBSFN_Subframe_Info_subframeAllocation),
        ('iE-Extensions', _MBSFN_Subframe_Info_iE_Extensions),
        ])
    MBSFN_Subframe_Info._ext = []
    
    #-----< MBSFN-Subframe-Info-ExtIEs >-----#
    MBSFN_Subframe_Info_ExtIEs = CLASS(name='MBSFN-Subframe-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    MBSFN_Subframe_Info_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MDT-ConfigurationNR >-----#
    MDT_ConfigurationNR = OCT_STR(name='MDT-ConfigurationNR', mode=MODE_TYPE)
    
    #-----< MobilityParametersModificationRange >-----#
    MobilityParametersModificationRange = SEQ(name='MobilityParametersModificationRange', mode=MODE_TYPE)
    _MobilityParametersModificationRange_handoverTriggerChangeLowerLimit = INT(name='handoverTriggerChangeLowerLimit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MobilityParametersModificationRange_handoverTriggerChangeLowerLimit._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-20, ub=20)], ev=None, er=[])
    _MobilityParametersModificationRange_handoverTriggerChangeUpperLimit = INT(name='handoverTriggerChangeUpperLimit', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MobilityParametersModificationRange_handoverTriggerChangeUpperLimit._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-20, ub=20)], ev=None, er=[])
    MobilityParametersModificationRange._cont = ASN1Dict([
        ('handoverTriggerChangeLowerLimit', _MobilityParametersModificationRange_handoverTriggerChangeLowerLimit),
        ('handoverTriggerChangeUpperLimit', _MobilityParametersModificationRange_handoverTriggerChangeUpperLimit),
        ])
    MobilityParametersModificationRange._ext = []
    
    #-----< MobilityParametersInformation >-----#
    MobilityParametersInformation = SEQ(name='MobilityParametersInformation', mode=MODE_TYPE)
    _MobilityParametersInformation_handoverTriggerChange = INT(name='handoverTriggerChange', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MobilityParametersInformation_handoverTriggerChange._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-20, ub=20)], ev=None, er=[])
    MobilityParametersInformation._cont = ASN1Dict([
        ('handoverTriggerChange', _MobilityParametersInformation_handoverTriggerChange),
        ])
    MobilityParametersInformation._ext = []
    
    #-----< MultibandInfoList >-----#
    MultibandInfoList = SEQ_OF(name='MultibandInfoList', mode=MODE_TYPE)
    _MultibandInfoList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'BandInfo')))
    MultibandInfoList._cont = _MultibandInfoList__item_
    MultibandInfoList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< MessageOversizeNotification >-----#
    MessageOversizeNotification = SEQ(name='MessageOversizeNotification', mode=MODE_TYPE)
    _MessageOversizeNotification_maximumCellListSize = INT(name='maximumCellListSize', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'MaximumCellListSize')))
    _MessageOversizeNotification_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MessageOversizeNotification_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___MessageOversizeNotification_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____MessageOversizeNotification_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____MessageOversizeNotification_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MessageOversizeNotification_iE_Extensions__item__id._const_tab = ____MessageOversizeNotification_iE_Extensions__item__id_tab
    ___MessageOversizeNotification_iE_Extensions__item__id._const_tab_at = None
    ___MessageOversizeNotification_iE_Extensions__item__id._const_tab_id = 'id'
    ___MessageOversizeNotification_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MessageOversizeNotification_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____MessageOversizeNotification_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MessageOversizeNotification_iE_Extensions__item__criticality._const_tab = ____MessageOversizeNotification_iE_Extensions__item__criticality_tab
    ___MessageOversizeNotification_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MessageOversizeNotification_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MessageOversizeNotification_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MessageOversizeNotification_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____MessageOversizeNotification_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MessageOversizeNotification_iE_Extensions__item__extensionValue._const_tab = ____MessageOversizeNotification_iE_Extensions__item__extensionValue_tab
    ___MessageOversizeNotification_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MessageOversizeNotification_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MessageOversizeNotification_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MessageOversizeNotification_iE_Extensions__item__id),
        ('criticality', ___MessageOversizeNotification_iE_Extensions__item__criticality),
        ('extensionValue', ___MessageOversizeNotification_iE_Extensions__item__extensionValue),
        ])
    __MessageOversizeNotification_iE_Extensions__item_._ext = None
    _MessageOversizeNotification_iE_Extensions._cont = __MessageOversizeNotification_iE_Extensions__item_
    _MessageOversizeNotification_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MessageOversizeNotification._cont = ASN1Dict([
        ('maximumCellListSize', _MessageOversizeNotification_maximumCellListSize),
        ('iE-Extensions', _MessageOversizeNotification_iE_Extensions),
        ])
    MessageOversizeNotification._ext = []
    
    #-----< MessageOversizeNotification-ExtIEs >-----#
    MessageOversizeNotification_ExtIEs = CLASS(name='MessageOversizeNotification-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    MessageOversizeNotification_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MaximumCellListSize >-----#
    MaximumCellListSize = INT(name='MaximumCellListSize', mode=MODE_TYPE)
    MaximumCellListSize._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16384)], ev=[], er=[])
    
    #-----< BandInfo >-----#
    BandInfo = SEQ(name='BandInfo', mode=MODE_TYPE)
    _BandInfo_freqBandIndicator = INT(name='freqBandIndicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'FreqBandIndicator')))
    _BandInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BandInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___BandInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____BandInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____BandInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BandInfo_iE_Extensions__item__id._const_tab = ____BandInfo_iE_Extensions__item__id_tab
    ___BandInfo_iE_Extensions__item__id._const_tab_at = None
    ___BandInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___BandInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____BandInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____BandInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BandInfo_iE_Extensions__item__criticality._const_tab = ____BandInfo_iE_Extensions__item__criticality_tab
    ___BandInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___BandInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___BandInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____BandInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____BandInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BandInfo_iE_Extensions__item__extensionValue._const_tab = ____BandInfo_iE_Extensions__item__extensionValue_tab
    ___BandInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___BandInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __BandInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___BandInfo_iE_Extensions__item__id),
        ('criticality', ___BandInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___BandInfo_iE_Extensions__item__extensionValue),
        ])
    __BandInfo_iE_Extensions__item_._ext = None
    _BandInfo_iE_Extensions._cont = __BandInfo_iE_Extensions__item_
    _BandInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BandInfo._cont = ASN1Dict([
        ('freqBandIndicator', _BandInfo_freqBandIndicator),
        ('iE-Extensions', _BandInfo_iE_Extensions),
        ])
    BandInfo._ext = []
    
    #-----< BandInfo-ExtIEs >-----#
    BandInfo_ExtIEs = CLASS(name='BandInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    BandInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MeNBtoSgNBContainer >-----#
    MeNBtoSgNBContainer = OCT_STR(name='MeNBtoSgNBContainer', mode=MODE_TYPE)
    
    #-----< SplitSRBs >-----#
    SplitSRBs = ENUM(name='SplitSRBs', mode=MODE_TYPE)
    SplitSRBs._cont = ASN1Dict([('srb1', 0), ('srb2', 1), ('srb1and2', 2)])
    SplitSRBs._ext = []
    
    #-----< SplitSRB >-----#
    SplitSRB = SEQ(name='SplitSRB', mode=MODE_TYPE)
    _SplitSRB_rrcContainer = OCT_STR(name='rrcContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'RRCContainer')), opt=True)
    _SplitSRB_srbType = ENUM(name='srbType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'SRBType')))
    _SplitSRB_deliveryStatus = SEQ(name='deliveryStatus', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'DeliveryStatus')), opt=True)
    _SplitSRB_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SplitSRB_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___SplitSRB_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____SplitSRB_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____SplitSRB_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SplitSRB_iE_Extensions__item__id._const_tab = ____SplitSRB_iE_Extensions__item__id_tab
    ___SplitSRB_iE_Extensions__item__id._const_tab_at = None
    ___SplitSRB_iE_Extensions__item__id._const_tab_id = 'id'
    ___SplitSRB_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SplitSRB_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____SplitSRB_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SplitSRB_iE_Extensions__item__criticality._const_tab = ____SplitSRB_iE_Extensions__item__criticality_tab
    ___SplitSRB_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SplitSRB_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SplitSRB_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SplitSRB_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____SplitSRB_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SplitSRB_iE_Extensions__item__extensionValue._const_tab = ____SplitSRB_iE_Extensions__item__extensionValue_tab
    ___SplitSRB_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SplitSRB_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SplitSRB_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SplitSRB_iE_Extensions__item__id),
        ('criticality', ___SplitSRB_iE_Extensions__item__criticality),
        ('extensionValue', ___SplitSRB_iE_Extensions__item__extensionValue),
        ])
    __SplitSRB_iE_Extensions__item_._ext = None
    _SplitSRB_iE_Extensions._cont = __SplitSRB_iE_Extensions__item_
    _SplitSRB_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SplitSRB._cont = ASN1Dict([
        ('rrcContainer', _SplitSRB_rrcContainer),
        ('srbType', _SplitSRB_srbType),
        ('deliveryStatus', _SplitSRB_deliveryStatus),
        ('iE-Extensions', _SplitSRB_iE_Extensions),
        ])
    SplitSRB._ext = []
    
    #-----< SplitSRB-ExtIEs >-----#
    SplitSRB_ExtIEs = CLASS(name='SplitSRB-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    SplitSRB_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NBIoT-UL-DL-AlignmentOffset >-----#
    NBIoT_UL_DL_AlignmentOffset = ENUM(name='NBIoT-UL-DL-AlignmentOffset', mode=MODE_TYPE)
    NBIoT_UL_DL_AlignmentOffset._cont = ASN1Dict([('khz-7dot5', 0), ('khz0', 1), ('khz7dot5', 2)])
    NBIoT_UL_DL_AlignmentOffset._ext = []
    
    #-----< NBIoT-RLF-Report-Container >-----#
    NBIoT_RLF_Report_Container = OCT_STR(name='NBIoT-RLF-Report-Container', mode=MODE_TYPE)
    
    #-----< Neighbour-Information >-----#
    Neighbour_Information = SEQ_OF(name='Neighbour-Information', mode=MODE_TYPE)
    _Neighbour_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __Neighbour_Information__item__eCGI = SEQ(name='eCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    __Neighbour_Information__item__pCI = INT(name='pCI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'PCI')))
    __Neighbour_Information__item__eARFCN = INT(name='eARFCN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'EARFCN')))
    __Neighbour_Information__item__iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___Neighbour_Information__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ____Neighbour_Information__item__iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    _____Neighbour_Information__item__iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ______Neighbour_Information__item__iE_Extensions__item__id_tab_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TAC')))
    ______Neighbour_Information__item__iE_Extensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'EARFCNExtension')))
    _____Neighbour_Information__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 76), ('criticality', 'ignore'), ('Extension', ______Neighbour_Information__item__iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 94), ('criticality', 'reject'), ('Extension', ______Neighbour_Information__item__iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ____Neighbour_Information__item__iE_Extensions__item__id._const_tab = _____Neighbour_Information__item__iE_Extensions__item__id_tab
    ____Neighbour_Information__item__iE_Extensions__item__id._const_tab_at = None
    ____Neighbour_Information__item__iE_Extensions__item__id._const_tab_id = 'id'
    ____Neighbour_Information__item__iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Neighbour_Information__item__iE_Extensions__item__criticality._const_tab = _____Neighbour_Information__item__iE_Extensions__item__id_tab
    ____Neighbour_Information__item__iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____Neighbour_Information__item__iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____Neighbour_Information__item__iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Neighbour_Information__item__iE_Extensions__item__extensionValue._const_tab = _____Neighbour_Information__item__iE_Extensions__item__id_tab
    ____Neighbour_Information__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____Neighbour_Information__item__iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___Neighbour_Information__item__iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____Neighbour_Information__item__iE_Extensions__item__id),
        ('criticality', ____Neighbour_Information__item__iE_Extensions__item__criticality),
        ('extensionValue', ____Neighbour_Information__item__iE_Extensions__item__extensionValue),
        ])
    ___Neighbour_Information__item__iE_Extensions__item_._ext = None
    __Neighbour_Information__item__iE_Extensions._cont = ___Neighbour_Information__item__iE_Extensions__item_
    __Neighbour_Information__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _Neighbour_Information__item_._cont = ASN1Dict([
        ('eCGI', __Neighbour_Information__item__eCGI),
        ('pCI', __Neighbour_Information__item__pCI),
        ('eARFCN', __Neighbour_Information__item__eARFCN),
        ('iE-Extensions', __Neighbour_Information__item__iE_Extensions),
        ])
    _Neighbour_Information__item_._ext = []
    Neighbour_Information._cont = _Neighbour_Information__item_
    Neighbour_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=512)], ev=None, er=[])
    
    #-----< Neighbour-Information-ExtIEs >-----#
    Neighbour_Information_ExtIEs = CLASS(name='Neighbour-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _Neighbour_Information_ExtIEs_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TAC')))
    _Neighbour_Information_ExtIEs_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'EARFCNExtension')))
    Neighbour_Information_ExtIEs._val = ASN1Set(rv=[dict([('id', 76), ('criticality', 'ignore'), ('Extension', _Neighbour_Information_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 94), ('criticality', 'reject'), ('Extension', _Neighbour_Information_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< NextHopChainingCount >-----#
    NextHopChainingCount = INT(name='NextHopChainingCount', mode=MODE_TYPE)
    NextHopChainingCount._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    
    #-----< NewDRBIDrequest >-----#
    NewDRBIDrequest = ENUM(name='NewDRBIDrequest', mode=MODE_TYPE)
    NewDRBIDrequest._cont = ASN1Dict([('true', 0)])
    NewDRBIDrequest._ext = []
    
    #-----< Number-of-Antennaports >-----#
    Number_of_Antennaports = ENUM(name='Number-of-Antennaports', mode=MODE_TYPE)
    Number_of_Antennaports._cont = ASN1Dict([('an1', 0), ('an2', 1), ('an4', 2)])
    Number_of_Antennaports._ext = []
    
    #-----< NRCapacityValue >-----#
    NRCapacityValue = SEQ(name='NRCapacityValue', mode=MODE_TYPE)
    _NRCapacityValue_capacityValue = INT(name='capacityValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NRCapacityValue_capacityValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _NRCapacityValue_ssbAreaCapacityValue_List = SEQ_OF(name='ssbAreaCapacityValue-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'SSBAreaCapacityValue-List')), opt=True)
    _NRCapacityValue_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NRCapacityValue_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___NRCapacityValue_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____NRCapacityValue_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____NRCapacityValue_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRCapacityValue_iE_Extensions__item__id._const_tab = ____NRCapacityValue_iE_Extensions__item__id_tab
    ___NRCapacityValue_iE_Extensions__item__id._const_tab_at = None
    ___NRCapacityValue_iE_Extensions__item__id._const_tab_id = 'id'
    ___NRCapacityValue_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NRCapacityValue_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____NRCapacityValue_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRCapacityValue_iE_Extensions__item__criticality._const_tab = ____NRCapacityValue_iE_Extensions__item__criticality_tab
    ___NRCapacityValue_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NRCapacityValue_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NRCapacityValue_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NRCapacityValue_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____NRCapacityValue_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRCapacityValue_iE_Extensions__item__extensionValue._const_tab = ____NRCapacityValue_iE_Extensions__item__extensionValue_tab
    ___NRCapacityValue_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NRCapacityValue_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NRCapacityValue_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NRCapacityValue_iE_Extensions__item__id),
        ('criticality', ___NRCapacityValue_iE_Extensions__item__criticality),
        ('extensionValue', ___NRCapacityValue_iE_Extensions__item__extensionValue),
        ])
    __NRCapacityValue_iE_Extensions__item_._ext = None
    _NRCapacityValue_iE_Extensions._cont = __NRCapacityValue_iE_Extensions__item_
    _NRCapacityValue_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NRCapacityValue._cont = ASN1Dict([
        ('capacityValue', _NRCapacityValue_capacityValue),
        ('ssbAreaCapacityValue-List', _NRCapacityValue_ssbAreaCapacityValue_List),
        ('iE-Extensions', _NRCapacityValue_iE_Extensions),
        ])
    NRCapacityValue._ext = []
    
    #-----< NRCapacityValue-ExtIEs >-----#
    NRCapacityValue_ExtIEs = CLASS(name='NRCapacityValue-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    NRCapacityValue_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NRCarrierList >-----#
    NRCarrierList = SEQ_OF(name='NRCarrierList', mode=MODE_TYPE)
    _NRCarrierList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'NRCarrierItem')))
    NRCarrierList._cont = _NRCarrierList__item_
    NRCarrierList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< NRCarrierItem >-----#
    NRCarrierItem = SEQ(name='NRCarrierItem', mode=MODE_TYPE)
    _NRCarrierItem_carrierSCS = ENUM(name='carrierSCS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'NRSCS')))
    _NRCarrierItem_offsetToCarrier = INT(name='offsetToCarrier', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NRCarrierItem_offsetToCarrier._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2199)], ev=[], er=[])
    _NRCarrierItem_carrierBandwidth = INT(name='carrierBandwidth', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NRCarrierItem_carrierBandwidth._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=275)], ev=[], er=[])
    _NRCarrierItem_iE_Extension = SEQ_OF(name='iE-Extension', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NRCarrierItem_iE_Extension__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___NRCarrierItem_iE_Extension__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____NRCarrierItem_iE_Extension__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____NRCarrierItem_iE_Extension__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRCarrierItem_iE_Extension__item__id._const_tab = ____NRCarrierItem_iE_Extension__item__id_tab
    ___NRCarrierItem_iE_Extension__item__id._const_tab_at = None
    ___NRCarrierItem_iE_Extension__item__id._const_tab_id = 'id'
    ___NRCarrierItem_iE_Extension__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NRCarrierItem_iE_Extension__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____NRCarrierItem_iE_Extension__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRCarrierItem_iE_Extension__item__criticality._const_tab = ____NRCarrierItem_iE_Extension__item__criticality_tab
    ___NRCarrierItem_iE_Extension__item__criticality._const_tab_at = ('..', 'id')
    ___NRCarrierItem_iE_Extension__item__criticality._const_tab_id = 'criticality'
    ___NRCarrierItem_iE_Extension__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NRCarrierItem_iE_Extension__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____NRCarrierItem_iE_Extension__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRCarrierItem_iE_Extension__item__extensionValue._const_tab = ____NRCarrierItem_iE_Extension__item__extensionValue_tab
    ___NRCarrierItem_iE_Extension__item__extensionValue._const_tab_at = ('..', 'id')
    ___NRCarrierItem_iE_Extension__item__extensionValue._const_tab_id = 'Extension'
    __NRCarrierItem_iE_Extension__item_._cont = ASN1Dict([
        ('id', ___NRCarrierItem_iE_Extension__item__id),
        ('criticality', ___NRCarrierItem_iE_Extension__item__criticality),
        ('extensionValue', ___NRCarrierItem_iE_Extension__item__extensionValue),
        ])
    __NRCarrierItem_iE_Extension__item_._ext = None
    _NRCarrierItem_iE_Extension._cont = __NRCarrierItem_iE_Extension__item_
    _NRCarrierItem_iE_Extension._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NRCarrierItem._cont = ASN1Dict([
        ('carrierSCS', _NRCarrierItem_carrierSCS),
        ('offsetToCarrier', _NRCarrierItem_offsetToCarrier),
        ('carrierBandwidth', _NRCarrierItem_carrierBandwidth),
        ('iE-Extension', _NRCarrierItem_iE_Extension),
        ])
    NRCarrierItem._ext = []
    
    #-----< NRCarrierItem-ExtIEs >-----#
    NRCarrierItem_ExtIEs = CLASS(name='NRCarrierItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    NRCarrierItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NRCellCapacityClassValue >-----#
    NRCellCapacityClassValue = INT(name='NRCellCapacityClassValue', mode=MODE_TYPE)
    NRCellCapacityClassValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=[], er=[])
    
    #-----< NRCellPRACHConfig >-----#
    NRCellPRACHConfig = OCT_STR(name='NRCellPRACHConfig', mode=MODE_TYPE)
    
    #-----< NRCompositeAvailableCapacityGroup >-----#
    NRCompositeAvailableCapacityGroup = SEQ(name='NRCompositeAvailableCapacityGroup', mode=MODE_TYPE)
    _NRCompositeAvailableCapacityGroup_compositeAvailableCapacityDL = SEQ(name='compositeAvailableCapacityDL', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'NRCompositeAvailableCapacity')))
    _NRCompositeAvailableCapacityGroup_compositeAvailableCapacityUL = SEQ(name='compositeAvailableCapacityUL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'NRCompositeAvailableCapacity')))
    _NRCompositeAvailableCapacityGroup_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NRCompositeAvailableCapacityGroup_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___NRCompositeAvailableCapacityGroup_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____NRCompositeAvailableCapacityGroup_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____NRCompositeAvailableCapacityGroup_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRCompositeAvailableCapacityGroup_iE_Extensions__item__id._const_tab = ____NRCompositeAvailableCapacityGroup_iE_Extensions__item__id_tab
    ___NRCompositeAvailableCapacityGroup_iE_Extensions__item__id._const_tab_at = None
    ___NRCompositeAvailableCapacityGroup_iE_Extensions__item__id._const_tab_id = 'id'
    ___NRCompositeAvailableCapacityGroup_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NRCompositeAvailableCapacityGroup_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____NRCompositeAvailableCapacityGroup_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRCompositeAvailableCapacityGroup_iE_Extensions__item__criticality._const_tab = ____NRCompositeAvailableCapacityGroup_iE_Extensions__item__criticality_tab
    ___NRCompositeAvailableCapacityGroup_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NRCompositeAvailableCapacityGroup_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NRCompositeAvailableCapacityGroup_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NRCompositeAvailableCapacityGroup_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____NRCompositeAvailableCapacityGroup_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRCompositeAvailableCapacityGroup_iE_Extensions__item__extensionValue._const_tab = ____NRCompositeAvailableCapacityGroup_iE_Extensions__item__extensionValue_tab
    ___NRCompositeAvailableCapacityGroup_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NRCompositeAvailableCapacityGroup_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NRCompositeAvailableCapacityGroup_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NRCompositeAvailableCapacityGroup_iE_Extensions__item__id),
        ('criticality', ___NRCompositeAvailableCapacityGroup_iE_Extensions__item__criticality),
        ('extensionValue', ___NRCompositeAvailableCapacityGroup_iE_Extensions__item__extensionValue),
        ])
    __NRCompositeAvailableCapacityGroup_iE_Extensions__item_._ext = None
    _NRCompositeAvailableCapacityGroup_iE_Extensions._cont = __NRCompositeAvailableCapacityGroup_iE_Extensions__item_
    _NRCompositeAvailableCapacityGroup_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NRCompositeAvailableCapacityGroup._cont = ASN1Dict([
        ('compositeAvailableCapacityDL', _NRCompositeAvailableCapacityGroup_compositeAvailableCapacityDL),
        ('compositeAvailableCapacityUL', _NRCompositeAvailableCapacityGroup_compositeAvailableCapacityUL),
        ('iE-Extensions', _NRCompositeAvailableCapacityGroup_iE_Extensions),
        ])
    NRCompositeAvailableCapacityGroup._ext = []
    
    #-----< NRCompositeAvailableCapacityGroup-ExtIEs >-----#
    NRCompositeAvailableCapacityGroup_ExtIEs = CLASS(name='NRCompositeAvailableCapacityGroup-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    NRCompositeAvailableCapacityGroup_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NRCompositeAvailableCapacity >-----#
    NRCompositeAvailableCapacity = SEQ(name='NRCompositeAvailableCapacity', mode=MODE_TYPE)
    _NRCompositeAvailableCapacity_cellCapacityClassValue = INT(name='cellCapacityClassValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'NRCellCapacityClassValue')), opt=True)
    _NRCompositeAvailableCapacity_capacityValue = SEQ(name='capacityValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'NRCapacityValue')))
    _NRCompositeAvailableCapacity_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NRCompositeAvailableCapacity_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___NRCompositeAvailableCapacity_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____NRCompositeAvailableCapacity_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____NRCompositeAvailableCapacity_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRCompositeAvailableCapacity_iE_Extensions__item__id._const_tab = ____NRCompositeAvailableCapacity_iE_Extensions__item__id_tab
    ___NRCompositeAvailableCapacity_iE_Extensions__item__id._const_tab_at = None
    ___NRCompositeAvailableCapacity_iE_Extensions__item__id._const_tab_id = 'id'
    ___NRCompositeAvailableCapacity_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NRCompositeAvailableCapacity_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____NRCompositeAvailableCapacity_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRCompositeAvailableCapacity_iE_Extensions__item__criticality._const_tab = ____NRCompositeAvailableCapacity_iE_Extensions__item__criticality_tab
    ___NRCompositeAvailableCapacity_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NRCompositeAvailableCapacity_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NRCompositeAvailableCapacity_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NRCompositeAvailableCapacity_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____NRCompositeAvailableCapacity_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRCompositeAvailableCapacity_iE_Extensions__item__extensionValue._const_tab = ____NRCompositeAvailableCapacity_iE_Extensions__item__extensionValue_tab
    ___NRCompositeAvailableCapacity_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NRCompositeAvailableCapacity_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NRCompositeAvailableCapacity_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NRCompositeAvailableCapacity_iE_Extensions__item__id),
        ('criticality', ___NRCompositeAvailableCapacity_iE_Extensions__item__criticality),
        ('extensionValue', ___NRCompositeAvailableCapacity_iE_Extensions__item__extensionValue),
        ])
    __NRCompositeAvailableCapacity_iE_Extensions__item_._ext = None
    _NRCompositeAvailableCapacity_iE_Extensions._cont = __NRCompositeAvailableCapacity_iE_Extensions__item_
    _NRCompositeAvailableCapacity_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NRCompositeAvailableCapacity._cont = ASN1Dict([
        ('cellCapacityClassValue', _NRCompositeAvailableCapacity_cellCapacityClassValue),
        ('capacityValue', _NRCompositeAvailableCapacity_capacityValue),
        ('iE-Extensions', _NRCompositeAvailableCapacity_iE_Extensions),
        ])
    NRCompositeAvailableCapacity._ext = []
    
    #-----< NRCompositeAvailableCapacity-ExtIEs >-----#
    NRCompositeAvailableCapacity_ExtIEs = CLASS(name='NRCompositeAvailableCapacity-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    NRCompositeAvailableCapacity_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NRFreqInfo >-----#
    NRFreqInfo = SEQ(name='NRFreqInfo', mode=MODE_TYPE)
    _NRFreqInfo_nRARFCN = INT(name='nRARFCN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NRFreqInfo_nRARFCN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3279165)], ev=None, er=[])
    _NRFreqInfo_freqBandListNr = SEQ_OF(name='freqBandListNr', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __NRFreqInfo_freqBandListNr__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'FreqBandNrItem')))
    _NRFreqInfo_freqBandListNr._cont = __NRFreqInfo_freqBandListNr__item_
    _NRFreqInfo_freqBandListNr._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    _NRFreqInfo_sULInformation = SEQ(name='sULInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'SULInformation')), opt=True)
    _NRFreqInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NRFreqInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___NRFreqInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____NRFreqInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____NRFreqInfo_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'FrequencyShift7p5khz')))
    ____NRFreqInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 388), ('criticality', 'ignore'), ('Extension', _____NRFreqInfo_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___NRFreqInfo_iE_Extensions__item__id._const_tab = ____NRFreqInfo_iE_Extensions__item__id_tab
    ___NRFreqInfo_iE_Extensions__item__id._const_tab_at = None
    ___NRFreqInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___NRFreqInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___NRFreqInfo_iE_Extensions__item__criticality._const_tab = ____NRFreqInfo_iE_Extensions__item__id_tab
    ___NRFreqInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NRFreqInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NRFreqInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___NRFreqInfo_iE_Extensions__item__extensionValue._const_tab = ____NRFreqInfo_iE_Extensions__item__id_tab
    ___NRFreqInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NRFreqInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NRFreqInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NRFreqInfo_iE_Extensions__item__id),
        ('criticality', ___NRFreqInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___NRFreqInfo_iE_Extensions__item__extensionValue),
        ])
    __NRFreqInfo_iE_Extensions__item_._ext = None
    _NRFreqInfo_iE_Extensions._cont = __NRFreqInfo_iE_Extensions__item_
    _NRFreqInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NRFreqInfo._cont = ASN1Dict([
        ('nRARFCN', _NRFreqInfo_nRARFCN),
        ('freqBandListNr', _NRFreqInfo_freqBandListNr),
        ('sULInformation', _NRFreqInfo_sULInformation),
        ('iE-Extensions', _NRFreqInfo_iE_Extensions),
        ])
    NRFreqInfo._ext = []
    
    #-----< NRFreqInfo-ExtIEs >-----#
    NRFreqInfo_ExtIEs = CLASS(name='NRFreqInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _NRFreqInfo_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'FrequencyShift7p5khz')))
    NRFreqInfo_ExtIEs._val = ASN1Set(rv=[dict([('id', 388), ('criticality', 'ignore'), ('Extension', _NRFreqInfo_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< NRCellIdentifier >-----#
    NRCellIdentifier = BIT_STR(name='NRCellIdentifier', mode=MODE_TYPE)
    NRCellIdentifier._const_sz = ASN1Set(rv=[36], rr=[], ev=None, er=[])
    
    #-----< NRCGI >-----#
    NRCGI = SEQ(name='NRCGI', mode=MODE_TYPE)
    _NRCGI_pLMN_Identity = OCT_STR(name='pLMN-Identity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'PLMN-Identity')))
    _NRCGI_nRcellIdentifier = BIT_STR(name='nRcellIdentifier', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'NRCellIdentifier')))
    _NRCGI_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NRCGI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___NRCGI_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____NRCGI_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____NRCGI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRCGI_iE_Extensions__item__id._const_tab = ____NRCGI_iE_Extensions__item__id_tab
    ___NRCGI_iE_Extensions__item__id._const_tab_at = None
    ___NRCGI_iE_Extensions__item__id._const_tab_id = 'id'
    ___NRCGI_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NRCGI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____NRCGI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRCGI_iE_Extensions__item__criticality._const_tab = ____NRCGI_iE_Extensions__item__criticality_tab
    ___NRCGI_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NRCGI_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NRCGI_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NRCGI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____NRCGI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRCGI_iE_Extensions__item__extensionValue._const_tab = ____NRCGI_iE_Extensions__item__extensionValue_tab
    ___NRCGI_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NRCGI_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NRCGI_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NRCGI_iE_Extensions__item__id),
        ('criticality', ___NRCGI_iE_Extensions__item__criticality),
        ('extensionValue', ___NRCGI_iE_Extensions__item__extensionValue),
        ])
    __NRCGI_iE_Extensions__item_._ext = None
    _NRCGI_iE_Extensions._cont = __NRCGI_iE_Extensions__item_
    _NRCGI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NRCGI._cont = ASN1Dict([
        ('pLMN-Identity', _NRCGI_pLMN_Identity),
        ('nRcellIdentifier', _NRCGI_nRcellIdentifier),
        ('iE-Extensions', _NRCGI_iE_Extensions),
        ])
    NRCGI._ext = []
    
    #-----< NRCGI-ExtIEs >-----#
    NRCGI_ExtIEs = CLASS(name='NRCGI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    NRCGI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NRRACHReportContainer >-----#
    NRRACHReportContainer = OCT_STR(name='NRRACHReportContainer', mode=MODE_TYPE)
    
    #-----< NRRACHReportInformation >-----#
    NRRACHReportInformation = SEQ_OF(name='NRRACHReportInformation', mode=MODE_TYPE)
    _NRRACHReportInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'NRRACHReportList-Item')))
    NRRACHReportInformation._cont = _NRRACHReportInformation__item_
    NRRACHReportInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< NRRACHReportList-Item >-----#
    NRRACHReportList_Item = SEQ(name='NRRACHReportList-Item', mode=MODE_TYPE)
    _NRRACHReportList_Item_nRRACHReport = OCT_STR(name='nRRACHReport', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'NRRACHReportContainer')))
    _NRRACHReportList_Item_uEAssitantIdentifier = INT(name='uEAssitantIdentifier', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'SgNB-UE-X2AP-ID')), opt=True)
    _NRRACHReportList_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NRRACHReportList_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___NRRACHReportList_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____NRRACHReportList_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____NRRACHReportList_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRRACHReportList_Item_iE_Extensions__item__id._const_tab = ____NRRACHReportList_Item_iE_Extensions__item__id_tab
    ___NRRACHReportList_Item_iE_Extensions__item__id._const_tab_at = None
    ___NRRACHReportList_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___NRRACHReportList_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NRRACHReportList_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____NRRACHReportList_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRRACHReportList_Item_iE_Extensions__item__criticality._const_tab = ____NRRACHReportList_Item_iE_Extensions__item__criticality_tab
    ___NRRACHReportList_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NRRACHReportList_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NRRACHReportList_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NRRACHReportList_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____NRRACHReportList_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRRACHReportList_Item_iE_Extensions__item__extensionValue._const_tab = ____NRRACHReportList_Item_iE_Extensions__item__extensionValue_tab
    ___NRRACHReportList_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NRRACHReportList_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NRRACHReportList_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NRRACHReportList_Item_iE_Extensions__item__id),
        ('criticality', ___NRRACHReportList_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___NRRACHReportList_Item_iE_Extensions__item__extensionValue),
        ])
    __NRRACHReportList_Item_iE_Extensions__item_._ext = None
    _NRRACHReportList_Item_iE_Extensions._cont = __NRRACHReportList_Item_iE_Extensions__item_
    _NRRACHReportList_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NRRACHReportList_Item._cont = ASN1Dict([
        ('nRRACHReport', _NRRACHReportList_Item_nRRACHReport),
        ('uEAssitantIdentifier', _NRRACHReportList_Item_uEAssitantIdentifier),
        ('iE-Extensions', _NRRACHReportList_Item_iE_Extensions),
        ])
    NRRACHReportList_Item._ext = []
    
    #-----< NRRACHReportList-Item-ExtIEs >-----#
    NRRACHReportList_Item_ExtIEs = CLASS(name='NRRACHReportList-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    NRRACHReportList_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NRNeighbour-Information >-----#
    NRNeighbour_Information = SEQ_OF(name='NRNeighbour-Information', mode=MODE_TYPE)
    _NRNeighbour_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __NRNeighbour_Information__item__nrpCI = INT(name='nrpCI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'NRPCI')))
    __NRNeighbour_Information__item__nrCellID = SEQ(name='nrCellID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'NRCGI')))
    __NRNeighbour_Information__item__fiveGS_TAC = OCT_STR(name='fiveGS-TAC', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'FiveGS-TAC')), opt=True)
    __NRNeighbour_Information__item__configured_TAC = OCT_STR(name='configured-TAC', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'TAC')), opt=True)
    __NRNeighbour_Information__item__measurementTimingConfiguration = OCT_STR(name='measurementTimingConfiguration', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __NRNeighbour_Information__item__nRNeighbourModeInfo = CHOICE(name='nRNeighbourModeInfo', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___NRNeighbour_Information__item__nRNeighbourModeInfo_fdd = SEQ(name='fdd', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'FDD-InfoNeighbourServedNRCell-Information')))
    ___NRNeighbour_Information__item__nRNeighbourModeInfo_tdd = SEQ(name='tdd', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'TDD-InfoNeighbourServedNRCell-Information')))
    __NRNeighbour_Information__item__nRNeighbourModeInfo._cont = ASN1Dict([
        ('fdd', ___NRNeighbour_Information__item__nRNeighbourModeInfo_fdd),
        ('tdd', ___NRNeighbour_Information__item__nRNeighbourModeInfo_tdd),
        ])
    __NRNeighbour_Information__item__nRNeighbourModeInfo._ext = []
    __NRNeighbour_Information__item__iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___NRNeighbour_Information__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ____NRNeighbour_Information__item__iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    _____NRNeighbour_Information__item__iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ______NRNeighbour_Information__item__iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CSI-RSTransmissionIndication')))
    ______NRNeighbour_Information__item__iE_Extensions__item__id_tab_val_Extension_1 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SSB-PositionsInBurst')))
    ______NRNeighbour_Information__item__iE_Extensions__item__id_tab_val_Extension_2 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'NRCellPRACHConfig')))
    ______NRNeighbour_Information__item__iE_Extensions__item__id_tab_val_Extension_3 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Additional-Measurement-Timing-Configuration-List')))
    _____NRNeighbour_Information__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 380), ('criticality', 'ignore'), ('Extension', ______NRNeighbour_Information__item__iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 389), ('criticality', 'ignore'), ('Extension', ______NRNeighbour_Information__item__iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 390), ('criticality', 'ignore'), ('Extension', ______NRNeighbour_Information__item__iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 433), ('criticality', 'ignore'), ('Extension', ______NRNeighbour_Information__item__iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ____NRNeighbour_Information__item__iE_Extensions__item__id._const_tab = _____NRNeighbour_Information__item__iE_Extensions__item__id_tab
    ____NRNeighbour_Information__item__iE_Extensions__item__id._const_tab_at = None
    ____NRNeighbour_Information__item__iE_Extensions__item__id._const_tab_id = 'id'
    ____NRNeighbour_Information__item__iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NRNeighbour_Information__item__iE_Extensions__item__criticality._const_tab = _____NRNeighbour_Information__item__iE_Extensions__item__id_tab
    ____NRNeighbour_Information__item__iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____NRNeighbour_Information__item__iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____NRNeighbour_Information__item__iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NRNeighbour_Information__item__iE_Extensions__item__extensionValue._const_tab = _____NRNeighbour_Information__item__iE_Extensions__item__id_tab
    ____NRNeighbour_Information__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____NRNeighbour_Information__item__iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___NRNeighbour_Information__item__iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____NRNeighbour_Information__item__iE_Extensions__item__id),
        ('criticality', ____NRNeighbour_Information__item__iE_Extensions__item__criticality),
        ('extensionValue', ____NRNeighbour_Information__item__iE_Extensions__item__extensionValue),
        ])
    ___NRNeighbour_Information__item__iE_Extensions__item_._ext = None
    __NRNeighbour_Information__item__iE_Extensions._cont = ___NRNeighbour_Information__item__iE_Extensions__item_
    __NRNeighbour_Information__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _NRNeighbour_Information__item_._cont = ASN1Dict([
        ('nrpCI', __NRNeighbour_Information__item__nrpCI),
        ('nrCellID', __NRNeighbour_Information__item__nrCellID),
        ('fiveGS-TAC', __NRNeighbour_Information__item__fiveGS_TAC),
        ('configured-TAC', __NRNeighbour_Information__item__configured_TAC),
        ('measurementTimingConfiguration', __NRNeighbour_Information__item__measurementTimingConfiguration),
        ('nRNeighbourModeInfo', __NRNeighbour_Information__item__nRNeighbourModeInfo),
        ('iE-Extensions', __NRNeighbour_Information__item__iE_Extensions),
        ])
    _NRNeighbour_Information__item_._ext = []
    NRNeighbour_Information._cont = _NRNeighbour_Information__item_
    NRNeighbour_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    
    #-----< NRNeighbour-Information-ExtIEs >-----#
    NRNeighbour_Information_ExtIEs = CLASS(name='NRNeighbour-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _NRNeighbour_Information_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CSI-RSTransmissionIndication')))
    _NRNeighbour_Information_ExtIEs_val_Extension_1 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SSB-PositionsInBurst')))
    _NRNeighbour_Information_ExtIEs_val_Extension_2 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'NRCellPRACHConfig')))
    _NRNeighbour_Information_ExtIEs_val_Extension_3 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Additional-Measurement-Timing-Configuration-List')))
    NRNeighbour_Information_ExtIEs._val = ASN1Set(rv=[dict([('id', 380), ('criticality', 'ignore'), ('Extension', _NRNeighbour_Information_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 389), ('criticality', 'ignore'), ('Extension', _NRNeighbour_Information_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 390), ('criticality', 'ignore'), ('Extension', _NRNeighbour_Information_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 433), ('criticality', 'ignore'), ('Extension', _NRNeighbour_Information_ExtIEs_val_Extension_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< NPRACHConfiguration >-----#
    NPRACHConfiguration = SEQ(name='NPRACHConfiguration', mode=MODE_TYPE)
    _NPRACHConfiguration_fdd_or_tdd = CHOICE(name='fdd-or-tdd', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __NPRACHConfiguration_fdd_or_tdd_fdd = SEQ(name='fdd', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'NPRACHConfiguration-FDD')))
    __NPRACHConfiguration_fdd_or_tdd_tdd = SEQ(name='tdd', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'NPRACHConfiguration-TDD')))
    _NPRACHConfiguration_fdd_or_tdd._cont = ASN1Dict([
        ('fdd', __NPRACHConfiguration_fdd_or_tdd_fdd),
        ('tdd', __NPRACHConfiguration_fdd_or_tdd_tdd),
        ])
    _NPRACHConfiguration_fdd_or_tdd._ext = []
    _NPRACHConfiguration_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NPRACHConfiguration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___NPRACHConfiguration_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____NPRACHConfiguration_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____NPRACHConfiguration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NPRACHConfiguration_iE_Extensions__item__id._const_tab = ____NPRACHConfiguration_iE_Extensions__item__id_tab
    ___NPRACHConfiguration_iE_Extensions__item__id._const_tab_at = None
    ___NPRACHConfiguration_iE_Extensions__item__id._const_tab_id = 'id'
    ___NPRACHConfiguration_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NPRACHConfiguration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____NPRACHConfiguration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NPRACHConfiguration_iE_Extensions__item__criticality._const_tab = ____NPRACHConfiguration_iE_Extensions__item__criticality_tab
    ___NPRACHConfiguration_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NPRACHConfiguration_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NPRACHConfiguration_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NPRACHConfiguration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____NPRACHConfiguration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NPRACHConfiguration_iE_Extensions__item__extensionValue._const_tab = ____NPRACHConfiguration_iE_Extensions__item__extensionValue_tab
    ___NPRACHConfiguration_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NPRACHConfiguration_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NPRACHConfiguration_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NPRACHConfiguration_iE_Extensions__item__id),
        ('criticality', ___NPRACHConfiguration_iE_Extensions__item__criticality),
        ('extensionValue', ___NPRACHConfiguration_iE_Extensions__item__extensionValue),
        ])
    __NPRACHConfiguration_iE_Extensions__item_._ext = None
    _NPRACHConfiguration_iE_Extensions._cont = __NPRACHConfiguration_iE_Extensions__item_
    _NPRACHConfiguration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NPRACHConfiguration._cont = ASN1Dict([
        ('fdd-or-tdd', _NPRACHConfiguration_fdd_or_tdd),
        ('iE-Extensions', _NPRACHConfiguration_iE_Extensions),
        ])
    NPRACHConfiguration._ext = []
    
    #-----< NPRACHConfiguration-ExtIEs >-----#
    NPRACHConfiguration_ExtIEs = CLASS(name='NPRACHConfiguration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    NPRACHConfiguration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NPRACHConfiguration-FDD >-----#
    NPRACHConfiguration_FDD = SEQ(name='NPRACHConfiguration-FDD', mode=MODE_TYPE)
    _NPRACHConfiguration_FDD_nprach_CP_length = ENUM(name='nprach-CP-length', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'NPRACH-CP-Length')))
    _NPRACHConfiguration_FDD_anchorCarrier_NPRACHConfig = OCT_STR(name='anchorCarrier-NPRACHConfig', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NPRACHConfiguration_FDD_anchorCarrier_EDT_NPRACHConfig = OCT_STR(name='anchorCarrier-EDT-NPRACHConfig', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _NPRACHConfiguration_FDD_anchorCarrier_Format2_NPRACHConfig = OCT_STR(name='anchorCarrier-Format2-NPRACHConfig', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _NPRACHConfiguration_FDD_anchorCarrier_Format2_EDT_NPRACHConfig = OCT_STR(name='anchorCarrier-Format2-EDT-NPRACHConfig', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _NPRACHConfiguration_FDD_non_anchorCarrier_NPRACHConfig = OCT_STR(name='non-anchorCarrier-NPRACHConfig', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _NPRACHConfiguration_FDD_non_anchorCarrier_Format2_NPRACHConfig = OCT_STR(name='non-anchorCarrier-Format2-NPRACHConfig', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _NPRACHConfiguration_FDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NPRACHConfiguration_FDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___NPRACHConfiguration_FDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____NPRACHConfiguration_FDD_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____NPRACHConfiguration_FDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NPRACHConfiguration_FDD_iE_Extensions__item__id._const_tab = ____NPRACHConfiguration_FDD_iE_Extensions__item__id_tab
    ___NPRACHConfiguration_FDD_iE_Extensions__item__id._const_tab_at = None
    ___NPRACHConfiguration_FDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___NPRACHConfiguration_FDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NPRACHConfiguration_FDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____NPRACHConfiguration_FDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NPRACHConfiguration_FDD_iE_Extensions__item__criticality._const_tab = ____NPRACHConfiguration_FDD_iE_Extensions__item__criticality_tab
    ___NPRACHConfiguration_FDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NPRACHConfiguration_FDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NPRACHConfiguration_FDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NPRACHConfiguration_FDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____NPRACHConfiguration_FDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NPRACHConfiguration_FDD_iE_Extensions__item__extensionValue._const_tab = ____NPRACHConfiguration_FDD_iE_Extensions__item__extensionValue_tab
    ___NPRACHConfiguration_FDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NPRACHConfiguration_FDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NPRACHConfiguration_FDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NPRACHConfiguration_FDD_iE_Extensions__item__id),
        ('criticality', ___NPRACHConfiguration_FDD_iE_Extensions__item__criticality),
        ('extensionValue', ___NPRACHConfiguration_FDD_iE_Extensions__item__extensionValue),
        ])
    __NPRACHConfiguration_FDD_iE_Extensions__item_._ext = None
    _NPRACHConfiguration_FDD_iE_Extensions._cont = __NPRACHConfiguration_FDD_iE_Extensions__item_
    _NPRACHConfiguration_FDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NPRACHConfiguration_FDD._cont = ASN1Dict([
        ('nprach-CP-length', _NPRACHConfiguration_FDD_nprach_CP_length),
        ('anchorCarrier-NPRACHConfig', _NPRACHConfiguration_FDD_anchorCarrier_NPRACHConfig),
        ('anchorCarrier-EDT-NPRACHConfig', _NPRACHConfiguration_FDD_anchorCarrier_EDT_NPRACHConfig),
        ('anchorCarrier-Format2-NPRACHConfig', _NPRACHConfiguration_FDD_anchorCarrier_Format2_NPRACHConfig),
        ('anchorCarrier-Format2-EDT-NPRACHConfig', _NPRACHConfiguration_FDD_anchorCarrier_Format2_EDT_NPRACHConfig),
        ('non-anchorCarrier-NPRACHConfig', _NPRACHConfiguration_FDD_non_anchorCarrier_NPRACHConfig),
        ('non-anchorCarrier-Format2-NPRACHConfig', _NPRACHConfiguration_FDD_non_anchorCarrier_Format2_NPRACHConfig),
        ('iE-Extensions', _NPRACHConfiguration_FDD_iE_Extensions),
        ])
    NPRACHConfiguration_FDD._ext = []
    
    #-----< NPRACHConfiguration-FDD-ExtIEs >-----#
    NPRACHConfiguration_FDD_ExtIEs = CLASS(name='NPRACHConfiguration-FDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    NPRACHConfiguration_FDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NPRACHConfiguration-TDD >-----#
    NPRACHConfiguration_TDD = SEQ(name='NPRACHConfiguration-TDD', mode=MODE_TYPE)
    _NPRACHConfiguration_TDD_nprach_preambleFormat = ENUM(name='nprach-preambleFormat', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'NPRACH-preambleFormat')))
    _NPRACHConfiguration_TDD_anchorCarrier_NPRACHConfigTDD = OCT_STR(name='anchorCarrier-NPRACHConfigTDD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NPRACHConfiguration_TDD_non_anchorCarrierFequencyConfiglist = SEQ_OF(name='non-anchorCarrierFequencyConfiglist', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'Non-AnchorCarrierFrequencylist')), opt=True)
    _NPRACHConfiguration_TDD_non_anchorCarrier_NPRACHConfigTDD = OCT_STR(name='non-anchorCarrier-NPRACHConfigTDD', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _NPRACHConfiguration_TDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NPRACHConfiguration_TDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___NPRACHConfiguration_TDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____NPRACHConfiguration_TDD_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____NPRACHConfiguration_TDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NPRACHConfiguration_TDD_iE_Extensions__item__id._const_tab = ____NPRACHConfiguration_TDD_iE_Extensions__item__id_tab
    ___NPRACHConfiguration_TDD_iE_Extensions__item__id._const_tab_at = None
    ___NPRACHConfiguration_TDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___NPRACHConfiguration_TDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NPRACHConfiguration_TDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____NPRACHConfiguration_TDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NPRACHConfiguration_TDD_iE_Extensions__item__criticality._const_tab = ____NPRACHConfiguration_TDD_iE_Extensions__item__criticality_tab
    ___NPRACHConfiguration_TDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NPRACHConfiguration_TDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NPRACHConfiguration_TDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NPRACHConfiguration_TDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____NPRACHConfiguration_TDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NPRACHConfiguration_TDD_iE_Extensions__item__extensionValue._const_tab = ____NPRACHConfiguration_TDD_iE_Extensions__item__extensionValue_tab
    ___NPRACHConfiguration_TDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NPRACHConfiguration_TDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NPRACHConfiguration_TDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NPRACHConfiguration_TDD_iE_Extensions__item__id),
        ('criticality', ___NPRACHConfiguration_TDD_iE_Extensions__item__criticality),
        ('extensionValue', ___NPRACHConfiguration_TDD_iE_Extensions__item__extensionValue),
        ])
    __NPRACHConfiguration_TDD_iE_Extensions__item_._ext = None
    _NPRACHConfiguration_TDD_iE_Extensions._cont = __NPRACHConfiguration_TDD_iE_Extensions__item_
    _NPRACHConfiguration_TDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NPRACHConfiguration_TDD._cont = ASN1Dict([
        ('nprach-preambleFormat', _NPRACHConfiguration_TDD_nprach_preambleFormat),
        ('anchorCarrier-NPRACHConfigTDD', _NPRACHConfiguration_TDD_anchorCarrier_NPRACHConfigTDD),
        ('non-anchorCarrierFequencyConfiglist', _NPRACHConfiguration_TDD_non_anchorCarrierFequencyConfiglist),
        ('non-anchorCarrier-NPRACHConfigTDD', _NPRACHConfiguration_TDD_non_anchorCarrier_NPRACHConfigTDD),
        ('iE-Extensions', _NPRACHConfiguration_TDD_iE_Extensions),
        ])
    NPRACHConfiguration_TDD._ext = []
    
    #-----< NPRACHConfiguration-TDD-ExtIEs >-----#
    NPRACHConfiguration_TDD_ExtIEs = CLASS(name='NPRACHConfiguration-TDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    NPRACHConfiguration_TDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NPRACH-CP-Length >-----#
    NPRACH_CP_Length = ENUM(name='NPRACH-CP-Length', mode=MODE_TYPE)
    NPRACH_CP_Length._cont = ASN1Dict([('us66dot7', 0), ('us266dot7', 1)])
    NPRACH_CP_Length._ext = []
    
    #-----< NPRACH-preambleFormat >-----#
    NPRACH_preambleFormat = ENUM(name='NPRACH-preambleFormat', mode=MODE_TYPE)
    NPRACH_preambleFormat._cont = ASN1Dict([('fmt0', 0), ('fmt1', 1), ('fmt2', 2), ('fmt0a', 3), ('fmt1a', 4)])
    NPRACH_preambleFormat._ext = []
    
    #-----< Non-AnchorCarrierFrequencylist >-----#
    Non_AnchorCarrierFrequencylist = SEQ_OF(name='Non-AnchorCarrierFrequencylist', mode=MODE_TYPE)
    _Non_AnchorCarrierFrequencylist__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __Non_AnchorCarrierFrequencylist__item__non_anchorCarrioerFrquency = OCT_STR(name='non-anchorCarrioerFrquency', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __Non_AnchorCarrierFrequencylist__item__iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___Non_AnchorCarrierFrequencylist__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ____Non_AnchorCarrierFrequencylist__item__iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    _____Non_AnchorCarrierFrequencylist__item__iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____Non_AnchorCarrierFrequencylist__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____Non_AnchorCarrierFrequencylist__item__iE_Extensions__item__id._const_tab = _____Non_AnchorCarrierFrequencylist__item__iE_Extensions__item__id_tab
    ____Non_AnchorCarrierFrequencylist__item__iE_Extensions__item__id._const_tab_at = None
    ____Non_AnchorCarrierFrequencylist__item__iE_Extensions__item__id._const_tab_id = 'id'
    ____Non_AnchorCarrierFrequencylist__item__iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    _____Non_AnchorCarrierFrequencylist__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____Non_AnchorCarrierFrequencylist__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____Non_AnchorCarrierFrequencylist__item__iE_Extensions__item__criticality._const_tab = _____Non_AnchorCarrierFrequencylist__item__iE_Extensions__item__criticality_tab
    ____Non_AnchorCarrierFrequencylist__item__iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____Non_AnchorCarrierFrequencylist__item__iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____Non_AnchorCarrierFrequencylist__item__iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    _____Non_AnchorCarrierFrequencylist__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____Non_AnchorCarrierFrequencylist__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____Non_AnchorCarrierFrequencylist__item__iE_Extensions__item__extensionValue._const_tab = _____Non_AnchorCarrierFrequencylist__item__iE_Extensions__item__extensionValue_tab
    ____Non_AnchorCarrierFrequencylist__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____Non_AnchorCarrierFrequencylist__item__iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___Non_AnchorCarrierFrequencylist__item__iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____Non_AnchorCarrierFrequencylist__item__iE_Extensions__item__id),
        ('criticality', ____Non_AnchorCarrierFrequencylist__item__iE_Extensions__item__criticality),
        ('extensionValue', ____Non_AnchorCarrierFrequencylist__item__iE_Extensions__item__extensionValue),
        ])
    ___Non_AnchorCarrierFrequencylist__item__iE_Extensions__item_._ext = None
    __Non_AnchorCarrierFrequencylist__item__iE_Extensions._cont = ___Non_AnchorCarrierFrequencylist__item__iE_Extensions__item_
    __Non_AnchorCarrierFrequencylist__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _Non_AnchorCarrierFrequencylist__item_._cont = ASN1Dict([
        ('non-anchorCarrioerFrquency', __Non_AnchorCarrierFrequencylist__item__non_anchorCarrioerFrquency),
        ('iE-Extensions', __Non_AnchorCarrierFrequencylist__item__iE_Extensions),
        ])
    _Non_AnchorCarrierFrequencylist__item_._ext = []
    Non_AnchorCarrierFrequencylist._cont = _Non_AnchorCarrierFrequencylist__item_
    Non_AnchorCarrierFrequencylist._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< Non-AnchorCarrierFrequencylist-ExtIEs >-----#
    Non_AnchorCarrierFrequencylist_ExtIEs = CLASS(name='Non-AnchorCarrierFrequencylist-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    Non_AnchorCarrierFrequencylist_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NRPCI >-----#
    NRPCI = INT(name='NRPCI', mode=MODE_TYPE)
    NRPCI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1007)], ev=None, er=[])
    
    #-----< NRrestrictioninEPSasSecondaryRAT >-----#
    NRrestrictioninEPSasSecondaryRAT = ENUM(name='NRrestrictioninEPSasSecondaryRAT', mode=MODE_TYPE)
    NRrestrictioninEPSasSecondaryRAT._cont = ASN1Dict([('nRrestrictedinEPSasSecondaryRAT', 0)])
    NRrestrictioninEPSasSecondaryRAT._ext = []
    
    #-----< MeasurementResultforNRCellsPossiblyAggregated >-----#
    MeasurementResultforNRCellsPossiblyAggregated = SEQ_OF(name='MeasurementResultforNRCellsPossiblyAggregated', mode=MODE_TYPE)
    _MeasurementResultforNRCellsPossiblyAggregated__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MeasurementResultforNRCellsPossiblyAggregated-Item')))
    MeasurementResultforNRCellsPossiblyAggregated._cont = _MeasurementResultforNRCellsPossiblyAggregated__item_
    MeasurementResultforNRCellsPossiblyAggregated._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< MeasurementResultforNRCellsPossiblyAggregated-Item >-----#
    MeasurementResultforNRCellsPossiblyAggregated_Item = SEQ(name='MeasurementResultforNRCellsPossiblyAggregated-Item', mode=MODE_TYPE)
    _MeasurementResultforNRCellsPossiblyAggregated_Item_cellID = SEQ(name='cellID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'NRCGI')))
    _MeasurementResultforNRCellsPossiblyAggregated_Item_nrCompositeAvailableCapacityGroup = SEQ(name='nrCompositeAvailableCapacityGroup', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'NRCompositeAvailableCapacityGroup')), opt=True)
    _MeasurementResultforNRCellsPossiblyAggregated_Item_iE_Extension = SEQ_OF(name='iE-Extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MeasurementResultforNRCellsPossiblyAggregated_Item_iE_Extension__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___MeasurementResultforNRCellsPossiblyAggregated_Item_iE_Extension__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____MeasurementResultforNRCellsPossiblyAggregated_Item_iE_Extension__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____MeasurementResultforNRCellsPossiblyAggregated_Item_iE_Extension__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MeasurementResultforNRCellsPossiblyAggregated_Item_iE_Extension__item__id._const_tab = ____MeasurementResultforNRCellsPossiblyAggregated_Item_iE_Extension__item__id_tab
    ___MeasurementResultforNRCellsPossiblyAggregated_Item_iE_Extension__item__id._const_tab_at = None
    ___MeasurementResultforNRCellsPossiblyAggregated_Item_iE_Extension__item__id._const_tab_id = 'id'
    ___MeasurementResultforNRCellsPossiblyAggregated_Item_iE_Extension__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MeasurementResultforNRCellsPossiblyAggregated_Item_iE_Extension__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____MeasurementResultforNRCellsPossiblyAggregated_Item_iE_Extension__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MeasurementResultforNRCellsPossiblyAggregated_Item_iE_Extension__item__criticality._const_tab = ____MeasurementResultforNRCellsPossiblyAggregated_Item_iE_Extension__item__criticality_tab
    ___MeasurementResultforNRCellsPossiblyAggregated_Item_iE_Extension__item__criticality._const_tab_at = ('..', 'id')
    ___MeasurementResultforNRCellsPossiblyAggregated_Item_iE_Extension__item__criticality._const_tab_id = 'criticality'
    ___MeasurementResultforNRCellsPossiblyAggregated_Item_iE_Extension__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MeasurementResultforNRCellsPossiblyAggregated_Item_iE_Extension__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____MeasurementResultforNRCellsPossiblyAggregated_Item_iE_Extension__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MeasurementResultforNRCellsPossiblyAggregated_Item_iE_Extension__item__extensionValue._const_tab = ____MeasurementResultforNRCellsPossiblyAggregated_Item_iE_Extension__item__extensionValue_tab
    ___MeasurementResultforNRCellsPossiblyAggregated_Item_iE_Extension__item__extensionValue._const_tab_at = ('..', 'id')
    ___MeasurementResultforNRCellsPossiblyAggregated_Item_iE_Extension__item__extensionValue._const_tab_id = 'Extension'
    __MeasurementResultforNRCellsPossiblyAggregated_Item_iE_Extension__item_._cont = ASN1Dict([
        ('id', ___MeasurementResultforNRCellsPossiblyAggregated_Item_iE_Extension__item__id),
        ('criticality', ___MeasurementResultforNRCellsPossiblyAggregated_Item_iE_Extension__item__criticality),
        ('extensionValue', ___MeasurementResultforNRCellsPossiblyAggregated_Item_iE_Extension__item__extensionValue),
        ])
    __MeasurementResultforNRCellsPossiblyAggregated_Item_iE_Extension__item_._ext = None
    _MeasurementResultforNRCellsPossiblyAggregated_Item_iE_Extension._cont = __MeasurementResultforNRCellsPossiblyAggregated_Item_iE_Extension__item_
    _MeasurementResultforNRCellsPossiblyAggregated_Item_iE_Extension._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MeasurementResultforNRCellsPossiblyAggregated_Item._cont = ASN1Dict([
        ('cellID', _MeasurementResultforNRCellsPossiblyAggregated_Item_cellID),
        ('nrCompositeAvailableCapacityGroup', _MeasurementResultforNRCellsPossiblyAggregated_Item_nrCompositeAvailableCapacityGroup),
        ('iE-Extension', _MeasurementResultforNRCellsPossiblyAggregated_Item_iE_Extension),
        ])
    MeasurementResultforNRCellsPossiblyAggregated_Item._ext = []
    
    #-----< MeasurementResultforNRCellsPossiblyAggregated-Item-ExtIEs >-----#
    MeasurementResultforNRCellsPossiblyAggregated_Item_ExtIEs = CLASS(name='MeasurementResultforNRCellsPossiblyAggregated-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    MeasurementResultforNRCellsPossiblyAggregated_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NRRadioResourceStatus >-----#
    NRRadioResourceStatus = SEQ(name='NRRadioResourceStatus', mode=MODE_TYPE)
    _NRRadioResourceStatus_ssbAreaRadioResourceStatus_List = SEQ_OF(name='ssbAreaRadioResourceStatus-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'SSBAreaRadioResourceStatus-List')))
    _NRRadioResourceStatus_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NRRadioResourceStatus_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___NRRadioResourceStatus_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____NRRadioResourceStatus_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____NRRadioResourceStatus_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MIMOPRBusageInformation')))
    ____NRRadioResourceStatus_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 439), ('criticality', 'ignore'), ('Extension', _____NRRadioResourceStatus_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___NRRadioResourceStatus_iE_Extensions__item__id._const_tab = ____NRRadioResourceStatus_iE_Extensions__item__id_tab
    ___NRRadioResourceStatus_iE_Extensions__item__id._const_tab_at = None
    ___NRRadioResourceStatus_iE_Extensions__item__id._const_tab_id = 'id'
    ___NRRadioResourceStatus_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___NRRadioResourceStatus_iE_Extensions__item__criticality._const_tab = ____NRRadioResourceStatus_iE_Extensions__item__id_tab
    ___NRRadioResourceStatus_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NRRadioResourceStatus_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NRRadioResourceStatus_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___NRRadioResourceStatus_iE_Extensions__item__extensionValue._const_tab = ____NRRadioResourceStatus_iE_Extensions__item__id_tab
    ___NRRadioResourceStatus_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NRRadioResourceStatus_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NRRadioResourceStatus_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NRRadioResourceStatus_iE_Extensions__item__id),
        ('criticality', ___NRRadioResourceStatus_iE_Extensions__item__criticality),
        ('extensionValue', ___NRRadioResourceStatus_iE_Extensions__item__extensionValue),
        ])
    __NRRadioResourceStatus_iE_Extensions__item_._ext = None
    _NRRadioResourceStatus_iE_Extensions._cont = __NRRadioResourceStatus_iE_Extensions__item_
    _NRRadioResourceStatus_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NRRadioResourceStatus._cont = ASN1Dict([
        ('ssbAreaRadioResourceStatus-List', _NRRadioResourceStatus_ssbAreaRadioResourceStatus_List),
        ('iE-Extensions', _NRRadioResourceStatus_iE_Extensions),
        ])
    NRRadioResourceStatus._ext = []
    
    #-----< NRRadioResourceStatus-ExtIEs >-----#
    NRRadioResourceStatus_ExtIEs = CLASS(name='NRRadioResourceStatus-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _NRRadioResourceStatus_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MIMOPRBusageInformation')))
    NRRadioResourceStatus_ExtIEs._val = ASN1Set(rv=[dict([('id', 439), ('criticality', 'ignore'), ('Extension', _NRRadioResourceStatus_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MIMOPRBusageInformation >-----#
    MIMOPRBusageInformation = SEQ(name='MIMOPRBusageInformation', mode=MODE_TYPE)
    _MIMOPRBusageInformation_dl_GBR_PRB_usage_for_MIMO = INT(name='dl-GBR-PRB-usage-for-MIMO', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'DL-GBR-PRB-usage-for-MIMO')))
    _MIMOPRBusageInformation_ul_GBR_PRB_usage_for_MIMO = INT(name='ul-GBR-PRB-usage-for-MIMO', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'UL-GBR-PRB-usage-for-MIMO')))
    _MIMOPRBusageInformation_dl_non_GBR_PRB_usage_for_MIMO = INT(name='dl-non-GBR-PRB-usage-for-MIMO', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'DL-non-GBR-PRB-usage-for-MIMO')))
    _MIMOPRBusageInformation_ul_non_GBR_PRB_usage_for_MIMO = INT(name='ul-non-GBR-PRB-usage-for-MIMO', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'UL-non-GBR-PRB-usage-for-MIMO')))
    _MIMOPRBusageInformation_dl_Total_PRB_usage_for_MIMO = INT(name='dl-Total-PRB-usage-for-MIMO', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'DL-Total-PRB-usage-for-MIMO')))
    _MIMOPRBusageInformation_ul_Total_PRB_usage_for_MIMO = INT(name='ul-Total-PRB-usage-for-MIMO', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'UL-Total-PRB-usage-for-MIMO')))
    _MIMOPRBusageInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MIMOPRBusageInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___MIMOPRBusageInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____MIMOPRBusageInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____MIMOPRBusageInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MIMOPRBusageInformation_iE_Extensions__item__id._const_tab = ____MIMOPRBusageInformation_iE_Extensions__item__id_tab
    ___MIMOPRBusageInformation_iE_Extensions__item__id._const_tab_at = None
    ___MIMOPRBusageInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___MIMOPRBusageInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MIMOPRBusageInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____MIMOPRBusageInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MIMOPRBusageInformation_iE_Extensions__item__criticality._const_tab = ____MIMOPRBusageInformation_iE_Extensions__item__criticality_tab
    ___MIMOPRBusageInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MIMOPRBusageInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MIMOPRBusageInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MIMOPRBusageInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____MIMOPRBusageInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MIMOPRBusageInformation_iE_Extensions__item__extensionValue._const_tab = ____MIMOPRBusageInformation_iE_Extensions__item__extensionValue_tab
    ___MIMOPRBusageInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MIMOPRBusageInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MIMOPRBusageInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MIMOPRBusageInformation_iE_Extensions__item__id),
        ('criticality', ___MIMOPRBusageInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___MIMOPRBusageInformation_iE_Extensions__item__extensionValue),
        ])
    __MIMOPRBusageInformation_iE_Extensions__item_._ext = None
    _MIMOPRBusageInformation_iE_Extensions._cont = __MIMOPRBusageInformation_iE_Extensions__item_
    _MIMOPRBusageInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MIMOPRBusageInformation._cont = ASN1Dict([
        ('dl-GBR-PRB-usage-for-MIMO', _MIMOPRBusageInformation_dl_GBR_PRB_usage_for_MIMO),
        ('ul-GBR-PRB-usage-for-MIMO', _MIMOPRBusageInformation_ul_GBR_PRB_usage_for_MIMO),
        ('dl-non-GBR-PRB-usage-for-MIMO', _MIMOPRBusageInformation_dl_non_GBR_PRB_usage_for_MIMO),
        ('ul-non-GBR-PRB-usage-for-MIMO', _MIMOPRBusageInformation_ul_non_GBR_PRB_usage_for_MIMO),
        ('dl-Total-PRB-usage-for-MIMO', _MIMOPRBusageInformation_dl_Total_PRB_usage_for_MIMO),
        ('ul-Total-PRB-usage-for-MIMO', _MIMOPRBusageInformation_ul_Total_PRB_usage_for_MIMO),
        ('iE-Extensions', _MIMOPRBusageInformation_iE_Extensions),
        ])
    MIMOPRBusageInformation._ext = []
    
    #-----< MIMOPRBusageInformation-ExtIEs >-----#
    MIMOPRBusageInformation_ExtIEs = CLASS(name='MIMOPRBusageInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    MIMOPRBusageInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NRrestrictionin5GS >-----#
    NRrestrictionin5GS = ENUM(name='NRrestrictionin5GS', mode=MODE_TYPE)
    NRrestrictionin5GS._cont = ASN1Dict([('nRrestrictedin5GS', 0)])
    NRrestrictionin5GS._ext = []
    
    #-----< NRencryptionAlgorithms >-----#
    NRencryptionAlgorithms = BIT_STR(name='NRencryptionAlgorithms', mode=MODE_TYPE)
    NRencryptionAlgorithms._const_sz = ASN1Set(rv=[16], rr=[], ev=[], er=[])
    
    #-----< NRintegrityProtectionAlgorithms >-----#
    NRintegrityProtectionAlgorithms = BIT_STR(name='NRintegrityProtectionAlgorithms', mode=MODE_TYPE)
    NRintegrityProtectionAlgorithms._const_sz = ASN1Set(rv=[16], rr=[], ev=[], er=[])
    
    #-----< NR-TxBW >-----#
    NR_TxBW = SEQ(name='NR-TxBW', mode=MODE_TYPE)
    _NR_TxBW_nRSCS = ENUM(name='nRSCS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'NRSCS')))
    _NR_TxBW_nRNRB = ENUM(name='nRNRB', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'NRNRB')))
    _NR_TxBW_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NR_TxBW_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___NR_TxBW_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____NR_TxBW_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____NR_TxBW_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NR_TxBW_iE_Extensions__item__id._const_tab = ____NR_TxBW_iE_Extensions__item__id_tab
    ___NR_TxBW_iE_Extensions__item__id._const_tab_at = None
    ___NR_TxBW_iE_Extensions__item__id._const_tab_id = 'id'
    ___NR_TxBW_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NR_TxBW_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____NR_TxBW_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NR_TxBW_iE_Extensions__item__criticality._const_tab = ____NR_TxBW_iE_Extensions__item__criticality_tab
    ___NR_TxBW_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NR_TxBW_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NR_TxBW_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NR_TxBW_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____NR_TxBW_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NR_TxBW_iE_Extensions__item__extensionValue._const_tab = ____NR_TxBW_iE_Extensions__item__extensionValue_tab
    ___NR_TxBW_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NR_TxBW_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NR_TxBW_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NR_TxBW_iE_Extensions__item__id),
        ('criticality', ___NR_TxBW_iE_Extensions__item__criticality),
        ('extensionValue', ___NR_TxBW_iE_Extensions__item__extensionValue),
        ])
    __NR_TxBW_iE_Extensions__item_._ext = None
    _NR_TxBW_iE_Extensions._cont = __NR_TxBW_iE_Extensions__item_
    _NR_TxBW_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NR_TxBW._cont = ASN1Dict([
        ('nRSCS', _NR_TxBW_nRSCS),
        ('nRNRB', _NR_TxBW_nRNRB),
        ('iE-Extensions', _NR_TxBW_iE_Extensions),
        ])
    NR_TxBW._ext = []
    
    #-----< NR-TxBW-ExtIEs >-----#
    NR_TxBW_ExtIEs = CLASS(name='NR-TxBW-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    NR_TxBW_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NRNRB >-----#
    NRNRB = ENUM(name='NRNRB', mode=MODE_TYPE)
    NRNRB._cont = ASN1Dict([('nrb11', 0), ('nrb18', 1), ('nrb24', 2), ('nrb25', 3), ('nrb31', 4), ('nrb32', 5), ('nrb38', 6), ('nrb51', 7), ('nrb52', 8), ('nrb65', 9), ('nrb66', 10), ('nrb78', 11), ('nrb79', 12), ('nrb93', 13), ('nrb106', 14), ('nrb107', 15), ('nrb121', 16), ('nrb132', 17), ('nrb133', 18), ('nrb135', 19), ('nrb160', 20), ('nrb162', 21), ('nrb189', 22), ('nrb216', 23), ('nrb217', 24), ('nrb245', 25), ('nrb264', 26), ('nrb270', 27), ('nrb273', 28)])
    NRNRB._ext = []
    
    #-----< NRSCS >-----#
    NRSCS = ENUM(name='NRSCS', mode=MODE_TYPE)
    NRSCS._cont = ASN1Dict([('scs15', 0), ('scs30', 1), ('scs60', 2), ('scs120', 3)])
    NRSCS._ext = []
    
    #-----< NRS-NSSS-PowerOffset >-----#
    NRS_NSSS_PowerOffset = ENUM(name='NRS-NSSS-PowerOffset', mode=MODE_TYPE)
    NRS_NSSS_PowerOffset._cont = ASN1Dict([('minusThree', 0), ('zero', 1), ('three', 2)])
    NRS_NSSS_PowerOffset._ext = []
    
    #-----< FiveGS-TAC >-----#
    FiveGS_TAC = OCT_STR(name='FiveGS-TAC', mode=MODE_TYPE)
    FiveGS_TAC._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< NRUeReport >-----#
    NRUeReport = SEQ(name='NRUeReport', mode=MODE_TYPE)
    _NRUeReport_uENRMeasurements = OCT_STR(name='uENRMeasurements', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'RRCContainer')))
    _NRUeReport_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NRUeReport_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___NRUeReport_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____NRUeReport_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____NRUeReport_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRUeReport_iE_Extensions__item__id._const_tab = ____NRUeReport_iE_Extensions__item__id_tab
    ___NRUeReport_iE_Extensions__item__id._const_tab_at = None
    ___NRUeReport_iE_Extensions__item__id._const_tab_id = 'id'
    ___NRUeReport_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NRUeReport_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____NRUeReport_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRUeReport_iE_Extensions__item__criticality._const_tab = ____NRUeReport_iE_Extensions__item__criticality_tab
    ___NRUeReport_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NRUeReport_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NRUeReport_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NRUeReport_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____NRUeReport_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRUeReport_iE_Extensions__item__extensionValue._const_tab = ____NRUeReport_iE_Extensions__item__extensionValue_tab
    ___NRUeReport_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NRUeReport_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NRUeReport_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NRUeReport_iE_Extensions__item__id),
        ('criticality', ___NRUeReport_iE_Extensions__item__criticality),
        ('extensionValue', ___NRUeReport_iE_Extensions__item__extensionValue),
        ])
    __NRUeReport_iE_Extensions__item_._ext = None
    _NRUeReport_iE_Extensions._cont = __NRUeReport_iE_Extensions__item_
    _NRUeReport_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NRUeReport._cont = ASN1Dict([
        ('uENRMeasurements', _NRUeReport_uENRMeasurements),
        ('iE-Extensions', _NRUeReport_iE_Extensions),
        ])
    NRUeReport._ext = []
    
    #-----< NRUeReport-ExtIEs >-----#
    NRUeReport_ExtIEs = CLASS(name='NRUeReport-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    NRUeReport_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NRUESidelinkAggregateMaximumBitRate >-----#
    NRUESidelinkAggregateMaximumBitRate = SEQ(name='NRUESidelinkAggregateMaximumBitRate', mode=MODE_TYPE)
    _NRUESidelinkAggregateMaximumBitRate_uESidelinkAggregateMaximumBitRate = INT(name='uESidelinkAggregateMaximumBitRate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'BitRate')))
    _NRUESidelinkAggregateMaximumBitRate_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NRUESidelinkAggregateMaximumBitRate_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___NRUESidelinkAggregateMaximumBitRate_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____NRUESidelinkAggregateMaximumBitRate_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____NRUESidelinkAggregateMaximumBitRate_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRUESidelinkAggregateMaximumBitRate_iE_Extensions__item__id._const_tab = ____NRUESidelinkAggregateMaximumBitRate_iE_Extensions__item__id_tab
    ___NRUESidelinkAggregateMaximumBitRate_iE_Extensions__item__id._const_tab_at = None
    ___NRUESidelinkAggregateMaximumBitRate_iE_Extensions__item__id._const_tab_id = 'id'
    ___NRUESidelinkAggregateMaximumBitRate_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NRUESidelinkAggregateMaximumBitRate_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____NRUESidelinkAggregateMaximumBitRate_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRUESidelinkAggregateMaximumBitRate_iE_Extensions__item__criticality._const_tab = ____NRUESidelinkAggregateMaximumBitRate_iE_Extensions__item__criticality_tab
    ___NRUESidelinkAggregateMaximumBitRate_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NRUESidelinkAggregateMaximumBitRate_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NRUESidelinkAggregateMaximumBitRate_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NRUESidelinkAggregateMaximumBitRate_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____NRUESidelinkAggregateMaximumBitRate_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRUESidelinkAggregateMaximumBitRate_iE_Extensions__item__extensionValue._const_tab = ____NRUESidelinkAggregateMaximumBitRate_iE_Extensions__item__extensionValue_tab
    ___NRUESidelinkAggregateMaximumBitRate_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NRUESidelinkAggregateMaximumBitRate_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NRUESidelinkAggregateMaximumBitRate_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NRUESidelinkAggregateMaximumBitRate_iE_Extensions__item__id),
        ('criticality', ___NRUESidelinkAggregateMaximumBitRate_iE_Extensions__item__criticality),
        ('extensionValue', ___NRUESidelinkAggregateMaximumBitRate_iE_Extensions__item__extensionValue),
        ])
    __NRUESidelinkAggregateMaximumBitRate_iE_Extensions__item_._ext = None
    _NRUESidelinkAggregateMaximumBitRate_iE_Extensions._cont = __NRUESidelinkAggregateMaximumBitRate_iE_Extensions__item_
    _NRUESidelinkAggregateMaximumBitRate_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NRUESidelinkAggregateMaximumBitRate._cont = ASN1Dict([
        ('uESidelinkAggregateMaximumBitRate', _NRUESidelinkAggregateMaximumBitRate_uESidelinkAggregateMaximumBitRate),
        ('iE-Extensions', _NRUESidelinkAggregateMaximumBitRate_iE_Extensions),
        ])
    NRUESidelinkAggregateMaximumBitRate._ext = []
    
    #-----< NRUESidelinkAggregateMaximumBitRate-ExtIEs >-----#
    NRUESidelinkAggregateMaximumBitRate_ExtIEs = CLASS(name='NRUESidelinkAggregateMaximumBitRate-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    NRUESidelinkAggregateMaximumBitRate_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NRUESecurityCapabilities >-----#
    NRUESecurityCapabilities = SEQ(name='NRUESecurityCapabilities', mode=MODE_TYPE)
    _NRUESecurityCapabilities_nRencryptionAlgorithms = BIT_STR(name='nRencryptionAlgorithms', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'NRencryptionAlgorithms')))
    _NRUESecurityCapabilities_nRintegrityProtectionAlgorithms = BIT_STR(name='nRintegrityProtectionAlgorithms', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'NRintegrityProtectionAlgorithms')))
    _NRUESecurityCapabilities_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NRUESecurityCapabilities_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___NRUESecurityCapabilities_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____NRUESecurityCapabilities_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____NRUESecurityCapabilities_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRUESecurityCapabilities_iE_Extensions__item__id._const_tab = ____NRUESecurityCapabilities_iE_Extensions__item__id_tab
    ___NRUESecurityCapabilities_iE_Extensions__item__id._const_tab_at = None
    ___NRUESecurityCapabilities_iE_Extensions__item__id._const_tab_id = 'id'
    ___NRUESecurityCapabilities_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NRUESecurityCapabilities_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____NRUESecurityCapabilities_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRUESecurityCapabilities_iE_Extensions__item__criticality._const_tab = ____NRUESecurityCapabilities_iE_Extensions__item__criticality_tab
    ___NRUESecurityCapabilities_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NRUESecurityCapabilities_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NRUESecurityCapabilities_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NRUESecurityCapabilities_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____NRUESecurityCapabilities_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRUESecurityCapabilities_iE_Extensions__item__extensionValue._const_tab = ____NRUESecurityCapabilities_iE_Extensions__item__extensionValue_tab
    ___NRUESecurityCapabilities_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NRUESecurityCapabilities_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NRUESecurityCapabilities_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NRUESecurityCapabilities_iE_Extensions__item__id),
        ('criticality', ___NRUESecurityCapabilities_iE_Extensions__item__criticality),
        ('extensionValue', ___NRUESecurityCapabilities_iE_Extensions__item__extensionValue),
        ])
    __NRUESecurityCapabilities_iE_Extensions__item_._ext = None
    _NRUESecurityCapabilities_iE_Extensions._cont = __NRUESecurityCapabilities_iE_Extensions__item_
    _NRUESecurityCapabilities_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NRUESecurityCapabilities._cont = ASN1Dict([
        ('nRencryptionAlgorithms', _NRUESecurityCapabilities_nRencryptionAlgorithms),
        ('nRintegrityProtectionAlgorithms', _NRUESecurityCapabilities_nRintegrityProtectionAlgorithms),
        ('iE-Extensions', _NRUESecurityCapabilities_iE_Extensions),
        ])
    NRUESecurityCapabilities._ext = []
    
    #-----< NRUESecurityCapabilities-ExtIEs >-----#
    NRUESecurityCapabilities_ExtIEs = CLASS(name='NRUESecurityCapabilities-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    NRUESecurityCapabilities_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NSSS-NumOccasionDifferentPrecoder >-----#
    NSSS_NumOccasionDifferentPrecoder = ENUM(name='NSSS-NumOccasionDifferentPrecoder', mode=MODE_TYPE)
    NSSS_NumOccasionDifferentPrecoder._cont = ASN1Dict([('two', 0), ('four', 1), ('eight', 2)])
    NSSS_NumOccasionDifferentPrecoder._ext = []
    
    #-----< NRV2XServicesAuthorized >-----#
    NRV2XServicesAuthorized = SEQ(name='NRV2XServicesAuthorized', mode=MODE_TYPE)
    _NRV2XServicesAuthorized_vehicleUE = ENUM(name='vehicleUE', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'VehicleUE')), opt=True)
    _NRV2XServicesAuthorized_pedestrianUE = ENUM(name='pedestrianUE', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'PedestrianUE')), opt=True)
    _NRV2XServicesAuthorized_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NRV2XServicesAuthorized_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___NRV2XServicesAuthorized_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____NRV2XServicesAuthorized_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____NRV2XServicesAuthorized_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRV2XServicesAuthorized_iE_Extensions__item__id._const_tab = ____NRV2XServicesAuthorized_iE_Extensions__item__id_tab
    ___NRV2XServicesAuthorized_iE_Extensions__item__id._const_tab_at = None
    ___NRV2XServicesAuthorized_iE_Extensions__item__id._const_tab_id = 'id'
    ___NRV2XServicesAuthorized_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NRV2XServicesAuthorized_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____NRV2XServicesAuthorized_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRV2XServicesAuthorized_iE_Extensions__item__criticality._const_tab = ____NRV2XServicesAuthorized_iE_Extensions__item__criticality_tab
    ___NRV2XServicesAuthorized_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NRV2XServicesAuthorized_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NRV2XServicesAuthorized_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NRV2XServicesAuthorized_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____NRV2XServicesAuthorized_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRV2XServicesAuthorized_iE_Extensions__item__extensionValue._const_tab = ____NRV2XServicesAuthorized_iE_Extensions__item__extensionValue_tab
    ___NRV2XServicesAuthorized_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NRV2XServicesAuthorized_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NRV2XServicesAuthorized_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NRV2XServicesAuthorized_iE_Extensions__item__id),
        ('criticality', ___NRV2XServicesAuthorized_iE_Extensions__item__criticality),
        ('extensionValue', ___NRV2XServicesAuthorized_iE_Extensions__item__extensionValue),
        ])
    __NRV2XServicesAuthorized_iE_Extensions__item_._ext = None
    _NRV2XServicesAuthorized_iE_Extensions._cont = __NRV2XServicesAuthorized_iE_Extensions__item_
    _NRV2XServicesAuthorized_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NRV2XServicesAuthorized._cont = ASN1Dict([
        ('vehicleUE', _NRV2XServicesAuthorized_vehicleUE),
        ('pedestrianUE', _NRV2XServicesAuthorized_pedestrianUE),
        ('iE-Extensions', _NRV2XServicesAuthorized_iE_Extensions),
        ])
    NRV2XServicesAuthorized._ext = []
    
    #-----< NRV2XServicesAuthorized-ExtIEs >-----#
    NRV2XServicesAuthorized_ExtIEs = CLASS(name='NRV2XServicesAuthorized-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    NRV2XServicesAuthorized_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< OffsetOfNbiotChannelNumberToEARFCN >-----#
    OffsetOfNbiotChannelNumberToEARFCN = ENUM(name='OffsetOfNbiotChannelNumberToEARFCN', mode=MODE_TYPE)
    OffsetOfNbiotChannelNumberToEARFCN._cont = ASN1Dict([('minusTen', 0), ('minusNine', 1), ('minusEight', 2), ('minusSeven', 3), ('minusSix', 4), ('minusFive', 5), ('minusFour', 6), ('minusThree', 7), ('minusTwo', 8), ('minusOne', 9), ('minusZeroDotFive', 10), ('zero', 11), ('one', 12), ('two', 13), ('three', 14), ('four', 15), ('five', 16), ('six', 17), ('seven', 18), ('eight', 19), ('nine', 20), ('minusEightDotFive', 21), ('minusFourDotFive', 22), ('threeDotFive', 23), ('sevenDotFive', 24)])
    OffsetOfNbiotChannelNumberToEARFCN._ext = ['minusEightDotFive', 'minusFourDotFive', 'threeDotFive', 'sevenDotFive']
    
    #-----< Oneframe >-----#
    Oneframe = BIT_STR(name='Oneframe', mode=MODE_TYPE)
    Oneframe._const_sz = ASN1Set(rv=[6], rr=[], ev=None, er=[])
    
    #-----< Packet-LossRate >-----#
    Packet_LossRate = INT(name='Packet-LossRate', mode=MODE_TYPE)
    Packet_LossRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1000)], ev=None, er=[])
    
    #-----< PA-Values >-----#
    PA_Values = ENUM(name='PA-Values', mode=MODE_TYPE)
    PA_Values._cont = ASN1Dict([('dB-6', 0), ('dB-4dot77', 1), ('dB-3', 2), ('dB-1dot77', 3), ('dB0', 4), ('dB1', 5), ('dB2', 6), ('dB3', 7)])
    PA_Values._ext = []
    
    #-----< PC5QoSParameters >-----#
    PC5QoSParameters = SEQ(name='PC5QoSParameters', mode=MODE_TYPE)
    _PC5QoSParameters_pc5QoSFlowList = SEQ_OF(name='pc5QoSFlowList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'PC5QoSFlowList')))
    _PC5QoSParameters_pc5LinkAggregatedBitRates = INT(name='pc5LinkAggregatedBitRates', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'BitRate')), opt=True)
    _PC5QoSParameters_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PC5QoSParameters_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___PC5QoSParameters_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____PC5QoSParameters_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____PC5QoSParameters_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5QoSParameters_iE_Extensions__item__id._const_tab = ____PC5QoSParameters_iE_Extensions__item__id_tab
    ___PC5QoSParameters_iE_Extensions__item__id._const_tab_at = None
    ___PC5QoSParameters_iE_Extensions__item__id._const_tab_id = 'id'
    ___PC5QoSParameters_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PC5QoSParameters_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____PC5QoSParameters_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5QoSParameters_iE_Extensions__item__criticality._const_tab = ____PC5QoSParameters_iE_Extensions__item__criticality_tab
    ___PC5QoSParameters_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PC5QoSParameters_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PC5QoSParameters_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PC5QoSParameters_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____PC5QoSParameters_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5QoSParameters_iE_Extensions__item__extensionValue._const_tab = ____PC5QoSParameters_iE_Extensions__item__extensionValue_tab
    ___PC5QoSParameters_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PC5QoSParameters_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PC5QoSParameters_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PC5QoSParameters_iE_Extensions__item__id),
        ('criticality', ___PC5QoSParameters_iE_Extensions__item__criticality),
        ('extensionValue', ___PC5QoSParameters_iE_Extensions__item__extensionValue),
        ])
    __PC5QoSParameters_iE_Extensions__item_._ext = None
    _PC5QoSParameters_iE_Extensions._cont = __PC5QoSParameters_iE_Extensions__item_
    _PC5QoSParameters_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PC5QoSParameters._cont = ASN1Dict([
        ('pc5QoSFlowList', _PC5QoSParameters_pc5QoSFlowList),
        ('pc5LinkAggregatedBitRates', _PC5QoSParameters_pc5LinkAggregatedBitRates),
        ('iE-Extensions', _PC5QoSParameters_iE_Extensions),
        ])
    PC5QoSParameters._ext = []
    
    #-----< PC5QoSParameters-ExtIEs >-----#
    PC5QoSParameters_ExtIEs = CLASS(name='PC5QoSParameters-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    PC5QoSParameters_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PC5QoSFlowList >-----#
    PC5QoSFlowList = SEQ_OF(name='PC5QoSFlowList', mode=MODE_TYPE)
    _PC5QoSFlowList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PC5QoSFlowItem')))
    PC5QoSFlowList._cont = _PC5QoSFlowList__item_
    PC5QoSFlowList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2048)], ev=None, er=[])
    
    #-----< PC5QoSFlowItem >-----#
    PC5QoSFlowItem = SEQ(name='PC5QoSFlowItem', mode=MODE_TYPE)
    _PC5QoSFlowItem_pQI = INT(name='pQI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'FiveQI')))
    _PC5QoSFlowItem_pc5FlowBitRates = SEQ(name='pc5FlowBitRates', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'PC5FlowBitRates')), opt=True)
    _PC5QoSFlowItem_range = ENUM(name='range', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'Range')), opt=True)
    _PC5QoSFlowItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PC5QoSFlowItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___PC5QoSFlowItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____PC5QoSFlowItem_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____PC5QoSFlowItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5QoSFlowItem_iE_Extensions__item__id._const_tab = ____PC5QoSFlowItem_iE_Extensions__item__id_tab
    ___PC5QoSFlowItem_iE_Extensions__item__id._const_tab_at = None
    ___PC5QoSFlowItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___PC5QoSFlowItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PC5QoSFlowItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____PC5QoSFlowItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5QoSFlowItem_iE_Extensions__item__criticality._const_tab = ____PC5QoSFlowItem_iE_Extensions__item__criticality_tab
    ___PC5QoSFlowItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PC5QoSFlowItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PC5QoSFlowItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PC5QoSFlowItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____PC5QoSFlowItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5QoSFlowItem_iE_Extensions__item__extensionValue._const_tab = ____PC5QoSFlowItem_iE_Extensions__item__extensionValue_tab
    ___PC5QoSFlowItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PC5QoSFlowItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PC5QoSFlowItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PC5QoSFlowItem_iE_Extensions__item__id),
        ('criticality', ___PC5QoSFlowItem_iE_Extensions__item__criticality),
        ('extensionValue', ___PC5QoSFlowItem_iE_Extensions__item__extensionValue),
        ])
    __PC5QoSFlowItem_iE_Extensions__item_._ext = None
    _PC5QoSFlowItem_iE_Extensions._cont = __PC5QoSFlowItem_iE_Extensions__item_
    _PC5QoSFlowItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PC5QoSFlowItem._cont = ASN1Dict([
        ('pQI', _PC5QoSFlowItem_pQI),
        ('pc5FlowBitRates', _PC5QoSFlowItem_pc5FlowBitRates),
        ('range', _PC5QoSFlowItem_range),
        ('iE-Extensions', _PC5QoSFlowItem_iE_Extensions),
        ])
    PC5QoSFlowItem._ext = []
    
    #-----< PC5QoSFlowItem-ExtIEs >-----#
    PC5QoSFlowItem_ExtIEs = CLASS(name='PC5QoSFlowItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    PC5QoSFlowItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PC5FlowBitRates >-----#
    PC5FlowBitRates = SEQ(name='PC5FlowBitRates', mode=MODE_TYPE)
    _PC5FlowBitRates_guaranteedFlowBitRate = INT(name='guaranteedFlowBitRate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'BitRate')))
    _PC5FlowBitRates_maximumFlowBitRate = INT(name='maximumFlowBitRate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'BitRate')))
    _PC5FlowBitRates_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PC5FlowBitRates_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___PC5FlowBitRates_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____PC5FlowBitRates_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____PC5FlowBitRates_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5FlowBitRates_iE_Extensions__item__id._const_tab = ____PC5FlowBitRates_iE_Extensions__item__id_tab
    ___PC5FlowBitRates_iE_Extensions__item__id._const_tab_at = None
    ___PC5FlowBitRates_iE_Extensions__item__id._const_tab_id = 'id'
    ___PC5FlowBitRates_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PC5FlowBitRates_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____PC5FlowBitRates_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5FlowBitRates_iE_Extensions__item__criticality._const_tab = ____PC5FlowBitRates_iE_Extensions__item__criticality_tab
    ___PC5FlowBitRates_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PC5FlowBitRates_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PC5FlowBitRates_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PC5FlowBitRates_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____PC5FlowBitRates_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5FlowBitRates_iE_Extensions__item__extensionValue._const_tab = ____PC5FlowBitRates_iE_Extensions__item__extensionValue_tab
    ___PC5FlowBitRates_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PC5FlowBitRates_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PC5FlowBitRates_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PC5FlowBitRates_iE_Extensions__item__id),
        ('criticality', ___PC5FlowBitRates_iE_Extensions__item__criticality),
        ('extensionValue', ___PC5FlowBitRates_iE_Extensions__item__extensionValue),
        ])
    __PC5FlowBitRates_iE_Extensions__item_._ext = None
    _PC5FlowBitRates_iE_Extensions._cont = __PC5FlowBitRates_iE_Extensions__item_
    _PC5FlowBitRates_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PC5FlowBitRates._cont = ASN1Dict([
        ('guaranteedFlowBitRate', _PC5FlowBitRates_guaranteedFlowBitRate),
        ('maximumFlowBitRate', _PC5FlowBitRates_maximumFlowBitRate),
        ('iE-Extensions', _PC5FlowBitRates_iE_Extensions),
        ])
    PC5FlowBitRates._ext = []
    
    #-----< PC5FlowBitRates-ExtIEs >-----#
    PC5FlowBitRates_ExtIEs = CLASS(name='PC5FlowBitRates-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    PC5FlowBitRates_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDCPChangeIndication >-----#
    PDCPChangeIndication = ENUM(name='PDCPChangeIndication', mode=MODE_TYPE)
    PDCPChangeIndication._cont = ASN1Dict([('s-KgNB-update-required', 0), ('pDCP-data-recovery-required', 1)])
    PDCPChangeIndication._ext = []
    
    #-----< PDCP-SN >-----#
    PDCP_SN = INT(name='PDCP-SN', mode=MODE_TYPE)
    PDCP_SN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    
    #-----< PDCP-SNExtended >-----#
    PDCP_SNExtended = INT(name='PDCP-SNExtended', mode=MODE_TYPE)
    PDCP_SNExtended._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    
    #-----< PDCP-SNlength18 >-----#
    PDCP_SNlength18 = INT(name='PDCP-SNlength18', mode=MODE_TYPE)
    PDCP_SNlength18._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=262143)], ev=None, er=[])
    
    #-----< PDCPSnLength >-----#
    PDCPSnLength = ENUM(name='PDCPSnLength', mode=MODE_TYPE)
    PDCPSnLength._cont = ASN1Dict([('twelve-bits', 0), ('eighteen-bits', 1)])
    PDCPSnLength._ext = []
    
    #-----< PCI >-----#
    PCI = INT(name='PCI', mode=MODE_TYPE)
    PCI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=503)], ev=[], er=[])
    
    #-----< PLMN-Identity >-----#
    PLMN_Identity = OCT_STR(name='PLMN-Identity', mode=MODE_TYPE)
    PLMN_Identity._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< Port-Number >-----#
    Port_Number = OCT_STR(name='Port-Number', mode=MODE_TYPE)
    Port_Number._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< PRACH-Configuration >-----#
    PRACH_Configuration = SEQ(name='PRACH-Configuration', mode=MODE_TYPE)
    _PRACH_Configuration_rootSequenceIndex = INT(name='rootSequenceIndex', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRACH_Configuration_rootSequenceIndex._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=837)], ev=None, er=[])
    _PRACH_Configuration_zeroCorrelationIndex = INT(name='zeroCorrelationIndex', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRACH_Configuration_zeroCorrelationIndex._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    _PRACH_Configuration_highSpeedFlag = BOOL(name='highSpeedFlag', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRACH_Configuration_prach_FreqOffset = INT(name='prach-FreqOffset', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRACH_Configuration_prach_FreqOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=94)], ev=None, er=[])
    _PRACH_Configuration_prach_ConfigIndex = INT(name='prach-ConfigIndex', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PRACH_Configuration_prach_ConfigIndex._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _PRACH_Configuration_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PRACH_Configuration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___PRACH_Configuration_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____PRACH_Configuration_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____PRACH_Configuration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRACH_Configuration_iE_Extensions__item__id._const_tab = ____PRACH_Configuration_iE_Extensions__item__id_tab
    ___PRACH_Configuration_iE_Extensions__item__id._const_tab_at = None
    ___PRACH_Configuration_iE_Extensions__item__id._const_tab_id = 'id'
    ___PRACH_Configuration_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PRACH_Configuration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____PRACH_Configuration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRACH_Configuration_iE_Extensions__item__criticality._const_tab = ____PRACH_Configuration_iE_Extensions__item__criticality_tab
    ___PRACH_Configuration_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PRACH_Configuration_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PRACH_Configuration_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PRACH_Configuration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____PRACH_Configuration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRACH_Configuration_iE_Extensions__item__extensionValue._const_tab = ____PRACH_Configuration_iE_Extensions__item__extensionValue_tab
    ___PRACH_Configuration_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PRACH_Configuration_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PRACH_Configuration_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PRACH_Configuration_iE_Extensions__item__id),
        ('criticality', ___PRACH_Configuration_iE_Extensions__item__criticality),
        ('extensionValue', ___PRACH_Configuration_iE_Extensions__item__extensionValue),
        ])
    __PRACH_Configuration_iE_Extensions__item_._ext = None
    _PRACH_Configuration_iE_Extensions._cont = __PRACH_Configuration_iE_Extensions__item_
    _PRACH_Configuration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PRACH_Configuration._cont = ASN1Dict([
        ('rootSequenceIndex', _PRACH_Configuration_rootSequenceIndex),
        ('zeroCorrelationIndex', _PRACH_Configuration_zeroCorrelationIndex),
        ('highSpeedFlag', _PRACH_Configuration_highSpeedFlag),
        ('prach-FreqOffset', _PRACH_Configuration_prach_FreqOffset),
        ('prach-ConfigIndex', _PRACH_Configuration_prach_ConfigIndex),
        ('iE-Extensions', _PRACH_Configuration_iE_Extensions),
        ])
    PRACH_Configuration._ext = []
    
    #-----< PLMNAreaBasedQMC >-----#
    PLMNAreaBasedQMC = SEQ(name='PLMNAreaBasedQMC', mode=MODE_TYPE)
    _PLMNAreaBasedQMC_plmnListforQMC = SEQ_OF(name='plmnListforQMC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'PLMNListforQMC')))
    _PLMNAreaBasedQMC_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PLMNAreaBasedQMC_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___PLMNAreaBasedQMC_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____PLMNAreaBasedQMC_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____PLMNAreaBasedQMC_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PLMNAreaBasedQMC_iE_Extensions__item__id._const_tab = ____PLMNAreaBasedQMC_iE_Extensions__item__id_tab
    ___PLMNAreaBasedQMC_iE_Extensions__item__id._const_tab_at = None
    ___PLMNAreaBasedQMC_iE_Extensions__item__id._const_tab_id = 'id'
    ___PLMNAreaBasedQMC_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PLMNAreaBasedQMC_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____PLMNAreaBasedQMC_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PLMNAreaBasedQMC_iE_Extensions__item__criticality._const_tab = ____PLMNAreaBasedQMC_iE_Extensions__item__criticality_tab
    ___PLMNAreaBasedQMC_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PLMNAreaBasedQMC_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PLMNAreaBasedQMC_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PLMNAreaBasedQMC_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____PLMNAreaBasedQMC_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PLMNAreaBasedQMC_iE_Extensions__item__extensionValue._const_tab = ____PLMNAreaBasedQMC_iE_Extensions__item__extensionValue_tab
    ___PLMNAreaBasedQMC_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PLMNAreaBasedQMC_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PLMNAreaBasedQMC_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PLMNAreaBasedQMC_iE_Extensions__item__id),
        ('criticality', ___PLMNAreaBasedQMC_iE_Extensions__item__criticality),
        ('extensionValue', ___PLMNAreaBasedQMC_iE_Extensions__item__extensionValue),
        ])
    __PLMNAreaBasedQMC_iE_Extensions__item_._ext = None
    _PLMNAreaBasedQMC_iE_Extensions._cont = __PLMNAreaBasedQMC_iE_Extensions__item_
    _PLMNAreaBasedQMC_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PLMNAreaBasedQMC._cont = ASN1Dict([
        ('plmnListforQMC', _PLMNAreaBasedQMC_plmnListforQMC),
        ('iE-Extensions', _PLMNAreaBasedQMC_iE_Extensions),
        ])
    PLMNAreaBasedQMC._ext = []
    
    #-----< PLMNAreaBasedQMC-ExtIEs >-----#
    PLMNAreaBasedQMC_ExtIEs = CLASS(name='PLMNAreaBasedQMC-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    PLMNAreaBasedQMC_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PLMNListforQMC >-----#
    PLMNListforQMC = SEQ_OF(name='PLMNListforQMC', mode=MODE_TYPE)
    _PLMNListforQMC__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PLMN-Identity')))
    PLMNListforQMC._cont = _PLMNListforQMC__item_
    PLMNListforQMC._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< PRACH-Configuration-ExtIEs >-----#
    PRACH_Configuration_ExtIEs = CLASS(name='PRACH-Configuration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    PRACH_Configuration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Pre-emptionCapability >-----#
    Pre_emptionCapability = ENUM(name='Pre-emptionCapability', mode=MODE_TYPE)
    Pre_emptionCapability._cont = ASN1Dict([('shall-not-trigger-pre-emption', 0), ('may-trigger-pre-emption', 1)])
    Pre_emptionCapability._ext = None
    
    #-----< Pre-emptionVulnerability >-----#
    Pre_emptionVulnerability = ENUM(name='Pre-emptionVulnerability', mode=MODE_TYPE)
    Pre_emptionVulnerability._cont = ASN1Dict([('not-pre-emptable', 0), ('pre-emptable', 1)])
    Pre_emptionVulnerability._ext = None
    
    #-----< PriorityLevel >-----#
    PriorityLevel = INT(name='PriorityLevel', mode=MODE_TYPE)
    PriorityLevel._cont = ASN1Dict([('spare', 0), ('highest', 1), ('lowest', 14), ('no-priority', 15)])
    PriorityLevel._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    
    #-----< ProSeAuthorized >-----#
    ProSeAuthorized = SEQ(name='ProSeAuthorized', mode=MODE_TYPE)
    _ProSeAuthorized_proSeDirectDiscovery = ENUM(name='proSeDirectDiscovery', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ProSeDirectDiscovery')), opt=True)
    _ProSeAuthorized_proSeDirectCommunication = ENUM(name='proSeDirectCommunication', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ProSeDirectCommunication')), opt=True)
    _ProSeAuthorized_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ProSeAuthorized_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___ProSeAuthorized_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____ProSeAuthorized_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____ProSeAuthorized_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ProSeUEtoNetworkRelaying')))
    ____ProSeAuthorized_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 149), ('criticality', 'ignore'), ('Extension', _____ProSeAuthorized_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ProSeAuthorized_iE_Extensions__item__id._const_tab = ____ProSeAuthorized_iE_Extensions__item__id_tab
    ___ProSeAuthorized_iE_Extensions__item__id._const_tab_at = None
    ___ProSeAuthorized_iE_Extensions__item__id._const_tab_id = 'id'
    ___ProSeAuthorized_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___ProSeAuthorized_iE_Extensions__item__criticality._const_tab = ____ProSeAuthorized_iE_Extensions__item__id_tab
    ___ProSeAuthorized_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ProSeAuthorized_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ProSeAuthorized_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___ProSeAuthorized_iE_Extensions__item__extensionValue._const_tab = ____ProSeAuthorized_iE_Extensions__item__id_tab
    ___ProSeAuthorized_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ProSeAuthorized_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ProSeAuthorized_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ProSeAuthorized_iE_Extensions__item__id),
        ('criticality', ___ProSeAuthorized_iE_Extensions__item__criticality),
        ('extensionValue', ___ProSeAuthorized_iE_Extensions__item__extensionValue),
        ])
    __ProSeAuthorized_iE_Extensions__item_._ext = None
    _ProSeAuthorized_iE_Extensions._cont = __ProSeAuthorized_iE_Extensions__item_
    _ProSeAuthorized_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ProSeAuthorized._cont = ASN1Dict([
        ('proSeDirectDiscovery', _ProSeAuthorized_proSeDirectDiscovery),
        ('proSeDirectCommunication', _ProSeAuthorized_proSeDirectCommunication),
        ('iE-Extensions', _ProSeAuthorized_iE_Extensions),
        ])
    ProSeAuthorized._ext = []
    
    #-----< ProSeAuthorized-ExtIEs >-----#
    ProSeAuthorized_ExtIEs = CLASS(name='ProSeAuthorized-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _ProSeAuthorized_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ProSeUEtoNetworkRelaying')))
    ProSeAuthorized_ExtIEs._val = ASN1Set(rv=[dict([('id', 149), ('criticality', 'ignore'), ('Extension', _ProSeAuthorized_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ProSeDirectDiscovery >-----#
    ProSeDirectDiscovery = ENUM(name='ProSeDirectDiscovery', mode=MODE_TYPE)
    ProSeDirectDiscovery._cont = ASN1Dict([('authorized', 0), ('not-authorized', 1)])
    ProSeDirectDiscovery._ext = []
    
    #-----< ProSeDirectCommunication >-----#
    ProSeDirectCommunication = ENUM(name='ProSeDirectCommunication', mode=MODE_TYPE)
    ProSeDirectCommunication._cont = ASN1Dict([('authorized', 0), ('not-authorized', 1)])
    ProSeDirectCommunication._ext = []
    
    #-----< ProSeUEtoNetworkRelaying >-----#
    ProSeUEtoNetworkRelaying = ENUM(name='ProSeUEtoNetworkRelaying', mode=MODE_TYPE)
    ProSeUEtoNetworkRelaying._cont = ASN1Dict([('authorized', 0), ('not-authorized', 1)])
    ProSeUEtoNetworkRelaying._ext = []
    
    #-----< ProtectedEUTRAResourceIndication >-----#
    ProtectedEUTRAResourceIndication = SEQ(name='ProtectedEUTRAResourceIndication', mode=MODE_TYPE)
    _ProtectedEUTRAResourceIndication_activationSFN = INT(name='activationSFN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ProtectedEUTRAResourceIndication_activationSFN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1023)], ev=None, er=[])
    _ProtectedEUTRAResourceIndication_protectedResourceList = SEQ_OF(name='protectedResourceList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ProtectedResourceList')))
    _ProtectedEUTRAResourceIndication_mBSFNControlRegionLength = INT(name='mBSFNControlRegionLength', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ProtectedEUTRAResourceIndication_mBSFNControlRegionLength._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=None, er=[])
    _ProtectedEUTRAResourceIndication_pDCCHRegionLength = INT(name='pDCCHRegionLength', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ProtectedEUTRAResourceIndication_pDCCHRegionLength._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    _ProtectedEUTRAResourceIndication_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ProtectedEUTRAResourceIndication_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___ProtectedEUTRAResourceIndication_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____ProtectedEUTRAResourceIndication_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ProtectedEUTRAResourceIndication_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ProtectedEUTRAResourceIndication_iE_Extensions__item__id._const_tab = ____ProtectedEUTRAResourceIndication_iE_Extensions__item__id_tab
    ___ProtectedEUTRAResourceIndication_iE_Extensions__item__id._const_tab_at = None
    ___ProtectedEUTRAResourceIndication_iE_Extensions__item__id._const_tab_id = 'id'
    ___ProtectedEUTRAResourceIndication_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ProtectedEUTRAResourceIndication_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ProtectedEUTRAResourceIndication_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ProtectedEUTRAResourceIndication_iE_Extensions__item__criticality._const_tab = ____ProtectedEUTRAResourceIndication_iE_Extensions__item__criticality_tab
    ___ProtectedEUTRAResourceIndication_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ProtectedEUTRAResourceIndication_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ProtectedEUTRAResourceIndication_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ProtectedEUTRAResourceIndication_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ProtectedEUTRAResourceIndication_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ProtectedEUTRAResourceIndication_iE_Extensions__item__extensionValue._const_tab = ____ProtectedEUTRAResourceIndication_iE_Extensions__item__extensionValue_tab
    ___ProtectedEUTRAResourceIndication_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ProtectedEUTRAResourceIndication_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ProtectedEUTRAResourceIndication_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ProtectedEUTRAResourceIndication_iE_Extensions__item__id),
        ('criticality', ___ProtectedEUTRAResourceIndication_iE_Extensions__item__criticality),
        ('extensionValue', ___ProtectedEUTRAResourceIndication_iE_Extensions__item__extensionValue),
        ])
    __ProtectedEUTRAResourceIndication_iE_Extensions__item_._ext = None
    _ProtectedEUTRAResourceIndication_iE_Extensions._cont = __ProtectedEUTRAResourceIndication_iE_Extensions__item_
    _ProtectedEUTRAResourceIndication_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ProtectedEUTRAResourceIndication._cont = ASN1Dict([
        ('activationSFN', _ProtectedEUTRAResourceIndication_activationSFN),
        ('protectedResourceList', _ProtectedEUTRAResourceIndication_protectedResourceList),
        ('mBSFNControlRegionLength', _ProtectedEUTRAResourceIndication_mBSFNControlRegionLength),
        ('pDCCHRegionLength', _ProtectedEUTRAResourceIndication_pDCCHRegionLength),
        ('iE-Extensions', _ProtectedEUTRAResourceIndication_iE_Extensions),
        ])
    ProtectedEUTRAResourceIndication._ext = []
    
    #-----< ProtectedEUTRAResourceIndication-ExtIEs >-----#
    ProtectedEUTRAResourceIndication_ExtIEs = CLASS(name='ProtectedEUTRAResourceIndication-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ProtectedEUTRAResourceIndication_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ProtectedFootprintTimePattern >-----#
    ProtectedFootprintTimePattern = SEQ(name='ProtectedFootprintTimePattern', mode=MODE_TYPE)
    _ProtectedFootprintTimePattern_protectedFootprintTimePeriodicity = INT(name='protectedFootprintTimePeriodicity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ProtectedFootprintTimePattern_protectedFootprintTimePeriodicity._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=320)], ev=[], er=[])
    _ProtectedFootprintTimePattern_protectedFootprintStartTime = INT(name='protectedFootprintStartTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ProtectedFootprintTimePattern_protectedFootprintStartTime._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=[], er=[])
    _ProtectedFootprintTimePattern_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ProtectedFootprintTimePattern_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___ProtectedFootprintTimePattern_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____ProtectedFootprintTimePattern_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ProtectedFootprintTimePattern_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ProtectedFootprintTimePattern_iE_Extensions__item__id._const_tab = ____ProtectedFootprintTimePattern_iE_Extensions__item__id_tab
    ___ProtectedFootprintTimePattern_iE_Extensions__item__id._const_tab_at = None
    ___ProtectedFootprintTimePattern_iE_Extensions__item__id._const_tab_id = 'id'
    ___ProtectedFootprintTimePattern_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ProtectedFootprintTimePattern_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ProtectedFootprintTimePattern_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ProtectedFootprintTimePattern_iE_Extensions__item__criticality._const_tab = ____ProtectedFootprintTimePattern_iE_Extensions__item__criticality_tab
    ___ProtectedFootprintTimePattern_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ProtectedFootprintTimePattern_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ProtectedFootprintTimePattern_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ProtectedFootprintTimePattern_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ProtectedFootprintTimePattern_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ProtectedFootprintTimePattern_iE_Extensions__item__extensionValue._const_tab = ____ProtectedFootprintTimePattern_iE_Extensions__item__extensionValue_tab
    ___ProtectedFootprintTimePattern_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ProtectedFootprintTimePattern_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ProtectedFootprintTimePattern_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ProtectedFootprintTimePattern_iE_Extensions__item__id),
        ('criticality', ___ProtectedFootprintTimePattern_iE_Extensions__item__criticality),
        ('extensionValue', ___ProtectedFootprintTimePattern_iE_Extensions__item__extensionValue),
        ])
    __ProtectedFootprintTimePattern_iE_Extensions__item_._ext = None
    _ProtectedFootprintTimePattern_iE_Extensions._cont = __ProtectedFootprintTimePattern_iE_Extensions__item_
    _ProtectedFootprintTimePattern_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ProtectedFootprintTimePattern._cont = ASN1Dict([
        ('protectedFootprintTimePeriodicity', _ProtectedFootprintTimePattern_protectedFootprintTimePeriodicity),
        ('protectedFootprintStartTime', _ProtectedFootprintTimePattern_protectedFootprintStartTime),
        ('iE-Extensions', _ProtectedFootprintTimePattern_iE_Extensions),
        ])
    ProtectedFootprintTimePattern._ext = []
    
    #-----< ProtectedFootprintTimePattern-ExtIEs >-----#
    ProtectedFootprintTimePattern_ExtIEs = CLASS(name='ProtectedFootprintTimePattern-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ProtectedFootprintTimePattern_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ProtectedResourceList >-----#
    ProtectedResourceList = SEQ_OF(name='ProtectedResourceList', mode=MODE_TYPE)
    _ProtectedResourceList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ProtectedResourceList-Item')))
    ProtectedResourceList._cont = _ProtectedResourceList__item_
    ProtectedResourceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< ProtectedResourceList-Item >-----#
    ProtectedResourceList_Item = SEQ(name='ProtectedResourceList-Item', mode=MODE_TYPE)
    _ProtectedResourceList_Item_resourceType = ENUM(name='resourceType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ResourceType')))
    _ProtectedResourceList_Item_intraPRBProtectedResourceFootprint = BIT_STR(name='intraPRBProtectedResourceFootprint', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ProtectedResourceList_Item_intraPRBProtectedResourceFootprint._const_sz = ASN1Set(rv=[84], rr=[], ev=[], er=[])
    _ProtectedResourceList_Item_protectedFootprintFrequencyPattern = BIT_STR(name='protectedFootprintFrequencyPattern', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ProtectedResourceList_Item_protectedFootprintFrequencyPattern._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=6, ub=110)], ev=[], er=[])
    _ProtectedResourceList_Item_protectedFootprintTimePattern = SEQ(name='protectedFootprintTimePattern', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ProtectedFootprintTimePattern')))
    _ProtectedResourceList_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ProtectedResourceList_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___ProtectedResourceList_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____ProtectedResourceList_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ProtectedResourceList_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ProtectedResourceList_Item_iE_Extensions__item__id._const_tab = ____ProtectedResourceList_Item_iE_Extensions__item__id_tab
    ___ProtectedResourceList_Item_iE_Extensions__item__id._const_tab_at = None
    ___ProtectedResourceList_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___ProtectedResourceList_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ProtectedResourceList_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ProtectedResourceList_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ProtectedResourceList_Item_iE_Extensions__item__criticality._const_tab = ____ProtectedResourceList_Item_iE_Extensions__item__criticality_tab
    ___ProtectedResourceList_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ProtectedResourceList_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ProtectedResourceList_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ProtectedResourceList_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ProtectedResourceList_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ProtectedResourceList_Item_iE_Extensions__item__extensionValue._const_tab = ____ProtectedResourceList_Item_iE_Extensions__item__extensionValue_tab
    ___ProtectedResourceList_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ProtectedResourceList_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ProtectedResourceList_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ProtectedResourceList_Item_iE_Extensions__item__id),
        ('criticality', ___ProtectedResourceList_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___ProtectedResourceList_Item_iE_Extensions__item__extensionValue),
        ])
    __ProtectedResourceList_Item_iE_Extensions__item_._ext = None
    _ProtectedResourceList_Item_iE_Extensions._cont = __ProtectedResourceList_Item_iE_Extensions__item_
    _ProtectedResourceList_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ProtectedResourceList_Item._cont = ASN1Dict([
        ('resourceType', _ProtectedResourceList_Item_resourceType),
        ('intraPRBProtectedResourceFootprint', _ProtectedResourceList_Item_intraPRBProtectedResourceFootprint),
        ('protectedFootprintFrequencyPattern', _ProtectedResourceList_Item_protectedFootprintFrequencyPattern),
        ('protectedFootprintTimePattern', _ProtectedResourceList_Item_protectedFootprintTimePattern),
        ('iE-Extensions', _ProtectedResourceList_Item_iE_Extensions),
        ])
    ProtectedResourceList_Item._ext = []
    
    #-----< ProtectedResourceList-Item-ExtIEs >-----#
    ProtectedResourceList_Item_ExtIEs = CLASS(name='ProtectedResourceList-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ProtectedResourceList_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PartialListIndicator >-----#
    PartialListIndicator = ENUM(name='PartialListIndicator', mode=MODE_TYPE)
    PartialListIndicator._cont = ASN1Dict([('partial', 0)])
    PartialListIndicator._ext = []
    
    #-----< PrivacyIndicator >-----#
    PrivacyIndicator = ENUM(name='PrivacyIndicator', mode=MODE_TYPE)
    PrivacyIndicator._cont = ASN1Dict([('immediate-MDT', 0), ('logged-MDT', 1)])
    PrivacyIndicator._ext = []
    
    #-----< PSCellHistoryInformationRetrieve >-----#
    PSCellHistoryInformationRetrieve = ENUM(name='PSCellHistoryInformationRetrieve', mode=MODE_TYPE)
    PSCellHistoryInformationRetrieve._cont = ASN1Dict([('query', 0)])
    PSCellHistoryInformationRetrieve._ext = []
    
    #-----< PSCell-UE-HistoryInformation >-----#
    PSCell_UE_HistoryInformation = SEQ_OF(name='PSCell-UE-HistoryInformation', mode=MODE_TYPE)
    _PSCell_UE_HistoryInformation__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'LastVisitedPSCell-Item')))
    PSCell_UE_HistoryInformation._cont = _PSCell_UE_HistoryInformation__item_
    PSCell_UE_HistoryInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< PSCellChangeHistory >-----#
    PSCellChangeHistory = ENUM(name='PSCellChangeHistory', mode=MODE_TYPE)
    PSCellChangeHistory._cont = ASN1Dict([('reportingFullHistory', 0)])
    PSCellChangeHistory._ext = []
    
    #-----< QCI >-----#
    QCI = INT(name='QCI', mode=MODE_TYPE)
    QCI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< QoS-Mapping-Information >-----#
    QoS_Mapping_Information = SEQ(name='QoS-Mapping-Information', mode=MODE_TYPE)
    _QoS_Mapping_Information_dscp = BIT_STR(name='dscp', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _QoS_Mapping_Information_dscp._const_sz = ASN1Set(rv=[6], rr=[], ev=None, er=[])
    _QoS_Mapping_Information_flow_label = BIT_STR(name='flow-label', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _QoS_Mapping_Information_flow_label._const_sz = ASN1Set(rv=[20], rr=[], ev=None, er=[])
    _QoS_Mapping_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __QoS_Mapping_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___QoS_Mapping_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____QoS_Mapping_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____QoS_Mapping_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QoS_Mapping_Information_iE_Extensions__item__id._const_tab = ____QoS_Mapping_Information_iE_Extensions__item__id_tab
    ___QoS_Mapping_Information_iE_Extensions__item__id._const_tab_at = None
    ___QoS_Mapping_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___QoS_Mapping_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____QoS_Mapping_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____QoS_Mapping_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QoS_Mapping_Information_iE_Extensions__item__criticality._const_tab = ____QoS_Mapping_Information_iE_Extensions__item__criticality_tab
    ___QoS_Mapping_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___QoS_Mapping_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___QoS_Mapping_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____QoS_Mapping_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____QoS_Mapping_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QoS_Mapping_Information_iE_Extensions__item__extensionValue._const_tab = ____QoS_Mapping_Information_iE_Extensions__item__extensionValue_tab
    ___QoS_Mapping_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___QoS_Mapping_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __QoS_Mapping_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___QoS_Mapping_Information_iE_Extensions__item__id),
        ('criticality', ___QoS_Mapping_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___QoS_Mapping_Information_iE_Extensions__item__extensionValue),
        ])
    __QoS_Mapping_Information_iE_Extensions__item_._ext = None
    _QoS_Mapping_Information_iE_Extensions._cont = __QoS_Mapping_Information_iE_Extensions__item_
    _QoS_Mapping_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    QoS_Mapping_Information._cont = ASN1Dict([
        ('dscp', _QoS_Mapping_Information_dscp),
        ('flow-label', _QoS_Mapping_Information_flow_label),
        ('iE-Extensions', _QoS_Mapping_Information_iE_Extensions),
        ])
    QoS_Mapping_Information._ext = []
    
    #-----< QoS-Mapping-Information-ExtIEs >-----#
    QoS_Mapping_Information_ExtIEs = CLASS(name='QoS-Mapping-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    QoS_Mapping_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RadioframeAllocationOffset >-----#
    RadioframeAllocationOffset = INT(name='RadioframeAllocationOffset', mode=MODE_TYPE)
    RadioframeAllocationOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=[], er=[])
    
    #-----< RadioframeAllocationPeriod >-----#
    RadioframeAllocationPeriod = ENUM(name='RadioframeAllocationPeriod', mode=MODE_TYPE)
    RadioframeAllocationPeriod._cont = ASN1Dict([('n1', 0), ('n2', 1), ('n4', 2), ('n8', 3), ('n16', 4), ('n32', 5)])
    RadioframeAllocationPeriod._ext = []
    
    #-----< RadioResourceStatus >-----#
    RadioResourceStatus = SEQ(name='RadioResourceStatus', mode=MODE_TYPE)
    _RadioResourceStatus_dL_GBR_PRB_usage = INT(name='dL-GBR-PRB-usage', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'DL-GBR-PRB-usage')))
    _RadioResourceStatus_uL_GBR_PRB_usage = INT(name='uL-GBR-PRB-usage', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'UL-GBR-PRB-usage')))
    _RadioResourceStatus_dL_non_GBR_PRB_usage = INT(name='dL-non-GBR-PRB-usage', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'DL-non-GBR-PRB-usage')))
    _RadioResourceStatus_uL_non_GBR_PRB_usage = INT(name='uL-non-GBR-PRB-usage', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'UL-non-GBR-PRB-usage')))
    _RadioResourceStatus_dL_Total_PRB_usage = INT(name='dL-Total-PRB-usage', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'DL-Total-PRB-usage')))
    _RadioResourceStatus_uL_Total_PRB_usage = INT(name='uL-Total-PRB-usage', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'UL-Total-PRB-usage')))
    _RadioResourceStatus_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RadioResourceStatus_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___RadioResourceStatus_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____RadioResourceStatus_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____RadioResourceStatus_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'DL-scheduling-PDCCH-CCE-usage')))
    _____RadioResourceStatus_iE_Extensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UL-scheduling-PDCCH-CCE-usage')))
    ____RadioResourceStatus_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 193), ('criticality', 'ignore'), ('Extension', _____RadioResourceStatus_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 194), ('criticality', 'ignore'), ('Extension', _____RadioResourceStatus_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RadioResourceStatus_iE_Extensions__item__id._const_tab = ____RadioResourceStatus_iE_Extensions__item__id_tab
    ___RadioResourceStatus_iE_Extensions__item__id._const_tab_at = None
    ___RadioResourceStatus_iE_Extensions__item__id._const_tab_id = 'id'
    ___RadioResourceStatus_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RadioResourceStatus_iE_Extensions__item__criticality._const_tab = ____RadioResourceStatus_iE_Extensions__item__id_tab
    ___RadioResourceStatus_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RadioResourceStatus_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RadioResourceStatus_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RadioResourceStatus_iE_Extensions__item__extensionValue._const_tab = ____RadioResourceStatus_iE_Extensions__item__id_tab
    ___RadioResourceStatus_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RadioResourceStatus_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RadioResourceStatus_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RadioResourceStatus_iE_Extensions__item__id),
        ('criticality', ___RadioResourceStatus_iE_Extensions__item__criticality),
        ('extensionValue', ___RadioResourceStatus_iE_Extensions__item__extensionValue),
        ])
    __RadioResourceStatus_iE_Extensions__item_._ext = None
    _RadioResourceStatus_iE_Extensions._cont = __RadioResourceStatus_iE_Extensions__item_
    _RadioResourceStatus_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RadioResourceStatus._cont = ASN1Dict([
        ('dL-GBR-PRB-usage', _RadioResourceStatus_dL_GBR_PRB_usage),
        ('uL-GBR-PRB-usage', _RadioResourceStatus_uL_GBR_PRB_usage),
        ('dL-non-GBR-PRB-usage', _RadioResourceStatus_dL_non_GBR_PRB_usage),
        ('uL-non-GBR-PRB-usage', _RadioResourceStatus_uL_non_GBR_PRB_usage),
        ('dL-Total-PRB-usage', _RadioResourceStatus_dL_Total_PRB_usage),
        ('uL-Total-PRB-usage', _RadioResourceStatus_uL_Total_PRB_usage),
        ('iE-Extensions', _RadioResourceStatus_iE_Extensions),
        ])
    RadioResourceStatus._ext = []
    
    #-----< RadioResourceStatus-ExtIEs >-----#
    RadioResourceStatus_ExtIEs = CLASS(name='RadioResourceStatus-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _RadioResourceStatus_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'DL-scheduling-PDCCH-CCE-usage')))
    _RadioResourceStatus_ExtIEs_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UL-scheduling-PDCCH-CCE-usage')))
    RadioResourceStatus_ExtIEs._val = ASN1Set(rv=[dict([('id', 193), ('criticality', 'ignore'), ('Extension', _RadioResourceStatus_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 194), ('criticality', 'ignore'), ('Extension', _RadioResourceStatus_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Range >-----#
    Range = ENUM(name='Range', mode=MODE_TYPE)
    Range._cont = ASN1Dict([('m50', 0), ('m80', 1), ('m180', 2), ('m200', 3), ('m350', 4), ('m400', 5), ('m500', 6), ('m700', 7), ('m1000', 8)])
    Range._ext = []
    
    #-----< RAN-UE-NGAP-ID >-----#
    RAN_UE_NGAP_ID = INT(name='RAN-UE-NGAP-ID', mode=MODE_TYPE)
    RAN_UE_NGAP_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    
    #-----< RAT-Restrictions >-----#
    RAT_Restrictions = SEQ_OF(name='RAT-Restrictions', mode=MODE_TYPE)
    _RAT_Restrictions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'RAT-RestrictionsItem')))
    RAT_Restrictions._cont = _RAT_Restrictions__item_
    RAT_Restrictions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< RAT-RestrictionsItem >-----#
    RAT_RestrictionsItem = SEQ(name='RAT-RestrictionsItem', mode=MODE_TYPE)
    _RAT_RestrictionsItem_pLMN_Identity = OCT_STR(name='pLMN-Identity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'PLMN-Identity')))
    _RAT_RestrictionsItem_rAT_RestrictionInformation = BIT_STR(name='rAT-RestrictionInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RAT_RestrictionsItem_rAT_RestrictionInformation._const_sz = ASN1Set(rv=[8], rr=[], ev=[], er=[])
    _RAT_RestrictionsItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RAT_RestrictionsItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___RAT_RestrictionsItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____RAT_RestrictionsItem_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____RAT_RestrictionsItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAT_RestrictionsItem_iE_Extensions__item__id._const_tab = ____RAT_RestrictionsItem_iE_Extensions__item__id_tab
    ___RAT_RestrictionsItem_iE_Extensions__item__id._const_tab_at = None
    ___RAT_RestrictionsItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___RAT_RestrictionsItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RAT_RestrictionsItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____RAT_RestrictionsItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAT_RestrictionsItem_iE_Extensions__item__criticality._const_tab = ____RAT_RestrictionsItem_iE_Extensions__item__criticality_tab
    ___RAT_RestrictionsItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RAT_RestrictionsItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RAT_RestrictionsItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RAT_RestrictionsItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____RAT_RestrictionsItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAT_RestrictionsItem_iE_Extensions__item__extensionValue._const_tab = ____RAT_RestrictionsItem_iE_Extensions__item__extensionValue_tab
    ___RAT_RestrictionsItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RAT_RestrictionsItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RAT_RestrictionsItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RAT_RestrictionsItem_iE_Extensions__item__id),
        ('criticality', ___RAT_RestrictionsItem_iE_Extensions__item__criticality),
        ('extensionValue', ___RAT_RestrictionsItem_iE_Extensions__item__extensionValue),
        ])
    __RAT_RestrictionsItem_iE_Extensions__item_._ext = None
    _RAT_RestrictionsItem_iE_Extensions._cont = __RAT_RestrictionsItem_iE_Extensions__item_
    _RAT_RestrictionsItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RAT_RestrictionsItem._cont = ASN1Dict([
        ('pLMN-Identity', _RAT_RestrictionsItem_pLMN_Identity),
        ('rAT-RestrictionInformation', _RAT_RestrictionsItem_rAT_RestrictionInformation),
        ('iE-Extensions', _RAT_RestrictionsItem_iE_Extensions),
        ])
    RAT_RestrictionsItem._ext = []
    
    #-----< RAT-RestrictionsItem-ExtIEs >-----#
    RAT_RestrictionsItem_ExtIEs = CLASS(name='RAT-RestrictionsItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    RAT_RestrictionsItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ReceiveStatusofULPDCPSDUs >-----#
    ReceiveStatusofULPDCPSDUs = BIT_STR(name='ReceiveStatusofULPDCPSDUs', mode=MODE_TYPE)
    ReceiveStatusofULPDCPSDUs._const_sz = ASN1Set(rv=[4096], rr=[], ev=None, er=[])
    
    #-----< ReceiveStatusOfULPDCPSDUsExtended >-----#
    ReceiveStatusOfULPDCPSDUsExtended = BIT_STR(name='ReceiveStatusOfULPDCPSDUsExtended', mode=MODE_TYPE)
    ReceiveStatusOfULPDCPSDUsExtended._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16384)], ev=None, er=[])
    
    #-----< ReceiveStatusOfULPDCPSDUsPDCP-SNlength18 >-----#
    ReceiveStatusOfULPDCPSDUsPDCP_SNlength18 = BIT_STR(name='ReceiveStatusOfULPDCPSDUsPDCP-SNlength18', mode=MODE_TYPE)
    ReceiveStatusOfULPDCPSDUsPDCP_SNlength18._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=131072)], ev=None, er=[])
    
    #-----< ReleaseFastMCGRecoveryViaSRB3 >-----#
    ReleaseFastMCGRecoveryViaSRB3 = ENUM(name='ReleaseFastMCGRecoveryViaSRB3', mode=MODE_TYPE)
    ReleaseFastMCGRecoveryViaSRB3._cont = ASN1Dict([('true', 0)])
    ReleaseFastMCGRecoveryViaSRB3._ext = []
    
    #-----< Reestablishment-Indication >-----#
    Reestablishment_Indication = ENUM(name='Reestablishment-Indication', mode=MODE_TYPE)
    Reestablishment_Indication._cont = ASN1Dict([('reestablished', 0)])
    Reestablishment_Indication._ext = []
    
    #-----< Registration-Request >-----#
    Registration_Request = ENUM(name='Registration-Request', mode=MODE_TYPE)
    Registration_Request._cont = ASN1Dict([('start', 0), ('stop', 1), ('partial-stop', 2), ('add', 3)])
    Registration_Request._ext = ['partial-stop', 'add']
    
    #-----< Registration-Request-ENDC >-----#
    Registration_Request_ENDC = ENUM(name='Registration-Request-ENDC', mode=MODE_TYPE)
    Registration_Request_ENDC._cont = ASN1Dict([('start', 0), ('stop', 1), ('add', 2)])
    Registration_Request_ENDC._ext = []
    
    #-----< RelativeNarrowbandTxPower >-----#
    RelativeNarrowbandTxPower = SEQ(name='RelativeNarrowbandTxPower', mode=MODE_TYPE)
    _RelativeNarrowbandTxPower_rNTP_PerPRB = BIT_STR(name='rNTP-PerPRB', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RelativeNarrowbandTxPower_rNTP_PerPRB._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=6, ub=110)], ev=[], er=[])
    _RelativeNarrowbandTxPower_rNTP_Threshold = ENUM(name='rNTP-Threshold', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'RNTP-Threshold')))
    _RelativeNarrowbandTxPower_numberOfCellSpecificAntennaPorts = ENUM(name='numberOfCellSpecificAntennaPorts', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RelativeNarrowbandTxPower_numberOfCellSpecificAntennaPorts._cont = ASN1Dict([('one', 0), ('two', 1), ('four', 2)])
    _RelativeNarrowbandTxPower_numberOfCellSpecificAntennaPorts._ext = []
    _RelativeNarrowbandTxPower_p_B = INT(name='p-B', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RelativeNarrowbandTxPower_p_B._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=[], er=[])
    _RelativeNarrowbandTxPower_pDCCH_InterferenceImpact = INT(name='pDCCH-InterferenceImpact', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RelativeNarrowbandTxPower_pDCCH_InterferenceImpact._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4)], ev=[], er=[])
    _RelativeNarrowbandTxPower_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RelativeNarrowbandTxPower_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___RelativeNarrowbandTxPower_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____RelativeNarrowbandTxPower_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____RelativeNarrowbandTxPower_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'EnhancedRNTP')))
    ____RelativeNarrowbandTxPower_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 148), ('criticality', 'ignore'), ('Extension', _____RelativeNarrowbandTxPower_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RelativeNarrowbandTxPower_iE_Extensions__item__id._const_tab = ____RelativeNarrowbandTxPower_iE_Extensions__item__id_tab
    ___RelativeNarrowbandTxPower_iE_Extensions__item__id._const_tab_at = None
    ___RelativeNarrowbandTxPower_iE_Extensions__item__id._const_tab_id = 'id'
    ___RelativeNarrowbandTxPower_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RelativeNarrowbandTxPower_iE_Extensions__item__criticality._const_tab = ____RelativeNarrowbandTxPower_iE_Extensions__item__id_tab
    ___RelativeNarrowbandTxPower_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RelativeNarrowbandTxPower_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RelativeNarrowbandTxPower_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RelativeNarrowbandTxPower_iE_Extensions__item__extensionValue._const_tab = ____RelativeNarrowbandTxPower_iE_Extensions__item__id_tab
    ___RelativeNarrowbandTxPower_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RelativeNarrowbandTxPower_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RelativeNarrowbandTxPower_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RelativeNarrowbandTxPower_iE_Extensions__item__id),
        ('criticality', ___RelativeNarrowbandTxPower_iE_Extensions__item__criticality),
        ('extensionValue', ___RelativeNarrowbandTxPower_iE_Extensions__item__extensionValue),
        ])
    __RelativeNarrowbandTxPower_iE_Extensions__item_._ext = None
    _RelativeNarrowbandTxPower_iE_Extensions._cont = __RelativeNarrowbandTxPower_iE_Extensions__item_
    _RelativeNarrowbandTxPower_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RelativeNarrowbandTxPower._cont = ASN1Dict([
        ('rNTP-PerPRB', _RelativeNarrowbandTxPower_rNTP_PerPRB),
        ('rNTP-Threshold', _RelativeNarrowbandTxPower_rNTP_Threshold),
        ('numberOfCellSpecificAntennaPorts', _RelativeNarrowbandTxPower_numberOfCellSpecificAntennaPorts),
        ('p-B', _RelativeNarrowbandTxPower_p_B),
        ('pDCCH-InterferenceImpact', _RelativeNarrowbandTxPower_pDCCH_InterferenceImpact),
        ('iE-Extensions', _RelativeNarrowbandTxPower_iE_Extensions),
        ])
    RelativeNarrowbandTxPower._ext = []
    
    #-----< RelativeNarrowbandTxPower-ExtIEs >-----#
    RelativeNarrowbandTxPower_ExtIEs = CLASS(name='RelativeNarrowbandTxPower-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _RelativeNarrowbandTxPower_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'EnhancedRNTP')))
    RelativeNarrowbandTxPower_ExtIEs._val = ASN1Set(rv=[dict([('id', 148), ('criticality', 'ignore'), ('Extension', _RelativeNarrowbandTxPower_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ReplacingCellsList >-----#
    ReplacingCellsList = SEQ_OF(name='ReplacingCellsList', mode=MODE_TYPE)
    _ReplacingCellsList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ReplacingCellsList-Item')))
    ReplacingCellsList._cont = _ReplacingCellsList__item_
    ReplacingCellsList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=256)], ev=None, er=[])
    
    #-----< ReplacingCellsList-Item >-----#
    ReplacingCellsList_Item = SEQ(name='ReplacingCellsList-Item', mode=MODE_TYPE)
    _ReplacingCellsList_Item_eCGI = SEQ(name='eCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    ReplacingCellsList_Item._cont = ASN1Dict([
        ('eCGI', _ReplacingCellsList_Item_eCGI),
        ])
    ReplacingCellsList_Item._ext = []
    
    #-----< ReportAmountMDT >-----#
    ReportAmountMDT = ENUM(name='ReportAmountMDT', mode=MODE_TYPE)
    ReportAmountMDT._cont = ASN1Dict([('r1', 0), ('r2', 1), ('r4', 2), ('r8', 3), ('r16', 4), ('r32', 5), ('r64', 6), ('rinfinity', 7)])
    ReportAmountMDT._ext = None
    
    #-----< ReportArea >-----#
    ReportArea = ENUM(name='ReportArea', mode=MODE_TYPE)
    ReportArea._cont = ASN1Dict([('ecgi', 0)])
    ReportArea._ext = []
    
    #-----< ReportCharacteristics >-----#
    ReportCharacteristics = BIT_STR(name='ReportCharacteristics', mode=MODE_TYPE)
    ReportCharacteristics._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    
    #-----< ReportingPeriodicityCSIR >-----#
    ReportingPeriodicityCSIR = ENUM(name='ReportingPeriodicityCSIR', mode=MODE_TYPE)
    ReportingPeriodicityCSIR._cont = ASN1Dict([('ms5', 0), ('ms10', 1), ('ms20', 2), ('ms40', 3), ('ms80', 4)])
    ReportingPeriodicityCSIR._ext = []
    
    #-----< ReportCharacteristics-ENDC >-----#
    ReportCharacteristics_ENDC = BIT_STR(name='ReportCharacteristics-ENDC', mode=MODE_TYPE)
    ReportCharacteristics_ENDC._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    
    #-----< ReportingPeriodicityRSRPMR >-----#
    ReportingPeriodicityRSRPMR = ENUM(name='ReportingPeriodicityRSRPMR', mode=MODE_TYPE)
    ReportingPeriodicityRSRPMR._cont = ASN1Dict([('one-hundred-20-ms', 0), ('two-hundred-40-ms', 1), ('four-hundred-80-ms', 2), ('six-hundred-40-ms', 3)])
    ReportingPeriodicityRSRPMR._ext = []
    
    #-----< ReportIntervalMDT >-----#
    ReportIntervalMDT = ENUM(name='ReportIntervalMDT', mode=MODE_TYPE)
    ReportIntervalMDT._cont = ASN1Dict([('ms120', 0), ('ms240', 1), ('ms480', 2), ('ms640', 3), ('ms1024', 4), ('ms2048', 5), ('ms5120', 6), ('ms10240', 7), ('min1', 8), ('min6', 9), ('min12', 10), ('min30', 11), ('min60', 12)])
    ReportIntervalMDT._ext = None
    
    #-----< RequestedFastMCGRecoveryViaSRB3 >-----#
    RequestedFastMCGRecoveryViaSRB3 = ENUM(name='RequestedFastMCGRecoveryViaSRB3', mode=MODE_TYPE)
    RequestedFastMCGRecoveryViaSRB3._cont = ASN1Dict([('true', 0)])
    RequestedFastMCGRecoveryViaSRB3._ext = []
    
    #-----< RequestedFastMCGRecoveryViaSRB3Release >-----#
    RequestedFastMCGRecoveryViaSRB3Release = ENUM(name='RequestedFastMCGRecoveryViaSRB3Release', mode=MODE_TYPE)
    RequestedFastMCGRecoveryViaSRB3Release._cont = ASN1Dict([('true', 0)])
    RequestedFastMCGRecoveryViaSRB3Release._ext = []
    
    #-----< ReservedSubframePattern >-----#
    ReservedSubframePattern = SEQ(name='ReservedSubframePattern', mode=MODE_TYPE)
    _ReservedSubframePattern_subframeType = ENUM(name='subframeType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'SubframeType')))
    _ReservedSubframePattern_reservedSubframePattern = BIT_STR(name='reservedSubframePattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ReservedSubframePattern_reservedSubframePattern._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=10, ub=160)], ev=None, er=[])
    _ReservedSubframePattern_mBSFNControlRegionLength = INT(name='mBSFNControlRegionLength', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ReservedSubframePattern_mBSFNControlRegionLength._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=None, er=[])
    _ReservedSubframePattern_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ReservedSubframePattern_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___ReservedSubframePattern_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____ReservedSubframePattern_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ReservedSubframePattern_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ReservedSubframePattern_iE_Extensions__item__id._const_tab = ____ReservedSubframePattern_iE_Extensions__item__id_tab
    ___ReservedSubframePattern_iE_Extensions__item__id._const_tab_at = None
    ___ReservedSubframePattern_iE_Extensions__item__id._const_tab_id = 'id'
    ___ReservedSubframePattern_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ReservedSubframePattern_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ReservedSubframePattern_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ReservedSubframePattern_iE_Extensions__item__criticality._const_tab = ____ReservedSubframePattern_iE_Extensions__item__criticality_tab
    ___ReservedSubframePattern_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ReservedSubframePattern_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ReservedSubframePattern_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ReservedSubframePattern_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ReservedSubframePattern_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ReservedSubframePattern_iE_Extensions__item__extensionValue._const_tab = ____ReservedSubframePattern_iE_Extensions__item__extensionValue_tab
    ___ReservedSubframePattern_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ReservedSubframePattern_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ReservedSubframePattern_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ReservedSubframePattern_iE_Extensions__item__id),
        ('criticality', ___ReservedSubframePattern_iE_Extensions__item__criticality),
        ('extensionValue', ___ReservedSubframePattern_iE_Extensions__item__extensionValue),
        ])
    __ReservedSubframePattern_iE_Extensions__item_._ext = None
    _ReservedSubframePattern_iE_Extensions._cont = __ReservedSubframePattern_iE_Extensions__item_
    _ReservedSubframePattern_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ReservedSubframePattern._cont = ASN1Dict([
        ('subframeType', _ReservedSubframePattern_subframeType),
        ('reservedSubframePattern', _ReservedSubframePattern_reservedSubframePattern),
        ('mBSFNControlRegionLength', _ReservedSubframePattern_mBSFNControlRegionLength),
        ('iE-Extensions', _ReservedSubframePattern_iE_Extensions),
        ])
    ReservedSubframePattern._ext = []
    
    #-----< ReservedSubframePattern-ExtIEs >-----#
    ReservedSubframePattern_ExtIEs = CLASS(name='ReservedSubframePattern-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ReservedSubframePattern_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResourceType >-----#
    ResourceType = ENUM(name='ResourceType', mode=MODE_TYPE)
    ResourceType._cont = ASN1Dict([('downlinknonCRS', 0), ('cRS', 1), ('uplink', 2)])
    ResourceType._ext = []
    
    #-----< ResumeID >-----#
    ResumeID = CHOICE(name='ResumeID', mode=MODE_TYPE)
    _ResumeID_non_truncated = BIT_STR(name='non-truncated', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResumeID_non_truncated._const_sz = ASN1Set(rv=[40], rr=[], ev=None, er=[])
    _ResumeID_truncated = BIT_STR(name='truncated', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResumeID_truncated._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    ResumeID._cont = ASN1Dict([
        ('non-truncated', _ResumeID_non_truncated),
        ('truncated', _ResumeID_truncated),
        ])
    ResumeID._ext = []
    
    #-----< RLCMode >-----#
    RLCMode = ENUM(name='RLCMode', mode=MODE_TYPE)
    RLCMode._cont = ASN1Dict([('rlc-am', 0), ('rlc-um-bidirectional', 1), ('rlc-um-unidirectional-ul', 2), ('rlc-um-unidirectional-dl', 3)])
    RLCMode._ext = []
    
    #-----< RLC-Status >-----#
    RLC_Status = SEQ(name='RLC-Status', mode=MODE_TYPE)
    _RLC_Status_reestablishment_Indication = ENUM(name='reestablishment-Indication', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'Reestablishment-Indication')))
    _RLC_Status_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RLC_Status_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___RLC_Status_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____RLC_Status_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____RLC_Status_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RLC_Status_iE_Extensions__item__id._const_tab = ____RLC_Status_iE_Extensions__item__id_tab
    ___RLC_Status_iE_Extensions__item__id._const_tab_at = None
    ___RLC_Status_iE_Extensions__item__id._const_tab_id = 'id'
    ___RLC_Status_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RLC_Status_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____RLC_Status_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RLC_Status_iE_Extensions__item__criticality._const_tab = ____RLC_Status_iE_Extensions__item__criticality_tab
    ___RLC_Status_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RLC_Status_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RLC_Status_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RLC_Status_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____RLC_Status_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RLC_Status_iE_Extensions__item__extensionValue._const_tab = ____RLC_Status_iE_Extensions__item__extensionValue_tab
    ___RLC_Status_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RLC_Status_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RLC_Status_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RLC_Status_iE_Extensions__item__id),
        ('criticality', ___RLC_Status_iE_Extensions__item__criticality),
        ('extensionValue', ___RLC_Status_iE_Extensions__item__extensionValue),
        ])
    __RLC_Status_iE_Extensions__item_._ext = None
    _RLC_Status_iE_Extensions._cont = __RLC_Status_iE_Extensions__item_
    _RLC_Status_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RLC_Status._cont = ASN1Dict([
        ('reestablishment-Indication', _RLC_Status_reestablishment_Indication),
        ('iE-Extensions', _RLC_Status_iE_Extensions),
        ])
    RLC_Status._ext = []
    
    #-----< RLC-Status-ExtIEs >-----#
    RLC_Status_ExtIEs = CLASS(name='RLC-Status-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    RLC_Status_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RNTP-Threshold >-----#
    RNTP_Threshold = ENUM(name='RNTP-Threshold', mode=MODE_TYPE)
    RNTP_Threshold._cont = ASN1Dict([('minusInfinity', 0), ('minusEleven', 1), ('minusTen', 2), ('minusNine', 3), ('minusEight', 4), ('minusSeven', 5), ('minusSix', 6), ('minusFive', 7), ('minusFour', 8), ('minusThree', 9), ('minusTwo', 10), ('minusOne', 11), ('zero', 12), ('one', 13), ('two', 14), ('three', 15)])
    RNTP_Threshold._ext = []
    
    #-----< RRC-Config-Ind >-----#
    RRC_Config_Ind = ENUM(name='RRC-Config-Ind', mode=MODE_TYPE)
    RRC_Config_Ind._cont = ASN1Dict([('full-config', 0), ('delta-config', 1)])
    RRC_Config_Ind._ext = []
    
    #-----< RRC-Context >-----#
    RRC_Context = OCT_STR(name='RRC-Context', mode=MODE_TYPE)
    
    #-----< RRCConnReestabIndicator >-----#
    RRCConnReestabIndicator = ENUM(name='RRCConnReestabIndicator', mode=MODE_TYPE)
    RRCConnReestabIndicator._cont = ASN1Dict([('reconfigurationFailure', 0), ('handoverFailure', 1), ('otherFailure', 2)])
    RRCConnReestabIndicator._ext = []
    
    #-----< RRCConnSetupIndicator >-----#
    RRCConnSetupIndicator = ENUM(name='RRCConnSetupIndicator', mode=MODE_TYPE)
    RRCConnSetupIndicator._cont = ASN1Dict([('rrcConnSetup', 0)])
    RRCConnSetupIndicator._ext = []
    
    #-----< RSRPMeasurementResult >-----#
    RSRPMeasurementResult = SEQ_OF(name='RSRPMeasurementResult', mode=MODE_TYPE)
    _RSRPMeasurementResult__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __RSRPMeasurementResult__item__rSRPCellID = SEQ(name='rSRPCellID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    __RSRPMeasurementResult__item__rSRPMeasured = INT(name='rSRPMeasured', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __RSRPMeasurementResult__item__rSRPMeasured._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=97)], ev=[], er=[])
    __RSRPMeasurementResult__item__iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___RSRPMeasurementResult__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ____RSRPMeasurementResult__item__iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    _____RSRPMeasurementResult__item__iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____RSRPMeasurementResult__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____RSRPMeasurementResult__item__iE_Extensions__item__id._const_tab = _____RSRPMeasurementResult__item__iE_Extensions__item__id_tab
    ____RSRPMeasurementResult__item__iE_Extensions__item__id._const_tab_at = None
    ____RSRPMeasurementResult__item__iE_Extensions__item__id._const_tab_id = 'id'
    ____RSRPMeasurementResult__item__iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    _____RSRPMeasurementResult__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____RSRPMeasurementResult__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____RSRPMeasurementResult__item__iE_Extensions__item__criticality._const_tab = _____RSRPMeasurementResult__item__iE_Extensions__item__criticality_tab
    ____RSRPMeasurementResult__item__iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____RSRPMeasurementResult__item__iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____RSRPMeasurementResult__item__iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    _____RSRPMeasurementResult__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____RSRPMeasurementResult__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____RSRPMeasurementResult__item__iE_Extensions__item__extensionValue._const_tab = _____RSRPMeasurementResult__item__iE_Extensions__item__extensionValue_tab
    ____RSRPMeasurementResult__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____RSRPMeasurementResult__item__iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___RSRPMeasurementResult__item__iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____RSRPMeasurementResult__item__iE_Extensions__item__id),
        ('criticality', ____RSRPMeasurementResult__item__iE_Extensions__item__criticality),
        ('extensionValue', ____RSRPMeasurementResult__item__iE_Extensions__item__extensionValue),
        ])
    ___RSRPMeasurementResult__item__iE_Extensions__item_._ext = None
    __RSRPMeasurementResult__item__iE_Extensions._cont = ___RSRPMeasurementResult__item__iE_Extensions__item_
    __RSRPMeasurementResult__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _RSRPMeasurementResult__item_._cont = ASN1Dict([
        ('rSRPCellID', __RSRPMeasurementResult__item__rSRPCellID),
        ('rSRPMeasured', __RSRPMeasurementResult__item__rSRPMeasured),
        ('iE-Extensions', __RSRPMeasurementResult__item__iE_Extensions),
        ])
    _RSRPMeasurementResult__item_._ext = []
    RSRPMeasurementResult._cont = _RSRPMeasurementResult__item_
    RSRPMeasurementResult._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=9)], ev=None, er=[])
    
    #-----< RSRPMeasurementResult-ExtIEs >-----#
    RSRPMeasurementResult_ExtIEs = CLASS(name='RSRPMeasurementResult-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    RSRPMeasurementResult_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RSRPMRList >-----#
    RSRPMRList = SEQ_OF(name='RSRPMRList', mode=MODE_TYPE)
    _RSRPMRList__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __RSRPMRList__item__rSRPMeasurementResult = SEQ_OF(name='rSRPMeasurementResult', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'RSRPMeasurementResult')))
    __RSRPMRList__item__iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___RSRPMRList__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ____RSRPMRList__item__iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    _____RSRPMRList__item__iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ______RSRPMRList__item__iE_Extensions__item__id_tab_val_Extension_0 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UEID')))
    _____RSRPMRList__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 147), ('criticality', 'ignore'), ('Extension', ______RSRPMRList__item__iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ____RSRPMRList__item__iE_Extensions__item__id._const_tab = _____RSRPMRList__item__iE_Extensions__item__id_tab
    ____RSRPMRList__item__iE_Extensions__item__id._const_tab_at = None
    ____RSRPMRList__item__iE_Extensions__item__id._const_tab_id = 'id'
    ____RSRPMRList__item__iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RSRPMRList__item__iE_Extensions__item__criticality._const_tab = _____RSRPMRList__item__iE_Extensions__item__id_tab
    ____RSRPMRList__item__iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____RSRPMRList__item__iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____RSRPMRList__item__iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RSRPMRList__item__iE_Extensions__item__extensionValue._const_tab = _____RSRPMRList__item__iE_Extensions__item__id_tab
    ____RSRPMRList__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____RSRPMRList__item__iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___RSRPMRList__item__iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____RSRPMRList__item__iE_Extensions__item__id),
        ('criticality', ____RSRPMRList__item__iE_Extensions__item__criticality),
        ('extensionValue', ____RSRPMRList__item__iE_Extensions__item__extensionValue),
        ])
    ___RSRPMRList__item__iE_Extensions__item_._ext = None
    __RSRPMRList__item__iE_Extensions._cont = ___RSRPMRList__item__iE_Extensions__item_
    __RSRPMRList__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _RSRPMRList__item_._cont = ASN1Dict([
        ('rSRPMeasurementResult', __RSRPMRList__item__rSRPMeasurementResult),
        ('iE-Extensions', __RSRPMRList__item__iE_Extensions),
        ])
    _RSRPMRList__item_._ext = []
    RSRPMRList._cont = _RSRPMRList__item_
    RSRPMRList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< RSRPMRList-ExtIEs >-----#
    RSRPMRList_ExtIEs = CLASS(name='RSRPMRList-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _RSRPMRList_ExtIEs_val_Extension_0 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UEID')))
    RSRPMRList_ExtIEs._val = ASN1Set(rv=[dict([('id', 147), ('criticality', 'ignore'), ('Extension', _RSRPMRList_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RRCContainer >-----#
    RRCContainer = OCT_STR(name='RRCContainer', mode=MODE_TYPE)
    
    #-----< S1TNLLoadIndicator >-----#
    S1TNLLoadIndicator = SEQ(name='S1TNLLoadIndicator', mode=MODE_TYPE)
    _S1TNLLoadIndicator_dLS1TNLLoadIndicator = ENUM(name='dLS1TNLLoadIndicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'LoadIndicator')))
    _S1TNLLoadIndicator_uLS1TNLLoadIndicator = ENUM(name='uLS1TNLLoadIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'LoadIndicator')))
    _S1TNLLoadIndicator_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __S1TNLLoadIndicator_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___S1TNLLoadIndicator_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____S1TNLLoadIndicator_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____S1TNLLoadIndicator_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___S1TNLLoadIndicator_iE_Extensions__item__id._const_tab = ____S1TNLLoadIndicator_iE_Extensions__item__id_tab
    ___S1TNLLoadIndicator_iE_Extensions__item__id._const_tab_at = None
    ___S1TNLLoadIndicator_iE_Extensions__item__id._const_tab_id = 'id'
    ___S1TNLLoadIndicator_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____S1TNLLoadIndicator_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____S1TNLLoadIndicator_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___S1TNLLoadIndicator_iE_Extensions__item__criticality._const_tab = ____S1TNLLoadIndicator_iE_Extensions__item__criticality_tab
    ___S1TNLLoadIndicator_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___S1TNLLoadIndicator_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___S1TNLLoadIndicator_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____S1TNLLoadIndicator_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____S1TNLLoadIndicator_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___S1TNLLoadIndicator_iE_Extensions__item__extensionValue._const_tab = ____S1TNLLoadIndicator_iE_Extensions__item__extensionValue_tab
    ___S1TNLLoadIndicator_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___S1TNLLoadIndicator_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __S1TNLLoadIndicator_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___S1TNLLoadIndicator_iE_Extensions__item__id),
        ('criticality', ___S1TNLLoadIndicator_iE_Extensions__item__criticality),
        ('extensionValue', ___S1TNLLoadIndicator_iE_Extensions__item__extensionValue),
        ])
    __S1TNLLoadIndicator_iE_Extensions__item_._ext = None
    _S1TNLLoadIndicator_iE_Extensions._cont = __S1TNLLoadIndicator_iE_Extensions__item_
    _S1TNLLoadIndicator_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    S1TNLLoadIndicator._cont = ASN1Dict([
        ('dLS1TNLLoadIndicator', _S1TNLLoadIndicator_dLS1TNLLoadIndicator),
        ('uLS1TNLLoadIndicator', _S1TNLLoadIndicator_uLS1TNLLoadIndicator),
        ('iE-Extensions', _S1TNLLoadIndicator_iE_Extensions),
        ])
    S1TNLLoadIndicator._ext = []
    
    #-----< S1TNLLoadIndicator-ExtIEs >-----#
    S1TNLLoadIndicator_ExtIEs = CLASS(name='S1TNLLoadIndicator-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    S1TNLLoadIndicator_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SCGActivationStatus >-----#
    SCGActivationStatus = ENUM(name='SCGActivationStatus', mode=MODE_TYPE)
    SCGActivationStatus._cont = ASN1Dict([('scg-activated', 0), ('scg-deactivated', 1)])
    SCGActivationStatus._ext = []
    
    #-----< SCGActivationRequest >-----#
    SCGActivationRequest = ENUM(name='SCGActivationRequest', mode=MODE_TYPE)
    SCGActivationRequest._cont = ASN1Dict([('activate-scg', 0), ('deactivate-scg', 1)])
    SCGActivationRequest._ext = []
    
    #-----< SCGChangeIndication >-----#
    SCGChangeIndication = ENUM(name='SCGChangeIndication', mode=MODE_TYPE)
    SCGChangeIndication._cont = ASN1Dict([('pDCPCountWrapAround', 0), ('pSCellChange', 1), ('other', 2)])
    SCGChangeIndication._ext = []
    
    #-----< SCGreconfigNotification >-----#
    SCGreconfigNotification = ENUM(name='SCGreconfigNotification', mode=MODE_TYPE)
    SCGreconfigNotification._cont = ASN1Dict([('executed', 0), ('executed-deleted', 1), ('deleted', 2)])
    SCGreconfigNotification._ext = ['executed-deleted', 'deleted']
    
    #-----< SCG-UE-HistoryInformation >-----#
    SCG_UE_HistoryInformation = SEQ_OF(name='SCG-UE-HistoryInformation', mode=MODE_TYPE)
    _SCG_UE_HistoryInformation__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'LastVisitedPSCell-Item')))
    SCG_UE_HistoryInformation._cont = _SCG_UE_HistoryInformation__item_
    SCG_UE_HistoryInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< SecondaryRATUsageReportList >-----#
    SecondaryRATUsageReportList = SEQ_OF(name='SecondaryRATUsageReportList', mode=MODE_TYPE)
    _SecondaryRATUsageReportList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __SecondaryRATUsageReportList__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ___SecondaryRATUsageReportList__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____SecondaryRATUsageReportList__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SecondaryRATUsageReport-Item')))
    ___SecondaryRATUsageReportList__item__id_tab._val = ASN1Set(rv=[dict([('id', 266), ('criticality', 'reject'), ('Value', ____SecondaryRATUsageReportList__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __SecondaryRATUsageReportList__item__id._const_tab = ___SecondaryRATUsageReportList__item__id_tab
    __SecondaryRATUsageReportList__item__id._const_tab_at = None
    __SecondaryRATUsageReportList__item__id._const_tab_id = 'id'
    __SecondaryRATUsageReportList__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    __SecondaryRATUsageReportList__item__criticality._const_tab = ___SecondaryRATUsageReportList__item__id_tab
    __SecondaryRATUsageReportList__item__criticality._const_tab_at = ('..', 'id')
    __SecondaryRATUsageReportList__item__criticality._const_tab_id = 'criticality'
    __SecondaryRATUsageReportList__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    __SecondaryRATUsageReportList__item__value._const_tab = ___SecondaryRATUsageReportList__item__id_tab
    __SecondaryRATUsageReportList__item__value._const_tab_at = ('..', 'id')
    __SecondaryRATUsageReportList__item__value._const_tab_id = 'Value'
    _SecondaryRATUsageReportList__item_._cont = ASN1Dict([
        ('id', __SecondaryRATUsageReportList__item__id),
        ('criticality', __SecondaryRATUsageReportList__item__criticality),
        ('value', __SecondaryRATUsageReportList__item__value),
        ])
    _SecondaryRATUsageReportList__item_._ext = None
    SecondaryRATUsageReportList._cont = _SecondaryRATUsageReportList__item_
    SecondaryRATUsageReportList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< SecondaryRATUsageReport-ItemIEs >-----#
    SecondaryRATUsageReport_ItemIEs = CLASS(name='SecondaryRATUsageReport-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _SecondaryRATUsageReport_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SecondaryRATUsageReport-Item')))
    SecondaryRATUsageReport_ItemIEs._val = ASN1Set(rv=[dict([('id', 266), ('criticality', 'reject'), ('Value', _SecondaryRATUsageReport_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< SecondaryRATUsageReport-Item >-----#
    SecondaryRATUsageReport_Item = SEQ(name='SecondaryRATUsageReport-Item', mode=MODE_TYPE)
    _SecondaryRATUsageReport_Item_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _SecondaryRATUsageReport_Item_secondaryRATType = ENUM(name='secondaryRATType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SecondaryRATUsageReport_Item_secondaryRATType._cont = ASN1Dict([('nr', 0), ('nR-unlicensed', 1)])
    _SecondaryRATUsageReport_Item_secondaryRATType._ext = ['nR-unlicensed']
    _SecondaryRATUsageReport_Item_e_RABUsageReportList = SEQ_OF(name='e-RABUsageReportList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RABUsageReportList')))
    _SecondaryRATUsageReport_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SecondaryRATUsageReport_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___SecondaryRATUsageReport_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____SecondaryRATUsageReport_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____SecondaryRATUsageReport_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecondaryRATUsageReport_Item_iE_Extensions__item__id._const_tab = ____SecondaryRATUsageReport_Item_iE_Extensions__item__id_tab
    ___SecondaryRATUsageReport_Item_iE_Extensions__item__id._const_tab_at = None
    ___SecondaryRATUsageReport_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___SecondaryRATUsageReport_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SecondaryRATUsageReport_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____SecondaryRATUsageReport_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecondaryRATUsageReport_Item_iE_Extensions__item__criticality._const_tab = ____SecondaryRATUsageReport_Item_iE_Extensions__item__criticality_tab
    ___SecondaryRATUsageReport_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SecondaryRATUsageReport_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SecondaryRATUsageReport_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SecondaryRATUsageReport_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____SecondaryRATUsageReport_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecondaryRATUsageReport_Item_iE_Extensions__item__extensionValue._const_tab = ____SecondaryRATUsageReport_Item_iE_Extensions__item__extensionValue_tab
    ___SecondaryRATUsageReport_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SecondaryRATUsageReport_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SecondaryRATUsageReport_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SecondaryRATUsageReport_Item_iE_Extensions__item__id),
        ('criticality', ___SecondaryRATUsageReport_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___SecondaryRATUsageReport_Item_iE_Extensions__item__extensionValue),
        ])
    __SecondaryRATUsageReport_Item_iE_Extensions__item_._ext = None
    _SecondaryRATUsageReport_Item_iE_Extensions._cont = __SecondaryRATUsageReport_Item_iE_Extensions__item_
    _SecondaryRATUsageReport_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SecondaryRATUsageReport_Item._cont = ASN1Dict([
        ('e-RAB-ID', _SecondaryRATUsageReport_Item_e_RAB_ID),
        ('secondaryRATType', _SecondaryRATUsageReport_Item_secondaryRATType),
        ('e-RABUsageReportList', _SecondaryRATUsageReport_Item_e_RABUsageReportList),
        ('iE-Extensions', _SecondaryRATUsageReport_Item_iE_Extensions),
        ])
    SecondaryRATUsageReport_Item._ext = []
    
    #-----< SecondaryRATUsageReport-Item-ExtIEs >-----#
    SecondaryRATUsageReport_Item_ExtIEs = CLASS(name='SecondaryRATUsageReport-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    SecondaryRATUsageReport_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SecurityIndication >-----#
    SecurityIndication = SEQ(name='SecurityIndication', mode=MODE_TYPE)
    _SecurityIndication_integrityProtectionIndication = ENUM(name='integrityProtectionIndication', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'IntegrityProtectionIndication')))
    _SecurityIndication_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SecurityIndication_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___SecurityIndication_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____SecurityIndication_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____SecurityIndication_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecurityIndication_iE_Extensions__item__id._const_tab = ____SecurityIndication_iE_Extensions__item__id_tab
    ___SecurityIndication_iE_Extensions__item__id._const_tab_at = None
    ___SecurityIndication_iE_Extensions__item__id._const_tab_id = 'id'
    ___SecurityIndication_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SecurityIndication_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____SecurityIndication_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecurityIndication_iE_Extensions__item__criticality._const_tab = ____SecurityIndication_iE_Extensions__item__criticality_tab
    ___SecurityIndication_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SecurityIndication_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SecurityIndication_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SecurityIndication_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____SecurityIndication_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecurityIndication_iE_Extensions__item__extensionValue._const_tab = ____SecurityIndication_iE_Extensions__item__extensionValue_tab
    ___SecurityIndication_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SecurityIndication_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SecurityIndication_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SecurityIndication_iE_Extensions__item__id),
        ('criticality', ___SecurityIndication_iE_Extensions__item__criticality),
        ('extensionValue', ___SecurityIndication_iE_Extensions__item__extensionValue),
        ])
    __SecurityIndication_iE_Extensions__item_._ext = None
    _SecurityIndication_iE_Extensions._cont = __SecurityIndication_iE_Extensions__item_
    _SecurityIndication_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SecurityIndication._cont = ASN1Dict([
        ('integrityProtectionIndication', _SecurityIndication_integrityProtectionIndication),
        ('iE-Extensions', _SecurityIndication_iE_Extensions),
        ])
    SecurityIndication._ext = []
    
    #-----< SecurityIndication-ExtIEs >-----#
    SecurityIndication_ExtIEs = CLASS(name='SecurityIndication-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    SecurityIndication_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SecurityResult >-----#
    SecurityResult = SEQ(name='SecurityResult', mode=MODE_TYPE)
    _SecurityResult_integrityProtectionResult = ENUM(name='integrityProtectionResult', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'IntegrityProtectionResult')))
    _SecurityResult_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SecurityResult_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___SecurityResult_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____SecurityResult_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____SecurityResult_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecurityResult_iE_Extensions__item__id._const_tab = ____SecurityResult_iE_Extensions__item__id_tab
    ___SecurityResult_iE_Extensions__item__id._const_tab_at = None
    ___SecurityResult_iE_Extensions__item__id._const_tab_id = 'id'
    ___SecurityResult_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SecurityResult_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____SecurityResult_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecurityResult_iE_Extensions__item__criticality._const_tab = ____SecurityResult_iE_Extensions__item__criticality_tab
    ___SecurityResult_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SecurityResult_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SecurityResult_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SecurityResult_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____SecurityResult_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecurityResult_iE_Extensions__item__extensionValue._const_tab = ____SecurityResult_iE_Extensions__item__extensionValue_tab
    ___SecurityResult_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SecurityResult_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SecurityResult_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SecurityResult_iE_Extensions__item__id),
        ('criticality', ___SecurityResult_iE_Extensions__item__criticality),
        ('extensionValue', ___SecurityResult_iE_Extensions__item__extensionValue),
        ])
    __SecurityResult_iE_Extensions__item_._ext = None
    _SecurityResult_iE_Extensions._cont = __SecurityResult_iE_Extensions__item_
    _SecurityResult_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SecurityResult._cont = ASN1Dict([
        ('integrityProtectionResult', _SecurityResult_integrityProtectionResult),
        ('iE-Extensions', _SecurityResult_iE_Extensions),
        ])
    SecurityResult._ext = []
    
    #-----< SecurityResult-ExtIEs >-----#
    SecurityResult_ExtIEs = CLASS(name='SecurityResult-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    SecurityResult_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SeNBSecurityKey >-----#
    SeNBSecurityKey = BIT_STR(name='SeNBSecurityKey', mode=MODE_TYPE)
    SeNBSecurityKey._const_sz = ASN1Set(rv=[256], rr=[], ev=None, er=[])
    
    #-----< SeNBtoMeNBContainer >-----#
    SeNBtoMeNBContainer = OCT_STR(name='SeNBtoMeNBContainer', mode=MODE_TYPE)
    
    #-----< SensorMeasurementConfiguration >-----#
    SensorMeasurementConfiguration = SEQ(name='SensorMeasurementConfiguration', mode=MODE_TYPE)
    _SensorMeasurementConfiguration_sensorMeasConfig = ENUM(name='sensorMeasConfig', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'SensorMeasConfig')))
    _SensorMeasurementConfiguration_sensorMeasConfigNameList = SEQ_OF(name='sensorMeasConfigNameList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'SensorMeasConfigNameList')), opt=True)
    _SensorMeasurementConfiguration_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SensorMeasurementConfiguration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___SensorMeasurementConfiguration_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____SensorMeasurementConfiguration_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____SensorMeasurementConfiguration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SensorMeasurementConfiguration_iE_Extensions__item__id._const_tab = ____SensorMeasurementConfiguration_iE_Extensions__item__id_tab
    ___SensorMeasurementConfiguration_iE_Extensions__item__id._const_tab_at = None
    ___SensorMeasurementConfiguration_iE_Extensions__item__id._const_tab_id = 'id'
    ___SensorMeasurementConfiguration_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SensorMeasurementConfiguration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____SensorMeasurementConfiguration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SensorMeasurementConfiguration_iE_Extensions__item__criticality._const_tab = ____SensorMeasurementConfiguration_iE_Extensions__item__criticality_tab
    ___SensorMeasurementConfiguration_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SensorMeasurementConfiguration_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SensorMeasurementConfiguration_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SensorMeasurementConfiguration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____SensorMeasurementConfiguration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SensorMeasurementConfiguration_iE_Extensions__item__extensionValue._const_tab = ____SensorMeasurementConfiguration_iE_Extensions__item__extensionValue_tab
    ___SensorMeasurementConfiguration_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SensorMeasurementConfiguration_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SensorMeasurementConfiguration_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SensorMeasurementConfiguration_iE_Extensions__item__id),
        ('criticality', ___SensorMeasurementConfiguration_iE_Extensions__item__criticality),
        ('extensionValue', ___SensorMeasurementConfiguration_iE_Extensions__item__extensionValue),
        ])
    __SensorMeasurementConfiguration_iE_Extensions__item_._ext = None
    _SensorMeasurementConfiguration_iE_Extensions._cont = __SensorMeasurementConfiguration_iE_Extensions__item_
    _SensorMeasurementConfiguration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SensorMeasurementConfiguration._cont = ASN1Dict([
        ('sensorMeasConfig', _SensorMeasurementConfiguration_sensorMeasConfig),
        ('sensorMeasConfigNameList', _SensorMeasurementConfiguration_sensorMeasConfigNameList),
        ('iE-Extensions', _SensorMeasurementConfiguration_iE_Extensions),
        ])
    SensorMeasurementConfiguration._ext = []
    
    #-----< SensorMeasurementConfiguration-ExtIEs >-----#
    SensorMeasurementConfiguration_ExtIEs = CLASS(name='SensorMeasurementConfiguration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    SensorMeasurementConfiguration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SensorMeasConfigNameList >-----#
    SensorMeasConfigNameList = SEQ_OF(name='SensorMeasConfigNameList', mode=MODE_TYPE)
    _SensorMeasConfigNameList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SensorMeasConfigNameItem')))
    SensorMeasConfigNameList._cont = _SensorMeasConfigNameList__item_
    SensorMeasConfigNameList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    
    #-----< SensorMeasConfigNameItem >-----#
    SensorMeasConfigNameItem = SEQ(name='SensorMeasConfigNameItem', mode=MODE_TYPE)
    _SensorMeasConfigNameItem_sensorNameConfig = CHOICE(name='sensorNameConfig', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'SensorNameConfig')))
    _SensorMeasConfigNameItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SensorMeasConfigNameItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___SensorMeasConfigNameItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____SensorMeasConfigNameItem_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____SensorMeasConfigNameItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SensorMeasConfigNameItem_iE_Extensions__item__id._const_tab = ____SensorMeasConfigNameItem_iE_Extensions__item__id_tab
    ___SensorMeasConfigNameItem_iE_Extensions__item__id._const_tab_at = None
    ___SensorMeasConfigNameItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___SensorMeasConfigNameItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SensorMeasConfigNameItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____SensorMeasConfigNameItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SensorMeasConfigNameItem_iE_Extensions__item__criticality._const_tab = ____SensorMeasConfigNameItem_iE_Extensions__item__criticality_tab
    ___SensorMeasConfigNameItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SensorMeasConfigNameItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SensorMeasConfigNameItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SensorMeasConfigNameItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____SensorMeasConfigNameItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SensorMeasConfigNameItem_iE_Extensions__item__extensionValue._const_tab = ____SensorMeasConfigNameItem_iE_Extensions__item__extensionValue_tab
    ___SensorMeasConfigNameItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SensorMeasConfigNameItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SensorMeasConfigNameItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SensorMeasConfigNameItem_iE_Extensions__item__id),
        ('criticality', ___SensorMeasConfigNameItem_iE_Extensions__item__criticality),
        ('extensionValue', ___SensorMeasConfigNameItem_iE_Extensions__item__extensionValue),
        ])
    __SensorMeasConfigNameItem_iE_Extensions__item_._ext = None
    _SensorMeasConfigNameItem_iE_Extensions._cont = __SensorMeasConfigNameItem_iE_Extensions__item_
    _SensorMeasConfigNameItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SensorMeasConfigNameItem._cont = ASN1Dict([
        ('sensorNameConfig', _SensorMeasConfigNameItem_sensorNameConfig),
        ('iE-Extensions', _SensorMeasConfigNameItem_iE_Extensions),
        ])
    SensorMeasConfigNameItem._ext = []
    
    #-----< SensorMeasConfigNameItem-ExtIEs >-----#
    SensorMeasConfigNameItem_ExtIEs = CLASS(name='SensorMeasConfigNameItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    SensorMeasConfigNameItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SensorMeasConfig >-----#
    SensorMeasConfig = ENUM(name='SensorMeasConfig', mode=MODE_TYPE)
    SensorMeasConfig._cont = ASN1Dict([('setup', 0)])
    SensorMeasConfig._ext = []
    
    #-----< SensorNameConfig >-----#
    SensorNameConfig = CHOICE(name='SensorNameConfig', mode=MODE_TYPE)
    _SensorNameConfig_uncompensatedBarometricConfig = ENUM(name='uncompensatedBarometricConfig', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SensorNameConfig_uncompensatedBarometricConfig._cont = ASN1Dict([('true', 0)])
    _SensorNameConfig_uncompensatedBarometricConfig._ext = []
    _SensorNameConfig_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __SensorNameConfig_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ___SensorNameConfig_choice_extension_id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ___SensorNameConfig_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SensorNameConfig_choice_extension_id._const_tab = ___SensorNameConfig_choice_extension_id_tab
    __SensorNameConfig_choice_extension_id._const_tab_at = None
    __SensorNameConfig_choice_extension_id._const_tab_id = 'id'
    __SensorNameConfig_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___SensorNameConfig_choice_extension_criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ___SensorNameConfig_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SensorNameConfig_choice_extension_criticality._const_tab = ___SensorNameConfig_choice_extension_criticality_tab
    __SensorNameConfig_choice_extension_criticality._const_tab_at = ('..', 'id')
    __SensorNameConfig_choice_extension_criticality._const_tab_id = 'criticality'
    __SensorNameConfig_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___SensorNameConfig_choice_extension_value_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ___SensorNameConfig_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SensorNameConfig_choice_extension_value._const_tab = ___SensorNameConfig_choice_extension_value_tab
    __SensorNameConfig_choice_extension_value._const_tab_at = ('..', 'id')
    __SensorNameConfig_choice_extension_value._const_tab_id = 'Value'
    _SensorNameConfig_choice_extension._cont = ASN1Dict([
        ('id', __SensorNameConfig_choice_extension_id),
        ('criticality', __SensorNameConfig_choice_extension_criticality),
        ('value', __SensorNameConfig_choice_extension_value),
        ])
    _SensorNameConfig_choice_extension._ext = None
    SensorNameConfig._cont = ASN1Dict([
        ('uncompensatedBarometricConfig', _SensorNameConfig_uncompensatedBarometricConfig),
        ('choice-extension', _SensorNameConfig_choice_extension),
        ])
    SensorNameConfig._ext = None
    
    #-----< SensorNameConfig-ExtIEs >-----#
    SensorNameConfig_ExtIEs = CLASS(name='SensorNameConfig-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    SensorNameConfig_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ServedCells >-----#
    ServedCells = SEQ_OF(name='ServedCells', mode=MODE_TYPE)
    _ServedCells__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __ServedCells__item__servedCellInfo = SEQ(name='servedCellInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ServedCell-Information')))
    __ServedCells__item__neighbour_Info = SEQ_OF(name='neighbour-Info', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'Neighbour-Information')), opt=True)
    __ServedCells__item__iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___ServedCells__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ____ServedCells__item__iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    _____ServedCells__item__iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ______ServedCells__item__iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'NRNeighbour-Information')))
    ______ServedCells__item__iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ServedCellSpecificInfoReq-NR')))
    _____ServedCells__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 327), ('criticality', 'ignore'), ('Extension', ______ServedCells__item__iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 434), ('criticality', 'ignore'), ('Extension', ______ServedCells__item__iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ____ServedCells__item__iE_Extensions__item__id._const_tab = _____ServedCells__item__iE_Extensions__item__id_tab
    ____ServedCells__item__iE_Extensions__item__id._const_tab_at = None
    ____ServedCells__item__iE_Extensions__item__id._const_tab_id = 'id'
    ____ServedCells__item__iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ServedCells__item__iE_Extensions__item__criticality._const_tab = _____ServedCells__item__iE_Extensions__item__id_tab
    ____ServedCells__item__iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____ServedCells__item__iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____ServedCells__item__iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ServedCells__item__iE_Extensions__item__extensionValue._const_tab = _____ServedCells__item__iE_Extensions__item__id_tab
    ____ServedCells__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____ServedCells__item__iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___ServedCells__item__iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____ServedCells__item__iE_Extensions__item__id),
        ('criticality', ____ServedCells__item__iE_Extensions__item__criticality),
        ('extensionValue', ____ServedCells__item__iE_Extensions__item__extensionValue),
        ])
    ___ServedCells__item__iE_Extensions__item_._ext = None
    __ServedCells__item__iE_Extensions._cont = ___ServedCells__item__iE_Extensions__item_
    __ServedCells__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _ServedCells__item_._cont = ASN1Dict([
        ('servedCellInfo', __ServedCells__item__servedCellInfo),
        ('neighbour-Info', __ServedCells__item__neighbour_Info),
        ('iE-Extensions', __ServedCells__item__iE_Extensions),
        ])
    _ServedCells__item_._ext = []
    ServedCells._cont = _ServedCells__item_
    ServedCells._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< ServedCell-ExtIEs >-----#
    ServedCell_ExtIEs = CLASS(name='ServedCell-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _ServedCell_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'NRNeighbour-Information')))
    _ServedCell_ExtIEs_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ServedCellSpecificInfoReq-NR')))
    ServedCell_ExtIEs._val = ASN1Set(rv=[dict([('id', 327), ('criticality', 'ignore'), ('Extension', _ServedCell_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 434), ('criticality', 'ignore'), ('Extension', _ServedCell_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ServedCell-Information >-----#
    ServedCell_Information = SEQ(name='ServedCell-Information', mode=MODE_TYPE)
    _ServedCell_Information_pCI = INT(name='pCI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'PCI')))
    _ServedCell_Information_cellId = SEQ(name='cellId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _ServedCell_Information_tAC = OCT_STR(name='tAC', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'TAC')))
    _ServedCell_Information_broadcastPLMNs = SEQ_OF(name='broadcastPLMNs', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'BroadcastPLMNs-Item')))
    _ServedCell_Information_eUTRA_Mode_Info = CHOICE(name='eUTRA-Mode-Info', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'EUTRA-Mode-Info')))
    _ServedCell_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ServedCell_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___ServedCell_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____ServedCell_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____ServedCell_Information_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Number-of-Antennaports')))
    _____ServedCell_Information_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PRACH-Configuration')))
    _____ServedCell_Information_iE_Extensions__item__id_tab_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MBSFN-Subframe-Infolist')))
    _____ServedCell_Information_iE_Extensions__item__id_tab_val_Extension_3 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CSG-Id')))
    _____ServedCell_Information_iE_Extensions__item__id_tab_val_Extension_4 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MBMS-Service-Area-Identity-List')))
    _____ServedCell_Information_iE_Extensions__item__id_tab_val_Extension_5 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MultibandInfoList')))
    _____ServedCell_Information_iE_Extensions__item__id_tab_val_Extension_6 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'FreqBandIndicatorPriority')))
    _____ServedCell_Information_iE_Extensions__item__id_tab_val_Extension_7 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'BandwidthReducedSI')))
    _____ServedCell_Information_iE_Extensions__item__id_tab_val_Extension_8 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ProtectedEUTRAResourceIndication')))
    _____ServedCell_Information_iE_Extensions__item__id_tab_val_Extension_9 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'BPLMN-ID-Info-EUTRA')))
    _____ServedCell_Information_iE_Extensions__item__id_tab_val_Extension_10 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'NPRACHConfiguration')))
    _____ServedCell_Information_iE_Extensions__item__id_tab_val_Extension_11 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SFN-Offset')))
    ____ServedCell_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 41), ('criticality', 'ignore'), ('Extension', _____ServedCell_Information_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 55), ('criticality', 'ignore'), ('Extension', _____ServedCell_Information_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 56), ('criticality', 'ignore'), ('Extension', _____ServedCell_Information_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 70), ('criticality', 'ignore'), ('Extension', _____ServedCell_Information_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 79), ('criticality', 'ignore'), ('Extension', _____ServedCell_Information_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 84), ('criticality', 'ignore'), ('Extension', _____ServedCell_Information_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')]), dict([('id', 160), ('criticality', 'ignore'), ('Extension', _____ServedCell_Information_iE_Extensions__item__id_tab_val_Extension_6), ('presence', 'optional')]), dict([('id', 180), ('criticality', 'ignore'), ('Extension', _____ServedCell_Information_iE_Extensions__item__id_tab_val_Extension_7), ('presence', 'optional')]), dict([('id', 284), ('criticality', 'ignore'), ('Extension', _____ServedCell_Information_iE_Extensions__item__id_tab_val_Extension_8), ('presence', 'optional')]), dict([('id', 336), ('criticality', 'ignore'), ('Extension', _____ServedCell_Information_iE_Extensions__item__id_tab_val_Extension_9), ('presence', 'optional')]), dict([('id', 373), ('criticality', 'ignore'), ('Extension', _____ServedCell_Information_iE_Extensions__item__id_tab_val_Extension_10), ('presence', 'optional')]), dict([('id', 406), ('criticality', 'ignore'), ('Extension', _____ServedCell_Information_iE_Extensions__item__id_tab_val_Extension_11), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ServedCell_Information_iE_Extensions__item__id._const_tab = ____ServedCell_Information_iE_Extensions__item__id_tab
    ___ServedCell_Information_iE_Extensions__item__id._const_tab_at = None
    ___ServedCell_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___ServedCell_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___ServedCell_Information_iE_Extensions__item__criticality._const_tab = ____ServedCell_Information_iE_Extensions__item__id_tab
    ___ServedCell_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ServedCell_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ServedCell_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___ServedCell_Information_iE_Extensions__item__extensionValue._const_tab = ____ServedCell_Information_iE_Extensions__item__id_tab
    ___ServedCell_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ServedCell_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ServedCell_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ServedCell_Information_iE_Extensions__item__id),
        ('criticality', ___ServedCell_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___ServedCell_Information_iE_Extensions__item__extensionValue),
        ])
    __ServedCell_Information_iE_Extensions__item_._ext = None
    _ServedCell_Information_iE_Extensions._cont = __ServedCell_Information_iE_Extensions__item_
    _ServedCell_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ServedCell_Information._cont = ASN1Dict([
        ('pCI', _ServedCell_Information_pCI),
        ('cellId', _ServedCell_Information_cellId),
        ('tAC', _ServedCell_Information_tAC),
        ('broadcastPLMNs', _ServedCell_Information_broadcastPLMNs),
        ('eUTRA-Mode-Info', _ServedCell_Information_eUTRA_Mode_Info),
        ('iE-Extensions', _ServedCell_Information_iE_Extensions),
        ])
    ServedCell_Information._ext = []
    
    #-----< ServedCell-Information-ExtIEs >-----#
    ServedCell_Information_ExtIEs = CLASS(name='ServedCell-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _ServedCell_Information_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Number-of-Antennaports')))
    _ServedCell_Information_ExtIEs_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PRACH-Configuration')))
    _ServedCell_Information_ExtIEs_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MBSFN-Subframe-Infolist')))
    _ServedCell_Information_ExtIEs_val_Extension_3 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CSG-Id')))
    _ServedCell_Information_ExtIEs_val_Extension_4 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MBMS-Service-Area-Identity-List')))
    _ServedCell_Information_ExtIEs_val_Extension_5 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MultibandInfoList')))
    _ServedCell_Information_ExtIEs_val_Extension_6 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'FreqBandIndicatorPriority')))
    _ServedCell_Information_ExtIEs_val_Extension_7 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'BandwidthReducedSI')))
    _ServedCell_Information_ExtIEs_val_Extension_8 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ProtectedEUTRAResourceIndication')))
    _ServedCell_Information_ExtIEs_val_Extension_9 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'BPLMN-ID-Info-EUTRA')))
    _ServedCell_Information_ExtIEs_val_Extension_10 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'NPRACHConfiguration')))
    _ServedCell_Information_ExtIEs_val_Extension_11 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SFN-Offset')))
    ServedCell_Information_ExtIEs._val = ASN1Set(rv=[dict([('id', 41), ('criticality', 'ignore'), ('Extension', _ServedCell_Information_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 55), ('criticality', 'ignore'), ('Extension', _ServedCell_Information_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 56), ('criticality', 'ignore'), ('Extension', _ServedCell_Information_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 70), ('criticality', 'ignore'), ('Extension', _ServedCell_Information_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 79), ('criticality', 'ignore'), ('Extension', _ServedCell_Information_ExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 84), ('criticality', 'ignore'), ('Extension', _ServedCell_Information_ExtIEs_val_Extension_5), ('presence', 'optional')]), dict([('id', 160), ('criticality', 'ignore'), ('Extension', _ServedCell_Information_ExtIEs_val_Extension_6), ('presence', 'optional')]), dict([('id', 180), ('criticality', 'ignore'), ('Extension', _ServedCell_Information_ExtIEs_val_Extension_7), ('presence', 'optional')]), dict([('id', 284), ('criticality', 'ignore'), ('Extension', _ServedCell_Information_ExtIEs_val_Extension_8), ('presence', 'optional')]), dict([('id', 336), ('criticality', 'ignore'), ('Extension', _ServedCell_Information_ExtIEs_val_Extension_9), ('presence', 'optional')]), dict([('id', 373), ('criticality', 'ignore'), ('Extension', _ServedCell_Information_ExtIEs_val_Extension_10), ('presence', 'optional')]), dict([('id', 406), ('criticality', 'ignore'), ('Extension', _ServedCell_Information_ExtIEs_val_Extension_11), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ServedCellSpecificInfoReq-NR >-----#
    ServedCellSpecificInfoReq_NR = SEQ_OF(name='ServedCellSpecificInfoReq-NR', mode=MODE_TYPE)
    _ServedCellSpecificInfoReq_NR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ServedCellSpecificInfoReq-NR-Item')))
    ServedCellSpecificInfoReq_NR._cont = _ServedCellSpecificInfoReq_NR__item_
    ServedCellSpecificInfoReq_NR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16384)], ev=None, er=[])
    
    #-----< ServedCellSpecificInfoReq-NR-Item >-----#
    ServedCellSpecificInfoReq_NR_Item = SEQ(name='ServedCellSpecificInfoReq-NR-Item', mode=MODE_TYPE)
    _ServedCellSpecificInfoReq_NR_Item_nRCGI = SEQ(name='nRCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'NRCGI')))
    _ServedCellSpecificInfoReq_NR_Item_additionalMTCListRequestIndicator = ENUM(name='additionalMTCListRequestIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ServedCellSpecificInfoReq_NR_Item_additionalMTCListRequestIndicator._cont = ASN1Dict([('additionalMTCListRequested', 0)])
    _ServedCellSpecificInfoReq_NR_Item_additionalMTCListRequestIndicator._ext = []
    _ServedCellSpecificInfoReq_NR_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ServedCellSpecificInfoReq_NR_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___ServedCellSpecificInfoReq_NR_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____ServedCellSpecificInfoReq_NR_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ServedCellSpecificInfoReq_NR_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ServedCellSpecificInfoReq_NR_Item_iE_Extensions__item__id._const_tab = ____ServedCellSpecificInfoReq_NR_Item_iE_Extensions__item__id_tab
    ___ServedCellSpecificInfoReq_NR_Item_iE_Extensions__item__id._const_tab_at = None
    ___ServedCellSpecificInfoReq_NR_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___ServedCellSpecificInfoReq_NR_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ServedCellSpecificInfoReq_NR_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ServedCellSpecificInfoReq_NR_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ServedCellSpecificInfoReq_NR_Item_iE_Extensions__item__criticality._const_tab = ____ServedCellSpecificInfoReq_NR_Item_iE_Extensions__item__criticality_tab
    ___ServedCellSpecificInfoReq_NR_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ServedCellSpecificInfoReq_NR_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ServedCellSpecificInfoReq_NR_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ServedCellSpecificInfoReq_NR_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ServedCellSpecificInfoReq_NR_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ServedCellSpecificInfoReq_NR_Item_iE_Extensions__item__extensionValue._const_tab = ____ServedCellSpecificInfoReq_NR_Item_iE_Extensions__item__extensionValue_tab
    ___ServedCellSpecificInfoReq_NR_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ServedCellSpecificInfoReq_NR_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ServedCellSpecificInfoReq_NR_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ServedCellSpecificInfoReq_NR_Item_iE_Extensions__item__id),
        ('criticality', ___ServedCellSpecificInfoReq_NR_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___ServedCellSpecificInfoReq_NR_Item_iE_Extensions__item__extensionValue),
        ])
    __ServedCellSpecificInfoReq_NR_Item_iE_Extensions__item_._ext = None
    _ServedCellSpecificInfoReq_NR_Item_iE_Extensions._cont = __ServedCellSpecificInfoReq_NR_Item_iE_Extensions__item_
    _ServedCellSpecificInfoReq_NR_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ServedCellSpecificInfoReq_NR_Item._cont = ASN1Dict([
        ('nRCGI', _ServedCellSpecificInfoReq_NR_Item_nRCGI),
        ('additionalMTCListRequestIndicator', _ServedCellSpecificInfoReq_NR_Item_additionalMTCListRequestIndicator),
        ('iE-Extensions', _ServedCellSpecificInfoReq_NR_Item_iE_Extensions),
        ])
    ServedCellSpecificInfoReq_NR_Item._ext = []
    
    #-----< ServedCellSpecificInfoReq-NR-Item-ExtIEs >-----#
    ServedCellSpecificInfoReq_NR_Item_ExtIEs = CLASS(name='ServedCellSpecificInfoReq-NR-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ServedCellSpecificInfoReq_NR_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ServiceType >-----#
    ServiceType = ENUM(name='ServiceType', mode=MODE_TYPE)
    ServiceType._cont = ASN1Dict([('qMC-for-streaming-service', 0), ('qMC-for-MTSI-service', 1)])
    ServiceType._ext = []
    
    #-----< SgNBCoordinationAssistanceInformation >-----#
    SgNBCoordinationAssistanceInformation = ENUM(name='SgNBCoordinationAssistanceInformation', mode=MODE_TYPE)
    SgNBCoordinationAssistanceInformation._cont = ASN1Dict([('coordination-not-required', 0)])
    SgNBCoordinationAssistanceInformation._ext = []
    
    #-----< SgNBResourceCoordinationInformation >-----#
    SgNBResourceCoordinationInformation = SEQ(name='SgNBResourceCoordinationInformation', mode=MODE_TYPE)
    _SgNBResourceCoordinationInformation_nR_CGI = SEQ(name='nR-CGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'NRCGI')))
    _SgNBResourceCoordinationInformation_uLCoordinationInformation = BIT_STR(name='uLCoordinationInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SgNBResourceCoordinationInformation_uLCoordinationInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=6, ub=4400)], ev=[], er=[])
    _SgNBResourceCoordinationInformation_dLCoordinationInformation = BIT_STR(name='dLCoordinationInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SgNBResourceCoordinationInformation_dLCoordinationInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=6, ub=4400)], ev=[], er=[])
    _SgNBResourceCoordinationInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SgNBResourceCoordinationInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___SgNBResourceCoordinationInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____SgNBResourceCoordinationInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____SgNBResourceCoordinationInformation_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _____SgNBResourceCoordinationInformation_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNBCoordinationAssistanceInformation')))
    ____SgNBResourceCoordinationInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 316), ('criticality', 'ignore'), ('Extension', _____SgNBResourceCoordinationInformation_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 324), ('criticality', 'reject'), ('Extension', _____SgNBResourceCoordinationInformation_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SgNBResourceCoordinationInformation_iE_Extensions__item__id._const_tab = ____SgNBResourceCoordinationInformation_iE_Extensions__item__id_tab
    ___SgNBResourceCoordinationInformation_iE_Extensions__item__id._const_tab_at = None
    ___SgNBResourceCoordinationInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___SgNBResourceCoordinationInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___SgNBResourceCoordinationInformation_iE_Extensions__item__criticality._const_tab = ____SgNBResourceCoordinationInformation_iE_Extensions__item__id_tab
    ___SgNBResourceCoordinationInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SgNBResourceCoordinationInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SgNBResourceCoordinationInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___SgNBResourceCoordinationInformation_iE_Extensions__item__extensionValue._const_tab = ____SgNBResourceCoordinationInformation_iE_Extensions__item__id_tab
    ___SgNBResourceCoordinationInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SgNBResourceCoordinationInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SgNBResourceCoordinationInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SgNBResourceCoordinationInformation_iE_Extensions__item__id),
        ('criticality', ___SgNBResourceCoordinationInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___SgNBResourceCoordinationInformation_iE_Extensions__item__extensionValue),
        ])
    __SgNBResourceCoordinationInformation_iE_Extensions__item_._ext = None
    _SgNBResourceCoordinationInformation_iE_Extensions._cont = __SgNBResourceCoordinationInformation_iE_Extensions__item_
    _SgNBResourceCoordinationInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SgNBResourceCoordinationInformation._cont = ASN1Dict([
        ('nR-CGI', _SgNBResourceCoordinationInformation_nR_CGI),
        ('uLCoordinationInformation', _SgNBResourceCoordinationInformation_uLCoordinationInformation),
        ('dLCoordinationInformation', _SgNBResourceCoordinationInformation_dLCoordinationInformation),
        ('iE-Extensions', _SgNBResourceCoordinationInformation_iE_Extensions),
        ])
    SgNBResourceCoordinationInformation._ext = []
    
    #-----< SgNBResourceCoordinationInformationExtIEs >-----#
    SgNBResourceCoordinationInformationExtIEs = CLASS(name='SgNBResourceCoordinationInformationExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _SgNBResourceCoordinationInformationExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _SgNBResourceCoordinationInformationExtIEs_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNBCoordinationAssistanceInformation')))
    SgNBResourceCoordinationInformationExtIEs._val = ASN1Set(rv=[dict([('id', 316), ('criticality', 'ignore'), ('Extension', _SgNBResourceCoordinationInformationExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 324), ('criticality', 'reject'), ('Extension', _SgNBResourceCoordinationInformationExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< SgNB-UE-X2AP-ID >-----#
    SgNB_UE_X2AP_ID = INT(name='SgNB-UE-X2AP-ID', mode=MODE_TYPE)
    SgNB_UE_X2AP_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    
    #-----< SIPTOBearerDeactivationIndication >-----#
    SIPTOBearerDeactivationIndication = ENUM(name='SIPTOBearerDeactivationIndication', mode=MODE_TYPE)
    SIPTOBearerDeactivationIndication._cont = ASN1Dict([('true', 0)])
    SIPTOBearerDeactivationIndication._ext = []
    
    #-----< SharedResourceType >-----#
    SharedResourceType = CHOICE(name='SharedResourceType', mode=MODE_TYPE)
    _SharedResourceType_uLOnlySharing = SEQ(name='uLOnlySharing', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ULOnlySharing')))
    _SharedResourceType_uLandDLSharing = SEQ(name='uLandDLSharing', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ULandDLSharing')))
    SharedResourceType._cont = ASN1Dict([
        ('uLOnlySharing', _SharedResourceType_uLOnlySharing),
        ('uLandDLSharing', _SharedResourceType_uLandDLSharing),
        ])
    SharedResourceType._ext = []
    
    #-----< ShortMAC-I >-----#
    ShortMAC_I = BIT_STR(name='ShortMAC-I', mode=MODE_TYPE)
    ShortMAC_I._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< SGNB-Addition-Trigger-Ind >-----#
    SGNB_Addition_Trigger_Ind = ENUM(name='SGNB-Addition-Trigger-Ind', mode=MODE_TYPE)
    SGNB_Addition_Trigger_Ind._cont = ASN1Dict([('sn-change', 0), ('inter-eNB-HO', 1), ('intra-eNB-HO', 2)])
    SGNB_Addition_Trigger_Ind._ext = []
    
    #-----< SNtriggered >-----#
    SNtriggered = ENUM(name='SNtriggered', mode=MODE_TYPE)
    SNtriggered._cont = ASN1Dict([('true', 0)])
    SNtriggered._ext = []
    
    #-----< SourceOfUEActivityBehaviourInformation >-----#
    SourceOfUEActivityBehaviourInformation = ENUM(name='SourceOfUEActivityBehaviourInformation', mode=MODE_TYPE)
    SourceOfUEActivityBehaviourInformation._cont = ASN1Dict([('subscription-information', 0), ('statistics', 1)])
    SourceOfUEActivityBehaviourInformation._ext = []
    
    #-----< SpecialSubframe-Info >-----#
    SpecialSubframe_Info = SEQ(name='SpecialSubframe-Info', mode=MODE_TYPE)
    _SpecialSubframe_Info_specialSubframePatterns = ENUM(name='specialSubframePatterns', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'SpecialSubframePatterns')))
    _SpecialSubframe_Info_cyclicPrefixDL = ENUM(name='cyclicPrefixDL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CyclicPrefixDL')))
    _SpecialSubframe_Info_cyclicPrefixUL = ENUM(name='cyclicPrefixUL', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CyclicPrefixUL')))
    _SpecialSubframe_Info_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SpecialSubframe_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___SpecialSubframe_Info_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____SpecialSubframe_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____SpecialSubframe_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SpecialSubframe_Info_iE_Extensions__item__id._const_tab = ____SpecialSubframe_Info_iE_Extensions__item__id_tab
    ___SpecialSubframe_Info_iE_Extensions__item__id._const_tab_at = None
    ___SpecialSubframe_Info_iE_Extensions__item__id._const_tab_id = 'id'
    ___SpecialSubframe_Info_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SpecialSubframe_Info_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____SpecialSubframe_Info_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SpecialSubframe_Info_iE_Extensions__item__criticality._const_tab = ____SpecialSubframe_Info_iE_Extensions__item__criticality_tab
    ___SpecialSubframe_Info_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SpecialSubframe_Info_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SpecialSubframe_Info_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SpecialSubframe_Info_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____SpecialSubframe_Info_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SpecialSubframe_Info_iE_Extensions__item__extensionValue._const_tab = ____SpecialSubframe_Info_iE_Extensions__item__extensionValue_tab
    ___SpecialSubframe_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SpecialSubframe_Info_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SpecialSubframe_Info_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SpecialSubframe_Info_iE_Extensions__item__id),
        ('criticality', ___SpecialSubframe_Info_iE_Extensions__item__criticality),
        ('extensionValue', ___SpecialSubframe_Info_iE_Extensions__item__extensionValue),
        ])
    __SpecialSubframe_Info_iE_Extensions__item_._ext = None
    _SpecialSubframe_Info_iE_Extensions._cont = __SpecialSubframe_Info_iE_Extensions__item_
    _SpecialSubframe_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SpecialSubframe_Info._cont = ASN1Dict([
        ('specialSubframePatterns', _SpecialSubframe_Info_specialSubframePatterns),
        ('cyclicPrefixDL', _SpecialSubframe_Info_cyclicPrefixDL),
        ('cyclicPrefixUL', _SpecialSubframe_Info_cyclicPrefixUL),
        ('iE-Extensions', _SpecialSubframe_Info_iE_Extensions),
        ])
    SpecialSubframe_Info._ext = []
    
    #-----< SpecialSubframe-Info-ExtIEs >-----#
    SpecialSubframe_Info_ExtIEs = CLASS(name='SpecialSubframe-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    SpecialSubframe_Info_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SpecialSubframePatterns >-----#
    SpecialSubframePatterns = ENUM(name='SpecialSubframePatterns', mode=MODE_TYPE)
    SpecialSubframePatterns._cont = ASN1Dict([('ssp0', 0), ('ssp1', 1), ('ssp2', 2), ('ssp3', 3), ('ssp4', 4), ('ssp5', 5), ('ssp6', 6), ('ssp7', 7), ('ssp8', 8)])
    SpecialSubframePatterns._ext = []
    
    #-----< SpectrumSharingGroupID >-----#
    SpectrumSharingGroupID = INT(name='SpectrumSharingGroupID', mode=MODE_TYPE)
    SpectrumSharingGroupID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< SubbandCQI >-----#
    SubbandCQI = SEQ(name='SubbandCQI', mode=MODE_TYPE)
    _SubbandCQI_subbandCQICodeword0 = CHOICE(name='subbandCQICodeword0', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'SubbandCQICodeword0')))
    _SubbandCQI_subbandCQICodeword1 = CHOICE(name='subbandCQICodeword1', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'SubbandCQICodeword1')), opt=True)
    _SubbandCQI_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SubbandCQI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___SubbandCQI_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____SubbandCQI_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____SubbandCQI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SubbandCQI_iE_Extensions__item__id._const_tab = ____SubbandCQI_iE_Extensions__item__id_tab
    ___SubbandCQI_iE_Extensions__item__id._const_tab_at = None
    ___SubbandCQI_iE_Extensions__item__id._const_tab_id = 'id'
    ___SubbandCQI_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SubbandCQI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____SubbandCQI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SubbandCQI_iE_Extensions__item__criticality._const_tab = ____SubbandCQI_iE_Extensions__item__criticality_tab
    ___SubbandCQI_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SubbandCQI_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SubbandCQI_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SubbandCQI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____SubbandCQI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SubbandCQI_iE_Extensions__item__extensionValue._const_tab = ____SubbandCQI_iE_Extensions__item__extensionValue_tab
    ___SubbandCQI_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SubbandCQI_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SubbandCQI_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SubbandCQI_iE_Extensions__item__id),
        ('criticality', ___SubbandCQI_iE_Extensions__item__criticality),
        ('extensionValue', ___SubbandCQI_iE_Extensions__item__extensionValue),
        ])
    __SubbandCQI_iE_Extensions__item_._ext = None
    _SubbandCQI_iE_Extensions._cont = __SubbandCQI_iE_Extensions__item_
    _SubbandCQI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SubbandCQI._cont = ASN1Dict([
        ('subbandCQICodeword0', _SubbandCQI_subbandCQICodeword0),
        ('subbandCQICodeword1', _SubbandCQI_subbandCQICodeword1),
        ('iE-Extensions', _SubbandCQI_iE_Extensions),
        ])
    SubbandCQI._ext = []
    
    #-----< Subscription-Based-UE-DifferentiationInfo >-----#
    Subscription_Based_UE_DifferentiationInfo = SEQ(name='Subscription-Based-UE-DifferentiationInfo', mode=MODE_TYPE)
    _Subscription_Based_UE_DifferentiationInfo_periodicCommunicationIndicator = ENUM(name='periodicCommunicationIndicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Subscription_Based_UE_DifferentiationInfo_periodicCommunicationIndicator._cont = ASN1Dict([('periodically', 0), ('ondemand', 1)])
    _Subscription_Based_UE_DifferentiationInfo_periodicCommunicationIndicator._ext = []
    _Subscription_Based_UE_DifferentiationInfo_periodicTime = INT(name='periodicTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Subscription_Based_UE_DifferentiationInfo_periodicTime._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3600)], ev=[], er=[])
    _Subscription_Based_UE_DifferentiationInfo_scheduledCommunicationTime = SEQ(name='scheduledCommunicationTime', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ScheduledCommunicationTime')), opt=True)
    _Subscription_Based_UE_DifferentiationInfo_stationaryIndication = ENUM(name='stationaryIndication', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Subscription_Based_UE_DifferentiationInfo_stationaryIndication._cont = ASN1Dict([('stationary', 0), ('mobile', 1)])
    _Subscription_Based_UE_DifferentiationInfo_stationaryIndication._ext = []
    _Subscription_Based_UE_DifferentiationInfo_trafficProfile = ENUM(name='trafficProfile', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Subscription_Based_UE_DifferentiationInfo_trafficProfile._cont = ASN1Dict([('single-packet', 0), ('dual-packets', 1), ('multiple-packets', 2)])
    _Subscription_Based_UE_DifferentiationInfo_trafficProfile._ext = []
    _Subscription_Based_UE_DifferentiationInfo_batteryIndication = ENUM(name='batteryIndication', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Subscription_Based_UE_DifferentiationInfo_batteryIndication._cont = ASN1Dict([('battery-powered', 0), ('battery-powered-not-rechargeable-or-replaceable', 1), ('not-battery-powered', 2)])
    _Subscription_Based_UE_DifferentiationInfo_batteryIndication._ext = []
    _Subscription_Based_UE_DifferentiationInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__id._const_tab = ____Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__id_tab
    ___Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__id._const_tab_at = None
    ___Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__criticality._const_tab = ____Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__criticality_tab
    ___Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__extensionValue._const_tab = ____Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__extensionValue_tab
    ___Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__id),
        ('criticality', ___Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__extensionValue),
        ])
    __Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item_._ext = None
    _Subscription_Based_UE_DifferentiationInfo_iE_Extensions._cont = __Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item_
    _Subscription_Based_UE_DifferentiationInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Subscription_Based_UE_DifferentiationInfo._cont = ASN1Dict([
        ('periodicCommunicationIndicator', _Subscription_Based_UE_DifferentiationInfo_periodicCommunicationIndicator),
        ('periodicTime', _Subscription_Based_UE_DifferentiationInfo_periodicTime),
        ('scheduledCommunicationTime', _Subscription_Based_UE_DifferentiationInfo_scheduledCommunicationTime),
        ('stationaryIndication', _Subscription_Based_UE_DifferentiationInfo_stationaryIndication),
        ('trafficProfile', _Subscription_Based_UE_DifferentiationInfo_trafficProfile),
        ('batteryIndication', _Subscription_Based_UE_DifferentiationInfo_batteryIndication),
        ('iE-Extensions', _Subscription_Based_UE_DifferentiationInfo_iE_Extensions),
        ])
    Subscription_Based_UE_DifferentiationInfo._ext = []
    
    #-----< Subscription-Based-UE-DifferentiationInfo-ExtIEs >-----#
    Subscription_Based_UE_DifferentiationInfo_ExtIEs = CLASS(name='Subscription-Based-UE-DifferentiationInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    Subscription_Based_UE_DifferentiationInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ScheduledCommunicationTime >-----#
    ScheduledCommunicationTime = SEQ(name='ScheduledCommunicationTime', mode=MODE_TYPE)
    _ScheduledCommunicationTime_dayofWeek = BIT_STR(name='dayofWeek', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ScheduledCommunicationTime_dayofWeek._const_sz = ASN1Set(rv=[7], rr=[], ev=None, er=[])
    _ScheduledCommunicationTime_timeofDayStart = INT(name='timeofDayStart', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ScheduledCommunicationTime_timeofDayStart._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=86399)], ev=[], er=[])
    _ScheduledCommunicationTime_timeofDayEnd = INT(name='timeofDayEnd', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ScheduledCommunicationTime_timeofDayEnd._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=86399)], ev=[], er=[])
    _ScheduledCommunicationTime_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ScheduledCommunicationTime_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___ScheduledCommunicationTime_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____ScheduledCommunicationTime_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ScheduledCommunicationTime_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ScheduledCommunicationTime_iE_Extensions__item__id._const_tab = ____ScheduledCommunicationTime_iE_Extensions__item__id_tab
    ___ScheduledCommunicationTime_iE_Extensions__item__id._const_tab_at = None
    ___ScheduledCommunicationTime_iE_Extensions__item__id._const_tab_id = 'id'
    ___ScheduledCommunicationTime_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ScheduledCommunicationTime_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ScheduledCommunicationTime_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ScheduledCommunicationTime_iE_Extensions__item__criticality._const_tab = ____ScheduledCommunicationTime_iE_Extensions__item__criticality_tab
    ___ScheduledCommunicationTime_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ScheduledCommunicationTime_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ScheduledCommunicationTime_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ScheduledCommunicationTime_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ScheduledCommunicationTime_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ScheduledCommunicationTime_iE_Extensions__item__extensionValue._const_tab = ____ScheduledCommunicationTime_iE_Extensions__item__extensionValue_tab
    ___ScheduledCommunicationTime_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ScheduledCommunicationTime_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ScheduledCommunicationTime_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ScheduledCommunicationTime_iE_Extensions__item__id),
        ('criticality', ___ScheduledCommunicationTime_iE_Extensions__item__criticality),
        ('extensionValue', ___ScheduledCommunicationTime_iE_Extensions__item__extensionValue),
        ])
    __ScheduledCommunicationTime_iE_Extensions__item_._ext = None
    _ScheduledCommunicationTime_iE_Extensions._cont = __ScheduledCommunicationTime_iE_Extensions__item_
    _ScheduledCommunicationTime_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ScheduledCommunicationTime._cont = ASN1Dict([
        ('dayofWeek', _ScheduledCommunicationTime_dayofWeek),
        ('timeofDayStart', _ScheduledCommunicationTime_timeofDayStart),
        ('timeofDayEnd', _ScheduledCommunicationTime_timeofDayEnd),
        ('iE-Extensions', _ScheduledCommunicationTime_iE_Extensions),
        ])
    ScheduledCommunicationTime._ext = []
    
    #-----< ScheduledCommunicationTime-ExtIEs >-----#
    ScheduledCommunicationTime_ExtIEs = CLASS(name='ScheduledCommunicationTime-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ScheduledCommunicationTime_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SRVCCOperationPossible >-----#
    SRVCCOperationPossible = ENUM(name='SRVCCOperationPossible', mode=MODE_TYPE)
    SRVCCOperationPossible._cont = ASN1Dict([('possible', 0)])
    SRVCCOperationPossible._ext = []
    
    #-----< SSBAreaCapacityValue-List >-----#
    SSBAreaCapacityValue_List = SEQ_OF(name='SSBAreaCapacityValue-List', mode=MODE_TYPE)
    _SSBAreaCapacityValue_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SSBAreaCapacityValue-Item')))
    SSBAreaCapacityValue_List._cont = _SSBAreaCapacityValue_List__item_
    SSBAreaCapacityValue_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< SSBAreaCapacityValue-Item >-----#
    SSBAreaCapacityValue_Item = SEQ(name='SSBAreaCapacityValue-Item', mode=MODE_TYPE)
    _SSBAreaCapacityValue_Item_ssbIndex = INT(name='ssbIndex', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'SSBIndex')))
    _SSBAreaCapacityValue_Item_ssbAreaCapacityValue = INT(name='ssbAreaCapacityValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SSBAreaCapacityValue_Item_ssbAreaCapacityValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _SSBAreaCapacityValue_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SSBAreaCapacityValue_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___SSBAreaCapacityValue_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____SSBAreaCapacityValue_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____SSBAreaCapacityValue_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSBAreaCapacityValue_Item_iE_Extensions__item__id._const_tab = ____SSBAreaCapacityValue_Item_iE_Extensions__item__id_tab
    ___SSBAreaCapacityValue_Item_iE_Extensions__item__id._const_tab_at = None
    ___SSBAreaCapacityValue_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___SSBAreaCapacityValue_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SSBAreaCapacityValue_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____SSBAreaCapacityValue_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSBAreaCapacityValue_Item_iE_Extensions__item__criticality._const_tab = ____SSBAreaCapacityValue_Item_iE_Extensions__item__criticality_tab
    ___SSBAreaCapacityValue_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SSBAreaCapacityValue_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SSBAreaCapacityValue_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SSBAreaCapacityValue_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____SSBAreaCapacityValue_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSBAreaCapacityValue_Item_iE_Extensions__item__extensionValue._const_tab = ____SSBAreaCapacityValue_Item_iE_Extensions__item__extensionValue_tab
    ___SSBAreaCapacityValue_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SSBAreaCapacityValue_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SSBAreaCapacityValue_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SSBAreaCapacityValue_Item_iE_Extensions__item__id),
        ('criticality', ___SSBAreaCapacityValue_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___SSBAreaCapacityValue_Item_iE_Extensions__item__extensionValue),
        ])
    __SSBAreaCapacityValue_Item_iE_Extensions__item_._ext = None
    _SSBAreaCapacityValue_Item_iE_Extensions._cont = __SSBAreaCapacityValue_Item_iE_Extensions__item_
    _SSBAreaCapacityValue_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SSBAreaCapacityValue_Item._cont = ASN1Dict([
        ('ssbIndex', _SSBAreaCapacityValue_Item_ssbIndex),
        ('ssbAreaCapacityValue', _SSBAreaCapacityValue_Item_ssbAreaCapacityValue),
        ('iE-Extensions', _SSBAreaCapacityValue_Item_iE_Extensions),
        ])
    SSBAreaCapacityValue_Item._ext = []
    
    #-----< SSBAreaCapacityValue-ExtIEs >-----#
    SSBAreaCapacityValue_ExtIEs = CLASS(name='SSBAreaCapacityValue-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    SSBAreaCapacityValue_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SSBAreaRadioResourceStatus-List >-----#
    SSBAreaRadioResourceStatus_List = SEQ_OF(name='SSBAreaRadioResourceStatus-List', mode=MODE_TYPE)
    _SSBAreaRadioResourceStatus_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SSBAreaRadioResourceStatus-Item')))
    SSBAreaRadioResourceStatus_List._cont = _SSBAreaRadioResourceStatus_List__item_
    SSBAreaRadioResourceStatus_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< SSBAreaRadioResourceStatus-Item >-----#
    SSBAreaRadioResourceStatus_Item = SEQ(name='SSBAreaRadioResourceStatus-Item', mode=MODE_TYPE)
    _SSBAreaRadioResourceStatus_Item_ssbIndex = INT(name='ssbIndex', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'SSBIndex')))
    _SSBAreaRadioResourceStatus_Item_ssbAreaDLGBRPRBUsage = INT(name='ssbAreaDLGBRPRBUsage', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SSBAreaRadioResourceStatus_Item_ssbAreaDLGBRPRBUsage._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _SSBAreaRadioResourceStatus_Item_ssbAreaULGBRPRBUsage = INT(name='ssbAreaULGBRPRBUsage', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SSBAreaRadioResourceStatus_Item_ssbAreaULGBRPRBUsage._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _SSBAreaRadioResourceStatus_Item_ssbAreaDLNonGBRPRBUsage = INT(name='ssbAreaDLNonGBRPRBUsage', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SSBAreaRadioResourceStatus_Item_ssbAreaDLNonGBRPRBUsage._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _SSBAreaRadioResourceStatus_Item_ssbAreaULNonGBRPRBUsage = INT(name='ssbAreaULNonGBRPRBUsage', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SSBAreaRadioResourceStatus_Item_ssbAreaULNonGBRPRBUsage._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _SSBAreaRadioResourceStatus_Item_ssbAreaDLTotalPRBUsage = INT(name='ssbAreaDLTotalPRBUsage', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SSBAreaRadioResourceStatus_Item_ssbAreaDLTotalPRBUsage._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _SSBAreaRadioResourceStatus_Item_ssbAreaULTotalPRBUsage = INT(name='ssbAreaULTotalPRBUsage', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SSBAreaRadioResourceStatus_Item_ssbAreaULTotalPRBUsage._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _SSBAreaRadioResourceStatus_Item_ssbAreaDLSchedulingPDCCHCCEUsage = INT(name='ssbAreaDLSchedulingPDCCHCCEUsage', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SSBAreaRadioResourceStatus_Item_ssbAreaDLSchedulingPDCCHCCEUsage._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _SSBAreaRadioResourceStatus_Item_ssbAreaULSchedulingPDCCHCCEUsage = INT(name='ssbAreaULSchedulingPDCCHCCEUsage', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SSBAreaRadioResourceStatus_Item_ssbAreaULSchedulingPDCCHCCEUsage._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _SSBAreaRadioResourceStatus_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SSBAreaRadioResourceStatus_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___SSBAreaRadioResourceStatus_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____SSBAreaRadioResourceStatus_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____SSBAreaRadioResourceStatus_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSBAreaRadioResourceStatus_Item_iE_Extensions__item__id._const_tab = ____SSBAreaRadioResourceStatus_Item_iE_Extensions__item__id_tab
    ___SSBAreaRadioResourceStatus_Item_iE_Extensions__item__id._const_tab_at = None
    ___SSBAreaRadioResourceStatus_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___SSBAreaRadioResourceStatus_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SSBAreaRadioResourceStatus_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____SSBAreaRadioResourceStatus_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSBAreaRadioResourceStatus_Item_iE_Extensions__item__criticality._const_tab = ____SSBAreaRadioResourceStatus_Item_iE_Extensions__item__criticality_tab
    ___SSBAreaRadioResourceStatus_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SSBAreaRadioResourceStatus_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SSBAreaRadioResourceStatus_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SSBAreaRadioResourceStatus_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____SSBAreaRadioResourceStatus_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSBAreaRadioResourceStatus_Item_iE_Extensions__item__extensionValue._const_tab = ____SSBAreaRadioResourceStatus_Item_iE_Extensions__item__extensionValue_tab
    ___SSBAreaRadioResourceStatus_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SSBAreaRadioResourceStatus_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SSBAreaRadioResourceStatus_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SSBAreaRadioResourceStatus_Item_iE_Extensions__item__id),
        ('criticality', ___SSBAreaRadioResourceStatus_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___SSBAreaRadioResourceStatus_Item_iE_Extensions__item__extensionValue),
        ])
    __SSBAreaRadioResourceStatus_Item_iE_Extensions__item_._ext = None
    _SSBAreaRadioResourceStatus_Item_iE_Extensions._cont = __SSBAreaRadioResourceStatus_Item_iE_Extensions__item_
    _SSBAreaRadioResourceStatus_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SSBAreaRadioResourceStatus_Item._cont = ASN1Dict([
        ('ssbIndex', _SSBAreaRadioResourceStatus_Item_ssbIndex),
        ('ssbAreaDLGBRPRBUsage', _SSBAreaRadioResourceStatus_Item_ssbAreaDLGBRPRBUsage),
        ('ssbAreaULGBRPRBUsage', _SSBAreaRadioResourceStatus_Item_ssbAreaULGBRPRBUsage),
        ('ssbAreaDLNonGBRPRBUsage', _SSBAreaRadioResourceStatus_Item_ssbAreaDLNonGBRPRBUsage),
        ('ssbAreaULNonGBRPRBUsage', _SSBAreaRadioResourceStatus_Item_ssbAreaULNonGBRPRBUsage),
        ('ssbAreaDLTotalPRBUsage', _SSBAreaRadioResourceStatus_Item_ssbAreaDLTotalPRBUsage),
        ('ssbAreaULTotalPRBUsage', _SSBAreaRadioResourceStatus_Item_ssbAreaULTotalPRBUsage),
        ('ssbAreaDLSchedulingPDCCHCCEUsage', _SSBAreaRadioResourceStatus_Item_ssbAreaDLSchedulingPDCCHCCEUsage),
        ('ssbAreaULSchedulingPDCCHCCEUsage', _SSBAreaRadioResourceStatus_Item_ssbAreaULSchedulingPDCCHCCEUsage),
        ('iE-Extensions', _SSBAreaRadioResourceStatus_Item_iE_Extensions),
        ])
    SSBAreaRadioResourceStatus_Item._ext = []
    
    #-----< SSBAreaRadioResourceStatus-ExtIEs >-----#
    SSBAreaRadioResourceStatus_ExtIEs = CLASS(name='SSBAreaRadioResourceStatus-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    SSBAreaRadioResourceStatus_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SSBIndex >-----#
    SSBIndex = INT(name='SSBIndex', mode=MODE_TYPE)
    SSBIndex._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    
    #-----< SSB-PositionsInBurst >-----#
    SSB_PositionsInBurst = CHOICE(name='SSB-PositionsInBurst', mode=MODE_TYPE)
    _SSB_PositionsInBurst_shortBitmap = BIT_STR(name='shortBitmap', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SSB_PositionsInBurst_shortBitmap._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _SSB_PositionsInBurst_mediumBitmap = BIT_STR(name='mediumBitmap', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SSB_PositionsInBurst_mediumBitmap._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _SSB_PositionsInBurst_longBitmap = BIT_STR(name='longBitmap', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SSB_PositionsInBurst_longBitmap._const_sz = ASN1Set(rv=[64], rr=[], ev=None, er=[])
    _SSB_PositionsInBurst_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __SSB_PositionsInBurst_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ___SSB_PositionsInBurst_choice_extension_id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ___SSB_PositionsInBurst_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SSB_PositionsInBurst_choice_extension_id._const_tab = ___SSB_PositionsInBurst_choice_extension_id_tab
    __SSB_PositionsInBurst_choice_extension_id._const_tab_at = None
    __SSB_PositionsInBurst_choice_extension_id._const_tab_id = 'id'
    __SSB_PositionsInBurst_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___SSB_PositionsInBurst_choice_extension_criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ___SSB_PositionsInBurst_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SSB_PositionsInBurst_choice_extension_criticality._const_tab = ___SSB_PositionsInBurst_choice_extension_criticality_tab
    __SSB_PositionsInBurst_choice_extension_criticality._const_tab_at = ('..', 'id')
    __SSB_PositionsInBurst_choice_extension_criticality._const_tab_id = 'criticality'
    __SSB_PositionsInBurst_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___SSB_PositionsInBurst_choice_extension_value_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ___SSB_PositionsInBurst_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SSB_PositionsInBurst_choice_extension_value._const_tab = ___SSB_PositionsInBurst_choice_extension_value_tab
    __SSB_PositionsInBurst_choice_extension_value._const_tab_at = ('..', 'id')
    __SSB_PositionsInBurst_choice_extension_value._const_tab_id = 'Value'
    _SSB_PositionsInBurst_choice_extension._cont = ASN1Dict([
        ('id', __SSB_PositionsInBurst_choice_extension_id),
        ('criticality', __SSB_PositionsInBurst_choice_extension_criticality),
        ('value', __SSB_PositionsInBurst_choice_extension_value),
        ])
    _SSB_PositionsInBurst_choice_extension._ext = None
    SSB_PositionsInBurst._cont = ASN1Dict([
        ('shortBitmap', _SSB_PositionsInBurst_shortBitmap),
        ('mediumBitmap', _SSB_PositionsInBurst_mediumBitmap),
        ('longBitmap', _SSB_PositionsInBurst_longBitmap),
        ('choice-extension', _SSB_PositionsInBurst_choice_extension),
        ])
    SSB_PositionsInBurst._ext = None
    
    #-----< SSB-PositionsInBurst-ExtIEs >-----#
    SSB_PositionsInBurst_ExtIEs = CLASS(name='SSB-PositionsInBurst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    SSB_PositionsInBurst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SubbandCQI-ExtIEs >-----#
    SubbandCQI_ExtIEs = CLASS(name='SubbandCQI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    SubbandCQI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SubbandCQICodeword0 >-----#
    SubbandCQICodeword0 = CHOICE(name='SubbandCQICodeword0', mode=MODE_TYPE)
    _SubbandCQICodeword0_four_bitCQI = INT(name='four-bitCQI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SubbandCQICodeword0_four_bitCQI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=[], er=[])
    _SubbandCQICodeword0_two_bitSubbandDifferentialCQI = INT(name='two-bitSubbandDifferentialCQI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SubbandCQICodeword0_two_bitSubbandDifferentialCQI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=[], er=[])
    _SubbandCQICodeword0_two_bitDifferentialCQI = INT(name='two-bitDifferentialCQI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SubbandCQICodeword0_two_bitDifferentialCQI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=[], er=[])
    SubbandCQICodeword0._cont = ASN1Dict([
        ('four-bitCQI', _SubbandCQICodeword0_four_bitCQI),
        ('two-bitSubbandDifferentialCQI', _SubbandCQICodeword0_two_bitSubbandDifferentialCQI),
        ('two-bitDifferentialCQI', _SubbandCQICodeword0_two_bitDifferentialCQI),
        ])
    SubbandCQICodeword0._ext = []
    
    #-----< SubbandCQICodeword1 >-----#
    SubbandCQICodeword1 = CHOICE(name='SubbandCQICodeword1', mode=MODE_TYPE)
    _SubbandCQICodeword1_four_bitCQI = INT(name='four-bitCQI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SubbandCQICodeword1_four_bitCQI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=[], er=[])
    _SubbandCQICodeword1_three_bitSpatialDifferentialCQI = INT(name='three-bitSpatialDifferentialCQI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SubbandCQICodeword1_three_bitSpatialDifferentialCQI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=[], er=[])
    _SubbandCQICodeword1_two_bitSubbandDifferentialCQI = INT(name='two-bitSubbandDifferentialCQI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SubbandCQICodeword1_two_bitSubbandDifferentialCQI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=[], er=[])
    _SubbandCQICodeword1_two_bitDifferentialCQI = INT(name='two-bitDifferentialCQI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SubbandCQICodeword1_two_bitDifferentialCQI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=[], er=[])
    SubbandCQICodeword1._cont = ASN1Dict([
        ('four-bitCQI', _SubbandCQICodeword1_four_bitCQI),
        ('three-bitSpatialDifferentialCQI', _SubbandCQICodeword1_three_bitSpatialDifferentialCQI),
        ('two-bitSubbandDifferentialCQI', _SubbandCQICodeword1_two_bitSubbandDifferentialCQI),
        ('two-bitDifferentialCQI', _SubbandCQICodeword1_two_bitDifferentialCQI),
        ])
    SubbandCQICodeword1._ext = []
    
    #-----< SubbandCQIList >-----#
    SubbandCQIList = SEQ_OF(name='SubbandCQIList', mode=MODE_TYPE)
    _SubbandCQIList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SubbandCQIItem')))
    SubbandCQIList._cont = _SubbandCQIList__item_
    SubbandCQIList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=14)], ev=None, er=[])
    
    #-----< SubbandCQIItem >-----#
    SubbandCQIItem = SEQ(name='SubbandCQIItem', mode=MODE_TYPE)
    _SubbandCQIItem_subbandCQI = SEQ(name='subbandCQI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'SubbandCQI')))
    _SubbandCQIItem_subbandIndex = INT(name='subbandIndex', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SubbandCQIItem_subbandIndex._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=27)], ev=[], er=[])
    _SubbandCQIItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SubbandCQIItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___SubbandCQIItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____SubbandCQIItem_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____SubbandCQIItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SubbandCQIItem_iE_Extensions__item__id._const_tab = ____SubbandCQIItem_iE_Extensions__item__id_tab
    ___SubbandCQIItem_iE_Extensions__item__id._const_tab_at = None
    ___SubbandCQIItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___SubbandCQIItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SubbandCQIItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____SubbandCQIItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SubbandCQIItem_iE_Extensions__item__criticality._const_tab = ____SubbandCQIItem_iE_Extensions__item__criticality_tab
    ___SubbandCQIItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SubbandCQIItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SubbandCQIItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SubbandCQIItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____SubbandCQIItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SubbandCQIItem_iE_Extensions__item__extensionValue._const_tab = ____SubbandCQIItem_iE_Extensions__item__extensionValue_tab
    ___SubbandCQIItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SubbandCQIItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SubbandCQIItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SubbandCQIItem_iE_Extensions__item__id),
        ('criticality', ___SubbandCQIItem_iE_Extensions__item__criticality),
        ('extensionValue', ___SubbandCQIItem_iE_Extensions__item__extensionValue),
        ])
    __SubbandCQIItem_iE_Extensions__item_._ext = None
    _SubbandCQIItem_iE_Extensions._cont = __SubbandCQIItem_iE_Extensions__item_
    _SubbandCQIItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SubbandCQIItem._cont = ASN1Dict([
        ('subbandCQI', _SubbandCQIItem_subbandCQI),
        ('subbandIndex', _SubbandCQIItem_subbandIndex),
        ('iE-Extensions', _SubbandCQIItem_iE_Extensions),
        ])
    SubbandCQIItem._ext = []
    
    #-----< SubbandCQIItem-ExtIEs >-----#
    SubbandCQIItem_ExtIEs = CLASS(name='SubbandCQIItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    SubbandCQIItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SubbandSize >-----#
    SubbandSize = ENUM(name='SubbandSize', mode=MODE_TYPE)
    SubbandSize._cont = ASN1Dict([('size2', 0), ('size3', 1), ('size4', 2), ('size6', 3), ('size8', 4)])
    SubbandSize._ext = []
    
    #-----< SubscriberProfileIDforRFP >-----#
    SubscriberProfileIDforRFP = INT(name='SubscriberProfileIDforRFP', mode=MODE_TYPE)
    SubscriberProfileIDforRFP._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< SubframeAllocation >-----#
    SubframeAllocation = CHOICE(name='SubframeAllocation', mode=MODE_TYPE)
    _SubframeAllocation_oneframe = BIT_STR(name='oneframe', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'Oneframe')))
    _SubframeAllocation_fourframes = BIT_STR(name='fourframes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'Fourframes')))
    SubframeAllocation._cont = ASN1Dict([
        ('oneframe', _SubframeAllocation_oneframe),
        ('fourframes', _SubframeAllocation_fourframes),
        ])
    SubframeAllocation._ext = []
    
    #-----< SubframeAssignment >-----#
    SubframeAssignment = ENUM(name='SubframeAssignment', mode=MODE_TYPE)
    SubframeAssignment._cont = ASN1Dict([('sa0', 0), ('sa1', 1), ('sa2', 2), ('sa3', 3), ('sa4', 4), ('sa5', 5), ('sa6', 6)])
    SubframeAssignment._ext = []
    
    #-----< SubframeType >-----#
    SubframeType = ENUM(name='SubframeType', mode=MODE_TYPE)
    SubframeType._cont = ASN1Dict([('mbsfn', 0), ('nonmbsfn', 1)])
    SubframeType._ext = []
    
    #-----< SgNBSecurityKey >-----#
    SgNBSecurityKey = BIT_STR(name='SgNBSecurityKey', mode=MODE_TYPE)
    SgNBSecurityKey._const_sz = ASN1Set(rv=[256], rr=[], ev=None, er=[])
    
    #-----< SgNBtoMeNBContainer >-----#
    SgNBtoMeNBContainer = OCT_STR(name='SgNBtoMeNBContainer', mode=MODE_TYPE)
    
    #-----< SRBType >-----#
    SRBType = ENUM(name='SRBType', mode=MODE_TYPE)
    SRBType._cont = ASN1Dict([('srb1', 0), ('srb2', 1)])
    SRBType._ext = []
    
    #-----< SCGConfigurationQuery >-----#
    SCGConfigurationQuery = ENUM(name='SCGConfigurationQuery', mode=MODE_TYPE)
    SCGConfigurationQuery._cont = ASN1Dict([('true', 0)])
    SCGConfigurationQuery._ext = []
    
    #-----< SULInformation >-----#
    SULInformation = SEQ(name='SULInformation', mode=MODE_TYPE)
    _SULInformation_sUL_ARFCN = INT(name='sUL-ARFCN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SULInformation_sUL_ARFCN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3279165)], ev=None, er=[])
    _SULInformation_sUL_TxBW = SEQ(name='sUL-TxBW', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'NR-TxBW')))
    _SULInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SULInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___SULInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____SULInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____SULInformation_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'NRCarrierList')))
    _____SULInformation_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'FrequencyShift7p5khz')))
    ____SULInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 386), ('criticality', 'ignore'), ('Extension', _____SULInformation_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 388), ('criticality', 'ignore'), ('Extension', _____SULInformation_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SULInformation_iE_Extensions__item__id._const_tab = ____SULInformation_iE_Extensions__item__id_tab
    ___SULInformation_iE_Extensions__item__id._const_tab_at = None
    ___SULInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___SULInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___SULInformation_iE_Extensions__item__criticality._const_tab = ____SULInformation_iE_Extensions__item__id_tab
    ___SULInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SULInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SULInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___SULInformation_iE_Extensions__item__extensionValue._const_tab = ____SULInformation_iE_Extensions__item__id_tab
    ___SULInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SULInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SULInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SULInformation_iE_Extensions__item__id),
        ('criticality', ___SULInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___SULInformation_iE_Extensions__item__extensionValue),
        ])
    __SULInformation_iE_Extensions__item_._ext = None
    _SULInformation_iE_Extensions._cont = __SULInformation_iE_Extensions__item_
    _SULInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SULInformation._cont = ASN1Dict([
        ('sUL-ARFCN', _SULInformation_sUL_ARFCN),
        ('sUL-TxBW', _SULInformation_sUL_TxBW),
        ('iE-Extensions', _SULInformation_iE_Extensions),
        ])
    SULInformation._ext = []
    
    #-----< SupportedSULFreqBandItem >-----#
    SupportedSULFreqBandItem = SEQ(name='SupportedSULFreqBandItem', mode=MODE_TYPE)
    _SupportedSULFreqBandItem_freqBandIndicatorNr = INT(name='freqBandIndicatorNr', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SupportedSULFreqBandItem_freqBandIndicatorNr._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=[], er=[])
    _SupportedSULFreqBandItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SupportedSULFreqBandItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___SupportedSULFreqBandItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____SupportedSULFreqBandItem_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____SupportedSULFreqBandItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SupportedSULFreqBandItem_iE_Extensions__item__id._const_tab = ____SupportedSULFreqBandItem_iE_Extensions__item__id_tab
    ___SupportedSULFreqBandItem_iE_Extensions__item__id._const_tab_at = None
    ___SupportedSULFreqBandItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___SupportedSULFreqBandItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SupportedSULFreqBandItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____SupportedSULFreqBandItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SupportedSULFreqBandItem_iE_Extensions__item__criticality._const_tab = ____SupportedSULFreqBandItem_iE_Extensions__item__criticality_tab
    ___SupportedSULFreqBandItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SupportedSULFreqBandItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SupportedSULFreqBandItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SupportedSULFreqBandItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____SupportedSULFreqBandItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SupportedSULFreqBandItem_iE_Extensions__item__extensionValue._const_tab = ____SupportedSULFreqBandItem_iE_Extensions__item__extensionValue_tab
    ___SupportedSULFreqBandItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SupportedSULFreqBandItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SupportedSULFreqBandItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SupportedSULFreqBandItem_iE_Extensions__item__id),
        ('criticality', ___SupportedSULFreqBandItem_iE_Extensions__item__criticality),
        ('extensionValue', ___SupportedSULFreqBandItem_iE_Extensions__item__extensionValue),
        ])
    __SupportedSULFreqBandItem_iE_Extensions__item_._ext = None
    _SupportedSULFreqBandItem_iE_Extensions._cont = __SupportedSULFreqBandItem_iE_Extensions__item_
    _SupportedSULFreqBandItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SupportedSULFreqBandItem._cont = ASN1Dict([
        ('freqBandIndicatorNr', _SupportedSULFreqBandItem_freqBandIndicatorNr),
        ('iE-Extensions', _SupportedSULFreqBandItem_iE_Extensions),
        ])
    SupportedSULFreqBandItem._ext = []
    
    #-----< SupportedSULFreqBandItem-ExtIEs >-----#
    SupportedSULFreqBandItem_ExtIEs = CLASS(name='SupportedSULFreqBandItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    SupportedSULFreqBandItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SULInformation-ExtIEs >-----#
    SULInformation_ExtIEs = CLASS(name='SULInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _SULInformation_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'NRCarrierList')))
    _SULInformation_ExtIEs_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'FrequencyShift7p5khz')))
    SULInformation_ExtIEs._val = ASN1Set(rv=[dict([('id', 386), ('criticality', 'ignore'), ('Extension', _SULInformation_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 388), ('criticality', 'ignore'), ('Extension', _SULInformation_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< SFN-Offset >-----#
    SFN_Offset = SEQ(name='SFN-Offset', mode=MODE_TYPE)
    _SFN_Offset_sFN_Time_Offset = BIT_STR(name='sFN-Time-Offset', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SFN_Offset_sFN_Time_Offset._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _SFN_Offset_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SFN_Offset_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___SFN_Offset_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____SFN_Offset_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____SFN_Offset_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SFN_Offset_iE_Extensions__item__id._const_tab = ____SFN_Offset_iE_Extensions__item__id_tab
    ___SFN_Offset_iE_Extensions__item__id._const_tab_at = None
    ___SFN_Offset_iE_Extensions__item__id._const_tab_id = 'id'
    ___SFN_Offset_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SFN_Offset_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____SFN_Offset_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SFN_Offset_iE_Extensions__item__criticality._const_tab = ____SFN_Offset_iE_Extensions__item__criticality_tab
    ___SFN_Offset_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SFN_Offset_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SFN_Offset_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SFN_Offset_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____SFN_Offset_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SFN_Offset_iE_Extensions__item__extensionValue._const_tab = ____SFN_Offset_iE_Extensions__item__extensionValue_tab
    ___SFN_Offset_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SFN_Offset_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SFN_Offset_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SFN_Offset_iE_Extensions__item__id),
        ('criticality', ___SFN_Offset_iE_Extensions__item__criticality),
        ('extensionValue', ___SFN_Offset_iE_Extensions__item__extensionValue),
        ])
    __SFN_Offset_iE_Extensions__item_._ext = None
    _SFN_Offset_iE_Extensions._cont = __SFN_Offset_iE_Extensions__item_
    _SFN_Offset_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SFN_Offset._cont = ASN1Dict([
        ('sFN-Time-Offset', _SFN_Offset_sFN_Time_Offset),
        ('iE-Extensions', _SFN_Offset_iE_Extensions),
        ])
    SFN_Offset._ext = []
    
    #-----< SFN-Offset-ExtIEs >-----#
    SFN_Offset_ExtIEs = CLASS(name='SFN-Offset-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    SFN_Offset_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TABasedMDT >-----#
    TABasedMDT = SEQ(name='TABasedMDT', mode=MODE_TYPE)
    _TABasedMDT_tAListforMDT = SEQ_OF(name='tAListforMDT', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'TAListforMDT')))
    _TABasedMDT_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TABasedMDT_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___TABasedMDT_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____TABasedMDT_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____TABasedMDT_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TABasedMDT_iE_Extensions__item__id._const_tab = ____TABasedMDT_iE_Extensions__item__id_tab
    ___TABasedMDT_iE_Extensions__item__id._const_tab_at = None
    ___TABasedMDT_iE_Extensions__item__id._const_tab_id = 'id'
    ___TABasedMDT_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TABasedMDT_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____TABasedMDT_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TABasedMDT_iE_Extensions__item__criticality._const_tab = ____TABasedMDT_iE_Extensions__item__criticality_tab
    ___TABasedMDT_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TABasedMDT_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TABasedMDT_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TABasedMDT_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____TABasedMDT_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TABasedMDT_iE_Extensions__item__extensionValue._const_tab = ____TABasedMDT_iE_Extensions__item__extensionValue_tab
    ___TABasedMDT_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TABasedMDT_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TABasedMDT_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TABasedMDT_iE_Extensions__item__id),
        ('criticality', ___TABasedMDT_iE_Extensions__item__criticality),
        ('extensionValue', ___TABasedMDT_iE_Extensions__item__extensionValue),
        ])
    __TABasedMDT_iE_Extensions__item_._ext = None
    _TABasedMDT_iE_Extensions._cont = __TABasedMDT_iE_Extensions__item_
    _TABasedMDT_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TABasedMDT._cont = ASN1Dict([
        ('tAListforMDT', _TABasedMDT_tAListforMDT),
        ('iE-Extensions', _TABasedMDT_iE_Extensions),
        ])
    TABasedMDT._ext = []
    
    #-----< TABasedMDT-ExtIEs >-----#
    TABasedMDT_ExtIEs = CLASS(name='TABasedMDT-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    TABasedMDT_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TAC >-----#
    TAC = OCT_STR(name='TAC', mode=MODE_TYPE)
    TAC._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< TAIBasedMDT >-----#
    TAIBasedMDT = SEQ(name='TAIBasedMDT', mode=MODE_TYPE)
    _TAIBasedMDT_tAIListforMDT = SEQ_OF(name='tAIListforMDT', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'TAIListforMDT')))
    _TAIBasedMDT_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TAIBasedMDT_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___TAIBasedMDT_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____TAIBasedMDT_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____TAIBasedMDT_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAIBasedMDT_iE_Extensions__item__id._const_tab = ____TAIBasedMDT_iE_Extensions__item__id_tab
    ___TAIBasedMDT_iE_Extensions__item__id._const_tab_at = None
    ___TAIBasedMDT_iE_Extensions__item__id._const_tab_id = 'id'
    ___TAIBasedMDT_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TAIBasedMDT_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____TAIBasedMDT_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAIBasedMDT_iE_Extensions__item__criticality._const_tab = ____TAIBasedMDT_iE_Extensions__item__criticality_tab
    ___TAIBasedMDT_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TAIBasedMDT_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TAIBasedMDT_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TAIBasedMDT_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____TAIBasedMDT_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAIBasedMDT_iE_Extensions__item__extensionValue._const_tab = ____TAIBasedMDT_iE_Extensions__item__extensionValue_tab
    ___TAIBasedMDT_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TAIBasedMDT_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TAIBasedMDT_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TAIBasedMDT_iE_Extensions__item__id),
        ('criticality', ___TAIBasedMDT_iE_Extensions__item__criticality),
        ('extensionValue', ___TAIBasedMDT_iE_Extensions__item__extensionValue),
        ])
    __TAIBasedMDT_iE_Extensions__item_._ext = None
    _TAIBasedMDT_iE_Extensions._cont = __TAIBasedMDT_iE_Extensions__item_
    _TAIBasedMDT_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TAIBasedMDT._cont = ASN1Dict([
        ('tAIListforMDT', _TAIBasedMDT_tAIListforMDT),
        ('iE-Extensions', _TAIBasedMDT_iE_Extensions),
        ])
    TAIBasedMDT._ext = []
    
    #-----< TAIBasedMDT-ExtIEs >-----#
    TAIBasedMDT_ExtIEs = CLASS(name='TAIBasedMDT-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    TAIBasedMDT_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TAIListforMDT >-----#
    TAIListforMDT = SEQ_OF(name='TAIListforMDT', mode=MODE_TYPE)
    _TAIListforMDT__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TAI-Item')))
    TAIListforMDT._cont = _TAIListforMDT__item_
    TAIListforMDT._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< TAI-Item >-----#
    TAI_Item = SEQ(name='TAI-Item', mode=MODE_TYPE)
    _TAI_Item_tAC = OCT_STR(name='tAC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'TAC')))
    _TAI_Item_pLMN_Identity = OCT_STR(name='pLMN-Identity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'PLMN-Identity')))
    _TAI_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TAI_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___TAI_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____TAI_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____TAI_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAI_Item_iE_Extensions__item__id._const_tab = ____TAI_Item_iE_Extensions__item__id_tab
    ___TAI_Item_iE_Extensions__item__id._const_tab_at = None
    ___TAI_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___TAI_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TAI_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____TAI_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAI_Item_iE_Extensions__item__criticality._const_tab = ____TAI_Item_iE_Extensions__item__criticality_tab
    ___TAI_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TAI_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TAI_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TAI_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____TAI_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAI_Item_iE_Extensions__item__extensionValue._const_tab = ____TAI_Item_iE_Extensions__item__extensionValue_tab
    ___TAI_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TAI_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TAI_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TAI_Item_iE_Extensions__item__id),
        ('criticality', ___TAI_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___TAI_Item_iE_Extensions__item__extensionValue),
        ])
    __TAI_Item_iE_Extensions__item_._ext = None
    _TAI_Item_iE_Extensions._cont = __TAI_Item_iE_Extensions__item_
    _TAI_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TAI_Item._cont = ASN1Dict([
        ('tAC', _TAI_Item_tAC),
        ('pLMN-Identity', _TAI_Item_pLMN_Identity),
        ('iE-Extensions', _TAI_Item_iE_Extensions),
        ])
    TAI_Item._ext = []
    
    #-----< TAI-Item-ExtIEs >-----#
    TAI_Item_ExtIEs = CLASS(name='TAI-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    TAI_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TAListforMDT >-----#
    TAListforMDT = SEQ_OF(name='TAListforMDT', mode=MODE_TYPE)
    _TAListforMDT__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TAC')))
    TAListforMDT._cont = _TAListforMDT__item_
    TAListforMDT._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< TABasedQMC >-----#
    TABasedQMC = SEQ(name='TABasedQMC', mode=MODE_TYPE)
    _TABasedQMC_tAListforQMC = SEQ_OF(name='tAListforQMC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'TAListforQMC')))
    _TABasedQMC_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TABasedQMC_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___TABasedQMC_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____TABasedQMC_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____TABasedQMC_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TABasedQMC_iE_Extensions__item__id._const_tab = ____TABasedQMC_iE_Extensions__item__id_tab
    ___TABasedQMC_iE_Extensions__item__id._const_tab_at = None
    ___TABasedQMC_iE_Extensions__item__id._const_tab_id = 'id'
    ___TABasedQMC_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TABasedQMC_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____TABasedQMC_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TABasedQMC_iE_Extensions__item__criticality._const_tab = ____TABasedQMC_iE_Extensions__item__criticality_tab
    ___TABasedQMC_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TABasedQMC_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TABasedQMC_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TABasedQMC_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____TABasedQMC_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TABasedQMC_iE_Extensions__item__extensionValue._const_tab = ____TABasedQMC_iE_Extensions__item__extensionValue_tab
    ___TABasedQMC_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TABasedQMC_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TABasedQMC_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TABasedQMC_iE_Extensions__item__id),
        ('criticality', ___TABasedQMC_iE_Extensions__item__criticality),
        ('extensionValue', ___TABasedQMC_iE_Extensions__item__extensionValue),
        ])
    __TABasedQMC_iE_Extensions__item_._ext = None
    _TABasedQMC_iE_Extensions._cont = __TABasedQMC_iE_Extensions__item_
    _TABasedQMC_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TABasedQMC._cont = ASN1Dict([
        ('tAListforQMC', _TABasedQMC_tAListforQMC),
        ('iE-Extensions', _TABasedQMC_iE_Extensions),
        ])
    TABasedQMC._ext = []
    
    #-----< TABasedQMC-ExtIEs >-----#
    TABasedQMC_ExtIEs = CLASS(name='TABasedQMC-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    TABasedQMC_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TAListforQMC >-----#
    TAListforQMC = SEQ_OF(name='TAListforQMC', mode=MODE_TYPE)
    _TAListforQMC__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TAC')))
    TAListforQMC._cont = _TAListforQMC__item_
    TAListforQMC._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< TAIBasedQMC >-----#
    TAIBasedQMC = SEQ(name='TAIBasedQMC', mode=MODE_TYPE)
    _TAIBasedQMC_tAIListforQMC = SEQ_OF(name='tAIListforQMC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'TAIListforQMC')))
    _TAIBasedQMC_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TAIBasedQMC_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___TAIBasedQMC_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____TAIBasedQMC_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____TAIBasedQMC_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAIBasedQMC_iE_Extensions__item__id._const_tab = ____TAIBasedQMC_iE_Extensions__item__id_tab
    ___TAIBasedQMC_iE_Extensions__item__id._const_tab_at = None
    ___TAIBasedQMC_iE_Extensions__item__id._const_tab_id = 'id'
    ___TAIBasedQMC_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TAIBasedQMC_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____TAIBasedQMC_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAIBasedQMC_iE_Extensions__item__criticality._const_tab = ____TAIBasedQMC_iE_Extensions__item__criticality_tab
    ___TAIBasedQMC_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TAIBasedQMC_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TAIBasedQMC_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TAIBasedQMC_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____TAIBasedQMC_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAIBasedQMC_iE_Extensions__item__extensionValue._const_tab = ____TAIBasedQMC_iE_Extensions__item__extensionValue_tab
    ___TAIBasedQMC_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TAIBasedQMC_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TAIBasedQMC_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TAIBasedQMC_iE_Extensions__item__id),
        ('criticality', ___TAIBasedQMC_iE_Extensions__item__criticality),
        ('extensionValue', ___TAIBasedQMC_iE_Extensions__item__extensionValue),
        ])
    __TAIBasedQMC_iE_Extensions__item_._ext = None
    _TAIBasedQMC_iE_Extensions._cont = __TAIBasedQMC_iE_Extensions__item_
    _TAIBasedQMC_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TAIBasedQMC._cont = ASN1Dict([
        ('tAIListforQMC', _TAIBasedQMC_tAIListforQMC),
        ('iE-Extensions', _TAIBasedQMC_iE_Extensions),
        ])
    TAIBasedQMC._ext = []
    
    #-----< TAIBasedQMC-ExtIEs >-----#
    TAIBasedQMC_ExtIEs = CLASS(name='TAIBasedQMC-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    TAIBasedQMC_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TAIListforQMC >-----#
    TAIListforQMC = SEQ_OF(name='TAIListforQMC', mode=MODE_TYPE)
    _TAIListforQMC__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TAI-Item')))
    TAIListforQMC._cont = _TAIListforQMC__item_
    TAIListforQMC._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< TargetCellInNGRAN >-----#
    TargetCellInNGRAN = OCT_STR(name='TargetCellInNGRAN', mode=MODE_TYPE)
    
    #-----< TargetCellInUTRAN >-----#
    TargetCellInUTRAN = OCT_STR(name='TargetCellInUTRAN', mode=MODE_TYPE)
    
    #-----< TargeteNBtoSource-eNBTransparentContainer >-----#
    TargeteNBtoSource_eNBTransparentContainer = OCT_STR(name='TargeteNBtoSource-eNBTransparentContainer', mode=MODE_TYPE)
    
    #-----< TDD-Info >-----#
    TDD_Info = SEQ(name='TDD-Info', mode=MODE_TYPE)
    _TDD_Info_eARFCN = INT(name='eARFCN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'EARFCN')))
    _TDD_Info_transmission_Bandwidth = ENUM(name='transmission-Bandwidth', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'Transmission-Bandwidth')))
    _TDD_Info_subframeAssignment = ENUM(name='subframeAssignment', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'SubframeAssignment')))
    _TDD_Info_specialSubframe_Info = SEQ(name='specialSubframe-Info', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'SpecialSubframe-Info')))
    _TDD_Info_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TDD_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___TDD_Info_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____TDD_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____TDD_Info_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'AdditionalSpecialSubframe-Info')))
    _____TDD_Info_iE_Extensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'EARFCNExtension')))
    _____TDD_Info_iE_Extensions__item__id_tab_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'AdditionalSpecialSubframeExtension-Info')))
    _____TDD_Info_iE_Extensions__item__id_tab_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'OffsetOfNbiotChannelNumberToEARFCN')))
    _____TDD_Info_iE_Extensions__item__id_tab_val_Extension_4 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'NBIoT-UL-DL-AlignmentOffset')))
    ____TDD_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 97), ('criticality', 'ignore'), ('Extension', _____TDD_Info_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 94), ('criticality', 'reject'), ('Extension', _____TDD_Info_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 179), ('criticality', 'ignore'), ('Extension', _____TDD_Info_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 177), ('criticality', 'reject'), ('Extension', _____TDD_Info_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 338), ('criticality', 'reject'), ('Extension', _____TDD_Info_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___TDD_Info_iE_Extensions__item__id._const_tab = ____TDD_Info_iE_Extensions__item__id_tab
    ___TDD_Info_iE_Extensions__item__id._const_tab_at = None
    ___TDD_Info_iE_Extensions__item__id._const_tab_id = 'id'
    ___TDD_Info_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___TDD_Info_iE_Extensions__item__criticality._const_tab = ____TDD_Info_iE_Extensions__item__id_tab
    ___TDD_Info_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TDD_Info_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TDD_Info_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___TDD_Info_iE_Extensions__item__extensionValue._const_tab = ____TDD_Info_iE_Extensions__item__id_tab
    ___TDD_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TDD_Info_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TDD_Info_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TDD_Info_iE_Extensions__item__id),
        ('criticality', ___TDD_Info_iE_Extensions__item__criticality),
        ('extensionValue', ___TDD_Info_iE_Extensions__item__extensionValue),
        ])
    __TDD_Info_iE_Extensions__item_._ext = None
    _TDD_Info_iE_Extensions._cont = __TDD_Info_iE_Extensions__item_
    _TDD_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TDD_Info._cont = ASN1Dict([
        ('eARFCN', _TDD_Info_eARFCN),
        ('transmission-Bandwidth', _TDD_Info_transmission_Bandwidth),
        ('subframeAssignment', _TDD_Info_subframeAssignment),
        ('specialSubframe-Info', _TDD_Info_specialSubframe_Info),
        ('iE-Extensions', _TDD_Info_iE_Extensions),
        ])
    TDD_Info._ext = []
    
    #-----< TDD-Info-ExtIEs >-----#
    TDD_Info_ExtIEs = CLASS(name='TDD-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _TDD_Info_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'AdditionalSpecialSubframe-Info')))
    _TDD_Info_ExtIEs_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'EARFCNExtension')))
    _TDD_Info_ExtIEs_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'AdditionalSpecialSubframeExtension-Info')))
    _TDD_Info_ExtIEs_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'OffsetOfNbiotChannelNumberToEARFCN')))
    _TDD_Info_ExtIEs_val_Extension_4 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'NBIoT-UL-DL-AlignmentOffset')))
    TDD_Info_ExtIEs._val = ASN1Set(rv=[dict([('id', 97), ('criticality', 'ignore'), ('Extension', _TDD_Info_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 94), ('criticality', 'reject'), ('Extension', _TDD_Info_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 179), ('criticality', 'ignore'), ('Extension', _TDD_Info_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 177), ('criticality', 'reject'), ('Extension', _TDD_Info_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 338), ('criticality', 'reject'), ('Extension', _TDD_Info_ExtIEs_val_Extension_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< TDD-InfoNeighbourServedNRCell-Information >-----#
    TDD_InfoNeighbourServedNRCell_Information = SEQ(name='TDD-InfoNeighbourServedNRCell-Information', mode=MODE_TYPE)
    _TDD_InfoNeighbourServedNRCell_Information_nRFreqInfo = SEQ(name='nRFreqInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'NRFreqInfo')))
    _TDD_InfoNeighbourServedNRCell_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___TDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____TDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____TDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item__id_tab_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'IntendedTDD-DL-ULConfiguration-NR')))
    _____TDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item__id_tab_val_Extension_1 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TDDULDLConfigurationCommonNR')))
    _____TDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item__id_tab_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'NRCarrierList')))
    ____TDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 399), ('criticality', 'ignore'), ('Extension', _____TDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 385), ('criticality', 'ignore'), ('Extension', _____TDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 386), ('criticality', 'ignore'), ('Extension', _____TDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___TDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item__id._const_tab = ____TDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item__id_tab
    ___TDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item__id._const_tab_at = None
    ___TDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___TDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___TDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item__criticality._const_tab = ____TDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item__id_tab
    ___TDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___TDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item__extensionValue._const_tab = ____TDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item__id_tab
    ___TDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item__id),
        ('criticality', ___TDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___TDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item__extensionValue),
        ])
    __TDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item_._ext = None
    _TDD_InfoNeighbourServedNRCell_Information_iE_Extensions._cont = __TDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item_
    _TDD_InfoNeighbourServedNRCell_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TDD_InfoNeighbourServedNRCell_Information._cont = ASN1Dict([
        ('nRFreqInfo', _TDD_InfoNeighbourServedNRCell_Information_nRFreqInfo),
        ('iE-Extensions', _TDD_InfoNeighbourServedNRCell_Information_iE_Extensions),
        ])
    TDD_InfoNeighbourServedNRCell_Information._ext = []
    
    #-----< TDD-InfoNeighbourServedNRCell-Information-ExtIEs >-----#
    TDD_InfoNeighbourServedNRCell_Information_ExtIEs = CLASS(name='TDD-InfoNeighbourServedNRCell-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _TDD_InfoNeighbourServedNRCell_Information_ExtIEs_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'IntendedTDD-DL-ULConfiguration-NR')))
    _TDD_InfoNeighbourServedNRCell_Information_ExtIEs_val_Extension_1 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TDDULDLConfigurationCommonNR')))
    _TDD_InfoNeighbourServedNRCell_Information_ExtIEs_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'NRCarrierList')))
    TDD_InfoNeighbourServedNRCell_Information_ExtIEs._val = ASN1Set(rv=[dict([('id', 399), ('criticality', 'ignore'), ('Extension', _TDD_InfoNeighbourServedNRCell_Information_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 385), ('criticality', 'ignore'), ('Extension', _TDD_InfoNeighbourServedNRCell_Information_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 386), ('criticality', 'ignore'), ('Extension', _TDD_InfoNeighbourServedNRCell_Information_ExtIEs_val_Extension_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< TDDULDLConfigurationCommonNR >-----#
    TDDULDLConfigurationCommonNR = OCT_STR(name='TDDULDLConfigurationCommonNR', mode=MODE_TYPE)
    
    #-----< Threshold-RSRP >-----#
    Threshold_RSRP = INT(name='Threshold-RSRP', mode=MODE_TYPE)
    Threshold_RSRP._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=97)], ev=None, er=[])
    
    #-----< Threshold-RSRQ >-----#
    Threshold_RSRQ = INT(name='Threshold-RSRQ', mode=MODE_TYPE)
    Threshold_RSRQ._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=34)], ev=None, er=[])
    
    #-----< TimeToWait >-----#
    TimeToWait = ENUM(name='TimeToWait', mode=MODE_TYPE)
    TimeToWait._cont = ASN1Dict([('v1s', 0), ('v2s', 1), ('v5s', 2), ('v10s', 3), ('v20s', 4), ('v60s', 5)])
    TimeToWait._ext = []
    
    #-----< Time-UE-StayedInCell >-----#
    Time_UE_StayedInCell = INT(name='Time-UE-StayedInCell', mode=MODE_TYPE)
    Time_UE_StayedInCell._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    
    #-----< Time-UE-StayedInCell-EnhancedGranularity >-----#
    Time_UE_StayedInCell_EnhancedGranularity = INT(name='Time-UE-StayedInCell-EnhancedGranularity', mode=MODE_TYPE)
    Time_UE_StayedInCell_EnhancedGranularity._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=40950)], ev=None, er=[])
    
    #-----< TNLA-To-Add-List >-----#
    TNLA_To_Add_List = SEQ_OF(name='TNLA-To-Add-List', mode=MODE_TYPE)
    _TNLA_To_Add_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TNLA-To-Add-Item')))
    TNLA_To_Add_List._cont = _TNLA_To_Add_List__item_
    TNLA_To_Add_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< TNLA-To-Add-Item >-----#
    TNLA_To_Add_Item = SEQ(name='TNLA-To-Add-Item', mode=MODE_TYPE)
    _TNLA_To_Add_Item_tNLAssociationTransportLayerAddress = CHOICE(name='tNLAssociationTransportLayerAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CPTransportLayerInformation')))
    _TNLA_To_Add_Item_tNLAssociationUsage = ENUM(name='tNLAssociationUsage', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'TNLAssociationUsage')))
    _TNLA_To_Add_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TNLA_To_Add_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___TNLA_To_Add_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____TNLA_To_Add_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____TNLA_To_Add_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TNLA_To_Add_Item_iE_Extensions__item__id._const_tab = ____TNLA_To_Add_Item_iE_Extensions__item__id_tab
    ___TNLA_To_Add_Item_iE_Extensions__item__id._const_tab_at = None
    ___TNLA_To_Add_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___TNLA_To_Add_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TNLA_To_Add_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____TNLA_To_Add_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TNLA_To_Add_Item_iE_Extensions__item__criticality._const_tab = ____TNLA_To_Add_Item_iE_Extensions__item__criticality_tab
    ___TNLA_To_Add_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TNLA_To_Add_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TNLA_To_Add_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TNLA_To_Add_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____TNLA_To_Add_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TNLA_To_Add_Item_iE_Extensions__item__extensionValue._const_tab = ____TNLA_To_Add_Item_iE_Extensions__item__extensionValue_tab
    ___TNLA_To_Add_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TNLA_To_Add_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TNLA_To_Add_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TNLA_To_Add_Item_iE_Extensions__item__id),
        ('criticality', ___TNLA_To_Add_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___TNLA_To_Add_Item_iE_Extensions__item__extensionValue),
        ])
    __TNLA_To_Add_Item_iE_Extensions__item_._ext = None
    _TNLA_To_Add_Item_iE_Extensions._cont = __TNLA_To_Add_Item_iE_Extensions__item_
    _TNLA_To_Add_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TNLA_To_Add_Item._cont = ASN1Dict([
        ('tNLAssociationTransportLayerAddress', _TNLA_To_Add_Item_tNLAssociationTransportLayerAddress),
        ('tNLAssociationUsage', _TNLA_To_Add_Item_tNLAssociationUsage),
        ('iE-Extensions', _TNLA_To_Add_Item_iE_Extensions),
        ])
    TNLA_To_Add_Item._ext = None
    
    #-----< TNLA-To-Add-Item-ExtIEs >-----#
    TNLA_To_Add_Item_ExtIEs = CLASS(name='TNLA-To-Add-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    TNLA_To_Add_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TNLA-To-Update-List >-----#
    TNLA_To_Update_List = SEQ_OF(name='TNLA-To-Update-List', mode=MODE_TYPE)
    _TNLA_To_Update_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TNLA-To-Update-Item')))
    TNLA_To_Update_List._cont = _TNLA_To_Update_List__item_
    TNLA_To_Update_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< TNLA-To-Update-Item >-----#
    TNLA_To_Update_Item = SEQ(name='TNLA-To-Update-Item', mode=MODE_TYPE)
    _TNLA_To_Update_Item_tNLAssociationTransportLayerAddress = CHOICE(name='tNLAssociationTransportLayerAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CPTransportLayerInformation')))
    _TNLA_To_Update_Item_tNLAssociationUsage = ENUM(name='tNLAssociationUsage', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'TNLAssociationUsage')), opt=True)
    _TNLA_To_Update_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TNLA_To_Update_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___TNLA_To_Update_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____TNLA_To_Update_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____TNLA_To_Update_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TNLA_To_Update_Item_iE_Extensions__item__id._const_tab = ____TNLA_To_Update_Item_iE_Extensions__item__id_tab
    ___TNLA_To_Update_Item_iE_Extensions__item__id._const_tab_at = None
    ___TNLA_To_Update_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___TNLA_To_Update_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TNLA_To_Update_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____TNLA_To_Update_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TNLA_To_Update_Item_iE_Extensions__item__criticality._const_tab = ____TNLA_To_Update_Item_iE_Extensions__item__criticality_tab
    ___TNLA_To_Update_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TNLA_To_Update_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TNLA_To_Update_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TNLA_To_Update_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____TNLA_To_Update_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TNLA_To_Update_Item_iE_Extensions__item__extensionValue._const_tab = ____TNLA_To_Update_Item_iE_Extensions__item__extensionValue_tab
    ___TNLA_To_Update_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TNLA_To_Update_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TNLA_To_Update_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TNLA_To_Update_Item_iE_Extensions__item__id),
        ('criticality', ___TNLA_To_Update_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___TNLA_To_Update_Item_iE_Extensions__item__extensionValue),
        ])
    __TNLA_To_Update_Item_iE_Extensions__item_._ext = None
    _TNLA_To_Update_Item_iE_Extensions._cont = __TNLA_To_Update_Item_iE_Extensions__item_
    _TNLA_To_Update_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TNLA_To_Update_Item._cont = ASN1Dict([
        ('tNLAssociationTransportLayerAddress', _TNLA_To_Update_Item_tNLAssociationTransportLayerAddress),
        ('tNLAssociationUsage', _TNLA_To_Update_Item_tNLAssociationUsage),
        ('iE-Extensions', _TNLA_To_Update_Item_iE_Extensions),
        ])
    TNLA_To_Update_Item._ext = None
    
    #-----< TNLA-To-Update-Item-ExtIEs >-----#
    TNLA_To_Update_Item_ExtIEs = CLASS(name='TNLA-To-Update-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    TNLA_To_Update_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TNLA-To-Remove-List >-----#
    TNLA_To_Remove_List = SEQ_OF(name='TNLA-To-Remove-List', mode=MODE_TYPE)
    _TNLA_To_Remove_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TNLA-To-Remove-Item')))
    TNLA_To_Remove_List._cont = _TNLA_To_Remove_List__item_
    TNLA_To_Remove_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< TNLA-To-Remove-Item >-----#
    TNLA_To_Remove_Item = SEQ(name='TNLA-To-Remove-Item', mode=MODE_TYPE)
    _TNLA_To_Remove_Item_tNLAssociationTransportLayerAddress = CHOICE(name='tNLAssociationTransportLayerAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CPTransportLayerInformation')))
    _TNLA_To_Remove_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TNLA_To_Remove_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___TNLA_To_Remove_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____TNLA_To_Remove_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____TNLA_To_Remove_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TNLA_To_Remove_Item_iE_Extensions__item__id._const_tab = ____TNLA_To_Remove_Item_iE_Extensions__item__id_tab
    ___TNLA_To_Remove_Item_iE_Extensions__item__id._const_tab_at = None
    ___TNLA_To_Remove_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___TNLA_To_Remove_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TNLA_To_Remove_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____TNLA_To_Remove_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TNLA_To_Remove_Item_iE_Extensions__item__criticality._const_tab = ____TNLA_To_Remove_Item_iE_Extensions__item__criticality_tab
    ___TNLA_To_Remove_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TNLA_To_Remove_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TNLA_To_Remove_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TNLA_To_Remove_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____TNLA_To_Remove_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TNLA_To_Remove_Item_iE_Extensions__item__extensionValue._const_tab = ____TNLA_To_Remove_Item_iE_Extensions__item__extensionValue_tab
    ___TNLA_To_Remove_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TNLA_To_Remove_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TNLA_To_Remove_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TNLA_To_Remove_Item_iE_Extensions__item__id),
        ('criticality', ___TNLA_To_Remove_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___TNLA_To_Remove_Item_iE_Extensions__item__extensionValue),
        ])
    __TNLA_To_Remove_Item_iE_Extensions__item_._ext = None
    _TNLA_To_Remove_Item_iE_Extensions._cont = __TNLA_To_Remove_Item_iE_Extensions__item_
    _TNLA_To_Remove_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TNLA_To_Remove_Item._cont = ASN1Dict([
        ('tNLAssociationTransportLayerAddress', _TNLA_To_Remove_Item_tNLAssociationTransportLayerAddress),
        ('iE-Extensions', _TNLA_To_Remove_Item_iE_Extensions),
        ])
    TNLA_To_Remove_Item._ext = None
    
    #-----< TNLA-To-Remove-Item-ExtIEs >-----#
    TNLA_To_Remove_Item_ExtIEs = CLASS(name='TNLA-To-Remove-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    TNLA_To_Remove_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TNLA-Setup-List >-----#
    TNLA_Setup_List = SEQ_OF(name='TNLA-Setup-List', mode=MODE_TYPE)
    _TNLA_Setup_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TNLA-Setup-Item')))
    TNLA_Setup_List._cont = _TNLA_Setup_List__item_
    TNLA_Setup_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< TNLA-Setup-Item >-----#
    TNLA_Setup_Item = SEQ(name='TNLA-Setup-Item', mode=MODE_TYPE)
    _TNLA_Setup_Item_tNLAssociationTransportLayerAddress = CHOICE(name='tNLAssociationTransportLayerAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CPTransportLayerInformation')))
    _TNLA_Setup_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TNLA_Setup_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___TNLA_Setup_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____TNLA_Setup_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____TNLA_Setup_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TNLA_Setup_Item_iE_Extensions__item__id._const_tab = ____TNLA_Setup_Item_iE_Extensions__item__id_tab
    ___TNLA_Setup_Item_iE_Extensions__item__id._const_tab_at = None
    ___TNLA_Setup_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___TNLA_Setup_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TNLA_Setup_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____TNLA_Setup_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TNLA_Setup_Item_iE_Extensions__item__criticality._const_tab = ____TNLA_Setup_Item_iE_Extensions__item__criticality_tab
    ___TNLA_Setup_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TNLA_Setup_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TNLA_Setup_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TNLA_Setup_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____TNLA_Setup_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TNLA_Setup_Item_iE_Extensions__item__extensionValue._const_tab = ____TNLA_Setup_Item_iE_Extensions__item__extensionValue_tab
    ___TNLA_Setup_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TNLA_Setup_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TNLA_Setup_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TNLA_Setup_Item_iE_Extensions__item__id),
        ('criticality', ___TNLA_Setup_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___TNLA_Setup_Item_iE_Extensions__item__extensionValue),
        ])
    __TNLA_Setup_Item_iE_Extensions__item_._ext = None
    _TNLA_Setup_Item_iE_Extensions._cont = __TNLA_Setup_Item_iE_Extensions__item_
    _TNLA_Setup_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TNLA_Setup_Item._cont = ASN1Dict([
        ('tNLAssociationTransportLayerAddress', _TNLA_Setup_Item_tNLAssociationTransportLayerAddress),
        ('iE-Extensions', _TNLA_Setup_Item_iE_Extensions),
        ])
    TNLA_Setup_Item._ext = []
    
    #-----< TNLA-Setup-Item-ExtIEs >-----#
    TNLA_Setup_Item_ExtIEs = CLASS(name='TNLA-Setup-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    TNLA_Setup_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TNLA-Failed-To-Setup-List >-----#
    TNLA_Failed_To_Setup_List = SEQ_OF(name='TNLA-Failed-To-Setup-List', mode=MODE_TYPE)
    _TNLA_Failed_To_Setup_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TNLA-Failed-To-Setup-Item')))
    TNLA_Failed_To_Setup_List._cont = _TNLA_Failed_To_Setup_List__item_
    TNLA_Failed_To_Setup_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< TNLA-Failed-To-Setup-Item >-----#
    TNLA_Failed_To_Setup_Item = SEQ(name='TNLA-Failed-To-Setup-Item', mode=MODE_TYPE)
    _TNLA_Failed_To_Setup_Item_tNLAssociationTransportLayerAddress = CHOICE(name='tNLAssociationTransportLayerAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CPTransportLayerInformation')))
    _TNLA_Failed_To_Setup_Item_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _TNLA_Failed_To_Setup_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TNLA_Failed_To_Setup_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___TNLA_Failed_To_Setup_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____TNLA_Failed_To_Setup_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____TNLA_Failed_To_Setup_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TNLA_Failed_To_Setup_Item_iE_Extensions__item__id._const_tab = ____TNLA_Failed_To_Setup_Item_iE_Extensions__item__id_tab
    ___TNLA_Failed_To_Setup_Item_iE_Extensions__item__id._const_tab_at = None
    ___TNLA_Failed_To_Setup_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___TNLA_Failed_To_Setup_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TNLA_Failed_To_Setup_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____TNLA_Failed_To_Setup_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TNLA_Failed_To_Setup_Item_iE_Extensions__item__criticality._const_tab = ____TNLA_Failed_To_Setup_Item_iE_Extensions__item__criticality_tab
    ___TNLA_Failed_To_Setup_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TNLA_Failed_To_Setup_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TNLA_Failed_To_Setup_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TNLA_Failed_To_Setup_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____TNLA_Failed_To_Setup_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TNLA_Failed_To_Setup_Item_iE_Extensions__item__extensionValue._const_tab = ____TNLA_Failed_To_Setup_Item_iE_Extensions__item__extensionValue_tab
    ___TNLA_Failed_To_Setup_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TNLA_Failed_To_Setup_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TNLA_Failed_To_Setup_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TNLA_Failed_To_Setup_Item_iE_Extensions__item__id),
        ('criticality', ___TNLA_Failed_To_Setup_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___TNLA_Failed_To_Setup_Item_iE_Extensions__item__extensionValue),
        ])
    __TNLA_Failed_To_Setup_Item_iE_Extensions__item_._ext = None
    _TNLA_Failed_To_Setup_Item_iE_Extensions._cont = __TNLA_Failed_To_Setup_Item_iE_Extensions__item_
    _TNLA_Failed_To_Setup_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TNLA_Failed_To_Setup_Item._cont = ASN1Dict([
        ('tNLAssociationTransportLayerAddress', _TNLA_Failed_To_Setup_Item_tNLAssociationTransportLayerAddress),
        ('cause', _TNLA_Failed_To_Setup_Item_cause),
        ('iE-Extensions', _TNLA_Failed_To_Setup_Item_iE_Extensions),
        ])
    TNLA_Failed_To_Setup_Item._ext = None
    
    #-----< TNLA-Failed-To-Setup-Item-ExtIEs >-----#
    TNLA_Failed_To_Setup_Item_ExtIEs = CLASS(name='TNLA-Failed-To-Setup-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    TNLA_Failed_To_Setup_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TNLAssociationUsage >-----#
    TNLAssociationUsage = ENUM(name='TNLAssociationUsage', mode=MODE_TYPE)
    TNLAssociationUsage._cont = ASN1Dict([('ue', 0), ('non-ue', 1), ('both', 2)])
    TNLAssociationUsage._ext = []
    
    #-----< TNLCapacityIndicator >-----#
    TNLCapacityIndicator = SEQ(name='TNLCapacityIndicator', mode=MODE_TYPE)
    _TNLCapacityIndicator_dlTNLMaximumOfferedCapacity = INT(name='dlTNLMaximumOfferedCapacity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TNLCapacityIndicator_dlTNLMaximumOfferedCapacity._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16777216)], ev=[], er=[])
    _TNLCapacityIndicator_dlTNLAvailableCapacity = INT(name='dlTNLAvailableCapacity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TNLCapacityIndicator_dlTNLAvailableCapacity._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=[], er=[])
    _TNLCapacityIndicator_ulTNLMaximumOfferedCapacity = INT(name='ulTNLMaximumOfferedCapacity', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TNLCapacityIndicator_ulTNLMaximumOfferedCapacity._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16777216)], ev=[], er=[])
    _TNLCapacityIndicator_ulTNLAvailableCapacity = INT(name='ulTNLAvailableCapacity', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TNLCapacityIndicator_ulTNLAvailableCapacity._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=[], er=[])
    _TNLCapacityIndicator_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TNLCapacityIndicator_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___TNLCapacityIndicator_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____TNLCapacityIndicator_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____TNLCapacityIndicator_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TNLCapacityIndicator_iE_Extensions__item__id._const_tab = ____TNLCapacityIndicator_iE_Extensions__item__id_tab
    ___TNLCapacityIndicator_iE_Extensions__item__id._const_tab_at = None
    ___TNLCapacityIndicator_iE_Extensions__item__id._const_tab_id = 'id'
    ___TNLCapacityIndicator_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TNLCapacityIndicator_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____TNLCapacityIndicator_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TNLCapacityIndicator_iE_Extensions__item__criticality._const_tab = ____TNLCapacityIndicator_iE_Extensions__item__criticality_tab
    ___TNLCapacityIndicator_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TNLCapacityIndicator_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TNLCapacityIndicator_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TNLCapacityIndicator_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____TNLCapacityIndicator_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TNLCapacityIndicator_iE_Extensions__item__extensionValue._const_tab = ____TNLCapacityIndicator_iE_Extensions__item__extensionValue_tab
    ___TNLCapacityIndicator_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TNLCapacityIndicator_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TNLCapacityIndicator_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TNLCapacityIndicator_iE_Extensions__item__id),
        ('criticality', ___TNLCapacityIndicator_iE_Extensions__item__criticality),
        ('extensionValue', ___TNLCapacityIndicator_iE_Extensions__item__extensionValue),
        ])
    __TNLCapacityIndicator_iE_Extensions__item_._ext = None
    _TNLCapacityIndicator_iE_Extensions._cont = __TNLCapacityIndicator_iE_Extensions__item_
    _TNLCapacityIndicator_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TNLCapacityIndicator._cont = ASN1Dict([
        ('dlTNLMaximumOfferedCapacity', _TNLCapacityIndicator_dlTNLMaximumOfferedCapacity),
        ('dlTNLAvailableCapacity', _TNLCapacityIndicator_dlTNLAvailableCapacity),
        ('ulTNLMaximumOfferedCapacity', _TNLCapacityIndicator_ulTNLMaximumOfferedCapacity),
        ('ulTNLAvailableCapacity', _TNLCapacityIndicator_ulTNLAvailableCapacity),
        ('iE-Extensions', _TNLCapacityIndicator_iE_Extensions),
        ])
    TNLCapacityIndicator._ext = []
    
    #-----< TNLCapacityIndicator-ExtIEs >-----#
    TNLCapacityIndicator_ExtIEs = CLASS(name='TNLCapacityIndicator-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    TNLCapacityIndicator_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Transport-UP-Layer-Addresses-Info-To-Add-List >-----#
    Transport_UP_Layer_Addresses_Info_To_Add_List = SEQ_OF(name='Transport-UP-Layer-Addresses-Info-To-Add-List', mode=MODE_TYPE)
    _Transport_UP_Layer_Addresses_Info_To_Add_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Transport-UP-Layer-Addresses-Info-To-Add-Item')))
    Transport_UP_Layer_Addresses_Info_To_Add_List._cont = _Transport_UP_Layer_Addresses_Info_To_Add_List__item_
    Transport_UP_Layer_Addresses_Info_To_Add_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< Transport-UP-Layer-Addresses-Info-To-Add-Item >-----#
    Transport_UP_Layer_Addresses_Info_To_Add_Item = SEQ(name='Transport-UP-Layer-Addresses-Info-To-Add-Item', mode=MODE_TYPE)
    _Transport_UP_Layer_Addresses_Info_To_Add_Item_iP_SecTransportLayerAddress = BIT_STR(name='iP-SecTransportLayerAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'TransportLayerAddress')))
    _Transport_UP_Layer_Addresses_Info_To_Add_Item_gTPTransportLayerAddressesToAdd = SEQ_OF(name='gTPTransportLayerAddressesToAdd', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPTLAs')), opt=True)
    _Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item__id._const_tab = ____Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item__id_tab
    ___Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item__id._const_tab_at = None
    ___Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item__criticality._const_tab = ____Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item__criticality_tab
    ___Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item__extensionValue._const_tab = ____Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item__extensionValue_tab
    ___Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item__id),
        ('criticality', ___Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item__extensionValue),
        ])
    __Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item_._ext = None
    _Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions._cont = __Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item_
    _Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Transport_UP_Layer_Addresses_Info_To_Add_Item._cont = ASN1Dict([
        ('iP-SecTransportLayerAddress', _Transport_UP_Layer_Addresses_Info_To_Add_Item_iP_SecTransportLayerAddress),
        ('gTPTransportLayerAddressesToAdd', _Transport_UP_Layer_Addresses_Info_To_Add_Item_gTPTransportLayerAddressesToAdd),
        ('iE-Extensions', _Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions),
        ])
    Transport_UP_Layer_Addresses_Info_To_Add_Item._ext = []
    
    #-----< Transport-UP-Layer-Addresses-Info-To-Add-ItemExtIEs >-----#
    Transport_UP_Layer_Addresses_Info_To_Add_ItemExtIEs = CLASS(name='Transport-UP-Layer-Addresses-Info-To-Add-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    Transport_UP_Layer_Addresses_Info_To_Add_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Transport-UP-Layer-Addresses-Info-To-Remove-List >-----#
    Transport_UP_Layer_Addresses_Info_To_Remove_List = SEQ_OF(name='Transport-UP-Layer-Addresses-Info-To-Remove-List', mode=MODE_TYPE)
    _Transport_UP_Layer_Addresses_Info_To_Remove_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Transport-UP-Layer-Addresses-Info-To-Remove-Item')))
    Transport_UP_Layer_Addresses_Info_To_Remove_List._cont = _Transport_UP_Layer_Addresses_Info_To_Remove_List__item_
    Transport_UP_Layer_Addresses_Info_To_Remove_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< Transport-UP-Layer-Addresses-Info-To-Remove-Item >-----#
    Transport_UP_Layer_Addresses_Info_To_Remove_Item = SEQ(name='Transport-UP-Layer-Addresses-Info-To-Remove-Item', mode=MODE_TYPE)
    _Transport_UP_Layer_Addresses_Info_To_Remove_Item_iP_SecTransportLayerAddress = BIT_STR(name='iP-SecTransportLayerAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'TransportLayerAddress')))
    _Transport_UP_Layer_Addresses_Info_To_Remove_Item_gTPTransportLayerAddressesToRemove = SEQ_OF(name='gTPTransportLayerAddressesToRemove', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPTLAs')), opt=True)
    _Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item__id._const_tab = ____Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item__id_tab
    ___Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item__id._const_tab_at = None
    ___Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item__criticality._const_tab = ____Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item__criticality_tab
    ___Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item__extensionValue._const_tab = ____Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item__extensionValue_tab
    ___Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item__id),
        ('criticality', ___Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item__extensionValue),
        ])
    __Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item_._ext = None
    _Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions._cont = __Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item_
    _Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Transport_UP_Layer_Addresses_Info_To_Remove_Item._cont = ASN1Dict([
        ('iP-SecTransportLayerAddress', _Transport_UP_Layer_Addresses_Info_To_Remove_Item_iP_SecTransportLayerAddress),
        ('gTPTransportLayerAddressesToRemove', _Transport_UP_Layer_Addresses_Info_To_Remove_Item_gTPTransportLayerAddressesToRemove),
        ('iE-Extensions', _Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions),
        ])
    Transport_UP_Layer_Addresses_Info_To_Remove_Item._ext = []
    
    #-----< Transport-UP-Layer-Addresses-Info-To-Remove-ItemExtIEs >-----#
    Transport_UP_Layer_Addresses_Info_To_Remove_ItemExtIEs = CLASS(name='Transport-UP-Layer-Addresses-Info-To-Remove-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    Transport_UP_Layer_Addresses_Info_To_Remove_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TNLConfigurationInfo >-----#
    TNLConfigurationInfo = SEQ(name='TNLConfigurationInfo', mode=MODE_TYPE)
    _TNLConfigurationInfo_transport_UP_Layer_Addresses_Info_To_Add_List = SEQ_OF(name='transport-UP-Layer-Addresses-Info-To-Add-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'Transport-UP-Layer-Addresses-Info-To-Add-List')), opt=True)
    _TNLConfigurationInfo_transport_UP_Layer_Addresses_Info_To_Remove_List = SEQ_OF(name='transport-UP-Layer-Addresses-Info-To-Remove-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'Transport-UP-Layer-Addresses-Info-To-Remove-List')), opt=True)
    _TNLConfigurationInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TNLConfigurationInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___TNLConfigurationInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____TNLConfigurationInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____TNLConfigurationInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TNLConfigurationInfo_iE_Extensions__item__id._const_tab = ____TNLConfigurationInfo_iE_Extensions__item__id_tab
    ___TNLConfigurationInfo_iE_Extensions__item__id._const_tab_at = None
    ___TNLConfigurationInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___TNLConfigurationInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TNLConfigurationInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____TNLConfigurationInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TNLConfigurationInfo_iE_Extensions__item__criticality._const_tab = ____TNLConfigurationInfo_iE_Extensions__item__criticality_tab
    ___TNLConfigurationInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TNLConfigurationInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TNLConfigurationInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TNLConfigurationInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____TNLConfigurationInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TNLConfigurationInfo_iE_Extensions__item__extensionValue._const_tab = ____TNLConfigurationInfo_iE_Extensions__item__extensionValue_tab
    ___TNLConfigurationInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TNLConfigurationInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TNLConfigurationInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TNLConfigurationInfo_iE_Extensions__item__id),
        ('criticality', ___TNLConfigurationInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___TNLConfigurationInfo_iE_Extensions__item__extensionValue),
        ])
    __TNLConfigurationInfo_iE_Extensions__item_._ext = None
    _TNLConfigurationInfo_iE_Extensions._cont = __TNLConfigurationInfo_iE_Extensions__item_
    _TNLConfigurationInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TNLConfigurationInfo._cont = ASN1Dict([
        ('transport-UP-Layer-Addresses-Info-To-Add-List', _TNLConfigurationInfo_transport_UP_Layer_Addresses_Info_To_Add_List),
        ('transport-UP-Layer-Addresses-Info-To-Remove-List', _TNLConfigurationInfo_transport_UP_Layer_Addresses_Info_To_Remove_List),
        ('iE-Extensions', _TNLConfigurationInfo_iE_Extensions),
        ])
    TNLConfigurationInfo._ext = []
    
    #-----< TNLConfigurationInfo-ExtIEs >-----#
    TNLConfigurationInfo_ExtIEs = CLASS(name='TNLConfigurationInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    TNLConfigurationInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TraceActivation >-----#
    TraceActivation = SEQ(name='TraceActivation', mode=MODE_TYPE)
    _TraceActivation_eUTRANTraceID = OCT_STR(name='eUTRANTraceID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'EUTRANTraceID')))
    _TraceActivation_interfacesToTrace = BIT_STR(name='interfacesToTrace', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'InterfacesToTrace')))
    _TraceActivation_traceDepth = ENUM(name='traceDepth', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'TraceDepth')))
    _TraceActivation_traceCollectionEntityIPAddress = BIT_STR(name='traceCollectionEntityIPAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'TraceCollectionEntityIPAddress')))
    _TraceActivation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TraceActivation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___TraceActivation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____TraceActivation_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____TraceActivation_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MDT-Configuration')))
    _____TraceActivation_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UEAppLayerMeasConfig')))
    _____TraceActivation_iE_Extensions__item__id_tab_val_Extension_2 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MDT-ConfigurationNR')))
    _____TraceActivation_iE_Extensions__item__id_tab_val_Extension_3 = STR_VIS(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'URI-Address')))
    ____TraceActivation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 72), ('criticality', 'ignore'), ('Extension', _____TraceActivation_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 195), ('criticality', 'ignore'), ('Extension', _____TraceActivation_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 375), ('criticality', 'ignore'), ('Extension', _____TraceActivation_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 405), ('criticality', 'ignore'), ('Extension', _____TraceActivation_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___TraceActivation_iE_Extensions__item__id._const_tab = ____TraceActivation_iE_Extensions__item__id_tab
    ___TraceActivation_iE_Extensions__item__id._const_tab_at = None
    ___TraceActivation_iE_Extensions__item__id._const_tab_id = 'id'
    ___TraceActivation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___TraceActivation_iE_Extensions__item__criticality._const_tab = ____TraceActivation_iE_Extensions__item__id_tab
    ___TraceActivation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TraceActivation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TraceActivation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___TraceActivation_iE_Extensions__item__extensionValue._const_tab = ____TraceActivation_iE_Extensions__item__id_tab
    ___TraceActivation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TraceActivation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TraceActivation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TraceActivation_iE_Extensions__item__id),
        ('criticality', ___TraceActivation_iE_Extensions__item__criticality),
        ('extensionValue', ___TraceActivation_iE_Extensions__item__extensionValue),
        ])
    __TraceActivation_iE_Extensions__item_._ext = None
    _TraceActivation_iE_Extensions._cont = __TraceActivation_iE_Extensions__item_
    _TraceActivation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TraceActivation._cont = ASN1Dict([
        ('eUTRANTraceID', _TraceActivation_eUTRANTraceID),
        ('interfacesToTrace', _TraceActivation_interfacesToTrace),
        ('traceDepth', _TraceActivation_traceDepth),
        ('traceCollectionEntityIPAddress', _TraceActivation_traceCollectionEntityIPAddress),
        ('iE-Extensions', _TraceActivation_iE_Extensions),
        ])
    TraceActivation._ext = []
    
    #-----< TraceActivation-ExtIEs >-----#
    TraceActivation_ExtIEs = CLASS(name='TraceActivation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _TraceActivation_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MDT-Configuration')))
    _TraceActivation_ExtIEs_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UEAppLayerMeasConfig')))
    _TraceActivation_ExtIEs_val_Extension_2 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MDT-ConfigurationNR')))
    _TraceActivation_ExtIEs_val_Extension_3 = STR_VIS(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'URI-Address')))
    TraceActivation_ExtIEs._val = ASN1Set(rv=[dict([('id', 72), ('criticality', 'ignore'), ('Extension', _TraceActivation_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 195), ('criticality', 'ignore'), ('Extension', _TraceActivation_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 375), ('criticality', 'ignore'), ('Extension', _TraceActivation_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 405), ('criticality', 'ignore'), ('Extension', _TraceActivation_ExtIEs_val_Extension_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< TraceCollectionEntityIPAddress >-----#
    TraceCollectionEntityIPAddress = BIT_STR(name='TraceCollectionEntityIPAddress', mode=MODE_TYPE)
    TraceCollectionEntityIPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=160)], ev=[], er=[])
    
    #-----< TraceDepth >-----#
    TraceDepth = ENUM(name='TraceDepth', mode=MODE_TYPE)
    TraceDepth._cont = ASN1Dict([('minimum', 0), ('medium', 1), ('maximum', 2), ('minimumWithoutVendorSpecificExtension', 3), ('mediumWithoutVendorSpecificExtension', 4), ('maximumWithoutVendorSpecificExtension', 5)])
    TraceDepth._ext = []
    
    #-----< Transmission-Bandwidth >-----#
    Transmission_Bandwidth = ENUM(name='Transmission-Bandwidth', mode=MODE_TYPE)
    Transmission_Bandwidth._cont = ASN1Dict([('bw6', 0), ('bw15', 1), ('bw25', 2), ('bw50', 3), ('bw75', 4), ('bw100', 5), ('bw1', 6)])
    Transmission_Bandwidth._ext = ['bw1']
    
    #-----< TransportLayerAddress >-----#
    TransportLayerAddress = BIT_STR(name='TransportLayerAddress', mode=MODE_TYPE)
    TransportLayerAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=160)], ev=[], er=[])
    
    #-----< TransportLayerAddressAndPort >-----#
    TransportLayerAddressAndPort = SEQ(name='TransportLayerAddressAndPort', mode=MODE_TYPE)
    _TransportLayerAddressAndPort_endpointIPAddress = BIT_STR(name='endpointIPAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'TransportLayerAddress')))
    _TransportLayerAddressAndPort_portnumber = OCT_STR(name='portnumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'Port-Number')))
    TransportLayerAddressAndPort._cont = ASN1Dict([
        ('endpointIPAddress', _TransportLayerAddressAndPort_endpointIPAddress),
        ('portnumber', _TransportLayerAddressAndPort_portnumber),
        ])
    TransportLayerAddressAndPort._ext = None
    
    #-----< TunnelInformation >-----#
    TunnelInformation = SEQ(name='TunnelInformation', mode=MODE_TYPE)
    _TunnelInformation_transportLayerAddress = BIT_STR(name='transportLayerAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'TransportLayerAddress')))
    _TunnelInformation_uDP_Port_Number = OCT_STR(name='uDP-Port-Number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'Port-Number')), opt=True)
    _TunnelInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TunnelInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___TunnelInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____TunnelInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____TunnelInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TunnelInformation_iE_Extensions__item__id._const_tab = ____TunnelInformation_iE_Extensions__item__id_tab
    ___TunnelInformation_iE_Extensions__item__id._const_tab_at = None
    ___TunnelInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___TunnelInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TunnelInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____TunnelInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TunnelInformation_iE_Extensions__item__criticality._const_tab = ____TunnelInformation_iE_Extensions__item__criticality_tab
    ___TunnelInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TunnelInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TunnelInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TunnelInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____TunnelInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TunnelInformation_iE_Extensions__item__extensionValue._const_tab = ____TunnelInformation_iE_Extensions__item__extensionValue_tab
    ___TunnelInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TunnelInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TunnelInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TunnelInformation_iE_Extensions__item__id),
        ('criticality', ___TunnelInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___TunnelInformation_iE_Extensions__item__extensionValue),
        ])
    __TunnelInformation_iE_Extensions__item_._ext = None
    _TunnelInformation_iE_Extensions._cont = __TunnelInformation_iE_Extensions__item_
    _TunnelInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TunnelInformation._cont = ASN1Dict([
        ('transportLayerAddress', _TunnelInformation_transportLayerAddress),
        ('uDP-Port-Number', _TunnelInformation_uDP_Port_Number),
        ('iE-Extensions', _TunnelInformation_iE_Extensions),
        ])
    TunnelInformation._ext = []
    
    #-----< Tunnel-Information-ExtIEs >-----#
    Tunnel_Information_ExtIEs = CLASS(name='Tunnel-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    Tunnel_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TypeOfError >-----#
    TypeOfError = ENUM(name='TypeOfError', mode=MODE_TYPE)
    TypeOfError._cont = ASN1Dict([('not-understood', 0), ('missing', 1)])
    TypeOfError._ext = []
    
    #-----< UEAggregateMaximumBitRate >-----#
    UEAggregateMaximumBitRate = SEQ(name='UEAggregateMaximumBitRate', mode=MODE_TYPE)
    _UEAggregateMaximumBitRate_uEaggregateMaximumBitRateDownlink = INT(name='uEaggregateMaximumBitRateDownlink', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'BitRate')))
    _UEAggregateMaximumBitRate_uEaggregateMaximumBitRateUplink = INT(name='uEaggregateMaximumBitRateUplink', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'BitRate')))
    _UEAggregateMaximumBitRate_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UEAggregateMaximumBitRate_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___UEAggregateMaximumBitRate_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____UEAggregateMaximumBitRate_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____UEAggregateMaximumBitRate_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ExtendedBitRate')))
    _____UEAggregateMaximumBitRate_iE_Extensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ExtendedBitRate')))
    ____UEAggregateMaximumBitRate_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 200), ('criticality', 'ignore'), ('Extension', _____UEAggregateMaximumBitRate_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 201), ('criticality', 'ignore'), ('Extension', _____UEAggregateMaximumBitRate_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UEAggregateMaximumBitRate_iE_Extensions__item__id._const_tab = ____UEAggregateMaximumBitRate_iE_Extensions__item__id_tab
    ___UEAggregateMaximumBitRate_iE_Extensions__item__id._const_tab_at = None
    ___UEAggregateMaximumBitRate_iE_Extensions__item__id._const_tab_id = 'id'
    ___UEAggregateMaximumBitRate_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___UEAggregateMaximumBitRate_iE_Extensions__item__criticality._const_tab = ____UEAggregateMaximumBitRate_iE_Extensions__item__id_tab
    ___UEAggregateMaximumBitRate_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UEAggregateMaximumBitRate_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UEAggregateMaximumBitRate_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___UEAggregateMaximumBitRate_iE_Extensions__item__extensionValue._const_tab = ____UEAggregateMaximumBitRate_iE_Extensions__item__id_tab
    ___UEAggregateMaximumBitRate_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UEAggregateMaximumBitRate_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UEAggregateMaximumBitRate_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UEAggregateMaximumBitRate_iE_Extensions__item__id),
        ('criticality', ___UEAggregateMaximumBitRate_iE_Extensions__item__criticality),
        ('extensionValue', ___UEAggregateMaximumBitRate_iE_Extensions__item__extensionValue),
        ])
    __UEAggregateMaximumBitRate_iE_Extensions__item_._ext = None
    _UEAggregateMaximumBitRate_iE_Extensions._cont = __UEAggregateMaximumBitRate_iE_Extensions__item_
    _UEAggregateMaximumBitRate_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UEAggregateMaximumBitRate._cont = ASN1Dict([
        ('uEaggregateMaximumBitRateDownlink', _UEAggregateMaximumBitRate_uEaggregateMaximumBitRateDownlink),
        ('uEaggregateMaximumBitRateUplink', _UEAggregateMaximumBitRate_uEaggregateMaximumBitRateUplink),
        ('iE-Extensions', _UEAggregateMaximumBitRate_iE_Extensions),
        ])
    UEAggregateMaximumBitRate._ext = []
    
    #-----< UEAggregate-MaximumBitrate-ExtIEs >-----#
    UEAggregate_MaximumBitrate_ExtIEs = CLASS(name='UEAggregate-MaximumBitrate-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _UEAggregate_MaximumBitrate_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ExtendedBitRate')))
    _UEAggregate_MaximumBitrate_ExtIEs_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ExtendedBitRate')))
    UEAggregate_MaximumBitrate_ExtIEs._val = ASN1Set(rv=[dict([('id', 200), ('criticality', 'ignore'), ('Extension', _UEAggregate_MaximumBitrate_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 201), ('criticality', 'ignore'), ('Extension', _UEAggregate_MaximumBitrate_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UEAppLayerMeasConfig >-----#
    UEAppLayerMeasConfig = SEQ(name='UEAppLayerMeasConfig', mode=MODE_TYPE)
    _UEAppLayerMeasConfig_containerForAppLayerMeasConfig = OCT_STR(name='containerForAppLayerMeasConfig', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UEAppLayerMeasConfig_containerForAppLayerMeasConfig._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1000)], ev=None, er=[])
    _UEAppLayerMeasConfig_areaScopeOfQMC = CHOICE(name='areaScopeOfQMC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'AreaScopeOfQMC')))
    _UEAppLayerMeasConfig_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UEAppLayerMeasConfig_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___UEAppLayerMeasConfig_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____UEAppLayerMeasConfig_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____UEAppLayerMeasConfig_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ServiceType')))
    ____UEAppLayerMeasConfig_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 276), ('criticality', 'ignore'), ('Extension', _____UEAppLayerMeasConfig_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UEAppLayerMeasConfig_iE_Extensions__item__id._const_tab = ____UEAppLayerMeasConfig_iE_Extensions__item__id_tab
    ___UEAppLayerMeasConfig_iE_Extensions__item__id._const_tab_at = None
    ___UEAppLayerMeasConfig_iE_Extensions__item__id._const_tab_id = 'id'
    ___UEAppLayerMeasConfig_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___UEAppLayerMeasConfig_iE_Extensions__item__criticality._const_tab = ____UEAppLayerMeasConfig_iE_Extensions__item__id_tab
    ___UEAppLayerMeasConfig_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UEAppLayerMeasConfig_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UEAppLayerMeasConfig_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___UEAppLayerMeasConfig_iE_Extensions__item__extensionValue._const_tab = ____UEAppLayerMeasConfig_iE_Extensions__item__id_tab
    ___UEAppLayerMeasConfig_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UEAppLayerMeasConfig_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UEAppLayerMeasConfig_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UEAppLayerMeasConfig_iE_Extensions__item__id),
        ('criticality', ___UEAppLayerMeasConfig_iE_Extensions__item__criticality),
        ('extensionValue', ___UEAppLayerMeasConfig_iE_Extensions__item__extensionValue),
        ])
    __UEAppLayerMeasConfig_iE_Extensions__item_._ext = None
    _UEAppLayerMeasConfig_iE_Extensions._cont = __UEAppLayerMeasConfig_iE_Extensions__item_
    _UEAppLayerMeasConfig_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UEAppLayerMeasConfig._cont = ASN1Dict([
        ('containerForAppLayerMeasConfig', _UEAppLayerMeasConfig_containerForAppLayerMeasConfig),
        ('areaScopeOfQMC', _UEAppLayerMeasConfig_areaScopeOfQMC),
        ('iE-Extensions', _UEAppLayerMeasConfig_iE_Extensions),
        ])
    UEAppLayerMeasConfig._ext = []
    
    #-----< UEAppLayerMeasConfig-ExtIEs >-----#
    UEAppLayerMeasConfig_ExtIEs = CLASS(name='UEAppLayerMeasConfig-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _UEAppLayerMeasConfig_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ServiceType')))
    UEAppLayerMeasConfig_ExtIEs._val = ASN1Set(rv=[dict([('id', 276), ('criticality', 'ignore'), ('Extension', _UEAppLayerMeasConfig_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UE-ContextKeptIndicator >-----#
    UE_ContextKeptIndicator = ENUM(name='UE-ContextKeptIndicator', mode=MODE_TYPE)
    UE_ContextKeptIndicator._cont = ASN1Dict([('true', 0)])
    UE_ContextKeptIndicator._ext = []
    
    #-----< UEID >-----#
    UEID = BIT_STR(name='UEID', mode=MODE_TYPE)
    UEID._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< UE-HistoryInformation >-----#
    UE_HistoryInformation = SEQ_OF(name='UE-HistoryInformation', mode=MODE_TYPE)
    _UE_HistoryInformation__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'LastVisitedCell-Item')))
    UE_HistoryInformation._cont = _UE_HistoryInformation__item_
    UE_HistoryInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< UE-HistoryInformationFromTheUE >-----#
    UE_HistoryInformationFromTheUE = OCT_STR(name='UE-HistoryInformationFromTheUE', mode=MODE_TYPE)
    
    #-----< UE-S1AP-ID >-----#
    UE_S1AP_ID = INT(name='UE-S1AP-ID', mode=MODE_TYPE)
    UE_S1AP_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    
    #-----< UE-X2AP-ID >-----#
    UE_X2AP_ID = INT(name='UE-X2AP-ID', mode=MODE_TYPE)
    UE_X2AP_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    
    #-----< UE-X2AP-ID-Extension >-----#
    UE_X2AP_ID_Extension = INT(name='UE-X2AP-ID-Extension', mode=MODE_TYPE)
    UE_X2AP_ID_Extension._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=[], er=[])
    
    #-----< UERadioCapability >-----#
    UERadioCapability = OCT_STR(name='UERadioCapability', mode=MODE_TYPE)
    
    #-----< UERadioCapabilityID >-----#
    UERadioCapabilityID = OCT_STR(name='UERadioCapabilityID', mode=MODE_TYPE)
    
    #-----< UE-RLF-Report-Container >-----#
    UE_RLF_Report_Container = OCT_STR(name='UE-RLF-Report-Container', mode=MODE_TYPE)
    
    #-----< UE-RLF-Report-Container-for-extended-bands >-----#
    UE_RLF_Report_Container_for_extended_bands = OCT_STR(name='UE-RLF-Report-Container-for-extended-bands', mode=MODE_TYPE)
    
    #-----< UESecurityCapabilities >-----#
    UESecurityCapabilities = SEQ(name='UESecurityCapabilities', mode=MODE_TYPE)
    _UESecurityCapabilities_encryptionAlgorithms = BIT_STR(name='encryptionAlgorithms', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'EncryptionAlgorithms')))
    _UESecurityCapabilities_integrityProtectionAlgorithms = BIT_STR(name='integrityProtectionAlgorithms', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'IntegrityProtectionAlgorithms')))
    _UESecurityCapabilities_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UESecurityCapabilities_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___UESecurityCapabilities_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____UESecurityCapabilities_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____UESecurityCapabilities_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UESecurityCapabilities_iE_Extensions__item__id._const_tab = ____UESecurityCapabilities_iE_Extensions__item__id_tab
    ___UESecurityCapabilities_iE_Extensions__item__id._const_tab_at = None
    ___UESecurityCapabilities_iE_Extensions__item__id._const_tab_id = 'id'
    ___UESecurityCapabilities_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UESecurityCapabilities_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____UESecurityCapabilities_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UESecurityCapabilities_iE_Extensions__item__criticality._const_tab = ____UESecurityCapabilities_iE_Extensions__item__criticality_tab
    ___UESecurityCapabilities_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UESecurityCapabilities_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UESecurityCapabilities_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UESecurityCapabilities_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____UESecurityCapabilities_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UESecurityCapabilities_iE_Extensions__item__extensionValue._const_tab = ____UESecurityCapabilities_iE_Extensions__item__extensionValue_tab
    ___UESecurityCapabilities_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UESecurityCapabilities_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UESecurityCapabilities_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UESecurityCapabilities_iE_Extensions__item__id),
        ('criticality', ___UESecurityCapabilities_iE_Extensions__item__criticality),
        ('extensionValue', ___UESecurityCapabilities_iE_Extensions__item__extensionValue),
        ])
    __UESecurityCapabilities_iE_Extensions__item_._ext = None
    _UESecurityCapabilities_iE_Extensions._cont = __UESecurityCapabilities_iE_Extensions__item_
    _UESecurityCapabilities_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UESecurityCapabilities._cont = ASN1Dict([
        ('encryptionAlgorithms', _UESecurityCapabilities_encryptionAlgorithms),
        ('integrityProtectionAlgorithms', _UESecurityCapabilities_integrityProtectionAlgorithms),
        ('iE-Extensions', _UESecurityCapabilities_iE_Extensions),
        ])
    UESecurityCapabilities._ext = []
    
    #-----< UESecurityCapabilities-ExtIEs >-----#
    UESecurityCapabilities_ExtIEs = CLASS(name='UESecurityCapabilities-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    UESecurityCapabilities_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UESidelinkAggregateMaximumBitRate >-----#
    UESidelinkAggregateMaximumBitRate = SEQ(name='UESidelinkAggregateMaximumBitRate', mode=MODE_TYPE)
    _UESidelinkAggregateMaximumBitRate_uESidelinkAggregateMaximumBitRate = INT(name='uESidelinkAggregateMaximumBitRate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'BitRate')))
    _UESidelinkAggregateMaximumBitRate_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UESidelinkAggregateMaximumBitRate_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___UESidelinkAggregateMaximumBitRate_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____UESidelinkAggregateMaximumBitRate_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____UESidelinkAggregateMaximumBitRate_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UESidelinkAggregateMaximumBitRate_iE_Extensions__item__id._const_tab = ____UESidelinkAggregateMaximumBitRate_iE_Extensions__item__id_tab
    ___UESidelinkAggregateMaximumBitRate_iE_Extensions__item__id._const_tab_at = None
    ___UESidelinkAggregateMaximumBitRate_iE_Extensions__item__id._const_tab_id = 'id'
    ___UESidelinkAggregateMaximumBitRate_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UESidelinkAggregateMaximumBitRate_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____UESidelinkAggregateMaximumBitRate_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UESidelinkAggregateMaximumBitRate_iE_Extensions__item__criticality._const_tab = ____UESidelinkAggregateMaximumBitRate_iE_Extensions__item__criticality_tab
    ___UESidelinkAggregateMaximumBitRate_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UESidelinkAggregateMaximumBitRate_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UESidelinkAggregateMaximumBitRate_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UESidelinkAggregateMaximumBitRate_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____UESidelinkAggregateMaximumBitRate_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UESidelinkAggregateMaximumBitRate_iE_Extensions__item__extensionValue._const_tab = ____UESidelinkAggregateMaximumBitRate_iE_Extensions__item__extensionValue_tab
    ___UESidelinkAggregateMaximumBitRate_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UESidelinkAggregateMaximumBitRate_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UESidelinkAggregateMaximumBitRate_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UESidelinkAggregateMaximumBitRate_iE_Extensions__item__id),
        ('criticality', ___UESidelinkAggregateMaximumBitRate_iE_Extensions__item__criticality),
        ('extensionValue', ___UESidelinkAggregateMaximumBitRate_iE_Extensions__item__extensionValue),
        ])
    __UESidelinkAggregateMaximumBitRate_iE_Extensions__item_._ext = None
    _UESidelinkAggregateMaximumBitRate_iE_Extensions._cont = __UESidelinkAggregateMaximumBitRate_iE_Extensions__item_
    _UESidelinkAggregateMaximumBitRate_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UESidelinkAggregateMaximumBitRate._cont = ASN1Dict([
        ('uESidelinkAggregateMaximumBitRate', _UESidelinkAggregateMaximumBitRate_uESidelinkAggregateMaximumBitRate),
        ('iE-Extensions', _UESidelinkAggregateMaximumBitRate_iE_Extensions),
        ])
    UESidelinkAggregateMaximumBitRate._ext = []
    
    #-----< UE-Sidelink-Aggregate-MaximumBitRate-ExtIEs >-----#
    UE_Sidelink_Aggregate_MaximumBitRate_ExtIEs = CLASS(name='UE-Sidelink-Aggregate-MaximumBitRate-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    UE_Sidelink_Aggregate_MaximumBitRate_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UEsToBeResetList >-----#
    UEsToBeResetList = SEQ_OF(name='UEsToBeResetList', mode=MODE_TYPE)
    _UEsToBeResetList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UEsToBeResetList-Item')))
    UEsToBeResetList._cont = _UEsToBeResetList__item_
    UEsToBeResetList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8192)], ev=None, er=[])
    
    #-----< UEsToBeResetList-Item >-----#
    UEsToBeResetList_Item = SEQ(name='UEsToBeResetList-Item', mode=MODE_TYPE)
    _UEsToBeResetList_Item_meNB_ID = INT(name='meNB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _UEsToBeResetList_Item_meNB_ID_ext = INT(name='meNB-ID-ext', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')), opt=True)
    _UEsToBeResetList_Item_sgNB_ID = INT(name='sgNB-ID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'SgNB-UE-X2AP-ID')), opt=True)
    _UEsToBeResetList_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UEsToBeResetList_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___UEsToBeResetList_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____UEsToBeResetList_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____UEsToBeResetList_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEsToBeResetList_Item_iE_Extensions__item__id._const_tab = ____UEsToBeResetList_Item_iE_Extensions__item__id_tab
    ___UEsToBeResetList_Item_iE_Extensions__item__id._const_tab_at = None
    ___UEsToBeResetList_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___UEsToBeResetList_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UEsToBeResetList_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____UEsToBeResetList_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEsToBeResetList_Item_iE_Extensions__item__criticality._const_tab = ____UEsToBeResetList_Item_iE_Extensions__item__criticality_tab
    ___UEsToBeResetList_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UEsToBeResetList_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UEsToBeResetList_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UEsToBeResetList_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____UEsToBeResetList_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEsToBeResetList_Item_iE_Extensions__item__extensionValue._const_tab = ____UEsToBeResetList_Item_iE_Extensions__item__extensionValue_tab
    ___UEsToBeResetList_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UEsToBeResetList_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UEsToBeResetList_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UEsToBeResetList_Item_iE_Extensions__item__id),
        ('criticality', ___UEsToBeResetList_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___UEsToBeResetList_Item_iE_Extensions__item__extensionValue),
        ])
    __UEsToBeResetList_Item_iE_Extensions__item_._ext = None
    _UEsToBeResetList_Item_iE_Extensions._cont = __UEsToBeResetList_Item_iE_Extensions__item_
    _UEsToBeResetList_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UEsToBeResetList_Item._cont = ASN1Dict([
        ('meNB-ID', _UEsToBeResetList_Item_meNB_ID),
        ('meNB-ID-ext', _UEsToBeResetList_Item_meNB_ID_ext),
        ('sgNB-ID', _UEsToBeResetList_Item_sgNB_ID),
        ('iE-Extensions', _UEsToBeResetList_Item_iE_Extensions),
        ])
    UEsToBeResetList_Item._ext = []
    
    #-----< UEsToBeResetList-Item-ExtIEs >-----#
    UEsToBeResetList_Item_ExtIEs = CLASS(name='UEsToBeResetList-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    UEsToBeResetList_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ULandDLSharing >-----#
    ULandDLSharing = SEQ(name='ULandDLSharing', mode=MODE_TYPE)
    _ULandDLSharing_uLResourcesULandDLSharing = CHOICE(name='uLResourcesULandDLSharing', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ULResourcesULandDLSharing')))
    _ULandDLSharing_dLResourcesULandDLSharing = CHOICE(name='dLResourcesULandDLSharing', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'DLResourcesULandDLSharing')))
    _ULandDLSharing_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ULandDLSharing_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___ULandDLSharing_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____ULandDLSharing_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ULandDLSharing_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ULandDLSharing_iE_Extensions__item__id._const_tab = ____ULandDLSharing_iE_Extensions__item__id_tab
    ___ULandDLSharing_iE_Extensions__item__id._const_tab_at = None
    ___ULandDLSharing_iE_Extensions__item__id._const_tab_id = 'id'
    ___ULandDLSharing_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ULandDLSharing_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ULandDLSharing_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ULandDLSharing_iE_Extensions__item__criticality._const_tab = ____ULandDLSharing_iE_Extensions__item__criticality_tab
    ___ULandDLSharing_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ULandDLSharing_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ULandDLSharing_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ULandDLSharing_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ULandDLSharing_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ULandDLSharing_iE_Extensions__item__extensionValue._const_tab = ____ULandDLSharing_iE_Extensions__item__extensionValue_tab
    ___ULandDLSharing_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ULandDLSharing_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ULandDLSharing_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ULandDLSharing_iE_Extensions__item__id),
        ('criticality', ___ULandDLSharing_iE_Extensions__item__criticality),
        ('extensionValue', ___ULandDLSharing_iE_Extensions__item__extensionValue),
        ])
    __ULandDLSharing_iE_Extensions__item_._ext = None
    _ULandDLSharing_iE_Extensions._cont = __ULandDLSharing_iE_Extensions__item_
    _ULandDLSharing_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ULandDLSharing._cont = ASN1Dict([
        ('uLResourcesULandDLSharing', _ULandDLSharing_uLResourcesULandDLSharing),
        ('dLResourcesULandDLSharing', _ULandDLSharing_dLResourcesULandDLSharing),
        ('iE-Extensions', _ULandDLSharing_iE_Extensions),
        ])
    ULandDLSharing._ext = []
    
    #-----< ULandDLSharing-ExtIEs >-----#
    ULandDLSharing_ExtIEs = CLASS(name='ULandDLSharing-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ULandDLSharing_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ULConfiguration >-----#
    ULConfiguration = SEQ(name='ULConfiguration', mode=MODE_TYPE)
    _ULConfiguration_uL_PDCP = ENUM(name='uL-PDCP', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'UL-UE-Configuration')))
    _ULConfiguration_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ULConfiguration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___ULConfiguration_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____ULConfiguration_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ULConfiguration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ULConfiguration_iE_Extensions__item__id._const_tab = ____ULConfiguration_iE_Extensions__item__id_tab
    ___ULConfiguration_iE_Extensions__item__id._const_tab_at = None
    ___ULConfiguration_iE_Extensions__item__id._const_tab_id = 'id'
    ___ULConfiguration_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ULConfiguration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ULConfiguration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ULConfiguration_iE_Extensions__item__criticality._const_tab = ____ULConfiguration_iE_Extensions__item__criticality_tab
    ___ULConfiguration_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ULConfiguration_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ULConfiguration_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ULConfiguration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ULConfiguration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ULConfiguration_iE_Extensions__item__extensionValue._const_tab = ____ULConfiguration_iE_Extensions__item__extensionValue_tab
    ___ULConfiguration_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ULConfiguration_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ULConfiguration_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ULConfiguration_iE_Extensions__item__id),
        ('criticality', ___ULConfiguration_iE_Extensions__item__criticality),
        ('extensionValue', ___ULConfiguration_iE_Extensions__item__extensionValue),
        ])
    __ULConfiguration_iE_Extensions__item_._ext = None
    _ULConfiguration_iE_Extensions._cont = __ULConfiguration_iE_Extensions__item_
    _ULConfiguration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ULConfiguration._cont = ASN1Dict([
        ('uL-PDCP', _ULConfiguration_uL_PDCP),
        ('iE-Extensions', _ULConfiguration_iE_Extensions),
        ])
    ULConfiguration._ext = []
    
    #-----< ULConfiguration-ExtIEs >-----#
    ULConfiguration_ExtIEs = CLASS(name='ULConfiguration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ULConfiguration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-UE-Configuration >-----#
    UL_UE_Configuration = ENUM(name='UL-UE-Configuration', mode=MODE_TYPE)
    UL_UE_Configuration._cont = ASN1Dict([('no-data', 0), ('shared', 1), ('only', 2)])
    UL_UE_Configuration._ext = []
    
    #-----< UL-GBR-PRB-usage >-----#
    UL_GBR_PRB_usage = INT(name='UL-GBR-PRB-usage', mode=MODE_TYPE)
    UL_GBR_PRB_usage._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    
    #-----< UL-GBR-PRB-usage-for-MIMO >-----#
    UL_GBR_PRB_usage_for_MIMO = INT(name='UL-GBR-PRB-usage-for-MIMO', mode=MODE_TYPE)
    UL_GBR_PRB_usage_for_MIMO._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    
    #-----< UL-HighInterferenceIndicationInfo >-----#
    UL_HighInterferenceIndicationInfo = SEQ_OF(name='UL-HighInterferenceIndicationInfo', mode=MODE_TYPE)
    _UL_HighInterferenceIndicationInfo__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UL-HighInterferenceIndicationInfo-Item')))
    UL_HighInterferenceIndicationInfo._cont = _UL_HighInterferenceIndicationInfo__item_
    UL_HighInterferenceIndicationInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< UL-HighInterferenceIndicationInfo-Item >-----#
    UL_HighInterferenceIndicationInfo_Item = SEQ(name='UL-HighInterferenceIndicationInfo-Item', mode=MODE_TYPE)
    _UL_HighInterferenceIndicationInfo_Item_target_Cell_ID = SEQ(name='target-Cell-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _UL_HighInterferenceIndicationInfo_Item_ul_interferenceindication = BIT_STR(name='ul-interferenceindication', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'UL-HighInterferenceIndication')))
    _UL_HighInterferenceIndicationInfo_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_HighInterferenceIndicationInfo_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___UL_HighInterferenceIndicationInfo_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_HighInterferenceIndicationInfo_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____UL_HighInterferenceIndicationInfo_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_HighInterferenceIndicationInfo_Item_iE_Extensions__item__id._const_tab = ____UL_HighInterferenceIndicationInfo_Item_iE_Extensions__item__id_tab
    ___UL_HighInterferenceIndicationInfo_Item_iE_Extensions__item__id._const_tab_at = None
    ___UL_HighInterferenceIndicationInfo_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_HighInterferenceIndicationInfo_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UL_HighInterferenceIndicationInfo_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____UL_HighInterferenceIndicationInfo_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_HighInterferenceIndicationInfo_Item_iE_Extensions__item__criticality._const_tab = ____UL_HighInterferenceIndicationInfo_Item_iE_Extensions__item__criticality_tab
    ___UL_HighInterferenceIndicationInfo_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_HighInterferenceIndicationInfo_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_HighInterferenceIndicationInfo_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UL_HighInterferenceIndicationInfo_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____UL_HighInterferenceIndicationInfo_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_HighInterferenceIndicationInfo_Item_iE_Extensions__item__extensionValue._const_tab = ____UL_HighInterferenceIndicationInfo_Item_iE_Extensions__item__extensionValue_tab
    ___UL_HighInterferenceIndicationInfo_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_HighInterferenceIndicationInfo_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_HighInterferenceIndicationInfo_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_HighInterferenceIndicationInfo_Item_iE_Extensions__item__id),
        ('criticality', ___UL_HighInterferenceIndicationInfo_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_HighInterferenceIndicationInfo_Item_iE_Extensions__item__extensionValue),
        ])
    __UL_HighInterferenceIndicationInfo_Item_iE_Extensions__item_._ext = None
    _UL_HighInterferenceIndicationInfo_Item_iE_Extensions._cont = __UL_HighInterferenceIndicationInfo_Item_iE_Extensions__item_
    _UL_HighInterferenceIndicationInfo_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_HighInterferenceIndicationInfo_Item._cont = ASN1Dict([
        ('target-Cell-ID', _UL_HighInterferenceIndicationInfo_Item_target_Cell_ID),
        ('ul-interferenceindication', _UL_HighInterferenceIndicationInfo_Item_ul_interferenceindication),
        ('iE-Extensions', _UL_HighInterferenceIndicationInfo_Item_iE_Extensions),
        ])
    UL_HighInterferenceIndicationInfo_Item._ext = []
    
    #-----< UL-HighInterferenceIndicationInfo-Item-ExtIEs >-----#
    UL_HighInterferenceIndicationInfo_Item_ExtIEs = CLASS(name='UL-HighInterferenceIndicationInfo-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    UL_HighInterferenceIndicationInfo_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-HighInterferenceIndication >-----#
    UL_HighInterferenceIndication = BIT_STR(name='UL-HighInterferenceIndication', mode=MODE_TYPE)
    UL_HighInterferenceIndication._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=110)], ev=[], er=[])
    
    #-----< UL-InterferenceOverloadIndication >-----#
    UL_InterferenceOverloadIndication = SEQ_OF(name='UL-InterferenceOverloadIndication', mode=MODE_TYPE)
    _UL_InterferenceOverloadIndication__item_ = ENUM(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UL-InterferenceOverloadIndication-Item')))
    UL_InterferenceOverloadIndication._cont = _UL_InterferenceOverloadIndication__item_
    UL_InterferenceOverloadIndication._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=110)], ev=None, er=[])
    
    #-----< UL-InterferenceOverloadIndication-Item >-----#
    UL_InterferenceOverloadIndication_Item = ENUM(name='UL-InterferenceOverloadIndication-Item', mode=MODE_TYPE)
    UL_InterferenceOverloadIndication_Item._cont = ASN1Dict([('high-interference', 0), ('medium-interference', 1), ('low-interference', 2)])
    UL_InterferenceOverloadIndication_Item._ext = []
    
    #-----< UL-non-GBR-PRB-usage >-----#
    UL_non_GBR_PRB_usage = INT(name='UL-non-GBR-PRB-usage', mode=MODE_TYPE)
    UL_non_GBR_PRB_usage._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    
    #-----< UL-non-GBR-PRB-usage-for-MIMO >-----#
    UL_non_GBR_PRB_usage_for_MIMO = INT(name='UL-non-GBR-PRB-usage-for-MIMO', mode=MODE_TYPE)
    UL_non_GBR_PRB_usage_for_MIMO._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    
    #-----< ULOnlySharing >-----#
    ULOnlySharing = SEQ(name='ULOnlySharing', mode=MODE_TYPE)
    _ULOnlySharing_uLResourceBitmapULOnlySharing = BIT_STR(name='uLResourceBitmapULOnlySharing', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'DataTrafficResources')))
    _ULOnlySharing_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ULOnlySharing_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___ULOnlySharing_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____ULOnlySharing_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ULOnlySharing_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ULOnlySharing_iE_Extensions__item__id._const_tab = ____ULOnlySharing_iE_Extensions__item__id_tab
    ___ULOnlySharing_iE_Extensions__item__id._const_tab_at = None
    ___ULOnlySharing_iE_Extensions__item__id._const_tab_id = 'id'
    ___ULOnlySharing_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ULOnlySharing_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ULOnlySharing_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ULOnlySharing_iE_Extensions__item__criticality._const_tab = ____ULOnlySharing_iE_Extensions__item__criticality_tab
    ___ULOnlySharing_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ULOnlySharing_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ULOnlySharing_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ULOnlySharing_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ULOnlySharing_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ULOnlySharing_iE_Extensions__item__extensionValue._const_tab = ____ULOnlySharing_iE_Extensions__item__extensionValue_tab
    ___ULOnlySharing_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ULOnlySharing_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ULOnlySharing_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ULOnlySharing_iE_Extensions__item__id),
        ('criticality', ___ULOnlySharing_iE_Extensions__item__criticality),
        ('extensionValue', ___ULOnlySharing_iE_Extensions__item__extensionValue),
        ])
    __ULOnlySharing_iE_Extensions__item_._ext = None
    _ULOnlySharing_iE_Extensions._cont = __ULOnlySharing_iE_Extensions__item_
    _ULOnlySharing_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ULOnlySharing._cont = ASN1Dict([
        ('uLResourceBitmapULOnlySharing', _ULOnlySharing_uLResourceBitmapULOnlySharing),
        ('iE-Extensions', _ULOnlySharing_iE_Extensions),
        ])
    ULOnlySharing._ext = []
    
    #-----< ULOnlySharing-ExtIEs >-----#
    ULOnlySharing_ExtIEs = CLASS(name='ULOnlySharing-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ULOnlySharing_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ULResourceBitmapULandDLSharing >-----#
    ULResourceBitmapULandDLSharing = BIT_STR(name='ULResourceBitmapULandDLSharing', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'DataTrafficResources')))
    
    #-----< ULResourcesULandDLSharing >-----#
    ULResourcesULandDLSharing = CHOICE(name='ULResourcesULandDLSharing', mode=MODE_TYPE)
    _ULResourcesULandDLSharing_unchanged = NULL(name='unchanged', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ULResourcesULandDLSharing_changed = BIT_STR(name='changed', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ULResourceBitmapULandDLSharing')))
    ULResourcesULandDLSharing._cont = ASN1Dict([
        ('unchanged', _ULResourcesULandDLSharing_unchanged),
        ('changed', _ULResourcesULandDLSharing_changed),
        ])
    ULResourcesULandDLSharing._ext = []
    
    #-----< UL-scheduling-PDCCH-CCE-usage >-----#
    UL_scheduling_PDCCH_CCE_usage = INT(name='UL-scheduling-PDCCH-CCE-usage', mode=MODE_TYPE)
    UL_scheduling_PDCCH_CCE_usage._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    
    #-----< UL-Total-PRB-usage >-----#
    UL_Total_PRB_usage = INT(name='UL-Total-PRB-usage', mode=MODE_TYPE)
    UL_Total_PRB_usage._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    
    #-----< UL-Total-PRB-usage-for-MIMO >-----#
    UL_Total_PRB_usage_for_MIMO = INT(name='UL-Total-PRB-usage-for-MIMO', mode=MODE_TYPE)
    UL_Total_PRB_usage_for_MIMO._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    
    #-----< UnlicensedSpectrumRestriction >-----#
    UnlicensedSpectrumRestriction = ENUM(name='UnlicensedSpectrumRestriction', mode=MODE_TYPE)
    UnlicensedSpectrumRestriction._cont = ASN1Dict([('unlicensed-restricted', 0)])
    UnlicensedSpectrumRestriction._ext = []
    
    #-----< URI-Address >-----#
    URI_Address = STR_VIS(name='URI-Address', mode=MODE_TYPE)
    
    #-----< UsableABSInformation >-----#
    UsableABSInformation = CHOICE(name='UsableABSInformation', mode=MODE_TYPE)
    _UsableABSInformation_fdd = SEQ(name='fdd', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'UsableABSInformationFDD')))
    _UsableABSInformation_tdd = SEQ(name='tdd', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'UsableABSInformationTDD')))
    UsableABSInformation._cont = ASN1Dict([
        ('fdd', _UsableABSInformation_fdd),
        ('tdd', _UsableABSInformation_tdd),
        ])
    UsableABSInformation._ext = []
    
    #-----< UsableABSInformationFDD >-----#
    UsableABSInformationFDD = SEQ(name='UsableABSInformationFDD', mode=MODE_TYPE)
    _UsableABSInformationFDD_usable_abs_pattern_info = BIT_STR(name='usable-abs-pattern-info', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UsableABSInformationFDD_usable_abs_pattern_info._const_sz = ASN1Set(rv=[40], rr=[], ev=None, er=[])
    _UsableABSInformationFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UsableABSInformationFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___UsableABSInformationFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____UsableABSInformationFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____UsableABSInformationFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UsableABSInformationFDD_iE_Extensions__item__id._const_tab = ____UsableABSInformationFDD_iE_Extensions__item__id_tab
    ___UsableABSInformationFDD_iE_Extensions__item__id._const_tab_at = None
    ___UsableABSInformationFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___UsableABSInformationFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UsableABSInformationFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____UsableABSInformationFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UsableABSInformationFDD_iE_Extensions__item__criticality._const_tab = ____UsableABSInformationFDD_iE_Extensions__item__criticality_tab
    ___UsableABSInformationFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UsableABSInformationFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UsableABSInformationFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UsableABSInformationFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____UsableABSInformationFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UsableABSInformationFDD_iE_Extensions__item__extensionValue._const_tab = ____UsableABSInformationFDD_iE_Extensions__item__extensionValue_tab
    ___UsableABSInformationFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UsableABSInformationFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UsableABSInformationFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UsableABSInformationFDD_iE_Extensions__item__id),
        ('criticality', ___UsableABSInformationFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___UsableABSInformationFDD_iE_Extensions__item__extensionValue),
        ])
    __UsableABSInformationFDD_iE_Extensions__item_._ext = None
    _UsableABSInformationFDD_iE_Extensions._cont = __UsableABSInformationFDD_iE_Extensions__item_
    _UsableABSInformationFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UsableABSInformationFDD._cont = ASN1Dict([
        ('usable-abs-pattern-info', _UsableABSInformationFDD_usable_abs_pattern_info),
        ('iE-Extensions', _UsableABSInformationFDD_iE_Extensions),
        ])
    UsableABSInformationFDD._ext = []
    
    #-----< UsableABSInformationFDD-ExtIEs >-----#
    UsableABSInformationFDD_ExtIEs = CLASS(name='UsableABSInformationFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    UsableABSInformationFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UsableABSInformationTDD >-----#
    UsableABSInformationTDD = SEQ(name='UsableABSInformationTDD', mode=MODE_TYPE)
    _UsableABSInformationTDD_usaable_abs_pattern_info = BIT_STR(name='usaable-abs-pattern-info', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UsableABSInformationTDD_usaable_abs_pattern_info._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=70)], ev=[], er=[])
    _UsableABSInformationTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UsableABSInformationTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___UsableABSInformationTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____UsableABSInformationTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____UsableABSInformationTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UsableABSInformationTDD_iE_Extensions__item__id._const_tab = ____UsableABSInformationTDD_iE_Extensions__item__id_tab
    ___UsableABSInformationTDD_iE_Extensions__item__id._const_tab_at = None
    ___UsableABSInformationTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___UsableABSInformationTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UsableABSInformationTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____UsableABSInformationTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UsableABSInformationTDD_iE_Extensions__item__criticality._const_tab = ____UsableABSInformationTDD_iE_Extensions__item__criticality_tab
    ___UsableABSInformationTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UsableABSInformationTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UsableABSInformationTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UsableABSInformationTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____UsableABSInformationTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UsableABSInformationTDD_iE_Extensions__item__extensionValue._const_tab = ____UsableABSInformationTDD_iE_Extensions__item__extensionValue_tab
    ___UsableABSInformationTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UsableABSInformationTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UsableABSInformationTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UsableABSInformationTDD_iE_Extensions__item__id),
        ('criticality', ___UsableABSInformationTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___UsableABSInformationTDD_iE_Extensions__item__extensionValue),
        ])
    __UsableABSInformationTDD_iE_Extensions__item_._ext = None
    _UsableABSInformationTDD_iE_Extensions._cont = __UsableABSInformationTDD_iE_Extensions__item_
    _UsableABSInformationTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UsableABSInformationTDD._cont = ASN1Dict([
        ('usaable-abs-pattern-info', _UsableABSInformationTDD_usaable_abs_pattern_info),
        ('iE-Extensions', _UsableABSInformationTDD_iE_Extensions),
        ])
    UsableABSInformationTDD._ext = []
    
    #-----< UsableABSInformationTDD-ExtIEs >-----#
    UsableABSInformationTDD_ExtIEs = CLASS(name='UsableABSInformationTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    UsableABSInformationTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UserPlaneTrafficActivityReport >-----#
    UserPlaneTrafficActivityReport = ENUM(name='UserPlaneTrafficActivityReport', mode=MODE_TYPE)
    UserPlaneTrafficActivityReport._cont = ASN1Dict([('inactive', 0), ('re-activated', 1)])
    UserPlaneTrafficActivityReport._ext = []
    
    #-----< V2XServicesAuthorized >-----#
    V2XServicesAuthorized = SEQ(name='V2XServicesAuthorized', mode=MODE_TYPE)
    _V2XServicesAuthorized_vehicleUE = ENUM(name='vehicleUE', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'VehicleUE')), opt=True)
    _V2XServicesAuthorized_pedestrianUE = ENUM(name='pedestrianUE', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'PedestrianUE')), opt=True)
    _V2XServicesAuthorized_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __V2XServicesAuthorized_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___V2XServicesAuthorized_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____V2XServicesAuthorized_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____V2XServicesAuthorized_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___V2XServicesAuthorized_iE_Extensions__item__id._const_tab = ____V2XServicesAuthorized_iE_Extensions__item__id_tab
    ___V2XServicesAuthorized_iE_Extensions__item__id._const_tab_at = None
    ___V2XServicesAuthorized_iE_Extensions__item__id._const_tab_id = 'id'
    ___V2XServicesAuthorized_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____V2XServicesAuthorized_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____V2XServicesAuthorized_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___V2XServicesAuthorized_iE_Extensions__item__criticality._const_tab = ____V2XServicesAuthorized_iE_Extensions__item__criticality_tab
    ___V2XServicesAuthorized_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___V2XServicesAuthorized_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___V2XServicesAuthorized_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____V2XServicesAuthorized_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____V2XServicesAuthorized_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___V2XServicesAuthorized_iE_Extensions__item__extensionValue._const_tab = ____V2XServicesAuthorized_iE_Extensions__item__extensionValue_tab
    ___V2XServicesAuthorized_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___V2XServicesAuthorized_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __V2XServicesAuthorized_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___V2XServicesAuthorized_iE_Extensions__item__id),
        ('criticality', ___V2XServicesAuthorized_iE_Extensions__item__criticality),
        ('extensionValue', ___V2XServicesAuthorized_iE_Extensions__item__extensionValue),
        ])
    __V2XServicesAuthorized_iE_Extensions__item_._ext = None
    _V2XServicesAuthorized_iE_Extensions._cont = __V2XServicesAuthorized_iE_Extensions__item_
    _V2XServicesAuthorized_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    V2XServicesAuthorized._cont = ASN1Dict([
        ('vehicleUE', _V2XServicesAuthorized_vehicleUE),
        ('pedestrianUE', _V2XServicesAuthorized_pedestrianUE),
        ('iE-Extensions', _V2XServicesAuthorized_iE_Extensions),
        ])
    V2XServicesAuthorized._ext = []
    
    #-----< V2XServicesAuthorized-ExtIEs >-----#
    V2XServicesAuthorized_ExtIEs = CLASS(name='V2XServicesAuthorized-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    V2XServicesAuthorized_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< VehicleUE >-----#
    VehicleUE = ENUM(name='VehicleUE', mode=MODE_TYPE)
    VehicleUE._cont = ASN1Dict([('authorized', 0), ('not-authorized', 1)])
    VehicleUE._ext = []
    
    #-----< PedestrianUE >-----#
    PedestrianUE = ENUM(name='PedestrianUE', mode=MODE_TYPE)
    PedestrianUE._cont = ASN1Dict([('authorized', 0), ('not-authorized', 1)])
    PedestrianUE._ext = []
    
    #-----< WidebandCQI >-----#
    WidebandCQI = SEQ(name='WidebandCQI', mode=MODE_TYPE)
    _WidebandCQI_widebandCQICodeword0 = INT(name='widebandCQICodeword0', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _WidebandCQI_widebandCQICodeword0._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=[], er=[])
    _WidebandCQI_widebandCQICodeword1 = CHOICE(name='widebandCQICodeword1', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'WidebandCQICodeword1')), opt=True)
    _WidebandCQI_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __WidebandCQI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___WidebandCQI_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____WidebandCQI_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____WidebandCQI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___WidebandCQI_iE_Extensions__item__id._const_tab = ____WidebandCQI_iE_Extensions__item__id_tab
    ___WidebandCQI_iE_Extensions__item__id._const_tab_at = None
    ___WidebandCQI_iE_Extensions__item__id._const_tab_id = 'id'
    ___WidebandCQI_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____WidebandCQI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____WidebandCQI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___WidebandCQI_iE_Extensions__item__criticality._const_tab = ____WidebandCQI_iE_Extensions__item__criticality_tab
    ___WidebandCQI_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___WidebandCQI_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___WidebandCQI_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____WidebandCQI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____WidebandCQI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___WidebandCQI_iE_Extensions__item__extensionValue._const_tab = ____WidebandCQI_iE_Extensions__item__extensionValue_tab
    ___WidebandCQI_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___WidebandCQI_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __WidebandCQI_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___WidebandCQI_iE_Extensions__item__id),
        ('criticality', ___WidebandCQI_iE_Extensions__item__criticality),
        ('extensionValue', ___WidebandCQI_iE_Extensions__item__extensionValue),
        ])
    __WidebandCQI_iE_Extensions__item_._ext = None
    _WidebandCQI_iE_Extensions._cont = __WidebandCQI_iE_Extensions__item_
    _WidebandCQI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    WidebandCQI._cont = ASN1Dict([
        ('widebandCQICodeword0', _WidebandCQI_widebandCQICodeword0),
        ('widebandCQICodeword1', _WidebandCQI_widebandCQICodeword1),
        ('iE-Extensions', _WidebandCQI_iE_Extensions),
        ])
    WidebandCQI._ext = []
    
    #-----< WidebandCQI-ExtIEs >-----#
    WidebandCQI_ExtIEs = CLASS(name='WidebandCQI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    WidebandCQI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< WidebandCQICodeword1 >-----#
    WidebandCQICodeword1 = CHOICE(name='WidebandCQICodeword1', mode=MODE_TYPE)
    _WidebandCQICodeword1_four_bitCQI = INT(name='four-bitCQI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _WidebandCQICodeword1_four_bitCQI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=[], er=[])
    _WidebandCQICodeword1_three_bitSpatialDifferentialCQI = INT(name='three-bitSpatialDifferentialCQI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _WidebandCQICodeword1_three_bitSpatialDifferentialCQI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=[], er=[])
    WidebandCQICodeword1._cont = ASN1Dict([
        ('four-bitCQI', _WidebandCQICodeword1_four_bitCQI),
        ('three-bitSpatialDifferentialCQI', _WidebandCQICodeword1_three_bitSpatialDifferentialCQI),
        ])
    WidebandCQICodeword1._ext = []
    
    #-----< WLANMeasurementConfiguration >-----#
    WLANMeasurementConfiguration = SEQ(name='WLANMeasurementConfiguration', mode=MODE_TYPE)
    _WLANMeasurementConfiguration_wlanMeasConfig = ENUM(name='wlanMeasConfig', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'WLANMeasConfig')))
    _WLANMeasurementConfiguration_wlanMeasConfigNameList = SEQ_OF(name='wlanMeasConfigNameList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'WLANMeasConfigNameList')), opt=True)
    _WLANMeasurementConfiguration_wlan_rssi = ENUM(name='wlan-rssi', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _WLANMeasurementConfiguration_wlan_rssi._cont = ASN1Dict([('true', 0)])
    _WLANMeasurementConfiguration_wlan_rssi._ext = []
    _WLANMeasurementConfiguration_wlan_rtt = ENUM(name='wlan-rtt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _WLANMeasurementConfiguration_wlan_rtt._cont = ASN1Dict([('true', 0)])
    _WLANMeasurementConfiguration_wlan_rtt._ext = []
    _WLANMeasurementConfiguration_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __WLANMeasurementConfiguration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___WLANMeasurementConfiguration_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____WLANMeasurementConfiguration_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____WLANMeasurementConfiguration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___WLANMeasurementConfiguration_iE_Extensions__item__id._const_tab = ____WLANMeasurementConfiguration_iE_Extensions__item__id_tab
    ___WLANMeasurementConfiguration_iE_Extensions__item__id._const_tab_at = None
    ___WLANMeasurementConfiguration_iE_Extensions__item__id._const_tab_id = 'id'
    ___WLANMeasurementConfiguration_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____WLANMeasurementConfiguration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____WLANMeasurementConfiguration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___WLANMeasurementConfiguration_iE_Extensions__item__criticality._const_tab = ____WLANMeasurementConfiguration_iE_Extensions__item__criticality_tab
    ___WLANMeasurementConfiguration_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___WLANMeasurementConfiguration_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___WLANMeasurementConfiguration_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____WLANMeasurementConfiguration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____WLANMeasurementConfiguration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___WLANMeasurementConfiguration_iE_Extensions__item__extensionValue._const_tab = ____WLANMeasurementConfiguration_iE_Extensions__item__extensionValue_tab
    ___WLANMeasurementConfiguration_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___WLANMeasurementConfiguration_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __WLANMeasurementConfiguration_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___WLANMeasurementConfiguration_iE_Extensions__item__id),
        ('criticality', ___WLANMeasurementConfiguration_iE_Extensions__item__criticality),
        ('extensionValue', ___WLANMeasurementConfiguration_iE_Extensions__item__extensionValue),
        ])
    __WLANMeasurementConfiguration_iE_Extensions__item_._ext = None
    _WLANMeasurementConfiguration_iE_Extensions._cont = __WLANMeasurementConfiguration_iE_Extensions__item_
    _WLANMeasurementConfiguration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    WLANMeasurementConfiguration._cont = ASN1Dict([
        ('wlanMeasConfig', _WLANMeasurementConfiguration_wlanMeasConfig),
        ('wlanMeasConfigNameList', _WLANMeasurementConfiguration_wlanMeasConfigNameList),
        ('wlan-rssi', _WLANMeasurementConfiguration_wlan_rssi),
        ('wlan-rtt', _WLANMeasurementConfiguration_wlan_rtt),
        ('iE-Extensions', _WLANMeasurementConfiguration_iE_Extensions),
        ])
    WLANMeasurementConfiguration._ext = []
    
    #-----< WLANMeasurementConfiguration-ExtIEs >-----#
    WLANMeasurementConfiguration_ExtIEs = CLASS(name='WLANMeasurementConfiguration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    WLANMeasurementConfiguration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< WLANMeasConfigNameList >-----#
    WLANMeasConfigNameList = SEQ_OF(name='WLANMeasConfigNameList', mode=MODE_TYPE)
    _WLANMeasConfigNameList__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'WLANName')))
    WLANMeasConfigNameList._cont = _WLANMeasConfigNameList__item_
    WLANMeasConfigNameList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< WLANMeasConfig >-----#
    WLANMeasConfig = ENUM(name='WLANMeasConfig', mode=MODE_TYPE)
    WLANMeasConfig._cont = ASN1Dict([('setup', 0)])
    WLANMeasConfig._ext = []
    
    #-----< WLANName >-----#
    WLANName = OCT_STR(name='WLANName', mode=MODE_TYPE)
    WLANName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< WTID >-----#
    WTID = CHOICE(name='WTID', mode=MODE_TYPE)
    _WTID_wTID_Type1 = SEQ(name='wTID-Type1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'WTID-Type1')))
    _WTID_wTID_Type2 = BIT_STR(name='wTID-Type2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'WTID-Long-Type2')))
    WTID._cont = ASN1Dict([
        ('wTID-Type1', _WTID_wTID_Type1),
        ('wTID-Type2', _WTID_wTID_Type2),
        ])
    WTID._ext = []
    
    #-----< WTID-Type1 >-----#
    WTID_Type1 = SEQ(name='WTID-Type1', mode=MODE_TYPE)
    _WTID_Type1_pLMN_Identity = OCT_STR(name='pLMN-Identity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'PLMN-Identity')))
    _WTID_Type1_shortWTID = BIT_STR(name='shortWTID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _WTID_Type1_shortWTID._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    WTID_Type1._cont = ASN1Dict([
        ('pLMN-Identity', _WTID_Type1_pLMN_Identity),
        ('shortWTID', _WTID_Type1_shortWTID),
        ])
    WTID_Type1._ext = []
    
    #-----< WTID-Long-Type2 >-----#
    WTID_Long_Type2 = BIT_STR(name='WTID-Long-Type2', mode=MODE_TYPE)
    WTID_Long_Type2._const_sz = ASN1Set(rv=[48], rr=[], ev=None, er=[])
    
    #-----< WT-UE-XwAP-ID >-----#
    WT_UE_XwAP_ID = OCT_STR(name='WT-UE-XwAP-ID', mode=MODE_TYPE)
    WT_UE_XwAP_ID._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< X2BenefitValue >-----#
    X2BenefitValue = INT(name='X2BenefitValue', mode=MODE_TYPE)
    X2BenefitValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=[], er=[])
    
    _all_ = [
        _ABSInformation_fdd,
        _ABSInformation_tdd,
        _ABSInformation_abs_inactive,
        ABSInformation,
        _ABSInformationFDD_abs_pattern_info,
        _ABSInformationFDD_numberOfCellSpecificAntennaPorts,
        _ABSInformationFDD_measurement_subset,
        ____ABSInformationFDD_iE_Extensions__item__id_tab,
        ___ABSInformationFDD_iE_Extensions__item__id,
        ____ABSInformationFDD_iE_Extensions__item__criticality_tab,
        ___ABSInformationFDD_iE_Extensions__item__criticality,
        ____ABSInformationFDD_iE_Extensions__item__extensionValue_tab,
        ___ABSInformationFDD_iE_Extensions__item__extensionValue,
        __ABSInformationFDD_iE_Extensions__item_,
        _ABSInformationFDD_iE_Extensions,
        ABSInformationFDD,
        ABSInformationFDD_ExtIEs,
        _ABSInformationTDD_abs_pattern_info,
        _ABSInformationTDD_numberOfCellSpecificAntennaPorts,
        _ABSInformationTDD_measurement_subset,
        ____ABSInformationTDD_iE_Extensions__item__id_tab,
        ___ABSInformationTDD_iE_Extensions__item__id,
        ____ABSInformationTDD_iE_Extensions__item__criticality_tab,
        ___ABSInformationTDD_iE_Extensions__item__criticality,
        ____ABSInformationTDD_iE_Extensions__item__extensionValue_tab,
        ___ABSInformationTDD_iE_Extensions__item__extensionValue,
        __ABSInformationTDD_iE_Extensions__item_,
        _ABSInformationTDD_iE_Extensions,
        ABSInformationTDD,
        ABSInformationTDD_ExtIEs,
        _ABS_Status_dL_ABS_status,
        _ABS_Status_usableABSInformation,
        ____ABS_Status_iE_Extensions__item__id_tab,
        ___ABS_Status_iE_Extensions__item__id,
        ____ABS_Status_iE_Extensions__item__criticality_tab,
        ___ABS_Status_iE_Extensions__item__criticality,
        ____ABS_Status_iE_Extensions__item__extensionValue_tab,
        ___ABS_Status_iE_Extensions__item__extensionValue,
        __ABS_Status_iE_Extensions__item_,
        _ABS_Status_iE_Extensions,
        ABS_Status,
        ABS_Status_ExtIEs,
        ActivationID,
        _Additional_Measurement_Timing_Configuration_List__item_,
        Additional_Measurement_Timing_Configuration_List,
        _Additional_Measurement_Timing_Configuration_Item_additionalMeasurementTimingConfiguration,
        _Additional_Measurement_Timing_Configuration_Item_csi_RS_MTC_Configuration_List,
        ____Additional_Measurement_Timing_Configuration_Item_iE_Extensions__item__id_tab,
        ___Additional_Measurement_Timing_Configuration_Item_iE_Extensions__item__id,
        ____Additional_Measurement_Timing_Configuration_Item_iE_Extensions__item__criticality_tab,
        ___Additional_Measurement_Timing_Configuration_Item_iE_Extensions__item__criticality,
        ____Additional_Measurement_Timing_Configuration_Item_iE_Extensions__item__extensionValue_tab,
        ___Additional_Measurement_Timing_Configuration_Item_iE_Extensions__item__extensionValue,
        __Additional_Measurement_Timing_Configuration_Item_iE_Extensions__item_,
        _Additional_Measurement_Timing_Configuration_Item_iE_Extensions,
        Additional_Measurement_Timing_Configuration_Item,
        Additional_Measurement_Timing_Configuration_Item_ExtIEs,
        _CSI_RS_MTC_Configuration_List__item_,
        CSI_RS_MTC_Configuration_List,
        _CSI_RS_MTC_Configuration_Item_csi_RS_Index,
        _CSI_RS_MTC_Configuration_Item_csi_RS_Status,
        _CSI_RS_MTC_Configuration_Item_csi_RS_Neighbour_List,
        ____CSI_RS_MTC_Configuration_Item_iE_Extensions__item__id_tab,
        ___CSI_RS_MTC_Configuration_Item_iE_Extensions__item__id,
        ____CSI_RS_MTC_Configuration_Item_iE_Extensions__item__criticality_tab,
        ___CSI_RS_MTC_Configuration_Item_iE_Extensions__item__criticality,
        ____CSI_RS_MTC_Configuration_Item_iE_Extensions__item__extensionValue_tab,
        ___CSI_RS_MTC_Configuration_Item_iE_Extensions__item__extensionValue,
        __CSI_RS_MTC_Configuration_Item_iE_Extensions__item_,
        _CSI_RS_MTC_Configuration_Item_iE_Extensions,
        CSI_RS_MTC_Configuration_Item,
        CSI_RS_MTC_Configuration_Item_ExtIEs,
        _CSI_RS_Neighbour_List__item_,
        CSI_RS_Neighbour_List,
        _CSI_RS_Neighbour_Item_nr_cgi,
        _CSI_RS_Neighbour_Item_csi_RS_MTC_Neighbour_List,
        ____CSI_RS_Neighbour_Item_iE_Extensions__item__id_tab,
        ___CSI_RS_Neighbour_Item_iE_Extensions__item__id,
        ____CSI_RS_Neighbour_Item_iE_Extensions__item__criticality_tab,
        ___CSI_RS_Neighbour_Item_iE_Extensions__item__criticality,
        ____CSI_RS_Neighbour_Item_iE_Extensions__item__extensionValue_tab,
        ___CSI_RS_Neighbour_Item_iE_Extensions__item__extensionValue,
        __CSI_RS_Neighbour_Item_iE_Extensions__item_,
        _CSI_RS_Neighbour_Item_iE_Extensions,
        CSI_RS_Neighbour_Item,
        CSI_RS_Neighbour_Item_ExtIEs,
        _CSI_RS_MTC_Neighbour_List__item_,
        CSI_RS_MTC_Neighbour_List,
        _CSI_RS_MTC_Neighbour_Item_csi_RS_Index,
        ____CSI_RS_MTC_Neighbour_Item_iE_Extensions__item__id_tab,
        ___CSI_RS_MTC_Neighbour_Item_iE_Extensions__item__id,
        ____CSI_RS_MTC_Neighbour_Item_iE_Extensions__item__criticality_tab,
        ___CSI_RS_MTC_Neighbour_Item_iE_Extensions__item__criticality,
        ____CSI_RS_MTC_Neighbour_Item_iE_Extensions__item__extensionValue_tab,
        ___CSI_RS_MTC_Neighbour_Item_iE_Extensions__item__extensionValue,
        __CSI_RS_MTC_Neighbour_Item_iE_Extensions__item_,
        _CSI_RS_MTC_Neighbour_Item_iE_Extensions,
        CSI_RS_MTC_Neighbour_Item,
        CSI_RS_MTC_Neighbour_Item_ExtIEs,
        _AdditionalListofForwardingGTPTunnelEndpoint__item_,
        AdditionalListofForwardingGTPTunnelEndpoint,
        _AdditionalListofForwardingGTPTunnelEndpoint_Item_uL_GTPtunnelEndpoint,
        _AdditionalListofForwardingGTPTunnelEndpoint_Item_dL_GTPtunnelEndpoint,
        ____AdditionalListofForwardingGTPTunnelEndpoint_Item_iE_Extensions__item__id_tab,
        ___AdditionalListofForwardingGTPTunnelEndpoint_Item_iE_Extensions__item__id,
        ____AdditionalListofForwardingGTPTunnelEndpoint_Item_iE_Extensions__item__criticality_tab,
        ___AdditionalListofForwardingGTPTunnelEndpoint_Item_iE_Extensions__item__criticality,
        ____AdditionalListofForwardingGTPTunnelEndpoint_Item_iE_Extensions__item__extensionValue_tab,
        ___AdditionalListofForwardingGTPTunnelEndpoint_Item_iE_Extensions__item__extensionValue,
        __AdditionalListofForwardingGTPTunnelEndpoint_Item_iE_Extensions__item_,
        _AdditionalListofForwardingGTPTunnelEndpoint_Item_iE_Extensions,
        AdditionalListofForwardingGTPTunnelEndpoint_Item,
        AdditionalListofForwardingGTPTunnelEndpoint_Item_ExtIEs,
        AdditionLocationInformation,
        AdditionalRRMPriorityIndex,
        _AdditionalSpecialSubframe_Info_additionalspecialSubframePatterns,
        _AdditionalSpecialSubframe_Info_cyclicPrefixDL,
        _AdditionalSpecialSubframe_Info_cyclicPrefixUL,
        ____AdditionalSpecialSubframe_Info_iE_Extensions__item__id_tab,
        ___AdditionalSpecialSubframe_Info_iE_Extensions__item__id,
        ____AdditionalSpecialSubframe_Info_iE_Extensions__item__criticality_tab,
        ___AdditionalSpecialSubframe_Info_iE_Extensions__item__criticality,
        ____AdditionalSpecialSubframe_Info_iE_Extensions__item__extensionValue_tab,
        ___AdditionalSpecialSubframe_Info_iE_Extensions__item__extensionValue,
        __AdditionalSpecialSubframe_Info_iE_Extensions__item_,
        _AdditionalSpecialSubframe_Info_iE_Extensions,
        AdditionalSpecialSubframe_Info,
        AdditionalSpecialSubframe_Info_ExtIEs,
        AdditionalSpecialSubframePatterns,
        _AdditionalSpecialSubframeExtension_Info_additionalspecialSubframePatternsExtension,
        _AdditionalSpecialSubframeExtension_Info_cyclicPrefixDL,
        _AdditionalSpecialSubframeExtension_Info_cyclicPrefixUL,
        ____AdditionalSpecialSubframeExtension_Info_iE_Extensions__item__id_tab,
        ___AdditionalSpecialSubframeExtension_Info_iE_Extensions__item__id,
        ____AdditionalSpecialSubframeExtension_Info_iE_Extensions__item__criticality_tab,
        ___AdditionalSpecialSubframeExtension_Info_iE_Extensions__item__criticality,
        ____AdditionalSpecialSubframeExtension_Info_iE_Extensions__item__extensionValue_tab,
        ___AdditionalSpecialSubframeExtension_Info_iE_Extensions__item__extensionValue,
        __AdditionalSpecialSubframeExtension_Info_iE_Extensions__item_,
        _AdditionalSpecialSubframeExtension_Info_iE_Extensions,
        AdditionalSpecialSubframeExtension_Info,
        AdditionalSpecialSubframeExtension_Info_ExtIEs,
        AdditionalSpecialSubframePatternsExtension,
        AvailableFastMCGRecoveryViaSRB3,
        AerialUEsubscriptionInformation,
        _AllocationAndRetentionPriority_priorityLevel,
        _AllocationAndRetentionPriority_pre_emptionCapability,
        _AllocationAndRetentionPriority_pre_emptionVulnerability,
        ____AllocationAndRetentionPriority_iE_Extensions__item__id_tab,
        ___AllocationAndRetentionPriority_iE_Extensions__item__id,
        ____AllocationAndRetentionPriority_iE_Extensions__item__criticality_tab,
        ___AllocationAndRetentionPriority_iE_Extensions__item__criticality,
        ____AllocationAndRetentionPriority_iE_Extensions__item__extensionValue_tab,
        ___AllocationAndRetentionPriority_iE_Extensions__item__extensionValue,
        __AllocationAndRetentionPriority_iE_Extensions__item_,
        _AllocationAndRetentionPriority_iE_Extensions,
        AllocationAndRetentionPriority,
        AllocationAndRetentionPriority_ExtIEs,
        _AreaScopeOfMDT_cellBased,
        _AreaScopeOfMDT_tABased,
        _AreaScopeOfMDT_pLMNWide,
        _AreaScopeOfMDT_tAIBased,
        AreaScopeOfMDT,
        _AreaScopeOfQMC_cellBased,
        _AreaScopeOfQMC_tABased,
        _AreaScopeOfQMC_tAIBased,
        _AreaScopeOfQMC_pLMNAreaBased,
        AreaScopeOfQMC,
        _AS_SecurityInformation_key_eNodeB_star,
        _AS_SecurityInformation_nextHopChainingCount,
        ____AS_SecurityInformation_iE_Extensions__item__id_tab,
        ___AS_SecurityInformation_iE_Extensions__item__id,
        ____AS_SecurityInformation_iE_Extensions__item__criticality_tab,
        ___AS_SecurityInformation_iE_Extensions__item__criticality,
        ____AS_SecurityInformation_iE_Extensions__item__extensionValue_tab,
        ___AS_SecurityInformation_iE_Extensions__item__extensionValue,
        __AS_SecurityInformation_iE_Extensions__item_,
        _AS_SecurityInformation_iE_Extensions,
        AS_SecurityInformation,
        AS_SecurityInformation_ExtIEs,
        _AdditionalPLMNs_Item__item_,
        AdditionalPLMNs_Item,
        BandwidthReducedSI,
        BearerType,
        BenefitMetric,
        BitRate,
        _BroadcastPLMNs_Item__item_,
        BroadcastPLMNs_Item,
        _BluetoothMeasurementConfiguration_bluetoothMeasConfig,
        _BluetoothMeasurementConfiguration_bluetoothMeasConfigNameList,
        _BluetoothMeasurementConfiguration_bt_rssi,
        ____BluetoothMeasurementConfiguration_iE_Extensions__item__id_tab,
        ___BluetoothMeasurementConfiguration_iE_Extensions__item__id,
        ____BluetoothMeasurementConfiguration_iE_Extensions__item__criticality_tab,
        ___BluetoothMeasurementConfiguration_iE_Extensions__item__criticality,
        ____BluetoothMeasurementConfiguration_iE_Extensions__item__extensionValue_tab,
        ___BluetoothMeasurementConfiguration_iE_Extensions__item__extensionValue,
        __BluetoothMeasurementConfiguration_iE_Extensions__item_,
        _BluetoothMeasurementConfiguration_iE_Extensions,
        BluetoothMeasurementConfiguration,
        BluetoothMeasurementConfiguration_ExtIEs,
        _BluetoothMeasConfigNameList__item_,
        BluetoothMeasConfigNameList,
        BluetoothMeasConfig,
        BluetoothName,
        _BPLMN_ID_Info_EUTRA__item_,
        BPLMN_ID_Info_EUTRA,
        _BPLMN_ID_Info_EUTRA_Item_broadcastPLMNs,
        _BPLMN_ID_Info_EUTRA_Item_tac,
        _BPLMN_ID_Info_EUTRA_Item_e_utraCI,
        ____BPLMN_ID_Info_EUTRA_Item_iE_Extension__item__id_tab,
        ___BPLMN_ID_Info_EUTRA_Item_iE_Extension__item__id,
        ____BPLMN_ID_Info_EUTRA_Item_iE_Extension__item__criticality_tab,
        ___BPLMN_ID_Info_EUTRA_Item_iE_Extension__item__criticality,
        ____BPLMN_ID_Info_EUTRA_Item_iE_Extension__item__extensionValue_tab,
        ___BPLMN_ID_Info_EUTRA_Item_iE_Extension__item__extensionValue,
        __BPLMN_ID_Info_EUTRA_Item_iE_Extension__item_,
        _BPLMN_ID_Info_EUTRA_Item_iE_Extension,
        BPLMN_ID_Info_EUTRA_Item,
        BPLMN_ID_Info_EUTRA_Item_ExtIEs,
        _BPLMN_ID_Info_NR__item_,
        BPLMN_ID_Info_NR,
        _BPLMN_ID_Info_NR_Item_broadcastPLMNs,
        _BPLMN_ID_Info_NR_Item_fiveGS_TAC,
        _BPLMN_ID_Info_NR_Item_nr_CI,
        ____BPLMN_ID_Info_NR_Item_iE_Extension__item__id_tab,
        ___BPLMN_ID_Info_NR_Item_iE_Extension__item__id,
        ____BPLMN_ID_Info_NR_Item_iE_Extension__item__criticality_tab,
        ___BPLMN_ID_Info_NR_Item_iE_Extension__item__criticality,
        ____BPLMN_ID_Info_NR_Item_iE_Extension__item__extensionValue_tab,
        ___BPLMN_ID_Info_NR_Item_iE_Extension__item__extensionValue,
        __BPLMN_ID_Info_NR_Item_iE_Extension__item_,
        _BPLMN_ID_Info_NR_Item_iE_Extension,
        BPLMN_ID_Info_NR_Item,
        BPLMN_ID_Info_NR_Item_ExtIEs,
        _BroadcastextPLMNs__item_,
        BroadcastextPLMNs,
        CapacityValue,
        _Cause_radioNetwork,
        _Cause_transport,
        _Cause_protocol,
        _Cause_misc,
        Cause,
        CauseMisc,
        CauseProtocol,
        CauseRadioNetwork,
        CauseTransport,
        _CellBasedMDT_cellIdListforMDT,
        ____CellBasedMDT_iE_Extensions__item__id_tab,
        ___CellBasedMDT_iE_Extensions__item__id,
        ____CellBasedMDT_iE_Extensions__item__criticality_tab,
        ___CellBasedMDT_iE_Extensions__item__criticality,
        ____CellBasedMDT_iE_Extensions__item__extensionValue_tab,
        ___CellBasedMDT_iE_Extensions__item__extensionValue,
        __CellBasedMDT_iE_Extensions__item_,
        _CellBasedMDT_iE_Extensions,
        CellBasedMDT,
        CellBasedMDT_ExtIEs,
        _CellBasedQMC_cellIdListforQMC,
        ____CellBasedQMC_iE_Extensions__item__id_tab,
        ___CellBasedQMC_iE_Extensions__item__id,
        ____CellBasedQMC_iE_Extensions__item__criticality_tab,
        ___CellBasedQMC_iE_Extensions__item__criticality,
        ____CellBasedQMC_iE_Extensions__item__extensionValue_tab,
        ___CellBasedQMC_iE_Extensions__item__extensionValue,
        __CellBasedQMC_iE_Extensions__item_,
        _CellBasedQMC_iE_Extensions,
        CellBasedQMC,
        CellBasedQMC_ExtIEs,
        CellCapacityClassValue,
        CellDeploymentStatusIndicator,
        _CellIdListforMDT__item_,
        CellIdListforMDT,
        _CellIdListforQMC__item_,
        CellIdListforQMC,
        _CellReplacingInfo_replacingCellsList,
        ____CellReplacingInfo_iE_Extensions__item__id_tab,
        ___CellReplacingInfo_iE_Extensions__item__id,
        ____CellReplacingInfo_iE_Extensions__item__criticality_tab,
        ___CellReplacingInfo_iE_Extensions__item__criticality,
        ____CellReplacingInfo_iE_Extensions__item__extensionValue_tab,
        ___CellReplacingInfo_iE_Extensions__item__extensionValue,
        __CellReplacingInfo_iE_Extensions__item_,
        _CellReplacingInfo_iE_Extensions,
        CellReplacingInfo,
        CellReplacingInfo_ExtIEs,
        CellReportingIndicator,
        Cell_Size,
        _CellType_cell_Size,
        ____CellType_iE_Extensions__item__id_tab,
        ___CellType_iE_Extensions__item__id,
        ____CellType_iE_Extensions__item__criticality_tab,
        ___CellType_iE_Extensions__item__criticality,
        ____CellType_iE_Extensions__item__extensionValue_tab,
        ___CellType_iE_Extensions__item__extensionValue,
        __CellType_iE_Extensions__item_,
        _CellType_iE_Extensions,
        CellType,
        CellType_ExtIEs,
        _CPACcandidatePSCells_list__item_,
        CPACcandidatePSCells_list,
        _CPACcandidatePSCells_item_pscell_id,
        ____CPACcandidatePSCells_item_iE_Extensions__item__id_tab,
        ___CPACcandidatePSCells_item_iE_Extensions__item__id,
        ____CPACcandidatePSCells_item_iE_Extensions__item__criticality_tab,
        ___CPACcandidatePSCells_item_iE_Extensions__item__criticality,
        ____CPACcandidatePSCells_item_iE_Extensions__item__extensionValue_tab,
        ___CPACcandidatePSCells_item_iE_Extensions__item__extensionValue,
        __CPACcandidatePSCells_item_iE_Extensions__item_,
        _CPACcandidatePSCells_item_iE_Extensions,
        CPACcandidatePSCells_item,
        CPACcandidatePSCells_item_ExtIEs,
        CPCindicator,
        CPCdataforwarding,
        _CPAinformation_REQ_max_no_of_pscells,
        _CPAinformation_REQ_estimatedArrivalProbability,
        ____CPAinformation_REQ_iE_Extensions__item__id_tab,
        ___CPAinformation_REQ_iE_Extensions__item__id,
        ____CPAinformation_REQ_iE_Extensions__item__criticality_tab,
        ___CPAinformation_REQ_iE_Extensions__item__criticality,
        ____CPAinformation_REQ_iE_Extensions__item__extensionValue_tab,
        ___CPAinformation_REQ_iE_Extensions__item__extensionValue,
        __CPAinformation_REQ_iE_Extensions__item_,
        _CPAinformation_REQ_iE_Extensions,
        CPAinformation_REQ,
        CPAinformation_REQ_ExtIEs,
        _CPAinformation_REQ_ACK_candidate_pscells,
        ____CPAinformation_REQ_ACK_iE_Extensions__item__id_tab,
        ___CPAinformation_REQ_ACK_iE_Extensions__item__id,
        ____CPAinformation_REQ_ACK_iE_Extensions__item__criticality_tab,
        ___CPAinformation_REQ_ACK_iE_Extensions__item__criticality,
        ____CPAinformation_REQ_ACK_iE_Extensions__item__extensionValue_tab,
        ___CPAinformation_REQ_ACK_iE_Extensions__item__extensionValue,
        __CPAinformation_REQ_ACK_iE_Extensions__item_,
        _CPAinformation_REQ_ACK_iE_Extensions,
        CPAinformation_REQ_ACK,
        CPAinformation_REQ_ACK_ExtIEs,
        _CPCinformation_REQD_cpc_target_sgnb_list,
        ____CPCinformation_REQD_iE_Extensions__item__id_tab,
        ___CPCinformation_REQD_iE_Extensions__item__id,
        ____CPCinformation_REQD_iE_Extensions__item__criticality_tab,
        ___CPCinformation_REQD_iE_Extensions__item__criticality,
        ____CPCinformation_REQD_iE_Extensions__item__extensionValue_tab,
        ___CPCinformation_REQD_iE_Extensions__item__extensionValue,
        __CPCinformation_REQD_iE_Extensions__item_,
        _CPCinformation_REQD_iE_Extensions,
        CPCinformation_REQD,
        CPCinformation_REQD_ExtIEs,
        _CPC_target_SgNB_reqd_list__item_,
        CPC_target_SgNB_reqd_list,
        _CPC_target_SgNB_reqd_item_target_SgNB_ID,
        _CPC_target_SgNB_reqd_item_cpc_indicator,
        _CPC_target_SgNB_reqd_item_max_no_of_pscells,
        _CPC_target_SgNB_reqd_item_estimatedArrivalProbability,
        _CPC_target_SgNB_reqd_item_sgNBtoMeNBContainer,
        ____CPC_target_SgNB_reqd_item_iE_Extensions__item__id_tab,
        ___CPC_target_SgNB_reqd_item_iE_Extensions__item__id,
        ____CPC_target_SgNB_reqd_item_iE_Extensions__item__criticality_tab,
        ___CPC_target_SgNB_reqd_item_iE_Extensions__item__criticality,
        ____CPC_target_SgNB_reqd_item_iE_Extensions__item__extensionValue_tab,
        ___CPC_target_SgNB_reqd_item_iE_Extensions__item__extensionValue,
        __CPC_target_SgNB_reqd_item_iE_Extensions__item_,
        _CPC_target_SgNB_reqd_item_iE_Extensions,
        CPC_target_SgNB_reqd_item,
        CPC_target_SgNB_reqd_item_ExtIEs,
        _CPCinformation_CONF_cpc_target_sgnb_list,
        ____CPCinformation_CONF_iE_Extensions__item__id_tab,
        ___CPCinformation_CONF_iE_Extensions__item__id,
        ____CPCinformation_CONF_iE_Extensions__item__criticality_tab,
        ___CPCinformation_CONF_iE_Extensions__item__criticality,
        ____CPCinformation_CONF_iE_Extensions__item__extensionValue_tab,
        ___CPCinformation_CONF_iE_Extensions__item__extensionValue,
        __CPCinformation_CONF_iE_Extensions__item_,
        _CPCinformation_CONF_iE_Extensions,
        CPCinformation_CONF,
        CPCinformation_CONF_ExtIEs,
        _CPC_target_SgNB_conf_list__item_,
        CPC_target_SgNB_conf_list,
        _CPC_target_SgNB_conf_item_target_SgNB_ID,
        _CPC_target_SgNB_conf_item_candidate_pscells,
        ____CPC_target_SgNB_conf_item_iE_Extensions__item__id_tab,
        ___CPC_target_SgNB_conf_item_iE_Extensions__item__id,
        ____CPC_target_SgNB_conf_item_iE_Extensions__item__criticality_tab,
        ___CPC_target_SgNB_conf_item_iE_Extensions__item__criticality,
        ____CPC_target_SgNB_conf_item_iE_Extensions__item__extensionValue_tab,
        ___CPC_target_SgNB_conf_item_iE_Extensions__item__extensionValue,
        __CPC_target_SgNB_conf_item_iE_Extensions__item_,
        _CPC_target_SgNB_conf_item_iE_Extensions,
        CPC_target_SgNB_conf_item,
        CPC_target_SgNB_conf_item_ExtIEs,
        _CPCinformation_NOTIFY_cpc_indicator,
        ____CPCinformation_NOTIFY_iE_Extensions__item__id_tab,
        ___CPCinformation_NOTIFY_iE_Extensions__item__id,
        ____CPCinformation_NOTIFY_iE_Extensions__item__criticality_tab,
        ___CPCinformation_NOTIFY_iE_Extensions__item__criticality,
        ____CPCinformation_NOTIFY_iE_Extensions__item__extensionValue_tab,
        ___CPCinformation_NOTIFY_iE_Extensions__item__extensionValue,
        __CPCinformation_NOTIFY_iE_Extensions__item_,
        _CPCinformation_NOTIFY_iE_Extensions,
        CPCinformation_NOTIFY,
        CPCinformation_NOTIFY_ExtIEs,
        _CPAinformation_MOD_max_no_of_pscells,
        _CPAinformation_MOD_estimatedArrivalProbability,
        ____CPAinformation_MOD_iE_Extensions__item__id_tab,
        ___CPAinformation_MOD_iE_Extensions__item__id,
        ____CPAinformation_MOD_iE_Extensions__item__criticality_tab,
        ___CPAinformation_MOD_iE_Extensions__item__criticality,
        ____CPAinformation_MOD_iE_Extensions__item__extensionValue_tab,
        ___CPAinformation_MOD_iE_Extensions__item__extensionValue,
        __CPAinformation_MOD_iE_Extensions__item_,
        _CPAinformation_MOD_iE_Extensions,
        CPAinformation_MOD,
        CPAinformation_MOD_ExtIEs,
        _CPCupdate_MOD_cpc_target_sgnb_list,
        ____CPCupdate_MOD_iE_Extensions__item__id_tab,
        ___CPCupdate_MOD_iE_Extensions__item__id,
        ____CPCupdate_MOD_iE_Extensions__item__criticality_tab,
        ___CPCupdate_MOD_iE_Extensions__item__criticality,
        ____CPCupdate_MOD_iE_Extensions__item__extensionValue_tab,
        ___CPCupdate_MOD_iE_Extensions__item__extensionValue,
        __CPCupdate_MOD_iE_Extensions__item_,
        _CPCupdate_MOD_iE_Extensions,
        CPCupdate_MOD,
        CPCupdate_MOD_ExtIEs,
        _CPC_target_SgNB_mod_list__item_,
        CPC_target_SgNB_mod_list,
        _CPC_target_SgNB_mod_item_target_SgNB_ID,
        _CPC_target_SgNB_mod_item_candidate_pscells,
        ____CPC_target_SgNB_mod_item_iE_Extensions__item__id_tab,
        ___CPC_target_SgNB_mod_item_iE_Extensions__item__id,
        ____CPC_target_SgNB_mod_item_iE_Extensions__item__criticality_tab,
        ___CPC_target_SgNB_mod_item_iE_Extensions__item__criticality,
        ____CPC_target_SgNB_mod_item_iE_Extensions__item__extensionValue_tab,
        ___CPC_target_SgNB_mod_item_iE_Extensions__item__extensionValue,
        __CPC_target_SgNB_mod_item_iE_Extensions__item_,
        _CPC_target_SgNB_mod_item_iE_Extensions,
        CPC_target_SgNB_mod_item,
        CPC_target_SgNB_mod_item_ExtIEs,
        _CPAinformation_MOD_ACK_candidate_pscells,
        ____CPAinformation_MOD_ACK_iE_Extensions__item__id_tab,
        ___CPAinformation_MOD_ACK_iE_Extensions__item__id,
        ____CPAinformation_MOD_ACK_iE_Extensions__item__criticality_tab,
        ___CPAinformation_MOD_ACK_iE_Extensions__item__criticality,
        ____CPAinformation_MOD_ACK_iE_Extensions__item__extensionValue_tab,
        ___CPAinformation_MOD_ACK_iE_Extensions__item__extensionValue,
        __CPAinformation_MOD_ACK_iE_Extensions__item_,
        _CPAinformation_MOD_ACK_iE_Extensions,
        CPAinformation_MOD_ACK,
        CPAinformation_MOD_ACK_ExtIEs,
        _CPACinformation_REQD_candidate_pscells,
        ____CPACinformation_REQD_iE_Extensions__item__id_tab,
        ___CPACinformation_REQD_iE_Extensions__item__id,
        ____CPACinformation_REQD_iE_Extensions__item__criticality_tab,
        ___CPACinformation_REQD_iE_Extensions__item__criticality,
        ____CPACinformation_REQD_iE_Extensions__item__extensionValue_tab,
        ___CPACinformation_REQD_iE_Extensions__item__extensionValue,
        __CPACinformation_REQD_iE_Extensions__item_,
        _CPACinformation_REQD_iE_Extensions,
        CPACinformation_REQD,
        CPACinformation_REQD_ExtIEs,
        CHO_DC_EarlyDataForwarding,
        CHO_DC_Indicator,
        _CNTypeRestrictions__item_,
        CNTypeRestrictions,
        _CNTypeRestrictionsItem_plmn_Id,
        _CNTypeRestrictionsItem_cn_type,
        ____CNTypeRestrictionsItem_iE_Extensions__item__id_tab,
        ___CNTypeRestrictionsItem_iE_Extensions__item__id,
        ____CNTypeRestrictionsItem_iE_Extensions__item__criticality_tab,
        ___CNTypeRestrictionsItem_iE_Extensions__item__criticality,
        ____CNTypeRestrictionsItem_iE_Extensions__item__extensionValue_tab,
        ___CNTypeRestrictionsItem_iE_Extensions__item__extensionValue,
        __CNTypeRestrictionsItem_iE_Extensions__item_,
        _CNTypeRestrictionsItem_iE_Extensions,
        CNTypeRestrictionsItem,
        CNTypeRestrictionsItem_ExtIEs,
        _CoMPHypothesisSet__item_,
        CoMPHypothesisSet,
        _CoMPHypothesisSetItem_coMPCellID,
        _CoMPHypothesisSetItem_coMPHypothesis,
        ____CoMPHypothesisSetItem_iE_Extensions__item__id_tab,
        ___CoMPHypothesisSetItem_iE_Extensions__item__id,
        ____CoMPHypothesisSetItem_iE_Extensions__item__criticality_tab,
        ___CoMPHypothesisSetItem_iE_Extensions__item__criticality,
        ____CoMPHypothesisSetItem_iE_Extensions__item__extensionValue_tab,
        ___CoMPHypothesisSetItem_iE_Extensions__item__extensionValue,
        __CoMPHypothesisSetItem_iE_Extensions__item_,
        _CoMPHypothesisSetItem_iE_Extensions,
        CoMPHypothesisSetItem,
        CoMPHypothesisSetItem_ExtIEs,
        _CoMPInformation_coMPInformationItem,
        _CoMPInformation_coMPInformationStartTime,
        ____CoMPInformation_iE_Extensions__item__id_tab,
        ___CoMPInformation_iE_Extensions__item__id,
        ____CoMPInformation_iE_Extensions__item__criticality_tab,
        ___CoMPInformation_iE_Extensions__item__criticality,
        ____CoMPInformation_iE_Extensions__item__extensionValue_tab,
        ___CoMPInformation_iE_Extensions__item__extensionValue,
        __CoMPInformation_iE_Extensions__item_,
        _CoMPInformation_iE_Extensions,
        CoMPInformation,
        CoMPInformation_ExtIEs,
        __CoMPInformationItem__item__coMPHypothesisSet,
        __CoMPInformationItem__item__benefitMetric,
        _____CoMPInformationItem__item__iE_Extensions__item__id_tab,
        ____CoMPInformationItem__item__iE_Extensions__item__id,
        _____CoMPInformationItem__item__iE_Extensions__item__criticality_tab,
        ____CoMPInformationItem__item__iE_Extensions__item__criticality,
        _____CoMPInformationItem__item__iE_Extensions__item__extensionValue_tab,
        ____CoMPInformationItem__item__iE_Extensions__item__extensionValue,
        ___CoMPInformationItem__item__iE_Extensions__item_,
        __CoMPInformationItem__item__iE_Extensions,
        _CoMPInformationItem__item_,
        CoMPInformationItem,
        CoMPInformationItem_ExtIEs,
        __CoMPInformationStartTime__item__startSFN,
        __CoMPInformationStartTime__item__startSubframeNumber,
        _____CoMPInformationStartTime__item__iE_Extensions__item__id_tab,
        ____CoMPInformationStartTime__item__iE_Extensions__item__id,
        _____CoMPInformationStartTime__item__iE_Extensions__item__criticality_tab,
        ____CoMPInformationStartTime__item__iE_Extensions__item__criticality,
        _____CoMPInformationStartTime__item__iE_Extensions__item__extensionValue_tab,
        ____CoMPInformationStartTime__item__iE_Extensions__item__extensionValue,
        ___CoMPInformationStartTime__item__iE_Extensions__item_,
        __CoMPInformationStartTime__item__iE_Extensions,
        _CoMPInformationStartTime__item_,
        CoMPInformationStartTime,
        CoMPInformationStartTime_ExtIEs,
        _CompositeAvailableCapacity_cellCapacityClassValue,
        _CompositeAvailableCapacity_capacityValue,
        ____CompositeAvailableCapacity_iE_Extensions__item__id_tab,
        ___CompositeAvailableCapacity_iE_Extensions__item__id,
        ____CompositeAvailableCapacity_iE_Extensions__item__criticality_tab,
        ___CompositeAvailableCapacity_iE_Extensions__item__criticality,
        ____CompositeAvailableCapacity_iE_Extensions__item__extensionValue_tab,
        ___CompositeAvailableCapacity_iE_Extensions__item__extensionValue,
        __CompositeAvailableCapacity_iE_Extensions__item_,
        _CompositeAvailableCapacity_iE_Extensions,
        CompositeAvailableCapacity,
        CompositeAvailableCapacity_ExtIEs,
        _CompositeAvailableCapacityGroup_dL_CompositeAvailableCapacity,
        _CompositeAvailableCapacityGroup_uL_CompositeAvailableCapacity,
        ____CompositeAvailableCapacityGroup_iE_Extensions__item__id_tab,
        ___CompositeAvailableCapacityGroup_iE_Extensions__item__id,
        ____CompositeAvailableCapacityGroup_iE_Extensions__item__criticality_tab,
        ___CompositeAvailableCapacityGroup_iE_Extensions__item__criticality,
        ____CompositeAvailableCapacityGroup_iE_Extensions__item__extensionValue_tab,
        ___CompositeAvailableCapacityGroup_iE_Extensions__item__extensionValue,
        __CompositeAvailableCapacityGroup_iE_Extensions__item_,
        _CompositeAvailableCapacityGroup_iE_Extensions,
        CompositeAvailableCapacityGroup,
        CompositeAvailableCapacityGroup_ExtIEs,
        Correlation_ID,
        _COUNTvalue_pDCP_SN,
        _COUNTvalue_hFN,
        ____COUNTvalue_iE_Extensions__item__id_tab,
        ___COUNTvalue_iE_Extensions__item__id,
        ____COUNTvalue_iE_Extensions__item__criticality_tab,
        ___COUNTvalue_iE_Extensions__item__criticality,
        ____COUNTvalue_iE_Extensions__item__extensionValue_tab,
        ___COUNTvalue_iE_Extensions__item__extensionValue,
        __COUNTvalue_iE_Extensions__item_,
        _COUNTvalue_iE_Extensions,
        COUNTvalue,
        COUNTvalue_ExtIEs,
        _COUNTValueExtended_pDCP_SNExtended,
        _COUNTValueExtended_hFNModified,
        ____COUNTValueExtended_iE_Extensions__item__id_tab,
        ___COUNTValueExtended_iE_Extensions__item__id,
        ____COUNTValueExtended_iE_Extensions__item__criticality_tab,
        ___COUNTValueExtended_iE_Extensions__item__criticality,
        ____COUNTValueExtended_iE_Extensions__item__extensionValue_tab,
        ___COUNTValueExtended_iE_Extensions__item__extensionValue,
        __COUNTValueExtended_iE_Extensions__item_,
        _COUNTValueExtended_iE_Extensions,
        COUNTValueExtended,
        COUNTValueExtended_ExtIEs,
        _COUNTvaluePDCP_SNlength18_pDCP_SNlength18,
        _COUNTvaluePDCP_SNlength18_hFNforPDCP_SNlength18,
        ____COUNTvaluePDCP_SNlength18_iE_Extensions__item__id_tab,
        ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__id,
        ____COUNTvaluePDCP_SNlength18_iE_Extensions__item__criticality_tab,
        ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__criticality,
        ____COUNTvaluePDCP_SNlength18_iE_Extensions__item__extensionValue_tab,
        ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__extensionValue,
        __COUNTvaluePDCP_SNlength18_iE_Extensions__item_,
        _COUNTvaluePDCP_SNlength18_iE_Extensions,
        COUNTvaluePDCP_SNlength18,
        COUNTvaluePDCP_SNlength18_ExtIEs,
        _CoverageModificationList__item_,
        CoverageModificationList,
        _CoverageModification_Item_eCGI,
        _CoverageModification_Item_coverageState,
        _CoverageModification_Item_cellDeploymentStatusIndicator,
        _CoverageModification_Item_cellReplacingInfo,
        CoverageModification_Item,
        _CPTransportLayerInformation_endpointIPAddress,
        _CPTransportLayerInformation_endpointIPAddressAndPort,
        CPTransportLayerInformation,
        _CriticalityDiagnostics_procedureCode,
        _CriticalityDiagnostics_triggeringMessage,
        _CriticalityDiagnostics_procedureCriticality,
        _CriticalityDiagnostics_iEsCriticalityDiagnostics,
        ____CriticalityDiagnostics_iE_Extensions__item__id_tab,
        ___CriticalityDiagnostics_iE_Extensions__item__id,
        ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab,
        ___CriticalityDiagnostics_iE_Extensions__item__criticality,
        ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab,
        ___CriticalityDiagnostics_iE_Extensions__item__extensionValue,
        __CriticalityDiagnostics_iE_Extensions__item_,
        _CriticalityDiagnostics_iE_Extensions,
        CriticalityDiagnostics,
        CriticalityDiagnostics_ExtIEs,
        __CriticalityDiagnostics_IE_List__item__iECriticality,
        __CriticalityDiagnostics_IE_List__item__iE_ID,
        __CriticalityDiagnostics_IE_List__item__typeOfError,
        _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab,
        ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id,
        _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality_tab,
        ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality,
        _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue_tab,
        ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue,
        ___CriticalityDiagnostics_IE_List__item__iE_Extensions__item_,
        __CriticalityDiagnostics_IE_List__item__iE_Extensions,
        _CriticalityDiagnostics_IE_List__item_,
        CriticalityDiagnostics_IE_List,
        CriticalityDiagnostics_IE_List_ExtIEs,
        CRNTI,
        CSGMembershipStatus,
        CSG_Id,
        __CSIReportList__item__uEID,
        __CSIReportList__item__cSIReportPerCSIProcess,
        _____CSIReportList__item__iE_Extensions__item__id_tab,
        ____CSIReportList__item__iE_Extensions__item__id,
        _____CSIReportList__item__iE_Extensions__item__criticality_tab,
        ____CSIReportList__item__iE_Extensions__item__criticality,
        _____CSIReportList__item__iE_Extensions__item__extensionValue_tab,
        ____CSIReportList__item__iE_Extensions__item__extensionValue,
        ___CSIReportList__item__iE_Extensions__item_,
        __CSIReportList__item__iE_Extensions,
        _CSIReportList__item_,
        CSIReportList,
        CSIReportList_ExtIEs,
        __CSIReportPerCSIProcess__item__cSIProcessConfigurationIndex,
        __CSIReportPerCSIProcess__item__cSIReportPerCSIProcessItem,
        _____CSIReportPerCSIProcess__item__iE_Extensions__item__id_tab,
        ____CSIReportPerCSIProcess__item__iE_Extensions__item__id,
        _____CSIReportPerCSIProcess__item__iE_Extensions__item__criticality_tab,
        ____CSIReportPerCSIProcess__item__iE_Extensions__item__criticality,
        _____CSIReportPerCSIProcess__item__iE_Extensions__item__extensionValue_tab,
        ____CSIReportPerCSIProcess__item__iE_Extensions__item__extensionValue,
        ___CSIReportPerCSIProcess__item__iE_Extensions__item_,
        __CSIReportPerCSIProcess__item__iE_Extensions,
        _CSIReportPerCSIProcess__item_,
        CSIReportPerCSIProcess,
        CSIReportPerCSIProcess_ExtIEs,
        __CSIReportPerCSIProcessItem__item__rI,
        __CSIReportPerCSIProcessItem__item__widebandCQI,
        __CSIReportPerCSIProcessItem__item__subbandSize,
        __CSIReportPerCSIProcessItem__item__subbandCQIList,
        _____CSIReportPerCSIProcessItem__item__iE_Extensions__item__id_tab,
        ____CSIReportPerCSIProcessItem__item__iE_Extensions__item__id,
        _____CSIReportPerCSIProcessItem__item__iE_Extensions__item__criticality_tab,
        ____CSIReportPerCSIProcessItem__item__iE_Extensions__item__criticality,
        _____CSIReportPerCSIProcessItem__item__iE_Extensions__item__extensionValue_tab,
        ____CSIReportPerCSIProcessItem__item__iE_Extensions__item__extensionValue,
        ___CSIReportPerCSIProcessItem__item__iE_Extensions__item_,
        __CSIReportPerCSIProcessItem__item__iE_Extensions,
        _CSIReportPerCSIProcessItem__item_,
        CSIReportPerCSIProcessItem,
        CSIReportPerCSIProcessItem_ExtIEs,
        CyclicPrefixDL,
        CyclicPrefixUL,
        CHOtrigger,
        _CHOinformation_REQ_cho_trigger,
        _CHOinformation_REQ_new_eNB_UE_X2AP_ID,
        _CHOinformation_REQ_new_eNB_UE_X2AP_ID_Extension,
        _CHOinformation_REQ_cHO_EstimatedArrivalProbability,
        ____CHOinformation_REQ_iE_Extensions__item__id_tab,
        ___CHOinformation_REQ_iE_Extensions__item__id,
        ____CHOinformation_REQ_iE_Extensions__item__criticality_tab,
        ___CHOinformation_REQ_iE_Extensions__item__criticality,
        ____CHOinformation_REQ_iE_Extensions__item__extensionValue_tab,
        ___CHOinformation_REQ_iE_Extensions__item__extensionValue,
        __CHOinformation_REQ_iE_Extensions__item_,
        _CHOinformation_REQ_iE_Extensions,
        CHOinformation_REQ,
        CHOinformation_REQ_ExtIEs,
        _CHOinformation_ACK_requestedTargetCellID,
        _CHOinformation_ACK_maxCHOpreparations,
        ____CHOinformation_ACK_iE_Extensions__item__id_tab,
        ___CHOinformation_ACK_iE_Extensions__item__id,
        ____CHOinformation_ACK_iE_Extensions__item__criticality_tab,
        ___CHOinformation_ACK_iE_Extensions__item__criticality,
        ____CHOinformation_ACK_iE_Extensions__item__extensionValue_tab,
        ___CHOinformation_ACK_iE_Extensions__item__extensionValue,
        __CHOinformation_ACK_iE_Extensions__item_,
        _CHOinformation_ACK_iE_Extensions,
        CHOinformation_ACK,
        CHOinformation_ACK_ExtIEs,
        _CandidateCellsToBeCancelledList__item_,
        CandidateCellsToBeCancelledList,
        CHO_Probability,
        _CHOinformation_AddReq_source_eNB_ID,
        _CHOinformation_AddReq_source_eNB_UE_X2AP_ID,
        _CHOinformation_AddReq_source_eNB_UE_X2AP_ID_Ext,
        _CHOinformation_AddReq_cHO_EstimatedArrivalProbability,
        ____CHOinformation_AddReq_iE_Extensions__item__id_tab,
        ___CHOinformation_AddReq_iE_Extensions__item__id,
        ____CHOinformation_AddReq_iE_Extensions__item__criticality_tab,
        ___CHOinformation_AddReq_iE_Extensions__item__criticality,
        ____CHOinformation_AddReq_iE_Extensions__item__extensionValue_tab,
        ___CHOinformation_AddReq_iE_Extensions__item__extensionValue,
        __CHOinformation_AddReq_iE_Extensions__item_,
        _CHOinformation_AddReq_iE_Extensions,
        CHOinformation_AddReq,
        CHOinformation_AddReq_ExtIEs,
        _CHOinformation_ModReq_conditionalReconfig,
        _CHOinformation_ModReq_cHO_EstimatedArrivalProbability,
        ____CHOinformation_ModReq_iE_Extensions__item__id_tab,
        ___CHOinformation_ModReq_iE_Extensions__item__id,
        ____CHOinformation_ModReq_iE_Extensions__item__criticality_tab,
        ___CHOinformation_ModReq_iE_Extensions__item__criticality,
        ____CHOinformation_ModReq_iE_Extensions__item__extensionValue_tab,
        ___CHOinformation_ModReq_iE_Extensions__item__extensionValue,
        __CHOinformation_ModReq_iE_Extensions__item_,
        _CHOinformation_ModReq_iE_Extensions,
        CHOinformation_ModReq,
        CHOinformation_ModReq_ExtIEs,
        CSI_RSTransmissionIndication,
        DataTrafficResources,
        _DataTrafficResourceIndication_activationSFN,
        _DataTrafficResourceIndication_sharedResourceType,
        _DataTrafficResourceIndication_reservedSubframePattern,
        ____DataTrafficResourceIndication_iE_Extensions__item__id_tab,
        ___DataTrafficResourceIndication_iE_Extensions__item__id,
        ____DataTrafficResourceIndication_iE_Extensions__item__criticality_tab,
        ___DataTrafficResourceIndication_iE_Extensions__item__criticality,
        ____DataTrafficResourceIndication_iE_Extensions__item__extensionValue_tab,
        ___DataTrafficResourceIndication_iE_Extensions__item__extensionValue,
        __DataTrafficResourceIndication_iE_Extensions__item_,
        _DataTrafficResourceIndication_iE_Extensions,
        DataTrafficResourceIndication,
        DataTrafficResourceIndication_ExtIEs,
        _DAPSRequestInfo_dAPSIndicator,
        ____DAPSRequestInfo_iE_Extensions__item__id_tab,
        ___DAPSRequestInfo_iE_Extensions__item__id,
        ____DAPSRequestInfo_iE_Extensions__item__criticality_tab,
        ___DAPSRequestInfo_iE_Extensions__item__criticality,
        ____DAPSRequestInfo_iE_Extensions__item__extensionValue_tab,
        ___DAPSRequestInfo_iE_Extensions__item__extensionValue,
        __DAPSRequestInfo_iE_Extensions__item_,
        _DAPSRequestInfo_iE_Extensions,
        DAPSRequestInfo,
        DAPSRequestInfo_ExtIEs,
        _DAPSResponseInfo_dAPSResponseIndicator,
        ____DAPSResponseInfo_iE_Extensions__item__id_tab,
        ___DAPSResponseInfo_iE_Extensions__item__id,
        ____DAPSResponseInfo_iE_Extensions__item__criticality_tab,
        ___DAPSResponseInfo_iE_Extensions__item__criticality,
        ____DAPSResponseInfo_iE_Extensions__item__extensionValue_tab,
        ___DAPSResponseInfo_iE_Extensions__item__extensionValue,
        __DAPSResponseInfo_iE_Extensions__item_,
        _DAPSResponseInfo_iE_Extensions,
        DAPSResponseInfo,
        DAPSResponseInfo_ExtIEs,
        DeactivationIndication,
        _DeliveryStatus_highestSuccessDeliveredPDCPSN,
        ____DeliveryStatus_iE_Extensions__item__id_tab,
        ___DeliveryStatus_iE_Extensions__item__id,
        ____DeliveryStatus_iE_Extensions__item__criticality_tab,
        ___DeliveryStatus_iE_Extensions__item__criticality,
        ____DeliveryStatus_iE_Extensions__item__extensionValue_tab,
        ___DeliveryStatus_iE_Extensions__item__extensionValue,
        __DeliveryStatus_iE_Extensions__item_,
        _DeliveryStatus_iE_Extensions,
        DeliveryStatus,
        DeliveryStatus_ExtIEs,
        DesiredActNotificationLevel,
        DirectForwardingPathAvailability,
        DL_ABS_status,
        DL_Forwarding,
        DL_GBR_PRB_usage,
        DL_GBR_PRB_usage_for_MIMO,
        DL_non_GBR_PRB_usage,
        DL_non_GBR_PRB_usage_for_MIMO,
        DLResourceBitmapULandDLSharing,
        _DLResourcesULandDLSharing_unchanged,
        _DLResourcesULandDLSharing_changed,
        DLResourcesULandDLSharing,
        DL_scheduling_PDCCH_CCE_usage,
        DL_Total_PRB_usage,
        DL_Total_PRB_usage_for_MIMO,
        DRB_ID,
        DuplicationActivation,
        _DynamicDLTransmissionInformation_naics_active,
        _DynamicDLTransmissionInformation_naics_inactive,
        DynamicDLTransmissionInformation,
        _DynamicNAICSInformation_transmissionModes,
        _DynamicNAICSInformation_pB_information,
        __DynamicNAICSInformation_pA_list__item_,
        _DynamicNAICSInformation_pA_list,
        ____DynamicNAICSInformation_iE_Extensions__item__id_tab,
        ___DynamicNAICSInformation_iE_Extensions__item__id,
        ____DynamicNAICSInformation_iE_Extensions__item__criticality_tab,
        ___DynamicNAICSInformation_iE_Extensions__item__criticality,
        ____DynamicNAICSInformation_iE_Extensions__item__extensionValue_tab,
        ___DynamicNAICSInformation_iE_Extensions__item__extensionValue,
        __DynamicNAICSInformation_iE_Extensions__item_,
        _DynamicNAICSInformation_iE_Extensions,
        DynamicNAICSInformation,
        DynamicNAICSInformation_ExtIEs,
        EARFCN,
        EARFCNExtension,
        _ECGI_pLMN_Identity,
        _ECGI_eUTRANcellIdentifier,
        ____ECGI_iE_Extensions__item__id_tab,
        ___ECGI_iE_Extensions__item__id,
        ____ECGI_iE_Extensions__item__criticality_tab,
        ___ECGI_iE_Extensions__item__criticality,
        ____ECGI_iE_Extensions__item__extensionValue_tab,
        ___ECGI_iE_Extensions__item__extensionValue,
        __ECGI_iE_Extensions__item_,
        _ECGI_iE_Extensions,
        ECGI,
        ECGI_ExtIEs,
        EndcSONConfigurationTransfer,
        _EnhancedRNTP_enhancedRNTPBitmap,
        _EnhancedRNTP_rNTP_High_Power_Threshold,
        _EnhancedRNTP_enhancedRNTPStartTime,
        ____EnhancedRNTP_iE_Extensions__item__id_tab,
        ___EnhancedRNTP_iE_Extensions__item__id,
        ____EnhancedRNTP_iE_Extensions__item__criticality_tab,
        ___EnhancedRNTP_iE_Extensions__item__criticality,
        ____EnhancedRNTP_iE_Extensions__item__extensionValue_tab,
        ___EnhancedRNTP_iE_Extensions__item__extensionValue,
        __EnhancedRNTP_iE_Extensions__item_,
        _EnhancedRNTP_iE_Extensions,
        EnhancedRNTP,
        EnhancedRNTP_ExtIEs,
        _EnhancedRNTPStartTime_startSFN,
        _EnhancedRNTPStartTime_startSubframeNumber,
        ____EnhancedRNTPStartTime_iE_Extensions__item__id_tab,
        ___EnhancedRNTPStartTime_iE_Extensions__item__id,
        ____EnhancedRNTPStartTime_iE_Extensions__item__criticality_tab,
        ___EnhancedRNTPStartTime_iE_Extensions__item__criticality,
        ____EnhancedRNTPStartTime_iE_Extensions__item__extensionValue_tab,
        ___EnhancedRNTPStartTime_iE_Extensions__item__extensionValue,
        __EnhancedRNTPStartTime_iE_Extensions__item_,
        _EnhancedRNTPStartTime_iE_Extensions,
        EnhancedRNTPStartTime,
        EnhancedRNTPStartTime_ExtIEs,
        _ENB_ID_macro_eNB_ID,
        _ENB_ID_home_eNB_ID,
        _ENB_ID_short_Macro_eNB_ID,
        _ENB_ID_long_Macro_eNB_ID,
        ENB_ID,
        EncryptionAlgorithms,
        _EN_DC_ResourceConfiguration_pDCPatSgNB,
        _EN_DC_ResourceConfiguration_mCGresources,
        _EN_DC_ResourceConfiguration_sCGresources,
        ____EN_DC_ResourceConfiguration_iE_Extensions__item__id_tab,
        ___EN_DC_ResourceConfiguration_iE_Extensions__item__id,
        ____EN_DC_ResourceConfiguration_iE_Extensions__item__criticality_tab,
        ___EN_DC_ResourceConfiguration_iE_Extensions__item__criticality,
        ____EN_DC_ResourceConfiguration_iE_Extensions__item__extensionValue_tab,
        ___EN_DC_ResourceConfiguration_iE_Extensions__item__extensionValue,
        __EN_DC_ResourceConfiguration_iE_Extensions__item_,
        _EN_DC_ResourceConfiguration_iE_Extensions,
        EN_DC_ResourceConfiguration,
        EN_DC_ResourceConfigurationExtIEs,
        EPCHandoverRestrictionListContainer,
        _EPLMNs__item_,
        EPLMNs,
        _ERABActivityNotifyItemList__item_,
        ERABActivityNotifyItemList,
        _ERABActivityNotifyItem_e_RAB_ID,
        _ERABActivityNotifyItem_activityReport,
        ____ERABActivityNotifyItem_iE_Extensions__item__id_tab,
        ___ERABActivityNotifyItem_iE_Extensions__item__id,
        ____ERABActivityNotifyItem_iE_Extensions__item__criticality_tab,
        ___ERABActivityNotifyItem_iE_Extensions__item__criticality,
        ____ERABActivityNotifyItem_iE_Extensions__item__extensionValue_tab,
        ___ERABActivityNotifyItem_iE_Extensions__item__extensionValue,
        __ERABActivityNotifyItem_iE_Extensions__item_,
        _ERABActivityNotifyItem_iE_Extensions,
        ERABActivityNotifyItem,
        ERABActivityNotifyItem_ExtIEs,
        E_RAB_ID,
        _E_RAB_Level_QoS_Parameters_qCI,
        _E_RAB_Level_QoS_Parameters_allocationAndRetentionPriority,
        _E_RAB_Level_QoS_Parameters_gbrQosInformation,
        ____E_RAB_Level_QoS_Parameters_iE_Extensions__item__id_tab,
        _____E_RAB_Level_QoS_Parameters_iE_Extensions__item__id_tab_val_Extension_0,
        _____E_RAB_Level_QoS_Parameters_iE_Extensions__item__id_tab_val_Extension_1,
        ___E_RAB_Level_QoS_Parameters_iE_Extensions__item__id,
        ___E_RAB_Level_QoS_Parameters_iE_Extensions__item__criticality,
        ___E_RAB_Level_QoS_Parameters_iE_Extensions__item__extensionValue,
        __E_RAB_Level_QoS_Parameters_iE_Extensions__item_,
        _E_RAB_Level_QoS_Parameters_iE_Extensions,
        E_RAB_Level_QoS_Parameters,
        E_RAB_Level_QoS_Parameters_ExtIEs,
        _E_RAB_Level_QoS_Parameters_ExtIEs_val_Extension_0,
        _E_RAB_Level_QoS_Parameters_ExtIEs_val_Extension_1,
        ___E_RAB_List__item__id_tab,
        ____E_RAB_List__item__id_tab_val_Value_0,
        __E_RAB_List__item__id,
        __E_RAB_List__item__criticality,
        __E_RAB_List__item__value,
        _E_RAB_List__item_,
        E_RAB_List,
        E_RAB_ItemIEs,
        _E_RAB_ItemIEs_val_Value_0,
        _E_RAB_Item_e_RAB_ID,
        _E_RAB_Item_cause,
        ____E_RAB_Item_iE_Extensions__item__id_tab,
        ___E_RAB_Item_iE_Extensions__item__id,
        ____E_RAB_Item_iE_Extensions__item__criticality_tab,
        ___E_RAB_Item_iE_Extensions__item__criticality,
        ____E_RAB_Item_iE_Extensions__item__extensionValue_tab,
        ___E_RAB_Item_iE_Extensions__item__extensionValue,
        __E_RAB_Item_iE_Extensions__item_,
        _E_RAB_Item_iE_Extensions,
        E_RAB_Item,
        E_RAB_Item_ExtIEs,
        _E_RABsSubjectToEarlyStatusTransfer_List__item_,
        E_RABsSubjectToEarlyStatusTransfer_List,
        _E_RABsSubjectToEarlyStatusTransfer_Item_e_RAB_ID,
        _E_RABsSubjectToEarlyStatusTransfer_Item_fIRST_DL_COUNTValue,
        _E_RABsSubjectToEarlyStatusTransfer_Item_fIRST_DL_COUNTValueExtended,
        _E_RABsSubjectToEarlyStatusTransfer_Item_fIRST_DL_COUNTValueforPDCPSNLength18,
        ____E_RABsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__id_tab,
        ___E_RABsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__id,
        ____E_RABsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__criticality_tab,
        ___E_RABsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__criticality,
        ____E_RABsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__extensionValue_tab,
        ___E_RABsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__extensionValue,
        __E_RABsSubjectToEarlyStatusTransfer_Item_iE_Extension__item_,
        _E_RABsSubjectToEarlyStatusTransfer_Item_iE_Extension,
        E_RABsSubjectToEarlyStatusTransfer_Item,
        E_RABsSubjectToEarlyStatusTransfer_Item_ExtIEs,
        _E_RABsSubjectToDLDiscarding_List__item_,
        E_RABsSubjectToDLDiscarding_List,
        _E_RABsSubjectToDLDiscarding_Item_e_RAB_ID,
        _E_RABsSubjectToDLDiscarding_Item_dISCARD_DL_COUNTValue,
        _E_RABsSubjectToDLDiscarding_Item_dISCARD_DL_COUNTValueExtended,
        _E_RABsSubjectToDLDiscarding_Item_dISCARD_DL_COUNTValueforPDCPSNLength18,
        ____E_RABsSubjectToDLDiscarding_Item_iE_Extension__item__id_tab,
        ___E_RABsSubjectToDLDiscarding_Item_iE_Extension__item__id,
        ____E_RABsSubjectToDLDiscarding_Item_iE_Extension__item__criticality_tab,
        ___E_RABsSubjectToDLDiscarding_Item_iE_Extension__item__criticality,
        ____E_RABsSubjectToDLDiscarding_Item_iE_Extension__item__extensionValue_tab,
        ___E_RABsSubjectToDLDiscarding_Item_iE_Extension__item__extensionValue,
        __E_RABsSubjectToDLDiscarding_Item_iE_Extension__item_,
        _E_RABsSubjectToDLDiscarding_Item_iE_Extension,
        E_RABsSubjectToDLDiscarding_Item,
        E_RABsSubjectToDLDiscarding_Item_ExtIEs,
        ___E_RABUsageReportList__item__id_tab,
        ____E_RABUsageReportList__item__id_tab_val_Value_0,
        __E_RABUsageReportList__item__id,
        __E_RABUsageReportList__item__criticality,
        __E_RABUsageReportList__item__value,
        _E_RABUsageReportList__item_,
        E_RABUsageReportList,
        E_RABUsageReport_ItemIEs,
        _E_RABUsageReport_ItemIEs_val_Value_0,
        _E_RABUsageReport_Item_startTimeStamp,
        _E_RABUsageReport_Item_endTimeStamp,
        _E_RABUsageReport_Item_usageCountUL,
        _E_RABUsageReport_Item_usageCountDL,
        ____E_RABUsageReport_Item_iE_Extensions__item__id_tab,
        ___E_RABUsageReport_Item_iE_Extensions__item__id,
        ____E_RABUsageReport_Item_iE_Extensions__item__criticality_tab,
        ___E_RABUsageReport_Item_iE_Extensions__item__criticality,
        ____E_RABUsageReport_Item_iE_Extensions__item__extensionValue_tab,
        ___E_RABUsageReport_Item_iE_Extensions__item__extensionValue,
        __E_RABUsageReport_Item_iE_Extensions__item_,
        _E_RABUsageReport_Item_iE_Extensions,
        E_RABUsageReport_Item,
        E_RABUsageReport_Item_ExtIEs,
        Ethernet_Type,
        _EUTRA_Mode_Info_fDD,
        _EUTRA_Mode_Info_tDD,
        EUTRA_Mode_Info,
        EUTRANCellIdentifier,
        EUTRANTraceID,
        EventType,
        _ExpectedUEBehaviour_expectedActivity,
        _ExpectedUEBehaviour_expectedHOInterval,
        ____ExpectedUEBehaviour_iE_Extensions__item__id_tab,
        ___ExpectedUEBehaviour_iE_Extensions__item__id,
        ____ExpectedUEBehaviour_iE_Extensions__item__criticality_tab,
        ___ExpectedUEBehaviour_iE_Extensions__item__criticality,
        ____ExpectedUEBehaviour_iE_Extensions__item__extensionValue_tab,
        ___ExpectedUEBehaviour_iE_Extensions__item__extensionValue,
        __ExpectedUEBehaviour_iE_Extensions__item_,
        _ExpectedUEBehaviour_iE_Extensions,
        ExpectedUEBehaviour,
        ExpectedUEBehaviour_ExtIEs,
        _ExpectedUEActivityBehaviour_expectedActivityPeriod,
        _ExpectedUEActivityBehaviour_expectedIdlePeriod,
        _ExpectedUEActivityBehaviour_sourceofUEActivityBehaviourInformation,
        ____ExpectedUEActivityBehaviour_iE_Extensions__item__id_tab,
        ___ExpectedUEActivityBehaviour_iE_Extensions__item__id,
        ____ExpectedUEActivityBehaviour_iE_Extensions__item__criticality_tab,
        ___ExpectedUEActivityBehaviour_iE_Extensions__item__criticality,
        ____ExpectedUEActivityBehaviour_iE_Extensions__item__extensionValue_tab,
        ___ExpectedUEActivityBehaviour_iE_Extensions__item__extensionValue,
        __ExpectedUEActivityBehaviour_iE_Extensions__item_,
        _ExpectedUEActivityBehaviour_iE_Extensions,
        ExpectedUEActivityBehaviour,
        ExpectedUEActivityBehaviour_ExtIEs,
        ExpectedActivityPeriod,
        ExpectedIdlePeriod,
        ExpectedHOInterval,
        _ExtendedULInterferenceOverloadInfo_associatedSubframes,
        _ExtendedULInterferenceOverloadInfo_extended_ul_InterferenceOverloadIndication,
        ____ExtendedULInterferenceOverloadInfo_iE_Extensions__item__id_tab,
        ___ExtendedULInterferenceOverloadInfo_iE_Extensions__item__id,
        ____ExtendedULInterferenceOverloadInfo_iE_Extensions__item__criticality_tab,
        ___ExtendedULInterferenceOverloadInfo_iE_Extensions__item__criticality,
        ____ExtendedULInterferenceOverloadInfo_iE_Extensions__item__extensionValue_tab,
        ___ExtendedULInterferenceOverloadInfo_iE_Extensions__item__extensionValue,
        __ExtendedULInterferenceOverloadInfo_iE_Extensions__item_,
        _ExtendedULInterferenceOverloadInfo_iE_Extensions,
        ExtendedULInterferenceOverloadInfo,
        ExtendedULInterferenceOverloadInfo_ExtIEs,
        ExtendedBitRate,
        F1CTrafficContainer,
        _FastMCGRecovery_rrcContainer,
        ____FastMCGRecovery_iE_Extensions__item__id_tab,
        ___FastMCGRecovery_iE_Extensions__item__id,
        ____FastMCGRecovery_iE_Extensions__item__criticality_tab,
        ___FastMCGRecovery_iE_Extensions__item__criticality,
        ____FastMCGRecovery_iE_Extensions__item__extensionValue_tab,
        ___FastMCGRecovery_iE_Extensions__item__extensionValue,
        __FastMCGRecovery_iE_Extensions__item_,
        _FastMCGRecovery_iE_Extensions,
        FastMCGRecovery,
        FastMCGRecovery_ExtIEs,
        _FDD_Info_uL_EARFCN,
        _FDD_Info_dL_EARFCN,
        _FDD_Info_uL_Transmission_Bandwidth,
        _FDD_Info_dL_Transmission_Bandwidth,
        ____FDD_Info_iE_Extensions__item__id_tab,
        _____FDD_Info_iE_Extensions__item__id_tab_val_Extension_0,
        _____FDD_Info_iE_Extensions__item__id_tab_val_Extension_1,
        _____FDD_Info_iE_Extensions__item__id_tab_val_Extension_2,
        _____FDD_Info_iE_Extensions__item__id_tab_val_Extension_3,
        _____FDD_Info_iE_Extensions__item__id_tab_val_Extension_4,
        _____FDD_Info_iE_Extensions__item__id_tab_val_Extension_5,
        ___FDD_Info_iE_Extensions__item__id,
        ___FDD_Info_iE_Extensions__item__criticality,
        ___FDD_Info_iE_Extensions__item__extensionValue,
        __FDD_Info_iE_Extensions__item_,
        _FDD_Info_iE_Extensions,
        FDD_Info,
        FDD_Info_ExtIEs,
        _FDD_Info_ExtIEs_val_Extension_0,
        _FDD_Info_ExtIEs_val_Extension_1,
        _FDD_Info_ExtIEs_val_Extension_2,
        _FDD_Info_ExtIEs_val_Extension_3,
        _FDD_Info_ExtIEs_val_Extension_4,
        _FDD_Info_ExtIEs_val_Extension_5,
        _FDD_InfoNeighbourServedNRCell_Information_ul_NRFreqInfo,
        _FDD_InfoNeighbourServedNRCell_Information_dl_NRFreqInfo,
        ____FDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item__id_tab,
        _____FDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item__id_tab_val_Extension_0,
        ___FDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item__id,
        ___FDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item__criticality,
        ___FDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item__extensionValue,
        __FDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item_,
        _FDD_InfoNeighbourServedNRCell_Information_iE_Extensions,
        FDD_InfoNeighbourServedNRCell_Information,
        FDD_InfoNeighbourServedNRCell_Information_ExtIEs,
        _FDD_InfoNeighbourServedNRCell_Information_ExtIEs_val_Extension_0,
        FiveQI,
        ForbiddenInterRATs,
        _ForbiddenTAs__item_,
        ForbiddenTAs,
        _ForbiddenTAs_Item_pLMN_Identity,
        _ForbiddenTAs_Item_forbiddenTACs,
        ____ForbiddenTAs_Item_iE_Extensions__item__id_tab,
        ___ForbiddenTAs_Item_iE_Extensions__item__id,
        ____ForbiddenTAs_Item_iE_Extensions__item__criticality_tab,
        ___ForbiddenTAs_Item_iE_Extensions__item__criticality,
        ____ForbiddenTAs_Item_iE_Extensions__item__extensionValue_tab,
        ___ForbiddenTAs_Item_iE_Extensions__item__extensionValue,
        __ForbiddenTAs_Item_iE_Extensions__item_,
        _ForbiddenTAs_Item_iE_Extensions,
        ForbiddenTAs_Item,
        ForbiddenTAs_Item_ExtIEs,
        _ForbiddenTACs__item_,
        ForbiddenTACs,
        _ForbiddenLAs__item_,
        ForbiddenLAs,
        _ForbiddenLAs_Item_pLMN_Identity,
        _ForbiddenLAs_Item_forbiddenLACs,
        ____ForbiddenLAs_Item_iE_Extensions__item__id_tab,
        ___ForbiddenLAs_Item_iE_Extensions__item__id,
        ____ForbiddenLAs_Item_iE_Extensions__item__criticality_tab,
        ___ForbiddenLAs_Item_iE_Extensions__item__criticality,
        ____ForbiddenLAs_Item_iE_Extensions__item__extensionValue_tab,
        ___ForbiddenLAs_Item_iE_Extensions__item__extensionValue,
        __ForbiddenLAs_Item_iE_Extensions__item_,
        _ForbiddenLAs_Item_iE_Extensions,
        ForbiddenLAs_Item,
        ForbiddenLAs_Item_ExtIEs,
        _ForbiddenLACs__item_,
        ForbiddenLACs,
        Fourframes,
        FreqBandIndicator,
        FreqBandIndicatorPriority,
        _FreqBandNrItem_freqBandIndicatorNr,
        __FreqBandNrItem_supportedSULBandList__item_,
        _FreqBandNrItem_supportedSULBandList,
        ____FreqBandNrItem_iE_Extensions__item__id_tab,
        ___FreqBandNrItem_iE_Extensions__item__id,
        ____FreqBandNrItem_iE_Extensions__item__criticality_tab,
        ___FreqBandNrItem_iE_Extensions__item__criticality,
        ____FreqBandNrItem_iE_Extensions__item__extensionValue_tab,
        ___FreqBandNrItem_iE_Extensions__item__extensionValue,
        __FreqBandNrItem_iE_Extensions__item_,
        _FreqBandNrItem_iE_Extensions,
        FreqBandNrItem,
        FreqBandNrItem_ExtIEs,
        FrequencyShift7p5khz,
        _GBR_QosInformation_e_RAB_MaximumBitrateDL,
        _GBR_QosInformation_e_RAB_MaximumBitrateUL,
        _GBR_QosInformation_e_RAB_GuaranteedBitrateDL,
        _GBR_QosInformation_e_RAB_GuaranteedBitrateUL,
        ____GBR_QosInformation_iE_Extensions__item__id_tab,
        _____GBR_QosInformation_iE_Extensions__item__id_tab_val_Extension_0,
        _____GBR_QosInformation_iE_Extensions__item__id_tab_val_Extension_1,
        _____GBR_QosInformation_iE_Extensions__item__id_tab_val_Extension_2,
        _____GBR_QosInformation_iE_Extensions__item__id_tab_val_Extension_3,
        ___GBR_QosInformation_iE_Extensions__item__id,
        ___GBR_QosInformation_iE_Extensions__item__criticality,
        ___GBR_QosInformation_iE_Extensions__item__extensionValue,
        __GBR_QosInformation_iE_Extensions__item_,
        _GBR_QosInformation_iE_Extensions,
        GBR_QosInformation,
        GBR_QosInformation_ExtIEs,
        _GBR_QosInformation_ExtIEs_val_Extension_0,
        _GBR_QosInformation_ExtIEs_val_Extension_1,
        _GBR_QosInformation_ExtIEs_val_Extension_2,
        _GBR_QosInformation_ExtIEs_val_Extension_3,
        _GlobalENB_ID_pLMN_Identity,
        _GlobalENB_ID_eNB_ID,
        ____GlobalENB_ID_iE_Extensions__item__id_tab,
        ___GlobalENB_ID_iE_Extensions__item__id,
        ____GlobalENB_ID_iE_Extensions__item__criticality_tab,
        ___GlobalENB_ID_iE_Extensions__item__criticality,
        ____GlobalENB_ID_iE_Extensions__item__extensionValue_tab,
        ___GlobalENB_ID_iE_Extensions__item__extensionValue,
        __GlobalENB_ID_iE_Extensions__item_,
        _GlobalENB_ID_iE_Extensions,
        GlobalENB_ID,
        GlobalENB_ID_ExtIEs,
        _GlobalGNB_ID_pLMN_Identity,
        _GlobalGNB_ID_gNB_ID,
        ____GlobalGNB_ID_iE_Extensions__item__id_tab,
        ___GlobalGNB_ID_iE_Extensions__item__id,
        ____GlobalGNB_ID_iE_Extensions__item__criticality_tab,
        ___GlobalGNB_ID_iE_Extensions__item__criticality,
        ____GlobalGNB_ID_iE_Extensions__item__extensionValue_tab,
        ___GlobalGNB_ID_iE_Extensions__item__extensionValue,
        __GlobalGNB_ID_iE_Extensions__item_,
        _GlobalGNB_ID_iE_Extensions,
        GlobalGNB_ID,
        GlobalGNB_ID_ExtIEs,
        _Global_RAN_NODE_ID_gNB,
        ___Global_RAN_NODE_ID_choice_extension_id_tab,
        __Global_RAN_NODE_ID_choice_extension_id,
        ___Global_RAN_NODE_ID_choice_extension_criticality_tab,
        __Global_RAN_NODE_ID_choice_extension_criticality,
        ___Global_RAN_NODE_ID_choice_extension_value_tab,
        __Global_RAN_NODE_ID_choice_extension_value,
        _Global_RAN_NODE_ID_choice_extension,
        Global_RAN_NODE_ID,
        Global_RAN_NODE_ID_ExtIEs,
        GNBOverloadInformation,
        _GTPTLAs__item_,
        GTPTLAs,
        _GTPTLA_Item_gTPTransportLayerAddresses,
        ____GTPTLA_Item_iE_Extensions__item__id_tab,
        ___GTPTLA_Item_iE_Extensions__item__id,
        ____GTPTLA_Item_iE_Extensions__item__criticality_tab,
        ___GTPTLA_Item_iE_Extensions__item__criticality,
        ____GTPTLA_Item_iE_Extensions__item__extensionValue_tab,
        ___GTPTLA_Item_iE_Extensions__item__extensionValue,
        __GTPTLA_Item_iE_Extensions__item_,
        _GTPTLA_Item_iE_Extensions,
        GTPTLA_Item,
        GTPTLA_Item_ExtIEs,
        _GTPtunnelEndpoint_transportLayerAddress,
        _GTPtunnelEndpoint_gTP_TEID,
        ____GTPtunnelEndpoint_iE_Extensions__item__id_tab,
        _____GTPtunnelEndpoint_iE_Extensions__item__id_tab_val_Extension_0,
        ___GTPtunnelEndpoint_iE_Extensions__item__id,
        ___GTPtunnelEndpoint_iE_Extensions__item__criticality,
        ___GTPtunnelEndpoint_iE_Extensions__item__extensionValue,
        __GTPtunnelEndpoint_iE_Extensions__item_,
        _GTPtunnelEndpoint_iE_Extensions,
        GTPtunnelEndpoint,
        GTPtunnelEndpoint_ExtIEs,
        _GTPtunnelEndpoint_ExtIEs_val_Extension_0,
        GTP_TEI,
        _GUGroupIDList__item_,
        GUGroupIDList,
        _GU_Group_ID_pLMN_Identity,
        _GU_Group_ID_mME_Group_ID,
        ____GU_Group_ID_iE_Extensions__item__id_tab,
        ___GU_Group_ID_iE_Extensions__item__id,
        ____GU_Group_ID_iE_Extensions__item__criticality_tab,
        ___GU_Group_ID_iE_Extensions__item__criticality,
        ____GU_Group_ID_iE_Extensions__item__extensionValue_tab,
        ___GU_Group_ID_iE_Extensions__item__extensionValue,
        __GU_Group_ID_iE_Extensions__item_,
        _GU_Group_ID_iE_Extensions,
        GU_Group_ID,
        GU_Group_ID_ExtIEs,
        _GUMMEI_gU_Group_ID,
        _GUMMEI_mME_Code,
        ____GUMMEI_iE_Extensions__item__id_tab,
        ___GUMMEI_iE_Extensions__item__id,
        ____GUMMEI_iE_Extensions__item__criticality_tab,
        ___GUMMEI_iE_Extensions__item__criticality,
        ____GUMMEI_iE_Extensions__item__extensionValue_tab,
        ___GUMMEI_iE_Extensions__item__extensionValue,
        __GUMMEI_iE_Extensions__item_,
        _GUMMEI_iE_Extensions,
        GUMMEI,
        GUMMEI_ExtIEs,
        _GNB_ID_gNB_ID,
        GNB_ID,
        HandoverReportType,
        _HandoverRestrictionList_servingPLMN,
        _HandoverRestrictionList_equivalentPLMNs,
        _HandoverRestrictionList_forbiddenTAs,
        _HandoverRestrictionList_forbiddenLAs,
        _HandoverRestrictionList_forbiddenInterRATs,
        ____HandoverRestrictionList_iE_Extensions__item__id_tab,
        _____HandoverRestrictionList_iE_Extensions__item__id_tab_val_Extension_0,
        _____HandoverRestrictionList_iE_Extensions__item__id_tab_val_Extension_1,
        _____HandoverRestrictionList_iE_Extensions__item__id_tab_val_Extension_2,
        _____HandoverRestrictionList_iE_Extensions__item__id_tab_val_Extension_3,
        _____HandoverRestrictionList_iE_Extensions__item__id_tab_val_Extension_4,
        _____HandoverRestrictionList_iE_Extensions__item__id_tab_val_Extension_5,
        ___HandoverRestrictionList_iE_Extensions__item__id,
        ___HandoverRestrictionList_iE_Extensions__item__criticality,
        ___HandoverRestrictionList_iE_Extensions__item__extensionValue,
        __HandoverRestrictionList_iE_Extensions__item_,
        _HandoverRestrictionList_iE_Extensions,
        HandoverRestrictionList,
        HandoverRestrictionList_ExtIEs,
        _HandoverRestrictionList_ExtIEs_val_Extension_0,
        _HandoverRestrictionList_ExtIEs_val_Extension_1,
        _HandoverRestrictionList_ExtIEs_val_Extension_2,
        _HandoverRestrictionList_ExtIEs_val_Extension_3,
        _HandoverRestrictionList_ExtIEs_val_Extension_4,
        _HandoverRestrictionList_ExtIEs_val_Extension_5,
        HFN,
        HFNModified,
        HFNforPDCP_SNlength18,
        _HWLoadIndicator_dLHWLoadIndicator,
        _HWLoadIndicator_uLHWLoadIndicator,
        ____HWLoadIndicator_iE_Extensions__item__id_tab,
        ___HWLoadIndicator_iE_Extensions__item__id,
        ____HWLoadIndicator_iE_Extensions__item__criticality_tab,
        ___HWLoadIndicator_iE_Extensions__item__criticality,
        ____HWLoadIndicator_iE_Extensions__item__extensionValue_tab,
        ___HWLoadIndicator_iE_Extensions__item__extensionValue,
        __HWLoadIndicator_iE_Extensions__item_,
        _HWLoadIndicator_iE_Extensions,
        HWLoadIndicator,
        HWLoadIndicator_ExtIEs,
        IABNodeIndication,
        IMSvoiceEPSfallbackfrom5G,
        IntegrityProtectionAlgorithms,
        IntegrityProtectionIndication,
        IntegrityProtectionResult,
        IntendedTDD_DL_ULConfiguration_NR,
        InterfaceInstanceIndication,
        InterfacesToTrace,
        InvokeIndication,
        Key_eNodeB_Star,
        LastVisitedPSCell_Item,
        LAC,
        _LastVisitedCell_Item_e_UTRAN_Cell,
        _LastVisitedCell_Item_uTRAN_Cell,
        _LastVisitedCell_Item_gERAN_Cell,
        _LastVisitedCell_Item_nG_RAN_Cell,
        LastVisitedCell_Item,
        _LastVisitedEUTRANCellInformation_global_Cell_ID,
        _LastVisitedEUTRANCellInformation_cellType,
        _LastVisitedEUTRANCellInformation_time_UE_StayedInCell,
        ____LastVisitedEUTRANCellInformation_iE_Extensions__item__id_tab,
        _____LastVisitedEUTRANCellInformation_iE_Extensions__item__id_tab_val_Extension_0,
        _____LastVisitedEUTRANCellInformation_iE_Extensions__item__id_tab_val_Extension_1,
        _____LastVisitedEUTRANCellInformation_iE_Extensions__item__id_tab_val_Extension_2,
        ___LastVisitedEUTRANCellInformation_iE_Extensions__item__id,
        ___LastVisitedEUTRANCellInformation_iE_Extensions__item__criticality,
        ___LastVisitedEUTRANCellInformation_iE_Extensions__item__extensionValue,
        __LastVisitedEUTRANCellInformation_iE_Extensions__item_,
        _LastVisitedEUTRANCellInformation_iE_Extensions,
        LastVisitedEUTRANCellInformation,
        LastVisitedEUTRANCellInformation_ExtIEs,
        _LastVisitedEUTRANCellInformation_ExtIEs_val_Extension_0,
        _LastVisitedEUTRANCellInformation_ExtIEs_val_Extension_1,
        _LastVisitedEUTRANCellInformation_ExtIEs_val_Extension_2,
        _LastVisitedGERANCellInformation_undefined,
        LastVisitedGERANCellInformation,
        LastVisitedNGRANCellInformation,
        LastVisitedUTRANCellInformation,
        LCID,
        LHN_ID,
        Links_to_log,
        LoadIndicator,
        _LocationInformationSgNB_pSCell_id,
        ____LocationInformationSgNB_iE_Extensions__item__id_tab,
        ___LocationInformationSgNB_iE_Extensions__item__id,
        ____LocationInformationSgNB_iE_Extensions__item__criticality_tab,
        ___LocationInformationSgNB_iE_Extensions__item__criticality,
        ____LocationInformationSgNB_iE_Extensions__item__extensionValue_tab,
        ___LocationInformationSgNB_iE_Extensions__item__extensionValue,
        __LocationInformationSgNB_iE_Extensions__item_,
        _LocationInformationSgNB_iE_Extensions,
        LocationInformationSgNB,
        LocationInformationSgNB_ExtIEs,
        LocationInformationSgNBReporting,
        _LocationReportingInformation_eventType,
        _LocationReportingInformation_reportArea,
        ____LocationReportingInformation_iE_Extensions__item__id_tab,
        _____LocationReportingInformation_iE_Extensions__item__id_tab_val_Extension_0,
        ___LocationReportingInformation_iE_Extensions__item__id,
        ___LocationReportingInformation_iE_Extensions__item__criticality,
        ___LocationReportingInformation_iE_Extensions__item__extensionValue,
        __LocationReportingInformation_iE_Extensions__item_,
        _LocationReportingInformation_iE_Extensions,
        LocationReportingInformation,
        LocationReportingInformation_ExtIEs,
        _LocationReportingInformation_ExtIEs_val_Extension_0,
        LowerLayerPresenceStatusChange,
        _M1PeriodicReporting_reportInterval,
        _M1PeriodicReporting_reportAmount,
        ____M1PeriodicReporting_iE_Extensions__item__id_tab,
        ___M1PeriodicReporting_iE_Extensions__item__id,
        ____M1PeriodicReporting_iE_Extensions__item__criticality_tab,
        ___M1PeriodicReporting_iE_Extensions__item__criticality,
        ____M1PeriodicReporting_iE_Extensions__item__extensionValue_tab,
        ___M1PeriodicReporting_iE_Extensions__item__extensionValue,
        __M1PeriodicReporting_iE_Extensions__item_,
        _M1PeriodicReporting_iE_Extensions,
        M1PeriodicReporting,
        M1PeriodicReporting_ExtIEs,
        M1ReportingTrigger,
        _M1ThresholdEventA2_measurementThreshold,
        ____M1ThresholdEventA2_iE_Extensions__item__id_tab,
        ___M1ThresholdEventA2_iE_Extensions__item__id,
        ____M1ThresholdEventA2_iE_Extensions__item__criticality_tab,
        ___M1ThresholdEventA2_iE_Extensions__item__criticality,
        ____M1ThresholdEventA2_iE_Extensions__item__extensionValue_tab,
        ___M1ThresholdEventA2_iE_Extensions__item__extensionValue,
        __M1ThresholdEventA2_iE_Extensions__item_,
        _M1ThresholdEventA2_iE_Extensions,
        M1ThresholdEventA2,
        M1ThresholdEventA2_ExtIEs,
        _M3Configuration_m3period,
        ____M3Configuration_iE_Extensions__item__id_tab,
        ___M3Configuration_iE_Extensions__item__id,
        ____M3Configuration_iE_Extensions__item__criticality_tab,
        ___M3Configuration_iE_Extensions__item__criticality,
        ____M3Configuration_iE_Extensions__item__extensionValue_tab,
        ___M3Configuration_iE_Extensions__item__extensionValue,
        __M3Configuration_iE_Extensions__item_,
        _M3Configuration_iE_Extensions,
        M3Configuration,
        M3Configuration_ExtIEs,
        M3period,
        _M4Configuration_m4period,
        _M4Configuration_m4_links_to_log,
        ____M4Configuration_iE_Extensions__item__id_tab,
        ___M4Configuration_iE_Extensions__item__id,
        ____M4Configuration_iE_Extensions__item__criticality_tab,
        ___M4Configuration_iE_Extensions__item__criticality,
        ____M4Configuration_iE_Extensions__item__extensionValue_tab,
        ___M4Configuration_iE_Extensions__item__extensionValue,
        __M4Configuration_iE_Extensions__item_,
        _M4Configuration_iE_Extensions,
        M4Configuration,
        M4Configuration_ExtIEs,
        M4period,
        _M5Configuration_m5period,
        _M5Configuration_m5_links_to_log,
        ____M5Configuration_iE_Extensions__item__id_tab,
        ___M5Configuration_iE_Extensions__item__id,
        ____M5Configuration_iE_Extensions__item__criticality_tab,
        ___M5Configuration_iE_Extensions__item__criticality,
        ____M5Configuration_iE_Extensions__item__extensionValue_tab,
        ___M5Configuration_iE_Extensions__item__extensionValue,
        __M5Configuration_iE_Extensions__item_,
        _M5Configuration_iE_Extensions,
        M5Configuration,
        M5Configuration_ExtIEs,
        M5period,
        _M6Configuration_m6report_interval,
        _M6Configuration_m6delay_threshold,
        _M6Configuration_m6_links_to_log,
        ____M6Configuration_iE_Extensions__item__id_tab,
        ___M6Configuration_iE_Extensions__item__id,
        ____M6Configuration_iE_Extensions__item__criticality_tab,
        ___M6Configuration_iE_Extensions__item__criticality,
        ____M6Configuration_iE_Extensions__item__extensionValue_tab,
        ___M6Configuration_iE_Extensions__item__extensionValue,
        __M6Configuration_iE_Extensions__item_,
        _M6Configuration_iE_Extensions,
        M6Configuration,
        M6Configuration_ExtIEs,
        M6report_interval,
        M6delay_threshold,
        _M7Configuration_m7period,
        _M7Configuration_m7_links_to_log,
        ____M7Configuration_iE_Extensions__item__id_tab,
        ___M7Configuration_iE_Extensions__item__id,
        ____M7Configuration_iE_Extensions__item__criticality_tab,
        ___M7Configuration_iE_Extensions__item__criticality,
        ____M7Configuration_iE_Extensions__item__extensionValue_tab,
        ___M7Configuration_iE_Extensions__item__extensionValue,
        __M7Configuration_iE_Extensions__item_,
        _M7Configuration_iE_Extensions,
        M7Configuration,
        M7Configuration_ExtIEs,
        M7period,
        MakeBeforeBreakIndicator,
        ManagementBasedMDTallowed,
        Masked_IMEISV,
        MaxCHOpreparations,
        MDT_Activation,
        _MDT_Configuration_mdt_Activation,
        _MDT_Configuration_areaScopeOfMDT,
        _MDT_Configuration_measurementsToActivate,
        _MDT_Configuration_m1reportingTrigger,
        _MDT_Configuration_m1thresholdeventA2,
        _MDT_Configuration_m1periodicReporting,
        ____MDT_Configuration_iE_Extensions__item__id_tab,
        _____MDT_Configuration_iE_Extensions__item__id_tab_val_Extension_0,
        _____MDT_Configuration_iE_Extensions__item__id_tab_val_Extension_1,
        _____MDT_Configuration_iE_Extensions__item__id_tab_val_Extension_2,
        _____MDT_Configuration_iE_Extensions__item__id_tab_val_Extension_3,
        _____MDT_Configuration_iE_Extensions__item__id_tab_val_Extension_4,
        _____MDT_Configuration_iE_Extensions__item__id_tab_val_Extension_5,
        _____MDT_Configuration_iE_Extensions__item__id_tab_val_Extension_6,
        _____MDT_Configuration_iE_Extensions__item__id_tab_val_Extension_7,
        _____MDT_Configuration_iE_Extensions__item__id_tab_val_Extension_8,
        _____MDT_Configuration_iE_Extensions__item__id_tab_val_Extension_9,
        ___MDT_Configuration_iE_Extensions__item__id,
        ___MDT_Configuration_iE_Extensions__item__criticality,
        ___MDT_Configuration_iE_Extensions__item__extensionValue,
        __MDT_Configuration_iE_Extensions__item_,
        _MDT_Configuration_iE_Extensions,
        MDT_Configuration,
        MDT_Configuration_ExtIEs,
        _MDT_Configuration_ExtIEs_val_Extension_0,
        _MDT_Configuration_ExtIEs_val_Extension_1,
        _MDT_Configuration_ExtIEs_val_Extension_2,
        _MDT_Configuration_ExtIEs_val_Extension_3,
        _MDT_Configuration_ExtIEs_val_Extension_4,
        _MDT_Configuration_ExtIEs_val_Extension_5,
        _MDT_Configuration_ExtIEs_val_Extension_6,
        _MDT_Configuration_ExtIEs_val_Extension_7,
        _MDT_Configuration_ExtIEs_val_Extension_8,
        _MDT_Configuration_ExtIEs_val_Extension_9,
        _MDTPLMNList__item_,
        MDTPLMNList,
        MDT_Location_Info,
        Measurement_ID,
        Measurement_ID_ENDC,
        MeasurementsToActivate,
        _MeasurementThresholdA2_threshold_RSRP,
        _MeasurementThresholdA2_threshold_RSRQ,
        MeasurementThresholdA2,
        MeNBCoordinationAssistanceInformation,
        _MeNBResourceCoordinationInformation_eUTRA_Cell_ID,
        _MeNBResourceCoordinationInformation_uLCoordinationInformation,
        _MeNBResourceCoordinationInformation_dLCoordinationInformation,
        ____MeNBResourceCoordinationInformation_iE_Extensions__item__id_tab,
        _____MeNBResourceCoordinationInformation_iE_Extensions__item__id_tab_val_Extension_0,
        _____MeNBResourceCoordinationInformation_iE_Extensions__item__id_tab_val_Extension_1,
        ___MeNBResourceCoordinationInformation_iE_Extensions__item__id,
        ___MeNBResourceCoordinationInformation_iE_Extensions__item__criticality,
        ___MeNBResourceCoordinationInformation_iE_Extensions__item__extensionValue,
        __MeNBResourceCoordinationInformation_iE_Extensions__item_,
        _MeNBResourceCoordinationInformation_iE_Extensions,
        MeNBResourceCoordinationInformation,
        MeNBResourceCoordinationInformationExtIEs,
        _MeNBResourceCoordinationInformationExtIEs_val_Extension_0,
        _MeNBResourceCoordinationInformationExtIEs_val_Extension_1,
        MeNBtoSeNBContainer,
        MME_Group_ID,
        MME_Code,
        _MBMS_Service_Area_Identity_List__item_,
        MBMS_Service_Area_Identity_List,
        MBMS_Service_Area_Identity,
        _MBSFN_Subframe_Infolist__item_,
        MBSFN_Subframe_Infolist,
        _MBSFN_Subframe_Info_radioframeAllocationPeriod,
        _MBSFN_Subframe_Info_radioframeAllocationOffset,
        _MBSFN_Subframe_Info_subframeAllocation,
        ____MBSFN_Subframe_Info_iE_Extensions__item__id_tab,
        ___MBSFN_Subframe_Info_iE_Extensions__item__id,
        ____MBSFN_Subframe_Info_iE_Extensions__item__criticality_tab,
        ___MBSFN_Subframe_Info_iE_Extensions__item__criticality,
        ____MBSFN_Subframe_Info_iE_Extensions__item__extensionValue_tab,
        ___MBSFN_Subframe_Info_iE_Extensions__item__extensionValue,
        __MBSFN_Subframe_Info_iE_Extensions__item_,
        _MBSFN_Subframe_Info_iE_Extensions,
        MBSFN_Subframe_Info,
        MBSFN_Subframe_Info_ExtIEs,
        MDT_ConfigurationNR,
        _MobilityParametersModificationRange_handoverTriggerChangeLowerLimit,
        _MobilityParametersModificationRange_handoverTriggerChangeUpperLimit,
        MobilityParametersModificationRange,
        _MobilityParametersInformation_handoverTriggerChange,
        MobilityParametersInformation,
        _MultibandInfoList__item_,
        MultibandInfoList,
        _MessageOversizeNotification_maximumCellListSize,
        ____MessageOversizeNotification_iE_Extensions__item__id_tab,
        ___MessageOversizeNotification_iE_Extensions__item__id,
        ____MessageOversizeNotification_iE_Extensions__item__criticality_tab,
        ___MessageOversizeNotification_iE_Extensions__item__criticality,
        ____MessageOversizeNotification_iE_Extensions__item__extensionValue_tab,
        ___MessageOversizeNotification_iE_Extensions__item__extensionValue,
        __MessageOversizeNotification_iE_Extensions__item_,
        _MessageOversizeNotification_iE_Extensions,
        MessageOversizeNotification,
        MessageOversizeNotification_ExtIEs,
        MaximumCellListSize,
        _BandInfo_freqBandIndicator,
        ____BandInfo_iE_Extensions__item__id_tab,
        ___BandInfo_iE_Extensions__item__id,
        ____BandInfo_iE_Extensions__item__criticality_tab,
        ___BandInfo_iE_Extensions__item__criticality,
        ____BandInfo_iE_Extensions__item__extensionValue_tab,
        ___BandInfo_iE_Extensions__item__extensionValue,
        __BandInfo_iE_Extensions__item_,
        _BandInfo_iE_Extensions,
        BandInfo,
        BandInfo_ExtIEs,
        MeNBtoSgNBContainer,
        SplitSRBs,
        _SplitSRB_rrcContainer,
        _SplitSRB_srbType,
        _SplitSRB_deliveryStatus,
        ____SplitSRB_iE_Extensions__item__id_tab,
        ___SplitSRB_iE_Extensions__item__id,
        ____SplitSRB_iE_Extensions__item__criticality_tab,
        ___SplitSRB_iE_Extensions__item__criticality,
        ____SplitSRB_iE_Extensions__item__extensionValue_tab,
        ___SplitSRB_iE_Extensions__item__extensionValue,
        __SplitSRB_iE_Extensions__item_,
        _SplitSRB_iE_Extensions,
        SplitSRB,
        SplitSRB_ExtIEs,
        NBIoT_UL_DL_AlignmentOffset,
        NBIoT_RLF_Report_Container,
        __Neighbour_Information__item__eCGI,
        __Neighbour_Information__item__pCI,
        __Neighbour_Information__item__eARFCN,
        _____Neighbour_Information__item__iE_Extensions__item__id_tab,
        ______Neighbour_Information__item__iE_Extensions__item__id_tab_val_Extension_0,
        ______Neighbour_Information__item__iE_Extensions__item__id_tab_val_Extension_1,
        ____Neighbour_Information__item__iE_Extensions__item__id,
        ____Neighbour_Information__item__iE_Extensions__item__criticality,
        ____Neighbour_Information__item__iE_Extensions__item__extensionValue,
        ___Neighbour_Information__item__iE_Extensions__item_,
        __Neighbour_Information__item__iE_Extensions,
        _Neighbour_Information__item_,
        Neighbour_Information,
        Neighbour_Information_ExtIEs,
        _Neighbour_Information_ExtIEs_val_Extension_0,
        _Neighbour_Information_ExtIEs_val_Extension_1,
        NextHopChainingCount,
        NewDRBIDrequest,
        Number_of_Antennaports,
        _NRCapacityValue_capacityValue,
        _NRCapacityValue_ssbAreaCapacityValue_List,
        ____NRCapacityValue_iE_Extensions__item__id_tab,
        ___NRCapacityValue_iE_Extensions__item__id,
        ____NRCapacityValue_iE_Extensions__item__criticality_tab,
        ___NRCapacityValue_iE_Extensions__item__criticality,
        ____NRCapacityValue_iE_Extensions__item__extensionValue_tab,
        ___NRCapacityValue_iE_Extensions__item__extensionValue,
        __NRCapacityValue_iE_Extensions__item_,
        _NRCapacityValue_iE_Extensions,
        NRCapacityValue,
        NRCapacityValue_ExtIEs,
        _NRCarrierList__item_,
        NRCarrierList,
        _NRCarrierItem_carrierSCS,
        _NRCarrierItem_offsetToCarrier,
        _NRCarrierItem_carrierBandwidth,
        ____NRCarrierItem_iE_Extension__item__id_tab,
        ___NRCarrierItem_iE_Extension__item__id,
        ____NRCarrierItem_iE_Extension__item__criticality_tab,
        ___NRCarrierItem_iE_Extension__item__criticality,
        ____NRCarrierItem_iE_Extension__item__extensionValue_tab,
        ___NRCarrierItem_iE_Extension__item__extensionValue,
        __NRCarrierItem_iE_Extension__item_,
        _NRCarrierItem_iE_Extension,
        NRCarrierItem,
        NRCarrierItem_ExtIEs,
        NRCellCapacityClassValue,
        NRCellPRACHConfig,
        _NRCompositeAvailableCapacityGroup_compositeAvailableCapacityDL,
        _NRCompositeAvailableCapacityGroup_compositeAvailableCapacityUL,
        ____NRCompositeAvailableCapacityGroup_iE_Extensions__item__id_tab,
        ___NRCompositeAvailableCapacityGroup_iE_Extensions__item__id,
        ____NRCompositeAvailableCapacityGroup_iE_Extensions__item__criticality_tab,
        ___NRCompositeAvailableCapacityGroup_iE_Extensions__item__criticality,
        ____NRCompositeAvailableCapacityGroup_iE_Extensions__item__extensionValue_tab,
        ___NRCompositeAvailableCapacityGroup_iE_Extensions__item__extensionValue,
        __NRCompositeAvailableCapacityGroup_iE_Extensions__item_,
        _NRCompositeAvailableCapacityGroup_iE_Extensions,
        NRCompositeAvailableCapacityGroup,
        NRCompositeAvailableCapacityGroup_ExtIEs,
        _NRCompositeAvailableCapacity_cellCapacityClassValue,
        _NRCompositeAvailableCapacity_capacityValue,
        ____NRCompositeAvailableCapacity_iE_Extensions__item__id_tab,
        ___NRCompositeAvailableCapacity_iE_Extensions__item__id,
        ____NRCompositeAvailableCapacity_iE_Extensions__item__criticality_tab,
        ___NRCompositeAvailableCapacity_iE_Extensions__item__criticality,
        ____NRCompositeAvailableCapacity_iE_Extensions__item__extensionValue_tab,
        ___NRCompositeAvailableCapacity_iE_Extensions__item__extensionValue,
        __NRCompositeAvailableCapacity_iE_Extensions__item_,
        _NRCompositeAvailableCapacity_iE_Extensions,
        NRCompositeAvailableCapacity,
        NRCompositeAvailableCapacity_ExtIEs,
        _NRFreqInfo_nRARFCN,
        __NRFreqInfo_freqBandListNr__item_,
        _NRFreqInfo_freqBandListNr,
        _NRFreqInfo_sULInformation,
        ____NRFreqInfo_iE_Extensions__item__id_tab,
        _____NRFreqInfo_iE_Extensions__item__id_tab_val_Extension_0,
        ___NRFreqInfo_iE_Extensions__item__id,
        ___NRFreqInfo_iE_Extensions__item__criticality,
        ___NRFreqInfo_iE_Extensions__item__extensionValue,
        __NRFreqInfo_iE_Extensions__item_,
        _NRFreqInfo_iE_Extensions,
        NRFreqInfo,
        NRFreqInfo_ExtIEs,
        _NRFreqInfo_ExtIEs_val_Extension_0,
        NRCellIdentifier,
        _NRCGI_pLMN_Identity,
        _NRCGI_nRcellIdentifier,
        ____NRCGI_iE_Extensions__item__id_tab,
        ___NRCGI_iE_Extensions__item__id,
        ____NRCGI_iE_Extensions__item__criticality_tab,
        ___NRCGI_iE_Extensions__item__criticality,
        ____NRCGI_iE_Extensions__item__extensionValue_tab,
        ___NRCGI_iE_Extensions__item__extensionValue,
        __NRCGI_iE_Extensions__item_,
        _NRCGI_iE_Extensions,
        NRCGI,
        NRCGI_ExtIEs,
        NRRACHReportContainer,
        _NRRACHReportInformation__item_,
        NRRACHReportInformation,
        _NRRACHReportList_Item_nRRACHReport,
        _NRRACHReportList_Item_uEAssitantIdentifier,
        ____NRRACHReportList_Item_iE_Extensions__item__id_tab,
        ___NRRACHReportList_Item_iE_Extensions__item__id,
        ____NRRACHReportList_Item_iE_Extensions__item__criticality_tab,
        ___NRRACHReportList_Item_iE_Extensions__item__criticality,
        ____NRRACHReportList_Item_iE_Extensions__item__extensionValue_tab,
        ___NRRACHReportList_Item_iE_Extensions__item__extensionValue,
        __NRRACHReportList_Item_iE_Extensions__item_,
        _NRRACHReportList_Item_iE_Extensions,
        NRRACHReportList_Item,
        NRRACHReportList_Item_ExtIEs,
        __NRNeighbour_Information__item__nrpCI,
        __NRNeighbour_Information__item__nrCellID,
        __NRNeighbour_Information__item__fiveGS_TAC,
        __NRNeighbour_Information__item__configured_TAC,
        __NRNeighbour_Information__item__measurementTimingConfiguration,
        ___NRNeighbour_Information__item__nRNeighbourModeInfo_fdd,
        ___NRNeighbour_Information__item__nRNeighbourModeInfo_tdd,
        __NRNeighbour_Information__item__nRNeighbourModeInfo,
        _____NRNeighbour_Information__item__iE_Extensions__item__id_tab,
        ______NRNeighbour_Information__item__iE_Extensions__item__id_tab_val_Extension_0,
        ______NRNeighbour_Information__item__iE_Extensions__item__id_tab_val_Extension_1,
        ______NRNeighbour_Information__item__iE_Extensions__item__id_tab_val_Extension_2,
        ______NRNeighbour_Information__item__iE_Extensions__item__id_tab_val_Extension_3,
        ____NRNeighbour_Information__item__iE_Extensions__item__id,
        ____NRNeighbour_Information__item__iE_Extensions__item__criticality,
        ____NRNeighbour_Information__item__iE_Extensions__item__extensionValue,
        ___NRNeighbour_Information__item__iE_Extensions__item_,
        __NRNeighbour_Information__item__iE_Extensions,
        _NRNeighbour_Information__item_,
        NRNeighbour_Information,
        NRNeighbour_Information_ExtIEs,
        _NRNeighbour_Information_ExtIEs_val_Extension_0,
        _NRNeighbour_Information_ExtIEs_val_Extension_1,
        _NRNeighbour_Information_ExtIEs_val_Extension_2,
        _NRNeighbour_Information_ExtIEs_val_Extension_3,
        __NPRACHConfiguration_fdd_or_tdd_fdd,
        __NPRACHConfiguration_fdd_or_tdd_tdd,
        _NPRACHConfiguration_fdd_or_tdd,
        ____NPRACHConfiguration_iE_Extensions__item__id_tab,
        ___NPRACHConfiguration_iE_Extensions__item__id,
        ____NPRACHConfiguration_iE_Extensions__item__criticality_tab,
        ___NPRACHConfiguration_iE_Extensions__item__criticality,
        ____NPRACHConfiguration_iE_Extensions__item__extensionValue_tab,
        ___NPRACHConfiguration_iE_Extensions__item__extensionValue,
        __NPRACHConfiguration_iE_Extensions__item_,
        _NPRACHConfiguration_iE_Extensions,
        NPRACHConfiguration,
        NPRACHConfiguration_ExtIEs,
        _NPRACHConfiguration_FDD_nprach_CP_length,
        _NPRACHConfiguration_FDD_anchorCarrier_NPRACHConfig,
        _NPRACHConfiguration_FDD_anchorCarrier_EDT_NPRACHConfig,
        _NPRACHConfiguration_FDD_anchorCarrier_Format2_NPRACHConfig,
        _NPRACHConfiguration_FDD_anchorCarrier_Format2_EDT_NPRACHConfig,
        _NPRACHConfiguration_FDD_non_anchorCarrier_NPRACHConfig,
        _NPRACHConfiguration_FDD_non_anchorCarrier_Format2_NPRACHConfig,
        ____NPRACHConfiguration_FDD_iE_Extensions__item__id_tab,
        ___NPRACHConfiguration_FDD_iE_Extensions__item__id,
        ____NPRACHConfiguration_FDD_iE_Extensions__item__criticality_tab,
        ___NPRACHConfiguration_FDD_iE_Extensions__item__criticality,
        ____NPRACHConfiguration_FDD_iE_Extensions__item__extensionValue_tab,
        ___NPRACHConfiguration_FDD_iE_Extensions__item__extensionValue,
        __NPRACHConfiguration_FDD_iE_Extensions__item_,
        _NPRACHConfiguration_FDD_iE_Extensions,
        NPRACHConfiguration_FDD,
        NPRACHConfiguration_FDD_ExtIEs,
        _NPRACHConfiguration_TDD_nprach_preambleFormat,
        _NPRACHConfiguration_TDD_anchorCarrier_NPRACHConfigTDD,
        _NPRACHConfiguration_TDD_non_anchorCarrierFequencyConfiglist,
        _NPRACHConfiguration_TDD_non_anchorCarrier_NPRACHConfigTDD,
        ____NPRACHConfiguration_TDD_iE_Extensions__item__id_tab,
        ___NPRACHConfiguration_TDD_iE_Extensions__item__id,
        ____NPRACHConfiguration_TDD_iE_Extensions__item__criticality_tab,
        ___NPRACHConfiguration_TDD_iE_Extensions__item__criticality,
        ____NPRACHConfiguration_TDD_iE_Extensions__item__extensionValue_tab,
        ___NPRACHConfiguration_TDD_iE_Extensions__item__extensionValue,
        __NPRACHConfiguration_TDD_iE_Extensions__item_,
        _NPRACHConfiguration_TDD_iE_Extensions,
        NPRACHConfiguration_TDD,
        NPRACHConfiguration_TDD_ExtIEs,
        NPRACH_CP_Length,
        NPRACH_preambleFormat,
        __Non_AnchorCarrierFrequencylist__item__non_anchorCarrioerFrquency,
        _____Non_AnchorCarrierFrequencylist__item__iE_Extensions__item__id_tab,
        ____Non_AnchorCarrierFrequencylist__item__iE_Extensions__item__id,
        _____Non_AnchorCarrierFrequencylist__item__iE_Extensions__item__criticality_tab,
        ____Non_AnchorCarrierFrequencylist__item__iE_Extensions__item__criticality,
        _____Non_AnchorCarrierFrequencylist__item__iE_Extensions__item__extensionValue_tab,
        ____Non_AnchorCarrierFrequencylist__item__iE_Extensions__item__extensionValue,
        ___Non_AnchorCarrierFrequencylist__item__iE_Extensions__item_,
        __Non_AnchorCarrierFrequencylist__item__iE_Extensions,
        _Non_AnchorCarrierFrequencylist__item_,
        Non_AnchorCarrierFrequencylist,
        Non_AnchorCarrierFrequencylist_ExtIEs,
        NRPCI,
        NRrestrictioninEPSasSecondaryRAT,
        _MeasurementResultforNRCellsPossiblyAggregated__item_,
        MeasurementResultforNRCellsPossiblyAggregated,
        _MeasurementResultforNRCellsPossiblyAggregated_Item_cellID,
        _MeasurementResultforNRCellsPossiblyAggregated_Item_nrCompositeAvailableCapacityGroup,
        ____MeasurementResultforNRCellsPossiblyAggregated_Item_iE_Extension__item__id_tab,
        ___MeasurementResultforNRCellsPossiblyAggregated_Item_iE_Extension__item__id,
        ____MeasurementResultforNRCellsPossiblyAggregated_Item_iE_Extension__item__criticality_tab,
        ___MeasurementResultforNRCellsPossiblyAggregated_Item_iE_Extension__item__criticality,
        ____MeasurementResultforNRCellsPossiblyAggregated_Item_iE_Extension__item__extensionValue_tab,
        ___MeasurementResultforNRCellsPossiblyAggregated_Item_iE_Extension__item__extensionValue,
        __MeasurementResultforNRCellsPossiblyAggregated_Item_iE_Extension__item_,
        _MeasurementResultforNRCellsPossiblyAggregated_Item_iE_Extension,
        MeasurementResultforNRCellsPossiblyAggregated_Item,
        MeasurementResultforNRCellsPossiblyAggregated_Item_ExtIEs,
        _NRRadioResourceStatus_ssbAreaRadioResourceStatus_List,
        ____NRRadioResourceStatus_iE_Extensions__item__id_tab,
        _____NRRadioResourceStatus_iE_Extensions__item__id_tab_val_Extension_0,
        ___NRRadioResourceStatus_iE_Extensions__item__id,
        ___NRRadioResourceStatus_iE_Extensions__item__criticality,
        ___NRRadioResourceStatus_iE_Extensions__item__extensionValue,
        __NRRadioResourceStatus_iE_Extensions__item_,
        _NRRadioResourceStatus_iE_Extensions,
        NRRadioResourceStatus,
        NRRadioResourceStatus_ExtIEs,
        _NRRadioResourceStatus_ExtIEs_val_Extension_0,
        _MIMOPRBusageInformation_dl_GBR_PRB_usage_for_MIMO,
        _MIMOPRBusageInformation_ul_GBR_PRB_usage_for_MIMO,
        _MIMOPRBusageInformation_dl_non_GBR_PRB_usage_for_MIMO,
        _MIMOPRBusageInformation_ul_non_GBR_PRB_usage_for_MIMO,
        _MIMOPRBusageInformation_dl_Total_PRB_usage_for_MIMO,
        _MIMOPRBusageInformation_ul_Total_PRB_usage_for_MIMO,
        ____MIMOPRBusageInformation_iE_Extensions__item__id_tab,
        ___MIMOPRBusageInformation_iE_Extensions__item__id,
        ____MIMOPRBusageInformation_iE_Extensions__item__criticality_tab,
        ___MIMOPRBusageInformation_iE_Extensions__item__criticality,
        ____MIMOPRBusageInformation_iE_Extensions__item__extensionValue_tab,
        ___MIMOPRBusageInformation_iE_Extensions__item__extensionValue,
        __MIMOPRBusageInformation_iE_Extensions__item_,
        _MIMOPRBusageInformation_iE_Extensions,
        MIMOPRBusageInformation,
        MIMOPRBusageInformation_ExtIEs,
        NRrestrictionin5GS,
        NRencryptionAlgorithms,
        NRintegrityProtectionAlgorithms,
        _NR_TxBW_nRSCS,
        _NR_TxBW_nRNRB,
        ____NR_TxBW_iE_Extensions__item__id_tab,
        ___NR_TxBW_iE_Extensions__item__id,
        ____NR_TxBW_iE_Extensions__item__criticality_tab,
        ___NR_TxBW_iE_Extensions__item__criticality,
        ____NR_TxBW_iE_Extensions__item__extensionValue_tab,
        ___NR_TxBW_iE_Extensions__item__extensionValue,
        __NR_TxBW_iE_Extensions__item_,
        _NR_TxBW_iE_Extensions,
        NR_TxBW,
        NR_TxBW_ExtIEs,
        NRNRB,
        NRSCS,
        NRS_NSSS_PowerOffset,
        FiveGS_TAC,
        _NRUeReport_uENRMeasurements,
        ____NRUeReport_iE_Extensions__item__id_tab,
        ___NRUeReport_iE_Extensions__item__id,
        ____NRUeReport_iE_Extensions__item__criticality_tab,
        ___NRUeReport_iE_Extensions__item__criticality,
        ____NRUeReport_iE_Extensions__item__extensionValue_tab,
        ___NRUeReport_iE_Extensions__item__extensionValue,
        __NRUeReport_iE_Extensions__item_,
        _NRUeReport_iE_Extensions,
        NRUeReport,
        NRUeReport_ExtIEs,
        _NRUESidelinkAggregateMaximumBitRate_uESidelinkAggregateMaximumBitRate,
        ____NRUESidelinkAggregateMaximumBitRate_iE_Extensions__item__id_tab,
        ___NRUESidelinkAggregateMaximumBitRate_iE_Extensions__item__id,
        ____NRUESidelinkAggregateMaximumBitRate_iE_Extensions__item__criticality_tab,
        ___NRUESidelinkAggregateMaximumBitRate_iE_Extensions__item__criticality,
        ____NRUESidelinkAggregateMaximumBitRate_iE_Extensions__item__extensionValue_tab,
        ___NRUESidelinkAggregateMaximumBitRate_iE_Extensions__item__extensionValue,
        __NRUESidelinkAggregateMaximumBitRate_iE_Extensions__item_,
        _NRUESidelinkAggregateMaximumBitRate_iE_Extensions,
        NRUESidelinkAggregateMaximumBitRate,
        NRUESidelinkAggregateMaximumBitRate_ExtIEs,
        _NRUESecurityCapabilities_nRencryptionAlgorithms,
        _NRUESecurityCapabilities_nRintegrityProtectionAlgorithms,
        ____NRUESecurityCapabilities_iE_Extensions__item__id_tab,
        ___NRUESecurityCapabilities_iE_Extensions__item__id,
        ____NRUESecurityCapabilities_iE_Extensions__item__criticality_tab,
        ___NRUESecurityCapabilities_iE_Extensions__item__criticality,
        ____NRUESecurityCapabilities_iE_Extensions__item__extensionValue_tab,
        ___NRUESecurityCapabilities_iE_Extensions__item__extensionValue,
        __NRUESecurityCapabilities_iE_Extensions__item_,
        _NRUESecurityCapabilities_iE_Extensions,
        NRUESecurityCapabilities,
        NRUESecurityCapabilities_ExtIEs,
        NSSS_NumOccasionDifferentPrecoder,
        _NRV2XServicesAuthorized_vehicleUE,
        _NRV2XServicesAuthorized_pedestrianUE,
        ____NRV2XServicesAuthorized_iE_Extensions__item__id_tab,
        ___NRV2XServicesAuthorized_iE_Extensions__item__id,
        ____NRV2XServicesAuthorized_iE_Extensions__item__criticality_tab,
        ___NRV2XServicesAuthorized_iE_Extensions__item__criticality,
        ____NRV2XServicesAuthorized_iE_Extensions__item__extensionValue_tab,
        ___NRV2XServicesAuthorized_iE_Extensions__item__extensionValue,
        __NRV2XServicesAuthorized_iE_Extensions__item_,
        _NRV2XServicesAuthorized_iE_Extensions,
        NRV2XServicesAuthorized,
        NRV2XServicesAuthorized_ExtIEs,
        OffsetOfNbiotChannelNumberToEARFCN,
        Oneframe,
        Packet_LossRate,
        PA_Values,
        _PC5QoSParameters_pc5QoSFlowList,
        _PC5QoSParameters_pc5LinkAggregatedBitRates,
        ____PC5QoSParameters_iE_Extensions__item__id_tab,
        ___PC5QoSParameters_iE_Extensions__item__id,
        ____PC5QoSParameters_iE_Extensions__item__criticality_tab,
        ___PC5QoSParameters_iE_Extensions__item__criticality,
        ____PC5QoSParameters_iE_Extensions__item__extensionValue_tab,
        ___PC5QoSParameters_iE_Extensions__item__extensionValue,
        __PC5QoSParameters_iE_Extensions__item_,
        _PC5QoSParameters_iE_Extensions,
        PC5QoSParameters,
        PC5QoSParameters_ExtIEs,
        _PC5QoSFlowList__item_,
        PC5QoSFlowList,
        _PC5QoSFlowItem_pQI,
        _PC5QoSFlowItem_pc5FlowBitRates,
        _PC5QoSFlowItem_range,
        ____PC5QoSFlowItem_iE_Extensions__item__id_tab,
        ___PC5QoSFlowItem_iE_Extensions__item__id,
        ____PC5QoSFlowItem_iE_Extensions__item__criticality_tab,
        ___PC5QoSFlowItem_iE_Extensions__item__criticality,
        ____PC5QoSFlowItem_iE_Extensions__item__extensionValue_tab,
        ___PC5QoSFlowItem_iE_Extensions__item__extensionValue,
        __PC5QoSFlowItem_iE_Extensions__item_,
        _PC5QoSFlowItem_iE_Extensions,
        PC5QoSFlowItem,
        PC5QoSFlowItem_ExtIEs,
        _PC5FlowBitRates_guaranteedFlowBitRate,
        _PC5FlowBitRates_maximumFlowBitRate,
        ____PC5FlowBitRates_iE_Extensions__item__id_tab,
        ___PC5FlowBitRates_iE_Extensions__item__id,
        ____PC5FlowBitRates_iE_Extensions__item__criticality_tab,
        ___PC5FlowBitRates_iE_Extensions__item__criticality,
        ____PC5FlowBitRates_iE_Extensions__item__extensionValue_tab,
        ___PC5FlowBitRates_iE_Extensions__item__extensionValue,
        __PC5FlowBitRates_iE_Extensions__item_,
        _PC5FlowBitRates_iE_Extensions,
        PC5FlowBitRates,
        PC5FlowBitRates_ExtIEs,
        PDCPChangeIndication,
        PDCP_SN,
        PDCP_SNExtended,
        PDCP_SNlength18,
        PDCPSnLength,
        PCI,
        PLMN_Identity,
        Port_Number,
        _PRACH_Configuration_rootSequenceIndex,
        _PRACH_Configuration_zeroCorrelationIndex,
        _PRACH_Configuration_highSpeedFlag,
        _PRACH_Configuration_prach_FreqOffset,
        _PRACH_Configuration_prach_ConfigIndex,
        ____PRACH_Configuration_iE_Extensions__item__id_tab,
        ___PRACH_Configuration_iE_Extensions__item__id,
        ____PRACH_Configuration_iE_Extensions__item__criticality_tab,
        ___PRACH_Configuration_iE_Extensions__item__criticality,
        ____PRACH_Configuration_iE_Extensions__item__extensionValue_tab,
        ___PRACH_Configuration_iE_Extensions__item__extensionValue,
        __PRACH_Configuration_iE_Extensions__item_,
        _PRACH_Configuration_iE_Extensions,
        PRACH_Configuration,
        _PLMNAreaBasedQMC_plmnListforQMC,
        ____PLMNAreaBasedQMC_iE_Extensions__item__id_tab,
        ___PLMNAreaBasedQMC_iE_Extensions__item__id,
        ____PLMNAreaBasedQMC_iE_Extensions__item__criticality_tab,
        ___PLMNAreaBasedQMC_iE_Extensions__item__criticality,
        ____PLMNAreaBasedQMC_iE_Extensions__item__extensionValue_tab,
        ___PLMNAreaBasedQMC_iE_Extensions__item__extensionValue,
        __PLMNAreaBasedQMC_iE_Extensions__item_,
        _PLMNAreaBasedQMC_iE_Extensions,
        PLMNAreaBasedQMC,
        PLMNAreaBasedQMC_ExtIEs,
        _PLMNListforQMC__item_,
        PLMNListforQMC,
        PRACH_Configuration_ExtIEs,
        Pre_emptionCapability,
        Pre_emptionVulnerability,
        PriorityLevel,
        _ProSeAuthorized_proSeDirectDiscovery,
        _ProSeAuthorized_proSeDirectCommunication,
        ____ProSeAuthorized_iE_Extensions__item__id_tab,
        _____ProSeAuthorized_iE_Extensions__item__id_tab_val_Extension_0,
        ___ProSeAuthorized_iE_Extensions__item__id,
        ___ProSeAuthorized_iE_Extensions__item__criticality,
        ___ProSeAuthorized_iE_Extensions__item__extensionValue,
        __ProSeAuthorized_iE_Extensions__item_,
        _ProSeAuthorized_iE_Extensions,
        ProSeAuthorized,
        ProSeAuthorized_ExtIEs,
        _ProSeAuthorized_ExtIEs_val_Extension_0,
        ProSeDirectDiscovery,
        ProSeDirectCommunication,
        ProSeUEtoNetworkRelaying,
        _ProtectedEUTRAResourceIndication_activationSFN,
        _ProtectedEUTRAResourceIndication_protectedResourceList,
        _ProtectedEUTRAResourceIndication_mBSFNControlRegionLength,
        _ProtectedEUTRAResourceIndication_pDCCHRegionLength,
        ____ProtectedEUTRAResourceIndication_iE_Extensions__item__id_tab,
        ___ProtectedEUTRAResourceIndication_iE_Extensions__item__id,
        ____ProtectedEUTRAResourceIndication_iE_Extensions__item__criticality_tab,
        ___ProtectedEUTRAResourceIndication_iE_Extensions__item__criticality,
        ____ProtectedEUTRAResourceIndication_iE_Extensions__item__extensionValue_tab,
        ___ProtectedEUTRAResourceIndication_iE_Extensions__item__extensionValue,
        __ProtectedEUTRAResourceIndication_iE_Extensions__item_,
        _ProtectedEUTRAResourceIndication_iE_Extensions,
        ProtectedEUTRAResourceIndication,
        ProtectedEUTRAResourceIndication_ExtIEs,
        _ProtectedFootprintTimePattern_protectedFootprintTimePeriodicity,
        _ProtectedFootprintTimePattern_protectedFootprintStartTime,
        ____ProtectedFootprintTimePattern_iE_Extensions__item__id_tab,
        ___ProtectedFootprintTimePattern_iE_Extensions__item__id,
        ____ProtectedFootprintTimePattern_iE_Extensions__item__criticality_tab,
        ___ProtectedFootprintTimePattern_iE_Extensions__item__criticality,
        ____ProtectedFootprintTimePattern_iE_Extensions__item__extensionValue_tab,
        ___ProtectedFootprintTimePattern_iE_Extensions__item__extensionValue,
        __ProtectedFootprintTimePattern_iE_Extensions__item_,
        _ProtectedFootprintTimePattern_iE_Extensions,
        ProtectedFootprintTimePattern,
        ProtectedFootprintTimePattern_ExtIEs,
        _ProtectedResourceList__item_,
        ProtectedResourceList,
        _ProtectedResourceList_Item_resourceType,
        _ProtectedResourceList_Item_intraPRBProtectedResourceFootprint,
        _ProtectedResourceList_Item_protectedFootprintFrequencyPattern,
        _ProtectedResourceList_Item_protectedFootprintTimePattern,
        ____ProtectedResourceList_Item_iE_Extensions__item__id_tab,
        ___ProtectedResourceList_Item_iE_Extensions__item__id,
        ____ProtectedResourceList_Item_iE_Extensions__item__criticality_tab,
        ___ProtectedResourceList_Item_iE_Extensions__item__criticality,
        ____ProtectedResourceList_Item_iE_Extensions__item__extensionValue_tab,
        ___ProtectedResourceList_Item_iE_Extensions__item__extensionValue,
        __ProtectedResourceList_Item_iE_Extensions__item_,
        _ProtectedResourceList_Item_iE_Extensions,
        ProtectedResourceList_Item,
        ProtectedResourceList_Item_ExtIEs,
        PartialListIndicator,
        PrivacyIndicator,
        PSCellHistoryInformationRetrieve,
        _PSCell_UE_HistoryInformation__item_,
        PSCell_UE_HistoryInformation,
        PSCellChangeHistory,
        QCI,
        _QoS_Mapping_Information_dscp,
        _QoS_Mapping_Information_flow_label,
        ____QoS_Mapping_Information_iE_Extensions__item__id_tab,
        ___QoS_Mapping_Information_iE_Extensions__item__id,
        ____QoS_Mapping_Information_iE_Extensions__item__criticality_tab,
        ___QoS_Mapping_Information_iE_Extensions__item__criticality,
        ____QoS_Mapping_Information_iE_Extensions__item__extensionValue_tab,
        ___QoS_Mapping_Information_iE_Extensions__item__extensionValue,
        __QoS_Mapping_Information_iE_Extensions__item_,
        _QoS_Mapping_Information_iE_Extensions,
        QoS_Mapping_Information,
        QoS_Mapping_Information_ExtIEs,
        RadioframeAllocationOffset,
        RadioframeAllocationPeriod,
        _RadioResourceStatus_dL_GBR_PRB_usage,
        _RadioResourceStatus_uL_GBR_PRB_usage,
        _RadioResourceStatus_dL_non_GBR_PRB_usage,
        _RadioResourceStatus_uL_non_GBR_PRB_usage,
        _RadioResourceStatus_dL_Total_PRB_usage,
        _RadioResourceStatus_uL_Total_PRB_usage,
        ____RadioResourceStatus_iE_Extensions__item__id_tab,
        _____RadioResourceStatus_iE_Extensions__item__id_tab_val_Extension_0,
        _____RadioResourceStatus_iE_Extensions__item__id_tab_val_Extension_1,
        ___RadioResourceStatus_iE_Extensions__item__id,
        ___RadioResourceStatus_iE_Extensions__item__criticality,
        ___RadioResourceStatus_iE_Extensions__item__extensionValue,
        __RadioResourceStatus_iE_Extensions__item_,
        _RadioResourceStatus_iE_Extensions,
        RadioResourceStatus,
        RadioResourceStatus_ExtIEs,
        _RadioResourceStatus_ExtIEs_val_Extension_0,
        _RadioResourceStatus_ExtIEs_val_Extension_1,
        Range,
        RAN_UE_NGAP_ID,
        _RAT_Restrictions__item_,
        RAT_Restrictions,
        _RAT_RestrictionsItem_pLMN_Identity,
        _RAT_RestrictionsItem_rAT_RestrictionInformation,
        ____RAT_RestrictionsItem_iE_Extensions__item__id_tab,
        ___RAT_RestrictionsItem_iE_Extensions__item__id,
        ____RAT_RestrictionsItem_iE_Extensions__item__criticality_tab,
        ___RAT_RestrictionsItem_iE_Extensions__item__criticality,
        ____RAT_RestrictionsItem_iE_Extensions__item__extensionValue_tab,
        ___RAT_RestrictionsItem_iE_Extensions__item__extensionValue,
        __RAT_RestrictionsItem_iE_Extensions__item_,
        _RAT_RestrictionsItem_iE_Extensions,
        RAT_RestrictionsItem,
        RAT_RestrictionsItem_ExtIEs,
        ReceiveStatusofULPDCPSDUs,
        ReceiveStatusOfULPDCPSDUsExtended,
        ReceiveStatusOfULPDCPSDUsPDCP_SNlength18,
        ReleaseFastMCGRecoveryViaSRB3,
        Reestablishment_Indication,
        Registration_Request,
        Registration_Request_ENDC,
        _RelativeNarrowbandTxPower_rNTP_PerPRB,
        _RelativeNarrowbandTxPower_rNTP_Threshold,
        _RelativeNarrowbandTxPower_numberOfCellSpecificAntennaPorts,
        _RelativeNarrowbandTxPower_p_B,
        _RelativeNarrowbandTxPower_pDCCH_InterferenceImpact,
        ____RelativeNarrowbandTxPower_iE_Extensions__item__id_tab,
        _____RelativeNarrowbandTxPower_iE_Extensions__item__id_tab_val_Extension_0,
        ___RelativeNarrowbandTxPower_iE_Extensions__item__id,
        ___RelativeNarrowbandTxPower_iE_Extensions__item__criticality,
        ___RelativeNarrowbandTxPower_iE_Extensions__item__extensionValue,
        __RelativeNarrowbandTxPower_iE_Extensions__item_,
        _RelativeNarrowbandTxPower_iE_Extensions,
        RelativeNarrowbandTxPower,
        RelativeNarrowbandTxPower_ExtIEs,
        _RelativeNarrowbandTxPower_ExtIEs_val_Extension_0,
        _ReplacingCellsList__item_,
        ReplacingCellsList,
        _ReplacingCellsList_Item_eCGI,
        ReplacingCellsList_Item,
        ReportAmountMDT,
        ReportArea,
        ReportCharacteristics,
        ReportingPeriodicityCSIR,
        ReportCharacteristics_ENDC,
        ReportingPeriodicityRSRPMR,
        ReportIntervalMDT,
        RequestedFastMCGRecoveryViaSRB3,
        RequestedFastMCGRecoveryViaSRB3Release,
        _ReservedSubframePattern_subframeType,
        _ReservedSubframePattern_reservedSubframePattern,
        _ReservedSubframePattern_mBSFNControlRegionLength,
        ____ReservedSubframePattern_iE_Extensions__item__id_tab,
        ___ReservedSubframePattern_iE_Extensions__item__id,
        ____ReservedSubframePattern_iE_Extensions__item__criticality_tab,
        ___ReservedSubframePattern_iE_Extensions__item__criticality,
        ____ReservedSubframePattern_iE_Extensions__item__extensionValue_tab,
        ___ReservedSubframePattern_iE_Extensions__item__extensionValue,
        __ReservedSubframePattern_iE_Extensions__item_,
        _ReservedSubframePattern_iE_Extensions,
        ReservedSubframePattern,
        ReservedSubframePattern_ExtIEs,
        ResourceType,
        _ResumeID_non_truncated,
        _ResumeID_truncated,
        ResumeID,
        RLCMode,
        _RLC_Status_reestablishment_Indication,
        ____RLC_Status_iE_Extensions__item__id_tab,
        ___RLC_Status_iE_Extensions__item__id,
        ____RLC_Status_iE_Extensions__item__criticality_tab,
        ___RLC_Status_iE_Extensions__item__criticality,
        ____RLC_Status_iE_Extensions__item__extensionValue_tab,
        ___RLC_Status_iE_Extensions__item__extensionValue,
        __RLC_Status_iE_Extensions__item_,
        _RLC_Status_iE_Extensions,
        RLC_Status,
        RLC_Status_ExtIEs,
        RNTP_Threshold,
        RRC_Config_Ind,
        RRC_Context,
        RRCConnReestabIndicator,
        RRCConnSetupIndicator,
        __RSRPMeasurementResult__item__rSRPCellID,
        __RSRPMeasurementResult__item__rSRPMeasured,
        _____RSRPMeasurementResult__item__iE_Extensions__item__id_tab,
        ____RSRPMeasurementResult__item__iE_Extensions__item__id,
        _____RSRPMeasurementResult__item__iE_Extensions__item__criticality_tab,
        ____RSRPMeasurementResult__item__iE_Extensions__item__criticality,
        _____RSRPMeasurementResult__item__iE_Extensions__item__extensionValue_tab,
        ____RSRPMeasurementResult__item__iE_Extensions__item__extensionValue,
        ___RSRPMeasurementResult__item__iE_Extensions__item_,
        __RSRPMeasurementResult__item__iE_Extensions,
        _RSRPMeasurementResult__item_,
        RSRPMeasurementResult,
        RSRPMeasurementResult_ExtIEs,
        __RSRPMRList__item__rSRPMeasurementResult,
        _____RSRPMRList__item__iE_Extensions__item__id_tab,
        ______RSRPMRList__item__iE_Extensions__item__id_tab_val_Extension_0,
        ____RSRPMRList__item__iE_Extensions__item__id,
        ____RSRPMRList__item__iE_Extensions__item__criticality,
        ____RSRPMRList__item__iE_Extensions__item__extensionValue,
        ___RSRPMRList__item__iE_Extensions__item_,
        __RSRPMRList__item__iE_Extensions,
        _RSRPMRList__item_,
        RSRPMRList,
        RSRPMRList_ExtIEs,
        _RSRPMRList_ExtIEs_val_Extension_0,
        RRCContainer,
        _S1TNLLoadIndicator_dLS1TNLLoadIndicator,
        _S1TNLLoadIndicator_uLS1TNLLoadIndicator,
        ____S1TNLLoadIndicator_iE_Extensions__item__id_tab,
        ___S1TNLLoadIndicator_iE_Extensions__item__id,
        ____S1TNLLoadIndicator_iE_Extensions__item__criticality_tab,
        ___S1TNLLoadIndicator_iE_Extensions__item__criticality,
        ____S1TNLLoadIndicator_iE_Extensions__item__extensionValue_tab,
        ___S1TNLLoadIndicator_iE_Extensions__item__extensionValue,
        __S1TNLLoadIndicator_iE_Extensions__item_,
        _S1TNLLoadIndicator_iE_Extensions,
        S1TNLLoadIndicator,
        S1TNLLoadIndicator_ExtIEs,
        SCGActivationStatus,
        SCGActivationRequest,
        SCGChangeIndication,
        SCGreconfigNotification,
        _SCG_UE_HistoryInformation__item_,
        SCG_UE_HistoryInformation,
        ___SecondaryRATUsageReportList__item__id_tab,
        ____SecondaryRATUsageReportList__item__id_tab_val_Value_0,
        __SecondaryRATUsageReportList__item__id,
        __SecondaryRATUsageReportList__item__criticality,
        __SecondaryRATUsageReportList__item__value,
        _SecondaryRATUsageReportList__item_,
        SecondaryRATUsageReportList,
        SecondaryRATUsageReport_ItemIEs,
        _SecondaryRATUsageReport_ItemIEs_val_Value_0,
        _SecondaryRATUsageReport_Item_e_RAB_ID,
        _SecondaryRATUsageReport_Item_secondaryRATType,
        _SecondaryRATUsageReport_Item_e_RABUsageReportList,
        ____SecondaryRATUsageReport_Item_iE_Extensions__item__id_tab,
        ___SecondaryRATUsageReport_Item_iE_Extensions__item__id,
        ____SecondaryRATUsageReport_Item_iE_Extensions__item__criticality_tab,
        ___SecondaryRATUsageReport_Item_iE_Extensions__item__criticality,
        ____SecondaryRATUsageReport_Item_iE_Extensions__item__extensionValue_tab,
        ___SecondaryRATUsageReport_Item_iE_Extensions__item__extensionValue,
        __SecondaryRATUsageReport_Item_iE_Extensions__item_,
        _SecondaryRATUsageReport_Item_iE_Extensions,
        SecondaryRATUsageReport_Item,
        SecondaryRATUsageReport_Item_ExtIEs,
        _SecurityIndication_integrityProtectionIndication,
        ____SecurityIndication_iE_Extensions__item__id_tab,
        ___SecurityIndication_iE_Extensions__item__id,
        ____SecurityIndication_iE_Extensions__item__criticality_tab,
        ___SecurityIndication_iE_Extensions__item__criticality,
        ____SecurityIndication_iE_Extensions__item__extensionValue_tab,
        ___SecurityIndication_iE_Extensions__item__extensionValue,
        __SecurityIndication_iE_Extensions__item_,
        _SecurityIndication_iE_Extensions,
        SecurityIndication,
        SecurityIndication_ExtIEs,
        _SecurityResult_integrityProtectionResult,
        ____SecurityResult_iE_Extensions__item__id_tab,
        ___SecurityResult_iE_Extensions__item__id,
        ____SecurityResult_iE_Extensions__item__criticality_tab,
        ___SecurityResult_iE_Extensions__item__criticality,
        ____SecurityResult_iE_Extensions__item__extensionValue_tab,
        ___SecurityResult_iE_Extensions__item__extensionValue,
        __SecurityResult_iE_Extensions__item_,
        _SecurityResult_iE_Extensions,
        SecurityResult,
        SecurityResult_ExtIEs,
        SeNBSecurityKey,
        SeNBtoMeNBContainer,
        _SensorMeasurementConfiguration_sensorMeasConfig,
        _SensorMeasurementConfiguration_sensorMeasConfigNameList,
        ____SensorMeasurementConfiguration_iE_Extensions__item__id_tab,
        ___SensorMeasurementConfiguration_iE_Extensions__item__id,
        ____SensorMeasurementConfiguration_iE_Extensions__item__criticality_tab,
        ___SensorMeasurementConfiguration_iE_Extensions__item__criticality,
        ____SensorMeasurementConfiguration_iE_Extensions__item__extensionValue_tab,
        ___SensorMeasurementConfiguration_iE_Extensions__item__extensionValue,
        __SensorMeasurementConfiguration_iE_Extensions__item_,
        _SensorMeasurementConfiguration_iE_Extensions,
        SensorMeasurementConfiguration,
        SensorMeasurementConfiguration_ExtIEs,
        _SensorMeasConfigNameList__item_,
        SensorMeasConfigNameList,
        _SensorMeasConfigNameItem_sensorNameConfig,
        ____SensorMeasConfigNameItem_iE_Extensions__item__id_tab,
        ___SensorMeasConfigNameItem_iE_Extensions__item__id,
        ____SensorMeasConfigNameItem_iE_Extensions__item__criticality_tab,
        ___SensorMeasConfigNameItem_iE_Extensions__item__criticality,
        ____SensorMeasConfigNameItem_iE_Extensions__item__extensionValue_tab,
        ___SensorMeasConfigNameItem_iE_Extensions__item__extensionValue,
        __SensorMeasConfigNameItem_iE_Extensions__item_,
        _SensorMeasConfigNameItem_iE_Extensions,
        SensorMeasConfigNameItem,
        SensorMeasConfigNameItem_ExtIEs,
        SensorMeasConfig,
        _SensorNameConfig_uncompensatedBarometricConfig,
        ___SensorNameConfig_choice_extension_id_tab,
        __SensorNameConfig_choice_extension_id,
        ___SensorNameConfig_choice_extension_criticality_tab,
        __SensorNameConfig_choice_extension_criticality,
        ___SensorNameConfig_choice_extension_value_tab,
        __SensorNameConfig_choice_extension_value,
        _SensorNameConfig_choice_extension,
        SensorNameConfig,
        SensorNameConfig_ExtIEs,
        __ServedCells__item__servedCellInfo,
        __ServedCells__item__neighbour_Info,
        _____ServedCells__item__iE_Extensions__item__id_tab,
        ______ServedCells__item__iE_Extensions__item__id_tab_val_Extension_0,
        ______ServedCells__item__iE_Extensions__item__id_tab_val_Extension_1,
        ____ServedCells__item__iE_Extensions__item__id,
        ____ServedCells__item__iE_Extensions__item__criticality,
        ____ServedCells__item__iE_Extensions__item__extensionValue,
        ___ServedCells__item__iE_Extensions__item_,
        __ServedCells__item__iE_Extensions,
        _ServedCells__item_,
        ServedCells,
        ServedCell_ExtIEs,
        _ServedCell_ExtIEs_val_Extension_0,
        _ServedCell_ExtIEs_val_Extension_1,
        _ServedCell_Information_pCI,
        _ServedCell_Information_cellId,
        _ServedCell_Information_tAC,
        _ServedCell_Information_broadcastPLMNs,
        _ServedCell_Information_eUTRA_Mode_Info,
        ____ServedCell_Information_iE_Extensions__item__id_tab,
        _____ServedCell_Information_iE_Extensions__item__id_tab_val_Extension_0,
        _____ServedCell_Information_iE_Extensions__item__id_tab_val_Extension_1,
        _____ServedCell_Information_iE_Extensions__item__id_tab_val_Extension_2,
        _____ServedCell_Information_iE_Extensions__item__id_tab_val_Extension_3,
        _____ServedCell_Information_iE_Extensions__item__id_tab_val_Extension_4,
        _____ServedCell_Information_iE_Extensions__item__id_tab_val_Extension_5,
        _____ServedCell_Information_iE_Extensions__item__id_tab_val_Extension_6,
        _____ServedCell_Information_iE_Extensions__item__id_tab_val_Extension_7,
        _____ServedCell_Information_iE_Extensions__item__id_tab_val_Extension_8,
        _____ServedCell_Information_iE_Extensions__item__id_tab_val_Extension_9,
        _____ServedCell_Information_iE_Extensions__item__id_tab_val_Extension_10,
        _____ServedCell_Information_iE_Extensions__item__id_tab_val_Extension_11,
        ___ServedCell_Information_iE_Extensions__item__id,
        ___ServedCell_Information_iE_Extensions__item__criticality,
        ___ServedCell_Information_iE_Extensions__item__extensionValue,
        __ServedCell_Information_iE_Extensions__item_,
        _ServedCell_Information_iE_Extensions,
        ServedCell_Information,
        ServedCell_Information_ExtIEs,
        _ServedCell_Information_ExtIEs_val_Extension_0,
        _ServedCell_Information_ExtIEs_val_Extension_1,
        _ServedCell_Information_ExtIEs_val_Extension_2,
        _ServedCell_Information_ExtIEs_val_Extension_3,
        _ServedCell_Information_ExtIEs_val_Extension_4,
        _ServedCell_Information_ExtIEs_val_Extension_5,
        _ServedCell_Information_ExtIEs_val_Extension_6,
        _ServedCell_Information_ExtIEs_val_Extension_7,
        _ServedCell_Information_ExtIEs_val_Extension_8,
        _ServedCell_Information_ExtIEs_val_Extension_9,
        _ServedCell_Information_ExtIEs_val_Extension_10,
        _ServedCell_Information_ExtIEs_val_Extension_11,
        _ServedCellSpecificInfoReq_NR__item_,
        ServedCellSpecificInfoReq_NR,
        _ServedCellSpecificInfoReq_NR_Item_nRCGI,
        _ServedCellSpecificInfoReq_NR_Item_additionalMTCListRequestIndicator,
        ____ServedCellSpecificInfoReq_NR_Item_iE_Extensions__item__id_tab,
        ___ServedCellSpecificInfoReq_NR_Item_iE_Extensions__item__id,
        ____ServedCellSpecificInfoReq_NR_Item_iE_Extensions__item__criticality_tab,
        ___ServedCellSpecificInfoReq_NR_Item_iE_Extensions__item__criticality,
        ____ServedCellSpecificInfoReq_NR_Item_iE_Extensions__item__extensionValue_tab,
        ___ServedCellSpecificInfoReq_NR_Item_iE_Extensions__item__extensionValue,
        __ServedCellSpecificInfoReq_NR_Item_iE_Extensions__item_,
        _ServedCellSpecificInfoReq_NR_Item_iE_Extensions,
        ServedCellSpecificInfoReq_NR_Item,
        ServedCellSpecificInfoReq_NR_Item_ExtIEs,
        ServiceType,
        SgNBCoordinationAssistanceInformation,
        _SgNBResourceCoordinationInformation_nR_CGI,
        _SgNBResourceCoordinationInformation_uLCoordinationInformation,
        _SgNBResourceCoordinationInformation_dLCoordinationInformation,
        ____SgNBResourceCoordinationInformation_iE_Extensions__item__id_tab,
        _____SgNBResourceCoordinationInformation_iE_Extensions__item__id_tab_val_Extension_0,
        _____SgNBResourceCoordinationInformation_iE_Extensions__item__id_tab_val_Extension_1,
        ___SgNBResourceCoordinationInformation_iE_Extensions__item__id,
        ___SgNBResourceCoordinationInformation_iE_Extensions__item__criticality,
        ___SgNBResourceCoordinationInformation_iE_Extensions__item__extensionValue,
        __SgNBResourceCoordinationInformation_iE_Extensions__item_,
        _SgNBResourceCoordinationInformation_iE_Extensions,
        SgNBResourceCoordinationInformation,
        SgNBResourceCoordinationInformationExtIEs,
        _SgNBResourceCoordinationInformationExtIEs_val_Extension_0,
        _SgNBResourceCoordinationInformationExtIEs_val_Extension_1,
        SgNB_UE_X2AP_ID,
        SIPTOBearerDeactivationIndication,
        _SharedResourceType_uLOnlySharing,
        _SharedResourceType_uLandDLSharing,
        SharedResourceType,
        ShortMAC_I,
        SGNB_Addition_Trigger_Ind,
        SNtriggered,
        SourceOfUEActivityBehaviourInformation,
        _SpecialSubframe_Info_specialSubframePatterns,
        _SpecialSubframe_Info_cyclicPrefixDL,
        _SpecialSubframe_Info_cyclicPrefixUL,
        ____SpecialSubframe_Info_iE_Extensions__item__id_tab,
        ___SpecialSubframe_Info_iE_Extensions__item__id,
        ____SpecialSubframe_Info_iE_Extensions__item__criticality_tab,
        ___SpecialSubframe_Info_iE_Extensions__item__criticality,
        ____SpecialSubframe_Info_iE_Extensions__item__extensionValue_tab,
        ___SpecialSubframe_Info_iE_Extensions__item__extensionValue,
        __SpecialSubframe_Info_iE_Extensions__item_,
        _SpecialSubframe_Info_iE_Extensions,
        SpecialSubframe_Info,
        SpecialSubframe_Info_ExtIEs,
        SpecialSubframePatterns,
        SpectrumSharingGroupID,
        _SubbandCQI_subbandCQICodeword0,
        _SubbandCQI_subbandCQICodeword1,
        ____SubbandCQI_iE_Extensions__item__id_tab,
        ___SubbandCQI_iE_Extensions__item__id,
        ____SubbandCQI_iE_Extensions__item__criticality_tab,
        ___SubbandCQI_iE_Extensions__item__criticality,
        ____SubbandCQI_iE_Extensions__item__extensionValue_tab,
        ___SubbandCQI_iE_Extensions__item__extensionValue,
        __SubbandCQI_iE_Extensions__item_,
        _SubbandCQI_iE_Extensions,
        SubbandCQI,
        _Subscription_Based_UE_DifferentiationInfo_periodicCommunicationIndicator,
        _Subscription_Based_UE_DifferentiationInfo_periodicTime,
        _Subscription_Based_UE_DifferentiationInfo_scheduledCommunicationTime,
        _Subscription_Based_UE_DifferentiationInfo_stationaryIndication,
        _Subscription_Based_UE_DifferentiationInfo_trafficProfile,
        _Subscription_Based_UE_DifferentiationInfo_batteryIndication,
        ____Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__id_tab,
        ___Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__id,
        ____Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__criticality_tab,
        ___Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__criticality,
        ____Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__extensionValue_tab,
        ___Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__extensionValue,
        __Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item_,
        _Subscription_Based_UE_DifferentiationInfo_iE_Extensions,
        Subscription_Based_UE_DifferentiationInfo,
        Subscription_Based_UE_DifferentiationInfo_ExtIEs,
        _ScheduledCommunicationTime_dayofWeek,
        _ScheduledCommunicationTime_timeofDayStart,
        _ScheduledCommunicationTime_timeofDayEnd,
        ____ScheduledCommunicationTime_iE_Extensions__item__id_tab,
        ___ScheduledCommunicationTime_iE_Extensions__item__id,
        ____ScheduledCommunicationTime_iE_Extensions__item__criticality_tab,
        ___ScheduledCommunicationTime_iE_Extensions__item__criticality,
        ____ScheduledCommunicationTime_iE_Extensions__item__extensionValue_tab,
        ___ScheduledCommunicationTime_iE_Extensions__item__extensionValue,
        __ScheduledCommunicationTime_iE_Extensions__item_,
        _ScheduledCommunicationTime_iE_Extensions,
        ScheduledCommunicationTime,
        ScheduledCommunicationTime_ExtIEs,
        SRVCCOperationPossible,
        _SSBAreaCapacityValue_List__item_,
        SSBAreaCapacityValue_List,
        _SSBAreaCapacityValue_Item_ssbIndex,
        _SSBAreaCapacityValue_Item_ssbAreaCapacityValue,
        ____SSBAreaCapacityValue_Item_iE_Extensions__item__id_tab,
        ___SSBAreaCapacityValue_Item_iE_Extensions__item__id,
        ____SSBAreaCapacityValue_Item_iE_Extensions__item__criticality_tab,
        ___SSBAreaCapacityValue_Item_iE_Extensions__item__criticality,
        ____SSBAreaCapacityValue_Item_iE_Extensions__item__extensionValue_tab,
        ___SSBAreaCapacityValue_Item_iE_Extensions__item__extensionValue,
        __SSBAreaCapacityValue_Item_iE_Extensions__item_,
        _SSBAreaCapacityValue_Item_iE_Extensions,
        SSBAreaCapacityValue_Item,
        SSBAreaCapacityValue_ExtIEs,
        _SSBAreaRadioResourceStatus_List__item_,
        SSBAreaRadioResourceStatus_List,
        _SSBAreaRadioResourceStatus_Item_ssbIndex,
        _SSBAreaRadioResourceStatus_Item_ssbAreaDLGBRPRBUsage,
        _SSBAreaRadioResourceStatus_Item_ssbAreaULGBRPRBUsage,
        _SSBAreaRadioResourceStatus_Item_ssbAreaDLNonGBRPRBUsage,
        _SSBAreaRadioResourceStatus_Item_ssbAreaULNonGBRPRBUsage,
        _SSBAreaRadioResourceStatus_Item_ssbAreaDLTotalPRBUsage,
        _SSBAreaRadioResourceStatus_Item_ssbAreaULTotalPRBUsage,
        _SSBAreaRadioResourceStatus_Item_ssbAreaDLSchedulingPDCCHCCEUsage,
        _SSBAreaRadioResourceStatus_Item_ssbAreaULSchedulingPDCCHCCEUsage,
        ____SSBAreaRadioResourceStatus_Item_iE_Extensions__item__id_tab,
        ___SSBAreaRadioResourceStatus_Item_iE_Extensions__item__id,
        ____SSBAreaRadioResourceStatus_Item_iE_Extensions__item__criticality_tab,
        ___SSBAreaRadioResourceStatus_Item_iE_Extensions__item__criticality,
        ____SSBAreaRadioResourceStatus_Item_iE_Extensions__item__extensionValue_tab,
        ___SSBAreaRadioResourceStatus_Item_iE_Extensions__item__extensionValue,
        __SSBAreaRadioResourceStatus_Item_iE_Extensions__item_,
        _SSBAreaRadioResourceStatus_Item_iE_Extensions,
        SSBAreaRadioResourceStatus_Item,
        SSBAreaRadioResourceStatus_ExtIEs,
        SSBIndex,
        _SSB_PositionsInBurst_shortBitmap,
        _SSB_PositionsInBurst_mediumBitmap,
        _SSB_PositionsInBurst_longBitmap,
        ___SSB_PositionsInBurst_choice_extension_id_tab,
        __SSB_PositionsInBurst_choice_extension_id,
        ___SSB_PositionsInBurst_choice_extension_criticality_tab,
        __SSB_PositionsInBurst_choice_extension_criticality,
        ___SSB_PositionsInBurst_choice_extension_value_tab,
        __SSB_PositionsInBurst_choice_extension_value,
        _SSB_PositionsInBurst_choice_extension,
        SSB_PositionsInBurst,
        SSB_PositionsInBurst_ExtIEs,
        SubbandCQI_ExtIEs,
        _SubbandCQICodeword0_four_bitCQI,
        _SubbandCQICodeword0_two_bitSubbandDifferentialCQI,
        _SubbandCQICodeword0_two_bitDifferentialCQI,
        SubbandCQICodeword0,
        _SubbandCQICodeword1_four_bitCQI,
        _SubbandCQICodeword1_three_bitSpatialDifferentialCQI,
        _SubbandCQICodeword1_two_bitSubbandDifferentialCQI,
        _SubbandCQICodeword1_two_bitDifferentialCQI,
        SubbandCQICodeword1,
        _SubbandCQIList__item_,
        SubbandCQIList,
        _SubbandCQIItem_subbandCQI,
        _SubbandCQIItem_subbandIndex,
        ____SubbandCQIItem_iE_Extensions__item__id_tab,
        ___SubbandCQIItem_iE_Extensions__item__id,
        ____SubbandCQIItem_iE_Extensions__item__criticality_tab,
        ___SubbandCQIItem_iE_Extensions__item__criticality,
        ____SubbandCQIItem_iE_Extensions__item__extensionValue_tab,
        ___SubbandCQIItem_iE_Extensions__item__extensionValue,
        __SubbandCQIItem_iE_Extensions__item_,
        _SubbandCQIItem_iE_Extensions,
        SubbandCQIItem,
        SubbandCQIItem_ExtIEs,
        SubbandSize,
        SubscriberProfileIDforRFP,
        _SubframeAllocation_oneframe,
        _SubframeAllocation_fourframes,
        SubframeAllocation,
        SubframeAssignment,
        SubframeType,
        SgNBSecurityKey,
        SgNBtoMeNBContainer,
        SRBType,
        SCGConfigurationQuery,
        _SULInformation_sUL_ARFCN,
        _SULInformation_sUL_TxBW,
        ____SULInformation_iE_Extensions__item__id_tab,
        _____SULInformation_iE_Extensions__item__id_tab_val_Extension_0,
        _____SULInformation_iE_Extensions__item__id_tab_val_Extension_1,
        ___SULInformation_iE_Extensions__item__id,
        ___SULInformation_iE_Extensions__item__criticality,
        ___SULInformation_iE_Extensions__item__extensionValue,
        __SULInformation_iE_Extensions__item_,
        _SULInformation_iE_Extensions,
        SULInformation,
        _SupportedSULFreqBandItem_freqBandIndicatorNr,
        ____SupportedSULFreqBandItem_iE_Extensions__item__id_tab,
        ___SupportedSULFreqBandItem_iE_Extensions__item__id,
        ____SupportedSULFreqBandItem_iE_Extensions__item__criticality_tab,
        ___SupportedSULFreqBandItem_iE_Extensions__item__criticality,
        ____SupportedSULFreqBandItem_iE_Extensions__item__extensionValue_tab,
        ___SupportedSULFreqBandItem_iE_Extensions__item__extensionValue,
        __SupportedSULFreqBandItem_iE_Extensions__item_,
        _SupportedSULFreqBandItem_iE_Extensions,
        SupportedSULFreqBandItem,
        SupportedSULFreqBandItem_ExtIEs,
        SULInformation_ExtIEs,
        _SULInformation_ExtIEs_val_Extension_0,
        _SULInformation_ExtIEs_val_Extension_1,
        _SFN_Offset_sFN_Time_Offset,
        ____SFN_Offset_iE_Extensions__item__id_tab,
        ___SFN_Offset_iE_Extensions__item__id,
        ____SFN_Offset_iE_Extensions__item__criticality_tab,
        ___SFN_Offset_iE_Extensions__item__criticality,
        ____SFN_Offset_iE_Extensions__item__extensionValue_tab,
        ___SFN_Offset_iE_Extensions__item__extensionValue,
        __SFN_Offset_iE_Extensions__item_,
        _SFN_Offset_iE_Extensions,
        SFN_Offset,
        SFN_Offset_ExtIEs,
        _TABasedMDT_tAListforMDT,
        ____TABasedMDT_iE_Extensions__item__id_tab,
        ___TABasedMDT_iE_Extensions__item__id,
        ____TABasedMDT_iE_Extensions__item__criticality_tab,
        ___TABasedMDT_iE_Extensions__item__criticality,
        ____TABasedMDT_iE_Extensions__item__extensionValue_tab,
        ___TABasedMDT_iE_Extensions__item__extensionValue,
        __TABasedMDT_iE_Extensions__item_,
        _TABasedMDT_iE_Extensions,
        TABasedMDT,
        TABasedMDT_ExtIEs,
        TAC,
        _TAIBasedMDT_tAIListforMDT,
        ____TAIBasedMDT_iE_Extensions__item__id_tab,
        ___TAIBasedMDT_iE_Extensions__item__id,
        ____TAIBasedMDT_iE_Extensions__item__criticality_tab,
        ___TAIBasedMDT_iE_Extensions__item__criticality,
        ____TAIBasedMDT_iE_Extensions__item__extensionValue_tab,
        ___TAIBasedMDT_iE_Extensions__item__extensionValue,
        __TAIBasedMDT_iE_Extensions__item_,
        _TAIBasedMDT_iE_Extensions,
        TAIBasedMDT,
        TAIBasedMDT_ExtIEs,
        _TAIListforMDT__item_,
        TAIListforMDT,
        _TAI_Item_tAC,
        _TAI_Item_pLMN_Identity,
        ____TAI_Item_iE_Extensions__item__id_tab,
        ___TAI_Item_iE_Extensions__item__id,
        ____TAI_Item_iE_Extensions__item__criticality_tab,
        ___TAI_Item_iE_Extensions__item__criticality,
        ____TAI_Item_iE_Extensions__item__extensionValue_tab,
        ___TAI_Item_iE_Extensions__item__extensionValue,
        __TAI_Item_iE_Extensions__item_,
        _TAI_Item_iE_Extensions,
        TAI_Item,
        TAI_Item_ExtIEs,
        _TAListforMDT__item_,
        TAListforMDT,
        _TABasedQMC_tAListforQMC,
        ____TABasedQMC_iE_Extensions__item__id_tab,
        ___TABasedQMC_iE_Extensions__item__id,
        ____TABasedQMC_iE_Extensions__item__criticality_tab,
        ___TABasedQMC_iE_Extensions__item__criticality,
        ____TABasedQMC_iE_Extensions__item__extensionValue_tab,
        ___TABasedQMC_iE_Extensions__item__extensionValue,
        __TABasedQMC_iE_Extensions__item_,
        _TABasedQMC_iE_Extensions,
        TABasedQMC,
        TABasedQMC_ExtIEs,
        _TAListforQMC__item_,
        TAListforQMC,
        _TAIBasedQMC_tAIListforQMC,
        ____TAIBasedQMC_iE_Extensions__item__id_tab,
        ___TAIBasedQMC_iE_Extensions__item__id,
        ____TAIBasedQMC_iE_Extensions__item__criticality_tab,
        ___TAIBasedQMC_iE_Extensions__item__criticality,
        ____TAIBasedQMC_iE_Extensions__item__extensionValue_tab,
        ___TAIBasedQMC_iE_Extensions__item__extensionValue,
        __TAIBasedQMC_iE_Extensions__item_,
        _TAIBasedQMC_iE_Extensions,
        TAIBasedQMC,
        TAIBasedQMC_ExtIEs,
        _TAIListforQMC__item_,
        TAIListforQMC,
        TargetCellInNGRAN,
        TargetCellInUTRAN,
        TargeteNBtoSource_eNBTransparentContainer,
        _TDD_Info_eARFCN,
        _TDD_Info_transmission_Bandwidth,
        _TDD_Info_subframeAssignment,
        _TDD_Info_specialSubframe_Info,
        ____TDD_Info_iE_Extensions__item__id_tab,
        _____TDD_Info_iE_Extensions__item__id_tab_val_Extension_0,
        _____TDD_Info_iE_Extensions__item__id_tab_val_Extension_1,
        _____TDD_Info_iE_Extensions__item__id_tab_val_Extension_2,
        _____TDD_Info_iE_Extensions__item__id_tab_val_Extension_3,
        _____TDD_Info_iE_Extensions__item__id_tab_val_Extension_4,
        ___TDD_Info_iE_Extensions__item__id,
        ___TDD_Info_iE_Extensions__item__criticality,
        ___TDD_Info_iE_Extensions__item__extensionValue,
        __TDD_Info_iE_Extensions__item_,
        _TDD_Info_iE_Extensions,
        TDD_Info,
        TDD_Info_ExtIEs,
        _TDD_Info_ExtIEs_val_Extension_0,
        _TDD_Info_ExtIEs_val_Extension_1,
        _TDD_Info_ExtIEs_val_Extension_2,
        _TDD_Info_ExtIEs_val_Extension_3,
        _TDD_Info_ExtIEs_val_Extension_4,
        _TDD_InfoNeighbourServedNRCell_Information_nRFreqInfo,
        ____TDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item__id_tab,
        _____TDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item__id_tab_val_Extension_0,
        _____TDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item__id_tab_val_Extension_1,
        _____TDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item__id_tab_val_Extension_2,
        ___TDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item__id,
        ___TDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item__criticality,
        ___TDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item__extensionValue,
        __TDD_InfoNeighbourServedNRCell_Information_iE_Extensions__item_,
        _TDD_InfoNeighbourServedNRCell_Information_iE_Extensions,
        TDD_InfoNeighbourServedNRCell_Information,
        TDD_InfoNeighbourServedNRCell_Information_ExtIEs,
        _TDD_InfoNeighbourServedNRCell_Information_ExtIEs_val_Extension_0,
        _TDD_InfoNeighbourServedNRCell_Information_ExtIEs_val_Extension_1,
        _TDD_InfoNeighbourServedNRCell_Information_ExtIEs_val_Extension_2,
        TDDULDLConfigurationCommonNR,
        Threshold_RSRP,
        Threshold_RSRQ,
        TimeToWait,
        Time_UE_StayedInCell,
        Time_UE_StayedInCell_EnhancedGranularity,
        _TNLA_To_Add_List__item_,
        TNLA_To_Add_List,
        _TNLA_To_Add_Item_tNLAssociationTransportLayerAddress,
        _TNLA_To_Add_Item_tNLAssociationUsage,
        ____TNLA_To_Add_Item_iE_Extensions__item__id_tab,
        ___TNLA_To_Add_Item_iE_Extensions__item__id,
        ____TNLA_To_Add_Item_iE_Extensions__item__criticality_tab,
        ___TNLA_To_Add_Item_iE_Extensions__item__criticality,
        ____TNLA_To_Add_Item_iE_Extensions__item__extensionValue_tab,
        ___TNLA_To_Add_Item_iE_Extensions__item__extensionValue,
        __TNLA_To_Add_Item_iE_Extensions__item_,
        _TNLA_To_Add_Item_iE_Extensions,
        TNLA_To_Add_Item,
        TNLA_To_Add_Item_ExtIEs,
        _TNLA_To_Update_List__item_,
        TNLA_To_Update_List,
        _TNLA_To_Update_Item_tNLAssociationTransportLayerAddress,
        _TNLA_To_Update_Item_tNLAssociationUsage,
        ____TNLA_To_Update_Item_iE_Extensions__item__id_tab,
        ___TNLA_To_Update_Item_iE_Extensions__item__id,
        ____TNLA_To_Update_Item_iE_Extensions__item__criticality_tab,
        ___TNLA_To_Update_Item_iE_Extensions__item__criticality,
        ____TNLA_To_Update_Item_iE_Extensions__item__extensionValue_tab,
        ___TNLA_To_Update_Item_iE_Extensions__item__extensionValue,
        __TNLA_To_Update_Item_iE_Extensions__item_,
        _TNLA_To_Update_Item_iE_Extensions,
        TNLA_To_Update_Item,
        TNLA_To_Update_Item_ExtIEs,
        _TNLA_To_Remove_List__item_,
        TNLA_To_Remove_List,
        _TNLA_To_Remove_Item_tNLAssociationTransportLayerAddress,
        ____TNLA_To_Remove_Item_iE_Extensions__item__id_tab,
        ___TNLA_To_Remove_Item_iE_Extensions__item__id,
        ____TNLA_To_Remove_Item_iE_Extensions__item__criticality_tab,
        ___TNLA_To_Remove_Item_iE_Extensions__item__criticality,
        ____TNLA_To_Remove_Item_iE_Extensions__item__extensionValue_tab,
        ___TNLA_To_Remove_Item_iE_Extensions__item__extensionValue,
        __TNLA_To_Remove_Item_iE_Extensions__item_,
        _TNLA_To_Remove_Item_iE_Extensions,
        TNLA_To_Remove_Item,
        TNLA_To_Remove_Item_ExtIEs,
        _TNLA_Setup_List__item_,
        TNLA_Setup_List,
        _TNLA_Setup_Item_tNLAssociationTransportLayerAddress,
        ____TNLA_Setup_Item_iE_Extensions__item__id_tab,
        ___TNLA_Setup_Item_iE_Extensions__item__id,
        ____TNLA_Setup_Item_iE_Extensions__item__criticality_tab,
        ___TNLA_Setup_Item_iE_Extensions__item__criticality,
        ____TNLA_Setup_Item_iE_Extensions__item__extensionValue_tab,
        ___TNLA_Setup_Item_iE_Extensions__item__extensionValue,
        __TNLA_Setup_Item_iE_Extensions__item_,
        _TNLA_Setup_Item_iE_Extensions,
        TNLA_Setup_Item,
        TNLA_Setup_Item_ExtIEs,
        _TNLA_Failed_To_Setup_List__item_,
        TNLA_Failed_To_Setup_List,
        _TNLA_Failed_To_Setup_Item_tNLAssociationTransportLayerAddress,
        _TNLA_Failed_To_Setup_Item_cause,
        ____TNLA_Failed_To_Setup_Item_iE_Extensions__item__id_tab,
        ___TNLA_Failed_To_Setup_Item_iE_Extensions__item__id,
        ____TNLA_Failed_To_Setup_Item_iE_Extensions__item__criticality_tab,
        ___TNLA_Failed_To_Setup_Item_iE_Extensions__item__criticality,
        ____TNLA_Failed_To_Setup_Item_iE_Extensions__item__extensionValue_tab,
        ___TNLA_Failed_To_Setup_Item_iE_Extensions__item__extensionValue,
        __TNLA_Failed_To_Setup_Item_iE_Extensions__item_,
        _TNLA_Failed_To_Setup_Item_iE_Extensions,
        TNLA_Failed_To_Setup_Item,
        TNLA_Failed_To_Setup_Item_ExtIEs,
        TNLAssociationUsage,
        _TNLCapacityIndicator_dlTNLMaximumOfferedCapacity,
        _TNLCapacityIndicator_dlTNLAvailableCapacity,
        _TNLCapacityIndicator_ulTNLMaximumOfferedCapacity,
        _TNLCapacityIndicator_ulTNLAvailableCapacity,
        ____TNLCapacityIndicator_iE_Extensions__item__id_tab,
        ___TNLCapacityIndicator_iE_Extensions__item__id,
        ____TNLCapacityIndicator_iE_Extensions__item__criticality_tab,
        ___TNLCapacityIndicator_iE_Extensions__item__criticality,
        ____TNLCapacityIndicator_iE_Extensions__item__extensionValue_tab,
        ___TNLCapacityIndicator_iE_Extensions__item__extensionValue,
        __TNLCapacityIndicator_iE_Extensions__item_,
        _TNLCapacityIndicator_iE_Extensions,
        TNLCapacityIndicator,
        TNLCapacityIndicator_ExtIEs,
        _Transport_UP_Layer_Addresses_Info_To_Add_List__item_,
        Transport_UP_Layer_Addresses_Info_To_Add_List,
        _Transport_UP_Layer_Addresses_Info_To_Add_Item_iP_SecTransportLayerAddress,
        _Transport_UP_Layer_Addresses_Info_To_Add_Item_gTPTransportLayerAddressesToAdd,
        ____Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item__id_tab,
        ___Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item__id,
        ____Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item__criticality_tab,
        ___Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item__criticality,
        ____Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item__extensionValue_tab,
        ___Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item__extensionValue,
        __Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions__item_,
        _Transport_UP_Layer_Addresses_Info_To_Add_Item_iE_Extensions,
        Transport_UP_Layer_Addresses_Info_To_Add_Item,
        Transport_UP_Layer_Addresses_Info_To_Add_ItemExtIEs,
        _Transport_UP_Layer_Addresses_Info_To_Remove_List__item_,
        Transport_UP_Layer_Addresses_Info_To_Remove_List,
        _Transport_UP_Layer_Addresses_Info_To_Remove_Item_iP_SecTransportLayerAddress,
        _Transport_UP_Layer_Addresses_Info_To_Remove_Item_gTPTransportLayerAddressesToRemove,
        ____Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item__id_tab,
        ___Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item__id,
        ____Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item__criticality_tab,
        ___Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item__criticality,
        ____Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item__extensionValue_tab,
        ___Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item__extensionValue,
        __Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions__item_,
        _Transport_UP_Layer_Addresses_Info_To_Remove_Item_iE_Extensions,
        Transport_UP_Layer_Addresses_Info_To_Remove_Item,
        Transport_UP_Layer_Addresses_Info_To_Remove_ItemExtIEs,
        _TNLConfigurationInfo_transport_UP_Layer_Addresses_Info_To_Add_List,
        _TNLConfigurationInfo_transport_UP_Layer_Addresses_Info_To_Remove_List,
        ____TNLConfigurationInfo_iE_Extensions__item__id_tab,
        ___TNLConfigurationInfo_iE_Extensions__item__id,
        ____TNLConfigurationInfo_iE_Extensions__item__criticality_tab,
        ___TNLConfigurationInfo_iE_Extensions__item__criticality,
        ____TNLConfigurationInfo_iE_Extensions__item__extensionValue_tab,
        ___TNLConfigurationInfo_iE_Extensions__item__extensionValue,
        __TNLConfigurationInfo_iE_Extensions__item_,
        _TNLConfigurationInfo_iE_Extensions,
        TNLConfigurationInfo,
        TNLConfigurationInfo_ExtIEs,
        _TraceActivation_eUTRANTraceID,
        _TraceActivation_interfacesToTrace,
        _TraceActivation_traceDepth,
        _TraceActivation_traceCollectionEntityIPAddress,
        ____TraceActivation_iE_Extensions__item__id_tab,
        _____TraceActivation_iE_Extensions__item__id_tab_val_Extension_0,
        _____TraceActivation_iE_Extensions__item__id_tab_val_Extension_1,
        _____TraceActivation_iE_Extensions__item__id_tab_val_Extension_2,
        _____TraceActivation_iE_Extensions__item__id_tab_val_Extension_3,
        ___TraceActivation_iE_Extensions__item__id,
        ___TraceActivation_iE_Extensions__item__criticality,
        ___TraceActivation_iE_Extensions__item__extensionValue,
        __TraceActivation_iE_Extensions__item_,
        _TraceActivation_iE_Extensions,
        TraceActivation,
        TraceActivation_ExtIEs,
        _TraceActivation_ExtIEs_val_Extension_0,
        _TraceActivation_ExtIEs_val_Extension_1,
        _TraceActivation_ExtIEs_val_Extension_2,
        _TraceActivation_ExtIEs_val_Extension_3,
        TraceCollectionEntityIPAddress,
        TraceDepth,
        Transmission_Bandwidth,
        TransportLayerAddress,
        _TransportLayerAddressAndPort_endpointIPAddress,
        _TransportLayerAddressAndPort_portnumber,
        TransportLayerAddressAndPort,
        _TunnelInformation_transportLayerAddress,
        _TunnelInformation_uDP_Port_Number,
        ____TunnelInformation_iE_Extensions__item__id_tab,
        ___TunnelInformation_iE_Extensions__item__id,
        ____TunnelInformation_iE_Extensions__item__criticality_tab,
        ___TunnelInformation_iE_Extensions__item__criticality,
        ____TunnelInformation_iE_Extensions__item__extensionValue_tab,
        ___TunnelInformation_iE_Extensions__item__extensionValue,
        __TunnelInformation_iE_Extensions__item_,
        _TunnelInformation_iE_Extensions,
        TunnelInformation,
        Tunnel_Information_ExtIEs,
        TypeOfError,
        _UEAggregateMaximumBitRate_uEaggregateMaximumBitRateDownlink,
        _UEAggregateMaximumBitRate_uEaggregateMaximumBitRateUplink,
        ____UEAggregateMaximumBitRate_iE_Extensions__item__id_tab,
        _____UEAggregateMaximumBitRate_iE_Extensions__item__id_tab_val_Extension_0,
        _____UEAggregateMaximumBitRate_iE_Extensions__item__id_tab_val_Extension_1,
        ___UEAggregateMaximumBitRate_iE_Extensions__item__id,
        ___UEAggregateMaximumBitRate_iE_Extensions__item__criticality,
        ___UEAggregateMaximumBitRate_iE_Extensions__item__extensionValue,
        __UEAggregateMaximumBitRate_iE_Extensions__item_,
        _UEAggregateMaximumBitRate_iE_Extensions,
        UEAggregateMaximumBitRate,
        UEAggregate_MaximumBitrate_ExtIEs,
        _UEAggregate_MaximumBitrate_ExtIEs_val_Extension_0,
        _UEAggregate_MaximumBitrate_ExtIEs_val_Extension_1,
        _UEAppLayerMeasConfig_containerForAppLayerMeasConfig,
        _UEAppLayerMeasConfig_areaScopeOfQMC,
        ____UEAppLayerMeasConfig_iE_Extensions__item__id_tab,
        _____UEAppLayerMeasConfig_iE_Extensions__item__id_tab_val_Extension_0,
        ___UEAppLayerMeasConfig_iE_Extensions__item__id,
        ___UEAppLayerMeasConfig_iE_Extensions__item__criticality,
        ___UEAppLayerMeasConfig_iE_Extensions__item__extensionValue,
        __UEAppLayerMeasConfig_iE_Extensions__item_,
        _UEAppLayerMeasConfig_iE_Extensions,
        UEAppLayerMeasConfig,
        UEAppLayerMeasConfig_ExtIEs,
        _UEAppLayerMeasConfig_ExtIEs_val_Extension_0,
        UE_ContextKeptIndicator,
        UEID,
        _UE_HistoryInformation__item_,
        UE_HistoryInformation,
        UE_HistoryInformationFromTheUE,
        UE_S1AP_ID,
        UE_X2AP_ID,
        UE_X2AP_ID_Extension,
        UERadioCapability,
        UERadioCapabilityID,
        UE_RLF_Report_Container,
        UE_RLF_Report_Container_for_extended_bands,
        _UESecurityCapabilities_encryptionAlgorithms,
        _UESecurityCapabilities_integrityProtectionAlgorithms,
        ____UESecurityCapabilities_iE_Extensions__item__id_tab,
        ___UESecurityCapabilities_iE_Extensions__item__id,
        ____UESecurityCapabilities_iE_Extensions__item__criticality_tab,
        ___UESecurityCapabilities_iE_Extensions__item__criticality,
        ____UESecurityCapabilities_iE_Extensions__item__extensionValue_tab,
        ___UESecurityCapabilities_iE_Extensions__item__extensionValue,
        __UESecurityCapabilities_iE_Extensions__item_,
        _UESecurityCapabilities_iE_Extensions,
        UESecurityCapabilities,
        UESecurityCapabilities_ExtIEs,
        _UESidelinkAggregateMaximumBitRate_uESidelinkAggregateMaximumBitRate,
        ____UESidelinkAggregateMaximumBitRate_iE_Extensions__item__id_tab,
        ___UESidelinkAggregateMaximumBitRate_iE_Extensions__item__id,
        ____UESidelinkAggregateMaximumBitRate_iE_Extensions__item__criticality_tab,
        ___UESidelinkAggregateMaximumBitRate_iE_Extensions__item__criticality,
        ____UESidelinkAggregateMaximumBitRate_iE_Extensions__item__extensionValue_tab,
        ___UESidelinkAggregateMaximumBitRate_iE_Extensions__item__extensionValue,
        __UESidelinkAggregateMaximumBitRate_iE_Extensions__item_,
        _UESidelinkAggregateMaximumBitRate_iE_Extensions,
        UESidelinkAggregateMaximumBitRate,
        UE_Sidelink_Aggregate_MaximumBitRate_ExtIEs,
        _UEsToBeResetList__item_,
        UEsToBeResetList,
        _UEsToBeResetList_Item_meNB_ID,
        _UEsToBeResetList_Item_meNB_ID_ext,
        _UEsToBeResetList_Item_sgNB_ID,
        ____UEsToBeResetList_Item_iE_Extensions__item__id_tab,
        ___UEsToBeResetList_Item_iE_Extensions__item__id,
        ____UEsToBeResetList_Item_iE_Extensions__item__criticality_tab,
        ___UEsToBeResetList_Item_iE_Extensions__item__criticality,
        ____UEsToBeResetList_Item_iE_Extensions__item__extensionValue_tab,
        ___UEsToBeResetList_Item_iE_Extensions__item__extensionValue,
        __UEsToBeResetList_Item_iE_Extensions__item_,
        _UEsToBeResetList_Item_iE_Extensions,
        UEsToBeResetList_Item,
        UEsToBeResetList_Item_ExtIEs,
        _ULandDLSharing_uLResourcesULandDLSharing,
        _ULandDLSharing_dLResourcesULandDLSharing,
        ____ULandDLSharing_iE_Extensions__item__id_tab,
        ___ULandDLSharing_iE_Extensions__item__id,
        ____ULandDLSharing_iE_Extensions__item__criticality_tab,
        ___ULandDLSharing_iE_Extensions__item__criticality,
        ____ULandDLSharing_iE_Extensions__item__extensionValue_tab,
        ___ULandDLSharing_iE_Extensions__item__extensionValue,
        __ULandDLSharing_iE_Extensions__item_,
        _ULandDLSharing_iE_Extensions,
        ULandDLSharing,
        ULandDLSharing_ExtIEs,
        _ULConfiguration_uL_PDCP,
        ____ULConfiguration_iE_Extensions__item__id_tab,
        ___ULConfiguration_iE_Extensions__item__id,
        ____ULConfiguration_iE_Extensions__item__criticality_tab,
        ___ULConfiguration_iE_Extensions__item__criticality,
        ____ULConfiguration_iE_Extensions__item__extensionValue_tab,
        ___ULConfiguration_iE_Extensions__item__extensionValue,
        __ULConfiguration_iE_Extensions__item_,
        _ULConfiguration_iE_Extensions,
        ULConfiguration,
        ULConfiguration_ExtIEs,
        UL_UE_Configuration,
        UL_GBR_PRB_usage,
        UL_GBR_PRB_usage_for_MIMO,
        _UL_HighInterferenceIndicationInfo__item_,
        UL_HighInterferenceIndicationInfo,
        _UL_HighInterferenceIndicationInfo_Item_target_Cell_ID,
        _UL_HighInterferenceIndicationInfo_Item_ul_interferenceindication,
        ____UL_HighInterferenceIndicationInfo_Item_iE_Extensions__item__id_tab,
        ___UL_HighInterferenceIndicationInfo_Item_iE_Extensions__item__id,
        ____UL_HighInterferenceIndicationInfo_Item_iE_Extensions__item__criticality_tab,
        ___UL_HighInterferenceIndicationInfo_Item_iE_Extensions__item__criticality,
        ____UL_HighInterferenceIndicationInfo_Item_iE_Extensions__item__extensionValue_tab,
        ___UL_HighInterferenceIndicationInfo_Item_iE_Extensions__item__extensionValue,
        __UL_HighInterferenceIndicationInfo_Item_iE_Extensions__item_,
        _UL_HighInterferenceIndicationInfo_Item_iE_Extensions,
        UL_HighInterferenceIndicationInfo_Item,
        UL_HighInterferenceIndicationInfo_Item_ExtIEs,
        UL_HighInterferenceIndication,
        _UL_InterferenceOverloadIndication__item_,
        UL_InterferenceOverloadIndication,
        UL_InterferenceOverloadIndication_Item,
        UL_non_GBR_PRB_usage,
        UL_non_GBR_PRB_usage_for_MIMO,
        _ULOnlySharing_uLResourceBitmapULOnlySharing,
        ____ULOnlySharing_iE_Extensions__item__id_tab,
        ___ULOnlySharing_iE_Extensions__item__id,
        ____ULOnlySharing_iE_Extensions__item__criticality_tab,
        ___ULOnlySharing_iE_Extensions__item__criticality,
        ____ULOnlySharing_iE_Extensions__item__extensionValue_tab,
        ___ULOnlySharing_iE_Extensions__item__extensionValue,
        __ULOnlySharing_iE_Extensions__item_,
        _ULOnlySharing_iE_Extensions,
        ULOnlySharing,
        ULOnlySharing_ExtIEs,
        ULResourceBitmapULandDLSharing,
        _ULResourcesULandDLSharing_unchanged,
        _ULResourcesULandDLSharing_changed,
        ULResourcesULandDLSharing,
        UL_scheduling_PDCCH_CCE_usage,
        UL_Total_PRB_usage,
        UL_Total_PRB_usage_for_MIMO,
        UnlicensedSpectrumRestriction,
        URI_Address,
        _UsableABSInformation_fdd,
        _UsableABSInformation_tdd,
        UsableABSInformation,
        _UsableABSInformationFDD_usable_abs_pattern_info,
        ____UsableABSInformationFDD_iE_Extensions__item__id_tab,
        ___UsableABSInformationFDD_iE_Extensions__item__id,
        ____UsableABSInformationFDD_iE_Extensions__item__criticality_tab,
        ___UsableABSInformationFDD_iE_Extensions__item__criticality,
        ____UsableABSInformationFDD_iE_Extensions__item__extensionValue_tab,
        ___UsableABSInformationFDD_iE_Extensions__item__extensionValue,
        __UsableABSInformationFDD_iE_Extensions__item_,
        _UsableABSInformationFDD_iE_Extensions,
        UsableABSInformationFDD,
        UsableABSInformationFDD_ExtIEs,
        _UsableABSInformationTDD_usaable_abs_pattern_info,
        ____UsableABSInformationTDD_iE_Extensions__item__id_tab,
        ___UsableABSInformationTDD_iE_Extensions__item__id,
        ____UsableABSInformationTDD_iE_Extensions__item__criticality_tab,
        ___UsableABSInformationTDD_iE_Extensions__item__criticality,
        ____UsableABSInformationTDD_iE_Extensions__item__extensionValue_tab,
        ___UsableABSInformationTDD_iE_Extensions__item__extensionValue,
        __UsableABSInformationTDD_iE_Extensions__item_,
        _UsableABSInformationTDD_iE_Extensions,
        UsableABSInformationTDD,
        UsableABSInformationTDD_ExtIEs,
        UserPlaneTrafficActivityReport,
        _V2XServicesAuthorized_vehicleUE,
        _V2XServicesAuthorized_pedestrianUE,
        ____V2XServicesAuthorized_iE_Extensions__item__id_tab,
        ___V2XServicesAuthorized_iE_Extensions__item__id,
        ____V2XServicesAuthorized_iE_Extensions__item__criticality_tab,
        ___V2XServicesAuthorized_iE_Extensions__item__criticality,
        ____V2XServicesAuthorized_iE_Extensions__item__extensionValue_tab,
        ___V2XServicesAuthorized_iE_Extensions__item__extensionValue,
        __V2XServicesAuthorized_iE_Extensions__item_,
        _V2XServicesAuthorized_iE_Extensions,
        V2XServicesAuthorized,
        V2XServicesAuthorized_ExtIEs,
        VehicleUE,
        PedestrianUE,
        _WidebandCQI_widebandCQICodeword0,
        _WidebandCQI_widebandCQICodeword1,
        ____WidebandCQI_iE_Extensions__item__id_tab,
        ___WidebandCQI_iE_Extensions__item__id,
        ____WidebandCQI_iE_Extensions__item__criticality_tab,
        ___WidebandCQI_iE_Extensions__item__criticality,
        ____WidebandCQI_iE_Extensions__item__extensionValue_tab,
        ___WidebandCQI_iE_Extensions__item__extensionValue,
        __WidebandCQI_iE_Extensions__item_,
        _WidebandCQI_iE_Extensions,
        WidebandCQI,
        WidebandCQI_ExtIEs,
        _WidebandCQICodeword1_four_bitCQI,
        _WidebandCQICodeword1_three_bitSpatialDifferentialCQI,
        WidebandCQICodeword1,
        _WLANMeasurementConfiguration_wlanMeasConfig,
        _WLANMeasurementConfiguration_wlanMeasConfigNameList,
        _WLANMeasurementConfiguration_wlan_rssi,
        _WLANMeasurementConfiguration_wlan_rtt,
        ____WLANMeasurementConfiguration_iE_Extensions__item__id_tab,
        ___WLANMeasurementConfiguration_iE_Extensions__item__id,
        ____WLANMeasurementConfiguration_iE_Extensions__item__criticality_tab,
        ___WLANMeasurementConfiguration_iE_Extensions__item__criticality,
        ____WLANMeasurementConfiguration_iE_Extensions__item__extensionValue_tab,
        ___WLANMeasurementConfiguration_iE_Extensions__item__extensionValue,
        __WLANMeasurementConfiguration_iE_Extensions__item_,
        _WLANMeasurementConfiguration_iE_Extensions,
        WLANMeasurementConfiguration,
        WLANMeasurementConfiguration_ExtIEs,
        _WLANMeasConfigNameList__item_,
        WLANMeasConfigNameList,
        WLANMeasConfig,
        WLANName,
        _WTID_wTID_Type1,
        _WTID_wTID_Type2,
        WTID,
        _WTID_Type1_pLMN_Identity,
        _WTID_Type1_shortWTID,
        WTID_Type1,
        WTID_Long_Type2,
        WT_UE_XwAP_ID,
        X2BenefitValue,
    ]

class X2AP_PDU_Contents:

    _name_  = 'X2AP-PDU-Contents'
    _oid_   = [0, 4, 0, 0, 21, 3, 2, 1, 1]
    
    _obj_ = [
        'HandoverRequest',
        'HandoverRequest-IEs',
        'UE-ContextInformation',
        'UE-ContextInformation-ExtIEs',
        'E-RABs-ToBeSetup-List',
        'E-RABs-ToBeSetup-ItemIEs',
        'E-RABs-ToBeSetup-Item',
        'E-RABs-ToBeSetup-ItemExtIEs',
        'MobilityInformation',
        'SourceDLForwardingIPAddress',
        'UE-ContextReferenceAtSeNB',
        'UE-ContextReferenceAtSeNB-ItemExtIEs',
        'UE-ContextReferenceAtWT',
        'UE-ContextReferenceAtWT-ItemExtIEs',
        'UE-ContextReferenceAtSgNB',
        'UE-ContextReferenceAtSgNB-ItemExtIEs',
        'HandoverRequestAcknowledge',
        'HandoverRequestAcknowledge-IEs',
        'E-RABs-Admitted-List',
        'E-RABs-Admitted-ItemIEs',
        'E-RABs-Admitted-Item',
        'E-RABs-Admitted-Item-ExtIEs',
        'HandoverPreparationFailure',
        'HandoverPreparationFailure-IEs',
        'HandoverReport',
        'HandoverReport-IEs',
        'EarlyStatusTransfer',
        'EarlyStatusTransfer-IEs',
        'ProcedureStageChoice',
        'ProcedureStageChoice-ExtIEs',
        'FirstDLCount',
        'FirstDLCount-ExtIEs',
        'DLDiscarding',
        'DLDiscarding-ExtIEs',
        'SNStatusTransfer',
        'SNStatusTransfer-IEs',
        'E-RABs-SubjectToStatusTransfer-List',
        'E-RABs-SubjectToStatusTransfer-ItemIEs',
        'E-RABs-SubjectToStatusTransfer-Item',
        'E-RABs-SubjectToStatusTransfer-ItemExtIEs',
        'UEContextRelease',
        'UEContextRelease-IEs',
        'HandoverCancel',
        'HandoverCancel-IEs',
        'HandoverSuccess',
        'HandoverSuccess-IEs',
        'ConditionalHandoverCancel',
        'ConditionalHandoverCancel-IEs',
        'ErrorIndication',
        'ErrorIndication-IEs',
        'ResetRequest',
        'ResetRequest-IEs',
        'ResetResponse',
        'ResetResponse-IEs',
        'X2SetupRequest',
        'X2SetupRequest-IEs',
        'X2SetupResponse',
        'X2SetupResponse-IEs',
        'X2SetupFailure',
        'X2SetupFailure-IEs',
        'LoadInformation',
        'LoadInformation-IEs',
        'CellInformation-List',
        'CellInformation-ItemIEs',
        'CellInformation-Item',
        'CellInformation-Item-ExtIEs',
        'ENBConfigurationUpdate',
        'ENBConfigurationUpdate-IEs',
        'ServedCellsToModify',
        'ServedCellsToModify-Item',
        'ServedCellsToModify-Item-ExtIEs',
        'Old-ECGIs',
        'ENBConfigurationUpdateAcknowledge',
        'ENBConfigurationUpdateAcknowledge-IEs',
        'ENBConfigurationUpdateFailure',
        'ENBConfigurationUpdateFailure-IEs',
        'ResourceStatusRequest',
        'ResourceStatusRequest-IEs',
        'CellToReport-List',
        'CellToReport-ItemIEs',
        'CellToReport-Item',
        'CellToReport-Item-ExtIEs',
        'ReportingPeriodicity',
        'PartialSuccessIndicator',
        'ResourceStatusResponse',
        'ResourceStatusResponse-IEs',
        'MeasurementInitiationResult-List',
        'MeasurementInitiationResult-ItemIEs',
        'MeasurementInitiationResult-Item',
        'MeasurementInitiationResult-Item-ExtIEs',
        'MeasurementFailureCause-List',
        'MeasurementFailureCause-ItemIEs',
        'MeasurementFailureCause-Item',
        'MeasurementFailureCause-Item-ExtIEs',
        'ResourceStatusFailure',
        'ResourceStatusFailure-IEs',
        'CompleteFailureCauseInformation-List',
        'CompleteFailureCauseInformation-ItemIEs',
        'CompleteFailureCauseInformation-Item',
        'CompleteFailureCauseInformation-Item-ExtIEs',
        'ResourceStatusUpdate',
        'ResourceStatusUpdate-IEs',
        'CellMeasurementResult-List',
        'CellMeasurementResult-ItemIEs',
        'CellMeasurementResult-Item',
        'CellMeasurementResult-Item-ExtIEs',
        'PrivateMessage',
        'PrivateMessage-IEs',
        'MobilityChangeRequest',
        'MobilityChangeRequest-IEs',
        'MobilityChangeAcknowledge',
        'MobilityChangeAcknowledge-IEs',
        'MobilityChangeFailure',
        'MobilityChangeFailure-IEs',
        'RLFIndication',
        'RLFIndication-IEs',
        'CellActivationRequest',
        'CellActivationRequest-IEs',
        'ServedCellsToActivate',
        'ServedCellsToActivate-Item',
        'ServedCellsToActivate-Item-ExtIEs',
        'CellActivationResponse',
        'CellActivationResponse-IEs',
        'ActivatedCellList',
        'ActivatedCellList-Item',
        'ActivatedCellList-Item-ExtIEs',
        'CellActivationFailure',
        'CellActivationFailure-IEs',
        'X2Release',
        'X2Release-IEs',
        'X2APMessageTransfer',
        'X2APMessageTransfer-IEs',
        'RNL-Header',
        'RNL-Header-Item-ExtIEs',
        'X2AP-Message',
        'SeNBAdditionRequest',
        'SeNBAdditionRequest-IEs',
        'E-RABs-ToBeAdded-List',
        'E-RABs-ToBeAdded-ItemIEs',
        'E-RABs-ToBeAdded-Item',
        'E-RABs-ToBeAdded-Item-SCG-Bearer',
        'E-RABs-ToBeAdded-Item-SCG-BearerExtIEs',
        'E-RABs-ToBeAdded-Item-Split-Bearer',
        'E-RABs-ToBeAdded-Item-Split-BearerExtIEs',
        'SeNBAdditionRequestAcknowledge',
        'SeNBAdditionRequestAcknowledge-IEs',
        'E-RABs-Admitted-ToBeAdded-List',
        'E-RABs-Admitted-ToBeAdded-ItemIEs',
        'E-RABs-Admitted-ToBeAdded-Item',
        'E-RABs-Admitted-ToBeAdded-Item-SCG-Bearer',
        'E-RABs-Admitted-ToBeAdded-Item-SCG-BearerExtIEs',
        'E-RABs-Admitted-ToBeAdded-Item-Split-Bearer',
        'E-RABs-Admitted-ToBeAdded-Item-Split-BearerExtIEs',
        'SeNBAdditionRequestReject',
        'SeNBAdditionRequestReject-IEs',
        'SeNBReconfigurationComplete',
        'SeNBReconfigurationComplete-IEs',
        'ResponseInformationSeNBReconfComp',
        'ResponseInformationSeNBReconfComp-SuccessItem',
        'ResponseInformationSeNBReconfComp-SuccessItemExtIEs',
        'ResponseInformationSeNBReconfComp-RejectByMeNBItem',
        'ResponseInformationSeNBReconfComp-RejectByMeNBItemExtIEs',
        'SeNBModificationRequest',
        'SeNBModificationRequest-IEs',
        'UE-ContextInformationSeNBModReq',
        'UE-ContextInformationSeNBModReqExtIEs',
        'E-RABs-ToBeAdded-List-ModReq',
        'E-RABs-ToBeAdded-ModReqItemIEs',
        'E-RABs-ToBeAdded-ModReqItem',
        'E-RABs-ToBeAdded-ModReqItem-SCG-Bearer',
        'E-RABs-ToBeAdded-ModReqItem-SCG-BearerExtIEs',
        'E-RABs-ToBeAdded-ModReqItem-Split-Bearer',
        'E-RABs-ToBeAdded-ModReqItem-Split-BearerExtIEs',
        'E-RABs-ToBeModified-List-ModReq',
        'E-RABs-ToBeModified-ModReqItemIEs',
        'E-RABs-ToBeModified-ModReqItem',
        'E-RABs-ToBeModified-ModReqItem-SCG-Bearer',
        'E-RABs-ToBeModified-ModReqItem-SCG-BearerExtIEs',
        'E-RABs-ToBeModified-ModReqItem-Split-Bearer',
        'E-RABs-ToBeModified-ModReqItem-Split-BearerExtIEs',
        'E-RABs-ToBeReleased-List-ModReq',
        'E-RABs-ToBeReleased-ModReqItemIEs',
        'E-RABs-ToBeReleased-ModReqItem',
        'E-RABs-ToBeReleased-ModReqItem-SCG-Bearer',
        'E-RABs-ToBeReleased-ModReqItem-SCG-BearerExtIEs',
        'E-RABs-ToBeReleased-ModReqItem-Split-Bearer',
        'E-RABs-ToBeReleased-ModReqItem-Split-BearerExtIEs',
        'SeNBModificationRequestAcknowledge',
        'SeNBModificationRequestAcknowledge-IEs',
        'E-RABs-Admitted-ToBeAdded-ModAckList',
        'E-RABs-Admitted-ToBeAdded-ModAckItemIEs',
        'E-RABs-Admitted-ToBeAdded-ModAckItem',
        'E-RABs-Admitted-ToBeAdded-ModAckItem-SCG-Bearer',
        'E-RABs-Admitted-ToBeAdded-ModAckItem-SCG-BearerExtIEs',
        'E-RABs-Admitted-ToBeAdded-ModAckItem-Split-Bearer',
        'E-RABs-Admitted-ToBeAdded-ModAckItem-Split-BearerExtIEs',
        'E-RABs-Admitted-ToBeModified-ModAckList',
        'E-RABs-Admitted-ToBeModified-ModAckItemIEs',
        'E-RABs-Admitted-ToBeModified-ModAckItem',
        'E-RABs-Admitted-ToBeModified-ModAckItem-SCG-Bearer',
        'E-RABs-Admitted-ToBeModified-ModAckItem-SCG-BearerExtIEs',
        'E-RABs-Admitted-ToBeModified-ModAckItem-Split-Bearer',
        'E-RABs-Admitted-ToBeModified-ModAckItem-Split-BearerExtIEs',
        'E-RABs-Admitted-ToBeReleased-ModAckList',
        'E-RABs-Admitted-ToBeReleased-ModAckItemIEs',
        'E-RABs-Admitted-ToReleased-ModAckItem',
        'E-RABs-Admitted-ToBeReleased-ModAckItem-SCG-Bearer',
        'E-RABs-Admitted-ToBeReleased-ModAckItem-SCG-BearerExtIEs',
        'E-RABs-Admitted-ToBeReleased-ModAckItem-Split-Bearer',
        'E-RABs-Admitted-ToBeReleased-ModAckItem-Split-BearerExtIEs',
        'SeNBModificationRequestReject',
        'SeNBModificationRequestReject-IEs',
        'SeNBModificationRequired',
        'SeNBModificationRequired-IEs',
        'E-RABs-ToBeReleased-ModReqd',
        'E-RABs-ToBeReleased-ModReqdItemIEs',
        'E-RABs-ToBeReleased-ModReqdItem',
        'E-RABs-ToBeReleased-ModReqdItemExtIEs',
        'SeNBModificationConfirm',
        'SeNBModificationConfirm-IEs',
        'SeNBModificationRefuse',
        'SeNBModificationRefuse-IEs',
        'SeNBReleaseRequest',
        'SeNBReleaseRequest-IEs',
        'E-RABs-ToBeReleased-List-RelReq',
        'E-RABs-ToBeReleased-RelReqItemIEs',
        'E-RABs-ToBeReleased-RelReqItem',
        'E-RABs-ToBeReleased-RelReqItem-SCG-Bearer',
        'E-RABs-ToBeReleased-RelReqItem-SCG-BearerExtIEs',
        'E-RABs-ToBeReleased-RelReqItem-Split-Bearer',
        'E-RABs-ToBeReleased-RelReqItem-Split-BearerExtIEs',
        'SeNBReleaseRequired',
        'SeNBReleaseRequired-IEs',
        'SeNBReleaseConfirm',
        'SeNBReleaseConfirm-IEs',
        'E-RABs-ToBeReleased-List-RelConf',
        'E-RABs-ToBeReleased-RelConfItemIEs',
        'E-RABs-ToBeReleased-RelConfItem',
        'E-RABs-ToBeReleased-RelConfItem-SCG-Bearer',
        'E-RABs-ToBeReleased-RelConfItem-SCG-BearerExtIEs',
        'E-RABs-ToBeReleased-RelConfItem-Split-Bearer',
        'E-RABs-ToBeReleased-RelConfItem-Split-BearerExtIEs',
        'SeNBCounterCheckRequest',
        'SeNBCounterCheckRequest-IEs',
        'E-RABs-SubjectToCounterCheck-List',
        'E-RABs-SubjectToCounterCheckItemIEs',
        'E-RABs-SubjectToCounterCheckItem',
        'E-RABs-SubjectToCounterCheckItemExtIEs',
        'X2RemovalRequest',
        'X2RemovalRequest-IEs',
        'X2RemovalResponse',
        'X2RemovalResponse-IEs',
        'X2RemovalFailure',
        'X2RemovalFailure-IEs',
        'RetrieveUEContextRequest',
        'RetrieveUEContextRequest-IEs',
        'RetrieveUEContextResponse',
        'RetrieveUEContextResponse-IEs',
        'UE-ContextInformationRetrieve',
        'UE-ContextInformationRetrieve-ExtIEs',
        'E-RABs-ToBeSetup-ListRetrieve',
        'E-RABs-ToBeSetupRetrieve-ItemIEs',
        'E-RABs-ToBeSetupRetrieve-Item',
        'E-RABs-ToBeSetupRetrieve-ItemExtIEs',
        'RetrieveUEContextFailure',
        'RetrieveUEContextFailure-IEs',
        'SgNBAdditionRequest',
        'SgNBAdditionRequest-IEs',
        'E-RABs-ToBeAdded-SgNBAddReqList',
        'E-RABs-ToBeAdded-SgNBAddReq-ItemIEs',
        'E-RABs-ToBeAdded-SgNBAddReq-Item',
        'E-RABs-ToBeAdded-SgNBAddReq-ItemExtIEs',
        'E-RABs-ToBeAdded-SgNBAddReq-Item-SgNBPDCPpresent',
        'E-RABs-ToBeAdded-SgNBAddReq-Item-SgNBPDCPpresentExtIEs',
        'E-RABs-ToBeAdded-SgNBAddReq-Item-SgNBPDCPnotpresent',
        'E-RABs-ToBeAdded-SgNBAddReq-Item-SgNBPDCPnotpresentExtIEs',
        'SgNBAdditionRequestAcknowledge',
        'SgNBAdditionRequestAcknowledge-IEs',
        'E-RABs-Admitted-ToBeAdded-SgNBAddReqAckList',
        'E-RABs-Admitted-ToBeAdded-SgNBAddReqAck-ItemIEs',
        'E-RABs-Admitted-ToBeAdded-SgNBAddReqAck-Item',
        'E-RABs-ToBeAdded-SgNBAddReqAck-ItemExtIEs',
        'E-RABs-Admitted-ToBeAdded-SgNBAddReqAck-Item-SgNBPDCPpresent',
        'E-RABs-Admitted-ToBeAdded-SgNBAddReqAck-Item-SgNBPDCPpresentExtIEs',
        'E-RABs-Admitted-ToBeAdded-SgNBAddReqAck-Item-SgNBPDCPnotpresent',
        'E-RABs-Admitted-ToBeAdded-SgNBAddReqAck-Item-SgNBPDCPnotpresentExtIEs',
        'SgNBAdditionRequestReject',
        'SgNBAdditionRequestReject-IEs',
        'SgNBReconfigurationComplete',
        'SgNBReconfigurationComplete-IEs',
        'ResponseInformationSgNBReconfComp',
        'ResponseInformationSgNBReconfComp-SuccessItem',
        'ResponseInformationSgNBReconfComp-SuccessItemExtIEs',
        'ResponseInformationSgNBReconfComp-RejectByMeNBItem',
        'ResponseInformationSgNBReconfComp-RejectByMeNBItemExtIEs',
        'SgNBModificationRequest',
        'SgNBModificationRequest-IEs',
        'UE-ContextInformation-SgNBModReq',
        'UE-ContextInformationSgNBModReqExtIEs',
        'E-RABs-ToBeAdded-SgNBModReq-List',
        'E-RABs-ToBeAdded-SgNBModReq-ItemIEs',
        'E-RABs-ToBeAdded-SgNBModReq-Item',
        'E-RABs-ToBeAdded-SgNBModReq-ItemExtIEs',
        'E-RABs-ToBeAdded-SgNBModReq-Item-SgNBPDCPpresent',
        'E-RABs-ToBeAdded-SgNBModReq-Item-SgNBPDCPpresentExtIEs',
        'E-RABs-ToBeAdded-SgNBModReq-Item-SgNBPDCPnotpresent',
        'E-RABs-ToBeAdded-SgNBModReq-Item-SgNBPDCPnotpresentExtIEs',
        'E-RABs-ToBeModified-SgNBModReq-List',
        'E-RABs-ToBeModified-SgNBModReq-ItemIEs',
        'E-RABs-ToBeModified-SgNBModReq-Item',
        'E-RABs-ToBeModified-SgNBModReq-ItemExtIEs',
        'E-RABs-ToBeModified-SgNBModReq-Item-SgNBPDCPpresent',
        'E-RABs-ToBeModified-SgNBModReq-Item-SgNBPDCPpresentExtIEs',
        'E-RABs-ToBeModified-SgNBModReq-Item-SgNBPDCPnotpresent',
        'E-RABs-ToBeModified-SgNBModReq-Item-SgNBPDCPnotpresentExtIEs',
        'E-RABs-ToBeReleased-SgNBModReq-List',
        'E-RABs-ToBeReleased-SgNBModReq-ItemIEs',
        'E-RABs-ToBeReleased-SgNBModReq-Item',
        'E-RABs-ToBeReleased-SgNBModReq-ItemExtIEs',
        'E-RABs-ToBeReleased-SgNBModReq-Item-SgNBPDCPpresent',
        'E-RABs-ToBeReleased-SgNBModReq-Item-SgNBPDCPpresentExtIEs',
        'E-RABs-ToBeReleased-SgNBModReq-Item-SgNBPDCPnotpresent',
        'E-RABs-ToBeReleased-SgNBModReq-Item-SgNBPDCPnotpresentExtIEs',
        'SgNBModificationRequestAcknowledge',
        'SgNBModificationRequestAcknowledge-IEs',
        'E-RABs-Admitted-ToBeAdded-SgNBModAckList',
        'E-RABs-Admitted-ToBeAdded-SgNBModAck-ItemIEs',
        'E-RABs-Admitted-ToBeAdded-SgNBModAck-Item',
        'E-RABs-Admitted-ToBeAdded-SgNBModAck-ItemExtIEs',
        'E-RABs-Admitted-ToBeAdded-SgNBModAck-Item-SgNBPDCPpresent',
        'E-RABs-Admitted-ToBeAdded-SgNBModAck-Item-SgNBPDCPpresentExtIEs',
        'E-RABs-Admitted-ToBeAdded-SgNBModAck-Item-SgNBPDCPnotpresent',
        'E-RABs-Admitted-ToBeAdded-SgNBModAck-Item-SgNBPDCPnotpresentExtIEs',
        'E-RABs-Admitted-ToBeModified-SgNBModAckList',
        'E-RABs-Admitted-ToBeModified-SgNBModAck-ItemIEs',
        'E-RABs-Admitted-ToBeModified-SgNBModAck-Item',
        'E-RABs-ToBeAdded-SgNBModAck-ItemExtIEs',
        'E-RABs-Admitted-ToBeModified-SgNBModAck-Item-SgNBPDCPpresent',
        'E-RABs-Admitted-ToBeModified-SgNBModAck-Item-SgNBPDCPpresentExtIEs',
        'E-RABs-Admitted-ToBeModified-SgNBModAck-Item-SgNBPDCPnotpresent',
        'E-RABs-Admitted-ToBeModified-SgNBModAck-Item-SgNBPDCPnotpresentExtIEs',
        'E-RABs-Admitted-ToBeReleased-SgNBModAckList',
        'E-RABs-Admitted-ToBeReleased-SgNBModAck-ItemIEs',
        'E-RABs-Admitted-ToReleased-SgNBModAck-Item',
        'E-RABs-ToBeReleased-SgNBModAck-ItemExtIEs',
        'E-RABs-Admitted-ToBeReleased-SgNBModAck-Item-SgNBPDCPpresent',
        'E-RABs-Admitted-ToBeReleased-SgNBModAck-Item-SgNBPDCPpresentExtIEs',
        'E-RABs-Admitted-ToBeReleased-SgNBModAck-Item-SgNBPDCPnotpresent',
        'E-RABs-Admitted-ToBeReleased-SgNBModAck-Item-SgNBPDCPnotpresentExtIEs',
        'SgNBModificationRequestReject',
        'SgNBModificationRequestReject-IEs',
        'SgNBModificationRequired',
        'SgNBModificationRequired-IEs',
        'E-RABs-ToBeReleased-SgNBModReqdList',
        'E-RABs-ToBeReleased-SgNBModReqd-ItemIEs',
        'E-RABs-ToBeReleased-SgNBModReqd-Item',
        'E-RABs-ToBeReleased-SgNBModReqd-ItemExtIEs',
        'E-RABs-ToBeModified-SgNBModReqdList',
        'E-RABs-ToBeModified-SgNBModReqd-ItemIEs',
        'E-RABs-ToBeModified-SgNBModReqd-Item',
        'E-RABs-ToBeModified-SgNBModReqd-ItemExtIEs',
        'E-RABs-ToBeModified-SgNBModReqd-Item-SgNBPDCPpresent',
        'E-RABs-ToBeModified-SgNBModReqd-Item-SgNBPDCPpresentExtIEs',
        'E-RABs-ToBeModified-SgNBModReqd-Item-SgNBPDCPnotpresent',
        'E-RABs-ToBeModified-SgNBModReqd-Item-SgNBPDCPnotpresentExtIEs',
        'SgNBModificationConfirm',
        'SgNBModificationConfirm-IEs',
        'E-RABs-AdmittedToBeModified-SgNBModConfList',
        'E-RABs-AdmittedToBeModified-SgNBModConf-ItemIEs',
        'E-RABs-AdmittedToBeModified-SgNBModConf-Item',
        'E-RABs-AdmittedToBeModified-SgNBModConf-ItemExtIEs',
        'E-RABs-AdmittedToBeModified-SgNBModConf-Item-SgNBPDCPpresent',
        'E-RABs-AdmittedToBeModified-SgNBModConf-Item-SgNBPDCPpresentExtIEs',
        'E-RABs-AdmittedToBeModified-SgNBModConf-Item-SgNBPDCPnotpresent',
        'E-RABs-AdmittedToBeModified-SgNBModConf-Item-SgNBPDCPnotpresentExtIEs',
        'SgNBModificationRefuse',
        'SgNBModificationRefuse-IEs',
        'SgNBReleaseRequest',
        'SgNBReleaseRequest-IEs',
        'E-RABs-ToBeReleased-SgNBRelReqList',
        'E-RABs-ToBeReleased-SgNBRelReq-ItemIEs',
        'E-RABs-ToBeReleased-SgNBRelReq-Item',
        'E-RABs-ToBeReleased-SgNBRelReq-ItemExtIEs',
        'E-RABs-ToBeReleased-SgNBRelReq-Item-SgNBPDCPpresent',
        'E-RABs-ToBeReleased-SgNBRelReq-Item-SgNBPDCPpresentExtIEs',
        'E-RABs-ToBeReleased-SgNBRelReq-Item-SgNBPDCPnotpresent',
        'E-RABs-ToBeReleased-SgNBRelReq-Item-SgNBPDCPnotpresentExtIEs',
        'SgNBReleaseRequestAcknowledge',
        'SgNBReleaseRequestAcknowledge-IEs',
        'E-RABs-Admitted-ToBeReleased-SgNBRelReqAckList',
        'E-RABs-Admitted-ToBeReleased-SgNBRelReqAck-ItemIEs',
        'E-RABs-Admitted-ToBeReleased-SgNBRelReqAck-Item',
        'E-RABs-Admitted-ToBeReleased-SgNBRelReqAck-ItemExtIEs',
        'SgNBReleaseRequestReject',
        'SgNBReleaseRequestReject-IEs',
        'SgNBReleaseRequired',
        'SgNBReleaseRequired-IEs',
        'E-RABs-ToBeReleased-SgNBRelReqdList',
        'E-RABs-ToBeReleased-SgNBRelReqd-ItemIEs',
        'E-RABs-ToBeReleased-SgNBRelReqd-Item',
        'E-RABs-ToBeReleased-SgNBRelReqd-ItemExtIEs',
        'SgNBReleaseConfirm',
        'SgNBReleaseConfirm-IEs',
        'E-RABs-ToBeReleased-SgNBRelConfList',
        'E-RABs-ToBeReleased-SgNBRelConf-ItemIEs',
        'E-RABs-ToBeReleased-SgNBRelConf-Item',
        'E-RABs-ToBeReleased-SgNBRelConf-ItemExtIEs',
        'E-RABs-ToBeReleased-SgNBRelConf-Item-SgNBPDCPpresent',
        'E-RABs-ToBeReleased-SgNBRelConf-Item-SgNBPDCPpresentExtIEs',
        'E-RABs-ToBeReleased-SgNBRelConf-Item-SgNBPDCPnotpresent',
        'E-RABs-ToBeReleased-SgNBRelConf-Item-SgNBPDCPnotpresentExtIEs',
        'SgNBCounterCheckRequest',
        'SgNBCounterCheckRequest-IEs',
        'E-RABs-SubjectToSgNBCounterCheck-List',
        'E-RABs-SubjectToSgNBCounterCheck-ItemIEs',
        'E-RABs-SubjectToSgNBCounterCheck-Item',
        'E-RABs-SubjectToSgNBCounterCheck-ItemExtIEs',
        'SgNBChangeRequired',
        'SgNBChangeRequired-IEs',
        'AccessAndMobilityIndication',
        'AccessAndMobilityIndication-IEs',
        'SgNBChangeConfirm',
        'SgNBChangeConfirm-IEs',
        'E-RABs-ToBeReleased-SgNBChaConfList',
        'E-RABs-ToBeReleased-SgNBChaConf-ItemIEs',
        'E-RABs-ToBeReleased-SgNBChaConf-Item',
        'E-RABs-ToBeReleased-SgNBChaConf-ItemExtIEs',
        'E-RABs-ToBeReleased-SgNBChaConf-Item-SgNBPDCPpresent',
        'E-RABs-ToBeReleased-SgNBChaConf-Item-SgNBPDCPpresentExtIEs',
        'E-RABs-ToBeReleased-SgNBChaConf-Item-SgNBPDCPnotpresent',
        'E-RABs-ToBeReleased-SgNBChaConf-Item-SgNBPDCPnotpresentExtIEs',
        'RRCTransfer',
        'RRCTransfer-IEs',
        'SgNBChangeRefuse',
        'SgNBChangeRefuse-IEs',
        'ENDCX2SetupRequest',
        'ENDCX2SetupRequest-IEs',
        'InitiatingNodeType-EndcX2Setup',
        'ENB-ENDCX2SetupReqIEs',
        'ServedEUTRAcellsENDCX2ManagementList',
        'ServedEUTRAcellsENDCX2Management-ExtIEs',
        'En-gNB-ENDCX2SetupReqIEs',
        'ServedNRcellsENDCX2ManagementList',
        'En-gNBServedCells-ExtIEs',
        'ServedNRCell-Information',
        'ServedNRCell-Information-ExtIEs',
        'FDD-InfoServedNRCell-Information',
        'FDD-InfoServedNRCell-Information-ExtIEs',
        'TDD-InfoServedNRCell-Information',
        'TDD-InfoServedNRCell-Information-ExtIEs',
        'CellandCapacityAssistInfo',
        'CellandCapacityAssistInfo-ExtIEs',
        'CellAssistanceInformation',
        'Limited-list',
        'Limited-list-ExtIEs',
        'ENDCX2SetupResponse',
        'ENDCX2SetupResponse-IEs',
        'RespondingNodeType-EndcX2Setup',
        'ENB-ENDCX2SetupReqAckIEs',
        'En-gNB-ENDCX2SetupReqAckIEs',
        'ENDCX2SetupFailure',
        'ENDCX2SetupFailure-IEs',
        'ENDCConfigurationUpdate',
        'ENDCConfigurationUpdate-IEs',
        'InitiatingNodeType-EndcConfigUpdate',
        'ENB-ENDCConfigUpdateIEs',
        'ServedEUTRAcellsToModifyListENDCConfUpd',
        'ServedEUTRAcellsToModifyListENDCConfUpd-ExtIEs',
        'ServedEUTRAcellsToDeleteListENDCConfUpd',
        'En-gNB-ENDCConfigUpdateIEs',
        'ServedNRcellsToModifyENDCConfUpdList',
        'ServedNRCellsToModify-Item',
        'ServedNRCellsToModify-Item-ExtIEs',
        'ServedNRcellsToDeleteENDCConfUpdList',
        'ENDCConfigurationUpdateAcknowledge',
        'ENDCConfigurationUpdateAcknowledge-IEs',
        'RespondingNodeType-EndcConfigUpdate',
        'ENB-ENDCConfigUpdateAckIEs',
        'En-gNB-ENDCConfigUpdateAckIEs',
        'ENDCConfigurationUpdateFailure',
        'ENDCConfigurationUpdateFailure-IEs',
        'ENDCCellActivationRequest',
        'ENDCCellActivationRequest-IEs',
        'ServedNRCellsToActivate',
        'ServedNRCellsToActivate-Item',
        'ServedNRCellsToActivate-Item-ExtIEs',
        'ENDCCellActivationResponse',
        'ENDCCellActivationResponse-IEs',
        'ActivatedNRCellList',
        'ActivatedNRCellList-Item',
        'ActivatedNRCellList-Item-ExtIEs',
        'ENDCCellActivationFailure',
        'ENDCCellActivationFailure-IEs',
        'ENDCResourceStatusRequest',
        'ENDCResourceStatusRequest-IEs',
        'ReportingPeriodicity-ENDC',
        'CellToReport-NR-ENDC-List',
        'CellToReport-NR-ENDC-ItemIEs',
        'CellToReport-NR-ENDC-Item',
        'CellToReport-NR-ENDC-Item-ExtIEs',
        'CellToReport-E-UTRA-ENDC-List',
        'CellToReport-E-UTRA-ENDC-Item-IEs',
        'CellToReport-E-UTRA-ENDC-Item',
        'CellToReport-E-UTRA-ENDC-Item-ExtIEs',
        'SSBToReport-List',
        'SSBToReport-Item',
        'SSBToReport-Item-ExtIEs',
        'ENDCResourceStatusResponse',
        'ENDCResourceStatusResponse-IEs',
        'ENDCResourceStatusFailure',
        'ENDCResourceStatusFailure-IEs',
        'ENDCResourceStatusUpdate',
        'ENDCResourceStatusUpdate-IEs',
        'CellMeasurementResult-NR-ENDC-List',
        'CellMeasurementResult-NR-ENDC-ItemIEs',
        'CellMeasurementResult-NR-ENDC-Item',
        'CellMeasurementResult-NR-ENDC-Item-ExtIEs',
        'CellMeasurementResult-E-UTRA-ENDC-List',
        'CellMeasurementResult-E-UTRA-ENDC-ItemIEs',
        'CellMeasurementResult-E-UTRA-ENDC-Item',
        'CellMeasurementResult-E-UTRA-ENDC-Item-ExtIEs',
        'SecondaryRATDataUsageReport',
        'SecondaryRATDataUsageReport-IEs',
        'SgNBActivityNotification',
        'SgNBActivityNotification-IEs',
        'ENDCPartialResetRequired',
        'ENDCPartialResetRequired-IEs',
        'ENDCPartialResetConfirm',
        'ENDCPartialResetConfirm-IEs',
        'EUTRANRCellResourceCoordinationRequest',
        'EUTRANRCellResourceCoordinationRequest-IEs',
        'InitiatingNodeType-EutranrCellResourceCoordination',
        'ENB-EUTRA-NRCellResourceCoordinationReqIEs',
        'En-gNB-EUTRA-NRCellResourceCoordinationReqIEs',
        'ListofEUTRACellsinEUTRACoordinationReq',
        'ListofEUTRACellsinNRCoordinationReq',
        'ListofNRCellsinNRCoordinationReq',
        'EUTRANRCellResourceCoordinationResponse',
        'EUTRANRCellResourceCoordinationResponse-IEs',
        'RespondingNodeType-EutranrCellResourceCoordination',
        'ENB-EUTRA-NRCellResourceCoordinationReqAckIEs',
        'En-gNB-EUTRA-NRCellResourceCoordinationReqAckIEs',
        'ListofEUTRACellsinEUTRACoordinationResp',
        'ListofNRCellsinNRCoordinationResp',
        'ENDCX2RemovalRequest',
        'ENDCX2RemovalRequest-IEs',
        'InitiatingNodeType-EndcX2Removal',
        'ENB-ENDCX2RemovalReqIEs',
        'En-gNB-ENDCX2RemovalReqIEs',
        'ENDCX2RemovalResponse',
        'ENDCX2RemovalResponse-IEs',
        'RespondingNodeType-EndcX2Removal',
        'ENB-ENDCX2RemovalReqAckIEs',
        'En-gNB-ENDCX2RemovalReqAckIEs',
        'ENDCX2RemovalFailure',
        'ENDCX2RemovalFailure-IEs',
        'DataForwardingAddressIndication',
        'DataForwardingAddressIndication-IEs',
        'E-RABs-DataForwardingAddress-List',
        'E-RABs-DataForwardingAddress-ItemIEs',
        'E-RABs-DataForwardingAddress-Item',
        'E-RABs-DataForwardingAddress-ItemExtIEs',
        'GNBStatusIndication',
        'GNBStatusIndicationIEs',
        'ENDCConfigurationTransfer',
        'ENDCConfigurationTransfer-IEs',
        'TraceStart',
        'TraceStartIEs',
        'DeactivateTrace',
        'DeactivateTraceIEs',
        'CellTrafficTrace',
        'CellTrafficTraceIEs',
        'F1CTrafficTransfer',
        'F1CTrafficTransfer-IEs',
        'UERadioCapabilityIDMappingRequest',
        'UERadioCapabilityIDMappingRequestIEs',
        'UERadioCapabilityIDMappingResponse',
        'UERadioCapabilityIDMappingResponseIEs',
        'CPC-cancel',
        'CPC-cancel-IEs',
        ]
    _type_ = [
        'HandoverRequest',
        'UE-ContextInformation',
        'E-RABs-ToBeSetup-List',
        'E-RABs-ToBeSetup-Item',
        'MobilityInformation',
        'SourceDLForwardingIPAddress',
        'UE-ContextReferenceAtSeNB',
        'UE-ContextReferenceAtWT',
        'UE-ContextReferenceAtSgNB',
        'HandoverRequestAcknowledge',
        'E-RABs-Admitted-List',
        'E-RABs-Admitted-Item',
        'HandoverPreparationFailure',
        'HandoverReport',
        'EarlyStatusTransfer',
        'ProcedureStageChoice',
        'FirstDLCount',
        'DLDiscarding',
        'SNStatusTransfer',
        'E-RABs-SubjectToStatusTransfer-List',
        'E-RABs-SubjectToStatusTransfer-Item',
        'UEContextRelease',
        'HandoverCancel',
        'HandoverSuccess',
        'ConditionalHandoverCancel',
        'ErrorIndication',
        'ResetRequest',
        'ResetResponse',
        'X2SetupRequest',
        'X2SetupResponse',
        'X2SetupFailure',
        'LoadInformation',
        'CellInformation-List',
        'CellInformation-Item',
        'ENBConfigurationUpdate',
        'ServedCellsToModify',
        'ServedCellsToModify-Item',
        'Old-ECGIs',
        'ENBConfigurationUpdateAcknowledge',
        'ENBConfigurationUpdateFailure',
        'ResourceStatusRequest',
        'CellToReport-List',
        'CellToReport-Item',
        'ReportingPeriodicity',
        'PartialSuccessIndicator',
        'ResourceStatusResponse',
        'MeasurementInitiationResult-List',
        'MeasurementInitiationResult-Item',
        'MeasurementFailureCause-List',
        'MeasurementFailureCause-Item',
        'ResourceStatusFailure',
        'CompleteFailureCauseInformation-List',
        'CompleteFailureCauseInformation-Item',
        'ResourceStatusUpdate',
        'CellMeasurementResult-List',
        'CellMeasurementResult-Item',
        'PrivateMessage',
        'MobilityChangeRequest',
        'MobilityChangeAcknowledge',
        'MobilityChangeFailure',
        'RLFIndication',
        'CellActivationRequest',
        'ServedCellsToActivate',
        'ServedCellsToActivate-Item',
        'CellActivationResponse',
        'ActivatedCellList',
        'ActivatedCellList-Item',
        'CellActivationFailure',
        'X2Release',
        'X2APMessageTransfer',
        'RNL-Header',
        'X2AP-Message',
        'SeNBAdditionRequest',
        'E-RABs-ToBeAdded-List',
        'E-RABs-ToBeAdded-Item',
        'E-RABs-ToBeAdded-Item-SCG-Bearer',
        'E-RABs-ToBeAdded-Item-Split-Bearer',
        'SeNBAdditionRequestAcknowledge',
        'E-RABs-Admitted-ToBeAdded-List',
        'E-RABs-Admitted-ToBeAdded-Item',
        'E-RABs-Admitted-ToBeAdded-Item-SCG-Bearer',
        'E-RABs-Admitted-ToBeAdded-Item-Split-Bearer',
        'SeNBAdditionRequestReject',
        'SeNBReconfigurationComplete',
        'ResponseInformationSeNBReconfComp',
        'ResponseInformationSeNBReconfComp-SuccessItem',
        'ResponseInformationSeNBReconfComp-RejectByMeNBItem',
        'SeNBModificationRequest',
        'UE-ContextInformationSeNBModReq',
        'E-RABs-ToBeAdded-List-ModReq',
        'E-RABs-ToBeAdded-ModReqItem',
        'E-RABs-ToBeAdded-ModReqItem-SCG-Bearer',
        'E-RABs-ToBeAdded-ModReqItem-Split-Bearer',
        'E-RABs-ToBeModified-List-ModReq',
        'E-RABs-ToBeModified-ModReqItem',
        'E-RABs-ToBeModified-ModReqItem-SCG-Bearer',
        'E-RABs-ToBeModified-ModReqItem-Split-Bearer',
        'E-RABs-ToBeReleased-List-ModReq',
        'E-RABs-ToBeReleased-ModReqItem',
        'E-RABs-ToBeReleased-ModReqItem-SCG-Bearer',
        'E-RABs-ToBeReleased-ModReqItem-Split-Bearer',
        'SeNBModificationRequestAcknowledge',
        'E-RABs-Admitted-ToBeAdded-ModAckList',
        'E-RABs-Admitted-ToBeAdded-ModAckItem',
        'E-RABs-Admitted-ToBeAdded-ModAckItem-SCG-Bearer',
        'E-RABs-Admitted-ToBeAdded-ModAckItem-Split-Bearer',
        'E-RABs-Admitted-ToBeModified-ModAckList',
        'E-RABs-Admitted-ToBeModified-ModAckItem',
        'E-RABs-Admitted-ToBeModified-ModAckItem-SCG-Bearer',
        'E-RABs-Admitted-ToBeModified-ModAckItem-Split-Bearer',
        'E-RABs-Admitted-ToBeReleased-ModAckList',
        'E-RABs-Admitted-ToReleased-ModAckItem',
        'E-RABs-Admitted-ToBeReleased-ModAckItem-SCG-Bearer',
        'E-RABs-Admitted-ToBeReleased-ModAckItem-Split-Bearer',
        'SeNBModificationRequestReject',
        'SeNBModificationRequired',
        'E-RABs-ToBeReleased-ModReqd',
        'E-RABs-ToBeReleased-ModReqdItem',
        'SeNBModificationConfirm',
        'SeNBModificationRefuse',
        'SeNBReleaseRequest',
        'E-RABs-ToBeReleased-List-RelReq',
        'E-RABs-ToBeReleased-RelReqItem',
        'E-RABs-ToBeReleased-RelReqItem-SCG-Bearer',
        'E-RABs-ToBeReleased-RelReqItem-Split-Bearer',
        'SeNBReleaseRequired',
        'SeNBReleaseConfirm',
        'E-RABs-ToBeReleased-List-RelConf',
        'E-RABs-ToBeReleased-RelConfItem',
        'E-RABs-ToBeReleased-RelConfItem-SCG-Bearer',
        'E-RABs-ToBeReleased-RelConfItem-Split-Bearer',
        'SeNBCounterCheckRequest',
        'E-RABs-SubjectToCounterCheck-List',
        'E-RABs-SubjectToCounterCheckItem',
        'X2RemovalRequest',
        'X2RemovalResponse',
        'X2RemovalFailure',
        'RetrieveUEContextRequest',
        'RetrieveUEContextResponse',
        'UE-ContextInformationRetrieve',
        'E-RABs-ToBeSetup-ListRetrieve',
        'E-RABs-ToBeSetupRetrieve-Item',
        'RetrieveUEContextFailure',
        'SgNBAdditionRequest',
        'E-RABs-ToBeAdded-SgNBAddReqList',
        'E-RABs-ToBeAdded-SgNBAddReq-Item',
        'E-RABs-ToBeAdded-SgNBAddReq-Item-SgNBPDCPpresent',
        'E-RABs-ToBeAdded-SgNBAddReq-Item-SgNBPDCPnotpresent',
        'SgNBAdditionRequestAcknowledge',
        'E-RABs-Admitted-ToBeAdded-SgNBAddReqAckList',
        'E-RABs-Admitted-ToBeAdded-SgNBAddReqAck-Item',
        'E-RABs-Admitted-ToBeAdded-SgNBAddReqAck-Item-SgNBPDCPpresent',
        'E-RABs-Admitted-ToBeAdded-SgNBAddReqAck-Item-SgNBPDCPnotpresent',
        'SgNBAdditionRequestReject',
        'SgNBReconfigurationComplete',
        'ResponseInformationSgNBReconfComp',
        'ResponseInformationSgNBReconfComp-SuccessItem',
        'ResponseInformationSgNBReconfComp-RejectByMeNBItem',
        'SgNBModificationRequest',
        'UE-ContextInformation-SgNBModReq',
        'E-RABs-ToBeAdded-SgNBModReq-List',
        'E-RABs-ToBeAdded-SgNBModReq-Item',
        'E-RABs-ToBeAdded-SgNBModReq-Item-SgNBPDCPpresent',
        'E-RABs-ToBeAdded-SgNBModReq-Item-SgNBPDCPnotpresent',
        'E-RABs-ToBeModified-SgNBModReq-List',
        'E-RABs-ToBeModified-SgNBModReq-Item',
        'E-RABs-ToBeModified-SgNBModReq-Item-SgNBPDCPpresent',
        'E-RABs-ToBeModified-SgNBModReq-Item-SgNBPDCPnotpresent',
        'E-RABs-ToBeReleased-SgNBModReq-List',
        'E-RABs-ToBeReleased-SgNBModReq-Item',
        'E-RABs-ToBeReleased-SgNBModReq-Item-SgNBPDCPpresent',
        'E-RABs-ToBeReleased-SgNBModReq-Item-SgNBPDCPnotpresent',
        'SgNBModificationRequestAcknowledge',
        'E-RABs-Admitted-ToBeAdded-SgNBModAckList',
        'E-RABs-Admitted-ToBeAdded-SgNBModAck-Item',
        'E-RABs-Admitted-ToBeAdded-SgNBModAck-Item-SgNBPDCPpresent',
        'E-RABs-Admitted-ToBeAdded-SgNBModAck-Item-SgNBPDCPnotpresent',
        'E-RABs-Admitted-ToBeModified-SgNBModAckList',
        'E-RABs-Admitted-ToBeModified-SgNBModAck-Item',
        'E-RABs-Admitted-ToBeModified-SgNBModAck-Item-SgNBPDCPpresent',
        'E-RABs-Admitted-ToBeModified-SgNBModAck-Item-SgNBPDCPnotpresent',
        'E-RABs-Admitted-ToBeReleased-SgNBModAckList',
        'E-RABs-Admitted-ToReleased-SgNBModAck-Item',
        'E-RABs-Admitted-ToBeReleased-SgNBModAck-Item-SgNBPDCPpresent',
        'E-RABs-Admitted-ToBeReleased-SgNBModAck-Item-SgNBPDCPnotpresent',
        'SgNBModificationRequestReject',
        'SgNBModificationRequired',
        'E-RABs-ToBeReleased-SgNBModReqdList',
        'E-RABs-ToBeReleased-SgNBModReqd-Item',
        'E-RABs-ToBeModified-SgNBModReqdList',
        'E-RABs-ToBeModified-SgNBModReqd-Item',
        'E-RABs-ToBeModified-SgNBModReqd-Item-SgNBPDCPpresent',
        'E-RABs-ToBeModified-SgNBModReqd-Item-SgNBPDCPnotpresent',
        'SgNBModificationConfirm',
        'E-RABs-AdmittedToBeModified-SgNBModConfList',
        'E-RABs-AdmittedToBeModified-SgNBModConf-Item',
        'E-RABs-AdmittedToBeModified-SgNBModConf-Item-SgNBPDCPpresent',
        'E-RABs-AdmittedToBeModified-SgNBModConf-Item-SgNBPDCPnotpresent',
        'SgNBModificationRefuse',
        'SgNBReleaseRequest',
        'E-RABs-ToBeReleased-SgNBRelReqList',
        'E-RABs-ToBeReleased-SgNBRelReq-Item',
        'E-RABs-ToBeReleased-SgNBRelReq-Item-SgNBPDCPpresent',
        'E-RABs-ToBeReleased-SgNBRelReq-Item-SgNBPDCPnotpresent',
        'SgNBReleaseRequestAcknowledge',
        'E-RABs-Admitted-ToBeReleased-SgNBRelReqAckList',
        'E-RABs-Admitted-ToBeReleased-SgNBRelReqAck-Item',
        'SgNBReleaseRequestReject',
        'SgNBReleaseRequired',
        'E-RABs-ToBeReleased-SgNBRelReqdList',
        'E-RABs-ToBeReleased-SgNBRelReqd-Item',
        'SgNBReleaseConfirm',
        'E-RABs-ToBeReleased-SgNBRelConfList',
        'E-RABs-ToBeReleased-SgNBRelConf-Item',
        'E-RABs-ToBeReleased-SgNBRelConf-Item-SgNBPDCPpresent',
        'E-RABs-ToBeReleased-SgNBRelConf-Item-SgNBPDCPnotpresent',
        'SgNBCounterCheckRequest',
        'E-RABs-SubjectToSgNBCounterCheck-List',
        'E-RABs-SubjectToSgNBCounterCheck-Item',
        'SgNBChangeRequired',
        'AccessAndMobilityIndication',
        'SgNBChangeConfirm',
        'E-RABs-ToBeReleased-SgNBChaConfList',
        'E-RABs-ToBeReleased-SgNBChaConf-Item',
        'E-RABs-ToBeReleased-SgNBChaConf-Item-SgNBPDCPpresent',
        'E-RABs-ToBeReleased-SgNBChaConf-Item-SgNBPDCPnotpresent',
        'RRCTransfer',
        'SgNBChangeRefuse',
        'ENDCX2SetupRequest',
        'InitiatingNodeType-EndcX2Setup',
        'ServedEUTRAcellsENDCX2ManagementList',
        'ServedNRcellsENDCX2ManagementList',
        'ServedNRCell-Information',
        'FDD-InfoServedNRCell-Information',
        'TDD-InfoServedNRCell-Information',
        'CellandCapacityAssistInfo',
        'CellAssistanceInformation',
        'Limited-list',
        'ENDCX2SetupResponse',
        'RespondingNodeType-EndcX2Setup',
        'ENDCX2SetupFailure',
        'ENDCConfigurationUpdate',
        'InitiatingNodeType-EndcConfigUpdate',
        'ServedEUTRAcellsToModifyListENDCConfUpd',
        'ServedEUTRAcellsToDeleteListENDCConfUpd',
        'ServedNRcellsToModifyENDCConfUpdList',
        'ServedNRCellsToModify-Item',
        'ServedNRcellsToDeleteENDCConfUpdList',
        'ENDCConfigurationUpdateAcknowledge',
        'RespondingNodeType-EndcConfigUpdate',
        'ENDCConfigurationUpdateFailure',
        'ENDCCellActivationRequest',
        'ServedNRCellsToActivate',
        'ServedNRCellsToActivate-Item',
        'ENDCCellActivationResponse',
        'ActivatedNRCellList',
        'ActivatedNRCellList-Item',
        'ENDCCellActivationFailure',
        'ENDCResourceStatusRequest',
        'ReportingPeriodicity-ENDC',
        'CellToReport-NR-ENDC-List',
        'CellToReport-NR-ENDC-Item',
        'CellToReport-E-UTRA-ENDC-List',
        'CellToReport-E-UTRA-ENDC-Item',
        'SSBToReport-List',
        'SSBToReport-Item',
        'ENDCResourceStatusResponse',
        'ENDCResourceStatusFailure',
        'ENDCResourceStatusUpdate',
        'CellMeasurementResult-NR-ENDC-List',
        'CellMeasurementResult-NR-ENDC-Item',
        'CellMeasurementResult-E-UTRA-ENDC-List',
        'CellMeasurementResult-E-UTRA-ENDC-Item',
        'SecondaryRATDataUsageReport',
        'SgNBActivityNotification',
        'ENDCPartialResetRequired',
        'ENDCPartialResetConfirm',
        'EUTRANRCellResourceCoordinationRequest',
        'InitiatingNodeType-EutranrCellResourceCoordination',
        'ListofEUTRACellsinEUTRACoordinationReq',
        'ListofEUTRACellsinNRCoordinationReq',
        'ListofNRCellsinNRCoordinationReq',
        'EUTRANRCellResourceCoordinationResponse',
        'RespondingNodeType-EutranrCellResourceCoordination',
        'ListofEUTRACellsinEUTRACoordinationResp',
        'ListofNRCellsinNRCoordinationResp',
        'ENDCX2RemovalRequest',
        'InitiatingNodeType-EndcX2Removal',
        'ENDCX2RemovalResponse',
        'RespondingNodeType-EndcX2Removal',
        'ENDCX2RemovalFailure',
        'DataForwardingAddressIndication',
        'E-RABs-DataForwardingAddress-List',
        'E-RABs-DataForwardingAddress-Item',
        'GNBStatusIndication',
        'ENDCConfigurationTransfer',
        'TraceStart',
        'DeactivateTrace',
        'CellTrafficTrace',
        'F1CTrafficTransfer',
        'UERadioCapabilityIDMappingRequest',
        'UERadioCapabilityIDMappingResponse',
        'CPC-cancel',
        ]
    _set_ = [
        'HandoverRequest-IEs',
        'UE-ContextInformation-ExtIEs',
        'E-RABs-ToBeSetup-ItemIEs',
        'E-RABs-ToBeSetup-ItemExtIEs',
        'UE-ContextReferenceAtSeNB-ItemExtIEs',
        'UE-ContextReferenceAtWT-ItemExtIEs',
        'UE-ContextReferenceAtSgNB-ItemExtIEs',
        'HandoverRequestAcknowledge-IEs',
        'E-RABs-Admitted-ItemIEs',
        'E-RABs-Admitted-Item-ExtIEs',
        'HandoverPreparationFailure-IEs',
        'HandoverReport-IEs',
        'EarlyStatusTransfer-IEs',
        'ProcedureStageChoice-ExtIEs',
        'FirstDLCount-ExtIEs',
        'DLDiscarding-ExtIEs',
        'SNStatusTransfer-IEs',
        'E-RABs-SubjectToStatusTransfer-ItemIEs',
        'E-RABs-SubjectToStatusTransfer-ItemExtIEs',
        'UEContextRelease-IEs',
        'HandoverCancel-IEs',
        'HandoverSuccess-IEs',
        'ConditionalHandoverCancel-IEs',
        'ErrorIndication-IEs',
        'ResetRequest-IEs',
        'ResetResponse-IEs',
        'X2SetupRequest-IEs',
        'X2SetupResponse-IEs',
        'X2SetupFailure-IEs',
        'LoadInformation-IEs',
        'CellInformation-ItemIEs',
        'CellInformation-Item-ExtIEs',
        'ENBConfigurationUpdate-IEs',
        'ServedCellsToModify-Item-ExtIEs',
        'ENBConfigurationUpdateAcknowledge-IEs',
        'ENBConfigurationUpdateFailure-IEs',
        'ResourceStatusRequest-IEs',
        'CellToReport-ItemIEs',
        'CellToReport-Item-ExtIEs',
        'ResourceStatusResponse-IEs',
        'MeasurementInitiationResult-ItemIEs',
        'MeasurementInitiationResult-Item-ExtIEs',
        'MeasurementFailureCause-ItemIEs',
        'MeasurementFailureCause-Item-ExtIEs',
        'ResourceStatusFailure-IEs',
        'CompleteFailureCauseInformation-ItemIEs',
        'CompleteFailureCauseInformation-Item-ExtIEs',
        'ResourceStatusUpdate-IEs',
        'CellMeasurementResult-ItemIEs',
        'CellMeasurementResult-Item-ExtIEs',
        'PrivateMessage-IEs',
        'MobilityChangeRequest-IEs',
        'MobilityChangeAcknowledge-IEs',
        'MobilityChangeFailure-IEs',
        'RLFIndication-IEs',
        'CellActivationRequest-IEs',
        'ServedCellsToActivate-Item-ExtIEs',
        'CellActivationResponse-IEs',
        'ActivatedCellList-Item-ExtIEs',
        'CellActivationFailure-IEs',
        'X2Release-IEs',
        'X2APMessageTransfer-IEs',
        'RNL-Header-Item-ExtIEs',
        'SeNBAdditionRequest-IEs',
        'E-RABs-ToBeAdded-ItemIEs',
        'E-RABs-ToBeAdded-Item-SCG-BearerExtIEs',
        'E-RABs-ToBeAdded-Item-Split-BearerExtIEs',
        'SeNBAdditionRequestAcknowledge-IEs',
        'E-RABs-Admitted-ToBeAdded-ItemIEs',
        'E-RABs-Admitted-ToBeAdded-Item-SCG-BearerExtIEs',
        'E-RABs-Admitted-ToBeAdded-Item-Split-BearerExtIEs',
        'SeNBAdditionRequestReject-IEs',
        'SeNBReconfigurationComplete-IEs',
        'ResponseInformationSeNBReconfComp-SuccessItemExtIEs',
        'ResponseInformationSeNBReconfComp-RejectByMeNBItemExtIEs',
        'SeNBModificationRequest-IEs',
        'UE-ContextInformationSeNBModReqExtIEs',
        'E-RABs-ToBeAdded-ModReqItemIEs',
        'E-RABs-ToBeAdded-ModReqItem-SCG-BearerExtIEs',
        'E-RABs-ToBeAdded-ModReqItem-Split-BearerExtIEs',
        'E-RABs-ToBeModified-ModReqItemIEs',
        'E-RABs-ToBeModified-ModReqItem-SCG-BearerExtIEs',
        'E-RABs-ToBeModified-ModReqItem-Split-BearerExtIEs',
        'E-RABs-ToBeReleased-ModReqItemIEs',
        'E-RABs-ToBeReleased-ModReqItem-SCG-BearerExtIEs',
        'E-RABs-ToBeReleased-ModReqItem-Split-BearerExtIEs',
        'SeNBModificationRequestAcknowledge-IEs',
        'E-RABs-Admitted-ToBeAdded-ModAckItemIEs',
        'E-RABs-Admitted-ToBeAdded-ModAckItem-SCG-BearerExtIEs',
        'E-RABs-Admitted-ToBeAdded-ModAckItem-Split-BearerExtIEs',
        'E-RABs-Admitted-ToBeModified-ModAckItemIEs',
        'E-RABs-Admitted-ToBeModified-ModAckItem-SCG-BearerExtIEs',
        'E-RABs-Admitted-ToBeModified-ModAckItem-Split-BearerExtIEs',
        'E-RABs-Admitted-ToBeReleased-ModAckItemIEs',
        'E-RABs-Admitted-ToBeReleased-ModAckItem-SCG-BearerExtIEs',
        'E-RABs-Admitted-ToBeReleased-ModAckItem-Split-BearerExtIEs',
        'SeNBModificationRequestReject-IEs',
        'SeNBModificationRequired-IEs',
        'E-RABs-ToBeReleased-ModReqdItemIEs',
        'E-RABs-ToBeReleased-ModReqdItemExtIEs',
        'SeNBModificationConfirm-IEs',
        'SeNBModificationRefuse-IEs',
        'SeNBReleaseRequest-IEs',
        'E-RABs-ToBeReleased-RelReqItemIEs',
        'E-RABs-ToBeReleased-RelReqItem-SCG-BearerExtIEs',
        'E-RABs-ToBeReleased-RelReqItem-Split-BearerExtIEs',
        'SeNBReleaseRequired-IEs',
        'SeNBReleaseConfirm-IEs',
        'E-RABs-ToBeReleased-RelConfItemIEs',
        'E-RABs-ToBeReleased-RelConfItem-SCG-BearerExtIEs',
        'E-RABs-ToBeReleased-RelConfItem-Split-BearerExtIEs',
        'SeNBCounterCheckRequest-IEs',
        'E-RABs-SubjectToCounterCheckItemIEs',
        'E-RABs-SubjectToCounterCheckItemExtIEs',
        'X2RemovalRequest-IEs',
        'X2RemovalResponse-IEs',
        'X2RemovalFailure-IEs',
        'RetrieveUEContextRequest-IEs',
        'RetrieveUEContextResponse-IEs',
        'UE-ContextInformationRetrieve-ExtIEs',
        'E-RABs-ToBeSetupRetrieve-ItemIEs',
        'E-RABs-ToBeSetupRetrieve-ItemExtIEs',
        'RetrieveUEContextFailure-IEs',
        'SgNBAdditionRequest-IEs',
        'E-RABs-ToBeAdded-SgNBAddReq-ItemIEs',
        'E-RABs-ToBeAdded-SgNBAddReq-ItemExtIEs',
        'E-RABs-ToBeAdded-SgNBAddReq-Item-SgNBPDCPpresentExtIEs',
        'E-RABs-ToBeAdded-SgNBAddReq-Item-SgNBPDCPnotpresentExtIEs',
        'SgNBAdditionRequestAcknowledge-IEs',
        'E-RABs-Admitted-ToBeAdded-SgNBAddReqAck-ItemIEs',
        'E-RABs-ToBeAdded-SgNBAddReqAck-ItemExtIEs',
        'E-RABs-Admitted-ToBeAdded-SgNBAddReqAck-Item-SgNBPDCPpresentExtIEs',
        'E-RABs-Admitted-ToBeAdded-SgNBAddReqAck-Item-SgNBPDCPnotpresentExtIEs',
        'SgNBAdditionRequestReject-IEs',
        'SgNBReconfigurationComplete-IEs',
        'ResponseInformationSgNBReconfComp-SuccessItemExtIEs',
        'ResponseInformationSgNBReconfComp-RejectByMeNBItemExtIEs',
        'SgNBModificationRequest-IEs',
        'UE-ContextInformationSgNBModReqExtIEs',
        'E-RABs-ToBeAdded-SgNBModReq-ItemIEs',
        'E-RABs-ToBeAdded-SgNBModReq-ItemExtIEs',
        'E-RABs-ToBeAdded-SgNBModReq-Item-SgNBPDCPpresentExtIEs',
        'E-RABs-ToBeAdded-SgNBModReq-Item-SgNBPDCPnotpresentExtIEs',
        'E-RABs-ToBeModified-SgNBModReq-ItemIEs',
        'E-RABs-ToBeModified-SgNBModReq-ItemExtIEs',
        'E-RABs-ToBeModified-SgNBModReq-Item-SgNBPDCPpresentExtIEs',
        'E-RABs-ToBeModified-SgNBModReq-Item-SgNBPDCPnotpresentExtIEs',
        'E-RABs-ToBeReleased-SgNBModReq-ItemIEs',
        'E-RABs-ToBeReleased-SgNBModReq-ItemExtIEs',
        'E-RABs-ToBeReleased-SgNBModReq-Item-SgNBPDCPpresentExtIEs',
        'E-RABs-ToBeReleased-SgNBModReq-Item-SgNBPDCPnotpresentExtIEs',
        'SgNBModificationRequestAcknowledge-IEs',
        'E-RABs-Admitted-ToBeAdded-SgNBModAck-ItemIEs',
        'E-RABs-Admitted-ToBeAdded-SgNBModAck-ItemExtIEs',
        'E-RABs-Admitted-ToBeAdded-SgNBModAck-Item-SgNBPDCPpresentExtIEs',
        'E-RABs-Admitted-ToBeAdded-SgNBModAck-Item-SgNBPDCPnotpresentExtIEs',
        'E-RABs-Admitted-ToBeModified-SgNBModAck-ItemIEs',
        'E-RABs-ToBeAdded-SgNBModAck-ItemExtIEs',
        'E-RABs-Admitted-ToBeModified-SgNBModAck-Item-SgNBPDCPpresentExtIEs',
        'E-RABs-Admitted-ToBeModified-SgNBModAck-Item-SgNBPDCPnotpresentExtIEs',
        'E-RABs-Admitted-ToBeReleased-SgNBModAck-ItemIEs',
        'E-RABs-ToBeReleased-SgNBModAck-ItemExtIEs',
        'E-RABs-Admitted-ToBeReleased-SgNBModAck-Item-SgNBPDCPpresentExtIEs',
        'E-RABs-Admitted-ToBeReleased-SgNBModAck-Item-SgNBPDCPnotpresentExtIEs',
        'SgNBModificationRequestReject-IEs',
        'SgNBModificationRequired-IEs',
        'E-RABs-ToBeReleased-SgNBModReqd-ItemIEs',
        'E-RABs-ToBeReleased-SgNBModReqd-ItemExtIEs',
        'E-RABs-ToBeModified-SgNBModReqd-ItemIEs',
        'E-RABs-ToBeModified-SgNBModReqd-ItemExtIEs',
        'E-RABs-ToBeModified-SgNBModReqd-Item-SgNBPDCPpresentExtIEs',
        'E-RABs-ToBeModified-SgNBModReqd-Item-SgNBPDCPnotpresentExtIEs',
        'SgNBModificationConfirm-IEs',
        'E-RABs-AdmittedToBeModified-SgNBModConf-ItemIEs',
        'E-RABs-AdmittedToBeModified-SgNBModConf-ItemExtIEs',
        'E-RABs-AdmittedToBeModified-SgNBModConf-Item-SgNBPDCPpresentExtIEs',
        'E-RABs-AdmittedToBeModified-SgNBModConf-Item-SgNBPDCPnotpresentExtIEs',
        'SgNBModificationRefuse-IEs',
        'SgNBReleaseRequest-IEs',
        'E-RABs-ToBeReleased-SgNBRelReq-ItemIEs',
        'E-RABs-ToBeReleased-SgNBRelReq-ItemExtIEs',
        'E-RABs-ToBeReleased-SgNBRelReq-Item-SgNBPDCPpresentExtIEs',
        'E-RABs-ToBeReleased-SgNBRelReq-Item-SgNBPDCPnotpresentExtIEs',
        'SgNBReleaseRequestAcknowledge-IEs',
        'E-RABs-Admitted-ToBeReleased-SgNBRelReqAck-ItemIEs',
        'E-RABs-Admitted-ToBeReleased-SgNBRelReqAck-ItemExtIEs',
        'SgNBReleaseRequestReject-IEs',
        'SgNBReleaseRequired-IEs',
        'E-RABs-ToBeReleased-SgNBRelReqd-ItemIEs',
        'E-RABs-ToBeReleased-SgNBRelReqd-ItemExtIEs',
        'SgNBReleaseConfirm-IEs',
        'E-RABs-ToBeReleased-SgNBRelConf-ItemIEs',
        'E-RABs-ToBeReleased-SgNBRelConf-ItemExtIEs',
        'E-RABs-ToBeReleased-SgNBRelConf-Item-SgNBPDCPpresentExtIEs',
        'E-RABs-ToBeReleased-SgNBRelConf-Item-SgNBPDCPnotpresentExtIEs',
        'SgNBCounterCheckRequest-IEs',
        'E-RABs-SubjectToSgNBCounterCheck-ItemIEs',
        'E-RABs-SubjectToSgNBCounterCheck-ItemExtIEs',
        'SgNBChangeRequired-IEs',
        'AccessAndMobilityIndication-IEs',
        'SgNBChangeConfirm-IEs',
        'E-RABs-ToBeReleased-SgNBChaConf-ItemIEs',
        'E-RABs-ToBeReleased-SgNBChaConf-ItemExtIEs',
        'E-RABs-ToBeReleased-SgNBChaConf-Item-SgNBPDCPpresentExtIEs',
        'E-RABs-ToBeReleased-SgNBChaConf-Item-SgNBPDCPnotpresentExtIEs',
        'RRCTransfer-IEs',
        'SgNBChangeRefuse-IEs',
        'ENDCX2SetupRequest-IEs',
        'ENB-ENDCX2SetupReqIEs',
        'ServedEUTRAcellsENDCX2Management-ExtIEs',
        'En-gNB-ENDCX2SetupReqIEs',
        'En-gNBServedCells-ExtIEs',
        'ServedNRCell-Information-ExtIEs',
        'FDD-InfoServedNRCell-Information-ExtIEs',
        'TDD-InfoServedNRCell-Information-ExtIEs',
        'CellandCapacityAssistInfo-ExtIEs',
        'Limited-list-ExtIEs',
        'ENDCX2SetupResponse-IEs',
        'ENB-ENDCX2SetupReqAckIEs',
        'En-gNB-ENDCX2SetupReqAckIEs',
        'ENDCX2SetupFailure-IEs',
        'ENDCConfigurationUpdate-IEs',
        'ENB-ENDCConfigUpdateIEs',
        'ServedEUTRAcellsToModifyListENDCConfUpd-ExtIEs',
        'En-gNB-ENDCConfigUpdateIEs',
        'ServedNRCellsToModify-Item-ExtIEs',
        'ENDCConfigurationUpdateAcknowledge-IEs',
        'ENB-ENDCConfigUpdateAckIEs',
        'En-gNB-ENDCConfigUpdateAckIEs',
        'ENDCConfigurationUpdateFailure-IEs',
        'ENDCCellActivationRequest-IEs',
        'ServedNRCellsToActivate-Item-ExtIEs',
        'ENDCCellActivationResponse-IEs',
        'ActivatedNRCellList-Item-ExtIEs',
        'ENDCCellActivationFailure-IEs',
        'ENDCResourceStatusRequest-IEs',
        'CellToReport-NR-ENDC-ItemIEs',
        'CellToReport-NR-ENDC-Item-ExtIEs',
        'CellToReport-E-UTRA-ENDC-Item-IEs',
        'CellToReport-E-UTRA-ENDC-Item-ExtIEs',
        'SSBToReport-Item-ExtIEs',
        'ENDCResourceStatusResponse-IEs',
        'ENDCResourceStatusFailure-IEs',
        'ENDCResourceStatusUpdate-IEs',
        'CellMeasurementResult-NR-ENDC-ItemIEs',
        'CellMeasurementResult-NR-ENDC-Item-ExtIEs',
        'CellMeasurementResult-E-UTRA-ENDC-ItemIEs',
        'CellMeasurementResult-E-UTRA-ENDC-Item-ExtIEs',
        'SecondaryRATDataUsageReport-IEs',
        'SgNBActivityNotification-IEs',
        'ENDCPartialResetRequired-IEs',
        'ENDCPartialResetConfirm-IEs',
        'EUTRANRCellResourceCoordinationRequest-IEs',
        'ENB-EUTRA-NRCellResourceCoordinationReqIEs',
        'En-gNB-EUTRA-NRCellResourceCoordinationReqIEs',
        'EUTRANRCellResourceCoordinationResponse-IEs',
        'ENB-EUTRA-NRCellResourceCoordinationReqAckIEs',
        'En-gNB-EUTRA-NRCellResourceCoordinationReqAckIEs',
        'ENDCX2RemovalRequest-IEs',
        'ENB-ENDCX2RemovalReqIEs',
        'En-gNB-ENDCX2RemovalReqIEs',
        'ENDCX2RemovalResponse-IEs',
        'ENB-ENDCX2RemovalReqAckIEs',
        'En-gNB-ENDCX2RemovalReqAckIEs',
        'ENDCX2RemovalFailure-IEs',
        'DataForwardingAddressIndication-IEs',
        'E-RABs-DataForwardingAddress-ItemIEs',
        'E-RABs-DataForwardingAddress-ItemExtIEs',
        'GNBStatusIndicationIEs',
        'ENDCConfigurationTransfer-IEs',
        'TraceStartIEs',
        'DeactivateTraceIEs',
        'CellTrafficTraceIEs',
        'F1CTrafficTransfer-IEs',
        'UERadioCapabilityIDMappingRequestIEs',
        'UERadioCapabilityIDMappingResponseIEs',
        'CPC-cancel-IEs',
        ]
    _val_ = [
        ]
    _class_ = [
        'HandoverRequest-IEs',
        'UE-ContextInformation-ExtIEs',
        'E-RABs-ToBeSetup-ItemIEs',
        'E-RABs-ToBeSetup-ItemExtIEs',
        'UE-ContextReferenceAtSeNB-ItemExtIEs',
        'UE-ContextReferenceAtWT-ItemExtIEs',
        'UE-ContextReferenceAtSgNB-ItemExtIEs',
        'HandoverRequestAcknowledge-IEs',
        'E-RABs-Admitted-ItemIEs',
        'E-RABs-Admitted-Item-ExtIEs',
        'HandoverPreparationFailure-IEs',
        'HandoverReport-IEs',
        'EarlyStatusTransfer-IEs',
        'ProcedureStageChoice-ExtIEs',
        'FirstDLCount-ExtIEs',
        'DLDiscarding-ExtIEs',
        'SNStatusTransfer-IEs',
        'E-RABs-SubjectToStatusTransfer-ItemIEs',
        'E-RABs-SubjectToStatusTransfer-ItemExtIEs',
        'UEContextRelease-IEs',
        'HandoverCancel-IEs',
        'HandoverSuccess-IEs',
        'ConditionalHandoverCancel-IEs',
        'ErrorIndication-IEs',
        'ResetRequest-IEs',
        'ResetResponse-IEs',
        'X2SetupRequest-IEs',
        'X2SetupResponse-IEs',
        'X2SetupFailure-IEs',
        'LoadInformation-IEs',
        'CellInformation-ItemIEs',
        'CellInformation-Item-ExtIEs',
        'ENBConfigurationUpdate-IEs',
        'ServedCellsToModify-Item-ExtIEs',
        'ENBConfigurationUpdateAcknowledge-IEs',
        'ENBConfigurationUpdateFailure-IEs',
        'ResourceStatusRequest-IEs',
        'CellToReport-ItemIEs',
        'CellToReport-Item-ExtIEs',
        'ResourceStatusResponse-IEs',
        'MeasurementInitiationResult-ItemIEs',
        'MeasurementInitiationResult-Item-ExtIEs',
        'MeasurementFailureCause-ItemIEs',
        'MeasurementFailureCause-Item-ExtIEs',
        'ResourceStatusFailure-IEs',
        'CompleteFailureCauseInformation-ItemIEs',
        'CompleteFailureCauseInformation-Item-ExtIEs',
        'ResourceStatusUpdate-IEs',
        'CellMeasurementResult-ItemIEs',
        'CellMeasurementResult-Item-ExtIEs',
        'PrivateMessage-IEs',
        'MobilityChangeRequest-IEs',
        'MobilityChangeAcknowledge-IEs',
        'MobilityChangeFailure-IEs',
        'RLFIndication-IEs',
        'CellActivationRequest-IEs',
        'ServedCellsToActivate-Item-ExtIEs',
        'CellActivationResponse-IEs',
        'ActivatedCellList-Item-ExtIEs',
        'CellActivationFailure-IEs',
        'X2Release-IEs',
        'X2APMessageTransfer-IEs',
        'RNL-Header-Item-ExtIEs',
        'SeNBAdditionRequest-IEs',
        'E-RABs-ToBeAdded-ItemIEs',
        'E-RABs-ToBeAdded-Item-SCG-BearerExtIEs',
        'E-RABs-ToBeAdded-Item-Split-BearerExtIEs',
        'SeNBAdditionRequestAcknowledge-IEs',
        'E-RABs-Admitted-ToBeAdded-ItemIEs',
        'E-RABs-Admitted-ToBeAdded-Item-SCG-BearerExtIEs',
        'E-RABs-Admitted-ToBeAdded-Item-Split-BearerExtIEs',
        'SeNBAdditionRequestReject-IEs',
        'SeNBReconfigurationComplete-IEs',
        'ResponseInformationSeNBReconfComp-SuccessItemExtIEs',
        'ResponseInformationSeNBReconfComp-RejectByMeNBItemExtIEs',
        'SeNBModificationRequest-IEs',
        'UE-ContextInformationSeNBModReqExtIEs',
        'E-RABs-ToBeAdded-ModReqItemIEs',
        'E-RABs-ToBeAdded-ModReqItem-SCG-BearerExtIEs',
        'E-RABs-ToBeAdded-ModReqItem-Split-BearerExtIEs',
        'E-RABs-ToBeModified-ModReqItemIEs',
        'E-RABs-ToBeModified-ModReqItem-SCG-BearerExtIEs',
        'E-RABs-ToBeModified-ModReqItem-Split-BearerExtIEs',
        'E-RABs-ToBeReleased-ModReqItemIEs',
        'E-RABs-ToBeReleased-ModReqItem-SCG-BearerExtIEs',
        'E-RABs-ToBeReleased-ModReqItem-Split-BearerExtIEs',
        'SeNBModificationRequestAcknowledge-IEs',
        'E-RABs-Admitted-ToBeAdded-ModAckItemIEs',
        'E-RABs-Admitted-ToBeAdded-ModAckItem-SCG-BearerExtIEs',
        'E-RABs-Admitted-ToBeAdded-ModAckItem-Split-BearerExtIEs',
        'E-RABs-Admitted-ToBeModified-ModAckItemIEs',
        'E-RABs-Admitted-ToBeModified-ModAckItem-SCG-BearerExtIEs',
        'E-RABs-Admitted-ToBeModified-ModAckItem-Split-BearerExtIEs',
        'E-RABs-Admitted-ToBeReleased-ModAckItemIEs',
        'E-RABs-Admitted-ToBeReleased-ModAckItem-SCG-BearerExtIEs',
        'E-RABs-Admitted-ToBeReleased-ModAckItem-Split-BearerExtIEs',
        'SeNBModificationRequestReject-IEs',
        'SeNBModificationRequired-IEs',
        'E-RABs-ToBeReleased-ModReqdItemIEs',
        'E-RABs-ToBeReleased-ModReqdItemExtIEs',
        'SeNBModificationConfirm-IEs',
        'SeNBModificationRefuse-IEs',
        'SeNBReleaseRequest-IEs',
        'E-RABs-ToBeReleased-RelReqItemIEs',
        'E-RABs-ToBeReleased-RelReqItem-SCG-BearerExtIEs',
        'E-RABs-ToBeReleased-RelReqItem-Split-BearerExtIEs',
        'SeNBReleaseRequired-IEs',
        'SeNBReleaseConfirm-IEs',
        'E-RABs-ToBeReleased-RelConfItemIEs',
        'E-RABs-ToBeReleased-RelConfItem-SCG-BearerExtIEs',
        'E-RABs-ToBeReleased-RelConfItem-Split-BearerExtIEs',
        'SeNBCounterCheckRequest-IEs',
        'E-RABs-SubjectToCounterCheckItemIEs',
        'E-RABs-SubjectToCounterCheckItemExtIEs',
        'X2RemovalRequest-IEs',
        'X2RemovalResponse-IEs',
        'X2RemovalFailure-IEs',
        'RetrieveUEContextRequest-IEs',
        'RetrieveUEContextResponse-IEs',
        'UE-ContextInformationRetrieve-ExtIEs',
        'E-RABs-ToBeSetupRetrieve-ItemIEs',
        'E-RABs-ToBeSetupRetrieve-ItemExtIEs',
        'RetrieveUEContextFailure-IEs',
        'SgNBAdditionRequest-IEs',
        'E-RABs-ToBeAdded-SgNBAddReq-ItemIEs',
        'E-RABs-ToBeAdded-SgNBAddReq-ItemExtIEs',
        'E-RABs-ToBeAdded-SgNBAddReq-Item-SgNBPDCPpresentExtIEs',
        'E-RABs-ToBeAdded-SgNBAddReq-Item-SgNBPDCPnotpresentExtIEs',
        'SgNBAdditionRequestAcknowledge-IEs',
        'E-RABs-Admitted-ToBeAdded-SgNBAddReqAck-ItemIEs',
        'E-RABs-ToBeAdded-SgNBAddReqAck-ItemExtIEs',
        'E-RABs-Admitted-ToBeAdded-SgNBAddReqAck-Item-SgNBPDCPpresentExtIEs',
        'E-RABs-Admitted-ToBeAdded-SgNBAddReqAck-Item-SgNBPDCPnotpresentExtIEs',
        'SgNBAdditionRequestReject-IEs',
        'SgNBReconfigurationComplete-IEs',
        'ResponseInformationSgNBReconfComp-SuccessItemExtIEs',
        'ResponseInformationSgNBReconfComp-RejectByMeNBItemExtIEs',
        'SgNBModificationRequest-IEs',
        'UE-ContextInformationSgNBModReqExtIEs',
        'E-RABs-ToBeAdded-SgNBModReq-ItemIEs',
        'E-RABs-ToBeAdded-SgNBModReq-ItemExtIEs',
        'E-RABs-ToBeAdded-SgNBModReq-Item-SgNBPDCPpresentExtIEs',
        'E-RABs-ToBeAdded-SgNBModReq-Item-SgNBPDCPnotpresentExtIEs',
        'E-RABs-ToBeModified-SgNBModReq-ItemIEs',
        'E-RABs-ToBeModified-SgNBModReq-ItemExtIEs',
        'E-RABs-ToBeModified-SgNBModReq-Item-SgNBPDCPpresentExtIEs',
        'E-RABs-ToBeModified-SgNBModReq-Item-SgNBPDCPnotpresentExtIEs',
        'E-RABs-ToBeReleased-SgNBModReq-ItemIEs',
        'E-RABs-ToBeReleased-SgNBModReq-ItemExtIEs',
        'E-RABs-ToBeReleased-SgNBModReq-Item-SgNBPDCPpresentExtIEs',
        'E-RABs-ToBeReleased-SgNBModReq-Item-SgNBPDCPnotpresentExtIEs',
        'SgNBModificationRequestAcknowledge-IEs',
        'E-RABs-Admitted-ToBeAdded-SgNBModAck-ItemIEs',
        'E-RABs-Admitted-ToBeAdded-SgNBModAck-ItemExtIEs',
        'E-RABs-Admitted-ToBeAdded-SgNBModAck-Item-SgNBPDCPpresentExtIEs',
        'E-RABs-Admitted-ToBeAdded-SgNBModAck-Item-SgNBPDCPnotpresentExtIEs',
        'E-RABs-Admitted-ToBeModified-SgNBModAck-ItemIEs',
        'E-RABs-ToBeAdded-SgNBModAck-ItemExtIEs',
        'E-RABs-Admitted-ToBeModified-SgNBModAck-Item-SgNBPDCPpresentExtIEs',
        'E-RABs-Admitted-ToBeModified-SgNBModAck-Item-SgNBPDCPnotpresentExtIEs',
        'E-RABs-Admitted-ToBeReleased-SgNBModAck-ItemIEs',
        'E-RABs-ToBeReleased-SgNBModAck-ItemExtIEs',
        'E-RABs-Admitted-ToBeReleased-SgNBModAck-Item-SgNBPDCPpresentExtIEs',
        'E-RABs-Admitted-ToBeReleased-SgNBModAck-Item-SgNBPDCPnotpresentExtIEs',
        'SgNBModificationRequestReject-IEs',
        'SgNBModificationRequired-IEs',
        'E-RABs-ToBeReleased-SgNBModReqd-ItemIEs',
        'E-RABs-ToBeReleased-SgNBModReqd-ItemExtIEs',
        'E-RABs-ToBeModified-SgNBModReqd-ItemIEs',
        'E-RABs-ToBeModified-SgNBModReqd-ItemExtIEs',
        'E-RABs-ToBeModified-SgNBModReqd-Item-SgNBPDCPpresentExtIEs',
        'E-RABs-ToBeModified-SgNBModReqd-Item-SgNBPDCPnotpresentExtIEs',
        'SgNBModificationConfirm-IEs',
        'E-RABs-AdmittedToBeModified-SgNBModConf-ItemIEs',
        'E-RABs-AdmittedToBeModified-SgNBModConf-ItemExtIEs',
        'E-RABs-AdmittedToBeModified-SgNBModConf-Item-SgNBPDCPpresentExtIEs',
        'E-RABs-AdmittedToBeModified-SgNBModConf-Item-SgNBPDCPnotpresentExtIEs',
        'SgNBModificationRefuse-IEs',
        'SgNBReleaseRequest-IEs',
        'E-RABs-ToBeReleased-SgNBRelReq-ItemIEs',
        'E-RABs-ToBeReleased-SgNBRelReq-ItemExtIEs',
        'E-RABs-ToBeReleased-SgNBRelReq-Item-SgNBPDCPpresentExtIEs',
        'E-RABs-ToBeReleased-SgNBRelReq-Item-SgNBPDCPnotpresentExtIEs',
        'SgNBReleaseRequestAcknowledge-IEs',
        'E-RABs-Admitted-ToBeReleased-SgNBRelReqAck-ItemIEs',
        'E-RABs-Admitted-ToBeReleased-SgNBRelReqAck-ItemExtIEs',
        'SgNBReleaseRequestReject-IEs',
        'SgNBReleaseRequired-IEs',
        'E-RABs-ToBeReleased-SgNBRelReqd-ItemIEs',
        'E-RABs-ToBeReleased-SgNBRelReqd-ItemExtIEs',
        'SgNBReleaseConfirm-IEs',
        'E-RABs-ToBeReleased-SgNBRelConf-ItemIEs',
        'E-RABs-ToBeReleased-SgNBRelConf-ItemExtIEs',
        'E-RABs-ToBeReleased-SgNBRelConf-Item-SgNBPDCPpresentExtIEs',
        'E-RABs-ToBeReleased-SgNBRelConf-Item-SgNBPDCPnotpresentExtIEs',
        'SgNBCounterCheckRequest-IEs',
        'E-RABs-SubjectToSgNBCounterCheck-ItemIEs',
        'E-RABs-SubjectToSgNBCounterCheck-ItemExtIEs',
        'SgNBChangeRequired-IEs',
        'AccessAndMobilityIndication-IEs',
        'SgNBChangeConfirm-IEs',
        'E-RABs-ToBeReleased-SgNBChaConf-ItemIEs',
        'E-RABs-ToBeReleased-SgNBChaConf-ItemExtIEs',
        'E-RABs-ToBeReleased-SgNBChaConf-Item-SgNBPDCPpresentExtIEs',
        'E-RABs-ToBeReleased-SgNBChaConf-Item-SgNBPDCPnotpresentExtIEs',
        'RRCTransfer-IEs',
        'SgNBChangeRefuse-IEs',
        'ENDCX2SetupRequest-IEs',
        'ENB-ENDCX2SetupReqIEs',
        'ServedEUTRAcellsENDCX2Management-ExtIEs',
        'En-gNB-ENDCX2SetupReqIEs',
        'En-gNBServedCells-ExtIEs',
        'ServedNRCell-Information-ExtIEs',
        'FDD-InfoServedNRCell-Information-ExtIEs',
        'TDD-InfoServedNRCell-Information-ExtIEs',
        'CellandCapacityAssistInfo-ExtIEs',
        'Limited-list-ExtIEs',
        'ENDCX2SetupResponse-IEs',
        'ENB-ENDCX2SetupReqAckIEs',
        'En-gNB-ENDCX2SetupReqAckIEs',
        'ENDCX2SetupFailure-IEs',
        'ENDCConfigurationUpdate-IEs',
        'ENB-ENDCConfigUpdateIEs',
        'ServedEUTRAcellsToModifyListENDCConfUpd-ExtIEs',
        'En-gNB-ENDCConfigUpdateIEs',
        'ServedNRCellsToModify-Item-ExtIEs',
        'ENDCConfigurationUpdateAcknowledge-IEs',
        'ENB-ENDCConfigUpdateAckIEs',
        'En-gNB-ENDCConfigUpdateAckIEs',
        'ENDCConfigurationUpdateFailure-IEs',
        'ENDCCellActivationRequest-IEs',
        'ServedNRCellsToActivate-Item-ExtIEs',
        'ENDCCellActivationResponse-IEs',
        'ActivatedNRCellList-Item-ExtIEs',
        'ENDCCellActivationFailure-IEs',
        'ENDCResourceStatusRequest-IEs',
        'CellToReport-NR-ENDC-ItemIEs',
        'CellToReport-NR-ENDC-Item-ExtIEs',
        'CellToReport-E-UTRA-ENDC-Item-IEs',
        'CellToReport-E-UTRA-ENDC-Item-ExtIEs',
        'SSBToReport-Item-ExtIEs',
        'ENDCResourceStatusResponse-IEs',
        'ENDCResourceStatusFailure-IEs',
        'ENDCResourceStatusUpdate-IEs',
        'CellMeasurementResult-NR-ENDC-ItemIEs',
        'CellMeasurementResult-NR-ENDC-Item-ExtIEs',
        'CellMeasurementResult-E-UTRA-ENDC-ItemIEs',
        'CellMeasurementResult-E-UTRA-ENDC-Item-ExtIEs',
        'SecondaryRATDataUsageReport-IEs',
        'SgNBActivityNotification-IEs',
        'ENDCPartialResetRequired-IEs',
        'ENDCPartialResetConfirm-IEs',
        'EUTRANRCellResourceCoordinationRequest-IEs',
        'ENB-EUTRA-NRCellResourceCoordinationReqIEs',
        'En-gNB-EUTRA-NRCellResourceCoordinationReqIEs',
        'EUTRANRCellResourceCoordinationResponse-IEs',
        'ENB-EUTRA-NRCellResourceCoordinationReqAckIEs',
        'En-gNB-EUTRA-NRCellResourceCoordinationReqAckIEs',
        'ENDCX2RemovalRequest-IEs',
        'ENB-ENDCX2RemovalReqIEs',
        'En-gNB-ENDCX2RemovalReqIEs',
        'ENDCX2RemovalResponse-IEs',
        'ENB-ENDCX2RemovalReqAckIEs',
        'En-gNB-ENDCX2RemovalReqAckIEs',
        'ENDCX2RemovalFailure-IEs',
        'DataForwardingAddressIndication-IEs',
        'E-RABs-DataForwardingAddress-ItemIEs',
        'E-RABs-DataForwardingAddress-ItemExtIEs',
        'GNBStatusIndicationIEs',
        'ENDCConfigurationTransfer-IEs',
        'TraceStartIEs',
        'DeactivateTraceIEs',
        'CellTrafficTraceIEs',
        'F1CTrafficTransfer-IEs',
        'UERadioCapabilityIDMappingRequestIEs',
        'UERadioCapabilityIDMappingResponseIEs',
        'CPC-cancel-IEs',
        ]
    _param_ = [
        ]
    
    #-----< HandoverRequest >-----#
    HandoverRequest = SEQ(name='HandoverRequest', mode=MODE_TYPE)
    _HandoverRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __HandoverRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___HandoverRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____HandoverRequest_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GUMMEI')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'UE-ContextInformation')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-HistoryInformation')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TraceActivation')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_7 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SRVCCOperationPossible')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_8 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CSGMembershipStatus')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_9 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'MobilityInformation')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_10 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Masked-IMEISV')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_11 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-HistoryInformationFromTheUE')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_12 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ExpectedUEBehaviour')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_13 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ProSeAuthorized')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_14 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'UE-ContextReferenceAtSeNB')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_15 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_16 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'V2XServicesAuthorized')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_17 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'UE-ContextReferenceAtWT')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_18 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'NRUESecurityCapabilities')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_19 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'UE-ContextReferenceAtSgNB')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_20 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'AerialUEsubscriptionInformation')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_21 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Subscription-Based-UE-DifferentiationInfo')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_22 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CHOinformation-REQ')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_23 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'NRV2XServicesAuthorized')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_24 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PC5QoSParameters')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_25 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'IABNodeIndication')))
    ____HandoverRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 11), ('criticality', 'reject'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 23), ('criticality', 'reject'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 14), ('criticality', 'reject'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_4), ('presence', 'mandatory')]), dict([('id', 15), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_5), ('presence', 'mandatory')]), dict([('id', 13), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 36), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')]), dict([('id', 71), ('criticality', 'reject'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_8), ('presence', 'optional')]), dict([('id', 82), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_9), ('presence', 'optional')]), dict([('id', 98), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_10), ('presence', 'optional')]), dict([('id', 105), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_11), ('presence', 'optional')]), dict([('id', 104), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_12), ('presence', 'optional')]), dict([('id', 103), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_13), ('presence', 'optional')]), dict([('id', 153), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_14), ('presence', 'optional')]), dict([('id', 156), ('criticality', 'reject'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_15), ('presence', 'optional')]), dict([('id', 176), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_16), ('presence', 'optional')]), dict([('id', 182), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_17), ('presence', 'optional')]), dict([('id', 248), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_18), ('presence', 'optional')]), dict([('id', 254), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_19), ('presence', 'optional')]), dict([('id', 277), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_20), ('presence', 'optional')]), dict([('id', 309), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_21), ('presence', 'optional')]), dict([('id', 361), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_22), ('presence', 'optional')]), dict([('id', 370), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_23), ('presence', 'optional')]), dict([('id', 372), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_24), ('presence', 'optional')]), dict([('id', 395), ('criticality', 'reject'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_25), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___HandoverRequest_protocolIEs__item__id._const_tab = ____HandoverRequest_protocolIEs__item__id_tab
    ___HandoverRequest_protocolIEs__item__id._const_tab_at = None
    ___HandoverRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___HandoverRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___HandoverRequest_protocolIEs__item__criticality._const_tab = ____HandoverRequest_protocolIEs__item__id_tab
    ___HandoverRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___HandoverRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___HandoverRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___HandoverRequest_protocolIEs__item__value._const_tab = ____HandoverRequest_protocolIEs__item__id_tab
    ___HandoverRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___HandoverRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __HandoverRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___HandoverRequest_protocolIEs__item__id),
        ('criticality', ___HandoverRequest_protocolIEs__item__criticality),
        ('value', ___HandoverRequest_protocolIEs__item__value),
        ])
    __HandoverRequest_protocolIEs__item_._ext = None
    _HandoverRequest_protocolIEs._cont = __HandoverRequest_protocolIEs__item_
    _HandoverRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    HandoverRequest._cont = ASN1Dict([
        ('protocolIEs', _HandoverRequest_protocolIEs),
        ])
    HandoverRequest._ext = []
    
    #-----< HandoverRequest-IEs >-----#
    HandoverRequest_IEs = CLASS(name='HandoverRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _HandoverRequest_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _HandoverRequest_IEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _HandoverRequest_IEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _HandoverRequest_IEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GUMMEI')))
    _HandoverRequest_IEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'UE-ContextInformation')))
    _HandoverRequest_IEs_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-HistoryInformation')))
    _HandoverRequest_IEs_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TraceActivation')))
    _HandoverRequest_IEs_val_Value_7 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SRVCCOperationPossible')))
    _HandoverRequest_IEs_val_Value_8 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CSGMembershipStatus')))
    _HandoverRequest_IEs_val_Value_9 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'MobilityInformation')))
    _HandoverRequest_IEs_val_Value_10 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Masked-IMEISV')))
    _HandoverRequest_IEs_val_Value_11 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-HistoryInformationFromTheUE')))
    _HandoverRequest_IEs_val_Value_12 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ExpectedUEBehaviour')))
    _HandoverRequest_IEs_val_Value_13 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ProSeAuthorized')))
    _HandoverRequest_IEs_val_Value_14 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'UE-ContextReferenceAtSeNB')))
    _HandoverRequest_IEs_val_Value_15 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _HandoverRequest_IEs_val_Value_16 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'V2XServicesAuthorized')))
    _HandoverRequest_IEs_val_Value_17 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'UE-ContextReferenceAtWT')))
    _HandoverRequest_IEs_val_Value_18 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'NRUESecurityCapabilities')))
    _HandoverRequest_IEs_val_Value_19 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'UE-ContextReferenceAtSgNB')))
    _HandoverRequest_IEs_val_Value_20 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'AerialUEsubscriptionInformation')))
    _HandoverRequest_IEs_val_Value_21 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Subscription-Based-UE-DifferentiationInfo')))
    _HandoverRequest_IEs_val_Value_22 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CHOinformation-REQ')))
    _HandoverRequest_IEs_val_Value_23 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'NRV2XServicesAuthorized')))
    _HandoverRequest_IEs_val_Value_24 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PC5QoSParameters')))
    _HandoverRequest_IEs_val_Value_25 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'IABNodeIndication')))
    HandoverRequest_IEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _HandoverRequest_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _HandoverRequest_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 11), ('criticality', 'reject'), ('Value', _HandoverRequest_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 23), ('criticality', 'reject'), ('Value', _HandoverRequest_IEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 14), ('criticality', 'reject'), ('Value', _HandoverRequest_IEs_val_Value_4), ('presence', 'mandatory')]), dict([('id', 15), ('criticality', 'ignore'), ('Value', _HandoverRequest_IEs_val_Value_5), ('presence', 'mandatory')]), dict([('id', 13), ('criticality', 'ignore'), ('Value', _HandoverRequest_IEs_val_Value_6), ('presence', 'optional')]), dict([('id', 36), ('criticality', 'ignore'), ('Value', _HandoverRequest_IEs_val_Value_7), ('presence', 'optional')]), dict([('id', 71), ('criticality', 'reject'), ('Value', _HandoverRequest_IEs_val_Value_8), ('presence', 'optional')]), dict([('id', 82), ('criticality', 'ignore'), ('Value', _HandoverRequest_IEs_val_Value_9), ('presence', 'optional')]), dict([('id', 98), ('criticality', 'ignore'), ('Value', _HandoverRequest_IEs_val_Value_10), ('presence', 'optional')]), dict([('id', 105), ('criticality', 'ignore'), ('Value', _HandoverRequest_IEs_val_Value_11), ('presence', 'optional')]), dict([('id', 104), ('criticality', 'ignore'), ('Value', _HandoverRequest_IEs_val_Value_12), ('presence', 'optional')]), dict([('id', 103), ('criticality', 'ignore'), ('Value', _HandoverRequest_IEs_val_Value_13), ('presence', 'optional')]), dict([('id', 153), ('criticality', 'ignore'), ('Value', _HandoverRequest_IEs_val_Value_14), ('presence', 'optional')]), dict([('id', 156), ('criticality', 'reject'), ('Value', _HandoverRequest_IEs_val_Value_15), ('presence', 'optional')]), dict([('id', 176), ('criticality', 'ignore'), ('Value', _HandoverRequest_IEs_val_Value_16), ('presence', 'optional')]), dict([('id', 182), ('criticality', 'ignore'), ('Value', _HandoverRequest_IEs_val_Value_17), ('presence', 'optional')]), dict([('id', 248), ('criticality', 'ignore'), ('Value', _HandoverRequest_IEs_val_Value_18), ('presence', 'optional')]), dict([('id', 254), ('criticality', 'ignore'), ('Value', _HandoverRequest_IEs_val_Value_19), ('presence', 'optional')]), dict([('id', 277), ('criticality', 'ignore'), ('Value', _HandoverRequest_IEs_val_Value_20), ('presence', 'optional')]), dict([('id', 309), ('criticality', 'ignore'), ('Value', _HandoverRequest_IEs_val_Value_21), ('presence', 'optional')]), dict([('id', 361), ('criticality', 'ignore'), ('Value', _HandoverRequest_IEs_val_Value_22), ('presence', 'optional')]), dict([('id', 370), ('criticality', 'ignore'), ('Value', _HandoverRequest_IEs_val_Value_23), ('presence', 'optional')]), dict([('id', 372), ('criticality', 'ignore'), ('Value', _HandoverRequest_IEs_val_Value_24), ('presence', 'optional')]), dict([('id', 395), ('criticality', 'reject'), ('Value', _HandoverRequest_IEs_val_Value_25), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UE-ContextInformation >-----#
    UE_ContextInformation = SEQ(name='UE-ContextInformation', mode=MODE_TYPE)
    _UE_ContextInformation_mME_UE_S1AP_ID = INT(name='mME-UE-S1AP-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'UE-S1AP-ID')))
    _UE_ContextInformation_uESecurityCapabilities = SEQ(name='uESecurityCapabilities', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'UESecurityCapabilities')))
    _UE_ContextInformation_aS_SecurityInformation = SEQ(name='aS-SecurityInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'AS-SecurityInformation')))
    _UE_ContextInformation_uEaggregateMaximumBitRate = SEQ(name='uEaggregateMaximumBitRate', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'UEAggregateMaximumBitRate')))
    _UE_ContextInformation_subscriberProfileIDforRFP = INT(name='subscriberProfileIDforRFP', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'SubscriberProfileIDforRFP')), opt=True)
    _UE_ContextInformation_e_RABs_ToBeSetup_List = SEQ_OF(name='e-RABs-ToBeSetup-List', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeSetup-List')))
    _UE_ContextInformation_rRC_Context = OCT_STR(name='rRC-Context', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'RRC-Context')))
    _UE_ContextInformation_handoverRestrictionList = SEQ(name='handoverRestrictionList', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'HandoverRestrictionList')), opt=True)
    _UE_ContextInformation_locationReportingInformation = SEQ(name='locationReportingInformation', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'LocationReportingInformation')), opt=True)
    _UE_ContextInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UE_ContextInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___UE_ContextInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____UE_ContextInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____UE_ContextInformation_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ManagementBasedMDTallowed')))
    _____UE_ContextInformation_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MDTPLMNList')))
    _____UE_ContextInformation_iE_Extensions__item__id_tab_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UESidelinkAggregateMaximumBitRate')))
    _____UE_ContextInformation_iE_Extensions__item__id_tab_val_Extension_3 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'EPCHandoverRestrictionListContainer')))
    _____UE_ContextInformation_iE_Extensions__item__id_tab_val_Extension_4 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'AdditionalRRMPriorityIndex')))
    _____UE_ContextInformation_iE_Extensions__item__id_tab_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'NRUESidelinkAggregateMaximumBitRate')))
    _____UE_ContextInformation_iE_Extensions__item__id_tab_val_Extension_6 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UERadioCapabilityID')))
    _____UE_ContextInformation_iE_Extensions__item__id_tab_val_Extension_7 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'IMSvoiceEPSfallbackfrom5G')))
    ____UE_ContextInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 74), ('criticality', 'ignore'), ('Extension', _____UE_ContextInformation_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 89), ('criticality', 'ignore'), ('Extension', _____UE_ContextInformation_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 184), ('criticality', 'ignore'), ('Extension', _____UE_ContextInformation_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 360), ('criticality', 'ignore'), ('Extension', _____UE_ContextInformation_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 340), ('criticality', 'ignore'), ('Extension', _____UE_ContextInformation_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 371), ('criticality', 'ignore'), ('Extension', _____UE_ContextInformation_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')]), dict([('id', 378), ('criticality', 'reject'), ('Extension', _____UE_ContextInformation_iE_Extensions__item__id_tab_val_Extension_6), ('presence', 'optional')]), dict([('id', 408), ('criticality', 'ignore'), ('Extension', _____UE_ContextInformation_iE_Extensions__item__id_tab_val_Extension_7), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UE_ContextInformation_iE_Extensions__item__id._const_tab = ____UE_ContextInformation_iE_Extensions__item__id_tab
    ___UE_ContextInformation_iE_Extensions__item__id._const_tab_at = None
    ___UE_ContextInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___UE_ContextInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___UE_ContextInformation_iE_Extensions__item__criticality._const_tab = ____UE_ContextInformation_iE_Extensions__item__id_tab
    ___UE_ContextInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UE_ContextInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UE_ContextInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___UE_ContextInformation_iE_Extensions__item__extensionValue._const_tab = ____UE_ContextInformation_iE_Extensions__item__id_tab
    ___UE_ContextInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UE_ContextInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UE_ContextInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UE_ContextInformation_iE_Extensions__item__id),
        ('criticality', ___UE_ContextInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___UE_ContextInformation_iE_Extensions__item__extensionValue),
        ])
    __UE_ContextInformation_iE_Extensions__item_._ext = None
    _UE_ContextInformation_iE_Extensions._cont = __UE_ContextInformation_iE_Extensions__item_
    _UE_ContextInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UE_ContextInformation._cont = ASN1Dict([
        ('mME-UE-S1AP-ID', _UE_ContextInformation_mME_UE_S1AP_ID),
        ('uESecurityCapabilities', _UE_ContextInformation_uESecurityCapabilities),
        ('aS-SecurityInformation', _UE_ContextInformation_aS_SecurityInformation),
        ('uEaggregateMaximumBitRate', _UE_ContextInformation_uEaggregateMaximumBitRate),
        ('subscriberProfileIDforRFP', _UE_ContextInformation_subscriberProfileIDforRFP),
        ('e-RABs-ToBeSetup-List', _UE_ContextInformation_e_RABs_ToBeSetup_List),
        ('rRC-Context', _UE_ContextInformation_rRC_Context),
        ('handoverRestrictionList', _UE_ContextInformation_handoverRestrictionList),
        ('locationReportingInformation', _UE_ContextInformation_locationReportingInformation),
        ('iE-Extensions', _UE_ContextInformation_iE_Extensions),
        ])
    UE_ContextInformation._ext = []
    
    #-----< UE-ContextInformation-ExtIEs >-----#
    UE_ContextInformation_ExtIEs = CLASS(name='UE-ContextInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _UE_ContextInformation_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ManagementBasedMDTallowed')))
    _UE_ContextInformation_ExtIEs_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MDTPLMNList')))
    _UE_ContextInformation_ExtIEs_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UESidelinkAggregateMaximumBitRate')))
    _UE_ContextInformation_ExtIEs_val_Extension_3 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'EPCHandoverRestrictionListContainer')))
    _UE_ContextInformation_ExtIEs_val_Extension_4 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'AdditionalRRMPriorityIndex')))
    _UE_ContextInformation_ExtIEs_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'NRUESidelinkAggregateMaximumBitRate')))
    _UE_ContextInformation_ExtIEs_val_Extension_6 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UERadioCapabilityID')))
    _UE_ContextInformation_ExtIEs_val_Extension_7 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'IMSvoiceEPSfallbackfrom5G')))
    UE_ContextInformation_ExtIEs._val = ASN1Set(rv=[dict([('id', 74), ('criticality', 'ignore'), ('Extension', _UE_ContextInformation_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 89), ('criticality', 'ignore'), ('Extension', _UE_ContextInformation_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 184), ('criticality', 'ignore'), ('Extension', _UE_ContextInformation_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 360), ('criticality', 'ignore'), ('Extension', _UE_ContextInformation_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 340), ('criticality', 'ignore'), ('Extension', _UE_ContextInformation_ExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 371), ('criticality', 'ignore'), ('Extension', _UE_ContextInformation_ExtIEs_val_Extension_5), ('presence', 'optional')]), dict([('id', 378), ('criticality', 'reject'), ('Extension', _UE_ContextInformation_ExtIEs_val_Extension_6), ('presence', 'optional')]), dict([('id', 408), ('criticality', 'ignore'), ('Extension', _UE_ContextInformation_ExtIEs_val_Extension_7), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeSetup-List >-----#
    E_RABs_ToBeSetup_List = SEQ_OF(name='E-RABs-ToBeSetup-List', mode=MODE_TYPE)
    _E_RABs_ToBeSetup_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __E_RABs_ToBeSetup_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ___E_RABs_ToBeSetup_List__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____E_RABs_ToBeSetup_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeSetup-Item')))
    ___E_RABs_ToBeSetup_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 4), ('criticality', 'ignore'), ('Value', ____E_RABs_ToBeSetup_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E_RABs_ToBeSetup_List__item__id._const_tab = ___E_RABs_ToBeSetup_List__item__id_tab
    __E_RABs_ToBeSetup_List__item__id._const_tab_at = None
    __E_RABs_ToBeSetup_List__item__id._const_tab_id = 'id'
    __E_RABs_ToBeSetup_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    __E_RABs_ToBeSetup_List__item__criticality._const_tab = ___E_RABs_ToBeSetup_List__item__id_tab
    __E_RABs_ToBeSetup_List__item__criticality._const_tab_at = ('..', 'id')
    __E_RABs_ToBeSetup_List__item__criticality._const_tab_id = 'criticality'
    __E_RABs_ToBeSetup_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    __E_RABs_ToBeSetup_List__item__value._const_tab = ___E_RABs_ToBeSetup_List__item__id_tab
    __E_RABs_ToBeSetup_List__item__value._const_tab_at = ('..', 'id')
    __E_RABs_ToBeSetup_List__item__value._const_tab_id = 'Value'
    _E_RABs_ToBeSetup_List__item_._cont = ASN1Dict([
        ('id', __E_RABs_ToBeSetup_List__item__id),
        ('criticality', __E_RABs_ToBeSetup_List__item__criticality),
        ('value', __E_RABs_ToBeSetup_List__item__value),
        ])
    _E_RABs_ToBeSetup_List__item_._ext = None
    E_RABs_ToBeSetup_List._cont = _E_RABs_ToBeSetup_List__item_
    E_RABs_ToBeSetup_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABs-ToBeSetup-ItemIEs >-----#
    E_RABs_ToBeSetup_ItemIEs = CLASS(name='E-RABs-ToBeSetup-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _E_RABs_ToBeSetup_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeSetup-Item')))
    E_RABs_ToBeSetup_ItemIEs._val = ASN1Set(rv=[dict([('id', 4), ('criticality', 'ignore'), ('Value', _E_RABs_ToBeSetup_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeSetup-Item >-----#
    E_RABs_ToBeSetup_Item = SEQ(name='E-RABs-ToBeSetup-Item', mode=MODE_TYPE)
    _E_RABs_ToBeSetup_Item_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_ToBeSetup_Item_e_RAB_Level_QoS_Parameters = SEQ(name='e-RAB-Level-QoS-Parameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-Level-QoS-Parameters')))
    _E_RABs_ToBeSetup_Item_dL_Forwarding = ENUM(name='dL-Forwarding', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'DL-Forwarding')), opt=True)
    _E_RABs_ToBeSetup_Item_uL_GTPtunnelEndpoint = SEQ(name='uL-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')))
    _E_RABs_ToBeSetup_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_ToBeSetup_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_ToBeSetup_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_ToBeSetup_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____E_RABs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'BearerType')))
    _____E_RABs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'DAPSRequestInfo')))
    _____E_RABs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Ethernet-Type')))
    _____E_RABs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_3 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TransportLayerAddress')))
    _____E_RABs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SecurityIndication')))
    ____E_RABs_ToBeSetup_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 171), ('criticality', 'reject'), ('Extension', _____E_RABs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 363), ('criticality', 'ignore'), ('Extension', _____E_RABs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 369), ('criticality', 'ignore'), ('Extension', _____E_RABs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 412), ('criticality', 'ignore'), ('Extension', _____E_RABs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 435), ('criticality', 'reject'), ('Extension', _____E_RABs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_RABs_ToBeSetup_Item_iE_Extensions__item__id._const_tab = ____E_RABs_ToBeSetup_Item_iE_Extensions__item__id_tab
    ___E_RABs_ToBeSetup_Item_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_ToBeSetup_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_ToBeSetup_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___E_RABs_ToBeSetup_Item_iE_Extensions__item__criticality._const_tab = ____E_RABs_ToBeSetup_Item_iE_Extensions__item__id_tab
    ___E_RABs_ToBeSetup_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeSetup_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_ToBeSetup_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___E_RABs_ToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_ToBeSetup_Item_iE_Extensions__item__id_tab
    ___E_RABs_ToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeSetup_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_ToBeSetup_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_ToBeSetup_Item_iE_Extensions__item__id),
        ('criticality', ___E_RABs_ToBeSetup_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_ToBeSetup_Item_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_ToBeSetup_Item_iE_Extensions__item_._ext = None
    _E_RABs_ToBeSetup_Item_iE_Extensions._cont = __E_RABs_ToBeSetup_Item_iE_Extensions__item_
    _E_RABs_ToBeSetup_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_ToBeSetup_Item._cont = ASN1Dict([
        ('e-RAB-ID', _E_RABs_ToBeSetup_Item_e_RAB_ID),
        ('e-RAB-Level-QoS-Parameters', _E_RABs_ToBeSetup_Item_e_RAB_Level_QoS_Parameters),
        ('dL-Forwarding', _E_RABs_ToBeSetup_Item_dL_Forwarding),
        ('uL-GTPtunnelEndpoint', _E_RABs_ToBeSetup_Item_uL_GTPtunnelEndpoint),
        ('iE-Extensions', _E_RABs_ToBeSetup_Item_iE_Extensions),
        ])
    E_RABs_ToBeSetup_Item._ext = []
    
    #-----< E-RABs-ToBeSetup-ItemExtIEs >-----#
    E_RABs_ToBeSetup_ItemExtIEs = CLASS(name='E-RABs-ToBeSetup-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _E_RABs_ToBeSetup_ItemExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'BearerType')))
    _E_RABs_ToBeSetup_ItemExtIEs_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'DAPSRequestInfo')))
    _E_RABs_ToBeSetup_ItemExtIEs_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Ethernet-Type')))
    _E_RABs_ToBeSetup_ItemExtIEs_val_Extension_3 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TransportLayerAddress')))
    _E_RABs_ToBeSetup_ItemExtIEs_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SecurityIndication')))
    E_RABs_ToBeSetup_ItemExtIEs._val = ASN1Set(rv=[dict([('id', 171), ('criticality', 'reject'), ('Extension', _E_RABs_ToBeSetup_ItemExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 363), ('criticality', 'ignore'), ('Extension', _E_RABs_ToBeSetup_ItemExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 369), ('criticality', 'ignore'), ('Extension', _E_RABs_ToBeSetup_ItemExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 412), ('criticality', 'ignore'), ('Extension', _E_RABs_ToBeSetup_ItemExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 435), ('criticality', 'reject'), ('Extension', _E_RABs_ToBeSetup_ItemExtIEs_val_Extension_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MobilityInformation >-----#
    MobilityInformation = BIT_STR(name='MobilityInformation', mode=MODE_TYPE)
    MobilityInformation._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    
    #-----< SourceDLForwardingIPAddress >-----#
    SourceDLForwardingIPAddress = BIT_STR(name='SourceDLForwardingIPAddress', mode=MODE_TYPE)
    SourceDLForwardingIPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=160)], ev=[], er=[])
    
    #-----< UE-ContextReferenceAtSeNB >-----#
    UE_ContextReferenceAtSeNB = SEQ(name='UE-ContextReferenceAtSeNB', mode=MODE_TYPE)
    _UE_ContextReferenceAtSeNB_source_GlobalSeNB_ID = SEQ(name='source-GlobalSeNB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GlobalENB-ID')))
    _UE_ContextReferenceAtSeNB_seNB_UE_X2AP_ID = INT(name='seNB-UE-X2AP-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _UE_ContextReferenceAtSeNB_seNB_UE_X2AP_ID_Extension = INT(name='seNB-UE-X2AP-ID-Extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _UE_ContextReferenceAtSeNB_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UE_ContextReferenceAtSeNB_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___UE_ContextReferenceAtSeNB_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____UE_ContextReferenceAtSeNB_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____UE_ContextReferenceAtSeNB_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_ContextReferenceAtSeNB_iE_Extensions__item__id._const_tab = ____UE_ContextReferenceAtSeNB_iE_Extensions__item__id_tab
    ___UE_ContextReferenceAtSeNB_iE_Extensions__item__id._const_tab_at = None
    ___UE_ContextReferenceAtSeNB_iE_Extensions__item__id._const_tab_id = 'id'
    ___UE_ContextReferenceAtSeNB_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UE_ContextReferenceAtSeNB_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____UE_ContextReferenceAtSeNB_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_ContextReferenceAtSeNB_iE_Extensions__item__criticality._const_tab = ____UE_ContextReferenceAtSeNB_iE_Extensions__item__criticality_tab
    ___UE_ContextReferenceAtSeNB_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UE_ContextReferenceAtSeNB_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UE_ContextReferenceAtSeNB_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UE_ContextReferenceAtSeNB_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____UE_ContextReferenceAtSeNB_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_ContextReferenceAtSeNB_iE_Extensions__item__extensionValue._const_tab = ____UE_ContextReferenceAtSeNB_iE_Extensions__item__extensionValue_tab
    ___UE_ContextReferenceAtSeNB_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UE_ContextReferenceAtSeNB_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UE_ContextReferenceAtSeNB_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UE_ContextReferenceAtSeNB_iE_Extensions__item__id),
        ('criticality', ___UE_ContextReferenceAtSeNB_iE_Extensions__item__criticality),
        ('extensionValue', ___UE_ContextReferenceAtSeNB_iE_Extensions__item__extensionValue),
        ])
    __UE_ContextReferenceAtSeNB_iE_Extensions__item_._ext = None
    _UE_ContextReferenceAtSeNB_iE_Extensions._cont = __UE_ContextReferenceAtSeNB_iE_Extensions__item_
    _UE_ContextReferenceAtSeNB_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UE_ContextReferenceAtSeNB._cont = ASN1Dict([
        ('source-GlobalSeNB-ID', _UE_ContextReferenceAtSeNB_source_GlobalSeNB_ID),
        ('seNB-UE-X2AP-ID', _UE_ContextReferenceAtSeNB_seNB_UE_X2AP_ID),
        ('seNB-UE-X2AP-ID-Extension', _UE_ContextReferenceAtSeNB_seNB_UE_X2AP_ID_Extension),
        ('iE-Extensions', _UE_ContextReferenceAtSeNB_iE_Extensions),
        ])
    UE_ContextReferenceAtSeNB._ext = []
    
    #-----< UE-ContextReferenceAtSeNB-ItemExtIEs >-----#
    UE_ContextReferenceAtSeNB_ItemExtIEs = CLASS(name='UE-ContextReferenceAtSeNB-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    UE_ContextReferenceAtSeNB_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UE-ContextReferenceAtWT >-----#
    UE_ContextReferenceAtWT = SEQ(name='UE-ContextReferenceAtWT', mode=MODE_TYPE)
    _UE_ContextReferenceAtWT_wTID = CHOICE(name='wTID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'WTID')))
    _UE_ContextReferenceAtWT_wT_UE_XwAP_ID = OCT_STR(name='wT-UE-XwAP-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'WT-UE-XwAP-ID')))
    _UE_ContextReferenceAtWT_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UE_ContextReferenceAtWT_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___UE_ContextReferenceAtWT_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____UE_ContextReferenceAtWT_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____UE_ContextReferenceAtWT_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_ContextReferenceAtWT_iE_Extensions__item__id._const_tab = ____UE_ContextReferenceAtWT_iE_Extensions__item__id_tab
    ___UE_ContextReferenceAtWT_iE_Extensions__item__id._const_tab_at = None
    ___UE_ContextReferenceAtWT_iE_Extensions__item__id._const_tab_id = 'id'
    ___UE_ContextReferenceAtWT_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UE_ContextReferenceAtWT_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____UE_ContextReferenceAtWT_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_ContextReferenceAtWT_iE_Extensions__item__criticality._const_tab = ____UE_ContextReferenceAtWT_iE_Extensions__item__criticality_tab
    ___UE_ContextReferenceAtWT_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UE_ContextReferenceAtWT_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UE_ContextReferenceAtWT_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UE_ContextReferenceAtWT_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____UE_ContextReferenceAtWT_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_ContextReferenceAtWT_iE_Extensions__item__extensionValue._const_tab = ____UE_ContextReferenceAtWT_iE_Extensions__item__extensionValue_tab
    ___UE_ContextReferenceAtWT_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UE_ContextReferenceAtWT_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UE_ContextReferenceAtWT_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UE_ContextReferenceAtWT_iE_Extensions__item__id),
        ('criticality', ___UE_ContextReferenceAtWT_iE_Extensions__item__criticality),
        ('extensionValue', ___UE_ContextReferenceAtWT_iE_Extensions__item__extensionValue),
        ])
    __UE_ContextReferenceAtWT_iE_Extensions__item_._ext = None
    _UE_ContextReferenceAtWT_iE_Extensions._cont = __UE_ContextReferenceAtWT_iE_Extensions__item_
    _UE_ContextReferenceAtWT_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UE_ContextReferenceAtWT._cont = ASN1Dict([
        ('wTID', _UE_ContextReferenceAtWT_wTID),
        ('wT-UE-XwAP-ID', _UE_ContextReferenceAtWT_wT_UE_XwAP_ID),
        ('iE-Extensions', _UE_ContextReferenceAtWT_iE_Extensions),
        ])
    UE_ContextReferenceAtWT._ext = []
    
    #-----< UE-ContextReferenceAtWT-ItemExtIEs >-----#
    UE_ContextReferenceAtWT_ItemExtIEs = CLASS(name='UE-ContextReferenceAtWT-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    UE_ContextReferenceAtWT_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UE-ContextReferenceAtSgNB >-----#
    UE_ContextReferenceAtSgNB = SEQ(name='UE-ContextReferenceAtSgNB', mode=MODE_TYPE)
    _UE_ContextReferenceAtSgNB_source_GlobalSgNB_ID = SEQ(name='source-GlobalSgNB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GlobalGNB-ID')))
    _UE_ContextReferenceAtSgNB_sgNB_UE_X2AP_ID = INT(name='sgNB-UE-X2AP-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'SgNB-UE-X2AP-ID')))
    _UE_ContextReferenceAtSgNB_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UE_ContextReferenceAtSgNB_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___UE_ContextReferenceAtSgNB_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____UE_ContextReferenceAtSgNB_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____UE_ContextReferenceAtSgNB_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_ContextReferenceAtSgNB_iE_Extensions__item__id._const_tab = ____UE_ContextReferenceAtSgNB_iE_Extensions__item__id_tab
    ___UE_ContextReferenceAtSgNB_iE_Extensions__item__id._const_tab_at = None
    ___UE_ContextReferenceAtSgNB_iE_Extensions__item__id._const_tab_id = 'id'
    ___UE_ContextReferenceAtSgNB_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UE_ContextReferenceAtSgNB_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____UE_ContextReferenceAtSgNB_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_ContextReferenceAtSgNB_iE_Extensions__item__criticality._const_tab = ____UE_ContextReferenceAtSgNB_iE_Extensions__item__criticality_tab
    ___UE_ContextReferenceAtSgNB_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UE_ContextReferenceAtSgNB_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UE_ContextReferenceAtSgNB_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UE_ContextReferenceAtSgNB_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____UE_ContextReferenceAtSgNB_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_ContextReferenceAtSgNB_iE_Extensions__item__extensionValue._const_tab = ____UE_ContextReferenceAtSgNB_iE_Extensions__item__extensionValue_tab
    ___UE_ContextReferenceAtSgNB_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UE_ContextReferenceAtSgNB_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UE_ContextReferenceAtSgNB_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UE_ContextReferenceAtSgNB_iE_Extensions__item__id),
        ('criticality', ___UE_ContextReferenceAtSgNB_iE_Extensions__item__criticality),
        ('extensionValue', ___UE_ContextReferenceAtSgNB_iE_Extensions__item__extensionValue),
        ])
    __UE_ContextReferenceAtSgNB_iE_Extensions__item_._ext = None
    _UE_ContextReferenceAtSgNB_iE_Extensions._cont = __UE_ContextReferenceAtSgNB_iE_Extensions__item_
    _UE_ContextReferenceAtSgNB_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UE_ContextReferenceAtSgNB._cont = ASN1Dict([
        ('source-GlobalSgNB-ID', _UE_ContextReferenceAtSgNB_source_GlobalSgNB_ID),
        ('sgNB-UE-X2AP-ID', _UE_ContextReferenceAtSgNB_sgNB_UE_X2AP_ID),
        ('iE-Extensions', _UE_ContextReferenceAtSgNB_iE_Extensions),
        ])
    UE_ContextReferenceAtSgNB._ext = []
    
    #-----< UE-ContextReferenceAtSgNB-ItemExtIEs >-----#
    UE_ContextReferenceAtSgNB_ItemExtIEs = CLASS(name='UE-ContextReferenceAtSgNB-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    UE_ContextReferenceAtSgNB_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HandoverRequestAcknowledge >-----#
    HandoverRequestAcknowledge = SEQ(name='HandoverRequestAcknowledge', mode=MODE_TYPE)
    _HandoverRequestAcknowledge_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __HandoverRequestAcknowledge_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___HandoverRequestAcknowledge_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____HandoverRequestAcknowledge_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-List')))
    _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-List')))
    _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_4 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TargeteNBtoSource-eNBTransparentContainer')))
    _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_6 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-ContextKeptIndicator')))
    _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_7 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_8 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_9 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_10 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-ContextKeptIndicator')))
    _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_11 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-List')))
    _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_12 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CHOinformation-ACK')))
    ____HandoverRequestAcknowledge_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'ignore'), ('Value', _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'ignore'), ('Value', _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 12), ('criticality', 'ignore'), ('Value', _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_4), ('presence', 'mandatory')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 154), ('criticality', 'ignore'), ('Value', _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 158), ('criticality', 'ignore'), ('Value', _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')]), dict([('id', 156), ('criticality', 'ignore'), ('Value', _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_8), ('presence', 'optional')]), dict([('id', 155), ('criticality', 'reject'), ('Value', _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_9), ('presence', 'optional')]), dict([('id', 183), ('criticality', 'ignore'), ('Value', _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_10), ('presence', 'optional')]), dict([('id', 339), ('criticality', 'ignore'), ('Value', _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_11), ('presence', 'optional')]), dict([('id', 362), ('criticality', 'ignore'), ('Value', _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_12), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___HandoverRequestAcknowledge_protocolIEs__item__id._const_tab = ____HandoverRequestAcknowledge_protocolIEs__item__id_tab
    ___HandoverRequestAcknowledge_protocolIEs__item__id._const_tab_at = None
    ___HandoverRequestAcknowledge_protocolIEs__item__id._const_tab_id = 'id'
    ___HandoverRequestAcknowledge_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___HandoverRequestAcknowledge_protocolIEs__item__criticality._const_tab = ____HandoverRequestAcknowledge_protocolIEs__item__id_tab
    ___HandoverRequestAcknowledge_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___HandoverRequestAcknowledge_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___HandoverRequestAcknowledge_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___HandoverRequestAcknowledge_protocolIEs__item__value._const_tab = ____HandoverRequestAcknowledge_protocolIEs__item__id_tab
    ___HandoverRequestAcknowledge_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___HandoverRequestAcknowledge_protocolIEs__item__value._const_tab_id = 'Value'
    __HandoverRequestAcknowledge_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___HandoverRequestAcknowledge_protocolIEs__item__id),
        ('criticality', ___HandoverRequestAcknowledge_protocolIEs__item__criticality),
        ('value', ___HandoverRequestAcknowledge_protocolIEs__item__value),
        ])
    __HandoverRequestAcknowledge_protocolIEs__item_._ext = None
    _HandoverRequestAcknowledge_protocolIEs._cont = __HandoverRequestAcknowledge_protocolIEs__item_
    _HandoverRequestAcknowledge_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    HandoverRequestAcknowledge._cont = ASN1Dict([
        ('protocolIEs', _HandoverRequestAcknowledge_protocolIEs),
        ])
    HandoverRequestAcknowledge._ext = []
    
    #-----< HandoverRequestAcknowledge-IEs >-----#
    HandoverRequestAcknowledge_IEs = CLASS(name='HandoverRequestAcknowledge-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _HandoverRequestAcknowledge_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _HandoverRequestAcknowledge_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _HandoverRequestAcknowledge_IEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-List')))
    _HandoverRequestAcknowledge_IEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-List')))
    _HandoverRequestAcknowledge_IEs_val_Value_4 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TargeteNBtoSource-eNBTransparentContainer')))
    _HandoverRequestAcknowledge_IEs_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _HandoverRequestAcknowledge_IEs_val_Value_6 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-ContextKeptIndicator')))
    _HandoverRequestAcknowledge_IEs_val_Value_7 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _HandoverRequestAcknowledge_IEs_val_Value_8 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _HandoverRequestAcknowledge_IEs_val_Value_9 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _HandoverRequestAcknowledge_IEs_val_Value_10 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-ContextKeptIndicator')))
    _HandoverRequestAcknowledge_IEs_val_Value_11 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-List')))
    _HandoverRequestAcknowledge_IEs_val_Value_12 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CHOinformation-ACK')))
    HandoverRequestAcknowledge_IEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'ignore'), ('Value', _HandoverRequestAcknowledge_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _HandoverRequestAcknowledge_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _HandoverRequestAcknowledge_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'ignore'), ('Value', _HandoverRequestAcknowledge_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 12), ('criticality', 'ignore'), ('Value', _HandoverRequestAcknowledge_IEs_val_Value_4), ('presence', 'mandatory')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _HandoverRequestAcknowledge_IEs_val_Value_5), ('presence', 'optional')]), dict([('id', 154), ('criticality', 'ignore'), ('Value', _HandoverRequestAcknowledge_IEs_val_Value_6), ('presence', 'optional')]), dict([('id', 158), ('criticality', 'ignore'), ('Value', _HandoverRequestAcknowledge_IEs_val_Value_7), ('presence', 'optional')]), dict([('id', 156), ('criticality', 'ignore'), ('Value', _HandoverRequestAcknowledge_IEs_val_Value_8), ('presence', 'optional')]), dict([('id', 155), ('criticality', 'reject'), ('Value', _HandoverRequestAcknowledge_IEs_val_Value_9), ('presence', 'optional')]), dict([('id', 183), ('criticality', 'ignore'), ('Value', _HandoverRequestAcknowledge_IEs_val_Value_10), ('presence', 'optional')]), dict([('id', 339), ('criticality', 'ignore'), ('Value', _HandoverRequestAcknowledge_IEs_val_Value_11), ('presence', 'optional')]), dict([('id', 362), ('criticality', 'ignore'), ('Value', _HandoverRequestAcknowledge_IEs_val_Value_12), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-Admitted-List >-----#
    E_RABs_Admitted_List = SEQ_OF(name='E-RABs-Admitted-List', mode=MODE_TYPE)
    _E_RABs_Admitted_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __E_RABs_Admitted_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ___E_RABs_Admitted_List__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____E_RABs_Admitted_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-Item')))
    ___E_RABs_Admitted_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Value', ____E_RABs_Admitted_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E_RABs_Admitted_List__item__id._const_tab = ___E_RABs_Admitted_List__item__id_tab
    __E_RABs_Admitted_List__item__id._const_tab_at = None
    __E_RABs_Admitted_List__item__id._const_tab_id = 'id'
    __E_RABs_Admitted_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    __E_RABs_Admitted_List__item__criticality._const_tab = ___E_RABs_Admitted_List__item__id_tab
    __E_RABs_Admitted_List__item__criticality._const_tab_at = ('..', 'id')
    __E_RABs_Admitted_List__item__criticality._const_tab_id = 'criticality'
    __E_RABs_Admitted_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    __E_RABs_Admitted_List__item__value._const_tab = ___E_RABs_Admitted_List__item__id_tab
    __E_RABs_Admitted_List__item__value._const_tab_at = ('..', 'id')
    __E_RABs_Admitted_List__item__value._const_tab_id = 'Value'
    _E_RABs_Admitted_List__item_._cont = ASN1Dict([
        ('id', __E_RABs_Admitted_List__item__id),
        ('criticality', __E_RABs_Admitted_List__item__criticality),
        ('value', __E_RABs_Admitted_List__item__value),
        ])
    _E_RABs_Admitted_List__item_._ext = None
    E_RABs_Admitted_List._cont = _E_RABs_Admitted_List__item_
    E_RABs_Admitted_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABs-Admitted-ItemIEs >-----#
    E_RABs_Admitted_ItemIEs = CLASS(name='E-RABs-Admitted-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _E_RABs_Admitted_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-Item')))
    E_RABs_Admitted_ItemIEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Value', _E_RABs_Admitted_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< E-RABs-Admitted-Item >-----#
    E_RABs_Admitted_Item = SEQ(name='E-RABs-Admitted-Item', mode=MODE_TYPE)
    _E_RABs_Admitted_Item_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_Admitted_Item_uL_GTP_TunnelEndpoint = SEQ(name='uL-GTP-TunnelEndpoint', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_Admitted_Item_dL_GTP_TunnelEndpoint = SEQ(name='dL-GTP-TunnelEndpoint', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_Admitted_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_Admitted_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_Admitted_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_Admitted_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____E_RABs_Admitted_Item_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'DAPSResponseInfo')))
    ____E_RABs_Admitted_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 366), ('criticality', 'reject'), ('Extension', _____E_RABs_Admitted_Item_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_RABs_Admitted_Item_iE_Extensions__item__id._const_tab = ____E_RABs_Admitted_Item_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_Item_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_Admitted_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_Admitted_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___E_RABs_Admitted_Item_iE_Extensions__item__criticality._const_tab = ____E_RABs_Admitted_Item_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_Admitted_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_Admitted_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___E_RABs_Admitted_Item_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_Admitted_Item_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_Admitted_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_Admitted_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_Admitted_Item_iE_Extensions__item__id),
        ('criticality', ___E_RABs_Admitted_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_Admitted_Item_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_Admitted_Item_iE_Extensions__item_._ext = None
    _E_RABs_Admitted_Item_iE_Extensions._cont = __E_RABs_Admitted_Item_iE_Extensions__item_
    _E_RABs_Admitted_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_Admitted_Item._cont = ASN1Dict([
        ('e-RAB-ID', _E_RABs_Admitted_Item_e_RAB_ID),
        ('uL-GTP-TunnelEndpoint', _E_RABs_Admitted_Item_uL_GTP_TunnelEndpoint),
        ('dL-GTP-TunnelEndpoint', _E_RABs_Admitted_Item_dL_GTP_TunnelEndpoint),
        ('iE-Extensions', _E_RABs_Admitted_Item_iE_Extensions),
        ])
    E_RABs_Admitted_Item._ext = []
    
    #-----< E-RABs-Admitted-Item-ExtIEs >-----#
    E_RABs_Admitted_Item_ExtIEs = CLASS(name='E-RABs-Admitted-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _E_RABs_Admitted_Item_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'DAPSResponseInfo')))
    E_RABs_Admitted_Item_ExtIEs._val = ASN1Set(rv=[dict([('id', 366), ('criticality', 'reject'), ('Extension', _E_RABs_Admitted_Item_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< HandoverPreparationFailure >-----#
    HandoverPreparationFailure = SEQ(name='HandoverPreparationFailure', mode=MODE_TYPE)
    _HandoverPreparationFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __HandoverPreparationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___HandoverPreparationFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____HandoverPreparationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    ____HandoverPreparationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'ignore'), ('Value', _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 156), ('criticality', 'ignore'), ('Value', _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 364), ('criticality', 'reject'), ('Value', _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___HandoverPreparationFailure_protocolIEs__item__id._const_tab = ____HandoverPreparationFailure_protocolIEs__item__id_tab
    ___HandoverPreparationFailure_protocolIEs__item__id._const_tab_at = None
    ___HandoverPreparationFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___HandoverPreparationFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___HandoverPreparationFailure_protocolIEs__item__criticality._const_tab = ____HandoverPreparationFailure_protocolIEs__item__id_tab
    ___HandoverPreparationFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___HandoverPreparationFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___HandoverPreparationFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___HandoverPreparationFailure_protocolIEs__item__value._const_tab = ____HandoverPreparationFailure_protocolIEs__item__id_tab
    ___HandoverPreparationFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___HandoverPreparationFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __HandoverPreparationFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___HandoverPreparationFailure_protocolIEs__item__id),
        ('criticality', ___HandoverPreparationFailure_protocolIEs__item__criticality),
        ('value', ___HandoverPreparationFailure_protocolIEs__item__value),
        ])
    __HandoverPreparationFailure_protocolIEs__item_._ext = None
    _HandoverPreparationFailure_protocolIEs._cont = __HandoverPreparationFailure_protocolIEs__item_
    _HandoverPreparationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    HandoverPreparationFailure._cont = ASN1Dict([
        ('protocolIEs', _HandoverPreparationFailure_protocolIEs),
        ])
    HandoverPreparationFailure._ext = []
    
    #-----< HandoverPreparationFailure-IEs >-----#
    HandoverPreparationFailure_IEs = CLASS(name='HandoverPreparationFailure-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _HandoverPreparationFailure_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _HandoverPreparationFailure_IEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _HandoverPreparationFailure_IEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _HandoverPreparationFailure_IEs_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _HandoverPreparationFailure_IEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    HandoverPreparationFailure_IEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'ignore'), ('Value', _HandoverPreparationFailure_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _HandoverPreparationFailure_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _HandoverPreparationFailure_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 156), ('criticality', 'ignore'), ('Value', _HandoverPreparationFailure_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 364), ('criticality', 'reject'), ('Value', _HandoverPreparationFailure_IEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< HandoverReport >-----#
    HandoverReport = SEQ(name='HandoverReport', mode=MODE_TYPE)
    _HandoverReport_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __HandoverReport_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___HandoverReport_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____HandoverReport_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____HandoverReport_protocolIEs__item__id_tab_val_Value_0 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'HandoverReportType')))
    _____HandoverReport_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _____HandoverReport_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _____HandoverReport_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _____HandoverReport_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _____HandoverReport_protocolIEs__item__id_tab_val_Value_5 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TargetCellInUTRAN')))
    _____HandoverReport_protocolIEs__item__id_tab_val_Value_6 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CRNTI')))
    _____HandoverReport_protocolIEs__item__id_tab_val_Value_7 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'MobilityInformation')))
    _____HandoverReport_protocolIEs__item__id_tab_val_Value_8 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-RLF-Report-Container')))
    _____HandoverReport_protocolIEs__item__id_tab_val_Value_9 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-RLF-Report-Container-for-extended-bands')))
    _____HandoverReport_protocolIEs__item__id_tab_val_Value_10 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TargetCellInNGRAN')))
    ____HandoverReport_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 54), ('criticality', 'ignore'), ('Value', _____HandoverReport_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _____HandoverReport_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 52), ('criticality', 'ignore'), ('Value', _____HandoverReport_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 53), ('criticality', 'ignore'), ('Value', _____HandoverReport_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 49), ('criticality', 'ignore'), ('Value', _____HandoverReport_protocolIEs__item__id_tab_val_Value_4), ('presence', 'conditional')]), dict([('id', 81), ('criticality', 'ignore'), ('Value', _____HandoverReport_protocolIEs__item__id_tab_val_Value_5), ('presence', 'conditional')]), dict([('id', 83), ('criticality', 'ignore'), ('Value', _____HandoverReport_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 82), ('criticality', 'ignore'), ('Value', _____HandoverReport_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')]), dict([('id', 60), ('criticality', 'ignore'), ('Value', _____HandoverReport_protocolIEs__item__id_tab_val_Value_8), ('presence', 'optional')]), dict([('id', 107), ('criticality', 'ignore'), ('Value', _____HandoverReport_protocolIEs__item__id_tab_val_Value_9), ('presence', 'optional')]), dict([('id', 382), ('criticality', 'ignore'), ('Value', _____HandoverReport_protocolIEs__item__id_tab_val_Value_10), ('presence', 'conditional')])], rr=[], ev=None, er=[])
    ___HandoverReport_protocolIEs__item__id._const_tab = ____HandoverReport_protocolIEs__item__id_tab
    ___HandoverReport_protocolIEs__item__id._const_tab_at = None
    ___HandoverReport_protocolIEs__item__id._const_tab_id = 'id'
    ___HandoverReport_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___HandoverReport_protocolIEs__item__criticality._const_tab = ____HandoverReport_protocolIEs__item__id_tab
    ___HandoverReport_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___HandoverReport_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___HandoverReport_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___HandoverReport_protocolIEs__item__value._const_tab = ____HandoverReport_protocolIEs__item__id_tab
    ___HandoverReport_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___HandoverReport_protocolIEs__item__value._const_tab_id = 'Value'
    __HandoverReport_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___HandoverReport_protocolIEs__item__id),
        ('criticality', ___HandoverReport_protocolIEs__item__criticality),
        ('value', ___HandoverReport_protocolIEs__item__value),
        ])
    __HandoverReport_protocolIEs__item_._ext = None
    _HandoverReport_protocolIEs._cont = __HandoverReport_protocolIEs__item_
    _HandoverReport_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    HandoverReport._cont = ASN1Dict([
        ('protocolIEs', _HandoverReport_protocolIEs),
        ])
    HandoverReport._ext = []
    
    #-----< HandoverReport-IEs >-----#
    HandoverReport_IEs = CLASS(name='HandoverReport-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _HandoverReport_IEs_val_Value_0 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'HandoverReportType')))
    _HandoverReport_IEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _HandoverReport_IEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _HandoverReport_IEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _HandoverReport_IEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _HandoverReport_IEs_val_Value_5 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TargetCellInUTRAN')))
    _HandoverReport_IEs_val_Value_6 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CRNTI')))
    _HandoverReport_IEs_val_Value_7 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'MobilityInformation')))
    _HandoverReport_IEs_val_Value_8 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-RLF-Report-Container')))
    _HandoverReport_IEs_val_Value_9 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-RLF-Report-Container-for-extended-bands')))
    _HandoverReport_IEs_val_Value_10 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TargetCellInNGRAN')))
    HandoverReport_IEs._val = ASN1Set(rv=[dict([('id', 54), ('criticality', 'ignore'), ('Value', _HandoverReport_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _HandoverReport_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 52), ('criticality', 'ignore'), ('Value', _HandoverReport_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 53), ('criticality', 'ignore'), ('Value', _HandoverReport_IEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 49), ('criticality', 'ignore'), ('Value', _HandoverReport_IEs_val_Value_4), ('presence', 'conditional')]), dict([('id', 81), ('criticality', 'ignore'), ('Value', _HandoverReport_IEs_val_Value_5), ('presence', 'conditional')]), dict([('id', 83), ('criticality', 'ignore'), ('Value', _HandoverReport_IEs_val_Value_6), ('presence', 'optional')]), dict([('id', 82), ('criticality', 'ignore'), ('Value', _HandoverReport_IEs_val_Value_7), ('presence', 'optional')]), dict([('id', 60), ('criticality', 'ignore'), ('Value', _HandoverReport_IEs_val_Value_8), ('presence', 'optional')]), dict([('id', 107), ('criticality', 'ignore'), ('Value', _HandoverReport_IEs_val_Value_9), ('presence', 'optional')]), dict([('id', 382), ('criticality', 'ignore'), ('Value', _HandoverReport_IEs_val_Value_10), ('presence', 'conditional')])], rr=[], ev=[], er=[])
    
    #-----< EarlyStatusTransfer >-----#
    EarlyStatusTransfer = SEQ(name='EarlyStatusTransfer', mode=MODE_TYPE)
    _EarlyStatusTransfer_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __EarlyStatusTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___EarlyStatusTransfer_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____EarlyStatusTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____EarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____EarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____EarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____EarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____EarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_4 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ProcedureStageChoice')))
    _____EarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_5 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNB-UE-X2AP-ID')))
    ____EarlyStatusTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _____EarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 9), ('criticality', 'reject'), ('Value', _____EarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 156), ('criticality', 'reject'), ('Value', _____EarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 155), ('criticality', 'reject'), ('Value', _____EarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 367), ('criticality', 'reject'), ('Value', _____EarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_4), ('presence', 'mandatory')]), dict([('id', 207), ('criticality', 'ignore'), ('Value', _____EarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___EarlyStatusTransfer_protocolIEs__item__id._const_tab = ____EarlyStatusTransfer_protocolIEs__item__id_tab
    ___EarlyStatusTransfer_protocolIEs__item__id._const_tab_at = None
    ___EarlyStatusTransfer_protocolIEs__item__id._const_tab_id = 'id'
    ___EarlyStatusTransfer_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___EarlyStatusTransfer_protocolIEs__item__criticality._const_tab = ____EarlyStatusTransfer_protocolIEs__item__id_tab
    ___EarlyStatusTransfer_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___EarlyStatusTransfer_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___EarlyStatusTransfer_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___EarlyStatusTransfer_protocolIEs__item__value._const_tab = ____EarlyStatusTransfer_protocolIEs__item__id_tab
    ___EarlyStatusTransfer_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___EarlyStatusTransfer_protocolIEs__item__value._const_tab_id = 'Value'
    __EarlyStatusTransfer_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___EarlyStatusTransfer_protocolIEs__item__id),
        ('criticality', ___EarlyStatusTransfer_protocolIEs__item__criticality),
        ('value', ___EarlyStatusTransfer_protocolIEs__item__value),
        ])
    __EarlyStatusTransfer_protocolIEs__item_._ext = None
    _EarlyStatusTransfer_protocolIEs._cont = __EarlyStatusTransfer_protocolIEs__item_
    _EarlyStatusTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    EarlyStatusTransfer._cont = ASN1Dict([
        ('protocolIEs', _EarlyStatusTransfer_protocolIEs),
        ])
    EarlyStatusTransfer._ext = []
    
    #-----< EarlyStatusTransfer-IEs >-----#
    EarlyStatusTransfer_IEs = CLASS(name='EarlyStatusTransfer-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _EarlyStatusTransfer_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _EarlyStatusTransfer_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _EarlyStatusTransfer_IEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _EarlyStatusTransfer_IEs_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _EarlyStatusTransfer_IEs_val_Value_4 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ProcedureStageChoice')))
    _EarlyStatusTransfer_IEs_val_Value_5 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNB-UE-X2AP-ID')))
    EarlyStatusTransfer_IEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _EarlyStatusTransfer_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 9), ('criticality', 'reject'), ('Value', _EarlyStatusTransfer_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 156), ('criticality', 'reject'), ('Value', _EarlyStatusTransfer_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 155), ('criticality', 'reject'), ('Value', _EarlyStatusTransfer_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 367), ('criticality', 'reject'), ('Value', _EarlyStatusTransfer_IEs_val_Value_4), ('presence', 'mandatory')]), dict([('id', 207), ('criticality', 'ignore'), ('Value', _EarlyStatusTransfer_IEs_val_Value_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ProcedureStageChoice >-----#
    ProcedureStageChoice = CHOICE(name='ProcedureStageChoice', mode=MODE_TYPE)
    _ProcedureStageChoice_first_dl_count = SEQ(name='first-dl-count', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'FirstDLCount')))
    _ProcedureStageChoice_dl_discarding = SEQ(name='dl-discarding', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'DLDiscarding')))
    _ProcedureStageChoice_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __ProcedureStageChoice_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ___ProcedureStageChoice_choice_extension_id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ___ProcedureStageChoice_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ProcedureStageChoice_choice_extension_id._const_tab = ___ProcedureStageChoice_choice_extension_id_tab
    __ProcedureStageChoice_choice_extension_id._const_tab_at = None
    __ProcedureStageChoice_choice_extension_id._const_tab_id = 'id'
    __ProcedureStageChoice_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___ProcedureStageChoice_choice_extension_criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ___ProcedureStageChoice_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ProcedureStageChoice_choice_extension_criticality._const_tab = ___ProcedureStageChoice_choice_extension_criticality_tab
    __ProcedureStageChoice_choice_extension_criticality._const_tab_at = ('..', 'id')
    __ProcedureStageChoice_choice_extension_criticality._const_tab_id = 'criticality'
    __ProcedureStageChoice_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___ProcedureStageChoice_choice_extension_value_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ___ProcedureStageChoice_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ProcedureStageChoice_choice_extension_value._const_tab = ___ProcedureStageChoice_choice_extension_value_tab
    __ProcedureStageChoice_choice_extension_value._const_tab_at = ('..', 'id')
    __ProcedureStageChoice_choice_extension_value._const_tab_id = 'Value'
    _ProcedureStageChoice_choice_extension._cont = ASN1Dict([
        ('id', __ProcedureStageChoice_choice_extension_id),
        ('criticality', __ProcedureStageChoice_choice_extension_criticality),
        ('value', __ProcedureStageChoice_choice_extension_value),
        ])
    _ProcedureStageChoice_choice_extension._ext = None
    ProcedureStageChoice._cont = ASN1Dict([
        ('first-dl-count', _ProcedureStageChoice_first_dl_count),
        ('dl-discarding', _ProcedureStageChoice_dl_discarding),
        ('choice-extension', _ProcedureStageChoice_choice_extension),
        ])
    ProcedureStageChoice._ext = None
    
    #-----< ProcedureStageChoice-ExtIEs >-----#
    ProcedureStageChoice_ExtIEs = CLASS(name='ProcedureStageChoice-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ProcedureStageChoice_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< FirstDLCount >-----#
    FirstDLCount = SEQ(name='FirstDLCount', mode=MODE_TYPE)
    _FirstDLCount_e_RABsSubjectToEarlyStatusTransfer = SEQ_OF(name='e-RABsSubjectToEarlyStatusTransfer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RABsSubjectToEarlyStatusTransfer-List')))
    _FirstDLCount_iE_Extension = SEQ_OF(name='iE-Extension', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __FirstDLCount_iE_Extension__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___FirstDLCount_iE_Extension__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____FirstDLCount_iE_Extension__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____FirstDLCount_iE_Extension__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FirstDLCount_iE_Extension__item__id._const_tab = ____FirstDLCount_iE_Extension__item__id_tab
    ___FirstDLCount_iE_Extension__item__id._const_tab_at = None
    ___FirstDLCount_iE_Extension__item__id._const_tab_id = 'id'
    ___FirstDLCount_iE_Extension__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____FirstDLCount_iE_Extension__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____FirstDLCount_iE_Extension__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FirstDLCount_iE_Extension__item__criticality._const_tab = ____FirstDLCount_iE_Extension__item__criticality_tab
    ___FirstDLCount_iE_Extension__item__criticality._const_tab_at = ('..', 'id')
    ___FirstDLCount_iE_Extension__item__criticality._const_tab_id = 'criticality'
    ___FirstDLCount_iE_Extension__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____FirstDLCount_iE_Extension__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____FirstDLCount_iE_Extension__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FirstDLCount_iE_Extension__item__extensionValue._const_tab = ____FirstDLCount_iE_Extension__item__extensionValue_tab
    ___FirstDLCount_iE_Extension__item__extensionValue._const_tab_at = ('..', 'id')
    ___FirstDLCount_iE_Extension__item__extensionValue._const_tab_id = 'Extension'
    __FirstDLCount_iE_Extension__item_._cont = ASN1Dict([
        ('id', ___FirstDLCount_iE_Extension__item__id),
        ('criticality', ___FirstDLCount_iE_Extension__item__criticality),
        ('extensionValue', ___FirstDLCount_iE_Extension__item__extensionValue),
        ])
    __FirstDLCount_iE_Extension__item_._ext = None
    _FirstDLCount_iE_Extension._cont = __FirstDLCount_iE_Extension__item_
    _FirstDLCount_iE_Extension._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    FirstDLCount._cont = ASN1Dict([
        ('e-RABsSubjectToEarlyStatusTransfer', _FirstDLCount_e_RABsSubjectToEarlyStatusTransfer),
        ('iE-Extension', _FirstDLCount_iE_Extension),
        ])
    FirstDLCount._ext = []
    
    #-----< FirstDLCount-ExtIEs >-----#
    FirstDLCount_ExtIEs = CLASS(name='FirstDLCount-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    FirstDLCount_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DLDiscarding >-----#
    DLDiscarding = SEQ(name='DLDiscarding', mode=MODE_TYPE)
    _DLDiscarding_e_RABsSubjectToDLDiscarding_List = SEQ_OF(name='e-RABsSubjectToDLDiscarding-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RABsSubjectToDLDiscarding-List')))
    _DLDiscarding_iE_Extension = SEQ_OF(name='iE-Extension', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DLDiscarding_iE_Extension__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___DLDiscarding_iE_Extension__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____DLDiscarding_iE_Extension__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____DLDiscarding_iE_Extension__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DLDiscarding_iE_Extension__item__id._const_tab = ____DLDiscarding_iE_Extension__item__id_tab
    ___DLDiscarding_iE_Extension__item__id._const_tab_at = None
    ___DLDiscarding_iE_Extension__item__id._const_tab_id = 'id'
    ___DLDiscarding_iE_Extension__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DLDiscarding_iE_Extension__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____DLDiscarding_iE_Extension__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DLDiscarding_iE_Extension__item__criticality._const_tab = ____DLDiscarding_iE_Extension__item__criticality_tab
    ___DLDiscarding_iE_Extension__item__criticality._const_tab_at = ('..', 'id')
    ___DLDiscarding_iE_Extension__item__criticality._const_tab_id = 'criticality'
    ___DLDiscarding_iE_Extension__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DLDiscarding_iE_Extension__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____DLDiscarding_iE_Extension__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DLDiscarding_iE_Extension__item__extensionValue._const_tab = ____DLDiscarding_iE_Extension__item__extensionValue_tab
    ___DLDiscarding_iE_Extension__item__extensionValue._const_tab_at = ('..', 'id')
    ___DLDiscarding_iE_Extension__item__extensionValue._const_tab_id = 'Extension'
    __DLDiscarding_iE_Extension__item_._cont = ASN1Dict([
        ('id', ___DLDiscarding_iE_Extension__item__id),
        ('criticality', ___DLDiscarding_iE_Extension__item__criticality),
        ('extensionValue', ___DLDiscarding_iE_Extension__item__extensionValue),
        ])
    __DLDiscarding_iE_Extension__item_._ext = None
    _DLDiscarding_iE_Extension._cont = __DLDiscarding_iE_Extension__item_
    _DLDiscarding_iE_Extension._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DLDiscarding._cont = ASN1Dict([
        ('e-RABsSubjectToDLDiscarding-List', _DLDiscarding_e_RABsSubjectToDLDiscarding_List),
        ('iE-Extension', _DLDiscarding_iE_Extension),
        ])
    DLDiscarding._ext = []
    
    #-----< DLDiscarding-ExtIEs >-----#
    DLDiscarding_ExtIEs = CLASS(name='DLDiscarding-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    DLDiscarding_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SNStatusTransfer >-----#
    SNStatusTransfer = SEQ(name='SNStatusTransfer', mode=MODE_TYPE)
    _SNStatusTransfer_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __SNStatusTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___SNStatusTransfer_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____SNStatusTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____SNStatusTransfer_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SNStatusTransfer_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SNStatusTransfer_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-SubjectToStatusTransfer-List')))
    _____SNStatusTransfer_protocolIEs__item__id_tab_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____SNStatusTransfer_protocolIEs__item__id_tab_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____SNStatusTransfer_protocolIEs__item__id_tab_val_Value_5 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNB-UE-X2AP-ID')))
    ____SNStatusTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _____SNStatusTransfer_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 9), ('criticality', 'reject'), ('Value', _____SNStatusTransfer_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 18), ('criticality', 'ignore'), ('Value', _____SNStatusTransfer_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 156), ('criticality', 'reject'), ('Value', _____SNStatusTransfer_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 155), ('criticality', 'reject'), ('Value', _____SNStatusTransfer_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 207), ('criticality', 'ignore'), ('Value', _____SNStatusTransfer_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SNStatusTransfer_protocolIEs__item__id._const_tab = ____SNStatusTransfer_protocolIEs__item__id_tab
    ___SNStatusTransfer_protocolIEs__item__id._const_tab_at = None
    ___SNStatusTransfer_protocolIEs__item__id._const_tab_id = 'id'
    ___SNStatusTransfer_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___SNStatusTransfer_protocolIEs__item__criticality._const_tab = ____SNStatusTransfer_protocolIEs__item__id_tab
    ___SNStatusTransfer_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___SNStatusTransfer_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___SNStatusTransfer_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___SNStatusTransfer_protocolIEs__item__value._const_tab = ____SNStatusTransfer_protocolIEs__item__id_tab
    ___SNStatusTransfer_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___SNStatusTransfer_protocolIEs__item__value._const_tab_id = 'Value'
    __SNStatusTransfer_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___SNStatusTransfer_protocolIEs__item__id),
        ('criticality', ___SNStatusTransfer_protocolIEs__item__criticality),
        ('value', ___SNStatusTransfer_protocolIEs__item__value),
        ])
    __SNStatusTransfer_protocolIEs__item_._ext = None
    _SNStatusTransfer_protocolIEs._cont = __SNStatusTransfer_protocolIEs__item_
    _SNStatusTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    SNStatusTransfer._cont = ASN1Dict([
        ('protocolIEs', _SNStatusTransfer_protocolIEs),
        ])
    SNStatusTransfer._ext = []
    
    #-----< SNStatusTransfer-IEs >-----#
    SNStatusTransfer_IEs = CLASS(name='SNStatusTransfer-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _SNStatusTransfer_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SNStatusTransfer_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SNStatusTransfer_IEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-SubjectToStatusTransfer-List')))
    _SNStatusTransfer_IEs_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _SNStatusTransfer_IEs_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _SNStatusTransfer_IEs_val_Value_5 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNB-UE-X2AP-ID')))
    SNStatusTransfer_IEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _SNStatusTransfer_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 9), ('criticality', 'reject'), ('Value', _SNStatusTransfer_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 18), ('criticality', 'ignore'), ('Value', _SNStatusTransfer_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 156), ('criticality', 'reject'), ('Value', _SNStatusTransfer_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 155), ('criticality', 'reject'), ('Value', _SNStatusTransfer_IEs_val_Value_4), ('presence', 'optional')]), dict([('id', 207), ('criticality', 'ignore'), ('Value', _SNStatusTransfer_IEs_val_Value_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-SubjectToStatusTransfer-List >-----#
    E_RABs_SubjectToStatusTransfer_List = SEQ_OF(name='E-RABs-SubjectToStatusTransfer-List', mode=MODE_TYPE)
    _E_RABs_SubjectToStatusTransfer_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __E_RABs_SubjectToStatusTransfer_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ___E_RABs_SubjectToStatusTransfer_List__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____E_RABs_SubjectToStatusTransfer_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-SubjectToStatusTransfer-Item')))
    ___E_RABs_SubjectToStatusTransfer_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 19), ('criticality', 'ignore'), ('Value', ____E_RABs_SubjectToStatusTransfer_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E_RABs_SubjectToStatusTransfer_List__item__id._const_tab = ___E_RABs_SubjectToStatusTransfer_List__item__id_tab
    __E_RABs_SubjectToStatusTransfer_List__item__id._const_tab_at = None
    __E_RABs_SubjectToStatusTransfer_List__item__id._const_tab_id = 'id'
    __E_RABs_SubjectToStatusTransfer_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    __E_RABs_SubjectToStatusTransfer_List__item__criticality._const_tab = ___E_RABs_SubjectToStatusTransfer_List__item__id_tab
    __E_RABs_SubjectToStatusTransfer_List__item__criticality._const_tab_at = ('..', 'id')
    __E_RABs_SubjectToStatusTransfer_List__item__criticality._const_tab_id = 'criticality'
    __E_RABs_SubjectToStatusTransfer_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    __E_RABs_SubjectToStatusTransfer_List__item__value._const_tab = ___E_RABs_SubjectToStatusTransfer_List__item__id_tab
    __E_RABs_SubjectToStatusTransfer_List__item__value._const_tab_at = ('..', 'id')
    __E_RABs_SubjectToStatusTransfer_List__item__value._const_tab_id = 'Value'
    _E_RABs_SubjectToStatusTransfer_List__item_._cont = ASN1Dict([
        ('id', __E_RABs_SubjectToStatusTransfer_List__item__id),
        ('criticality', __E_RABs_SubjectToStatusTransfer_List__item__criticality),
        ('value', __E_RABs_SubjectToStatusTransfer_List__item__value),
        ])
    _E_RABs_SubjectToStatusTransfer_List__item_._ext = None
    E_RABs_SubjectToStatusTransfer_List._cont = _E_RABs_SubjectToStatusTransfer_List__item_
    E_RABs_SubjectToStatusTransfer_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABs-SubjectToStatusTransfer-ItemIEs >-----#
    E_RABs_SubjectToStatusTransfer_ItemIEs = CLASS(name='E-RABs-SubjectToStatusTransfer-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _E_RABs_SubjectToStatusTransfer_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-SubjectToStatusTransfer-Item')))
    E_RABs_SubjectToStatusTransfer_ItemIEs._val = ASN1Set(rv=[dict([('id', 19), ('criticality', 'ignore'), ('Value', _E_RABs_SubjectToStatusTransfer_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< E-RABs-SubjectToStatusTransfer-Item >-----#
    E_RABs_SubjectToStatusTransfer_Item = SEQ(name='E-RABs-SubjectToStatusTransfer-Item', mode=MODE_TYPE)
    _E_RABs_SubjectToStatusTransfer_Item_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_SubjectToStatusTransfer_Item_receiveStatusofULPDCPSDUs = BIT_STR(name='receiveStatusofULPDCPSDUs', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ReceiveStatusofULPDCPSDUs')), opt=True)
    _E_RABs_SubjectToStatusTransfer_Item_uL_COUNTvalue = SEQ(name='uL-COUNTvalue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'COUNTvalue')))
    _E_RABs_SubjectToStatusTransfer_Item_dL_COUNTvalue = SEQ(name='dL-COUNTvalue', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'COUNTvalue')))
    _E_RABs_SubjectToStatusTransfer_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_0 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ReceiveStatusOfULPDCPSDUsExtended')))
    _____E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'COUNTValueExtended')))
    _____E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'COUNTValueExtended')))
    _____E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_3 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ReceiveStatusOfULPDCPSDUsPDCP-SNlength18')))
    _____E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'COUNTvaluePDCP-SNlength18')))
    _____E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'COUNTvaluePDCP-SNlength18')))
    ____E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 91), ('criticality', 'ignore'), ('Extension', _____E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 92), ('criticality', 'ignore'), ('Extension', _____E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 93), ('criticality', 'ignore'), ('Extension', _____E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 150), ('criticality', 'ignore'), ('Extension', _____E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 151), ('criticality', 'ignore'), ('Extension', _____E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 152), ('criticality', 'ignore'), ('Extension', _____E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__id._const_tab = ____E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab
    ___E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__criticality._const_tab = ____E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab
    ___E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab
    ___E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__id),
        ('criticality', ___E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item_._ext = None
    _E_RABs_SubjectToStatusTransfer_Item_iE_Extensions._cont = __E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item_
    _E_RABs_SubjectToStatusTransfer_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_SubjectToStatusTransfer_Item._cont = ASN1Dict([
        ('e-RAB-ID', _E_RABs_SubjectToStatusTransfer_Item_e_RAB_ID),
        ('receiveStatusofULPDCPSDUs', _E_RABs_SubjectToStatusTransfer_Item_receiveStatusofULPDCPSDUs),
        ('uL-COUNTvalue', _E_RABs_SubjectToStatusTransfer_Item_uL_COUNTvalue),
        ('dL-COUNTvalue', _E_RABs_SubjectToStatusTransfer_Item_dL_COUNTvalue),
        ('iE-Extensions', _E_RABs_SubjectToStatusTransfer_Item_iE_Extensions),
        ])
    E_RABs_SubjectToStatusTransfer_Item._ext = []
    
    #-----< E-RABs-SubjectToStatusTransfer-ItemExtIEs >-----#
    E_RABs_SubjectToStatusTransfer_ItemExtIEs = CLASS(name='E-RABs-SubjectToStatusTransfer-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _E_RABs_SubjectToStatusTransfer_ItemExtIEs_val_Extension_0 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ReceiveStatusOfULPDCPSDUsExtended')))
    _E_RABs_SubjectToStatusTransfer_ItemExtIEs_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'COUNTValueExtended')))
    _E_RABs_SubjectToStatusTransfer_ItemExtIEs_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'COUNTValueExtended')))
    _E_RABs_SubjectToStatusTransfer_ItemExtIEs_val_Extension_3 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ReceiveStatusOfULPDCPSDUsPDCP-SNlength18')))
    _E_RABs_SubjectToStatusTransfer_ItemExtIEs_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'COUNTvaluePDCP-SNlength18')))
    _E_RABs_SubjectToStatusTransfer_ItemExtIEs_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'COUNTvaluePDCP-SNlength18')))
    E_RABs_SubjectToStatusTransfer_ItemExtIEs._val = ASN1Set(rv=[dict([('id', 91), ('criticality', 'ignore'), ('Extension', _E_RABs_SubjectToStatusTransfer_ItemExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 92), ('criticality', 'ignore'), ('Extension', _E_RABs_SubjectToStatusTransfer_ItemExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 93), ('criticality', 'ignore'), ('Extension', _E_RABs_SubjectToStatusTransfer_ItemExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 150), ('criticality', 'ignore'), ('Extension', _E_RABs_SubjectToStatusTransfer_ItemExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 151), ('criticality', 'ignore'), ('Extension', _E_RABs_SubjectToStatusTransfer_ItemExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 152), ('criticality', 'ignore'), ('Extension', _E_RABs_SubjectToStatusTransfer_ItemExtIEs_val_Extension_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UEContextRelease >-----#
    UEContextRelease = SEQ(name='UEContextRelease', mode=MODE_TYPE)
    _UEContextRelease_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __UEContextRelease_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___UEContextRelease_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____UEContextRelease_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____UEContextRelease_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____UEContextRelease_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____UEContextRelease_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____UEContextRelease_protocolIEs__item__id_tab_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____UEContextRelease_protocolIEs__item__id_tab_val_Value_4 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SIPTOBearerDeactivationIndication')))
    _____UEContextRelease_protocolIEs__item__id_tab_val_Value_5 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNB-UE-X2AP-ID')))
    ____UEContextRelease_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _____UEContextRelease_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 9), ('criticality', 'reject'), ('Value', _____UEContextRelease_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 156), ('criticality', 'reject'), ('Value', _____UEContextRelease_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 155), ('criticality', 'reject'), ('Value', _____UEContextRelease_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 164), ('criticality', 'ignore'), ('Value', _____UEContextRelease_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 207), ('criticality', 'ignore'), ('Value', _____UEContextRelease_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UEContextRelease_protocolIEs__item__id._const_tab = ____UEContextRelease_protocolIEs__item__id_tab
    ___UEContextRelease_protocolIEs__item__id._const_tab_at = None
    ___UEContextRelease_protocolIEs__item__id._const_tab_id = 'id'
    ___UEContextRelease_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___UEContextRelease_protocolIEs__item__criticality._const_tab = ____UEContextRelease_protocolIEs__item__id_tab
    ___UEContextRelease_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UEContextRelease_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UEContextRelease_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___UEContextRelease_protocolIEs__item__value._const_tab = ____UEContextRelease_protocolIEs__item__id_tab
    ___UEContextRelease_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UEContextRelease_protocolIEs__item__value._const_tab_id = 'Value'
    __UEContextRelease_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UEContextRelease_protocolIEs__item__id),
        ('criticality', ___UEContextRelease_protocolIEs__item__criticality),
        ('value', ___UEContextRelease_protocolIEs__item__value),
        ])
    __UEContextRelease_protocolIEs__item_._ext = None
    _UEContextRelease_protocolIEs._cont = __UEContextRelease_protocolIEs__item_
    _UEContextRelease_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextRelease._cont = ASN1Dict([
        ('protocolIEs', _UEContextRelease_protocolIEs),
        ])
    UEContextRelease._ext = []
    
    #-----< UEContextRelease-IEs >-----#
    UEContextRelease_IEs = CLASS(name='UEContextRelease-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _UEContextRelease_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _UEContextRelease_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _UEContextRelease_IEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _UEContextRelease_IEs_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _UEContextRelease_IEs_val_Value_4 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SIPTOBearerDeactivationIndication')))
    _UEContextRelease_IEs_val_Value_5 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNB-UE-X2AP-ID')))
    UEContextRelease_IEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _UEContextRelease_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 9), ('criticality', 'reject'), ('Value', _UEContextRelease_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 156), ('criticality', 'reject'), ('Value', _UEContextRelease_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 155), ('criticality', 'reject'), ('Value', _UEContextRelease_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 164), ('criticality', 'ignore'), ('Value', _UEContextRelease_IEs_val_Value_4), ('presence', 'optional')]), dict([('id', 207), ('criticality', 'ignore'), ('Value', _UEContextRelease_IEs_val_Value_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< HandoverCancel >-----#
    HandoverCancel = SEQ(name='HandoverCancel', mode=MODE_TYPE)
    _HandoverCancel_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __HandoverCancel_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___HandoverCancel_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____HandoverCancel_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____HandoverCancel_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____HandoverCancel_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____HandoverCancel_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _____HandoverCancel_protocolIEs__item__id_tab_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____HandoverCancel_protocolIEs__item__id_tab_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____HandoverCancel_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CandidateCellsToBeCancelledList')))
    ____HandoverCancel_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _____HandoverCancel_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _____HandoverCancel_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _____HandoverCancel_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 156), ('criticality', 'reject'), ('Value', _____HandoverCancel_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 155), ('criticality', 'ignore'), ('Value', _____HandoverCancel_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 365), ('criticality', 'reject'), ('Value', _____HandoverCancel_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___HandoverCancel_protocolIEs__item__id._const_tab = ____HandoverCancel_protocolIEs__item__id_tab
    ___HandoverCancel_protocolIEs__item__id._const_tab_at = None
    ___HandoverCancel_protocolIEs__item__id._const_tab_id = 'id'
    ___HandoverCancel_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___HandoverCancel_protocolIEs__item__criticality._const_tab = ____HandoverCancel_protocolIEs__item__id_tab
    ___HandoverCancel_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___HandoverCancel_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___HandoverCancel_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___HandoverCancel_protocolIEs__item__value._const_tab = ____HandoverCancel_protocolIEs__item__id_tab
    ___HandoverCancel_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___HandoverCancel_protocolIEs__item__value._const_tab_id = 'Value'
    __HandoverCancel_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___HandoverCancel_protocolIEs__item__id),
        ('criticality', ___HandoverCancel_protocolIEs__item__criticality),
        ('value', ___HandoverCancel_protocolIEs__item__value),
        ])
    __HandoverCancel_protocolIEs__item_._ext = None
    _HandoverCancel_protocolIEs._cont = __HandoverCancel_protocolIEs__item_
    _HandoverCancel_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    HandoverCancel._cont = ASN1Dict([
        ('protocolIEs', _HandoverCancel_protocolIEs),
        ])
    HandoverCancel._ext = []
    
    #-----< HandoverCancel-IEs >-----#
    HandoverCancel_IEs = CLASS(name='HandoverCancel-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _HandoverCancel_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _HandoverCancel_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _HandoverCancel_IEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _HandoverCancel_IEs_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _HandoverCancel_IEs_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _HandoverCancel_IEs_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CandidateCellsToBeCancelledList')))
    HandoverCancel_IEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _HandoverCancel_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _HandoverCancel_IEs_val_Value_1), ('presence', 'optional')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _HandoverCancel_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 156), ('criticality', 'reject'), ('Value', _HandoverCancel_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 155), ('criticality', 'ignore'), ('Value', _HandoverCancel_IEs_val_Value_4), ('presence', 'optional')]), dict([('id', 365), ('criticality', 'reject'), ('Value', _HandoverCancel_IEs_val_Value_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< HandoverSuccess >-----#
    HandoverSuccess = SEQ(name='HandoverSuccess', mode=MODE_TYPE)
    _HandoverSuccess_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __HandoverSuccess_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___HandoverSuccess_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____HandoverSuccess_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____HandoverSuccess_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____HandoverSuccess_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____HandoverSuccess_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____HandoverSuccess_protocolIEs__item__id_tab_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____HandoverSuccess_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    ____HandoverSuccess_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _____HandoverSuccess_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 9), ('criticality', 'reject'), ('Value', _____HandoverSuccess_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 156), ('criticality', 'ignore'), ('Value', _____HandoverSuccess_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 155), ('criticality', 'ignore'), ('Value', _____HandoverSuccess_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 11), ('criticality', 'reject'), ('Value', _____HandoverSuccess_protocolIEs__item__id_tab_val_Value_4), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___HandoverSuccess_protocolIEs__item__id._const_tab = ____HandoverSuccess_protocolIEs__item__id_tab
    ___HandoverSuccess_protocolIEs__item__id._const_tab_at = None
    ___HandoverSuccess_protocolIEs__item__id._const_tab_id = 'id'
    ___HandoverSuccess_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___HandoverSuccess_protocolIEs__item__criticality._const_tab = ____HandoverSuccess_protocolIEs__item__id_tab
    ___HandoverSuccess_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___HandoverSuccess_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___HandoverSuccess_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___HandoverSuccess_protocolIEs__item__value._const_tab = ____HandoverSuccess_protocolIEs__item__id_tab
    ___HandoverSuccess_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___HandoverSuccess_protocolIEs__item__value._const_tab_id = 'Value'
    __HandoverSuccess_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___HandoverSuccess_protocolIEs__item__id),
        ('criticality', ___HandoverSuccess_protocolIEs__item__criticality),
        ('value', ___HandoverSuccess_protocolIEs__item__value),
        ])
    __HandoverSuccess_protocolIEs__item_._ext = None
    _HandoverSuccess_protocolIEs._cont = __HandoverSuccess_protocolIEs__item_
    _HandoverSuccess_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    HandoverSuccess._cont = ASN1Dict([
        ('protocolIEs', _HandoverSuccess_protocolIEs),
        ])
    HandoverSuccess._ext = []
    
    #-----< HandoverSuccess-IEs >-----#
    HandoverSuccess_IEs = CLASS(name='HandoverSuccess-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _HandoverSuccess_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _HandoverSuccess_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _HandoverSuccess_IEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _HandoverSuccess_IEs_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _HandoverSuccess_IEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    HandoverSuccess_IEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _HandoverSuccess_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 9), ('criticality', 'reject'), ('Value', _HandoverSuccess_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 156), ('criticality', 'ignore'), ('Value', _HandoverSuccess_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 155), ('criticality', 'ignore'), ('Value', _HandoverSuccess_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 11), ('criticality', 'reject'), ('Value', _HandoverSuccess_IEs_val_Value_4), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< ConditionalHandoverCancel >-----#
    ConditionalHandoverCancel = SEQ(name='ConditionalHandoverCancel', mode=MODE_TYPE)
    _ConditionalHandoverCancel_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __ConditionalHandoverCancel_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___ConditionalHandoverCancel_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____ConditionalHandoverCancel_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____ConditionalHandoverCancel_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____ConditionalHandoverCancel_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____ConditionalHandoverCancel_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _____ConditionalHandoverCancel_protocolIEs__item__id_tab_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____ConditionalHandoverCancel_protocolIEs__item__id_tab_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____ConditionalHandoverCancel_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CandidateCellsToBeCancelledList')))
    ____ConditionalHandoverCancel_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _____ConditionalHandoverCancel_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _____ConditionalHandoverCancel_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _____ConditionalHandoverCancel_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 156), ('criticality', 'reject'), ('Value', _____ConditionalHandoverCancel_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 155), ('criticality', 'ignore'), ('Value', _____ConditionalHandoverCancel_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 365), ('criticality', 'reject'), ('Value', _____ConditionalHandoverCancel_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ConditionalHandoverCancel_protocolIEs__item__id._const_tab = ____ConditionalHandoverCancel_protocolIEs__item__id_tab
    ___ConditionalHandoverCancel_protocolIEs__item__id._const_tab_at = None
    ___ConditionalHandoverCancel_protocolIEs__item__id._const_tab_id = 'id'
    ___ConditionalHandoverCancel_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___ConditionalHandoverCancel_protocolIEs__item__criticality._const_tab = ____ConditionalHandoverCancel_protocolIEs__item__id_tab
    ___ConditionalHandoverCancel_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ConditionalHandoverCancel_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ConditionalHandoverCancel_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___ConditionalHandoverCancel_protocolIEs__item__value._const_tab = ____ConditionalHandoverCancel_protocolIEs__item__id_tab
    ___ConditionalHandoverCancel_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ConditionalHandoverCancel_protocolIEs__item__value._const_tab_id = 'Value'
    __ConditionalHandoverCancel_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ConditionalHandoverCancel_protocolIEs__item__id),
        ('criticality', ___ConditionalHandoverCancel_protocolIEs__item__criticality),
        ('value', ___ConditionalHandoverCancel_protocolIEs__item__value),
        ])
    __ConditionalHandoverCancel_protocolIEs__item_._ext = None
    _ConditionalHandoverCancel_protocolIEs._cont = __ConditionalHandoverCancel_protocolIEs__item_
    _ConditionalHandoverCancel_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ConditionalHandoverCancel._cont = ASN1Dict([
        ('protocolIEs', _ConditionalHandoverCancel_protocolIEs),
        ])
    ConditionalHandoverCancel._ext = []
    
    #-----< ConditionalHandoverCancel-IEs >-----#
    ConditionalHandoverCancel_IEs = CLASS(name='ConditionalHandoverCancel-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _ConditionalHandoverCancel_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _ConditionalHandoverCancel_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _ConditionalHandoverCancel_IEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _ConditionalHandoverCancel_IEs_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _ConditionalHandoverCancel_IEs_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _ConditionalHandoverCancel_IEs_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CandidateCellsToBeCancelledList')))
    ConditionalHandoverCancel_IEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _ConditionalHandoverCancel_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _ConditionalHandoverCancel_IEs_val_Value_1), ('presence', 'optional')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _ConditionalHandoverCancel_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 156), ('criticality', 'reject'), ('Value', _ConditionalHandoverCancel_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 155), ('criticality', 'ignore'), ('Value', _ConditionalHandoverCancel_IEs_val_Value_4), ('presence', 'optional')]), dict([('id', 365), ('criticality', 'reject'), ('Value', _ConditionalHandoverCancel_IEs_val_Value_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ErrorIndication >-----#
    ErrorIndication = SEQ(name='ErrorIndication', mode=MODE_TYPE)
    _ErrorIndication_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __ErrorIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___ErrorIndication_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____ErrorIndication_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_5 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_6 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNB-UE-X2AP-ID')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_7 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'InterfaceInstanceIndication')))
    ____ErrorIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'ignore'), ('Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 156), ('criticality', 'ignore'), ('Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 155), ('criticality', 'ignore'), ('Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 264), ('criticality', 'ignore'), ('Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 335), ('criticality', 'reject'), ('Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ErrorIndication_protocolIEs__item__id._const_tab = ____ErrorIndication_protocolIEs__item__id_tab
    ___ErrorIndication_protocolIEs__item__id._const_tab_at = None
    ___ErrorIndication_protocolIEs__item__id._const_tab_id = 'id'
    ___ErrorIndication_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___ErrorIndication_protocolIEs__item__criticality._const_tab = ____ErrorIndication_protocolIEs__item__id_tab
    ___ErrorIndication_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ErrorIndication_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ErrorIndication_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___ErrorIndication_protocolIEs__item__value._const_tab = ____ErrorIndication_protocolIEs__item__id_tab
    ___ErrorIndication_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ErrorIndication_protocolIEs__item__value._const_tab_id = 'Value'
    __ErrorIndication_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ErrorIndication_protocolIEs__item__id),
        ('criticality', ___ErrorIndication_protocolIEs__item__criticality),
        ('value', ___ErrorIndication_protocolIEs__item__value),
        ])
    __ErrorIndication_protocolIEs__item_._ext = None
    _ErrorIndication_protocolIEs._cont = __ErrorIndication_protocolIEs__item_
    _ErrorIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ErrorIndication._cont = ASN1Dict([
        ('protocolIEs', _ErrorIndication_protocolIEs),
        ])
    ErrorIndication._ext = []
    
    #-----< ErrorIndication-IEs >-----#
    ErrorIndication_IEs = CLASS(name='ErrorIndication-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _ErrorIndication_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _ErrorIndication_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _ErrorIndication_IEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _ErrorIndication_IEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _ErrorIndication_IEs_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _ErrorIndication_IEs_val_Value_5 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _ErrorIndication_IEs_val_Value_6 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNB-UE-X2AP-ID')))
    _ErrorIndication_IEs_val_Value_7 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'InterfaceInstanceIndication')))
    ErrorIndication_IEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'ignore'), ('Value', _ErrorIndication_IEs_val_Value_0), ('presence', 'optional')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _ErrorIndication_IEs_val_Value_1), ('presence', 'optional')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _ErrorIndication_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _ErrorIndication_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 156), ('criticality', 'ignore'), ('Value', _ErrorIndication_IEs_val_Value_4), ('presence', 'optional')]), dict([('id', 155), ('criticality', 'ignore'), ('Value', _ErrorIndication_IEs_val_Value_5), ('presence', 'optional')]), dict([('id', 264), ('criticality', 'ignore'), ('Value', _ErrorIndication_IEs_val_Value_6), ('presence', 'optional')]), dict([('id', 335), ('criticality', 'reject'), ('Value', _ErrorIndication_IEs_val_Value_7), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ResetRequest >-----#
    ResetRequest = SEQ(name='ResetRequest', mode=MODE_TYPE)
    _ResetRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __ResetRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___ResetRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____ResetRequest_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____ResetRequest_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _____ResetRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'InterfaceInstanceIndication')))
    ____ResetRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 5), ('criticality', 'ignore'), ('Value', _____ResetRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 335), ('criticality', 'reject'), ('Value', _____ResetRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ResetRequest_protocolIEs__item__id._const_tab = ____ResetRequest_protocolIEs__item__id_tab
    ___ResetRequest_protocolIEs__item__id._const_tab_at = None
    ___ResetRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___ResetRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___ResetRequest_protocolIEs__item__criticality._const_tab = ____ResetRequest_protocolIEs__item__id_tab
    ___ResetRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ResetRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ResetRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___ResetRequest_protocolIEs__item__value._const_tab = ____ResetRequest_protocolIEs__item__id_tab
    ___ResetRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ResetRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __ResetRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ResetRequest_protocolIEs__item__id),
        ('criticality', ___ResetRequest_protocolIEs__item__criticality),
        ('value', ___ResetRequest_protocolIEs__item__value),
        ])
    __ResetRequest_protocolIEs__item_._ext = None
    _ResetRequest_protocolIEs._cont = __ResetRequest_protocolIEs__item_
    _ResetRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ResetRequest._cont = ASN1Dict([
        ('protocolIEs', _ResetRequest_protocolIEs),
        ])
    ResetRequest._ext = []
    
    #-----< ResetRequest-IEs >-----#
    ResetRequest_IEs = CLASS(name='ResetRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _ResetRequest_IEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _ResetRequest_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'InterfaceInstanceIndication')))
    ResetRequest_IEs._val = ASN1Set(rv=[dict([('id', 5), ('criticality', 'ignore'), ('Value', _ResetRequest_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 335), ('criticality', 'reject'), ('Value', _ResetRequest_IEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ResetResponse >-----#
    ResetResponse = SEQ(name='ResetResponse', mode=MODE_TYPE)
    _ResetResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __ResetResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___ResetResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____ResetResponse_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____ResetResponse_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _____ResetResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'InterfaceInstanceIndication')))
    ____ResetResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 17), ('criticality', 'ignore'), ('Value', _____ResetResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 335), ('criticality', 'reject'), ('Value', _____ResetResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ResetResponse_protocolIEs__item__id._const_tab = ____ResetResponse_protocolIEs__item__id_tab
    ___ResetResponse_protocolIEs__item__id._const_tab_at = None
    ___ResetResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___ResetResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___ResetResponse_protocolIEs__item__criticality._const_tab = ____ResetResponse_protocolIEs__item__id_tab
    ___ResetResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ResetResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ResetResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___ResetResponse_protocolIEs__item__value._const_tab = ____ResetResponse_protocolIEs__item__id_tab
    ___ResetResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ResetResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __ResetResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ResetResponse_protocolIEs__item__id),
        ('criticality', ___ResetResponse_protocolIEs__item__criticality),
        ('value', ___ResetResponse_protocolIEs__item__value),
        ])
    __ResetResponse_protocolIEs__item_._ext = None
    _ResetResponse_protocolIEs._cont = __ResetResponse_protocolIEs__item_
    _ResetResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ResetResponse._cont = ASN1Dict([
        ('protocolIEs', _ResetResponse_protocolIEs),
        ])
    ResetResponse._ext = []
    
    #-----< ResetResponse-IEs >-----#
    ResetResponse_IEs = CLASS(name='ResetResponse-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _ResetResponse_IEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _ResetResponse_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'InterfaceInstanceIndication')))
    ResetResponse_IEs._val = ASN1Set(rv=[dict([('id', 17), ('criticality', 'ignore'), ('Value', _ResetResponse_IEs_val_Value_0), ('presence', 'optional')]), dict([('id', 335), ('criticality', 'reject'), ('Value', _ResetResponse_IEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< X2SetupRequest >-----#
    X2SetupRequest = SEQ(name='X2SetupRequest', mode=MODE_TYPE)
    _X2SetupRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __X2SetupRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___X2SetupRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____X2SetupRequest_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____X2SetupRequest_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GlobalENB-ID')))
    _____X2SetupRequest_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ServedCells')))
    _____X2SetupRequest_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GUGroupIDList')))
    _____X2SetupRequest_protocolIEs__item__id_tab_val_Value_3 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'LHN-ID')))
    ____X2SetupRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 21), ('criticality', 'reject'), ('Value', _____X2SetupRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 20), ('criticality', 'reject'), ('Value', _____X2SetupRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 24), ('criticality', 'reject'), ('Value', _____X2SetupRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 159), ('criticality', 'ignore'), ('Value', _____X2SetupRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___X2SetupRequest_protocolIEs__item__id._const_tab = ____X2SetupRequest_protocolIEs__item__id_tab
    ___X2SetupRequest_protocolIEs__item__id._const_tab_at = None
    ___X2SetupRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___X2SetupRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___X2SetupRequest_protocolIEs__item__criticality._const_tab = ____X2SetupRequest_protocolIEs__item__id_tab
    ___X2SetupRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___X2SetupRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___X2SetupRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___X2SetupRequest_protocolIEs__item__value._const_tab = ____X2SetupRequest_protocolIEs__item__id_tab
    ___X2SetupRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___X2SetupRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __X2SetupRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___X2SetupRequest_protocolIEs__item__id),
        ('criticality', ___X2SetupRequest_protocolIEs__item__criticality),
        ('value', ___X2SetupRequest_protocolIEs__item__value),
        ])
    __X2SetupRequest_protocolIEs__item_._ext = None
    _X2SetupRequest_protocolIEs._cont = __X2SetupRequest_protocolIEs__item_
    _X2SetupRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    X2SetupRequest._cont = ASN1Dict([
        ('protocolIEs', _X2SetupRequest_protocolIEs),
        ])
    X2SetupRequest._ext = []
    
    #-----< X2SetupRequest-IEs >-----#
    X2SetupRequest_IEs = CLASS(name='X2SetupRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _X2SetupRequest_IEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GlobalENB-ID')))
    _X2SetupRequest_IEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ServedCells')))
    _X2SetupRequest_IEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GUGroupIDList')))
    _X2SetupRequest_IEs_val_Value_3 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'LHN-ID')))
    X2SetupRequest_IEs._val = ASN1Set(rv=[dict([('id', 21), ('criticality', 'reject'), ('Value', _X2SetupRequest_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 20), ('criticality', 'reject'), ('Value', _X2SetupRequest_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 24), ('criticality', 'reject'), ('Value', _X2SetupRequest_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 159), ('criticality', 'ignore'), ('Value', _X2SetupRequest_IEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< X2SetupResponse >-----#
    X2SetupResponse = SEQ(name='X2SetupResponse', mode=MODE_TYPE)
    _X2SetupResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __X2SetupResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___X2SetupResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____X2SetupResponse_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____X2SetupResponse_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GlobalENB-ID')))
    _____X2SetupResponse_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ServedCells')))
    _____X2SetupResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GUGroupIDList')))
    _____X2SetupResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _____X2SetupResponse_protocolIEs__item__id_tab_val_Value_4 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'LHN-ID')))
    ____X2SetupResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 21), ('criticality', 'reject'), ('Value', _____X2SetupResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 20), ('criticality', 'reject'), ('Value', _____X2SetupResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 24), ('criticality', 'reject'), ('Value', _____X2SetupResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _____X2SetupResponse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 159), ('criticality', 'ignore'), ('Value', _____X2SetupResponse_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___X2SetupResponse_protocolIEs__item__id._const_tab = ____X2SetupResponse_protocolIEs__item__id_tab
    ___X2SetupResponse_protocolIEs__item__id._const_tab_at = None
    ___X2SetupResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___X2SetupResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___X2SetupResponse_protocolIEs__item__criticality._const_tab = ____X2SetupResponse_protocolIEs__item__id_tab
    ___X2SetupResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___X2SetupResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___X2SetupResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___X2SetupResponse_protocolIEs__item__value._const_tab = ____X2SetupResponse_protocolIEs__item__id_tab
    ___X2SetupResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___X2SetupResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __X2SetupResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___X2SetupResponse_protocolIEs__item__id),
        ('criticality', ___X2SetupResponse_protocolIEs__item__criticality),
        ('value', ___X2SetupResponse_protocolIEs__item__value),
        ])
    __X2SetupResponse_protocolIEs__item_._ext = None
    _X2SetupResponse_protocolIEs._cont = __X2SetupResponse_protocolIEs__item_
    _X2SetupResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    X2SetupResponse._cont = ASN1Dict([
        ('protocolIEs', _X2SetupResponse_protocolIEs),
        ])
    X2SetupResponse._ext = []
    
    #-----< X2SetupResponse-IEs >-----#
    X2SetupResponse_IEs = CLASS(name='X2SetupResponse-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _X2SetupResponse_IEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GlobalENB-ID')))
    _X2SetupResponse_IEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ServedCells')))
    _X2SetupResponse_IEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GUGroupIDList')))
    _X2SetupResponse_IEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _X2SetupResponse_IEs_val_Value_4 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'LHN-ID')))
    X2SetupResponse_IEs._val = ASN1Set(rv=[dict([('id', 21), ('criticality', 'reject'), ('Value', _X2SetupResponse_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 20), ('criticality', 'reject'), ('Value', _X2SetupResponse_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 24), ('criticality', 'reject'), ('Value', _X2SetupResponse_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _X2SetupResponse_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 159), ('criticality', 'ignore'), ('Value', _X2SetupResponse_IEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< X2SetupFailure >-----#
    X2SetupFailure = SEQ(name='X2SetupFailure', mode=MODE_TYPE)
    _X2SetupFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __X2SetupFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___X2SetupFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____X2SetupFailure_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____X2SetupFailure_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _____X2SetupFailure_protocolIEs__item__id_tab_val_Value_1 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TimeToWait')))
    _____X2SetupFailure_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    ____X2SetupFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 5), ('criticality', 'ignore'), ('Value', _____X2SetupFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 22), ('criticality', 'ignore'), ('Value', _____X2SetupFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _____X2SetupFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___X2SetupFailure_protocolIEs__item__id._const_tab = ____X2SetupFailure_protocolIEs__item__id_tab
    ___X2SetupFailure_protocolIEs__item__id._const_tab_at = None
    ___X2SetupFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___X2SetupFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___X2SetupFailure_protocolIEs__item__criticality._const_tab = ____X2SetupFailure_protocolIEs__item__id_tab
    ___X2SetupFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___X2SetupFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___X2SetupFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___X2SetupFailure_protocolIEs__item__value._const_tab = ____X2SetupFailure_protocolIEs__item__id_tab
    ___X2SetupFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___X2SetupFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __X2SetupFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___X2SetupFailure_protocolIEs__item__id),
        ('criticality', ___X2SetupFailure_protocolIEs__item__criticality),
        ('value', ___X2SetupFailure_protocolIEs__item__value),
        ])
    __X2SetupFailure_protocolIEs__item_._ext = None
    _X2SetupFailure_protocolIEs._cont = __X2SetupFailure_protocolIEs__item_
    _X2SetupFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    X2SetupFailure._cont = ASN1Dict([
        ('protocolIEs', _X2SetupFailure_protocolIEs),
        ])
    X2SetupFailure._ext = []
    
    #-----< X2SetupFailure-IEs >-----#
    X2SetupFailure_IEs = CLASS(name='X2SetupFailure-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _X2SetupFailure_IEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _X2SetupFailure_IEs_val_Value_1 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TimeToWait')))
    _X2SetupFailure_IEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    X2SetupFailure_IEs._val = ASN1Set(rv=[dict([('id', 5), ('criticality', 'ignore'), ('Value', _X2SetupFailure_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 22), ('criticality', 'ignore'), ('Value', _X2SetupFailure_IEs_val_Value_1), ('presence', 'optional')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _X2SetupFailure_IEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< LoadInformation >-----#
    LoadInformation = SEQ(name='LoadInformation', mode=MODE_TYPE)
    _LoadInformation_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __LoadInformation_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___LoadInformation_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____LoadInformation_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____LoadInformation_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellInformation-List')))
    ____LoadInformation_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 6), ('criticality', 'ignore'), ('Value', _____LoadInformation_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___LoadInformation_protocolIEs__item__id._const_tab = ____LoadInformation_protocolIEs__item__id_tab
    ___LoadInformation_protocolIEs__item__id._const_tab_at = None
    ___LoadInformation_protocolIEs__item__id._const_tab_id = 'id'
    ___LoadInformation_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___LoadInformation_protocolIEs__item__criticality._const_tab = ____LoadInformation_protocolIEs__item__id_tab
    ___LoadInformation_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___LoadInformation_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___LoadInformation_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___LoadInformation_protocolIEs__item__value._const_tab = ____LoadInformation_protocolIEs__item__id_tab
    ___LoadInformation_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___LoadInformation_protocolIEs__item__value._const_tab_id = 'Value'
    __LoadInformation_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___LoadInformation_protocolIEs__item__id),
        ('criticality', ___LoadInformation_protocolIEs__item__criticality),
        ('value', ___LoadInformation_protocolIEs__item__value),
        ])
    __LoadInformation_protocolIEs__item_._ext = None
    _LoadInformation_protocolIEs._cont = __LoadInformation_protocolIEs__item_
    _LoadInformation_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    LoadInformation._cont = ASN1Dict([
        ('protocolIEs', _LoadInformation_protocolIEs),
        ])
    LoadInformation._ext = []
    
    #-----< LoadInformation-IEs >-----#
    LoadInformation_IEs = CLASS(name='LoadInformation-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _LoadInformation_IEs_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellInformation-List')))
    LoadInformation_IEs._val = ASN1Set(rv=[dict([('id', 6), ('criticality', 'ignore'), ('Value', _LoadInformation_IEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< CellInformation-List >-----#
    CellInformation_List = SEQ_OF(name='CellInformation-List', mode=MODE_TYPE)
    _CellInformation_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __CellInformation_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ___CellInformation_List__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____CellInformation_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellInformation-Item')))
    ___CellInformation_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 7), ('criticality', 'ignore'), ('Value', ____CellInformation_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __CellInformation_List__item__id._const_tab = ___CellInformation_List__item__id_tab
    __CellInformation_List__item__id._const_tab_at = None
    __CellInformation_List__item__id._const_tab_id = 'id'
    __CellInformation_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    __CellInformation_List__item__criticality._const_tab = ___CellInformation_List__item__id_tab
    __CellInformation_List__item__criticality._const_tab_at = ('..', 'id')
    __CellInformation_List__item__criticality._const_tab_id = 'criticality'
    __CellInformation_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    __CellInformation_List__item__value._const_tab = ___CellInformation_List__item__id_tab
    __CellInformation_List__item__value._const_tab_at = ('..', 'id')
    __CellInformation_List__item__value._const_tab_id = 'Value'
    _CellInformation_List__item_._cont = ASN1Dict([
        ('id', __CellInformation_List__item__id),
        ('criticality', __CellInformation_List__item__criticality),
        ('value', __CellInformation_List__item__value),
        ])
    _CellInformation_List__item_._ext = None
    CellInformation_List._cont = _CellInformation_List__item_
    CellInformation_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< CellInformation-ItemIEs >-----#
    CellInformation_ItemIEs = CLASS(name='CellInformation-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _CellInformation_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellInformation-Item')))
    CellInformation_ItemIEs._val = ASN1Set(rv=[dict([('id', 7), ('criticality', 'ignore'), ('Value', _CellInformation_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< CellInformation-Item >-----#
    CellInformation_Item = SEQ(name='CellInformation-Item', mode=MODE_TYPE)
    _CellInformation_Item_cell_ID = SEQ(name='cell-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _CellInformation_Item_ul_InterferenceOverloadIndication = SEQ_OF(name='ul-InterferenceOverloadIndication', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'UL-InterferenceOverloadIndication')), opt=True)
    _CellInformation_Item_ul_HighInterferenceIndicationInfo = SEQ_OF(name='ul-HighInterferenceIndicationInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'UL-HighInterferenceIndicationInfo')), opt=True)
    _CellInformation_Item_relativeNarrowbandTxPower = SEQ(name='relativeNarrowbandTxPower', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'RelativeNarrowbandTxPower')), opt=True)
    _CellInformation_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellInformation_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___CellInformation_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____CellInformation_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____CellInformation_Item_iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ABSInformation')))
    _____CellInformation_Item_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'InvokeIndication')))
    _____CellInformation_Item_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SubframeAssignment')))
    _____CellInformation_Item_iE_Extensions__item__id_tab_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ExtendedULInterferenceOverloadInfo')))
    _____CellInformation_Item_iE_Extensions__item__id_tab_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CoMPInformation')))
    _____CellInformation_Item_iE_Extensions__item__id_tab_val_Extension_5 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'DynamicDLTransmissionInformation')))
    ____CellInformation_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 61), ('criticality', 'ignore'), ('Extension', _____CellInformation_Item_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 62), ('criticality', 'ignore'), ('Extension', _____CellInformation_Item_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 99), ('criticality', 'ignore'), ('Extension', _____CellInformation_Item_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 100), ('criticality', 'ignore'), ('Extension', _____CellInformation_Item_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 108), ('criticality', 'ignore'), ('Extension', _____CellInformation_Item_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 106), ('criticality', 'ignore'), ('Extension', _____CellInformation_Item_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___CellInformation_Item_iE_Extensions__item__id._const_tab = ____CellInformation_Item_iE_Extensions__item__id_tab
    ___CellInformation_Item_iE_Extensions__item__id._const_tab_at = None
    ___CellInformation_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___CellInformation_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___CellInformation_Item_iE_Extensions__item__criticality._const_tab = ____CellInformation_Item_iE_Extensions__item__id_tab
    ___CellInformation_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CellInformation_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CellInformation_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___CellInformation_Item_iE_Extensions__item__extensionValue._const_tab = ____CellInformation_Item_iE_Extensions__item__id_tab
    ___CellInformation_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellInformation_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CellInformation_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CellInformation_Item_iE_Extensions__item__id),
        ('criticality', ___CellInformation_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___CellInformation_Item_iE_Extensions__item__extensionValue),
        ])
    __CellInformation_Item_iE_Extensions__item_._ext = None
    _CellInformation_Item_iE_Extensions._cont = __CellInformation_Item_iE_Extensions__item_
    _CellInformation_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellInformation_Item._cont = ASN1Dict([
        ('cell-ID', _CellInformation_Item_cell_ID),
        ('ul-InterferenceOverloadIndication', _CellInformation_Item_ul_InterferenceOverloadIndication),
        ('ul-HighInterferenceIndicationInfo', _CellInformation_Item_ul_HighInterferenceIndicationInfo),
        ('relativeNarrowbandTxPower', _CellInformation_Item_relativeNarrowbandTxPower),
        ('iE-Extensions', _CellInformation_Item_iE_Extensions),
        ])
    CellInformation_Item._ext = []
    
    #-----< CellInformation-Item-ExtIEs >-----#
    CellInformation_Item_ExtIEs = CLASS(name='CellInformation-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _CellInformation_Item_ExtIEs_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ABSInformation')))
    _CellInformation_Item_ExtIEs_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'InvokeIndication')))
    _CellInformation_Item_ExtIEs_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SubframeAssignment')))
    _CellInformation_Item_ExtIEs_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ExtendedULInterferenceOverloadInfo')))
    _CellInformation_Item_ExtIEs_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CoMPInformation')))
    _CellInformation_Item_ExtIEs_val_Extension_5 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'DynamicDLTransmissionInformation')))
    CellInformation_Item_ExtIEs._val = ASN1Set(rv=[dict([('id', 61), ('criticality', 'ignore'), ('Extension', _CellInformation_Item_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 62), ('criticality', 'ignore'), ('Extension', _CellInformation_Item_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 99), ('criticality', 'ignore'), ('Extension', _CellInformation_Item_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 100), ('criticality', 'ignore'), ('Extension', _CellInformation_Item_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 108), ('criticality', 'ignore'), ('Extension', _CellInformation_Item_ExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 106), ('criticality', 'ignore'), ('Extension', _CellInformation_Item_ExtIEs_val_Extension_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ENBConfigurationUpdate >-----#
    ENBConfigurationUpdate = SEQ(name='ENBConfigurationUpdate', mode=MODE_TYPE)
    _ENBConfigurationUpdate_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __ENBConfigurationUpdate_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___ENBConfigurationUpdate_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____ENBConfigurationUpdate_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ServedCells')))
    _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ServedCellsToModify')))
    _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'Old-ECGIs')))
    _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GUGroupIDList')))
    _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GUGroupIDList')))
    _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CoverageModificationList')))
    ____ENBConfigurationUpdate_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 25), ('criticality', 'reject'), ('Value', _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 26), ('criticality', 'reject'), ('Value', _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 27), ('criticality', 'reject'), ('Value', _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 34), ('criticality', 'reject'), ('Value', _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 35), ('criticality', 'reject'), ('Value', _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 143), ('criticality', 'reject'), ('Value', _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ENBConfigurationUpdate_protocolIEs__item__id._const_tab = ____ENBConfigurationUpdate_protocolIEs__item__id_tab
    ___ENBConfigurationUpdate_protocolIEs__item__id._const_tab_at = None
    ___ENBConfigurationUpdate_protocolIEs__item__id._const_tab_id = 'id'
    ___ENBConfigurationUpdate_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___ENBConfigurationUpdate_protocolIEs__item__criticality._const_tab = ____ENBConfigurationUpdate_protocolIEs__item__id_tab
    ___ENBConfigurationUpdate_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ENBConfigurationUpdate_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ENBConfigurationUpdate_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___ENBConfigurationUpdate_protocolIEs__item__value._const_tab = ____ENBConfigurationUpdate_protocolIEs__item__id_tab
    ___ENBConfigurationUpdate_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ENBConfigurationUpdate_protocolIEs__item__value._const_tab_id = 'Value'
    __ENBConfigurationUpdate_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ENBConfigurationUpdate_protocolIEs__item__id),
        ('criticality', ___ENBConfigurationUpdate_protocolIEs__item__criticality),
        ('value', ___ENBConfigurationUpdate_protocolIEs__item__value),
        ])
    __ENBConfigurationUpdate_protocolIEs__item_._ext = None
    _ENBConfigurationUpdate_protocolIEs._cont = __ENBConfigurationUpdate_protocolIEs__item_
    _ENBConfigurationUpdate_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ENBConfigurationUpdate._cont = ASN1Dict([
        ('protocolIEs', _ENBConfigurationUpdate_protocolIEs),
        ])
    ENBConfigurationUpdate._ext = []
    
    #-----< ENBConfigurationUpdate-IEs >-----#
    ENBConfigurationUpdate_IEs = CLASS(name='ENBConfigurationUpdate-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _ENBConfigurationUpdate_IEs_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ServedCells')))
    _ENBConfigurationUpdate_IEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ServedCellsToModify')))
    _ENBConfigurationUpdate_IEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'Old-ECGIs')))
    _ENBConfigurationUpdate_IEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GUGroupIDList')))
    _ENBConfigurationUpdate_IEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GUGroupIDList')))
    _ENBConfigurationUpdate_IEs_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CoverageModificationList')))
    ENBConfigurationUpdate_IEs._val = ASN1Set(rv=[dict([('id', 25), ('criticality', 'reject'), ('Value', _ENBConfigurationUpdate_IEs_val_Value_0), ('presence', 'optional')]), dict([('id', 26), ('criticality', 'reject'), ('Value', _ENBConfigurationUpdate_IEs_val_Value_1), ('presence', 'optional')]), dict([('id', 27), ('criticality', 'reject'), ('Value', _ENBConfigurationUpdate_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 34), ('criticality', 'reject'), ('Value', _ENBConfigurationUpdate_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 35), ('criticality', 'reject'), ('Value', _ENBConfigurationUpdate_IEs_val_Value_4), ('presence', 'optional')]), dict([('id', 143), ('criticality', 'reject'), ('Value', _ENBConfigurationUpdate_IEs_val_Value_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ServedCellsToModify >-----#
    ServedCellsToModify = SEQ_OF(name='ServedCellsToModify', mode=MODE_TYPE)
    _ServedCellsToModify__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ServedCellsToModify-Item')))
    ServedCellsToModify._cont = _ServedCellsToModify__item_
    ServedCellsToModify._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< ServedCellsToModify-Item >-----#
    ServedCellsToModify_Item = SEQ(name='ServedCellsToModify-Item', mode=MODE_TYPE)
    _ServedCellsToModify_Item_old_ecgi = SEQ(name='old-ecgi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _ServedCellsToModify_Item_servedCellInfo = SEQ(name='servedCellInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ServedCell-Information')))
    _ServedCellsToModify_Item_neighbour_Info = SEQ_OF(name='neighbour-Info', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'Neighbour-Information')), opt=True)
    _ServedCellsToModify_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ServedCellsToModify_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___ServedCellsToModify_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____ServedCellsToModify_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____ServedCellsToModify_Item_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'DeactivationIndication')))
    _____ServedCellsToModify_Item_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'NRNeighbour-Information')))
    ____ServedCellsToModify_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 59), ('criticality', 'ignore'), ('Extension', _____ServedCellsToModify_Item_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 328), ('criticality', 'ignore'), ('Extension', _____ServedCellsToModify_Item_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ServedCellsToModify_Item_iE_Extensions__item__id._const_tab = ____ServedCellsToModify_Item_iE_Extensions__item__id_tab
    ___ServedCellsToModify_Item_iE_Extensions__item__id._const_tab_at = None
    ___ServedCellsToModify_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___ServedCellsToModify_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___ServedCellsToModify_Item_iE_Extensions__item__criticality._const_tab = ____ServedCellsToModify_Item_iE_Extensions__item__id_tab
    ___ServedCellsToModify_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ServedCellsToModify_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ServedCellsToModify_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___ServedCellsToModify_Item_iE_Extensions__item__extensionValue._const_tab = ____ServedCellsToModify_Item_iE_Extensions__item__id_tab
    ___ServedCellsToModify_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ServedCellsToModify_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ServedCellsToModify_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ServedCellsToModify_Item_iE_Extensions__item__id),
        ('criticality', ___ServedCellsToModify_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___ServedCellsToModify_Item_iE_Extensions__item__extensionValue),
        ])
    __ServedCellsToModify_Item_iE_Extensions__item_._ext = None
    _ServedCellsToModify_Item_iE_Extensions._cont = __ServedCellsToModify_Item_iE_Extensions__item_
    _ServedCellsToModify_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ServedCellsToModify_Item._cont = ASN1Dict([
        ('old-ecgi', _ServedCellsToModify_Item_old_ecgi),
        ('servedCellInfo', _ServedCellsToModify_Item_servedCellInfo),
        ('neighbour-Info', _ServedCellsToModify_Item_neighbour_Info),
        ('iE-Extensions', _ServedCellsToModify_Item_iE_Extensions),
        ])
    ServedCellsToModify_Item._ext = []
    
    #-----< ServedCellsToModify-Item-ExtIEs >-----#
    ServedCellsToModify_Item_ExtIEs = CLASS(name='ServedCellsToModify-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _ServedCellsToModify_Item_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'DeactivationIndication')))
    _ServedCellsToModify_Item_ExtIEs_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'NRNeighbour-Information')))
    ServedCellsToModify_Item_ExtIEs._val = ASN1Set(rv=[dict([('id', 59), ('criticality', 'ignore'), ('Extension', _ServedCellsToModify_Item_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 328), ('criticality', 'ignore'), ('Extension', _ServedCellsToModify_Item_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Old-ECGIs >-----#
    Old_ECGIs = SEQ_OF(name='Old-ECGIs', mode=MODE_TYPE)
    _Old_ECGIs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    Old_ECGIs._cont = _Old_ECGIs__item_
    Old_ECGIs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< ENBConfigurationUpdateAcknowledge >-----#
    ENBConfigurationUpdateAcknowledge = SEQ(name='ENBConfigurationUpdateAcknowledge', mode=MODE_TYPE)
    _ENBConfigurationUpdateAcknowledge_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __ENBConfigurationUpdateAcknowledge_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____ENBConfigurationUpdateAcknowledge_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____ENBConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    ____ENBConfigurationUpdateAcknowledge_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 17), ('criticality', 'ignore'), ('Value', _____ENBConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__id._const_tab = ____ENBConfigurationUpdateAcknowledge_protocolIEs__item__id_tab
    ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__id._const_tab_at = None
    ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__id._const_tab_id = 'id'
    ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__criticality._const_tab = ____ENBConfigurationUpdateAcknowledge_protocolIEs__item__id_tab
    ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__value._const_tab = ____ENBConfigurationUpdateAcknowledge_protocolIEs__item__id_tab
    ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__value._const_tab_id = 'Value'
    __ENBConfigurationUpdateAcknowledge_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__id),
        ('criticality', ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__criticality),
        ('value', ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__value),
        ])
    __ENBConfigurationUpdateAcknowledge_protocolIEs__item_._ext = None
    _ENBConfigurationUpdateAcknowledge_protocolIEs._cont = __ENBConfigurationUpdateAcknowledge_protocolIEs__item_
    _ENBConfigurationUpdateAcknowledge_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ENBConfigurationUpdateAcknowledge._cont = ASN1Dict([
        ('protocolIEs', _ENBConfigurationUpdateAcknowledge_protocolIEs),
        ])
    ENBConfigurationUpdateAcknowledge._ext = []
    
    #-----< ENBConfigurationUpdateAcknowledge-IEs >-----#
    ENBConfigurationUpdateAcknowledge_IEs = CLASS(name='ENBConfigurationUpdateAcknowledge-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _ENBConfigurationUpdateAcknowledge_IEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    ENBConfigurationUpdateAcknowledge_IEs._val = ASN1Set(rv=[dict([('id', 17), ('criticality', 'ignore'), ('Value', _ENBConfigurationUpdateAcknowledge_IEs_val_Value_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ENBConfigurationUpdateFailure >-----#
    ENBConfigurationUpdateFailure = SEQ(name='ENBConfigurationUpdateFailure', mode=MODE_TYPE)
    _ENBConfigurationUpdateFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __ENBConfigurationUpdateFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___ENBConfigurationUpdateFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____ENBConfigurationUpdateFailure_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____ENBConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _____ENBConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_1 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TimeToWait')))
    _____ENBConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    ____ENBConfigurationUpdateFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 5), ('criticality', 'ignore'), ('Value', _____ENBConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 22), ('criticality', 'ignore'), ('Value', _____ENBConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _____ENBConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ENBConfigurationUpdateFailure_protocolIEs__item__id._const_tab = ____ENBConfigurationUpdateFailure_protocolIEs__item__id_tab
    ___ENBConfigurationUpdateFailure_protocolIEs__item__id._const_tab_at = None
    ___ENBConfigurationUpdateFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___ENBConfigurationUpdateFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___ENBConfigurationUpdateFailure_protocolIEs__item__criticality._const_tab = ____ENBConfigurationUpdateFailure_protocolIEs__item__id_tab
    ___ENBConfigurationUpdateFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ENBConfigurationUpdateFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ENBConfigurationUpdateFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___ENBConfigurationUpdateFailure_protocolIEs__item__value._const_tab = ____ENBConfigurationUpdateFailure_protocolIEs__item__id_tab
    ___ENBConfigurationUpdateFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ENBConfigurationUpdateFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __ENBConfigurationUpdateFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ENBConfigurationUpdateFailure_protocolIEs__item__id),
        ('criticality', ___ENBConfigurationUpdateFailure_protocolIEs__item__criticality),
        ('value', ___ENBConfigurationUpdateFailure_protocolIEs__item__value),
        ])
    __ENBConfigurationUpdateFailure_protocolIEs__item_._ext = None
    _ENBConfigurationUpdateFailure_protocolIEs._cont = __ENBConfigurationUpdateFailure_protocolIEs__item_
    _ENBConfigurationUpdateFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ENBConfigurationUpdateFailure._cont = ASN1Dict([
        ('protocolIEs', _ENBConfigurationUpdateFailure_protocolIEs),
        ])
    ENBConfigurationUpdateFailure._ext = []
    
    #-----< ENBConfigurationUpdateFailure-IEs >-----#
    ENBConfigurationUpdateFailure_IEs = CLASS(name='ENBConfigurationUpdateFailure-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _ENBConfigurationUpdateFailure_IEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _ENBConfigurationUpdateFailure_IEs_val_Value_1 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TimeToWait')))
    _ENBConfigurationUpdateFailure_IEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    ENBConfigurationUpdateFailure_IEs._val = ASN1Set(rv=[dict([('id', 5), ('criticality', 'ignore'), ('Value', _ENBConfigurationUpdateFailure_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 22), ('criticality', 'ignore'), ('Value', _ENBConfigurationUpdateFailure_IEs_val_Value_1), ('presence', 'optional')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _ENBConfigurationUpdateFailure_IEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ResourceStatusRequest >-----#
    ResourceStatusRequest = SEQ(name='ResourceStatusRequest', mode=MODE_TYPE)
    _ResourceStatusRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __ResourceStatusRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___ResourceStatusRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____ResourceStatusRequest_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Measurement-ID')))
    _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Measurement-ID')))
    _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Registration-Request')))
    _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_3 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ReportCharacteristics')))
    _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellToReport-List')))
    _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_5 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ReportingPeriodicity')))
    _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_6 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'PartialSuccessIndicator')))
    _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_7 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ReportingPeriodicityRSRPMR')))
    _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_8 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ReportingPeriodicityCSIR')))
    ____ResourceStatusRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 39), ('criticality', 'reject'), ('Value', _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 40), ('criticality', 'ignore'), ('Value', _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'conditional')]), dict([('id', 28), ('criticality', 'reject'), ('Value', _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 38), ('criticality', 'reject'), ('Value', _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 29), ('criticality', 'ignore'), ('Value', _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_4), ('presence', 'mandatory')]), dict([('id', 30), ('criticality', 'ignore'), ('Value', _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 64), ('criticality', 'ignore'), ('Value', _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 109), ('criticality', 'ignore'), ('Value', _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')]), dict([('id', 145), ('criticality', 'ignore'), ('Value', _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_8), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ResourceStatusRequest_protocolIEs__item__id._const_tab = ____ResourceStatusRequest_protocolIEs__item__id_tab
    ___ResourceStatusRequest_protocolIEs__item__id._const_tab_at = None
    ___ResourceStatusRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___ResourceStatusRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___ResourceStatusRequest_protocolIEs__item__criticality._const_tab = ____ResourceStatusRequest_protocolIEs__item__id_tab
    ___ResourceStatusRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ResourceStatusRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ResourceStatusRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___ResourceStatusRequest_protocolIEs__item__value._const_tab = ____ResourceStatusRequest_protocolIEs__item__id_tab
    ___ResourceStatusRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ResourceStatusRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __ResourceStatusRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ResourceStatusRequest_protocolIEs__item__id),
        ('criticality', ___ResourceStatusRequest_protocolIEs__item__criticality),
        ('value', ___ResourceStatusRequest_protocolIEs__item__value),
        ])
    __ResourceStatusRequest_protocolIEs__item_._ext = None
    _ResourceStatusRequest_protocolIEs._cont = __ResourceStatusRequest_protocolIEs__item_
    _ResourceStatusRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ResourceStatusRequest._cont = ASN1Dict([
        ('protocolIEs', _ResourceStatusRequest_protocolIEs),
        ])
    ResourceStatusRequest._ext = []
    
    #-----< ResourceStatusRequest-IEs >-----#
    ResourceStatusRequest_IEs = CLASS(name='ResourceStatusRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _ResourceStatusRequest_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Measurement-ID')))
    _ResourceStatusRequest_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Measurement-ID')))
    _ResourceStatusRequest_IEs_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Registration-Request')))
    _ResourceStatusRequest_IEs_val_Value_3 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ReportCharacteristics')))
    _ResourceStatusRequest_IEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellToReport-List')))
    _ResourceStatusRequest_IEs_val_Value_5 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ReportingPeriodicity')))
    _ResourceStatusRequest_IEs_val_Value_6 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'PartialSuccessIndicator')))
    _ResourceStatusRequest_IEs_val_Value_7 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ReportingPeriodicityRSRPMR')))
    _ResourceStatusRequest_IEs_val_Value_8 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ReportingPeriodicityCSIR')))
    ResourceStatusRequest_IEs._val = ASN1Set(rv=[dict([('id', 39), ('criticality', 'reject'), ('Value', _ResourceStatusRequest_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 40), ('criticality', 'ignore'), ('Value', _ResourceStatusRequest_IEs_val_Value_1), ('presence', 'conditional')]), dict([('id', 28), ('criticality', 'reject'), ('Value', _ResourceStatusRequest_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 38), ('criticality', 'reject'), ('Value', _ResourceStatusRequest_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 29), ('criticality', 'ignore'), ('Value', _ResourceStatusRequest_IEs_val_Value_4), ('presence', 'mandatory')]), dict([('id', 30), ('criticality', 'ignore'), ('Value', _ResourceStatusRequest_IEs_val_Value_5), ('presence', 'optional')]), dict([('id', 64), ('criticality', 'ignore'), ('Value', _ResourceStatusRequest_IEs_val_Value_6), ('presence', 'optional')]), dict([('id', 109), ('criticality', 'ignore'), ('Value', _ResourceStatusRequest_IEs_val_Value_7), ('presence', 'optional')]), dict([('id', 145), ('criticality', 'ignore'), ('Value', _ResourceStatusRequest_IEs_val_Value_8), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< CellToReport-List >-----#
    CellToReport_List = SEQ_OF(name='CellToReport-List', mode=MODE_TYPE)
    _CellToReport_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __CellToReport_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ___CellToReport_List__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____CellToReport_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellToReport-Item')))
    ___CellToReport_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 31), ('criticality', 'ignore'), ('Value', ____CellToReport_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __CellToReport_List__item__id._const_tab = ___CellToReport_List__item__id_tab
    __CellToReport_List__item__id._const_tab_at = None
    __CellToReport_List__item__id._const_tab_id = 'id'
    __CellToReport_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    __CellToReport_List__item__criticality._const_tab = ___CellToReport_List__item__id_tab
    __CellToReport_List__item__criticality._const_tab_at = ('..', 'id')
    __CellToReport_List__item__criticality._const_tab_id = 'criticality'
    __CellToReport_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    __CellToReport_List__item__value._const_tab = ___CellToReport_List__item__id_tab
    __CellToReport_List__item__value._const_tab_at = ('..', 'id')
    __CellToReport_List__item__value._const_tab_id = 'Value'
    _CellToReport_List__item_._cont = ASN1Dict([
        ('id', __CellToReport_List__item__id),
        ('criticality', __CellToReport_List__item__criticality),
        ('value', __CellToReport_List__item__value),
        ])
    _CellToReport_List__item_._ext = None
    CellToReport_List._cont = _CellToReport_List__item_
    CellToReport_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< CellToReport-ItemIEs >-----#
    CellToReport_ItemIEs = CLASS(name='CellToReport-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _CellToReport_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellToReport-Item')))
    CellToReport_ItemIEs._val = ASN1Set(rv=[dict([('id', 31), ('criticality', 'ignore'), ('Value', _CellToReport_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< CellToReport-Item >-----#
    CellToReport_Item = SEQ(name='CellToReport-Item', mode=MODE_TYPE)
    _CellToReport_Item_cell_ID = SEQ(name='cell-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _CellToReport_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellToReport_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___CellToReport_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____CellToReport_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CellToReport_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellToReport_Item_iE_Extensions__item__id._const_tab = ____CellToReport_Item_iE_Extensions__item__id_tab
    ___CellToReport_Item_iE_Extensions__item__id._const_tab_at = None
    ___CellToReport_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___CellToReport_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CellToReport_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CellToReport_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellToReport_Item_iE_Extensions__item__criticality._const_tab = ____CellToReport_Item_iE_Extensions__item__criticality_tab
    ___CellToReport_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CellToReport_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CellToReport_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CellToReport_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CellToReport_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellToReport_Item_iE_Extensions__item__extensionValue._const_tab = ____CellToReport_Item_iE_Extensions__item__extensionValue_tab
    ___CellToReport_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellToReport_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CellToReport_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CellToReport_Item_iE_Extensions__item__id),
        ('criticality', ___CellToReport_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___CellToReport_Item_iE_Extensions__item__extensionValue),
        ])
    __CellToReport_Item_iE_Extensions__item_._ext = None
    _CellToReport_Item_iE_Extensions._cont = __CellToReport_Item_iE_Extensions__item_
    _CellToReport_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellToReport_Item._cont = ASN1Dict([
        ('cell-ID', _CellToReport_Item_cell_ID),
        ('iE-Extensions', _CellToReport_Item_iE_Extensions),
        ])
    CellToReport_Item._ext = []
    
    #-----< CellToReport-Item-ExtIEs >-----#
    CellToReport_Item_ExtIEs = CLASS(name='CellToReport-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    CellToReport_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ReportingPeriodicity >-----#
    ReportingPeriodicity = ENUM(name='ReportingPeriodicity', mode=MODE_TYPE)
    ReportingPeriodicity._cont = ASN1Dict([('one-thousand-ms', 0), ('two-thousand-ms', 1), ('five-thousand-ms', 2), ('ten-thousand-ms', 3)])
    ReportingPeriodicity._ext = []
    
    #-----< PartialSuccessIndicator >-----#
    PartialSuccessIndicator = ENUM(name='PartialSuccessIndicator', mode=MODE_TYPE)
    PartialSuccessIndicator._cont = ASN1Dict([('partial-success-allowed', 0)])
    PartialSuccessIndicator._ext = []
    
    #-----< ResourceStatusResponse >-----#
    ResourceStatusResponse = SEQ(name='ResourceStatusResponse', mode=MODE_TYPE)
    _ResourceStatusResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __ResourceStatusResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___ResourceStatusResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____ResourceStatusResponse_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____ResourceStatusResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Measurement-ID')))
    _____ResourceStatusResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Measurement-ID')))
    _____ResourceStatusResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _____ResourceStatusResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'MeasurementInitiationResult-List')))
    ____ResourceStatusResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 39), ('criticality', 'reject'), ('Value', _____ResourceStatusResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 40), ('criticality', 'reject'), ('Value', _____ResourceStatusResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _____ResourceStatusResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 65), ('criticality', 'ignore'), ('Value', _____ResourceStatusResponse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ResourceStatusResponse_protocolIEs__item__id._const_tab = ____ResourceStatusResponse_protocolIEs__item__id_tab
    ___ResourceStatusResponse_protocolIEs__item__id._const_tab_at = None
    ___ResourceStatusResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___ResourceStatusResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___ResourceStatusResponse_protocolIEs__item__criticality._const_tab = ____ResourceStatusResponse_protocolIEs__item__id_tab
    ___ResourceStatusResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ResourceStatusResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ResourceStatusResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___ResourceStatusResponse_protocolIEs__item__value._const_tab = ____ResourceStatusResponse_protocolIEs__item__id_tab
    ___ResourceStatusResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ResourceStatusResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __ResourceStatusResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ResourceStatusResponse_protocolIEs__item__id),
        ('criticality', ___ResourceStatusResponse_protocolIEs__item__criticality),
        ('value', ___ResourceStatusResponse_protocolIEs__item__value),
        ])
    __ResourceStatusResponse_protocolIEs__item_._ext = None
    _ResourceStatusResponse_protocolIEs._cont = __ResourceStatusResponse_protocolIEs__item_
    _ResourceStatusResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ResourceStatusResponse._cont = ASN1Dict([
        ('protocolIEs', _ResourceStatusResponse_protocolIEs),
        ])
    ResourceStatusResponse._ext = []
    
    #-----< ResourceStatusResponse-IEs >-----#
    ResourceStatusResponse_IEs = CLASS(name='ResourceStatusResponse-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _ResourceStatusResponse_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Measurement-ID')))
    _ResourceStatusResponse_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Measurement-ID')))
    _ResourceStatusResponse_IEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _ResourceStatusResponse_IEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'MeasurementInitiationResult-List')))
    ResourceStatusResponse_IEs._val = ASN1Set(rv=[dict([('id', 39), ('criticality', 'reject'), ('Value', _ResourceStatusResponse_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 40), ('criticality', 'reject'), ('Value', _ResourceStatusResponse_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _ResourceStatusResponse_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 65), ('criticality', 'ignore'), ('Value', _ResourceStatusResponse_IEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MeasurementInitiationResult-List >-----#
    MeasurementInitiationResult_List = SEQ_OF(name='MeasurementInitiationResult-List', mode=MODE_TYPE)
    _MeasurementInitiationResult_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __MeasurementInitiationResult_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ___MeasurementInitiationResult_List__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____MeasurementInitiationResult_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'MeasurementInitiationResult-Item')))
    ___MeasurementInitiationResult_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 66), ('criticality', 'ignore'), ('Value', ____MeasurementInitiationResult_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __MeasurementInitiationResult_List__item__id._const_tab = ___MeasurementInitiationResult_List__item__id_tab
    __MeasurementInitiationResult_List__item__id._const_tab_at = None
    __MeasurementInitiationResult_List__item__id._const_tab_id = 'id'
    __MeasurementInitiationResult_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    __MeasurementInitiationResult_List__item__criticality._const_tab = ___MeasurementInitiationResult_List__item__id_tab
    __MeasurementInitiationResult_List__item__criticality._const_tab_at = ('..', 'id')
    __MeasurementInitiationResult_List__item__criticality._const_tab_id = 'criticality'
    __MeasurementInitiationResult_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    __MeasurementInitiationResult_List__item__value._const_tab = ___MeasurementInitiationResult_List__item__id_tab
    __MeasurementInitiationResult_List__item__value._const_tab_at = ('..', 'id')
    __MeasurementInitiationResult_List__item__value._const_tab_id = 'Value'
    _MeasurementInitiationResult_List__item_._cont = ASN1Dict([
        ('id', __MeasurementInitiationResult_List__item__id),
        ('criticality', __MeasurementInitiationResult_List__item__criticality),
        ('value', __MeasurementInitiationResult_List__item__value),
        ])
    _MeasurementInitiationResult_List__item_._ext = None
    MeasurementInitiationResult_List._cont = _MeasurementInitiationResult_List__item_
    MeasurementInitiationResult_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< MeasurementInitiationResult-ItemIEs >-----#
    MeasurementInitiationResult_ItemIEs = CLASS(name='MeasurementInitiationResult-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _MeasurementInitiationResult_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'MeasurementInitiationResult-Item')))
    MeasurementInitiationResult_ItemIEs._val = ASN1Set(rv=[dict([('id', 66), ('criticality', 'ignore'), ('Value', _MeasurementInitiationResult_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< MeasurementInitiationResult-Item >-----#
    MeasurementInitiationResult_Item = SEQ(name='MeasurementInitiationResult-Item', mode=MODE_TYPE)
    _MeasurementInitiationResult_Item_cell_ID = SEQ(name='cell-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _MeasurementInitiationResult_Item_measurementFailureCause_List = SEQ_OF(name='measurementFailureCause-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'MeasurementFailureCause-List')), opt=True)
    _MeasurementInitiationResult_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MeasurementInitiationResult_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___MeasurementInitiationResult_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____MeasurementInitiationResult_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____MeasurementInitiationResult_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MeasurementInitiationResult_Item_iE_Extensions__item__id._const_tab = ____MeasurementInitiationResult_Item_iE_Extensions__item__id_tab
    ___MeasurementInitiationResult_Item_iE_Extensions__item__id._const_tab_at = None
    ___MeasurementInitiationResult_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___MeasurementInitiationResult_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MeasurementInitiationResult_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____MeasurementInitiationResult_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MeasurementInitiationResult_Item_iE_Extensions__item__criticality._const_tab = ____MeasurementInitiationResult_Item_iE_Extensions__item__criticality_tab
    ___MeasurementInitiationResult_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MeasurementInitiationResult_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MeasurementInitiationResult_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MeasurementInitiationResult_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____MeasurementInitiationResult_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MeasurementInitiationResult_Item_iE_Extensions__item__extensionValue._const_tab = ____MeasurementInitiationResult_Item_iE_Extensions__item__extensionValue_tab
    ___MeasurementInitiationResult_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MeasurementInitiationResult_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MeasurementInitiationResult_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MeasurementInitiationResult_Item_iE_Extensions__item__id),
        ('criticality', ___MeasurementInitiationResult_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___MeasurementInitiationResult_Item_iE_Extensions__item__extensionValue),
        ])
    __MeasurementInitiationResult_Item_iE_Extensions__item_._ext = None
    _MeasurementInitiationResult_Item_iE_Extensions._cont = __MeasurementInitiationResult_Item_iE_Extensions__item_
    _MeasurementInitiationResult_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MeasurementInitiationResult_Item._cont = ASN1Dict([
        ('cell-ID', _MeasurementInitiationResult_Item_cell_ID),
        ('measurementFailureCause-List', _MeasurementInitiationResult_Item_measurementFailureCause_List),
        ('iE-Extensions', _MeasurementInitiationResult_Item_iE_Extensions),
        ])
    MeasurementInitiationResult_Item._ext = []
    
    #-----< MeasurementInitiationResult-Item-ExtIEs >-----#
    MeasurementInitiationResult_Item_ExtIEs = CLASS(name='MeasurementInitiationResult-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    MeasurementInitiationResult_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MeasurementFailureCause-List >-----#
    MeasurementFailureCause_List = SEQ_OF(name='MeasurementFailureCause-List', mode=MODE_TYPE)
    _MeasurementFailureCause_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __MeasurementFailureCause_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ___MeasurementFailureCause_List__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____MeasurementFailureCause_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'MeasurementFailureCause-Item')))
    ___MeasurementFailureCause_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 67), ('criticality', 'ignore'), ('Value', ____MeasurementFailureCause_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __MeasurementFailureCause_List__item__id._const_tab = ___MeasurementFailureCause_List__item__id_tab
    __MeasurementFailureCause_List__item__id._const_tab_at = None
    __MeasurementFailureCause_List__item__id._const_tab_id = 'id'
    __MeasurementFailureCause_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    __MeasurementFailureCause_List__item__criticality._const_tab = ___MeasurementFailureCause_List__item__id_tab
    __MeasurementFailureCause_List__item__criticality._const_tab_at = ('..', 'id')
    __MeasurementFailureCause_List__item__criticality._const_tab_id = 'criticality'
    __MeasurementFailureCause_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    __MeasurementFailureCause_List__item__value._const_tab = ___MeasurementFailureCause_List__item__id_tab
    __MeasurementFailureCause_List__item__value._const_tab_at = ('..', 'id')
    __MeasurementFailureCause_List__item__value._const_tab_id = 'Value'
    _MeasurementFailureCause_List__item_._cont = ASN1Dict([
        ('id', __MeasurementFailureCause_List__item__id),
        ('criticality', __MeasurementFailureCause_List__item__criticality),
        ('value', __MeasurementFailureCause_List__item__value),
        ])
    _MeasurementFailureCause_List__item_._ext = None
    MeasurementFailureCause_List._cont = _MeasurementFailureCause_List__item_
    MeasurementFailureCause_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< MeasurementFailureCause-ItemIEs >-----#
    MeasurementFailureCause_ItemIEs = CLASS(name='MeasurementFailureCause-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _MeasurementFailureCause_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'MeasurementFailureCause-Item')))
    MeasurementFailureCause_ItemIEs._val = ASN1Set(rv=[dict([('id', 67), ('criticality', 'ignore'), ('Value', _MeasurementFailureCause_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< MeasurementFailureCause-Item >-----#
    MeasurementFailureCause_Item = SEQ(name='MeasurementFailureCause-Item', mode=MODE_TYPE)
    _MeasurementFailureCause_Item_measurementFailedReportCharacteristics = BIT_STR(name='measurementFailedReportCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ReportCharacteristics')))
    _MeasurementFailureCause_Item_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _MeasurementFailureCause_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MeasurementFailureCause_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___MeasurementFailureCause_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____MeasurementFailureCause_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____MeasurementFailureCause_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MeasurementFailureCause_Item_iE_Extensions__item__id._const_tab = ____MeasurementFailureCause_Item_iE_Extensions__item__id_tab
    ___MeasurementFailureCause_Item_iE_Extensions__item__id._const_tab_at = None
    ___MeasurementFailureCause_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___MeasurementFailureCause_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MeasurementFailureCause_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____MeasurementFailureCause_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MeasurementFailureCause_Item_iE_Extensions__item__criticality._const_tab = ____MeasurementFailureCause_Item_iE_Extensions__item__criticality_tab
    ___MeasurementFailureCause_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MeasurementFailureCause_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MeasurementFailureCause_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MeasurementFailureCause_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____MeasurementFailureCause_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MeasurementFailureCause_Item_iE_Extensions__item__extensionValue._const_tab = ____MeasurementFailureCause_Item_iE_Extensions__item__extensionValue_tab
    ___MeasurementFailureCause_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MeasurementFailureCause_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MeasurementFailureCause_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MeasurementFailureCause_Item_iE_Extensions__item__id),
        ('criticality', ___MeasurementFailureCause_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___MeasurementFailureCause_Item_iE_Extensions__item__extensionValue),
        ])
    __MeasurementFailureCause_Item_iE_Extensions__item_._ext = None
    _MeasurementFailureCause_Item_iE_Extensions._cont = __MeasurementFailureCause_Item_iE_Extensions__item_
    _MeasurementFailureCause_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MeasurementFailureCause_Item._cont = ASN1Dict([
        ('measurementFailedReportCharacteristics', _MeasurementFailureCause_Item_measurementFailedReportCharacteristics),
        ('cause', _MeasurementFailureCause_Item_cause),
        ('iE-Extensions', _MeasurementFailureCause_Item_iE_Extensions),
        ])
    MeasurementFailureCause_Item._ext = []
    
    #-----< MeasurementFailureCause-Item-ExtIEs >-----#
    MeasurementFailureCause_Item_ExtIEs = CLASS(name='MeasurementFailureCause-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    MeasurementFailureCause_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResourceStatusFailure >-----#
    ResourceStatusFailure = SEQ(name='ResourceStatusFailure', mode=MODE_TYPE)
    _ResourceStatusFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __ResourceStatusFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___ResourceStatusFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____ResourceStatusFailure_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Measurement-ID')))
    _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Measurement-ID')))
    _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CompleteFailureCauseInformation-List')))
    ____ResourceStatusFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 39), ('criticality', 'reject'), ('Value', _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 40), ('criticality', 'reject'), ('Value', _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 68), ('criticality', 'ignore'), ('Value', _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ResourceStatusFailure_protocolIEs__item__id._const_tab = ____ResourceStatusFailure_protocolIEs__item__id_tab
    ___ResourceStatusFailure_protocolIEs__item__id._const_tab_at = None
    ___ResourceStatusFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___ResourceStatusFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___ResourceStatusFailure_protocolIEs__item__criticality._const_tab = ____ResourceStatusFailure_protocolIEs__item__id_tab
    ___ResourceStatusFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ResourceStatusFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ResourceStatusFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___ResourceStatusFailure_protocolIEs__item__value._const_tab = ____ResourceStatusFailure_protocolIEs__item__id_tab
    ___ResourceStatusFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ResourceStatusFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __ResourceStatusFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ResourceStatusFailure_protocolIEs__item__id),
        ('criticality', ___ResourceStatusFailure_protocolIEs__item__criticality),
        ('value', ___ResourceStatusFailure_protocolIEs__item__value),
        ])
    __ResourceStatusFailure_protocolIEs__item_._ext = None
    _ResourceStatusFailure_protocolIEs._cont = __ResourceStatusFailure_protocolIEs__item_
    _ResourceStatusFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ResourceStatusFailure._cont = ASN1Dict([
        ('protocolIEs', _ResourceStatusFailure_protocolIEs),
        ])
    ResourceStatusFailure._ext = []
    
    #-----< ResourceStatusFailure-IEs >-----#
    ResourceStatusFailure_IEs = CLASS(name='ResourceStatusFailure-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _ResourceStatusFailure_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Measurement-ID')))
    _ResourceStatusFailure_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Measurement-ID')))
    _ResourceStatusFailure_IEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _ResourceStatusFailure_IEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _ResourceStatusFailure_IEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CompleteFailureCauseInformation-List')))
    ResourceStatusFailure_IEs._val = ASN1Set(rv=[dict([('id', 39), ('criticality', 'reject'), ('Value', _ResourceStatusFailure_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 40), ('criticality', 'reject'), ('Value', _ResourceStatusFailure_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _ResourceStatusFailure_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _ResourceStatusFailure_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 68), ('criticality', 'ignore'), ('Value', _ResourceStatusFailure_IEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< CompleteFailureCauseInformation-List >-----#
    CompleteFailureCauseInformation_List = SEQ_OF(name='CompleteFailureCauseInformation-List', mode=MODE_TYPE)
    _CompleteFailureCauseInformation_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __CompleteFailureCauseInformation_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ___CompleteFailureCauseInformation_List__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____CompleteFailureCauseInformation_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CompleteFailureCauseInformation-Item')))
    ___CompleteFailureCauseInformation_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 69), ('criticality', 'ignore'), ('Value', ____CompleteFailureCauseInformation_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __CompleteFailureCauseInformation_List__item__id._const_tab = ___CompleteFailureCauseInformation_List__item__id_tab
    __CompleteFailureCauseInformation_List__item__id._const_tab_at = None
    __CompleteFailureCauseInformation_List__item__id._const_tab_id = 'id'
    __CompleteFailureCauseInformation_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    __CompleteFailureCauseInformation_List__item__criticality._const_tab = ___CompleteFailureCauseInformation_List__item__id_tab
    __CompleteFailureCauseInformation_List__item__criticality._const_tab_at = ('..', 'id')
    __CompleteFailureCauseInformation_List__item__criticality._const_tab_id = 'criticality'
    __CompleteFailureCauseInformation_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    __CompleteFailureCauseInformation_List__item__value._const_tab = ___CompleteFailureCauseInformation_List__item__id_tab
    __CompleteFailureCauseInformation_List__item__value._const_tab_at = ('..', 'id')
    __CompleteFailureCauseInformation_List__item__value._const_tab_id = 'Value'
    _CompleteFailureCauseInformation_List__item_._cont = ASN1Dict([
        ('id', __CompleteFailureCauseInformation_List__item__id),
        ('criticality', __CompleteFailureCauseInformation_List__item__criticality),
        ('value', __CompleteFailureCauseInformation_List__item__value),
        ])
    _CompleteFailureCauseInformation_List__item_._ext = None
    CompleteFailureCauseInformation_List._cont = _CompleteFailureCauseInformation_List__item_
    CompleteFailureCauseInformation_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< CompleteFailureCauseInformation-ItemIEs >-----#
    CompleteFailureCauseInformation_ItemIEs = CLASS(name='CompleteFailureCauseInformation-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _CompleteFailureCauseInformation_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CompleteFailureCauseInformation-Item')))
    CompleteFailureCauseInformation_ItemIEs._val = ASN1Set(rv=[dict([('id', 69), ('criticality', 'ignore'), ('Value', _CompleteFailureCauseInformation_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< CompleteFailureCauseInformation-Item >-----#
    CompleteFailureCauseInformation_Item = SEQ(name='CompleteFailureCauseInformation-Item', mode=MODE_TYPE)
    _CompleteFailureCauseInformation_Item_cell_ID = SEQ(name='cell-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _CompleteFailureCauseInformation_Item_measurementFailureCause_List = SEQ_OF(name='measurementFailureCause-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'MeasurementFailureCause-List')))
    _CompleteFailureCauseInformation_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CompleteFailureCauseInformation_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___CompleteFailureCauseInformation_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____CompleteFailureCauseInformation_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CompleteFailureCauseInformation_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompleteFailureCauseInformation_Item_iE_Extensions__item__id._const_tab = ____CompleteFailureCauseInformation_Item_iE_Extensions__item__id_tab
    ___CompleteFailureCauseInformation_Item_iE_Extensions__item__id._const_tab_at = None
    ___CompleteFailureCauseInformation_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___CompleteFailureCauseInformation_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CompleteFailureCauseInformation_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CompleteFailureCauseInformation_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompleteFailureCauseInformation_Item_iE_Extensions__item__criticality._const_tab = ____CompleteFailureCauseInformation_Item_iE_Extensions__item__criticality_tab
    ___CompleteFailureCauseInformation_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CompleteFailureCauseInformation_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CompleteFailureCauseInformation_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CompleteFailureCauseInformation_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CompleteFailureCauseInformation_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompleteFailureCauseInformation_Item_iE_Extensions__item__extensionValue._const_tab = ____CompleteFailureCauseInformation_Item_iE_Extensions__item__extensionValue_tab
    ___CompleteFailureCauseInformation_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CompleteFailureCauseInformation_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CompleteFailureCauseInformation_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CompleteFailureCauseInformation_Item_iE_Extensions__item__id),
        ('criticality', ___CompleteFailureCauseInformation_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___CompleteFailureCauseInformation_Item_iE_Extensions__item__extensionValue),
        ])
    __CompleteFailureCauseInformation_Item_iE_Extensions__item_._ext = None
    _CompleteFailureCauseInformation_Item_iE_Extensions._cont = __CompleteFailureCauseInformation_Item_iE_Extensions__item_
    _CompleteFailureCauseInformation_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CompleteFailureCauseInformation_Item._cont = ASN1Dict([
        ('cell-ID', _CompleteFailureCauseInformation_Item_cell_ID),
        ('measurementFailureCause-List', _CompleteFailureCauseInformation_Item_measurementFailureCause_List),
        ('iE-Extensions', _CompleteFailureCauseInformation_Item_iE_Extensions),
        ])
    CompleteFailureCauseInformation_Item._ext = []
    
    #-----< CompleteFailureCauseInformation-Item-ExtIEs >-----#
    CompleteFailureCauseInformation_Item_ExtIEs = CLASS(name='CompleteFailureCauseInformation-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    CompleteFailureCauseInformation_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResourceStatusUpdate >-----#
    ResourceStatusUpdate = SEQ(name='ResourceStatusUpdate', mode=MODE_TYPE)
    _ResourceStatusUpdate_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __ResourceStatusUpdate_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___ResourceStatusUpdate_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____ResourceStatusUpdate_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Measurement-ID')))
    _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Measurement-ID')))
    _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellMeasurementResult-List')))
    ____ResourceStatusUpdate_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 39), ('criticality', 'reject'), ('Value', _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 40), ('criticality', 'reject'), ('Value', _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 32), ('criticality', 'ignore'), ('Value', _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___ResourceStatusUpdate_protocolIEs__item__id._const_tab = ____ResourceStatusUpdate_protocolIEs__item__id_tab
    ___ResourceStatusUpdate_protocolIEs__item__id._const_tab_at = None
    ___ResourceStatusUpdate_protocolIEs__item__id._const_tab_id = 'id'
    ___ResourceStatusUpdate_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___ResourceStatusUpdate_protocolIEs__item__criticality._const_tab = ____ResourceStatusUpdate_protocolIEs__item__id_tab
    ___ResourceStatusUpdate_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ResourceStatusUpdate_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ResourceStatusUpdate_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___ResourceStatusUpdate_protocolIEs__item__value._const_tab = ____ResourceStatusUpdate_protocolIEs__item__id_tab
    ___ResourceStatusUpdate_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ResourceStatusUpdate_protocolIEs__item__value._const_tab_id = 'Value'
    __ResourceStatusUpdate_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ResourceStatusUpdate_protocolIEs__item__id),
        ('criticality', ___ResourceStatusUpdate_protocolIEs__item__criticality),
        ('value', ___ResourceStatusUpdate_protocolIEs__item__value),
        ])
    __ResourceStatusUpdate_protocolIEs__item_._ext = None
    _ResourceStatusUpdate_protocolIEs._cont = __ResourceStatusUpdate_protocolIEs__item_
    _ResourceStatusUpdate_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ResourceStatusUpdate._cont = ASN1Dict([
        ('protocolIEs', _ResourceStatusUpdate_protocolIEs),
        ])
    ResourceStatusUpdate._ext = []
    
    #-----< ResourceStatusUpdate-IEs >-----#
    ResourceStatusUpdate_IEs = CLASS(name='ResourceStatusUpdate-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _ResourceStatusUpdate_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Measurement-ID')))
    _ResourceStatusUpdate_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Measurement-ID')))
    _ResourceStatusUpdate_IEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellMeasurementResult-List')))
    ResourceStatusUpdate_IEs._val = ASN1Set(rv=[dict([('id', 39), ('criticality', 'reject'), ('Value', _ResourceStatusUpdate_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 40), ('criticality', 'reject'), ('Value', _ResourceStatusUpdate_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 32), ('criticality', 'ignore'), ('Value', _ResourceStatusUpdate_IEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< CellMeasurementResult-List >-----#
    CellMeasurementResult_List = SEQ_OF(name='CellMeasurementResult-List', mode=MODE_TYPE)
    _CellMeasurementResult_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __CellMeasurementResult_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ___CellMeasurementResult_List__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____CellMeasurementResult_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellMeasurementResult-Item')))
    ___CellMeasurementResult_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 33), ('criticality', 'ignore'), ('Value', ____CellMeasurementResult_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __CellMeasurementResult_List__item__id._const_tab = ___CellMeasurementResult_List__item__id_tab
    __CellMeasurementResult_List__item__id._const_tab_at = None
    __CellMeasurementResult_List__item__id._const_tab_id = 'id'
    __CellMeasurementResult_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    __CellMeasurementResult_List__item__criticality._const_tab = ___CellMeasurementResult_List__item__id_tab
    __CellMeasurementResult_List__item__criticality._const_tab_at = ('..', 'id')
    __CellMeasurementResult_List__item__criticality._const_tab_id = 'criticality'
    __CellMeasurementResult_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    __CellMeasurementResult_List__item__value._const_tab = ___CellMeasurementResult_List__item__id_tab
    __CellMeasurementResult_List__item__value._const_tab_at = ('..', 'id')
    __CellMeasurementResult_List__item__value._const_tab_id = 'Value'
    _CellMeasurementResult_List__item_._cont = ASN1Dict([
        ('id', __CellMeasurementResult_List__item__id),
        ('criticality', __CellMeasurementResult_List__item__criticality),
        ('value', __CellMeasurementResult_List__item__value),
        ])
    _CellMeasurementResult_List__item_._ext = None
    CellMeasurementResult_List._cont = _CellMeasurementResult_List__item_
    CellMeasurementResult_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< CellMeasurementResult-ItemIEs >-----#
    CellMeasurementResult_ItemIEs = CLASS(name='CellMeasurementResult-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _CellMeasurementResult_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellMeasurementResult-Item')))
    CellMeasurementResult_ItemIEs._val = ASN1Set(rv=[dict([('id', 33), ('criticality', 'ignore'), ('Value', _CellMeasurementResult_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< CellMeasurementResult-Item >-----#
    CellMeasurementResult_Item = SEQ(name='CellMeasurementResult-Item', mode=MODE_TYPE)
    _CellMeasurementResult_Item_cell_ID = SEQ(name='cell-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _CellMeasurementResult_Item_hWLoadIndicator = SEQ(name='hWLoadIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'HWLoadIndicator')), opt=True)
    _CellMeasurementResult_Item_s1TNLLoadIndicator = SEQ(name='s1TNLLoadIndicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'S1TNLLoadIndicator')), opt=True)
    _CellMeasurementResult_Item_radioResourceStatus = SEQ(name='radioResourceStatus', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'RadioResourceStatus')), opt=True)
    _CellMeasurementResult_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellMeasurementResult_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___CellMeasurementResult_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____CellMeasurementResult_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____CellMeasurementResult_Item_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CompositeAvailableCapacityGroup')))
    _____CellMeasurementResult_Item_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ABS-Status')))
    _____CellMeasurementResult_Item_iE_Extensions__item__id_tab_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'RSRPMRList')))
    _____CellMeasurementResult_Item_iE_Extensions__item__id_tab_val_Extension_3 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CSIReportList')))
    _____CellMeasurementResult_Item_iE_Extensions__item__id_tab_val_Extension_4 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CellReportingIndicator')))
    _____CellMeasurementResult_Item_iE_Extensions__item__id_tab_val_Extension_5 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MeasurementResultforNRCellsPossiblyAggregated')))
    ____CellMeasurementResult_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 42), ('criticality', 'ignore'), ('Extension', _____CellMeasurementResult_Item_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 63), ('criticality', 'ignore'), ('Extension', _____CellMeasurementResult_Item_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 110), ('criticality', 'ignore'), ('Extension', _____CellMeasurementResult_Item_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 146), ('criticality', 'ignore'), ('Extension', _____CellMeasurementResult_Item_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 170), ('criticality', 'ignore'), ('Extension', _____CellMeasurementResult_Item_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 417), ('criticality', 'ignore'), ('Extension', _____CellMeasurementResult_Item_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___CellMeasurementResult_Item_iE_Extensions__item__id._const_tab = ____CellMeasurementResult_Item_iE_Extensions__item__id_tab
    ___CellMeasurementResult_Item_iE_Extensions__item__id._const_tab_at = None
    ___CellMeasurementResult_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___CellMeasurementResult_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___CellMeasurementResult_Item_iE_Extensions__item__criticality._const_tab = ____CellMeasurementResult_Item_iE_Extensions__item__id_tab
    ___CellMeasurementResult_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CellMeasurementResult_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CellMeasurementResult_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___CellMeasurementResult_Item_iE_Extensions__item__extensionValue._const_tab = ____CellMeasurementResult_Item_iE_Extensions__item__id_tab
    ___CellMeasurementResult_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellMeasurementResult_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CellMeasurementResult_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CellMeasurementResult_Item_iE_Extensions__item__id),
        ('criticality', ___CellMeasurementResult_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___CellMeasurementResult_Item_iE_Extensions__item__extensionValue),
        ])
    __CellMeasurementResult_Item_iE_Extensions__item_._ext = None
    _CellMeasurementResult_Item_iE_Extensions._cont = __CellMeasurementResult_Item_iE_Extensions__item_
    _CellMeasurementResult_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellMeasurementResult_Item._cont = ASN1Dict([
        ('cell-ID', _CellMeasurementResult_Item_cell_ID),
        ('hWLoadIndicator', _CellMeasurementResult_Item_hWLoadIndicator),
        ('s1TNLLoadIndicator', _CellMeasurementResult_Item_s1TNLLoadIndicator),
        ('radioResourceStatus', _CellMeasurementResult_Item_radioResourceStatus),
        ('iE-Extensions', _CellMeasurementResult_Item_iE_Extensions),
        ])
    CellMeasurementResult_Item._ext = []
    
    #-----< CellMeasurementResult-Item-ExtIEs >-----#
    CellMeasurementResult_Item_ExtIEs = CLASS(name='CellMeasurementResult-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _CellMeasurementResult_Item_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CompositeAvailableCapacityGroup')))
    _CellMeasurementResult_Item_ExtIEs_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ABS-Status')))
    _CellMeasurementResult_Item_ExtIEs_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'RSRPMRList')))
    _CellMeasurementResult_Item_ExtIEs_val_Extension_3 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CSIReportList')))
    _CellMeasurementResult_Item_ExtIEs_val_Extension_4 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CellReportingIndicator')))
    _CellMeasurementResult_Item_ExtIEs_val_Extension_5 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MeasurementResultforNRCellsPossiblyAggregated')))
    CellMeasurementResult_Item_ExtIEs._val = ASN1Set(rv=[dict([('id', 42), ('criticality', 'ignore'), ('Extension', _CellMeasurementResult_Item_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 63), ('criticality', 'ignore'), ('Extension', _CellMeasurementResult_Item_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 110), ('criticality', 'ignore'), ('Extension', _CellMeasurementResult_Item_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 146), ('criticality', 'ignore'), ('Extension', _CellMeasurementResult_Item_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 170), ('criticality', 'ignore'), ('Extension', _CellMeasurementResult_Item_ExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 417), ('criticality', 'ignore'), ('Extension', _CellMeasurementResult_Item_ExtIEs_val_Extension_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PrivateMessage >-----#
    PrivateMessage = SEQ(name='PrivateMessage', mode=MODE_TYPE)
    _PrivateMessage_privateIEs = SEQ_OF(name='privateIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'PrivateIE-Container')))
    __PrivateMessage_privateIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'PrivateIE-Field')))
    ___PrivateMessage_privateIEs__item__id = CHOICE(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PRIVATE-IES'), ['id']))
    ____PrivateMessage_privateIEs__item__id_tab = CLASS(name='_tab_X2AP-PRIVATE-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PRIVATE-IES')))
    ____PrivateMessage_privateIEs__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrivateMessage_privateIEs__item__id._const_tab = ____PrivateMessage_privateIEs__item__id_tab
    ___PrivateMessage_privateIEs__item__id._const_tab_at = None
    ___PrivateMessage_privateIEs__item__id._const_tab_id = 'id'
    ___PrivateMessage_privateIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PRIVATE-IES'), ['criticality']))
    ____PrivateMessage_privateIEs__item__criticality_tab = CLASS(name='_tab_X2AP-PRIVATE-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PRIVATE-IES')))
    ____PrivateMessage_privateIEs__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrivateMessage_privateIEs__item__criticality._const_tab = ____PrivateMessage_privateIEs__item__criticality_tab
    ___PrivateMessage_privateIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PrivateMessage_privateIEs__item__criticality._const_tab_id = 'criticality'
    ___PrivateMessage_privateIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PRIVATE-IES'), ['Value']))
    ____PrivateMessage_privateIEs__item__value_tab = CLASS(name='_tab_X2AP-PRIVATE-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PRIVATE-IES')))
    ____PrivateMessage_privateIEs__item__value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrivateMessage_privateIEs__item__value._const_tab = ____PrivateMessage_privateIEs__item__value_tab
    ___PrivateMessage_privateIEs__item__value._const_tab_at = ('..', 'id')
    ___PrivateMessage_privateIEs__item__value._const_tab_id = 'Value'
    __PrivateMessage_privateIEs__item_._cont = ASN1Dict([
        ('id', ___PrivateMessage_privateIEs__item__id),
        ('criticality', ___PrivateMessage_privateIEs__item__criticality),
        ('value', ___PrivateMessage_privateIEs__item__value),
        ])
    __PrivateMessage_privateIEs__item_._ext = None
    _PrivateMessage_privateIEs._cont = __PrivateMessage_privateIEs__item_
    _PrivateMessage_privateIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PrivateMessage._cont = ASN1Dict([
        ('privateIEs', _PrivateMessage_privateIEs),
        ])
    PrivateMessage._ext = []
    
    #-----< PrivateMessage-IEs >-----#
    PrivateMessage_IEs = CLASS(name='PrivateMessage-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PRIVATE-IES')))
    PrivateMessage_IEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MobilityChangeRequest >-----#
    MobilityChangeRequest = SEQ(name='MobilityChangeRequest', mode=MODE_TYPE)
    _MobilityChangeRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __MobilityChangeRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___MobilityChangeRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____MobilityChangeRequest_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____MobilityChangeRequest_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _____MobilityChangeRequest_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _____MobilityChangeRequest_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MobilityParametersInformation')))
    _____MobilityChangeRequest_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MobilityParametersInformation')))
    _____MobilityChangeRequest_protocolIEs__item__id_tab_val_Value_4 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    ____MobilityChangeRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 43), ('criticality', 'reject'), ('Value', _____MobilityChangeRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 44), ('criticality', 'reject'), ('Value', _____MobilityChangeRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 46), ('criticality', 'ignore'), ('Value', _____MobilityChangeRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 45), ('criticality', 'reject'), ('Value', _____MobilityChangeRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'reject'), ('Value', _____MobilityChangeRequest_protocolIEs__item__id_tab_val_Value_4), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___MobilityChangeRequest_protocolIEs__item__id._const_tab = ____MobilityChangeRequest_protocolIEs__item__id_tab
    ___MobilityChangeRequest_protocolIEs__item__id._const_tab_at = None
    ___MobilityChangeRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___MobilityChangeRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___MobilityChangeRequest_protocolIEs__item__criticality._const_tab = ____MobilityChangeRequest_protocolIEs__item__id_tab
    ___MobilityChangeRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MobilityChangeRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MobilityChangeRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___MobilityChangeRequest_protocolIEs__item__value._const_tab = ____MobilityChangeRequest_protocolIEs__item__id_tab
    ___MobilityChangeRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MobilityChangeRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __MobilityChangeRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MobilityChangeRequest_protocolIEs__item__id),
        ('criticality', ___MobilityChangeRequest_protocolIEs__item__criticality),
        ('value', ___MobilityChangeRequest_protocolIEs__item__value),
        ])
    __MobilityChangeRequest_protocolIEs__item_._ext = None
    _MobilityChangeRequest_protocolIEs._cont = __MobilityChangeRequest_protocolIEs__item_
    _MobilityChangeRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MobilityChangeRequest._cont = ASN1Dict([
        ('protocolIEs', _MobilityChangeRequest_protocolIEs),
        ])
    MobilityChangeRequest._ext = []
    
    #-----< MobilityChangeRequest-IEs >-----#
    MobilityChangeRequest_IEs = CLASS(name='MobilityChangeRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _MobilityChangeRequest_IEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _MobilityChangeRequest_IEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _MobilityChangeRequest_IEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MobilityParametersInformation')))
    _MobilityChangeRequest_IEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MobilityParametersInformation')))
    _MobilityChangeRequest_IEs_val_Value_4 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    MobilityChangeRequest_IEs._val = ASN1Set(rv=[dict([('id', 43), ('criticality', 'reject'), ('Value', _MobilityChangeRequest_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 44), ('criticality', 'reject'), ('Value', _MobilityChangeRequest_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 46), ('criticality', 'ignore'), ('Value', _MobilityChangeRequest_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 45), ('criticality', 'reject'), ('Value', _MobilityChangeRequest_IEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'reject'), ('Value', _MobilityChangeRequest_IEs_val_Value_4), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< MobilityChangeAcknowledge >-----#
    MobilityChangeAcknowledge = SEQ(name='MobilityChangeAcknowledge', mode=MODE_TYPE)
    _MobilityChangeAcknowledge_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __MobilityChangeAcknowledge_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___MobilityChangeAcknowledge_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____MobilityChangeAcknowledge_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____MobilityChangeAcknowledge_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _____MobilityChangeAcknowledge_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _____MobilityChangeAcknowledge_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    ____MobilityChangeAcknowledge_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 43), ('criticality', 'reject'), ('Value', _____MobilityChangeAcknowledge_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 44), ('criticality', 'reject'), ('Value', _____MobilityChangeAcknowledge_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _____MobilityChangeAcknowledge_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MobilityChangeAcknowledge_protocolIEs__item__id._const_tab = ____MobilityChangeAcknowledge_protocolIEs__item__id_tab
    ___MobilityChangeAcknowledge_protocolIEs__item__id._const_tab_at = None
    ___MobilityChangeAcknowledge_protocolIEs__item__id._const_tab_id = 'id'
    ___MobilityChangeAcknowledge_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___MobilityChangeAcknowledge_protocolIEs__item__criticality._const_tab = ____MobilityChangeAcknowledge_protocolIEs__item__id_tab
    ___MobilityChangeAcknowledge_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MobilityChangeAcknowledge_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MobilityChangeAcknowledge_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___MobilityChangeAcknowledge_protocolIEs__item__value._const_tab = ____MobilityChangeAcknowledge_protocolIEs__item__id_tab
    ___MobilityChangeAcknowledge_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MobilityChangeAcknowledge_protocolIEs__item__value._const_tab_id = 'Value'
    __MobilityChangeAcknowledge_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MobilityChangeAcknowledge_protocolIEs__item__id),
        ('criticality', ___MobilityChangeAcknowledge_protocolIEs__item__criticality),
        ('value', ___MobilityChangeAcknowledge_protocolIEs__item__value),
        ])
    __MobilityChangeAcknowledge_protocolIEs__item_._ext = None
    _MobilityChangeAcknowledge_protocolIEs._cont = __MobilityChangeAcknowledge_protocolIEs__item_
    _MobilityChangeAcknowledge_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MobilityChangeAcknowledge._cont = ASN1Dict([
        ('protocolIEs', _MobilityChangeAcknowledge_protocolIEs),
        ])
    MobilityChangeAcknowledge._ext = []
    
    #-----< MobilityChangeAcknowledge-IEs >-----#
    MobilityChangeAcknowledge_IEs = CLASS(name='MobilityChangeAcknowledge-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _MobilityChangeAcknowledge_IEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _MobilityChangeAcknowledge_IEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _MobilityChangeAcknowledge_IEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    MobilityChangeAcknowledge_IEs._val = ASN1Set(rv=[dict([('id', 43), ('criticality', 'reject'), ('Value', _MobilityChangeAcknowledge_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 44), ('criticality', 'reject'), ('Value', _MobilityChangeAcknowledge_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _MobilityChangeAcknowledge_IEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MobilityChangeFailure >-----#
    MobilityChangeFailure = SEQ(name='MobilityChangeFailure', mode=MODE_TYPE)
    _MobilityChangeFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __MobilityChangeFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___MobilityChangeFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____MobilityChangeFailure_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____MobilityChangeFailure_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _____MobilityChangeFailure_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _____MobilityChangeFailure_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _____MobilityChangeFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MobilityParametersModificationRange')))
    _____MobilityChangeFailure_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    ____MobilityChangeFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 43), ('criticality', 'ignore'), ('Value', _____MobilityChangeFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 44), ('criticality', 'ignore'), ('Value', _____MobilityChangeFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _____MobilityChangeFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 47), ('criticality', 'ignore'), ('Value', _____MobilityChangeFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _____MobilityChangeFailure_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MobilityChangeFailure_protocolIEs__item__id._const_tab = ____MobilityChangeFailure_protocolIEs__item__id_tab
    ___MobilityChangeFailure_protocolIEs__item__id._const_tab_at = None
    ___MobilityChangeFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___MobilityChangeFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___MobilityChangeFailure_protocolIEs__item__criticality._const_tab = ____MobilityChangeFailure_protocolIEs__item__id_tab
    ___MobilityChangeFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MobilityChangeFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MobilityChangeFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___MobilityChangeFailure_protocolIEs__item__value._const_tab = ____MobilityChangeFailure_protocolIEs__item__id_tab
    ___MobilityChangeFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MobilityChangeFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __MobilityChangeFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MobilityChangeFailure_protocolIEs__item__id),
        ('criticality', ___MobilityChangeFailure_protocolIEs__item__criticality),
        ('value', ___MobilityChangeFailure_protocolIEs__item__value),
        ])
    __MobilityChangeFailure_protocolIEs__item_._ext = None
    _MobilityChangeFailure_protocolIEs._cont = __MobilityChangeFailure_protocolIEs__item_
    _MobilityChangeFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MobilityChangeFailure._cont = ASN1Dict([
        ('protocolIEs', _MobilityChangeFailure_protocolIEs),
        ])
    MobilityChangeFailure._ext = []
    
    #-----< MobilityChangeFailure-IEs >-----#
    MobilityChangeFailure_IEs = CLASS(name='MobilityChangeFailure-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _MobilityChangeFailure_IEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _MobilityChangeFailure_IEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _MobilityChangeFailure_IEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _MobilityChangeFailure_IEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MobilityParametersModificationRange')))
    _MobilityChangeFailure_IEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    MobilityChangeFailure_IEs._val = ASN1Set(rv=[dict([('id', 43), ('criticality', 'ignore'), ('Value', _MobilityChangeFailure_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 44), ('criticality', 'ignore'), ('Value', _MobilityChangeFailure_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _MobilityChangeFailure_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 47), ('criticality', 'ignore'), ('Value', _MobilityChangeFailure_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _MobilityChangeFailure_IEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RLFIndication >-----#
    RLFIndication = SEQ(name='RLFIndication', mode=MODE_TYPE)
    _RLFIndication_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __RLFIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___RLFIndication_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____RLFIndication_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____RLFIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PCI')))
    _____RLFIndication_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _____RLFIndication_protocolIEs__item__id_tab_val_Value_2 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CRNTI')))
    _____RLFIndication_protocolIEs__item__id_tab_val_Value_3 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ShortMAC-I')))
    _____RLFIndication_protocolIEs__item__id_tab_val_Value_4 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-RLF-Report-Container')))
    _____RLFIndication_protocolIEs__item__id_tab_val_Value_5 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'RRCConnSetupIndicator')))
    _____RLFIndication_protocolIEs__item__id_tab_val_Value_6 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'RRCConnReestabIndicator')))
    _____RLFIndication_protocolIEs__item__id_tab_val_Value_7 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-RLF-Report-Container-for-extended-bands')))
    _____RLFIndication_protocolIEs__item__id_tab_val_Value_8 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'NBIoT-RLF-Report-Container')))
    ____RLFIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 48), ('criticality', 'ignore'), ('Value', _____RLFIndication_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 49), ('criticality', 'ignore'), ('Value', _____RLFIndication_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 50), ('criticality', 'ignore'), ('Value', _____RLFIndication_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 51), ('criticality', 'ignore'), ('Value', _____RLFIndication_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 60), ('criticality', 'ignore'), ('Value', _____RLFIndication_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 75), ('criticality', 'reject'), ('Value', _____RLFIndication_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 78), ('criticality', 'ignore'), ('Value', _____RLFIndication_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 107), ('criticality', 'ignore'), ('Value', _____RLFIndication_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')]), dict([('id', 374), ('criticality', 'ignore'), ('Value', _____RLFIndication_protocolIEs__item__id_tab_val_Value_8), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RLFIndication_protocolIEs__item__id._const_tab = ____RLFIndication_protocolIEs__item__id_tab
    ___RLFIndication_protocolIEs__item__id._const_tab_at = None
    ___RLFIndication_protocolIEs__item__id._const_tab_id = 'id'
    ___RLFIndication_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___RLFIndication_protocolIEs__item__criticality._const_tab = ____RLFIndication_protocolIEs__item__id_tab
    ___RLFIndication_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RLFIndication_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RLFIndication_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___RLFIndication_protocolIEs__item__value._const_tab = ____RLFIndication_protocolIEs__item__id_tab
    ___RLFIndication_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RLFIndication_protocolIEs__item__value._const_tab_id = 'Value'
    __RLFIndication_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RLFIndication_protocolIEs__item__id),
        ('criticality', ___RLFIndication_protocolIEs__item__criticality),
        ('value', ___RLFIndication_protocolIEs__item__value),
        ])
    __RLFIndication_protocolIEs__item_._ext = None
    _RLFIndication_protocolIEs._cont = __RLFIndication_protocolIEs__item_
    _RLFIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RLFIndication._cont = ASN1Dict([
        ('protocolIEs', _RLFIndication_protocolIEs),
        ])
    RLFIndication._ext = []
    
    #-----< RLFIndication-IEs >-----#
    RLFIndication_IEs = CLASS(name='RLFIndication-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _RLFIndication_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PCI')))
    _RLFIndication_IEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _RLFIndication_IEs_val_Value_2 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CRNTI')))
    _RLFIndication_IEs_val_Value_3 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ShortMAC-I')))
    _RLFIndication_IEs_val_Value_4 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-RLF-Report-Container')))
    _RLFIndication_IEs_val_Value_5 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'RRCConnSetupIndicator')))
    _RLFIndication_IEs_val_Value_6 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'RRCConnReestabIndicator')))
    _RLFIndication_IEs_val_Value_7 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-RLF-Report-Container-for-extended-bands')))
    _RLFIndication_IEs_val_Value_8 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'NBIoT-RLF-Report-Container')))
    RLFIndication_IEs._val = ASN1Set(rv=[dict([('id', 48), ('criticality', 'ignore'), ('Value', _RLFIndication_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 49), ('criticality', 'ignore'), ('Value', _RLFIndication_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 50), ('criticality', 'ignore'), ('Value', _RLFIndication_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 51), ('criticality', 'ignore'), ('Value', _RLFIndication_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 60), ('criticality', 'ignore'), ('Value', _RLFIndication_IEs_val_Value_4), ('presence', 'optional')]), dict([('id', 75), ('criticality', 'reject'), ('Value', _RLFIndication_IEs_val_Value_5), ('presence', 'optional')]), dict([('id', 78), ('criticality', 'ignore'), ('Value', _RLFIndication_IEs_val_Value_6), ('presence', 'optional')]), dict([('id', 107), ('criticality', 'ignore'), ('Value', _RLFIndication_IEs_val_Value_7), ('presence', 'optional')]), dict([('id', 374), ('criticality', 'ignore'), ('Value', _RLFIndication_IEs_val_Value_8), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< CellActivationRequest >-----#
    CellActivationRequest = SEQ(name='CellActivationRequest', mode=MODE_TYPE)
    _CellActivationRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __CellActivationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___CellActivationRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____CellActivationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____CellActivationRequest_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ServedCellsToActivate')))
    ____CellActivationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 57), ('criticality', 'reject'), ('Value', _____CellActivationRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___CellActivationRequest_protocolIEs__item__id._const_tab = ____CellActivationRequest_protocolIEs__item__id_tab
    ___CellActivationRequest_protocolIEs__item__id._const_tab_at = None
    ___CellActivationRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___CellActivationRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___CellActivationRequest_protocolIEs__item__criticality._const_tab = ____CellActivationRequest_protocolIEs__item__id_tab
    ___CellActivationRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___CellActivationRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___CellActivationRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___CellActivationRequest_protocolIEs__item__value._const_tab = ____CellActivationRequest_protocolIEs__item__id_tab
    ___CellActivationRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___CellActivationRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __CellActivationRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___CellActivationRequest_protocolIEs__item__id),
        ('criticality', ___CellActivationRequest_protocolIEs__item__criticality),
        ('value', ___CellActivationRequest_protocolIEs__item__value),
        ])
    __CellActivationRequest_protocolIEs__item_._ext = None
    _CellActivationRequest_protocolIEs._cont = __CellActivationRequest_protocolIEs__item_
    _CellActivationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    CellActivationRequest._cont = ASN1Dict([
        ('protocolIEs', _CellActivationRequest_protocolIEs),
        ])
    CellActivationRequest._ext = []
    
    #-----< CellActivationRequest-IEs >-----#
    CellActivationRequest_IEs = CLASS(name='CellActivationRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _CellActivationRequest_IEs_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ServedCellsToActivate')))
    CellActivationRequest_IEs._val = ASN1Set(rv=[dict([('id', 57), ('criticality', 'reject'), ('Value', _CellActivationRequest_IEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< ServedCellsToActivate >-----#
    ServedCellsToActivate = SEQ_OF(name='ServedCellsToActivate', mode=MODE_TYPE)
    _ServedCellsToActivate__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ServedCellsToActivate-Item')))
    ServedCellsToActivate._cont = _ServedCellsToActivate__item_
    ServedCellsToActivate._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< ServedCellsToActivate-Item >-----#
    ServedCellsToActivate_Item = SEQ(name='ServedCellsToActivate-Item', mode=MODE_TYPE)
    _ServedCellsToActivate_Item_ecgi = SEQ(name='ecgi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _ServedCellsToActivate_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ServedCellsToActivate_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___ServedCellsToActivate_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____ServedCellsToActivate_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ServedCellsToActivate_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ServedCellsToActivate_Item_iE_Extensions__item__id._const_tab = ____ServedCellsToActivate_Item_iE_Extensions__item__id_tab
    ___ServedCellsToActivate_Item_iE_Extensions__item__id._const_tab_at = None
    ___ServedCellsToActivate_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___ServedCellsToActivate_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ServedCellsToActivate_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ServedCellsToActivate_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ServedCellsToActivate_Item_iE_Extensions__item__criticality._const_tab = ____ServedCellsToActivate_Item_iE_Extensions__item__criticality_tab
    ___ServedCellsToActivate_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ServedCellsToActivate_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ServedCellsToActivate_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ServedCellsToActivate_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ServedCellsToActivate_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ServedCellsToActivate_Item_iE_Extensions__item__extensionValue._const_tab = ____ServedCellsToActivate_Item_iE_Extensions__item__extensionValue_tab
    ___ServedCellsToActivate_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ServedCellsToActivate_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ServedCellsToActivate_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ServedCellsToActivate_Item_iE_Extensions__item__id),
        ('criticality', ___ServedCellsToActivate_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___ServedCellsToActivate_Item_iE_Extensions__item__extensionValue),
        ])
    __ServedCellsToActivate_Item_iE_Extensions__item_._ext = None
    _ServedCellsToActivate_Item_iE_Extensions._cont = __ServedCellsToActivate_Item_iE_Extensions__item_
    _ServedCellsToActivate_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ServedCellsToActivate_Item._cont = ASN1Dict([
        ('ecgi', _ServedCellsToActivate_Item_ecgi),
        ('iE-Extensions', _ServedCellsToActivate_Item_iE_Extensions),
        ])
    ServedCellsToActivate_Item._ext = []
    
    #-----< ServedCellsToActivate-Item-ExtIEs >-----#
    ServedCellsToActivate_Item_ExtIEs = CLASS(name='ServedCellsToActivate-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ServedCellsToActivate_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellActivationResponse >-----#
    CellActivationResponse = SEQ(name='CellActivationResponse', mode=MODE_TYPE)
    _CellActivationResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __CellActivationResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___CellActivationResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____CellActivationResponse_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____CellActivationResponse_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ActivatedCellList')))
    _____CellActivationResponse_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    ____CellActivationResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 58), ('criticality', 'ignore'), ('Value', _____CellActivationResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _____CellActivationResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___CellActivationResponse_protocolIEs__item__id._const_tab = ____CellActivationResponse_protocolIEs__item__id_tab
    ___CellActivationResponse_protocolIEs__item__id._const_tab_at = None
    ___CellActivationResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___CellActivationResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___CellActivationResponse_protocolIEs__item__criticality._const_tab = ____CellActivationResponse_protocolIEs__item__id_tab
    ___CellActivationResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___CellActivationResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___CellActivationResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___CellActivationResponse_protocolIEs__item__value._const_tab = ____CellActivationResponse_protocolIEs__item__id_tab
    ___CellActivationResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___CellActivationResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __CellActivationResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___CellActivationResponse_protocolIEs__item__id),
        ('criticality', ___CellActivationResponse_protocolIEs__item__criticality),
        ('value', ___CellActivationResponse_protocolIEs__item__value),
        ])
    __CellActivationResponse_protocolIEs__item_._ext = None
    _CellActivationResponse_protocolIEs._cont = __CellActivationResponse_protocolIEs__item_
    _CellActivationResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    CellActivationResponse._cont = ASN1Dict([
        ('protocolIEs', _CellActivationResponse_protocolIEs),
        ])
    CellActivationResponse._ext = []
    
    #-----< CellActivationResponse-IEs >-----#
    CellActivationResponse_IEs = CLASS(name='CellActivationResponse-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _CellActivationResponse_IEs_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ActivatedCellList')))
    _CellActivationResponse_IEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    CellActivationResponse_IEs._val = ASN1Set(rv=[dict([('id', 58), ('criticality', 'ignore'), ('Value', _CellActivationResponse_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _CellActivationResponse_IEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ActivatedCellList >-----#
    ActivatedCellList = SEQ_OF(name='ActivatedCellList', mode=MODE_TYPE)
    _ActivatedCellList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ActivatedCellList-Item')))
    ActivatedCellList._cont = _ActivatedCellList__item_
    ActivatedCellList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< ActivatedCellList-Item >-----#
    ActivatedCellList_Item = SEQ(name='ActivatedCellList-Item', mode=MODE_TYPE)
    _ActivatedCellList_Item_ecgi = SEQ(name='ecgi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _ActivatedCellList_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ActivatedCellList_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___ActivatedCellList_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____ActivatedCellList_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ActivatedCellList_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ActivatedCellList_Item_iE_Extensions__item__id._const_tab = ____ActivatedCellList_Item_iE_Extensions__item__id_tab
    ___ActivatedCellList_Item_iE_Extensions__item__id._const_tab_at = None
    ___ActivatedCellList_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___ActivatedCellList_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ActivatedCellList_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ActivatedCellList_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ActivatedCellList_Item_iE_Extensions__item__criticality._const_tab = ____ActivatedCellList_Item_iE_Extensions__item__criticality_tab
    ___ActivatedCellList_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ActivatedCellList_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ActivatedCellList_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ActivatedCellList_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ActivatedCellList_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ActivatedCellList_Item_iE_Extensions__item__extensionValue._const_tab = ____ActivatedCellList_Item_iE_Extensions__item__extensionValue_tab
    ___ActivatedCellList_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ActivatedCellList_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ActivatedCellList_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ActivatedCellList_Item_iE_Extensions__item__id),
        ('criticality', ___ActivatedCellList_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___ActivatedCellList_Item_iE_Extensions__item__extensionValue),
        ])
    __ActivatedCellList_Item_iE_Extensions__item_._ext = None
    _ActivatedCellList_Item_iE_Extensions._cont = __ActivatedCellList_Item_iE_Extensions__item_
    _ActivatedCellList_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ActivatedCellList_Item._cont = ASN1Dict([
        ('ecgi', _ActivatedCellList_Item_ecgi),
        ('iE-Extensions', _ActivatedCellList_Item_iE_Extensions),
        ])
    ActivatedCellList_Item._ext = []
    
    #-----< ActivatedCellList-Item-ExtIEs >-----#
    ActivatedCellList_Item_ExtIEs = CLASS(name='ActivatedCellList-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ActivatedCellList_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellActivationFailure >-----#
    CellActivationFailure = SEQ(name='CellActivationFailure', mode=MODE_TYPE)
    _CellActivationFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __CellActivationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___CellActivationFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____CellActivationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____CellActivationFailure_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _____CellActivationFailure_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    ____CellActivationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 5), ('criticality', 'ignore'), ('Value', _____CellActivationFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _____CellActivationFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___CellActivationFailure_protocolIEs__item__id._const_tab = ____CellActivationFailure_protocolIEs__item__id_tab
    ___CellActivationFailure_protocolIEs__item__id._const_tab_at = None
    ___CellActivationFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___CellActivationFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___CellActivationFailure_protocolIEs__item__criticality._const_tab = ____CellActivationFailure_protocolIEs__item__id_tab
    ___CellActivationFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___CellActivationFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___CellActivationFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___CellActivationFailure_protocolIEs__item__value._const_tab = ____CellActivationFailure_protocolIEs__item__id_tab
    ___CellActivationFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___CellActivationFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __CellActivationFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___CellActivationFailure_protocolIEs__item__id),
        ('criticality', ___CellActivationFailure_protocolIEs__item__criticality),
        ('value', ___CellActivationFailure_protocolIEs__item__value),
        ])
    __CellActivationFailure_protocolIEs__item_._ext = None
    _CellActivationFailure_protocolIEs._cont = __CellActivationFailure_protocolIEs__item_
    _CellActivationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    CellActivationFailure._cont = ASN1Dict([
        ('protocolIEs', _CellActivationFailure_protocolIEs),
        ])
    CellActivationFailure._ext = []
    
    #-----< CellActivationFailure-IEs >-----#
    CellActivationFailure_IEs = CLASS(name='CellActivationFailure-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _CellActivationFailure_IEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _CellActivationFailure_IEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    CellActivationFailure_IEs._val = ASN1Set(rv=[dict([('id', 5), ('criticality', 'ignore'), ('Value', _CellActivationFailure_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _CellActivationFailure_IEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< X2Release >-----#
    X2Release = SEQ(name='X2Release', mode=MODE_TYPE)
    _X2Release_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __X2Release_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___X2Release_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____X2Release_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____X2Release_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GlobalENB-ID')))
    ____X2Release_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 21), ('criticality', 'reject'), ('Value', _____X2Release_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___X2Release_protocolIEs__item__id._const_tab = ____X2Release_protocolIEs__item__id_tab
    ___X2Release_protocolIEs__item__id._const_tab_at = None
    ___X2Release_protocolIEs__item__id._const_tab_id = 'id'
    ___X2Release_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___X2Release_protocolIEs__item__criticality._const_tab = ____X2Release_protocolIEs__item__id_tab
    ___X2Release_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___X2Release_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___X2Release_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___X2Release_protocolIEs__item__value._const_tab = ____X2Release_protocolIEs__item__id_tab
    ___X2Release_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___X2Release_protocolIEs__item__value._const_tab_id = 'Value'
    __X2Release_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___X2Release_protocolIEs__item__id),
        ('criticality', ___X2Release_protocolIEs__item__criticality),
        ('value', ___X2Release_protocolIEs__item__value),
        ])
    __X2Release_protocolIEs__item_._ext = None
    _X2Release_protocolIEs._cont = __X2Release_protocolIEs__item_
    _X2Release_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    X2Release._cont = ASN1Dict([
        ('protocolIEs', _X2Release_protocolIEs),
        ])
    X2Release._ext = []
    
    #-----< X2Release-IEs >-----#
    X2Release_IEs = CLASS(name='X2Release-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _X2Release_IEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GlobalENB-ID')))
    X2Release_IEs._val = ASN1Set(rv=[dict([('id', 21), ('criticality', 'reject'), ('Value', _X2Release_IEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< X2APMessageTransfer >-----#
    X2APMessageTransfer = SEQ(name='X2APMessageTransfer', mode=MODE_TYPE)
    _X2APMessageTransfer_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __X2APMessageTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___X2APMessageTransfer_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____X2APMessageTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____X2APMessageTransfer_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'RNL-Header')))
    _____X2APMessageTransfer_protocolIEs__item__id_tab_val_Value_1 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2AP-Message')))
    ____X2APMessageTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 101), ('criticality', 'reject'), ('Value', _____X2APMessageTransfer_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 102), ('criticality', 'reject'), ('Value', _____X2APMessageTransfer_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___X2APMessageTransfer_protocolIEs__item__id._const_tab = ____X2APMessageTransfer_protocolIEs__item__id_tab
    ___X2APMessageTransfer_protocolIEs__item__id._const_tab_at = None
    ___X2APMessageTransfer_protocolIEs__item__id._const_tab_id = 'id'
    ___X2APMessageTransfer_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___X2APMessageTransfer_protocolIEs__item__criticality._const_tab = ____X2APMessageTransfer_protocolIEs__item__id_tab
    ___X2APMessageTransfer_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___X2APMessageTransfer_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___X2APMessageTransfer_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___X2APMessageTransfer_protocolIEs__item__value._const_tab = ____X2APMessageTransfer_protocolIEs__item__id_tab
    ___X2APMessageTransfer_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___X2APMessageTransfer_protocolIEs__item__value._const_tab_id = 'Value'
    __X2APMessageTransfer_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___X2APMessageTransfer_protocolIEs__item__id),
        ('criticality', ___X2APMessageTransfer_protocolIEs__item__criticality),
        ('value', ___X2APMessageTransfer_protocolIEs__item__value),
        ])
    __X2APMessageTransfer_protocolIEs__item_._ext = None
    _X2APMessageTransfer_protocolIEs._cont = __X2APMessageTransfer_protocolIEs__item_
    _X2APMessageTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    X2APMessageTransfer._cont = ASN1Dict([
        ('protocolIEs', _X2APMessageTransfer_protocolIEs),
        ])
    X2APMessageTransfer._ext = []
    
    #-----< X2APMessageTransfer-IEs >-----#
    X2APMessageTransfer_IEs = CLASS(name='X2APMessageTransfer-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _X2APMessageTransfer_IEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'RNL-Header')))
    _X2APMessageTransfer_IEs_val_Value_1 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2AP-Message')))
    X2APMessageTransfer_IEs._val = ASN1Set(rv=[dict([('id', 101), ('criticality', 'reject'), ('Value', _X2APMessageTransfer_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 102), ('criticality', 'reject'), ('Value', _X2APMessageTransfer_IEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RNL-Header >-----#
    RNL_Header = SEQ(name='RNL-Header', mode=MODE_TYPE)
    _RNL_Header_source_GlobalENB_ID = SEQ(name='source-GlobalENB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GlobalENB-ID')))
    _RNL_Header_target_GlobalENB_ID = SEQ(name='target-GlobalENB-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GlobalENB-ID')), opt=True)
    _RNL_Header_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RNL_Header_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___RNL_Header_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____RNL_Header_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____RNL_Header_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RNL_Header_iE_Extensions__item__id._const_tab = ____RNL_Header_iE_Extensions__item__id_tab
    ___RNL_Header_iE_Extensions__item__id._const_tab_at = None
    ___RNL_Header_iE_Extensions__item__id._const_tab_id = 'id'
    ___RNL_Header_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RNL_Header_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____RNL_Header_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RNL_Header_iE_Extensions__item__criticality._const_tab = ____RNL_Header_iE_Extensions__item__criticality_tab
    ___RNL_Header_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RNL_Header_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RNL_Header_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RNL_Header_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____RNL_Header_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RNL_Header_iE_Extensions__item__extensionValue._const_tab = ____RNL_Header_iE_Extensions__item__extensionValue_tab
    ___RNL_Header_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RNL_Header_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RNL_Header_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RNL_Header_iE_Extensions__item__id),
        ('criticality', ___RNL_Header_iE_Extensions__item__criticality),
        ('extensionValue', ___RNL_Header_iE_Extensions__item__extensionValue),
        ])
    __RNL_Header_iE_Extensions__item_._ext = None
    _RNL_Header_iE_Extensions._cont = __RNL_Header_iE_Extensions__item_
    _RNL_Header_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RNL_Header._cont = ASN1Dict([
        ('source-GlobalENB-ID', _RNL_Header_source_GlobalENB_ID),
        ('target-GlobalENB-ID', _RNL_Header_target_GlobalENB_ID),
        ('iE-Extensions', _RNL_Header_iE_Extensions),
        ])
    RNL_Header._ext = []
    
    #-----< RNL-Header-Item-ExtIEs >-----#
    RNL_Header_Item_ExtIEs = CLASS(name='RNL-Header-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    RNL_Header_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< X2AP-Message >-----#
    X2AP_Message = OCT_STR(name='X2AP-Message', mode=MODE_TYPE)
    
    #-----< SeNBAdditionRequest >-----#
    SeNBAdditionRequest = SEQ(name='SeNBAdditionRequest', mode=MODE_TYPE)
    _SeNBAdditionRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __SeNBAdditionRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___SeNBAdditionRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____SeNBAdditionRequest_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UESecurityCapabilities')))
    _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_2 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SeNBSecurityKey')))
    _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UEAggregateMaximumBitRate')))
    _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_4 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PLMN-Identity')))
    _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeAdded-List')))
    _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_6 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MeNBtoSeNBContainer')))
    _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_7 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CSGMembershipStatus')))
    _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_8 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_9 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_10 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ExpectedUEBehaviour')))
    _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_11 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    ____SeNBAdditionRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'reject'), ('Value', _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 113), ('criticality', 'reject'), ('Value', _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'conditional')]), dict([('id', 114), ('criticality', 'reject'), ('Value', _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'conditional')]), dict([('id', 115), ('criticality', 'reject'), ('Value', _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 116), ('criticality', 'ignore'), ('Value', _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 117), ('criticality', 'reject'), ('Value', _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_5), ('presence', 'mandatory')]), dict([('id', 119), ('criticality', 'reject'), ('Value', _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_6), ('presence', 'mandatory')]), dict([('id', 71), ('criticality', 'reject'), ('Value', _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')]), dict([('id', 112), ('criticality', 'reject'), ('Value', _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_8), ('presence', 'optional')]), dict([('id', 158), ('criticality', 'reject'), ('Value', _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_9), ('presence', 'optional')]), dict([('id', 104), ('criticality', 'ignore'), ('Value', _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_10), ('presence', 'optional')]), dict([('id', 157), ('criticality', 'reject'), ('Value', _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_11), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SeNBAdditionRequest_protocolIEs__item__id._const_tab = ____SeNBAdditionRequest_protocolIEs__item__id_tab
    ___SeNBAdditionRequest_protocolIEs__item__id._const_tab_at = None
    ___SeNBAdditionRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___SeNBAdditionRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___SeNBAdditionRequest_protocolIEs__item__criticality._const_tab = ____SeNBAdditionRequest_protocolIEs__item__id_tab
    ___SeNBAdditionRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___SeNBAdditionRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___SeNBAdditionRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___SeNBAdditionRequest_protocolIEs__item__value._const_tab = ____SeNBAdditionRequest_protocolIEs__item__id_tab
    ___SeNBAdditionRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___SeNBAdditionRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __SeNBAdditionRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___SeNBAdditionRequest_protocolIEs__item__id),
        ('criticality', ___SeNBAdditionRequest_protocolIEs__item__criticality),
        ('value', ___SeNBAdditionRequest_protocolIEs__item__value),
        ])
    __SeNBAdditionRequest_protocolIEs__item_._ext = None
    _SeNBAdditionRequest_protocolIEs._cont = __SeNBAdditionRequest_protocolIEs__item_
    _SeNBAdditionRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    SeNBAdditionRequest._cont = ASN1Dict([
        ('protocolIEs', _SeNBAdditionRequest_protocolIEs),
        ])
    SeNBAdditionRequest._ext = []
    
    #-----< SeNBAdditionRequest-IEs >-----#
    SeNBAdditionRequest_IEs = CLASS(name='SeNBAdditionRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _SeNBAdditionRequest_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SeNBAdditionRequest_IEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UESecurityCapabilities')))
    _SeNBAdditionRequest_IEs_val_Value_2 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SeNBSecurityKey')))
    _SeNBAdditionRequest_IEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UEAggregateMaximumBitRate')))
    _SeNBAdditionRequest_IEs_val_Value_4 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PLMN-Identity')))
    _SeNBAdditionRequest_IEs_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeAdded-List')))
    _SeNBAdditionRequest_IEs_val_Value_6 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MeNBtoSeNBContainer')))
    _SeNBAdditionRequest_IEs_val_Value_7 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CSGMembershipStatus')))
    _SeNBAdditionRequest_IEs_val_Value_8 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SeNBAdditionRequest_IEs_val_Value_9 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _SeNBAdditionRequest_IEs_val_Value_10 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ExpectedUEBehaviour')))
    _SeNBAdditionRequest_IEs_val_Value_11 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    SeNBAdditionRequest_IEs._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'reject'), ('Value', _SeNBAdditionRequest_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 113), ('criticality', 'reject'), ('Value', _SeNBAdditionRequest_IEs_val_Value_1), ('presence', 'conditional')]), dict([('id', 114), ('criticality', 'reject'), ('Value', _SeNBAdditionRequest_IEs_val_Value_2), ('presence', 'conditional')]), dict([('id', 115), ('criticality', 'reject'), ('Value', _SeNBAdditionRequest_IEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 116), ('criticality', 'ignore'), ('Value', _SeNBAdditionRequest_IEs_val_Value_4), ('presence', 'optional')]), dict([('id', 117), ('criticality', 'reject'), ('Value', _SeNBAdditionRequest_IEs_val_Value_5), ('presence', 'mandatory')]), dict([('id', 119), ('criticality', 'reject'), ('Value', _SeNBAdditionRequest_IEs_val_Value_6), ('presence', 'mandatory')]), dict([('id', 71), ('criticality', 'reject'), ('Value', _SeNBAdditionRequest_IEs_val_Value_7), ('presence', 'optional')]), dict([('id', 112), ('criticality', 'reject'), ('Value', _SeNBAdditionRequest_IEs_val_Value_8), ('presence', 'optional')]), dict([('id', 158), ('criticality', 'reject'), ('Value', _SeNBAdditionRequest_IEs_val_Value_9), ('presence', 'optional')]), dict([('id', 104), ('criticality', 'ignore'), ('Value', _SeNBAdditionRequest_IEs_val_Value_10), ('presence', 'optional')]), dict([('id', 157), ('criticality', 'reject'), ('Value', _SeNBAdditionRequest_IEs_val_Value_11), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeAdded-List >-----#
    E_RABs_ToBeAdded_List = SEQ_OF(name='E-RABs-ToBeAdded-List', mode=MODE_TYPE)
    _E_RABs_ToBeAdded_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __E_RABs_ToBeAdded_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ___E_RABs_ToBeAdded_List__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____E_RABs_ToBeAdded_List__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeAdded-Item')))
    ___E_RABs_ToBeAdded_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 118), ('criticality', 'reject'), ('Value', ____E_RABs_ToBeAdded_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E_RABs_ToBeAdded_List__item__id._const_tab = ___E_RABs_ToBeAdded_List__item__id_tab
    __E_RABs_ToBeAdded_List__item__id._const_tab_at = None
    __E_RABs_ToBeAdded_List__item__id._const_tab_id = 'id'
    __E_RABs_ToBeAdded_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    __E_RABs_ToBeAdded_List__item__criticality._const_tab = ___E_RABs_ToBeAdded_List__item__id_tab
    __E_RABs_ToBeAdded_List__item__criticality._const_tab_at = ('..', 'id')
    __E_RABs_ToBeAdded_List__item__criticality._const_tab_id = 'criticality'
    __E_RABs_ToBeAdded_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    __E_RABs_ToBeAdded_List__item__value._const_tab = ___E_RABs_ToBeAdded_List__item__id_tab
    __E_RABs_ToBeAdded_List__item__value._const_tab_at = ('..', 'id')
    __E_RABs_ToBeAdded_List__item__value._const_tab_id = 'Value'
    _E_RABs_ToBeAdded_List__item_._cont = ASN1Dict([
        ('id', __E_RABs_ToBeAdded_List__item__id),
        ('criticality', __E_RABs_ToBeAdded_List__item__criticality),
        ('value', __E_RABs_ToBeAdded_List__item__value),
        ])
    _E_RABs_ToBeAdded_List__item_._ext = None
    E_RABs_ToBeAdded_List._cont = _E_RABs_ToBeAdded_List__item_
    E_RABs_ToBeAdded_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABs-ToBeAdded-ItemIEs >-----#
    E_RABs_ToBeAdded_ItemIEs = CLASS(name='E-RABs-ToBeAdded-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _E_RABs_ToBeAdded_ItemIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeAdded-Item')))
    E_RABs_ToBeAdded_ItemIEs._val = ASN1Set(rv=[dict([('id', 118), ('criticality', 'reject'), ('Value', _E_RABs_ToBeAdded_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeAdded-Item >-----#
    E_RABs_ToBeAdded_Item = CHOICE(name='E-RABs-ToBeAdded-Item', mode=MODE_TYPE)
    _E_RABs_ToBeAdded_Item_sCG_Bearer = SEQ(name='sCG-Bearer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeAdded-Item-SCG-Bearer')))
    _E_RABs_ToBeAdded_Item_split_Bearer = SEQ(name='split-Bearer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeAdded-Item-Split-Bearer')))
    E_RABs_ToBeAdded_Item._cont = ASN1Dict([
        ('sCG-Bearer', _E_RABs_ToBeAdded_Item_sCG_Bearer),
        ('split-Bearer', _E_RABs_ToBeAdded_Item_split_Bearer),
        ])
    E_RABs_ToBeAdded_Item._ext = []
    
    #-----< E-RABs-ToBeAdded-Item-SCG-Bearer >-----#
    E_RABs_ToBeAdded_Item_SCG_Bearer = SEQ(name='E-RABs-ToBeAdded-Item-SCG-Bearer', mode=MODE_TYPE)
    _E_RABs_ToBeAdded_Item_SCG_Bearer_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_ToBeAdded_Item_SCG_Bearer_e_RAB_Level_QoS_Parameters = SEQ(name='e-RAB-Level-QoS-Parameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-Level-QoS-Parameters')))
    _E_RABs_ToBeAdded_Item_SCG_Bearer_dL_Forwarding = ENUM(name='dL-Forwarding', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'DL-Forwarding')), opt=True)
    _E_RABs_ToBeAdded_Item_SCG_Bearer_s1_UL_GTPtunnelEndpoint = SEQ(name='s1-UL-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')))
    _E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id_tab_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Correlation-ID')))
    _____E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id_tab_val_Extension_1 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Correlation-ID')))
    _____E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'BearerType')))
    _____E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id_tab_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Ethernet-Type')))
    _____E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id_tab_val_Extension_4 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TransportLayerAddress')))
    ____E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 166), ('criticality', 'ignore'), ('Extension', _____E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 167), ('criticality', 'ignore'), ('Extension', _____E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 171), ('criticality', 'ignore'), ('Extension', _____E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 369), ('criticality', 'ignore'), ('Extension', _____E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 412), ('criticality', 'ignore'), ('Extension', _____E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id._const_tab = ____E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__criticality._const_tab = ____E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id),
        ('criticality', ___E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item_._ext = None
    _E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions._cont = __E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item_
    _E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_ToBeAdded_Item_SCG_Bearer._cont = ASN1Dict([
        ('e-RAB-ID', _E_RABs_ToBeAdded_Item_SCG_Bearer_e_RAB_ID),
        ('e-RAB-Level-QoS-Parameters', _E_RABs_ToBeAdded_Item_SCG_Bearer_e_RAB_Level_QoS_Parameters),
        ('dL-Forwarding', _E_RABs_ToBeAdded_Item_SCG_Bearer_dL_Forwarding),
        ('s1-UL-GTPtunnelEndpoint', _E_RABs_ToBeAdded_Item_SCG_Bearer_s1_UL_GTPtunnelEndpoint),
        ('iE-Extensions', _E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions),
        ])
    E_RABs_ToBeAdded_Item_SCG_Bearer._ext = []
    
    #-----< E-RABs-ToBeAdded-Item-SCG-BearerExtIEs >-----#
    E_RABs_ToBeAdded_Item_SCG_BearerExtIEs = CLASS(name='E-RABs-ToBeAdded-Item-SCG-BearerExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _E_RABs_ToBeAdded_Item_SCG_BearerExtIEs_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Correlation-ID')))
    _E_RABs_ToBeAdded_Item_SCG_BearerExtIEs_val_Extension_1 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Correlation-ID')))
    _E_RABs_ToBeAdded_Item_SCG_BearerExtIEs_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'BearerType')))
    _E_RABs_ToBeAdded_Item_SCG_BearerExtIEs_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Ethernet-Type')))
    _E_RABs_ToBeAdded_Item_SCG_BearerExtIEs_val_Extension_4 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TransportLayerAddress')))
    E_RABs_ToBeAdded_Item_SCG_BearerExtIEs._val = ASN1Set(rv=[dict([('id', 166), ('criticality', 'ignore'), ('Extension', _E_RABs_ToBeAdded_Item_SCG_BearerExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 167), ('criticality', 'ignore'), ('Extension', _E_RABs_ToBeAdded_Item_SCG_BearerExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 171), ('criticality', 'ignore'), ('Extension', _E_RABs_ToBeAdded_Item_SCG_BearerExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 369), ('criticality', 'ignore'), ('Extension', _E_RABs_ToBeAdded_Item_SCG_BearerExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 412), ('criticality', 'ignore'), ('Extension', _E_RABs_ToBeAdded_Item_SCG_BearerExtIEs_val_Extension_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeAdded-Item-Split-Bearer >-----#
    E_RABs_ToBeAdded_Item_Split_Bearer = SEQ(name='E-RABs-ToBeAdded-Item-Split-Bearer', mode=MODE_TYPE)
    _E_RABs_ToBeAdded_Item_Split_Bearer_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_ToBeAdded_Item_Split_Bearer_e_RAB_Level_QoS_Parameters = SEQ(name='e-RAB-Level-QoS-Parameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-Level-QoS-Parameters')))
    _E_RABs_ToBeAdded_Item_Split_Bearer_meNB_GTPtunnelEndpoint = SEQ(name='meNB-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')))
    _E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__id_tab_val_Extension_0 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TransportLayerAddress')))
    ____E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 412), ('criticality', 'ignore'), ('Extension', _____E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__id._const_tab = ____E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__criticality._const_tab = ____E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__id),
        ('criticality', ___E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions__item_._ext = None
    _E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions._cont = __E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions__item_
    _E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_ToBeAdded_Item_Split_Bearer._cont = ASN1Dict([
        ('e-RAB-ID', _E_RABs_ToBeAdded_Item_Split_Bearer_e_RAB_ID),
        ('e-RAB-Level-QoS-Parameters', _E_RABs_ToBeAdded_Item_Split_Bearer_e_RAB_Level_QoS_Parameters),
        ('meNB-GTPtunnelEndpoint', _E_RABs_ToBeAdded_Item_Split_Bearer_meNB_GTPtunnelEndpoint),
        ('iE-Extensions', _E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions),
        ])
    E_RABs_ToBeAdded_Item_Split_Bearer._ext = []
    
    #-----< E-RABs-ToBeAdded-Item-Split-BearerExtIEs >-----#
    E_RABs_ToBeAdded_Item_Split_BearerExtIEs = CLASS(name='E-RABs-ToBeAdded-Item-Split-BearerExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _E_RABs_ToBeAdded_Item_Split_BearerExtIEs_val_Extension_0 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TransportLayerAddress')))
    E_RABs_ToBeAdded_Item_Split_BearerExtIEs._val = ASN1Set(rv=[dict([('id', 412), ('criticality', 'ignore'), ('Extension', _E_RABs_ToBeAdded_Item_Split_BearerExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< SeNBAdditionRequestAcknowledge >-----#
    SeNBAdditionRequestAcknowledge = SEQ(name='SeNBAdditionRequestAcknowledge', mode=MODE_TYPE)
    _SeNBAdditionRequestAcknowledge_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __SeNBAdditionRequestAcknowledge_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___SeNBAdditionRequestAcknowledge_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeAdded-List')))
    _____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-List')))
    _____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_4 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SeNBtoMeNBContainer')))
    _____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_6 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TransportLayerAddress')))
    _____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_7 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TransportLayerAddress')))
    _____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_8 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_9 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_10 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TunnelInformation')))
    ____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'reject'), ('Value', _____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 112), ('criticality', 'reject'), ('Value', _____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 120), ('criticality', 'ignore'), ('Value', _____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'ignore'), ('Value', _____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 122), ('criticality', 'reject'), ('Value', _____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_4), ('presence', 'mandatory')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 165), ('criticality', 'ignore'), ('Value', _____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 168), ('criticality', 'ignore'), ('Value', _____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')]), dict([('id', 157), ('criticality', 'reject'), ('Value', _____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_8), ('presence', 'optional')]), dict([('id', 158), ('criticality', 'reject'), ('Value', _____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_9), ('presence', 'optional')]), dict([('id', 163), ('criticality', 'ignore'), ('Value', _____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_10), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SeNBAdditionRequestAcknowledge_protocolIEs__item__id._const_tab = ____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab
    ___SeNBAdditionRequestAcknowledge_protocolIEs__item__id._const_tab_at = None
    ___SeNBAdditionRequestAcknowledge_protocolIEs__item__id._const_tab_id = 'id'
    ___SeNBAdditionRequestAcknowledge_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___SeNBAdditionRequestAcknowledge_protocolIEs__item__criticality._const_tab = ____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab
    ___SeNBAdditionRequestAcknowledge_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___SeNBAdditionRequestAcknowledge_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___SeNBAdditionRequestAcknowledge_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___SeNBAdditionRequestAcknowledge_protocolIEs__item__value._const_tab = ____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab
    ___SeNBAdditionRequestAcknowledge_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___SeNBAdditionRequestAcknowledge_protocolIEs__item__value._const_tab_id = 'Value'
    __SeNBAdditionRequestAcknowledge_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___SeNBAdditionRequestAcknowledge_protocolIEs__item__id),
        ('criticality', ___SeNBAdditionRequestAcknowledge_protocolIEs__item__criticality),
        ('value', ___SeNBAdditionRequestAcknowledge_protocolIEs__item__value),
        ])
    __SeNBAdditionRequestAcknowledge_protocolIEs__item_._ext = None
    _SeNBAdditionRequestAcknowledge_protocolIEs._cont = __SeNBAdditionRequestAcknowledge_protocolIEs__item_
    _SeNBAdditionRequestAcknowledge_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    SeNBAdditionRequestAcknowledge._cont = ASN1Dict([
        ('protocolIEs', _SeNBAdditionRequestAcknowledge_protocolIEs),
        ])
    SeNBAdditionRequestAcknowledge._ext = []
    
    #-----< SeNBAdditionRequestAcknowledge-IEs >-----#
    SeNBAdditionRequestAcknowledge_IEs = CLASS(name='SeNBAdditionRequestAcknowledge-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _SeNBAdditionRequestAcknowledge_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SeNBAdditionRequestAcknowledge_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SeNBAdditionRequestAcknowledge_IEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeAdded-List')))
    _SeNBAdditionRequestAcknowledge_IEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-List')))
    _SeNBAdditionRequestAcknowledge_IEs_val_Value_4 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SeNBtoMeNBContainer')))
    _SeNBAdditionRequestAcknowledge_IEs_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _SeNBAdditionRequestAcknowledge_IEs_val_Value_6 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TransportLayerAddress')))
    _SeNBAdditionRequestAcknowledge_IEs_val_Value_7 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TransportLayerAddress')))
    _SeNBAdditionRequestAcknowledge_IEs_val_Value_8 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _SeNBAdditionRequestAcknowledge_IEs_val_Value_9 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _SeNBAdditionRequestAcknowledge_IEs_val_Value_10 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TunnelInformation')))
    SeNBAdditionRequestAcknowledge_IEs._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'reject'), ('Value', _SeNBAdditionRequestAcknowledge_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 112), ('criticality', 'reject'), ('Value', _SeNBAdditionRequestAcknowledge_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 120), ('criticality', 'ignore'), ('Value', _SeNBAdditionRequestAcknowledge_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'ignore'), ('Value', _SeNBAdditionRequestAcknowledge_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 122), ('criticality', 'reject'), ('Value', _SeNBAdditionRequestAcknowledge_IEs_val_Value_4), ('presence', 'mandatory')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _SeNBAdditionRequestAcknowledge_IEs_val_Value_5), ('presence', 'optional')]), dict([('id', 165), ('criticality', 'ignore'), ('Value', _SeNBAdditionRequestAcknowledge_IEs_val_Value_6), ('presence', 'optional')]), dict([('id', 168), ('criticality', 'ignore'), ('Value', _SeNBAdditionRequestAcknowledge_IEs_val_Value_7), ('presence', 'optional')]), dict([('id', 157), ('criticality', 'reject'), ('Value', _SeNBAdditionRequestAcknowledge_IEs_val_Value_8), ('presence', 'optional')]), dict([('id', 158), ('criticality', 'reject'), ('Value', _SeNBAdditionRequestAcknowledge_IEs_val_Value_9), ('presence', 'optional')]), dict([('id', 163), ('criticality', 'ignore'), ('Value', _SeNBAdditionRequestAcknowledge_IEs_val_Value_10), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-Admitted-ToBeAdded-List >-----#
    E_RABs_Admitted_ToBeAdded_List = SEQ_OF(name='E-RABs-Admitted-ToBeAdded-List', mode=MODE_TYPE)
    _E_RABs_Admitted_ToBeAdded_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __E_RABs_Admitted_ToBeAdded_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ___E_RABs_Admitted_ToBeAdded_List__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____E_RABs_Admitted_ToBeAdded_List__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeAdded-Item')))
    ___E_RABs_Admitted_ToBeAdded_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 121), ('criticality', 'ignore'), ('Value', ____E_RABs_Admitted_ToBeAdded_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E_RABs_Admitted_ToBeAdded_List__item__id._const_tab = ___E_RABs_Admitted_ToBeAdded_List__item__id_tab
    __E_RABs_Admitted_ToBeAdded_List__item__id._const_tab_at = None
    __E_RABs_Admitted_ToBeAdded_List__item__id._const_tab_id = 'id'
    __E_RABs_Admitted_ToBeAdded_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    __E_RABs_Admitted_ToBeAdded_List__item__criticality._const_tab = ___E_RABs_Admitted_ToBeAdded_List__item__id_tab
    __E_RABs_Admitted_ToBeAdded_List__item__criticality._const_tab_at = ('..', 'id')
    __E_RABs_Admitted_ToBeAdded_List__item__criticality._const_tab_id = 'criticality'
    __E_RABs_Admitted_ToBeAdded_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    __E_RABs_Admitted_ToBeAdded_List__item__value._const_tab = ___E_RABs_Admitted_ToBeAdded_List__item__id_tab
    __E_RABs_Admitted_ToBeAdded_List__item__value._const_tab_at = ('..', 'id')
    __E_RABs_Admitted_ToBeAdded_List__item__value._const_tab_id = 'Value'
    _E_RABs_Admitted_ToBeAdded_List__item_._cont = ASN1Dict([
        ('id', __E_RABs_Admitted_ToBeAdded_List__item__id),
        ('criticality', __E_RABs_Admitted_ToBeAdded_List__item__criticality),
        ('value', __E_RABs_Admitted_ToBeAdded_List__item__value),
        ])
    _E_RABs_Admitted_ToBeAdded_List__item_._ext = None
    E_RABs_Admitted_ToBeAdded_List._cont = _E_RABs_Admitted_ToBeAdded_List__item_
    E_RABs_Admitted_ToBeAdded_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABs-Admitted-ToBeAdded-ItemIEs >-----#
    E_RABs_Admitted_ToBeAdded_ItemIEs = CLASS(name='E-RABs-Admitted-ToBeAdded-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _E_RABs_Admitted_ToBeAdded_ItemIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeAdded-Item')))
    E_RABs_Admitted_ToBeAdded_ItemIEs._val = ASN1Set(rv=[dict([('id', 121), ('criticality', 'ignore'), ('Value', _E_RABs_Admitted_ToBeAdded_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< E-RABs-Admitted-ToBeAdded-Item >-----#
    E_RABs_Admitted_ToBeAdded_Item = CHOICE(name='E-RABs-Admitted-ToBeAdded-Item', mode=MODE_TYPE)
    _E_RABs_Admitted_ToBeAdded_Item_sCG_Bearer = SEQ(name='sCG-Bearer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeAdded-Item-SCG-Bearer')))
    _E_RABs_Admitted_ToBeAdded_Item_split_Bearer = SEQ(name='split-Bearer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeAdded-Item-Split-Bearer')))
    E_RABs_Admitted_ToBeAdded_Item._cont = ASN1Dict([
        ('sCG-Bearer', _E_RABs_Admitted_ToBeAdded_Item_sCG_Bearer),
        ('split-Bearer', _E_RABs_Admitted_ToBeAdded_Item_split_Bearer),
        ])
    E_RABs_Admitted_ToBeAdded_Item._ext = []
    
    #-----< E-RABs-Admitted-ToBeAdded-Item-SCG-Bearer >-----#
    E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer = SEQ(name='E-RABs-Admitted-ToBeAdded-Item-SCG-Bearer', mode=MODE_TYPE)
    _E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_s1_DL_GTPtunnelEndpoint = SEQ(name='s1-DL-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')))
    _E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_dL_Forwarding_GTPtunnelEndpoint = SEQ(name='dL-Forwarding-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_uL_Forwarding_GTPtunnelEndpoint = SEQ(name='uL-Forwarding-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id_tab_val_Extension_0 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TransportLayerAddress')))
    ____E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 412), ('criticality', 'ignore'), ('Extension', _____E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id._const_tab = ____E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__criticality._const_tab = ____E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id),
        ('criticality', ___E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item_._ext = None
    _E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions._cont = __E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item_
    _E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer._cont = ASN1Dict([
        ('e-RAB-ID', _E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_e_RAB_ID),
        ('s1-DL-GTPtunnelEndpoint', _E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_s1_DL_GTPtunnelEndpoint),
        ('dL-Forwarding-GTPtunnelEndpoint', _E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_dL_Forwarding_GTPtunnelEndpoint),
        ('uL-Forwarding-GTPtunnelEndpoint', _E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_uL_Forwarding_GTPtunnelEndpoint),
        ('iE-Extensions', _E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions),
        ])
    E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer._ext = []
    
    #-----< E-RABs-Admitted-ToBeAdded-Item-SCG-BearerExtIEs >-----#
    E_RABs_Admitted_ToBeAdded_Item_SCG_BearerExtIEs = CLASS(name='E-RABs-Admitted-ToBeAdded-Item-SCG-BearerExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _E_RABs_Admitted_ToBeAdded_Item_SCG_BearerExtIEs_val_Extension_0 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TransportLayerAddress')))
    E_RABs_Admitted_ToBeAdded_Item_SCG_BearerExtIEs._val = ASN1Set(rv=[dict([('id', 412), ('criticality', 'ignore'), ('Extension', _E_RABs_Admitted_ToBeAdded_Item_SCG_BearerExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-Admitted-ToBeAdded-Item-Split-Bearer >-----#
    E_RABs_Admitted_ToBeAdded_Item_Split_Bearer = SEQ(name='E-RABs-Admitted-ToBeAdded-Item-Split-Bearer', mode=MODE_TYPE)
    _E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_seNB_GTPtunnelEndpoint = SEQ(name='seNB-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')))
    _E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__id_tab_val_Extension_0 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TransportLayerAddress')))
    ____E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 412), ('criticality', 'ignore'), ('Extension', _____E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__id._const_tab = ____E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__criticality._const_tab = ____E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__id),
        ('criticality', ___E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions__item_._ext = None
    _E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions._cont = __E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions__item_
    _E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_Admitted_ToBeAdded_Item_Split_Bearer._cont = ASN1Dict([
        ('e-RAB-ID', _E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_e_RAB_ID),
        ('seNB-GTPtunnelEndpoint', _E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_seNB_GTPtunnelEndpoint),
        ('iE-Extensions', _E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions),
        ])
    E_RABs_Admitted_ToBeAdded_Item_Split_Bearer._ext = []
    
    #-----< E-RABs-Admitted-ToBeAdded-Item-Split-BearerExtIEs >-----#
    E_RABs_Admitted_ToBeAdded_Item_Split_BearerExtIEs = CLASS(name='E-RABs-Admitted-ToBeAdded-Item-Split-BearerExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _E_RABs_Admitted_ToBeAdded_Item_Split_BearerExtIEs_val_Extension_0 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TransportLayerAddress')))
    E_RABs_Admitted_ToBeAdded_Item_Split_BearerExtIEs._val = ASN1Set(rv=[dict([('id', 412), ('criticality', 'ignore'), ('Extension', _E_RABs_Admitted_ToBeAdded_Item_Split_BearerExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< SeNBAdditionRequestReject >-----#
    SeNBAdditionRequestReject = SEQ(name='SeNBAdditionRequestReject', mode=MODE_TYPE)
    _SeNBAdditionRequestReject_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __SeNBAdditionRequestReject_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___SeNBAdditionRequestReject_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____SeNBAdditionRequestReject_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____SeNBAdditionRequestReject_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SeNBAdditionRequestReject_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SeNBAdditionRequestReject_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _____SeNBAdditionRequestReject_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _____SeNBAdditionRequestReject_protocolIEs__item__id_tab_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____SeNBAdditionRequestReject_protocolIEs__item__id_tab_val_Value_5 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    ____SeNBAdditionRequestReject_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'reject'), ('Value', _____SeNBAdditionRequestReject_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 112), ('criticality', 'reject'), ('Value', _____SeNBAdditionRequestReject_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _____SeNBAdditionRequestReject_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _____SeNBAdditionRequestReject_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 157), ('criticality', 'reject'), ('Value', _____SeNBAdditionRequestReject_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 158), ('criticality', 'reject'), ('Value', _____SeNBAdditionRequestReject_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SeNBAdditionRequestReject_protocolIEs__item__id._const_tab = ____SeNBAdditionRequestReject_protocolIEs__item__id_tab
    ___SeNBAdditionRequestReject_protocolIEs__item__id._const_tab_at = None
    ___SeNBAdditionRequestReject_protocolIEs__item__id._const_tab_id = 'id'
    ___SeNBAdditionRequestReject_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___SeNBAdditionRequestReject_protocolIEs__item__criticality._const_tab = ____SeNBAdditionRequestReject_protocolIEs__item__id_tab
    ___SeNBAdditionRequestReject_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___SeNBAdditionRequestReject_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___SeNBAdditionRequestReject_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___SeNBAdditionRequestReject_protocolIEs__item__value._const_tab = ____SeNBAdditionRequestReject_protocolIEs__item__id_tab
    ___SeNBAdditionRequestReject_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___SeNBAdditionRequestReject_protocolIEs__item__value._const_tab_id = 'Value'
    __SeNBAdditionRequestReject_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___SeNBAdditionRequestReject_protocolIEs__item__id),
        ('criticality', ___SeNBAdditionRequestReject_protocolIEs__item__criticality),
        ('value', ___SeNBAdditionRequestReject_protocolIEs__item__value),
        ])
    __SeNBAdditionRequestReject_protocolIEs__item_._ext = None
    _SeNBAdditionRequestReject_protocolIEs._cont = __SeNBAdditionRequestReject_protocolIEs__item_
    _SeNBAdditionRequestReject_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    SeNBAdditionRequestReject._cont = ASN1Dict([
        ('protocolIEs', _SeNBAdditionRequestReject_protocolIEs),
        ])
    SeNBAdditionRequestReject._ext = []
    
    #-----< SeNBAdditionRequestReject-IEs >-----#
    SeNBAdditionRequestReject_IEs = CLASS(name='SeNBAdditionRequestReject-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _SeNBAdditionRequestReject_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SeNBAdditionRequestReject_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SeNBAdditionRequestReject_IEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _SeNBAdditionRequestReject_IEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _SeNBAdditionRequestReject_IEs_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _SeNBAdditionRequestReject_IEs_val_Value_5 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    SeNBAdditionRequestReject_IEs._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'reject'), ('Value', _SeNBAdditionRequestReject_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 112), ('criticality', 'reject'), ('Value', _SeNBAdditionRequestReject_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _SeNBAdditionRequestReject_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _SeNBAdditionRequestReject_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 157), ('criticality', 'reject'), ('Value', _SeNBAdditionRequestReject_IEs_val_Value_4), ('presence', 'optional')]), dict([('id', 158), ('criticality', 'reject'), ('Value', _SeNBAdditionRequestReject_IEs_val_Value_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< SeNBReconfigurationComplete >-----#
    SeNBReconfigurationComplete = SEQ(name='SeNBReconfigurationComplete', mode=MODE_TYPE)
    _SeNBReconfigurationComplete_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __SeNBReconfigurationComplete_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___SeNBReconfigurationComplete_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____SeNBReconfigurationComplete_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____SeNBReconfigurationComplete_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SeNBReconfigurationComplete_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SeNBReconfigurationComplete_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResponseInformationSeNBReconfComp')))
    _____SeNBReconfigurationComplete_protocolIEs__item__id_tab_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____SeNBReconfigurationComplete_protocolIEs__item__id_tab_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    ____SeNBReconfigurationComplete_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'reject'), ('Value', _____SeNBReconfigurationComplete_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 112), ('criticality', 'reject'), ('Value', _____SeNBReconfigurationComplete_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 123), ('criticality', 'ignore'), ('Value', _____SeNBReconfigurationComplete_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 157), ('criticality', 'reject'), ('Value', _____SeNBReconfigurationComplete_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 158), ('criticality', 'reject'), ('Value', _____SeNBReconfigurationComplete_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SeNBReconfigurationComplete_protocolIEs__item__id._const_tab = ____SeNBReconfigurationComplete_protocolIEs__item__id_tab
    ___SeNBReconfigurationComplete_protocolIEs__item__id._const_tab_at = None
    ___SeNBReconfigurationComplete_protocolIEs__item__id._const_tab_id = 'id'
    ___SeNBReconfigurationComplete_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___SeNBReconfigurationComplete_protocolIEs__item__criticality._const_tab = ____SeNBReconfigurationComplete_protocolIEs__item__id_tab
    ___SeNBReconfigurationComplete_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___SeNBReconfigurationComplete_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___SeNBReconfigurationComplete_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___SeNBReconfigurationComplete_protocolIEs__item__value._const_tab = ____SeNBReconfigurationComplete_protocolIEs__item__id_tab
    ___SeNBReconfigurationComplete_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___SeNBReconfigurationComplete_protocolIEs__item__value._const_tab_id = 'Value'
    __SeNBReconfigurationComplete_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___SeNBReconfigurationComplete_protocolIEs__item__id),
        ('criticality', ___SeNBReconfigurationComplete_protocolIEs__item__criticality),
        ('value', ___SeNBReconfigurationComplete_protocolIEs__item__value),
        ])
    __SeNBReconfigurationComplete_protocolIEs__item_._ext = None
    _SeNBReconfigurationComplete_protocolIEs._cont = __SeNBReconfigurationComplete_protocolIEs__item_
    _SeNBReconfigurationComplete_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    SeNBReconfigurationComplete._cont = ASN1Dict([
        ('protocolIEs', _SeNBReconfigurationComplete_protocolIEs),
        ])
    SeNBReconfigurationComplete._ext = []
    
    #-----< SeNBReconfigurationComplete-IEs >-----#
    SeNBReconfigurationComplete_IEs = CLASS(name='SeNBReconfigurationComplete-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _SeNBReconfigurationComplete_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SeNBReconfigurationComplete_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SeNBReconfigurationComplete_IEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResponseInformationSeNBReconfComp')))
    _SeNBReconfigurationComplete_IEs_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _SeNBReconfigurationComplete_IEs_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    SeNBReconfigurationComplete_IEs._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'reject'), ('Value', _SeNBReconfigurationComplete_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 112), ('criticality', 'reject'), ('Value', _SeNBReconfigurationComplete_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 123), ('criticality', 'ignore'), ('Value', _SeNBReconfigurationComplete_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 157), ('criticality', 'reject'), ('Value', _SeNBReconfigurationComplete_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 158), ('criticality', 'reject'), ('Value', _SeNBReconfigurationComplete_IEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ResponseInformationSeNBReconfComp >-----#
    ResponseInformationSeNBReconfComp = CHOICE(name='ResponseInformationSeNBReconfComp', mode=MODE_TYPE)
    _ResponseInformationSeNBReconfComp_success = SEQ(name='success', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResponseInformationSeNBReconfComp-SuccessItem')))
    _ResponseInformationSeNBReconfComp_reject_by_MeNB = SEQ(name='reject-by-MeNB', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResponseInformationSeNBReconfComp-RejectByMeNBItem')))
    ResponseInformationSeNBReconfComp._cont = ASN1Dict([
        ('success', _ResponseInformationSeNBReconfComp_success),
        ('reject-by-MeNB', _ResponseInformationSeNBReconfComp_reject_by_MeNB),
        ])
    ResponseInformationSeNBReconfComp._ext = []
    
    #-----< ResponseInformationSeNBReconfComp-SuccessItem >-----#
    ResponseInformationSeNBReconfComp_SuccessItem = SEQ(name='ResponseInformationSeNBReconfComp-SuccessItem', mode=MODE_TYPE)
    _ResponseInformationSeNBReconfComp_SuccessItem_meNBtoSeNBContainer = OCT_STR(name='meNBtoSeNBContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'MeNBtoSeNBContainer')), opt=True)
    _ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions__item__id._const_tab = ____ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions__item__id_tab
    ___ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions__item__id._const_tab_at = None
    ___ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions__item__criticality._const_tab = ____ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions__item__criticality_tab
    ___ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions__item__extensionValue._const_tab = ____ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions__item__extensionValue_tab
    ___ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions__item__id),
        ('criticality', ___ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions__item__criticality),
        ('extensionValue', ___ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions__item__extensionValue),
        ])
    __ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions__item_._ext = None
    _ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions._cont = __ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions__item_
    _ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResponseInformationSeNBReconfComp_SuccessItem._cont = ASN1Dict([
        ('meNBtoSeNBContainer', _ResponseInformationSeNBReconfComp_SuccessItem_meNBtoSeNBContainer),
        ('iE-Extensions', _ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions),
        ])
    ResponseInformationSeNBReconfComp_SuccessItem._ext = []
    
    #-----< ResponseInformationSeNBReconfComp-SuccessItemExtIEs >-----#
    ResponseInformationSeNBReconfComp_SuccessItemExtIEs = CLASS(name='ResponseInformationSeNBReconfComp-SuccessItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ResponseInformationSeNBReconfComp_SuccessItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResponseInformationSeNBReconfComp-RejectByMeNBItem >-----#
    ResponseInformationSeNBReconfComp_RejectByMeNBItem = SEQ(name='ResponseInformationSeNBReconfComp-RejectByMeNBItem', mode=MODE_TYPE)
    _ResponseInformationSeNBReconfComp_RejectByMeNBItem_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _ResponseInformationSeNBReconfComp_RejectByMeNBItem_meNBtoSeNBContainer = OCT_STR(name='meNBtoSeNBContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'MeNBtoSeNBContainer')), opt=True)
    _ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions__item__id._const_tab = ____ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions__item__id_tab
    ___ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions__item__id._const_tab_at = None
    ___ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions__item__criticality._const_tab = ____ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions__item__criticality_tab
    ___ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions__item__extensionValue._const_tab = ____ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions__item__extensionValue_tab
    ___ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions__item__id),
        ('criticality', ___ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions__item__criticality),
        ('extensionValue', ___ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions__item__extensionValue),
        ])
    __ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions__item_._ext = None
    _ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions._cont = __ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions__item_
    _ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResponseInformationSeNBReconfComp_RejectByMeNBItem._cont = ASN1Dict([
        ('cause', _ResponseInformationSeNBReconfComp_RejectByMeNBItem_cause),
        ('meNBtoSeNBContainer', _ResponseInformationSeNBReconfComp_RejectByMeNBItem_meNBtoSeNBContainer),
        ('iE-Extensions', _ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions),
        ])
    ResponseInformationSeNBReconfComp_RejectByMeNBItem._ext = []
    
    #-----< ResponseInformationSeNBReconfComp-RejectByMeNBItemExtIEs >-----#
    ResponseInformationSeNBReconfComp_RejectByMeNBItemExtIEs = CLASS(name='ResponseInformationSeNBReconfComp-RejectByMeNBItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ResponseInformationSeNBReconfComp_RejectByMeNBItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SeNBModificationRequest >-----#
    SeNBModificationRequest = SEQ(name='SeNBModificationRequest', mode=MODE_TYPE)
    _SeNBModificationRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __SeNBModificationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___SeNBModificationRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____SeNBModificationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____SeNBModificationRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SeNBModificationRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SeNBModificationRequest_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _____SeNBModificationRequest_protocolIEs__item__id_tab_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SCGChangeIndication')))
    _____SeNBModificationRequest_protocolIEs__item__id_tab_val_Value_4 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PLMN-Identity')))
    _____SeNBModificationRequest_protocolIEs__item__id_tab_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'UE-ContextInformationSeNBModReq')))
    _____SeNBModificationRequest_protocolIEs__item__id_tab_val_Value_6 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MeNBtoSeNBContainer')))
    _____SeNBModificationRequest_protocolIEs__item__id_tab_val_Value_7 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CSGMembershipStatus')))
    _____SeNBModificationRequest_protocolIEs__item__id_tab_val_Value_8 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____SeNBModificationRequest_protocolIEs__item__id_tab_val_Value_9 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    ____SeNBModificationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'reject'), ('Value', _____SeNBModificationRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 112), ('criticality', 'reject'), ('Value', _____SeNBModificationRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _____SeNBModificationRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 136), ('criticality', 'ignore'), ('Value', _____SeNBModificationRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 116), ('criticality', 'ignore'), ('Value', _____SeNBModificationRequest_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 124), ('criticality', 'reject'), ('Value', _____SeNBModificationRequest_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 119), ('criticality', 'ignore'), ('Value', _____SeNBModificationRequest_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 71), ('criticality', 'reject'), ('Value', _____SeNBModificationRequest_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')]), dict([('id', 157), ('criticality', 'reject'), ('Value', _____SeNBModificationRequest_protocolIEs__item__id_tab_val_Value_8), ('presence', 'optional')]), dict([('id', 158), ('criticality', 'reject'), ('Value', _____SeNBModificationRequest_protocolIEs__item__id_tab_val_Value_9), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SeNBModificationRequest_protocolIEs__item__id._const_tab = ____SeNBModificationRequest_protocolIEs__item__id_tab
    ___SeNBModificationRequest_protocolIEs__item__id._const_tab_at = None
    ___SeNBModificationRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___SeNBModificationRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___SeNBModificationRequest_protocolIEs__item__criticality._const_tab = ____SeNBModificationRequest_protocolIEs__item__id_tab
    ___SeNBModificationRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___SeNBModificationRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___SeNBModificationRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___SeNBModificationRequest_protocolIEs__item__value._const_tab = ____SeNBModificationRequest_protocolIEs__item__id_tab
    ___SeNBModificationRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___SeNBModificationRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __SeNBModificationRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___SeNBModificationRequest_protocolIEs__item__id),
        ('criticality', ___SeNBModificationRequest_protocolIEs__item__criticality),
        ('value', ___SeNBModificationRequest_protocolIEs__item__value),
        ])
    __SeNBModificationRequest_protocolIEs__item_._ext = None
    _SeNBModificationRequest_protocolIEs._cont = __SeNBModificationRequest_protocolIEs__item_
    _SeNBModificationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    SeNBModificationRequest._cont = ASN1Dict([
        ('protocolIEs', _SeNBModificationRequest_protocolIEs),
        ])
    SeNBModificationRequest._ext = []
    
    #-----< SeNBModificationRequest-IEs >-----#
    SeNBModificationRequest_IEs = CLASS(name='SeNBModificationRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _SeNBModificationRequest_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SeNBModificationRequest_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SeNBModificationRequest_IEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _SeNBModificationRequest_IEs_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SCGChangeIndication')))
    _SeNBModificationRequest_IEs_val_Value_4 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PLMN-Identity')))
    _SeNBModificationRequest_IEs_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'UE-ContextInformationSeNBModReq')))
    _SeNBModificationRequest_IEs_val_Value_6 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MeNBtoSeNBContainer')))
    _SeNBModificationRequest_IEs_val_Value_7 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CSGMembershipStatus')))
    _SeNBModificationRequest_IEs_val_Value_8 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _SeNBModificationRequest_IEs_val_Value_9 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    SeNBModificationRequest_IEs._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'reject'), ('Value', _SeNBModificationRequest_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 112), ('criticality', 'reject'), ('Value', _SeNBModificationRequest_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _SeNBModificationRequest_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 136), ('criticality', 'ignore'), ('Value', _SeNBModificationRequest_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 116), ('criticality', 'ignore'), ('Value', _SeNBModificationRequest_IEs_val_Value_4), ('presence', 'optional')]), dict([('id', 124), ('criticality', 'reject'), ('Value', _SeNBModificationRequest_IEs_val_Value_5), ('presence', 'optional')]), dict([('id', 119), ('criticality', 'ignore'), ('Value', _SeNBModificationRequest_IEs_val_Value_6), ('presence', 'optional')]), dict([('id', 71), ('criticality', 'reject'), ('Value', _SeNBModificationRequest_IEs_val_Value_7), ('presence', 'optional')]), dict([('id', 157), ('criticality', 'reject'), ('Value', _SeNBModificationRequest_IEs_val_Value_8), ('presence', 'optional')]), dict([('id', 158), ('criticality', 'reject'), ('Value', _SeNBModificationRequest_IEs_val_Value_9), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UE-ContextInformationSeNBModReq >-----#
    UE_ContextInformationSeNBModReq = SEQ(name='UE-ContextInformationSeNBModReq', mode=MODE_TYPE)
    _UE_ContextInformationSeNBModReq_uE_SecurityCapabilities = SEQ(name='uE-SecurityCapabilities', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'UESecurityCapabilities')), opt=True)
    _UE_ContextInformationSeNBModReq_seNB_SecurityKey = BIT_STR(name='seNB-SecurityKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'SeNBSecurityKey')), opt=True)
    _UE_ContextInformationSeNBModReq_seNBUEAggregateMaximumBitRate = SEQ(name='seNBUEAggregateMaximumBitRate', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'UEAggregateMaximumBitRate')), opt=True)
    _UE_ContextInformationSeNBModReq_e_RABs_ToBeAdded = SEQ_OF(name='e-RABs-ToBeAdded', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeAdded-List-ModReq')), opt=True)
    _UE_ContextInformationSeNBModReq_e_RABs_ToBeModified = SEQ_OF(name='e-RABs-ToBeModified', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeModified-List-ModReq')), opt=True)
    _UE_ContextInformationSeNBModReq_e_RABs_ToBeReleased = SEQ_OF(name='e-RABs-ToBeReleased', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-List-ModReq')), opt=True)
    _UE_ContextInformationSeNBModReq_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UE_ContextInformationSeNBModReq_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___UE_ContextInformationSeNBModReq_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____UE_ContextInformationSeNBModReq_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____UE_ContextInformationSeNBModReq_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_ContextInformationSeNBModReq_iE_Extensions__item__id._const_tab = ____UE_ContextInformationSeNBModReq_iE_Extensions__item__id_tab
    ___UE_ContextInformationSeNBModReq_iE_Extensions__item__id._const_tab_at = None
    ___UE_ContextInformationSeNBModReq_iE_Extensions__item__id._const_tab_id = 'id'
    ___UE_ContextInformationSeNBModReq_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UE_ContextInformationSeNBModReq_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____UE_ContextInformationSeNBModReq_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_ContextInformationSeNBModReq_iE_Extensions__item__criticality._const_tab = ____UE_ContextInformationSeNBModReq_iE_Extensions__item__criticality_tab
    ___UE_ContextInformationSeNBModReq_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UE_ContextInformationSeNBModReq_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UE_ContextInformationSeNBModReq_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UE_ContextInformationSeNBModReq_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____UE_ContextInformationSeNBModReq_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_ContextInformationSeNBModReq_iE_Extensions__item__extensionValue._const_tab = ____UE_ContextInformationSeNBModReq_iE_Extensions__item__extensionValue_tab
    ___UE_ContextInformationSeNBModReq_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UE_ContextInformationSeNBModReq_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UE_ContextInformationSeNBModReq_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UE_ContextInformationSeNBModReq_iE_Extensions__item__id),
        ('criticality', ___UE_ContextInformationSeNBModReq_iE_Extensions__item__criticality),
        ('extensionValue', ___UE_ContextInformationSeNBModReq_iE_Extensions__item__extensionValue),
        ])
    __UE_ContextInformationSeNBModReq_iE_Extensions__item_._ext = None
    _UE_ContextInformationSeNBModReq_iE_Extensions._cont = __UE_ContextInformationSeNBModReq_iE_Extensions__item_
    _UE_ContextInformationSeNBModReq_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UE_ContextInformationSeNBModReq._cont = ASN1Dict([
        ('uE-SecurityCapabilities', _UE_ContextInformationSeNBModReq_uE_SecurityCapabilities),
        ('seNB-SecurityKey', _UE_ContextInformationSeNBModReq_seNB_SecurityKey),
        ('seNBUEAggregateMaximumBitRate', _UE_ContextInformationSeNBModReq_seNBUEAggregateMaximumBitRate),
        ('e-RABs-ToBeAdded', _UE_ContextInformationSeNBModReq_e_RABs_ToBeAdded),
        ('e-RABs-ToBeModified', _UE_ContextInformationSeNBModReq_e_RABs_ToBeModified),
        ('e-RABs-ToBeReleased', _UE_ContextInformationSeNBModReq_e_RABs_ToBeReleased),
        ('iE-Extensions', _UE_ContextInformationSeNBModReq_iE_Extensions),
        ])
    UE_ContextInformationSeNBModReq._ext = []
    
    #-----< UE-ContextInformationSeNBModReqExtIEs >-----#
    UE_ContextInformationSeNBModReqExtIEs = CLASS(name='UE-ContextInformationSeNBModReqExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    UE_ContextInformationSeNBModReqExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeAdded-List-ModReq >-----#
    E_RABs_ToBeAdded_List_ModReq = SEQ_OF(name='E-RABs-ToBeAdded-List-ModReq', mode=MODE_TYPE)
    _E_RABs_ToBeAdded_List_ModReq__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __E_RABs_ToBeAdded_List_ModReq__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ___E_RABs_ToBeAdded_List_ModReq__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____E_RABs_ToBeAdded_List_ModReq__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeAdded-ModReqItem')))
    ___E_RABs_ToBeAdded_List_ModReq__item__id_tab._val = ASN1Set(rv=[dict([('id', 125), ('criticality', 'ignore'), ('Value', ____E_RABs_ToBeAdded_List_ModReq__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E_RABs_ToBeAdded_List_ModReq__item__id._const_tab = ___E_RABs_ToBeAdded_List_ModReq__item__id_tab
    __E_RABs_ToBeAdded_List_ModReq__item__id._const_tab_at = None
    __E_RABs_ToBeAdded_List_ModReq__item__id._const_tab_id = 'id'
    __E_RABs_ToBeAdded_List_ModReq__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    __E_RABs_ToBeAdded_List_ModReq__item__criticality._const_tab = ___E_RABs_ToBeAdded_List_ModReq__item__id_tab
    __E_RABs_ToBeAdded_List_ModReq__item__criticality._const_tab_at = ('..', 'id')
    __E_RABs_ToBeAdded_List_ModReq__item__criticality._const_tab_id = 'criticality'
    __E_RABs_ToBeAdded_List_ModReq__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    __E_RABs_ToBeAdded_List_ModReq__item__value._const_tab = ___E_RABs_ToBeAdded_List_ModReq__item__id_tab
    __E_RABs_ToBeAdded_List_ModReq__item__value._const_tab_at = ('..', 'id')
    __E_RABs_ToBeAdded_List_ModReq__item__value._const_tab_id = 'Value'
    _E_RABs_ToBeAdded_List_ModReq__item_._cont = ASN1Dict([
        ('id', __E_RABs_ToBeAdded_List_ModReq__item__id),
        ('criticality', __E_RABs_ToBeAdded_List_ModReq__item__criticality),
        ('value', __E_RABs_ToBeAdded_List_ModReq__item__value),
        ])
    _E_RABs_ToBeAdded_List_ModReq__item_._ext = None
    E_RABs_ToBeAdded_List_ModReq._cont = _E_RABs_ToBeAdded_List_ModReq__item_
    E_RABs_ToBeAdded_List_ModReq._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABs-ToBeAdded-ModReqItemIEs >-----#
    E_RABs_ToBeAdded_ModReqItemIEs = CLASS(name='E-RABs-ToBeAdded-ModReqItemIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _E_RABs_ToBeAdded_ModReqItemIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeAdded-ModReqItem')))
    E_RABs_ToBeAdded_ModReqItemIEs._val = ASN1Set(rv=[dict([('id', 125), ('criticality', 'ignore'), ('Value', _E_RABs_ToBeAdded_ModReqItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeAdded-ModReqItem >-----#
    E_RABs_ToBeAdded_ModReqItem = CHOICE(name='E-RABs-ToBeAdded-ModReqItem', mode=MODE_TYPE)
    _E_RABs_ToBeAdded_ModReqItem_sCG_Bearer = SEQ(name='sCG-Bearer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeAdded-ModReqItem-SCG-Bearer')))
    _E_RABs_ToBeAdded_ModReqItem_split_Bearer = SEQ(name='split-Bearer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeAdded-ModReqItem-Split-Bearer')))
    E_RABs_ToBeAdded_ModReqItem._cont = ASN1Dict([
        ('sCG-Bearer', _E_RABs_ToBeAdded_ModReqItem_sCG_Bearer),
        ('split-Bearer', _E_RABs_ToBeAdded_ModReqItem_split_Bearer),
        ])
    E_RABs_ToBeAdded_ModReqItem._ext = []
    
    #-----< E-RABs-ToBeAdded-ModReqItem-SCG-Bearer >-----#
    E_RABs_ToBeAdded_ModReqItem_SCG_Bearer = SEQ(name='E-RABs-ToBeAdded-ModReqItem-SCG-Bearer', mode=MODE_TYPE)
    _E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_e_RAB_Level_QoS_Parameters = SEQ(name='e-RAB-Level-QoS-Parameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-Level-QoS-Parameters')))
    _E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_dL_Forwarding = ENUM(name='dL-Forwarding', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'DL-Forwarding')), opt=True)
    _E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_s1_UL_GTPtunnelEndpoint = SEQ(name='s1-UL-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')))
    _E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item__id_tab_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Correlation-ID')))
    _____E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item__id_tab_val_Extension_1 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Correlation-ID')))
    _____E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'BearerType')))
    _____E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item__id_tab_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Ethernet-Type')))
    _____E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item__id_tab_val_Extension_4 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TransportLayerAddress')))
    ____E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 166), ('criticality', 'ignore'), ('Extension', _____E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 167), ('criticality', 'ignore'), ('Extension', _____E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 171), ('criticality', 'ignore'), ('Extension', _____E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 369), ('criticality', 'ignore'), ('Extension', _____E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 412), ('criticality', 'ignore'), ('Extension', _____E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item__id._const_tab = ____E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item__criticality._const_tab = ____E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item__id),
        ('criticality', ___E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item_._ext = None
    _E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions._cont = __E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item_
    _E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_ToBeAdded_ModReqItem_SCG_Bearer._cont = ASN1Dict([
        ('e-RAB-ID', _E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_e_RAB_ID),
        ('e-RAB-Level-QoS-Parameters', _E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_e_RAB_Level_QoS_Parameters),
        ('dL-Forwarding', _E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_dL_Forwarding),
        ('s1-UL-GTPtunnelEndpoint', _E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_s1_UL_GTPtunnelEndpoint),
        ('iE-Extensions', _E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions),
        ])
    E_RABs_ToBeAdded_ModReqItem_SCG_Bearer._ext = []
    
    #-----< E-RABs-ToBeAdded-ModReqItem-SCG-BearerExtIEs >-----#
    E_RABs_ToBeAdded_ModReqItem_SCG_BearerExtIEs = CLASS(name='E-RABs-ToBeAdded-ModReqItem-SCG-BearerExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _E_RABs_ToBeAdded_ModReqItem_SCG_BearerExtIEs_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Correlation-ID')))
    _E_RABs_ToBeAdded_ModReqItem_SCG_BearerExtIEs_val_Extension_1 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Correlation-ID')))
    _E_RABs_ToBeAdded_ModReqItem_SCG_BearerExtIEs_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'BearerType')))
    _E_RABs_ToBeAdded_ModReqItem_SCG_BearerExtIEs_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Ethernet-Type')))
    _E_RABs_ToBeAdded_ModReqItem_SCG_BearerExtIEs_val_Extension_4 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TransportLayerAddress')))
    E_RABs_ToBeAdded_ModReqItem_SCG_BearerExtIEs._val = ASN1Set(rv=[dict([('id', 166), ('criticality', 'ignore'), ('Extension', _E_RABs_ToBeAdded_ModReqItem_SCG_BearerExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 167), ('criticality', 'ignore'), ('Extension', _E_RABs_ToBeAdded_ModReqItem_SCG_BearerExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 171), ('criticality', 'ignore'), ('Extension', _E_RABs_ToBeAdded_ModReqItem_SCG_BearerExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 369), ('criticality', 'ignore'), ('Extension', _E_RABs_ToBeAdded_ModReqItem_SCG_BearerExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 412), ('criticality', 'ignore'), ('Extension', _E_RABs_ToBeAdded_ModReqItem_SCG_BearerExtIEs_val_Extension_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeAdded-ModReqItem-Split-Bearer >-----#
    E_RABs_ToBeAdded_ModReqItem_Split_Bearer = SEQ(name='E-RABs-ToBeAdded-ModReqItem-Split-Bearer', mode=MODE_TYPE)
    _E_RABs_ToBeAdded_ModReqItem_Split_Bearer_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_ToBeAdded_ModReqItem_Split_Bearer_e_RAB_Level_QoS_Parameters = SEQ(name='e-RAB-Level-QoS-Parameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-Level-QoS-Parameters')))
    _E_RABs_ToBeAdded_ModReqItem_Split_Bearer_meNB_GTPtunnelEndpoint = SEQ(name='meNB-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')))
    _E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions__item__id_tab_val_Extension_0 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TransportLayerAddress')))
    ____E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 412), ('criticality', 'ignore'), ('Extension', _____E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions__item__id._const_tab = ____E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions__item__criticality._const_tab = ____E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions__item__id),
        ('criticality', ___E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions__item_._ext = None
    _E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions._cont = __E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions__item_
    _E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_ToBeAdded_ModReqItem_Split_Bearer._cont = ASN1Dict([
        ('e-RAB-ID', _E_RABs_ToBeAdded_ModReqItem_Split_Bearer_e_RAB_ID),
        ('e-RAB-Level-QoS-Parameters', _E_RABs_ToBeAdded_ModReqItem_Split_Bearer_e_RAB_Level_QoS_Parameters),
        ('meNB-GTPtunnelEndpoint', _E_RABs_ToBeAdded_ModReqItem_Split_Bearer_meNB_GTPtunnelEndpoint),
        ('iE-Extensions', _E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions),
        ])
    E_RABs_ToBeAdded_ModReqItem_Split_Bearer._ext = []
    
    #-----< E-RABs-ToBeAdded-ModReqItem-Split-BearerExtIEs >-----#
    E_RABs_ToBeAdded_ModReqItem_Split_BearerExtIEs = CLASS(name='E-RABs-ToBeAdded-ModReqItem-Split-BearerExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _E_RABs_ToBeAdded_ModReqItem_Split_BearerExtIEs_val_Extension_0 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TransportLayerAddress')))
    E_RABs_ToBeAdded_ModReqItem_Split_BearerExtIEs._val = ASN1Set(rv=[dict([('id', 412), ('criticality', 'ignore'), ('Extension', _E_RABs_ToBeAdded_ModReqItem_Split_BearerExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeModified-List-ModReq >-----#
    E_RABs_ToBeModified_List_ModReq = SEQ_OF(name='E-RABs-ToBeModified-List-ModReq', mode=MODE_TYPE)
    _E_RABs_ToBeModified_List_ModReq__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __E_RABs_ToBeModified_List_ModReq__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ___E_RABs_ToBeModified_List_ModReq__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____E_RABs_ToBeModified_List_ModReq__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeModified-ModReqItem')))
    ___E_RABs_ToBeModified_List_ModReq__item__id_tab._val = ASN1Set(rv=[dict([('id', 126), ('criticality', 'ignore'), ('Value', ____E_RABs_ToBeModified_List_ModReq__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E_RABs_ToBeModified_List_ModReq__item__id._const_tab = ___E_RABs_ToBeModified_List_ModReq__item__id_tab
    __E_RABs_ToBeModified_List_ModReq__item__id._const_tab_at = None
    __E_RABs_ToBeModified_List_ModReq__item__id._const_tab_id = 'id'
    __E_RABs_ToBeModified_List_ModReq__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    __E_RABs_ToBeModified_List_ModReq__item__criticality._const_tab = ___E_RABs_ToBeModified_List_ModReq__item__id_tab
    __E_RABs_ToBeModified_List_ModReq__item__criticality._const_tab_at = ('..', 'id')
    __E_RABs_ToBeModified_List_ModReq__item__criticality._const_tab_id = 'criticality'
    __E_RABs_ToBeModified_List_ModReq__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    __E_RABs_ToBeModified_List_ModReq__item__value._const_tab = ___E_RABs_ToBeModified_List_ModReq__item__id_tab
    __E_RABs_ToBeModified_List_ModReq__item__value._const_tab_at = ('..', 'id')
    __E_RABs_ToBeModified_List_ModReq__item__value._const_tab_id = 'Value'
    _E_RABs_ToBeModified_List_ModReq__item_._cont = ASN1Dict([
        ('id', __E_RABs_ToBeModified_List_ModReq__item__id),
        ('criticality', __E_RABs_ToBeModified_List_ModReq__item__criticality),
        ('value', __E_RABs_ToBeModified_List_ModReq__item__value),
        ])
    _E_RABs_ToBeModified_List_ModReq__item_._ext = None
    E_RABs_ToBeModified_List_ModReq._cont = _E_RABs_ToBeModified_List_ModReq__item_
    E_RABs_ToBeModified_List_ModReq._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABs-ToBeModified-ModReqItemIEs >-----#
    E_RABs_ToBeModified_ModReqItemIEs = CLASS(name='E-RABs-ToBeModified-ModReqItemIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _E_RABs_ToBeModified_ModReqItemIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeModified-ModReqItem')))
    E_RABs_ToBeModified_ModReqItemIEs._val = ASN1Set(rv=[dict([('id', 126), ('criticality', 'ignore'), ('Value', _E_RABs_ToBeModified_ModReqItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeModified-ModReqItem >-----#
    E_RABs_ToBeModified_ModReqItem = CHOICE(name='E-RABs-ToBeModified-ModReqItem', mode=MODE_TYPE)
    _E_RABs_ToBeModified_ModReqItem_sCG_Bearer = SEQ(name='sCG-Bearer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeModified-ModReqItem-SCG-Bearer')))
    _E_RABs_ToBeModified_ModReqItem_split_Bearer = SEQ(name='split-Bearer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeModified-ModReqItem-Split-Bearer')))
    E_RABs_ToBeModified_ModReqItem._cont = ASN1Dict([
        ('sCG-Bearer', _E_RABs_ToBeModified_ModReqItem_sCG_Bearer),
        ('split-Bearer', _E_RABs_ToBeModified_ModReqItem_split_Bearer),
        ])
    E_RABs_ToBeModified_ModReqItem._ext = []
    
    #-----< E-RABs-ToBeModified-ModReqItem-SCG-Bearer >-----#
    E_RABs_ToBeModified_ModReqItem_SCG_Bearer = SEQ(name='E-RABs-ToBeModified-ModReqItem-SCG-Bearer', mode=MODE_TYPE)
    _E_RABs_ToBeModified_ModReqItem_SCG_Bearer_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_ToBeModified_ModReqItem_SCG_Bearer_e_RAB_Level_QoS_Parameters = SEQ(name='e-RAB-Level-QoS-Parameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-Level-QoS-Parameters')), opt=True)
    _E_RABs_ToBeModified_ModReqItem_SCG_Bearer_s1_UL_GTPtunnelEndpoint = SEQ(name='s1-UL-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions__item__id._const_tab = ____E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions__item__criticality._const_tab = ____E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions__item__criticality_tab
    ___E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions__item__extensionValue_tab
    ___E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions__item__id),
        ('criticality', ___E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions__item_._ext = None
    _E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions._cont = __E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions__item_
    _E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_ToBeModified_ModReqItem_SCG_Bearer._cont = ASN1Dict([
        ('e-RAB-ID', _E_RABs_ToBeModified_ModReqItem_SCG_Bearer_e_RAB_ID),
        ('e-RAB-Level-QoS-Parameters', _E_RABs_ToBeModified_ModReqItem_SCG_Bearer_e_RAB_Level_QoS_Parameters),
        ('s1-UL-GTPtunnelEndpoint', _E_RABs_ToBeModified_ModReqItem_SCG_Bearer_s1_UL_GTPtunnelEndpoint),
        ('iE-Extensions', _E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions),
        ])
    E_RABs_ToBeModified_ModReqItem_SCG_Bearer._ext = []
    
    #-----< E-RABs-ToBeModified-ModReqItem-SCG-BearerExtIEs >-----#
    E_RABs_ToBeModified_ModReqItem_SCG_BearerExtIEs = CLASS(name='E-RABs-ToBeModified-ModReqItem-SCG-BearerExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    E_RABs_ToBeModified_ModReqItem_SCG_BearerExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeModified-ModReqItem-Split-Bearer >-----#
    E_RABs_ToBeModified_ModReqItem_Split_Bearer = SEQ(name='E-RABs-ToBeModified-ModReqItem-Split-Bearer', mode=MODE_TYPE)
    _E_RABs_ToBeModified_ModReqItem_Split_Bearer_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_ToBeModified_ModReqItem_Split_Bearer_e_RAB_Level_QoS_Parameters = SEQ(name='e-RAB-Level-QoS-Parameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-Level-QoS-Parameters')), opt=True)
    _E_RABs_ToBeModified_ModReqItem_Split_Bearer_meNB_GTPtunnelEndpoint = SEQ(name='meNB-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions__item__id._const_tab = ____E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions__item__criticality._const_tab = ____E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions__item__criticality_tab
    ___E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions__item__extensionValue_tab
    ___E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions__item__id),
        ('criticality', ___E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions__item_._ext = None
    _E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions._cont = __E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions__item_
    _E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_ToBeModified_ModReqItem_Split_Bearer._cont = ASN1Dict([
        ('e-RAB-ID', _E_RABs_ToBeModified_ModReqItem_Split_Bearer_e_RAB_ID),
        ('e-RAB-Level-QoS-Parameters', _E_RABs_ToBeModified_ModReqItem_Split_Bearer_e_RAB_Level_QoS_Parameters),
        ('meNB-GTPtunnelEndpoint', _E_RABs_ToBeModified_ModReqItem_Split_Bearer_meNB_GTPtunnelEndpoint),
        ('iE-Extensions', _E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions),
        ])
    E_RABs_ToBeModified_ModReqItem_Split_Bearer._ext = []
    
    #-----< E-RABs-ToBeModified-ModReqItem-Split-BearerExtIEs >-----#
    E_RABs_ToBeModified_ModReqItem_Split_BearerExtIEs = CLASS(name='E-RABs-ToBeModified-ModReqItem-Split-BearerExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    E_RABs_ToBeModified_ModReqItem_Split_BearerExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeReleased-List-ModReq >-----#
    E_RABs_ToBeReleased_List_ModReq = SEQ_OF(name='E-RABs-ToBeReleased-List-ModReq', mode=MODE_TYPE)
    _E_RABs_ToBeReleased_List_ModReq__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __E_RABs_ToBeReleased_List_ModReq__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ___E_RABs_ToBeReleased_List_ModReq__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____E_RABs_ToBeReleased_List_ModReq__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-ModReqItem')))
    ___E_RABs_ToBeReleased_List_ModReq__item__id_tab._val = ASN1Set(rv=[dict([('id', 127), ('criticality', 'ignore'), ('Value', ____E_RABs_ToBeReleased_List_ModReq__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E_RABs_ToBeReleased_List_ModReq__item__id._const_tab = ___E_RABs_ToBeReleased_List_ModReq__item__id_tab
    __E_RABs_ToBeReleased_List_ModReq__item__id._const_tab_at = None
    __E_RABs_ToBeReleased_List_ModReq__item__id._const_tab_id = 'id'
    __E_RABs_ToBeReleased_List_ModReq__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    __E_RABs_ToBeReleased_List_ModReq__item__criticality._const_tab = ___E_RABs_ToBeReleased_List_ModReq__item__id_tab
    __E_RABs_ToBeReleased_List_ModReq__item__criticality._const_tab_at = ('..', 'id')
    __E_RABs_ToBeReleased_List_ModReq__item__criticality._const_tab_id = 'criticality'
    __E_RABs_ToBeReleased_List_ModReq__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    __E_RABs_ToBeReleased_List_ModReq__item__value._const_tab = ___E_RABs_ToBeReleased_List_ModReq__item__id_tab
    __E_RABs_ToBeReleased_List_ModReq__item__value._const_tab_at = ('..', 'id')
    __E_RABs_ToBeReleased_List_ModReq__item__value._const_tab_id = 'Value'
    _E_RABs_ToBeReleased_List_ModReq__item_._cont = ASN1Dict([
        ('id', __E_RABs_ToBeReleased_List_ModReq__item__id),
        ('criticality', __E_RABs_ToBeReleased_List_ModReq__item__criticality),
        ('value', __E_RABs_ToBeReleased_List_ModReq__item__value),
        ])
    _E_RABs_ToBeReleased_List_ModReq__item_._ext = None
    E_RABs_ToBeReleased_List_ModReq._cont = _E_RABs_ToBeReleased_List_ModReq__item_
    E_RABs_ToBeReleased_List_ModReq._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABs-ToBeReleased-ModReqItemIEs >-----#
    E_RABs_ToBeReleased_ModReqItemIEs = CLASS(name='E-RABs-ToBeReleased-ModReqItemIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _E_RABs_ToBeReleased_ModReqItemIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-ModReqItem')))
    E_RABs_ToBeReleased_ModReqItemIEs._val = ASN1Set(rv=[dict([('id', 127), ('criticality', 'ignore'), ('Value', _E_RABs_ToBeReleased_ModReqItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeReleased-ModReqItem >-----#
    E_RABs_ToBeReleased_ModReqItem = CHOICE(name='E-RABs-ToBeReleased-ModReqItem', mode=MODE_TYPE)
    _E_RABs_ToBeReleased_ModReqItem_sCG_Bearer = SEQ(name='sCG-Bearer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-ModReqItem-SCG-Bearer')))
    _E_RABs_ToBeReleased_ModReqItem_split_Bearer = SEQ(name='split-Bearer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-ModReqItem-Split-Bearer')))
    E_RABs_ToBeReleased_ModReqItem._cont = ASN1Dict([
        ('sCG-Bearer', _E_RABs_ToBeReleased_ModReqItem_sCG_Bearer),
        ('split-Bearer', _E_RABs_ToBeReleased_ModReqItem_split_Bearer),
        ])
    E_RABs_ToBeReleased_ModReqItem._ext = []
    
    #-----< E-RABs-ToBeReleased-ModReqItem-SCG-Bearer >-----#
    E_RABs_ToBeReleased_ModReqItem_SCG_Bearer = SEQ(name='E-RABs-ToBeReleased-ModReqItem-SCG-Bearer', mode=MODE_TYPE)
    _E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_dL_Forwarding_GTPtunnelEndpoint = SEQ(name='dL-Forwarding-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_uL_Forwarding_GTPtunnelEndpoint = SEQ(name='uL-Forwarding-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions__item__id._const_tab = ____E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions__item__criticality._const_tab = ____E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions__item__criticality_tab
    ___E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions__item__extensionValue_tab
    ___E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions__item__id),
        ('criticality', ___E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions__item_._ext = None
    _E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions._cont = __E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions__item_
    _E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_ToBeReleased_ModReqItem_SCG_Bearer._cont = ASN1Dict([
        ('e-RAB-ID', _E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_e_RAB_ID),
        ('dL-Forwarding-GTPtunnelEndpoint', _E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_dL_Forwarding_GTPtunnelEndpoint),
        ('uL-Forwarding-GTPtunnelEndpoint', _E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_uL_Forwarding_GTPtunnelEndpoint),
        ('iE-Extensions', _E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions),
        ])
    E_RABs_ToBeReleased_ModReqItem_SCG_Bearer._ext = []
    
    #-----< E-RABs-ToBeReleased-ModReqItem-SCG-BearerExtIEs >-----#
    E_RABs_ToBeReleased_ModReqItem_SCG_BearerExtIEs = CLASS(name='E-RABs-ToBeReleased-ModReqItem-SCG-BearerExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    E_RABs_ToBeReleased_ModReqItem_SCG_BearerExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeReleased-ModReqItem-Split-Bearer >-----#
    E_RABs_ToBeReleased_ModReqItem_Split_Bearer = SEQ(name='E-RABs-ToBeReleased-ModReqItem-Split-Bearer', mode=MODE_TYPE)
    _E_RABs_ToBeReleased_ModReqItem_Split_Bearer_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_ToBeReleased_ModReqItem_Split_Bearer_dL_Forwarding_GTPtunnelEndpoint = SEQ(name='dL-Forwarding-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions__item__id._const_tab = ____E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions__item__criticality._const_tab = ____E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions__item__criticality_tab
    ___E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions__item__extensionValue_tab
    ___E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions__item__id),
        ('criticality', ___E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions__item_._ext = None
    _E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions._cont = __E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions__item_
    _E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_ToBeReleased_ModReqItem_Split_Bearer._cont = ASN1Dict([
        ('e-RAB-ID', _E_RABs_ToBeReleased_ModReqItem_Split_Bearer_e_RAB_ID),
        ('dL-Forwarding-GTPtunnelEndpoint', _E_RABs_ToBeReleased_ModReqItem_Split_Bearer_dL_Forwarding_GTPtunnelEndpoint),
        ('iE-Extensions', _E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions),
        ])
    E_RABs_ToBeReleased_ModReqItem_Split_Bearer._ext = []
    
    #-----< E-RABs-ToBeReleased-ModReqItem-Split-BearerExtIEs >-----#
    E_RABs_ToBeReleased_ModReqItem_Split_BearerExtIEs = CLASS(name='E-RABs-ToBeReleased-ModReqItem-Split-BearerExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    E_RABs_ToBeReleased_ModReqItem_Split_BearerExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SeNBModificationRequestAcknowledge >-----#
    SeNBModificationRequestAcknowledge = SEQ(name='SeNBModificationRequestAcknowledge', mode=MODE_TYPE)
    _SeNBModificationRequestAcknowledge_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __SeNBModificationRequestAcknowledge_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___SeNBModificationRequestAcknowledge_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeAdded-ModAckList')))
    _____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeModified-ModAckList')))
    _____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeReleased-ModAckList')))
    _____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-List')))
    _____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_6 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SeNBtoMeNBContainer')))
    _____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_7 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_8 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_9 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    ____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'ignore'), ('Value', _____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 112), ('criticality', 'ignore'), ('Value', _____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 128), ('criticality', 'ignore'), ('Value', _____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 129), ('criticality', 'ignore'), ('Value', _____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 130), ('criticality', 'ignore'), ('Value', _____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 3), ('criticality', 'ignore'), ('Value', _____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 122), ('criticality', 'ignore'), ('Value', _____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')]), dict([('id', 157), ('criticality', 'ignore'), ('Value', _____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_8), ('presence', 'optional')]), dict([('id', 158), ('criticality', 'ignore'), ('Value', _____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_9), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SeNBModificationRequestAcknowledge_protocolIEs__item__id._const_tab = ____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab
    ___SeNBModificationRequestAcknowledge_protocolIEs__item__id._const_tab_at = None
    ___SeNBModificationRequestAcknowledge_protocolIEs__item__id._const_tab_id = 'id'
    ___SeNBModificationRequestAcknowledge_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___SeNBModificationRequestAcknowledge_protocolIEs__item__criticality._const_tab = ____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab
    ___SeNBModificationRequestAcknowledge_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___SeNBModificationRequestAcknowledge_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___SeNBModificationRequestAcknowledge_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___SeNBModificationRequestAcknowledge_protocolIEs__item__value._const_tab = ____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab
    ___SeNBModificationRequestAcknowledge_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___SeNBModificationRequestAcknowledge_protocolIEs__item__value._const_tab_id = 'Value'
    __SeNBModificationRequestAcknowledge_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___SeNBModificationRequestAcknowledge_protocolIEs__item__id),
        ('criticality', ___SeNBModificationRequestAcknowledge_protocolIEs__item__criticality),
        ('value', ___SeNBModificationRequestAcknowledge_protocolIEs__item__value),
        ])
    __SeNBModificationRequestAcknowledge_protocolIEs__item_._ext = None
    _SeNBModificationRequestAcknowledge_protocolIEs._cont = __SeNBModificationRequestAcknowledge_protocolIEs__item_
    _SeNBModificationRequestAcknowledge_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    SeNBModificationRequestAcknowledge._cont = ASN1Dict([
        ('protocolIEs', _SeNBModificationRequestAcknowledge_protocolIEs),
        ])
    SeNBModificationRequestAcknowledge._ext = []
    
    #-----< SeNBModificationRequestAcknowledge-IEs >-----#
    SeNBModificationRequestAcknowledge_IEs = CLASS(name='SeNBModificationRequestAcknowledge-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _SeNBModificationRequestAcknowledge_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SeNBModificationRequestAcknowledge_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SeNBModificationRequestAcknowledge_IEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeAdded-ModAckList')))
    _SeNBModificationRequestAcknowledge_IEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeModified-ModAckList')))
    _SeNBModificationRequestAcknowledge_IEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeReleased-ModAckList')))
    _SeNBModificationRequestAcknowledge_IEs_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-List')))
    _SeNBModificationRequestAcknowledge_IEs_val_Value_6 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SeNBtoMeNBContainer')))
    _SeNBModificationRequestAcknowledge_IEs_val_Value_7 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _SeNBModificationRequestAcknowledge_IEs_val_Value_8 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _SeNBModificationRequestAcknowledge_IEs_val_Value_9 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    SeNBModificationRequestAcknowledge_IEs._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'ignore'), ('Value', _SeNBModificationRequestAcknowledge_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 112), ('criticality', 'ignore'), ('Value', _SeNBModificationRequestAcknowledge_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 128), ('criticality', 'ignore'), ('Value', _SeNBModificationRequestAcknowledge_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 129), ('criticality', 'ignore'), ('Value', _SeNBModificationRequestAcknowledge_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 130), ('criticality', 'ignore'), ('Value', _SeNBModificationRequestAcknowledge_IEs_val_Value_4), ('presence', 'optional')]), dict([('id', 3), ('criticality', 'ignore'), ('Value', _SeNBModificationRequestAcknowledge_IEs_val_Value_5), ('presence', 'optional')]), dict([('id', 122), ('criticality', 'ignore'), ('Value', _SeNBModificationRequestAcknowledge_IEs_val_Value_6), ('presence', 'optional')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _SeNBModificationRequestAcknowledge_IEs_val_Value_7), ('presence', 'optional')]), dict([('id', 157), ('criticality', 'ignore'), ('Value', _SeNBModificationRequestAcknowledge_IEs_val_Value_8), ('presence', 'optional')]), dict([('id', 158), ('criticality', 'ignore'), ('Value', _SeNBModificationRequestAcknowledge_IEs_val_Value_9), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-Admitted-ToBeAdded-ModAckList >-----#
    E_RABs_Admitted_ToBeAdded_ModAckList = SEQ_OF(name='E-RABs-Admitted-ToBeAdded-ModAckList', mode=MODE_TYPE)
    _E_RABs_Admitted_ToBeAdded_ModAckList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __E_RABs_Admitted_ToBeAdded_ModAckList__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ___E_RABs_Admitted_ToBeAdded_ModAckList__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____E_RABs_Admitted_ToBeAdded_ModAckList__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeAdded-ModAckItem')))
    ___E_RABs_Admitted_ToBeAdded_ModAckList__item__id_tab._val = ASN1Set(rv=[dict([('id', 131), ('criticality', 'ignore'), ('Value', ____E_RABs_Admitted_ToBeAdded_ModAckList__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E_RABs_Admitted_ToBeAdded_ModAckList__item__id._const_tab = ___E_RABs_Admitted_ToBeAdded_ModAckList__item__id_tab
    __E_RABs_Admitted_ToBeAdded_ModAckList__item__id._const_tab_at = None
    __E_RABs_Admitted_ToBeAdded_ModAckList__item__id._const_tab_id = 'id'
    __E_RABs_Admitted_ToBeAdded_ModAckList__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    __E_RABs_Admitted_ToBeAdded_ModAckList__item__criticality._const_tab = ___E_RABs_Admitted_ToBeAdded_ModAckList__item__id_tab
    __E_RABs_Admitted_ToBeAdded_ModAckList__item__criticality._const_tab_at = ('..', 'id')
    __E_RABs_Admitted_ToBeAdded_ModAckList__item__criticality._const_tab_id = 'criticality'
    __E_RABs_Admitted_ToBeAdded_ModAckList__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    __E_RABs_Admitted_ToBeAdded_ModAckList__item__value._const_tab = ___E_RABs_Admitted_ToBeAdded_ModAckList__item__id_tab
    __E_RABs_Admitted_ToBeAdded_ModAckList__item__value._const_tab_at = ('..', 'id')
    __E_RABs_Admitted_ToBeAdded_ModAckList__item__value._const_tab_id = 'Value'
    _E_RABs_Admitted_ToBeAdded_ModAckList__item_._cont = ASN1Dict([
        ('id', __E_RABs_Admitted_ToBeAdded_ModAckList__item__id),
        ('criticality', __E_RABs_Admitted_ToBeAdded_ModAckList__item__criticality),
        ('value', __E_RABs_Admitted_ToBeAdded_ModAckList__item__value),
        ])
    _E_RABs_Admitted_ToBeAdded_ModAckList__item_._ext = None
    E_RABs_Admitted_ToBeAdded_ModAckList._cont = _E_RABs_Admitted_ToBeAdded_ModAckList__item_
    E_RABs_Admitted_ToBeAdded_ModAckList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABs-Admitted-ToBeAdded-ModAckItemIEs >-----#
    E_RABs_Admitted_ToBeAdded_ModAckItemIEs = CLASS(name='E-RABs-Admitted-ToBeAdded-ModAckItemIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _E_RABs_Admitted_ToBeAdded_ModAckItemIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeAdded-ModAckItem')))
    E_RABs_Admitted_ToBeAdded_ModAckItemIEs._val = ASN1Set(rv=[dict([('id', 131), ('criticality', 'ignore'), ('Value', _E_RABs_Admitted_ToBeAdded_ModAckItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< E-RABs-Admitted-ToBeAdded-ModAckItem >-----#
    E_RABs_Admitted_ToBeAdded_ModAckItem = CHOICE(name='E-RABs-Admitted-ToBeAdded-ModAckItem', mode=MODE_TYPE)
    _E_RABs_Admitted_ToBeAdded_ModAckItem_sCG_Bearer = SEQ(name='sCG-Bearer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeAdded-ModAckItem-SCG-Bearer')))
    _E_RABs_Admitted_ToBeAdded_ModAckItem_split_Bearer = SEQ(name='split-Bearer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeAdded-ModAckItem-Split-Bearer')))
    E_RABs_Admitted_ToBeAdded_ModAckItem._cont = ASN1Dict([
        ('sCG-Bearer', _E_RABs_Admitted_ToBeAdded_ModAckItem_sCG_Bearer),
        ('split-Bearer', _E_RABs_Admitted_ToBeAdded_ModAckItem_split_Bearer),
        ])
    E_RABs_Admitted_ToBeAdded_ModAckItem._ext = []
    
    #-----< E-RABs-Admitted-ToBeAdded-ModAckItem-SCG-Bearer >-----#
    E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer = SEQ(name='E-RABs-Admitted-ToBeAdded-ModAckItem-SCG-Bearer', mode=MODE_TYPE)
    _E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_s1_DL_GTPtunnelEndpoint = SEQ(name='s1-DL-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')))
    _E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_dL_Forwarding_GTPtunnelEndpoint = SEQ(name='dL-Forwarding-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_uL_Forwarding_GTPtunnelEndpoint = SEQ(name='uL-Forwarding-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions__item__id_tab_val_Extension_0 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TransportLayerAddress')))
    ____E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 412), ('criticality', 'ignore'), ('Extension', _____E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions__item__id._const_tab = ____E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions__item__criticality._const_tab = ____E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions__item__id),
        ('criticality', ___E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions__item_._ext = None
    _E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions._cont = __E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions__item_
    _E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer._cont = ASN1Dict([
        ('e-RAB-ID', _E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_e_RAB_ID),
        ('s1-DL-GTPtunnelEndpoint', _E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_s1_DL_GTPtunnelEndpoint),
        ('dL-Forwarding-GTPtunnelEndpoint', _E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_dL_Forwarding_GTPtunnelEndpoint),
        ('uL-Forwarding-GTPtunnelEndpoint', _E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_uL_Forwarding_GTPtunnelEndpoint),
        ('iE-Extensions', _E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions),
        ])
    E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer._ext = []
    
    #-----< E-RABs-Admitted-ToBeAdded-ModAckItem-SCG-BearerExtIEs >-----#
    E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_BearerExtIEs = CLASS(name='E-RABs-Admitted-ToBeAdded-ModAckItem-SCG-BearerExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_BearerExtIEs_val_Extension_0 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TransportLayerAddress')))
    E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_BearerExtIEs._val = ASN1Set(rv=[dict([('id', 412), ('criticality', 'ignore'), ('Extension', _E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_BearerExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-Admitted-ToBeAdded-ModAckItem-Split-Bearer >-----#
    E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer = SEQ(name='E-RABs-Admitted-ToBeAdded-ModAckItem-Split-Bearer', mode=MODE_TYPE)
    _E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_seNB_GTPtunnelEndpoint = SEQ(name='seNB-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')))
    _E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions__item__id_tab_val_Extension_0 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TransportLayerAddress')))
    ____E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 412), ('criticality', 'ignore'), ('Extension', _____E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions__item__id._const_tab = ____E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions__item__criticality._const_tab = ____E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions__item__id),
        ('criticality', ___E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions__item_._ext = None
    _E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions._cont = __E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions__item_
    _E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer._cont = ASN1Dict([
        ('e-RAB-ID', _E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_e_RAB_ID),
        ('seNB-GTPtunnelEndpoint', _E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_seNB_GTPtunnelEndpoint),
        ('iE-Extensions', _E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions),
        ])
    E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer._ext = []
    
    #-----< E-RABs-Admitted-ToBeAdded-ModAckItem-Split-BearerExtIEs >-----#
    E_RABs_Admitted_ToBeAdded_ModAckItem_Split_BearerExtIEs = CLASS(name='E-RABs-Admitted-ToBeAdded-ModAckItem-Split-BearerExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _E_RABs_Admitted_ToBeAdded_ModAckItem_Split_BearerExtIEs_val_Extension_0 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TransportLayerAddress')))
    E_RABs_Admitted_ToBeAdded_ModAckItem_Split_BearerExtIEs._val = ASN1Set(rv=[dict([('id', 412), ('criticality', 'ignore'), ('Extension', _E_RABs_Admitted_ToBeAdded_ModAckItem_Split_BearerExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-Admitted-ToBeModified-ModAckList >-----#
    E_RABs_Admitted_ToBeModified_ModAckList = SEQ_OF(name='E-RABs-Admitted-ToBeModified-ModAckList', mode=MODE_TYPE)
    _E_RABs_Admitted_ToBeModified_ModAckList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __E_RABs_Admitted_ToBeModified_ModAckList__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ___E_RABs_Admitted_ToBeModified_ModAckList__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____E_RABs_Admitted_ToBeModified_ModAckList__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeModified-ModAckItem')))
    ___E_RABs_Admitted_ToBeModified_ModAckList__item__id_tab._val = ASN1Set(rv=[dict([('id', 132), ('criticality', 'ignore'), ('Value', ____E_RABs_Admitted_ToBeModified_ModAckList__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E_RABs_Admitted_ToBeModified_ModAckList__item__id._const_tab = ___E_RABs_Admitted_ToBeModified_ModAckList__item__id_tab
    __E_RABs_Admitted_ToBeModified_ModAckList__item__id._const_tab_at = None
    __E_RABs_Admitted_ToBeModified_ModAckList__item__id._const_tab_id = 'id'
    __E_RABs_Admitted_ToBeModified_ModAckList__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    __E_RABs_Admitted_ToBeModified_ModAckList__item__criticality._const_tab = ___E_RABs_Admitted_ToBeModified_ModAckList__item__id_tab
    __E_RABs_Admitted_ToBeModified_ModAckList__item__criticality._const_tab_at = ('..', 'id')
    __E_RABs_Admitted_ToBeModified_ModAckList__item__criticality._const_tab_id = 'criticality'
    __E_RABs_Admitted_ToBeModified_ModAckList__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    __E_RABs_Admitted_ToBeModified_ModAckList__item__value._const_tab = ___E_RABs_Admitted_ToBeModified_ModAckList__item__id_tab
    __E_RABs_Admitted_ToBeModified_ModAckList__item__value._const_tab_at = ('..', 'id')
    __E_RABs_Admitted_ToBeModified_ModAckList__item__value._const_tab_id = 'Value'
    _E_RABs_Admitted_ToBeModified_ModAckList__item_._cont = ASN1Dict([
        ('id', __E_RABs_Admitted_ToBeModified_ModAckList__item__id),
        ('criticality', __E_RABs_Admitted_ToBeModified_ModAckList__item__criticality),
        ('value', __E_RABs_Admitted_ToBeModified_ModAckList__item__value),
        ])
    _E_RABs_Admitted_ToBeModified_ModAckList__item_._ext = None
    E_RABs_Admitted_ToBeModified_ModAckList._cont = _E_RABs_Admitted_ToBeModified_ModAckList__item_
    E_RABs_Admitted_ToBeModified_ModAckList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABs-Admitted-ToBeModified-ModAckItemIEs >-----#
    E_RABs_Admitted_ToBeModified_ModAckItemIEs = CLASS(name='E-RABs-Admitted-ToBeModified-ModAckItemIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _E_RABs_Admitted_ToBeModified_ModAckItemIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeModified-ModAckItem')))
    E_RABs_Admitted_ToBeModified_ModAckItemIEs._val = ASN1Set(rv=[dict([('id', 132), ('criticality', 'ignore'), ('Value', _E_RABs_Admitted_ToBeModified_ModAckItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< E-RABs-Admitted-ToBeModified-ModAckItem >-----#
    E_RABs_Admitted_ToBeModified_ModAckItem = CHOICE(name='E-RABs-Admitted-ToBeModified-ModAckItem', mode=MODE_TYPE)
    _E_RABs_Admitted_ToBeModified_ModAckItem_sCG_Bearer = SEQ(name='sCG-Bearer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeModified-ModAckItem-SCG-Bearer')))
    _E_RABs_Admitted_ToBeModified_ModAckItem_split_Bearer = SEQ(name='split-Bearer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeModified-ModAckItem-Split-Bearer')))
    E_RABs_Admitted_ToBeModified_ModAckItem._cont = ASN1Dict([
        ('sCG-Bearer', _E_RABs_Admitted_ToBeModified_ModAckItem_sCG_Bearer),
        ('split-Bearer', _E_RABs_Admitted_ToBeModified_ModAckItem_split_Bearer),
        ])
    E_RABs_Admitted_ToBeModified_ModAckItem._ext = []
    
    #-----< E-RABs-Admitted-ToBeModified-ModAckItem-SCG-Bearer >-----#
    E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer = SEQ(name='E-RABs-Admitted-ToBeModified-ModAckItem-SCG-Bearer', mode=MODE_TYPE)
    _E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_s1_DL_GTPtunnelEndpoint = SEQ(name='s1-DL-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions__item__id._const_tab = ____E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions__item__criticality._const_tab = ____E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions__item__criticality_tab
    ___E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions__item__extensionValue_tab
    ___E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions__item__id),
        ('criticality', ___E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions__item_._ext = None
    _E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions._cont = __E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions__item_
    _E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer._cont = ASN1Dict([
        ('e-RAB-ID', _E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_e_RAB_ID),
        ('s1-DL-GTPtunnelEndpoint', _E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_s1_DL_GTPtunnelEndpoint),
        ('iE-Extensions', _E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions),
        ])
    E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer._ext = []
    
    #-----< E-RABs-Admitted-ToBeModified-ModAckItem-SCG-BearerExtIEs >-----#
    E_RABs_Admitted_ToBeModified_ModAckItem_SCG_BearerExtIEs = CLASS(name='E-RABs-Admitted-ToBeModified-ModAckItem-SCG-BearerExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    E_RABs_Admitted_ToBeModified_ModAckItem_SCG_BearerExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RABs-Admitted-ToBeModified-ModAckItem-Split-Bearer >-----#
    E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer = SEQ(name='E-RABs-Admitted-ToBeModified-ModAckItem-Split-Bearer', mode=MODE_TYPE)
    _E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_seNB_GTPtunnelEndpoint = SEQ(name='seNB-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions__item__id._const_tab = ____E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions__item__criticality._const_tab = ____E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions__item__criticality_tab
    ___E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions__item__extensionValue_tab
    ___E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions__item__id),
        ('criticality', ___E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions__item_._ext = None
    _E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions._cont = __E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions__item_
    _E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer._cont = ASN1Dict([
        ('e-RAB-ID', _E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_e_RAB_ID),
        ('seNB-GTPtunnelEndpoint', _E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_seNB_GTPtunnelEndpoint),
        ('iE-Extensions', _E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions),
        ])
    E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer._ext = []
    
    #-----< E-RABs-Admitted-ToBeModified-ModAckItem-Split-BearerExtIEs >-----#
    E_RABs_Admitted_ToBeModified_ModAckItem_Split_BearerExtIEs = CLASS(name='E-RABs-Admitted-ToBeModified-ModAckItem-Split-BearerExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    E_RABs_Admitted_ToBeModified_ModAckItem_Split_BearerExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RABs-Admitted-ToBeReleased-ModAckList >-----#
    E_RABs_Admitted_ToBeReleased_ModAckList = SEQ_OF(name='E-RABs-Admitted-ToBeReleased-ModAckList', mode=MODE_TYPE)
    _E_RABs_Admitted_ToBeReleased_ModAckList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __E_RABs_Admitted_ToBeReleased_ModAckList__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ___E_RABs_Admitted_ToBeReleased_ModAckList__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____E_RABs_Admitted_ToBeReleased_ModAckList__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToReleased-ModAckItem')))
    ___E_RABs_Admitted_ToBeReleased_ModAckList__item__id_tab._val = ASN1Set(rv=[dict([('id', 133), ('criticality', 'ignore'), ('Value', ____E_RABs_Admitted_ToBeReleased_ModAckList__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E_RABs_Admitted_ToBeReleased_ModAckList__item__id._const_tab = ___E_RABs_Admitted_ToBeReleased_ModAckList__item__id_tab
    __E_RABs_Admitted_ToBeReleased_ModAckList__item__id._const_tab_at = None
    __E_RABs_Admitted_ToBeReleased_ModAckList__item__id._const_tab_id = 'id'
    __E_RABs_Admitted_ToBeReleased_ModAckList__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    __E_RABs_Admitted_ToBeReleased_ModAckList__item__criticality._const_tab = ___E_RABs_Admitted_ToBeReleased_ModAckList__item__id_tab
    __E_RABs_Admitted_ToBeReleased_ModAckList__item__criticality._const_tab_at = ('..', 'id')
    __E_RABs_Admitted_ToBeReleased_ModAckList__item__criticality._const_tab_id = 'criticality'
    __E_RABs_Admitted_ToBeReleased_ModAckList__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    __E_RABs_Admitted_ToBeReleased_ModAckList__item__value._const_tab = ___E_RABs_Admitted_ToBeReleased_ModAckList__item__id_tab
    __E_RABs_Admitted_ToBeReleased_ModAckList__item__value._const_tab_at = ('..', 'id')
    __E_RABs_Admitted_ToBeReleased_ModAckList__item__value._const_tab_id = 'Value'
    _E_RABs_Admitted_ToBeReleased_ModAckList__item_._cont = ASN1Dict([
        ('id', __E_RABs_Admitted_ToBeReleased_ModAckList__item__id),
        ('criticality', __E_RABs_Admitted_ToBeReleased_ModAckList__item__criticality),
        ('value', __E_RABs_Admitted_ToBeReleased_ModAckList__item__value),
        ])
    _E_RABs_Admitted_ToBeReleased_ModAckList__item_._ext = None
    E_RABs_Admitted_ToBeReleased_ModAckList._cont = _E_RABs_Admitted_ToBeReleased_ModAckList__item_
    E_RABs_Admitted_ToBeReleased_ModAckList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABs-Admitted-ToBeReleased-ModAckItemIEs >-----#
    E_RABs_Admitted_ToBeReleased_ModAckItemIEs = CLASS(name='E-RABs-Admitted-ToBeReleased-ModAckItemIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _E_RABs_Admitted_ToBeReleased_ModAckItemIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToReleased-ModAckItem')))
    E_RABs_Admitted_ToBeReleased_ModAckItemIEs._val = ASN1Set(rv=[dict([('id', 133), ('criticality', 'ignore'), ('Value', _E_RABs_Admitted_ToBeReleased_ModAckItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< E-RABs-Admitted-ToReleased-ModAckItem >-----#
    E_RABs_Admitted_ToReleased_ModAckItem = CHOICE(name='E-RABs-Admitted-ToReleased-ModAckItem', mode=MODE_TYPE)
    _E_RABs_Admitted_ToReleased_ModAckItem_sCG_Bearer = SEQ(name='sCG-Bearer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeReleased-ModAckItem-SCG-Bearer')))
    _E_RABs_Admitted_ToReleased_ModAckItem_split_Bearer = SEQ(name='split-Bearer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeReleased-ModAckItem-Split-Bearer')))
    E_RABs_Admitted_ToReleased_ModAckItem._cont = ASN1Dict([
        ('sCG-Bearer', _E_RABs_Admitted_ToReleased_ModAckItem_sCG_Bearer),
        ('split-Bearer', _E_RABs_Admitted_ToReleased_ModAckItem_split_Bearer),
        ])
    E_RABs_Admitted_ToReleased_ModAckItem._ext = []
    
    #-----< E-RABs-Admitted-ToBeReleased-ModAckItem-SCG-Bearer >-----#
    E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer = SEQ(name='E-RABs-Admitted-ToBeReleased-ModAckItem-SCG-Bearer', mode=MODE_TYPE)
    _E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions__item__id._const_tab = ____E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions__item__criticality._const_tab = ____E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions__item__criticality_tab
    ___E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions__item__extensionValue_tab
    ___E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions__item__id),
        ('criticality', ___E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions__item_._ext = None
    _E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions._cont = __E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions__item_
    _E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer._cont = ASN1Dict([
        ('e-RAB-ID', _E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_e_RAB_ID),
        ('iE-Extensions', _E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions),
        ])
    E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer._ext = []
    
    #-----< E-RABs-Admitted-ToBeReleased-ModAckItem-SCG-BearerExtIEs >-----#
    E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_BearerExtIEs = CLASS(name='E-RABs-Admitted-ToBeReleased-ModAckItem-SCG-BearerExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_BearerExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RABs-Admitted-ToBeReleased-ModAckItem-Split-Bearer >-----#
    E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer = SEQ(name='E-RABs-Admitted-ToBeReleased-ModAckItem-Split-Bearer', mode=MODE_TYPE)
    _E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions__item__id._const_tab = ____E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions__item__criticality._const_tab = ____E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions__item__criticality_tab
    ___E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions__item__extensionValue_tab
    ___E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions__item__id),
        ('criticality', ___E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions__item_._ext = None
    _E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions._cont = __E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions__item_
    _E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer._cont = ASN1Dict([
        ('e-RAB-ID', _E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_e_RAB_ID),
        ('iE-Extensions', _E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions),
        ])
    E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer._ext = []
    
    #-----< E-RABs-Admitted-ToBeReleased-ModAckItem-Split-BearerExtIEs >-----#
    E_RABs_Admitted_ToBeReleased_ModAckItem_Split_BearerExtIEs = CLASS(name='E-RABs-Admitted-ToBeReleased-ModAckItem-Split-BearerExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    E_RABs_Admitted_ToBeReleased_ModAckItem_Split_BearerExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SeNBModificationRequestReject >-----#
    SeNBModificationRequestReject = SEQ(name='SeNBModificationRequestReject', mode=MODE_TYPE)
    _SeNBModificationRequestReject_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __SeNBModificationRequestReject_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___SeNBModificationRequestReject_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____SeNBModificationRequestReject_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____SeNBModificationRequestReject_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SeNBModificationRequestReject_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SeNBModificationRequestReject_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _____SeNBModificationRequestReject_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _____SeNBModificationRequestReject_protocolIEs__item__id_tab_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____SeNBModificationRequestReject_protocolIEs__item__id_tab_val_Value_5 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    ____SeNBModificationRequestReject_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'ignore'), ('Value', _____SeNBModificationRequestReject_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 112), ('criticality', 'ignore'), ('Value', _____SeNBModificationRequestReject_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _____SeNBModificationRequestReject_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _____SeNBModificationRequestReject_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 157), ('criticality', 'ignore'), ('Value', _____SeNBModificationRequestReject_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 158), ('criticality', 'ignore'), ('Value', _____SeNBModificationRequestReject_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SeNBModificationRequestReject_protocolIEs__item__id._const_tab = ____SeNBModificationRequestReject_protocolIEs__item__id_tab
    ___SeNBModificationRequestReject_protocolIEs__item__id._const_tab_at = None
    ___SeNBModificationRequestReject_protocolIEs__item__id._const_tab_id = 'id'
    ___SeNBModificationRequestReject_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___SeNBModificationRequestReject_protocolIEs__item__criticality._const_tab = ____SeNBModificationRequestReject_protocolIEs__item__id_tab
    ___SeNBModificationRequestReject_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___SeNBModificationRequestReject_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___SeNBModificationRequestReject_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___SeNBModificationRequestReject_protocolIEs__item__value._const_tab = ____SeNBModificationRequestReject_protocolIEs__item__id_tab
    ___SeNBModificationRequestReject_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___SeNBModificationRequestReject_protocolIEs__item__value._const_tab_id = 'Value'
    __SeNBModificationRequestReject_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___SeNBModificationRequestReject_protocolIEs__item__id),
        ('criticality', ___SeNBModificationRequestReject_protocolIEs__item__criticality),
        ('value', ___SeNBModificationRequestReject_protocolIEs__item__value),
        ])
    __SeNBModificationRequestReject_protocolIEs__item_._ext = None
    _SeNBModificationRequestReject_protocolIEs._cont = __SeNBModificationRequestReject_protocolIEs__item_
    _SeNBModificationRequestReject_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    SeNBModificationRequestReject._cont = ASN1Dict([
        ('protocolIEs', _SeNBModificationRequestReject_protocolIEs),
        ])
    SeNBModificationRequestReject._ext = []
    
    #-----< SeNBModificationRequestReject-IEs >-----#
    SeNBModificationRequestReject_IEs = CLASS(name='SeNBModificationRequestReject-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _SeNBModificationRequestReject_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SeNBModificationRequestReject_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SeNBModificationRequestReject_IEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _SeNBModificationRequestReject_IEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _SeNBModificationRequestReject_IEs_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _SeNBModificationRequestReject_IEs_val_Value_5 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    SeNBModificationRequestReject_IEs._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'ignore'), ('Value', _SeNBModificationRequestReject_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 112), ('criticality', 'ignore'), ('Value', _SeNBModificationRequestReject_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _SeNBModificationRequestReject_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _SeNBModificationRequestReject_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 157), ('criticality', 'ignore'), ('Value', _SeNBModificationRequestReject_IEs_val_Value_4), ('presence', 'optional')]), dict([('id', 158), ('criticality', 'ignore'), ('Value', _SeNBModificationRequestReject_IEs_val_Value_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< SeNBModificationRequired >-----#
    SeNBModificationRequired = SEQ(name='SeNBModificationRequired', mode=MODE_TYPE)
    _SeNBModificationRequired_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __SeNBModificationRequired_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___SeNBModificationRequired_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____SeNBModificationRequired_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____SeNBModificationRequired_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SeNBModificationRequired_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SeNBModificationRequired_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _____SeNBModificationRequired_protocolIEs__item__id_tab_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SCGChangeIndication')))
    _____SeNBModificationRequired_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-ModReqd')))
    _____SeNBModificationRequired_protocolIEs__item__id_tab_val_Value_5 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SeNBtoMeNBContainer')))
    _____SeNBModificationRequired_protocolIEs__item__id_tab_val_Value_6 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____SeNBModificationRequired_protocolIEs__item__id_tab_val_Value_7 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    ____SeNBModificationRequired_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'reject'), ('Value', _____SeNBModificationRequired_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 112), ('criticality', 'reject'), ('Value', _____SeNBModificationRequired_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _____SeNBModificationRequired_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 136), ('criticality', 'ignore'), ('Value', _____SeNBModificationRequired_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 134), ('criticality', 'ignore'), ('Value', _____SeNBModificationRequired_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 122), ('criticality', 'ignore'), ('Value', _____SeNBModificationRequired_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 157), ('criticality', 'reject'), ('Value', _____SeNBModificationRequired_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 158), ('criticality', 'reject'), ('Value', _____SeNBModificationRequired_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SeNBModificationRequired_protocolIEs__item__id._const_tab = ____SeNBModificationRequired_protocolIEs__item__id_tab
    ___SeNBModificationRequired_protocolIEs__item__id._const_tab_at = None
    ___SeNBModificationRequired_protocolIEs__item__id._const_tab_id = 'id'
    ___SeNBModificationRequired_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___SeNBModificationRequired_protocolIEs__item__criticality._const_tab = ____SeNBModificationRequired_protocolIEs__item__id_tab
    ___SeNBModificationRequired_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___SeNBModificationRequired_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___SeNBModificationRequired_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___SeNBModificationRequired_protocolIEs__item__value._const_tab = ____SeNBModificationRequired_protocolIEs__item__id_tab
    ___SeNBModificationRequired_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___SeNBModificationRequired_protocolIEs__item__value._const_tab_id = 'Value'
    __SeNBModificationRequired_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___SeNBModificationRequired_protocolIEs__item__id),
        ('criticality', ___SeNBModificationRequired_protocolIEs__item__criticality),
        ('value', ___SeNBModificationRequired_protocolIEs__item__value),
        ])
    __SeNBModificationRequired_protocolIEs__item_._ext = None
    _SeNBModificationRequired_protocolIEs._cont = __SeNBModificationRequired_protocolIEs__item_
    _SeNBModificationRequired_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    SeNBModificationRequired._cont = ASN1Dict([
        ('protocolIEs', _SeNBModificationRequired_protocolIEs),
        ])
    SeNBModificationRequired._ext = []
    
    #-----< SeNBModificationRequired-IEs >-----#
    SeNBModificationRequired_IEs = CLASS(name='SeNBModificationRequired-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _SeNBModificationRequired_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SeNBModificationRequired_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SeNBModificationRequired_IEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _SeNBModificationRequired_IEs_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SCGChangeIndication')))
    _SeNBModificationRequired_IEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-ModReqd')))
    _SeNBModificationRequired_IEs_val_Value_5 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SeNBtoMeNBContainer')))
    _SeNBModificationRequired_IEs_val_Value_6 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _SeNBModificationRequired_IEs_val_Value_7 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    SeNBModificationRequired_IEs._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'reject'), ('Value', _SeNBModificationRequired_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 112), ('criticality', 'reject'), ('Value', _SeNBModificationRequired_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _SeNBModificationRequired_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 136), ('criticality', 'ignore'), ('Value', _SeNBModificationRequired_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 134), ('criticality', 'ignore'), ('Value', _SeNBModificationRequired_IEs_val_Value_4), ('presence', 'optional')]), dict([('id', 122), ('criticality', 'ignore'), ('Value', _SeNBModificationRequired_IEs_val_Value_5), ('presence', 'optional')]), dict([('id', 157), ('criticality', 'reject'), ('Value', _SeNBModificationRequired_IEs_val_Value_6), ('presence', 'optional')]), dict([('id', 158), ('criticality', 'reject'), ('Value', _SeNBModificationRequired_IEs_val_Value_7), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeReleased-ModReqd >-----#
    E_RABs_ToBeReleased_ModReqd = SEQ_OF(name='E-RABs-ToBeReleased-ModReqd', mode=MODE_TYPE)
    _E_RABs_ToBeReleased_ModReqd__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __E_RABs_ToBeReleased_ModReqd__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ___E_RABs_ToBeReleased_ModReqd__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____E_RABs_ToBeReleased_ModReqd__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-ModReqdItem')))
    ___E_RABs_ToBeReleased_ModReqd__item__id_tab._val = ASN1Set(rv=[dict([('id', 135), ('criticality', 'ignore'), ('Value', ____E_RABs_ToBeReleased_ModReqd__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E_RABs_ToBeReleased_ModReqd__item__id._const_tab = ___E_RABs_ToBeReleased_ModReqd__item__id_tab
    __E_RABs_ToBeReleased_ModReqd__item__id._const_tab_at = None
    __E_RABs_ToBeReleased_ModReqd__item__id._const_tab_id = 'id'
    __E_RABs_ToBeReleased_ModReqd__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    __E_RABs_ToBeReleased_ModReqd__item__criticality._const_tab = ___E_RABs_ToBeReleased_ModReqd__item__id_tab
    __E_RABs_ToBeReleased_ModReqd__item__criticality._const_tab_at = ('..', 'id')
    __E_RABs_ToBeReleased_ModReqd__item__criticality._const_tab_id = 'criticality'
    __E_RABs_ToBeReleased_ModReqd__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    __E_RABs_ToBeReleased_ModReqd__item__value._const_tab = ___E_RABs_ToBeReleased_ModReqd__item__id_tab
    __E_RABs_ToBeReleased_ModReqd__item__value._const_tab_at = ('..', 'id')
    __E_RABs_ToBeReleased_ModReqd__item__value._const_tab_id = 'Value'
    _E_RABs_ToBeReleased_ModReqd__item_._cont = ASN1Dict([
        ('id', __E_RABs_ToBeReleased_ModReqd__item__id),
        ('criticality', __E_RABs_ToBeReleased_ModReqd__item__criticality),
        ('value', __E_RABs_ToBeReleased_ModReqd__item__value),
        ])
    _E_RABs_ToBeReleased_ModReqd__item_._ext = None
    E_RABs_ToBeReleased_ModReqd._cont = _E_RABs_ToBeReleased_ModReqd__item_
    E_RABs_ToBeReleased_ModReqd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABs-ToBeReleased-ModReqdItemIEs >-----#
    E_RABs_ToBeReleased_ModReqdItemIEs = CLASS(name='E-RABs-ToBeReleased-ModReqdItemIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _E_RABs_ToBeReleased_ModReqdItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-ModReqdItem')))
    E_RABs_ToBeReleased_ModReqdItemIEs._val = ASN1Set(rv=[dict([('id', 135), ('criticality', 'ignore'), ('Value', _E_RABs_ToBeReleased_ModReqdItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeReleased-ModReqdItem >-----#
    E_RABs_ToBeReleased_ModReqdItem = SEQ(name='E-RABs-ToBeReleased-ModReqdItem', mode=MODE_TYPE)
    _E_RABs_ToBeReleased_ModReqdItem_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_ToBeReleased_ModReqdItem_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _E_RABs_ToBeReleased_ModReqdItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__id._const_tab = ____E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__id_tab
    ___E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__criticality._const_tab = ____E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__criticality_tab
    ___E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__extensionValue_tab
    ___E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__id),
        ('criticality', ___E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item_._ext = None
    _E_RABs_ToBeReleased_ModReqdItem_iE_Extensions._cont = __E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item_
    _E_RABs_ToBeReleased_ModReqdItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_ToBeReleased_ModReqdItem._cont = ASN1Dict([
        ('e-RAB-ID', _E_RABs_ToBeReleased_ModReqdItem_e_RAB_ID),
        ('cause', _E_RABs_ToBeReleased_ModReqdItem_cause),
        ('iE-Extensions', _E_RABs_ToBeReleased_ModReqdItem_iE_Extensions),
        ])
    E_RABs_ToBeReleased_ModReqdItem._ext = []
    
    #-----< E-RABs-ToBeReleased-ModReqdItemExtIEs >-----#
    E_RABs_ToBeReleased_ModReqdItemExtIEs = CLASS(name='E-RABs-ToBeReleased-ModReqdItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    E_RABs_ToBeReleased_ModReqdItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SeNBModificationConfirm >-----#
    SeNBModificationConfirm = SEQ(name='SeNBModificationConfirm', mode=MODE_TYPE)
    _SeNBModificationConfirm_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __SeNBModificationConfirm_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___SeNBModificationConfirm_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____SeNBModificationConfirm_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____SeNBModificationConfirm_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SeNBModificationConfirm_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SeNBModificationConfirm_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MeNBtoSeNBContainer')))
    _____SeNBModificationConfirm_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _____SeNBModificationConfirm_protocolIEs__item__id_tab_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____SeNBModificationConfirm_protocolIEs__item__id_tab_val_Value_5 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    ____SeNBModificationConfirm_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'ignore'), ('Value', _____SeNBModificationConfirm_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 112), ('criticality', 'ignore'), ('Value', _____SeNBModificationConfirm_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 119), ('criticality', 'ignore'), ('Value', _____SeNBModificationConfirm_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _____SeNBModificationConfirm_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 157), ('criticality', 'ignore'), ('Value', _____SeNBModificationConfirm_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 158), ('criticality', 'ignore'), ('Value', _____SeNBModificationConfirm_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SeNBModificationConfirm_protocolIEs__item__id._const_tab = ____SeNBModificationConfirm_protocolIEs__item__id_tab
    ___SeNBModificationConfirm_protocolIEs__item__id._const_tab_at = None
    ___SeNBModificationConfirm_protocolIEs__item__id._const_tab_id = 'id'
    ___SeNBModificationConfirm_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___SeNBModificationConfirm_protocolIEs__item__criticality._const_tab = ____SeNBModificationConfirm_protocolIEs__item__id_tab
    ___SeNBModificationConfirm_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___SeNBModificationConfirm_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___SeNBModificationConfirm_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___SeNBModificationConfirm_protocolIEs__item__value._const_tab = ____SeNBModificationConfirm_protocolIEs__item__id_tab
    ___SeNBModificationConfirm_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___SeNBModificationConfirm_protocolIEs__item__value._const_tab_id = 'Value'
    __SeNBModificationConfirm_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___SeNBModificationConfirm_protocolIEs__item__id),
        ('criticality', ___SeNBModificationConfirm_protocolIEs__item__criticality),
        ('value', ___SeNBModificationConfirm_protocolIEs__item__value),
        ])
    __SeNBModificationConfirm_protocolIEs__item_._ext = None
    _SeNBModificationConfirm_protocolIEs._cont = __SeNBModificationConfirm_protocolIEs__item_
    _SeNBModificationConfirm_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    SeNBModificationConfirm._cont = ASN1Dict([
        ('protocolIEs', _SeNBModificationConfirm_protocolIEs),
        ])
    SeNBModificationConfirm._ext = []
    
    #-----< SeNBModificationConfirm-IEs >-----#
    SeNBModificationConfirm_IEs = CLASS(name='SeNBModificationConfirm-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _SeNBModificationConfirm_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SeNBModificationConfirm_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SeNBModificationConfirm_IEs_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MeNBtoSeNBContainer')))
    _SeNBModificationConfirm_IEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _SeNBModificationConfirm_IEs_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _SeNBModificationConfirm_IEs_val_Value_5 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    SeNBModificationConfirm_IEs._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'ignore'), ('Value', _SeNBModificationConfirm_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 112), ('criticality', 'ignore'), ('Value', _SeNBModificationConfirm_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 119), ('criticality', 'ignore'), ('Value', _SeNBModificationConfirm_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _SeNBModificationConfirm_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 157), ('criticality', 'ignore'), ('Value', _SeNBModificationConfirm_IEs_val_Value_4), ('presence', 'optional')]), dict([('id', 158), ('criticality', 'ignore'), ('Value', _SeNBModificationConfirm_IEs_val_Value_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< SeNBModificationRefuse >-----#
    SeNBModificationRefuse = SEQ(name='SeNBModificationRefuse', mode=MODE_TYPE)
    _SeNBModificationRefuse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __SeNBModificationRefuse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___SeNBModificationRefuse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____SeNBModificationRefuse_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____SeNBModificationRefuse_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SeNBModificationRefuse_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SeNBModificationRefuse_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _____SeNBModificationRefuse_protocolIEs__item__id_tab_val_Value_3 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MeNBtoSeNBContainer')))
    _____SeNBModificationRefuse_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _____SeNBModificationRefuse_protocolIEs__item__id_tab_val_Value_5 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____SeNBModificationRefuse_protocolIEs__item__id_tab_val_Value_6 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    ____SeNBModificationRefuse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'ignore'), ('Value', _____SeNBModificationRefuse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 112), ('criticality', 'ignore'), ('Value', _____SeNBModificationRefuse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _____SeNBModificationRefuse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 119), ('criticality', 'ignore'), ('Value', _____SeNBModificationRefuse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _____SeNBModificationRefuse_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 157), ('criticality', 'ignore'), ('Value', _____SeNBModificationRefuse_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 158), ('criticality', 'ignore'), ('Value', _____SeNBModificationRefuse_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SeNBModificationRefuse_protocolIEs__item__id._const_tab = ____SeNBModificationRefuse_protocolIEs__item__id_tab
    ___SeNBModificationRefuse_protocolIEs__item__id._const_tab_at = None
    ___SeNBModificationRefuse_protocolIEs__item__id._const_tab_id = 'id'
    ___SeNBModificationRefuse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___SeNBModificationRefuse_protocolIEs__item__criticality._const_tab = ____SeNBModificationRefuse_protocolIEs__item__id_tab
    ___SeNBModificationRefuse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___SeNBModificationRefuse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___SeNBModificationRefuse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___SeNBModificationRefuse_protocolIEs__item__value._const_tab = ____SeNBModificationRefuse_protocolIEs__item__id_tab
    ___SeNBModificationRefuse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___SeNBModificationRefuse_protocolIEs__item__value._const_tab_id = 'Value'
    __SeNBModificationRefuse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___SeNBModificationRefuse_protocolIEs__item__id),
        ('criticality', ___SeNBModificationRefuse_protocolIEs__item__criticality),
        ('value', ___SeNBModificationRefuse_protocolIEs__item__value),
        ])
    __SeNBModificationRefuse_protocolIEs__item_._ext = None
    _SeNBModificationRefuse_protocolIEs._cont = __SeNBModificationRefuse_protocolIEs__item_
    _SeNBModificationRefuse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    SeNBModificationRefuse._cont = ASN1Dict([
        ('protocolIEs', _SeNBModificationRefuse_protocolIEs),
        ])
    SeNBModificationRefuse._ext = []
    
    #-----< SeNBModificationRefuse-IEs >-----#
    SeNBModificationRefuse_IEs = CLASS(name='SeNBModificationRefuse-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _SeNBModificationRefuse_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SeNBModificationRefuse_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SeNBModificationRefuse_IEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _SeNBModificationRefuse_IEs_val_Value_3 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MeNBtoSeNBContainer')))
    _SeNBModificationRefuse_IEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _SeNBModificationRefuse_IEs_val_Value_5 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _SeNBModificationRefuse_IEs_val_Value_6 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    SeNBModificationRefuse_IEs._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'ignore'), ('Value', _SeNBModificationRefuse_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 112), ('criticality', 'ignore'), ('Value', _SeNBModificationRefuse_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _SeNBModificationRefuse_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 119), ('criticality', 'ignore'), ('Value', _SeNBModificationRefuse_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _SeNBModificationRefuse_IEs_val_Value_4), ('presence', 'optional')]), dict([('id', 157), ('criticality', 'ignore'), ('Value', _SeNBModificationRefuse_IEs_val_Value_5), ('presence', 'optional')]), dict([('id', 158), ('criticality', 'ignore'), ('Value', _SeNBModificationRefuse_IEs_val_Value_6), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< SeNBReleaseRequest >-----#
    SeNBReleaseRequest = SEQ(name='SeNBReleaseRequest', mode=MODE_TYPE)
    _SeNBReleaseRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __SeNBReleaseRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___SeNBReleaseRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____SeNBReleaseRequest_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____SeNBReleaseRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SeNBReleaseRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SeNBReleaseRequest_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _____SeNBReleaseRequest_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-List-RelReq')))
    _____SeNBReleaseRequest_protocolIEs__item__id_tab_val_Value_4 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-ContextKeptIndicator')))
    _____SeNBReleaseRequest_protocolIEs__item__id_tab_val_Value_5 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____SeNBReleaseRequest_protocolIEs__item__id_tab_val_Value_6 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____SeNBReleaseRequest_protocolIEs__item__id_tab_val_Value_7 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MakeBeforeBreakIndicator')))
    ____SeNBReleaseRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'reject'), ('Value', _____SeNBReleaseRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 112), ('criticality', 'reject'), ('Value', _____SeNBReleaseRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _____SeNBReleaseRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 137), ('criticality', 'ignore'), ('Value', _____SeNBReleaseRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 154), ('criticality', 'ignore'), ('Value', _____SeNBReleaseRequest_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 157), ('criticality', 'reject'), ('Value', _____SeNBReleaseRequest_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 158), ('criticality', 'reject'), ('Value', _____SeNBReleaseRequest_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 181), ('criticality', 'ignore'), ('Value', _____SeNBReleaseRequest_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SeNBReleaseRequest_protocolIEs__item__id._const_tab = ____SeNBReleaseRequest_protocolIEs__item__id_tab
    ___SeNBReleaseRequest_protocolIEs__item__id._const_tab_at = None
    ___SeNBReleaseRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___SeNBReleaseRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___SeNBReleaseRequest_protocolIEs__item__criticality._const_tab = ____SeNBReleaseRequest_protocolIEs__item__id_tab
    ___SeNBReleaseRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___SeNBReleaseRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___SeNBReleaseRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___SeNBReleaseRequest_protocolIEs__item__value._const_tab = ____SeNBReleaseRequest_protocolIEs__item__id_tab
    ___SeNBReleaseRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___SeNBReleaseRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __SeNBReleaseRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___SeNBReleaseRequest_protocolIEs__item__id),
        ('criticality', ___SeNBReleaseRequest_protocolIEs__item__criticality),
        ('value', ___SeNBReleaseRequest_protocolIEs__item__value),
        ])
    __SeNBReleaseRequest_protocolIEs__item_._ext = None
    _SeNBReleaseRequest_protocolIEs._cont = __SeNBReleaseRequest_protocolIEs__item_
    _SeNBReleaseRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    SeNBReleaseRequest._cont = ASN1Dict([
        ('protocolIEs', _SeNBReleaseRequest_protocolIEs),
        ])
    SeNBReleaseRequest._ext = []
    
    #-----< SeNBReleaseRequest-IEs >-----#
    SeNBReleaseRequest_IEs = CLASS(name='SeNBReleaseRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _SeNBReleaseRequest_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SeNBReleaseRequest_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SeNBReleaseRequest_IEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _SeNBReleaseRequest_IEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-List-RelReq')))
    _SeNBReleaseRequest_IEs_val_Value_4 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-ContextKeptIndicator')))
    _SeNBReleaseRequest_IEs_val_Value_5 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _SeNBReleaseRequest_IEs_val_Value_6 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _SeNBReleaseRequest_IEs_val_Value_7 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MakeBeforeBreakIndicator')))
    SeNBReleaseRequest_IEs._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'reject'), ('Value', _SeNBReleaseRequest_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 112), ('criticality', 'reject'), ('Value', _SeNBReleaseRequest_IEs_val_Value_1), ('presence', 'optional')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _SeNBReleaseRequest_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 137), ('criticality', 'ignore'), ('Value', _SeNBReleaseRequest_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 154), ('criticality', 'ignore'), ('Value', _SeNBReleaseRequest_IEs_val_Value_4), ('presence', 'optional')]), dict([('id', 157), ('criticality', 'reject'), ('Value', _SeNBReleaseRequest_IEs_val_Value_5), ('presence', 'optional')]), dict([('id', 158), ('criticality', 'reject'), ('Value', _SeNBReleaseRequest_IEs_val_Value_6), ('presence', 'optional')]), dict([('id', 181), ('criticality', 'ignore'), ('Value', _SeNBReleaseRequest_IEs_val_Value_7), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeReleased-List-RelReq >-----#
    E_RABs_ToBeReleased_List_RelReq = SEQ_OF(name='E-RABs-ToBeReleased-List-RelReq', mode=MODE_TYPE)
    _E_RABs_ToBeReleased_List_RelReq__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __E_RABs_ToBeReleased_List_RelReq__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ___E_RABs_ToBeReleased_List_RelReq__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____E_RABs_ToBeReleased_List_RelReq__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-RelReqItem')))
    ___E_RABs_ToBeReleased_List_RelReq__item__id_tab._val = ASN1Set(rv=[dict([('id', 138), ('criticality', 'ignore'), ('Value', ____E_RABs_ToBeReleased_List_RelReq__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E_RABs_ToBeReleased_List_RelReq__item__id._const_tab = ___E_RABs_ToBeReleased_List_RelReq__item__id_tab
    __E_RABs_ToBeReleased_List_RelReq__item__id._const_tab_at = None
    __E_RABs_ToBeReleased_List_RelReq__item__id._const_tab_id = 'id'
    __E_RABs_ToBeReleased_List_RelReq__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    __E_RABs_ToBeReleased_List_RelReq__item__criticality._const_tab = ___E_RABs_ToBeReleased_List_RelReq__item__id_tab
    __E_RABs_ToBeReleased_List_RelReq__item__criticality._const_tab_at = ('..', 'id')
    __E_RABs_ToBeReleased_List_RelReq__item__criticality._const_tab_id = 'criticality'
    __E_RABs_ToBeReleased_List_RelReq__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    __E_RABs_ToBeReleased_List_RelReq__item__value._const_tab = ___E_RABs_ToBeReleased_List_RelReq__item__id_tab
    __E_RABs_ToBeReleased_List_RelReq__item__value._const_tab_at = ('..', 'id')
    __E_RABs_ToBeReleased_List_RelReq__item__value._const_tab_id = 'Value'
    _E_RABs_ToBeReleased_List_RelReq__item_._cont = ASN1Dict([
        ('id', __E_RABs_ToBeReleased_List_RelReq__item__id),
        ('criticality', __E_RABs_ToBeReleased_List_RelReq__item__criticality),
        ('value', __E_RABs_ToBeReleased_List_RelReq__item__value),
        ])
    _E_RABs_ToBeReleased_List_RelReq__item_._ext = None
    E_RABs_ToBeReleased_List_RelReq._cont = _E_RABs_ToBeReleased_List_RelReq__item_
    E_RABs_ToBeReleased_List_RelReq._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABs-ToBeReleased-RelReqItemIEs >-----#
    E_RABs_ToBeReleased_RelReqItemIEs = CLASS(name='E-RABs-ToBeReleased-RelReqItemIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _E_RABs_ToBeReleased_RelReqItemIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-RelReqItem')))
    E_RABs_ToBeReleased_RelReqItemIEs._val = ASN1Set(rv=[dict([('id', 138), ('criticality', 'ignore'), ('Value', _E_RABs_ToBeReleased_RelReqItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeReleased-RelReqItem >-----#
    E_RABs_ToBeReleased_RelReqItem = CHOICE(name='E-RABs-ToBeReleased-RelReqItem', mode=MODE_TYPE)
    _E_RABs_ToBeReleased_RelReqItem_sCG_Bearer = SEQ(name='sCG-Bearer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-RelReqItem-SCG-Bearer')))
    _E_RABs_ToBeReleased_RelReqItem_split_Bearer = SEQ(name='split-Bearer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-RelReqItem-Split-Bearer')))
    E_RABs_ToBeReleased_RelReqItem._cont = ASN1Dict([
        ('sCG-Bearer', _E_RABs_ToBeReleased_RelReqItem_sCG_Bearer),
        ('split-Bearer', _E_RABs_ToBeReleased_RelReqItem_split_Bearer),
        ])
    E_RABs_ToBeReleased_RelReqItem._ext = []
    
    #-----< E-RABs-ToBeReleased-RelReqItem-SCG-Bearer >-----#
    E_RABs_ToBeReleased_RelReqItem_SCG_Bearer = SEQ(name='E-RABs-ToBeReleased-RelReqItem-SCG-Bearer', mode=MODE_TYPE)
    _E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_uL_Forwarding_GTPtunnelEndpoint = SEQ(name='uL-Forwarding-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_dL_Forwarding_GTPtunnelEndpoint = SEQ(name='dL-Forwarding-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions__item__id._const_tab = ____E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions__item__criticality._const_tab = ____E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions__item__criticality_tab
    ___E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions__item__extensionValue_tab
    ___E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions__item__id),
        ('criticality', ___E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions__item_._ext = None
    _E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions._cont = __E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions__item_
    _E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_ToBeReleased_RelReqItem_SCG_Bearer._cont = ASN1Dict([
        ('e-RAB-ID', _E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_e_RAB_ID),
        ('uL-Forwarding-GTPtunnelEndpoint', _E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_uL_Forwarding_GTPtunnelEndpoint),
        ('dL-Forwarding-GTPtunnelEndpoint', _E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_dL_Forwarding_GTPtunnelEndpoint),
        ('iE-Extensions', _E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions),
        ])
    E_RABs_ToBeReleased_RelReqItem_SCG_Bearer._ext = []
    
    #-----< E-RABs-ToBeReleased-RelReqItem-SCG-BearerExtIEs >-----#
    E_RABs_ToBeReleased_RelReqItem_SCG_BearerExtIEs = CLASS(name='E-RABs-ToBeReleased-RelReqItem-SCG-BearerExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    E_RABs_ToBeReleased_RelReqItem_SCG_BearerExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeReleased-RelReqItem-Split-Bearer >-----#
    E_RABs_ToBeReleased_RelReqItem_Split_Bearer = SEQ(name='E-RABs-ToBeReleased-RelReqItem-Split-Bearer', mode=MODE_TYPE)
    _E_RABs_ToBeReleased_RelReqItem_Split_Bearer_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_ToBeReleased_RelReqItem_Split_Bearer_dL_Forwarding_GTPtunnelEndpoint = SEQ(name='dL-Forwarding-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions__item__id._const_tab = ____E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions__item__criticality._const_tab = ____E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions__item__criticality_tab
    ___E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions__item__extensionValue_tab
    ___E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions__item__id),
        ('criticality', ___E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions__item_._ext = None
    _E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions._cont = __E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions__item_
    _E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_ToBeReleased_RelReqItem_Split_Bearer._cont = ASN1Dict([
        ('e-RAB-ID', _E_RABs_ToBeReleased_RelReqItem_Split_Bearer_e_RAB_ID),
        ('dL-Forwarding-GTPtunnelEndpoint', _E_RABs_ToBeReleased_RelReqItem_Split_Bearer_dL_Forwarding_GTPtunnelEndpoint),
        ('iE-Extensions', _E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions),
        ])
    E_RABs_ToBeReleased_RelReqItem_Split_Bearer._ext = []
    
    #-----< E-RABs-ToBeReleased-RelReqItem-Split-BearerExtIEs >-----#
    E_RABs_ToBeReleased_RelReqItem_Split_BearerExtIEs = CLASS(name='E-RABs-ToBeReleased-RelReqItem-Split-BearerExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    E_RABs_ToBeReleased_RelReqItem_Split_BearerExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SeNBReleaseRequired >-----#
    SeNBReleaseRequired = SEQ(name='SeNBReleaseRequired', mode=MODE_TYPE)
    _SeNBReleaseRequired_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __SeNBReleaseRequired_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___SeNBReleaseRequired_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____SeNBReleaseRequired_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____SeNBReleaseRequired_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SeNBReleaseRequired_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SeNBReleaseRequired_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _____SeNBReleaseRequired_protocolIEs__item__id_tab_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____SeNBReleaseRequired_protocolIEs__item__id_tab_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    ____SeNBReleaseRequired_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'reject'), ('Value', _____SeNBReleaseRequired_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 112), ('criticality', 'reject'), ('Value', _____SeNBReleaseRequired_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _____SeNBReleaseRequired_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 157), ('criticality', 'reject'), ('Value', _____SeNBReleaseRequired_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 158), ('criticality', 'reject'), ('Value', _____SeNBReleaseRequired_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SeNBReleaseRequired_protocolIEs__item__id._const_tab = ____SeNBReleaseRequired_protocolIEs__item__id_tab
    ___SeNBReleaseRequired_protocolIEs__item__id._const_tab_at = None
    ___SeNBReleaseRequired_protocolIEs__item__id._const_tab_id = 'id'
    ___SeNBReleaseRequired_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___SeNBReleaseRequired_protocolIEs__item__criticality._const_tab = ____SeNBReleaseRequired_protocolIEs__item__id_tab
    ___SeNBReleaseRequired_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___SeNBReleaseRequired_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___SeNBReleaseRequired_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___SeNBReleaseRequired_protocolIEs__item__value._const_tab = ____SeNBReleaseRequired_protocolIEs__item__id_tab
    ___SeNBReleaseRequired_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___SeNBReleaseRequired_protocolIEs__item__value._const_tab_id = 'Value'
    __SeNBReleaseRequired_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___SeNBReleaseRequired_protocolIEs__item__id),
        ('criticality', ___SeNBReleaseRequired_protocolIEs__item__criticality),
        ('value', ___SeNBReleaseRequired_protocolIEs__item__value),
        ])
    __SeNBReleaseRequired_protocolIEs__item_._ext = None
    _SeNBReleaseRequired_protocolIEs._cont = __SeNBReleaseRequired_protocolIEs__item_
    _SeNBReleaseRequired_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    SeNBReleaseRequired._cont = ASN1Dict([
        ('protocolIEs', _SeNBReleaseRequired_protocolIEs),
        ])
    SeNBReleaseRequired._ext = []
    
    #-----< SeNBReleaseRequired-IEs >-----#
    SeNBReleaseRequired_IEs = CLASS(name='SeNBReleaseRequired-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _SeNBReleaseRequired_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SeNBReleaseRequired_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SeNBReleaseRequired_IEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _SeNBReleaseRequired_IEs_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _SeNBReleaseRequired_IEs_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    SeNBReleaseRequired_IEs._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'reject'), ('Value', _SeNBReleaseRequired_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 112), ('criticality', 'reject'), ('Value', _SeNBReleaseRequired_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _SeNBReleaseRequired_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 157), ('criticality', 'reject'), ('Value', _SeNBReleaseRequired_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 158), ('criticality', 'reject'), ('Value', _SeNBReleaseRequired_IEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< SeNBReleaseConfirm >-----#
    SeNBReleaseConfirm = SEQ(name='SeNBReleaseConfirm', mode=MODE_TYPE)
    _SeNBReleaseConfirm_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __SeNBReleaseConfirm_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___SeNBReleaseConfirm_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____SeNBReleaseConfirm_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____SeNBReleaseConfirm_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SeNBReleaseConfirm_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SeNBReleaseConfirm_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-List-RelConf')))
    _____SeNBReleaseConfirm_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _____SeNBReleaseConfirm_protocolIEs__item__id_tab_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____SeNBReleaseConfirm_protocolIEs__item__id_tab_val_Value_5 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    ____SeNBReleaseConfirm_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'ignore'), ('Value', _____SeNBReleaseConfirm_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 112), ('criticality', 'ignore'), ('Value', _____SeNBReleaseConfirm_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 139), ('criticality', 'ignore'), ('Value', _____SeNBReleaseConfirm_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _____SeNBReleaseConfirm_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 157), ('criticality', 'ignore'), ('Value', _____SeNBReleaseConfirm_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 158), ('criticality', 'ignore'), ('Value', _____SeNBReleaseConfirm_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SeNBReleaseConfirm_protocolIEs__item__id._const_tab = ____SeNBReleaseConfirm_protocolIEs__item__id_tab
    ___SeNBReleaseConfirm_protocolIEs__item__id._const_tab_at = None
    ___SeNBReleaseConfirm_protocolIEs__item__id._const_tab_id = 'id'
    ___SeNBReleaseConfirm_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___SeNBReleaseConfirm_protocolIEs__item__criticality._const_tab = ____SeNBReleaseConfirm_protocolIEs__item__id_tab
    ___SeNBReleaseConfirm_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___SeNBReleaseConfirm_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___SeNBReleaseConfirm_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___SeNBReleaseConfirm_protocolIEs__item__value._const_tab = ____SeNBReleaseConfirm_protocolIEs__item__id_tab
    ___SeNBReleaseConfirm_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___SeNBReleaseConfirm_protocolIEs__item__value._const_tab_id = 'Value'
    __SeNBReleaseConfirm_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___SeNBReleaseConfirm_protocolIEs__item__id),
        ('criticality', ___SeNBReleaseConfirm_protocolIEs__item__criticality),
        ('value', ___SeNBReleaseConfirm_protocolIEs__item__value),
        ])
    __SeNBReleaseConfirm_protocolIEs__item_._ext = None
    _SeNBReleaseConfirm_protocolIEs._cont = __SeNBReleaseConfirm_protocolIEs__item_
    _SeNBReleaseConfirm_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    SeNBReleaseConfirm._cont = ASN1Dict([
        ('protocolIEs', _SeNBReleaseConfirm_protocolIEs),
        ])
    SeNBReleaseConfirm._ext = []
    
    #-----< SeNBReleaseConfirm-IEs >-----#
    SeNBReleaseConfirm_IEs = CLASS(name='SeNBReleaseConfirm-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _SeNBReleaseConfirm_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SeNBReleaseConfirm_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SeNBReleaseConfirm_IEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-List-RelConf')))
    _SeNBReleaseConfirm_IEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _SeNBReleaseConfirm_IEs_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _SeNBReleaseConfirm_IEs_val_Value_5 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    SeNBReleaseConfirm_IEs._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'ignore'), ('Value', _SeNBReleaseConfirm_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 112), ('criticality', 'ignore'), ('Value', _SeNBReleaseConfirm_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 139), ('criticality', 'ignore'), ('Value', _SeNBReleaseConfirm_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _SeNBReleaseConfirm_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 157), ('criticality', 'ignore'), ('Value', _SeNBReleaseConfirm_IEs_val_Value_4), ('presence', 'optional')]), dict([('id', 158), ('criticality', 'ignore'), ('Value', _SeNBReleaseConfirm_IEs_val_Value_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeReleased-List-RelConf >-----#
    E_RABs_ToBeReleased_List_RelConf = SEQ_OF(name='E-RABs-ToBeReleased-List-RelConf', mode=MODE_TYPE)
    _E_RABs_ToBeReleased_List_RelConf__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __E_RABs_ToBeReleased_List_RelConf__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ___E_RABs_ToBeReleased_List_RelConf__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____E_RABs_ToBeReleased_List_RelConf__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-RelConfItem')))
    ___E_RABs_ToBeReleased_List_RelConf__item__id_tab._val = ASN1Set(rv=[dict([('id', 140), ('criticality', 'ignore'), ('Value', ____E_RABs_ToBeReleased_List_RelConf__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E_RABs_ToBeReleased_List_RelConf__item__id._const_tab = ___E_RABs_ToBeReleased_List_RelConf__item__id_tab
    __E_RABs_ToBeReleased_List_RelConf__item__id._const_tab_at = None
    __E_RABs_ToBeReleased_List_RelConf__item__id._const_tab_id = 'id'
    __E_RABs_ToBeReleased_List_RelConf__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    __E_RABs_ToBeReleased_List_RelConf__item__criticality._const_tab = ___E_RABs_ToBeReleased_List_RelConf__item__id_tab
    __E_RABs_ToBeReleased_List_RelConf__item__criticality._const_tab_at = ('..', 'id')
    __E_RABs_ToBeReleased_List_RelConf__item__criticality._const_tab_id = 'criticality'
    __E_RABs_ToBeReleased_List_RelConf__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    __E_RABs_ToBeReleased_List_RelConf__item__value._const_tab = ___E_RABs_ToBeReleased_List_RelConf__item__id_tab
    __E_RABs_ToBeReleased_List_RelConf__item__value._const_tab_at = ('..', 'id')
    __E_RABs_ToBeReleased_List_RelConf__item__value._const_tab_id = 'Value'
    _E_RABs_ToBeReleased_List_RelConf__item_._cont = ASN1Dict([
        ('id', __E_RABs_ToBeReleased_List_RelConf__item__id),
        ('criticality', __E_RABs_ToBeReleased_List_RelConf__item__criticality),
        ('value', __E_RABs_ToBeReleased_List_RelConf__item__value),
        ])
    _E_RABs_ToBeReleased_List_RelConf__item_._ext = None
    E_RABs_ToBeReleased_List_RelConf._cont = _E_RABs_ToBeReleased_List_RelConf__item_
    E_RABs_ToBeReleased_List_RelConf._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABs-ToBeReleased-RelConfItemIEs >-----#
    E_RABs_ToBeReleased_RelConfItemIEs = CLASS(name='E-RABs-ToBeReleased-RelConfItemIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _E_RABs_ToBeReleased_RelConfItemIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-RelConfItem')))
    E_RABs_ToBeReleased_RelConfItemIEs._val = ASN1Set(rv=[dict([('id', 140), ('criticality', 'ignore'), ('Value', _E_RABs_ToBeReleased_RelConfItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeReleased-RelConfItem >-----#
    E_RABs_ToBeReleased_RelConfItem = CHOICE(name='E-RABs-ToBeReleased-RelConfItem', mode=MODE_TYPE)
    _E_RABs_ToBeReleased_RelConfItem_sCG_Bearer = SEQ(name='sCG-Bearer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-RelConfItem-SCG-Bearer')))
    _E_RABs_ToBeReleased_RelConfItem_split_Bearer = SEQ(name='split-Bearer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-RelConfItem-Split-Bearer')))
    E_RABs_ToBeReleased_RelConfItem._cont = ASN1Dict([
        ('sCG-Bearer', _E_RABs_ToBeReleased_RelConfItem_sCG_Bearer),
        ('split-Bearer', _E_RABs_ToBeReleased_RelConfItem_split_Bearer),
        ])
    E_RABs_ToBeReleased_RelConfItem._ext = []
    
    #-----< E-RABs-ToBeReleased-RelConfItem-SCG-Bearer >-----#
    E_RABs_ToBeReleased_RelConfItem_SCG_Bearer = SEQ(name='E-RABs-ToBeReleased-RelConfItem-SCG-Bearer', mode=MODE_TYPE)
    _E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_uL_Forwarding_GTPtunnelEndpoint = SEQ(name='uL-Forwarding-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_dL_Forwarding_GTPtunnelEndpoint = SEQ(name='dL-Forwarding-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions__item__id._const_tab = ____E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions__item__criticality._const_tab = ____E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions__item__criticality_tab
    ___E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions__item__extensionValue_tab
    ___E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions__item__id),
        ('criticality', ___E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions__item_._ext = None
    _E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions._cont = __E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions__item_
    _E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_ToBeReleased_RelConfItem_SCG_Bearer._cont = ASN1Dict([
        ('e-RAB-ID', _E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_e_RAB_ID),
        ('uL-Forwarding-GTPtunnelEndpoint', _E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_uL_Forwarding_GTPtunnelEndpoint),
        ('dL-Forwarding-GTPtunnelEndpoint', _E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_dL_Forwarding_GTPtunnelEndpoint),
        ('iE-Extensions', _E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions),
        ])
    E_RABs_ToBeReleased_RelConfItem_SCG_Bearer._ext = []
    
    #-----< E-RABs-ToBeReleased-RelConfItem-SCG-BearerExtIEs >-----#
    E_RABs_ToBeReleased_RelConfItem_SCG_BearerExtIEs = CLASS(name='E-RABs-ToBeReleased-RelConfItem-SCG-BearerExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    E_RABs_ToBeReleased_RelConfItem_SCG_BearerExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeReleased-RelConfItem-Split-Bearer >-----#
    E_RABs_ToBeReleased_RelConfItem_Split_Bearer = SEQ(name='E-RABs-ToBeReleased-RelConfItem-Split-Bearer', mode=MODE_TYPE)
    _E_RABs_ToBeReleased_RelConfItem_Split_Bearer_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_ToBeReleased_RelConfItem_Split_Bearer_dL_Forwarding_GTPtunnelEndpoint = SEQ(name='dL-Forwarding-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions__item__id._const_tab = ____E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions__item__id_tab
    ___E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions__item__criticality._const_tab = ____E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions__item__criticality_tab
    ___E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions__item__extensionValue_tab
    ___E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions__item__id),
        ('criticality', ___E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions__item_._ext = None
    _E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions._cont = __E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions__item_
    _E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_ToBeReleased_RelConfItem_Split_Bearer._cont = ASN1Dict([
        ('e-RAB-ID', _E_RABs_ToBeReleased_RelConfItem_Split_Bearer_e_RAB_ID),
        ('dL-Forwarding-GTPtunnelEndpoint', _E_RABs_ToBeReleased_RelConfItem_Split_Bearer_dL_Forwarding_GTPtunnelEndpoint),
        ('iE-Extensions', _E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions),
        ])
    E_RABs_ToBeReleased_RelConfItem_Split_Bearer._ext = []
    
    #-----< E-RABs-ToBeReleased-RelConfItem-Split-BearerExtIEs >-----#
    E_RABs_ToBeReleased_RelConfItem_Split_BearerExtIEs = CLASS(name='E-RABs-ToBeReleased-RelConfItem-Split-BearerExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    E_RABs_ToBeReleased_RelConfItem_Split_BearerExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SeNBCounterCheckRequest >-----#
    SeNBCounterCheckRequest = SEQ(name='SeNBCounterCheckRequest', mode=MODE_TYPE)
    _SeNBCounterCheckRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __SeNBCounterCheckRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___SeNBCounterCheckRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____SeNBCounterCheckRequest_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____SeNBCounterCheckRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SeNBCounterCheckRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SeNBCounterCheckRequest_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-SubjectToCounterCheck-List')))
    _____SeNBCounterCheckRequest_protocolIEs__item__id_tab_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____SeNBCounterCheckRequest_protocolIEs__item__id_tab_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    ____SeNBCounterCheckRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'reject'), ('Value', _____SeNBCounterCheckRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 112), ('criticality', 'reject'), ('Value', _____SeNBCounterCheckRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 141), ('criticality', 'ignore'), ('Value', _____SeNBCounterCheckRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 157), ('criticality', 'ignore'), ('Value', _____SeNBCounterCheckRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 158), ('criticality', 'ignore'), ('Value', _____SeNBCounterCheckRequest_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SeNBCounterCheckRequest_protocolIEs__item__id._const_tab = ____SeNBCounterCheckRequest_protocolIEs__item__id_tab
    ___SeNBCounterCheckRequest_protocolIEs__item__id._const_tab_at = None
    ___SeNBCounterCheckRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___SeNBCounterCheckRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___SeNBCounterCheckRequest_protocolIEs__item__criticality._const_tab = ____SeNBCounterCheckRequest_protocolIEs__item__id_tab
    ___SeNBCounterCheckRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___SeNBCounterCheckRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___SeNBCounterCheckRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___SeNBCounterCheckRequest_protocolIEs__item__value._const_tab = ____SeNBCounterCheckRequest_protocolIEs__item__id_tab
    ___SeNBCounterCheckRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___SeNBCounterCheckRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __SeNBCounterCheckRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___SeNBCounterCheckRequest_protocolIEs__item__id),
        ('criticality', ___SeNBCounterCheckRequest_protocolIEs__item__criticality),
        ('value', ___SeNBCounterCheckRequest_protocolIEs__item__value),
        ])
    __SeNBCounterCheckRequest_protocolIEs__item_._ext = None
    _SeNBCounterCheckRequest_protocolIEs._cont = __SeNBCounterCheckRequest_protocolIEs__item_
    _SeNBCounterCheckRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    SeNBCounterCheckRequest._cont = ASN1Dict([
        ('protocolIEs', _SeNBCounterCheckRequest_protocolIEs),
        ])
    SeNBCounterCheckRequest._ext = []
    
    #-----< SeNBCounterCheckRequest-IEs >-----#
    SeNBCounterCheckRequest_IEs = CLASS(name='SeNBCounterCheckRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _SeNBCounterCheckRequest_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SeNBCounterCheckRequest_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SeNBCounterCheckRequest_IEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-SubjectToCounterCheck-List')))
    _SeNBCounterCheckRequest_IEs_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _SeNBCounterCheckRequest_IEs_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    SeNBCounterCheckRequest_IEs._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'reject'), ('Value', _SeNBCounterCheckRequest_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 112), ('criticality', 'reject'), ('Value', _SeNBCounterCheckRequest_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 141), ('criticality', 'ignore'), ('Value', _SeNBCounterCheckRequest_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 157), ('criticality', 'ignore'), ('Value', _SeNBCounterCheckRequest_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 158), ('criticality', 'ignore'), ('Value', _SeNBCounterCheckRequest_IEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-SubjectToCounterCheck-List >-----#
    E_RABs_SubjectToCounterCheck_List = SEQ_OF(name='E-RABs-SubjectToCounterCheck-List', mode=MODE_TYPE)
    _E_RABs_SubjectToCounterCheck_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __E_RABs_SubjectToCounterCheck_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ___E_RABs_SubjectToCounterCheck_List__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____E_RABs_SubjectToCounterCheck_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-SubjectToCounterCheckItem')))
    ___E_RABs_SubjectToCounterCheck_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 142), ('criticality', 'ignore'), ('Value', ____E_RABs_SubjectToCounterCheck_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E_RABs_SubjectToCounterCheck_List__item__id._const_tab = ___E_RABs_SubjectToCounterCheck_List__item__id_tab
    __E_RABs_SubjectToCounterCheck_List__item__id._const_tab_at = None
    __E_RABs_SubjectToCounterCheck_List__item__id._const_tab_id = 'id'
    __E_RABs_SubjectToCounterCheck_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    __E_RABs_SubjectToCounterCheck_List__item__criticality._const_tab = ___E_RABs_SubjectToCounterCheck_List__item__id_tab
    __E_RABs_SubjectToCounterCheck_List__item__criticality._const_tab_at = ('..', 'id')
    __E_RABs_SubjectToCounterCheck_List__item__criticality._const_tab_id = 'criticality'
    __E_RABs_SubjectToCounterCheck_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    __E_RABs_SubjectToCounterCheck_List__item__value._const_tab = ___E_RABs_SubjectToCounterCheck_List__item__id_tab
    __E_RABs_SubjectToCounterCheck_List__item__value._const_tab_at = ('..', 'id')
    __E_RABs_SubjectToCounterCheck_List__item__value._const_tab_id = 'Value'
    _E_RABs_SubjectToCounterCheck_List__item_._cont = ASN1Dict([
        ('id', __E_RABs_SubjectToCounterCheck_List__item__id),
        ('criticality', __E_RABs_SubjectToCounterCheck_List__item__criticality),
        ('value', __E_RABs_SubjectToCounterCheck_List__item__value),
        ])
    _E_RABs_SubjectToCounterCheck_List__item_._ext = None
    E_RABs_SubjectToCounterCheck_List._cont = _E_RABs_SubjectToCounterCheck_List__item_
    E_RABs_SubjectToCounterCheck_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABs-SubjectToCounterCheckItemIEs >-----#
    E_RABs_SubjectToCounterCheckItemIEs = CLASS(name='E-RABs-SubjectToCounterCheckItemIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _E_RABs_SubjectToCounterCheckItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-SubjectToCounterCheckItem')))
    E_RABs_SubjectToCounterCheckItemIEs._val = ASN1Set(rv=[dict([('id', 142), ('criticality', 'ignore'), ('Value', _E_RABs_SubjectToCounterCheckItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-SubjectToCounterCheckItem >-----#
    E_RABs_SubjectToCounterCheckItem = SEQ(name='E-RABs-SubjectToCounterCheckItem', mode=MODE_TYPE)
    _E_RABs_SubjectToCounterCheckItem_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_SubjectToCounterCheckItem_uL_Count = INT(name='uL-Count', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _E_RABs_SubjectToCounterCheckItem_uL_Count._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    _E_RABs_SubjectToCounterCheckItem_dL_Count = INT(name='dL-Count', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _E_RABs_SubjectToCounterCheckItem_dL_Count._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    _E_RABs_SubjectToCounterCheckItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_SubjectToCounterCheckItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_SubjectToCounterCheckItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_SubjectToCounterCheckItem_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_SubjectToCounterCheckItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_SubjectToCounterCheckItem_iE_Extensions__item__id._const_tab = ____E_RABs_SubjectToCounterCheckItem_iE_Extensions__item__id_tab
    ___E_RABs_SubjectToCounterCheckItem_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_SubjectToCounterCheckItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_SubjectToCounterCheckItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_RABs_SubjectToCounterCheckItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_SubjectToCounterCheckItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_SubjectToCounterCheckItem_iE_Extensions__item__criticality._const_tab = ____E_RABs_SubjectToCounterCheckItem_iE_Extensions__item__criticality_tab
    ___E_RABs_SubjectToCounterCheckItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_SubjectToCounterCheckItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_SubjectToCounterCheckItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_RABs_SubjectToCounterCheckItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_SubjectToCounterCheckItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_SubjectToCounterCheckItem_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_SubjectToCounterCheckItem_iE_Extensions__item__extensionValue_tab
    ___E_RABs_SubjectToCounterCheckItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_SubjectToCounterCheckItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_SubjectToCounterCheckItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_SubjectToCounterCheckItem_iE_Extensions__item__id),
        ('criticality', ___E_RABs_SubjectToCounterCheckItem_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_SubjectToCounterCheckItem_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_SubjectToCounterCheckItem_iE_Extensions__item_._ext = None
    _E_RABs_SubjectToCounterCheckItem_iE_Extensions._cont = __E_RABs_SubjectToCounterCheckItem_iE_Extensions__item_
    _E_RABs_SubjectToCounterCheckItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_SubjectToCounterCheckItem._cont = ASN1Dict([
        ('e-RAB-ID', _E_RABs_SubjectToCounterCheckItem_e_RAB_ID),
        ('uL-Count', _E_RABs_SubjectToCounterCheckItem_uL_Count),
        ('dL-Count', _E_RABs_SubjectToCounterCheckItem_dL_Count),
        ('iE-Extensions', _E_RABs_SubjectToCounterCheckItem_iE_Extensions),
        ])
    E_RABs_SubjectToCounterCheckItem._ext = []
    
    #-----< E-RABs-SubjectToCounterCheckItemExtIEs >-----#
    E_RABs_SubjectToCounterCheckItemExtIEs = CLASS(name='E-RABs-SubjectToCounterCheckItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    E_RABs_SubjectToCounterCheckItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< X2RemovalRequest >-----#
    X2RemovalRequest = SEQ(name='X2RemovalRequest', mode=MODE_TYPE)
    _X2RemovalRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __X2RemovalRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___X2RemovalRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____X2RemovalRequest_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____X2RemovalRequest_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GlobalENB-ID')))
    _____X2RemovalRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'X2BenefitValue')))
    ____X2RemovalRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 21), ('criticality', 'reject'), ('Value', _____X2RemovalRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 169), ('criticality', 'reject'), ('Value', _____X2RemovalRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___X2RemovalRequest_protocolIEs__item__id._const_tab = ____X2RemovalRequest_protocolIEs__item__id_tab
    ___X2RemovalRequest_protocolIEs__item__id._const_tab_at = None
    ___X2RemovalRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___X2RemovalRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___X2RemovalRequest_protocolIEs__item__criticality._const_tab = ____X2RemovalRequest_protocolIEs__item__id_tab
    ___X2RemovalRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___X2RemovalRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___X2RemovalRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___X2RemovalRequest_protocolIEs__item__value._const_tab = ____X2RemovalRequest_protocolIEs__item__id_tab
    ___X2RemovalRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___X2RemovalRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __X2RemovalRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___X2RemovalRequest_protocolIEs__item__id),
        ('criticality', ___X2RemovalRequest_protocolIEs__item__criticality),
        ('value', ___X2RemovalRequest_protocolIEs__item__value),
        ])
    __X2RemovalRequest_protocolIEs__item_._ext = None
    _X2RemovalRequest_protocolIEs._cont = __X2RemovalRequest_protocolIEs__item_
    _X2RemovalRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    X2RemovalRequest._cont = ASN1Dict([
        ('protocolIEs', _X2RemovalRequest_protocolIEs),
        ])
    X2RemovalRequest._ext = []
    
    #-----< X2RemovalRequest-IEs >-----#
    X2RemovalRequest_IEs = CLASS(name='X2RemovalRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _X2RemovalRequest_IEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GlobalENB-ID')))
    _X2RemovalRequest_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'X2BenefitValue')))
    X2RemovalRequest_IEs._val = ASN1Set(rv=[dict([('id', 21), ('criticality', 'reject'), ('Value', _X2RemovalRequest_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 169), ('criticality', 'reject'), ('Value', _X2RemovalRequest_IEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< X2RemovalResponse >-----#
    X2RemovalResponse = SEQ(name='X2RemovalResponse', mode=MODE_TYPE)
    _X2RemovalResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __X2RemovalResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___X2RemovalResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____X2RemovalResponse_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____X2RemovalResponse_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GlobalENB-ID')))
    _____X2RemovalResponse_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    ____X2RemovalResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 21), ('criticality', 'reject'), ('Value', _____X2RemovalResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _____X2RemovalResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___X2RemovalResponse_protocolIEs__item__id._const_tab = ____X2RemovalResponse_protocolIEs__item__id_tab
    ___X2RemovalResponse_protocolIEs__item__id._const_tab_at = None
    ___X2RemovalResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___X2RemovalResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___X2RemovalResponse_protocolIEs__item__criticality._const_tab = ____X2RemovalResponse_protocolIEs__item__id_tab
    ___X2RemovalResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___X2RemovalResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___X2RemovalResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___X2RemovalResponse_protocolIEs__item__value._const_tab = ____X2RemovalResponse_protocolIEs__item__id_tab
    ___X2RemovalResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___X2RemovalResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __X2RemovalResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___X2RemovalResponse_protocolIEs__item__id),
        ('criticality', ___X2RemovalResponse_protocolIEs__item__criticality),
        ('value', ___X2RemovalResponse_protocolIEs__item__value),
        ])
    __X2RemovalResponse_protocolIEs__item_._ext = None
    _X2RemovalResponse_protocolIEs._cont = __X2RemovalResponse_protocolIEs__item_
    _X2RemovalResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    X2RemovalResponse._cont = ASN1Dict([
        ('protocolIEs', _X2RemovalResponse_protocolIEs),
        ])
    X2RemovalResponse._ext = []
    
    #-----< X2RemovalResponse-IEs >-----#
    X2RemovalResponse_IEs = CLASS(name='X2RemovalResponse-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _X2RemovalResponse_IEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GlobalENB-ID')))
    _X2RemovalResponse_IEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    X2RemovalResponse_IEs._val = ASN1Set(rv=[dict([('id', 21), ('criticality', 'reject'), ('Value', _X2RemovalResponse_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _X2RemovalResponse_IEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< X2RemovalFailure >-----#
    X2RemovalFailure = SEQ(name='X2RemovalFailure', mode=MODE_TYPE)
    _X2RemovalFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __X2RemovalFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___X2RemovalFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____X2RemovalFailure_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____X2RemovalFailure_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _____X2RemovalFailure_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    ____X2RemovalFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 5), ('criticality', 'ignore'), ('Value', _____X2RemovalFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _____X2RemovalFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___X2RemovalFailure_protocolIEs__item__id._const_tab = ____X2RemovalFailure_protocolIEs__item__id_tab
    ___X2RemovalFailure_protocolIEs__item__id._const_tab_at = None
    ___X2RemovalFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___X2RemovalFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___X2RemovalFailure_protocolIEs__item__criticality._const_tab = ____X2RemovalFailure_protocolIEs__item__id_tab
    ___X2RemovalFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___X2RemovalFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___X2RemovalFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___X2RemovalFailure_protocolIEs__item__value._const_tab = ____X2RemovalFailure_protocolIEs__item__id_tab
    ___X2RemovalFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___X2RemovalFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __X2RemovalFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___X2RemovalFailure_protocolIEs__item__id),
        ('criticality', ___X2RemovalFailure_protocolIEs__item__criticality),
        ('value', ___X2RemovalFailure_protocolIEs__item__value),
        ])
    __X2RemovalFailure_protocolIEs__item_._ext = None
    _X2RemovalFailure_protocolIEs._cont = __X2RemovalFailure_protocolIEs__item_
    _X2RemovalFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    X2RemovalFailure._cont = ASN1Dict([
        ('protocolIEs', _X2RemovalFailure_protocolIEs),
        ])
    X2RemovalFailure._ext = []
    
    #-----< X2RemovalFailure-IEs >-----#
    X2RemovalFailure_IEs = CLASS(name='X2RemovalFailure-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _X2RemovalFailure_IEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _X2RemovalFailure_IEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    X2RemovalFailure_IEs._val = ASN1Set(rv=[dict([('id', 5), ('criticality', 'ignore'), ('Value', _X2RemovalFailure_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _X2RemovalFailure_IEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RetrieveUEContextRequest >-----#
    RetrieveUEContextRequest = SEQ(name='RetrieveUEContextRequest', mode=MODE_TYPE)
    _RetrieveUEContextRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __RetrieveUEContextRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___RetrieveUEContextRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____RetrieveUEContextRequest_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____RetrieveUEContextRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____RetrieveUEContextRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____RetrieveUEContextRequest_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ResumeID')))
    _____RetrieveUEContextRequest_protocolIEs__item__id_tab_val_Value_3 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ShortMAC-I')))
    _____RetrieveUEContextRequest_protocolIEs__item__id_tab_val_Value_4 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'EUTRANCellIdentifier')))
    _____RetrieveUEContextRequest_protocolIEs__item__id_tab_val_Value_5 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CRNTI')))
    _____RetrieveUEContextRequest_protocolIEs__item__id_tab_val_Value_6 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PCI')))
    ____RetrieveUEContextRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 9), ('criticality', 'reject'), ('Value', _____RetrieveUEContextRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 158), ('criticality', 'reject'), ('Value', _____RetrieveUEContextRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 172), ('criticality', 'reject'), ('Value', _____RetrieveUEContextRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 51), ('criticality', 'reject'), ('Value', _____RetrieveUEContextRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 175), ('criticality', 'reject'), ('Value', _____RetrieveUEContextRequest_protocolIEs__item__id_tab_val_Value_4), ('presence', 'mandatory')]), dict([('id', 50), ('criticality', 'reject'), ('Value', _____RetrieveUEContextRequest_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 48), ('criticality', 'reject'), ('Value', _____RetrieveUEContextRequest_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RetrieveUEContextRequest_protocolIEs__item__id._const_tab = ____RetrieveUEContextRequest_protocolIEs__item__id_tab
    ___RetrieveUEContextRequest_protocolIEs__item__id._const_tab_at = None
    ___RetrieveUEContextRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___RetrieveUEContextRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___RetrieveUEContextRequest_protocolIEs__item__criticality._const_tab = ____RetrieveUEContextRequest_protocolIEs__item__id_tab
    ___RetrieveUEContextRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RetrieveUEContextRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RetrieveUEContextRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___RetrieveUEContextRequest_protocolIEs__item__value._const_tab = ____RetrieveUEContextRequest_protocolIEs__item__id_tab
    ___RetrieveUEContextRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RetrieveUEContextRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __RetrieveUEContextRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RetrieveUEContextRequest_protocolIEs__item__id),
        ('criticality', ___RetrieveUEContextRequest_protocolIEs__item__criticality),
        ('value', ___RetrieveUEContextRequest_protocolIEs__item__value),
        ])
    __RetrieveUEContextRequest_protocolIEs__item_._ext = None
    _RetrieveUEContextRequest_protocolIEs._cont = __RetrieveUEContextRequest_protocolIEs__item_
    _RetrieveUEContextRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RetrieveUEContextRequest._cont = ASN1Dict([
        ('protocolIEs', _RetrieveUEContextRequest_protocolIEs),
        ])
    RetrieveUEContextRequest._ext = []
    
    #-----< RetrieveUEContextRequest-IEs >-----#
    RetrieveUEContextRequest_IEs = CLASS(name='RetrieveUEContextRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _RetrieveUEContextRequest_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _RetrieveUEContextRequest_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _RetrieveUEContextRequest_IEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ResumeID')))
    _RetrieveUEContextRequest_IEs_val_Value_3 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ShortMAC-I')))
    _RetrieveUEContextRequest_IEs_val_Value_4 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'EUTRANCellIdentifier')))
    _RetrieveUEContextRequest_IEs_val_Value_5 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CRNTI')))
    _RetrieveUEContextRequest_IEs_val_Value_6 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PCI')))
    RetrieveUEContextRequest_IEs._val = ASN1Set(rv=[dict([('id', 9), ('criticality', 'reject'), ('Value', _RetrieveUEContextRequest_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 158), ('criticality', 'reject'), ('Value', _RetrieveUEContextRequest_IEs_val_Value_1), ('presence', 'optional')]), dict([('id', 172), ('criticality', 'reject'), ('Value', _RetrieveUEContextRequest_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 51), ('criticality', 'reject'), ('Value', _RetrieveUEContextRequest_IEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 175), ('criticality', 'reject'), ('Value', _RetrieveUEContextRequest_IEs_val_Value_4), ('presence', 'mandatory')]), dict([('id', 50), ('criticality', 'reject'), ('Value', _RetrieveUEContextRequest_IEs_val_Value_5), ('presence', 'optional')]), dict([('id', 48), ('criticality', 'reject'), ('Value', _RetrieveUEContextRequest_IEs_val_Value_6), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RetrieveUEContextResponse >-----#
    RetrieveUEContextResponse = SEQ(name='RetrieveUEContextResponse', mode=MODE_TYPE)
    _RetrieveUEContextResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __RetrieveUEContextResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___RetrieveUEContextResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____RetrieveUEContextResponse_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GUMMEI')))
    _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'UE-ContextInformationRetrieve')))
    _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TraceActivation')))
    _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_7 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SRVCCOperationPossible')))
    _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_8 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Masked-IMEISV')))
    _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_9 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ExpectedUEBehaviour')))
    _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_10 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ProSeAuthorized')))
    _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_11 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_12 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'V2XServicesAuthorized')))
    _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_13 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'AerialUEsubscriptionInformation')))
    _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_14 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Subscription-Based-UE-DifferentiationInfo')))
    _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_15 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'NRV2XServicesAuthorized')))
    _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_16 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PC5QoSParameters')))
    ____RetrieveUEContextResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 9), ('criticality', 'ignore'), ('Value', _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 155), ('criticality', 'ignore'), ('Value', _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 10), ('criticality', 'ignore'), ('Value', _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 156), ('criticality', 'ignore'), ('Value', _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 23), ('criticality', 'reject'), ('Value', _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_4), ('presence', 'mandatory')]), dict([('id', 173), ('criticality', 'reject'), ('Value', _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_5), ('presence', 'mandatory')]), dict([('id', 13), ('criticality', 'ignore'), ('Value', _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 36), ('criticality', 'ignore'), ('Value', _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')]), dict([('id', 98), ('criticality', 'ignore'), ('Value', _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_8), ('presence', 'optional')]), dict([('id', 104), ('criticality', 'ignore'), ('Value', _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_9), ('presence', 'optional')]), dict([('id', 103), ('criticality', 'ignore'), ('Value', _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_10), ('presence', 'optional')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_11), ('presence', 'optional')]), dict([('id', 176), ('criticality', 'ignore'), ('Value', _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_12), ('presence', 'optional')]), dict([('id', 277), ('criticality', 'ignore'), ('Value', _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_13), ('presence', 'optional')]), dict([('id', 309), ('criticality', 'ignore'), ('Value', _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_14), ('presence', 'optional')]), dict([('id', 370), ('criticality', 'ignore'), ('Value', _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_15), ('presence', 'optional')]), dict([('id', 372), ('criticality', 'ignore'), ('Value', _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_16), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RetrieveUEContextResponse_protocolIEs__item__id._const_tab = ____RetrieveUEContextResponse_protocolIEs__item__id_tab
    ___RetrieveUEContextResponse_protocolIEs__item__id._const_tab_at = None
    ___RetrieveUEContextResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___RetrieveUEContextResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___RetrieveUEContextResponse_protocolIEs__item__criticality._const_tab = ____RetrieveUEContextResponse_protocolIEs__item__id_tab
    ___RetrieveUEContextResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RetrieveUEContextResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RetrieveUEContextResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___RetrieveUEContextResponse_protocolIEs__item__value._const_tab = ____RetrieveUEContextResponse_protocolIEs__item__id_tab
    ___RetrieveUEContextResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RetrieveUEContextResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __RetrieveUEContextResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RetrieveUEContextResponse_protocolIEs__item__id),
        ('criticality', ___RetrieveUEContextResponse_protocolIEs__item__criticality),
        ('value', ___RetrieveUEContextResponse_protocolIEs__item__value),
        ])
    __RetrieveUEContextResponse_protocolIEs__item_._ext = None
    _RetrieveUEContextResponse_protocolIEs._cont = __RetrieveUEContextResponse_protocolIEs__item_
    _RetrieveUEContextResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RetrieveUEContextResponse._cont = ASN1Dict([
        ('protocolIEs', _RetrieveUEContextResponse_protocolIEs),
        ])
    RetrieveUEContextResponse._ext = []
    
    #-----< RetrieveUEContextResponse-IEs >-----#
    RetrieveUEContextResponse_IEs = CLASS(name='RetrieveUEContextResponse-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _RetrieveUEContextResponse_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _RetrieveUEContextResponse_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _RetrieveUEContextResponse_IEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _RetrieveUEContextResponse_IEs_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _RetrieveUEContextResponse_IEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GUMMEI')))
    _RetrieveUEContextResponse_IEs_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'UE-ContextInformationRetrieve')))
    _RetrieveUEContextResponse_IEs_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TraceActivation')))
    _RetrieveUEContextResponse_IEs_val_Value_7 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SRVCCOperationPossible')))
    _RetrieveUEContextResponse_IEs_val_Value_8 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Masked-IMEISV')))
    _RetrieveUEContextResponse_IEs_val_Value_9 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ExpectedUEBehaviour')))
    _RetrieveUEContextResponse_IEs_val_Value_10 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ProSeAuthorized')))
    _RetrieveUEContextResponse_IEs_val_Value_11 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _RetrieveUEContextResponse_IEs_val_Value_12 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'V2XServicesAuthorized')))
    _RetrieveUEContextResponse_IEs_val_Value_13 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'AerialUEsubscriptionInformation')))
    _RetrieveUEContextResponse_IEs_val_Value_14 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Subscription-Based-UE-DifferentiationInfo')))
    _RetrieveUEContextResponse_IEs_val_Value_15 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'NRV2XServicesAuthorized')))
    _RetrieveUEContextResponse_IEs_val_Value_16 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PC5QoSParameters')))
    RetrieveUEContextResponse_IEs._val = ASN1Set(rv=[dict([('id', 9), ('criticality', 'ignore'), ('Value', _RetrieveUEContextResponse_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 155), ('criticality', 'ignore'), ('Value', _RetrieveUEContextResponse_IEs_val_Value_1), ('presence', 'optional')]), dict([('id', 10), ('criticality', 'ignore'), ('Value', _RetrieveUEContextResponse_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 156), ('criticality', 'ignore'), ('Value', _RetrieveUEContextResponse_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 23), ('criticality', 'reject'), ('Value', _RetrieveUEContextResponse_IEs_val_Value_4), ('presence', 'mandatory')]), dict([('id', 173), ('criticality', 'reject'), ('Value', _RetrieveUEContextResponse_IEs_val_Value_5), ('presence', 'mandatory')]), dict([('id', 13), ('criticality', 'ignore'), ('Value', _RetrieveUEContextResponse_IEs_val_Value_6), ('presence', 'optional')]), dict([('id', 36), ('criticality', 'ignore'), ('Value', _RetrieveUEContextResponse_IEs_val_Value_7), ('presence', 'optional')]), dict([('id', 98), ('criticality', 'ignore'), ('Value', _RetrieveUEContextResponse_IEs_val_Value_8), ('presence', 'optional')]), dict([('id', 104), ('criticality', 'ignore'), ('Value', _RetrieveUEContextResponse_IEs_val_Value_9), ('presence', 'optional')]), dict([('id', 103), ('criticality', 'ignore'), ('Value', _RetrieveUEContextResponse_IEs_val_Value_10), ('presence', 'optional')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _RetrieveUEContextResponse_IEs_val_Value_11), ('presence', 'optional')]), dict([('id', 176), ('criticality', 'ignore'), ('Value', _RetrieveUEContextResponse_IEs_val_Value_12), ('presence', 'optional')]), dict([('id', 277), ('criticality', 'ignore'), ('Value', _RetrieveUEContextResponse_IEs_val_Value_13), ('presence', 'optional')]), dict([('id', 309), ('criticality', 'ignore'), ('Value', _RetrieveUEContextResponse_IEs_val_Value_14), ('presence', 'optional')]), dict([('id', 370), ('criticality', 'ignore'), ('Value', _RetrieveUEContextResponse_IEs_val_Value_15), ('presence', 'optional')]), dict([('id', 372), ('criticality', 'ignore'), ('Value', _RetrieveUEContextResponse_IEs_val_Value_16), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UE-ContextInformationRetrieve >-----#
    UE_ContextInformationRetrieve = SEQ(name='UE-ContextInformationRetrieve', mode=MODE_TYPE)
    _UE_ContextInformationRetrieve_mME_UE_S1AP_ID = INT(name='mME-UE-S1AP-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'UE-S1AP-ID')))
    _UE_ContextInformationRetrieve_uESecurityCapabilities = SEQ(name='uESecurityCapabilities', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'UESecurityCapabilities')))
    _UE_ContextInformationRetrieve_aS_SecurityInformation = SEQ(name='aS-SecurityInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'AS-SecurityInformation')))
    _UE_ContextInformationRetrieve_uEaggregateMaximumBitRate = SEQ(name='uEaggregateMaximumBitRate', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'UEAggregateMaximumBitRate')))
    _UE_ContextInformationRetrieve_subscriberProfileIDforRFP = INT(name='subscriberProfileIDforRFP', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'SubscriberProfileIDforRFP')), opt=True)
    _UE_ContextInformationRetrieve_e_RABs_ToBeSetup_ListRetrieve = SEQ_OF(name='e-RABs-ToBeSetup-ListRetrieve', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeSetup-ListRetrieve')))
    _UE_ContextInformationRetrieve_rRC_Context = OCT_STR(name='rRC-Context', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'RRC-Context')))
    _UE_ContextInformationRetrieve_handoverRestrictionList = SEQ(name='handoverRestrictionList', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'HandoverRestrictionList')), opt=True)
    _UE_ContextInformationRetrieve_locationReportingInformation = SEQ(name='locationReportingInformation', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'LocationReportingInformation')), opt=True)
    _UE_ContextInformationRetrieve_managBasedMDTallowed = ENUM(name='managBasedMDTallowed', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ManagementBasedMDTallowed')), opt=True)
    _UE_ContextInformationRetrieve_managBasedMDTPLMNList = SEQ_OF(name='managBasedMDTPLMNList', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'MDTPLMNList')), opt=True)
    _UE_ContextInformationRetrieve_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UE_ContextInformationRetrieve_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___UE_ContextInformationRetrieve_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____UE_ContextInformationRetrieve_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____UE_ContextInformationRetrieve_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UESidelinkAggregateMaximumBitRate')))
    _____UE_ContextInformationRetrieve_iE_Extensions__item__id_tab_val_Extension_1 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'AdditionalRRMPriorityIndex')))
    _____UE_ContextInformationRetrieve_iE_Extensions__item__id_tab_val_Extension_2 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'EPCHandoverRestrictionListContainer')))
    _____UE_ContextInformationRetrieve_iE_Extensions__item__id_tab_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'NRUESidelinkAggregateMaximumBitRate')))
    _____UE_ContextInformationRetrieve_iE_Extensions__item__id_tab_val_Extension_4 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UERadioCapabilityID')))
    _____UE_ContextInformationRetrieve_iE_Extensions__item__id_tab_val_Extension_5 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'IMSvoiceEPSfallbackfrom5G')))
    ____UE_ContextInformationRetrieve_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 184), ('criticality', 'ignore'), ('Extension', _____UE_ContextInformationRetrieve_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 340), ('criticality', 'ignore'), ('Extension', _____UE_ContextInformationRetrieve_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 360), ('criticality', 'ignore'), ('Extension', _____UE_ContextInformationRetrieve_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 371), ('criticality', 'ignore'), ('Extension', _____UE_ContextInformationRetrieve_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 378), ('criticality', 'reject'), ('Extension', _____UE_ContextInformationRetrieve_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 408), ('criticality', 'ignore'), ('Extension', _____UE_ContextInformationRetrieve_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UE_ContextInformationRetrieve_iE_Extensions__item__id._const_tab = ____UE_ContextInformationRetrieve_iE_Extensions__item__id_tab
    ___UE_ContextInformationRetrieve_iE_Extensions__item__id._const_tab_at = None
    ___UE_ContextInformationRetrieve_iE_Extensions__item__id._const_tab_id = 'id'
    ___UE_ContextInformationRetrieve_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___UE_ContextInformationRetrieve_iE_Extensions__item__criticality._const_tab = ____UE_ContextInformationRetrieve_iE_Extensions__item__id_tab
    ___UE_ContextInformationRetrieve_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UE_ContextInformationRetrieve_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UE_ContextInformationRetrieve_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___UE_ContextInformationRetrieve_iE_Extensions__item__extensionValue._const_tab = ____UE_ContextInformationRetrieve_iE_Extensions__item__id_tab
    ___UE_ContextInformationRetrieve_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UE_ContextInformationRetrieve_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UE_ContextInformationRetrieve_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UE_ContextInformationRetrieve_iE_Extensions__item__id),
        ('criticality', ___UE_ContextInformationRetrieve_iE_Extensions__item__criticality),
        ('extensionValue', ___UE_ContextInformationRetrieve_iE_Extensions__item__extensionValue),
        ])
    __UE_ContextInformationRetrieve_iE_Extensions__item_._ext = None
    _UE_ContextInformationRetrieve_iE_Extensions._cont = __UE_ContextInformationRetrieve_iE_Extensions__item_
    _UE_ContextInformationRetrieve_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UE_ContextInformationRetrieve._cont = ASN1Dict([
        ('mME-UE-S1AP-ID', _UE_ContextInformationRetrieve_mME_UE_S1AP_ID),
        ('uESecurityCapabilities', _UE_ContextInformationRetrieve_uESecurityCapabilities),
        ('aS-SecurityInformation', _UE_ContextInformationRetrieve_aS_SecurityInformation),
        ('uEaggregateMaximumBitRate', _UE_ContextInformationRetrieve_uEaggregateMaximumBitRate),
        ('subscriberProfileIDforRFP', _UE_ContextInformationRetrieve_subscriberProfileIDforRFP),
        ('e-RABs-ToBeSetup-ListRetrieve', _UE_ContextInformationRetrieve_e_RABs_ToBeSetup_ListRetrieve),
        ('rRC-Context', _UE_ContextInformationRetrieve_rRC_Context),
        ('handoverRestrictionList', _UE_ContextInformationRetrieve_handoverRestrictionList),
        ('locationReportingInformation', _UE_ContextInformationRetrieve_locationReportingInformation),
        ('managBasedMDTallowed', _UE_ContextInformationRetrieve_managBasedMDTallowed),
        ('managBasedMDTPLMNList', _UE_ContextInformationRetrieve_managBasedMDTPLMNList),
        ('iE-Extensions', _UE_ContextInformationRetrieve_iE_Extensions),
        ])
    UE_ContextInformationRetrieve._ext = []
    
    #-----< UE-ContextInformationRetrieve-ExtIEs >-----#
    UE_ContextInformationRetrieve_ExtIEs = CLASS(name='UE-ContextInformationRetrieve-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _UE_ContextInformationRetrieve_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UESidelinkAggregateMaximumBitRate')))
    _UE_ContextInformationRetrieve_ExtIEs_val_Extension_1 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'AdditionalRRMPriorityIndex')))
    _UE_ContextInformationRetrieve_ExtIEs_val_Extension_2 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'EPCHandoverRestrictionListContainer')))
    _UE_ContextInformationRetrieve_ExtIEs_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'NRUESidelinkAggregateMaximumBitRate')))
    _UE_ContextInformationRetrieve_ExtIEs_val_Extension_4 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UERadioCapabilityID')))
    _UE_ContextInformationRetrieve_ExtIEs_val_Extension_5 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'IMSvoiceEPSfallbackfrom5G')))
    UE_ContextInformationRetrieve_ExtIEs._val = ASN1Set(rv=[dict([('id', 184), ('criticality', 'ignore'), ('Extension', _UE_ContextInformationRetrieve_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 340), ('criticality', 'ignore'), ('Extension', _UE_ContextInformationRetrieve_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 360), ('criticality', 'ignore'), ('Extension', _UE_ContextInformationRetrieve_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 371), ('criticality', 'ignore'), ('Extension', _UE_ContextInformationRetrieve_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 378), ('criticality', 'reject'), ('Extension', _UE_ContextInformationRetrieve_ExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 408), ('criticality', 'ignore'), ('Extension', _UE_ContextInformationRetrieve_ExtIEs_val_Extension_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeSetup-ListRetrieve >-----#
    E_RABs_ToBeSetup_ListRetrieve = SEQ_OF(name='E-RABs-ToBeSetup-ListRetrieve', mode=MODE_TYPE)
    _E_RABs_ToBeSetup_ListRetrieve__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __E_RABs_ToBeSetup_ListRetrieve__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ___E_RABs_ToBeSetup_ListRetrieve__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____E_RABs_ToBeSetup_ListRetrieve__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeSetupRetrieve-Item')))
    ___E_RABs_ToBeSetup_ListRetrieve__item__id_tab._val = ASN1Set(rv=[dict([('id', 174), ('criticality', 'ignore'), ('Value', ____E_RABs_ToBeSetup_ListRetrieve__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E_RABs_ToBeSetup_ListRetrieve__item__id._const_tab = ___E_RABs_ToBeSetup_ListRetrieve__item__id_tab
    __E_RABs_ToBeSetup_ListRetrieve__item__id._const_tab_at = None
    __E_RABs_ToBeSetup_ListRetrieve__item__id._const_tab_id = 'id'
    __E_RABs_ToBeSetup_ListRetrieve__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    __E_RABs_ToBeSetup_ListRetrieve__item__criticality._const_tab = ___E_RABs_ToBeSetup_ListRetrieve__item__id_tab
    __E_RABs_ToBeSetup_ListRetrieve__item__criticality._const_tab_at = ('..', 'id')
    __E_RABs_ToBeSetup_ListRetrieve__item__criticality._const_tab_id = 'criticality'
    __E_RABs_ToBeSetup_ListRetrieve__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    __E_RABs_ToBeSetup_ListRetrieve__item__value._const_tab = ___E_RABs_ToBeSetup_ListRetrieve__item__id_tab
    __E_RABs_ToBeSetup_ListRetrieve__item__value._const_tab_at = ('..', 'id')
    __E_RABs_ToBeSetup_ListRetrieve__item__value._const_tab_id = 'Value'
    _E_RABs_ToBeSetup_ListRetrieve__item_._cont = ASN1Dict([
        ('id', __E_RABs_ToBeSetup_ListRetrieve__item__id),
        ('criticality', __E_RABs_ToBeSetup_ListRetrieve__item__criticality),
        ('value', __E_RABs_ToBeSetup_ListRetrieve__item__value),
        ])
    _E_RABs_ToBeSetup_ListRetrieve__item_._ext = None
    E_RABs_ToBeSetup_ListRetrieve._cont = _E_RABs_ToBeSetup_ListRetrieve__item_
    E_RABs_ToBeSetup_ListRetrieve._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABs-ToBeSetupRetrieve-ItemIEs >-----#
    E_RABs_ToBeSetupRetrieve_ItemIEs = CLASS(name='E-RABs-ToBeSetupRetrieve-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _E_RABs_ToBeSetupRetrieve_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeSetupRetrieve-Item')))
    E_RABs_ToBeSetupRetrieve_ItemIEs._val = ASN1Set(rv=[dict([('id', 174), ('criticality', 'ignore'), ('Value', _E_RABs_ToBeSetupRetrieve_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeSetupRetrieve-Item >-----#
    E_RABs_ToBeSetupRetrieve_Item = SEQ(name='E-RABs-ToBeSetupRetrieve-Item', mode=MODE_TYPE)
    _E_RABs_ToBeSetupRetrieve_Item_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_ToBeSetupRetrieve_Item_e_RAB_Level_QoS_Parameters = SEQ(name='e-RAB-Level-QoS-Parameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-Level-QoS-Parameters')))
    _E_RABs_ToBeSetupRetrieve_Item_bearerType = ENUM(name='bearerType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'BearerType')), opt=True)
    _E_RABs_ToBeSetupRetrieve_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')))
    _____E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'DL-Forwarding')))
    _____E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Ethernet-Type')))
    _____E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item__id_tab_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SecurityIndication')))
    ____E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 185), ('criticality', 'reject'), ('Extension', _____E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'mandatory')]), dict([('id', 306), ('criticality', 'ignore'), ('Extension', _____E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 369), ('criticality', 'ignore'), ('Extension', _____E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 435), ('criticality', 'reject'), ('Extension', _____E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item__id._const_tab = ____E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item__id_tab
    ___E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item__criticality._const_tab = ____E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item__id_tab
    ___E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item__id_tab
    ___E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item__id),
        ('criticality', ___E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item_._ext = None
    _E_RABs_ToBeSetupRetrieve_Item_iE_Extensions._cont = __E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item_
    _E_RABs_ToBeSetupRetrieve_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_ToBeSetupRetrieve_Item._cont = ASN1Dict([
        ('e-RAB-ID', _E_RABs_ToBeSetupRetrieve_Item_e_RAB_ID),
        ('e-RAB-Level-QoS-Parameters', _E_RABs_ToBeSetupRetrieve_Item_e_RAB_Level_QoS_Parameters),
        ('bearerType', _E_RABs_ToBeSetupRetrieve_Item_bearerType),
        ('iE-Extensions', _E_RABs_ToBeSetupRetrieve_Item_iE_Extensions),
        ])
    E_RABs_ToBeSetupRetrieve_Item._ext = []
    
    #-----< E-RABs-ToBeSetupRetrieve-ItemExtIEs >-----#
    E_RABs_ToBeSetupRetrieve_ItemExtIEs = CLASS(name='E-RABs-ToBeSetupRetrieve-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _E_RABs_ToBeSetupRetrieve_ItemExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')))
    _E_RABs_ToBeSetupRetrieve_ItemExtIEs_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'DL-Forwarding')))
    _E_RABs_ToBeSetupRetrieve_ItemExtIEs_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Ethernet-Type')))
    _E_RABs_ToBeSetupRetrieve_ItemExtIEs_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SecurityIndication')))
    E_RABs_ToBeSetupRetrieve_ItemExtIEs._val = ASN1Set(rv=[dict([('id', 185), ('criticality', 'reject'), ('Extension', _E_RABs_ToBeSetupRetrieve_ItemExtIEs_val_Extension_0), ('presence', 'mandatory')]), dict([('id', 306), ('criticality', 'ignore'), ('Extension', _E_RABs_ToBeSetupRetrieve_ItemExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 369), ('criticality', 'ignore'), ('Extension', _E_RABs_ToBeSetupRetrieve_ItemExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 435), ('criticality', 'reject'), ('Extension', _E_RABs_ToBeSetupRetrieve_ItemExtIEs_val_Extension_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RetrieveUEContextFailure >-----#
    RetrieveUEContextFailure = SEQ(name='RetrieveUEContextFailure', mode=MODE_TYPE)
    _RetrieveUEContextFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __RetrieveUEContextFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___RetrieveUEContextFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____RetrieveUEContextFailure_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____RetrieveUEContextFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____RetrieveUEContextFailure_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____RetrieveUEContextFailure_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _____RetrieveUEContextFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    ____RetrieveUEContextFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 9), ('criticality', 'ignore'), ('Value', _____RetrieveUEContextFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 155), ('criticality', 'ignore'), ('Value', _____RetrieveUEContextFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _____RetrieveUEContextFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _____RetrieveUEContextFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RetrieveUEContextFailure_protocolIEs__item__id._const_tab = ____RetrieveUEContextFailure_protocolIEs__item__id_tab
    ___RetrieveUEContextFailure_protocolIEs__item__id._const_tab_at = None
    ___RetrieveUEContextFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___RetrieveUEContextFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___RetrieveUEContextFailure_protocolIEs__item__criticality._const_tab = ____RetrieveUEContextFailure_protocolIEs__item__id_tab
    ___RetrieveUEContextFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RetrieveUEContextFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RetrieveUEContextFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___RetrieveUEContextFailure_protocolIEs__item__value._const_tab = ____RetrieveUEContextFailure_protocolIEs__item__id_tab
    ___RetrieveUEContextFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RetrieveUEContextFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __RetrieveUEContextFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RetrieveUEContextFailure_protocolIEs__item__id),
        ('criticality', ___RetrieveUEContextFailure_protocolIEs__item__criticality),
        ('value', ___RetrieveUEContextFailure_protocolIEs__item__value),
        ])
    __RetrieveUEContextFailure_protocolIEs__item_._ext = None
    _RetrieveUEContextFailure_protocolIEs._cont = __RetrieveUEContextFailure_protocolIEs__item_
    _RetrieveUEContextFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RetrieveUEContextFailure._cont = ASN1Dict([
        ('protocolIEs', _RetrieveUEContextFailure_protocolIEs),
        ])
    RetrieveUEContextFailure._ext = []
    
    #-----< RetrieveUEContextFailure-IEs >-----#
    RetrieveUEContextFailure_IEs = CLASS(name='RetrieveUEContextFailure-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _RetrieveUEContextFailure_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _RetrieveUEContextFailure_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _RetrieveUEContextFailure_IEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _RetrieveUEContextFailure_IEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    RetrieveUEContextFailure_IEs._val = ASN1Set(rv=[dict([('id', 9), ('criticality', 'ignore'), ('Value', _RetrieveUEContextFailure_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 155), ('criticality', 'ignore'), ('Value', _RetrieveUEContextFailure_IEs_val_Value_1), ('presence', 'optional')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _RetrieveUEContextFailure_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _RetrieveUEContextFailure_IEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< SgNBAdditionRequest >-----#
    SgNBAdditionRequest = SEQ(name='SgNBAdditionRequest', mode=MODE_TYPE)
    _SgNBAdditionRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __SgNBAdditionRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___SgNBAdditionRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____SgNBAdditionRequest_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'NRUESecurityCapabilities')))
    _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_2 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNBSecurityKey')))
    _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UEAggregateMaximumBitRate')))
    _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_4 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PLMN-Identity')))
    _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'HandoverRestrictionList')))
    _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_6 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeAdded-SgNBAddReqList')))
    _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_7 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MeNBtoSgNBContainer')))
    _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_8 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNB-UE-X2AP-ID')))
    _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_9 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ExpectedUEBehaviour')))
    _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_10 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_11 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SplitSRBs')))
    _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_12 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MeNBResourceCoordinationInformation')))
    _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_13 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SGNB-Addition-Trigger-Ind')))
    _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_14 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SubscriberProfileIDforRFP')))
    _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_15 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_16 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'DesiredActNotificationLevel')))
    _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_17 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TraceActivation')))
    _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_18 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'LocationInformationSgNBReporting')))
    _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_19 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Masked-IMEISV')))
    _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_20 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'AdditionalRRMPriorityIndex')))
    _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_21 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'RequestedFastMCGRecoveryViaSRB3')))
    _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_22 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'RAN-UE-NGAP-ID')))
    _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_23 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ManagementBasedMDTallowed')))
    _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_24 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MDTPLMNList')))
    _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_25 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UERadioCapabilityID')))
    _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_26 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'IABNodeIndication')))
    _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_27 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Global-RAN-NODE-ID')))
    _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_28 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-HistoryInformation')))
    _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_29 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-HistoryInformationFromTheUE')))
    _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_30 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PSCellChangeHistory')))
    _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_31 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CHOinformation-AddReq')))
    _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_32 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SCGActivationRequest')))
    _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_33 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CPAinformation-REQ')))
    ____SgNBAdditionRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'reject'), ('Value', _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 248), ('criticality', 'reject'), ('Value', _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 203), ('criticality', 'reject'), ('Value', _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 204), ('criticality', 'reject'), ('Value', _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 269), ('criticality', 'ignore'), ('Value', _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 240), ('criticality', 'ignore'), ('Value', _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 205), ('criticality', 'reject'), ('Value', _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_6), ('presence', 'mandatory')]), dict([('id', 206), ('criticality', 'reject'), ('Value', _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_7), ('presence', 'mandatory')]), dict([('id', 207), ('criticality', 'reject'), ('Value', _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_8), ('presence', 'optional')]), dict([('id', 104), ('criticality', 'ignore'), ('Value', _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_9), ('presence', 'optional')]), dict([('id', 157), ('criticality', 'reject'), ('Value', _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_10), ('presence', 'optional')]), dict([('id', 208), ('criticality', 'reject'), ('Value', _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_11), ('presence', 'optional')]), dict([('id', 257), ('criticality', 'ignore'), ('Value', _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_12), ('presence', 'optional')]), dict([('id', 278), ('criticality', 'reject'), ('Value', _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_13), ('presence', 'optional')]), dict([('id', 275), ('criticality', 'ignore'), ('Value', _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_14), ('presence', 'optional')]), dict([('id', 279), ('criticality', 'reject'), ('Value', _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_15), ('presence', 'mandatory')]), dict([('id', 329), ('criticality', 'ignore'), ('Value', _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_16), ('presence', 'optional')]), dict([('id', 13), ('criticality', 'ignore'), ('Value', _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_17), ('presence', 'optional')]), dict([('id', 330), ('criticality', 'ignore'), ('Value', _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_18), ('presence', 'optional')]), dict([('id', 98), ('criticality', 'ignore'), ('Value', _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_19), ('presence', 'optional')]), dict([('id', 340), ('criticality', 'ignore'), ('Value', _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_20), ('presence', 'optional')]), dict([('id', 343), ('criticality', 'ignore'), ('Value', _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_21), ('presence', 'optional')]), dict([('id', 359), ('criticality', 'ignore'), ('Value', _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_22), ('presence', 'optional')]), dict([('id', 74), ('criticality', 'ignore'), ('Value', _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_23), ('presence', 'optional')]), dict([('id', 89), ('criticality', 'ignore'), ('Value', _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_24), ('presence', 'optional')]), dict([('id', 378), ('criticality', 'reject'), ('Value', _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_25), ('presence', 'optional')]), dict([('id', 395), ('criticality', 'reject'), ('Value', _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_26), ('presence', 'optional')]), dict([('id', 411), ('criticality', 'ignore'), ('Value', _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_27), ('presence', 'optional')]), dict([('id', 15), ('criticality', 'ignore'), ('Value', _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_28), ('presence', 'optional')]), dict([('id', 105), ('criticality', 'ignore'), ('Value', _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_29), ('presence', 'optional')]), dict([('id', 419), ('criticality', 'ignore'), ('Value', _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_30), ('presence', 'optional')]), dict([('id', 420), ('criticality', 'reject'), ('Value', _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_31), ('presence', 'optional')]), dict([('id', 423), ('criticality', 'ignore'), ('Value', _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_32), ('presence', 'optional')]), dict([('id', 424), ('criticality', 'reject'), ('Value', _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_33), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SgNBAdditionRequest_protocolIEs__item__id._const_tab = ____SgNBAdditionRequest_protocolIEs__item__id_tab
    ___SgNBAdditionRequest_protocolIEs__item__id._const_tab_at = None
    ___SgNBAdditionRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___SgNBAdditionRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___SgNBAdditionRequest_protocolIEs__item__criticality._const_tab = ____SgNBAdditionRequest_protocolIEs__item__id_tab
    ___SgNBAdditionRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___SgNBAdditionRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___SgNBAdditionRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___SgNBAdditionRequest_protocolIEs__item__value._const_tab = ____SgNBAdditionRequest_protocolIEs__item__id_tab
    ___SgNBAdditionRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___SgNBAdditionRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __SgNBAdditionRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___SgNBAdditionRequest_protocolIEs__item__id),
        ('criticality', ___SgNBAdditionRequest_protocolIEs__item__criticality),
        ('value', ___SgNBAdditionRequest_protocolIEs__item__value),
        ])
    __SgNBAdditionRequest_protocolIEs__item_._ext = None
    _SgNBAdditionRequest_protocolIEs._cont = __SgNBAdditionRequest_protocolIEs__item_
    _SgNBAdditionRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    SgNBAdditionRequest._cont = ASN1Dict([
        ('protocolIEs', _SgNBAdditionRequest_protocolIEs),
        ])
    SgNBAdditionRequest._ext = []
    
    #-----< SgNBAdditionRequest-IEs >-----#
    SgNBAdditionRequest_IEs = CLASS(name='SgNBAdditionRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _SgNBAdditionRequest_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SgNBAdditionRequest_IEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'NRUESecurityCapabilities')))
    _SgNBAdditionRequest_IEs_val_Value_2 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNBSecurityKey')))
    _SgNBAdditionRequest_IEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UEAggregateMaximumBitRate')))
    _SgNBAdditionRequest_IEs_val_Value_4 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PLMN-Identity')))
    _SgNBAdditionRequest_IEs_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'HandoverRestrictionList')))
    _SgNBAdditionRequest_IEs_val_Value_6 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeAdded-SgNBAddReqList')))
    _SgNBAdditionRequest_IEs_val_Value_7 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MeNBtoSgNBContainer')))
    _SgNBAdditionRequest_IEs_val_Value_8 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNB-UE-X2AP-ID')))
    _SgNBAdditionRequest_IEs_val_Value_9 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ExpectedUEBehaviour')))
    _SgNBAdditionRequest_IEs_val_Value_10 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _SgNBAdditionRequest_IEs_val_Value_11 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SplitSRBs')))
    _SgNBAdditionRequest_IEs_val_Value_12 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MeNBResourceCoordinationInformation')))
    _SgNBAdditionRequest_IEs_val_Value_13 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SGNB-Addition-Trigger-Ind')))
    _SgNBAdditionRequest_IEs_val_Value_14 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SubscriberProfileIDforRFP')))
    _SgNBAdditionRequest_IEs_val_Value_15 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _SgNBAdditionRequest_IEs_val_Value_16 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'DesiredActNotificationLevel')))
    _SgNBAdditionRequest_IEs_val_Value_17 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TraceActivation')))
    _SgNBAdditionRequest_IEs_val_Value_18 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'LocationInformationSgNBReporting')))
    _SgNBAdditionRequest_IEs_val_Value_19 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Masked-IMEISV')))
    _SgNBAdditionRequest_IEs_val_Value_20 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'AdditionalRRMPriorityIndex')))
    _SgNBAdditionRequest_IEs_val_Value_21 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'RequestedFastMCGRecoveryViaSRB3')))
    _SgNBAdditionRequest_IEs_val_Value_22 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'RAN-UE-NGAP-ID')))
    _SgNBAdditionRequest_IEs_val_Value_23 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ManagementBasedMDTallowed')))
    _SgNBAdditionRequest_IEs_val_Value_24 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MDTPLMNList')))
    _SgNBAdditionRequest_IEs_val_Value_25 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UERadioCapabilityID')))
    _SgNBAdditionRequest_IEs_val_Value_26 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'IABNodeIndication')))
    _SgNBAdditionRequest_IEs_val_Value_27 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Global-RAN-NODE-ID')))
    _SgNBAdditionRequest_IEs_val_Value_28 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-HistoryInformation')))
    _SgNBAdditionRequest_IEs_val_Value_29 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-HistoryInformationFromTheUE')))
    _SgNBAdditionRequest_IEs_val_Value_30 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PSCellChangeHistory')))
    _SgNBAdditionRequest_IEs_val_Value_31 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CHOinformation-AddReq')))
    _SgNBAdditionRequest_IEs_val_Value_32 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SCGActivationRequest')))
    _SgNBAdditionRequest_IEs_val_Value_33 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CPAinformation-REQ')))
    SgNBAdditionRequest_IEs._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'reject'), ('Value', _SgNBAdditionRequest_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 248), ('criticality', 'reject'), ('Value', _SgNBAdditionRequest_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 203), ('criticality', 'reject'), ('Value', _SgNBAdditionRequest_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 204), ('criticality', 'reject'), ('Value', _SgNBAdditionRequest_IEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 269), ('criticality', 'ignore'), ('Value', _SgNBAdditionRequest_IEs_val_Value_4), ('presence', 'optional')]), dict([('id', 240), ('criticality', 'ignore'), ('Value', _SgNBAdditionRequest_IEs_val_Value_5), ('presence', 'optional')]), dict([('id', 205), ('criticality', 'reject'), ('Value', _SgNBAdditionRequest_IEs_val_Value_6), ('presence', 'mandatory')]), dict([('id', 206), ('criticality', 'reject'), ('Value', _SgNBAdditionRequest_IEs_val_Value_7), ('presence', 'mandatory')]), dict([('id', 207), ('criticality', 'reject'), ('Value', _SgNBAdditionRequest_IEs_val_Value_8), ('presence', 'optional')]), dict([('id', 104), ('criticality', 'ignore'), ('Value', _SgNBAdditionRequest_IEs_val_Value_9), ('presence', 'optional')]), dict([('id', 157), ('criticality', 'reject'), ('Value', _SgNBAdditionRequest_IEs_val_Value_10), ('presence', 'optional')]), dict([('id', 208), ('criticality', 'reject'), ('Value', _SgNBAdditionRequest_IEs_val_Value_11), ('presence', 'optional')]), dict([('id', 257), ('criticality', 'ignore'), ('Value', _SgNBAdditionRequest_IEs_val_Value_12), ('presence', 'optional')]), dict([('id', 278), ('criticality', 'reject'), ('Value', _SgNBAdditionRequest_IEs_val_Value_13), ('presence', 'optional')]), dict([('id', 275), ('criticality', 'ignore'), ('Value', _SgNBAdditionRequest_IEs_val_Value_14), ('presence', 'optional')]), dict([('id', 279), ('criticality', 'reject'), ('Value', _SgNBAdditionRequest_IEs_val_Value_15), ('presence', 'mandatory')]), dict([('id', 329), ('criticality', 'ignore'), ('Value', _SgNBAdditionRequest_IEs_val_Value_16), ('presence', 'optional')]), dict([('id', 13), ('criticality', 'ignore'), ('Value', _SgNBAdditionRequest_IEs_val_Value_17), ('presence', 'optional')]), dict([('id', 330), ('criticality', 'ignore'), ('Value', _SgNBAdditionRequest_IEs_val_Value_18), ('presence', 'optional')]), dict([('id', 98), ('criticality', 'ignore'), ('Value', _SgNBAdditionRequest_IEs_val_Value_19), ('presence', 'optional')]), dict([('id', 340), ('criticality', 'ignore'), ('Value', _SgNBAdditionRequest_IEs_val_Value_20), ('presence', 'optional')]), dict([('id', 343), ('criticality', 'ignore'), ('Value', _SgNBAdditionRequest_IEs_val_Value_21), ('presence', 'optional')]), dict([('id', 359), ('criticality', 'ignore'), ('Value', _SgNBAdditionRequest_IEs_val_Value_22), ('presence', 'optional')]), dict([('id', 74), ('criticality', 'ignore'), ('Value', _SgNBAdditionRequest_IEs_val_Value_23), ('presence', 'optional')]), dict([('id', 89), ('criticality', 'ignore'), ('Value', _SgNBAdditionRequest_IEs_val_Value_24), ('presence', 'optional')]), dict([('id', 378), ('criticality', 'reject'), ('Value', _SgNBAdditionRequest_IEs_val_Value_25), ('presence', 'optional')]), dict([('id', 395), ('criticality', 'reject'), ('Value', _SgNBAdditionRequest_IEs_val_Value_26), ('presence', 'optional')]), dict([('id', 411), ('criticality', 'ignore'), ('Value', _SgNBAdditionRequest_IEs_val_Value_27), ('presence', 'optional')]), dict([('id', 15), ('criticality', 'ignore'), ('Value', _SgNBAdditionRequest_IEs_val_Value_28), ('presence', 'optional')]), dict([('id', 105), ('criticality', 'ignore'), ('Value', _SgNBAdditionRequest_IEs_val_Value_29), ('presence', 'optional')]), dict([('id', 419), ('criticality', 'ignore'), ('Value', _SgNBAdditionRequest_IEs_val_Value_30), ('presence', 'optional')]), dict([('id', 420), ('criticality', 'reject'), ('Value', _SgNBAdditionRequest_IEs_val_Value_31), ('presence', 'optional')]), dict([('id', 423), ('criticality', 'ignore'), ('Value', _SgNBAdditionRequest_IEs_val_Value_32), ('presence', 'optional')]), dict([('id', 424), ('criticality', 'reject'), ('Value', _SgNBAdditionRequest_IEs_val_Value_33), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeAdded-SgNBAddReqList >-----#
    E_RABs_ToBeAdded_SgNBAddReqList = SEQ_OF(name='E-RABs-ToBeAdded-SgNBAddReqList', mode=MODE_TYPE)
    _E_RABs_ToBeAdded_SgNBAddReqList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __E_RABs_ToBeAdded_SgNBAddReqList__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ___E_RABs_ToBeAdded_SgNBAddReqList__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____E_RABs_ToBeAdded_SgNBAddReqList__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeAdded-SgNBAddReq-Item')))
    ___E_RABs_ToBeAdded_SgNBAddReqList__item__id_tab._val = ASN1Set(rv=[dict([('id', 209), ('criticality', 'reject'), ('Value', ____E_RABs_ToBeAdded_SgNBAddReqList__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E_RABs_ToBeAdded_SgNBAddReqList__item__id._const_tab = ___E_RABs_ToBeAdded_SgNBAddReqList__item__id_tab
    __E_RABs_ToBeAdded_SgNBAddReqList__item__id._const_tab_at = None
    __E_RABs_ToBeAdded_SgNBAddReqList__item__id._const_tab_id = 'id'
    __E_RABs_ToBeAdded_SgNBAddReqList__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    __E_RABs_ToBeAdded_SgNBAddReqList__item__criticality._const_tab = ___E_RABs_ToBeAdded_SgNBAddReqList__item__id_tab
    __E_RABs_ToBeAdded_SgNBAddReqList__item__criticality._const_tab_at = ('..', 'id')
    __E_RABs_ToBeAdded_SgNBAddReqList__item__criticality._const_tab_id = 'criticality'
    __E_RABs_ToBeAdded_SgNBAddReqList__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    __E_RABs_ToBeAdded_SgNBAddReqList__item__value._const_tab = ___E_RABs_ToBeAdded_SgNBAddReqList__item__id_tab
    __E_RABs_ToBeAdded_SgNBAddReqList__item__value._const_tab_at = ('..', 'id')
    __E_RABs_ToBeAdded_SgNBAddReqList__item__value._const_tab_id = 'Value'
    _E_RABs_ToBeAdded_SgNBAddReqList__item_._cont = ASN1Dict([
        ('id', __E_RABs_ToBeAdded_SgNBAddReqList__item__id),
        ('criticality', __E_RABs_ToBeAdded_SgNBAddReqList__item__criticality),
        ('value', __E_RABs_ToBeAdded_SgNBAddReqList__item__value),
        ])
    _E_RABs_ToBeAdded_SgNBAddReqList__item_._ext = None
    E_RABs_ToBeAdded_SgNBAddReqList._cont = _E_RABs_ToBeAdded_SgNBAddReqList__item_
    E_RABs_ToBeAdded_SgNBAddReqList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABs-ToBeAdded-SgNBAddReq-ItemIEs >-----#
    E_RABs_ToBeAdded_SgNBAddReq_ItemIEs = CLASS(name='E-RABs-ToBeAdded-SgNBAddReq-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _E_RABs_ToBeAdded_SgNBAddReq_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeAdded-SgNBAddReq-Item')))
    E_RABs_ToBeAdded_SgNBAddReq_ItemIEs._val = ASN1Set(rv=[dict([('id', 209), ('criticality', 'reject'), ('Value', _E_RABs_ToBeAdded_SgNBAddReq_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeAdded-SgNBAddReq-Item >-----#
    E_RABs_ToBeAdded_SgNBAddReq_Item = SEQ(name='E-RABs-ToBeAdded-SgNBAddReq-Item', mode=MODE_TYPE)
    _E_RABs_ToBeAdded_SgNBAddReq_Item_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_ToBeAdded_SgNBAddReq_Item_drb_ID = INT(name='drb-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'DRB-ID')))
    _E_RABs_ToBeAdded_SgNBAddReq_Item_en_DC_ResourceConfiguration = SEQ(name='en-DC-ResourceConfiguration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'EN-DC-ResourceConfiguration')))
    _E_RABs_ToBeAdded_SgNBAddReq_Item_resource_configuration = CHOICE(name='resource-configuration', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __E_RABs_ToBeAdded_SgNBAddReq_Item_resource_configuration_sgNBPDCPpresent = SEQ(name='sgNBPDCPpresent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeAdded-SgNBAddReq-Item-SgNBPDCPpresent')))
    __E_RABs_ToBeAdded_SgNBAddReq_Item_resource_configuration_sgNBPDCPnotpresent = SEQ(name='sgNBPDCPnotpresent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeAdded-SgNBAddReq-Item-SgNBPDCPnotpresent')))
    _E_RABs_ToBeAdded_SgNBAddReq_Item_resource_configuration._cont = ASN1Dict([
        ('sgNBPDCPpresent', __E_RABs_ToBeAdded_SgNBAddReq_Item_resource_configuration_sgNBPDCPpresent),
        ('sgNBPDCPnotpresent', __E_RABs_ToBeAdded_SgNBAddReq_Item_resource_configuration_sgNBPDCPnotpresent),
        ])
    _E_RABs_ToBeAdded_SgNBAddReq_Item_resource_configuration._ext = []
    _E_RABs_ToBeAdded_SgNBAddReq_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_ToBeAdded_SgNBAddReq_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_ToBeAdded_SgNBAddReq_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_ToBeAdded_SgNBAddReq_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeAdded_SgNBAddReq_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeAdded_SgNBAddReq_Item_iE_Extensions__item__id._const_tab = ____E_RABs_ToBeAdded_SgNBAddReq_Item_iE_Extensions__item__id_tab
    ___E_RABs_ToBeAdded_SgNBAddReq_Item_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_ToBeAdded_SgNBAddReq_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_ToBeAdded_SgNBAddReq_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_RABs_ToBeAdded_SgNBAddReq_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeAdded_SgNBAddReq_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeAdded_SgNBAddReq_Item_iE_Extensions__item__criticality._const_tab = ____E_RABs_ToBeAdded_SgNBAddReq_Item_iE_Extensions__item__criticality_tab
    ___E_RABs_ToBeAdded_SgNBAddReq_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeAdded_SgNBAddReq_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_ToBeAdded_SgNBAddReq_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_RABs_ToBeAdded_SgNBAddReq_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeAdded_SgNBAddReq_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeAdded_SgNBAddReq_Item_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_ToBeAdded_SgNBAddReq_Item_iE_Extensions__item__extensionValue_tab
    ___E_RABs_ToBeAdded_SgNBAddReq_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeAdded_SgNBAddReq_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_ToBeAdded_SgNBAddReq_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_ToBeAdded_SgNBAddReq_Item_iE_Extensions__item__id),
        ('criticality', ___E_RABs_ToBeAdded_SgNBAddReq_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_ToBeAdded_SgNBAddReq_Item_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_ToBeAdded_SgNBAddReq_Item_iE_Extensions__item_._ext = None
    _E_RABs_ToBeAdded_SgNBAddReq_Item_iE_Extensions._cont = __E_RABs_ToBeAdded_SgNBAddReq_Item_iE_Extensions__item_
    _E_RABs_ToBeAdded_SgNBAddReq_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_ToBeAdded_SgNBAddReq_Item._cont = ASN1Dict([
        ('e-RAB-ID', _E_RABs_ToBeAdded_SgNBAddReq_Item_e_RAB_ID),
        ('drb-ID', _E_RABs_ToBeAdded_SgNBAddReq_Item_drb_ID),
        ('en-DC-ResourceConfiguration', _E_RABs_ToBeAdded_SgNBAddReq_Item_en_DC_ResourceConfiguration),
        ('resource-configuration', _E_RABs_ToBeAdded_SgNBAddReq_Item_resource_configuration),
        ('iE-Extensions', _E_RABs_ToBeAdded_SgNBAddReq_Item_iE_Extensions),
        ])
    E_RABs_ToBeAdded_SgNBAddReq_Item._ext = []
    
    #-----< E-RABs-ToBeAdded-SgNBAddReq-ItemExtIEs >-----#
    E_RABs_ToBeAdded_SgNBAddReq_ItemExtIEs = CLASS(name='E-RABs-ToBeAdded-SgNBAddReq-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    E_RABs_ToBeAdded_SgNBAddReq_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeAdded-SgNBAddReq-Item-SgNBPDCPpresent >-----#
    E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent = SEQ(name='E-RABs-ToBeAdded-SgNBAddReq-Item-SgNBPDCPpresent', mode=MODE_TYPE)
    _E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent_full_E_RAB_Level_QoS_Parameters = SEQ(name='full-E-RAB-Level-QoS-Parameters', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-Level-QoS-Parameters')))
    _E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent_max_MCG_admit_E_RAB_Level_QoS_Parameters = SEQ(name='max-MCG-admit-E-RAB-Level-QoS-Parameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GBR-QosInformation')), opt=True)
    _E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent_dL_Forwarding = ENUM(name='dL-Forwarding', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'DL-Forwarding')), opt=True)
    _E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent_meNB_DL_GTP_TEIDatMCG = SEQ(name='meNB-DL-GTP-TEIDatMCG', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent_s1_UL_GTPtunnelEndpoint = SEQ(name='s1-UL-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')))
    _E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'RLCMode')))
    _____E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'BearerType')))
    _____E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Ethernet-Type')))
    _____E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_3 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TransportLayerAddress')))
    _____E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SecurityIndication')))
    _____E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_5 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TransportLayerAddress')))
    ____E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 317), ('criticality', 'ignore'), ('Extension', _____E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 171), ('criticality', 'ignore'), ('Extension', _____E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 369), ('criticality', 'ignore'), ('Extension', _____E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 412), ('criticality', 'ignore'), ('Extension', _____E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 435), ('criticality', 'reject'), ('Extension', _____E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 413), ('criticality', 'ignore'), ('Extension', _____E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent_iE_Extensions__item__id._const_tab = ____E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab
    ___E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent_iE_Extensions__item__criticality._const_tab = ____E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab
    ___E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab
    ___E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent_iE_Extensions__item__id),
        ('criticality', ___E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent_iE_Extensions__item_._ext = None
    _E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent_iE_Extensions._cont = __E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent_iE_Extensions__item_
    _E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent._cont = ASN1Dict([
        ('full-E-RAB-Level-QoS-Parameters', _E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent_full_E_RAB_Level_QoS_Parameters),
        ('max-MCG-admit-E-RAB-Level-QoS-Parameters', _E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent_max_MCG_admit_E_RAB_Level_QoS_Parameters),
        ('dL-Forwarding', _E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent_dL_Forwarding),
        ('meNB-DL-GTP-TEIDatMCG', _E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent_meNB_DL_GTP_TEIDatMCG),
        ('s1-UL-GTPtunnelEndpoint', _E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent_s1_UL_GTPtunnelEndpoint),
        ('iE-Extensions', _E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent_iE_Extensions),
        ])
    E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent._ext = []
    
    #-----< E-RABs-ToBeAdded-SgNBAddReq-Item-SgNBPDCPpresentExtIEs >-----#
    E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresentExtIEs = CLASS(name='E-RABs-ToBeAdded-SgNBAddReq-Item-SgNBPDCPpresentExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresentExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'RLCMode')))
    _E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresentExtIEs_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'BearerType')))
    _E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresentExtIEs_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Ethernet-Type')))
    _E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresentExtIEs_val_Extension_3 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TransportLayerAddress')))
    _E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresentExtIEs_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SecurityIndication')))
    _E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresentExtIEs_val_Extension_5 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TransportLayerAddress')))
    E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresentExtIEs._val = ASN1Set(rv=[dict([('id', 317), ('criticality', 'ignore'), ('Extension', _E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresentExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 171), ('criticality', 'ignore'), ('Extension', _E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresentExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 369), ('criticality', 'ignore'), ('Extension', _E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresentExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 412), ('criticality', 'ignore'), ('Extension', _E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresentExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 435), ('criticality', 'reject'), ('Extension', _E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresentExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 413), ('criticality', 'ignore'), ('Extension', _E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresentExtIEs_val_Extension_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeAdded-SgNBAddReq-Item-SgNBPDCPnotpresent >-----#
    E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresent = SEQ(name='E-RABs-ToBeAdded-SgNBAddReq-Item-SgNBPDCPnotpresent', mode=MODE_TYPE)
    _E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresent_requested_SCG_E_RAB_Level_QoS_Parameters = SEQ(name='requested-SCG-E-RAB-Level-QoS-Parameters', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-Level-QoS-Parameters')))
    _E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresent_meNB_UL_GTP_TEIDatPDCP = SEQ(name='meNB-UL-GTP-TEIDatPDCP', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')))
    _E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresent_secondary_meNB_UL_GTP_TEIDatPDCP = SEQ(name='secondary-meNB-UL-GTP-TEIDatPDCP', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresent_rlc_Mode = ENUM(name='rlc-Mode', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'RLCMode')))
    _E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresent_uL_Configuration = SEQ(name='uL-Configuration', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ULConfiguration')), opt=True)
    _E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresent_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresent_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PDCPSnLength')))
    _____E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PDCPSnLength')))
    _____E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'DuplicationActivation')))
    ____E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 302), ('criticality', 'ignore'), ('Extension', _____E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 311), ('criticality', 'ignore'), ('Extension', _____E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 315), ('criticality', 'ignore'), ('Extension', _____E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id._const_tab = ____E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab
    ___E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality._const_tab = ____E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab
    ___E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab
    ___E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresent_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id),
        ('criticality', ___E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresent_iE_Extensions__item_._ext = None
    _E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresent_iE_Extensions._cont = __E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresent_iE_Extensions__item_
    _E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresent_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresent._cont = ASN1Dict([
        ('requested-SCG-E-RAB-Level-QoS-Parameters', _E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresent_requested_SCG_E_RAB_Level_QoS_Parameters),
        ('meNB-UL-GTP-TEIDatPDCP', _E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresent_meNB_UL_GTP_TEIDatPDCP),
        ('secondary-meNB-UL-GTP-TEIDatPDCP', _E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresent_secondary_meNB_UL_GTP_TEIDatPDCP),
        ('rlc-Mode', _E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresent_rlc_Mode),
        ('uL-Configuration', _E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresent_uL_Configuration),
        ('iE-Extensions', _E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresent_iE_Extensions),
        ])
    E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresent._ext = []
    
    #-----< E-RABs-ToBeAdded-SgNBAddReq-Item-SgNBPDCPnotpresentExtIEs >-----#
    E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresentExtIEs = CLASS(name='E-RABs-ToBeAdded-SgNBAddReq-Item-SgNBPDCPnotpresentExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresentExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PDCPSnLength')))
    _E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresentExtIEs_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PDCPSnLength')))
    _E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresentExtIEs_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'DuplicationActivation')))
    E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresentExtIEs._val = ASN1Set(rv=[dict([('id', 302), ('criticality', 'ignore'), ('Extension', _E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresentExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 311), ('criticality', 'ignore'), ('Extension', _E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresentExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 315), ('criticality', 'ignore'), ('Extension', _E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresentExtIEs_val_Extension_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< SgNBAdditionRequestAcknowledge >-----#
    SgNBAdditionRequestAcknowledge = SEQ(name='SgNBAdditionRequestAcknowledge', mode=MODE_TYPE)
    _SgNBAdditionRequestAcknowledge_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __SgNBAdditionRequestAcknowledge_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___SgNBAdditionRequestAcknowledge_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____SgNBAdditionRequestAcknowledge_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____SgNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SgNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNB-UE-X2AP-ID')))
    _____SgNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeAdded-SgNBAddReqAckList')))
    _____SgNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-List')))
    _____SgNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_4 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNBtoMeNBContainer')))
    _____SgNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _____SgNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_6 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____SgNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_7 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SplitSRBs')))
    _____SgNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_8 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNBResourceCoordinationInformation')))
    _____SgNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_9 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'RRC-Config-Ind')))
    _____SgNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_10 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'LocationInformationSgNB')))
    _____SgNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_11 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'AvailableFastMCGRecoveryViaSRB3')))
    _____SgNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_12 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'DirectForwardingPathAvailability')))
    _____SgNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_13 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SCGActivationStatus')))
    _____SgNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_14 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CPAinformation-REQ-ACK')))
    ____SgNBAdditionRequestAcknowledge_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'reject'), ('Value', _____SgNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 207), ('criticality', 'reject'), ('Value', _____SgNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 210), ('criticality', 'ignore'), ('Value', _____SgNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'ignore'), ('Value', _____SgNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 211), ('criticality', 'reject'), ('Value', _____SgNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_4), ('presence', 'mandatory')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _____SgNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 157), ('criticality', 'reject'), ('Value', _____SgNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 212), ('criticality', 'reject'), ('Value', _____SgNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')]), dict([('id', 258), ('criticality', 'ignore'), ('Value', _____SgNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_8), ('presence', 'optional')]), dict([('id', 272), ('criticality', 'reject'), ('Value', _____SgNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_9), ('presence', 'optional')]), dict([('id', 331), ('criticality', 'ignore'), ('Value', _____SgNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_10), ('presence', 'optional')]), dict([('id', 344), ('criticality', 'ignore'), ('Value', _____SgNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_11), ('presence', 'optional')]), dict([('id', 410), ('criticality', 'ignore'), ('Value', _____SgNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_12), ('presence', 'optional')]), dict([('id', 422), ('criticality', 'ignore'), ('Value', _____SgNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_13), ('presence', 'optional')]), dict([('id', 425), ('criticality', 'ignore'), ('Value', _____SgNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_14), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SgNBAdditionRequestAcknowledge_protocolIEs__item__id._const_tab = ____SgNBAdditionRequestAcknowledge_protocolIEs__item__id_tab
    ___SgNBAdditionRequestAcknowledge_protocolIEs__item__id._const_tab_at = None
    ___SgNBAdditionRequestAcknowledge_protocolIEs__item__id._const_tab_id = 'id'
    ___SgNBAdditionRequestAcknowledge_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___SgNBAdditionRequestAcknowledge_protocolIEs__item__criticality._const_tab = ____SgNBAdditionRequestAcknowledge_protocolIEs__item__id_tab
    ___SgNBAdditionRequestAcknowledge_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___SgNBAdditionRequestAcknowledge_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___SgNBAdditionRequestAcknowledge_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___SgNBAdditionRequestAcknowledge_protocolIEs__item__value._const_tab = ____SgNBAdditionRequestAcknowledge_protocolIEs__item__id_tab
    ___SgNBAdditionRequestAcknowledge_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___SgNBAdditionRequestAcknowledge_protocolIEs__item__value._const_tab_id = 'Value'
    __SgNBAdditionRequestAcknowledge_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___SgNBAdditionRequestAcknowledge_protocolIEs__item__id),
        ('criticality', ___SgNBAdditionRequestAcknowledge_protocolIEs__item__criticality),
        ('value', ___SgNBAdditionRequestAcknowledge_protocolIEs__item__value),
        ])
    __SgNBAdditionRequestAcknowledge_protocolIEs__item_._ext = None
    _SgNBAdditionRequestAcknowledge_protocolIEs._cont = __SgNBAdditionRequestAcknowledge_protocolIEs__item_
    _SgNBAdditionRequestAcknowledge_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    SgNBAdditionRequestAcknowledge._cont = ASN1Dict([
        ('protocolIEs', _SgNBAdditionRequestAcknowledge_protocolIEs),
        ])
    SgNBAdditionRequestAcknowledge._ext = []
    
    #-----< SgNBAdditionRequestAcknowledge-IEs >-----#
    SgNBAdditionRequestAcknowledge_IEs = CLASS(name='SgNBAdditionRequestAcknowledge-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _SgNBAdditionRequestAcknowledge_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SgNBAdditionRequestAcknowledge_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNB-UE-X2AP-ID')))
    _SgNBAdditionRequestAcknowledge_IEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeAdded-SgNBAddReqAckList')))
    _SgNBAdditionRequestAcknowledge_IEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-List')))
    _SgNBAdditionRequestAcknowledge_IEs_val_Value_4 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNBtoMeNBContainer')))
    _SgNBAdditionRequestAcknowledge_IEs_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _SgNBAdditionRequestAcknowledge_IEs_val_Value_6 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _SgNBAdditionRequestAcknowledge_IEs_val_Value_7 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SplitSRBs')))
    _SgNBAdditionRequestAcknowledge_IEs_val_Value_8 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNBResourceCoordinationInformation')))
    _SgNBAdditionRequestAcknowledge_IEs_val_Value_9 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'RRC-Config-Ind')))
    _SgNBAdditionRequestAcknowledge_IEs_val_Value_10 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'LocationInformationSgNB')))
    _SgNBAdditionRequestAcknowledge_IEs_val_Value_11 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'AvailableFastMCGRecoveryViaSRB3')))
    _SgNBAdditionRequestAcknowledge_IEs_val_Value_12 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'DirectForwardingPathAvailability')))
    _SgNBAdditionRequestAcknowledge_IEs_val_Value_13 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SCGActivationStatus')))
    _SgNBAdditionRequestAcknowledge_IEs_val_Value_14 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CPAinformation-REQ-ACK')))
    SgNBAdditionRequestAcknowledge_IEs._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'reject'), ('Value', _SgNBAdditionRequestAcknowledge_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 207), ('criticality', 'reject'), ('Value', _SgNBAdditionRequestAcknowledge_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 210), ('criticality', 'ignore'), ('Value', _SgNBAdditionRequestAcknowledge_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'ignore'), ('Value', _SgNBAdditionRequestAcknowledge_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 211), ('criticality', 'reject'), ('Value', _SgNBAdditionRequestAcknowledge_IEs_val_Value_4), ('presence', 'mandatory')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _SgNBAdditionRequestAcknowledge_IEs_val_Value_5), ('presence', 'optional')]), dict([('id', 157), ('criticality', 'reject'), ('Value', _SgNBAdditionRequestAcknowledge_IEs_val_Value_6), ('presence', 'optional')]), dict([('id', 212), ('criticality', 'reject'), ('Value', _SgNBAdditionRequestAcknowledge_IEs_val_Value_7), ('presence', 'optional')]), dict([('id', 258), ('criticality', 'ignore'), ('Value', _SgNBAdditionRequestAcknowledge_IEs_val_Value_8), ('presence', 'optional')]), dict([('id', 272), ('criticality', 'reject'), ('Value', _SgNBAdditionRequestAcknowledge_IEs_val_Value_9), ('presence', 'optional')]), dict([('id', 331), ('criticality', 'ignore'), ('Value', _SgNBAdditionRequestAcknowledge_IEs_val_Value_10), ('presence', 'optional')]), dict([('id', 344), ('criticality', 'ignore'), ('Value', _SgNBAdditionRequestAcknowledge_IEs_val_Value_11), ('presence', 'optional')]), dict([('id', 410), ('criticality', 'ignore'), ('Value', _SgNBAdditionRequestAcknowledge_IEs_val_Value_12), ('presence', 'optional')]), dict([('id', 422), ('criticality', 'ignore'), ('Value', _SgNBAdditionRequestAcknowledge_IEs_val_Value_13), ('presence', 'optional')]), dict([('id', 425), ('criticality', 'ignore'), ('Value', _SgNBAdditionRequestAcknowledge_IEs_val_Value_14), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-Admitted-ToBeAdded-SgNBAddReqAckList >-----#
    E_RABs_Admitted_ToBeAdded_SgNBAddReqAckList = SEQ_OF(name='E-RABs-Admitted-ToBeAdded-SgNBAddReqAckList', mode=MODE_TYPE)
    _E_RABs_Admitted_ToBeAdded_SgNBAddReqAckList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __E_RABs_Admitted_ToBeAdded_SgNBAddReqAckList__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ___E_RABs_Admitted_ToBeAdded_SgNBAddReqAckList__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____E_RABs_Admitted_ToBeAdded_SgNBAddReqAckList__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeAdded-SgNBAddReqAck-Item')))
    ___E_RABs_Admitted_ToBeAdded_SgNBAddReqAckList__item__id_tab._val = ASN1Set(rv=[dict([('id', 213), ('criticality', 'ignore'), ('Value', ____E_RABs_Admitted_ToBeAdded_SgNBAddReqAckList__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E_RABs_Admitted_ToBeAdded_SgNBAddReqAckList__item__id._const_tab = ___E_RABs_Admitted_ToBeAdded_SgNBAddReqAckList__item__id_tab
    __E_RABs_Admitted_ToBeAdded_SgNBAddReqAckList__item__id._const_tab_at = None
    __E_RABs_Admitted_ToBeAdded_SgNBAddReqAckList__item__id._const_tab_id = 'id'
    __E_RABs_Admitted_ToBeAdded_SgNBAddReqAckList__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    __E_RABs_Admitted_ToBeAdded_SgNBAddReqAckList__item__criticality._const_tab = ___E_RABs_Admitted_ToBeAdded_SgNBAddReqAckList__item__id_tab
    __E_RABs_Admitted_ToBeAdded_SgNBAddReqAckList__item__criticality._const_tab_at = ('..', 'id')
    __E_RABs_Admitted_ToBeAdded_SgNBAddReqAckList__item__criticality._const_tab_id = 'criticality'
    __E_RABs_Admitted_ToBeAdded_SgNBAddReqAckList__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    __E_RABs_Admitted_ToBeAdded_SgNBAddReqAckList__item__value._const_tab = ___E_RABs_Admitted_ToBeAdded_SgNBAddReqAckList__item__id_tab
    __E_RABs_Admitted_ToBeAdded_SgNBAddReqAckList__item__value._const_tab_at = ('..', 'id')
    __E_RABs_Admitted_ToBeAdded_SgNBAddReqAckList__item__value._const_tab_id = 'Value'
    _E_RABs_Admitted_ToBeAdded_SgNBAddReqAckList__item_._cont = ASN1Dict([
        ('id', __E_RABs_Admitted_ToBeAdded_SgNBAddReqAckList__item__id),
        ('criticality', __E_RABs_Admitted_ToBeAdded_SgNBAddReqAckList__item__criticality),
        ('value', __E_RABs_Admitted_ToBeAdded_SgNBAddReqAckList__item__value),
        ])
    _E_RABs_Admitted_ToBeAdded_SgNBAddReqAckList__item_._ext = None
    E_RABs_Admitted_ToBeAdded_SgNBAddReqAckList._cont = _E_RABs_Admitted_ToBeAdded_SgNBAddReqAckList__item_
    E_RABs_Admitted_ToBeAdded_SgNBAddReqAckList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABs-Admitted-ToBeAdded-SgNBAddReqAck-ItemIEs >-----#
    E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_ItemIEs = CLASS(name='E-RABs-Admitted-ToBeAdded-SgNBAddReqAck-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeAdded-SgNBAddReqAck-Item')))
    E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_ItemIEs._val = ASN1Set(rv=[dict([('id', 213), ('criticality', 'ignore'), ('Value', _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< E-RABs-Admitted-ToBeAdded-SgNBAddReqAck-Item >-----#
    E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item = SEQ(name='E-RABs-Admitted-ToBeAdded-SgNBAddReqAck-Item', mode=MODE_TYPE)
    _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_en_DC_ResourceConfiguration = SEQ(name='en-DC-ResourceConfiguration', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'EN-DC-ResourceConfiguration')))
    _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_resource_configuration = CHOICE(name='resource-configuration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_resource_configuration_sgNBPDCPpresent = SEQ(name='sgNBPDCPpresent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeAdded-SgNBAddReqAck-Item-SgNBPDCPpresent')))
    __E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_resource_configuration_sgNBPDCPnotpresent = SEQ(name='sgNBPDCPnotpresent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeAdded-SgNBAddReqAck-Item-SgNBPDCPnotpresent')))
    _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_resource_configuration._cont = ASN1Dict([
        ('sgNBPDCPpresent', __E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_resource_configuration_sgNBPDCPpresent),
        ('sgNBPDCPnotpresent', __E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_resource_configuration_sgNBPDCPnotpresent),
        ])
    _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_resource_configuration._ext = []
    _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_iE_Extensions__item__id._const_tab = ____E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_iE_Extensions__item__criticality._const_tab = ____E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_iE_Extensions__item__criticality_tab
    ___E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_iE_Extensions__item__extensionValue_tab
    ___E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_iE_Extensions__item__id),
        ('criticality', ___E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_iE_Extensions__item_._ext = None
    _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_iE_Extensions._cont = __E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_iE_Extensions__item_
    _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item._cont = ASN1Dict([
        ('e-RAB-ID', _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_e_RAB_ID),
        ('en-DC-ResourceConfiguration', _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_en_DC_ResourceConfiguration),
        ('resource-configuration', _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_resource_configuration),
        ('iE-Extensions', _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_iE_Extensions),
        ])
    E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item._ext = []
    
    #-----< E-RABs-ToBeAdded-SgNBAddReqAck-ItemExtIEs >-----#
    E_RABs_ToBeAdded_SgNBAddReqAck_ItemExtIEs = CLASS(name='E-RABs-ToBeAdded-SgNBAddReqAck-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    E_RABs_ToBeAdded_SgNBAddReqAck_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RABs-Admitted-ToBeAdded-SgNBAddReqAck-Item-SgNBPDCPpresent >-----#
    E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent = SEQ(name='E-RABs-Admitted-ToBeAdded-SgNBAddReqAck-Item-SgNBPDCPpresent', mode=MODE_TYPE)
    _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent_s1_DL_GTPtunnelEndpoint = SEQ(name='s1-DL-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')))
    _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent_sgNB_UL_GTP_TEIDatPDCP = SEQ(name='sgNB-UL-GTP-TEIDatPDCP', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent_rlc_Mode = ENUM(name='rlc-Mode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'RLCMode')), opt=True)
    _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent_dL_Forwarding_GTPtunnelEndpoint = SEQ(name='dL-Forwarding-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent_uL_Forwarding_GTPtunnelEndpoint = SEQ(name='uL-Forwarding-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent_mCG_E_RAB_Level_QoS_Parameters = SEQ(name='mCG-E-RAB-Level-QoS-Parameters', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-Level-QoS-Parameters')), opt=True)
    _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent_uL_Configuration = SEQ(name='uL-Configuration', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ULConfiguration')), opt=True)
    _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PDCPSnLength')))
    _____E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PDCPSnLength')))
    _____E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_2 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TransportLayerAddress')))
    _____E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SecurityResult')))
    ____E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 302), ('criticality', 'ignore'), ('Extension', _____E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 311), ('criticality', 'ignore'), ('Extension', _____E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 412), ('criticality', 'ignore'), ('Extension', _____E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 436), ('criticality', 'ignore'), ('Extension', _____E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent_iE_Extensions__item__id._const_tab = ____E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent_iE_Extensions__item__criticality._const_tab = ____E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent_iE_Extensions__item__id),
        ('criticality', ___E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent_iE_Extensions__item_._ext = None
    _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent_iE_Extensions._cont = __E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent_iE_Extensions__item_
    _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent._cont = ASN1Dict([
        ('s1-DL-GTPtunnelEndpoint', _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent_s1_DL_GTPtunnelEndpoint),
        ('sgNB-UL-GTP-TEIDatPDCP', _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent_sgNB_UL_GTP_TEIDatPDCP),
        ('rlc-Mode', _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent_rlc_Mode),
        ('dL-Forwarding-GTPtunnelEndpoint', _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent_dL_Forwarding_GTPtunnelEndpoint),
        ('uL-Forwarding-GTPtunnelEndpoint', _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent_uL_Forwarding_GTPtunnelEndpoint),
        ('mCG-E-RAB-Level-QoS-Parameters', _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent_mCG_E_RAB_Level_QoS_Parameters),
        ('uL-Configuration', _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent_uL_Configuration),
        ('iE-Extensions', _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent_iE_Extensions),
        ])
    E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent._ext = []
    
    #-----< E-RABs-Admitted-ToBeAdded-SgNBAddReqAck-Item-SgNBPDCPpresentExtIEs >-----#
    E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresentExtIEs = CLASS(name='E-RABs-Admitted-ToBeAdded-SgNBAddReqAck-Item-SgNBPDCPpresentExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresentExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PDCPSnLength')))
    _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresentExtIEs_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PDCPSnLength')))
    _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresentExtIEs_val_Extension_2 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TransportLayerAddress')))
    _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresentExtIEs_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SecurityResult')))
    E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresentExtIEs._val = ASN1Set(rv=[dict([('id', 302), ('criticality', 'ignore'), ('Extension', _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresentExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 311), ('criticality', 'ignore'), ('Extension', _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresentExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 412), ('criticality', 'ignore'), ('Extension', _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresentExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 436), ('criticality', 'ignore'), ('Extension', _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresentExtIEs_val_Extension_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-Admitted-ToBeAdded-SgNBAddReqAck-Item-SgNBPDCPnotpresent >-----#
    E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPnotpresent = SEQ(name='E-RABs-Admitted-ToBeAdded-SgNBAddReqAck-Item-SgNBPDCPnotpresent', mode=MODE_TYPE)
    _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPnotpresent_sgNB_DL_GTP_TEIDatSCG = SEQ(name='sgNB-DL-GTP-TEIDatSCG', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')))
    _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPnotpresent_secondary_sgNB_DL_GTP_TEIDatSCG = SEQ(name='secondary-sgNB-DL-GTP-TEIDatSCG', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPnotpresent_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPnotpresent_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'LCID')))
    ____E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 314), ('criticality', 'ignore'), ('Extension', _____E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__id._const_tab = ____E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality._const_tab = ____E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPnotpresent_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__id),
        ('criticality', ___E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPnotpresent_iE_Extensions__item_._ext = None
    _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPnotpresent_iE_Extensions._cont = __E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPnotpresent_iE_Extensions__item_
    _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPnotpresent_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPnotpresent._cont = ASN1Dict([
        ('sgNB-DL-GTP-TEIDatSCG', _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPnotpresent_sgNB_DL_GTP_TEIDatSCG),
        ('secondary-sgNB-DL-GTP-TEIDatSCG', _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPnotpresent_secondary_sgNB_DL_GTP_TEIDatSCG),
        ('iE-Extensions', _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPnotpresent_iE_Extensions),
        ])
    E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPnotpresent._ext = []
    
    #-----< E-RABs-Admitted-ToBeAdded-SgNBAddReqAck-Item-SgNBPDCPnotpresentExtIEs >-----#
    E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPnotpresentExtIEs = CLASS(name='E-RABs-Admitted-ToBeAdded-SgNBAddReqAck-Item-SgNBPDCPnotpresentExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPnotpresentExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'LCID')))
    E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPnotpresentExtIEs._val = ASN1Set(rv=[dict([('id', 314), ('criticality', 'ignore'), ('Extension', _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPnotpresentExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< SgNBAdditionRequestReject >-----#
    SgNBAdditionRequestReject = SEQ(name='SgNBAdditionRequestReject', mode=MODE_TYPE)
    _SgNBAdditionRequestReject_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __SgNBAdditionRequestReject_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___SgNBAdditionRequestReject_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____SgNBAdditionRequestReject_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____SgNBAdditionRequestReject_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SgNBAdditionRequestReject_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNB-UE-X2AP-ID')))
    _____SgNBAdditionRequestReject_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _____SgNBAdditionRequestReject_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _____SgNBAdditionRequestReject_protocolIEs__item__id_tab_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    ____SgNBAdditionRequestReject_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'reject'), ('Value', _____SgNBAdditionRequestReject_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 207), ('criticality', 'reject'), ('Value', _____SgNBAdditionRequestReject_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _____SgNBAdditionRequestReject_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _____SgNBAdditionRequestReject_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 157), ('criticality', 'reject'), ('Value', _____SgNBAdditionRequestReject_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SgNBAdditionRequestReject_protocolIEs__item__id._const_tab = ____SgNBAdditionRequestReject_protocolIEs__item__id_tab
    ___SgNBAdditionRequestReject_protocolIEs__item__id._const_tab_at = None
    ___SgNBAdditionRequestReject_protocolIEs__item__id._const_tab_id = 'id'
    ___SgNBAdditionRequestReject_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___SgNBAdditionRequestReject_protocolIEs__item__criticality._const_tab = ____SgNBAdditionRequestReject_protocolIEs__item__id_tab
    ___SgNBAdditionRequestReject_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___SgNBAdditionRequestReject_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___SgNBAdditionRequestReject_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___SgNBAdditionRequestReject_protocolIEs__item__value._const_tab = ____SgNBAdditionRequestReject_protocolIEs__item__id_tab
    ___SgNBAdditionRequestReject_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___SgNBAdditionRequestReject_protocolIEs__item__value._const_tab_id = 'Value'
    __SgNBAdditionRequestReject_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___SgNBAdditionRequestReject_protocolIEs__item__id),
        ('criticality', ___SgNBAdditionRequestReject_protocolIEs__item__criticality),
        ('value', ___SgNBAdditionRequestReject_protocolIEs__item__value),
        ])
    __SgNBAdditionRequestReject_protocolIEs__item_._ext = None
    _SgNBAdditionRequestReject_protocolIEs._cont = __SgNBAdditionRequestReject_protocolIEs__item_
    _SgNBAdditionRequestReject_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    SgNBAdditionRequestReject._cont = ASN1Dict([
        ('protocolIEs', _SgNBAdditionRequestReject_protocolIEs),
        ])
    SgNBAdditionRequestReject._ext = []
    
    #-----< SgNBAdditionRequestReject-IEs >-----#
    SgNBAdditionRequestReject_IEs = CLASS(name='SgNBAdditionRequestReject-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _SgNBAdditionRequestReject_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SgNBAdditionRequestReject_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNB-UE-X2AP-ID')))
    _SgNBAdditionRequestReject_IEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _SgNBAdditionRequestReject_IEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _SgNBAdditionRequestReject_IEs_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    SgNBAdditionRequestReject_IEs._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'reject'), ('Value', _SgNBAdditionRequestReject_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 207), ('criticality', 'reject'), ('Value', _SgNBAdditionRequestReject_IEs_val_Value_1), ('presence', 'optional')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _SgNBAdditionRequestReject_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _SgNBAdditionRequestReject_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 157), ('criticality', 'reject'), ('Value', _SgNBAdditionRequestReject_IEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< SgNBReconfigurationComplete >-----#
    SgNBReconfigurationComplete = SEQ(name='SgNBReconfigurationComplete', mode=MODE_TYPE)
    _SgNBReconfigurationComplete_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __SgNBReconfigurationComplete_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___SgNBReconfigurationComplete_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____SgNBReconfigurationComplete_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____SgNBReconfigurationComplete_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SgNBReconfigurationComplete_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNB-UE-X2AP-ID')))
    _____SgNBReconfigurationComplete_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResponseInformationSgNBReconfComp')))
    _____SgNBReconfigurationComplete_protocolIEs__item__id_tab_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    ____SgNBReconfigurationComplete_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'reject'), ('Value', _____SgNBReconfigurationComplete_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 207), ('criticality', 'reject'), ('Value', _____SgNBReconfigurationComplete_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 214), ('criticality', 'ignore'), ('Value', _____SgNBReconfigurationComplete_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 157), ('criticality', 'reject'), ('Value', _____SgNBReconfigurationComplete_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SgNBReconfigurationComplete_protocolIEs__item__id._const_tab = ____SgNBReconfigurationComplete_protocolIEs__item__id_tab
    ___SgNBReconfigurationComplete_protocolIEs__item__id._const_tab_at = None
    ___SgNBReconfigurationComplete_protocolIEs__item__id._const_tab_id = 'id'
    ___SgNBReconfigurationComplete_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___SgNBReconfigurationComplete_protocolIEs__item__criticality._const_tab = ____SgNBReconfigurationComplete_protocolIEs__item__id_tab
    ___SgNBReconfigurationComplete_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___SgNBReconfigurationComplete_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___SgNBReconfigurationComplete_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___SgNBReconfigurationComplete_protocolIEs__item__value._const_tab = ____SgNBReconfigurationComplete_protocolIEs__item__id_tab
    ___SgNBReconfigurationComplete_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___SgNBReconfigurationComplete_protocolIEs__item__value._const_tab_id = 'Value'
    __SgNBReconfigurationComplete_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___SgNBReconfigurationComplete_protocolIEs__item__id),
        ('criticality', ___SgNBReconfigurationComplete_protocolIEs__item__criticality),
        ('value', ___SgNBReconfigurationComplete_protocolIEs__item__value),
        ])
    __SgNBReconfigurationComplete_protocolIEs__item_._ext = None
    _SgNBReconfigurationComplete_protocolIEs._cont = __SgNBReconfigurationComplete_protocolIEs__item_
    _SgNBReconfigurationComplete_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    SgNBReconfigurationComplete._cont = ASN1Dict([
        ('protocolIEs', _SgNBReconfigurationComplete_protocolIEs),
        ])
    SgNBReconfigurationComplete._ext = []
    
    #-----< SgNBReconfigurationComplete-IEs >-----#
    SgNBReconfigurationComplete_IEs = CLASS(name='SgNBReconfigurationComplete-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _SgNBReconfigurationComplete_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SgNBReconfigurationComplete_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNB-UE-X2AP-ID')))
    _SgNBReconfigurationComplete_IEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResponseInformationSgNBReconfComp')))
    _SgNBReconfigurationComplete_IEs_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    SgNBReconfigurationComplete_IEs._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'reject'), ('Value', _SgNBReconfigurationComplete_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 207), ('criticality', 'reject'), ('Value', _SgNBReconfigurationComplete_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 214), ('criticality', 'ignore'), ('Value', _SgNBReconfigurationComplete_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 157), ('criticality', 'reject'), ('Value', _SgNBReconfigurationComplete_IEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ResponseInformationSgNBReconfComp >-----#
    ResponseInformationSgNBReconfComp = CHOICE(name='ResponseInformationSgNBReconfComp', mode=MODE_TYPE)
    _ResponseInformationSgNBReconfComp_success_SgNBReconfComp = SEQ(name='success-SgNBReconfComp', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResponseInformationSgNBReconfComp-SuccessItem')))
    _ResponseInformationSgNBReconfComp_reject_by_MeNB_SgNBReconfComp = SEQ(name='reject-by-MeNB-SgNBReconfComp', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResponseInformationSgNBReconfComp-RejectByMeNBItem')))
    ResponseInformationSgNBReconfComp._cont = ASN1Dict([
        ('success-SgNBReconfComp', _ResponseInformationSgNBReconfComp_success_SgNBReconfComp),
        ('reject-by-MeNB-SgNBReconfComp', _ResponseInformationSgNBReconfComp_reject_by_MeNB_SgNBReconfComp),
        ])
    ResponseInformationSgNBReconfComp._ext = []
    
    #-----< ResponseInformationSgNBReconfComp-SuccessItem >-----#
    ResponseInformationSgNBReconfComp_SuccessItem = SEQ(name='ResponseInformationSgNBReconfComp-SuccessItem', mode=MODE_TYPE)
    _ResponseInformationSgNBReconfComp_SuccessItem_meNBtoSgNBContainer = OCT_STR(name='meNBtoSgNBContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'MeNBtoSgNBContainer')), opt=True)
    _ResponseInformationSgNBReconfComp_SuccessItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResponseInformationSgNBReconfComp_SuccessItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___ResponseInformationSgNBReconfComp_SuccessItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____ResponseInformationSgNBReconfComp_SuccessItem_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ResponseInformationSgNBReconfComp_SuccessItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResponseInformationSgNBReconfComp_SuccessItem_iE_Extensions__item__id._const_tab = ____ResponseInformationSgNBReconfComp_SuccessItem_iE_Extensions__item__id_tab
    ___ResponseInformationSgNBReconfComp_SuccessItem_iE_Extensions__item__id._const_tab_at = None
    ___ResponseInformationSgNBReconfComp_SuccessItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___ResponseInformationSgNBReconfComp_SuccessItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ResponseInformationSgNBReconfComp_SuccessItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ResponseInformationSgNBReconfComp_SuccessItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResponseInformationSgNBReconfComp_SuccessItem_iE_Extensions__item__criticality._const_tab = ____ResponseInformationSgNBReconfComp_SuccessItem_iE_Extensions__item__criticality_tab
    ___ResponseInformationSgNBReconfComp_SuccessItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ResponseInformationSgNBReconfComp_SuccessItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ResponseInformationSgNBReconfComp_SuccessItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ResponseInformationSgNBReconfComp_SuccessItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ResponseInformationSgNBReconfComp_SuccessItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResponseInformationSgNBReconfComp_SuccessItem_iE_Extensions__item__extensionValue._const_tab = ____ResponseInformationSgNBReconfComp_SuccessItem_iE_Extensions__item__extensionValue_tab
    ___ResponseInformationSgNBReconfComp_SuccessItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ResponseInformationSgNBReconfComp_SuccessItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ResponseInformationSgNBReconfComp_SuccessItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ResponseInformationSgNBReconfComp_SuccessItem_iE_Extensions__item__id),
        ('criticality', ___ResponseInformationSgNBReconfComp_SuccessItem_iE_Extensions__item__criticality),
        ('extensionValue', ___ResponseInformationSgNBReconfComp_SuccessItem_iE_Extensions__item__extensionValue),
        ])
    __ResponseInformationSgNBReconfComp_SuccessItem_iE_Extensions__item_._ext = None
    _ResponseInformationSgNBReconfComp_SuccessItem_iE_Extensions._cont = __ResponseInformationSgNBReconfComp_SuccessItem_iE_Extensions__item_
    _ResponseInformationSgNBReconfComp_SuccessItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResponseInformationSgNBReconfComp_SuccessItem._cont = ASN1Dict([
        ('meNBtoSgNBContainer', _ResponseInformationSgNBReconfComp_SuccessItem_meNBtoSgNBContainer),
        ('iE-Extensions', _ResponseInformationSgNBReconfComp_SuccessItem_iE_Extensions),
        ])
    ResponseInformationSgNBReconfComp_SuccessItem._ext = []
    
    #-----< ResponseInformationSgNBReconfComp-SuccessItemExtIEs >-----#
    ResponseInformationSgNBReconfComp_SuccessItemExtIEs = CLASS(name='ResponseInformationSgNBReconfComp-SuccessItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ResponseInformationSgNBReconfComp_SuccessItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResponseInformationSgNBReconfComp-RejectByMeNBItem >-----#
    ResponseInformationSgNBReconfComp_RejectByMeNBItem = SEQ(name='ResponseInformationSgNBReconfComp-RejectByMeNBItem', mode=MODE_TYPE)
    _ResponseInformationSgNBReconfComp_RejectByMeNBItem_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _ResponseInformationSgNBReconfComp_RejectByMeNBItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResponseInformationSgNBReconfComp_RejectByMeNBItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___ResponseInformationSgNBReconfComp_RejectByMeNBItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____ResponseInformationSgNBReconfComp_RejectByMeNBItem_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ResponseInformationSgNBReconfComp_RejectByMeNBItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResponseInformationSgNBReconfComp_RejectByMeNBItem_iE_Extensions__item__id._const_tab = ____ResponseInformationSgNBReconfComp_RejectByMeNBItem_iE_Extensions__item__id_tab
    ___ResponseInformationSgNBReconfComp_RejectByMeNBItem_iE_Extensions__item__id._const_tab_at = None
    ___ResponseInformationSgNBReconfComp_RejectByMeNBItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___ResponseInformationSgNBReconfComp_RejectByMeNBItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ResponseInformationSgNBReconfComp_RejectByMeNBItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ResponseInformationSgNBReconfComp_RejectByMeNBItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResponseInformationSgNBReconfComp_RejectByMeNBItem_iE_Extensions__item__criticality._const_tab = ____ResponseInformationSgNBReconfComp_RejectByMeNBItem_iE_Extensions__item__criticality_tab
    ___ResponseInformationSgNBReconfComp_RejectByMeNBItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ResponseInformationSgNBReconfComp_RejectByMeNBItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ResponseInformationSgNBReconfComp_RejectByMeNBItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ResponseInformationSgNBReconfComp_RejectByMeNBItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ResponseInformationSgNBReconfComp_RejectByMeNBItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResponseInformationSgNBReconfComp_RejectByMeNBItem_iE_Extensions__item__extensionValue._const_tab = ____ResponseInformationSgNBReconfComp_RejectByMeNBItem_iE_Extensions__item__extensionValue_tab
    ___ResponseInformationSgNBReconfComp_RejectByMeNBItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ResponseInformationSgNBReconfComp_RejectByMeNBItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ResponseInformationSgNBReconfComp_RejectByMeNBItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ResponseInformationSgNBReconfComp_RejectByMeNBItem_iE_Extensions__item__id),
        ('criticality', ___ResponseInformationSgNBReconfComp_RejectByMeNBItem_iE_Extensions__item__criticality),
        ('extensionValue', ___ResponseInformationSgNBReconfComp_RejectByMeNBItem_iE_Extensions__item__extensionValue),
        ])
    __ResponseInformationSgNBReconfComp_RejectByMeNBItem_iE_Extensions__item_._ext = None
    _ResponseInformationSgNBReconfComp_RejectByMeNBItem_iE_Extensions._cont = __ResponseInformationSgNBReconfComp_RejectByMeNBItem_iE_Extensions__item_
    _ResponseInformationSgNBReconfComp_RejectByMeNBItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResponseInformationSgNBReconfComp_RejectByMeNBItem._cont = ASN1Dict([
        ('cause', _ResponseInformationSgNBReconfComp_RejectByMeNBItem_cause),
        ('iE-Extensions', _ResponseInformationSgNBReconfComp_RejectByMeNBItem_iE_Extensions),
        ])
    ResponseInformationSgNBReconfComp_RejectByMeNBItem._ext = []
    
    #-----< ResponseInformationSgNBReconfComp-RejectByMeNBItemExtIEs >-----#
    ResponseInformationSgNBReconfComp_RejectByMeNBItemExtIEs = CLASS(name='ResponseInformationSgNBReconfComp-RejectByMeNBItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ResponseInformationSgNBReconfComp_RejectByMeNBItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SgNBModificationRequest >-----#
    SgNBModificationRequest = SEQ(name='SgNBModificationRequest', mode=MODE_TYPE)
    _SgNBModificationRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __SgNBModificationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___SgNBModificationRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____SgNBModificationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNB-UE-X2AP-ID')))
    _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_3 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PLMN-Identity')))
    _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'HandoverRestrictionList')))
    _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_5 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SCGConfigurationQuery')))
    _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'UE-ContextInformation-SgNBModReq')))
    _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_7 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MeNBtoSgNBContainer')))
    _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_8 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_9 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MeNBResourceCoordinationInformation')))
    _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_10 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SplitSRBs')))
    _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_11 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SplitSRBs')))
    _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_12 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'DesiredActNotificationLevel')))
    _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_13 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'LocationInformationSgNBReporting')))
    _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_14 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_15 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'RequestedFastMCGRecoveryViaSRB3')))
    _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_16 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'RequestedFastMCGRecoveryViaSRB3Release')))
    _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_17 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SNtriggered')))
    _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_18 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'IABNodeIndication')))
    _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_19 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PSCellHistoryInformationRetrieve')))
    _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_20 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-HistoryInformationFromTheUE')))
    _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_21 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CHOinformation-ModReq')))
    _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_22 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SCGActivationRequest')))
    _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_23 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CPAinformation-MOD')))
    _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_24 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CPCupdate-MOD')))
    ____SgNBModificationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'reject'), ('Value', _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 207), ('criticality', 'reject'), ('Value', _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 269), ('criticality', 'ignore'), ('Value', _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 240), ('criticality', 'ignore'), ('Value', _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 241), ('criticality', 'ignore'), ('Value', _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 215), ('criticality', 'reject'), ('Value', _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 206), ('criticality', 'reject'), ('Value', _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')]), dict([('id', 157), ('criticality', 'reject'), ('Value', _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_8), ('presence', 'optional')]), dict([('id', 257), ('criticality', 'ignore'), ('Value', _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_9), ('presence', 'optional')]), dict([('id', 208), ('criticality', 'ignore'), ('Value', _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_10), ('presence', 'optional')]), dict([('id', 280), ('criticality', 'ignore'), ('Value', _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_11), ('presence', 'optional')]), dict([('id', 329), ('criticality', 'ignore'), ('Value', _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_12), ('presence', 'optional')]), dict([('id', 330), ('criticality', 'ignore'), ('Value', _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_13), ('presence', 'optional')]), dict([('id', 279), ('criticality', 'ignore'), ('Value', _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_14), ('presence', 'optional')]), dict([('id', 343), ('criticality', 'ignore'), ('Value', _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_15), ('presence', 'optional')]), dict([('id', 345), ('criticality', 'ignore'), ('Value', _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_16), ('presence', 'optional')]), dict([('id', 379), ('criticality', 'ignore'), ('Value', _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_17), ('presence', 'optional')]), dict([('id', 395), ('criticality', 'reject'), ('Value', _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_18), ('presence', 'optional')]), dict([('id', 416), ('criticality', 'ignore'), ('Value', _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_19), ('presence', 'optional')]), dict([('id', 105), ('criticality', 'ignore'), ('Value', _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_20), ('presence', 'optional')]), dict([('id', 421), ('criticality', 'ignore'), ('Value', _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_21), ('presence', 'optional')]), dict([('id', 423), ('criticality', 'ignore'), ('Value', _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_22), ('presence', 'optional')]), dict([('id', 426), ('criticality', 'ignore'), ('Value', _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_23), ('presence', 'optional')]), dict([('id', 432), ('criticality', 'ignore'), ('Value', _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_24), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SgNBModificationRequest_protocolIEs__item__id._const_tab = ____SgNBModificationRequest_protocolIEs__item__id_tab
    ___SgNBModificationRequest_protocolIEs__item__id._const_tab_at = None
    ___SgNBModificationRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___SgNBModificationRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___SgNBModificationRequest_protocolIEs__item__criticality._const_tab = ____SgNBModificationRequest_protocolIEs__item__id_tab
    ___SgNBModificationRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___SgNBModificationRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___SgNBModificationRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___SgNBModificationRequest_protocolIEs__item__value._const_tab = ____SgNBModificationRequest_protocolIEs__item__id_tab
    ___SgNBModificationRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___SgNBModificationRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __SgNBModificationRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___SgNBModificationRequest_protocolIEs__item__id),
        ('criticality', ___SgNBModificationRequest_protocolIEs__item__criticality),
        ('value', ___SgNBModificationRequest_protocolIEs__item__value),
        ])
    __SgNBModificationRequest_protocolIEs__item_._ext = None
    _SgNBModificationRequest_protocolIEs._cont = __SgNBModificationRequest_protocolIEs__item_
    _SgNBModificationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    SgNBModificationRequest._cont = ASN1Dict([
        ('protocolIEs', _SgNBModificationRequest_protocolIEs),
        ])
    SgNBModificationRequest._ext = []
    
    #-----< SgNBModificationRequest-IEs >-----#
    SgNBModificationRequest_IEs = CLASS(name='SgNBModificationRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _SgNBModificationRequest_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SgNBModificationRequest_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNB-UE-X2AP-ID')))
    _SgNBModificationRequest_IEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _SgNBModificationRequest_IEs_val_Value_3 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PLMN-Identity')))
    _SgNBModificationRequest_IEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'HandoverRestrictionList')))
    _SgNBModificationRequest_IEs_val_Value_5 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SCGConfigurationQuery')))
    _SgNBModificationRequest_IEs_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'UE-ContextInformation-SgNBModReq')))
    _SgNBModificationRequest_IEs_val_Value_7 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MeNBtoSgNBContainer')))
    _SgNBModificationRequest_IEs_val_Value_8 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _SgNBModificationRequest_IEs_val_Value_9 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MeNBResourceCoordinationInformation')))
    _SgNBModificationRequest_IEs_val_Value_10 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SplitSRBs')))
    _SgNBModificationRequest_IEs_val_Value_11 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SplitSRBs')))
    _SgNBModificationRequest_IEs_val_Value_12 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'DesiredActNotificationLevel')))
    _SgNBModificationRequest_IEs_val_Value_13 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'LocationInformationSgNBReporting')))
    _SgNBModificationRequest_IEs_val_Value_14 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _SgNBModificationRequest_IEs_val_Value_15 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'RequestedFastMCGRecoveryViaSRB3')))
    _SgNBModificationRequest_IEs_val_Value_16 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'RequestedFastMCGRecoveryViaSRB3Release')))
    _SgNBModificationRequest_IEs_val_Value_17 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SNtriggered')))
    _SgNBModificationRequest_IEs_val_Value_18 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'IABNodeIndication')))
    _SgNBModificationRequest_IEs_val_Value_19 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PSCellHistoryInformationRetrieve')))
    _SgNBModificationRequest_IEs_val_Value_20 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-HistoryInformationFromTheUE')))
    _SgNBModificationRequest_IEs_val_Value_21 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CHOinformation-ModReq')))
    _SgNBModificationRequest_IEs_val_Value_22 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SCGActivationRequest')))
    _SgNBModificationRequest_IEs_val_Value_23 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CPAinformation-MOD')))
    _SgNBModificationRequest_IEs_val_Value_24 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CPCupdate-MOD')))
    SgNBModificationRequest_IEs._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'reject'), ('Value', _SgNBModificationRequest_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 207), ('criticality', 'reject'), ('Value', _SgNBModificationRequest_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _SgNBModificationRequest_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 269), ('criticality', 'ignore'), ('Value', _SgNBModificationRequest_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 240), ('criticality', 'ignore'), ('Value', _SgNBModificationRequest_IEs_val_Value_4), ('presence', 'optional')]), dict([('id', 241), ('criticality', 'ignore'), ('Value', _SgNBModificationRequest_IEs_val_Value_5), ('presence', 'optional')]), dict([('id', 215), ('criticality', 'reject'), ('Value', _SgNBModificationRequest_IEs_val_Value_6), ('presence', 'optional')]), dict([('id', 206), ('criticality', 'reject'), ('Value', _SgNBModificationRequest_IEs_val_Value_7), ('presence', 'optional')]), dict([('id', 157), ('criticality', 'reject'), ('Value', _SgNBModificationRequest_IEs_val_Value_8), ('presence', 'optional')]), dict([('id', 257), ('criticality', 'ignore'), ('Value', _SgNBModificationRequest_IEs_val_Value_9), ('presence', 'optional')]), dict([('id', 208), ('criticality', 'ignore'), ('Value', _SgNBModificationRequest_IEs_val_Value_10), ('presence', 'optional')]), dict([('id', 280), ('criticality', 'ignore'), ('Value', _SgNBModificationRequest_IEs_val_Value_11), ('presence', 'optional')]), dict([('id', 329), ('criticality', 'ignore'), ('Value', _SgNBModificationRequest_IEs_val_Value_12), ('presence', 'optional')]), dict([('id', 330), ('criticality', 'ignore'), ('Value', _SgNBModificationRequest_IEs_val_Value_13), ('presence', 'optional')]), dict([('id', 279), ('criticality', 'ignore'), ('Value', _SgNBModificationRequest_IEs_val_Value_14), ('presence', 'optional')]), dict([('id', 343), ('criticality', 'ignore'), ('Value', _SgNBModificationRequest_IEs_val_Value_15), ('presence', 'optional')]), dict([('id', 345), ('criticality', 'ignore'), ('Value', _SgNBModificationRequest_IEs_val_Value_16), ('presence', 'optional')]), dict([('id', 379), ('criticality', 'ignore'), ('Value', _SgNBModificationRequest_IEs_val_Value_17), ('presence', 'optional')]), dict([('id', 395), ('criticality', 'reject'), ('Value', _SgNBModificationRequest_IEs_val_Value_18), ('presence', 'optional')]), dict([('id', 416), ('criticality', 'ignore'), ('Value', _SgNBModificationRequest_IEs_val_Value_19), ('presence', 'optional')]), dict([('id', 105), ('criticality', 'ignore'), ('Value', _SgNBModificationRequest_IEs_val_Value_20), ('presence', 'optional')]), dict([('id', 421), ('criticality', 'ignore'), ('Value', _SgNBModificationRequest_IEs_val_Value_21), ('presence', 'optional')]), dict([('id', 423), ('criticality', 'ignore'), ('Value', _SgNBModificationRequest_IEs_val_Value_22), ('presence', 'optional')]), dict([('id', 426), ('criticality', 'ignore'), ('Value', _SgNBModificationRequest_IEs_val_Value_23), ('presence', 'optional')]), dict([('id', 432), ('criticality', 'ignore'), ('Value', _SgNBModificationRequest_IEs_val_Value_24), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UE-ContextInformation-SgNBModReq >-----#
    UE_ContextInformation_SgNBModReq = SEQ(name='UE-ContextInformation-SgNBModReq', mode=MODE_TYPE)
    _UE_ContextInformation_SgNBModReq_nRUE_SecurityCapabilities = SEQ(name='nRUE-SecurityCapabilities', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'NRUESecurityCapabilities')), opt=True)
    _UE_ContextInformation_SgNBModReq_sgNB_SecurityKey = BIT_STR(name='sgNB-SecurityKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'SgNBSecurityKey')), opt=True)
    _UE_ContextInformation_SgNBModReq_sgNBUEAggregateMaximumBitRate = SEQ(name='sgNBUEAggregateMaximumBitRate', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'UEAggregateMaximumBitRate')), opt=True)
    _UE_ContextInformation_SgNBModReq_e_RABs_ToBeAdded = SEQ_OF(name='e-RABs-ToBeAdded', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeAdded-SgNBModReq-List')), opt=True)
    _UE_ContextInformation_SgNBModReq_e_RABs_ToBeModified = SEQ_OF(name='e-RABs-ToBeModified', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeModified-SgNBModReq-List')), opt=True)
    _UE_ContextInformation_SgNBModReq_e_RABs_ToBeReleased = SEQ_OF(name='e-RABs-ToBeReleased', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-SgNBModReq-List')), opt=True)
    _UE_ContextInformation_SgNBModReq_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UE_ContextInformation_SgNBModReq_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___UE_ContextInformation_SgNBModReq_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____UE_ContextInformation_SgNBModReq_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____UE_ContextInformation_SgNBModReq_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SubscriberProfileIDforRFP')))
    _____UE_ContextInformation_SgNBModReq_iE_Extensions__item__id_tab_val_Extension_1 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'AdditionalRRMPriorityIndex')))
    _____UE_ContextInformation_SgNBModReq_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'LowerLayerPresenceStatusChange')))
    ____UE_ContextInformation_SgNBModReq_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 275), ('criticality', 'ignore'), ('Extension', _____UE_ContextInformation_SgNBModReq_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 340), ('criticality', 'ignore'), ('Extension', _____UE_ContextInformation_SgNBModReq_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 341), ('criticality', 'ignore'), ('Extension', _____UE_ContextInformation_SgNBModReq_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UE_ContextInformation_SgNBModReq_iE_Extensions__item__id._const_tab = ____UE_ContextInformation_SgNBModReq_iE_Extensions__item__id_tab
    ___UE_ContextInformation_SgNBModReq_iE_Extensions__item__id._const_tab_at = None
    ___UE_ContextInformation_SgNBModReq_iE_Extensions__item__id._const_tab_id = 'id'
    ___UE_ContextInformation_SgNBModReq_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___UE_ContextInformation_SgNBModReq_iE_Extensions__item__criticality._const_tab = ____UE_ContextInformation_SgNBModReq_iE_Extensions__item__id_tab
    ___UE_ContextInformation_SgNBModReq_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UE_ContextInformation_SgNBModReq_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UE_ContextInformation_SgNBModReq_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___UE_ContextInformation_SgNBModReq_iE_Extensions__item__extensionValue._const_tab = ____UE_ContextInformation_SgNBModReq_iE_Extensions__item__id_tab
    ___UE_ContextInformation_SgNBModReq_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UE_ContextInformation_SgNBModReq_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UE_ContextInformation_SgNBModReq_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UE_ContextInformation_SgNBModReq_iE_Extensions__item__id),
        ('criticality', ___UE_ContextInformation_SgNBModReq_iE_Extensions__item__criticality),
        ('extensionValue', ___UE_ContextInformation_SgNBModReq_iE_Extensions__item__extensionValue),
        ])
    __UE_ContextInformation_SgNBModReq_iE_Extensions__item_._ext = None
    _UE_ContextInformation_SgNBModReq_iE_Extensions._cont = __UE_ContextInformation_SgNBModReq_iE_Extensions__item_
    _UE_ContextInformation_SgNBModReq_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UE_ContextInformation_SgNBModReq._cont = ASN1Dict([
        ('nRUE-SecurityCapabilities', _UE_ContextInformation_SgNBModReq_nRUE_SecurityCapabilities),
        ('sgNB-SecurityKey', _UE_ContextInformation_SgNBModReq_sgNB_SecurityKey),
        ('sgNBUEAggregateMaximumBitRate', _UE_ContextInformation_SgNBModReq_sgNBUEAggregateMaximumBitRate),
        ('e-RABs-ToBeAdded', _UE_ContextInformation_SgNBModReq_e_RABs_ToBeAdded),
        ('e-RABs-ToBeModified', _UE_ContextInformation_SgNBModReq_e_RABs_ToBeModified),
        ('e-RABs-ToBeReleased', _UE_ContextInformation_SgNBModReq_e_RABs_ToBeReleased),
        ('iE-Extensions', _UE_ContextInformation_SgNBModReq_iE_Extensions),
        ])
    UE_ContextInformation_SgNBModReq._ext = []
    
    #-----< UE-ContextInformationSgNBModReqExtIEs >-----#
    UE_ContextInformationSgNBModReqExtIEs = CLASS(name='UE-ContextInformationSgNBModReqExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _UE_ContextInformationSgNBModReqExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SubscriberProfileIDforRFP')))
    _UE_ContextInformationSgNBModReqExtIEs_val_Extension_1 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'AdditionalRRMPriorityIndex')))
    _UE_ContextInformationSgNBModReqExtIEs_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'LowerLayerPresenceStatusChange')))
    UE_ContextInformationSgNBModReqExtIEs._val = ASN1Set(rv=[dict([('id', 275), ('criticality', 'ignore'), ('Extension', _UE_ContextInformationSgNBModReqExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 340), ('criticality', 'ignore'), ('Extension', _UE_ContextInformationSgNBModReqExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 341), ('criticality', 'ignore'), ('Extension', _UE_ContextInformationSgNBModReqExtIEs_val_Extension_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeAdded-SgNBModReq-List >-----#
    E_RABs_ToBeAdded_SgNBModReq_List = SEQ_OF(name='E-RABs-ToBeAdded-SgNBModReq-List', mode=MODE_TYPE)
    _E_RABs_ToBeAdded_SgNBModReq_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __E_RABs_ToBeAdded_SgNBModReq_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ___E_RABs_ToBeAdded_SgNBModReq_List__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____E_RABs_ToBeAdded_SgNBModReq_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeAdded-SgNBModReq-Item')))
    ___E_RABs_ToBeAdded_SgNBModReq_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 216), ('criticality', 'ignore'), ('Value', ____E_RABs_ToBeAdded_SgNBModReq_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E_RABs_ToBeAdded_SgNBModReq_List__item__id._const_tab = ___E_RABs_ToBeAdded_SgNBModReq_List__item__id_tab
    __E_RABs_ToBeAdded_SgNBModReq_List__item__id._const_tab_at = None
    __E_RABs_ToBeAdded_SgNBModReq_List__item__id._const_tab_id = 'id'
    __E_RABs_ToBeAdded_SgNBModReq_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    __E_RABs_ToBeAdded_SgNBModReq_List__item__criticality._const_tab = ___E_RABs_ToBeAdded_SgNBModReq_List__item__id_tab
    __E_RABs_ToBeAdded_SgNBModReq_List__item__criticality._const_tab_at = ('..', 'id')
    __E_RABs_ToBeAdded_SgNBModReq_List__item__criticality._const_tab_id = 'criticality'
    __E_RABs_ToBeAdded_SgNBModReq_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    __E_RABs_ToBeAdded_SgNBModReq_List__item__value._const_tab = ___E_RABs_ToBeAdded_SgNBModReq_List__item__id_tab
    __E_RABs_ToBeAdded_SgNBModReq_List__item__value._const_tab_at = ('..', 'id')
    __E_RABs_ToBeAdded_SgNBModReq_List__item__value._const_tab_id = 'Value'
    _E_RABs_ToBeAdded_SgNBModReq_List__item_._cont = ASN1Dict([
        ('id', __E_RABs_ToBeAdded_SgNBModReq_List__item__id),
        ('criticality', __E_RABs_ToBeAdded_SgNBModReq_List__item__criticality),
        ('value', __E_RABs_ToBeAdded_SgNBModReq_List__item__value),
        ])
    _E_RABs_ToBeAdded_SgNBModReq_List__item_._ext = None
    E_RABs_ToBeAdded_SgNBModReq_List._cont = _E_RABs_ToBeAdded_SgNBModReq_List__item_
    E_RABs_ToBeAdded_SgNBModReq_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABs-ToBeAdded-SgNBModReq-ItemIEs >-----#
    E_RABs_ToBeAdded_SgNBModReq_ItemIEs = CLASS(name='E-RABs-ToBeAdded-SgNBModReq-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _E_RABs_ToBeAdded_SgNBModReq_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeAdded-SgNBModReq-Item')))
    E_RABs_ToBeAdded_SgNBModReq_ItemIEs._val = ASN1Set(rv=[dict([('id', 216), ('criticality', 'ignore'), ('Value', _E_RABs_ToBeAdded_SgNBModReq_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeAdded-SgNBModReq-Item >-----#
    E_RABs_ToBeAdded_SgNBModReq_Item = SEQ(name='E-RABs-ToBeAdded-SgNBModReq-Item', mode=MODE_TYPE)
    _E_RABs_ToBeAdded_SgNBModReq_Item_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_ToBeAdded_SgNBModReq_Item_drb_ID = INT(name='drb-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'DRB-ID')))
    _E_RABs_ToBeAdded_SgNBModReq_Item_en_DC_ResourceConfiguration = SEQ(name='en-DC-ResourceConfiguration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'EN-DC-ResourceConfiguration')))
    _E_RABs_ToBeAdded_SgNBModReq_Item_resource_configuration = CHOICE(name='resource-configuration', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __E_RABs_ToBeAdded_SgNBModReq_Item_resource_configuration_sgNBPDCPpresent = SEQ(name='sgNBPDCPpresent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeAdded-SgNBModReq-Item-SgNBPDCPpresent')))
    __E_RABs_ToBeAdded_SgNBModReq_Item_resource_configuration_sgNBPDCPnotpresent = SEQ(name='sgNBPDCPnotpresent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeAdded-SgNBModReq-Item-SgNBPDCPnotpresent')))
    _E_RABs_ToBeAdded_SgNBModReq_Item_resource_configuration._cont = ASN1Dict([
        ('sgNBPDCPpresent', __E_RABs_ToBeAdded_SgNBModReq_Item_resource_configuration_sgNBPDCPpresent),
        ('sgNBPDCPnotpresent', __E_RABs_ToBeAdded_SgNBModReq_Item_resource_configuration_sgNBPDCPnotpresent),
        ])
    _E_RABs_ToBeAdded_SgNBModReq_Item_resource_configuration._ext = []
    _E_RABs_ToBeAdded_SgNBModReq_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_ToBeAdded_SgNBModReq_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_ToBeAdded_SgNBModReq_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_ToBeAdded_SgNBModReq_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeAdded_SgNBModReq_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeAdded_SgNBModReq_Item_iE_Extensions__item__id._const_tab = ____E_RABs_ToBeAdded_SgNBModReq_Item_iE_Extensions__item__id_tab
    ___E_RABs_ToBeAdded_SgNBModReq_Item_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_ToBeAdded_SgNBModReq_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_ToBeAdded_SgNBModReq_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_RABs_ToBeAdded_SgNBModReq_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeAdded_SgNBModReq_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeAdded_SgNBModReq_Item_iE_Extensions__item__criticality._const_tab = ____E_RABs_ToBeAdded_SgNBModReq_Item_iE_Extensions__item__criticality_tab
    ___E_RABs_ToBeAdded_SgNBModReq_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeAdded_SgNBModReq_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_ToBeAdded_SgNBModReq_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_RABs_ToBeAdded_SgNBModReq_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeAdded_SgNBModReq_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeAdded_SgNBModReq_Item_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_ToBeAdded_SgNBModReq_Item_iE_Extensions__item__extensionValue_tab
    ___E_RABs_ToBeAdded_SgNBModReq_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeAdded_SgNBModReq_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_ToBeAdded_SgNBModReq_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_ToBeAdded_SgNBModReq_Item_iE_Extensions__item__id),
        ('criticality', ___E_RABs_ToBeAdded_SgNBModReq_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_ToBeAdded_SgNBModReq_Item_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_ToBeAdded_SgNBModReq_Item_iE_Extensions__item_._ext = None
    _E_RABs_ToBeAdded_SgNBModReq_Item_iE_Extensions._cont = __E_RABs_ToBeAdded_SgNBModReq_Item_iE_Extensions__item_
    _E_RABs_ToBeAdded_SgNBModReq_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_ToBeAdded_SgNBModReq_Item._cont = ASN1Dict([
        ('e-RAB-ID', _E_RABs_ToBeAdded_SgNBModReq_Item_e_RAB_ID),
        ('drb-ID', _E_RABs_ToBeAdded_SgNBModReq_Item_drb_ID),
        ('en-DC-ResourceConfiguration', _E_RABs_ToBeAdded_SgNBModReq_Item_en_DC_ResourceConfiguration),
        ('resource-configuration', _E_RABs_ToBeAdded_SgNBModReq_Item_resource_configuration),
        ('iE-Extensions', _E_RABs_ToBeAdded_SgNBModReq_Item_iE_Extensions),
        ])
    E_RABs_ToBeAdded_SgNBModReq_Item._ext = []
    
    #-----< E-RABs-ToBeAdded-SgNBModReq-ItemExtIEs >-----#
    E_RABs_ToBeAdded_SgNBModReq_ItemExtIEs = CLASS(name='E-RABs-ToBeAdded-SgNBModReq-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    E_RABs_ToBeAdded_SgNBModReq_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeAdded-SgNBModReq-Item-SgNBPDCPpresent >-----#
    E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresent = SEQ(name='E-RABs-ToBeAdded-SgNBModReq-Item-SgNBPDCPpresent', mode=MODE_TYPE)
    _E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresent_full_E_RAB_Level_QoS_Parameters = SEQ(name='full-E-RAB-Level-QoS-Parameters', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-Level-QoS-Parameters')))
    _E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresent_max_MN_admit_E_RAB_Level_QoS_Parameters = SEQ(name='max-MN-admit-E-RAB-Level-QoS-Parameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GBR-QosInformation')), opt=True)
    _E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresent_dL_Forwarding = ENUM(name='dL-Forwarding', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'DL-Forwarding')), opt=True)
    _E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresent_meNB_DL_GTP_TEIDatMCG = SEQ(name='meNB-DL-GTP-TEIDatMCG', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresent_s1_UL_GTPtunnelEndpoint = SEQ(name='s1-UL-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')))
    _E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'RLCMode')))
    _____E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'BearerType')))
    _____E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Ethernet-Type')))
    _____E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SecurityIndication')))
    _____E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_4 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TransportLayerAddress')))
    ____E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 317), ('criticality', 'ignore'), ('Extension', _____E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 171), ('criticality', 'ignore'), ('Extension', _____E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 369), ('criticality', 'ignore'), ('Extension', _____E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 435), ('criticality', 'reject'), ('Extension', _____E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 412), ('criticality', 'ignore'), ('Extension', _____E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__id._const_tab = ____E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab
    ___E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__criticality._const_tab = ____E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab
    ___E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab
    ___E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__id),
        ('criticality', ___E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item_._ext = None
    _E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions._cont = __E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item_
    _E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresent._cont = ASN1Dict([
        ('full-E-RAB-Level-QoS-Parameters', _E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresent_full_E_RAB_Level_QoS_Parameters),
        ('max-MN-admit-E-RAB-Level-QoS-Parameters', _E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresent_max_MN_admit_E_RAB_Level_QoS_Parameters),
        ('dL-Forwarding', _E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresent_dL_Forwarding),
        ('meNB-DL-GTP-TEIDatMCG', _E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresent_meNB_DL_GTP_TEIDatMCG),
        ('s1-UL-GTPtunnelEndpoint', _E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresent_s1_UL_GTPtunnelEndpoint),
        ('iE-Extensions', _E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions),
        ])
    E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresent._ext = []
    
    #-----< E-RABs-ToBeAdded-SgNBModReq-Item-SgNBPDCPpresentExtIEs >-----#
    E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresentExtIEs = CLASS(name='E-RABs-ToBeAdded-SgNBModReq-Item-SgNBPDCPpresentExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresentExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'RLCMode')))
    _E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresentExtIEs_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'BearerType')))
    _E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresentExtIEs_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Ethernet-Type')))
    _E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresentExtIEs_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SecurityIndication')))
    _E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresentExtIEs_val_Extension_4 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TransportLayerAddress')))
    E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresentExtIEs._val = ASN1Set(rv=[dict([('id', 317), ('criticality', 'ignore'), ('Extension', _E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresentExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 171), ('criticality', 'ignore'), ('Extension', _E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresentExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 369), ('criticality', 'ignore'), ('Extension', _E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresentExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 435), ('criticality', 'reject'), ('Extension', _E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresentExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 412), ('criticality', 'ignore'), ('Extension', _E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresentExtIEs_val_Extension_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeAdded-SgNBModReq-Item-SgNBPDCPnotpresent >-----#
    E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresent = SEQ(name='E-RABs-ToBeAdded-SgNBModReq-Item-SgNBPDCPnotpresent', mode=MODE_TYPE)
    _E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresent_requested_SCG_E_RAB_Level_QoS_Parameters = SEQ(name='requested-SCG-E-RAB-Level-QoS-Parameters', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-Level-QoS-Parameters')))
    _E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresent_meNB_UL_GTP_TEIDatPDCP = SEQ(name='meNB-UL-GTP-TEIDatPDCP', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')))
    _E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresent_secondary_meNB_UL_GTP_TEIDatPDCP = SEQ(name='secondary-meNB-UL-GTP-TEIDatPDCP', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresent_rlc_Mode = ENUM(name='rlc-Mode', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'RLCMode')))
    _E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresent_uL_Configuration = SEQ(name='uL-Configuration', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ULConfiguration')), opt=True)
    _E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PDCPSnLength')))
    _____E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PDCPSnLength')))
    _____E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'DuplicationActivation')))
    ____E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 302), ('criticality', 'ignore'), ('Extension', _____E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 311), ('criticality', 'ignore'), ('Extension', _____E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 315), ('criticality', 'ignore'), ('Extension', _____E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id._const_tab = ____E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab
    ___E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality._const_tab = ____E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab
    ___E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab
    ___E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id),
        ('criticality', ___E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item_._ext = None
    _E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions._cont = __E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item_
    _E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresent._cont = ASN1Dict([
        ('requested-SCG-E-RAB-Level-QoS-Parameters', _E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresent_requested_SCG_E_RAB_Level_QoS_Parameters),
        ('meNB-UL-GTP-TEIDatPDCP', _E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresent_meNB_UL_GTP_TEIDatPDCP),
        ('secondary-meNB-UL-GTP-TEIDatPDCP', _E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresent_secondary_meNB_UL_GTP_TEIDatPDCP),
        ('rlc-Mode', _E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresent_rlc_Mode),
        ('uL-Configuration', _E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresent_uL_Configuration),
        ('iE-Extensions', _E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions),
        ])
    E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresent._ext = []
    
    #-----< E-RABs-ToBeAdded-SgNBModReq-Item-SgNBPDCPnotpresentExtIEs >-----#
    E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresentExtIEs = CLASS(name='E-RABs-ToBeAdded-SgNBModReq-Item-SgNBPDCPnotpresentExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresentExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PDCPSnLength')))
    _E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresentExtIEs_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PDCPSnLength')))
    _E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresentExtIEs_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'DuplicationActivation')))
    E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresentExtIEs._val = ASN1Set(rv=[dict([('id', 302), ('criticality', 'ignore'), ('Extension', _E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresentExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 311), ('criticality', 'ignore'), ('Extension', _E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresentExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 315), ('criticality', 'ignore'), ('Extension', _E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresentExtIEs_val_Extension_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeModified-SgNBModReq-List >-----#
    E_RABs_ToBeModified_SgNBModReq_List = SEQ_OF(name='E-RABs-ToBeModified-SgNBModReq-List', mode=MODE_TYPE)
    _E_RABs_ToBeModified_SgNBModReq_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __E_RABs_ToBeModified_SgNBModReq_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ___E_RABs_ToBeModified_SgNBModReq_List__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____E_RABs_ToBeModified_SgNBModReq_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeModified-SgNBModReq-Item')))
    ___E_RABs_ToBeModified_SgNBModReq_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 217), ('criticality', 'ignore'), ('Value', ____E_RABs_ToBeModified_SgNBModReq_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E_RABs_ToBeModified_SgNBModReq_List__item__id._const_tab = ___E_RABs_ToBeModified_SgNBModReq_List__item__id_tab
    __E_RABs_ToBeModified_SgNBModReq_List__item__id._const_tab_at = None
    __E_RABs_ToBeModified_SgNBModReq_List__item__id._const_tab_id = 'id'
    __E_RABs_ToBeModified_SgNBModReq_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    __E_RABs_ToBeModified_SgNBModReq_List__item__criticality._const_tab = ___E_RABs_ToBeModified_SgNBModReq_List__item__id_tab
    __E_RABs_ToBeModified_SgNBModReq_List__item__criticality._const_tab_at = ('..', 'id')
    __E_RABs_ToBeModified_SgNBModReq_List__item__criticality._const_tab_id = 'criticality'
    __E_RABs_ToBeModified_SgNBModReq_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    __E_RABs_ToBeModified_SgNBModReq_List__item__value._const_tab = ___E_RABs_ToBeModified_SgNBModReq_List__item__id_tab
    __E_RABs_ToBeModified_SgNBModReq_List__item__value._const_tab_at = ('..', 'id')
    __E_RABs_ToBeModified_SgNBModReq_List__item__value._const_tab_id = 'Value'
    _E_RABs_ToBeModified_SgNBModReq_List__item_._cont = ASN1Dict([
        ('id', __E_RABs_ToBeModified_SgNBModReq_List__item__id),
        ('criticality', __E_RABs_ToBeModified_SgNBModReq_List__item__criticality),
        ('value', __E_RABs_ToBeModified_SgNBModReq_List__item__value),
        ])
    _E_RABs_ToBeModified_SgNBModReq_List__item_._ext = None
    E_RABs_ToBeModified_SgNBModReq_List._cont = _E_RABs_ToBeModified_SgNBModReq_List__item_
    E_RABs_ToBeModified_SgNBModReq_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABs-ToBeModified-SgNBModReq-ItemIEs >-----#
    E_RABs_ToBeModified_SgNBModReq_ItemIEs = CLASS(name='E-RABs-ToBeModified-SgNBModReq-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _E_RABs_ToBeModified_SgNBModReq_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeModified-SgNBModReq-Item')))
    E_RABs_ToBeModified_SgNBModReq_ItemIEs._val = ASN1Set(rv=[dict([('id', 217), ('criticality', 'ignore'), ('Value', _E_RABs_ToBeModified_SgNBModReq_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeModified-SgNBModReq-Item >-----#
    E_RABs_ToBeModified_SgNBModReq_Item = SEQ(name='E-RABs-ToBeModified-SgNBModReq-Item', mode=MODE_TYPE)
    _E_RABs_ToBeModified_SgNBModReq_Item_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_ToBeModified_SgNBModReq_Item_en_DC_ResourceConfiguration = SEQ(name='en-DC-ResourceConfiguration', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'EN-DC-ResourceConfiguration')))
    _E_RABs_ToBeModified_SgNBModReq_Item_resource_configuration = CHOICE(name='resource-configuration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __E_RABs_ToBeModified_SgNBModReq_Item_resource_configuration_sgNBPDCPpresent = SEQ(name='sgNBPDCPpresent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeModified-SgNBModReq-Item-SgNBPDCPpresent')))
    __E_RABs_ToBeModified_SgNBModReq_Item_resource_configuration_sgNBPDCPnotpresent = SEQ(name='sgNBPDCPnotpresent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeModified-SgNBModReq-Item-SgNBPDCPnotpresent')))
    _E_RABs_ToBeModified_SgNBModReq_Item_resource_configuration._cont = ASN1Dict([
        ('sgNBPDCPpresent', __E_RABs_ToBeModified_SgNBModReq_Item_resource_configuration_sgNBPDCPpresent),
        ('sgNBPDCPnotpresent', __E_RABs_ToBeModified_SgNBModReq_Item_resource_configuration_sgNBPDCPnotpresent),
        ])
    _E_RABs_ToBeModified_SgNBModReq_Item_resource_configuration._ext = []
    _E_RABs_ToBeModified_SgNBModReq_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_ToBeModified_SgNBModReq_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_ToBeModified_SgNBModReq_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_ToBeModified_SgNBModReq_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeModified_SgNBModReq_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeModified_SgNBModReq_Item_iE_Extensions__item__id._const_tab = ____E_RABs_ToBeModified_SgNBModReq_Item_iE_Extensions__item__id_tab
    ___E_RABs_ToBeModified_SgNBModReq_Item_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_ToBeModified_SgNBModReq_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_ToBeModified_SgNBModReq_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_RABs_ToBeModified_SgNBModReq_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeModified_SgNBModReq_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeModified_SgNBModReq_Item_iE_Extensions__item__criticality._const_tab = ____E_RABs_ToBeModified_SgNBModReq_Item_iE_Extensions__item__criticality_tab
    ___E_RABs_ToBeModified_SgNBModReq_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeModified_SgNBModReq_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_ToBeModified_SgNBModReq_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_RABs_ToBeModified_SgNBModReq_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeModified_SgNBModReq_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeModified_SgNBModReq_Item_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_ToBeModified_SgNBModReq_Item_iE_Extensions__item__extensionValue_tab
    ___E_RABs_ToBeModified_SgNBModReq_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeModified_SgNBModReq_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_ToBeModified_SgNBModReq_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_ToBeModified_SgNBModReq_Item_iE_Extensions__item__id),
        ('criticality', ___E_RABs_ToBeModified_SgNBModReq_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_ToBeModified_SgNBModReq_Item_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_ToBeModified_SgNBModReq_Item_iE_Extensions__item_._ext = None
    _E_RABs_ToBeModified_SgNBModReq_Item_iE_Extensions._cont = __E_RABs_ToBeModified_SgNBModReq_Item_iE_Extensions__item_
    _E_RABs_ToBeModified_SgNBModReq_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_ToBeModified_SgNBModReq_Item._cont = ASN1Dict([
        ('e-RAB-ID', _E_RABs_ToBeModified_SgNBModReq_Item_e_RAB_ID),
        ('en-DC-ResourceConfiguration', _E_RABs_ToBeModified_SgNBModReq_Item_en_DC_ResourceConfiguration),
        ('resource-configuration', _E_RABs_ToBeModified_SgNBModReq_Item_resource_configuration),
        ('iE-Extensions', _E_RABs_ToBeModified_SgNBModReq_Item_iE_Extensions),
        ])
    E_RABs_ToBeModified_SgNBModReq_Item._ext = []
    
    #-----< E-RABs-ToBeModified-SgNBModReq-ItemExtIEs >-----#
    E_RABs_ToBeModified_SgNBModReq_ItemExtIEs = CLASS(name='E-RABs-ToBeModified-SgNBModReq-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    E_RABs_ToBeModified_SgNBModReq_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeModified-SgNBModReq-Item-SgNBPDCPpresent >-----#
    E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPpresent = SEQ(name='E-RABs-ToBeModified-SgNBModReq-Item-SgNBPDCPpresent', mode=MODE_TYPE)
    _E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPpresent_full_E_RAB_Level_QoS_Parameters = SEQ(name='full-E-RAB-Level-QoS-Parameters', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-Level-QoS-Parameters')), opt=True)
    _E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPpresent_max_MN_admit_E_RAB_Level_QoS_Parameters = SEQ(name='max-MN-admit-E-RAB-Level-QoS-Parameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GBR-QosInformation')), opt=True)
    _E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPpresent_meNB_DL_GTP_TEIDatMCG = SEQ(name='meNB-DL-GTP-TEIDatMCG', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPpresent_s1_UL_GTPtunnelEndpoint = SEQ(name='s1-UL-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'RLC-Status')))
    ____E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 300), ('criticality', 'ignore'), ('Extension', _____E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__id._const_tab = ____E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab
    ___E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__criticality._const_tab = ____E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab
    ___E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab
    ___E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__id),
        ('criticality', ___E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item_._ext = None
    _E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions._cont = __E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item_
    _E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPpresent._cont = ASN1Dict([
        ('full-E-RAB-Level-QoS-Parameters', _E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPpresent_full_E_RAB_Level_QoS_Parameters),
        ('max-MN-admit-E-RAB-Level-QoS-Parameters', _E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPpresent_max_MN_admit_E_RAB_Level_QoS_Parameters),
        ('meNB-DL-GTP-TEIDatMCG', _E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPpresent_meNB_DL_GTP_TEIDatMCG),
        ('s1-UL-GTPtunnelEndpoint', _E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPpresent_s1_UL_GTPtunnelEndpoint),
        ('iE-Extensions', _E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions),
        ])
    E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPpresent._ext = []
    
    #-----< E-RABs-ToBeModified-SgNBModReq-Item-SgNBPDCPpresentExtIEs >-----#
    E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPpresentExtIEs = CLASS(name='E-RABs-ToBeModified-SgNBModReq-Item-SgNBPDCPpresentExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPpresentExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'RLC-Status')))
    E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPpresentExtIEs._val = ASN1Set(rv=[dict([('id', 300), ('criticality', 'ignore'), ('Extension', _E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPpresentExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeModified-SgNBModReq-Item-SgNBPDCPnotpresent >-----#
    E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPnotpresent = SEQ(name='E-RABs-ToBeModified-SgNBModReq-Item-SgNBPDCPnotpresent', mode=MODE_TYPE)
    _E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPnotpresent_requested_SCG_E_RAB_Level_QoS_Parameters = SEQ(name='requested-SCG-E-RAB-Level-QoS-Parameters', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-Level-QoS-Parameters')), opt=True)
    _E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPnotpresent_meNB_UL_GTP_TEIDatPDCP = SEQ(name='meNB-UL-GTP-TEIDatPDCP', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPnotpresent_uL_Configuration = SEQ(name='uL-Configuration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ULConfiguration')), opt=True)
    _E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PDCPSnLength')))
    _____E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PDCPSnLength')))
    _____E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')))
    ____E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 302), ('criticality', 'ignore'), ('Extension', _____E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 311), ('criticality', 'ignore'), ('Extension', _____E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 313), ('criticality', 'ignore'), ('Extension', _____E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id._const_tab = ____E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab
    ___E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality._const_tab = ____E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab
    ___E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab
    ___E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id),
        ('criticality', ___E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item_._ext = None
    _E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions._cont = __E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item_
    _E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPnotpresent._cont = ASN1Dict([
        ('requested-SCG-E-RAB-Level-QoS-Parameters', _E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPnotpresent_requested_SCG_E_RAB_Level_QoS_Parameters),
        ('meNB-UL-GTP-TEIDatPDCP', _E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPnotpresent_meNB_UL_GTP_TEIDatPDCP),
        ('uL-Configuration', _E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPnotpresent_uL_Configuration),
        ('iE-Extensions', _E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions),
        ])
    E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPnotpresent._ext = []
    
    #-----< E-RABs-ToBeModified-SgNBModReq-Item-SgNBPDCPnotpresentExtIEs >-----#
    E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPnotpresentExtIEs = CLASS(name='E-RABs-ToBeModified-SgNBModReq-Item-SgNBPDCPnotpresentExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPnotpresentExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PDCPSnLength')))
    _E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPnotpresentExtIEs_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PDCPSnLength')))
    _E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPnotpresentExtIEs_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')))
    E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPnotpresentExtIEs._val = ASN1Set(rv=[dict([('id', 302), ('criticality', 'ignore'), ('Extension', _E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPnotpresentExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 311), ('criticality', 'ignore'), ('Extension', _E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPnotpresentExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 313), ('criticality', 'ignore'), ('Extension', _E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPnotpresentExtIEs_val_Extension_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeReleased-SgNBModReq-List >-----#
    E_RABs_ToBeReleased_SgNBModReq_List = SEQ_OF(name='E-RABs-ToBeReleased-SgNBModReq-List', mode=MODE_TYPE)
    _E_RABs_ToBeReleased_SgNBModReq_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __E_RABs_ToBeReleased_SgNBModReq_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ___E_RABs_ToBeReleased_SgNBModReq_List__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____E_RABs_ToBeReleased_SgNBModReq_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-SgNBModReq-Item')))
    ___E_RABs_ToBeReleased_SgNBModReq_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 218), ('criticality', 'ignore'), ('Value', ____E_RABs_ToBeReleased_SgNBModReq_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E_RABs_ToBeReleased_SgNBModReq_List__item__id._const_tab = ___E_RABs_ToBeReleased_SgNBModReq_List__item__id_tab
    __E_RABs_ToBeReleased_SgNBModReq_List__item__id._const_tab_at = None
    __E_RABs_ToBeReleased_SgNBModReq_List__item__id._const_tab_id = 'id'
    __E_RABs_ToBeReleased_SgNBModReq_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    __E_RABs_ToBeReleased_SgNBModReq_List__item__criticality._const_tab = ___E_RABs_ToBeReleased_SgNBModReq_List__item__id_tab
    __E_RABs_ToBeReleased_SgNBModReq_List__item__criticality._const_tab_at = ('..', 'id')
    __E_RABs_ToBeReleased_SgNBModReq_List__item__criticality._const_tab_id = 'criticality'
    __E_RABs_ToBeReleased_SgNBModReq_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    __E_RABs_ToBeReleased_SgNBModReq_List__item__value._const_tab = ___E_RABs_ToBeReleased_SgNBModReq_List__item__id_tab
    __E_RABs_ToBeReleased_SgNBModReq_List__item__value._const_tab_at = ('..', 'id')
    __E_RABs_ToBeReleased_SgNBModReq_List__item__value._const_tab_id = 'Value'
    _E_RABs_ToBeReleased_SgNBModReq_List__item_._cont = ASN1Dict([
        ('id', __E_RABs_ToBeReleased_SgNBModReq_List__item__id),
        ('criticality', __E_RABs_ToBeReleased_SgNBModReq_List__item__criticality),
        ('value', __E_RABs_ToBeReleased_SgNBModReq_List__item__value),
        ])
    _E_RABs_ToBeReleased_SgNBModReq_List__item_._ext = None
    E_RABs_ToBeReleased_SgNBModReq_List._cont = _E_RABs_ToBeReleased_SgNBModReq_List__item_
    E_RABs_ToBeReleased_SgNBModReq_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABs-ToBeReleased-SgNBModReq-ItemIEs >-----#
    E_RABs_ToBeReleased_SgNBModReq_ItemIEs = CLASS(name='E-RABs-ToBeReleased-SgNBModReq-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _E_RABs_ToBeReleased_SgNBModReq_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-SgNBModReq-Item')))
    E_RABs_ToBeReleased_SgNBModReq_ItemIEs._val = ASN1Set(rv=[dict([('id', 218), ('criticality', 'ignore'), ('Value', _E_RABs_ToBeReleased_SgNBModReq_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeReleased-SgNBModReq-Item >-----#
    E_RABs_ToBeReleased_SgNBModReq_Item = SEQ(name='E-RABs-ToBeReleased-SgNBModReq-Item', mode=MODE_TYPE)
    _E_RABs_ToBeReleased_SgNBModReq_Item_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_ToBeReleased_SgNBModReq_Item_en_DC_ResourceConfiguration = SEQ(name='en-DC-ResourceConfiguration', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'EN-DC-ResourceConfiguration')))
    _E_RABs_ToBeReleased_SgNBModReq_Item_resource_configuration = CHOICE(name='resource-configuration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __E_RABs_ToBeReleased_SgNBModReq_Item_resource_configuration_sgNBPDCPpresent = SEQ(name='sgNBPDCPpresent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-SgNBModReq-Item-SgNBPDCPpresent')))
    __E_RABs_ToBeReleased_SgNBModReq_Item_resource_configuration_sgNBPDCPnotpresent = SEQ(name='sgNBPDCPnotpresent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-SgNBModReq-Item-SgNBPDCPnotpresent')))
    _E_RABs_ToBeReleased_SgNBModReq_Item_resource_configuration._cont = ASN1Dict([
        ('sgNBPDCPpresent', __E_RABs_ToBeReleased_SgNBModReq_Item_resource_configuration_sgNBPDCPpresent),
        ('sgNBPDCPnotpresent', __E_RABs_ToBeReleased_SgNBModReq_Item_resource_configuration_sgNBPDCPnotpresent),
        ])
    _E_RABs_ToBeReleased_SgNBModReq_Item_resource_configuration._ext = []
    _E_RABs_ToBeReleased_SgNBModReq_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_ToBeReleased_SgNBModReq_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_ToBeReleased_SgNBModReq_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_ToBeReleased_SgNBModReq_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_SgNBModReq_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_SgNBModReq_Item_iE_Extensions__item__id._const_tab = ____E_RABs_ToBeReleased_SgNBModReq_Item_iE_Extensions__item__id_tab
    ___E_RABs_ToBeReleased_SgNBModReq_Item_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_ToBeReleased_SgNBModReq_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_ToBeReleased_SgNBModReq_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_RABs_ToBeReleased_SgNBModReq_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_SgNBModReq_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_SgNBModReq_Item_iE_Extensions__item__criticality._const_tab = ____E_RABs_ToBeReleased_SgNBModReq_Item_iE_Extensions__item__criticality_tab
    ___E_RABs_ToBeReleased_SgNBModReq_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeReleased_SgNBModReq_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_ToBeReleased_SgNBModReq_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_RABs_ToBeReleased_SgNBModReq_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_SgNBModReq_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_SgNBModReq_Item_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_ToBeReleased_SgNBModReq_Item_iE_Extensions__item__extensionValue_tab
    ___E_RABs_ToBeReleased_SgNBModReq_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeReleased_SgNBModReq_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_ToBeReleased_SgNBModReq_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_ToBeReleased_SgNBModReq_Item_iE_Extensions__item__id),
        ('criticality', ___E_RABs_ToBeReleased_SgNBModReq_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_ToBeReleased_SgNBModReq_Item_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_ToBeReleased_SgNBModReq_Item_iE_Extensions__item_._ext = None
    _E_RABs_ToBeReleased_SgNBModReq_Item_iE_Extensions._cont = __E_RABs_ToBeReleased_SgNBModReq_Item_iE_Extensions__item_
    _E_RABs_ToBeReleased_SgNBModReq_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_ToBeReleased_SgNBModReq_Item._cont = ASN1Dict([
        ('e-RAB-ID', _E_RABs_ToBeReleased_SgNBModReq_Item_e_RAB_ID),
        ('en-DC-ResourceConfiguration', _E_RABs_ToBeReleased_SgNBModReq_Item_en_DC_ResourceConfiguration),
        ('resource-configuration', _E_RABs_ToBeReleased_SgNBModReq_Item_resource_configuration),
        ('iE-Extensions', _E_RABs_ToBeReleased_SgNBModReq_Item_iE_Extensions),
        ])
    E_RABs_ToBeReleased_SgNBModReq_Item._ext = []
    
    #-----< E-RABs-ToBeReleased-SgNBModReq-ItemExtIEs >-----#
    E_RABs_ToBeReleased_SgNBModReq_ItemExtIEs = CLASS(name='E-RABs-ToBeReleased-SgNBModReq-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    E_RABs_ToBeReleased_SgNBModReq_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeReleased-SgNBModReq-Item-SgNBPDCPpresent >-----#
    E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPpresent = SEQ(name='E-RABs-ToBeReleased-SgNBModReq-Item-SgNBPDCPpresent', mode=MODE_TYPE)
    _E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPpresent_dL_GTPtunnelEndpoint = SEQ(name='dL-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPpresent_uL_GTPtunnelEndpoint = SEQ(name='uL-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__id._const_tab = ____E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab
    ___E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__criticality._const_tab = ____E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__criticality_tab
    ___E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue_tab
    ___E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__id),
        ('criticality', ___E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item_._ext = None
    _E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions._cont = __E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item_
    _E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPpresent._cont = ASN1Dict([
        ('dL-GTPtunnelEndpoint', _E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPpresent_dL_GTPtunnelEndpoint),
        ('uL-GTPtunnelEndpoint', _E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPpresent_uL_GTPtunnelEndpoint),
        ('iE-Extensions', _E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions),
        ])
    E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPpresent._ext = []
    
    #-----< E-RABs-ToBeReleased-SgNBModReq-Item-SgNBPDCPpresentExtIEs >-----#
    E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPpresentExtIEs = CLASS(name='E-RABs-ToBeReleased-SgNBModReq-Item-SgNBPDCPpresentExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPpresentExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeReleased-SgNBModReq-Item-SgNBPDCPnotpresent >-----#
    E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPnotpresent = SEQ(name='E-RABs-ToBeReleased-SgNBModReq-Item-SgNBPDCPnotpresent', mode=MODE_TYPE)
    _E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id._const_tab = ____E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab
    ___E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality._const_tab = ____E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality_tab
    ___E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue_tab
    ___E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id),
        ('criticality', ___E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item_._ext = None
    _E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions._cont = __E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item_
    _E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPnotpresent._cont = ASN1Dict([
        ('iE-Extensions', _E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions),
        ])
    E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPnotpresent._ext = []
    
    #-----< E-RABs-ToBeReleased-SgNBModReq-Item-SgNBPDCPnotpresentExtIEs >-----#
    E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPnotpresentExtIEs = CLASS(name='E-RABs-ToBeReleased-SgNBModReq-Item-SgNBPDCPnotpresentExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPnotpresentExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SgNBModificationRequestAcknowledge >-----#
    SgNBModificationRequestAcknowledge = SEQ(name='SgNBModificationRequestAcknowledge', mode=MODE_TYPE)
    _SgNBModificationRequestAcknowledge_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __SgNBModificationRequestAcknowledge_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___SgNBModificationRequestAcknowledge_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____SgNBModificationRequestAcknowledge_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____SgNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SgNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNB-UE-X2AP-ID')))
    _____SgNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeAdded-SgNBModAckList')))
    _____SgNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeModified-SgNBModAckList')))
    _____SgNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeReleased-SgNBModAckList')))
    _____SgNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-List')))
    _____SgNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_6 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNBtoMeNBContainer')))
    _____SgNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_7 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _____SgNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_8 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____SgNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_9 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNBResourceCoordinationInformation')))
    _____SgNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_10 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SplitSRBs')))
    _____SgNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_11 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SplitSRBs')))
    _____SgNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_12 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'RRC-Config-Ind')))
    _____SgNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_13 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'LocationInformationSgNB')))
    _____SgNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_14 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'AvailableFastMCGRecoveryViaSRB3')))
    _____SgNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_15 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ReleaseFastMCGRecoveryViaSRB3')))
    _____SgNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_16 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SCG-UE-HistoryInformation')))
    _____SgNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_17 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SCGActivationStatus')))
    _____SgNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_18 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CPAinformation-MOD-ACK')))
    ____SgNBModificationRequestAcknowledge_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'ignore'), ('Value', _____SgNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 207), ('criticality', 'ignore'), ('Value', _____SgNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 219), ('criticality', 'ignore'), ('Value', _____SgNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 220), ('criticality', 'ignore'), ('Value', _____SgNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 221), ('criticality', 'ignore'), ('Value', _____SgNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 3), ('criticality', 'ignore'), ('Value', _____SgNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 211), ('criticality', 'ignore'), ('Value', _____SgNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _____SgNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')]), dict([('id', 157), ('criticality', 'ignore'), ('Value', _____SgNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_8), ('presence', 'optional')]), dict([('id', 258), ('criticality', 'ignore'), ('Value', _____SgNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_9), ('presence', 'optional')]), dict([('id', 212), ('criticality', 'ignore'), ('Value', _____SgNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_10), ('presence', 'optional')]), dict([('id', 281), ('criticality', 'ignore'), ('Value', _____SgNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_11), ('presence', 'optional')]), dict([('id', 272), ('criticality', 'reject'), ('Value', _____SgNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_12), ('presence', 'optional')]), dict([('id', 331), ('criticality', 'ignore'), ('Value', _____SgNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_13), ('presence', 'optional')]), dict([('id', 344), ('criticality', 'ignore'), ('Value', _____SgNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_14), ('presence', 'optional')]), dict([('id', 346), ('criticality', 'ignore'), ('Value', _____SgNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_15), ('presence', 'optional')]), dict([('id', 415), ('criticality', 'ignore'), ('Value', _____SgNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_16), ('presence', 'optional')]), dict([('id', 422), ('criticality', 'ignore'), ('Value', _____SgNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_17), ('presence', 'optional')]), dict([('id', 427), ('criticality', 'reject'), ('Value', _____SgNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_18), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SgNBModificationRequestAcknowledge_protocolIEs__item__id._const_tab = ____SgNBModificationRequestAcknowledge_protocolIEs__item__id_tab
    ___SgNBModificationRequestAcknowledge_protocolIEs__item__id._const_tab_at = None
    ___SgNBModificationRequestAcknowledge_protocolIEs__item__id._const_tab_id = 'id'
    ___SgNBModificationRequestAcknowledge_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___SgNBModificationRequestAcknowledge_protocolIEs__item__criticality._const_tab = ____SgNBModificationRequestAcknowledge_protocolIEs__item__id_tab
    ___SgNBModificationRequestAcknowledge_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___SgNBModificationRequestAcknowledge_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___SgNBModificationRequestAcknowledge_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___SgNBModificationRequestAcknowledge_protocolIEs__item__value._const_tab = ____SgNBModificationRequestAcknowledge_protocolIEs__item__id_tab
    ___SgNBModificationRequestAcknowledge_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___SgNBModificationRequestAcknowledge_protocolIEs__item__value._const_tab_id = 'Value'
    __SgNBModificationRequestAcknowledge_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___SgNBModificationRequestAcknowledge_protocolIEs__item__id),
        ('criticality', ___SgNBModificationRequestAcknowledge_protocolIEs__item__criticality),
        ('value', ___SgNBModificationRequestAcknowledge_protocolIEs__item__value),
        ])
    __SgNBModificationRequestAcknowledge_protocolIEs__item_._ext = None
    _SgNBModificationRequestAcknowledge_protocolIEs._cont = __SgNBModificationRequestAcknowledge_protocolIEs__item_
    _SgNBModificationRequestAcknowledge_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    SgNBModificationRequestAcknowledge._cont = ASN1Dict([
        ('protocolIEs', _SgNBModificationRequestAcknowledge_protocolIEs),
        ])
    SgNBModificationRequestAcknowledge._ext = []
    
    #-----< SgNBModificationRequestAcknowledge-IEs >-----#
    SgNBModificationRequestAcknowledge_IEs = CLASS(name='SgNBModificationRequestAcknowledge-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _SgNBModificationRequestAcknowledge_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SgNBModificationRequestAcknowledge_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNB-UE-X2AP-ID')))
    _SgNBModificationRequestAcknowledge_IEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeAdded-SgNBModAckList')))
    _SgNBModificationRequestAcknowledge_IEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeModified-SgNBModAckList')))
    _SgNBModificationRequestAcknowledge_IEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeReleased-SgNBModAckList')))
    _SgNBModificationRequestAcknowledge_IEs_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-List')))
    _SgNBModificationRequestAcknowledge_IEs_val_Value_6 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNBtoMeNBContainer')))
    _SgNBModificationRequestAcknowledge_IEs_val_Value_7 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _SgNBModificationRequestAcknowledge_IEs_val_Value_8 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _SgNBModificationRequestAcknowledge_IEs_val_Value_9 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNBResourceCoordinationInformation')))
    _SgNBModificationRequestAcknowledge_IEs_val_Value_10 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SplitSRBs')))
    _SgNBModificationRequestAcknowledge_IEs_val_Value_11 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SplitSRBs')))
    _SgNBModificationRequestAcknowledge_IEs_val_Value_12 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'RRC-Config-Ind')))
    _SgNBModificationRequestAcknowledge_IEs_val_Value_13 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'LocationInformationSgNB')))
    _SgNBModificationRequestAcknowledge_IEs_val_Value_14 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'AvailableFastMCGRecoveryViaSRB3')))
    _SgNBModificationRequestAcknowledge_IEs_val_Value_15 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ReleaseFastMCGRecoveryViaSRB3')))
    _SgNBModificationRequestAcknowledge_IEs_val_Value_16 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SCG-UE-HistoryInformation')))
    _SgNBModificationRequestAcknowledge_IEs_val_Value_17 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SCGActivationStatus')))
    _SgNBModificationRequestAcknowledge_IEs_val_Value_18 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CPAinformation-MOD-ACK')))
    SgNBModificationRequestAcknowledge_IEs._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'ignore'), ('Value', _SgNBModificationRequestAcknowledge_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 207), ('criticality', 'ignore'), ('Value', _SgNBModificationRequestAcknowledge_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 219), ('criticality', 'ignore'), ('Value', _SgNBModificationRequestAcknowledge_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 220), ('criticality', 'ignore'), ('Value', _SgNBModificationRequestAcknowledge_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 221), ('criticality', 'ignore'), ('Value', _SgNBModificationRequestAcknowledge_IEs_val_Value_4), ('presence', 'optional')]), dict([('id', 3), ('criticality', 'ignore'), ('Value', _SgNBModificationRequestAcknowledge_IEs_val_Value_5), ('presence', 'optional')]), dict([('id', 211), ('criticality', 'ignore'), ('Value', _SgNBModificationRequestAcknowledge_IEs_val_Value_6), ('presence', 'optional')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _SgNBModificationRequestAcknowledge_IEs_val_Value_7), ('presence', 'optional')]), dict([('id', 157), ('criticality', 'ignore'), ('Value', _SgNBModificationRequestAcknowledge_IEs_val_Value_8), ('presence', 'optional')]), dict([('id', 258), ('criticality', 'ignore'), ('Value', _SgNBModificationRequestAcknowledge_IEs_val_Value_9), ('presence', 'optional')]), dict([('id', 212), ('criticality', 'ignore'), ('Value', _SgNBModificationRequestAcknowledge_IEs_val_Value_10), ('presence', 'optional')]), dict([('id', 281), ('criticality', 'ignore'), ('Value', _SgNBModificationRequestAcknowledge_IEs_val_Value_11), ('presence', 'optional')]), dict([('id', 272), ('criticality', 'reject'), ('Value', _SgNBModificationRequestAcknowledge_IEs_val_Value_12), ('presence', 'optional')]), dict([('id', 331), ('criticality', 'ignore'), ('Value', _SgNBModificationRequestAcknowledge_IEs_val_Value_13), ('presence', 'optional')]), dict([('id', 344), ('criticality', 'ignore'), ('Value', _SgNBModificationRequestAcknowledge_IEs_val_Value_14), ('presence', 'optional')]), dict([('id', 346), ('criticality', 'ignore'), ('Value', _SgNBModificationRequestAcknowledge_IEs_val_Value_15), ('presence', 'optional')]), dict([('id', 415), ('criticality', 'ignore'), ('Value', _SgNBModificationRequestAcknowledge_IEs_val_Value_16), ('presence', 'optional')]), dict([('id', 422), ('criticality', 'ignore'), ('Value', _SgNBModificationRequestAcknowledge_IEs_val_Value_17), ('presence', 'optional')]), dict([('id', 427), ('criticality', 'reject'), ('Value', _SgNBModificationRequestAcknowledge_IEs_val_Value_18), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-Admitted-ToBeAdded-SgNBModAckList >-----#
    E_RABs_Admitted_ToBeAdded_SgNBModAckList = SEQ_OF(name='E-RABs-Admitted-ToBeAdded-SgNBModAckList', mode=MODE_TYPE)
    _E_RABs_Admitted_ToBeAdded_SgNBModAckList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __E_RABs_Admitted_ToBeAdded_SgNBModAckList__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ___E_RABs_Admitted_ToBeAdded_SgNBModAckList__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____E_RABs_Admitted_ToBeAdded_SgNBModAckList__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeAdded-SgNBModAck-Item')))
    ___E_RABs_Admitted_ToBeAdded_SgNBModAckList__item__id_tab._val = ASN1Set(rv=[dict([('id', 222), ('criticality', 'ignore'), ('Value', ____E_RABs_Admitted_ToBeAdded_SgNBModAckList__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E_RABs_Admitted_ToBeAdded_SgNBModAckList__item__id._const_tab = ___E_RABs_Admitted_ToBeAdded_SgNBModAckList__item__id_tab
    __E_RABs_Admitted_ToBeAdded_SgNBModAckList__item__id._const_tab_at = None
    __E_RABs_Admitted_ToBeAdded_SgNBModAckList__item__id._const_tab_id = 'id'
    __E_RABs_Admitted_ToBeAdded_SgNBModAckList__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    __E_RABs_Admitted_ToBeAdded_SgNBModAckList__item__criticality._const_tab = ___E_RABs_Admitted_ToBeAdded_SgNBModAckList__item__id_tab
    __E_RABs_Admitted_ToBeAdded_SgNBModAckList__item__criticality._const_tab_at = ('..', 'id')
    __E_RABs_Admitted_ToBeAdded_SgNBModAckList__item__criticality._const_tab_id = 'criticality'
    __E_RABs_Admitted_ToBeAdded_SgNBModAckList__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    __E_RABs_Admitted_ToBeAdded_SgNBModAckList__item__value._const_tab = ___E_RABs_Admitted_ToBeAdded_SgNBModAckList__item__id_tab
    __E_RABs_Admitted_ToBeAdded_SgNBModAckList__item__value._const_tab_at = ('..', 'id')
    __E_RABs_Admitted_ToBeAdded_SgNBModAckList__item__value._const_tab_id = 'Value'
    _E_RABs_Admitted_ToBeAdded_SgNBModAckList__item_._cont = ASN1Dict([
        ('id', __E_RABs_Admitted_ToBeAdded_SgNBModAckList__item__id),
        ('criticality', __E_RABs_Admitted_ToBeAdded_SgNBModAckList__item__criticality),
        ('value', __E_RABs_Admitted_ToBeAdded_SgNBModAckList__item__value),
        ])
    _E_RABs_Admitted_ToBeAdded_SgNBModAckList__item_._ext = None
    E_RABs_Admitted_ToBeAdded_SgNBModAckList._cont = _E_RABs_Admitted_ToBeAdded_SgNBModAckList__item_
    E_RABs_Admitted_ToBeAdded_SgNBModAckList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABs-Admitted-ToBeAdded-SgNBModAck-ItemIEs >-----#
    E_RABs_Admitted_ToBeAdded_SgNBModAck_ItemIEs = CLASS(name='E-RABs-Admitted-ToBeAdded-SgNBModAck-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _E_RABs_Admitted_ToBeAdded_SgNBModAck_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeAdded-SgNBModAck-Item')))
    E_RABs_Admitted_ToBeAdded_SgNBModAck_ItemIEs._val = ASN1Set(rv=[dict([('id', 222), ('criticality', 'ignore'), ('Value', _E_RABs_Admitted_ToBeAdded_SgNBModAck_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< E-RABs-Admitted-ToBeAdded-SgNBModAck-Item >-----#
    E_RABs_Admitted_ToBeAdded_SgNBModAck_Item = SEQ(name='E-RABs-Admitted-ToBeAdded-SgNBModAck-Item', mode=MODE_TYPE)
    _E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_en_DC_ResourceConfiguration = SEQ(name='en-DC-ResourceConfiguration', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'EN-DC-ResourceConfiguration')))
    _E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_resource_configuration = CHOICE(name='resource-configuration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_resource_configuration_sgNBPDCPpresent = SEQ(name='sgNBPDCPpresent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeAdded-SgNBModAck-Item-SgNBPDCPpresent')))
    __E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_resource_configuration_sgNBPDCPnotpresent = SEQ(name='sgNBPDCPnotpresent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeAdded-SgNBModAck-Item-SgNBPDCPnotpresent')))
    _E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_resource_configuration._cont = ASN1Dict([
        ('sgNBPDCPpresent', __E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_resource_configuration_sgNBPDCPpresent),
        ('sgNBPDCPnotpresent', __E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_resource_configuration_sgNBPDCPnotpresent),
        ])
    _E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_resource_configuration._ext = []
    _E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_iE_Extensions__item__id._const_tab = ____E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_iE_Extensions__item__criticality._const_tab = ____E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_iE_Extensions__item__criticality_tab
    ___E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_iE_Extensions__item__extensionValue_tab
    ___E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_iE_Extensions__item__id),
        ('criticality', ___E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_iE_Extensions__item_._ext = None
    _E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_iE_Extensions._cont = __E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_iE_Extensions__item_
    _E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_Admitted_ToBeAdded_SgNBModAck_Item._cont = ASN1Dict([
        ('e-RAB-ID', _E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_e_RAB_ID),
        ('en-DC-ResourceConfiguration', _E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_en_DC_ResourceConfiguration),
        ('resource-configuration', _E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_resource_configuration),
        ('iE-Extensions', _E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_iE_Extensions),
        ])
    E_RABs_Admitted_ToBeAdded_SgNBModAck_Item._ext = []
    
    #-----< E-RABs-Admitted-ToBeAdded-SgNBModAck-ItemExtIEs >-----#
    E_RABs_Admitted_ToBeAdded_SgNBModAck_ItemExtIEs = CLASS(name='E-RABs-Admitted-ToBeAdded-SgNBModAck-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    E_RABs_Admitted_ToBeAdded_SgNBModAck_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RABs-Admitted-ToBeAdded-SgNBModAck-Item-SgNBPDCPpresent >-----#
    E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent = SEQ(name='E-RABs-Admitted-ToBeAdded-SgNBModAck-Item-SgNBPDCPpresent', mode=MODE_TYPE)
    _E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent_s1_DL_GTPtunnelEndpoint = SEQ(name='s1-DL-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')))
    _E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent_sgNB_UL_GTP_TEIDatPDCP = SEQ(name='sgNB-UL-GTP-TEIDatPDCP', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent_rlc_Mode = ENUM(name='rlc-Mode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'RLCMode')), opt=True)
    _E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent_dL_Forwarding_GTPtunnelEndpoint = SEQ(name='dL-Forwarding-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent_uL_Forwarding_GTPtunnelEndpoint = SEQ(name='uL-Forwarding-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent_mCG_E_RAB_Level_QoS_Parameters = SEQ(name='mCG-E-RAB-Level-QoS-Parameters', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-Level-QoS-Parameters')), opt=True)
    _E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent_uL_Configuration = SEQ(name='uL-Configuration', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ULConfiguration')), opt=True)
    _E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PDCPSnLength')))
    _____E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PDCPSnLength')))
    _____E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SecurityResult')))
    _____E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_3 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TransportLayerAddress')))
    ____E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 302), ('criticality', 'ignore'), ('Extension', _____E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 311), ('criticality', 'ignore'), ('Extension', _____E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 436), ('criticality', 'ignore'), ('Extension', _____E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 412), ('criticality', 'ignore'), ('Extension', _____E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__id._const_tab = ____E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__criticality._const_tab = ____E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__id),
        ('criticality', ___E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item_._ext = None
    _E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions._cont = __E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item_
    _E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent._cont = ASN1Dict([
        ('s1-DL-GTPtunnelEndpoint', _E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent_s1_DL_GTPtunnelEndpoint),
        ('sgNB-UL-GTP-TEIDatPDCP', _E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent_sgNB_UL_GTP_TEIDatPDCP),
        ('rlc-Mode', _E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent_rlc_Mode),
        ('dL-Forwarding-GTPtunnelEndpoint', _E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent_dL_Forwarding_GTPtunnelEndpoint),
        ('uL-Forwarding-GTPtunnelEndpoint', _E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent_uL_Forwarding_GTPtunnelEndpoint),
        ('mCG-E-RAB-Level-QoS-Parameters', _E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent_mCG_E_RAB_Level_QoS_Parameters),
        ('uL-Configuration', _E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent_uL_Configuration),
        ('iE-Extensions', _E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions),
        ])
    E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent._ext = []
    
    #-----< E-RABs-Admitted-ToBeAdded-SgNBModAck-Item-SgNBPDCPpresentExtIEs >-----#
    E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresentExtIEs = CLASS(name='E-RABs-Admitted-ToBeAdded-SgNBModAck-Item-SgNBPDCPpresentExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresentExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PDCPSnLength')))
    _E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresentExtIEs_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PDCPSnLength')))
    _E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresentExtIEs_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SecurityResult')))
    _E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresentExtIEs_val_Extension_3 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TransportLayerAddress')))
    E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresentExtIEs._val = ASN1Set(rv=[dict([('id', 302), ('criticality', 'ignore'), ('Extension', _E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresentExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 311), ('criticality', 'ignore'), ('Extension', _E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresentExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 436), ('criticality', 'ignore'), ('Extension', _E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresentExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 412), ('criticality', 'ignore'), ('Extension', _E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresentExtIEs_val_Extension_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-Admitted-ToBeAdded-SgNBModAck-Item-SgNBPDCPnotpresent >-----#
    E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPnotpresent = SEQ(name='E-RABs-Admitted-ToBeAdded-SgNBModAck-Item-SgNBPDCPnotpresent', mode=MODE_TYPE)
    _E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPnotpresent_sgNB_DL_GTP_TEIDatSCG = SEQ(name='sgNB-DL-GTP-TEIDatSCG', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')))
    _E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPnotpresent_secondary_sgNB_DL_GTP_TEIDatSCG = SEQ(name='secondary-sgNB-DL-GTP-TEIDatSCG', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'LCID')))
    ____E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 314), ('criticality', 'ignore'), ('Extension', _____E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__id._const_tab = ____E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality._const_tab = ____E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__id),
        ('criticality', ___E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item_._ext = None
    _E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions._cont = __E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item_
    _E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPnotpresent._cont = ASN1Dict([
        ('sgNB-DL-GTP-TEIDatSCG', _E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPnotpresent_sgNB_DL_GTP_TEIDatSCG),
        ('secondary-sgNB-DL-GTP-TEIDatSCG', _E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPnotpresent_secondary_sgNB_DL_GTP_TEIDatSCG),
        ('iE-Extensions', _E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions),
        ])
    E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPnotpresent._ext = []
    
    #-----< E-RABs-Admitted-ToBeAdded-SgNBModAck-Item-SgNBPDCPnotpresentExtIEs >-----#
    E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPnotpresentExtIEs = CLASS(name='E-RABs-Admitted-ToBeAdded-SgNBModAck-Item-SgNBPDCPnotpresentExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPnotpresentExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'LCID')))
    E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPnotpresentExtIEs._val = ASN1Set(rv=[dict([('id', 314), ('criticality', 'ignore'), ('Extension', _E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPnotpresentExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-Admitted-ToBeModified-SgNBModAckList >-----#
    E_RABs_Admitted_ToBeModified_SgNBModAckList = SEQ_OF(name='E-RABs-Admitted-ToBeModified-SgNBModAckList', mode=MODE_TYPE)
    _E_RABs_Admitted_ToBeModified_SgNBModAckList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __E_RABs_Admitted_ToBeModified_SgNBModAckList__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ___E_RABs_Admitted_ToBeModified_SgNBModAckList__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____E_RABs_Admitted_ToBeModified_SgNBModAckList__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeModified-SgNBModAck-Item')))
    ___E_RABs_Admitted_ToBeModified_SgNBModAckList__item__id_tab._val = ASN1Set(rv=[dict([('id', 223), ('criticality', 'ignore'), ('Value', ____E_RABs_Admitted_ToBeModified_SgNBModAckList__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E_RABs_Admitted_ToBeModified_SgNBModAckList__item__id._const_tab = ___E_RABs_Admitted_ToBeModified_SgNBModAckList__item__id_tab
    __E_RABs_Admitted_ToBeModified_SgNBModAckList__item__id._const_tab_at = None
    __E_RABs_Admitted_ToBeModified_SgNBModAckList__item__id._const_tab_id = 'id'
    __E_RABs_Admitted_ToBeModified_SgNBModAckList__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    __E_RABs_Admitted_ToBeModified_SgNBModAckList__item__criticality._const_tab = ___E_RABs_Admitted_ToBeModified_SgNBModAckList__item__id_tab
    __E_RABs_Admitted_ToBeModified_SgNBModAckList__item__criticality._const_tab_at = ('..', 'id')
    __E_RABs_Admitted_ToBeModified_SgNBModAckList__item__criticality._const_tab_id = 'criticality'
    __E_RABs_Admitted_ToBeModified_SgNBModAckList__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    __E_RABs_Admitted_ToBeModified_SgNBModAckList__item__value._const_tab = ___E_RABs_Admitted_ToBeModified_SgNBModAckList__item__id_tab
    __E_RABs_Admitted_ToBeModified_SgNBModAckList__item__value._const_tab_at = ('..', 'id')
    __E_RABs_Admitted_ToBeModified_SgNBModAckList__item__value._const_tab_id = 'Value'
    _E_RABs_Admitted_ToBeModified_SgNBModAckList__item_._cont = ASN1Dict([
        ('id', __E_RABs_Admitted_ToBeModified_SgNBModAckList__item__id),
        ('criticality', __E_RABs_Admitted_ToBeModified_SgNBModAckList__item__criticality),
        ('value', __E_RABs_Admitted_ToBeModified_SgNBModAckList__item__value),
        ])
    _E_RABs_Admitted_ToBeModified_SgNBModAckList__item_._ext = None
    E_RABs_Admitted_ToBeModified_SgNBModAckList._cont = _E_RABs_Admitted_ToBeModified_SgNBModAckList__item_
    E_RABs_Admitted_ToBeModified_SgNBModAckList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABs-Admitted-ToBeModified-SgNBModAck-ItemIEs >-----#
    E_RABs_Admitted_ToBeModified_SgNBModAck_ItemIEs = CLASS(name='E-RABs-Admitted-ToBeModified-SgNBModAck-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _E_RABs_Admitted_ToBeModified_SgNBModAck_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeModified-SgNBModAck-Item')))
    E_RABs_Admitted_ToBeModified_SgNBModAck_ItemIEs._val = ASN1Set(rv=[dict([('id', 223), ('criticality', 'ignore'), ('Value', _E_RABs_Admitted_ToBeModified_SgNBModAck_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< E-RABs-Admitted-ToBeModified-SgNBModAck-Item >-----#
    E_RABs_Admitted_ToBeModified_SgNBModAck_Item = SEQ(name='E-RABs-Admitted-ToBeModified-SgNBModAck-Item', mode=MODE_TYPE)
    _E_RABs_Admitted_ToBeModified_SgNBModAck_Item_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_Admitted_ToBeModified_SgNBModAck_Item_en_DC_ResourceConfiguration = SEQ(name='en-DC-ResourceConfiguration', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'EN-DC-ResourceConfiguration')))
    _E_RABs_Admitted_ToBeModified_SgNBModAck_Item_resource_configuration = CHOICE(name='resource-configuration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __E_RABs_Admitted_ToBeModified_SgNBModAck_Item_resource_configuration_sgNBPDCPpresent = SEQ(name='sgNBPDCPpresent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeModified-SgNBModAck-Item-SgNBPDCPpresent')))
    __E_RABs_Admitted_ToBeModified_SgNBModAck_Item_resource_configuration_sgNBPDCPnotpresent = SEQ(name='sgNBPDCPnotpresent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeModified-SgNBModAck-Item-SgNBPDCPnotpresent')))
    _E_RABs_Admitted_ToBeModified_SgNBModAck_Item_resource_configuration._cont = ASN1Dict([
        ('sgNBPDCPpresent', __E_RABs_Admitted_ToBeModified_SgNBModAck_Item_resource_configuration_sgNBPDCPpresent),
        ('sgNBPDCPnotpresent', __E_RABs_Admitted_ToBeModified_SgNBModAck_Item_resource_configuration_sgNBPDCPnotpresent),
        ])
    _E_RABs_Admitted_ToBeModified_SgNBModAck_Item_resource_configuration._ext = []
    _E_RABs_Admitted_ToBeModified_SgNBModAck_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_Admitted_ToBeModified_SgNBModAck_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_Admitted_ToBeModified_SgNBModAck_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_Admitted_ToBeModified_SgNBModAck_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_Admitted_ToBeModified_SgNBModAck_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_Admitted_ToBeModified_SgNBModAck_Item_iE_Extensions__item__id._const_tab = ____E_RABs_Admitted_ToBeModified_SgNBModAck_Item_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeModified_SgNBModAck_Item_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_Admitted_ToBeModified_SgNBModAck_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_Admitted_ToBeModified_SgNBModAck_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_RABs_Admitted_ToBeModified_SgNBModAck_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_Admitted_ToBeModified_SgNBModAck_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_Admitted_ToBeModified_SgNBModAck_Item_iE_Extensions__item__criticality._const_tab = ____E_RABs_Admitted_ToBeModified_SgNBModAck_Item_iE_Extensions__item__criticality_tab
    ___E_RABs_Admitted_ToBeModified_SgNBModAck_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_Admitted_ToBeModified_SgNBModAck_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_Admitted_ToBeModified_SgNBModAck_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_RABs_Admitted_ToBeModified_SgNBModAck_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_Admitted_ToBeModified_SgNBModAck_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_Admitted_ToBeModified_SgNBModAck_Item_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_Admitted_ToBeModified_SgNBModAck_Item_iE_Extensions__item__extensionValue_tab
    ___E_RABs_Admitted_ToBeModified_SgNBModAck_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_Admitted_ToBeModified_SgNBModAck_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_Admitted_ToBeModified_SgNBModAck_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_Admitted_ToBeModified_SgNBModAck_Item_iE_Extensions__item__id),
        ('criticality', ___E_RABs_Admitted_ToBeModified_SgNBModAck_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_Admitted_ToBeModified_SgNBModAck_Item_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_Admitted_ToBeModified_SgNBModAck_Item_iE_Extensions__item_._ext = None
    _E_RABs_Admitted_ToBeModified_SgNBModAck_Item_iE_Extensions._cont = __E_RABs_Admitted_ToBeModified_SgNBModAck_Item_iE_Extensions__item_
    _E_RABs_Admitted_ToBeModified_SgNBModAck_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_Admitted_ToBeModified_SgNBModAck_Item._cont = ASN1Dict([
        ('e-RAB-ID', _E_RABs_Admitted_ToBeModified_SgNBModAck_Item_e_RAB_ID),
        ('en-DC-ResourceConfiguration', _E_RABs_Admitted_ToBeModified_SgNBModAck_Item_en_DC_ResourceConfiguration),
        ('resource-configuration', _E_RABs_Admitted_ToBeModified_SgNBModAck_Item_resource_configuration),
        ('iE-Extensions', _E_RABs_Admitted_ToBeModified_SgNBModAck_Item_iE_Extensions),
        ])
    E_RABs_Admitted_ToBeModified_SgNBModAck_Item._ext = []
    
    #-----< E-RABs-ToBeAdded-SgNBModAck-ItemExtIEs >-----#
    E_RABs_ToBeAdded_SgNBModAck_ItemExtIEs = CLASS(name='E-RABs-ToBeAdded-SgNBModAck-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    E_RABs_ToBeAdded_SgNBModAck_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RABs-Admitted-ToBeModified-SgNBModAck-Item-SgNBPDCPpresent >-----#
    E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPpresent = SEQ(name='E-RABs-Admitted-ToBeModified-SgNBModAck-Item-SgNBPDCPpresent', mode=MODE_TYPE)
    _E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPpresent_s1_DL_GTPtunnelEndpoint = SEQ(name='s1-DL-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPpresent_sgNB_UL_GTP_TEIDatPDCP = SEQ(name='sgNB-UL-GTP-TEIDatPDCP', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPpresent_mCG_E_RAB_Level_QoS_Parameters = SEQ(name='mCG-E-RAB-Level-QoS-Parameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-Level-QoS-Parameters')), opt=True)
    _E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPpresent_uL_Configuration = SEQ(name='uL-Configuration', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ULConfiguration')), opt=True)
    _E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PDCPSnLength')))
    _____E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PDCPSnLength')))
    ____E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 302), ('criticality', 'ignore'), ('Extension', _____E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 311), ('criticality', 'ignore'), ('Extension', _____E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__id._const_tab = ____E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__criticality._const_tab = ____E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__id),
        ('criticality', ___E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item_._ext = None
    _E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions._cont = __E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item_
    _E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPpresent._cont = ASN1Dict([
        ('s1-DL-GTPtunnelEndpoint', _E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPpresent_s1_DL_GTPtunnelEndpoint),
        ('sgNB-UL-GTP-TEIDatPDCP', _E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPpresent_sgNB_UL_GTP_TEIDatPDCP),
        ('mCG-E-RAB-Level-QoS-Parameters', _E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPpresent_mCG_E_RAB_Level_QoS_Parameters),
        ('uL-Configuration', _E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPpresent_uL_Configuration),
        ('iE-Extensions', _E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions),
        ])
    E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPpresent._ext = []
    
    #-----< E-RABs-Admitted-ToBeModified-SgNBModAck-Item-SgNBPDCPpresentExtIEs >-----#
    E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPpresentExtIEs = CLASS(name='E-RABs-Admitted-ToBeModified-SgNBModAck-Item-SgNBPDCPpresentExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPpresentExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PDCPSnLength')))
    _E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPpresentExtIEs_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PDCPSnLength')))
    E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPpresentExtIEs._val = ASN1Set(rv=[dict([('id', 302), ('criticality', 'ignore'), ('Extension', _E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPpresentExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 311), ('criticality', 'ignore'), ('Extension', _E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPpresentExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-Admitted-ToBeModified-SgNBModAck-Item-SgNBPDCPnotpresent >-----#
    E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPnotpresent = SEQ(name='E-RABs-Admitted-ToBeModified-SgNBModAck-Item-SgNBPDCPnotpresent', mode=MODE_TYPE)
    _E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPnotpresent_sgNB_DL_GTP_TEIDatSCG = SEQ(name='sgNB-DL-GTP-TEIDatSCG', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')))
    _____E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'RLC-Status')))
    ____E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 312), ('criticality', 'ignore'), ('Extension', _____E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 300), ('criticality', 'ignore'), ('Extension', _____E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__id._const_tab = ____E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality._const_tab = ____E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__id),
        ('criticality', ___E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item_._ext = None
    _E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions._cont = __E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item_
    _E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPnotpresent._cont = ASN1Dict([
        ('sgNB-DL-GTP-TEIDatSCG', _E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPnotpresent_sgNB_DL_GTP_TEIDatSCG),
        ('iE-Extensions', _E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions),
        ])
    E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPnotpresent._ext = []
    
    #-----< E-RABs-Admitted-ToBeModified-SgNBModAck-Item-SgNBPDCPnotpresentExtIEs >-----#
    E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPnotpresentExtIEs = CLASS(name='E-RABs-Admitted-ToBeModified-SgNBModAck-Item-SgNBPDCPnotpresentExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPnotpresentExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')))
    _E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPnotpresentExtIEs_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'RLC-Status')))
    E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPnotpresentExtIEs._val = ASN1Set(rv=[dict([('id', 312), ('criticality', 'ignore'), ('Extension', _E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPnotpresentExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 300), ('criticality', 'ignore'), ('Extension', _E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPnotpresentExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-Admitted-ToBeReleased-SgNBModAckList >-----#
    E_RABs_Admitted_ToBeReleased_SgNBModAckList = SEQ_OF(name='E-RABs-Admitted-ToBeReleased-SgNBModAckList', mode=MODE_TYPE)
    _E_RABs_Admitted_ToBeReleased_SgNBModAckList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __E_RABs_Admitted_ToBeReleased_SgNBModAckList__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ___E_RABs_Admitted_ToBeReleased_SgNBModAckList__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____E_RABs_Admitted_ToBeReleased_SgNBModAckList__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToReleased-SgNBModAck-Item')))
    ___E_RABs_Admitted_ToBeReleased_SgNBModAckList__item__id_tab._val = ASN1Set(rv=[dict([('id', 224), ('criticality', 'ignore'), ('Value', ____E_RABs_Admitted_ToBeReleased_SgNBModAckList__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E_RABs_Admitted_ToBeReleased_SgNBModAckList__item__id._const_tab = ___E_RABs_Admitted_ToBeReleased_SgNBModAckList__item__id_tab
    __E_RABs_Admitted_ToBeReleased_SgNBModAckList__item__id._const_tab_at = None
    __E_RABs_Admitted_ToBeReleased_SgNBModAckList__item__id._const_tab_id = 'id'
    __E_RABs_Admitted_ToBeReleased_SgNBModAckList__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    __E_RABs_Admitted_ToBeReleased_SgNBModAckList__item__criticality._const_tab = ___E_RABs_Admitted_ToBeReleased_SgNBModAckList__item__id_tab
    __E_RABs_Admitted_ToBeReleased_SgNBModAckList__item__criticality._const_tab_at = ('..', 'id')
    __E_RABs_Admitted_ToBeReleased_SgNBModAckList__item__criticality._const_tab_id = 'criticality'
    __E_RABs_Admitted_ToBeReleased_SgNBModAckList__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    __E_RABs_Admitted_ToBeReleased_SgNBModAckList__item__value._const_tab = ___E_RABs_Admitted_ToBeReleased_SgNBModAckList__item__id_tab
    __E_RABs_Admitted_ToBeReleased_SgNBModAckList__item__value._const_tab_at = ('..', 'id')
    __E_RABs_Admitted_ToBeReleased_SgNBModAckList__item__value._const_tab_id = 'Value'
    _E_RABs_Admitted_ToBeReleased_SgNBModAckList__item_._cont = ASN1Dict([
        ('id', __E_RABs_Admitted_ToBeReleased_SgNBModAckList__item__id),
        ('criticality', __E_RABs_Admitted_ToBeReleased_SgNBModAckList__item__criticality),
        ('value', __E_RABs_Admitted_ToBeReleased_SgNBModAckList__item__value),
        ])
    _E_RABs_Admitted_ToBeReleased_SgNBModAckList__item_._ext = None
    E_RABs_Admitted_ToBeReleased_SgNBModAckList._cont = _E_RABs_Admitted_ToBeReleased_SgNBModAckList__item_
    E_RABs_Admitted_ToBeReleased_SgNBModAckList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABs-Admitted-ToBeReleased-SgNBModAck-ItemIEs >-----#
    E_RABs_Admitted_ToBeReleased_SgNBModAck_ItemIEs = CLASS(name='E-RABs-Admitted-ToBeReleased-SgNBModAck-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _E_RABs_Admitted_ToBeReleased_SgNBModAck_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToReleased-SgNBModAck-Item')))
    E_RABs_Admitted_ToBeReleased_SgNBModAck_ItemIEs._val = ASN1Set(rv=[dict([('id', 224), ('criticality', 'ignore'), ('Value', _E_RABs_Admitted_ToBeReleased_SgNBModAck_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< E-RABs-Admitted-ToReleased-SgNBModAck-Item >-----#
    E_RABs_Admitted_ToReleased_SgNBModAck_Item = SEQ(name='E-RABs-Admitted-ToReleased-SgNBModAck-Item', mode=MODE_TYPE)
    _E_RABs_Admitted_ToReleased_SgNBModAck_Item_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_Admitted_ToReleased_SgNBModAck_Item_en_DC_ResourceConfiguration = SEQ(name='en-DC-ResourceConfiguration', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'EN-DC-ResourceConfiguration')))
    _E_RABs_Admitted_ToReleased_SgNBModAck_Item_resource_configuration = CHOICE(name='resource-configuration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __E_RABs_Admitted_ToReleased_SgNBModAck_Item_resource_configuration_sgNBPDCPpresent = SEQ(name='sgNBPDCPpresent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeReleased-SgNBModAck-Item-SgNBPDCPpresent')))
    __E_RABs_Admitted_ToReleased_SgNBModAck_Item_resource_configuration_sgNBPDCPnotpresent = SEQ(name='sgNBPDCPnotpresent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeReleased-SgNBModAck-Item-SgNBPDCPnotpresent')))
    _E_RABs_Admitted_ToReleased_SgNBModAck_Item_resource_configuration._cont = ASN1Dict([
        ('sgNBPDCPpresent', __E_RABs_Admitted_ToReleased_SgNBModAck_Item_resource_configuration_sgNBPDCPpresent),
        ('sgNBPDCPnotpresent', __E_RABs_Admitted_ToReleased_SgNBModAck_Item_resource_configuration_sgNBPDCPnotpresent),
        ])
    _E_RABs_Admitted_ToReleased_SgNBModAck_Item_resource_configuration._ext = []
    _E_RABs_Admitted_ToReleased_SgNBModAck_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_Admitted_ToReleased_SgNBModAck_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_Admitted_ToReleased_SgNBModAck_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_Admitted_ToReleased_SgNBModAck_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_Admitted_ToReleased_SgNBModAck_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_Admitted_ToReleased_SgNBModAck_Item_iE_Extensions__item__id._const_tab = ____E_RABs_Admitted_ToReleased_SgNBModAck_Item_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToReleased_SgNBModAck_Item_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_Admitted_ToReleased_SgNBModAck_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_Admitted_ToReleased_SgNBModAck_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_RABs_Admitted_ToReleased_SgNBModAck_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_Admitted_ToReleased_SgNBModAck_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_Admitted_ToReleased_SgNBModAck_Item_iE_Extensions__item__criticality._const_tab = ____E_RABs_Admitted_ToReleased_SgNBModAck_Item_iE_Extensions__item__criticality_tab
    ___E_RABs_Admitted_ToReleased_SgNBModAck_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_Admitted_ToReleased_SgNBModAck_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_Admitted_ToReleased_SgNBModAck_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_RABs_Admitted_ToReleased_SgNBModAck_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_Admitted_ToReleased_SgNBModAck_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_Admitted_ToReleased_SgNBModAck_Item_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_Admitted_ToReleased_SgNBModAck_Item_iE_Extensions__item__extensionValue_tab
    ___E_RABs_Admitted_ToReleased_SgNBModAck_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_Admitted_ToReleased_SgNBModAck_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_Admitted_ToReleased_SgNBModAck_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_Admitted_ToReleased_SgNBModAck_Item_iE_Extensions__item__id),
        ('criticality', ___E_RABs_Admitted_ToReleased_SgNBModAck_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_Admitted_ToReleased_SgNBModAck_Item_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_Admitted_ToReleased_SgNBModAck_Item_iE_Extensions__item_._ext = None
    _E_RABs_Admitted_ToReleased_SgNBModAck_Item_iE_Extensions._cont = __E_RABs_Admitted_ToReleased_SgNBModAck_Item_iE_Extensions__item_
    _E_RABs_Admitted_ToReleased_SgNBModAck_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_Admitted_ToReleased_SgNBModAck_Item._cont = ASN1Dict([
        ('e-RAB-ID', _E_RABs_Admitted_ToReleased_SgNBModAck_Item_e_RAB_ID),
        ('en-DC-ResourceConfiguration', _E_RABs_Admitted_ToReleased_SgNBModAck_Item_en_DC_ResourceConfiguration),
        ('resource-configuration', _E_RABs_Admitted_ToReleased_SgNBModAck_Item_resource_configuration),
        ('iE-Extensions', _E_RABs_Admitted_ToReleased_SgNBModAck_Item_iE_Extensions),
        ])
    E_RABs_Admitted_ToReleased_SgNBModAck_Item._ext = []
    
    #-----< E-RABs-ToBeReleased-SgNBModAck-ItemExtIEs >-----#
    E_RABs_ToBeReleased_SgNBModAck_ItemExtIEs = CLASS(name='E-RABs-ToBeReleased-SgNBModAck-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    E_RABs_ToBeReleased_SgNBModAck_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RABs-Admitted-ToBeReleased-SgNBModAck-Item-SgNBPDCPpresent >-----#
    E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPpresent = SEQ(name='E-RABs-Admitted-ToBeReleased-SgNBModAck-Item-SgNBPDCPpresent', mode=MODE_TYPE)
    _E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__id._const_tab = ____E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__criticality._const_tab = ____E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__criticality_tab
    ___E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue_tab
    ___E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__id),
        ('criticality', ___E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item_._ext = None
    _E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions._cont = __E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item_
    _E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPpresent._cont = ASN1Dict([
        ('iE-Extensions', _E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions),
        ])
    E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPpresent._ext = []
    
    #-----< E-RABs-Admitted-ToBeReleased-SgNBModAck-Item-SgNBPDCPpresentExtIEs >-----#
    E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPpresentExtIEs = CLASS(name='E-RABs-Admitted-ToBeReleased-SgNBModAck-Item-SgNBPDCPpresentExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPpresentExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RABs-Admitted-ToBeReleased-SgNBModAck-Item-SgNBPDCPnotpresent >-----#
    E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPnotpresent = SEQ(name='E-RABs-Admitted-ToBeReleased-SgNBModAck-Item-SgNBPDCPnotpresent', mode=MODE_TYPE)
    _E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__id._const_tab = ____E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality._const_tab = ____E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality_tab
    ___E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue_tab
    ___E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__id),
        ('criticality', ___E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item_._ext = None
    _E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions._cont = __E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item_
    _E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPnotpresent._cont = ASN1Dict([
        ('iE-Extensions', _E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions),
        ])
    E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPnotpresent._ext = []
    
    #-----< E-RABs-Admitted-ToBeReleased-SgNBModAck-Item-SgNBPDCPnotpresentExtIEs >-----#
    E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPnotpresentExtIEs = CLASS(name='E-RABs-Admitted-ToBeReleased-SgNBModAck-Item-SgNBPDCPnotpresentExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPnotpresentExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SgNBModificationRequestReject >-----#
    SgNBModificationRequestReject = SEQ(name='SgNBModificationRequestReject', mode=MODE_TYPE)
    _SgNBModificationRequestReject_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __SgNBModificationRequestReject_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___SgNBModificationRequestReject_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____SgNBModificationRequestReject_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____SgNBModificationRequestReject_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SgNBModificationRequestReject_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNB-UE-X2AP-ID')))
    _____SgNBModificationRequestReject_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _____SgNBModificationRequestReject_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _____SgNBModificationRequestReject_protocolIEs__item__id_tab_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    ____SgNBModificationRequestReject_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'ignore'), ('Value', _____SgNBModificationRequestReject_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 207), ('criticality', 'ignore'), ('Value', _____SgNBModificationRequestReject_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _____SgNBModificationRequestReject_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _____SgNBModificationRequestReject_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 157), ('criticality', 'ignore'), ('Value', _____SgNBModificationRequestReject_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SgNBModificationRequestReject_protocolIEs__item__id._const_tab = ____SgNBModificationRequestReject_protocolIEs__item__id_tab
    ___SgNBModificationRequestReject_protocolIEs__item__id._const_tab_at = None
    ___SgNBModificationRequestReject_protocolIEs__item__id._const_tab_id = 'id'
    ___SgNBModificationRequestReject_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___SgNBModificationRequestReject_protocolIEs__item__criticality._const_tab = ____SgNBModificationRequestReject_protocolIEs__item__id_tab
    ___SgNBModificationRequestReject_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___SgNBModificationRequestReject_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___SgNBModificationRequestReject_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___SgNBModificationRequestReject_protocolIEs__item__value._const_tab = ____SgNBModificationRequestReject_protocolIEs__item__id_tab
    ___SgNBModificationRequestReject_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___SgNBModificationRequestReject_protocolIEs__item__value._const_tab_id = 'Value'
    __SgNBModificationRequestReject_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___SgNBModificationRequestReject_protocolIEs__item__id),
        ('criticality', ___SgNBModificationRequestReject_protocolIEs__item__criticality),
        ('value', ___SgNBModificationRequestReject_protocolIEs__item__value),
        ])
    __SgNBModificationRequestReject_protocolIEs__item_._ext = None
    _SgNBModificationRequestReject_protocolIEs._cont = __SgNBModificationRequestReject_protocolIEs__item_
    _SgNBModificationRequestReject_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    SgNBModificationRequestReject._cont = ASN1Dict([
        ('protocolIEs', _SgNBModificationRequestReject_protocolIEs),
        ])
    SgNBModificationRequestReject._ext = []
    
    #-----< SgNBModificationRequestReject-IEs >-----#
    SgNBModificationRequestReject_IEs = CLASS(name='SgNBModificationRequestReject-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _SgNBModificationRequestReject_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SgNBModificationRequestReject_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNB-UE-X2AP-ID')))
    _SgNBModificationRequestReject_IEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _SgNBModificationRequestReject_IEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _SgNBModificationRequestReject_IEs_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    SgNBModificationRequestReject_IEs._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'ignore'), ('Value', _SgNBModificationRequestReject_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 207), ('criticality', 'ignore'), ('Value', _SgNBModificationRequestReject_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _SgNBModificationRequestReject_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _SgNBModificationRequestReject_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 157), ('criticality', 'ignore'), ('Value', _SgNBModificationRequestReject_IEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< SgNBModificationRequired >-----#
    SgNBModificationRequired = SEQ(name='SgNBModificationRequired', mode=MODE_TYPE)
    _SgNBModificationRequired_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __SgNBModificationRequired_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___SgNBModificationRequired_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____SgNBModificationRequired_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____SgNBModificationRequired_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SgNBModificationRequired_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNB-UE-X2AP-ID')))
    _____SgNBModificationRequired_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _____SgNBModificationRequired_protocolIEs__item__id_tab_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PDCPChangeIndication')))
    _____SgNBModificationRequired_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-SgNBModReqdList')))
    _____SgNBModificationRequired_protocolIEs__item__id_tab_val_Value_5 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNBtoMeNBContainer')))
    _____SgNBModificationRequired_protocolIEs__item__id_tab_val_Value_6 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____SgNBModificationRequired_protocolIEs__item__id_tab_val_Value_7 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeModified-SgNBModReqdList')))
    _____SgNBModificationRequired_protocolIEs__item__id_tab_val_Value_8 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNBResourceCoordinationInformation')))
    _____SgNBModificationRequired_protocolIEs__item__id_tab_val_Value_9 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'RRC-Config-Ind')))
    _____SgNBModificationRequired_protocolIEs__item__id_tab_val_Value_10 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'LocationInformationSgNB')))
    _____SgNBModificationRequired_protocolIEs__item__id_tab_val_Value_11 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SCG-UE-HistoryInformation')))
    _____SgNBModificationRequired_protocolIEs__item__id_tab_val_Value_12 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SCGActivationRequest')))
    _____SgNBModificationRequired_protocolIEs__item__id_tab_val_Value_13 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CPACinformation-REQD')))
    _____SgNBModificationRequired_protocolIEs__item__id_tab_val_Value_14 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SCGreconfigNotification')))
    ____SgNBModificationRequired_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'reject'), ('Value', _____SgNBModificationRequired_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 207), ('criticality', 'reject'), ('Value', _____SgNBModificationRequired_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _____SgNBModificationRequired_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 249), ('criticality', 'ignore'), ('Value', _____SgNBModificationRequired_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 225), ('criticality', 'ignore'), ('Value', _____SgNBModificationRequired_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 211), ('criticality', 'ignore'), ('Value', _____SgNBModificationRequired_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 157), ('criticality', 'reject'), ('Value', _____SgNBModificationRequired_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 226), ('criticality', 'ignore'), ('Value', _____SgNBModificationRequired_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')]), dict([('id', 258), ('criticality', 'ignore'), ('Value', _____SgNBModificationRequired_protocolIEs__item__id_tab_val_Value_8), ('presence', 'optional')]), dict([('id', 272), ('criticality', 'reject'), ('Value', _____SgNBModificationRequired_protocolIEs__item__id_tab_val_Value_9), ('presence', 'optional')]), dict([('id', 331), ('criticality', 'ignore'), ('Value', _____SgNBModificationRequired_protocolIEs__item__id_tab_val_Value_10), ('presence', 'optional')]), dict([('id', 415), ('criticality', 'ignore'), ('Value', _____SgNBModificationRequired_protocolIEs__item__id_tab_val_Value_11), ('presence', 'optional')]), dict([('id', 423), ('criticality', 'ignore'), ('Value', _____SgNBModificationRequired_protocolIEs__item__id_tab_val_Value_12), ('presence', 'optional')]), dict([('id', 428), ('criticality', 'ignore'), ('Value', _____SgNBModificationRequired_protocolIEs__item__id_tab_val_Value_13), ('presence', 'optional')]), dict([('id', 438), ('criticality', 'ignore'), ('Value', _____SgNBModificationRequired_protocolIEs__item__id_tab_val_Value_14), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SgNBModificationRequired_protocolIEs__item__id._const_tab = ____SgNBModificationRequired_protocolIEs__item__id_tab
    ___SgNBModificationRequired_protocolIEs__item__id._const_tab_at = None
    ___SgNBModificationRequired_protocolIEs__item__id._const_tab_id = 'id'
    ___SgNBModificationRequired_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___SgNBModificationRequired_protocolIEs__item__criticality._const_tab = ____SgNBModificationRequired_protocolIEs__item__id_tab
    ___SgNBModificationRequired_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___SgNBModificationRequired_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___SgNBModificationRequired_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___SgNBModificationRequired_protocolIEs__item__value._const_tab = ____SgNBModificationRequired_protocolIEs__item__id_tab
    ___SgNBModificationRequired_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___SgNBModificationRequired_protocolIEs__item__value._const_tab_id = 'Value'
    __SgNBModificationRequired_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___SgNBModificationRequired_protocolIEs__item__id),
        ('criticality', ___SgNBModificationRequired_protocolIEs__item__criticality),
        ('value', ___SgNBModificationRequired_protocolIEs__item__value),
        ])
    __SgNBModificationRequired_protocolIEs__item_._ext = None
    _SgNBModificationRequired_protocolIEs._cont = __SgNBModificationRequired_protocolIEs__item_
    _SgNBModificationRequired_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    SgNBModificationRequired._cont = ASN1Dict([
        ('protocolIEs', _SgNBModificationRequired_protocolIEs),
        ])
    SgNBModificationRequired._ext = []
    
    #-----< SgNBModificationRequired-IEs >-----#
    SgNBModificationRequired_IEs = CLASS(name='SgNBModificationRequired-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _SgNBModificationRequired_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SgNBModificationRequired_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNB-UE-X2AP-ID')))
    _SgNBModificationRequired_IEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _SgNBModificationRequired_IEs_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PDCPChangeIndication')))
    _SgNBModificationRequired_IEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-SgNBModReqdList')))
    _SgNBModificationRequired_IEs_val_Value_5 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNBtoMeNBContainer')))
    _SgNBModificationRequired_IEs_val_Value_6 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _SgNBModificationRequired_IEs_val_Value_7 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeModified-SgNBModReqdList')))
    _SgNBModificationRequired_IEs_val_Value_8 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNBResourceCoordinationInformation')))
    _SgNBModificationRequired_IEs_val_Value_9 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'RRC-Config-Ind')))
    _SgNBModificationRequired_IEs_val_Value_10 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'LocationInformationSgNB')))
    _SgNBModificationRequired_IEs_val_Value_11 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SCG-UE-HistoryInformation')))
    _SgNBModificationRequired_IEs_val_Value_12 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SCGActivationRequest')))
    _SgNBModificationRequired_IEs_val_Value_13 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CPACinformation-REQD')))
    _SgNBModificationRequired_IEs_val_Value_14 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SCGreconfigNotification')))
    SgNBModificationRequired_IEs._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'reject'), ('Value', _SgNBModificationRequired_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 207), ('criticality', 'reject'), ('Value', _SgNBModificationRequired_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _SgNBModificationRequired_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 249), ('criticality', 'ignore'), ('Value', _SgNBModificationRequired_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 225), ('criticality', 'ignore'), ('Value', _SgNBModificationRequired_IEs_val_Value_4), ('presence', 'optional')]), dict([('id', 211), ('criticality', 'ignore'), ('Value', _SgNBModificationRequired_IEs_val_Value_5), ('presence', 'optional')]), dict([('id', 157), ('criticality', 'reject'), ('Value', _SgNBModificationRequired_IEs_val_Value_6), ('presence', 'optional')]), dict([('id', 226), ('criticality', 'ignore'), ('Value', _SgNBModificationRequired_IEs_val_Value_7), ('presence', 'optional')]), dict([('id', 258), ('criticality', 'ignore'), ('Value', _SgNBModificationRequired_IEs_val_Value_8), ('presence', 'optional')]), dict([('id', 272), ('criticality', 'reject'), ('Value', _SgNBModificationRequired_IEs_val_Value_9), ('presence', 'optional')]), dict([('id', 331), ('criticality', 'ignore'), ('Value', _SgNBModificationRequired_IEs_val_Value_10), ('presence', 'optional')]), dict([('id', 415), ('criticality', 'ignore'), ('Value', _SgNBModificationRequired_IEs_val_Value_11), ('presence', 'optional')]), dict([('id', 423), ('criticality', 'ignore'), ('Value', _SgNBModificationRequired_IEs_val_Value_12), ('presence', 'optional')]), dict([('id', 428), ('criticality', 'ignore'), ('Value', _SgNBModificationRequired_IEs_val_Value_13), ('presence', 'optional')]), dict([('id', 438), ('criticality', 'ignore'), ('Value', _SgNBModificationRequired_IEs_val_Value_14), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeReleased-SgNBModReqdList >-----#
    E_RABs_ToBeReleased_SgNBModReqdList = SEQ_OF(name='E-RABs-ToBeReleased-SgNBModReqdList', mode=MODE_TYPE)
    _E_RABs_ToBeReleased_SgNBModReqdList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __E_RABs_ToBeReleased_SgNBModReqdList__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ___E_RABs_ToBeReleased_SgNBModReqdList__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____E_RABs_ToBeReleased_SgNBModReqdList__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-SgNBModReqd-Item')))
    ___E_RABs_ToBeReleased_SgNBModReqdList__item__id_tab._val = ASN1Set(rv=[dict([('id', 227), ('criticality', 'ignore'), ('Value', ____E_RABs_ToBeReleased_SgNBModReqdList__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E_RABs_ToBeReleased_SgNBModReqdList__item__id._const_tab = ___E_RABs_ToBeReleased_SgNBModReqdList__item__id_tab
    __E_RABs_ToBeReleased_SgNBModReqdList__item__id._const_tab_at = None
    __E_RABs_ToBeReleased_SgNBModReqdList__item__id._const_tab_id = 'id'
    __E_RABs_ToBeReleased_SgNBModReqdList__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    __E_RABs_ToBeReleased_SgNBModReqdList__item__criticality._const_tab = ___E_RABs_ToBeReleased_SgNBModReqdList__item__id_tab
    __E_RABs_ToBeReleased_SgNBModReqdList__item__criticality._const_tab_at = ('..', 'id')
    __E_RABs_ToBeReleased_SgNBModReqdList__item__criticality._const_tab_id = 'criticality'
    __E_RABs_ToBeReleased_SgNBModReqdList__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    __E_RABs_ToBeReleased_SgNBModReqdList__item__value._const_tab = ___E_RABs_ToBeReleased_SgNBModReqdList__item__id_tab
    __E_RABs_ToBeReleased_SgNBModReqdList__item__value._const_tab_at = ('..', 'id')
    __E_RABs_ToBeReleased_SgNBModReqdList__item__value._const_tab_id = 'Value'
    _E_RABs_ToBeReleased_SgNBModReqdList__item_._cont = ASN1Dict([
        ('id', __E_RABs_ToBeReleased_SgNBModReqdList__item__id),
        ('criticality', __E_RABs_ToBeReleased_SgNBModReqdList__item__criticality),
        ('value', __E_RABs_ToBeReleased_SgNBModReqdList__item__value),
        ])
    _E_RABs_ToBeReleased_SgNBModReqdList__item_._ext = None
    E_RABs_ToBeReleased_SgNBModReqdList._cont = _E_RABs_ToBeReleased_SgNBModReqdList__item_
    E_RABs_ToBeReleased_SgNBModReqdList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABs-ToBeReleased-SgNBModReqd-ItemIEs >-----#
    E_RABs_ToBeReleased_SgNBModReqd_ItemIEs = CLASS(name='E-RABs-ToBeReleased-SgNBModReqd-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _E_RABs_ToBeReleased_SgNBModReqd_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-SgNBModReqd-Item')))
    E_RABs_ToBeReleased_SgNBModReqd_ItemIEs._val = ASN1Set(rv=[dict([('id', 227), ('criticality', 'ignore'), ('Value', _E_RABs_ToBeReleased_SgNBModReqd_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeReleased-SgNBModReqd-Item >-----#
    E_RABs_ToBeReleased_SgNBModReqd_Item = SEQ(name='E-RABs-ToBeReleased-SgNBModReqd-Item', mode=MODE_TYPE)
    _E_RABs_ToBeReleased_SgNBModReqd_Item_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_ToBeReleased_SgNBModReqd_Item_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _E_RABs_ToBeReleased_SgNBModReqd_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_ToBeReleased_SgNBModReqd_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_ToBeReleased_SgNBModReqd_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_ToBeReleased_SgNBModReqd_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____E_RABs_ToBeReleased_SgNBModReqd_Item_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'RLCMode')))
    ____E_RABs_ToBeReleased_SgNBModReqd_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 317), ('criticality', 'ignore'), ('Extension', _____E_RABs_ToBeReleased_SgNBModReqd_Item_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_SgNBModReqd_Item_iE_Extensions__item__id._const_tab = ____E_RABs_ToBeReleased_SgNBModReqd_Item_iE_Extensions__item__id_tab
    ___E_RABs_ToBeReleased_SgNBModReqd_Item_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_ToBeReleased_SgNBModReqd_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_ToBeReleased_SgNBModReqd_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___E_RABs_ToBeReleased_SgNBModReqd_Item_iE_Extensions__item__criticality._const_tab = ____E_RABs_ToBeReleased_SgNBModReqd_Item_iE_Extensions__item__id_tab
    ___E_RABs_ToBeReleased_SgNBModReqd_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeReleased_SgNBModReqd_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_ToBeReleased_SgNBModReqd_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___E_RABs_ToBeReleased_SgNBModReqd_Item_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_ToBeReleased_SgNBModReqd_Item_iE_Extensions__item__id_tab
    ___E_RABs_ToBeReleased_SgNBModReqd_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeReleased_SgNBModReqd_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_ToBeReleased_SgNBModReqd_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_ToBeReleased_SgNBModReqd_Item_iE_Extensions__item__id),
        ('criticality', ___E_RABs_ToBeReleased_SgNBModReqd_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_ToBeReleased_SgNBModReqd_Item_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_ToBeReleased_SgNBModReqd_Item_iE_Extensions__item_._ext = None
    _E_RABs_ToBeReleased_SgNBModReqd_Item_iE_Extensions._cont = __E_RABs_ToBeReleased_SgNBModReqd_Item_iE_Extensions__item_
    _E_RABs_ToBeReleased_SgNBModReqd_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_ToBeReleased_SgNBModReqd_Item._cont = ASN1Dict([
        ('e-RAB-ID', _E_RABs_ToBeReleased_SgNBModReqd_Item_e_RAB_ID),
        ('cause', _E_RABs_ToBeReleased_SgNBModReqd_Item_cause),
        ('iE-Extensions', _E_RABs_ToBeReleased_SgNBModReqd_Item_iE_Extensions),
        ])
    E_RABs_ToBeReleased_SgNBModReqd_Item._ext = []
    
    #-----< E-RABs-ToBeReleased-SgNBModReqd-ItemExtIEs >-----#
    E_RABs_ToBeReleased_SgNBModReqd_ItemExtIEs = CLASS(name='E-RABs-ToBeReleased-SgNBModReqd-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _E_RABs_ToBeReleased_SgNBModReqd_ItemExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'RLCMode')))
    E_RABs_ToBeReleased_SgNBModReqd_ItemExtIEs._val = ASN1Set(rv=[dict([('id', 317), ('criticality', 'ignore'), ('Extension', _E_RABs_ToBeReleased_SgNBModReqd_ItemExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeModified-SgNBModReqdList >-----#
    E_RABs_ToBeModified_SgNBModReqdList = SEQ_OF(name='E-RABs-ToBeModified-SgNBModReqdList', mode=MODE_TYPE)
    _E_RABs_ToBeModified_SgNBModReqdList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __E_RABs_ToBeModified_SgNBModReqdList__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ___E_RABs_ToBeModified_SgNBModReqdList__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____E_RABs_ToBeModified_SgNBModReqdList__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeModified-SgNBModReqd-Item')))
    ___E_RABs_ToBeModified_SgNBModReqdList__item__id_tab._val = ASN1Set(rv=[dict([('id', 228), ('criticality', 'ignore'), ('Value', ____E_RABs_ToBeModified_SgNBModReqdList__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E_RABs_ToBeModified_SgNBModReqdList__item__id._const_tab = ___E_RABs_ToBeModified_SgNBModReqdList__item__id_tab
    __E_RABs_ToBeModified_SgNBModReqdList__item__id._const_tab_at = None
    __E_RABs_ToBeModified_SgNBModReqdList__item__id._const_tab_id = 'id'
    __E_RABs_ToBeModified_SgNBModReqdList__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    __E_RABs_ToBeModified_SgNBModReqdList__item__criticality._const_tab = ___E_RABs_ToBeModified_SgNBModReqdList__item__id_tab
    __E_RABs_ToBeModified_SgNBModReqdList__item__criticality._const_tab_at = ('..', 'id')
    __E_RABs_ToBeModified_SgNBModReqdList__item__criticality._const_tab_id = 'criticality'
    __E_RABs_ToBeModified_SgNBModReqdList__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    __E_RABs_ToBeModified_SgNBModReqdList__item__value._const_tab = ___E_RABs_ToBeModified_SgNBModReqdList__item__id_tab
    __E_RABs_ToBeModified_SgNBModReqdList__item__value._const_tab_at = ('..', 'id')
    __E_RABs_ToBeModified_SgNBModReqdList__item__value._const_tab_id = 'Value'
    _E_RABs_ToBeModified_SgNBModReqdList__item_._cont = ASN1Dict([
        ('id', __E_RABs_ToBeModified_SgNBModReqdList__item__id),
        ('criticality', __E_RABs_ToBeModified_SgNBModReqdList__item__criticality),
        ('value', __E_RABs_ToBeModified_SgNBModReqdList__item__value),
        ])
    _E_RABs_ToBeModified_SgNBModReqdList__item_._ext = None
    E_RABs_ToBeModified_SgNBModReqdList._cont = _E_RABs_ToBeModified_SgNBModReqdList__item_
    E_RABs_ToBeModified_SgNBModReqdList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABs-ToBeModified-SgNBModReqd-ItemIEs >-----#
    E_RABs_ToBeModified_SgNBModReqd_ItemIEs = CLASS(name='E-RABs-ToBeModified-SgNBModReqd-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _E_RABs_ToBeModified_SgNBModReqd_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeModified-SgNBModReqd-Item')))
    E_RABs_ToBeModified_SgNBModReqd_ItemIEs._val = ASN1Set(rv=[dict([('id', 228), ('criticality', 'ignore'), ('Value', _E_RABs_ToBeModified_SgNBModReqd_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeModified-SgNBModReqd-Item >-----#
    E_RABs_ToBeModified_SgNBModReqd_Item = SEQ(name='E-RABs-ToBeModified-SgNBModReqd-Item', mode=MODE_TYPE)
    _E_RABs_ToBeModified_SgNBModReqd_Item_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_ToBeModified_SgNBModReqd_Item_en_DC_ResourceConfiguration = SEQ(name='en-DC-ResourceConfiguration', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'EN-DC-ResourceConfiguration')))
    _E_RABs_ToBeModified_SgNBModReqd_Item_resource_configuration = CHOICE(name='resource-configuration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __E_RABs_ToBeModified_SgNBModReqd_Item_resource_configuration_sgNBPDCPpresent = SEQ(name='sgNBPDCPpresent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeModified-SgNBModReqd-Item-SgNBPDCPpresent')))
    __E_RABs_ToBeModified_SgNBModReqd_Item_resource_configuration_sgNBPDCPnotpresent = SEQ(name='sgNBPDCPnotpresent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeModified-SgNBModReqd-Item-SgNBPDCPnotpresent')))
    _E_RABs_ToBeModified_SgNBModReqd_Item_resource_configuration._cont = ASN1Dict([
        ('sgNBPDCPpresent', __E_RABs_ToBeModified_SgNBModReqd_Item_resource_configuration_sgNBPDCPpresent),
        ('sgNBPDCPnotpresent', __E_RABs_ToBeModified_SgNBModReqd_Item_resource_configuration_sgNBPDCPnotpresent),
        ])
    _E_RABs_ToBeModified_SgNBModReqd_Item_resource_configuration._ext = []
    _E_RABs_ToBeModified_SgNBModReqd_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_ToBeModified_SgNBModReqd_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_ToBeModified_SgNBModReqd_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_ToBeModified_SgNBModReqd_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeModified_SgNBModReqd_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeModified_SgNBModReqd_Item_iE_Extensions__item__id._const_tab = ____E_RABs_ToBeModified_SgNBModReqd_Item_iE_Extensions__item__id_tab
    ___E_RABs_ToBeModified_SgNBModReqd_Item_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_ToBeModified_SgNBModReqd_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_ToBeModified_SgNBModReqd_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_RABs_ToBeModified_SgNBModReqd_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeModified_SgNBModReqd_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeModified_SgNBModReqd_Item_iE_Extensions__item__criticality._const_tab = ____E_RABs_ToBeModified_SgNBModReqd_Item_iE_Extensions__item__criticality_tab
    ___E_RABs_ToBeModified_SgNBModReqd_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeModified_SgNBModReqd_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_ToBeModified_SgNBModReqd_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_RABs_ToBeModified_SgNBModReqd_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeModified_SgNBModReqd_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeModified_SgNBModReqd_Item_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_ToBeModified_SgNBModReqd_Item_iE_Extensions__item__extensionValue_tab
    ___E_RABs_ToBeModified_SgNBModReqd_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeModified_SgNBModReqd_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_ToBeModified_SgNBModReqd_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_ToBeModified_SgNBModReqd_Item_iE_Extensions__item__id),
        ('criticality', ___E_RABs_ToBeModified_SgNBModReqd_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_ToBeModified_SgNBModReqd_Item_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_ToBeModified_SgNBModReqd_Item_iE_Extensions__item_._ext = None
    _E_RABs_ToBeModified_SgNBModReqd_Item_iE_Extensions._cont = __E_RABs_ToBeModified_SgNBModReqd_Item_iE_Extensions__item_
    _E_RABs_ToBeModified_SgNBModReqd_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_ToBeModified_SgNBModReqd_Item._cont = ASN1Dict([
        ('e-RAB-ID', _E_RABs_ToBeModified_SgNBModReqd_Item_e_RAB_ID),
        ('en-DC-ResourceConfiguration', _E_RABs_ToBeModified_SgNBModReqd_Item_en_DC_ResourceConfiguration),
        ('resource-configuration', _E_RABs_ToBeModified_SgNBModReqd_Item_resource_configuration),
        ('iE-Extensions', _E_RABs_ToBeModified_SgNBModReqd_Item_iE_Extensions),
        ])
    E_RABs_ToBeModified_SgNBModReqd_Item._ext = []
    
    #-----< E-RABs-ToBeModified-SgNBModReqd-ItemExtIEs >-----#
    E_RABs_ToBeModified_SgNBModReqd_ItemExtIEs = CLASS(name='E-RABs-ToBeModified-SgNBModReqd-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    E_RABs_ToBeModified_SgNBModReqd_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeModified-SgNBModReqd-Item-SgNBPDCPpresent >-----#
    E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresent = SEQ(name='E-RABs-ToBeModified-SgNBModReqd-Item-SgNBPDCPpresent', mode=MODE_TYPE)
    _E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresent_requested_MCG_E_RAB_Level_QoS_Parameters = SEQ(name='requested-MCG-E-RAB-Level-QoS-Parameters', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-Level-QoS-Parameters')), opt=True)
    _E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresent_uL_Configuration = SEQ(name='uL-Configuration', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ULConfiguration')), opt=True)
    _E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresent_sgNB_UL_GTP_TEIDatPDCP = SEQ(name='sgNB-UL-GTP-TEIDatPDCP', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresent_s1_DL_GTP_TEIDatSgNB = SEQ(name='s1-DL-GTP-TEIDatSgNB', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresent_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresent_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresent_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PDCPSnLength')))
    _____E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PDCPSnLength')))
    _____E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'NewDRBIDrequest')))
    ____E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 302), ('criticality', 'ignore'), ('Extension', _____E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 311), ('criticality', 'ignore'), ('Extension', _____E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 325), ('criticality', 'ignore'), ('Extension', _____E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresent_iE_Extensions__item__id._const_tab = ____E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab
    ___E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresent_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresent_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresent_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresent_iE_Extensions__item__criticality._const_tab = ____E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab
    ___E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresent_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresent_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab
    ___E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresent_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresent_iE_Extensions__item__id),
        ('criticality', ___E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresent_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresent_iE_Extensions__item_._ext = None
    _E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresent_iE_Extensions._cont = __E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresent_iE_Extensions__item_
    _E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresent_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresent._cont = ASN1Dict([
        ('requested-MCG-E-RAB-Level-QoS-Parameters', _E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresent_requested_MCG_E_RAB_Level_QoS_Parameters),
        ('uL-Configuration', _E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresent_uL_Configuration),
        ('sgNB-UL-GTP-TEIDatPDCP', _E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresent_sgNB_UL_GTP_TEIDatPDCP),
        ('s1-DL-GTP-TEIDatSgNB', _E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresent_s1_DL_GTP_TEIDatSgNB),
        ('iE-Extensions', _E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresent_iE_Extensions),
        ])
    E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresent._ext = []
    
    #-----< E-RABs-ToBeModified-SgNBModReqd-Item-SgNBPDCPpresentExtIEs >-----#
    E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresentExtIEs = CLASS(name='E-RABs-ToBeModified-SgNBModReqd-Item-SgNBPDCPpresentExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresentExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PDCPSnLength')))
    _E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresentExtIEs_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PDCPSnLength')))
    _E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresentExtIEs_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'NewDRBIDrequest')))
    E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresentExtIEs._val = ASN1Set(rv=[dict([('id', 302), ('criticality', 'ignore'), ('Extension', _E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresentExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 311), ('criticality', 'ignore'), ('Extension', _E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresentExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 325), ('criticality', 'ignore'), ('Extension', _E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresentExtIEs_val_Extension_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeModified-SgNBModReqd-Item-SgNBPDCPnotpresent >-----#
    E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPnotpresent = SEQ(name='E-RABs-ToBeModified-SgNBModReqd-Item-SgNBPDCPnotpresent', mode=MODE_TYPE)
    _E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPnotpresent_sgNB_DL_GTP_TEIDatSCG = SEQ(name='sgNB-DL-GTP-TEIDatSCG', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPnotpresent_secondary_sgNB_DL_GTP_TEIDatSCG = SEQ(name='secondary-sgNB-DL-GTP-TEIDatSCG', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPnotpresent_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPnotpresent_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPnotpresent_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'RLC-Status')))
    _____E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'LCID')))
    ____E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 300), ('criticality', 'ignore'), ('Extension', _____E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 314), ('criticality', 'ignore'), ('Extension', _____E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPnotpresent_iE_Extensions__item__id._const_tab = ____E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab
    ___E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPnotpresent_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPnotpresent_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality._const_tab = ____E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab
    ___E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab
    ___E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPnotpresent_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPnotpresent_iE_Extensions__item__id),
        ('criticality', ___E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPnotpresent_iE_Extensions__item_._ext = None
    _E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPnotpresent_iE_Extensions._cont = __E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPnotpresent_iE_Extensions__item_
    _E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPnotpresent_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPnotpresent._cont = ASN1Dict([
        ('sgNB-DL-GTP-TEIDatSCG', _E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPnotpresent_sgNB_DL_GTP_TEIDatSCG),
        ('secondary-sgNB-DL-GTP-TEIDatSCG', _E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPnotpresent_secondary_sgNB_DL_GTP_TEIDatSCG),
        ('iE-Extensions', _E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPnotpresent_iE_Extensions),
        ])
    E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPnotpresent._ext = []
    
    #-----< E-RABs-ToBeModified-SgNBModReqd-Item-SgNBPDCPnotpresentExtIEs >-----#
    E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPnotpresentExtIEs = CLASS(name='E-RABs-ToBeModified-SgNBModReqd-Item-SgNBPDCPnotpresentExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPnotpresentExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'RLC-Status')))
    _E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPnotpresentExtIEs_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'LCID')))
    E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPnotpresentExtIEs._val = ASN1Set(rv=[dict([('id', 300), ('criticality', 'ignore'), ('Extension', _E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPnotpresentExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 314), ('criticality', 'ignore'), ('Extension', _E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPnotpresentExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< SgNBModificationConfirm >-----#
    SgNBModificationConfirm = SEQ(name='SgNBModificationConfirm', mode=MODE_TYPE)
    _SgNBModificationConfirm_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __SgNBModificationConfirm_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___SgNBModificationConfirm_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____SgNBModificationConfirm_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____SgNBModificationConfirm_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SgNBModificationConfirm_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNB-UE-X2AP-ID')))
    _____SgNBModificationConfirm_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-AdmittedToBeModified-SgNBModConfList')))
    _____SgNBModificationConfirm_protocolIEs__item__id_tab_val_Value_3 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MeNBtoSgNBContainer')))
    _____SgNBModificationConfirm_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _____SgNBModificationConfirm_protocolIEs__item__id_tab_val_Value_5 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____SgNBModificationConfirm_protocolIEs__item__id_tab_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MeNBResourceCoordinationInformation')))
    ____SgNBModificationConfirm_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'ignore'), ('Value', _____SgNBModificationConfirm_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 207), ('criticality', 'ignore'), ('Value', _____SgNBModificationConfirm_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 294), ('criticality', 'ignore'), ('Value', _____SgNBModificationConfirm_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 206), ('criticality', 'ignore'), ('Value', _____SgNBModificationConfirm_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _____SgNBModificationConfirm_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 157), ('criticality', 'ignore'), ('Value', _____SgNBModificationConfirm_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 257), ('criticality', 'ignore'), ('Value', _____SgNBModificationConfirm_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SgNBModificationConfirm_protocolIEs__item__id._const_tab = ____SgNBModificationConfirm_protocolIEs__item__id_tab
    ___SgNBModificationConfirm_protocolIEs__item__id._const_tab_at = None
    ___SgNBModificationConfirm_protocolIEs__item__id._const_tab_id = 'id'
    ___SgNBModificationConfirm_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___SgNBModificationConfirm_protocolIEs__item__criticality._const_tab = ____SgNBModificationConfirm_protocolIEs__item__id_tab
    ___SgNBModificationConfirm_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___SgNBModificationConfirm_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___SgNBModificationConfirm_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___SgNBModificationConfirm_protocolIEs__item__value._const_tab = ____SgNBModificationConfirm_protocolIEs__item__id_tab
    ___SgNBModificationConfirm_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___SgNBModificationConfirm_protocolIEs__item__value._const_tab_id = 'Value'
    __SgNBModificationConfirm_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___SgNBModificationConfirm_protocolIEs__item__id),
        ('criticality', ___SgNBModificationConfirm_protocolIEs__item__criticality),
        ('value', ___SgNBModificationConfirm_protocolIEs__item__value),
        ])
    __SgNBModificationConfirm_protocolIEs__item_._ext = None
    _SgNBModificationConfirm_protocolIEs._cont = __SgNBModificationConfirm_protocolIEs__item_
    _SgNBModificationConfirm_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    SgNBModificationConfirm._cont = ASN1Dict([
        ('protocolIEs', _SgNBModificationConfirm_protocolIEs),
        ])
    SgNBModificationConfirm._ext = []
    
    #-----< SgNBModificationConfirm-IEs >-----#
    SgNBModificationConfirm_IEs = CLASS(name='SgNBModificationConfirm-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _SgNBModificationConfirm_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SgNBModificationConfirm_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNB-UE-X2AP-ID')))
    _SgNBModificationConfirm_IEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-AdmittedToBeModified-SgNBModConfList')))
    _SgNBModificationConfirm_IEs_val_Value_3 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MeNBtoSgNBContainer')))
    _SgNBModificationConfirm_IEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _SgNBModificationConfirm_IEs_val_Value_5 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _SgNBModificationConfirm_IEs_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MeNBResourceCoordinationInformation')))
    SgNBModificationConfirm_IEs._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'ignore'), ('Value', _SgNBModificationConfirm_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 207), ('criticality', 'ignore'), ('Value', _SgNBModificationConfirm_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 294), ('criticality', 'ignore'), ('Value', _SgNBModificationConfirm_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 206), ('criticality', 'ignore'), ('Value', _SgNBModificationConfirm_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _SgNBModificationConfirm_IEs_val_Value_4), ('presence', 'optional')]), dict([('id', 157), ('criticality', 'ignore'), ('Value', _SgNBModificationConfirm_IEs_val_Value_5), ('presence', 'optional')]), dict([('id', 257), ('criticality', 'ignore'), ('Value', _SgNBModificationConfirm_IEs_val_Value_6), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-AdmittedToBeModified-SgNBModConfList >-----#
    E_RABs_AdmittedToBeModified_SgNBModConfList = SEQ_OF(name='E-RABs-AdmittedToBeModified-SgNBModConfList', mode=MODE_TYPE)
    _E_RABs_AdmittedToBeModified_SgNBModConfList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __E_RABs_AdmittedToBeModified_SgNBModConfList__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ___E_RABs_AdmittedToBeModified_SgNBModConfList__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____E_RABs_AdmittedToBeModified_SgNBModConfList__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-AdmittedToBeModified-SgNBModConf-Item')))
    ___E_RABs_AdmittedToBeModified_SgNBModConfList__item__id_tab._val = ASN1Set(rv=[dict([('id', 295), ('criticality', 'ignore'), ('Value', ____E_RABs_AdmittedToBeModified_SgNBModConfList__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E_RABs_AdmittedToBeModified_SgNBModConfList__item__id._const_tab = ___E_RABs_AdmittedToBeModified_SgNBModConfList__item__id_tab
    __E_RABs_AdmittedToBeModified_SgNBModConfList__item__id._const_tab_at = None
    __E_RABs_AdmittedToBeModified_SgNBModConfList__item__id._const_tab_id = 'id'
    __E_RABs_AdmittedToBeModified_SgNBModConfList__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    __E_RABs_AdmittedToBeModified_SgNBModConfList__item__criticality._const_tab = ___E_RABs_AdmittedToBeModified_SgNBModConfList__item__id_tab
    __E_RABs_AdmittedToBeModified_SgNBModConfList__item__criticality._const_tab_at = ('..', 'id')
    __E_RABs_AdmittedToBeModified_SgNBModConfList__item__criticality._const_tab_id = 'criticality'
    __E_RABs_AdmittedToBeModified_SgNBModConfList__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    __E_RABs_AdmittedToBeModified_SgNBModConfList__item__value._const_tab = ___E_RABs_AdmittedToBeModified_SgNBModConfList__item__id_tab
    __E_RABs_AdmittedToBeModified_SgNBModConfList__item__value._const_tab_at = ('..', 'id')
    __E_RABs_AdmittedToBeModified_SgNBModConfList__item__value._const_tab_id = 'Value'
    _E_RABs_AdmittedToBeModified_SgNBModConfList__item_._cont = ASN1Dict([
        ('id', __E_RABs_AdmittedToBeModified_SgNBModConfList__item__id),
        ('criticality', __E_RABs_AdmittedToBeModified_SgNBModConfList__item__criticality),
        ('value', __E_RABs_AdmittedToBeModified_SgNBModConfList__item__value),
        ])
    _E_RABs_AdmittedToBeModified_SgNBModConfList__item_._ext = None
    E_RABs_AdmittedToBeModified_SgNBModConfList._cont = _E_RABs_AdmittedToBeModified_SgNBModConfList__item_
    E_RABs_AdmittedToBeModified_SgNBModConfList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABs-AdmittedToBeModified-SgNBModConf-ItemIEs >-----#
    E_RABs_AdmittedToBeModified_SgNBModConf_ItemIEs = CLASS(name='E-RABs-AdmittedToBeModified-SgNBModConf-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _E_RABs_AdmittedToBeModified_SgNBModConf_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-AdmittedToBeModified-SgNBModConf-Item')))
    E_RABs_AdmittedToBeModified_SgNBModConf_ItemIEs._val = ASN1Set(rv=[dict([('id', 295), ('criticality', 'ignore'), ('Value', _E_RABs_AdmittedToBeModified_SgNBModConf_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-AdmittedToBeModified-SgNBModConf-Item >-----#
    E_RABs_AdmittedToBeModified_SgNBModConf_Item = SEQ(name='E-RABs-AdmittedToBeModified-SgNBModConf-Item', mode=MODE_TYPE)
    _E_RABs_AdmittedToBeModified_SgNBModConf_Item_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_AdmittedToBeModified_SgNBModConf_Item_en_DC_ResourceConfiguration = SEQ(name='en-DC-ResourceConfiguration', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'EN-DC-ResourceConfiguration')))
    _E_RABs_AdmittedToBeModified_SgNBModConf_Item_resource_configuration = CHOICE(name='resource-configuration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __E_RABs_AdmittedToBeModified_SgNBModConf_Item_resource_configuration_sgNBPDCPpresent = SEQ(name='sgNBPDCPpresent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-AdmittedToBeModified-SgNBModConf-Item-SgNBPDCPpresent')))
    __E_RABs_AdmittedToBeModified_SgNBModConf_Item_resource_configuration_sgNBPDCPnotpresent = SEQ(name='sgNBPDCPnotpresent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-AdmittedToBeModified-SgNBModConf-Item-SgNBPDCPnotpresent')))
    _E_RABs_AdmittedToBeModified_SgNBModConf_Item_resource_configuration._cont = ASN1Dict([
        ('sgNBPDCPpresent', __E_RABs_AdmittedToBeModified_SgNBModConf_Item_resource_configuration_sgNBPDCPpresent),
        ('sgNBPDCPnotpresent', __E_RABs_AdmittedToBeModified_SgNBModConf_Item_resource_configuration_sgNBPDCPnotpresent),
        ])
    _E_RABs_AdmittedToBeModified_SgNBModConf_Item_resource_configuration._ext = []
    _E_RABs_AdmittedToBeModified_SgNBModConf_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_AdmittedToBeModified_SgNBModConf_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_AdmittedToBeModified_SgNBModConf_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_AdmittedToBeModified_SgNBModConf_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_AdmittedToBeModified_SgNBModConf_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_AdmittedToBeModified_SgNBModConf_Item_iE_Extensions__item__id._const_tab = ____E_RABs_AdmittedToBeModified_SgNBModConf_Item_iE_Extensions__item__id_tab
    ___E_RABs_AdmittedToBeModified_SgNBModConf_Item_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_AdmittedToBeModified_SgNBModConf_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_AdmittedToBeModified_SgNBModConf_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_RABs_AdmittedToBeModified_SgNBModConf_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_AdmittedToBeModified_SgNBModConf_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_AdmittedToBeModified_SgNBModConf_Item_iE_Extensions__item__criticality._const_tab = ____E_RABs_AdmittedToBeModified_SgNBModConf_Item_iE_Extensions__item__criticality_tab
    ___E_RABs_AdmittedToBeModified_SgNBModConf_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_AdmittedToBeModified_SgNBModConf_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_AdmittedToBeModified_SgNBModConf_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_RABs_AdmittedToBeModified_SgNBModConf_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_AdmittedToBeModified_SgNBModConf_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_AdmittedToBeModified_SgNBModConf_Item_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_AdmittedToBeModified_SgNBModConf_Item_iE_Extensions__item__extensionValue_tab
    ___E_RABs_AdmittedToBeModified_SgNBModConf_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_AdmittedToBeModified_SgNBModConf_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_AdmittedToBeModified_SgNBModConf_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_AdmittedToBeModified_SgNBModConf_Item_iE_Extensions__item__id),
        ('criticality', ___E_RABs_AdmittedToBeModified_SgNBModConf_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_AdmittedToBeModified_SgNBModConf_Item_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_AdmittedToBeModified_SgNBModConf_Item_iE_Extensions__item_._ext = None
    _E_RABs_AdmittedToBeModified_SgNBModConf_Item_iE_Extensions._cont = __E_RABs_AdmittedToBeModified_SgNBModConf_Item_iE_Extensions__item_
    _E_RABs_AdmittedToBeModified_SgNBModConf_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_AdmittedToBeModified_SgNBModConf_Item._cont = ASN1Dict([
        ('e-RAB-ID', _E_RABs_AdmittedToBeModified_SgNBModConf_Item_e_RAB_ID),
        ('en-DC-ResourceConfiguration', _E_RABs_AdmittedToBeModified_SgNBModConf_Item_en_DC_ResourceConfiguration),
        ('resource-configuration', _E_RABs_AdmittedToBeModified_SgNBModConf_Item_resource_configuration),
        ('iE-Extensions', _E_RABs_AdmittedToBeModified_SgNBModConf_Item_iE_Extensions),
        ])
    E_RABs_AdmittedToBeModified_SgNBModConf_Item._ext = []
    
    #-----< E-RABs-AdmittedToBeModified-SgNBModConf-ItemExtIEs >-----#
    E_RABs_AdmittedToBeModified_SgNBModConf_ItemExtIEs = CLASS(name='E-RABs-AdmittedToBeModified-SgNBModConf-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    E_RABs_AdmittedToBeModified_SgNBModConf_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RABs-AdmittedToBeModified-SgNBModConf-Item-SgNBPDCPpresent >-----#
    E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPpresent = SEQ(name='E-RABs-AdmittedToBeModified-SgNBModConf-Item-SgNBPDCPpresent', mode=MODE_TYPE)
    _E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPpresent_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPpresent_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPpresent_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPpresent_iE_Extensions__item__id._const_tab = ____E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab
    ___E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPpresent_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPpresent_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPpresent_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPpresent_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPpresent_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPpresent_iE_Extensions__item__criticality._const_tab = ____E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPpresent_iE_Extensions__item__criticality_tab
    ___E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPpresent_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPpresent_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue_tab
    ___E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPpresent_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPpresent_iE_Extensions__item__id),
        ('criticality', ___E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPpresent_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPpresent_iE_Extensions__item_._ext = None
    _E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPpresent_iE_Extensions._cont = __E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPpresent_iE_Extensions__item_
    _E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPpresent_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPpresent._cont = ASN1Dict([
        ('iE-Extensions', _E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPpresent_iE_Extensions),
        ])
    E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPpresent._ext = []
    
    #-----< E-RABs-AdmittedToBeModified-SgNBModConf-Item-SgNBPDCPpresentExtIEs >-----#
    E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPpresentExtIEs = CLASS(name='E-RABs-AdmittedToBeModified-SgNBModConf-Item-SgNBPDCPpresentExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPpresentExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RABs-AdmittedToBeModified-SgNBModConf-Item-SgNBPDCPnotpresent >-----#
    E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPnotpresent = SEQ(name='E-RABs-AdmittedToBeModified-SgNBModConf-Item-SgNBPDCPnotpresent', mode=MODE_TYPE)
    _E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPnotpresent_secondary_meNB_UL_GTP_TEIDatPDCP = SEQ(name='secondary-meNB-UL-GTP-TEIDatPDCP', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPnotpresent_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPnotpresent_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PDCPSnLength')))
    _____E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PDCPSnLength')))
    ____E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 302), ('criticality', 'ignore'), ('Extension', _____E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 311), ('criticality', 'ignore'), ('Extension', _____E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__id._const_tab = ____E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab
    ___E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality._const_tab = ____E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab
    ___E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab
    ___E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPnotpresent_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__id),
        ('criticality', ___E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPnotpresent_iE_Extensions__item_._ext = None
    _E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPnotpresent_iE_Extensions._cont = __E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPnotpresent_iE_Extensions__item_
    _E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPnotpresent_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPnotpresent._cont = ASN1Dict([
        ('secondary-meNB-UL-GTP-TEIDatPDCP', _E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPnotpresent_secondary_meNB_UL_GTP_TEIDatPDCP),
        ('iE-Extensions', _E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPnotpresent_iE_Extensions),
        ])
    E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPnotpresent._ext = []
    
    #-----< E-RABs-AdmittedToBeModified-SgNBModConf-Item-SgNBPDCPnotpresentExtIEs >-----#
    E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPnotpresentExtIEs = CLASS(name='E-RABs-AdmittedToBeModified-SgNBModConf-Item-SgNBPDCPnotpresentExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPnotpresentExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PDCPSnLength')))
    _E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPnotpresentExtIEs_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PDCPSnLength')))
    E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPnotpresentExtIEs._val = ASN1Set(rv=[dict([('id', 302), ('criticality', 'ignore'), ('Extension', _E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPnotpresentExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 311), ('criticality', 'ignore'), ('Extension', _E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPnotpresentExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< SgNBModificationRefuse >-----#
    SgNBModificationRefuse = SEQ(name='SgNBModificationRefuse', mode=MODE_TYPE)
    _SgNBModificationRefuse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __SgNBModificationRefuse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___SgNBModificationRefuse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____SgNBModificationRefuse_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____SgNBModificationRefuse_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SgNBModificationRefuse_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNB-UE-X2AP-ID')))
    _____SgNBModificationRefuse_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _____SgNBModificationRefuse_protocolIEs__item__id_tab_val_Value_3 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MeNBtoSgNBContainer')))
    _____SgNBModificationRefuse_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _____SgNBModificationRefuse_protocolIEs__item__id_tab_val_Value_5 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    ____SgNBModificationRefuse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'ignore'), ('Value', _____SgNBModificationRefuse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 207), ('criticality', 'ignore'), ('Value', _____SgNBModificationRefuse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _____SgNBModificationRefuse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 206), ('criticality', 'ignore'), ('Value', _____SgNBModificationRefuse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _____SgNBModificationRefuse_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 157), ('criticality', 'ignore'), ('Value', _____SgNBModificationRefuse_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SgNBModificationRefuse_protocolIEs__item__id._const_tab = ____SgNBModificationRefuse_protocolIEs__item__id_tab
    ___SgNBModificationRefuse_protocolIEs__item__id._const_tab_at = None
    ___SgNBModificationRefuse_protocolIEs__item__id._const_tab_id = 'id'
    ___SgNBModificationRefuse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___SgNBModificationRefuse_protocolIEs__item__criticality._const_tab = ____SgNBModificationRefuse_protocolIEs__item__id_tab
    ___SgNBModificationRefuse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___SgNBModificationRefuse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___SgNBModificationRefuse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___SgNBModificationRefuse_protocolIEs__item__value._const_tab = ____SgNBModificationRefuse_protocolIEs__item__id_tab
    ___SgNBModificationRefuse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___SgNBModificationRefuse_protocolIEs__item__value._const_tab_id = 'Value'
    __SgNBModificationRefuse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___SgNBModificationRefuse_protocolIEs__item__id),
        ('criticality', ___SgNBModificationRefuse_protocolIEs__item__criticality),
        ('value', ___SgNBModificationRefuse_protocolIEs__item__value),
        ])
    __SgNBModificationRefuse_protocolIEs__item_._ext = None
    _SgNBModificationRefuse_protocolIEs._cont = __SgNBModificationRefuse_protocolIEs__item_
    _SgNBModificationRefuse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    SgNBModificationRefuse._cont = ASN1Dict([
        ('protocolIEs', _SgNBModificationRefuse_protocolIEs),
        ])
    SgNBModificationRefuse._ext = []
    
    #-----< SgNBModificationRefuse-IEs >-----#
    SgNBModificationRefuse_IEs = CLASS(name='SgNBModificationRefuse-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _SgNBModificationRefuse_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SgNBModificationRefuse_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNB-UE-X2AP-ID')))
    _SgNBModificationRefuse_IEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _SgNBModificationRefuse_IEs_val_Value_3 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MeNBtoSgNBContainer')))
    _SgNBModificationRefuse_IEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _SgNBModificationRefuse_IEs_val_Value_5 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    SgNBModificationRefuse_IEs._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'ignore'), ('Value', _SgNBModificationRefuse_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 207), ('criticality', 'ignore'), ('Value', _SgNBModificationRefuse_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _SgNBModificationRefuse_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 206), ('criticality', 'ignore'), ('Value', _SgNBModificationRefuse_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _SgNBModificationRefuse_IEs_val_Value_4), ('presence', 'optional')]), dict([('id', 157), ('criticality', 'ignore'), ('Value', _SgNBModificationRefuse_IEs_val_Value_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< SgNBReleaseRequest >-----#
    SgNBReleaseRequest = SEQ(name='SgNBReleaseRequest', mode=MODE_TYPE)
    _SgNBReleaseRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __SgNBReleaseRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___SgNBReleaseRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____SgNBReleaseRequest_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____SgNBReleaseRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SgNBReleaseRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNB-UE-X2AP-ID')))
    _____SgNBReleaseRequest_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _____SgNBReleaseRequest_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-SgNBRelReqList')))
    _____SgNBReleaseRequest_protocolIEs__item__id_tab_val_Value_4 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-ContextKeptIndicator')))
    _____SgNBReleaseRequest_protocolIEs__item__id_tab_val_Value_5 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____SgNBReleaseRequest_protocolIEs__item__id_tab_val_Value_6 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MeNBtoSgNBContainer')))
    _____SgNBReleaseRequest_protocolIEs__item__id_tab_val_Value_7 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-List')))
    ____SgNBReleaseRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'reject'), ('Value', _____SgNBReleaseRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 207), ('criticality', 'reject'), ('Value', _____SgNBReleaseRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _____SgNBReleaseRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 231), ('criticality', 'ignore'), ('Value', _____SgNBReleaseRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 154), ('criticality', 'ignore'), ('Value', _____SgNBReleaseRequest_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 157), ('criticality', 'reject'), ('Value', _____SgNBReleaseRequest_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 206), ('criticality', 'reject'), ('Value', _____SgNBReleaseRequest_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 339), ('criticality', 'ignore'), ('Value', _____SgNBReleaseRequest_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SgNBReleaseRequest_protocolIEs__item__id._const_tab = ____SgNBReleaseRequest_protocolIEs__item__id_tab
    ___SgNBReleaseRequest_protocolIEs__item__id._const_tab_at = None
    ___SgNBReleaseRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___SgNBReleaseRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___SgNBReleaseRequest_protocolIEs__item__criticality._const_tab = ____SgNBReleaseRequest_protocolIEs__item__id_tab
    ___SgNBReleaseRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___SgNBReleaseRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___SgNBReleaseRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___SgNBReleaseRequest_protocolIEs__item__value._const_tab = ____SgNBReleaseRequest_protocolIEs__item__id_tab
    ___SgNBReleaseRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___SgNBReleaseRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __SgNBReleaseRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___SgNBReleaseRequest_protocolIEs__item__id),
        ('criticality', ___SgNBReleaseRequest_protocolIEs__item__criticality),
        ('value', ___SgNBReleaseRequest_protocolIEs__item__value),
        ])
    __SgNBReleaseRequest_protocolIEs__item_._ext = None
    _SgNBReleaseRequest_protocolIEs._cont = __SgNBReleaseRequest_protocolIEs__item_
    _SgNBReleaseRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    SgNBReleaseRequest._cont = ASN1Dict([
        ('protocolIEs', _SgNBReleaseRequest_protocolIEs),
        ])
    SgNBReleaseRequest._ext = []
    
    #-----< SgNBReleaseRequest-IEs >-----#
    SgNBReleaseRequest_IEs = CLASS(name='SgNBReleaseRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _SgNBReleaseRequest_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SgNBReleaseRequest_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNB-UE-X2AP-ID')))
    _SgNBReleaseRequest_IEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _SgNBReleaseRequest_IEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-SgNBRelReqList')))
    _SgNBReleaseRequest_IEs_val_Value_4 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-ContextKeptIndicator')))
    _SgNBReleaseRequest_IEs_val_Value_5 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _SgNBReleaseRequest_IEs_val_Value_6 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MeNBtoSgNBContainer')))
    _SgNBReleaseRequest_IEs_val_Value_7 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-List')))
    SgNBReleaseRequest_IEs._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'reject'), ('Value', _SgNBReleaseRequest_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 207), ('criticality', 'reject'), ('Value', _SgNBReleaseRequest_IEs_val_Value_1), ('presence', 'optional')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _SgNBReleaseRequest_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 231), ('criticality', 'ignore'), ('Value', _SgNBReleaseRequest_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 154), ('criticality', 'ignore'), ('Value', _SgNBReleaseRequest_IEs_val_Value_4), ('presence', 'optional')]), dict([('id', 157), ('criticality', 'reject'), ('Value', _SgNBReleaseRequest_IEs_val_Value_5), ('presence', 'optional')]), dict([('id', 206), ('criticality', 'reject'), ('Value', _SgNBReleaseRequest_IEs_val_Value_6), ('presence', 'optional')]), dict([('id', 339), ('criticality', 'ignore'), ('Value', _SgNBReleaseRequest_IEs_val_Value_7), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeReleased-SgNBRelReqList >-----#
    E_RABs_ToBeReleased_SgNBRelReqList = SEQ_OF(name='E-RABs-ToBeReleased-SgNBRelReqList', mode=MODE_TYPE)
    _E_RABs_ToBeReleased_SgNBRelReqList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __E_RABs_ToBeReleased_SgNBRelReqList__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ___E_RABs_ToBeReleased_SgNBRelReqList__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____E_RABs_ToBeReleased_SgNBRelReqList__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-SgNBRelReq-Item')))
    ___E_RABs_ToBeReleased_SgNBRelReqList__item__id_tab._val = ASN1Set(rv=[dict([('id', 232), ('criticality', 'ignore'), ('Value', ____E_RABs_ToBeReleased_SgNBRelReqList__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E_RABs_ToBeReleased_SgNBRelReqList__item__id._const_tab = ___E_RABs_ToBeReleased_SgNBRelReqList__item__id_tab
    __E_RABs_ToBeReleased_SgNBRelReqList__item__id._const_tab_at = None
    __E_RABs_ToBeReleased_SgNBRelReqList__item__id._const_tab_id = 'id'
    __E_RABs_ToBeReleased_SgNBRelReqList__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    __E_RABs_ToBeReleased_SgNBRelReqList__item__criticality._const_tab = ___E_RABs_ToBeReleased_SgNBRelReqList__item__id_tab
    __E_RABs_ToBeReleased_SgNBRelReqList__item__criticality._const_tab_at = ('..', 'id')
    __E_RABs_ToBeReleased_SgNBRelReqList__item__criticality._const_tab_id = 'criticality'
    __E_RABs_ToBeReleased_SgNBRelReqList__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    __E_RABs_ToBeReleased_SgNBRelReqList__item__value._const_tab = ___E_RABs_ToBeReleased_SgNBRelReqList__item__id_tab
    __E_RABs_ToBeReleased_SgNBRelReqList__item__value._const_tab_at = ('..', 'id')
    __E_RABs_ToBeReleased_SgNBRelReqList__item__value._const_tab_id = 'Value'
    _E_RABs_ToBeReleased_SgNBRelReqList__item_._cont = ASN1Dict([
        ('id', __E_RABs_ToBeReleased_SgNBRelReqList__item__id),
        ('criticality', __E_RABs_ToBeReleased_SgNBRelReqList__item__criticality),
        ('value', __E_RABs_ToBeReleased_SgNBRelReqList__item__value),
        ])
    _E_RABs_ToBeReleased_SgNBRelReqList__item_._ext = None
    E_RABs_ToBeReleased_SgNBRelReqList._cont = _E_RABs_ToBeReleased_SgNBRelReqList__item_
    E_RABs_ToBeReleased_SgNBRelReqList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABs-ToBeReleased-SgNBRelReq-ItemIEs >-----#
    E_RABs_ToBeReleased_SgNBRelReq_ItemIEs = CLASS(name='E-RABs-ToBeReleased-SgNBRelReq-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _E_RABs_ToBeReleased_SgNBRelReq_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-SgNBRelReq-Item')))
    E_RABs_ToBeReleased_SgNBRelReq_ItemIEs._val = ASN1Set(rv=[dict([('id', 232), ('criticality', 'ignore'), ('Value', _E_RABs_ToBeReleased_SgNBRelReq_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeReleased-SgNBRelReq-Item >-----#
    E_RABs_ToBeReleased_SgNBRelReq_Item = SEQ(name='E-RABs-ToBeReleased-SgNBRelReq-Item', mode=MODE_TYPE)
    _E_RABs_ToBeReleased_SgNBRelReq_Item_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_ToBeReleased_SgNBRelReq_Item_en_DC_ResourceConfiguration = SEQ(name='en-DC-ResourceConfiguration', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'EN-DC-ResourceConfiguration')))
    _E_RABs_ToBeReleased_SgNBRelReq_Item_resource_configuration = CHOICE(name='resource-configuration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __E_RABs_ToBeReleased_SgNBRelReq_Item_resource_configuration_sgNBPDCPpresent = SEQ(name='sgNBPDCPpresent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-SgNBRelReq-Item-SgNBPDCPpresent')))
    __E_RABs_ToBeReleased_SgNBRelReq_Item_resource_configuration_sgNBPDCPnotpresent = SEQ(name='sgNBPDCPnotpresent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-SgNBRelReq-Item-SgNBPDCPnotpresent')))
    _E_RABs_ToBeReleased_SgNBRelReq_Item_resource_configuration._cont = ASN1Dict([
        ('sgNBPDCPpresent', __E_RABs_ToBeReleased_SgNBRelReq_Item_resource_configuration_sgNBPDCPpresent),
        ('sgNBPDCPnotpresent', __E_RABs_ToBeReleased_SgNBRelReq_Item_resource_configuration_sgNBPDCPnotpresent),
        ])
    _E_RABs_ToBeReleased_SgNBRelReq_Item_resource_configuration._ext = []
    _E_RABs_ToBeReleased_SgNBRelReq_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_ToBeReleased_SgNBRelReq_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_ToBeReleased_SgNBRelReq_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_ToBeReleased_SgNBRelReq_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_SgNBRelReq_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_SgNBRelReq_Item_iE_Extensions__item__id._const_tab = ____E_RABs_ToBeReleased_SgNBRelReq_Item_iE_Extensions__item__id_tab
    ___E_RABs_ToBeReleased_SgNBRelReq_Item_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_ToBeReleased_SgNBRelReq_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_ToBeReleased_SgNBRelReq_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_RABs_ToBeReleased_SgNBRelReq_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_SgNBRelReq_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_SgNBRelReq_Item_iE_Extensions__item__criticality._const_tab = ____E_RABs_ToBeReleased_SgNBRelReq_Item_iE_Extensions__item__criticality_tab
    ___E_RABs_ToBeReleased_SgNBRelReq_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeReleased_SgNBRelReq_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_ToBeReleased_SgNBRelReq_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_RABs_ToBeReleased_SgNBRelReq_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_SgNBRelReq_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_SgNBRelReq_Item_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_ToBeReleased_SgNBRelReq_Item_iE_Extensions__item__extensionValue_tab
    ___E_RABs_ToBeReleased_SgNBRelReq_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeReleased_SgNBRelReq_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_ToBeReleased_SgNBRelReq_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_ToBeReleased_SgNBRelReq_Item_iE_Extensions__item__id),
        ('criticality', ___E_RABs_ToBeReleased_SgNBRelReq_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_ToBeReleased_SgNBRelReq_Item_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_ToBeReleased_SgNBRelReq_Item_iE_Extensions__item_._ext = None
    _E_RABs_ToBeReleased_SgNBRelReq_Item_iE_Extensions._cont = __E_RABs_ToBeReleased_SgNBRelReq_Item_iE_Extensions__item_
    _E_RABs_ToBeReleased_SgNBRelReq_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_ToBeReleased_SgNBRelReq_Item._cont = ASN1Dict([
        ('e-RAB-ID', _E_RABs_ToBeReleased_SgNBRelReq_Item_e_RAB_ID),
        ('en-DC-ResourceConfiguration', _E_RABs_ToBeReleased_SgNBRelReq_Item_en_DC_ResourceConfiguration),
        ('resource-configuration', _E_RABs_ToBeReleased_SgNBRelReq_Item_resource_configuration),
        ('iE-Extensions', _E_RABs_ToBeReleased_SgNBRelReq_Item_iE_Extensions),
        ])
    E_RABs_ToBeReleased_SgNBRelReq_Item._ext = []
    
    #-----< E-RABs-ToBeReleased-SgNBRelReq-ItemExtIEs >-----#
    E_RABs_ToBeReleased_SgNBRelReq_ItemExtIEs = CLASS(name='E-RABs-ToBeReleased-SgNBRelReq-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    E_RABs_ToBeReleased_SgNBRelReq_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeReleased-SgNBRelReq-Item-SgNBPDCPpresent >-----#
    E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPpresent = SEQ(name='E-RABs-ToBeReleased-SgNBRelReq-Item-SgNBPDCPpresent', mode=MODE_TYPE)
    _E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPpresent_uL_GTPtunnelEndpoint = SEQ(name='uL-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPpresent_dL_GTPtunnelEndpoint = SEQ(name='dL-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPpresent_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPpresent_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPpresent_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPpresent_iE_Extensions__item__id._const_tab = ____E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab
    ___E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPpresent_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPpresent_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPpresent_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPpresent_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPpresent_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPpresent_iE_Extensions__item__criticality._const_tab = ____E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPpresent_iE_Extensions__item__criticality_tab
    ___E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPpresent_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPpresent_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue_tab
    ___E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPpresent_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPpresent_iE_Extensions__item__id),
        ('criticality', ___E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPpresent_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPpresent_iE_Extensions__item_._ext = None
    _E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPpresent_iE_Extensions._cont = __E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPpresent_iE_Extensions__item_
    _E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPpresent_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPpresent._cont = ASN1Dict([
        ('uL-GTPtunnelEndpoint', _E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPpresent_uL_GTPtunnelEndpoint),
        ('dL-GTPtunnelEndpoint', _E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPpresent_dL_GTPtunnelEndpoint),
        ('iE-Extensions', _E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPpresent_iE_Extensions),
        ])
    E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPpresent._ext = []
    
    #-----< E-RABs-ToBeReleased-SgNBRelReq-Item-SgNBPDCPpresentExtIEs >-----#
    E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPpresentExtIEs = CLASS(name='E-RABs-ToBeReleased-SgNBRelReq-Item-SgNBPDCPpresentExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPpresentExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeReleased-SgNBRelReq-Item-SgNBPDCPnotpresent >-----#
    E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPnotpresent = SEQ(name='E-RABs-ToBeReleased-SgNBRelReq-Item-SgNBPDCPnotpresent', mode=MODE_TYPE)
    _E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPnotpresent_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPnotpresent_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id._const_tab = ____E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab
    ___E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality._const_tab = ____E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality_tab
    ___E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue_tab
    ___E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPnotpresent_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id),
        ('criticality', ___E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPnotpresent_iE_Extensions__item_._ext = None
    _E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPnotpresent_iE_Extensions._cont = __E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPnotpresent_iE_Extensions__item_
    _E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPnotpresent_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPnotpresent._cont = ASN1Dict([
        ('iE-Extensions', _E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPnotpresent_iE_Extensions),
        ])
    E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPnotpresent._ext = []
    
    #-----< E-RABs-ToBeReleased-SgNBRelReq-Item-SgNBPDCPnotpresentExtIEs >-----#
    E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPnotpresentExtIEs = CLASS(name='E-RABs-ToBeReleased-SgNBRelReq-Item-SgNBPDCPnotpresentExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPnotpresentExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SgNBReleaseRequestAcknowledge >-----#
    SgNBReleaseRequestAcknowledge = SEQ(name='SgNBReleaseRequestAcknowledge', mode=MODE_TYPE)
    _SgNBReleaseRequestAcknowledge_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __SgNBReleaseRequestAcknowledge_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___SgNBReleaseRequestAcknowledge_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____SgNBReleaseRequestAcknowledge_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____SgNBReleaseRequestAcknowledge_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SgNBReleaseRequestAcknowledge_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNB-UE-X2AP-ID')))
    _____SgNBReleaseRequestAcknowledge_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _____SgNBReleaseRequestAcknowledge_protocolIEs__item__id_tab_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____SgNBReleaseRequestAcknowledge_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeReleased-SgNBRelReqAckList')))
    _____SgNBReleaseRequestAcknowledge_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SCG-UE-HistoryInformation')))
    ____SgNBReleaseRequestAcknowledge_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'ignore'), ('Value', _____SgNBReleaseRequestAcknowledge_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 207), ('criticality', 'ignore'), ('Value', _____SgNBReleaseRequestAcknowledge_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _____SgNBReleaseRequestAcknowledge_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 157), ('criticality', 'reject'), ('Value', _____SgNBReleaseRequestAcknowledge_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 318), ('criticality', 'ignore'), ('Value', _____SgNBReleaseRequestAcknowledge_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 415), ('criticality', 'ignore'), ('Value', _____SgNBReleaseRequestAcknowledge_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SgNBReleaseRequestAcknowledge_protocolIEs__item__id._const_tab = ____SgNBReleaseRequestAcknowledge_protocolIEs__item__id_tab
    ___SgNBReleaseRequestAcknowledge_protocolIEs__item__id._const_tab_at = None
    ___SgNBReleaseRequestAcknowledge_protocolIEs__item__id._const_tab_id = 'id'
    ___SgNBReleaseRequestAcknowledge_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___SgNBReleaseRequestAcknowledge_protocolIEs__item__criticality._const_tab = ____SgNBReleaseRequestAcknowledge_protocolIEs__item__id_tab
    ___SgNBReleaseRequestAcknowledge_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___SgNBReleaseRequestAcknowledge_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___SgNBReleaseRequestAcknowledge_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___SgNBReleaseRequestAcknowledge_protocolIEs__item__value._const_tab = ____SgNBReleaseRequestAcknowledge_protocolIEs__item__id_tab
    ___SgNBReleaseRequestAcknowledge_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___SgNBReleaseRequestAcknowledge_protocolIEs__item__value._const_tab_id = 'Value'
    __SgNBReleaseRequestAcknowledge_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___SgNBReleaseRequestAcknowledge_protocolIEs__item__id),
        ('criticality', ___SgNBReleaseRequestAcknowledge_protocolIEs__item__criticality),
        ('value', ___SgNBReleaseRequestAcknowledge_protocolIEs__item__value),
        ])
    __SgNBReleaseRequestAcknowledge_protocolIEs__item_._ext = None
    _SgNBReleaseRequestAcknowledge_protocolIEs._cont = __SgNBReleaseRequestAcknowledge_protocolIEs__item_
    _SgNBReleaseRequestAcknowledge_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    SgNBReleaseRequestAcknowledge._cont = ASN1Dict([
        ('protocolIEs', _SgNBReleaseRequestAcknowledge_protocolIEs),
        ])
    SgNBReleaseRequestAcknowledge._ext = []
    
    #-----< SgNBReleaseRequestAcknowledge-IEs >-----#
    SgNBReleaseRequestAcknowledge_IEs = CLASS(name='SgNBReleaseRequestAcknowledge-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _SgNBReleaseRequestAcknowledge_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SgNBReleaseRequestAcknowledge_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNB-UE-X2AP-ID')))
    _SgNBReleaseRequestAcknowledge_IEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _SgNBReleaseRequestAcknowledge_IEs_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _SgNBReleaseRequestAcknowledge_IEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeReleased-SgNBRelReqAckList')))
    _SgNBReleaseRequestAcknowledge_IEs_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SCG-UE-HistoryInformation')))
    SgNBReleaseRequestAcknowledge_IEs._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'ignore'), ('Value', _SgNBReleaseRequestAcknowledge_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 207), ('criticality', 'ignore'), ('Value', _SgNBReleaseRequestAcknowledge_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _SgNBReleaseRequestAcknowledge_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 157), ('criticality', 'reject'), ('Value', _SgNBReleaseRequestAcknowledge_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 318), ('criticality', 'ignore'), ('Value', _SgNBReleaseRequestAcknowledge_IEs_val_Value_4), ('presence', 'optional')]), dict([('id', 415), ('criticality', 'ignore'), ('Value', _SgNBReleaseRequestAcknowledge_IEs_val_Value_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-Admitted-ToBeReleased-SgNBRelReqAckList >-----#
    E_RABs_Admitted_ToBeReleased_SgNBRelReqAckList = SEQ_OF(name='E-RABs-Admitted-ToBeReleased-SgNBRelReqAckList', mode=MODE_TYPE)
    _E_RABs_Admitted_ToBeReleased_SgNBRelReqAckList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __E_RABs_Admitted_ToBeReleased_SgNBRelReqAckList__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ___E_RABs_Admitted_ToBeReleased_SgNBRelReqAckList__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____E_RABs_Admitted_ToBeReleased_SgNBRelReqAckList__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeReleased-SgNBRelReqAck-Item')))
    ___E_RABs_Admitted_ToBeReleased_SgNBRelReqAckList__item__id_tab._val = ASN1Set(rv=[dict([('id', 319), ('criticality', 'ignore'), ('Value', ____E_RABs_Admitted_ToBeReleased_SgNBRelReqAckList__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E_RABs_Admitted_ToBeReleased_SgNBRelReqAckList__item__id._const_tab = ___E_RABs_Admitted_ToBeReleased_SgNBRelReqAckList__item__id_tab
    __E_RABs_Admitted_ToBeReleased_SgNBRelReqAckList__item__id._const_tab_at = None
    __E_RABs_Admitted_ToBeReleased_SgNBRelReqAckList__item__id._const_tab_id = 'id'
    __E_RABs_Admitted_ToBeReleased_SgNBRelReqAckList__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    __E_RABs_Admitted_ToBeReleased_SgNBRelReqAckList__item__criticality._const_tab = ___E_RABs_Admitted_ToBeReleased_SgNBRelReqAckList__item__id_tab
    __E_RABs_Admitted_ToBeReleased_SgNBRelReqAckList__item__criticality._const_tab_at = ('..', 'id')
    __E_RABs_Admitted_ToBeReleased_SgNBRelReqAckList__item__criticality._const_tab_id = 'criticality'
    __E_RABs_Admitted_ToBeReleased_SgNBRelReqAckList__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    __E_RABs_Admitted_ToBeReleased_SgNBRelReqAckList__item__value._const_tab = ___E_RABs_Admitted_ToBeReleased_SgNBRelReqAckList__item__id_tab
    __E_RABs_Admitted_ToBeReleased_SgNBRelReqAckList__item__value._const_tab_at = ('..', 'id')
    __E_RABs_Admitted_ToBeReleased_SgNBRelReqAckList__item__value._const_tab_id = 'Value'
    _E_RABs_Admitted_ToBeReleased_SgNBRelReqAckList__item_._cont = ASN1Dict([
        ('id', __E_RABs_Admitted_ToBeReleased_SgNBRelReqAckList__item__id),
        ('criticality', __E_RABs_Admitted_ToBeReleased_SgNBRelReqAckList__item__criticality),
        ('value', __E_RABs_Admitted_ToBeReleased_SgNBRelReqAckList__item__value),
        ])
    _E_RABs_Admitted_ToBeReleased_SgNBRelReqAckList__item_._ext = None
    E_RABs_Admitted_ToBeReleased_SgNBRelReqAckList._cont = _E_RABs_Admitted_ToBeReleased_SgNBRelReqAckList__item_
    E_RABs_Admitted_ToBeReleased_SgNBRelReqAckList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABs-Admitted-ToBeReleased-SgNBRelReqAck-ItemIEs >-----#
    E_RABs_Admitted_ToBeReleased_SgNBRelReqAck_ItemIEs = CLASS(name='E-RABs-Admitted-ToBeReleased-SgNBRelReqAck-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _E_RABs_Admitted_ToBeReleased_SgNBRelReqAck_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-Admitted-ToBeReleased-SgNBRelReqAck-Item')))
    E_RABs_Admitted_ToBeReleased_SgNBRelReqAck_ItemIEs._val = ASN1Set(rv=[dict([('id', 319), ('criticality', 'ignore'), ('Value', _E_RABs_Admitted_ToBeReleased_SgNBRelReqAck_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-Admitted-ToBeReleased-SgNBRelReqAck-Item >-----#
    E_RABs_Admitted_ToBeReleased_SgNBRelReqAck_Item = SEQ(name='E-RABs-Admitted-ToBeReleased-SgNBRelReqAck-Item', mode=MODE_TYPE)
    _E_RABs_Admitted_ToBeReleased_SgNBRelReqAck_Item_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_Admitted_ToBeReleased_SgNBRelReqAck_Item_rlc_Mode_transferred = ENUM(name='rlc-Mode-transferred', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'RLCMode')))
    _E_RABs_Admitted_ToBeReleased_SgNBRelReqAck_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_Admitted_ToBeReleased_SgNBRelReqAck_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_Admitted_ToBeReleased_SgNBRelReqAck_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_Admitted_ToBeReleased_SgNBRelReqAck_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_Admitted_ToBeReleased_SgNBRelReqAck_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_Admitted_ToBeReleased_SgNBRelReqAck_Item_iE_Extensions__item__id._const_tab = ____E_RABs_Admitted_ToBeReleased_SgNBRelReqAck_Item_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeReleased_SgNBRelReqAck_Item_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_Admitted_ToBeReleased_SgNBRelReqAck_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_Admitted_ToBeReleased_SgNBRelReqAck_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_RABs_Admitted_ToBeReleased_SgNBRelReqAck_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_Admitted_ToBeReleased_SgNBRelReqAck_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_Admitted_ToBeReleased_SgNBRelReqAck_Item_iE_Extensions__item__criticality._const_tab = ____E_RABs_Admitted_ToBeReleased_SgNBRelReqAck_Item_iE_Extensions__item__criticality_tab
    ___E_RABs_Admitted_ToBeReleased_SgNBRelReqAck_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_Admitted_ToBeReleased_SgNBRelReqAck_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_Admitted_ToBeReleased_SgNBRelReqAck_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_RABs_Admitted_ToBeReleased_SgNBRelReqAck_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_Admitted_ToBeReleased_SgNBRelReqAck_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_Admitted_ToBeReleased_SgNBRelReqAck_Item_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_Admitted_ToBeReleased_SgNBRelReqAck_Item_iE_Extensions__item__extensionValue_tab
    ___E_RABs_Admitted_ToBeReleased_SgNBRelReqAck_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_Admitted_ToBeReleased_SgNBRelReqAck_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_Admitted_ToBeReleased_SgNBRelReqAck_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_Admitted_ToBeReleased_SgNBRelReqAck_Item_iE_Extensions__item__id),
        ('criticality', ___E_RABs_Admitted_ToBeReleased_SgNBRelReqAck_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_Admitted_ToBeReleased_SgNBRelReqAck_Item_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_Admitted_ToBeReleased_SgNBRelReqAck_Item_iE_Extensions__item_._ext = None
    _E_RABs_Admitted_ToBeReleased_SgNBRelReqAck_Item_iE_Extensions._cont = __E_RABs_Admitted_ToBeReleased_SgNBRelReqAck_Item_iE_Extensions__item_
    _E_RABs_Admitted_ToBeReleased_SgNBRelReqAck_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_Admitted_ToBeReleased_SgNBRelReqAck_Item._cont = ASN1Dict([
        ('e-RAB-ID', _E_RABs_Admitted_ToBeReleased_SgNBRelReqAck_Item_e_RAB_ID),
        ('rlc-Mode-transferred', _E_RABs_Admitted_ToBeReleased_SgNBRelReqAck_Item_rlc_Mode_transferred),
        ('iE-Extensions', _E_RABs_Admitted_ToBeReleased_SgNBRelReqAck_Item_iE_Extensions),
        ])
    E_RABs_Admitted_ToBeReleased_SgNBRelReqAck_Item._ext = []
    
    #-----< E-RABs-Admitted-ToBeReleased-SgNBRelReqAck-ItemExtIEs >-----#
    E_RABs_Admitted_ToBeReleased_SgNBRelReqAck_ItemExtIEs = CLASS(name='E-RABs-Admitted-ToBeReleased-SgNBRelReqAck-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    E_RABs_Admitted_ToBeReleased_SgNBRelReqAck_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SgNBReleaseRequestReject >-----#
    SgNBReleaseRequestReject = SEQ(name='SgNBReleaseRequestReject', mode=MODE_TYPE)
    _SgNBReleaseRequestReject_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __SgNBReleaseRequestReject_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___SgNBReleaseRequestReject_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____SgNBReleaseRequestReject_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____SgNBReleaseRequestReject_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SgNBReleaseRequestReject_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNB-UE-X2AP-ID')))
    _____SgNBReleaseRequestReject_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _____SgNBReleaseRequestReject_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _____SgNBReleaseRequestReject_protocolIEs__item__id_tab_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    ____SgNBReleaseRequestReject_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'ignore'), ('Value', _____SgNBReleaseRequestReject_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 207), ('criticality', 'ignore'), ('Value', _____SgNBReleaseRequestReject_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _____SgNBReleaseRequestReject_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _____SgNBReleaseRequestReject_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 157), ('criticality', 'reject'), ('Value', _____SgNBReleaseRequestReject_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SgNBReleaseRequestReject_protocolIEs__item__id._const_tab = ____SgNBReleaseRequestReject_protocolIEs__item__id_tab
    ___SgNBReleaseRequestReject_protocolIEs__item__id._const_tab_at = None
    ___SgNBReleaseRequestReject_protocolIEs__item__id._const_tab_id = 'id'
    ___SgNBReleaseRequestReject_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___SgNBReleaseRequestReject_protocolIEs__item__criticality._const_tab = ____SgNBReleaseRequestReject_protocolIEs__item__id_tab
    ___SgNBReleaseRequestReject_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___SgNBReleaseRequestReject_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___SgNBReleaseRequestReject_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___SgNBReleaseRequestReject_protocolIEs__item__value._const_tab = ____SgNBReleaseRequestReject_protocolIEs__item__id_tab
    ___SgNBReleaseRequestReject_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___SgNBReleaseRequestReject_protocolIEs__item__value._const_tab_id = 'Value'
    __SgNBReleaseRequestReject_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___SgNBReleaseRequestReject_protocolIEs__item__id),
        ('criticality', ___SgNBReleaseRequestReject_protocolIEs__item__criticality),
        ('value', ___SgNBReleaseRequestReject_protocolIEs__item__value),
        ])
    __SgNBReleaseRequestReject_protocolIEs__item_._ext = None
    _SgNBReleaseRequestReject_protocolIEs._cont = __SgNBReleaseRequestReject_protocolIEs__item_
    _SgNBReleaseRequestReject_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    SgNBReleaseRequestReject._cont = ASN1Dict([
        ('protocolIEs', _SgNBReleaseRequestReject_protocolIEs),
        ])
    SgNBReleaseRequestReject._ext = []
    
    #-----< SgNBReleaseRequestReject-IEs >-----#
    SgNBReleaseRequestReject_IEs = CLASS(name='SgNBReleaseRequestReject-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _SgNBReleaseRequestReject_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SgNBReleaseRequestReject_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNB-UE-X2AP-ID')))
    _SgNBReleaseRequestReject_IEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _SgNBReleaseRequestReject_IEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _SgNBReleaseRequestReject_IEs_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    SgNBReleaseRequestReject_IEs._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'ignore'), ('Value', _SgNBReleaseRequestReject_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 207), ('criticality', 'ignore'), ('Value', _SgNBReleaseRequestReject_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _SgNBReleaseRequestReject_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _SgNBReleaseRequestReject_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 157), ('criticality', 'reject'), ('Value', _SgNBReleaseRequestReject_IEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< SgNBReleaseRequired >-----#
    SgNBReleaseRequired = SEQ(name='SgNBReleaseRequired', mode=MODE_TYPE)
    _SgNBReleaseRequired_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __SgNBReleaseRequired_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___SgNBReleaseRequired_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____SgNBReleaseRequired_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____SgNBReleaseRequired_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SgNBReleaseRequired_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNB-UE-X2AP-ID')))
    _____SgNBReleaseRequired_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _____SgNBReleaseRequired_protocolIEs__item__id_tab_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____SgNBReleaseRequired_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-SgNBRelReqdList')))
    _____SgNBReleaseRequired_protocolIEs__item__id_tab_val_Value_5 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNBtoMeNBContainer')))
    _____SgNBReleaseRequired_protocolIEs__item__id_tab_val_Value_6 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SCG-UE-HistoryInformation')))
    ____SgNBReleaseRequired_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'reject'), ('Value', _____SgNBReleaseRequired_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 207), ('criticality', 'reject'), ('Value', _____SgNBReleaseRequired_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _____SgNBReleaseRequired_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 157), ('criticality', 'reject'), ('Value', _____SgNBReleaseRequired_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 320), ('criticality', 'ignore'), ('Value', _____SgNBReleaseRequired_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 211), ('criticality', 'ignore'), ('Value', _____SgNBReleaseRequired_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 415), ('criticality', 'ignore'), ('Value', _____SgNBReleaseRequired_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SgNBReleaseRequired_protocolIEs__item__id._const_tab = ____SgNBReleaseRequired_protocolIEs__item__id_tab
    ___SgNBReleaseRequired_protocolIEs__item__id._const_tab_at = None
    ___SgNBReleaseRequired_protocolIEs__item__id._const_tab_id = 'id'
    ___SgNBReleaseRequired_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___SgNBReleaseRequired_protocolIEs__item__criticality._const_tab = ____SgNBReleaseRequired_protocolIEs__item__id_tab
    ___SgNBReleaseRequired_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___SgNBReleaseRequired_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___SgNBReleaseRequired_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___SgNBReleaseRequired_protocolIEs__item__value._const_tab = ____SgNBReleaseRequired_protocolIEs__item__id_tab
    ___SgNBReleaseRequired_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___SgNBReleaseRequired_protocolIEs__item__value._const_tab_id = 'Value'
    __SgNBReleaseRequired_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___SgNBReleaseRequired_protocolIEs__item__id),
        ('criticality', ___SgNBReleaseRequired_protocolIEs__item__criticality),
        ('value', ___SgNBReleaseRequired_protocolIEs__item__value),
        ])
    __SgNBReleaseRequired_protocolIEs__item_._ext = None
    _SgNBReleaseRequired_protocolIEs._cont = __SgNBReleaseRequired_protocolIEs__item_
    _SgNBReleaseRequired_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    SgNBReleaseRequired._cont = ASN1Dict([
        ('protocolIEs', _SgNBReleaseRequired_protocolIEs),
        ])
    SgNBReleaseRequired._ext = []
    
    #-----< SgNBReleaseRequired-IEs >-----#
    SgNBReleaseRequired_IEs = CLASS(name='SgNBReleaseRequired-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _SgNBReleaseRequired_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SgNBReleaseRequired_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNB-UE-X2AP-ID')))
    _SgNBReleaseRequired_IEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _SgNBReleaseRequired_IEs_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _SgNBReleaseRequired_IEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-SgNBRelReqdList')))
    _SgNBReleaseRequired_IEs_val_Value_5 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNBtoMeNBContainer')))
    _SgNBReleaseRequired_IEs_val_Value_6 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SCG-UE-HistoryInformation')))
    SgNBReleaseRequired_IEs._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'reject'), ('Value', _SgNBReleaseRequired_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 207), ('criticality', 'reject'), ('Value', _SgNBReleaseRequired_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _SgNBReleaseRequired_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 157), ('criticality', 'reject'), ('Value', _SgNBReleaseRequired_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 320), ('criticality', 'ignore'), ('Value', _SgNBReleaseRequired_IEs_val_Value_4), ('presence', 'optional')]), dict([('id', 211), ('criticality', 'ignore'), ('Value', _SgNBReleaseRequired_IEs_val_Value_5), ('presence', 'optional')]), dict([('id', 415), ('criticality', 'ignore'), ('Value', _SgNBReleaseRequired_IEs_val_Value_6), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeReleased-SgNBRelReqdList >-----#
    E_RABs_ToBeReleased_SgNBRelReqdList = SEQ_OF(name='E-RABs-ToBeReleased-SgNBRelReqdList', mode=MODE_TYPE)
    _E_RABs_ToBeReleased_SgNBRelReqdList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __E_RABs_ToBeReleased_SgNBRelReqdList__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ___E_RABs_ToBeReleased_SgNBRelReqdList__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____E_RABs_ToBeReleased_SgNBRelReqdList__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-SgNBRelReqd-Item')))
    ___E_RABs_ToBeReleased_SgNBRelReqdList__item__id_tab._val = ASN1Set(rv=[dict([('id', 321), ('criticality', 'ignore'), ('Value', ____E_RABs_ToBeReleased_SgNBRelReqdList__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E_RABs_ToBeReleased_SgNBRelReqdList__item__id._const_tab = ___E_RABs_ToBeReleased_SgNBRelReqdList__item__id_tab
    __E_RABs_ToBeReleased_SgNBRelReqdList__item__id._const_tab_at = None
    __E_RABs_ToBeReleased_SgNBRelReqdList__item__id._const_tab_id = 'id'
    __E_RABs_ToBeReleased_SgNBRelReqdList__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    __E_RABs_ToBeReleased_SgNBRelReqdList__item__criticality._const_tab = ___E_RABs_ToBeReleased_SgNBRelReqdList__item__id_tab
    __E_RABs_ToBeReleased_SgNBRelReqdList__item__criticality._const_tab_at = ('..', 'id')
    __E_RABs_ToBeReleased_SgNBRelReqdList__item__criticality._const_tab_id = 'criticality'
    __E_RABs_ToBeReleased_SgNBRelReqdList__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    __E_RABs_ToBeReleased_SgNBRelReqdList__item__value._const_tab = ___E_RABs_ToBeReleased_SgNBRelReqdList__item__id_tab
    __E_RABs_ToBeReleased_SgNBRelReqdList__item__value._const_tab_at = ('..', 'id')
    __E_RABs_ToBeReleased_SgNBRelReqdList__item__value._const_tab_id = 'Value'
    _E_RABs_ToBeReleased_SgNBRelReqdList__item_._cont = ASN1Dict([
        ('id', __E_RABs_ToBeReleased_SgNBRelReqdList__item__id),
        ('criticality', __E_RABs_ToBeReleased_SgNBRelReqdList__item__criticality),
        ('value', __E_RABs_ToBeReleased_SgNBRelReqdList__item__value),
        ])
    _E_RABs_ToBeReleased_SgNBRelReqdList__item_._ext = None
    E_RABs_ToBeReleased_SgNBRelReqdList._cont = _E_RABs_ToBeReleased_SgNBRelReqdList__item_
    E_RABs_ToBeReleased_SgNBRelReqdList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABs-ToBeReleased-SgNBRelReqd-ItemIEs >-----#
    E_RABs_ToBeReleased_SgNBRelReqd_ItemIEs = CLASS(name='E-RABs-ToBeReleased-SgNBRelReqd-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _E_RABs_ToBeReleased_SgNBRelReqd_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-SgNBRelReqd-Item')))
    E_RABs_ToBeReleased_SgNBRelReqd_ItemIEs._val = ASN1Set(rv=[dict([('id', 321), ('criticality', 'ignore'), ('Value', _E_RABs_ToBeReleased_SgNBRelReqd_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeReleased-SgNBRelReqd-Item >-----#
    E_RABs_ToBeReleased_SgNBRelReqd_Item = SEQ(name='E-RABs-ToBeReleased-SgNBRelReqd-Item', mode=MODE_TYPE)
    _E_RABs_ToBeReleased_SgNBRelReqd_Item_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_ToBeReleased_SgNBRelReqd_Item_rlc_Mode_transferred = ENUM(name='rlc-Mode-transferred', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'RLCMode')))
    _E_RABs_ToBeReleased_SgNBRelReqd_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_ToBeReleased_SgNBRelReqd_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_ToBeReleased_SgNBRelReqd_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_ToBeReleased_SgNBRelReqd_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_SgNBRelReqd_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_SgNBRelReqd_Item_iE_Extensions__item__id._const_tab = ____E_RABs_ToBeReleased_SgNBRelReqd_Item_iE_Extensions__item__id_tab
    ___E_RABs_ToBeReleased_SgNBRelReqd_Item_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_ToBeReleased_SgNBRelReqd_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_ToBeReleased_SgNBRelReqd_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_RABs_ToBeReleased_SgNBRelReqd_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_SgNBRelReqd_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_SgNBRelReqd_Item_iE_Extensions__item__criticality._const_tab = ____E_RABs_ToBeReleased_SgNBRelReqd_Item_iE_Extensions__item__criticality_tab
    ___E_RABs_ToBeReleased_SgNBRelReqd_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeReleased_SgNBRelReqd_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_ToBeReleased_SgNBRelReqd_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_RABs_ToBeReleased_SgNBRelReqd_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_SgNBRelReqd_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_SgNBRelReqd_Item_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_ToBeReleased_SgNBRelReqd_Item_iE_Extensions__item__extensionValue_tab
    ___E_RABs_ToBeReleased_SgNBRelReqd_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeReleased_SgNBRelReqd_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_ToBeReleased_SgNBRelReqd_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_ToBeReleased_SgNBRelReqd_Item_iE_Extensions__item__id),
        ('criticality', ___E_RABs_ToBeReleased_SgNBRelReqd_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_ToBeReleased_SgNBRelReqd_Item_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_ToBeReleased_SgNBRelReqd_Item_iE_Extensions__item_._ext = None
    _E_RABs_ToBeReleased_SgNBRelReqd_Item_iE_Extensions._cont = __E_RABs_ToBeReleased_SgNBRelReqd_Item_iE_Extensions__item_
    _E_RABs_ToBeReleased_SgNBRelReqd_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_ToBeReleased_SgNBRelReqd_Item._cont = ASN1Dict([
        ('e-RAB-ID', _E_RABs_ToBeReleased_SgNBRelReqd_Item_e_RAB_ID),
        ('rlc-Mode-transferred', _E_RABs_ToBeReleased_SgNBRelReqd_Item_rlc_Mode_transferred),
        ('iE-Extensions', _E_RABs_ToBeReleased_SgNBRelReqd_Item_iE_Extensions),
        ])
    E_RABs_ToBeReleased_SgNBRelReqd_Item._ext = []
    
    #-----< E-RABs-ToBeReleased-SgNBRelReqd-ItemExtIEs >-----#
    E_RABs_ToBeReleased_SgNBRelReqd_ItemExtIEs = CLASS(name='E-RABs-ToBeReleased-SgNBRelReqd-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    E_RABs_ToBeReleased_SgNBRelReqd_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SgNBReleaseConfirm >-----#
    SgNBReleaseConfirm = SEQ(name='SgNBReleaseConfirm', mode=MODE_TYPE)
    _SgNBReleaseConfirm_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __SgNBReleaseConfirm_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___SgNBReleaseConfirm_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____SgNBReleaseConfirm_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____SgNBReleaseConfirm_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SgNBReleaseConfirm_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNB-UE-X2AP-ID')))
    _____SgNBReleaseConfirm_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-SgNBRelConfList')))
    _____SgNBReleaseConfirm_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _____SgNBReleaseConfirm_protocolIEs__item__id_tab_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    ____SgNBReleaseConfirm_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'ignore'), ('Value', _____SgNBReleaseConfirm_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 207), ('criticality', 'ignore'), ('Value', _____SgNBReleaseConfirm_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 233), ('criticality', 'ignore'), ('Value', _____SgNBReleaseConfirm_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _____SgNBReleaseConfirm_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 157), ('criticality', 'ignore'), ('Value', _____SgNBReleaseConfirm_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SgNBReleaseConfirm_protocolIEs__item__id._const_tab = ____SgNBReleaseConfirm_protocolIEs__item__id_tab
    ___SgNBReleaseConfirm_protocolIEs__item__id._const_tab_at = None
    ___SgNBReleaseConfirm_protocolIEs__item__id._const_tab_id = 'id'
    ___SgNBReleaseConfirm_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___SgNBReleaseConfirm_protocolIEs__item__criticality._const_tab = ____SgNBReleaseConfirm_protocolIEs__item__id_tab
    ___SgNBReleaseConfirm_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___SgNBReleaseConfirm_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___SgNBReleaseConfirm_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___SgNBReleaseConfirm_protocolIEs__item__value._const_tab = ____SgNBReleaseConfirm_protocolIEs__item__id_tab
    ___SgNBReleaseConfirm_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___SgNBReleaseConfirm_protocolIEs__item__value._const_tab_id = 'Value'
    __SgNBReleaseConfirm_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___SgNBReleaseConfirm_protocolIEs__item__id),
        ('criticality', ___SgNBReleaseConfirm_protocolIEs__item__criticality),
        ('value', ___SgNBReleaseConfirm_protocolIEs__item__value),
        ])
    __SgNBReleaseConfirm_protocolIEs__item_._ext = None
    _SgNBReleaseConfirm_protocolIEs._cont = __SgNBReleaseConfirm_protocolIEs__item_
    _SgNBReleaseConfirm_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    SgNBReleaseConfirm._cont = ASN1Dict([
        ('protocolIEs', _SgNBReleaseConfirm_protocolIEs),
        ])
    SgNBReleaseConfirm._ext = []
    
    #-----< SgNBReleaseConfirm-IEs >-----#
    SgNBReleaseConfirm_IEs = CLASS(name='SgNBReleaseConfirm-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _SgNBReleaseConfirm_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SgNBReleaseConfirm_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNB-UE-X2AP-ID')))
    _SgNBReleaseConfirm_IEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-SgNBRelConfList')))
    _SgNBReleaseConfirm_IEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _SgNBReleaseConfirm_IEs_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    SgNBReleaseConfirm_IEs._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'ignore'), ('Value', _SgNBReleaseConfirm_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 207), ('criticality', 'ignore'), ('Value', _SgNBReleaseConfirm_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 233), ('criticality', 'ignore'), ('Value', _SgNBReleaseConfirm_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _SgNBReleaseConfirm_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 157), ('criticality', 'ignore'), ('Value', _SgNBReleaseConfirm_IEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeReleased-SgNBRelConfList >-----#
    E_RABs_ToBeReleased_SgNBRelConfList = SEQ_OF(name='E-RABs-ToBeReleased-SgNBRelConfList', mode=MODE_TYPE)
    _E_RABs_ToBeReleased_SgNBRelConfList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __E_RABs_ToBeReleased_SgNBRelConfList__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ___E_RABs_ToBeReleased_SgNBRelConfList__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____E_RABs_ToBeReleased_SgNBRelConfList__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-SgNBRelConf-Item')))
    ___E_RABs_ToBeReleased_SgNBRelConfList__item__id_tab._val = ASN1Set(rv=[dict([('id', 234), ('criticality', 'ignore'), ('Value', ____E_RABs_ToBeReleased_SgNBRelConfList__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E_RABs_ToBeReleased_SgNBRelConfList__item__id._const_tab = ___E_RABs_ToBeReleased_SgNBRelConfList__item__id_tab
    __E_RABs_ToBeReleased_SgNBRelConfList__item__id._const_tab_at = None
    __E_RABs_ToBeReleased_SgNBRelConfList__item__id._const_tab_id = 'id'
    __E_RABs_ToBeReleased_SgNBRelConfList__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    __E_RABs_ToBeReleased_SgNBRelConfList__item__criticality._const_tab = ___E_RABs_ToBeReleased_SgNBRelConfList__item__id_tab
    __E_RABs_ToBeReleased_SgNBRelConfList__item__criticality._const_tab_at = ('..', 'id')
    __E_RABs_ToBeReleased_SgNBRelConfList__item__criticality._const_tab_id = 'criticality'
    __E_RABs_ToBeReleased_SgNBRelConfList__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    __E_RABs_ToBeReleased_SgNBRelConfList__item__value._const_tab = ___E_RABs_ToBeReleased_SgNBRelConfList__item__id_tab
    __E_RABs_ToBeReleased_SgNBRelConfList__item__value._const_tab_at = ('..', 'id')
    __E_RABs_ToBeReleased_SgNBRelConfList__item__value._const_tab_id = 'Value'
    _E_RABs_ToBeReleased_SgNBRelConfList__item_._cont = ASN1Dict([
        ('id', __E_RABs_ToBeReleased_SgNBRelConfList__item__id),
        ('criticality', __E_RABs_ToBeReleased_SgNBRelConfList__item__criticality),
        ('value', __E_RABs_ToBeReleased_SgNBRelConfList__item__value),
        ])
    _E_RABs_ToBeReleased_SgNBRelConfList__item_._ext = None
    E_RABs_ToBeReleased_SgNBRelConfList._cont = _E_RABs_ToBeReleased_SgNBRelConfList__item_
    E_RABs_ToBeReleased_SgNBRelConfList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABs-ToBeReleased-SgNBRelConf-ItemIEs >-----#
    E_RABs_ToBeReleased_SgNBRelConf_ItemIEs = CLASS(name='E-RABs-ToBeReleased-SgNBRelConf-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _E_RABs_ToBeReleased_SgNBRelConf_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-SgNBRelConf-Item')))
    E_RABs_ToBeReleased_SgNBRelConf_ItemIEs._val = ASN1Set(rv=[dict([('id', 234), ('criticality', 'ignore'), ('Value', _E_RABs_ToBeReleased_SgNBRelConf_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeReleased-SgNBRelConf-Item >-----#
    E_RABs_ToBeReleased_SgNBRelConf_Item = SEQ(name='E-RABs-ToBeReleased-SgNBRelConf-Item', mode=MODE_TYPE)
    _E_RABs_ToBeReleased_SgNBRelConf_Item_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_ToBeReleased_SgNBRelConf_Item_en_DC_ResourceConfiguration = SEQ(name='en-DC-ResourceConfiguration', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'EN-DC-ResourceConfiguration')))
    _E_RABs_ToBeReleased_SgNBRelConf_Item_resource_configuration = CHOICE(name='resource-configuration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __E_RABs_ToBeReleased_SgNBRelConf_Item_resource_configuration_sgNBPDCPpresent = SEQ(name='sgNBPDCPpresent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-SgNBRelConf-Item-SgNBPDCPpresent')))
    __E_RABs_ToBeReleased_SgNBRelConf_Item_resource_configuration_sgNBPDCPnotpresent = SEQ(name='sgNBPDCPnotpresent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-SgNBRelConf-Item-SgNBPDCPnotpresent')))
    _E_RABs_ToBeReleased_SgNBRelConf_Item_resource_configuration._cont = ASN1Dict([
        ('sgNBPDCPpresent', __E_RABs_ToBeReleased_SgNBRelConf_Item_resource_configuration_sgNBPDCPpresent),
        ('sgNBPDCPnotpresent', __E_RABs_ToBeReleased_SgNBRelConf_Item_resource_configuration_sgNBPDCPnotpresent),
        ])
    _E_RABs_ToBeReleased_SgNBRelConf_Item_resource_configuration._ext = []
    _E_RABs_ToBeReleased_SgNBRelConf_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_ToBeReleased_SgNBRelConf_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_ToBeReleased_SgNBRelConf_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_ToBeReleased_SgNBRelConf_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_SgNBRelConf_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_SgNBRelConf_Item_iE_Extensions__item__id._const_tab = ____E_RABs_ToBeReleased_SgNBRelConf_Item_iE_Extensions__item__id_tab
    ___E_RABs_ToBeReleased_SgNBRelConf_Item_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_ToBeReleased_SgNBRelConf_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_ToBeReleased_SgNBRelConf_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_RABs_ToBeReleased_SgNBRelConf_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_SgNBRelConf_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_SgNBRelConf_Item_iE_Extensions__item__criticality._const_tab = ____E_RABs_ToBeReleased_SgNBRelConf_Item_iE_Extensions__item__criticality_tab
    ___E_RABs_ToBeReleased_SgNBRelConf_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeReleased_SgNBRelConf_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_ToBeReleased_SgNBRelConf_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_RABs_ToBeReleased_SgNBRelConf_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_SgNBRelConf_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_SgNBRelConf_Item_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_ToBeReleased_SgNBRelConf_Item_iE_Extensions__item__extensionValue_tab
    ___E_RABs_ToBeReleased_SgNBRelConf_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeReleased_SgNBRelConf_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_ToBeReleased_SgNBRelConf_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_ToBeReleased_SgNBRelConf_Item_iE_Extensions__item__id),
        ('criticality', ___E_RABs_ToBeReleased_SgNBRelConf_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_ToBeReleased_SgNBRelConf_Item_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_ToBeReleased_SgNBRelConf_Item_iE_Extensions__item_._ext = None
    _E_RABs_ToBeReleased_SgNBRelConf_Item_iE_Extensions._cont = __E_RABs_ToBeReleased_SgNBRelConf_Item_iE_Extensions__item_
    _E_RABs_ToBeReleased_SgNBRelConf_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_ToBeReleased_SgNBRelConf_Item._cont = ASN1Dict([
        ('e-RAB-ID', _E_RABs_ToBeReleased_SgNBRelConf_Item_e_RAB_ID),
        ('en-DC-ResourceConfiguration', _E_RABs_ToBeReleased_SgNBRelConf_Item_en_DC_ResourceConfiguration),
        ('resource-configuration', _E_RABs_ToBeReleased_SgNBRelConf_Item_resource_configuration),
        ('iE-Extensions', _E_RABs_ToBeReleased_SgNBRelConf_Item_iE_Extensions),
        ])
    E_RABs_ToBeReleased_SgNBRelConf_Item._ext = []
    
    #-----< E-RABs-ToBeReleased-SgNBRelConf-ItemExtIEs >-----#
    E_RABs_ToBeReleased_SgNBRelConf_ItemExtIEs = CLASS(name='E-RABs-ToBeReleased-SgNBRelConf-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    E_RABs_ToBeReleased_SgNBRelConf_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeReleased-SgNBRelConf-Item-SgNBPDCPpresent >-----#
    E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPpresent = SEQ(name='E-RABs-ToBeReleased-SgNBRelConf-Item-SgNBPDCPpresent', mode=MODE_TYPE)
    _E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPpresent_uL_GTPtunnelEndpoint = SEQ(name='uL-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPpresent_dL_GTPtunnelEndpoint = SEQ(name='dL-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPpresent_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPpresent_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPpresent_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPpresent_iE_Extensions__item__id._const_tab = ____E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab
    ___E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPpresent_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPpresent_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPpresent_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPpresent_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPpresent_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPpresent_iE_Extensions__item__criticality._const_tab = ____E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPpresent_iE_Extensions__item__criticality_tab
    ___E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPpresent_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPpresent_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue_tab
    ___E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPpresent_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPpresent_iE_Extensions__item__id),
        ('criticality', ___E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPpresent_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPpresent_iE_Extensions__item_._ext = None
    _E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPpresent_iE_Extensions._cont = __E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPpresent_iE_Extensions__item_
    _E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPpresent_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPpresent._cont = ASN1Dict([
        ('uL-GTPtunnelEndpoint', _E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPpresent_uL_GTPtunnelEndpoint),
        ('dL-GTPtunnelEndpoint', _E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPpresent_dL_GTPtunnelEndpoint),
        ('iE-Extensions', _E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPpresent_iE_Extensions),
        ])
    E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPpresent._ext = []
    
    #-----< E-RABs-ToBeReleased-SgNBRelConf-Item-SgNBPDCPpresentExtIEs >-----#
    E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPpresentExtIEs = CLASS(name='E-RABs-ToBeReleased-SgNBRelConf-Item-SgNBPDCPpresentExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPpresentExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeReleased-SgNBRelConf-Item-SgNBPDCPnotpresent >-----#
    E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPnotpresent = SEQ(name='E-RABs-ToBeReleased-SgNBRelConf-Item-SgNBPDCPnotpresent', mode=MODE_TYPE)
    _E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPnotpresent_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPnotpresent_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__id._const_tab = ____E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab
    ___E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality._const_tab = ____E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality_tab
    ___E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue_tab
    ___E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPnotpresent_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__id),
        ('criticality', ___E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPnotpresent_iE_Extensions__item_._ext = None
    _E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPnotpresent_iE_Extensions._cont = __E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPnotpresent_iE_Extensions__item_
    _E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPnotpresent_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPnotpresent._cont = ASN1Dict([
        ('iE-Extensions', _E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPnotpresent_iE_Extensions),
        ])
    E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPnotpresent._ext = []
    
    #-----< E-RABs-ToBeReleased-SgNBRelConf-Item-SgNBPDCPnotpresentExtIEs >-----#
    E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPnotpresentExtIEs = CLASS(name='E-RABs-ToBeReleased-SgNBRelConf-Item-SgNBPDCPnotpresentExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPnotpresentExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SgNBCounterCheckRequest >-----#
    SgNBCounterCheckRequest = SEQ(name='SgNBCounterCheckRequest', mode=MODE_TYPE)
    _SgNBCounterCheckRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __SgNBCounterCheckRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___SgNBCounterCheckRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____SgNBCounterCheckRequest_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____SgNBCounterCheckRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SgNBCounterCheckRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNB-UE-X2AP-ID')))
    _____SgNBCounterCheckRequest_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-SubjectToSgNBCounterCheck-List')))
    _____SgNBCounterCheckRequest_protocolIEs__item__id_tab_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    ____SgNBCounterCheckRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'reject'), ('Value', _____SgNBCounterCheckRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 207), ('criticality', 'reject'), ('Value', _____SgNBCounterCheckRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 235), ('criticality', 'ignore'), ('Value', _____SgNBCounterCheckRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 157), ('criticality', 'ignore'), ('Value', _____SgNBCounterCheckRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SgNBCounterCheckRequest_protocolIEs__item__id._const_tab = ____SgNBCounterCheckRequest_protocolIEs__item__id_tab
    ___SgNBCounterCheckRequest_protocolIEs__item__id._const_tab_at = None
    ___SgNBCounterCheckRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___SgNBCounterCheckRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___SgNBCounterCheckRequest_protocolIEs__item__criticality._const_tab = ____SgNBCounterCheckRequest_protocolIEs__item__id_tab
    ___SgNBCounterCheckRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___SgNBCounterCheckRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___SgNBCounterCheckRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___SgNBCounterCheckRequest_protocolIEs__item__value._const_tab = ____SgNBCounterCheckRequest_protocolIEs__item__id_tab
    ___SgNBCounterCheckRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___SgNBCounterCheckRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __SgNBCounterCheckRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___SgNBCounterCheckRequest_protocolIEs__item__id),
        ('criticality', ___SgNBCounterCheckRequest_protocolIEs__item__criticality),
        ('value', ___SgNBCounterCheckRequest_protocolIEs__item__value),
        ])
    __SgNBCounterCheckRequest_protocolIEs__item_._ext = None
    _SgNBCounterCheckRequest_protocolIEs._cont = __SgNBCounterCheckRequest_protocolIEs__item_
    _SgNBCounterCheckRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    SgNBCounterCheckRequest._cont = ASN1Dict([
        ('protocolIEs', _SgNBCounterCheckRequest_protocolIEs),
        ])
    SgNBCounterCheckRequest._ext = []
    
    #-----< SgNBCounterCheckRequest-IEs >-----#
    SgNBCounterCheckRequest_IEs = CLASS(name='SgNBCounterCheckRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _SgNBCounterCheckRequest_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SgNBCounterCheckRequest_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNB-UE-X2AP-ID')))
    _SgNBCounterCheckRequest_IEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-SubjectToSgNBCounterCheck-List')))
    _SgNBCounterCheckRequest_IEs_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    SgNBCounterCheckRequest_IEs._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'reject'), ('Value', _SgNBCounterCheckRequest_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 207), ('criticality', 'reject'), ('Value', _SgNBCounterCheckRequest_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 235), ('criticality', 'ignore'), ('Value', _SgNBCounterCheckRequest_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 157), ('criticality', 'ignore'), ('Value', _SgNBCounterCheckRequest_IEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-SubjectToSgNBCounterCheck-List >-----#
    E_RABs_SubjectToSgNBCounterCheck_List = SEQ_OF(name='E-RABs-SubjectToSgNBCounterCheck-List', mode=MODE_TYPE)
    _E_RABs_SubjectToSgNBCounterCheck_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __E_RABs_SubjectToSgNBCounterCheck_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ___E_RABs_SubjectToSgNBCounterCheck_List__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____E_RABs_SubjectToSgNBCounterCheck_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-SubjectToSgNBCounterCheck-Item')))
    ___E_RABs_SubjectToSgNBCounterCheck_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 236), ('criticality', 'ignore'), ('Value', ____E_RABs_SubjectToSgNBCounterCheck_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E_RABs_SubjectToSgNBCounterCheck_List__item__id._const_tab = ___E_RABs_SubjectToSgNBCounterCheck_List__item__id_tab
    __E_RABs_SubjectToSgNBCounterCheck_List__item__id._const_tab_at = None
    __E_RABs_SubjectToSgNBCounterCheck_List__item__id._const_tab_id = 'id'
    __E_RABs_SubjectToSgNBCounterCheck_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    __E_RABs_SubjectToSgNBCounterCheck_List__item__criticality._const_tab = ___E_RABs_SubjectToSgNBCounterCheck_List__item__id_tab
    __E_RABs_SubjectToSgNBCounterCheck_List__item__criticality._const_tab_at = ('..', 'id')
    __E_RABs_SubjectToSgNBCounterCheck_List__item__criticality._const_tab_id = 'criticality'
    __E_RABs_SubjectToSgNBCounterCheck_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    __E_RABs_SubjectToSgNBCounterCheck_List__item__value._const_tab = ___E_RABs_SubjectToSgNBCounterCheck_List__item__id_tab
    __E_RABs_SubjectToSgNBCounterCheck_List__item__value._const_tab_at = ('..', 'id')
    __E_RABs_SubjectToSgNBCounterCheck_List__item__value._const_tab_id = 'Value'
    _E_RABs_SubjectToSgNBCounterCheck_List__item_._cont = ASN1Dict([
        ('id', __E_RABs_SubjectToSgNBCounterCheck_List__item__id),
        ('criticality', __E_RABs_SubjectToSgNBCounterCheck_List__item__criticality),
        ('value', __E_RABs_SubjectToSgNBCounterCheck_List__item__value),
        ])
    _E_RABs_SubjectToSgNBCounterCheck_List__item_._ext = None
    E_RABs_SubjectToSgNBCounterCheck_List._cont = _E_RABs_SubjectToSgNBCounterCheck_List__item_
    E_RABs_SubjectToSgNBCounterCheck_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABs-SubjectToSgNBCounterCheck-ItemIEs >-----#
    E_RABs_SubjectToSgNBCounterCheck_ItemIEs = CLASS(name='E-RABs-SubjectToSgNBCounterCheck-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _E_RABs_SubjectToSgNBCounterCheck_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-SubjectToSgNBCounterCheck-Item')))
    E_RABs_SubjectToSgNBCounterCheck_ItemIEs._val = ASN1Set(rv=[dict([('id', 236), ('criticality', 'ignore'), ('Value', _E_RABs_SubjectToSgNBCounterCheck_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-SubjectToSgNBCounterCheck-Item >-----#
    E_RABs_SubjectToSgNBCounterCheck_Item = SEQ(name='E-RABs-SubjectToSgNBCounterCheck-Item', mode=MODE_TYPE)
    _E_RABs_SubjectToSgNBCounterCheck_Item_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_SubjectToSgNBCounterCheck_Item_uL_Count = INT(name='uL-Count', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _E_RABs_SubjectToSgNBCounterCheck_Item_uL_Count._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    _E_RABs_SubjectToSgNBCounterCheck_Item_dL_Count = INT(name='dL-Count', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _E_RABs_SubjectToSgNBCounterCheck_Item_dL_Count._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    _E_RABs_SubjectToSgNBCounterCheck_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_SubjectToSgNBCounterCheck_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_SubjectToSgNBCounterCheck_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_SubjectToSgNBCounterCheck_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_SubjectToSgNBCounterCheck_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_SubjectToSgNBCounterCheck_Item_iE_Extensions__item__id._const_tab = ____E_RABs_SubjectToSgNBCounterCheck_Item_iE_Extensions__item__id_tab
    ___E_RABs_SubjectToSgNBCounterCheck_Item_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_SubjectToSgNBCounterCheck_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_SubjectToSgNBCounterCheck_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_RABs_SubjectToSgNBCounterCheck_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_SubjectToSgNBCounterCheck_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_SubjectToSgNBCounterCheck_Item_iE_Extensions__item__criticality._const_tab = ____E_RABs_SubjectToSgNBCounterCheck_Item_iE_Extensions__item__criticality_tab
    ___E_RABs_SubjectToSgNBCounterCheck_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_SubjectToSgNBCounterCheck_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_SubjectToSgNBCounterCheck_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_RABs_SubjectToSgNBCounterCheck_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_SubjectToSgNBCounterCheck_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_SubjectToSgNBCounterCheck_Item_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_SubjectToSgNBCounterCheck_Item_iE_Extensions__item__extensionValue_tab
    ___E_RABs_SubjectToSgNBCounterCheck_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_SubjectToSgNBCounterCheck_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_SubjectToSgNBCounterCheck_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_SubjectToSgNBCounterCheck_Item_iE_Extensions__item__id),
        ('criticality', ___E_RABs_SubjectToSgNBCounterCheck_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_SubjectToSgNBCounterCheck_Item_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_SubjectToSgNBCounterCheck_Item_iE_Extensions__item_._ext = None
    _E_RABs_SubjectToSgNBCounterCheck_Item_iE_Extensions._cont = __E_RABs_SubjectToSgNBCounterCheck_Item_iE_Extensions__item_
    _E_RABs_SubjectToSgNBCounterCheck_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_SubjectToSgNBCounterCheck_Item._cont = ASN1Dict([
        ('e-RAB-ID', _E_RABs_SubjectToSgNBCounterCheck_Item_e_RAB_ID),
        ('uL-Count', _E_RABs_SubjectToSgNBCounterCheck_Item_uL_Count),
        ('dL-Count', _E_RABs_SubjectToSgNBCounterCheck_Item_dL_Count),
        ('iE-Extensions', _E_RABs_SubjectToSgNBCounterCheck_Item_iE_Extensions),
        ])
    E_RABs_SubjectToSgNBCounterCheck_Item._ext = []
    
    #-----< E-RABs-SubjectToSgNBCounterCheck-ItemExtIEs >-----#
    E_RABs_SubjectToSgNBCounterCheck_ItemExtIEs = CLASS(name='E-RABs-SubjectToSgNBCounterCheck-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    E_RABs_SubjectToSgNBCounterCheck_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SgNBChangeRequired >-----#
    SgNBChangeRequired = SEQ(name='SgNBChangeRequired', mode=MODE_TYPE)
    _SgNBChangeRequired_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __SgNBChangeRequired_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___SgNBChangeRequired_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____SgNBChangeRequired_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____SgNBChangeRequired_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SgNBChangeRequired_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNB-UE-X2AP-ID')))
    _____SgNBChangeRequired_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GlobalGNB-ID')))
    _____SgNBChangeRequired_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _____SgNBChangeRequired_protocolIEs__item__id_tab_val_Value_4 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNBtoMeNBContainer')))
    _____SgNBChangeRequired_protocolIEs__item__id_tab_val_Value_5 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____SgNBChangeRequired_protocolIEs__item__id_tab_val_Value_6 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SCG-UE-HistoryInformation')))
    _____SgNBChangeRequired_protocolIEs__item__id_tab_val_Value_7 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CPCinformation-REQD')))
    ____SgNBChangeRequired_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'reject'), ('Value', _____SgNBChangeRequired_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 207), ('criticality', 'reject'), ('Value', _____SgNBChangeRequired_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 239), ('criticality', 'reject'), ('Value', _____SgNBChangeRequired_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _____SgNBChangeRequired_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 211), ('criticality', 'reject'), ('Value', _____SgNBChangeRequired_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 157), ('criticality', 'reject'), ('Value', _____SgNBChangeRequired_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 415), ('criticality', 'ignore'), ('Value', _____SgNBChangeRequired_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 429), ('criticality', 'reject'), ('Value', _____SgNBChangeRequired_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SgNBChangeRequired_protocolIEs__item__id._const_tab = ____SgNBChangeRequired_protocolIEs__item__id_tab
    ___SgNBChangeRequired_protocolIEs__item__id._const_tab_at = None
    ___SgNBChangeRequired_protocolIEs__item__id._const_tab_id = 'id'
    ___SgNBChangeRequired_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___SgNBChangeRequired_protocolIEs__item__criticality._const_tab = ____SgNBChangeRequired_protocolIEs__item__id_tab
    ___SgNBChangeRequired_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___SgNBChangeRequired_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___SgNBChangeRequired_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___SgNBChangeRequired_protocolIEs__item__value._const_tab = ____SgNBChangeRequired_protocolIEs__item__id_tab
    ___SgNBChangeRequired_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___SgNBChangeRequired_protocolIEs__item__value._const_tab_id = 'Value'
    __SgNBChangeRequired_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___SgNBChangeRequired_protocolIEs__item__id),
        ('criticality', ___SgNBChangeRequired_protocolIEs__item__criticality),
        ('value', ___SgNBChangeRequired_protocolIEs__item__value),
        ])
    __SgNBChangeRequired_protocolIEs__item_._ext = None
    _SgNBChangeRequired_protocolIEs._cont = __SgNBChangeRequired_protocolIEs__item_
    _SgNBChangeRequired_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    SgNBChangeRequired._cont = ASN1Dict([
        ('protocolIEs', _SgNBChangeRequired_protocolIEs),
        ])
    SgNBChangeRequired._ext = []
    
    #-----< SgNBChangeRequired-IEs >-----#
    SgNBChangeRequired_IEs = CLASS(name='SgNBChangeRequired-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _SgNBChangeRequired_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SgNBChangeRequired_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNB-UE-X2AP-ID')))
    _SgNBChangeRequired_IEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GlobalGNB-ID')))
    _SgNBChangeRequired_IEs_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _SgNBChangeRequired_IEs_val_Value_4 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNBtoMeNBContainer')))
    _SgNBChangeRequired_IEs_val_Value_5 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _SgNBChangeRequired_IEs_val_Value_6 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SCG-UE-HistoryInformation')))
    _SgNBChangeRequired_IEs_val_Value_7 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CPCinformation-REQD')))
    SgNBChangeRequired_IEs._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'reject'), ('Value', _SgNBChangeRequired_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 207), ('criticality', 'reject'), ('Value', _SgNBChangeRequired_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 239), ('criticality', 'reject'), ('Value', _SgNBChangeRequired_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _SgNBChangeRequired_IEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 211), ('criticality', 'reject'), ('Value', _SgNBChangeRequired_IEs_val_Value_4), ('presence', 'optional')]), dict([('id', 157), ('criticality', 'reject'), ('Value', _SgNBChangeRequired_IEs_val_Value_5), ('presence', 'optional')]), dict([('id', 415), ('criticality', 'ignore'), ('Value', _SgNBChangeRequired_IEs_val_Value_6), ('presence', 'optional')]), dict([('id', 429), ('criticality', 'reject'), ('Value', _SgNBChangeRequired_IEs_val_Value_7), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< AccessAndMobilityIndication >-----#
    AccessAndMobilityIndication = SEQ(name='AccessAndMobilityIndication', mode=MODE_TYPE)
    _AccessAndMobilityIndication_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __AccessAndMobilityIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___AccessAndMobilityIndication_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____AccessAndMobilityIndication_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____AccessAndMobilityIndication_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'NRRACHReportInformation')))
    ____AccessAndMobilityIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 414), ('criticality', 'ignore'), ('Value', _____AccessAndMobilityIndication_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___AccessAndMobilityIndication_protocolIEs__item__id._const_tab = ____AccessAndMobilityIndication_protocolIEs__item__id_tab
    ___AccessAndMobilityIndication_protocolIEs__item__id._const_tab_at = None
    ___AccessAndMobilityIndication_protocolIEs__item__id._const_tab_id = 'id'
    ___AccessAndMobilityIndication_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___AccessAndMobilityIndication_protocolIEs__item__criticality._const_tab = ____AccessAndMobilityIndication_protocolIEs__item__id_tab
    ___AccessAndMobilityIndication_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___AccessAndMobilityIndication_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___AccessAndMobilityIndication_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___AccessAndMobilityIndication_protocolIEs__item__value._const_tab = ____AccessAndMobilityIndication_protocolIEs__item__id_tab
    ___AccessAndMobilityIndication_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___AccessAndMobilityIndication_protocolIEs__item__value._const_tab_id = 'Value'
    __AccessAndMobilityIndication_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___AccessAndMobilityIndication_protocolIEs__item__id),
        ('criticality', ___AccessAndMobilityIndication_protocolIEs__item__criticality),
        ('value', ___AccessAndMobilityIndication_protocolIEs__item__value),
        ])
    __AccessAndMobilityIndication_protocolIEs__item_._ext = None
    _AccessAndMobilityIndication_protocolIEs._cont = __AccessAndMobilityIndication_protocolIEs__item_
    _AccessAndMobilityIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    AccessAndMobilityIndication._cont = ASN1Dict([
        ('protocolIEs', _AccessAndMobilityIndication_protocolIEs),
        ])
    AccessAndMobilityIndication._ext = []
    
    #-----< AccessAndMobilityIndication-IEs >-----#
    AccessAndMobilityIndication_IEs = CLASS(name='AccessAndMobilityIndication-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _AccessAndMobilityIndication_IEs_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'NRRACHReportInformation')))
    AccessAndMobilityIndication_IEs._val = ASN1Set(rv=[dict([('id', 414), ('criticality', 'ignore'), ('Value', _AccessAndMobilityIndication_IEs_val_Value_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< SgNBChangeConfirm >-----#
    SgNBChangeConfirm = SEQ(name='SgNBChangeConfirm', mode=MODE_TYPE)
    _SgNBChangeConfirm_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __SgNBChangeConfirm_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___SgNBChangeConfirm_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____SgNBChangeConfirm_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____SgNBChangeConfirm_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SgNBChangeConfirm_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNB-UE-X2AP-ID')))
    _____SgNBChangeConfirm_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-SgNBChaConfList')))
    _____SgNBChangeConfirm_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _____SgNBChangeConfirm_protocolIEs__item__id_tab_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____SgNBChangeConfirm_protocolIEs__item__id_tab_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CPCinformation-CONF')))
    _____SgNBChangeConfirm_protocolIEs__item__id_tab_val_Value_6 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MeNBtoSgNBContainer')))
    ____SgNBChangeConfirm_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'ignore'), ('Value', _____SgNBChangeConfirm_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 207), ('criticality', 'ignore'), ('Value', _____SgNBChangeConfirm_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 229), ('criticality', 'ignore'), ('Value', _____SgNBChangeConfirm_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _____SgNBChangeConfirm_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 157), ('criticality', 'ignore'), ('Value', _____SgNBChangeConfirm_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 430), ('criticality', 'ignore'), ('Value', _____SgNBChangeConfirm_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 206), ('criticality', 'ignore'), ('Value', _____SgNBChangeConfirm_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SgNBChangeConfirm_protocolIEs__item__id._const_tab = ____SgNBChangeConfirm_protocolIEs__item__id_tab
    ___SgNBChangeConfirm_protocolIEs__item__id._const_tab_at = None
    ___SgNBChangeConfirm_protocolIEs__item__id._const_tab_id = 'id'
    ___SgNBChangeConfirm_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___SgNBChangeConfirm_protocolIEs__item__criticality._const_tab = ____SgNBChangeConfirm_protocolIEs__item__id_tab
    ___SgNBChangeConfirm_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___SgNBChangeConfirm_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___SgNBChangeConfirm_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___SgNBChangeConfirm_protocolIEs__item__value._const_tab = ____SgNBChangeConfirm_protocolIEs__item__id_tab
    ___SgNBChangeConfirm_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___SgNBChangeConfirm_protocolIEs__item__value._const_tab_id = 'Value'
    __SgNBChangeConfirm_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___SgNBChangeConfirm_protocolIEs__item__id),
        ('criticality', ___SgNBChangeConfirm_protocolIEs__item__criticality),
        ('value', ___SgNBChangeConfirm_protocolIEs__item__value),
        ])
    __SgNBChangeConfirm_protocolIEs__item_._ext = None
    _SgNBChangeConfirm_protocolIEs._cont = __SgNBChangeConfirm_protocolIEs__item_
    _SgNBChangeConfirm_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    SgNBChangeConfirm._cont = ASN1Dict([
        ('protocolIEs', _SgNBChangeConfirm_protocolIEs),
        ])
    SgNBChangeConfirm._ext = []
    
    #-----< SgNBChangeConfirm-IEs >-----#
    SgNBChangeConfirm_IEs = CLASS(name='SgNBChangeConfirm-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _SgNBChangeConfirm_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SgNBChangeConfirm_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNB-UE-X2AP-ID')))
    _SgNBChangeConfirm_IEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-SgNBChaConfList')))
    _SgNBChangeConfirm_IEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _SgNBChangeConfirm_IEs_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _SgNBChangeConfirm_IEs_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CPCinformation-CONF')))
    _SgNBChangeConfirm_IEs_val_Value_6 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MeNBtoSgNBContainer')))
    SgNBChangeConfirm_IEs._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'ignore'), ('Value', _SgNBChangeConfirm_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 207), ('criticality', 'ignore'), ('Value', _SgNBChangeConfirm_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 229), ('criticality', 'ignore'), ('Value', _SgNBChangeConfirm_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _SgNBChangeConfirm_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 157), ('criticality', 'ignore'), ('Value', _SgNBChangeConfirm_IEs_val_Value_4), ('presence', 'optional')]), dict([('id', 430), ('criticality', 'ignore'), ('Value', _SgNBChangeConfirm_IEs_val_Value_5), ('presence', 'optional')]), dict([('id', 206), ('criticality', 'ignore'), ('Value', _SgNBChangeConfirm_IEs_val_Value_6), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeReleased-SgNBChaConfList >-----#
    E_RABs_ToBeReleased_SgNBChaConfList = SEQ_OF(name='E-RABs-ToBeReleased-SgNBChaConfList', mode=MODE_TYPE)
    _E_RABs_ToBeReleased_SgNBChaConfList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __E_RABs_ToBeReleased_SgNBChaConfList__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ___E_RABs_ToBeReleased_SgNBChaConfList__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____E_RABs_ToBeReleased_SgNBChaConfList__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-SgNBChaConf-Item')))
    ___E_RABs_ToBeReleased_SgNBChaConfList__item__id_tab._val = ASN1Set(rv=[dict([('id', 230), ('criticality', 'ignore'), ('Value', ____E_RABs_ToBeReleased_SgNBChaConfList__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E_RABs_ToBeReleased_SgNBChaConfList__item__id._const_tab = ___E_RABs_ToBeReleased_SgNBChaConfList__item__id_tab
    __E_RABs_ToBeReleased_SgNBChaConfList__item__id._const_tab_at = None
    __E_RABs_ToBeReleased_SgNBChaConfList__item__id._const_tab_id = 'id'
    __E_RABs_ToBeReleased_SgNBChaConfList__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    __E_RABs_ToBeReleased_SgNBChaConfList__item__criticality._const_tab = ___E_RABs_ToBeReleased_SgNBChaConfList__item__id_tab
    __E_RABs_ToBeReleased_SgNBChaConfList__item__criticality._const_tab_at = ('..', 'id')
    __E_RABs_ToBeReleased_SgNBChaConfList__item__criticality._const_tab_id = 'criticality'
    __E_RABs_ToBeReleased_SgNBChaConfList__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    __E_RABs_ToBeReleased_SgNBChaConfList__item__value._const_tab = ___E_RABs_ToBeReleased_SgNBChaConfList__item__id_tab
    __E_RABs_ToBeReleased_SgNBChaConfList__item__value._const_tab_at = ('..', 'id')
    __E_RABs_ToBeReleased_SgNBChaConfList__item__value._const_tab_id = 'Value'
    _E_RABs_ToBeReleased_SgNBChaConfList__item_._cont = ASN1Dict([
        ('id', __E_RABs_ToBeReleased_SgNBChaConfList__item__id),
        ('criticality', __E_RABs_ToBeReleased_SgNBChaConfList__item__criticality),
        ('value', __E_RABs_ToBeReleased_SgNBChaConfList__item__value),
        ])
    _E_RABs_ToBeReleased_SgNBChaConfList__item_._ext = None
    E_RABs_ToBeReleased_SgNBChaConfList._cont = _E_RABs_ToBeReleased_SgNBChaConfList__item_
    E_RABs_ToBeReleased_SgNBChaConfList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABs-ToBeReleased-SgNBChaConf-ItemIEs >-----#
    E_RABs_ToBeReleased_SgNBChaConf_ItemIEs = CLASS(name='E-RABs-ToBeReleased-SgNBChaConf-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _E_RABs_ToBeReleased_SgNBChaConf_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-SgNBChaConf-Item')))
    E_RABs_ToBeReleased_SgNBChaConf_ItemIEs._val = ASN1Set(rv=[dict([('id', 230), ('criticality', 'ignore'), ('Value', _E_RABs_ToBeReleased_SgNBChaConf_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeReleased-SgNBChaConf-Item >-----#
    E_RABs_ToBeReleased_SgNBChaConf_Item = SEQ(name='E-RABs-ToBeReleased-SgNBChaConf-Item', mode=MODE_TYPE)
    _E_RABs_ToBeReleased_SgNBChaConf_Item_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_ToBeReleased_SgNBChaConf_Item_en_DC_ResourceConfiguration = SEQ(name='en-DC-ResourceConfiguration', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'EN-DC-ResourceConfiguration')))
    _E_RABs_ToBeReleased_SgNBChaConf_Item_resource_configuration = CHOICE(name='resource-configuration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __E_RABs_ToBeReleased_SgNBChaConf_Item_resource_configuration_sgNBPDCPpresent = SEQ(name='sgNBPDCPpresent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-SgNBChaConf-Item-SgNBPDCPpresent')))
    __E_RABs_ToBeReleased_SgNBChaConf_Item_resource_configuration_sgNBPDCPnotpresent = SEQ(name='sgNBPDCPnotpresent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-ToBeReleased-SgNBChaConf-Item-SgNBPDCPnotpresent')))
    _E_RABs_ToBeReleased_SgNBChaConf_Item_resource_configuration._cont = ASN1Dict([
        ('sgNBPDCPpresent', __E_RABs_ToBeReleased_SgNBChaConf_Item_resource_configuration_sgNBPDCPpresent),
        ('sgNBPDCPnotpresent', __E_RABs_ToBeReleased_SgNBChaConf_Item_resource_configuration_sgNBPDCPnotpresent),
        ])
    _E_RABs_ToBeReleased_SgNBChaConf_Item_resource_configuration._ext = []
    _E_RABs_ToBeReleased_SgNBChaConf_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_ToBeReleased_SgNBChaConf_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_ToBeReleased_SgNBChaConf_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_ToBeReleased_SgNBChaConf_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_SgNBChaConf_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_SgNBChaConf_Item_iE_Extensions__item__id._const_tab = ____E_RABs_ToBeReleased_SgNBChaConf_Item_iE_Extensions__item__id_tab
    ___E_RABs_ToBeReleased_SgNBChaConf_Item_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_ToBeReleased_SgNBChaConf_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_ToBeReleased_SgNBChaConf_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_RABs_ToBeReleased_SgNBChaConf_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_SgNBChaConf_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_SgNBChaConf_Item_iE_Extensions__item__criticality._const_tab = ____E_RABs_ToBeReleased_SgNBChaConf_Item_iE_Extensions__item__criticality_tab
    ___E_RABs_ToBeReleased_SgNBChaConf_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeReleased_SgNBChaConf_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_ToBeReleased_SgNBChaConf_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_RABs_ToBeReleased_SgNBChaConf_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_SgNBChaConf_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_SgNBChaConf_Item_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_ToBeReleased_SgNBChaConf_Item_iE_Extensions__item__extensionValue_tab
    ___E_RABs_ToBeReleased_SgNBChaConf_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeReleased_SgNBChaConf_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_ToBeReleased_SgNBChaConf_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_ToBeReleased_SgNBChaConf_Item_iE_Extensions__item__id),
        ('criticality', ___E_RABs_ToBeReleased_SgNBChaConf_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_ToBeReleased_SgNBChaConf_Item_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_ToBeReleased_SgNBChaConf_Item_iE_Extensions__item_._ext = None
    _E_RABs_ToBeReleased_SgNBChaConf_Item_iE_Extensions._cont = __E_RABs_ToBeReleased_SgNBChaConf_Item_iE_Extensions__item_
    _E_RABs_ToBeReleased_SgNBChaConf_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_ToBeReleased_SgNBChaConf_Item._cont = ASN1Dict([
        ('e-RAB-ID', _E_RABs_ToBeReleased_SgNBChaConf_Item_e_RAB_ID),
        ('en-DC-ResourceConfiguration', _E_RABs_ToBeReleased_SgNBChaConf_Item_en_DC_ResourceConfiguration),
        ('resource-configuration', _E_RABs_ToBeReleased_SgNBChaConf_Item_resource_configuration),
        ('iE-Extensions', _E_RABs_ToBeReleased_SgNBChaConf_Item_iE_Extensions),
        ])
    E_RABs_ToBeReleased_SgNBChaConf_Item._ext = []
    
    #-----< E-RABs-ToBeReleased-SgNBChaConf-ItemExtIEs >-----#
    E_RABs_ToBeReleased_SgNBChaConf_ItemExtIEs = CLASS(name='E-RABs-ToBeReleased-SgNBChaConf-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    E_RABs_ToBeReleased_SgNBChaConf_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeReleased-SgNBChaConf-Item-SgNBPDCPpresent >-----#
    E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPpresent = SEQ(name='E-RABs-ToBeReleased-SgNBChaConf-Item-SgNBPDCPpresent', mode=MODE_TYPE)
    _E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPpresent_uL_GTPtunnelEndpoint = SEQ(name='uL-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPpresent_dL_GTPtunnelEndpoint = SEQ(name='dL-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPpresent_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPpresent_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPpresent_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'AdditionalListofForwardingGTPTunnelEndpoint')))
    ____E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 441), ('criticality', 'ignore'), ('Extension', _____E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPpresent_iE_Extensions__item__id._const_tab = ____E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab
    ___E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPpresent_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPpresent_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPpresent_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPpresent_iE_Extensions__item__criticality._const_tab = ____E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab
    ___E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPpresent_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPpresent_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab
    ___E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPpresent_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPpresent_iE_Extensions__item__id),
        ('criticality', ___E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPpresent_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPpresent_iE_Extensions__item_._ext = None
    _E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPpresent_iE_Extensions._cont = __E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPpresent_iE_Extensions__item_
    _E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPpresent_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPpresent._cont = ASN1Dict([
        ('uL-GTPtunnelEndpoint', _E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPpresent_uL_GTPtunnelEndpoint),
        ('dL-GTPtunnelEndpoint', _E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPpresent_dL_GTPtunnelEndpoint),
        ('iE-Extensions', _E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPpresent_iE_Extensions),
        ])
    E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPpresent._ext = []
    
    #-----< E-RABs-ToBeReleased-SgNBChaConf-Item-SgNBPDCPpresentExtIEs >-----#
    E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPpresentExtIEs = CLASS(name='E-RABs-ToBeReleased-SgNBChaConf-Item-SgNBPDCPpresentExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPpresentExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'AdditionalListofForwardingGTPTunnelEndpoint')))
    E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPpresentExtIEs._val = ASN1Set(rv=[dict([('id', 441), ('criticality', 'ignore'), ('Extension', _E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPpresentExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeReleased-SgNBChaConf-Item-SgNBPDCPnotpresent >-----#
    E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPnotpresent = SEQ(name='E-RABs-ToBeReleased-SgNBChaConf-Item-SgNBPDCPnotpresent', mode=MODE_TYPE)
    _E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPnotpresent_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPnotpresent_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__id._const_tab = ____E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab
    ___E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality._const_tab = ____E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality_tab
    ___E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue_tab
    ___E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPnotpresent_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__id),
        ('criticality', ___E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPnotpresent_iE_Extensions__item_._ext = None
    _E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPnotpresent_iE_Extensions._cont = __E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPnotpresent_iE_Extensions__item_
    _E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPnotpresent_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPnotpresent._cont = ASN1Dict([
        ('iE-Extensions', _E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPnotpresent_iE_Extensions),
        ])
    E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPnotpresent._ext = []
    
    #-----< E-RABs-ToBeReleased-SgNBChaConf-Item-SgNBPDCPnotpresentExtIEs >-----#
    E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPnotpresentExtIEs = CLASS(name='E-RABs-ToBeReleased-SgNBChaConf-Item-SgNBPDCPnotpresentExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPnotpresentExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RRCTransfer >-----#
    RRCTransfer = SEQ(name='RRCTransfer', mode=MODE_TYPE)
    _RRCTransfer_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __RRCTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___RRCTransfer_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____RRCTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____RRCTransfer_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____RRCTransfer_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNB-UE-X2AP-ID')))
    _____RRCTransfer_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SplitSRB')))
    _____RRCTransfer_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'NRUeReport')))
    _____RRCTransfer_protocolIEs__item__id_tab_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____RRCTransfer_protocolIEs__item__id_tab_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'FastMCGRecovery')))
    _____RRCTransfer_protocolIEs__item__id_tab_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'FastMCGRecovery')))
    ____RRCTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'reject'), ('Value', _____RRCTransfer_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 207), ('criticality', 'reject'), ('Value', _____RRCTransfer_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 242), ('criticality', 'reject'), ('Value', _____RRCTransfer_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 243), ('criticality', 'reject'), ('Value', _____RRCTransfer_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 157), ('criticality', 'reject'), ('Value', _____RRCTransfer_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 342), ('criticality', 'ignore'), ('Value', _____RRCTransfer_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 347), ('criticality', 'ignore'), ('Value', _____RRCTransfer_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RRCTransfer_protocolIEs__item__id._const_tab = ____RRCTransfer_protocolIEs__item__id_tab
    ___RRCTransfer_protocolIEs__item__id._const_tab_at = None
    ___RRCTransfer_protocolIEs__item__id._const_tab_id = 'id'
    ___RRCTransfer_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___RRCTransfer_protocolIEs__item__criticality._const_tab = ____RRCTransfer_protocolIEs__item__id_tab
    ___RRCTransfer_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RRCTransfer_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RRCTransfer_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___RRCTransfer_protocolIEs__item__value._const_tab = ____RRCTransfer_protocolIEs__item__id_tab
    ___RRCTransfer_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RRCTransfer_protocolIEs__item__value._const_tab_id = 'Value'
    __RRCTransfer_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RRCTransfer_protocolIEs__item__id),
        ('criticality', ___RRCTransfer_protocolIEs__item__criticality),
        ('value', ___RRCTransfer_protocolIEs__item__value),
        ])
    __RRCTransfer_protocolIEs__item_._ext = None
    _RRCTransfer_protocolIEs._cont = __RRCTransfer_protocolIEs__item_
    _RRCTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RRCTransfer._cont = ASN1Dict([
        ('protocolIEs', _RRCTransfer_protocolIEs),
        ])
    RRCTransfer._ext = []
    
    #-----< RRCTransfer-IEs >-----#
    RRCTransfer_IEs = CLASS(name='RRCTransfer-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _RRCTransfer_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _RRCTransfer_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNB-UE-X2AP-ID')))
    _RRCTransfer_IEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SplitSRB')))
    _RRCTransfer_IEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'NRUeReport')))
    _RRCTransfer_IEs_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _RRCTransfer_IEs_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'FastMCGRecovery')))
    _RRCTransfer_IEs_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'FastMCGRecovery')))
    RRCTransfer_IEs._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'reject'), ('Value', _RRCTransfer_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 207), ('criticality', 'reject'), ('Value', _RRCTransfer_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 242), ('criticality', 'reject'), ('Value', _RRCTransfer_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 243), ('criticality', 'reject'), ('Value', _RRCTransfer_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 157), ('criticality', 'reject'), ('Value', _RRCTransfer_IEs_val_Value_4), ('presence', 'optional')]), dict([('id', 342), ('criticality', 'ignore'), ('Value', _RRCTransfer_IEs_val_Value_5), ('presence', 'optional')]), dict([('id', 347), ('criticality', 'ignore'), ('Value', _RRCTransfer_IEs_val_Value_6), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< SgNBChangeRefuse >-----#
    SgNBChangeRefuse = SEQ(name='SgNBChangeRefuse', mode=MODE_TYPE)
    _SgNBChangeRefuse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __SgNBChangeRefuse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___SgNBChangeRefuse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____SgNBChangeRefuse_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____SgNBChangeRefuse_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SgNBChangeRefuse_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNB-UE-X2AP-ID')))
    _____SgNBChangeRefuse_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _____SgNBChangeRefuse_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _____SgNBChangeRefuse_protocolIEs__item__id_tab_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    ____SgNBChangeRefuse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'ignore'), ('Value', _____SgNBChangeRefuse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 207), ('criticality', 'ignore'), ('Value', _____SgNBChangeRefuse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _____SgNBChangeRefuse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _____SgNBChangeRefuse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 157), ('criticality', 'reject'), ('Value', _____SgNBChangeRefuse_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SgNBChangeRefuse_protocolIEs__item__id._const_tab = ____SgNBChangeRefuse_protocolIEs__item__id_tab
    ___SgNBChangeRefuse_protocolIEs__item__id._const_tab_at = None
    ___SgNBChangeRefuse_protocolIEs__item__id._const_tab_id = 'id'
    ___SgNBChangeRefuse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___SgNBChangeRefuse_protocolIEs__item__criticality._const_tab = ____SgNBChangeRefuse_protocolIEs__item__id_tab
    ___SgNBChangeRefuse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___SgNBChangeRefuse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___SgNBChangeRefuse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___SgNBChangeRefuse_protocolIEs__item__value._const_tab = ____SgNBChangeRefuse_protocolIEs__item__id_tab
    ___SgNBChangeRefuse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___SgNBChangeRefuse_protocolIEs__item__value._const_tab_id = 'Value'
    __SgNBChangeRefuse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___SgNBChangeRefuse_protocolIEs__item__id),
        ('criticality', ___SgNBChangeRefuse_protocolIEs__item__criticality),
        ('value', ___SgNBChangeRefuse_protocolIEs__item__value),
        ])
    __SgNBChangeRefuse_protocolIEs__item_._ext = None
    _SgNBChangeRefuse_protocolIEs._cont = __SgNBChangeRefuse_protocolIEs__item_
    _SgNBChangeRefuse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    SgNBChangeRefuse._cont = ASN1Dict([
        ('protocolIEs', _SgNBChangeRefuse_protocolIEs),
        ])
    SgNBChangeRefuse._ext = []
    
    #-----< SgNBChangeRefuse-IEs >-----#
    SgNBChangeRefuse_IEs = CLASS(name='SgNBChangeRefuse-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _SgNBChangeRefuse_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SgNBChangeRefuse_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNB-UE-X2AP-ID')))
    _SgNBChangeRefuse_IEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _SgNBChangeRefuse_IEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _SgNBChangeRefuse_IEs_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    SgNBChangeRefuse_IEs._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'ignore'), ('Value', _SgNBChangeRefuse_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 207), ('criticality', 'ignore'), ('Value', _SgNBChangeRefuse_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _SgNBChangeRefuse_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _SgNBChangeRefuse_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 157), ('criticality', 'reject'), ('Value', _SgNBChangeRefuse_IEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ENDCX2SetupRequest >-----#
    ENDCX2SetupRequest = SEQ(name='ENDCX2SetupRequest', mode=MODE_TYPE)
    _ENDCX2SetupRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __ENDCX2SetupRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___ENDCX2SetupRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____ENDCX2SetupRequest_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____ENDCX2SetupRequest_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'InitiatingNodeType-EndcX2Setup')))
    _____ENDCX2SetupRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'InterfaceInstanceIndication')))
    _____ENDCX2SetupRequest_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TNLConfigurationInfo')))
    ____ENDCX2SetupRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 244), ('criticality', 'reject'), ('Value', _____ENDCX2SetupRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 335), ('criticality', 'reject'), ('Value', _____ENDCX2SetupRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 352), ('criticality', 'ignore'), ('Value', _____ENDCX2SetupRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ENDCX2SetupRequest_protocolIEs__item__id._const_tab = ____ENDCX2SetupRequest_protocolIEs__item__id_tab
    ___ENDCX2SetupRequest_protocolIEs__item__id._const_tab_at = None
    ___ENDCX2SetupRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___ENDCX2SetupRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___ENDCX2SetupRequest_protocolIEs__item__criticality._const_tab = ____ENDCX2SetupRequest_protocolIEs__item__id_tab
    ___ENDCX2SetupRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ENDCX2SetupRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ENDCX2SetupRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___ENDCX2SetupRequest_protocolIEs__item__value._const_tab = ____ENDCX2SetupRequest_protocolIEs__item__id_tab
    ___ENDCX2SetupRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ENDCX2SetupRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __ENDCX2SetupRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ENDCX2SetupRequest_protocolIEs__item__id),
        ('criticality', ___ENDCX2SetupRequest_protocolIEs__item__criticality),
        ('value', ___ENDCX2SetupRequest_protocolIEs__item__value),
        ])
    __ENDCX2SetupRequest_protocolIEs__item_._ext = None
    _ENDCX2SetupRequest_protocolIEs._cont = __ENDCX2SetupRequest_protocolIEs__item_
    _ENDCX2SetupRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ENDCX2SetupRequest._cont = ASN1Dict([
        ('protocolIEs', _ENDCX2SetupRequest_protocolIEs),
        ])
    ENDCX2SetupRequest._ext = []
    
    #-----< ENDCX2SetupRequest-IEs >-----#
    ENDCX2SetupRequest_IEs = CLASS(name='ENDCX2SetupRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _ENDCX2SetupRequest_IEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'InitiatingNodeType-EndcX2Setup')))
    _ENDCX2SetupRequest_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'InterfaceInstanceIndication')))
    _ENDCX2SetupRequest_IEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TNLConfigurationInfo')))
    ENDCX2SetupRequest_IEs._val = ASN1Set(rv=[dict([('id', 244), ('criticality', 'reject'), ('Value', _ENDCX2SetupRequest_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 335), ('criticality', 'reject'), ('Value', _ENDCX2SetupRequest_IEs_val_Value_1), ('presence', 'optional')]), dict([('id', 352), ('criticality', 'ignore'), ('Value', _ENDCX2SetupRequest_IEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< InitiatingNodeType-EndcX2Setup >-----#
    InitiatingNodeType_EndcX2Setup = CHOICE(name='InitiatingNodeType-EndcX2Setup', mode=MODE_TYPE)
    _InitiatingNodeType_EndcX2Setup_init_eNB = SEQ_OF(name='init-eNB', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __InitiatingNodeType_EndcX2Setup_init_eNB__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___InitiatingNodeType_EndcX2Setup_init_eNB__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____InitiatingNodeType_EndcX2Setup_init_eNB__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____InitiatingNodeType_EndcX2Setup_init_eNB__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GlobalENB-ID')))
    _____InitiatingNodeType_EndcX2Setup_init_eNB__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ServedEUTRAcellsENDCX2ManagementList')))
    _____InitiatingNodeType_EndcX2Setup_init_eNB__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'InterfaceInstanceIndication')))
    _____InitiatingNodeType_EndcX2Setup_init_eNB__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellandCapacityAssistInfo')))
    ____InitiatingNodeType_EndcX2Setup_init_eNB__item__id_tab._val = ASN1Set(rv=[dict([('id', 21), ('criticality', 'reject'), ('Value', _____InitiatingNodeType_EndcX2Setup_init_eNB__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 250), ('criticality', 'reject'), ('Value', _____InitiatingNodeType_EndcX2Setup_init_eNB__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 335), ('criticality', 'reject'), ('Value', _____InitiatingNodeType_EndcX2Setup_init_eNB__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 351), ('criticality', 'ignore'), ('Value', _____InitiatingNodeType_EndcX2Setup_init_eNB__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___InitiatingNodeType_EndcX2Setup_init_eNB__item__id._const_tab = ____InitiatingNodeType_EndcX2Setup_init_eNB__item__id_tab
    ___InitiatingNodeType_EndcX2Setup_init_eNB__item__id._const_tab_at = None
    ___InitiatingNodeType_EndcX2Setup_init_eNB__item__id._const_tab_id = 'id'
    ___InitiatingNodeType_EndcX2Setup_init_eNB__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___InitiatingNodeType_EndcX2Setup_init_eNB__item__criticality._const_tab = ____InitiatingNodeType_EndcX2Setup_init_eNB__item__id_tab
    ___InitiatingNodeType_EndcX2Setup_init_eNB__item__criticality._const_tab_at = ('..', 'id')
    ___InitiatingNodeType_EndcX2Setup_init_eNB__item__criticality._const_tab_id = 'criticality'
    ___InitiatingNodeType_EndcX2Setup_init_eNB__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___InitiatingNodeType_EndcX2Setup_init_eNB__item__value._const_tab = ____InitiatingNodeType_EndcX2Setup_init_eNB__item__id_tab
    ___InitiatingNodeType_EndcX2Setup_init_eNB__item__value._const_tab_at = ('..', 'id')
    ___InitiatingNodeType_EndcX2Setup_init_eNB__item__value._const_tab_id = 'Value'
    __InitiatingNodeType_EndcX2Setup_init_eNB__item_._cont = ASN1Dict([
        ('id', ___InitiatingNodeType_EndcX2Setup_init_eNB__item__id),
        ('criticality', ___InitiatingNodeType_EndcX2Setup_init_eNB__item__criticality),
        ('value', ___InitiatingNodeType_EndcX2Setup_init_eNB__item__value),
        ])
    __InitiatingNodeType_EndcX2Setup_init_eNB__item_._ext = None
    _InitiatingNodeType_EndcX2Setup_init_eNB._cont = __InitiatingNodeType_EndcX2Setup_init_eNB__item_
    _InitiatingNodeType_EndcX2Setup_init_eNB._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _InitiatingNodeType_EndcX2Setup_init_en_gNB = SEQ_OF(name='init-en-gNB', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __InitiatingNodeType_EndcX2Setup_init_en_gNB__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___InitiatingNodeType_EndcX2Setup_init_en_gNB__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____InitiatingNodeType_EndcX2Setup_init_en_gNB__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____InitiatingNodeType_EndcX2Setup_init_en_gNB__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GlobalGNB-ID')))
    _____InitiatingNodeType_EndcX2Setup_init_en_gNB__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ServedNRcellsENDCX2ManagementList')))
    _____InitiatingNodeType_EndcX2Setup_init_en_gNB__item__id_tab_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PartialListIndicator')))
    ____InitiatingNodeType_EndcX2Setup_init_en_gNB__item__id_tab._val = ASN1Set(rv=[dict([('id', 252), ('criticality', 'reject'), ('Value', _____InitiatingNodeType_EndcX2Setup_init_en_gNB__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 253), ('criticality', 'reject'), ('Value', _____InitiatingNodeType_EndcX2Setup_init_en_gNB__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 348), ('criticality', 'ignore'), ('Value', _____InitiatingNodeType_EndcX2Setup_init_en_gNB__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___InitiatingNodeType_EndcX2Setup_init_en_gNB__item__id._const_tab = ____InitiatingNodeType_EndcX2Setup_init_en_gNB__item__id_tab
    ___InitiatingNodeType_EndcX2Setup_init_en_gNB__item__id._const_tab_at = None
    ___InitiatingNodeType_EndcX2Setup_init_en_gNB__item__id._const_tab_id = 'id'
    ___InitiatingNodeType_EndcX2Setup_init_en_gNB__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___InitiatingNodeType_EndcX2Setup_init_en_gNB__item__criticality._const_tab = ____InitiatingNodeType_EndcX2Setup_init_en_gNB__item__id_tab
    ___InitiatingNodeType_EndcX2Setup_init_en_gNB__item__criticality._const_tab_at = ('..', 'id')
    ___InitiatingNodeType_EndcX2Setup_init_en_gNB__item__criticality._const_tab_id = 'criticality'
    ___InitiatingNodeType_EndcX2Setup_init_en_gNB__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___InitiatingNodeType_EndcX2Setup_init_en_gNB__item__value._const_tab = ____InitiatingNodeType_EndcX2Setup_init_en_gNB__item__id_tab
    ___InitiatingNodeType_EndcX2Setup_init_en_gNB__item__value._const_tab_at = ('..', 'id')
    ___InitiatingNodeType_EndcX2Setup_init_en_gNB__item__value._const_tab_id = 'Value'
    __InitiatingNodeType_EndcX2Setup_init_en_gNB__item_._cont = ASN1Dict([
        ('id', ___InitiatingNodeType_EndcX2Setup_init_en_gNB__item__id),
        ('criticality', ___InitiatingNodeType_EndcX2Setup_init_en_gNB__item__criticality),
        ('value', ___InitiatingNodeType_EndcX2Setup_init_en_gNB__item__value),
        ])
    __InitiatingNodeType_EndcX2Setup_init_en_gNB__item_._ext = None
    _InitiatingNodeType_EndcX2Setup_init_en_gNB._cont = __InitiatingNodeType_EndcX2Setup_init_en_gNB__item_
    _InitiatingNodeType_EndcX2Setup_init_en_gNB._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    InitiatingNodeType_EndcX2Setup._cont = ASN1Dict([
        ('init-eNB', _InitiatingNodeType_EndcX2Setup_init_eNB),
        ('init-en-gNB', _InitiatingNodeType_EndcX2Setup_init_en_gNB),
        ])
    InitiatingNodeType_EndcX2Setup._ext = []
    
    #-----< ENB-ENDCX2SetupReqIEs >-----#
    ENB_ENDCX2SetupReqIEs = CLASS(name='ENB-ENDCX2SetupReqIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _ENB_ENDCX2SetupReqIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GlobalENB-ID')))
    _ENB_ENDCX2SetupReqIEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ServedEUTRAcellsENDCX2ManagementList')))
    _ENB_ENDCX2SetupReqIEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'InterfaceInstanceIndication')))
    _ENB_ENDCX2SetupReqIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellandCapacityAssistInfo')))
    ENB_ENDCX2SetupReqIEs._val = ASN1Set(rv=[dict([('id', 21), ('criticality', 'reject'), ('Value', _ENB_ENDCX2SetupReqIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 250), ('criticality', 'reject'), ('Value', _ENB_ENDCX2SetupReqIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 335), ('criticality', 'reject'), ('Value', _ENB_ENDCX2SetupReqIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 351), ('criticality', 'ignore'), ('Value', _ENB_ENDCX2SetupReqIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ServedEUTRAcellsENDCX2ManagementList >-----#
    ServedEUTRAcellsENDCX2ManagementList = SEQ_OF(name='ServedEUTRAcellsENDCX2ManagementList', mode=MODE_TYPE)
    _ServedEUTRAcellsENDCX2ManagementList__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __ServedEUTRAcellsENDCX2ManagementList__item__servedEUTRACellInfo = SEQ(name='servedEUTRACellInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ServedCell-Information')))
    __ServedEUTRAcellsENDCX2ManagementList__item__nrNeighbourInfo = SEQ_OF(name='nrNeighbourInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'NRNeighbour-Information')), opt=True)
    __ServedEUTRAcellsENDCX2ManagementList__item__iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___ServedEUTRAcellsENDCX2ManagementList__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ____ServedEUTRAcellsENDCX2ManagementList__item__iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    _____ServedEUTRAcellsENDCX2ManagementList__item__iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____ServedEUTRAcellsENDCX2ManagementList__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____ServedEUTRAcellsENDCX2ManagementList__item__iE_Extensions__item__id._const_tab = _____ServedEUTRAcellsENDCX2ManagementList__item__iE_Extensions__item__id_tab
    ____ServedEUTRAcellsENDCX2ManagementList__item__iE_Extensions__item__id._const_tab_at = None
    ____ServedEUTRAcellsENDCX2ManagementList__item__iE_Extensions__item__id._const_tab_id = 'id'
    ____ServedEUTRAcellsENDCX2ManagementList__item__iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    _____ServedEUTRAcellsENDCX2ManagementList__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____ServedEUTRAcellsENDCX2ManagementList__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____ServedEUTRAcellsENDCX2ManagementList__item__iE_Extensions__item__criticality._const_tab = _____ServedEUTRAcellsENDCX2ManagementList__item__iE_Extensions__item__criticality_tab
    ____ServedEUTRAcellsENDCX2ManagementList__item__iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____ServedEUTRAcellsENDCX2ManagementList__item__iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____ServedEUTRAcellsENDCX2ManagementList__item__iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    _____ServedEUTRAcellsENDCX2ManagementList__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____ServedEUTRAcellsENDCX2ManagementList__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____ServedEUTRAcellsENDCX2ManagementList__item__iE_Extensions__item__extensionValue._const_tab = _____ServedEUTRAcellsENDCX2ManagementList__item__iE_Extensions__item__extensionValue_tab
    ____ServedEUTRAcellsENDCX2ManagementList__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____ServedEUTRAcellsENDCX2ManagementList__item__iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___ServedEUTRAcellsENDCX2ManagementList__item__iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____ServedEUTRAcellsENDCX2ManagementList__item__iE_Extensions__item__id),
        ('criticality', ____ServedEUTRAcellsENDCX2ManagementList__item__iE_Extensions__item__criticality),
        ('extensionValue', ____ServedEUTRAcellsENDCX2ManagementList__item__iE_Extensions__item__extensionValue),
        ])
    ___ServedEUTRAcellsENDCX2ManagementList__item__iE_Extensions__item_._ext = None
    __ServedEUTRAcellsENDCX2ManagementList__item__iE_Extensions._cont = ___ServedEUTRAcellsENDCX2ManagementList__item__iE_Extensions__item_
    __ServedEUTRAcellsENDCX2ManagementList__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _ServedEUTRAcellsENDCX2ManagementList__item_._cont = ASN1Dict([
        ('servedEUTRACellInfo', __ServedEUTRAcellsENDCX2ManagementList__item__servedEUTRACellInfo),
        ('nrNeighbourInfo', __ServedEUTRAcellsENDCX2ManagementList__item__nrNeighbourInfo),
        ('iE-Extensions', __ServedEUTRAcellsENDCX2ManagementList__item__iE_Extensions),
        ])
    _ServedEUTRAcellsENDCX2ManagementList__item_._ext = []
    ServedEUTRAcellsENDCX2ManagementList._cont = _ServedEUTRAcellsENDCX2ManagementList__item_
    ServedEUTRAcellsENDCX2ManagementList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< ServedEUTRAcellsENDCX2Management-ExtIEs >-----#
    ServedEUTRAcellsENDCX2Management_ExtIEs = CLASS(name='ServedEUTRAcellsENDCX2Management-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ServedEUTRAcellsENDCX2Management_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< En-gNB-ENDCX2SetupReqIEs >-----#
    En_gNB_ENDCX2SetupReqIEs = CLASS(name='En-gNB-ENDCX2SetupReqIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _En_gNB_ENDCX2SetupReqIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GlobalGNB-ID')))
    _En_gNB_ENDCX2SetupReqIEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ServedNRcellsENDCX2ManagementList')))
    _En_gNB_ENDCX2SetupReqIEs_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PartialListIndicator')))
    En_gNB_ENDCX2SetupReqIEs._val = ASN1Set(rv=[dict([('id', 252), ('criticality', 'reject'), ('Value', _En_gNB_ENDCX2SetupReqIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 253), ('criticality', 'reject'), ('Value', _En_gNB_ENDCX2SetupReqIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 348), ('criticality', 'ignore'), ('Value', _En_gNB_ENDCX2SetupReqIEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ServedNRcellsENDCX2ManagementList >-----#
    ServedNRcellsENDCX2ManagementList = SEQ_OF(name='ServedNRcellsENDCX2ManagementList', mode=MODE_TYPE)
    _ServedNRcellsENDCX2ManagementList__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __ServedNRcellsENDCX2ManagementList__item__servedNRCellInfo = SEQ(name='servedNRCellInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'ServedNRCell-Information')))
    __ServedNRcellsENDCX2ManagementList__item__nRNeighbourInfo = SEQ_OF(name='nRNeighbourInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'NRNeighbour-Information')), opt=True)
    __ServedNRcellsENDCX2ManagementList__item__iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___ServedNRcellsENDCX2ManagementList__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ____ServedNRcellsENDCX2ManagementList__item__iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    _____ServedNRcellsENDCX2ManagementList__item__iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ______ServedNRcellsENDCX2ManagementList__item__iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ServedCellSpecificInfoReq-NR')))
    _____ServedNRcellsENDCX2ManagementList__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 434), ('criticality', 'ignore'), ('Extension', ______ServedNRcellsENDCX2ManagementList__item__iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ____ServedNRcellsENDCX2ManagementList__item__iE_Extensions__item__id._const_tab = _____ServedNRcellsENDCX2ManagementList__item__iE_Extensions__item__id_tab
    ____ServedNRcellsENDCX2ManagementList__item__iE_Extensions__item__id._const_tab_at = None
    ____ServedNRcellsENDCX2ManagementList__item__iE_Extensions__item__id._const_tab_id = 'id'
    ____ServedNRcellsENDCX2ManagementList__item__iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ServedNRcellsENDCX2ManagementList__item__iE_Extensions__item__criticality._const_tab = _____ServedNRcellsENDCX2ManagementList__item__iE_Extensions__item__id_tab
    ____ServedNRcellsENDCX2ManagementList__item__iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____ServedNRcellsENDCX2ManagementList__item__iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____ServedNRcellsENDCX2ManagementList__item__iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ServedNRcellsENDCX2ManagementList__item__iE_Extensions__item__extensionValue._const_tab = _____ServedNRcellsENDCX2ManagementList__item__iE_Extensions__item__id_tab
    ____ServedNRcellsENDCX2ManagementList__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____ServedNRcellsENDCX2ManagementList__item__iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___ServedNRcellsENDCX2ManagementList__item__iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____ServedNRcellsENDCX2ManagementList__item__iE_Extensions__item__id),
        ('criticality', ____ServedNRcellsENDCX2ManagementList__item__iE_Extensions__item__criticality),
        ('extensionValue', ____ServedNRcellsENDCX2ManagementList__item__iE_Extensions__item__extensionValue),
        ])
    ___ServedNRcellsENDCX2ManagementList__item__iE_Extensions__item_._ext = None
    __ServedNRcellsENDCX2ManagementList__item__iE_Extensions._cont = ___ServedNRcellsENDCX2ManagementList__item__iE_Extensions__item_
    __ServedNRcellsENDCX2ManagementList__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _ServedNRcellsENDCX2ManagementList__item_._cont = ASN1Dict([
        ('servedNRCellInfo', __ServedNRcellsENDCX2ManagementList__item__servedNRCellInfo),
        ('nRNeighbourInfo', __ServedNRcellsENDCX2ManagementList__item__nRNeighbourInfo),
        ('iE-Extensions', __ServedNRcellsENDCX2ManagementList__item__iE_Extensions),
        ])
    _ServedNRcellsENDCX2ManagementList__item_._ext = []
    ServedNRcellsENDCX2ManagementList._cont = _ServedNRcellsENDCX2ManagementList__item_
    ServedNRcellsENDCX2ManagementList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16384)], ev=None, er=[])
    
    #-----< En-gNBServedCells-ExtIEs >-----#
    En_gNBServedCells_ExtIEs = CLASS(name='En-gNBServedCells-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _En_gNBServedCells_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ServedCellSpecificInfoReq-NR')))
    En_gNBServedCells_ExtIEs._val = ASN1Set(rv=[dict([('id', 434), ('criticality', 'ignore'), ('Extension', _En_gNBServedCells_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ServedNRCell-Information >-----#
    ServedNRCell_Information = SEQ(name='ServedNRCell-Information', mode=MODE_TYPE)
    _ServedNRCell_Information_nrpCI = INT(name='nrpCI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'NRPCI')))
    _ServedNRCell_Information_nrCellID = SEQ(name='nrCellID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'NRCGI')))
    _ServedNRCell_Information_fiveGS_TAC = OCT_STR(name='fiveGS-TAC', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'FiveGS-TAC')), opt=True)
    _ServedNRCell_Information_configured_TAC = OCT_STR(name='configured-TAC', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'TAC')), opt=True)
    _ServedNRCell_Information_broadcastPLMNs = SEQ_OF(name='broadcastPLMNs', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'BroadcastPLMNs-Item')))
    _ServedNRCell_Information_nrModeInfo = CHOICE(name='nrModeInfo', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __ServedNRCell_Information_nrModeInfo_fdd = SEQ(name='fdd', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'FDD-InfoServedNRCell-Information')))
    __ServedNRCell_Information_nrModeInfo_tdd = SEQ(name='tdd', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'TDD-InfoServedNRCell-Information')))
    _ServedNRCell_Information_nrModeInfo._cont = ASN1Dict([
        ('fdd', __ServedNRCell_Information_nrModeInfo_fdd),
        ('tdd', __ServedNRCell_Information_nrModeInfo_tdd),
        ])
    _ServedNRCell_Information_nrModeInfo._ext = []
    _ServedNRCell_Information_measurementTimingConfiguration = OCT_STR(name='measurementTimingConfiguration', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ServedNRCell_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ServedNRCell_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___ServedNRCell_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____ServedNRCell_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____ServedNRCell_Information_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'AdditionalPLMNs-Item')))
    _____ServedNRCell_Information_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'BPLMN-ID-Info-NR')))
    _____ServedNRCell_Information_iE_Extensions__item__id_tab_val_Extension_2 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SSB-PositionsInBurst')))
    _____ServedNRCell_Information_iE_Extensions__item__id_tab_val_Extension_3 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'NRCellPRACHConfig')))
    _____ServedNRCell_Information_iE_Extensions__item__id_tab_val_Extension_4 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CSI-RSTransmissionIndication')))
    _____ServedNRCell_Information_iE_Extensions__item__id_tab_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SFN-Offset')))
    _____ServedNRCell_Information_iE_Extensions__item__id_tab_val_Extension_6 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Additional-Measurement-Timing-Configuration-List')))
    ____ServedNRCell_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 334), ('criticality', 'ignore'), ('Extension', _____ServedNRCell_Information_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 337), ('criticality', 'ignore'), ('Extension', _____ServedNRCell_Information_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 389), ('criticality', 'ignore'), ('Extension', _____ServedNRCell_Information_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 390), ('criticality', 'ignore'), ('Extension', _____ServedNRCell_Information_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 380), ('criticality', 'ignore'), ('Extension', _____ServedNRCell_Information_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 406), ('criticality', 'ignore'), ('Extension', _____ServedNRCell_Information_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')]), dict([('id', 433), ('criticality', 'ignore'), ('Extension', _____ServedNRCell_Information_iE_Extensions__item__id_tab_val_Extension_6), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ServedNRCell_Information_iE_Extensions__item__id._const_tab = ____ServedNRCell_Information_iE_Extensions__item__id_tab
    ___ServedNRCell_Information_iE_Extensions__item__id._const_tab_at = None
    ___ServedNRCell_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___ServedNRCell_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___ServedNRCell_Information_iE_Extensions__item__criticality._const_tab = ____ServedNRCell_Information_iE_Extensions__item__id_tab
    ___ServedNRCell_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ServedNRCell_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ServedNRCell_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___ServedNRCell_Information_iE_Extensions__item__extensionValue._const_tab = ____ServedNRCell_Information_iE_Extensions__item__id_tab
    ___ServedNRCell_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ServedNRCell_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ServedNRCell_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ServedNRCell_Information_iE_Extensions__item__id),
        ('criticality', ___ServedNRCell_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___ServedNRCell_Information_iE_Extensions__item__extensionValue),
        ])
    __ServedNRCell_Information_iE_Extensions__item_._ext = None
    _ServedNRCell_Information_iE_Extensions._cont = __ServedNRCell_Information_iE_Extensions__item_
    _ServedNRCell_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ServedNRCell_Information._cont = ASN1Dict([
        ('nrpCI', _ServedNRCell_Information_nrpCI),
        ('nrCellID', _ServedNRCell_Information_nrCellID),
        ('fiveGS-TAC', _ServedNRCell_Information_fiveGS_TAC),
        ('configured-TAC', _ServedNRCell_Information_configured_TAC),
        ('broadcastPLMNs', _ServedNRCell_Information_broadcastPLMNs),
        ('nrModeInfo', _ServedNRCell_Information_nrModeInfo),
        ('measurementTimingConfiguration', _ServedNRCell_Information_measurementTimingConfiguration),
        ('iE-Extensions', _ServedNRCell_Information_iE_Extensions),
        ])
    ServedNRCell_Information._ext = []
    
    #-----< ServedNRCell-Information-ExtIEs >-----#
    ServedNRCell_Information_ExtIEs = CLASS(name='ServedNRCell-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _ServedNRCell_Information_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'AdditionalPLMNs-Item')))
    _ServedNRCell_Information_ExtIEs_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'BPLMN-ID-Info-NR')))
    _ServedNRCell_Information_ExtIEs_val_Extension_2 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SSB-PositionsInBurst')))
    _ServedNRCell_Information_ExtIEs_val_Extension_3 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'NRCellPRACHConfig')))
    _ServedNRCell_Information_ExtIEs_val_Extension_4 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CSI-RSTransmissionIndication')))
    _ServedNRCell_Information_ExtIEs_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SFN-Offset')))
    _ServedNRCell_Information_ExtIEs_val_Extension_6 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Additional-Measurement-Timing-Configuration-List')))
    ServedNRCell_Information_ExtIEs._val = ASN1Set(rv=[dict([('id', 334), ('criticality', 'ignore'), ('Extension', _ServedNRCell_Information_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 337), ('criticality', 'ignore'), ('Extension', _ServedNRCell_Information_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 389), ('criticality', 'ignore'), ('Extension', _ServedNRCell_Information_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 390), ('criticality', 'ignore'), ('Extension', _ServedNRCell_Information_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 380), ('criticality', 'ignore'), ('Extension', _ServedNRCell_Information_ExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 406), ('criticality', 'ignore'), ('Extension', _ServedNRCell_Information_ExtIEs_val_Extension_5), ('presence', 'optional')]), dict([('id', 433), ('criticality', 'ignore'), ('Extension', _ServedNRCell_Information_ExtIEs_val_Extension_6), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< FDD-InfoServedNRCell-Information >-----#
    FDD_InfoServedNRCell_Information = SEQ(name='FDD-InfoServedNRCell-Information', mode=MODE_TYPE)
    _FDD_InfoServedNRCell_Information_ul_NRFreqInfo = SEQ(name='ul-NRFreqInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'NRFreqInfo')))
    _FDD_InfoServedNRCell_Information_dl_NRFreqInfo = SEQ(name='dl-NRFreqInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'NRFreqInfo')))
    _FDD_InfoServedNRCell_Information_ul_NR_TxBW = SEQ(name='ul-NR-TxBW', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'NR-TxBW')))
    _FDD_InfoServedNRCell_Information_dl_NR_TxBW = SEQ(name='dl-NR-TxBW', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'NR-TxBW')))
    _FDD_InfoServedNRCell_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __FDD_InfoServedNRCell_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___FDD_InfoServedNRCell_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____FDD_InfoServedNRCell_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____FDD_InfoServedNRCell_Information_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'NRCarrierList')))
    _____FDD_InfoServedNRCell_Information_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'NRCarrierList')))
    ____FDD_InfoServedNRCell_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 387), ('criticality', 'ignore'), ('Extension', _____FDD_InfoServedNRCell_Information_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 381), ('criticality', 'ignore'), ('Extension', _____FDD_InfoServedNRCell_Information_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___FDD_InfoServedNRCell_Information_iE_Extensions__item__id._const_tab = ____FDD_InfoServedNRCell_Information_iE_Extensions__item__id_tab
    ___FDD_InfoServedNRCell_Information_iE_Extensions__item__id._const_tab_at = None
    ___FDD_InfoServedNRCell_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___FDD_InfoServedNRCell_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___FDD_InfoServedNRCell_Information_iE_Extensions__item__criticality._const_tab = ____FDD_InfoServedNRCell_Information_iE_Extensions__item__id_tab
    ___FDD_InfoServedNRCell_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___FDD_InfoServedNRCell_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___FDD_InfoServedNRCell_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___FDD_InfoServedNRCell_Information_iE_Extensions__item__extensionValue._const_tab = ____FDD_InfoServedNRCell_Information_iE_Extensions__item__id_tab
    ___FDD_InfoServedNRCell_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___FDD_InfoServedNRCell_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __FDD_InfoServedNRCell_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___FDD_InfoServedNRCell_Information_iE_Extensions__item__id),
        ('criticality', ___FDD_InfoServedNRCell_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___FDD_InfoServedNRCell_Information_iE_Extensions__item__extensionValue),
        ])
    __FDD_InfoServedNRCell_Information_iE_Extensions__item_._ext = None
    _FDD_InfoServedNRCell_Information_iE_Extensions._cont = __FDD_InfoServedNRCell_Information_iE_Extensions__item_
    _FDD_InfoServedNRCell_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    FDD_InfoServedNRCell_Information._cont = ASN1Dict([
        ('ul-NRFreqInfo', _FDD_InfoServedNRCell_Information_ul_NRFreqInfo),
        ('dl-NRFreqInfo', _FDD_InfoServedNRCell_Information_dl_NRFreqInfo),
        ('ul-NR-TxBW', _FDD_InfoServedNRCell_Information_ul_NR_TxBW),
        ('dl-NR-TxBW', _FDD_InfoServedNRCell_Information_dl_NR_TxBW),
        ('iE-Extensions', _FDD_InfoServedNRCell_Information_iE_Extensions),
        ])
    FDD_InfoServedNRCell_Information._ext = []
    
    #-----< FDD-InfoServedNRCell-Information-ExtIEs >-----#
    FDD_InfoServedNRCell_Information_ExtIEs = CLASS(name='FDD-InfoServedNRCell-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _FDD_InfoServedNRCell_Information_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'NRCarrierList')))
    _FDD_InfoServedNRCell_Information_ExtIEs_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'NRCarrierList')))
    FDD_InfoServedNRCell_Information_ExtIEs._val = ASN1Set(rv=[dict([('id', 387), ('criticality', 'ignore'), ('Extension', _FDD_InfoServedNRCell_Information_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 381), ('criticality', 'ignore'), ('Extension', _FDD_InfoServedNRCell_Information_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< TDD-InfoServedNRCell-Information >-----#
    TDD_InfoServedNRCell_Information = SEQ(name='TDD-InfoServedNRCell-Information', mode=MODE_TYPE)
    _TDD_InfoServedNRCell_Information_nRFreqInfo = SEQ(name='nRFreqInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'NRFreqInfo')))
    _TDD_InfoServedNRCell_Information_nR_TxBW = SEQ(name='nR-TxBW', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'NR-TxBW')))
    _TDD_InfoServedNRCell_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TDD_InfoServedNRCell_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___TDD_InfoServedNRCell_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____TDD_InfoServedNRCell_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____TDD_InfoServedNRCell_Information_iE_Extensions__item__id_tab_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TDDULDLConfigurationCommonNR')))
    _____TDD_InfoServedNRCell_Information_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'NRCarrierList')))
    _____TDD_InfoServedNRCell_Information_iE_Extensions__item__id_tab_val_Extension_2 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'IntendedTDD-DL-ULConfiguration-NR')))
    ____TDD_InfoServedNRCell_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 385), ('criticality', 'ignore'), ('Extension', _____TDD_InfoServedNRCell_Information_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 386), ('criticality', 'ignore'), ('Extension', _____TDD_InfoServedNRCell_Information_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 399), ('criticality', 'ignore'), ('Extension', _____TDD_InfoServedNRCell_Information_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___TDD_InfoServedNRCell_Information_iE_Extensions__item__id._const_tab = ____TDD_InfoServedNRCell_Information_iE_Extensions__item__id_tab
    ___TDD_InfoServedNRCell_Information_iE_Extensions__item__id._const_tab_at = None
    ___TDD_InfoServedNRCell_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___TDD_InfoServedNRCell_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ___TDD_InfoServedNRCell_Information_iE_Extensions__item__criticality._const_tab = ____TDD_InfoServedNRCell_Information_iE_Extensions__item__id_tab
    ___TDD_InfoServedNRCell_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TDD_InfoServedNRCell_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TDD_InfoServedNRCell_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ___TDD_InfoServedNRCell_Information_iE_Extensions__item__extensionValue._const_tab = ____TDD_InfoServedNRCell_Information_iE_Extensions__item__id_tab
    ___TDD_InfoServedNRCell_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TDD_InfoServedNRCell_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TDD_InfoServedNRCell_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TDD_InfoServedNRCell_Information_iE_Extensions__item__id),
        ('criticality', ___TDD_InfoServedNRCell_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___TDD_InfoServedNRCell_Information_iE_Extensions__item__extensionValue),
        ])
    __TDD_InfoServedNRCell_Information_iE_Extensions__item_._ext = None
    _TDD_InfoServedNRCell_Information_iE_Extensions._cont = __TDD_InfoServedNRCell_Information_iE_Extensions__item_
    _TDD_InfoServedNRCell_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TDD_InfoServedNRCell_Information._cont = ASN1Dict([
        ('nRFreqInfo', _TDD_InfoServedNRCell_Information_nRFreqInfo),
        ('nR-TxBW', _TDD_InfoServedNRCell_Information_nR_TxBW),
        ('iE-Extensions', _TDD_InfoServedNRCell_Information_iE_Extensions),
        ])
    TDD_InfoServedNRCell_Information._ext = []
    
    #-----< TDD-InfoServedNRCell-Information-ExtIEs >-----#
    TDD_InfoServedNRCell_Information_ExtIEs = CLASS(name='TDD-InfoServedNRCell-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _TDD_InfoServedNRCell_Information_ExtIEs_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TDDULDLConfigurationCommonNR')))
    _TDD_InfoServedNRCell_Information_ExtIEs_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'NRCarrierList')))
    _TDD_InfoServedNRCell_Information_ExtIEs_val_Extension_2 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'IntendedTDD-DL-ULConfiguration-NR')))
    TDD_InfoServedNRCell_Information_ExtIEs._val = ASN1Set(rv=[dict([('id', 385), ('criticality', 'ignore'), ('Extension', _TDD_InfoServedNRCell_Information_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 386), ('criticality', 'ignore'), ('Extension', _TDD_InfoServedNRCell_Information_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 399), ('criticality', 'ignore'), ('Extension', _TDD_InfoServedNRCell_Information_ExtIEs_val_Extension_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< CellandCapacityAssistInfo >-----#
    CellandCapacityAssistInfo = SEQ(name='CellandCapacityAssistInfo', mode=MODE_TYPE)
    _CellandCapacityAssistInfo_maximumCellListSize = INT(name='maximumCellListSize', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'MaximumCellListSize')), opt=True)
    _CellandCapacityAssistInfo_cellAssistanceInformation = CHOICE(name='cellAssistanceInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellAssistanceInformation')), opt=True)
    _CellandCapacityAssistInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellandCapacityAssistInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___CellandCapacityAssistInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____CellandCapacityAssistInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CellandCapacityAssistInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellandCapacityAssistInfo_iE_Extensions__item__id._const_tab = ____CellandCapacityAssistInfo_iE_Extensions__item__id_tab
    ___CellandCapacityAssistInfo_iE_Extensions__item__id._const_tab_at = None
    ___CellandCapacityAssistInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___CellandCapacityAssistInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CellandCapacityAssistInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CellandCapacityAssistInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellandCapacityAssistInfo_iE_Extensions__item__criticality._const_tab = ____CellandCapacityAssistInfo_iE_Extensions__item__criticality_tab
    ___CellandCapacityAssistInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CellandCapacityAssistInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CellandCapacityAssistInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CellandCapacityAssistInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CellandCapacityAssistInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellandCapacityAssistInfo_iE_Extensions__item__extensionValue._const_tab = ____CellandCapacityAssistInfo_iE_Extensions__item__extensionValue_tab
    ___CellandCapacityAssistInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellandCapacityAssistInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CellandCapacityAssistInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CellandCapacityAssistInfo_iE_Extensions__item__id),
        ('criticality', ___CellandCapacityAssistInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___CellandCapacityAssistInfo_iE_Extensions__item__extensionValue),
        ])
    __CellandCapacityAssistInfo_iE_Extensions__item_._ext = None
    _CellandCapacityAssistInfo_iE_Extensions._cont = __CellandCapacityAssistInfo_iE_Extensions__item_
    _CellandCapacityAssistInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellandCapacityAssistInfo._cont = ASN1Dict([
        ('maximumCellListSize', _CellandCapacityAssistInfo_maximumCellListSize),
        ('cellAssistanceInformation', _CellandCapacityAssistInfo_cellAssistanceInformation),
        ('iE-Extensions', _CellandCapacityAssistInfo_iE_Extensions),
        ])
    CellandCapacityAssistInfo._ext = []
    
    #-----< CellandCapacityAssistInfo-ExtIEs >-----#
    CellandCapacityAssistInfo_ExtIEs = CLASS(name='CellandCapacityAssistInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    CellandCapacityAssistInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellAssistanceInformation >-----#
    CellAssistanceInformation = CHOICE(name='CellAssistanceInformation', mode=MODE_TYPE)
    _CellAssistanceInformation_limited_list = SEQ_OF(name='limited-list', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'Limited-list')))
    _CellAssistanceInformation_full_list = ENUM(name='full-list', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CellAssistanceInformation_full_list._cont = ASN1Dict([('allServedNRcells', 0)])
    _CellAssistanceInformation_full_list._ext = []
    CellAssistanceInformation._cont = ASN1Dict([
        ('limited-list', _CellAssistanceInformation_limited_list),
        ('full-list', _CellAssistanceInformation_full_list),
        ])
    CellAssistanceInformation._ext = []
    
    #-----< Limited-list >-----#
    Limited_list = SEQ_OF(name='Limited-list', mode=MODE_TYPE)
    _Limited_list__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __Limited_list__item__nrCellID = SEQ(name='nrCellID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'NRCGI')))
    __Limited_list__item__iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___Limited_list__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ____Limited_list__item__iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    _____Limited_list__item__iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____Limited_list__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____Limited_list__item__iE_Extensions__item__id._const_tab = _____Limited_list__item__iE_Extensions__item__id_tab
    ____Limited_list__item__iE_Extensions__item__id._const_tab_at = None
    ____Limited_list__item__iE_Extensions__item__id._const_tab_id = 'id'
    ____Limited_list__item__iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    _____Limited_list__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____Limited_list__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____Limited_list__item__iE_Extensions__item__criticality._const_tab = _____Limited_list__item__iE_Extensions__item__criticality_tab
    ____Limited_list__item__iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____Limited_list__item__iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____Limited_list__item__iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    _____Limited_list__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____Limited_list__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____Limited_list__item__iE_Extensions__item__extensionValue._const_tab = _____Limited_list__item__iE_Extensions__item__extensionValue_tab
    ____Limited_list__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____Limited_list__item__iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___Limited_list__item__iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____Limited_list__item__iE_Extensions__item__id),
        ('criticality', ____Limited_list__item__iE_Extensions__item__criticality),
        ('extensionValue', ____Limited_list__item__iE_Extensions__item__extensionValue),
        ])
    ___Limited_list__item__iE_Extensions__item_._ext = None
    __Limited_list__item__iE_Extensions._cont = ___Limited_list__item__iE_Extensions__item_
    __Limited_list__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _Limited_list__item_._cont = ASN1Dict([
        ('nrCellID', __Limited_list__item__nrCellID),
        ('iE-Extensions', __Limited_list__item__iE_Extensions),
        ])
    _Limited_list__item_._ext = []
    Limited_list._cont = _Limited_list__item_
    Limited_list._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16384)], ev=None, er=[])
    
    #-----< Limited-list-ExtIEs >-----#
    Limited_list_ExtIEs = CLASS(name='Limited-list-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    Limited_list_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ENDCX2SetupResponse >-----#
    ENDCX2SetupResponse = SEQ(name='ENDCX2SetupResponse', mode=MODE_TYPE)
    _ENDCX2SetupResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __ENDCX2SetupResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___ENDCX2SetupResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____ENDCX2SetupResponse_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____ENDCX2SetupResponse_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'RespondingNodeType-EndcX2Setup')))
    _____ENDCX2SetupResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'InterfaceInstanceIndication')))
    _____ENDCX2SetupResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TNLConfigurationInfo')))
    ____ENDCX2SetupResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 246), ('criticality', 'reject'), ('Value', _____ENDCX2SetupResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 335), ('criticality', 'reject'), ('Value', _____ENDCX2SetupResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 352), ('criticality', 'ignore'), ('Value', _____ENDCX2SetupResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ENDCX2SetupResponse_protocolIEs__item__id._const_tab = ____ENDCX2SetupResponse_protocolIEs__item__id_tab
    ___ENDCX2SetupResponse_protocolIEs__item__id._const_tab_at = None
    ___ENDCX2SetupResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___ENDCX2SetupResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___ENDCX2SetupResponse_protocolIEs__item__criticality._const_tab = ____ENDCX2SetupResponse_protocolIEs__item__id_tab
    ___ENDCX2SetupResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ENDCX2SetupResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ENDCX2SetupResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___ENDCX2SetupResponse_protocolIEs__item__value._const_tab = ____ENDCX2SetupResponse_protocolIEs__item__id_tab
    ___ENDCX2SetupResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ENDCX2SetupResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __ENDCX2SetupResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ENDCX2SetupResponse_protocolIEs__item__id),
        ('criticality', ___ENDCX2SetupResponse_protocolIEs__item__criticality),
        ('value', ___ENDCX2SetupResponse_protocolIEs__item__value),
        ])
    __ENDCX2SetupResponse_protocolIEs__item_._ext = None
    _ENDCX2SetupResponse_protocolIEs._cont = __ENDCX2SetupResponse_protocolIEs__item_
    _ENDCX2SetupResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ENDCX2SetupResponse._cont = ASN1Dict([
        ('protocolIEs', _ENDCX2SetupResponse_protocolIEs),
        ])
    ENDCX2SetupResponse._ext = []
    
    #-----< ENDCX2SetupResponse-IEs >-----#
    ENDCX2SetupResponse_IEs = CLASS(name='ENDCX2SetupResponse-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _ENDCX2SetupResponse_IEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'RespondingNodeType-EndcX2Setup')))
    _ENDCX2SetupResponse_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'InterfaceInstanceIndication')))
    _ENDCX2SetupResponse_IEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TNLConfigurationInfo')))
    ENDCX2SetupResponse_IEs._val = ASN1Set(rv=[dict([('id', 246), ('criticality', 'reject'), ('Value', _ENDCX2SetupResponse_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 335), ('criticality', 'reject'), ('Value', _ENDCX2SetupResponse_IEs_val_Value_1), ('presence', 'optional')]), dict([('id', 352), ('criticality', 'ignore'), ('Value', _ENDCX2SetupResponse_IEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RespondingNodeType-EndcX2Setup >-----#
    RespondingNodeType_EndcX2Setup = CHOICE(name='RespondingNodeType-EndcX2Setup', mode=MODE_TYPE)
    _RespondingNodeType_EndcX2Setup_respond_eNB = SEQ_OF(name='respond-eNB', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __RespondingNodeType_EndcX2Setup_respond_eNB__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___RespondingNodeType_EndcX2Setup_respond_eNB__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____RespondingNodeType_EndcX2Setup_respond_eNB__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____RespondingNodeType_EndcX2Setup_respond_eNB__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GlobalENB-ID')))
    _____RespondingNodeType_EndcX2Setup_respond_eNB__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ServedEUTRAcellsENDCX2ManagementList')))
    _____RespondingNodeType_EndcX2Setup_respond_eNB__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'InterfaceInstanceIndication')))
    _____RespondingNodeType_EndcX2Setup_respond_eNB__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellandCapacityAssistInfo')))
    ____RespondingNodeType_EndcX2Setup_respond_eNB__item__id_tab._val = ASN1Set(rv=[dict([('id', 21), ('criticality', 'reject'), ('Value', _____RespondingNodeType_EndcX2Setup_respond_eNB__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 250), ('criticality', 'reject'), ('Value', _____RespondingNodeType_EndcX2Setup_respond_eNB__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 335), ('criticality', 'reject'), ('Value', _____RespondingNodeType_EndcX2Setup_respond_eNB__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 351), ('criticality', 'ignore'), ('Value', _____RespondingNodeType_EndcX2Setup_respond_eNB__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RespondingNodeType_EndcX2Setup_respond_eNB__item__id._const_tab = ____RespondingNodeType_EndcX2Setup_respond_eNB__item__id_tab
    ___RespondingNodeType_EndcX2Setup_respond_eNB__item__id._const_tab_at = None
    ___RespondingNodeType_EndcX2Setup_respond_eNB__item__id._const_tab_id = 'id'
    ___RespondingNodeType_EndcX2Setup_respond_eNB__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___RespondingNodeType_EndcX2Setup_respond_eNB__item__criticality._const_tab = ____RespondingNodeType_EndcX2Setup_respond_eNB__item__id_tab
    ___RespondingNodeType_EndcX2Setup_respond_eNB__item__criticality._const_tab_at = ('..', 'id')
    ___RespondingNodeType_EndcX2Setup_respond_eNB__item__criticality._const_tab_id = 'criticality'
    ___RespondingNodeType_EndcX2Setup_respond_eNB__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___RespondingNodeType_EndcX2Setup_respond_eNB__item__value._const_tab = ____RespondingNodeType_EndcX2Setup_respond_eNB__item__id_tab
    ___RespondingNodeType_EndcX2Setup_respond_eNB__item__value._const_tab_at = ('..', 'id')
    ___RespondingNodeType_EndcX2Setup_respond_eNB__item__value._const_tab_id = 'Value'
    __RespondingNodeType_EndcX2Setup_respond_eNB__item_._cont = ASN1Dict([
        ('id', ___RespondingNodeType_EndcX2Setup_respond_eNB__item__id),
        ('criticality', ___RespondingNodeType_EndcX2Setup_respond_eNB__item__criticality),
        ('value', ___RespondingNodeType_EndcX2Setup_respond_eNB__item__value),
        ])
    __RespondingNodeType_EndcX2Setup_respond_eNB__item_._ext = None
    _RespondingNodeType_EndcX2Setup_respond_eNB._cont = __RespondingNodeType_EndcX2Setup_respond_eNB__item_
    _RespondingNodeType_EndcX2Setup_respond_eNB._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RespondingNodeType_EndcX2Setup_respond_en_gNB = SEQ_OF(name='respond-en-gNB', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __RespondingNodeType_EndcX2Setup_respond_en_gNB__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___RespondingNodeType_EndcX2Setup_respond_en_gNB__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____RespondingNodeType_EndcX2Setup_respond_en_gNB__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____RespondingNodeType_EndcX2Setup_respond_en_gNB__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GlobalGNB-ID')))
    _____RespondingNodeType_EndcX2Setup_respond_en_gNB__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ServedNRcellsENDCX2ManagementList')))
    _____RespondingNodeType_EndcX2Setup_respond_en_gNB__item__id_tab_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PartialListIndicator')))
    ____RespondingNodeType_EndcX2Setup_respond_en_gNB__item__id_tab._val = ASN1Set(rv=[dict([('id', 252), ('criticality', 'reject'), ('Value', _____RespondingNodeType_EndcX2Setup_respond_en_gNB__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 253), ('criticality', 'reject'), ('Value', _____RespondingNodeType_EndcX2Setup_respond_en_gNB__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 348), ('criticality', 'ignore'), ('Value', _____RespondingNodeType_EndcX2Setup_respond_en_gNB__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RespondingNodeType_EndcX2Setup_respond_en_gNB__item__id._const_tab = ____RespondingNodeType_EndcX2Setup_respond_en_gNB__item__id_tab
    ___RespondingNodeType_EndcX2Setup_respond_en_gNB__item__id._const_tab_at = None
    ___RespondingNodeType_EndcX2Setup_respond_en_gNB__item__id._const_tab_id = 'id'
    ___RespondingNodeType_EndcX2Setup_respond_en_gNB__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___RespondingNodeType_EndcX2Setup_respond_en_gNB__item__criticality._const_tab = ____RespondingNodeType_EndcX2Setup_respond_en_gNB__item__id_tab
    ___RespondingNodeType_EndcX2Setup_respond_en_gNB__item__criticality._const_tab_at = ('..', 'id')
    ___RespondingNodeType_EndcX2Setup_respond_en_gNB__item__criticality._const_tab_id = 'criticality'
    ___RespondingNodeType_EndcX2Setup_respond_en_gNB__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___RespondingNodeType_EndcX2Setup_respond_en_gNB__item__value._const_tab = ____RespondingNodeType_EndcX2Setup_respond_en_gNB__item__id_tab
    ___RespondingNodeType_EndcX2Setup_respond_en_gNB__item__value._const_tab_at = ('..', 'id')
    ___RespondingNodeType_EndcX2Setup_respond_en_gNB__item__value._const_tab_id = 'Value'
    __RespondingNodeType_EndcX2Setup_respond_en_gNB__item_._cont = ASN1Dict([
        ('id', ___RespondingNodeType_EndcX2Setup_respond_en_gNB__item__id),
        ('criticality', ___RespondingNodeType_EndcX2Setup_respond_en_gNB__item__criticality),
        ('value', ___RespondingNodeType_EndcX2Setup_respond_en_gNB__item__value),
        ])
    __RespondingNodeType_EndcX2Setup_respond_en_gNB__item_._ext = None
    _RespondingNodeType_EndcX2Setup_respond_en_gNB._cont = __RespondingNodeType_EndcX2Setup_respond_en_gNB__item_
    _RespondingNodeType_EndcX2Setup_respond_en_gNB._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RespondingNodeType_EndcX2Setup._cont = ASN1Dict([
        ('respond-eNB', _RespondingNodeType_EndcX2Setup_respond_eNB),
        ('respond-en-gNB', _RespondingNodeType_EndcX2Setup_respond_en_gNB),
        ])
    RespondingNodeType_EndcX2Setup._ext = []
    
    #-----< ENB-ENDCX2SetupReqAckIEs >-----#
    ENB_ENDCX2SetupReqAckIEs = CLASS(name='ENB-ENDCX2SetupReqAckIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _ENB_ENDCX2SetupReqAckIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GlobalENB-ID')))
    _ENB_ENDCX2SetupReqAckIEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ServedEUTRAcellsENDCX2ManagementList')))
    _ENB_ENDCX2SetupReqAckIEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'InterfaceInstanceIndication')))
    _ENB_ENDCX2SetupReqAckIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellandCapacityAssistInfo')))
    ENB_ENDCX2SetupReqAckIEs._val = ASN1Set(rv=[dict([('id', 21), ('criticality', 'reject'), ('Value', _ENB_ENDCX2SetupReqAckIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 250), ('criticality', 'reject'), ('Value', _ENB_ENDCX2SetupReqAckIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 335), ('criticality', 'reject'), ('Value', _ENB_ENDCX2SetupReqAckIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 351), ('criticality', 'ignore'), ('Value', _ENB_ENDCX2SetupReqAckIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< En-gNB-ENDCX2SetupReqAckIEs >-----#
    En_gNB_ENDCX2SetupReqAckIEs = CLASS(name='En-gNB-ENDCX2SetupReqAckIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _En_gNB_ENDCX2SetupReqAckIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GlobalGNB-ID')))
    _En_gNB_ENDCX2SetupReqAckIEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ServedNRcellsENDCX2ManagementList')))
    _En_gNB_ENDCX2SetupReqAckIEs_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PartialListIndicator')))
    En_gNB_ENDCX2SetupReqAckIEs._val = ASN1Set(rv=[dict([('id', 252), ('criticality', 'reject'), ('Value', _En_gNB_ENDCX2SetupReqAckIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 253), ('criticality', 'reject'), ('Value', _En_gNB_ENDCX2SetupReqAckIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 348), ('criticality', 'ignore'), ('Value', _En_gNB_ENDCX2SetupReqAckIEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ENDCX2SetupFailure >-----#
    ENDCX2SetupFailure = SEQ(name='ENDCX2SetupFailure', mode=MODE_TYPE)
    _ENDCX2SetupFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __ENDCX2SetupFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___ENDCX2SetupFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____ENDCX2SetupFailure_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____ENDCX2SetupFailure_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _____ENDCX2SetupFailure_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _____ENDCX2SetupFailure_protocolIEs__item__id_tab_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TimeToWait')))
    _____ENDCX2SetupFailure_protocolIEs__item__id_tab_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'InterfaceInstanceIndication')))
    _____ENDCX2SetupFailure_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MessageOversizeNotification')))
    ____ENDCX2SetupFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 5), ('criticality', 'ignore'), ('Value', _____ENDCX2SetupFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _____ENDCX2SetupFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 22), ('criticality', 'ignore'), ('Value', _____ENDCX2SetupFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 335), ('criticality', 'reject'), ('Value', _____ENDCX2SetupFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 350), ('criticality', 'ignore'), ('Value', _____ENDCX2SetupFailure_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ENDCX2SetupFailure_protocolIEs__item__id._const_tab = ____ENDCX2SetupFailure_protocolIEs__item__id_tab
    ___ENDCX2SetupFailure_protocolIEs__item__id._const_tab_at = None
    ___ENDCX2SetupFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___ENDCX2SetupFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___ENDCX2SetupFailure_protocolIEs__item__criticality._const_tab = ____ENDCX2SetupFailure_protocolIEs__item__id_tab
    ___ENDCX2SetupFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ENDCX2SetupFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ENDCX2SetupFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___ENDCX2SetupFailure_protocolIEs__item__value._const_tab = ____ENDCX2SetupFailure_protocolIEs__item__id_tab
    ___ENDCX2SetupFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ENDCX2SetupFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __ENDCX2SetupFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ENDCX2SetupFailure_protocolIEs__item__id),
        ('criticality', ___ENDCX2SetupFailure_protocolIEs__item__criticality),
        ('value', ___ENDCX2SetupFailure_protocolIEs__item__value),
        ])
    __ENDCX2SetupFailure_protocolIEs__item_._ext = None
    _ENDCX2SetupFailure_protocolIEs._cont = __ENDCX2SetupFailure_protocolIEs__item_
    _ENDCX2SetupFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ENDCX2SetupFailure._cont = ASN1Dict([
        ('protocolIEs', _ENDCX2SetupFailure_protocolIEs),
        ])
    ENDCX2SetupFailure._ext = []
    
    #-----< ENDCX2SetupFailure-IEs >-----#
    ENDCX2SetupFailure_IEs = CLASS(name='ENDCX2SetupFailure-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _ENDCX2SetupFailure_IEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _ENDCX2SetupFailure_IEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _ENDCX2SetupFailure_IEs_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TimeToWait')))
    _ENDCX2SetupFailure_IEs_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'InterfaceInstanceIndication')))
    _ENDCX2SetupFailure_IEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'MessageOversizeNotification')))
    ENDCX2SetupFailure_IEs._val = ASN1Set(rv=[dict([('id', 5), ('criticality', 'ignore'), ('Value', _ENDCX2SetupFailure_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _ENDCX2SetupFailure_IEs_val_Value_1), ('presence', 'optional')]), dict([('id', 22), ('criticality', 'ignore'), ('Value', _ENDCX2SetupFailure_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 335), ('criticality', 'reject'), ('Value', _ENDCX2SetupFailure_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 350), ('criticality', 'ignore'), ('Value', _ENDCX2SetupFailure_IEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ENDCConfigurationUpdate >-----#
    ENDCConfigurationUpdate = SEQ(name='ENDCConfigurationUpdate', mode=MODE_TYPE)
    _ENDCConfigurationUpdate_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __ENDCConfigurationUpdate_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___ENDCConfigurationUpdate_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____ENDCConfigurationUpdate_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____ENDCConfigurationUpdate_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'InitiatingNodeType-EndcConfigUpdate')))
    _____ENDCConfigurationUpdate_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'InterfaceInstanceIndication')))
    _____ENDCConfigurationUpdate_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TNLConfigurationInfo')))
    _____ENDCConfigurationUpdate_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TNLA-To-Add-List')))
    _____ENDCConfigurationUpdate_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TNLA-To-Update-List')))
    _____ENDCConfigurationUpdate_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TNLA-To-Remove-List')))
    ____ENDCConfigurationUpdate_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 245), ('criticality', 'reject'), ('Value', _____ENDCConfigurationUpdate_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 335), ('criticality', 'reject'), ('Value', _____ENDCConfigurationUpdate_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 352), ('criticality', 'ignore'), ('Value', _____ENDCConfigurationUpdate_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 353), ('criticality', 'ignore'), ('Value', _____ENDCConfigurationUpdate_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 354), ('criticality', 'ignore'), ('Value', _____ENDCConfigurationUpdate_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 355), ('criticality', 'ignore'), ('Value', _____ENDCConfigurationUpdate_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ENDCConfigurationUpdate_protocolIEs__item__id._const_tab = ____ENDCConfigurationUpdate_protocolIEs__item__id_tab
    ___ENDCConfigurationUpdate_protocolIEs__item__id._const_tab_at = None
    ___ENDCConfigurationUpdate_protocolIEs__item__id._const_tab_id = 'id'
    ___ENDCConfigurationUpdate_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___ENDCConfigurationUpdate_protocolIEs__item__criticality._const_tab = ____ENDCConfigurationUpdate_protocolIEs__item__id_tab
    ___ENDCConfigurationUpdate_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ENDCConfigurationUpdate_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ENDCConfigurationUpdate_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___ENDCConfigurationUpdate_protocolIEs__item__value._const_tab = ____ENDCConfigurationUpdate_protocolIEs__item__id_tab
    ___ENDCConfigurationUpdate_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ENDCConfigurationUpdate_protocolIEs__item__value._const_tab_id = 'Value'
    __ENDCConfigurationUpdate_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ENDCConfigurationUpdate_protocolIEs__item__id),
        ('criticality', ___ENDCConfigurationUpdate_protocolIEs__item__criticality),
        ('value', ___ENDCConfigurationUpdate_protocolIEs__item__value),
        ])
    __ENDCConfigurationUpdate_protocolIEs__item_._ext = None
    _ENDCConfigurationUpdate_protocolIEs._cont = __ENDCConfigurationUpdate_protocolIEs__item_
    _ENDCConfigurationUpdate_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ENDCConfigurationUpdate._cont = ASN1Dict([
        ('protocolIEs', _ENDCConfigurationUpdate_protocolIEs),
        ])
    ENDCConfigurationUpdate._ext = []
    
    #-----< ENDCConfigurationUpdate-IEs >-----#
    ENDCConfigurationUpdate_IEs = CLASS(name='ENDCConfigurationUpdate-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _ENDCConfigurationUpdate_IEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'InitiatingNodeType-EndcConfigUpdate')))
    _ENDCConfigurationUpdate_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'InterfaceInstanceIndication')))
    _ENDCConfigurationUpdate_IEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TNLConfigurationInfo')))
    _ENDCConfigurationUpdate_IEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TNLA-To-Add-List')))
    _ENDCConfigurationUpdate_IEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TNLA-To-Update-List')))
    _ENDCConfigurationUpdate_IEs_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TNLA-To-Remove-List')))
    ENDCConfigurationUpdate_IEs._val = ASN1Set(rv=[dict([('id', 245), ('criticality', 'reject'), ('Value', _ENDCConfigurationUpdate_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 335), ('criticality', 'reject'), ('Value', _ENDCConfigurationUpdate_IEs_val_Value_1), ('presence', 'optional')]), dict([('id', 352), ('criticality', 'ignore'), ('Value', _ENDCConfigurationUpdate_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 353), ('criticality', 'ignore'), ('Value', _ENDCConfigurationUpdate_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 354), ('criticality', 'ignore'), ('Value', _ENDCConfigurationUpdate_IEs_val_Value_4), ('presence', 'optional')]), dict([('id', 355), ('criticality', 'ignore'), ('Value', _ENDCConfigurationUpdate_IEs_val_Value_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< InitiatingNodeType-EndcConfigUpdate >-----#
    InitiatingNodeType_EndcConfigUpdate = CHOICE(name='InitiatingNodeType-EndcConfigUpdate', mode=MODE_TYPE)
    _InitiatingNodeType_EndcConfigUpdate_init_eNB = SEQ_OF(name='init-eNB', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __InitiatingNodeType_EndcConfigUpdate_init_eNB__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___InitiatingNodeType_EndcConfigUpdate_init_eNB__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____InitiatingNodeType_EndcConfigUpdate_init_eNB__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____InitiatingNodeType_EndcConfigUpdate_init_eNB__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellAssistanceInformation')))
    _____InitiatingNodeType_EndcConfigUpdate_init_eNB__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ServedEUTRAcellsENDCX2ManagementList')))
    _____InitiatingNodeType_EndcConfigUpdate_init_eNB__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ServedEUTRAcellsToModifyListENDCConfUpd')))
    _____InitiatingNodeType_EndcConfigUpdate_init_eNB__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ServedEUTRAcellsToDeleteListENDCConfUpd')))
    ____InitiatingNodeType_EndcConfigUpdate_init_eNB__item__id_tab._val = ASN1Set(rv=[dict([('id', 251), ('criticality', 'reject'), ('Value', _____InitiatingNodeType_EndcConfigUpdate_init_eNB__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 250), ('criticality', 'reject'), ('Value', _____InitiatingNodeType_EndcConfigUpdate_init_eNB__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 259), ('criticality', 'reject'), ('Value', _____InitiatingNodeType_EndcConfigUpdate_init_eNB__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 260), ('criticality', 'reject'), ('Value', _____InitiatingNodeType_EndcConfigUpdate_init_eNB__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___InitiatingNodeType_EndcConfigUpdate_init_eNB__item__id._const_tab = ____InitiatingNodeType_EndcConfigUpdate_init_eNB__item__id_tab
    ___InitiatingNodeType_EndcConfigUpdate_init_eNB__item__id._const_tab_at = None
    ___InitiatingNodeType_EndcConfigUpdate_init_eNB__item__id._const_tab_id = 'id'
    ___InitiatingNodeType_EndcConfigUpdate_init_eNB__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___InitiatingNodeType_EndcConfigUpdate_init_eNB__item__criticality._const_tab = ____InitiatingNodeType_EndcConfigUpdate_init_eNB__item__id_tab
    ___InitiatingNodeType_EndcConfigUpdate_init_eNB__item__criticality._const_tab_at = ('..', 'id')
    ___InitiatingNodeType_EndcConfigUpdate_init_eNB__item__criticality._const_tab_id = 'criticality'
    ___InitiatingNodeType_EndcConfigUpdate_init_eNB__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___InitiatingNodeType_EndcConfigUpdate_init_eNB__item__value._const_tab = ____InitiatingNodeType_EndcConfigUpdate_init_eNB__item__id_tab
    ___InitiatingNodeType_EndcConfigUpdate_init_eNB__item__value._const_tab_at = ('..', 'id')
    ___InitiatingNodeType_EndcConfigUpdate_init_eNB__item__value._const_tab_id = 'Value'
    __InitiatingNodeType_EndcConfigUpdate_init_eNB__item_._cont = ASN1Dict([
        ('id', ___InitiatingNodeType_EndcConfigUpdate_init_eNB__item__id),
        ('criticality', ___InitiatingNodeType_EndcConfigUpdate_init_eNB__item__criticality),
        ('value', ___InitiatingNodeType_EndcConfigUpdate_init_eNB__item__value),
        ])
    __InitiatingNodeType_EndcConfigUpdate_init_eNB__item_._ext = None
    _InitiatingNodeType_EndcConfigUpdate_init_eNB._cont = __InitiatingNodeType_EndcConfigUpdate_init_eNB__item_
    _InitiatingNodeType_EndcConfigUpdate_init_eNB._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _InitiatingNodeType_EndcConfigUpdate_init_en_gNB = SEQ_OF(name='init-en-gNB', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __InitiatingNodeType_EndcConfigUpdate_init_en_gNB__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___InitiatingNodeType_EndcConfigUpdate_init_en_gNB__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____InitiatingNodeType_EndcConfigUpdate_init_en_gNB__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____InitiatingNodeType_EndcConfigUpdate_init_en_gNB__item__id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ServedNRcellsENDCX2ManagementList')))
    _____InitiatingNodeType_EndcConfigUpdate_init_en_gNB__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ServedNRcellsToModifyENDCConfUpdList')))
    _____InitiatingNodeType_EndcConfigUpdate_init_en_gNB__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ServedNRcellsToDeleteENDCConfUpdList')))
    ____InitiatingNodeType_EndcConfigUpdate_init_en_gNB__item__id_tab._val = ASN1Set(rv=[dict([('id', 253), ('criticality', 'reject'), ('Value', _____InitiatingNodeType_EndcConfigUpdate_init_en_gNB__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 261), ('criticality', 'reject'), ('Value', _____InitiatingNodeType_EndcConfigUpdate_init_en_gNB__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 262), ('criticality', 'reject'), ('Value', _____InitiatingNodeType_EndcConfigUpdate_init_en_gNB__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___InitiatingNodeType_EndcConfigUpdate_init_en_gNB__item__id._const_tab = ____InitiatingNodeType_EndcConfigUpdate_init_en_gNB__item__id_tab
    ___InitiatingNodeType_EndcConfigUpdate_init_en_gNB__item__id._const_tab_at = None
    ___InitiatingNodeType_EndcConfigUpdate_init_en_gNB__item__id._const_tab_id = 'id'
    ___InitiatingNodeType_EndcConfigUpdate_init_en_gNB__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___InitiatingNodeType_EndcConfigUpdate_init_en_gNB__item__criticality._const_tab = ____InitiatingNodeType_EndcConfigUpdate_init_en_gNB__item__id_tab
    ___InitiatingNodeType_EndcConfigUpdate_init_en_gNB__item__criticality._const_tab_at = ('..', 'id')
    ___InitiatingNodeType_EndcConfigUpdate_init_en_gNB__item__criticality._const_tab_id = 'criticality'
    ___InitiatingNodeType_EndcConfigUpdate_init_en_gNB__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___InitiatingNodeType_EndcConfigUpdate_init_en_gNB__item__value._const_tab = ____InitiatingNodeType_EndcConfigUpdate_init_en_gNB__item__id_tab
    ___InitiatingNodeType_EndcConfigUpdate_init_en_gNB__item__value._const_tab_at = ('..', 'id')
    ___InitiatingNodeType_EndcConfigUpdate_init_en_gNB__item__value._const_tab_id = 'Value'
    __InitiatingNodeType_EndcConfigUpdate_init_en_gNB__item_._cont = ASN1Dict([
        ('id', ___InitiatingNodeType_EndcConfigUpdate_init_en_gNB__item__id),
        ('criticality', ___InitiatingNodeType_EndcConfigUpdate_init_en_gNB__item__criticality),
        ('value', ___InitiatingNodeType_EndcConfigUpdate_init_en_gNB__item__value),
        ])
    __InitiatingNodeType_EndcConfigUpdate_init_en_gNB__item_._ext = None
    _InitiatingNodeType_EndcConfigUpdate_init_en_gNB._cont = __InitiatingNodeType_EndcConfigUpdate_init_en_gNB__item_
    _InitiatingNodeType_EndcConfigUpdate_init_en_gNB._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    InitiatingNodeType_EndcConfigUpdate._cont = ASN1Dict([
        ('init-eNB', _InitiatingNodeType_EndcConfigUpdate_init_eNB),
        ('init-en-gNB', _InitiatingNodeType_EndcConfigUpdate_init_en_gNB),
        ])
    InitiatingNodeType_EndcConfigUpdate._ext = []
    
    #-----< ENB-ENDCConfigUpdateIEs >-----#
    ENB_ENDCConfigUpdateIEs = CLASS(name='ENB-ENDCConfigUpdateIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _ENB_ENDCConfigUpdateIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellAssistanceInformation')))
    _ENB_ENDCConfigUpdateIEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ServedEUTRAcellsENDCX2ManagementList')))
    _ENB_ENDCConfigUpdateIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ServedEUTRAcellsToModifyListENDCConfUpd')))
    _ENB_ENDCConfigUpdateIEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ServedEUTRAcellsToDeleteListENDCConfUpd')))
    ENB_ENDCConfigUpdateIEs._val = ASN1Set(rv=[dict([('id', 251), ('criticality', 'reject'), ('Value', _ENB_ENDCConfigUpdateIEs_val_Value_0), ('presence', 'optional')]), dict([('id', 250), ('criticality', 'reject'), ('Value', _ENB_ENDCConfigUpdateIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 259), ('criticality', 'reject'), ('Value', _ENB_ENDCConfigUpdateIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 260), ('criticality', 'reject'), ('Value', _ENB_ENDCConfigUpdateIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ServedEUTRAcellsToModifyListENDCConfUpd >-----#
    ServedEUTRAcellsToModifyListENDCConfUpd = SEQ_OF(name='ServedEUTRAcellsToModifyListENDCConfUpd', mode=MODE_TYPE)
    _ServedEUTRAcellsToModifyListENDCConfUpd__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __ServedEUTRAcellsToModifyListENDCConfUpd__item__old_ECGI = SEQ(name='old-ECGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    __ServedEUTRAcellsToModifyListENDCConfUpd__item__servedEUTRACellInfo = SEQ(name='servedEUTRACellInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ServedCell-Information')))
    __ServedEUTRAcellsToModifyListENDCConfUpd__item__nrNeighbourInfo = SEQ_OF(name='nrNeighbourInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'NRNeighbour-Information')), opt=True)
    __ServedEUTRAcellsToModifyListENDCConfUpd__item__iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___ServedEUTRAcellsToModifyListENDCConfUpd__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ____ServedEUTRAcellsToModifyListENDCConfUpd__item__iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    _____ServedEUTRAcellsToModifyListENDCConfUpd__item__iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____ServedEUTRAcellsToModifyListENDCConfUpd__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____ServedEUTRAcellsToModifyListENDCConfUpd__item__iE_Extensions__item__id._const_tab = _____ServedEUTRAcellsToModifyListENDCConfUpd__item__iE_Extensions__item__id_tab
    ____ServedEUTRAcellsToModifyListENDCConfUpd__item__iE_Extensions__item__id._const_tab_at = None
    ____ServedEUTRAcellsToModifyListENDCConfUpd__item__iE_Extensions__item__id._const_tab_id = 'id'
    ____ServedEUTRAcellsToModifyListENDCConfUpd__item__iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    _____ServedEUTRAcellsToModifyListENDCConfUpd__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____ServedEUTRAcellsToModifyListENDCConfUpd__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____ServedEUTRAcellsToModifyListENDCConfUpd__item__iE_Extensions__item__criticality._const_tab = _____ServedEUTRAcellsToModifyListENDCConfUpd__item__iE_Extensions__item__criticality_tab
    ____ServedEUTRAcellsToModifyListENDCConfUpd__item__iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____ServedEUTRAcellsToModifyListENDCConfUpd__item__iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____ServedEUTRAcellsToModifyListENDCConfUpd__item__iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    _____ServedEUTRAcellsToModifyListENDCConfUpd__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    _____ServedEUTRAcellsToModifyListENDCConfUpd__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____ServedEUTRAcellsToModifyListENDCConfUpd__item__iE_Extensions__item__extensionValue._const_tab = _____ServedEUTRAcellsToModifyListENDCConfUpd__item__iE_Extensions__item__extensionValue_tab
    ____ServedEUTRAcellsToModifyListENDCConfUpd__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____ServedEUTRAcellsToModifyListENDCConfUpd__item__iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___ServedEUTRAcellsToModifyListENDCConfUpd__item__iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____ServedEUTRAcellsToModifyListENDCConfUpd__item__iE_Extensions__item__id),
        ('criticality', ____ServedEUTRAcellsToModifyListENDCConfUpd__item__iE_Extensions__item__criticality),
        ('extensionValue', ____ServedEUTRAcellsToModifyListENDCConfUpd__item__iE_Extensions__item__extensionValue),
        ])
    ___ServedEUTRAcellsToModifyListENDCConfUpd__item__iE_Extensions__item_._ext = None
    __ServedEUTRAcellsToModifyListENDCConfUpd__item__iE_Extensions._cont = ___ServedEUTRAcellsToModifyListENDCConfUpd__item__iE_Extensions__item_
    __ServedEUTRAcellsToModifyListENDCConfUpd__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _ServedEUTRAcellsToModifyListENDCConfUpd__item_._cont = ASN1Dict([
        ('old-ECGI', __ServedEUTRAcellsToModifyListENDCConfUpd__item__old_ECGI),
        ('servedEUTRACellInfo', __ServedEUTRAcellsToModifyListENDCConfUpd__item__servedEUTRACellInfo),
        ('nrNeighbourInfo', __ServedEUTRAcellsToModifyListENDCConfUpd__item__nrNeighbourInfo),
        ('iE-Extensions', __ServedEUTRAcellsToModifyListENDCConfUpd__item__iE_Extensions),
        ])
    _ServedEUTRAcellsToModifyListENDCConfUpd__item_._ext = []
    ServedEUTRAcellsToModifyListENDCConfUpd._cont = _ServedEUTRAcellsToModifyListENDCConfUpd__item_
    ServedEUTRAcellsToModifyListENDCConfUpd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< ServedEUTRAcellsToModifyListENDCConfUpd-ExtIEs >-----#
    ServedEUTRAcellsToModifyListENDCConfUpd_ExtIEs = CLASS(name='ServedEUTRAcellsToModifyListENDCConfUpd-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ServedEUTRAcellsToModifyListENDCConfUpd_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ServedEUTRAcellsToDeleteListENDCConfUpd >-----#
    ServedEUTRAcellsToDeleteListENDCConfUpd = SEQ_OF(name='ServedEUTRAcellsToDeleteListENDCConfUpd', mode=MODE_TYPE)
    _ServedEUTRAcellsToDeleteListENDCConfUpd__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    ServedEUTRAcellsToDeleteListENDCConfUpd._cont = _ServedEUTRAcellsToDeleteListENDCConfUpd__item_
    ServedEUTRAcellsToDeleteListENDCConfUpd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< En-gNB-ENDCConfigUpdateIEs >-----#
    En_gNB_ENDCConfigUpdateIEs = CLASS(name='En-gNB-ENDCConfigUpdateIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _En_gNB_ENDCConfigUpdateIEs_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ServedNRcellsENDCX2ManagementList')))
    _En_gNB_ENDCConfigUpdateIEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ServedNRcellsToModifyENDCConfUpdList')))
    _En_gNB_ENDCConfigUpdateIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ServedNRcellsToDeleteENDCConfUpdList')))
    En_gNB_ENDCConfigUpdateIEs._val = ASN1Set(rv=[dict([('id', 253), ('criticality', 'reject'), ('Value', _En_gNB_ENDCConfigUpdateIEs_val_Value_0), ('presence', 'optional')]), dict([('id', 261), ('criticality', 'reject'), ('Value', _En_gNB_ENDCConfigUpdateIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 262), ('criticality', 'reject'), ('Value', _En_gNB_ENDCConfigUpdateIEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ServedNRcellsToModifyENDCConfUpdList >-----#
    ServedNRcellsToModifyENDCConfUpdList = SEQ_OF(name='ServedNRcellsToModifyENDCConfUpdList', mode=MODE_TYPE)
    _ServedNRcellsToModifyENDCConfUpdList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ServedNRCellsToModify-Item')))
    ServedNRcellsToModifyENDCConfUpdList._cont = _ServedNRcellsToModifyENDCConfUpdList__item_
    ServedNRcellsToModifyENDCConfUpdList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16384)], ev=None, er=[])
    
    #-----< ServedNRCellsToModify-Item >-----#
    ServedNRCellsToModify_Item = SEQ(name='ServedNRCellsToModify-Item', mode=MODE_TYPE)
    _ServedNRCellsToModify_Item_old_nrcgi = SEQ(name='old-nrcgi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'NRCGI')))
    _ServedNRCellsToModify_Item_servedNRCellInformation = SEQ(name='servedNRCellInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'ServedNRCell-Information')))
    _ServedNRCellsToModify_Item_nrNeighbourInformation = SEQ_OF(name='nrNeighbourInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'NRNeighbour-Information')), opt=True)
    _ServedNRCellsToModify_Item_nrDeactivationIndication = ENUM(name='nrDeactivationIndication', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'DeactivationIndication')), opt=True)
    _ServedNRCellsToModify_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ServedNRCellsToModify_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___ServedNRCellsToModify_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____ServedNRCellsToModify_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ServedNRCellsToModify_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ServedNRCellsToModify_Item_iE_Extensions__item__id._const_tab = ____ServedNRCellsToModify_Item_iE_Extensions__item__id_tab
    ___ServedNRCellsToModify_Item_iE_Extensions__item__id._const_tab_at = None
    ___ServedNRCellsToModify_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___ServedNRCellsToModify_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ServedNRCellsToModify_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ServedNRCellsToModify_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ServedNRCellsToModify_Item_iE_Extensions__item__criticality._const_tab = ____ServedNRCellsToModify_Item_iE_Extensions__item__criticality_tab
    ___ServedNRCellsToModify_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ServedNRCellsToModify_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ServedNRCellsToModify_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ServedNRCellsToModify_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ServedNRCellsToModify_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ServedNRCellsToModify_Item_iE_Extensions__item__extensionValue._const_tab = ____ServedNRCellsToModify_Item_iE_Extensions__item__extensionValue_tab
    ___ServedNRCellsToModify_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ServedNRCellsToModify_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ServedNRCellsToModify_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ServedNRCellsToModify_Item_iE_Extensions__item__id),
        ('criticality', ___ServedNRCellsToModify_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___ServedNRCellsToModify_Item_iE_Extensions__item__extensionValue),
        ])
    __ServedNRCellsToModify_Item_iE_Extensions__item_._ext = None
    _ServedNRCellsToModify_Item_iE_Extensions._cont = __ServedNRCellsToModify_Item_iE_Extensions__item_
    _ServedNRCellsToModify_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ServedNRCellsToModify_Item._cont = ASN1Dict([
        ('old-nrcgi', _ServedNRCellsToModify_Item_old_nrcgi),
        ('servedNRCellInformation', _ServedNRCellsToModify_Item_servedNRCellInformation),
        ('nrNeighbourInformation', _ServedNRCellsToModify_Item_nrNeighbourInformation),
        ('nrDeactivationIndication', _ServedNRCellsToModify_Item_nrDeactivationIndication),
        ('iE-Extensions', _ServedNRCellsToModify_Item_iE_Extensions),
        ])
    ServedNRCellsToModify_Item._ext = []
    
    #-----< ServedNRCellsToModify-Item-ExtIEs >-----#
    ServedNRCellsToModify_Item_ExtIEs = CLASS(name='ServedNRCellsToModify-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ServedNRCellsToModify_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ServedNRcellsToDeleteENDCConfUpdList >-----#
    ServedNRcellsToDeleteENDCConfUpdList = SEQ_OF(name='ServedNRcellsToDeleteENDCConfUpdList', mode=MODE_TYPE)
    _ServedNRcellsToDeleteENDCConfUpdList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'NRCGI')))
    ServedNRcellsToDeleteENDCConfUpdList._cont = _ServedNRcellsToDeleteENDCConfUpdList__item_
    ServedNRcellsToDeleteENDCConfUpdList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16384)], ev=None, er=[])
    
    #-----< ENDCConfigurationUpdateAcknowledge >-----#
    ENDCConfigurationUpdateAcknowledge = SEQ(name='ENDCConfigurationUpdateAcknowledge', mode=MODE_TYPE)
    _ENDCConfigurationUpdateAcknowledge_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __ENDCConfigurationUpdateAcknowledge_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___ENDCConfigurationUpdateAcknowledge_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____ENDCConfigurationUpdateAcknowledge_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____ENDCConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'RespondingNodeType-EndcConfigUpdate')))
    _____ENDCConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'InterfaceInstanceIndication')))
    _____ENDCConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _____ENDCConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TNLConfigurationInfo')))
    _____ENDCConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TNLA-Setup-List')))
    _____ENDCConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TNLA-Failed-To-Setup-List')))
    ____ENDCConfigurationUpdateAcknowledge_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 247), ('criticality', 'reject'), ('Value', _____ENDCConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 335), ('criticality', 'reject'), ('Value', _____ENDCConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _____ENDCConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 352), ('criticality', 'ignore'), ('Value', _____ENDCConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 356), ('criticality', 'ignore'), ('Value', _____ENDCConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 357), ('criticality', 'ignore'), ('Value', _____ENDCConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ENDCConfigurationUpdateAcknowledge_protocolIEs__item__id._const_tab = ____ENDCConfigurationUpdateAcknowledge_protocolIEs__item__id_tab
    ___ENDCConfigurationUpdateAcknowledge_protocolIEs__item__id._const_tab_at = None
    ___ENDCConfigurationUpdateAcknowledge_protocolIEs__item__id._const_tab_id = 'id'
    ___ENDCConfigurationUpdateAcknowledge_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___ENDCConfigurationUpdateAcknowledge_protocolIEs__item__criticality._const_tab = ____ENDCConfigurationUpdateAcknowledge_protocolIEs__item__id_tab
    ___ENDCConfigurationUpdateAcknowledge_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ENDCConfigurationUpdateAcknowledge_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ENDCConfigurationUpdateAcknowledge_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___ENDCConfigurationUpdateAcknowledge_protocolIEs__item__value._const_tab = ____ENDCConfigurationUpdateAcknowledge_protocolIEs__item__id_tab
    ___ENDCConfigurationUpdateAcknowledge_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ENDCConfigurationUpdateAcknowledge_protocolIEs__item__value._const_tab_id = 'Value'
    __ENDCConfigurationUpdateAcknowledge_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ENDCConfigurationUpdateAcknowledge_protocolIEs__item__id),
        ('criticality', ___ENDCConfigurationUpdateAcknowledge_protocolIEs__item__criticality),
        ('value', ___ENDCConfigurationUpdateAcknowledge_protocolIEs__item__value),
        ])
    __ENDCConfigurationUpdateAcknowledge_protocolIEs__item_._ext = None
    _ENDCConfigurationUpdateAcknowledge_protocolIEs._cont = __ENDCConfigurationUpdateAcknowledge_protocolIEs__item_
    _ENDCConfigurationUpdateAcknowledge_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ENDCConfigurationUpdateAcknowledge._cont = ASN1Dict([
        ('protocolIEs', _ENDCConfigurationUpdateAcknowledge_protocolIEs),
        ])
    ENDCConfigurationUpdateAcknowledge._ext = []
    
    #-----< ENDCConfigurationUpdateAcknowledge-IEs >-----#
    ENDCConfigurationUpdateAcknowledge_IEs = CLASS(name='ENDCConfigurationUpdateAcknowledge-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _ENDCConfigurationUpdateAcknowledge_IEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'RespondingNodeType-EndcConfigUpdate')))
    _ENDCConfigurationUpdateAcknowledge_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'InterfaceInstanceIndication')))
    _ENDCConfigurationUpdateAcknowledge_IEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _ENDCConfigurationUpdateAcknowledge_IEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TNLConfigurationInfo')))
    _ENDCConfigurationUpdateAcknowledge_IEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TNLA-Setup-List')))
    _ENDCConfigurationUpdateAcknowledge_IEs_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TNLA-Failed-To-Setup-List')))
    ENDCConfigurationUpdateAcknowledge_IEs._val = ASN1Set(rv=[dict([('id', 247), ('criticality', 'reject'), ('Value', _ENDCConfigurationUpdateAcknowledge_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 335), ('criticality', 'reject'), ('Value', _ENDCConfigurationUpdateAcknowledge_IEs_val_Value_1), ('presence', 'optional')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _ENDCConfigurationUpdateAcknowledge_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 352), ('criticality', 'ignore'), ('Value', _ENDCConfigurationUpdateAcknowledge_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 356), ('criticality', 'ignore'), ('Value', _ENDCConfigurationUpdateAcknowledge_IEs_val_Value_4), ('presence', 'optional')]), dict([('id', 357), ('criticality', 'ignore'), ('Value', _ENDCConfigurationUpdateAcknowledge_IEs_val_Value_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RespondingNodeType-EndcConfigUpdate >-----#
    RespondingNodeType_EndcConfigUpdate = CHOICE(name='RespondingNodeType-EndcConfigUpdate', mode=MODE_TYPE)
    _RespondingNodeType_EndcConfigUpdate_respond_eNB = SEQ_OF(name='respond-eNB', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __RespondingNodeType_EndcConfigUpdate_respond_eNB__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___RespondingNodeType_EndcConfigUpdate_respond_eNB__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____RespondingNodeType_EndcConfigUpdate_respond_eNB__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____RespondingNodeType_EndcConfigUpdate_respond_eNB__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RespondingNodeType_EndcConfigUpdate_respond_eNB__item__id._const_tab = ____RespondingNodeType_EndcConfigUpdate_respond_eNB__item__id_tab
    ___RespondingNodeType_EndcConfigUpdate_respond_eNB__item__id._const_tab_at = None
    ___RespondingNodeType_EndcConfigUpdate_respond_eNB__item__id._const_tab_id = 'id'
    ___RespondingNodeType_EndcConfigUpdate_respond_eNB__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ____RespondingNodeType_EndcConfigUpdate_respond_eNB__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____RespondingNodeType_EndcConfigUpdate_respond_eNB__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RespondingNodeType_EndcConfigUpdate_respond_eNB__item__criticality._const_tab = ____RespondingNodeType_EndcConfigUpdate_respond_eNB__item__criticality_tab
    ___RespondingNodeType_EndcConfigUpdate_respond_eNB__item__criticality._const_tab_at = ('..', 'id')
    ___RespondingNodeType_EndcConfigUpdate_respond_eNB__item__criticality._const_tab_id = 'criticality'
    ___RespondingNodeType_EndcConfigUpdate_respond_eNB__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ____RespondingNodeType_EndcConfigUpdate_respond_eNB__item__value_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____RespondingNodeType_EndcConfigUpdate_respond_eNB__item__value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RespondingNodeType_EndcConfigUpdate_respond_eNB__item__value._const_tab = ____RespondingNodeType_EndcConfigUpdate_respond_eNB__item__value_tab
    ___RespondingNodeType_EndcConfigUpdate_respond_eNB__item__value._const_tab_at = ('..', 'id')
    ___RespondingNodeType_EndcConfigUpdate_respond_eNB__item__value._const_tab_id = 'Value'
    __RespondingNodeType_EndcConfigUpdate_respond_eNB__item_._cont = ASN1Dict([
        ('id', ___RespondingNodeType_EndcConfigUpdate_respond_eNB__item__id),
        ('criticality', ___RespondingNodeType_EndcConfigUpdate_respond_eNB__item__criticality),
        ('value', ___RespondingNodeType_EndcConfigUpdate_respond_eNB__item__value),
        ])
    __RespondingNodeType_EndcConfigUpdate_respond_eNB__item_._ext = None
    _RespondingNodeType_EndcConfigUpdate_respond_eNB._cont = __RespondingNodeType_EndcConfigUpdate_respond_eNB__item_
    _RespondingNodeType_EndcConfigUpdate_respond_eNB._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RespondingNodeType_EndcConfigUpdate_respond_en_gNB = SEQ_OF(name='respond-en-gNB', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __RespondingNodeType_EndcConfigUpdate_respond_en_gNB__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___RespondingNodeType_EndcConfigUpdate_respond_en_gNB__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____RespondingNodeType_EndcConfigUpdate_respond_en_gNB__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____RespondingNodeType_EndcConfigUpdate_respond_en_gNB__item__id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ServedNRcellsENDCX2ManagementList')))
    ____RespondingNodeType_EndcConfigUpdate_respond_en_gNB__item__id_tab._val = ASN1Set(rv=[dict([('id', 253), ('criticality', 'reject'), ('Value', _____RespondingNodeType_EndcConfigUpdate_respond_en_gNB__item__id_tab_val_Value_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RespondingNodeType_EndcConfigUpdate_respond_en_gNB__item__id._const_tab = ____RespondingNodeType_EndcConfigUpdate_respond_en_gNB__item__id_tab
    ___RespondingNodeType_EndcConfigUpdate_respond_en_gNB__item__id._const_tab_at = None
    ___RespondingNodeType_EndcConfigUpdate_respond_en_gNB__item__id._const_tab_id = 'id'
    ___RespondingNodeType_EndcConfigUpdate_respond_en_gNB__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___RespondingNodeType_EndcConfigUpdate_respond_en_gNB__item__criticality._const_tab = ____RespondingNodeType_EndcConfigUpdate_respond_en_gNB__item__id_tab
    ___RespondingNodeType_EndcConfigUpdate_respond_en_gNB__item__criticality._const_tab_at = ('..', 'id')
    ___RespondingNodeType_EndcConfigUpdate_respond_en_gNB__item__criticality._const_tab_id = 'criticality'
    ___RespondingNodeType_EndcConfigUpdate_respond_en_gNB__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___RespondingNodeType_EndcConfigUpdate_respond_en_gNB__item__value._const_tab = ____RespondingNodeType_EndcConfigUpdate_respond_en_gNB__item__id_tab
    ___RespondingNodeType_EndcConfigUpdate_respond_en_gNB__item__value._const_tab_at = ('..', 'id')
    ___RespondingNodeType_EndcConfigUpdate_respond_en_gNB__item__value._const_tab_id = 'Value'
    __RespondingNodeType_EndcConfigUpdate_respond_en_gNB__item_._cont = ASN1Dict([
        ('id', ___RespondingNodeType_EndcConfigUpdate_respond_en_gNB__item__id),
        ('criticality', ___RespondingNodeType_EndcConfigUpdate_respond_en_gNB__item__criticality),
        ('value', ___RespondingNodeType_EndcConfigUpdate_respond_en_gNB__item__value),
        ])
    __RespondingNodeType_EndcConfigUpdate_respond_en_gNB__item_._ext = None
    _RespondingNodeType_EndcConfigUpdate_respond_en_gNB._cont = __RespondingNodeType_EndcConfigUpdate_respond_en_gNB__item_
    _RespondingNodeType_EndcConfigUpdate_respond_en_gNB._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RespondingNodeType_EndcConfigUpdate._cont = ASN1Dict([
        ('respond-eNB', _RespondingNodeType_EndcConfigUpdate_respond_eNB),
        ('respond-en-gNB', _RespondingNodeType_EndcConfigUpdate_respond_en_gNB),
        ])
    RespondingNodeType_EndcConfigUpdate._ext = []
    
    #-----< ENB-ENDCConfigUpdateAckIEs >-----#
    ENB_ENDCConfigUpdateAckIEs = CLASS(name='ENB-ENDCConfigUpdateAckIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ENB_ENDCConfigUpdateAckIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< En-gNB-ENDCConfigUpdateAckIEs >-----#
    En_gNB_ENDCConfigUpdateAckIEs = CLASS(name='En-gNB-ENDCConfigUpdateAckIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _En_gNB_ENDCConfigUpdateAckIEs_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ServedNRcellsENDCX2ManagementList')))
    En_gNB_ENDCConfigUpdateAckIEs._val = ASN1Set(rv=[dict([('id', 253), ('criticality', 'reject'), ('Value', _En_gNB_ENDCConfigUpdateAckIEs_val_Value_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ENDCConfigurationUpdateFailure >-----#
    ENDCConfigurationUpdateFailure = SEQ(name='ENDCConfigurationUpdateFailure', mode=MODE_TYPE)
    _ENDCConfigurationUpdateFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __ENDCConfigurationUpdateFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___ENDCConfigurationUpdateFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____ENDCConfigurationUpdateFailure_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____ENDCConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _____ENDCConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _____ENDCConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TimeToWait')))
    _____ENDCConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'InterfaceInstanceIndication')))
    ____ENDCConfigurationUpdateFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 5), ('criticality', 'ignore'), ('Value', _____ENDCConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _____ENDCConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 22), ('criticality', 'ignore'), ('Value', _____ENDCConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 335), ('criticality', 'reject'), ('Value', _____ENDCConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ENDCConfigurationUpdateFailure_protocolIEs__item__id._const_tab = ____ENDCConfigurationUpdateFailure_protocolIEs__item__id_tab
    ___ENDCConfigurationUpdateFailure_protocolIEs__item__id._const_tab_at = None
    ___ENDCConfigurationUpdateFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___ENDCConfigurationUpdateFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___ENDCConfigurationUpdateFailure_protocolIEs__item__criticality._const_tab = ____ENDCConfigurationUpdateFailure_protocolIEs__item__id_tab
    ___ENDCConfigurationUpdateFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ENDCConfigurationUpdateFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ENDCConfigurationUpdateFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___ENDCConfigurationUpdateFailure_protocolIEs__item__value._const_tab = ____ENDCConfigurationUpdateFailure_protocolIEs__item__id_tab
    ___ENDCConfigurationUpdateFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ENDCConfigurationUpdateFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __ENDCConfigurationUpdateFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ENDCConfigurationUpdateFailure_protocolIEs__item__id),
        ('criticality', ___ENDCConfigurationUpdateFailure_protocolIEs__item__criticality),
        ('value', ___ENDCConfigurationUpdateFailure_protocolIEs__item__value),
        ])
    __ENDCConfigurationUpdateFailure_protocolIEs__item_._ext = None
    _ENDCConfigurationUpdateFailure_protocolIEs._cont = __ENDCConfigurationUpdateFailure_protocolIEs__item_
    _ENDCConfigurationUpdateFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ENDCConfigurationUpdateFailure._cont = ASN1Dict([
        ('protocolIEs', _ENDCConfigurationUpdateFailure_protocolIEs),
        ])
    ENDCConfigurationUpdateFailure._ext = []
    
    #-----< ENDCConfigurationUpdateFailure-IEs >-----#
    ENDCConfigurationUpdateFailure_IEs = CLASS(name='ENDCConfigurationUpdateFailure-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _ENDCConfigurationUpdateFailure_IEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _ENDCConfigurationUpdateFailure_IEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _ENDCConfigurationUpdateFailure_IEs_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TimeToWait')))
    _ENDCConfigurationUpdateFailure_IEs_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'InterfaceInstanceIndication')))
    ENDCConfigurationUpdateFailure_IEs._val = ASN1Set(rv=[dict([('id', 5), ('criticality', 'ignore'), ('Value', _ENDCConfigurationUpdateFailure_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _ENDCConfigurationUpdateFailure_IEs_val_Value_1), ('presence', 'optional')]), dict([('id', 22), ('criticality', 'ignore'), ('Value', _ENDCConfigurationUpdateFailure_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 335), ('criticality', 'reject'), ('Value', _ENDCConfigurationUpdateFailure_IEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ENDCCellActivationRequest >-----#
    ENDCCellActivationRequest = SEQ(name='ENDCCellActivationRequest', mode=MODE_TYPE)
    _ENDCCellActivationRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __ENDCCellActivationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___ENDCCellActivationRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____ENDCCellActivationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____ENDCCellActivationRequest_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ServedNRCellsToActivate')))
    _____ENDCCellActivationRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ActivationID')))
    _____ENDCCellActivationRequest_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'InterfaceInstanceIndication')))
    ____ENDCCellActivationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 267), ('criticality', 'reject'), ('Value', _____ENDCCellActivationRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 256), ('criticality', 'reject'), ('Value', _____ENDCCellActivationRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 335), ('criticality', 'reject'), ('Value', _____ENDCCellActivationRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ENDCCellActivationRequest_protocolIEs__item__id._const_tab = ____ENDCCellActivationRequest_protocolIEs__item__id_tab
    ___ENDCCellActivationRequest_protocolIEs__item__id._const_tab_at = None
    ___ENDCCellActivationRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___ENDCCellActivationRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___ENDCCellActivationRequest_protocolIEs__item__criticality._const_tab = ____ENDCCellActivationRequest_protocolIEs__item__id_tab
    ___ENDCCellActivationRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ENDCCellActivationRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ENDCCellActivationRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___ENDCCellActivationRequest_protocolIEs__item__value._const_tab = ____ENDCCellActivationRequest_protocolIEs__item__id_tab
    ___ENDCCellActivationRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ENDCCellActivationRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __ENDCCellActivationRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ENDCCellActivationRequest_protocolIEs__item__id),
        ('criticality', ___ENDCCellActivationRequest_protocolIEs__item__criticality),
        ('value', ___ENDCCellActivationRequest_protocolIEs__item__value),
        ])
    __ENDCCellActivationRequest_protocolIEs__item_._ext = None
    _ENDCCellActivationRequest_protocolIEs._cont = __ENDCCellActivationRequest_protocolIEs__item_
    _ENDCCellActivationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ENDCCellActivationRequest._cont = ASN1Dict([
        ('protocolIEs', _ENDCCellActivationRequest_protocolIEs),
        ])
    ENDCCellActivationRequest._ext = []
    
    #-----< ENDCCellActivationRequest-IEs >-----#
    ENDCCellActivationRequest_IEs = CLASS(name='ENDCCellActivationRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _ENDCCellActivationRequest_IEs_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ServedNRCellsToActivate')))
    _ENDCCellActivationRequest_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ActivationID')))
    _ENDCCellActivationRequest_IEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'InterfaceInstanceIndication')))
    ENDCCellActivationRequest_IEs._val = ASN1Set(rv=[dict([('id', 267), ('criticality', 'reject'), ('Value', _ENDCCellActivationRequest_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 256), ('criticality', 'reject'), ('Value', _ENDCCellActivationRequest_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 335), ('criticality', 'reject'), ('Value', _ENDCCellActivationRequest_IEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ServedNRCellsToActivate >-----#
    ServedNRCellsToActivate = SEQ_OF(name='ServedNRCellsToActivate', mode=MODE_TYPE)
    _ServedNRCellsToActivate__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ServedNRCellsToActivate-Item')))
    ServedNRCellsToActivate._cont = _ServedNRCellsToActivate__item_
    ServedNRCellsToActivate._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16384)], ev=None, er=[])
    
    #-----< ServedNRCellsToActivate-Item >-----#
    ServedNRCellsToActivate_Item = SEQ(name='ServedNRCellsToActivate-Item', mode=MODE_TYPE)
    _ServedNRCellsToActivate_Item_nrCellID = SEQ(name='nrCellID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'NRCGI')))
    _ServedNRCellsToActivate_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ServedNRCellsToActivate_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___ServedNRCellsToActivate_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____ServedNRCellsToActivate_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ServedNRCellsToActivate_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ServedNRCellsToActivate_Item_iE_Extensions__item__id._const_tab = ____ServedNRCellsToActivate_Item_iE_Extensions__item__id_tab
    ___ServedNRCellsToActivate_Item_iE_Extensions__item__id._const_tab_at = None
    ___ServedNRCellsToActivate_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___ServedNRCellsToActivate_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ServedNRCellsToActivate_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ServedNRCellsToActivate_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ServedNRCellsToActivate_Item_iE_Extensions__item__criticality._const_tab = ____ServedNRCellsToActivate_Item_iE_Extensions__item__criticality_tab
    ___ServedNRCellsToActivate_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ServedNRCellsToActivate_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ServedNRCellsToActivate_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ServedNRCellsToActivate_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ServedNRCellsToActivate_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ServedNRCellsToActivate_Item_iE_Extensions__item__extensionValue._const_tab = ____ServedNRCellsToActivate_Item_iE_Extensions__item__extensionValue_tab
    ___ServedNRCellsToActivate_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ServedNRCellsToActivate_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ServedNRCellsToActivate_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ServedNRCellsToActivate_Item_iE_Extensions__item__id),
        ('criticality', ___ServedNRCellsToActivate_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___ServedNRCellsToActivate_Item_iE_Extensions__item__extensionValue),
        ])
    __ServedNRCellsToActivate_Item_iE_Extensions__item_._ext = None
    _ServedNRCellsToActivate_Item_iE_Extensions._cont = __ServedNRCellsToActivate_Item_iE_Extensions__item_
    _ServedNRCellsToActivate_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ServedNRCellsToActivate_Item._cont = ASN1Dict([
        ('nrCellID', _ServedNRCellsToActivate_Item_nrCellID),
        ('iE-Extensions', _ServedNRCellsToActivate_Item_iE_Extensions),
        ])
    ServedNRCellsToActivate_Item._ext = []
    
    #-----< ServedNRCellsToActivate-Item-ExtIEs >-----#
    ServedNRCellsToActivate_Item_ExtIEs = CLASS(name='ServedNRCellsToActivate-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ServedNRCellsToActivate_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ENDCCellActivationResponse >-----#
    ENDCCellActivationResponse = SEQ(name='ENDCCellActivationResponse', mode=MODE_TYPE)
    _ENDCCellActivationResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __ENDCCellActivationResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___ENDCCellActivationResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____ENDCCellActivationResponse_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____ENDCCellActivationResponse_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ActivatedNRCellList')))
    _____ENDCCellActivationResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ActivationID')))
    _____ENDCCellActivationResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _____ENDCCellActivationResponse_protocolIEs__item__id_tab_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'InterfaceInstanceIndication')))
    ____ENDCCellActivationResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 268), ('criticality', 'ignore'), ('Value', _____ENDCCellActivationResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 256), ('criticality', 'reject'), ('Value', _____ENDCCellActivationResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _____ENDCCellActivationResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 335), ('criticality', 'reject'), ('Value', _____ENDCCellActivationResponse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ENDCCellActivationResponse_protocolIEs__item__id._const_tab = ____ENDCCellActivationResponse_protocolIEs__item__id_tab
    ___ENDCCellActivationResponse_protocolIEs__item__id._const_tab_at = None
    ___ENDCCellActivationResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___ENDCCellActivationResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___ENDCCellActivationResponse_protocolIEs__item__criticality._const_tab = ____ENDCCellActivationResponse_protocolIEs__item__id_tab
    ___ENDCCellActivationResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ENDCCellActivationResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ENDCCellActivationResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___ENDCCellActivationResponse_protocolIEs__item__value._const_tab = ____ENDCCellActivationResponse_protocolIEs__item__id_tab
    ___ENDCCellActivationResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ENDCCellActivationResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __ENDCCellActivationResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ENDCCellActivationResponse_protocolIEs__item__id),
        ('criticality', ___ENDCCellActivationResponse_protocolIEs__item__criticality),
        ('value', ___ENDCCellActivationResponse_protocolIEs__item__value),
        ])
    __ENDCCellActivationResponse_protocolIEs__item_._ext = None
    _ENDCCellActivationResponse_protocolIEs._cont = __ENDCCellActivationResponse_protocolIEs__item_
    _ENDCCellActivationResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ENDCCellActivationResponse._cont = ASN1Dict([
        ('protocolIEs', _ENDCCellActivationResponse_protocolIEs),
        ])
    ENDCCellActivationResponse._ext = []
    
    #-----< ENDCCellActivationResponse-IEs >-----#
    ENDCCellActivationResponse_IEs = CLASS(name='ENDCCellActivationResponse-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _ENDCCellActivationResponse_IEs_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ActivatedNRCellList')))
    _ENDCCellActivationResponse_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ActivationID')))
    _ENDCCellActivationResponse_IEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _ENDCCellActivationResponse_IEs_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'InterfaceInstanceIndication')))
    ENDCCellActivationResponse_IEs._val = ASN1Set(rv=[dict([('id', 268), ('criticality', 'ignore'), ('Value', _ENDCCellActivationResponse_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 256), ('criticality', 'reject'), ('Value', _ENDCCellActivationResponse_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _ENDCCellActivationResponse_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 335), ('criticality', 'reject'), ('Value', _ENDCCellActivationResponse_IEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ActivatedNRCellList >-----#
    ActivatedNRCellList = SEQ_OF(name='ActivatedNRCellList', mode=MODE_TYPE)
    _ActivatedNRCellList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ActivatedNRCellList-Item')))
    ActivatedNRCellList._cont = _ActivatedNRCellList__item_
    ActivatedNRCellList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16384)], ev=None, er=[])
    
    #-----< ActivatedNRCellList-Item >-----#
    ActivatedNRCellList_Item = SEQ(name='ActivatedNRCellList-Item', mode=MODE_TYPE)
    _ActivatedNRCellList_Item_nrCellID = SEQ(name='nrCellID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'NRCGI')))
    _ActivatedNRCellList_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ActivatedNRCellList_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___ActivatedNRCellList_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____ActivatedNRCellList_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ActivatedNRCellList_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ActivatedNRCellList_Item_iE_Extensions__item__id._const_tab = ____ActivatedNRCellList_Item_iE_Extensions__item__id_tab
    ___ActivatedNRCellList_Item_iE_Extensions__item__id._const_tab_at = None
    ___ActivatedNRCellList_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___ActivatedNRCellList_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ActivatedNRCellList_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ActivatedNRCellList_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ActivatedNRCellList_Item_iE_Extensions__item__criticality._const_tab = ____ActivatedNRCellList_Item_iE_Extensions__item__criticality_tab
    ___ActivatedNRCellList_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ActivatedNRCellList_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ActivatedNRCellList_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ActivatedNRCellList_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____ActivatedNRCellList_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ActivatedNRCellList_Item_iE_Extensions__item__extensionValue._const_tab = ____ActivatedNRCellList_Item_iE_Extensions__item__extensionValue_tab
    ___ActivatedNRCellList_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ActivatedNRCellList_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ActivatedNRCellList_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ActivatedNRCellList_Item_iE_Extensions__item__id),
        ('criticality', ___ActivatedNRCellList_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___ActivatedNRCellList_Item_iE_Extensions__item__extensionValue),
        ])
    __ActivatedNRCellList_Item_iE_Extensions__item_._ext = None
    _ActivatedNRCellList_Item_iE_Extensions._cont = __ActivatedNRCellList_Item_iE_Extensions__item_
    _ActivatedNRCellList_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ActivatedNRCellList_Item._cont = ASN1Dict([
        ('nrCellID', _ActivatedNRCellList_Item_nrCellID),
        ('iE-Extensions', _ActivatedNRCellList_Item_iE_Extensions),
        ])
    ActivatedNRCellList_Item._ext = []
    
    #-----< ActivatedNRCellList-Item-ExtIEs >-----#
    ActivatedNRCellList_Item_ExtIEs = CLASS(name='ActivatedNRCellList-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ActivatedNRCellList_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ENDCCellActivationFailure >-----#
    ENDCCellActivationFailure = SEQ(name='ENDCCellActivationFailure', mode=MODE_TYPE)
    _ENDCCellActivationFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __ENDCCellActivationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___ENDCCellActivationFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____ENDCCellActivationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____ENDCCellActivationFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ActivationID')))
    _____ENDCCellActivationFailure_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _____ENDCCellActivationFailure_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _____ENDCCellActivationFailure_protocolIEs__item__id_tab_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'InterfaceInstanceIndication')))
    ____ENDCCellActivationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 256), ('criticality', 'reject'), ('Value', _____ENDCCellActivationFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _____ENDCCellActivationFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _____ENDCCellActivationFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 335), ('criticality', 'reject'), ('Value', _____ENDCCellActivationFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ENDCCellActivationFailure_protocolIEs__item__id._const_tab = ____ENDCCellActivationFailure_protocolIEs__item__id_tab
    ___ENDCCellActivationFailure_protocolIEs__item__id._const_tab_at = None
    ___ENDCCellActivationFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___ENDCCellActivationFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___ENDCCellActivationFailure_protocolIEs__item__criticality._const_tab = ____ENDCCellActivationFailure_protocolIEs__item__id_tab
    ___ENDCCellActivationFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ENDCCellActivationFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ENDCCellActivationFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___ENDCCellActivationFailure_protocolIEs__item__value._const_tab = ____ENDCCellActivationFailure_protocolIEs__item__id_tab
    ___ENDCCellActivationFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ENDCCellActivationFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __ENDCCellActivationFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ENDCCellActivationFailure_protocolIEs__item__id),
        ('criticality', ___ENDCCellActivationFailure_protocolIEs__item__criticality),
        ('value', ___ENDCCellActivationFailure_protocolIEs__item__value),
        ])
    __ENDCCellActivationFailure_protocolIEs__item_._ext = None
    _ENDCCellActivationFailure_protocolIEs._cont = __ENDCCellActivationFailure_protocolIEs__item_
    _ENDCCellActivationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ENDCCellActivationFailure._cont = ASN1Dict([
        ('protocolIEs', _ENDCCellActivationFailure_protocolIEs),
        ])
    ENDCCellActivationFailure._ext = []
    
    #-----< ENDCCellActivationFailure-IEs >-----#
    ENDCCellActivationFailure_IEs = CLASS(name='ENDCCellActivationFailure-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _ENDCCellActivationFailure_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ActivationID')))
    _ENDCCellActivationFailure_IEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _ENDCCellActivationFailure_IEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _ENDCCellActivationFailure_IEs_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'InterfaceInstanceIndication')))
    ENDCCellActivationFailure_IEs._val = ASN1Set(rv=[dict([('id', 256), ('criticality', 'reject'), ('Value', _ENDCCellActivationFailure_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _ENDCCellActivationFailure_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _ENDCCellActivationFailure_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 335), ('criticality', 'reject'), ('Value', _ENDCCellActivationFailure_IEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ENDCResourceStatusRequest >-----#
    ENDCResourceStatusRequest = SEQ(name='ENDCResourceStatusRequest', mode=MODE_TYPE)
    _ENDCResourceStatusRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __ENDCResourceStatusRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___ENDCResourceStatusRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____ENDCResourceStatusRequest_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____ENDCResourceStatusRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Measurement-ID-ENDC')))
    _____ENDCResourceStatusRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Measurement-ID-ENDC')))
    _____ENDCResourceStatusRequest_protocolIEs__item__id_tab_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Registration-Request-ENDC')))
    _____ENDCResourceStatusRequest_protocolIEs__item__id_tab_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ReportingPeriodicity-ENDC')))
    _____ENDCResourceStatusRequest_protocolIEs__item__id_tab_val_Value_4 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ReportCharacteristics-ENDC')))
    _____ENDCResourceStatusRequest_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellToReport-NR-ENDC-List')))
    _____ENDCResourceStatusRequest_protocolIEs__item__id_tab_val_Value_6 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'InterfaceInstanceIndication')))
    _____ENDCResourceStatusRequest_protocolIEs__item__id_tab_val_Value_7 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellToReport-E-UTRA-ENDC-List')))
    ____ENDCResourceStatusRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 383), ('criticality', 'reject'), ('Value', _____ENDCResourceStatusRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 384), ('criticality', 'ignore'), ('Value', _____ENDCResourceStatusRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'conditional')]), dict([('id', 28), ('criticality', 'reject'), ('Value', _____ENDCResourceStatusRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 30), ('criticality', 'ignore'), ('Value', _____ENDCResourceStatusRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 38), ('criticality', 'ignore'), ('Value', _____ENDCResourceStatusRequest_protocolIEs__item__id_tab_val_Value_4), ('presence', 'conditional')]), dict([('id', 391), ('criticality', 'ignore'), ('Value', _____ENDCResourceStatusRequest_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 335), ('criticality', 'reject'), ('Value', _____ENDCResourceStatusRequest_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 403), ('criticality', 'ignore'), ('Value', _____ENDCResourceStatusRequest_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ENDCResourceStatusRequest_protocolIEs__item__id._const_tab = ____ENDCResourceStatusRequest_protocolIEs__item__id_tab
    ___ENDCResourceStatusRequest_protocolIEs__item__id._const_tab_at = None
    ___ENDCResourceStatusRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___ENDCResourceStatusRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___ENDCResourceStatusRequest_protocolIEs__item__criticality._const_tab = ____ENDCResourceStatusRequest_protocolIEs__item__id_tab
    ___ENDCResourceStatusRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ENDCResourceStatusRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ENDCResourceStatusRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___ENDCResourceStatusRequest_protocolIEs__item__value._const_tab = ____ENDCResourceStatusRequest_protocolIEs__item__id_tab
    ___ENDCResourceStatusRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ENDCResourceStatusRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __ENDCResourceStatusRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ENDCResourceStatusRequest_protocolIEs__item__id),
        ('criticality', ___ENDCResourceStatusRequest_protocolIEs__item__criticality),
        ('value', ___ENDCResourceStatusRequest_protocolIEs__item__value),
        ])
    __ENDCResourceStatusRequest_protocolIEs__item_._ext = None
    _ENDCResourceStatusRequest_protocolIEs._cont = __ENDCResourceStatusRequest_protocolIEs__item_
    _ENDCResourceStatusRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ENDCResourceStatusRequest._cont = ASN1Dict([
        ('protocolIEs', _ENDCResourceStatusRequest_protocolIEs),
        ])
    ENDCResourceStatusRequest._ext = []
    
    #-----< ENDCResourceStatusRequest-IEs >-----#
    ENDCResourceStatusRequest_IEs = CLASS(name='ENDCResourceStatusRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _ENDCResourceStatusRequest_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Measurement-ID-ENDC')))
    _ENDCResourceStatusRequest_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Measurement-ID-ENDC')))
    _ENDCResourceStatusRequest_IEs_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Registration-Request-ENDC')))
    _ENDCResourceStatusRequest_IEs_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ReportingPeriodicity-ENDC')))
    _ENDCResourceStatusRequest_IEs_val_Value_4 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ReportCharacteristics-ENDC')))
    _ENDCResourceStatusRequest_IEs_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellToReport-NR-ENDC-List')))
    _ENDCResourceStatusRequest_IEs_val_Value_6 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'InterfaceInstanceIndication')))
    _ENDCResourceStatusRequest_IEs_val_Value_7 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellToReport-E-UTRA-ENDC-List')))
    ENDCResourceStatusRequest_IEs._val = ASN1Set(rv=[dict([('id', 383), ('criticality', 'reject'), ('Value', _ENDCResourceStatusRequest_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 384), ('criticality', 'ignore'), ('Value', _ENDCResourceStatusRequest_IEs_val_Value_1), ('presence', 'conditional')]), dict([('id', 28), ('criticality', 'reject'), ('Value', _ENDCResourceStatusRequest_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 30), ('criticality', 'ignore'), ('Value', _ENDCResourceStatusRequest_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 38), ('criticality', 'ignore'), ('Value', _ENDCResourceStatusRequest_IEs_val_Value_4), ('presence', 'conditional')]), dict([('id', 391), ('criticality', 'ignore'), ('Value', _ENDCResourceStatusRequest_IEs_val_Value_5), ('presence', 'optional')]), dict([('id', 335), ('criticality', 'reject'), ('Value', _ENDCResourceStatusRequest_IEs_val_Value_6), ('presence', 'optional')]), dict([('id', 403), ('criticality', 'ignore'), ('Value', _ENDCResourceStatusRequest_IEs_val_Value_7), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ReportingPeriodicity-ENDC >-----#
    ReportingPeriodicity_ENDC = ENUM(name='ReportingPeriodicity-ENDC', mode=MODE_TYPE)
    ReportingPeriodicity_ENDC._cont = ASN1Dict([('ms500', 0), ('ms1000', 1), ('ms2000', 2), ('ms5000', 3), ('ms10000', 4)])
    ReportingPeriodicity_ENDC._ext = []
    
    #-----< CellToReport-NR-ENDC-List >-----#
    CellToReport_NR_ENDC_List = SEQ_OF(name='CellToReport-NR-ENDC-List', mode=MODE_TYPE)
    _CellToReport_NR_ENDC_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __CellToReport_NR_ENDC_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ___CellToReport_NR_ENDC_List__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____CellToReport_NR_ENDC_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellToReport-NR-ENDC-Item')))
    ___CellToReport_NR_ENDC_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 392), ('criticality', 'ignore'), ('Value', ____CellToReport_NR_ENDC_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __CellToReport_NR_ENDC_List__item__id._const_tab = ___CellToReport_NR_ENDC_List__item__id_tab
    __CellToReport_NR_ENDC_List__item__id._const_tab_at = None
    __CellToReport_NR_ENDC_List__item__id._const_tab_id = 'id'
    __CellToReport_NR_ENDC_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    __CellToReport_NR_ENDC_List__item__criticality._const_tab = ___CellToReport_NR_ENDC_List__item__id_tab
    __CellToReport_NR_ENDC_List__item__criticality._const_tab_at = ('..', 'id')
    __CellToReport_NR_ENDC_List__item__criticality._const_tab_id = 'criticality'
    __CellToReport_NR_ENDC_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    __CellToReport_NR_ENDC_List__item__value._const_tab = ___CellToReport_NR_ENDC_List__item__id_tab
    __CellToReport_NR_ENDC_List__item__value._const_tab_at = ('..', 'id')
    __CellToReport_NR_ENDC_List__item__value._const_tab_id = 'Value'
    _CellToReport_NR_ENDC_List__item_._cont = ASN1Dict([
        ('id', __CellToReport_NR_ENDC_List__item__id),
        ('criticality', __CellToReport_NR_ENDC_List__item__criticality),
        ('value', __CellToReport_NR_ENDC_List__item__value),
        ])
    _CellToReport_NR_ENDC_List__item_._ext = None
    CellToReport_NR_ENDC_List._cont = _CellToReport_NR_ENDC_List__item_
    CellToReport_NR_ENDC_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16384)], ev=None, er=[])
    
    #-----< CellToReport-NR-ENDC-ItemIEs >-----#
    CellToReport_NR_ENDC_ItemIEs = CLASS(name='CellToReport-NR-ENDC-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _CellToReport_NR_ENDC_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellToReport-NR-ENDC-Item')))
    CellToReport_NR_ENDC_ItemIEs._val = ASN1Set(rv=[dict([('id', 392), ('criticality', 'ignore'), ('Value', _CellToReport_NR_ENDC_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< CellToReport-NR-ENDC-Item >-----#
    CellToReport_NR_ENDC_Item = SEQ(name='CellToReport-NR-ENDC-Item', mode=MODE_TYPE)
    _CellToReport_NR_ENDC_Item_nr_cell_ID = SEQ(name='nr-cell-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'NRCGI')))
    _CellToReport_NR_ENDC_Item_ssbToReport_List = SEQ_OF(name='ssbToReport-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Contents', 'SSBToReport-List')), opt=True)
    _CellToReport_NR_ENDC_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellToReport_NR_ENDC_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___CellToReport_NR_ENDC_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____CellToReport_NR_ENDC_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CellToReport_NR_ENDC_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellToReport_NR_ENDC_Item_iE_Extensions__item__id._const_tab = ____CellToReport_NR_ENDC_Item_iE_Extensions__item__id_tab
    ___CellToReport_NR_ENDC_Item_iE_Extensions__item__id._const_tab_at = None
    ___CellToReport_NR_ENDC_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___CellToReport_NR_ENDC_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CellToReport_NR_ENDC_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CellToReport_NR_ENDC_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellToReport_NR_ENDC_Item_iE_Extensions__item__criticality._const_tab = ____CellToReport_NR_ENDC_Item_iE_Extensions__item__criticality_tab
    ___CellToReport_NR_ENDC_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CellToReport_NR_ENDC_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CellToReport_NR_ENDC_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CellToReport_NR_ENDC_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CellToReport_NR_ENDC_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellToReport_NR_ENDC_Item_iE_Extensions__item__extensionValue._const_tab = ____CellToReport_NR_ENDC_Item_iE_Extensions__item__extensionValue_tab
    ___CellToReport_NR_ENDC_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellToReport_NR_ENDC_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CellToReport_NR_ENDC_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CellToReport_NR_ENDC_Item_iE_Extensions__item__id),
        ('criticality', ___CellToReport_NR_ENDC_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___CellToReport_NR_ENDC_Item_iE_Extensions__item__extensionValue),
        ])
    __CellToReport_NR_ENDC_Item_iE_Extensions__item_._ext = None
    _CellToReport_NR_ENDC_Item_iE_Extensions._cont = __CellToReport_NR_ENDC_Item_iE_Extensions__item_
    _CellToReport_NR_ENDC_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellToReport_NR_ENDC_Item._cont = ASN1Dict([
        ('nr-cell-ID', _CellToReport_NR_ENDC_Item_nr_cell_ID),
        ('ssbToReport-List', _CellToReport_NR_ENDC_Item_ssbToReport_List),
        ('iE-Extensions', _CellToReport_NR_ENDC_Item_iE_Extensions),
        ])
    CellToReport_NR_ENDC_Item._ext = []
    
    #-----< CellToReport-NR-ENDC-Item-ExtIEs >-----#
    CellToReport_NR_ENDC_Item_ExtIEs = CLASS(name='CellToReport-NR-ENDC-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    CellToReport_NR_ENDC_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellToReport-E-UTRA-ENDC-List >-----#
    CellToReport_E_UTRA_ENDC_List = SEQ_OF(name='CellToReport-E-UTRA-ENDC-List', mode=MODE_TYPE)
    _CellToReport_E_UTRA_ENDC_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __CellToReport_E_UTRA_ENDC_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ___CellToReport_E_UTRA_ENDC_List__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____CellToReport_E_UTRA_ENDC_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellToReport-E-UTRA-ENDC-Item')))
    ___CellToReport_E_UTRA_ENDC_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 404), ('criticality', 'ignore'), ('Value', ____CellToReport_E_UTRA_ENDC_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __CellToReport_E_UTRA_ENDC_List__item__id._const_tab = ___CellToReport_E_UTRA_ENDC_List__item__id_tab
    __CellToReport_E_UTRA_ENDC_List__item__id._const_tab_at = None
    __CellToReport_E_UTRA_ENDC_List__item__id._const_tab_id = 'id'
    __CellToReport_E_UTRA_ENDC_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    __CellToReport_E_UTRA_ENDC_List__item__criticality._const_tab = ___CellToReport_E_UTRA_ENDC_List__item__id_tab
    __CellToReport_E_UTRA_ENDC_List__item__criticality._const_tab_at = ('..', 'id')
    __CellToReport_E_UTRA_ENDC_List__item__criticality._const_tab_id = 'criticality'
    __CellToReport_E_UTRA_ENDC_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    __CellToReport_E_UTRA_ENDC_List__item__value._const_tab = ___CellToReport_E_UTRA_ENDC_List__item__id_tab
    __CellToReport_E_UTRA_ENDC_List__item__value._const_tab_at = ('..', 'id')
    __CellToReport_E_UTRA_ENDC_List__item__value._const_tab_id = 'Value'
    _CellToReport_E_UTRA_ENDC_List__item_._cont = ASN1Dict([
        ('id', __CellToReport_E_UTRA_ENDC_List__item__id),
        ('criticality', __CellToReport_E_UTRA_ENDC_List__item__criticality),
        ('value', __CellToReport_E_UTRA_ENDC_List__item__value),
        ])
    _CellToReport_E_UTRA_ENDC_List__item_._ext = None
    CellToReport_E_UTRA_ENDC_List._cont = _CellToReport_E_UTRA_ENDC_List__item_
    CellToReport_E_UTRA_ENDC_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< CellToReport-E-UTRA-ENDC-Item-IEs >-----#
    CellToReport_E_UTRA_ENDC_Item_IEs = CLASS(name='CellToReport-E-UTRA-ENDC-Item-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _CellToReport_E_UTRA_ENDC_Item_IEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellToReport-E-UTRA-ENDC-Item')))
    CellToReport_E_UTRA_ENDC_Item_IEs._val = ASN1Set(rv=[dict([('id', 404), ('criticality', 'ignore'), ('Value', _CellToReport_E_UTRA_ENDC_Item_IEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< CellToReport-E-UTRA-ENDC-Item >-----#
    CellToReport_E_UTRA_ENDC_Item = SEQ(name='CellToReport-E-UTRA-ENDC-Item', mode=MODE_TYPE)
    _CellToReport_E_UTRA_ENDC_Item_e_utra_cell_ID = SEQ(name='e-utra-cell-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _CellToReport_E_UTRA_ENDC_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellToReport_E_UTRA_ENDC_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___CellToReport_E_UTRA_ENDC_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____CellToReport_E_UTRA_ENDC_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CellToReport_E_UTRA_ENDC_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellToReport_E_UTRA_ENDC_Item_iE_Extensions__item__id._const_tab = ____CellToReport_E_UTRA_ENDC_Item_iE_Extensions__item__id_tab
    ___CellToReport_E_UTRA_ENDC_Item_iE_Extensions__item__id._const_tab_at = None
    ___CellToReport_E_UTRA_ENDC_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___CellToReport_E_UTRA_ENDC_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CellToReport_E_UTRA_ENDC_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CellToReport_E_UTRA_ENDC_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellToReport_E_UTRA_ENDC_Item_iE_Extensions__item__criticality._const_tab = ____CellToReport_E_UTRA_ENDC_Item_iE_Extensions__item__criticality_tab
    ___CellToReport_E_UTRA_ENDC_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CellToReport_E_UTRA_ENDC_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CellToReport_E_UTRA_ENDC_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CellToReport_E_UTRA_ENDC_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CellToReport_E_UTRA_ENDC_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellToReport_E_UTRA_ENDC_Item_iE_Extensions__item__extensionValue._const_tab = ____CellToReport_E_UTRA_ENDC_Item_iE_Extensions__item__extensionValue_tab
    ___CellToReport_E_UTRA_ENDC_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellToReport_E_UTRA_ENDC_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CellToReport_E_UTRA_ENDC_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CellToReport_E_UTRA_ENDC_Item_iE_Extensions__item__id),
        ('criticality', ___CellToReport_E_UTRA_ENDC_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___CellToReport_E_UTRA_ENDC_Item_iE_Extensions__item__extensionValue),
        ])
    __CellToReport_E_UTRA_ENDC_Item_iE_Extensions__item_._ext = None
    _CellToReport_E_UTRA_ENDC_Item_iE_Extensions._cont = __CellToReport_E_UTRA_ENDC_Item_iE_Extensions__item_
    _CellToReport_E_UTRA_ENDC_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellToReport_E_UTRA_ENDC_Item._cont = ASN1Dict([
        ('e-utra-cell-ID', _CellToReport_E_UTRA_ENDC_Item_e_utra_cell_ID),
        ('iE-Extensions', _CellToReport_E_UTRA_ENDC_Item_iE_Extensions),
        ])
    CellToReport_E_UTRA_ENDC_Item._ext = []
    
    #-----< CellToReport-E-UTRA-ENDC-Item-ExtIEs >-----#
    CellToReport_E_UTRA_ENDC_Item_ExtIEs = CLASS(name='CellToReport-E-UTRA-ENDC-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    CellToReport_E_UTRA_ENDC_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SSBToReport-List >-----#
    SSBToReport_List = SEQ_OF(name='SSBToReport-List', mode=MODE_TYPE)
    _SSBToReport_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SSBToReport-Item')))
    SSBToReport_List._cont = _SSBToReport_List__item_
    SSBToReport_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< SSBToReport-Item >-----#
    SSBToReport_Item = SEQ(name='SSBToReport-Item', mode=MODE_TYPE)
    _SSBToReport_Item_ssbIndex = INT(name='ssbIndex', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'SSBIndex')))
    _SSBToReport_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SSBToReport_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___SSBToReport_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____SSBToReport_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____SSBToReport_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSBToReport_Item_iE_Extensions__item__id._const_tab = ____SSBToReport_Item_iE_Extensions__item__id_tab
    ___SSBToReport_Item_iE_Extensions__item__id._const_tab_at = None
    ___SSBToReport_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___SSBToReport_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SSBToReport_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____SSBToReport_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSBToReport_Item_iE_Extensions__item__criticality._const_tab = ____SSBToReport_Item_iE_Extensions__item__criticality_tab
    ___SSBToReport_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SSBToReport_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SSBToReport_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SSBToReport_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____SSBToReport_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSBToReport_Item_iE_Extensions__item__extensionValue._const_tab = ____SSBToReport_Item_iE_Extensions__item__extensionValue_tab
    ___SSBToReport_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SSBToReport_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SSBToReport_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SSBToReport_Item_iE_Extensions__item__id),
        ('criticality', ___SSBToReport_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___SSBToReport_Item_iE_Extensions__item__extensionValue),
        ])
    __SSBToReport_Item_iE_Extensions__item_._ext = None
    _SSBToReport_Item_iE_Extensions._cont = __SSBToReport_Item_iE_Extensions__item_
    _SSBToReport_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SSBToReport_Item._cont = ASN1Dict([
        ('ssbIndex', _SSBToReport_Item_ssbIndex),
        ('iE-Extensions', _SSBToReport_Item_iE_Extensions),
        ])
    SSBToReport_Item._ext = []
    
    #-----< SSBToReport-Item-ExtIEs >-----#
    SSBToReport_Item_ExtIEs = CLASS(name='SSBToReport-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    SSBToReport_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ENDCResourceStatusResponse >-----#
    ENDCResourceStatusResponse = SEQ(name='ENDCResourceStatusResponse', mode=MODE_TYPE)
    _ENDCResourceStatusResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __ENDCResourceStatusResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___ENDCResourceStatusResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____ENDCResourceStatusResponse_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____ENDCResourceStatusResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Measurement-ID-ENDC')))
    _____ENDCResourceStatusResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Measurement-ID-ENDC')))
    _____ENDCResourceStatusResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _____ENDCResourceStatusResponse_protocolIEs__item__id_tab_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'InterfaceInstanceIndication')))
    ____ENDCResourceStatusResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 383), ('criticality', 'reject'), ('Value', _____ENDCResourceStatusResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 384), ('criticality', 'reject'), ('Value', _____ENDCResourceStatusResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _____ENDCResourceStatusResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 335), ('criticality', 'reject'), ('Value', _____ENDCResourceStatusResponse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ENDCResourceStatusResponse_protocolIEs__item__id._const_tab = ____ENDCResourceStatusResponse_protocolIEs__item__id_tab
    ___ENDCResourceStatusResponse_protocolIEs__item__id._const_tab_at = None
    ___ENDCResourceStatusResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___ENDCResourceStatusResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___ENDCResourceStatusResponse_protocolIEs__item__criticality._const_tab = ____ENDCResourceStatusResponse_protocolIEs__item__id_tab
    ___ENDCResourceStatusResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ENDCResourceStatusResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ENDCResourceStatusResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___ENDCResourceStatusResponse_protocolIEs__item__value._const_tab = ____ENDCResourceStatusResponse_protocolIEs__item__id_tab
    ___ENDCResourceStatusResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ENDCResourceStatusResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __ENDCResourceStatusResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ENDCResourceStatusResponse_protocolIEs__item__id),
        ('criticality', ___ENDCResourceStatusResponse_protocolIEs__item__criticality),
        ('value', ___ENDCResourceStatusResponse_protocolIEs__item__value),
        ])
    __ENDCResourceStatusResponse_protocolIEs__item_._ext = None
    _ENDCResourceStatusResponse_protocolIEs._cont = __ENDCResourceStatusResponse_protocolIEs__item_
    _ENDCResourceStatusResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ENDCResourceStatusResponse._cont = ASN1Dict([
        ('protocolIEs', _ENDCResourceStatusResponse_protocolIEs),
        ])
    ENDCResourceStatusResponse._ext = []
    
    #-----< ENDCResourceStatusResponse-IEs >-----#
    ENDCResourceStatusResponse_IEs = CLASS(name='ENDCResourceStatusResponse-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _ENDCResourceStatusResponse_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Measurement-ID-ENDC')))
    _ENDCResourceStatusResponse_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Measurement-ID-ENDC')))
    _ENDCResourceStatusResponse_IEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _ENDCResourceStatusResponse_IEs_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'InterfaceInstanceIndication')))
    ENDCResourceStatusResponse_IEs._val = ASN1Set(rv=[dict([('id', 383), ('criticality', 'reject'), ('Value', _ENDCResourceStatusResponse_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 384), ('criticality', 'reject'), ('Value', _ENDCResourceStatusResponse_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _ENDCResourceStatusResponse_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 335), ('criticality', 'reject'), ('Value', _ENDCResourceStatusResponse_IEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ENDCResourceStatusFailure >-----#
    ENDCResourceStatusFailure = SEQ(name='ENDCResourceStatusFailure', mode=MODE_TYPE)
    _ENDCResourceStatusFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __ENDCResourceStatusFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___ENDCResourceStatusFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____ENDCResourceStatusFailure_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____ENDCResourceStatusFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Measurement-ID-ENDC')))
    _____ENDCResourceStatusFailure_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Measurement-ID-ENDC')))
    _____ENDCResourceStatusFailure_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _____ENDCResourceStatusFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _____ENDCResourceStatusFailure_protocolIEs__item__id_tab_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'InterfaceInstanceIndication')))
    ____ENDCResourceStatusFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 383), ('criticality', 'reject'), ('Value', _____ENDCResourceStatusFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 384), ('criticality', 'reject'), ('Value', _____ENDCResourceStatusFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _____ENDCResourceStatusFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _____ENDCResourceStatusFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 335), ('criticality', 'reject'), ('Value', _____ENDCResourceStatusFailure_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ENDCResourceStatusFailure_protocolIEs__item__id._const_tab = ____ENDCResourceStatusFailure_protocolIEs__item__id_tab
    ___ENDCResourceStatusFailure_protocolIEs__item__id._const_tab_at = None
    ___ENDCResourceStatusFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___ENDCResourceStatusFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___ENDCResourceStatusFailure_protocolIEs__item__criticality._const_tab = ____ENDCResourceStatusFailure_protocolIEs__item__id_tab
    ___ENDCResourceStatusFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ENDCResourceStatusFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ENDCResourceStatusFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___ENDCResourceStatusFailure_protocolIEs__item__value._const_tab = ____ENDCResourceStatusFailure_protocolIEs__item__id_tab
    ___ENDCResourceStatusFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ENDCResourceStatusFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __ENDCResourceStatusFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ENDCResourceStatusFailure_protocolIEs__item__id),
        ('criticality', ___ENDCResourceStatusFailure_protocolIEs__item__criticality),
        ('value', ___ENDCResourceStatusFailure_protocolIEs__item__value),
        ])
    __ENDCResourceStatusFailure_protocolIEs__item_._ext = None
    _ENDCResourceStatusFailure_protocolIEs._cont = __ENDCResourceStatusFailure_protocolIEs__item_
    _ENDCResourceStatusFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ENDCResourceStatusFailure._cont = ASN1Dict([
        ('protocolIEs', _ENDCResourceStatusFailure_protocolIEs),
        ])
    ENDCResourceStatusFailure._ext = []
    
    #-----< ENDCResourceStatusFailure-IEs >-----#
    ENDCResourceStatusFailure_IEs = CLASS(name='ENDCResourceStatusFailure-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _ENDCResourceStatusFailure_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Measurement-ID-ENDC')))
    _ENDCResourceStatusFailure_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Measurement-ID-ENDC')))
    _ENDCResourceStatusFailure_IEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _ENDCResourceStatusFailure_IEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _ENDCResourceStatusFailure_IEs_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'InterfaceInstanceIndication')))
    ENDCResourceStatusFailure_IEs._val = ASN1Set(rv=[dict([('id', 383), ('criticality', 'reject'), ('Value', _ENDCResourceStatusFailure_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 384), ('criticality', 'reject'), ('Value', _ENDCResourceStatusFailure_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _ENDCResourceStatusFailure_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _ENDCResourceStatusFailure_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 335), ('criticality', 'reject'), ('Value', _ENDCResourceStatusFailure_IEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ENDCResourceStatusUpdate >-----#
    ENDCResourceStatusUpdate = SEQ(name='ENDCResourceStatusUpdate', mode=MODE_TYPE)
    _ENDCResourceStatusUpdate_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __ENDCResourceStatusUpdate_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___ENDCResourceStatusUpdate_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____ENDCResourceStatusUpdate_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____ENDCResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Measurement-ID-ENDC')))
    _____ENDCResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Measurement-ID-ENDC')))
    _____ENDCResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellMeasurementResult-NR-ENDC-List')))
    _____ENDCResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'InterfaceInstanceIndication')))
    _____ENDCResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellMeasurementResult-E-UTRA-ENDC-List')))
    ____ENDCResourceStatusUpdate_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 383), ('criticality', 'reject'), ('Value', _____ENDCResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 384), ('criticality', 'reject'), ('Value', _____ENDCResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 393), ('criticality', 'ignore'), ('Value', _____ENDCResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 335), ('criticality', 'reject'), ('Value', _____ENDCResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 401), ('criticality', 'ignore'), ('Value', _____ENDCResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ENDCResourceStatusUpdate_protocolIEs__item__id._const_tab = ____ENDCResourceStatusUpdate_protocolIEs__item__id_tab
    ___ENDCResourceStatusUpdate_protocolIEs__item__id._const_tab_at = None
    ___ENDCResourceStatusUpdate_protocolIEs__item__id._const_tab_id = 'id'
    ___ENDCResourceStatusUpdate_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___ENDCResourceStatusUpdate_protocolIEs__item__criticality._const_tab = ____ENDCResourceStatusUpdate_protocolIEs__item__id_tab
    ___ENDCResourceStatusUpdate_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ENDCResourceStatusUpdate_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ENDCResourceStatusUpdate_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___ENDCResourceStatusUpdate_protocolIEs__item__value._const_tab = ____ENDCResourceStatusUpdate_protocolIEs__item__id_tab
    ___ENDCResourceStatusUpdate_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ENDCResourceStatusUpdate_protocolIEs__item__value._const_tab_id = 'Value'
    __ENDCResourceStatusUpdate_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ENDCResourceStatusUpdate_protocolIEs__item__id),
        ('criticality', ___ENDCResourceStatusUpdate_protocolIEs__item__criticality),
        ('value', ___ENDCResourceStatusUpdate_protocolIEs__item__value),
        ])
    __ENDCResourceStatusUpdate_protocolIEs__item_._ext = None
    _ENDCResourceStatusUpdate_protocolIEs._cont = __ENDCResourceStatusUpdate_protocolIEs__item_
    _ENDCResourceStatusUpdate_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ENDCResourceStatusUpdate._cont = ASN1Dict([
        ('protocolIEs', _ENDCResourceStatusUpdate_protocolIEs),
        ])
    ENDCResourceStatusUpdate._ext = []
    
    #-----< ENDCResourceStatusUpdate-IEs >-----#
    ENDCResourceStatusUpdate_IEs = CLASS(name='ENDCResourceStatusUpdate-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _ENDCResourceStatusUpdate_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Measurement-ID-ENDC')))
    _ENDCResourceStatusUpdate_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Measurement-ID-ENDC')))
    _ENDCResourceStatusUpdate_IEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellMeasurementResult-NR-ENDC-List')))
    _ENDCResourceStatusUpdate_IEs_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'InterfaceInstanceIndication')))
    _ENDCResourceStatusUpdate_IEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellMeasurementResult-E-UTRA-ENDC-List')))
    ENDCResourceStatusUpdate_IEs._val = ASN1Set(rv=[dict([('id', 383), ('criticality', 'reject'), ('Value', _ENDCResourceStatusUpdate_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 384), ('criticality', 'reject'), ('Value', _ENDCResourceStatusUpdate_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 393), ('criticality', 'ignore'), ('Value', _ENDCResourceStatusUpdate_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 335), ('criticality', 'reject'), ('Value', _ENDCResourceStatusUpdate_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 401), ('criticality', 'ignore'), ('Value', _ENDCResourceStatusUpdate_IEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< CellMeasurementResult-NR-ENDC-List >-----#
    CellMeasurementResult_NR_ENDC_List = SEQ_OF(name='CellMeasurementResult-NR-ENDC-List', mode=MODE_TYPE)
    _CellMeasurementResult_NR_ENDC_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __CellMeasurementResult_NR_ENDC_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ___CellMeasurementResult_NR_ENDC_List__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____CellMeasurementResult_NR_ENDC_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellMeasurementResult-NR-ENDC-Item')))
    ___CellMeasurementResult_NR_ENDC_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 394), ('criticality', 'ignore'), ('Value', ____CellMeasurementResult_NR_ENDC_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __CellMeasurementResult_NR_ENDC_List__item__id._const_tab = ___CellMeasurementResult_NR_ENDC_List__item__id_tab
    __CellMeasurementResult_NR_ENDC_List__item__id._const_tab_at = None
    __CellMeasurementResult_NR_ENDC_List__item__id._const_tab_id = 'id'
    __CellMeasurementResult_NR_ENDC_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    __CellMeasurementResult_NR_ENDC_List__item__criticality._const_tab = ___CellMeasurementResult_NR_ENDC_List__item__id_tab
    __CellMeasurementResult_NR_ENDC_List__item__criticality._const_tab_at = ('..', 'id')
    __CellMeasurementResult_NR_ENDC_List__item__criticality._const_tab_id = 'criticality'
    __CellMeasurementResult_NR_ENDC_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    __CellMeasurementResult_NR_ENDC_List__item__value._const_tab = ___CellMeasurementResult_NR_ENDC_List__item__id_tab
    __CellMeasurementResult_NR_ENDC_List__item__value._const_tab_at = ('..', 'id')
    __CellMeasurementResult_NR_ENDC_List__item__value._const_tab_id = 'Value'
    _CellMeasurementResult_NR_ENDC_List__item_._cont = ASN1Dict([
        ('id', __CellMeasurementResult_NR_ENDC_List__item__id),
        ('criticality', __CellMeasurementResult_NR_ENDC_List__item__criticality),
        ('value', __CellMeasurementResult_NR_ENDC_List__item__value),
        ])
    _CellMeasurementResult_NR_ENDC_List__item_._ext = None
    CellMeasurementResult_NR_ENDC_List._cont = _CellMeasurementResult_NR_ENDC_List__item_
    CellMeasurementResult_NR_ENDC_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16384)], ev=None, er=[])
    
    #-----< CellMeasurementResult-NR-ENDC-ItemIEs >-----#
    CellMeasurementResult_NR_ENDC_ItemIEs = CLASS(name='CellMeasurementResult-NR-ENDC-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _CellMeasurementResult_NR_ENDC_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellMeasurementResult-NR-ENDC-Item')))
    CellMeasurementResult_NR_ENDC_ItemIEs._val = ASN1Set(rv=[dict([('id', 394), ('criticality', 'ignore'), ('Value', _CellMeasurementResult_NR_ENDC_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< CellMeasurementResult-NR-ENDC-Item >-----#
    CellMeasurementResult_NR_ENDC_Item = SEQ(name='CellMeasurementResult-NR-ENDC-Item', mode=MODE_TYPE)
    _CellMeasurementResult_NR_ENDC_Item_nr_cell_ID = SEQ(name='nr-cell-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'NRCGI')))
    _CellMeasurementResult_NR_ENDC_Item_nr_radioResourceStatus = SEQ(name='nr-radioResourceStatus', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'NRRadioResourceStatus')), opt=True)
    _CellMeasurementResult_NR_ENDC_Item_tnlCapacityIndicator = SEQ(name='tnlCapacityIndicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'TNLCapacityIndicator')), opt=True)
    _CellMeasurementResult_NR_ENDC_Item_nr_compositeAvailableCapacityGroup = SEQ(name='nr-compositeAvailableCapacityGroup', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'NRCompositeAvailableCapacityGroup')), opt=True)
    _CellMeasurementResult_NR_ENDC_Item_numberofActiveUEs = INT(name='numberofActiveUEs', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CellMeasurementResult_NR_ENDC_Item_numberofActiveUEs._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16777215)], ev=[], er=[])
    _CellMeasurementResult_NR_ENDC_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellMeasurementResult_NR_ENDC_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___CellMeasurementResult_NR_ENDC_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____CellMeasurementResult_NR_ENDC_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CellMeasurementResult_NR_ENDC_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellMeasurementResult_NR_ENDC_Item_iE_Extensions__item__id._const_tab = ____CellMeasurementResult_NR_ENDC_Item_iE_Extensions__item__id_tab
    ___CellMeasurementResult_NR_ENDC_Item_iE_Extensions__item__id._const_tab_at = None
    ___CellMeasurementResult_NR_ENDC_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___CellMeasurementResult_NR_ENDC_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CellMeasurementResult_NR_ENDC_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CellMeasurementResult_NR_ENDC_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellMeasurementResult_NR_ENDC_Item_iE_Extensions__item__criticality._const_tab = ____CellMeasurementResult_NR_ENDC_Item_iE_Extensions__item__criticality_tab
    ___CellMeasurementResult_NR_ENDC_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CellMeasurementResult_NR_ENDC_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CellMeasurementResult_NR_ENDC_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CellMeasurementResult_NR_ENDC_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CellMeasurementResult_NR_ENDC_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellMeasurementResult_NR_ENDC_Item_iE_Extensions__item__extensionValue._const_tab = ____CellMeasurementResult_NR_ENDC_Item_iE_Extensions__item__extensionValue_tab
    ___CellMeasurementResult_NR_ENDC_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellMeasurementResult_NR_ENDC_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CellMeasurementResult_NR_ENDC_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CellMeasurementResult_NR_ENDC_Item_iE_Extensions__item__id),
        ('criticality', ___CellMeasurementResult_NR_ENDC_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___CellMeasurementResult_NR_ENDC_Item_iE_Extensions__item__extensionValue),
        ])
    __CellMeasurementResult_NR_ENDC_Item_iE_Extensions__item_._ext = None
    _CellMeasurementResult_NR_ENDC_Item_iE_Extensions._cont = __CellMeasurementResult_NR_ENDC_Item_iE_Extensions__item_
    _CellMeasurementResult_NR_ENDC_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellMeasurementResult_NR_ENDC_Item._cont = ASN1Dict([
        ('nr-cell-ID', _CellMeasurementResult_NR_ENDC_Item_nr_cell_ID),
        ('nr-radioResourceStatus', _CellMeasurementResult_NR_ENDC_Item_nr_radioResourceStatus),
        ('tnlCapacityIndicator', _CellMeasurementResult_NR_ENDC_Item_tnlCapacityIndicator),
        ('nr-compositeAvailableCapacityGroup', _CellMeasurementResult_NR_ENDC_Item_nr_compositeAvailableCapacityGroup),
        ('numberofActiveUEs', _CellMeasurementResult_NR_ENDC_Item_numberofActiveUEs),
        ('iE-Extensions', _CellMeasurementResult_NR_ENDC_Item_iE_Extensions),
        ])
    CellMeasurementResult_NR_ENDC_Item._ext = []
    
    #-----< CellMeasurementResult-NR-ENDC-Item-ExtIEs >-----#
    CellMeasurementResult_NR_ENDC_Item_ExtIEs = CLASS(name='CellMeasurementResult-NR-ENDC-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    CellMeasurementResult_NR_ENDC_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellMeasurementResult-E-UTRA-ENDC-List >-----#
    CellMeasurementResult_E_UTRA_ENDC_List = SEQ_OF(name='CellMeasurementResult-E-UTRA-ENDC-List', mode=MODE_TYPE)
    _CellMeasurementResult_E_UTRA_ENDC_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __CellMeasurementResult_E_UTRA_ENDC_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ___CellMeasurementResult_E_UTRA_ENDC_List__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____CellMeasurementResult_E_UTRA_ENDC_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellMeasurementResult-E-UTRA-ENDC-Item')))
    ___CellMeasurementResult_E_UTRA_ENDC_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 402), ('criticality', 'ignore'), ('Value', ____CellMeasurementResult_E_UTRA_ENDC_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __CellMeasurementResult_E_UTRA_ENDC_List__item__id._const_tab = ___CellMeasurementResult_E_UTRA_ENDC_List__item__id_tab
    __CellMeasurementResult_E_UTRA_ENDC_List__item__id._const_tab_at = None
    __CellMeasurementResult_E_UTRA_ENDC_List__item__id._const_tab_id = 'id'
    __CellMeasurementResult_E_UTRA_ENDC_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    __CellMeasurementResult_E_UTRA_ENDC_List__item__criticality._const_tab = ___CellMeasurementResult_E_UTRA_ENDC_List__item__id_tab
    __CellMeasurementResult_E_UTRA_ENDC_List__item__criticality._const_tab_at = ('..', 'id')
    __CellMeasurementResult_E_UTRA_ENDC_List__item__criticality._const_tab_id = 'criticality'
    __CellMeasurementResult_E_UTRA_ENDC_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    __CellMeasurementResult_E_UTRA_ENDC_List__item__value._const_tab = ___CellMeasurementResult_E_UTRA_ENDC_List__item__id_tab
    __CellMeasurementResult_E_UTRA_ENDC_List__item__value._const_tab_at = ('..', 'id')
    __CellMeasurementResult_E_UTRA_ENDC_List__item__value._const_tab_id = 'Value'
    _CellMeasurementResult_E_UTRA_ENDC_List__item_._cont = ASN1Dict([
        ('id', __CellMeasurementResult_E_UTRA_ENDC_List__item__id),
        ('criticality', __CellMeasurementResult_E_UTRA_ENDC_List__item__criticality),
        ('value', __CellMeasurementResult_E_UTRA_ENDC_List__item__value),
        ])
    _CellMeasurementResult_E_UTRA_ENDC_List__item_._ext = None
    CellMeasurementResult_E_UTRA_ENDC_List._cont = _CellMeasurementResult_E_UTRA_ENDC_List__item_
    CellMeasurementResult_E_UTRA_ENDC_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< CellMeasurementResult-E-UTRA-ENDC-ItemIEs >-----#
    CellMeasurementResult_E_UTRA_ENDC_ItemIEs = CLASS(name='CellMeasurementResult-E-UTRA-ENDC-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _CellMeasurementResult_E_UTRA_ENDC_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellMeasurementResult-E-UTRA-ENDC-Item')))
    CellMeasurementResult_E_UTRA_ENDC_ItemIEs._val = ASN1Set(rv=[dict([('id', 402), ('criticality', 'ignore'), ('Value', _CellMeasurementResult_E_UTRA_ENDC_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< CellMeasurementResult-E-UTRA-ENDC-Item >-----#
    CellMeasurementResult_E_UTRA_ENDC_Item = SEQ(name='CellMeasurementResult-E-UTRA-ENDC-Item', mode=MODE_TYPE)
    _CellMeasurementResult_E_UTRA_ENDC_Item_e_utra_cell_ID = SEQ(name='e-utra-cell-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    _CellMeasurementResult_E_UTRA_ENDC_Item_hWLoadIndicator = SEQ(name='hWLoadIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'HWLoadIndicator')), opt=True)
    _CellMeasurementResult_E_UTRA_ENDC_Item_s1TNLLoadIndicator = SEQ(name='s1TNLLoadIndicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'S1TNLLoadIndicator')), opt=True)
    _CellMeasurementResult_E_UTRA_ENDC_Item_radioResourceStatus = SEQ(name='radioResourceStatus', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'RadioResourceStatus')), opt=True)
    _CellMeasurementResult_E_UTRA_ENDC_Item_compositeAvailableCapacityGroup = SEQ(name='compositeAvailableCapacityGroup', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'CompositeAvailableCapacityGroup')), opt=True)
    _CellMeasurementResult_E_UTRA_ENDC_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellMeasurementResult_E_UTRA_ENDC_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___CellMeasurementResult_E_UTRA_ENDC_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____CellMeasurementResult_E_UTRA_ENDC_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CellMeasurementResult_E_UTRA_ENDC_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellMeasurementResult_E_UTRA_ENDC_Item_iE_Extensions__item__id._const_tab = ____CellMeasurementResult_E_UTRA_ENDC_Item_iE_Extensions__item__id_tab
    ___CellMeasurementResult_E_UTRA_ENDC_Item_iE_Extensions__item__id._const_tab_at = None
    ___CellMeasurementResult_E_UTRA_ENDC_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___CellMeasurementResult_E_UTRA_ENDC_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CellMeasurementResult_E_UTRA_ENDC_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CellMeasurementResult_E_UTRA_ENDC_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellMeasurementResult_E_UTRA_ENDC_Item_iE_Extensions__item__criticality._const_tab = ____CellMeasurementResult_E_UTRA_ENDC_Item_iE_Extensions__item__criticality_tab
    ___CellMeasurementResult_E_UTRA_ENDC_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CellMeasurementResult_E_UTRA_ENDC_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CellMeasurementResult_E_UTRA_ENDC_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CellMeasurementResult_E_UTRA_ENDC_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____CellMeasurementResult_E_UTRA_ENDC_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellMeasurementResult_E_UTRA_ENDC_Item_iE_Extensions__item__extensionValue._const_tab = ____CellMeasurementResult_E_UTRA_ENDC_Item_iE_Extensions__item__extensionValue_tab
    ___CellMeasurementResult_E_UTRA_ENDC_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellMeasurementResult_E_UTRA_ENDC_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CellMeasurementResult_E_UTRA_ENDC_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CellMeasurementResult_E_UTRA_ENDC_Item_iE_Extensions__item__id),
        ('criticality', ___CellMeasurementResult_E_UTRA_ENDC_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___CellMeasurementResult_E_UTRA_ENDC_Item_iE_Extensions__item__extensionValue),
        ])
    __CellMeasurementResult_E_UTRA_ENDC_Item_iE_Extensions__item_._ext = None
    _CellMeasurementResult_E_UTRA_ENDC_Item_iE_Extensions._cont = __CellMeasurementResult_E_UTRA_ENDC_Item_iE_Extensions__item_
    _CellMeasurementResult_E_UTRA_ENDC_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellMeasurementResult_E_UTRA_ENDC_Item._cont = ASN1Dict([
        ('e-utra-cell-ID', _CellMeasurementResult_E_UTRA_ENDC_Item_e_utra_cell_ID),
        ('hWLoadIndicator', _CellMeasurementResult_E_UTRA_ENDC_Item_hWLoadIndicator),
        ('s1TNLLoadIndicator', _CellMeasurementResult_E_UTRA_ENDC_Item_s1TNLLoadIndicator),
        ('radioResourceStatus', _CellMeasurementResult_E_UTRA_ENDC_Item_radioResourceStatus),
        ('compositeAvailableCapacityGroup', _CellMeasurementResult_E_UTRA_ENDC_Item_compositeAvailableCapacityGroup),
        ('iE-Extensions', _CellMeasurementResult_E_UTRA_ENDC_Item_iE_Extensions),
        ])
    CellMeasurementResult_E_UTRA_ENDC_Item._ext = []
    
    #-----< CellMeasurementResult-E-UTRA-ENDC-Item-ExtIEs >-----#
    CellMeasurementResult_E_UTRA_ENDC_Item_ExtIEs = CLASS(name='CellMeasurementResult-E-UTRA-ENDC-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    CellMeasurementResult_E_UTRA_ENDC_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SecondaryRATDataUsageReport >-----#
    SecondaryRATDataUsageReport = SEQ(name='SecondaryRATDataUsageReport', mode=MODE_TYPE)
    _SecondaryRATDataUsageReport_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __SecondaryRATDataUsageReport_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___SecondaryRATDataUsageReport_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____SecondaryRATDataUsageReport_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNB-UE-X2AP-ID')))
    _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SecondaryRATUsageReportList')))
    _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    ____SecondaryRATDataUsageReport_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'reject'), ('Value', _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 207), ('criticality', 'reject'), ('Value', _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 265), ('criticality', 'reject'), ('Value', _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 157), ('criticality', 'reject'), ('Value', _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SecondaryRATDataUsageReport_protocolIEs__item__id._const_tab = ____SecondaryRATDataUsageReport_protocolIEs__item__id_tab
    ___SecondaryRATDataUsageReport_protocolIEs__item__id._const_tab_at = None
    ___SecondaryRATDataUsageReport_protocolIEs__item__id._const_tab_id = 'id'
    ___SecondaryRATDataUsageReport_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___SecondaryRATDataUsageReport_protocolIEs__item__criticality._const_tab = ____SecondaryRATDataUsageReport_protocolIEs__item__id_tab
    ___SecondaryRATDataUsageReport_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___SecondaryRATDataUsageReport_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___SecondaryRATDataUsageReport_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___SecondaryRATDataUsageReport_protocolIEs__item__value._const_tab = ____SecondaryRATDataUsageReport_protocolIEs__item__id_tab
    ___SecondaryRATDataUsageReport_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___SecondaryRATDataUsageReport_protocolIEs__item__value._const_tab_id = 'Value'
    __SecondaryRATDataUsageReport_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___SecondaryRATDataUsageReport_protocolIEs__item__id),
        ('criticality', ___SecondaryRATDataUsageReport_protocolIEs__item__criticality),
        ('value', ___SecondaryRATDataUsageReport_protocolIEs__item__value),
        ])
    __SecondaryRATDataUsageReport_protocolIEs__item_._ext = None
    _SecondaryRATDataUsageReport_protocolIEs._cont = __SecondaryRATDataUsageReport_protocolIEs__item_
    _SecondaryRATDataUsageReport_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    SecondaryRATDataUsageReport._cont = ASN1Dict([
        ('protocolIEs', _SecondaryRATDataUsageReport_protocolIEs),
        ])
    SecondaryRATDataUsageReport._ext = []
    
    #-----< SecondaryRATDataUsageReport-IEs >-----#
    SecondaryRATDataUsageReport_IEs = CLASS(name='SecondaryRATDataUsageReport-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _SecondaryRATDataUsageReport_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SecondaryRATDataUsageReport_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNB-UE-X2AP-ID')))
    _SecondaryRATDataUsageReport_IEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SecondaryRATUsageReportList')))
    _SecondaryRATDataUsageReport_IEs_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    SecondaryRATDataUsageReport_IEs._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'reject'), ('Value', _SecondaryRATDataUsageReport_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 207), ('criticality', 'reject'), ('Value', _SecondaryRATDataUsageReport_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 265), ('criticality', 'reject'), ('Value', _SecondaryRATDataUsageReport_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 157), ('criticality', 'reject'), ('Value', _SecondaryRATDataUsageReport_IEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< SgNBActivityNotification >-----#
    SgNBActivityNotification = SEQ(name='SgNBActivityNotification', mode=MODE_TYPE)
    _SgNBActivityNotification_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __SgNBActivityNotification_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___SgNBActivityNotification_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____SgNBActivityNotification_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____SgNBActivityNotification_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____SgNBActivityNotification_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNB-UE-X2AP-ID')))
    _____SgNBActivityNotification_protocolIEs__item__id_tab_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UserPlaneTrafficActivityReport')))
    _____SgNBActivityNotification_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ERABActivityNotifyItemList')))
    _____SgNBActivityNotification_protocolIEs__item__id_tab_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    ____SgNBActivityNotification_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'reject'), ('Value', _____SgNBActivityNotification_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 207), ('criticality', 'reject'), ('Value', _____SgNBActivityNotification_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 296), ('criticality', 'ignore'), ('Value', _____SgNBActivityNotification_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 297), ('criticality', 'ignore'), ('Value', _____SgNBActivityNotification_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 157), ('criticality', 'reject'), ('Value', _____SgNBActivityNotification_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SgNBActivityNotification_protocolIEs__item__id._const_tab = ____SgNBActivityNotification_protocolIEs__item__id_tab
    ___SgNBActivityNotification_protocolIEs__item__id._const_tab_at = None
    ___SgNBActivityNotification_protocolIEs__item__id._const_tab_id = 'id'
    ___SgNBActivityNotification_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___SgNBActivityNotification_protocolIEs__item__criticality._const_tab = ____SgNBActivityNotification_protocolIEs__item__id_tab
    ___SgNBActivityNotification_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___SgNBActivityNotification_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___SgNBActivityNotification_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___SgNBActivityNotification_protocolIEs__item__value._const_tab = ____SgNBActivityNotification_protocolIEs__item__id_tab
    ___SgNBActivityNotification_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___SgNBActivityNotification_protocolIEs__item__value._const_tab_id = 'Value'
    __SgNBActivityNotification_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___SgNBActivityNotification_protocolIEs__item__id),
        ('criticality', ___SgNBActivityNotification_protocolIEs__item__criticality),
        ('value', ___SgNBActivityNotification_protocolIEs__item__value),
        ])
    __SgNBActivityNotification_protocolIEs__item_._ext = None
    _SgNBActivityNotification_protocolIEs._cont = __SgNBActivityNotification_protocolIEs__item_
    _SgNBActivityNotification_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    SgNBActivityNotification._cont = ASN1Dict([
        ('protocolIEs', _SgNBActivityNotification_protocolIEs),
        ])
    SgNBActivityNotification._ext = []
    
    #-----< SgNBActivityNotification-IEs >-----#
    SgNBActivityNotification_IEs = CLASS(name='SgNBActivityNotification-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _SgNBActivityNotification_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _SgNBActivityNotification_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNB-UE-X2AP-ID')))
    _SgNBActivityNotification_IEs_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UserPlaneTrafficActivityReport')))
    _SgNBActivityNotification_IEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ERABActivityNotifyItemList')))
    _SgNBActivityNotification_IEs_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    SgNBActivityNotification_IEs._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'reject'), ('Value', _SgNBActivityNotification_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 207), ('criticality', 'reject'), ('Value', _SgNBActivityNotification_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 296), ('criticality', 'ignore'), ('Value', _SgNBActivityNotification_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 297), ('criticality', 'ignore'), ('Value', _SgNBActivityNotification_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 157), ('criticality', 'reject'), ('Value', _SgNBActivityNotification_IEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ENDCPartialResetRequired >-----#
    ENDCPartialResetRequired = SEQ(name='ENDCPartialResetRequired', mode=MODE_TYPE)
    _ENDCPartialResetRequired_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __ENDCPartialResetRequired_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___ENDCPartialResetRequired_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____ENDCPartialResetRequired_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____ENDCPartialResetRequired_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UEsToBeResetList')))
    _____ENDCPartialResetRequired_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _____ENDCPartialResetRequired_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'InterfaceInstanceIndication')))
    ____ENDCPartialResetRequired_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 270), ('criticality', 'reject'), ('Value', _____ENDCPartialResetRequired_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _____ENDCPartialResetRequired_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 335), ('criticality', 'reject'), ('Value', _____ENDCPartialResetRequired_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ENDCPartialResetRequired_protocolIEs__item__id._const_tab = ____ENDCPartialResetRequired_protocolIEs__item__id_tab
    ___ENDCPartialResetRequired_protocolIEs__item__id._const_tab_at = None
    ___ENDCPartialResetRequired_protocolIEs__item__id._const_tab_id = 'id'
    ___ENDCPartialResetRequired_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___ENDCPartialResetRequired_protocolIEs__item__criticality._const_tab = ____ENDCPartialResetRequired_protocolIEs__item__id_tab
    ___ENDCPartialResetRequired_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ENDCPartialResetRequired_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ENDCPartialResetRequired_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___ENDCPartialResetRequired_protocolIEs__item__value._const_tab = ____ENDCPartialResetRequired_protocolIEs__item__id_tab
    ___ENDCPartialResetRequired_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ENDCPartialResetRequired_protocolIEs__item__value._const_tab_id = 'Value'
    __ENDCPartialResetRequired_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ENDCPartialResetRequired_protocolIEs__item__id),
        ('criticality', ___ENDCPartialResetRequired_protocolIEs__item__criticality),
        ('value', ___ENDCPartialResetRequired_protocolIEs__item__value),
        ])
    __ENDCPartialResetRequired_protocolIEs__item_._ext = None
    _ENDCPartialResetRequired_protocolIEs._cont = __ENDCPartialResetRequired_protocolIEs__item_
    _ENDCPartialResetRequired_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ENDCPartialResetRequired._cont = ASN1Dict([
        ('protocolIEs', _ENDCPartialResetRequired_protocolIEs),
        ])
    ENDCPartialResetRequired._ext = []
    
    #-----< ENDCPartialResetRequired-IEs >-----#
    ENDCPartialResetRequired_IEs = CLASS(name='ENDCPartialResetRequired-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _ENDCPartialResetRequired_IEs_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UEsToBeResetList')))
    _ENDCPartialResetRequired_IEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _ENDCPartialResetRequired_IEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'InterfaceInstanceIndication')))
    ENDCPartialResetRequired_IEs._val = ASN1Set(rv=[dict([('id', 270), ('criticality', 'reject'), ('Value', _ENDCPartialResetRequired_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _ENDCPartialResetRequired_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 335), ('criticality', 'reject'), ('Value', _ENDCPartialResetRequired_IEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ENDCPartialResetConfirm >-----#
    ENDCPartialResetConfirm = SEQ(name='ENDCPartialResetConfirm', mode=MODE_TYPE)
    _ENDCPartialResetConfirm_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __ENDCPartialResetConfirm_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___ENDCPartialResetConfirm_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____ENDCPartialResetConfirm_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____ENDCPartialResetConfirm_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UEsToBeResetList')))
    _____ENDCPartialResetConfirm_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'InterfaceInstanceIndication')))
    ____ENDCPartialResetConfirm_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 271), ('criticality', 'reject'), ('Value', _____ENDCPartialResetConfirm_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 335), ('criticality', 'reject'), ('Value', _____ENDCPartialResetConfirm_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ENDCPartialResetConfirm_protocolIEs__item__id._const_tab = ____ENDCPartialResetConfirm_protocolIEs__item__id_tab
    ___ENDCPartialResetConfirm_protocolIEs__item__id._const_tab_at = None
    ___ENDCPartialResetConfirm_protocolIEs__item__id._const_tab_id = 'id'
    ___ENDCPartialResetConfirm_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___ENDCPartialResetConfirm_protocolIEs__item__criticality._const_tab = ____ENDCPartialResetConfirm_protocolIEs__item__id_tab
    ___ENDCPartialResetConfirm_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ENDCPartialResetConfirm_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ENDCPartialResetConfirm_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___ENDCPartialResetConfirm_protocolIEs__item__value._const_tab = ____ENDCPartialResetConfirm_protocolIEs__item__id_tab
    ___ENDCPartialResetConfirm_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ENDCPartialResetConfirm_protocolIEs__item__value._const_tab_id = 'Value'
    __ENDCPartialResetConfirm_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ENDCPartialResetConfirm_protocolIEs__item__id),
        ('criticality', ___ENDCPartialResetConfirm_protocolIEs__item__criticality),
        ('value', ___ENDCPartialResetConfirm_protocolIEs__item__value),
        ])
    __ENDCPartialResetConfirm_protocolIEs__item_._ext = None
    _ENDCPartialResetConfirm_protocolIEs._cont = __ENDCPartialResetConfirm_protocolIEs__item_
    _ENDCPartialResetConfirm_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ENDCPartialResetConfirm._cont = ASN1Dict([
        ('protocolIEs', _ENDCPartialResetConfirm_protocolIEs),
        ])
    ENDCPartialResetConfirm._ext = []
    
    #-----< ENDCPartialResetConfirm-IEs >-----#
    ENDCPartialResetConfirm_IEs = CLASS(name='ENDCPartialResetConfirm-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _ENDCPartialResetConfirm_IEs_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UEsToBeResetList')))
    _ENDCPartialResetConfirm_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'InterfaceInstanceIndication')))
    ENDCPartialResetConfirm_IEs._val = ASN1Set(rv=[dict([('id', 271), ('criticality', 'reject'), ('Value', _ENDCPartialResetConfirm_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 335), ('criticality', 'reject'), ('Value', _ENDCPartialResetConfirm_IEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< EUTRANRCellResourceCoordinationRequest >-----#
    EUTRANRCellResourceCoordinationRequest = SEQ(name='EUTRANRCellResourceCoordinationRequest', mode=MODE_TYPE)
    _EUTRANRCellResourceCoordinationRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __EUTRANRCellResourceCoordinationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___EUTRANRCellResourceCoordinationRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____EUTRANRCellResourceCoordinationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____EUTRANRCellResourceCoordinationRequest_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'InitiatingNodeType-EutranrCellResourceCoordination')))
    _____EUTRANRCellResourceCoordinationRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'InterfaceInstanceIndication')))
    ____EUTRANRCellResourceCoordinationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 285), ('criticality', 'reject'), ('Value', _____EUTRANRCellResourceCoordinationRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 335), ('criticality', 'reject'), ('Value', _____EUTRANRCellResourceCoordinationRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___EUTRANRCellResourceCoordinationRequest_protocolIEs__item__id._const_tab = ____EUTRANRCellResourceCoordinationRequest_protocolIEs__item__id_tab
    ___EUTRANRCellResourceCoordinationRequest_protocolIEs__item__id._const_tab_at = None
    ___EUTRANRCellResourceCoordinationRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___EUTRANRCellResourceCoordinationRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___EUTRANRCellResourceCoordinationRequest_protocolIEs__item__criticality._const_tab = ____EUTRANRCellResourceCoordinationRequest_protocolIEs__item__id_tab
    ___EUTRANRCellResourceCoordinationRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___EUTRANRCellResourceCoordinationRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___EUTRANRCellResourceCoordinationRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___EUTRANRCellResourceCoordinationRequest_protocolIEs__item__value._const_tab = ____EUTRANRCellResourceCoordinationRequest_protocolIEs__item__id_tab
    ___EUTRANRCellResourceCoordinationRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___EUTRANRCellResourceCoordinationRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __EUTRANRCellResourceCoordinationRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___EUTRANRCellResourceCoordinationRequest_protocolIEs__item__id),
        ('criticality', ___EUTRANRCellResourceCoordinationRequest_protocolIEs__item__criticality),
        ('value', ___EUTRANRCellResourceCoordinationRequest_protocolIEs__item__value),
        ])
    __EUTRANRCellResourceCoordinationRequest_protocolIEs__item_._ext = None
    _EUTRANRCellResourceCoordinationRequest_protocolIEs._cont = __EUTRANRCellResourceCoordinationRequest_protocolIEs__item_
    _EUTRANRCellResourceCoordinationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    EUTRANRCellResourceCoordinationRequest._cont = ASN1Dict([
        ('protocolIEs', _EUTRANRCellResourceCoordinationRequest_protocolIEs),
        ])
    EUTRANRCellResourceCoordinationRequest._ext = []
    
    #-----< EUTRANRCellResourceCoordinationRequest-IEs >-----#
    EUTRANRCellResourceCoordinationRequest_IEs = CLASS(name='EUTRANRCellResourceCoordinationRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _EUTRANRCellResourceCoordinationRequest_IEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'InitiatingNodeType-EutranrCellResourceCoordination')))
    _EUTRANRCellResourceCoordinationRequest_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'InterfaceInstanceIndication')))
    EUTRANRCellResourceCoordinationRequest_IEs._val = ASN1Set(rv=[dict([('id', 285), ('criticality', 'reject'), ('Value', _EUTRANRCellResourceCoordinationRequest_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 335), ('criticality', 'reject'), ('Value', _EUTRANRCellResourceCoordinationRequest_IEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< InitiatingNodeType-EutranrCellResourceCoordination >-----#
    InitiatingNodeType_EutranrCellResourceCoordination = CHOICE(name='InitiatingNodeType-EutranrCellResourceCoordination', mode=MODE_TYPE)
    _InitiatingNodeType_EutranrCellResourceCoordination_initiate_eNB = SEQ_OF(name='initiate-eNB', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __InitiatingNodeType_EutranrCellResourceCoordination_initiate_eNB__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___InitiatingNodeType_EutranrCellResourceCoordination_initiate_eNB__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____InitiatingNodeType_EutranrCellResourceCoordination_initiate_eNB__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____InitiatingNodeType_EutranrCellResourceCoordination_initiate_eNB__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'DataTrafficResourceIndication')))
    _____InitiatingNodeType_EutranrCellResourceCoordination_initiate_eNB__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SpectrumSharingGroupID')))
    _____InitiatingNodeType_EutranrCellResourceCoordination_initiate_eNB__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ListofEUTRACellsinEUTRACoordinationReq')))
    ____InitiatingNodeType_EutranrCellResourceCoordination_initiate_eNB__item__id_tab._val = ASN1Set(rv=[dict([('id', 287), ('criticality', 'reject'), ('Value', _____InitiatingNodeType_EutranrCellResourceCoordination_initiate_eNB__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 288), ('criticality', 'reject'), ('Value', _____InitiatingNodeType_EutranrCellResourceCoordination_initiate_eNB__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 289), ('criticality', 'reject'), ('Value', _____InitiatingNodeType_EutranrCellResourceCoordination_initiate_eNB__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___InitiatingNodeType_EutranrCellResourceCoordination_initiate_eNB__item__id._const_tab = ____InitiatingNodeType_EutranrCellResourceCoordination_initiate_eNB__item__id_tab
    ___InitiatingNodeType_EutranrCellResourceCoordination_initiate_eNB__item__id._const_tab_at = None
    ___InitiatingNodeType_EutranrCellResourceCoordination_initiate_eNB__item__id._const_tab_id = 'id'
    ___InitiatingNodeType_EutranrCellResourceCoordination_initiate_eNB__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___InitiatingNodeType_EutranrCellResourceCoordination_initiate_eNB__item__criticality._const_tab = ____InitiatingNodeType_EutranrCellResourceCoordination_initiate_eNB__item__id_tab
    ___InitiatingNodeType_EutranrCellResourceCoordination_initiate_eNB__item__criticality._const_tab_at = ('..', 'id')
    ___InitiatingNodeType_EutranrCellResourceCoordination_initiate_eNB__item__criticality._const_tab_id = 'criticality'
    ___InitiatingNodeType_EutranrCellResourceCoordination_initiate_eNB__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___InitiatingNodeType_EutranrCellResourceCoordination_initiate_eNB__item__value._const_tab = ____InitiatingNodeType_EutranrCellResourceCoordination_initiate_eNB__item__id_tab
    ___InitiatingNodeType_EutranrCellResourceCoordination_initiate_eNB__item__value._const_tab_at = ('..', 'id')
    ___InitiatingNodeType_EutranrCellResourceCoordination_initiate_eNB__item__value._const_tab_id = 'Value'
    __InitiatingNodeType_EutranrCellResourceCoordination_initiate_eNB__item_._cont = ASN1Dict([
        ('id', ___InitiatingNodeType_EutranrCellResourceCoordination_initiate_eNB__item__id),
        ('criticality', ___InitiatingNodeType_EutranrCellResourceCoordination_initiate_eNB__item__criticality),
        ('value', ___InitiatingNodeType_EutranrCellResourceCoordination_initiate_eNB__item__value),
        ])
    __InitiatingNodeType_EutranrCellResourceCoordination_initiate_eNB__item_._ext = None
    _InitiatingNodeType_EutranrCellResourceCoordination_initiate_eNB._cont = __InitiatingNodeType_EutranrCellResourceCoordination_initiate_eNB__item_
    _InitiatingNodeType_EutranrCellResourceCoordination_initiate_eNB._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _InitiatingNodeType_EutranrCellResourceCoordination_initiate_en_gNB = SEQ_OF(name='initiate-en-gNB', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __InitiatingNodeType_EutranrCellResourceCoordination_initiate_en_gNB__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___InitiatingNodeType_EutranrCellResourceCoordination_initiate_en_gNB__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____InitiatingNodeType_EutranrCellResourceCoordination_initiate_en_gNB__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____InitiatingNodeType_EutranrCellResourceCoordination_initiate_en_gNB__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'DataTrafficResourceIndication')))
    _____InitiatingNodeType_EutranrCellResourceCoordination_initiate_en_gNB__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ListofEUTRACellsinNRCoordinationReq')))
    _____InitiatingNodeType_EutranrCellResourceCoordination_initiate_en_gNB__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SpectrumSharingGroupID')))
    _____InitiatingNodeType_EutranrCellResourceCoordination_initiate_en_gNB__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ListofNRCellsinNRCoordinationReq')))
    ____InitiatingNodeType_EutranrCellResourceCoordination_initiate_en_gNB__item__id_tab._val = ASN1Set(rv=[dict([('id', 287), ('criticality', 'reject'), ('Value', _____InitiatingNodeType_EutranrCellResourceCoordination_initiate_en_gNB__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 291), ('criticality', 'reject'), ('Value', _____InitiatingNodeType_EutranrCellResourceCoordination_initiate_en_gNB__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 288), ('criticality', 'reject'), ('Value', _____InitiatingNodeType_EutranrCellResourceCoordination_initiate_en_gNB__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 292), ('criticality', 'reject'), ('Value', _____InitiatingNodeType_EutranrCellResourceCoordination_initiate_en_gNB__item__id_tab_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___InitiatingNodeType_EutranrCellResourceCoordination_initiate_en_gNB__item__id._const_tab = ____InitiatingNodeType_EutranrCellResourceCoordination_initiate_en_gNB__item__id_tab
    ___InitiatingNodeType_EutranrCellResourceCoordination_initiate_en_gNB__item__id._const_tab_at = None
    ___InitiatingNodeType_EutranrCellResourceCoordination_initiate_en_gNB__item__id._const_tab_id = 'id'
    ___InitiatingNodeType_EutranrCellResourceCoordination_initiate_en_gNB__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___InitiatingNodeType_EutranrCellResourceCoordination_initiate_en_gNB__item__criticality._const_tab = ____InitiatingNodeType_EutranrCellResourceCoordination_initiate_en_gNB__item__id_tab
    ___InitiatingNodeType_EutranrCellResourceCoordination_initiate_en_gNB__item__criticality._const_tab_at = ('..', 'id')
    ___InitiatingNodeType_EutranrCellResourceCoordination_initiate_en_gNB__item__criticality._const_tab_id = 'criticality'
    ___InitiatingNodeType_EutranrCellResourceCoordination_initiate_en_gNB__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___InitiatingNodeType_EutranrCellResourceCoordination_initiate_en_gNB__item__value._const_tab = ____InitiatingNodeType_EutranrCellResourceCoordination_initiate_en_gNB__item__id_tab
    ___InitiatingNodeType_EutranrCellResourceCoordination_initiate_en_gNB__item__value._const_tab_at = ('..', 'id')
    ___InitiatingNodeType_EutranrCellResourceCoordination_initiate_en_gNB__item__value._const_tab_id = 'Value'
    __InitiatingNodeType_EutranrCellResourceCoordination_initiate_en_gNB__item_._cont = ASN1Dict([
        ('id', ___InitiatingNodeType_EutranrCellResourceCoordination_initiate_en_gNB__item__id),
        ('criticality', ___InitiatingNodeType_EutranrCellResourceCoordination_initiate_en_gNB__item__criticality),
        ('value', ___InitiatingNodeType_EutranrCellResourceCoordination_initiate_en_gNB__item__value),
        ])
    __InitiatingNodeType_EutranrCellResourceCoordination_initiate_en_gNB__item_._ext = None
    _InitiatingNodeType_EutranrCellResourceCoordination_initiate_en_gNB._cont = __InitiatingNodeType_EutranrCellResourceCoordination_initiate_en_gNB__item_
    _InitiatingNodeType_EutranrCellResourceCoordination_initiate_en_gNB._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    InitiatingNodeType_EutranrCellResourceCoordination._cont = ASN1Dict([
        ('initiate-eNB', _InitiatingNodeType_EutranrCellResourceCoordination_initiate_eNB),
        ('initiate-en-gNB', _InitiatingNodeType_EutranrCellResourceCoordination_initiate_en_gNB),
        ])
    InitiatingNodeType_EutranrCellResourceCoordination._ext = []
    
    #-----< ENB-EUTRA-NRCellResourceCoordinationReqIEs >-----#
    ENB_EUTRA_NRCellResourceCoordinationReqIEs = CLASS(name='ENB-EUTRA-NRCellResourceCoordinationReqIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _ENB_EUTRA_NRCellResourceCoordinationReqIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'DataTrafficResourceIndication')))
    _ENB_EUTRA_NRCellResourceCoordinationReqIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SpectrumSharingGroupID')))
    _ENB_EUTRA_NRCellResourceCoordinationReqIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ListofEUTRACellsinEUTRACoordinationReq')))
    ENB_EUTRA_NRCellResourceCoordinationReqIEs._val = ASN1Set(rv=[dict([('id', 287), ('criticality', 'reject'), ('Value', _ENB_EUTRA_NRCellResourceCoordinationReqIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 288), ('criticality', 'reject'), ('Value', _ENB_EUTRA_NRCellResourceCoordinationReqIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 289), ('criticality', 'reject'), ('Value', _ENB_EUTRA_NRCellResourceCoordinationReqIEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< En-gNB-EUTRA-NRCellResourceCoordinationReqIEs >-----#
    En_gNB_EUTRA_NRCellResourceCoordinationReqIEs = CLASS(name='En-gNB-EUTRA-NRCellResourceCoordinationReqIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _En_gNB_EUTRA_NRCellResourceCoordinationReqIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'DataTrafficResourceIndication')))
    _En_gNB_EUTRA_NRCellResourceCoordinationReqIEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ListofEUTRACellsinNRCoordinationReq')))
    _En_gNB_EUTRA_NRCellResourceCoordinationReqIEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SpectrumSharingGroupID')))
    _En_gNB_EUTRA_NRCellResourceCoordinationReqIEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ListofNRCellsinNRCoordinationReq')))
    En_gNB_EUTRA_NRCellResourceCoordinationReqIEs._val = ASN1Set(rv=[dict([('id', 287), ('criticality', 'reject'), ('Value', _En_gNB_EUTRA_NRCellResourceCoordinationReqIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 291), ('criticality', 'reject'), ('Value', _En_gNB_EUTRA_NRCellResourceCoordinationReqIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 288), ('criticality', 'reject'), ('Value', _En_gNB_EUTRA_NRCellResourceCoordinationReqIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 292), ('criticality', 'reject'), ('Value', _En_gNB_EUTRA_NRCellResourceCoordinationReqIEs_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< ListofEUTRACellsinEUTRACoordinationReq >-----#
    ListofEUTRACellsinEUTRACoordinationReq = SEQ_OF(name='ListofEUTRACellsinEUTRACoordinationReq', mode=MODE_TYPE)
    _ListofEUTRACellsinEUTRACoordinationReq__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    ListofEUTRACellsinEUTRACoordinationReq._cont = _ListofEUTRACellsinEUTRACoordinationReq__item_
    ListofEUTRACellsinEUTRACoordinationReq._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=256)], ev=None, er=[])
    
    #-----< ListofEUTRACellsinNRCoordinationReq >-----#
    ListofEUTRACellsinNRCoordinationReq = SEQ_OF(name='ListofEUTRACellsinNRCoordinationReq', mode=MODE_TYPE)
    _ListofEUTRACellsinNRCoordinationReq__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    ListofEUTRACellsinNRCoordinationReq._cont = _ListofEUTRACellsinNRCoordinationReq__item_
    ListofEUTRACellsinNRCoordinationReq._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< ListofNRCellsinNRCoordinationReq >-----#
    ListofNRCellsinNRCoordinationReq = SEQ_OF(name='ListofNRCellsinNRCoordinationReq', mode=MODE_TYPE)
    _ListofNRCellsinNRCoordinationReq__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'NRCGI')))
    ListofNRCellsinNRCoordinationReq._cont = _ListofNRCellsinNRCoordinationReq__item_
    ListofNRCellsinNRCoordinationReq._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=64)], ev=None, er=[])
    
    #-----< EUTRANRCellResourceCoordinationResponse >-----#
    EUTRANRCellResourceCoordinationResponse = SEQ(name='EUTRANRCellResourceCoordinationResponse', mode=MODE_TYPE)
    _EUTRANRCellResourceCoordinationResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __EUTRANRCellResourceCoordinationResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___EUTRANRCellResourceCoordinationResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____EUTRANRCellResourceCoordinationResponse_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____EUTRANRCellResourceCoordinationResponse_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'RespondingNodeType-EutranrCellResourceCoordination')))
    _____EUTRANRCellResourceCoordinationResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'InterfaceInstanceIndication')))
    ____EUTRANRCellResourceCoordinationResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 286), ('criticality', 'reject'), ('Value', _____EUTRANRCellResourceCoordinationResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 335), ('criticality', 'reject'), ('Value', _____EUTRANRCellResourceCoordinationResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___EUTRANRCellResourceCoordinationResponse_protocolIEs__item__id._const_tab = ____EUTRANRCellResourceCoordinationResponse_protocolIEs__item__id_tab
    ___EUTRANRCellResourceCoordinationResponse_protocolIEs__item__id._const_tab_at = None
    ___EUTRANRCellResourceCoordinationResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___EUTRANRCellResourceCoordinationResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___EUTRANRCellResourceCoordinationResponse_protocolIEs__item__criticality._const_tab = ____EUTRANRCellResourceCoordinationResponse_protocolIEs__item__id_tab
    ___EUTRANRCellResourceCoordinationResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___EUTRANRCellResourceCoordinationResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___EUTRANRCellResourceCoordinationResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___EUTRANRCellResourceCoordinationResponse_protocolIEs__item__value._const_tab = ____EUTRANRCellResourceCoordinationResponse_protocolIEs__item__id_tab
    ___EUTRANRCellResourceCoordinationResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___EUTRANRCellResourceCoordinationResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __EUTRANRCellResourceCoordinationResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___EUTRANRCellResourceCoordinationResponse_protocolIEs__item__id),
        ('criticality', ___EUTRANRCellResourceCoordinationResponse_protocolIEs__item__criticality),
        ('value', ___EUTRANRCellResourceCoordinationResponse_protocolIEs__item__value),
        ])
    __EUTRANRCellResourceCoordinationResponse_protocolIEs__item_._ext = None
    _EUTRANRCellResourceCoordinationResponse_protocolIEs._cont = __EUTRANRCellResourceCoordinationResponse_protocolIEs__item_
    _EUTRANRCellResourceCoordinationResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    EUTRANRCellResourceCoordinationResponse._cont = ASN1Dict([
        ('protocolIEs', _EUTRANRCellResourceCoordinationResponse_protocolIEs),
        ])
    EUTRANRCellResourceCoordinationResponse._ext = []
    
    #-----< EUTRANRCellResourceCoordinationResponse-IEs >-----#
    EUTRANRCellResourceCoordinationResponse_IEs = CLASS(name='EUTRANRCellResourceCoordinationResponse-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _EUTRANRCellResourceCoordinationResponse_IEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'RespondingNodeType-EutranrCellResourceCoordination')))
    _EUTRANRCellResourceCoordinationResponse_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'InterfaceInstanceIndication')))
    EUTRANRCellResourceCoordinationResponse_IEs._val = ASN1Set(rv=[dict([('id', 286), ('criticality', 'reject'), ('Value', _EUTRANRCellResourceCoordinationResponse_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 335), ('criticality', 'reject'), ('Value', _EUTRANRCellResourceCoordinationResponse_IEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RespondingNodeType-EutranrCellResourceCoordination >-----#
    RespondingNodeType_EutranrCellResourceCoordination = CHOICE(name='RespondingNodeType-EutranrCellResourceCoordination', mode=MODE_TYPE)
    _RespondingNodeType_EutranrCellResourceCoordination_respond_eNB = SEQ_OF(name='respond-eNB', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __RespondingNodeType_EutranrCellResourceCoordination_respond_eNB__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___RespondingNodeType_EutranrCellResourceCoordination_respond_eNB__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____RespondingNodeType_EutranrCellResourceCoordination_respond_eNB__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____RespondingNodeType_EutranrCellResourceCoordination_respond_eNB__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'DataTrafficResourceIndication')))
    _____RespondingNodeType_EutranrCellResourceCoordination_respond_eNB__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SpectrumSharingGroupID')))
    _____RespondingNodeType_EutranrCellResourceCoordination_respond_eNB__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ListofEUTRACellsinEUTRACoordinationResp')))
    ____RespondingNodeType_EutranrCellResourceCoordination_respond_eNB__item__id_tab._val = ASN1Set(rv=[dict([('id', 287), ('criticality', 'reject'), ('Value', _____RespondingNodeType_EutranrCellResourceCoordination_respond_eNB__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 288), ('criticality', 'reject'), ('Value', _____RespondingNodeType_EutranrCellResourceCoordination_respond_eNB__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 290), ('criticality', 'reject'), ('Value', _____RespondingNodeType_EutranrCellResourceCoordination_respond_eNB__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___RespondingNodeType_EutranrCellResourceCoordination_respond_eNB__item__id._const_tab = ____RespondingNodeType_EutranrCellResourceCoordination_respond_eNB__item__id_tab
    ___RespondingNodeType_EutranrCellResourceCoordination_respond_eNB__item__id._const_tab_at = None
    ___RespondingNodeType_EutranrCellResourceCoordination_respond_eNB__item__id._const_tab_id = 'id'
    ___RespondingNodeType_EutranrCellResourceCoordination_respond_eNB__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___RespondingNodeType_EutranrCellResourceCoordination_respond_eNB__item__criticality._const_tab = ____RespondingNodeType_EutranrCellResourceCoordination_respond_eNB__item__id_tab
    ___RespondingNodeType_EutranrCellResourceCoordination_respond_eNB__item__criticality._const_tab_at = ('..', 'id')
    ___RespondingNodeType_EutranrCellResourceCoordination_respond_eNB__item__criticality._const_tab_id = 'criticality'
    ___RespondingNodeType_EutranrCellResourceCoordination_respond_eNB__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___RespondingNodeType_EutranrCellResourceCoordination_respond_eNB__item__value._const_tab = ____RespondingNodeType_EutranrCellResourceCoordination_respond_eNB__item__id_tab
    ___RespondingNodeType_EutranrCellResourceCoordination_respond_eNB__item__value._const_tab_at = ('..', 'id')
    ___RespondingNodeType_EutranrCellResourceCoordination_respond_eNB__item__value._const_tab_id = 'Value'
    __RespondingNodeType_EutranrCellResourceCoordination_respond_eNB__item_._cont = ASN1Dict([
        ('id', ___RespondingNodeType_EutranrCellResourceCoordination_respond_eNB__item__id),
        ('criticality', ___RespondingNodeType_EutranrCellResourceCoordination_respond_eNB__item__criticality),
        ('value', ___RespondingNodeType_EutranrCellResourceCoordination_respond_eNB__item__value),
        ])
    __RespondingNodeType_EutranrCellResourceCoordination_respond_eNB__item_._ext = None
    _RespondingNodeType_EutranrCellResourceCoordination_respond_eNB._cont = __RespondingNodeType_EutranrCellResourceCoordination_respond_eNB__item_
    _RespondingNodeType_EutranrCellResourceCoordination_respond_eNB._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RespondingNodeType_EutranrCellResourceCoordination_respond_en_gNB = SEQ_OF(name='respond-en-gNB', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __RespondingNodeType_EutranrCellResourceCoordination_respond_en_gNB__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___RespondingNodeType_EutranrCellResourceCoordination_respond_en_gNB__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____RespondingNodeType_EutranrCellResourceCoordination_respond_en_gNB__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____RespondingNodeType_EutranrCellResourceCoordination_respond_en_gNB__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'DataTrafficResourceIndication')))
    _____RespondingNodeType_EutranrCellResourceCoordination_respond_en_gNB__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SpectrumSharingGroupID')))
    _____RespondingNodeType_EutranrCellResourceCoordination_respond_en_gNB__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ListofNRCellsinNRCoordinationResp')))
    ____RespondingNodeType_EutranrCellResourceCoordination_respond_en_gNB__item__id_tab._val = ASN1Set(rv=[dict([('id', 287), ('criticality', 'reject'), ('Value', _____RespondingNodeType_EutranrCellResourceCoordination_respond_en_gNB__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 288), ('criticality', 'reject'), ('Value', _____RespondingNodeType_EutranrCellResourceCoordination_respond_en_gNB__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 293), ('criticality', 'reject'), ('Value', _____RespondingNodeType_EutranrCellResourceCoordination_respond_en_gNB__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___RespondingNodeType_EutranrCellResourceCoordination_respond_en_gNB__item__id._const_tab = ____RespondingNodeType_EutranrCellResourceCoordination_respond_en_gNB__item__id_tab
    ___RespondingNodeType_EutranrCellResourceCoordination_respond_en_gNB__item__id._const_tab_at = None
    ___RespondingNodeType_EutranrCellResourceCoordination_respond_en_gNB__item__id._const_tab_id = 'id'
    ___RespondingNodeType_EutranrCellResourceCoordination_respond_en_gNB__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___RespondingNodeType_EutranrCellResourceCoordination_respond_en_gNB__item__criticality._const_tab = ____RespondingNodeType_EutranrCellResourceCoordination_respond_en_gNB__item__id_tab
    ___RespondingNodeType_EutranrCellResourceCoordination_respond_en_gNB__item__criticality._const_tab_at = ('..', 'id')
    ___RespondingNodeType_EutranrCellResourceCoordination_respond_en_gNB__item__criticality._const_tab_id = 'criticality'
    ___RespondingNodeType_EutranrCellResourceCoordination_respond_en_gNB__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___RespondingNodeType_EutranrCellResourceCoordination_respond_en_gNB__item__value._const_tab = ____RespondingNodeType_EutranrCellResourceCoordination_respond_en_gNB__item__id_tab
    ___RespondingNodeType_EutranrCellResourceCoordination_respond_en_gNB__item__value._const_tab_at = ('..', 'id')
    ___RespondingNodeType_EutranrCellResourceCoordination_respond_en_gNB__item__value._const_tab_id = 'Value'
    __RespondingNodeType_EutranrCellResourceCoordination_respond_en_gNB__item_._cont = ASN1Dict([
        ('id', ___RespondingNodeType_EutranrCellResourceCoordination_respond_en_gNB__item__id),
        ('criticality', ___RespondingNodeType_EutranrCellResourceCoordination_respond_en_gNB__item__criticality),
        ('value', ___RespondingNodeType_EutranrCellResourceCoordination_respond_en_gNB__item__value),
        ])
    __RespondingNodeType_EutranrCellResourceCoordination_respond_en_gNB__item_._ext = None
    _RespondingNodeType_EutranrCellResourceCoordination_respond_en_gNB._cont = __RespondingNodeType_EutranrCellResourceCoordination_respond_en_gNB__item_
    _RespondingNodeType_EutranrCellResourceCoordination_respond_en_gNB._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RespondingNodeType_EutranrCellResourceCoordination._cont = ASN1Dict([
        ('respond-eNB', _RespondingNodeType_EutranrCellResourceCoordination_respond_eNB),
        ('respond-en-gNB', _RespondingNodeType_EutranrCellResourceCoordination_respond_en_gNB),
        ])
    RespondingNodeType_EutranrCellResourceCoordination._ext = []
    
    #-----< ENB-EUTRA-NRCellResourceCoordinationReqAckIEs >-----#
    ENB_EUTRA_NRCellResourceCoordinationReqAckIEs = CLASS(name='ENB-EUTRA-NRCellResourceCoordinationReqAckIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _ENB_EUTRA_NRCellResourceCoordinationReqAckIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'DataTrafficResourceIndication')))
    _ENB_EUTRA_NRCellResourceCoordinationReqAckIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SpectrumSharingGroupID')))
    _ENB_EUTRA_NRCellResourceCoordinationReqAckIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ListofEUTRACellsinEUTRACoordinationResp')))
    ENB_EUTRA_NRCellResourceCoordinationReqAckIEs._val = ASN1Set(rv=[dict([('id', 287), ('criticality', 'reject'), ('Value', _ENB_EUTRA_NRCellResourceCoordinationReqAckIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 288), ('criticality', 'reject'), ('Value', _ENB_EUTRA_NRCellResourceCoordinationReqAckIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 290), ('criticality', 'reject'), ('Value', _ENB_EUTRA_NRCellResourceCoordinationReqAckIEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< En-gNB-EUTRA-NRCellResourceCoordinationReqAckIEs >-----#
    En_gNB_EUTRA_NRCellResourceCoordinationReqAckIEs = CLASS(name='En-gNB-EUTRA-NRCellResourceCoordinationReqAckIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _En_gNB_EUTRA_NRCellResourceCoordinationReqAckIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'DataTrafficResourceIndication')))
    _En_gNB_EUTRA_NRCellResourceCoordinationReqAckIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SpectrumSharingGroupID')))
    _En_gNB_EUTRA_NRCellResourceCoordinationReqAckIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ListofNRCellsinNRCoordinationResp')))
    En_gNB_EUTRA_NRCellResourceCoordinationReqAckIEs._val = ASN1Set(rv=[dict([('id', 287), ('criticality', 'reject'), ('Value', _En_gNB_EUTRA_NRCellResourceCoordinationReqAckIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 288), ('criticality', 'reject'), ('Value', _En_gNB_EUTRA_NRCellResourceCoordinationReqAckIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 293), ('criticality', 'reject'), ('Value', _En_gNB_EUTRA_NRCellResourceCoordinationReqAckIEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< ListofEUTRACellsinEUTRACoordinationResp >-----#
    ListofEUTRACellsinEUTRACoordinationResp = SEQ_OF(name='ListofEUTRACellsinEUTRACoordinationResp', mode=MODE_TYPE)
    _ListofEUTRACellsinEUTRACoordinationResp__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'ECGI')))
    ListofEUTRACellsinEUTRACoordinationResp._cont = _ListofEUTRACellsinEUTRACoordinationResp__item_
    ListofEUTRACellsinEUTRACoordinationResp._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=256)], ev=None, er=[])
    
    #-----< ListofNRCellsinNRCoordinationResp >-----#
    ListofNRCellsinNRCoordinationResp = SEQ_OF(name='ListofNRCellsinNRCoordinationResp', mode=MODE_TYPE)
    _ListofNRCellsinNRCoordinationResp__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'NRCGI')))
    ListofNRCellsinNRCoordinationResp._cont = _ListofNRCellsinNRCoordinationResp__item_
    ListofNRCellsinNRCoordinationResp._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=64)], ev=None, er=[])
    
    #-----< ENDCX2RemovalRequest >-----#
    ENDCX2RemovalRequest = SEQ(name='ENDCX2RemovalRequest', mode=MODE_TYPE)
    _ENDCX2RemovalRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __ENDCX2RemovalRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___ENDCX2RemovalRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____ENDCX2RemovalRequest_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____ENDCX2RemovalRequest_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'InitiatingNodeType-EndcX2Removal')))
    _____ENDCX2RemovalRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'InterfaceInstanceIndication')))
    ____ENDCX2RemovalRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 298), ('criticality', 'reject'), ('Value', _____ENDCX2RemovalRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 335), ('criticality', 'reject'), ('Value', _____ENDCX2RemovalRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ENDCX2RemovalRequest_protocolIEs__item__id._const_tab = ____ENDCX2RemovalRequest_protocolIEs__item__id_tab
    ___ENDCX2RemovalRequest_protocolIEs__item__id._const_tab_at = None
    ___ENDCX2RemovalRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___ENDCX2RemovalRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___ENDCX2RemovalRequest_protocolIEs__item__criticality._const_tab = ____ENDCX2RemovalRequest_protocolIEs__item__id_tab
    ___ENDCX2RemovalRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ENDCX2RemovalRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ENDCX2RemovalRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___ENDCX2RemovalRequest_protocolIEs__item__value._const_tab = ____ENDCX2RemovalRequest_protocolIEs__item__id_tab
    ___ENDCX2RemovalRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ENDCX2RemovalRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __ENDCX2RemovalRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ENDCX2RemovalRequest_protocolIEs__item__id),
        ('criticality', ___ENDCX2RemovalRequest_protocolIEs__item__criticality),
        ('value', ___ENDCX2RemovalRequest_protocolIEs__item__value),
        ])
    __ENDCX2RemovalRequest_protocolIEs__item_._ext = None
    _ENDCX2RemovalRequest_protocolIEs._cont = __ENDCX2RemovalRequest_protocolIEs__item_
    _ENDCX2RemovalRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ENDCX2RemovalRequest._cont = ASN1Dict([
        ('protocolIEs', _ENDCX2RemovalRequest_protocolIEs),
        ])
    ENDCX2RemovalRequest._ext = []
    
    #-----< ENDCX2RemovalRequest-IEs >-----#
    ENDCX2RemovalRequest_IEs = CLASS(name='ENDCX2RemovalRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _ENDCX2RemovalRequest_IEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'InitiatingNodeType-EndcX2Removal')))
    _ENDCX2RemovalRequest_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'InterfaceInstanceIndication')))
    ENDCX2RemovalRequest_IEs._val = ASN1Set(rv=[dict([('id', 298), ('criticality', 'reject'), ('Value', _ENDCX2RemovalRequest_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 335), ('criticality', 'reject'), ('Value', _ENDCX2RemovalRequest_IEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< InitiatingNodeType-EndcX2Removal >-----#
    InitiatingNodeType_EndcX2Removal = CHOICE(name='InitiatingNodeType-EndcX2Removal', mode=MODE_TYPE)
    _InitiatingNodeType_EndcX2Removal_init_eNB = SEQ_OF(name='init-eNB', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __InitiatingNodeType_EndcX2Removal_init_eNB__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___InitiatingNodeType_EndcX2Removal_init_eNB__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____InitiatingNodeType_EndcX2Removal_init_eNB__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____InitiatingNodeType_EndcX2Removal_init_eNB__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GlobalENB-ID')))
    ____InitiatingNodeType_EndcX2Removal_init_eNB__item__id_tab._val = ASN1Set(rv=[dict([('id', 21), ('criticality', 'reject'), ('Value', _____InitiatingNodeType_EndcX2Removal_init_eNB__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___InitiatingNodeType_EndcX2Removal_init_eNB__item__id._const_tab = ____InitiatingNodeType_EndcX2Removal_init_eNB__item__id_tab
    ___InitiatingNodeType_EndcX2Removal_init_eNB__item__id._const_tab_at = None
    ___InitiatingNodeType_EndcX2Removal_init_eNB__item__id._const_tab_id = 'id'
    ___InitiatingNodeType_EndcX2Removal_init_eNB__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___InitiatingNodeType_EndcX2Removal_init_eNB__item__criticality._const_tab = ____InitiatingNodeType_EndcX2Removal_init_eNB__item__id_tab
    ___InitiatingNodeType_EndcX2Removal_init_eNB__item__criticality._const_tab_at = ('..', 'id')
    ___InitiatingNodeType_EndcX2Removal_init_eNB__item__criticality._const_tab_id = 'criticality'
    ___InitiatingNodeType_EndcX2Removal_init_eNB__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___InitiatingNodeType_EndcX2Removal_init_eNB__item__value._const_tab = ____InitiatingNodeType_EndcX2Removal_init_eNB__item__id_tab
    ___InitiatingNodeType_EndcX2Removal_init_eNB__item__value._const_tab_at = ('..', 'id')
    ___InitiatingNodeType_EndcX2Removal_init_eNB__item__value._const_tab_id = 'Value'
    __InitiatingNodeType_EndcX2Removal_init_eNB__item_._cont = ASN1Dict([
        ('id', ___InitiatingNodeType_EndcX2Removal_init_eNB__item__id),
        ('criticality', ___InitiatingNodeType_EndcX2Removal_init_eNB__item__criticality),
        ('value', ___InitiatingNodeType_EndcX2Removal_init_eNB__item__value),
        ])
    __InitiatingNodeType_EndcX2Removal_init_eNB__item_._ext = None
    _InitiatingNodeType_EndcX2Removal_init_eNB._cont = __InitiatingNodeType_EndcX2Removal_init_eNB__item_
    _InitiatingNodeType_EndcX2Removal_init_eNB._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _InitiatingNodeType_EndcX2Removal_init_en_gNB = SEQ_OF(name='init-en-gNB', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __InitiatingNodeType_EndcX2Removal_init_en_gNB__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___InitiatingNodeType_EndcX2Removal_init_en_gNB__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____InitiatingNodeType_EndcX2Removal_init_en_gNB__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____InitiatingNodeType_EndcX2Removal_init_en_gNB__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GlobalGNB-ID')))
    ____InitiatingNodeType_EndcX2Removal_init_en_gNB__item__id_tab._val = ASN1Set(rv=[dict([('id', 252), ('criticality', 'reject'), ('Value', _____InitiatingNodeType_EndcX2Removal_init_en_gNB__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___InitiatingNodeType_EndcX2Removal_init_en_gNB__item__id._const_tab = ____InitiatingNodeType_EndcX2Removal_init_en_gNB__item__id_tab
    ___InitiatingNodeType_EndcX2Removal_init_en_gNB__item__id._const_tab_at = None
    ___InitiatingNodeType_EndcX2Removal_init_en_gNB__item__id._const_tab_id = 'id'
    ___InitiatingNodeType_EndcX2Removal_init_en_gNB__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___InitiatingNodeType_EndcX2Removal_init_en_gNB__item__criticality._const_tab = ____InitiatingNodeType_EndcX2Removal_init_en_gNB__item__id_tab
    ___InitiatingNodeType_EndcX2Removal_init_en_gNB__item__criticality._const_tab_at = ('..', 'id')
    ___InitiatingNodeType_EndcX2Removal_init_en_gNB__item__criticality._const_tab_id = 'criticality'
    ___InitiatingNodeType_EndcX2Removal_init_en_gNB__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___InitiatingNodeType_EndcX2Removal_init_en_gNB__item__value._const_tab = ____InitiatingNodeType_EndcX2Removal_init_en_gNB__item__id_tab
    ___InitiatingNodeType_EndcX2Removal_init_en_gNB__item__value._const_tab_at = ('..', 'id')
    ___InitiatingNodeType_EndcX2Removal_init_en_gNB__item__value._const_tab_id = 'Value'
    __InitiatingNodeType_EndcX2Removal_init_en_gNB__item_._cont = ASN1Dict([
        ('id', ___InitiatingNodeType_EndcX2Removal_init_en_gNB__item__id),
        ('criticality', ___InitiatingNodeType_EndcX2Removal_init_en_gNB__item__criticality),
        ('value', ___InitiatingNodeType_EndcX2Removal_init_en_gNB__item__value),
        ])
    __InitiatingNodeType_EndcX2Removal_init_en_gNB__item_._ext = None
    _InitiatingNodeType_EndcX2Removal_init_en_gNB._cont = __InitiatingNodeType_EndcX2Removal_init_en_gNB__item_
    _InitiatingNodeType_EndcX2Removal_init_en_gNB._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    InitiatingNodeType_EndcX2Removal._cont = ASN1Dict([
        ('init-eNB', _InitiatingNodeType_EndcX2Removal_init_eNB),
        ('init-en-gNB', _InitiatingNodeType_EndcX2Removal_init_en_gNB),
        ])
    InitiatingNodeType_EndcX2Removal._ext = []
    
    #-----< ENB-ENDCX2RemovalReqIEs >-----#
    ENB_ENDCX2RemovalReqIEs = CLASS(name='ENB-ENDCX2RemovalReqIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _ENB_ENDCX2RemovalReqIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GlobalENB-ID')))
    ENB_ENDCX2RemovalReqIEs._val = ASN1Set(rv=[dict([('id', 21), ('criticality', 'reject'), ('Value', _ENB_ENDCX2RemovalReqIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< En-gNB-ENDCX2RemovalReqIEs >-----#
    En_gNB_ENDCX2RemovalReqIEs = CLASS(name='En-gNB-ENDCX2RemovalReqIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _En_gNB_ENDCX2RemovalReqIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GlobalGNB-ID')))
    En_gNB_ENDCX2RemovalReqIEs._val = ASN1Set(rv=[dict([('id', 252), ('criticality', 'reject'), ('Value', _En_gNB_ENDCX2RemovalReqIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< ENDCX2RemovalResponse >-----#
    ENDCX2RemovalResponse = SEQ(name='ENDCX2RemovalResponse', mode=MODE_TYPE)
    _ENDCX2RemovalResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __ENDCX2RemovalResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___ENDCX2RemovalResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____ENDCX2RemovalResponse_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____ENDCX2RemovalResponse_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'RespondingNodeType-EndcX2Removal')))
    _____ENDCX2RemovalResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'InterfaceInstanceIndication')))
    ____ENDCX2RemovalResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 299), ('criticality', 'reject'), ('Value', _____ENDCX2RemovalResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 335), ('criticality', 'reject'), ('Value', _____ENDCX2RemovalResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ENDCX2RemovalResponse_protocolIEs__item__id._const_tab = ____ENDCX2RemovalResponse_protocolIEs__item__id_tab
    ___ENDCX2RemovalResponse_protocolIEs__item__id._const_tab_at = None
    ___ENDCX2RemovalResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___ENDCX2RemovalResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___ENDCX2RemovalResponse_protocolIEs__item__criticality._const_tab = ____ENDCX2RemovalResponse_protocolIEs__item__id_tab
    ___ENDCX2RemovalResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ENDCX2RemovalResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ENDCX2RemovalResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___ENDCX2RemovalResponse_protocolIEs__item__value._const_tab = ____ENDCX2RemovalResponse_protocolIEs__item__id_tab
    ___ENDCX2RemovalResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ENDCX2RemovalResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __ENDCX2RemovalResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ENDCX2RemovalResponse_protocolIEs__item__id),
        ('criticality', ___ENDCX2RemovalResponse_protocolIEs__item__criticality),
        ('value', ___ENDCX2RemovalResponse_protocolIEs__item__value),
        ])
    __ENDCX2RemovalResponse_protocolIEs__item_._ext = None
    _ENDCX2RemovalResponse_protocolIEs._cont = __ENDCX2RemovalResponse_protocolIEs__item_
    _ENDCX2RemovalResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ENDCX2RemovalResponse._cont = ASN1Dict([
        ('protocolIEs', _ENDCX2RemovalResponse_protocolIEs),
        ])
    ENDCX2RemovalResponse._ext = []
    
    #-----< ENDCX2RemovalResponse-IEs >-----#
    ENDCX2RemovalResponse_IEs = CLASS(name='ENDCX2RemovalResponse-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _ENDCX2RemovalResponse_IEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'RespondingNodeType-EndcX2Removal')))
    _ENDCX2RemovalResponse_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'InterfaceInstanceIndication')))
    ENDCX2RemovalResponse_IEs._val = ASN1Set(rv=[dict([('id', 299), ('criticality', 'reject'), ('Value', _ENDCX2RemovalResponse_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 335), ('criticality', 'reject'), ('Value', _ENDCX2RemovalResponse_IEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RespondingNodeType-EndcX2Removal >-----#
    RespondingNodeType_EndcX2Removal = CHOICE(name='RespondingNodeType-EndcX2Removal', mode=MODE_TYPE)
    _RespondingNodeType_EndcX2Removal_respond_eNB = SEQ_OF(name='respond-eNB', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __RespondingNodeType_EndcX2Removal_respond_eNB__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___RespondingNodeType_EndcX2Removal_respond_eNB__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____RespondingNodeType_EndcX2Removal_respond_eNB__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____RespondingNodeType_EndcX2Removal_respond_eNB__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GlobalENB-ID')))
    ____RespondingNodeType_EndcX2Removal_respond_eNB__item__id_tab._val = ASN1Set(rv=[dict([('id', 21), ('criticality', 'reject'), ('Value', _____RespondingNodeType_EndcX2Removal_respond_eNB__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___RespondingNodeType_EndcX2Removal_respond_eNB__item__id._const_tab = ____RespondingNodeType_EndcX2Removal_respond_eNB__item__id_tab
    ___RespondingNodeType_EndcX2Removal_respond_eNB__item__id._const_tab_at = None
    ___RespondingNodeType_EndcX2Removal_respond_eNB__item__id._const_tab_id = 'id'
    ___RespondingNodeType_EndcX2Removal_respond_eNB__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___RespondingNodeType_EndcX2Removal_respond_eNB__item__criticality._const_tab = ____RespondingNodeType_EndcX2Removal_respond_eNB__item__id_tab
    ___RespondingNodeType_EndcX2Removal_respond_eNB__item__criticality._const_tab_at = ('..', 'id')
    ___RespondingNodeType_EndcX2Removal_respond_eNB__item__criticality._const_tab_id = 'criticality'
    ___RespondingNodeType_EndcX2Removal_respond_eNB__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___RespondingNodeType_EndcX2Removal_respond_eNB__item__value._const_tab = ____RespondingNodeType_EndcX2Removal_respond_eNB__item__id_tab
    ___RespondingNodeType_EndcX2Removal_respond_eNB__item__value._const_tab_at = ('..', 'id')
    ___RespondingNodeType_EndcX2Removal_respond_eNB__item__value._const_tab_id = 'Value'
    __RespondingNodeType_EndcX2Removal_respond_eNB__item_._cont = ASN1Dict([
        ('id', ___RespondingNodeType_EndcX2Removal_respond_eNB__item__id),
        ('criticality', ___RespondingNodeType_EndcX2Removal_respond_eNB__item__criticality),
        ('value', ___RespondingNodeType_EndcX2Removal_respond_eNB__item__value),
        ])
    __RespondingNodeType_EndcX2Removal_respond_eNB__item_._ext = None
    _RespondingNodeType_EndcX2Removal_respond_eNB._cont = __RespondingNodeType_EndcX2Removal_respond_eNB__item_
    _RespondingNodeType_EndcX2Removal_respond_eNB._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RespondingNodeType_EndcX2Removal_respond_en_gNB = SEQ_OF(name='respond-en-gNB', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __RespondingNodeType_EndcX2Removal_respond_en_gNB__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___RespondingNodeType_EndcX2Removal_respond_en_gNB__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____RespondingNodeType_EndcX2Removal_respond_en_gNB__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____RespondingNodeType_EndcX2Removal_respond_en_gNB__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GlobalGNB-ID')))
    ____RespondingNodeType_EndcX2Removal_respond_en_gNB__item__id_tab._val = ASN1Set(rv=[dict([('id', 252), ('criticality', 'reject'), ('Value', _____RespondingNodeType_EndcX2Removal_respond_en_gNB__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___RespondingNodeType_EndcX2Removal_respond_en_gNB__item__id._const_tab = ____RespondingNodeType_EndcX2Removal_respond_en_gNB__item__id_tab
    ___RespondingNodeType_EndcX2Removal_respond_en_gNB__item__id._const_tab_at = None
    ___RespondingNodeType_EndcX2Removal_respond_en_gNB__item__id._const_tab_id = 'id'
    ___RespondingNodeType_EndcX2Removal_respond_en_gNB__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___RespondingNodeType_EndcX2Removal_respond_en_gNB__item__criticality._const_tab = ____RespondingNodeType_EndcX2Removal_respond_en_gNB__item__id_tab
    ___RespondingNodeType_EndcX2Removal_respond_en_gNB__item__criticality._const_tab_at = ('..', 'id')
    ___RespondingNodeType_EndcX2Removal_respond_en_gNB__item__criticality._const_tab_id = 'criticality'
    ___RespondingNodeType_EndcX2Removal_respond_en_gNB__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___RespondingNodeType_EndcX2Removal_respond_en_gNB__item__value._const_tab = ____RespondingNodeType_EndcX2Removal_respond_en_gNB__item__id_tab
    ___RespondingNodeType_EndcX2Removal_respond_en_gNB__item__value._const_tab_at = ('..', 'id')
    ___RespondingNodeType_EndcX2Removal_respond_en_gNB__item__value._const_tab_id = 'Value'
    __RespondingNodeType_EndcX2Removal_respond_en_gNB__item_._cont = ASN1Dict([
        ('id', ___RespondingNodeType_EndcX2Removal_respond_en_gNB__item__id),
        ('criticality', ___RespondingNodeType_EndcX2Removal_respond_en_gNB__item__criticality),
        ('value', ___RespondingNodeType_EndcX2Removal_respond_en_gNB__item__value),
        ])
    __RespondingNodeType_EndcX2Removal_respond_en_gNB__item_._ext = None
    _RespondingNodeType_EndcX2Removal_respond_en_gNB._cont = __RespondingNodeType_EndcX2Removal_respond_en_gNB__item_
    _RespondingNodeType_EndcX2Removal_respond_en_gNB._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RespondingNodeType_EndcX2Removal._cont = ASN1Dict([
        ('respond-eNB', _RespondingNodeType_EndcX2Removal_respond_eNB),
        ('respond-en-gNB', _RespondingNodeType_EndcX2Removal_respond_en_gNB),
        ])
    RespondingNodeType_EndcX2Removal._ext = []
    
    #-----< ENB-ENDCX2RemovalReqAckIEs >-----#
    ENB_ENDCX2RemovalReqAckIEs = CLASS(name='ENB-ENDCX2RemovalReqAckIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _ENB_ENDCX2RemovalReqAckIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GlobalENB-ID')))
    ENB_ENDCX2RemovalReqAckIEs._val = ASN1Set(rv=[dict([('id', 21), ('criticality', 'reject'), ('Value', _ENB_ENDCX2RemovalReqAckIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< En-gNB-ENDCX2RemovalReqAckIEs >-----#
    En_gNB_ENDCX2RemovalReqAckIEs = CLASS(name='En-gNB-ENDCX2RemovalReqAckIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _En_gNB_ENDCX2RemovalReqAckIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GlobalGNB-ID')))
    En_gNB_ENDCX2RemovalReqAckIEs._val = ASN1Set(rv=[dict([('id', 252), ('criticality', 'reject'), ('Value', _En_gNB_ENDCX2RemovalReqAckIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< ENDCX2RemovalFailure >-----#
    ENDCX2RemovalFailure = SEQ(name='ENDCX2RemovalFailure', mode=MODE_TYPE)
    _ENDCX2RemovalFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __ENDCX2RemovalFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___ENDCX2RemovalFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____ENDCX2RemovalFailure_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____ENDCX2RemovalFailure_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _____ENDCX2RemovalFailure_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _____ENDCX2RemovalFailure_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'InterfaceInstanceIndication')))
    ____ENDCX2RemovalFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 5), ('criticality', 'ignore'), ('Value', _____ENDCX2RemovalFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _____ENDCX2RemovalFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 335), ('criticality', 'reject'), ('Value', _____ENDCX2RemovalFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ENDCX2RemovalFailure_protocolIEs__item__id._const_tab = ____ENDCX2RemovalFailure_protocolIEs__item__id_tab
    ___ENDCX2RemovalFailure_protocolIEs__item__id._const_tab_at = None
    ___ENDCX2RemovalFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___ENDCX2RemovalFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___ENDCX2RemovalFailure_protocolIEs__item__criticality._const_tab = ____ENDCX2RemovalFailure_protocolIEs__item__id_tab
    ___ENDCX2RemovalFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ENDCX2RemovalFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ENDCX2RemovalFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___ENDCX2RemovalFailure_protocolIEs__item__value._const_tab = ____ENDCX2RemovalFailure_protocolIEs__item__id_tab
    ___ENDCX2RemovalFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ENDCX2RemovalFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __ENDCX2RemovalFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ENDCX2RemovalFailure_protocolIEs__item__id),
        ('criticality', ___ENDCX2RemovalFailure_protocolIEs__item__criticality),
        ('value', ___ENDCX2RemovalFailure_protocolIEs__item__value),
        ])
    __ENDCX2RemovalFailure_protocolIEs__item_._ext = None
    _ENDCX2RemovalFailure_protocolIEs._cont = __ENDCX2RemovalFailure_protocolIEs__item_
    _ENDCX2RemovalFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ENDCX2RemovalFailure._cont = ASN1Dict([
        ('protocolIEs', _ENDCX2RemovalFailure_protocolIEs),
        ])
    ENDCX2RemovalFailure._ext = []
    
    #-----< ENDCX2RemovalFailure-IEs >-----#
    ENDCX2RemovalFailure_IEs = CLASS(name='ENDCX2RemovalFailure-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _ENDCX2RemovalFailure_IEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _ENDCX2RemovalFailure_IEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    _ENDCX2RemovalFailure_IEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'InterfaceInstanceIndication')))
    ENDCX2RemovalFailure_IEs._val = ASN1Set(rv=[dict([('id', 5), ('criticality', 'ignore'), ('Value', _ENDCX2RemovalFailure_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _ENDCX2RemovalFailure_IEs_val_Value_1), ('presence', 'optional')]), dict([('id', 335), ('criticality', 'reject'), ('Value', _ENDCX2RemovalFailure_IEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DataForwardingAddressIndication >-----#
    DataForwardingAddressIndication = SEQ(name='DataForwardingAddressIndication', mode=MODE_TYPE)
    _DataForwardingAddressIndication_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __DataForwardingAddressIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___DataForwardingAddressIndication_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____DataForwardingAddressIndication_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____DataForwardingAddressIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____DataForwardingAddressIndication_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____DataForwardingAddressIndication_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____DataForwardingAddressIndication_protocolIEs__item__id_tab_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____DataForwardingAddressIndication_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-DataForwardingAddress-List')))
    _____DataForwardingAddressIndication_protocolIEs__item__id_tab_val_Value_5 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CHO-DC-Indicator')))
    _____DataForwardingAddressIndication_protocolIEs__item__id_tab_val_Value_6 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CHO-DC-EarlyDataForwarding')))
    _____DataForwardingAddressIndication_protocolIEs__item__id_tab_val_Value_7 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNB-UE-X2AP-ID')))
    _____DataForwardingAddressIndication_protocolIEs__item__id_tab_val_Value_8 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CPCinformation-NOTIFY')))
    ____DataForwardingAddressIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 9), ('criticality', 'ignore'), ('Value', _____DataForwardingAddressIndication_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 155), ('criticality', 'ignore'), ('Value', _____DataForwardingAddressIndication_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 10), ('criticality', 'ignore'), ('Value', _____DataForwardingAddressIndication_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 156), ('criticality', 'ignore'), ('Value', _____DataForwardingAddressIndication_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 307), ('criticality', 'ignore'), ('Value', _____DataForwardingAddressIndication_protocolIEs__item__id_tab_val_Value_4), ('presence', 'mandatory')]), dict([('id', 368), ('criticality', 'reject'), ('Value', _____DataForwardingAddressIndication_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 407), ('criticality', 'ignore'), ('Value', _____DataForwardingAddressIndication_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 207), ('criticality', 'ignore'), ('Value', _____DataForwardingAddressIndication_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')]), dict([('id', 431), ('criticality', 'reject'), ('Value', _____DataForwardingAddressIndication_protocolIEs__item__id_tab_val_Value_8), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DataForwardingAddressIndication_protocolIEs__item__id._const_tab = ____DataForwardingAddressIndication_protocolIEs__item__id_tab
    ___DataForwardingAddressIndication_protocolIEs__item__id._const_tab_at = None
    ___DataForwardingAddressIndication_protocolIEs__item__id._const_tab_id = 'id'
    ___DataForwardingAddressIndication_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___DataForwardingAddressIndication_protocolIEs__item__criticality._const_tab = ____DataForwardingAddressIndication_protocolIEs__item__id_tab
    ___DataForwardingAddressIndication_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___DataForwardingAddressIndication_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___DataForwardingAddressIndication_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___DataForwardingAddressIndication_protocolIEs__item__value._const_tab = ____DataForwardingAddressIndication_protocolIEs__item__id_tab
    ___DataForwardingAddressIndication_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___DataForwardingAddressIndication_protocolIEs__item__value._const_tab_id = 'Value'
    __DataForwardingAddressIndication_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___DataForwardingAddressIndication_protocolIEs__item__id),
        ('criticality', ___DataForwardingAddressIndication_protocolIEs__item__criticality),
        ('value', ___DataForwardingAddressIndication_protocolIEs__item__value),
        ])
    __DataForwardingAddressIndication_protocolIEs__item_._ext = None
    _DataForwardingAddressIndication_protocolIEs._cont = __DataForwardingAddressIndication_protocolIEs__item_
    _DataForwardingAddressIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    DataForwardingAddressIndication._cont = ASN1Dict([
        ('protocolIEs', _DataForwardingAddressIndication_protocolIEs),
        ])
    DataForwardingAddressIndication._ext = []
    
    #-----< DataForwardingAddressIndication-IEs >-----#
    DataForwardingAddressIndication_IEs = CLASS(name='DataForwardingAddressIndication-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _DataForwardingAddressIndication_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _DataForwardingAddressIndication_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _DataForwardingAddressIndication_IEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _DataForwardingAddressIndication_IEs_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _DataForwardingAddressIndication_IEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-DataForwardingAddress-List')))
    _DataForwardingAddressIndication_IEs_val_Value_5 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CHO-DC-Indicator')))
    _DataForwardingAddressIndication_IEs_val_Value_6 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CHO-DC-EarlyDataForwarding')))
    _DataForwardingAddressIndication_IEs_val_Value_7 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNB-UE-X2AP-ID')))
    _DataForwardingAddressIndication_IEs_val_Value_8 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CPCinformation-NOTIFY')))
    DataForwardingAddressIndication_IEs._val = ASN1Set(rv=[dict([('id', 9), ('criticality', 'ignore'), ('Value', _DataForwardingAddressIndication_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 155), ('criticality', 'ignore'), ('Value', _DataForwardingAddressIndication_IEs_val_Value_1), ('presence', 'optional')]), dict([('id', 10), ('criticality', 'ignore'), ('Value', _DataForwardingAddressIndication_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 156), ('criticality', 'ignore'), ('Value', _DataForwardingAddressIndication_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 307), ('criticality', 'ignore'), ('Value', _DataForwardingAddressIndication_IEs_val_Value_4), ('presence', 'mandatory')]), dict([('id', 368), ('criticality', 'reject'), ('Value', _DataForwardingAddressIndication_IEs_val_Value_5), ('presence', 'optional')]), dict([('id', 407), ('criticality', 'ignore'), ('Value', _DataForwardingAddressIndication_IEs_val_Value_6), ('presence', 'optional')]), dict([('id', 207), ('criticality', 'ignore'), ('Value', _DataForwardingAddressIndication_IEs_val_Value_7), ('presence', 'optional')]), dict([('id', 431), ('criticality', 'reject'), ('Value', _DataForwardingAddressIndication_IEs_val_Value_8), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-DataForwardingAddress-List >-----#
    E_RABs_DataForwardingAddress_List = SEQ_OF(name='E-RABs-DataForwardingAddress-List', mode=MODE_TYPE)
    _E_RABs_DataForwardingAddress_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Single-Container')))
    __E_RABs_DataForwardingAddress_List__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ___E_RABs_DataForwardingAddress_List__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    ____E_RABs_DataForwardingAddress_List__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-DataForwardingAddress-Item')))
    ___E_RABs_DataForwardingAddress_List__item__id_tab._val = ASN1Set(rv=[dict([('id', 308), ('criticality', 'ignore'), ('Value', ____E_RABs_DataForwardingAddress_List__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __E_RABs_DataForwardingAddress_List__item__id._const_tab = ___E_RABs_DataForwardingAddress_List__item__id_tab
    __E_RABs_DataForwardingAddress_List__item__id._const_tab_at = None
    __E_RABs_DataForwardingAddress_List__item__id._const_tab_id = 'id'
    __E_RABs_DataForwardingAddress_List__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    __E_RABs_DataForwardingAddress_List__item__criticality._const_tab = ___E_RABs_DataForwardingAddress_List__item__id_tab
    __E_RABs_DataForwardingAddress_List__item__criticality._const_tab_at = ('..', 'id')
    __E_RABs_DataForwardingAddress_List__item__criticality._const_tab_id = 'criticality'
    __E_RABs_DataForwardingAddress_List__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    __E_RABs_DataForwardingAddress_List__item__value._const_tab = ___E_RABs_DataForwardingAddress_List__item__id_tab
    __E_RABs_DataForwardingAddress_List__item__value._const_tab_at = ('..', 'id')
    __E_RABs_DataForwardingAddress_List__item__value._const_tab_id = 'Value'
    _E_RABs_DataForwardingAddress_List__item_._cont = ASN1Dict([
        ('id', __E_RABs_DataForwardingAddress_List__item__id),
        ('criticality', __E_RABs_DataForwardingAddress_List__item__criticality),
        ('value', __E_RABs_DataForwardingAddress_List__item__value),
        ])
    _E_RABs_DataForwardingAddress_List__item_._ext = None
    E_RABs_DataForwardingAddress_List._cont = _E_RABs_DataForwardingAddress_List__item_
    E_RABs_DataForwardingAddress_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABs-DataForwardingAddress-ItemIEs >-----#
    E_RABs_DataForwardingAddress_ItemIEs = CLASS(name='E-RABs-DataForwardingAddress-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _E_RABs_DataForwardingAddress_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'E-RABs-DataForwardingAddress-Item')))
    E_RABs_DataForwardingAddress_ItemIEs._val = ASN1Set(rv=[dict([('id', 308), ('criticality', 'ignore'), ('Value', _E_RABs_DataForwardingAddress_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-DataForwardingAddress-Item >-----#
    E_RABs_DataForwardingAddress_Item = SEQ(name='E-RABs-DataForwardingAddress-Item', mode=MODE_TYPE)
    _E_RABs_DataForwardingAddress_Item_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'E-RAB-ID')))
    _E_RABs_DataForwardingAddress_Item_dl_GTPtunnelEndpoint = SEQ(name='dl-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-IEs', 'GTPtunnelEndpoint')))
    _E_RABs_DataForwardingAddress_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_DataForwardingAddress_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_DataForwardingAddress_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABs_DataForwardingAddress_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_DataForwardingAddress_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_DataForwardingAddress_Item_iE_Extensions__item__id._const_tab = ____E_RABs_DataForwardingAddress_Item_iE_Extensions__item__id_tab
    ___E_RABs_DataForwardingAddress_Item_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_DataForwardingAddress_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABs_DataForwardingAddress_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_RABs_DataForwardingAddress_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_DataForwardingAddress_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_DataForwardingAddress_Item_iE_Extensions__item__criticality._const_tab = ____E_RABs_DataForwardingAddress_Item_iE_Extensions__item__criticality_tab
    ___E_RABs_DataForwardingAddress_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABs_DataForwardingAddress_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABs_DataForwardingAddress_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_RABs_DataForwardingAddress_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_X2AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    ____E_RABs_DataForwardingAddress_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_DataForwardingAddress_Item_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_DataForwardingAddress_Item_iE_Extensions__item__extensionValue_tab
    ___E_RABs_DataForwardingAddress_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABs_DataForwardingAddress_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABs_DataForwardingAddress_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABs_DataForwardingAddress_Item_iE_Extensions__item__id),
        ('criticality', ___E_RABs_DataForwardingAddress_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABs_DataForwardingAddress_Item_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_DataForwardingAddress_Item_iE_Extensions__item_._ext = None
    _E_RABs_DataForwardingAddress_Item_iE_Extensions._cont = __E_RABs_DataForwardingAddress_Item_iE_Extensions__item_
    _E_RABs_DataForwardingAddress_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_DataForwardingAddress_Item._cont = ASN1Dict([
        ('e-RAB-ID', _E_RABs_DataForwardingAddress_Item_e_RAB_ID),
        ('dl-GTPtunnelEndpoint', _E_RABs_DataForwardingAddress_Item_dl_GTPtunnelEndpoint),
        ('iE-Extensions', _E_RABs_DataForwardingAddress_Item_iE_Extensions),
        ])
    E_RABs_DataForwardingAddress_Item._ext = []
    
    #-----< E-RABs-DataForwardingAddress-ItemExtIEs >-----#
    E_RABs_DataForwardingAddress_ItemExtIEs = CLASS(name='E-RABs-DataForwardingAddress-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-EXTENSION')))
    E_RABs_DataForwardingAddress_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GNBStatusIndication >-----#
    GNBStatusIndication = SEQ(name='GNBStatusIndication', mode=MODE_TYPE)
    _GNBStatusIndication_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __GNBStatusIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___GNBStatusIndication_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____GNBStatusIndication_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____GNBStatusIndication_protocolIEs__item__id_tab_val_Value_0 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GNBOverloadInformation')))
    _____GNBStatusIndication_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'InterfaceInstanceIndication')))
    ____GNBStatusIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 310), ('criticality', 'ignore'), ('Value', _____GNBStatusIndication_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 335), ('criticality', 'reject'), ('Value', _____GNBStatusIndication_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___GNBStatusIndication_protocolIEs__item__id._const_tab = ____GNBStatusIndication_protocolIEs__item__id_tab
    ___GNBStatusIndication_protocolIEs__item__id._const_tab_at = None
    ___GNBStatusIndication_protocolIEs__item__id._const_tab_id = 'id'
    ___GNBStatusIndication_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___GNBStatusIndication_protocolIEs__item__criticality._const_tab = ____GNBStatusIndication_protocolIEs__item__id_tab
    ___GNBStatusIndication_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___GNBStatusIndication_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___GNBStatusIndication_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___GNBStatusIndication_protocolIEs__item__value._const_tab = ____GNBStatusIndication_protocolIEs__item__id_tab
    ___GNBStatusIndication_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___GNBStatusIndication_protocolIEs__item__value._const_tab_id = 'Value'
    __GNBStatusIndication_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___GNBStatusIndication_protocolIEs__item__id),
        ('criticality', ___GNBStatusIndication_protocolIEs__item__criticality),
        ('value', ___GNBStatusIndication_protocolIEs__item__value),
        ])
    __GNBStatusIndication_protocolIEs__item_._ext = None
    _GNBStatusIndication_protocolIEs._cont = __GNBStatusIndication_protocolIEs__item_
    _GNBStatusIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    GNBStatusIndication._cont = ASN1Dict([
        ('protocolIEs', _GNBStatusIndication_protocolIEs),
        ])
    GNBStatusIndication._ext = []
    
    #-----< GNBStatusIndicationIEs >-----#
    GNBStatusIndicationIEs = CLASS(name='GNBStatusIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _GNBStatusIndicationIEs_val_Value_0 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GNBOverloadInformation')))
    _GNBStatusIndicationIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'InterfaceInstanceIndication')))
    GNBStatusIndicationIEs._val = ASN1Set(rv=[dict([('id', 310), ('criticality', 'ignore'), ('Value', _GNBStatusIndicationIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 335), ('criticality', 'reject'), ('Value', _GNBStatusIndicationIEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ENDCConfigurationTransfer >-----#
    ENDCConfigurationTransfer = SEQ(name='ENDCConfigurationTransfer', mode=MODE_TYPE)
    _ENDCConfigurationTransfer_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __ENDCConfigurationTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___ENDCConfigurationTransfer_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____ENDCConfigurationTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____ENDCConfigurationTransfer_protocolIEs__item__id_tab_val_Value_0 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'EndcSONConfigurationTransfer')))
    _____ENDCConfigurationTransfer_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'InterfaceInstanceIndication')))
    ____ENDCConfigurationTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 326), ('criticality', 'ignore'), ('Value', _____ENDCConfigurationTransfer_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 335), ('criticality', 'reject'), ('Value', _____ENDCConfigurationTransfer_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ENDCConfigurationTransfer_protocolIEs__item__id._const_tab = ____ENDCConfigurationTransfer_protocolIEs__item__id_tab
    ___ENDCConfigurationTransfer_protocolIEs__item__id._const_tab_at = None
    ___ENDCConfigurationTransfer_protocolIEs__item__id._const_tab_id = 'id'
    ___ENDCConfigurationTransfer_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___ENDCConfigurationTransfer_protocolIEs__item__criticality._const_tab = ____ENDCConfigurationTransfer_protocolIEs__item__id_tab
    ___ENDCConfigurationTransfer_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ENDCConfigurationTransfer_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ENDCConfigurationTransfer_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___ENDCConfigurationTransfer_protocolIEs__item__value._const_tab = ____ENDCConfigurationTransfer_protocolIEs__item__id_tab
    ___ENDCConfigurationTransfer_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ENDCConfigurationTransfer_protocolIEs__item__value._const_tab_id = 'Value'
    __ENDCConfigurationTransfer_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ENDCConfigurationTransfer_protocolIEs__item__id),
        ('criticality', ___ENDCConfigurationTransfer_protocolIEs__item__criticality),
        ('value', ___ENDCConfigurationTransfer_protocolIEs__item__value),
        ])
    __ENDCConfigurationTransfer_protocolIEs__item_._ext = None
    _ENDCConfigurationTransfer_protocolIEs._cont = __ENDCConfigurationTransfer_protocolIEs__item_
    _ENDCConfigurationTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ENDCConfigurationTransfer._cont = ASN1Dict([
        ('protocolIEs', _ENDCConfigurationTransfer_protocolIEs),
        ])
    ENDCConfigurationTransfer._ext = []
    
    #-----< ENDCConfigurationTransfer-IEs >-----#
    ENDCConfigurationTransfer_IEs = CLASS(name='ENDCConfigurationTransfer-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _ENDCConfigurationTransfer_IEs_val_Value_0 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'EndcSONConfigurationTransfer')))
    _ENDCConfigurationTransfer_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'InterfaceInstanceIndication')))
    ENDCConfigurationTransfer_IEs._val = ASN1Set(rv=[dict([('id', 326), ('criticality', 'ignore'), ('Value', _ENDCConfigurationTransfer_IEs_val_Value_0), ('presence', 'optional')]), dict([('id', 335), ('criticality', 'reject'), ('Value', _ENDCConfigurationTransfer_IEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< TraceStart >-----#
    TraceStart = SEQ(name='TraceStart', mode=MODE_TYPE)
    _TraceStart_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __TraceStart_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___TraceStart_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____TraceStart_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____TraceStart_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____TraceStart_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNB-UE-X2AP-ID')))
    _____TraceStart_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TraceActivation')))
    _____TraceStart_protocolIEs__item__id_tab_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    ____TraceStart_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'reject'), ('Value', _____TraceStart_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 207), ('criticality', 'reject'), ('Value', _____TraceStart_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 13), ('criticality', 'ignore'), ('Value', _____TraceStart_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 157), ('criticality', 'reject'), ('Value', _____TraceStart_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___TraceStart_protocolIEs__item__id._const_tab = ____TraceStart_protocolIEs__item__id_tab
    ___TraceStart_protocolIEs__item__id._const_tab_at = None
    ___TraceStart_protocolIEs__item__id._const_tab_id = 'id'
    ___TraceStart_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___TraceStart_protocolIEs__item__criticality._const_tab = ____TraceStart_protocolIEs__item__id_tab
    ___TraceStart_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___TraceStart_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___TraceStart_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___TraceStart_protocolIEs__item__value._const_tab = ____TraceStart_protocolIEs__item__id_tab
    ___TraceStart_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___TraceStart_protocolIEs__item__value._const_tab_id = 'Value'
    __TraceStart_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___TraceStart_protocolIEs__item__id),
        ('criticality', ___TraceStart_protocolIEs__item__criticality),
        ('value', ___TraceStart_protocolIEs__item__value),
        ])
    __TraceStart_protocolIEs__item_._ext = None
    _TraceStart_protocolIEs._cont = __TraceStart_protocolIEs__item_
    _TraceStart_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    TraceStart._cont = ASN1Dict([
        ('protocolIEs', _TraceStart_protocolIEs),
        ])
    TraceStart._ext = []
    
    #-----< TraceStartIEs >-----#
    TraceStartIEs = CLASS(name='TraceStartIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _TraceStartIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _TraceStartIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNB-UE-X2AP-ID')))
    _TraceStartIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TraceActivation')))
    _TraceStartIEs_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    TraceStartIEs._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'reject'), ('Value', _TraceStartIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 207), ('criticality', 'reject'), ('Value', _TraceStartIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 13), ('criticality', 'ignore'), ('Value', _TraceStartIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 157), ('criticality', 'reject'), ('Value', _TraceStartIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DeactivateTrace >-----#
    DeactivateTrace = SEQ(name='DeactivateTrace', mode=MODE_TYPE)
    _DeactivateTrace_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __DeactivateTrace_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___DeactivateTrace_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____DeactivateTrace_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNB-UE-X2AP-ID')))
    _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'EUTRANTraceID')))
    _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    ____DeactivateTrace_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'reject'), ('Value', _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 207), ('criticality', 'reject'), ('Value', _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 333), ('criticality', 'ignore'), ('Value', _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 157), ('criticality', 'reject'), ('Value', _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DeactivateTrace_protocolIEs__item__id._const_tab = ____DeactivateTrace_protocolIEs__item__id_tab
    ___DeactivateTrace_protocolIEs__item__id._const_tab_at = None
    ___DeactivateTrace_protocolIEs__item__id._const_tab_id = 'id'
    ___DeactivateTrace_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___DeactivateTrace_protocolIEs__item__criticality._const_tab = ____DeactivateTrace_protocolIEs__item__id_tab
    ___DeactivateTrace_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___DeactivateTrace_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___DeactivateTrace_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___DeactivateTrace_protocolIEs__item__value._const_tab = ____DeactivateTrace_protocolIEs__item__id_tab
    ___DeactivateTrace_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___DeactivateTrace_protocolIEs__item__value._const_tab_id = 'Value'
    __DeactivateTrace_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___DeactivateTrace_protocolIEs__item__id),
        ('criticality', ___DeactivateTrace_protocolIEs__item__criticality),
        ('value', ___DeactivateTrace_protocolIEs__item__value),
        ])
    __DeactivateTrace_protocolIEs__item_._ext = None
    _DeactivateTrace_protocolIEs._cont = __DeactivateTrace_protocolIEs__item_
    _DeactivateTrace_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    DeactivateTrace._cont = ASN1Dict([
        ('protocolIEs', _DeactivateTrace_protocolIEs),
        ])
    DeactivateTrace._ext = []
    
    #-----< DeactivateTraceIEs >-----#
    DeactivateTraceIEs = CLASS(name='DeactivateTraceIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _DeactivateTraceIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _DeactivateTraceIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNB-UE-X2AP-ID')))
    _DeactivateTraceIEs_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'EUTRANTraceID')))
    _DeactivateTraceIEs_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    DeactivateTraceIEs._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'reject'), ('Value', _DeactivateTraceIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 207), ('criticality', 'reject'), ('Value', _DeactivateTraceIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 333), ('criticality', 'ignore'), ('Value', _DeactivateTraceIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 157), ('criticality', 'reject'), ('Value', _DeactivateTraceIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< CellTrafficTrace >-----#
    CellTrafficTrace = SEQ(name='CellTrafficTrace', mode=MODE_TYPE)
    _CellTrafficTrace_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __CellTrafficTrace_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___CellTrafficTrace_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____CellTrafficTrace_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNB-UE-X2AP-ID')))
    _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'EUTRANTraceID')))
    _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_3 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TraceCollectionEntityIPAddress')))
    _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_4 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PrivacyIndicator')))
    _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_5 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    ____CellTrafficTrace_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'reject'), ('Value', _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 207), ('criticality', 'reject'), ('Value', _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 333), ('criticality', 'ignore'), ('Value', _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 377), ('criticality', 'ignore'), ('Value', _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 376), ('criticality', 'ignore'), ('Value', _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 157), ('criticality', 'reject'), ('Value', _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___CellTrafficTrace_protocolIEs__item__id._const_tab = ____CellTrafficTrace_protocolIEs__item__id_tab
    ___CellTrafficTrace_protocolIEs__item__id._const_tab_at = None
    ___CellTrafficTrace_protocolIEs__item__id._const_tab_id = 'id'
    ___CellTrafficTrace_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___CellTrafficTrace_protocolIEs__item__criticality._const_tab = ____CellTrafficTrace_protocolIEs__item__id_tab
    ___CellTrafficTrace_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___CellTrafficTrace_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___CellTrafficTrace_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___CellTrafficTrace_protocolIEs__item__value._const_tab = ____CellTrafficTrace_protocolIEs__item__id_tab
    ___CellTrafficTrace_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___CellTrafficTrace_protocolIEs__item__value._const_tab_id = 'Value'
    __CellTrafficTrace_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___CellTrafficTrace_protocolIEs__item__id),
        ('criticality', ___CellTrafficTrace_protocolIEs__item__criticality),
        ('value', ___CellTrafficTrace_protocolIEs__item__value),
        ])
    __CellTrafficTrace_protocolIEs__item_._ext = None
    _CellTrafficTrace_protocolIEs._cont = __CellTrafficTrace_protocolIEs__item_
    _CellTrafficTrace_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    CellTrafficTrace._cont = ASN1Dict([
        ('protocolIEs', _CellTrafficTrace_protocolIEs),
        ])
    CellTrafficTrace._ext = []
    
    #-----< CellTrafficTraceIEs >-----#
    CellTrafficTraceIEs = CLASS(name='CellTrafficTraceIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _CellTrafficTraceIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _CellTrafficTraceIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNB-UE-X2AP-ID')))
    _CellTrafficTraceIEs_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'EUTRANTraceID')))
    _CellTrafficTraceIEs_val_Value_3 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'TraceCollectionEntityIPAddress')))
    _CellTrafficTraceIEs_val_Value_4 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'PrivacyIndicator')))
    _CellTrafficTraceIEs_val_Value_5 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    CellTrafficTraceIEs._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'reject'), ('Value', _CellTrafficTraceIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 207), ('criticality', 'reject'), ('Value', _CellTrafficTraceIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 333), ('criticality', 'ignore'), ('Value', _CellTrafficTraceIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 377), ('criticality', 'ignore'), ('Value', _CellTrafficTraceIEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 376), ('criticality', 'ignore'), ('Value', _CellTrafficTraceIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 157), ('criticality', 'reject'), ('Value', _CellTrafficTraceIEs_val_Value_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< F1CTrafficTransfer >-----#
    F1CTrafficTransfer = SEQ(name='F1CTrafficTransfer', mode=MODE_TYPE)
    _F1CTrafficTransfer_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __F1CTrafficTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___F1CTrafficTransfer_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____F1CTrafficTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____F1CTrafficTransfer_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____F1CTrafficTransfer_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNB-UE-X2AP-ID')))
    _____F1CTrafficTransfer_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'F1CTrafficContainer')))
    _____F1CTrafficTransfer_protocolIEs__item__id_tab_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    ____F1CTrafficTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'reject'), ('Value', _____F1CTrafficTransfer_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 207), ('criticality', 'reject'), ('Value', _____F1CTrafficTransfer_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 397), ('criticality', 'reject'), ('Value', _____F1CTrafficTransfer_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 157), ('criticality', 'reject'), ('Value', _____F1CTrafficTransfer_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___F1CTrafficTransfer_protocolIEs__item__id._const_tab = ____F1CTrafficTransfer_protocolIEs__item__id_tab
    ___F1CTrafficTransfer_protocolIEs__item__id._const_tab_at = None
    ___F1CTrafficTransfer_protocolIEs__item__id._const_tab_id = 'id'
    ___F1CTrafficTransfer_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___F1CTrafficTransfer_protocolIEs__item__criticality._const_tab = ____F1CTrafficTransfer_protocolIEs__item__id_tab
    ___F1CTrafficTransfer_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___F1CTrafficTransfer_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___F1CTrafficTransfer_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___F1CTrafficTransfer_protocolIEs__item__value._const_tab = ____F1CTrafficTransfer_protocolIEs__item__id_tab
    ___F1CTrafficTransfer_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___F1CTrafficTransfer_protocolIEs__item__value._const_tab_id = 'Value'
    __F1CTrafficTransfer_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___F1CTrafficTransfer_protocolIEs__item__id),
        ('criticality', ___F1CTrafficTransfer_protocolIEs__item__criticality),
        ('value', ___F1CTrafficTransfer_protocolIEs__item__value),
        ])
    __F1CTrafficTransfer_protocolIEs__item_._ext = None
    _F1CTrafficTransfer_protocolIEs._cont = __F1CTrafficTransfer_protocolIEs__item_
    _F1CTrafficTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    F1CTrafficTransfer._cont = ASN1Dict([
        ('protocolIEs', _F1CTrafficTransfer_protocolIEs),
        ])
    F1CTrafficTransfer._ext = []
    
    #-----< F1CTrafficTransfer-IEs >-----#
    F1CTrafficTransfer_IEs = CLASS(name='F1CTrafficTransfer-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _F1CTrafficTransfer_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _F1CTrafficTransfer_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNB-UE-X2AP-ID')))
    _F1CTrafficTransfer_IEs_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'F1CTrafficContainer')))
    _F1CTrafficTransfer_IEs_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    F1CTrafficTransfer_IEs._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'reject'), ('Value', _F1CTrafficTransfer_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 207), ('criticality', 'reject'), ('Value', _F1CTrafficTransfer_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 397), ('criticality', 'reject'), ('Value', _F1CTrafficTransfer_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 157), ('criticality', 'reject'), ('Value', _F1CTrafficTransfer_IEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UERadioCapabilityIDMappingRequest >-----#
    UERadioCapabilityIDMappingRequest = SEQ(name='UERadioCapabilityIDMappingRequest', mode=MODE_TYPE)
    _UERadioCapabilityIDMappingRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __UERadioCapabilityIDMappingRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___UERadioCapabilityIDMappingRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____UERadioCapabilityIDMappingRequest_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____UERadioCapabilityIDMappingRequest_protocolIEs__item__id_tab_val_Value_0 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UERadioCapabilityID')))
    ____UERadioCapabilityIDMappingRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 378), ('criticality', 'reject'), ('Value', _____UERadioCapabilityIDMappingRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___UERadioCapabilityIDMappingRequest_protocolIEs__item__id._const_tab = ____UERadioCapabilityIDMappingRequest_protocolIEs__item__id_tab
    ___UERadioCapabilityIDMappingRequest_protocolIEs__item__id._const_tab_at = None
    ___UERadioCapabilityIDMappingRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___UERadioCapabilityIDMappingRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___UERadioCapabilityIDMappingRequest_protocolIEs__item__criticality._const_tab = ____UERadioCapabilityIDMappingRequest_protocolIEs__item__id_tab
    ___UERadioCapabilityIDMappingRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UERadioCapabilityIDMappingRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UERadioCapabilityIDMappingRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___UERadioCapabilityIDMappingRequest_protocolIEs__item__value._const_tab = ____UERadioCapabilityIDMappingRequest_protocolIEs__item__id_tab
    ___UERadioCapabilityIDMappingRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UERadioCapabilityIDMappingRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __UERadioCapabilityIDMappingRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UERadioCapabilityIDMappingRequest_protocolIEs__item__id),
        ('criticality', ___UERadioCapabilityIDMappingRequest_protocolIEs__item__criticality),
        ('value', ___UERadioCapabilityIDMappingRequest_protocolIEs__item__value),
        ])
    __UERadioCapabilityIDMappingRequest_protocolIEs__item_._ext = None
    _UERadioCapabilityIDMappingRequest_protocolIEs._cont = __UERadioCapabilityIDMappingRequest_protocolIEs__item_
    _UERadioCapabilityIDMappingRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UERadioCapabilityIDMappingRequest._cont = ASN1Dict([
        ('protocolIEs', _UERadioCapabilityIDMappingRequest_protocolIEs),
        ])
    UERadioCapabilityIDMappingRequest._ext = []
    
    #-----< UERadioCapabilityIDMappingRequestIEs >-----#
    UERadioCapabilityIDMappingRequestIEs = CLASS(name='UERadioCapabilityIDMappingRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _UERadioCapabilityIDMappingRequestIEs_val_Value_0 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UERadioCapabilityID')))
    UERadioCapabilityIDMappingRequestIEs._val = ASN1Set(rv=[dict([('id', 378), ('criticality', 'reject'), ('Value', _UERadioCapabilityIDMappingRequestIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UERadioCapabilityIDMappingResponse >-----#
    UERadioCapabilityIDMappingResponse = SEQ(name='UERadioCapabilityIDMappingResponse', mode=MODE_TYPE)
    _UERadioCapabilityIDMappingResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __UERadioCapabilityIDMappingResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___UERadioCapabilityIDMappingResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab_val_Value_0 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UERadioCapabilityID')))
    _____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab_val_Value_1 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UERadioCapability')))
    _____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    ____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 378), ('criticality', 'reject'), ('Value', _____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 400), ('criticality', 'ignore'), ('Value', _____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UERadioCapabilityIDMappingResponse_protocolIEs__item__id._const_tab = ____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab
    ___UERadioCapabilityIDMappingResponse_protocolIEs__item__id._const_tab_at = None
    ___UERadioCapabilityIDMappingResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___UERadioCapabilityIDMappingResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___UERadioCapabilityIDMappingResponse_protocolIEs__item__criticality._const_tab = ____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab
    ___UERadioCapabilityIDMappingResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UERadioCapabilityIDMappingResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UERadioCapabilityIDMappingResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___UERadioCapabilityIDMappingResponse_protocolIEs__item__value._const_tab = ____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab
    ___UERadioCapabilityIDMappingResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UERadioCapabilityIDMappingResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __UERadioCapabilityIDMappingResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UERadioCapabilityIDMappingResponse_protocolIEs__item__id),
        ('criticality', ___UERadioCapabilityIDMappingResponse_protocolIEs__item__criticality),
        ('value', ___UERadioCapabilityIDMappingResponse_protocolIEs__item__value),
        ])
    __UERadioCapabilityIDMappingResponse_protocolIEs__item_._ext = None
    _UERadioCapabilityIDMappingResponse_protocolIEs._cont = __UERadioCapabilityIDMappingResponse_protocolIEs__item_
    _UERadioCapabilityIDMappingResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UERadioCapabilityIDMappingResponse._cont = ASN1Dict([
        ('protocolIEs', _UERadioCapabilityIDMappingResponse_protocolIEs),
        ])
    UERadioCapabilityIDMappingResponse._ext = []
    
    #-----< UERadioCapabilityIDMappingResponseIEs >-----#
    UERadioCapabilityIDMappingResponseIEs = CLASS(name='UERadioCapabilityIDMappingResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _UERadioCapabilityIDMappingResponseIEs_val_Value_0 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UERadioCapabilityID')))
    _UERadioCapabilityIDMappingResponseIEs_val_Value_1 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UERadioCapability')))
    _UERadioCapabilityIDMappingResponseIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'CriticalityDiagnostics')))
    UERadioCapabilityIDMappingResponseIEs._val = ASN1Set(rv=[dict([('id', 378), ('criticality', 'reject'), ('Value', _UERadioCapabilityIDMappingResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 400), ('criticality', 'ignore'), ('Value', _UERadioCapabilityIDMappingResponseIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _UERadioCapabilityIDMappingResponseIEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< CPC-cancel >-----#
    CPC_cancel = SEQ(name='CPC-cancel', mode=MODE_TYPE)
    _CPC_cancel_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Container')))
    __CPC_cancel_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-Containers', 'ProtocolIE-Field')))
    ___CPC_cancel_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['id']))
    ____CPC_cancel_protocolIEs__item__id_tab = CLASS(name='_tab_X2AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _____CPC_cancel_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _____CPC_cancel_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNB-UE-X2AP-ID')))
    _____CPC_cancel_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _____CPC_cancel_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _____CPC_cancel_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GlobalGNB-ID')))
    ____CPC_cancel_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'reject'), ('Value', _____CPC_cancel_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 207), ('criticality', 'reject'), ('Value', _____CPC_cancel_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 157), ('criticality', 'reject'), ('Value', _____CPC_cancel_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _____CPC_cancel_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 239), ('criticality', 'reject'), ('Value', _____CPC_cancel_protocolIEs__item__id_tab_val_Value_4), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___CPC_cancel_protocolIEs__item__id._const_tab = ____CPC_cancel_protocolIEs__item__id_tab
    ___CPC_cancel_protocolIEs__item__id._const_tab_at = None
    ___CPC_cancel_protocolIEs__item__id._const_tab_id = 'id'
    ___CPC_cancel_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['criticality']))
    ___CPC_cancel_protocolIEs__item__criticality._const_tab = ____CPC_cancel_protocolIEs__item__id_tab
    ___CPC_cancel_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___CPC_cancel_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___CPC_cancel_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-Containers', 'X2AP-PROTOCOL-IES'), ['Value']))
    ___CPC_cancel_protocolIEs__item__value._const_tab = ____CPC_cancel_protocolIEs__item__id_tab
    ___CPC_cancel_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___CPC_cancel_protocolIEs__item__value._const_tab_id = 'Value'
    __CPC_cancel_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___CPC_cancel_protocolIEs__item__id),
        ('criticality', ___CPC_cancel_protocolIEs__item__criticality),
        ('value', ___CPC_cancel_protocolIEs__item__value),
        ])
    __CPC_cancel_protocolIEs__item_._ext = None
    _CPC_cancel_protocolIEs._cont = __CPC_cancel_protocolIEs__item_
    _CPC_cancel_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    CPC_cancel._cont = ASN1Dict([
        ('protocolIEs', _CPC_cancel_protocolIEs),
        ])
    CPC_cancel._ext = []
    
    #-----< CPC-cancel-IEs >-----#
    CPC_cancel_IEs = CLASS(name='CPC-cancel-IEs', mode=MODE_SET, typeref=ASN1RefType(('X2AP-Containers', 'X2AP-PROTOCOL-IES')))
    _CPC_cancel_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID')))
    _CPC_cancel_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'SgNB-UE-X2AP-ID')))
    _CPC_cancel_IEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'UE-X2AP-ID-Extension')))
    _CPC_cancel_IEs_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'Cause')))
    _CPC_cancel_IEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-IEs', 'GlobalGNB-ID')))
    CPC_cancel_IEs._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'reject'), ('Value', _CPC_cancel_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 207), ('criticality', 'reject'), ('Value', _CPC_cancel_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 157), ('criticality', 'reject'), ('Value', _CPC_cancel_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _CPC_cancel_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 239), ('criticality', 'reject'), ('Value', _CPC_cancel_IEs_val_Value_4), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    _all_ = [
        ____HandoverRequest_protocolIEs__item__id_tab,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_0,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_1,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_2,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_3,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_4,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_5,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_6,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_7,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_8,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_9,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_10,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_11,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_12,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_13,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_14,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_15,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_16,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_17,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_18,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_19,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_20,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_21,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_22,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_23,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_24,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_25,
        ___HandoverRequest_protocolIEs__item__id,
        ___HandoverRequest_protocolIEs__item__criticality,
        ___HandoverRequest_protocolIEs__item__value,
        __HandoverRequest_protocolIEs__item_,
        _HandoverRequest_protocolIEs,
        HandoverRequest,
        HandoverRequest_IEs,
        _HandoverRequest_IEs_val_Value_0,
        _HandoverRequest_IEs_val_Value_1,
        _HandoverRequest_IEs_val_Value_2,
        _HandoverRequest_IEs_val_Value_3,
        _HandoverRequest_IEs_val_Value_4,
        _HandoverRequest_IEs_val_Value_5,
        _HandoverRequest_IEs_val_Value_6,
        _HandoverRequest_IEs_val_Value_7,
        _HandoverRequest_IEs_val_Value_8,
        _HandoverRequest_IEs_val_Value_9,
        _HandoverRequest_IEs_val_Value_10,
        _HandoverRequest_IEs_val_Value_11,
        _HandoverRequest_IEs_val_Value_12,
        _HandoverRequest_IEs_val_Value_13,
        _HandoverRequest_IEs_val_Value_14,
        _HandoverRequest_IEs_val_Value_15,
        _HandoverRequest_IEs_val_Value_16,
        _HandoverRequest_IEs_val_Value_17,
        _HandoverRequest_IEs_val_Value_18,
        _HandoverRequest_IEs_val_Value_19,
        _HandoverRequest_IEs_val_Value_20,
        _HandoverRequest_IEs_val_Value_21,
        _HandoverRequest_IEs_val_Value_22,
        _HandoverRequest_IEs_val_Value_23,
        _HandoverRequest_IEs_val_Value_24,
        _HandoverRequest_IEs_val_Value_25,
        _UE_ContextInformation_mME_UE_S1AP_ID,
        _UE_ContextInformation_uESecurityCapabilities,
        _UE_ContextInformation_aS_SecurityInformation,
        _UE_ContextInformation_uEaggregateMaximumBitRate,
        _UE_ContextInformation_subscriberProfileIDforRFP,
        _UE_ContextInformation_e_RABs_ToBeSetup_List,
        _UE_ContextInformation_rRC_Context,
        _UE_ContextInformation_handoverRestrictionList,
        _UE_ContextInformation_locationReportingInformation,
        ____UE_ContextInformation_iE_Extensions__item__id_tab,
        _____UE_ContextInformation_iE_Extensions__item__id_tab_val_Extension_0,
        _____UE_ContextInformation_iE_Extensions__item__id_tab_val_Extension_1,
        _____UE_ContextInformation_iE_Extensions__item__id_tab_val_Extension_2,
        _____UE_ContextInformation_iE_Extensions__item__id_tab_val_Extension_3,
        _____UE_ContextInformation_iE_Extensions__item__id_tab_val_Extension_4,
        _____UE_ContextInformation_iE_Extensions__item__id_tab_val_Extension_5,
        _____UE_ContextInformation_iE_Extensions__item__id_tab_val_Extension_6,
        _____UE_ContextInformation_iE_Extensions__item__id_tab_val_Extension_7,
        ___UE_ContextInformation_iE_Extensions__item__id,
        ___UE_ContextInformation_iE_Extensions__item__criticality,
        ___UE_ContextInformation_iE_Extensions__item__extensionValue,
        __UE_ContextInformation_iE_Extensions__item_,
        _UE_ContextInformation_iE_Extensions,
        UE_ContextInformation,
        UE_ContextInformation_ExtIEs,
        _UE_ContextInformation_ExtIEs_val_Extension_0,
        _UE_ContextInformation_ExtIEs_val_Extension_1,
        _UE_ContextInformation_ExtIEs_val_Extension_2,
        _UE_ContextInformation_ExtIEs_val_Extension_3,
        _UE_ContextInformation_ExtIEs_val_Extension_4,
        _UE_ContextInformation_ExtIEs_val_Extension_5,
        _UE_ContextInformation_ExtIEs_val_Extension_6,
        _UE_ContextInformation_ExtIEs_val_Extension_7,
        ___E_RABs_ToBeSetup_List__item__id_tab,
        ____E_RABs_ToBeSetup_List__item__id_tab_val_Value_0,
        __E_RABs_ToBeSetup_List__item__id,
        __E_RABs_ToBeSetup_List__item__criticality,
        __E_RABs_ToBeSetup_List__item__value,
        _E_RABs_ToBeSetup_List__item_,
        E_RABs_ToBeSetup_List,
        E_RABs_ToBeSetup_ItemIEs,
        _E_RABs_ToBeSetup_ItemIEs_val_Value_0,
        _E_RABs_ToBeSetup_Item_e_RAB_ID,
        _E_RABs_ToBeSetup_Item_e_RAB_Level_QoS_Parameters,
        _E_RABs_ToBeSetup_Item_dL_Forwarding,
        _E_RABs_ToBeSetup_Item_uL_GTPtunnelEndpoint,
        ____E_RABs_ToBeSetup_Item_iE_Extensions__item__id_tab,
        _____E_RABs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_0,
        _____E_RABs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_1,
        _____E_RABs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_2,
        _____E_RABs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_3,
        _____E_RABs_ToBeSetup_Item_iE_Extensions__item__id_tab_val_Extension_4,
        ___E_RABs_ToBeSetup_Item_iE_Extensions__item__id,
        ___E_RABs_ToBeSetup_Item_iE_Extensions__item__criticality,
        ___E_RABs_ToBeSetup_Item_iE_Extensions__item__extensionValue,
        __E_RABs_ToBeSetup_Item_iE_Extensions__item_,
        _E_RABs_ToBeSetup_Item_iE_Extensions,
        E_RABs_ToBeSetup_Item,
        E_RABs_ToBeSetup_ItemExtIEs,
        _E_RABs_ToBeSetup_ItemExtIEs_val_Extension_0,
        _E_RABs_ToBeSetup_ItemExtIEs_val_Extension_1,
        _E_RABs_ToBeSetup_ItemExtIEs_val_Extension_2,
        _E_RABs_ToBeSetup_ItemExtIEs_val_Extension_3,
        _E_RABs_ToBeSetup_ItemExtIEs_val_Extension_4,
        MobilityInformation,
        SourceDLForwardingIPAddress,
        _UE_ContextReferenceAtSeNB_source_GlobalSeNB_ID,
        _UE_ContextReferenceAtSeNB_seNB_UE_X2AP_ID,
        _UE_ContextReferenceAtSeNB_seNB_UE_X2AP_ID_Extension,
        ____UE_ContextReferenceAtSeNB_iE_Extensions__item__id_tab,
        ___UE_ContextReferenceAtSeNB_iE_Extensions__item__id,
        ____UE_ContextReferenceAtSeNB_iE_Extensions__item__criticality_tab,
        ___UE_ContextReferenceAtSeNB_iE_Extensions__item__criticality,
        ____UE_ContextReferenceAtSeNB_iE_Extensions__item__extensionValue_tab,
        ___UE_ContextReferenceAtSeNB_iE_Extensions__item__extensionValue,
        __UE_ContextReferenceAtSeNB_iE_Extensions__item_,
        _UE_ContextReferenceAtSeNB_iE_Extensions,
        UE_ContextReferenceAtSeNB,
        UE_ContextReferenceAtSeNB_ItemExtIEs,
        _UE_ContextReferenceAtWT_wTID,
        _UE_ContextReferenceAtWT_wT_UE_XwAP_ID,
        ____UE_ContextReferenceAtWT_iE_Extensions__item__id_tab,
        ___UE_ContextReferenceAtWT_iE_Extensions__item__id,
        ____UE_ContextReferenceAtWT_iE_Extensions__item__criticality_tab,
        ___UE_ContextReferenceAtWT_iE_Extensions__item__criticality,
        ____UE_ContextReferenceAtWT_iE_Extensions__item__extensionValue_tab,
        ___UE_ContextReferenceAtWT_iE_Extensions__item__extensionValue,
        __UE_ContextReferenceAtWT_iE_Extensions__item_,
        _UE_ContextReferenceAtWT_iE_Extensions,
        UE_ContextReferenceAtWT,
        UE_ContextReferenceAtWT_ItemExtIEs,
        _UE_ContextReferenceAtSgNB_source_GlobalSgNB_ID,
        _UE_ContextReferenceAtSgNB_sgNB_UE_X2AP_ID,
        ____UE_ContextReferenceAtSgNB_iE_Extensions__item__id_tab,
        ___UE_ContextReferenceAtSgNB_iE_Extensions__item__id,
        ____UE_ContextReferenceAtSgNB_iE_Extensions__item__criticality_tab,
        ___UE_ContextReferenceAtSgNB_iE_Extensions__item__criticality,
        ____UE_ContextReferenceAtSgNB_iE_Extensions__item__extensionValue_tab,
        ___UE_ContextReferenceAtSgNB_iE_Extensions__item__extensionValue,
        __UE_ContextReferenceAtSgNB_iE_Extensions__item_,
        _UE_ContextReferenceAtSgNB_iE_Extensions,
        UE_ContextReferenceAtSgNB,
        UE_ContextReferenceAtSgNB_ItemExtIEs,
        ____HandoverRequestAcknowledge_protocolIEs__item__id_tab,
        _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_0,
        _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_1,
        _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_2,
        _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_3,
        _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_4,
        _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_5,
        _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_6,
        _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_7,
        _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_8,
        _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_9,
        _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_10,
        _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_11,
        _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_12,
        ___HandoverRequestAcknowledge_protocolIEs__item__id,
        ___HandoverRequestAcknowledge_protocolIEs__item__criticality,
        ___HandoverRequestAcknowledge_protocolIEs__item__value,
        __HandoverRequestAcknowledge_protocolIEs__item_,
        _HandoverRequestAcknowledge_protocolIEs,
        HandoverRequestAcknowledge,
        HandoverRequestAcknowledge_IEs,
        _HandoverRequestAcknowledge_IEs_val_Value_0,
        _HandoverRequestAcknowledge_IEs_val_Value_1,
        _HandoverRequestAcknowledge_IEs_val_Value_2,
        _HandoverRequestAcknowledge_IEs_val_Value_3,
        _HandoverRequestAcknowledge_IEs_val_Value_4,
        _HandoverRequestAcknowledge_IEs_val_Value_5,
        _HandoverRequestAcknowledge_IEs_val_Value_6,
        _HandoverRequestAcknowledge_IEs_val_Value_7,
        _HandoverRequestAcknowledge_IEs_val_Value_8,
        _HandoverRequestAcknowledge_IEs_val_Value_9,
        _HandoverRequestAcknowledge_IEs_val_Value_10,
        _HandoverRequestAcknowledge_IEs_val_Value_11,
        _HandoverRequestAcknowledge_IEs_val_Value_12,
        ___E_RABs_Admitted_List__item__id_tab,
        ____E_RABs_Admitted_List__item__id_tab_val_Value_0,
        __E_RABs_Admitted_List__item__id,
        __E_RABs_Admitted_List__item__criticality,
        __E_RABs_Admitted_List__item__value,
        _E_RABs_Admitted_List__item_,
        E_RABs_Admitted_List,
        E_RABs_Admitted_ItemIEs,
        _E_RABs_Admitted_ItemIEs_val_Value_0,
        _E_RABs_Admitted_Item_e_RAB_ID,
        _E_RABs_Admitted_Item_uL_GTP_TunnelEndpoint,
        _E_RABs_Admitted_Item_dL_GTP_TunnelEndpoint,
        ____E_RABs_Admitted_Item_iE_Extensions__item__id_tab,
        _____E_RABs_Admitted_Item_iE_Extensions__item__id_tab_val_Extension_0,
        ___E_RABs_Admitted_Item_iE_Extensions__item__id,
        ___E_RABs_Admitted_Item_iE_Extensions__item__criticality,
        ___E_RABs_Admitted_Item_iE_Extensions__item__extensionValue,
        __E_RABs_Admitted_Item_iE_Extensions__item_,
        _E_RABs_Admitted_Item_iE_Extensions,
        E_RABs_Admitted_Item,
        E_RABs_Admitted_Item_ExtIEs,
        _E_RABs_Admitted_Item_ExtIEs_val_Extension_0,
        ____HandoverPreparationFailure_protocolIEs__item__id_tab,
        _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_1,
        _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_2,
        _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_3,
        _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_4,
        ___HandoverPreparationFailure_protocolIEs__item__id,
        ___HandoverPreparationFailure_protocolIEs__item__criticality,
        ___HandoverPreparationFailure_protocolIEs__item__value,
        __HandoverPreparationFailure_protocolIEs__item_,
        _HandoverPreparationFailure_protocolIEs,
        HandoverPreparationFailure,
        HandoverPreparationFailure_IEs,
        _HandoverPreparationFailure_IEs_val_Value_0,
        _HandoverPreparationFailure_IEs_val_Value_1,
        _HandoverPreparationFailure_IEs_val_Value_2,
        _HandoverPreparationFailure_IEs_val_Value_3,
        _HandoverPreparationFailure_IEs_val_Value_4,
        ____HandoverReport_protocolIEs__item__id_tab,
        _____HandoverReport_protocolIEs__item__id_tab_val_Value_0,
        _____HandoverReport_protocolIEs__item__id_tab_val_Value_1,
        _____HandoverReport_protocolIEs__item__id_tab_val_Value_2,
        _____HandoverReport_protocolIEs__item__id_tab_val_Value_3,
        _____HandoverReport_protocolIEs__item__id_tab_val_Value_4,
        _____HandoverReport_protocolIEs__item__id_tab_val_Value_5,
        _____HandoverReport_protocolIEs__item__id_tab_val_Value_6,
        _____HandoverReport_protocolIEs__item__id_tab_val_Value_7,
        _____HandoverReport_protocolIEs__item__id_tab_val_Value_8,
        _____HandoverReport_protocolIEs__item__id_tab_val_Value_9,
        _____HandoverReport_protocolIEs__item__id_tab_val_Value_10,
        ___HandoverReport_protocolIEs__item__id,
        ___HandoverReport_protocolIEs__item__criticality,
        ___HandoverReport_protocolIEs__item__value,
        __HandoverReport_protocolIEs__item_,
        _HandoverReport_protocolIEs,
        HandoverReport,
        HandoverReport_IEs,
        _HandoverReport_IEs_val_Value_0,
        _HandoverReport_IEs_val_Value_1,
        _HandoverReport_IEs_val_Value_2,
        _HandoverReport_IEs_val_Value_3,
        _HandoverReport_IEs_val_Value_4,
        _HandoverReport_IEs_val_Value_5,
        _HandoverReport_IEs_val_Value_6,
        _HandoverReport_IEs_val_Value_7,
        _HandoverReport_IEs_val_Value_8,
        _HandoverReport_IEs_val_Value_9,
        _HandoverReport_IEs_val_Value_10,
        ____EarlyStatusTransfer_protocolIEs__item__id_tab,
        _____EarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_0,
        _____EarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_1,
        _____EarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_2,
        _____EarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_3,
        _____EarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_4,
        _____EarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_5,
        ___EarlyStatusTransfer_protocolIEs__item__id,
        ___EarlyStatusTransfer_protocolIEs__item__criticality,
        ___EarlyStatusTransfer_protocolIEs__item__value,
        __EarlyStatusTransfer_protocolIEs__item_,
        _EarlyStatusTransfer_protocolIEs,
        EarlyStatusTransfer,
        EarlyStatusTransfer_IEs,
        _EarlyStatusTransfer_IEs_val_Value_0,
        _EarlyStatusTransfer_IEs_val_Value_1,
        _EarlyStatusTransfer_IEs_val_Value_2,
        _EarlyStatusTransfer_IEs_val_Value_3,
        _EarlyStatusTransfer_IEs_val_Value_4,
        _EarlyStatusTransfer_IEs_val_Value_5,
        _ProcedureStageChoice_first_dl_count,
        _ProcedureStageChoice_dl_discarding,
        ___ProcedureStageChoice_choice_extension_id_tab,
        __ProcedureStageChoice_choice_extension_id,
        ___ProcedureStageChoice_choice_extension_criticality_tab,
        __ProcedureStageChoice_choice_extension_criticality,
        ___ProcedureStageChoice_choice_extension_value_tab,
        __ProcedureStageChoice_choice_extension_value,
        _ProcedureStageChoice_choice_extension,
        ProcedureStageChoice,
        ProcedureStageChoice_ExtIEs,
        _FirstDLCount_e_RABsSubjectToEarlyStatusTransfer,
        ____FirstDLCount_iE_Extension__item__id_tab,
        ___FirstDLCount_iE_Extension__item__id,
        ____FirstDLCount_iE_Extension__item__criticality_tab,
        ___FirstDLCount_iE_Extension__item__criticality,
        ____FirstDLCount_iE_Extension__item__extensionValue_tab,
        ___FirstDLCount_iE_Extension__item__extensionValue,
        __FirstDLCount_iE_Extension__item_,
        _FirstDLCount_iE_Extension,
        FirstDLCount,
        FirstDLCount_ExtIEs,
        _DLDiscarding_e_RABsSubjectToDLDiscarding_List,
        ____DLDiscarding_iE_Extension__item__id_tab,
        ___DLDiscarding_iE_Extension__item__id,
        ____DLDiscarding_iE_Extension__item__criticality_tab,
        ___DLDiscarding_iE_Extension__item__criticality,
        ____DLDiscarding_iE_Extension__item__extensionValue_tab,
        ___DLDiscarding_iE_Extension__item__extensionValue,
        __DLDiscarding_iE_Extension__item_,
        _DLDiscarding_iE_Extension,
        DLDiscarding,
        DLDiscarding_ExtIEs,
        ____SNStatusTransfer_protocolIEs__item__id_tab,
        _____SNStatusTransfer_protocolIEs__item__id_tab_val_Value_0,
        _____SNStatusTransfer_protocolIEs__item__id_tab_val_Value_1,
        _____SNStatusTransfer_protocolIEs__item__id_tab_val_Value_2,
        _____SNStatusTransfer_protocolIEs__item__id_tab_val_Value_3,
        _____SNStatusTransfer_protocolIEs__item__id_tab_val_Value_4,
        _____SNStatusTransfer_protocolIEs__item__id_tab_val_Value_5,
        ___SNStatusTransfer_protocolIEs__item__id,
        ___SNStatusTransfer_protocolIEs__item__criticality,
        ___SNStatusTransfer_protocolIEs__item__value,
        __SNStatusTransfer_protocolIEs__item_,
        _SNStatusTransfer_protocolIEs,
        SNStatusTransfer,
        SNStatusTransfer_IEs,
        _SNStatusTransfer_IEs_val_Value_0,
        _SNStatusTransfer_IEs_val_Value_1,
        _SNStatusTransfer_IEs_val_Value_2,
        _SNStatusTransfer_IEs_val_Value_3,
        _SNStatusTransfer_IEs_val_Value_4,
        _SNStatusTransfer_IEs_val_Value_5,
        ___E_RABs_SubjectToStatusTransfer_List__item__id_tab,
        ____E_RABs_SubjectToStatusTransfer_List__item__id_tab_val_Value_0,
        __E_RABs_SubjectToStatusTransfer_List__item__id,
        __E_RABs_SubjectToStatusTransfer_List__item__criticality,
        __E_RABs_SubjectToStatusTransfer_List__item__value,
        _E_RABs_SubjectToStatusTransfer_List__item_,
        E_RABs_SubjectToStatusTransfer_List,
        E_RABs_SubjectToStatusTransfer_ItemIEs,
        _E_RABs_SubjectToStatusTransfer_ItemIEs_val_Value_0,
        _E_RABs_SubjectToStatusTransfer_Item_e_RAB_ID,
        _E_RABs_SubjectToStatusTransfer_Item_receiveStatusofULPDCPSDUs,
        _E_RABs_SubjectToStatusTransfer_Item_uL_COUNTvalue,
        _E_RABs_SubjectToStatusTransfer_Item_dL_COUNTvalue,
        ____E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab,
        _____E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_0,
        _____E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_1,
        _____E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_2,
        _____E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_3,
        _____E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_4,
        _____E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_5,
        ___E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__id,
        ___E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__criticality,
        ___E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item__extensionValue,
        __E_RABs_SubjectToStatusTransfer_Item_iE_Extensions__item_,
        _E_RABs_SubjectToStatusTransfer_Item_iE_Extensions,
        E_RABs_SubjectToStatusTransfer_Item,
        E_RABs_SubjectToStatusTransfer_ItemExtIEs,
        _E_RABs_SubjectToStatusTransfer_ItemExtIEs_val_Extension_0,
        _E_RABs_SubjectToStatusTransfer_ItemExtIEs_val_Extension_1,
        _E_RABs_SubjectToStatusTransfer_ItemExtIEs_val_Extension_2,
        _E_RABs_SubjectToStatusTransfer_ItemExtIEs_val_Extension_3,
        _E_RABs_SubjectToStatusTransfer_ItemExtIEs_val_Extension_4,
        _E_RABs_SubjectToStatusTransfer_ItemExtIEs_val_Extension_5,
        ____UEContextRelease_protocolIEs__item__id_tab,
        _____UEContextRelease_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextRelease_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextRelease_protocolIEs__item__id_tab_val_Value_2,
        _____UEContextRelease_protocolIEs__item__id_tab_val_Value_3,
        _____UEContextRelease_protocolIEs__item__id_tab_val_Value_4,
        _____UEContextRelease_protocolIEs__item__id_tab_val_Value_5,
        ___UEContextRelease_protocolIEs__item__id,
        ___UEContextRelease_protocolIEs__item__criticality,
        ___UEContextRelease_protocolIEs__item__value,
        __UEContextRelease_protocolIEs__item_,
        _UEContextRelease_protocolIEs,
        UEContextRelease,
        UEContextRelease_IEs,
        _UEContextRelease_IEs_val_Value_0,
        _UEContextRelease_IEs_val_Value_1,
        _UEContextRelease_IEs_val_Value_2,
        _UEContextRelease_IEs_val_Value_3,
        _UEContextRelease_IEs_val_Value_4,
        _UEContextRelease_IEs_val_Value_5,
        ____HandoverCancel_protocolIEs__item__id_tab,
        _____HandoverCancel_protocolIEs__item__id_tab_val_Value_0,
        _____HandoverCancel_protocolIEs__item__id_tab_val_Value_1,
        _____HandoverCancel_protocolIEs__item__id_tab_val_Value_2,
        _____HandoverCancel_protocolIEs__item__id_tab_val_Value_3,
        _____HandoverCancel_protocolIEs__item__id_tab_val_Value_4,
        _____HandoverCancel_protocolIEs__item__id_tab_val_Value_5,
        ___HandoverCancel_protocolIEs__item__id,
        ___HandoverCancel_protocolIEs__item__criticality,
        ___HandoverCancel_protocolIEs__item__value,
        __HandoverCancel_protocolIEs__item_,
        _HandoverCancel_protocolIEs,
        HandoverCancel,
        HandoverCancel_IEs,
        _HandoverCancel_IEs_val_Value_0,
        _HandoverCancel_IEs_val_Value_1,
        _HandoverCancel_IEs_val_Value_2,
        _HandoverCancel_IEs_val_Value_3,
        _HandoverCancel_IEs_val_Value_4,
        _HandoverCancel_IEs_val_Value_5,
        ____HandoverSuccess_protocolIEs__item__id_tab,
        _____HandoverSuccess_protocolIEs__item__id_tab_val_Value_0,
        _____HandoverSuccess_protocolIEs__item__id_tab_val_Value_1,
        _____HandoverSuccess_protocolIEs__item__id_tab_val_Value_2,
        _____HandoverSuccess_protocolIEs__item__id_tab_val_Value_3,
        _____HandoverSuccess_protocolIEs__item__id_tab_val_Value_4,
        ___HandoverSuccess_protocolIEs__item__id,
        ___HandoverSuccess_protocolIEs__item__criticality,
        ___HandoverSuccess_protocolIEs__item__value,
        __HandoverSuccess_protocolIEs__item_,
        _HandoverSuccess_protocolIEs,
        HandoverSuccess,
        HandoverSuccess_IEs,
        _HandoverSuccess_IEs_val_Value_0,
        _HandoverSuccess_IEs_val_Value_1,
        _HandoverSuccess_IEs_val_Value_2,
        _HandoverSuccess_IEs_val_Value_3,
        _HandoverSuccess_IEs_val_Value_4,
        ____ConditionalHandoverCancel_protocolIEs__item__id_tab,
        _____ConditionalHandoverCancel_protocolIEs__item__id_tab_val_Value_0,
        _____ConditionalHandoverCancel_protocolIEs__item__id_tab_val_Value_1,
        _____ConditionalHandoverCancel_protocolIEs__item__id_tab_val_Value_2,
        _____ConditionalHandoverCancel_protocolIEs__item__id_tab_val_Value_3,
        _____ConditionalHandoverCancel_protocolIEs__item__id_tab_val_Value_4,
        _____ConditionalHandoverCancel_protocolIEs__item__id_tab_val_Value_5,
        ___ConditionalHandoverCancel_protocolIEs__item__id,
        ___ConditionalHandoverCancel_protocolIEs__item__criticality,
        ___ConditionalHandoverCancel_protocolIEs__item__value,
        __ConditionalHandoverCancel_protocolIEs__item_,
        _ConditionalHandoverCancel_protocolIEs,
        ConditionalHandoverCancel,
        ConditionalHandoverCancel_IEs,
        _ConditionalHandoverCancel_IEs_val_Value_0,
        _ConditionalHandoverCancel_IEs_val_Value_1,
        _ConditionalHandoverCancel_IEs_val_Value_2,
        _ConditionalHandoverCancel_IEs_val_Value_3,
        _ConditionalHandoverCancel_IEs_val_Value_4,
        _ConditionalHandoverCancel_IEs_val_Value_5,
        ____ErrorIndication_protocolIEs__item__id_tab,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_0,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_1,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_2,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_3,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_4,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_5,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_6,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_7,
        ___ErrorIndication_protocolIEs__item__id,
        ___ErrorIndication_protocolIEs__item__criticality,
        ___ErrorIndication_protocolIEs__item__value,
        __ErrorIndication_protocolIEs__item_,
        _ErrorIndication_protocolIEs,
        ErrorIndication,
        ErrorIndication_IEs,
        _ErrorIndication_IEs_val_Value_0,
        _ErrorIndication_IEs_val_Value_1,
        _ErrorIndication_IEs_val_Value_2,
        _ErrorIndication_IEs_val_Value_3,
        _ErrorIndication_IEs_val_Value_4,
        _ErrorIndication_IEs_val_Value_5,
        _ErrorIndication_IEs_val_Value_6,
        _ErrorIndication_IEs_val_Value_7,
        ____ResetRequest_protocolIEs__item__id_tab,
        _____ResetRequest_protocolIEs__item__id_tab_val_Value_0,
        _____ResetRequest_protocolIEs__item__id_tab_val_Value_1,
        ___ResetRequest_protocolIEs__item__id,
        ___ResetRequest_protocolIEs__item__criticality,
        ___ResetRequest_protocolIEs__item__value,
        __ResetRequest_protocolIEs__item_,
        _ResetRequest_protocolIEs,
        ResetRequest,
        ResetRequest_IEs,
        _ResetRequest_IEs_val_Value_0,
        _ResetRequest_IEs_val_Value_1,
        ____ResetResponse_protocolIEs__item__id_tab,
        _____ResetResponse_protocolIEs__item__id_tab_val_Value_0,
        _____ResetResponse_protocolIEs__item__id_tab_val_Value_1,
        ___ResetResponse_protocolIEs__item__id,
        ___ResetResponse_protocolIEs__item__criticality,
        ___ResetResponse_protocolIEs__item__value,
        __ResetResponse_protocolIEs__item_,
        _ResetResponse_protocolIEs,
        ResetResponse,
        ResetResponse_IEs,
        _ResetResponse_IEs_val_Value_0,
        _ResetResponse_IEs_val_Value_1,
        ____X2SetupRequest_protocolIEs__item__id_tab,
        _____X2SetupRequest_protocolIEs__item__id_tab_val_Value_0,
        _____X2SetupRequest_protocolIEs__item__id_tab_val_Value_1,
        _____X2SetupRequest_protocolIEs__item__id_tab_val_Value_2,
        _____X2SetupRequest_protocolIEs__item__id_tab_val_Value_3,
        ___X2SetupRequest_protocolIEs__item__id,
        ___X2SetupRequest_protocolIEs__item__criticality,
        ___X2SetupRequest_protocolIEs__item__value,
        __X2SetupRequest_protocolIEs__item_,
        _X2SetupRequest_protocolIEs,
        X2SetupRequest,
        X2SetupRequest_IEs,
        _X2SetupRequest_IEs_val_Value_0,
        _X2SetupRequest_IEs_val_Value_1,
        _X2SetupRequest_IEs_val_Value_2,
        _X2SetupRequest_IEs_val_Value_3,
        ____X2SetupResponse_protocolIEs__item__id_tab,
        _____X2SetupResponse_protocolIEs__item__id_tab_val_Value_0,
        _____X2SetupResponse_protocolIEs__item__id_tab_val_Value_1,
        _____X2SetupResponse_protocolIEs__item__id_tab_val_Value_2,
        _____X2SetupResponse_protocolIEs__item__id_tab_val_Value_3,
        _____X2SetupResponse_protocolIEs__item__id_tab_val_Value_4,
        ___X2SetupResponse_protocolIEs__item__id,
        ___X2SetupResponse_protocolIEs__item__criticality,
        ___X2SetupResponse_protocolIEs__item__value,
        __X2SetupResponse_protocolIEs__item_,
        _X2SetupResponse_protocolIEs,
        X2SetupResponse,
        X2SetupResponse_IEs,
        _X2SetupResponse_IEs_val_Value_0,
        _X2SetupResponse_IEs_val_Value_1,
        _X2SetupResponse_IEs_val_Value_2,
        _X2SetupResponse_IEs_val_Value_3,
        _X2SetupResponse_IEs_val_Value_4,
        ____X2SetupFailure_protocolIEs__item__id_tab,
        _____X2SetupFailure_protocolIEs__item__id_tab_val_Value_0,
        _____X2SetupFailure_protocolIEs__item__id_tab_val_Value_1,
        _____X2SetupFailure_protocolIEs__item__id_tab_val_Value_2,
        ___X2SetupFailure_protocolIEs__item__id,
        ___X2SetupFailure_protocolIEs__item__criticality,
        ___X2SetupFailure_protocolIEs__item__value,
        __X2SetupFailure_protocolIEs__item_,
        _X2SetupFailure_protocolIEs,
        X2SetupFailure,
        X2SetupFailure_IEs,
        _X2SetupFailure_IEs_val_Value_0,
        _X2SetupFailure_IEs_val_Value_1,
        _X2SetupFailure_IEs_val_Value_2,
        ____LoadInformation_protocolIEs__item__id_tab,
        _____LoadInformation_protocolIEs__item__id_tab_val_Value_0,
        ___LoadInformation_protocolIEs__item__id,
        ___LoadInformation_protocolIEs__item__criticality,
        ___LoadInformation_protocolIEs__item__value,
        __LoadInformation_protocolIEs__item_,
        _LoadInformation_protocolIEs,
        LoadInformation,
        LoadInformation_IEs,
        _LoadInformation_IEs_val_Value_0,
        ___CellInformation_List__item__id_tab,
        ____CellInformation_List__item__id_tab_val_Value_0,
        __CellInformation_List__item__id,
        __CellInformation_List__item__criticality,
        __CellInformation_List__item__value,
        _CellInformation_List__item_,
        CellInformation_List,
        CellInformation_ItemIEs,
        _CellInformation_ItemIEs_val_Value_0,
        _CellInformation_Item_cell_ID,
        _CellInformation_Item_ul_InterferenceOverloadIndication,
        _CellInformation_Item_ul_HighInterferenceIndicationInfo,
        _CellInformation_Item_relativeNarrowbandTxPower,
        ____CellInformation_Item_iE_Extensions__item__id_tab,
        _____CellInformation_Item_iE_Extensions__item__id_tab_val_Extension_0,
        _____CellInformation_Item_iE_Extensions__item__id_tab_val_Extension_1,
        _____CellInformation_Item_iE_Extensions__item__id_tab_val_Extension_2,
        _____CellInformation_Item_iE_Extensions__item__id_tab_val_Extension_3,
        _____CellInformation_Item_iE_Extensions__item__id_tab_val_Extension_4,
        _____CellInformation_Item_iE_Extensions__item__id_tab_val_Extension_5,
        ___CellInformation_Item_iE_Extensions__item__id,
        ___CellInformation_Item_iE_Extensions__item__criticality,
        ___CellInformation_Item_iE_Extensions__item__extensionValue,
        __CellInformation_Item_iE_Extensions__item_,
        _CellInformation_Item_iE_Extensions,
        CellInformation_Item,
        CellInformation_Item_ExtIEs,
        _CellInformation_Item_ExtIEs_val_Extension_0,
        _CellInformation_Item_ExtIEs_val_Extension_1,
        _CellInformation_Item_ExtIEs_val_Extension_2,
        _CellInformation_Item_ExtIEs_val_Extension_3,
        _CellInformation_Item_ExtIEs_val_Extension_4,
        _CellInformation_Item_ExtIEs_val_Extension_5,
        ____ENBConfigurationUpdate_protocolIEs__item__id_tab,
        _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_0,
        _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_1,
        _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_2,
        _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_3,
        _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_4,
        _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_5,
        ___ENBConfigurationUpdate_protocolIEs__item__id,
        ___ENBConfigurationUpdate_protocolIEs__item__criticality,
        ___ENBConfigurationUpdate_protocolIEs__item__value,
        __ENBConfigurationUpdate_protocolIEs__item_,
        _ENBConfigurationUpdate_protocolIEs,
        ENBConfigurationUpdate,
        ENBConfigurationUpdate_IEs,
        _ENBConfigurationUpdate_IEs_val_Value_0,
        _ENBConfigurationUpdate_IEs_val_Value_1,
        _ENBConfigurationUpdate_IEs_val_Value_2,
        _ENBConfigurationUpdate_IEs_val_Value_3,
        _ENBConfigurationUpdate_IEs_val_Value_4,
        _ENBConfigurationUpdate_IEs_val_Value_5,
        _ServedCellsToModify__item_,
        ServedCellsToModify,
        _ServedCellsToModify_Item_old_ecgi,
        _ServedCellsToModify_Item_servedCellInfo,
        _ServedCellsToModify_Item_neighbour_Info,
        ____ServedCellsToModify_Item_iE_Extensions__item__id_tab,
        _____ServedCellsToModify_Item_iE_Extensions__item__id_tab_val_Extension_0,
        _____ServedCellsToModify_Item_iE_Extensions__item__id_tab_val_Extension_1,
        ___ServedCellsToModify_Item_iE_Extensions__item__id,
        ___ServedCellsToModify_Item_iE_Extensions__item__criticality,
        ___ServedCellsToModify_Item_iE_Extensions__item__extensionValue,
        __ServedCellsToModify_Item_iE_Extensions__item_,
        _ServedCellsToModify_Item_iE_Extensions,
        ServedCellsToModify_Item,
        ServedCellsToModify_Item_ExtIEs,
        _ServedCellsToModify_Item_ExtIEs_val_Extension_0,
        _ServedCellsToModify_Item_ExtIEs_val_Extension_1,
        _Old_ECGIs__item_,
        Old_ECGIs,
        ____ENBConfigurationUpdateAcknowledge_protocolIEs__item__id_tab,
        _____ENBConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_0,
        ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__id,
        ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__criticality,
        ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__value,
        __ENBConfigurationUpdateAcknowledge_protocolIEs__item_,
        _ENBConfigurationUpdateAcknowledge_protocolIEs,
        ENBConfigurationUpdateAcknowledge,
        ENBConfigurationUpdateAcknowledge_IEs,
        _ENBConfigurationUpdateAcknowledge_IEs_val_Value_0,
        ____ENBConfigurationUpdateFailure_protocolIEs__item__id_tab,
        _____ENBConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_0,
        _____ENBConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_1,
        _____ENBConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_2,
        ___ENBConfigurationUpdateFailure_protocolIEs__item__id,
        ___ENBConfigurationUpdateFailure_protocolIEs__item__criticality,
        ___ENBConfigurationUpdateFailure_protocolIEs__item__value,
        __ENBConfigurationUpdateFailure_protocolIEs__item_,
        _ENBConfigurationUpdateFailure_protocolIEs,
        ENBConfigurationUpdateFailure,
        ENBConfigurationUpdateFailure_IEs,
        _ENBConfigurationUpdateFailure_IEs_val_Value_0,
        _ENBConfigurationUpdateFailure_IEs_val_Value_1,
        _ENBConfigurationUpdateFailure_IEs_val_Value_2,
        ____ResourceStatusRequest_protocolIEs__item__id_tab,
        _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_0,
        _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_1,
        _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_2,
        _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_3,
        _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_4,
        _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_5,
        _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_6,
        _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_7,
        _____ResourceStatusRequest_protocolIEs__item__id_tab_val_Value_8,
        ___ResourceStatusRequest_protocolIEs__item__id,
        ___ResourceStatusRequest_protocolIEs__item__criticality,
        ___ResourceStatusRequest_protocolIEs__item__value,
        __ResourceStatusRequest_protocolIEs__item_,
        _ResourceStatusRequest_protocolIEs,
        ResourceStatusRequest,
        ResourceStatusRequest_IEs,
        _ResourceStatusRequest_IEs_val_Value_0,
        _ResourceStatusRequest_IEs_val_Value_1,
        _ResourceStatusRequest_IEs_val_Value_2,
        _ResourceStatusRequest_IEs_val_Value_3,
        _ResourceStatusRequest_IEs_val_Value_4,
        _ResourceStatusRequest_IEs_val_Value_5,
        _ResourceStatusRequest_IEs_val_Value_6,
        _ResourceStatusRequest_IEs_val_Value_7,
        _ResourceStatusRequest_IEs_val_Value_8,
        ___CellToReport_List__item__id_tab,
        ____CellToReport_List__item__id_tab_val_Value_0,
        __CellToReport_List__item__id,
        __CellToReport_List__item__criticality,
        __CellToReport_List__item__value,
        _CellToReport_List__item_,
        CellToReport_List,
        CellToReport_ItemIEs,
        _CellToReport_ItemIEs_val_Value_0,
        _CellToReport_Item_cell_ID,
        ____CellToReport_Item_iE_Extensions__item__id_tab,
        ___CellToReport_Item_iE_Extensions__item__id,
        ____CellToReport_Item_iE_Extensions__item__criticality_tab,
        ___CellToReport_Item_iE_Extensions__item__criticality,
        ____CellToReport_Item_iE_Extensions__item__extensionValue_tab,
        ___CellToReport_Item_iE_Extensions__item__extensionValue,
        __CellToReport_Item_iE_Extensions__item_,
        _CellToReport_Item_iE_Extensions,
        CellToReport_Item,
        CellToReport_Item_ExtIEs,
        ReportingPeriodicity,
        PartialSuccessIndicator,
        ____ResourceStatusResponse_protocolIEs__item__id_tab,
        _____ResourceStatusResponse_protocolIEs__item__id_tab_val_Value_0,
        _____ResourceStatusResponse_protocolIEs__item__id_tab_val_Value_1,
        _____ResourceStatusResponse_protocolIEs__item__id_tab_val_Value_2,
        _____ResourceStatusResponse_protocolIEs__item__id_tab_val_Value_3,
        ___ResourceStatusResponse_protocolIEs__item__id,
        ___ResourceStatusResponse_protocolIEs__item__criticality,
        ___ResourceStatusResponse_protocolIEs__item__value,
        __ResourceStatusResponse_protocolIEs__item_,
        _ResourceStatusResponse_protocolIEs,
        ResourceStatusResponse,
        ResourceStatusResponse_IEs,
        _ResourceStatusResponse_IEs_val_Value_0,
        _ResourceStatusResponse_IEs_val_Value_1,
        _ResourceStatusResponse_IEs_val_Value_2,
        _ResourceStatusResponse_IEs_val_Value_3,
        ___MeasurementInitiationResult_List__item__id_tab,
        ____MeasurementInitiationResult_List__item__id_tab_val_Value_0,
        __MeasurementInitiationResult_List__item__id,
        __MeasurementInitiationResult_List__item__criticality,
        __MeasurementInitiationResult_List__item__value,
        _MeasurementInitiationResult_List__item_,
        MeasurementInitiationResult_List,
        MeasurementInitiationResult_ItemIEs,
        _MeasurementInitiationResult_ItemIEs_val_Value_0,
        _MeasurementInitiationResult_Item_cell_ID,
        _MeasurementInitiationResult_Item_measurementFailureCause_List,
        ____MeasurementInitiationResult_Item_iE_Extensions__item__id_tab,
        ___MeasurementInitiationResult_Item_iE_Extensions__item__id,
        ____MeasurementInitiationResult_Item_iE_Extensions__item__criticality_tab,
        ___MeasurementInitiationResult_Item_iE_Extensions__item__criticality,
        ____MeasurementInitiationResult_Item_iE_Extensions__item__extensionValue_tab,
        ___MeasurementInitiationResult_Item_iE_Extensions__item__extensionValue,
        __MeasurementInitiationResult_Item_iE_Extensions__item_,
        _MeasurementInitiationResult_Item_iE_Extensions,
        MeasurementInitiationResult_Item,
        MeasurementInitiationResult_Item_ExtIEs,
        ___MeasurementFailureCause_List__item__id_tab,
        ____MeasurementFailureCause_List__item__id_tab_val_Value_0,
        __MeasurementFailureCause_List__item__id,
        __MeasurementFailureCause_List__item__criticality,
        __MeasurementFailureCause_List__item__value,
        _MeasurementFailureCause_List__item_,
        MeasurementFailureCause_List,
        MeasurementFailureCause_ItemIEs,
        _MeasurementFailureCause_ItemIEs_val_Value_0,
        _MeasurementFailureCause_Item_measurementFailedReportCharacteristics,
        _MeasurementFailureCause_Item_cause,
        ____MeasurementFailureCause_Item_iE_Extensions__item__id_tab,
        ___MeasurementFailureCause_Item_iE_Extensions__item__id,
        ____MeasurementFailureCause_Item_iE_Extensions__item__criticality_tab,
        ___MeasurementFailureCause_Item_iE_Extensions__item__criticality,
        ____MeasurementFailureCause_Item_iE_Extensions__item__extensionValue_tab,
        ___MeasurementFailureCause_Item_iE_Extensions__item__extensionValue,
        __MeasurementFailureCause_Item_iE_Extensions__item_,
        _MeasurementFailureCause_Item_iE_Extensions,
        MeasurementFailureCause_Item,
        MeasurementFailureCause_Item_ExtIEs,
        ____ResourceStatusFailure_protocolIEs__item__id_tab,
        _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_0,
        _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_1,
        _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_2,
        _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_3,
        _____ResourceStatusFailure_protocolIEs__item__id_tab_val_Value_4,
        ___ResourceStatusFailure_protocolIEs__item__id,
        ___ResourceStatusFailure_protocolIEs__item__criticality,
        ___ResourceStatusFailure_protocolIEs__item__value,
        __ResourceStatusFailure_protocolIEs__item_,
        _ResourceStatusFailure_protocolIEs,
        ResourceStatusFailure,
        ResourceStatusFailure_IEs,
        _ResourceStatusFailure_IEs_val_Value_0,
        _ResourceStatusFailure_IEs_val_Value_1,
        _ResourceStatusFailure_IEs_val_Value_2,
        _ResourceStatusFailure_IEs_val_Value_3,
        _ResourceStatusFailure_IEs_val_Value_4,
        ___CompleteFailureCauseInformation_List__item__id_tab,
        ____CompleteFailureCauseInformation_List__item__id_tab_val_Value_0,
        __CompleteFailureCauseInformation_List__item__id,
        __CompleteFailureCauseInformation_List__item__criticality,
        __CompleteFailureCauseInformation_List__item__value,
        _CompleteFailureCauseInformation_List__item_,
        CompleteFailureCauseInformation_List,
        CompleteFailureCauseInformation_ItemIEs,
        _CompleteFailureCauseInformation_ItemIEs_val_Value_0,
        _CompleteFailureCauseInformation_Item_cell_ID,
        _CompleteFailureCauseInformation_Item_measurementFailureCause_List,
        ____CompleteFailureCauseInformation_Item_iE_Extensions__item__id_tab,
        ___CompleteFailureCauseInformation_Item_iE_Extensions__item__id,
        ____CompleteFailureCauseInformation_Item_iE_Extensions__item__criticality_tab,
        ___CompleteFailureCauseInformation_Item_iE_Extensions__item__criticality,
        ____CompleteFailureCauseInformation_Item_iE_Extensions__item__extensionValue_tab,
        ___CompleteFailureCauseInformation_Item_iE_Extensions__item__extensionValue,
        __CompleteFailureCauseInformation_Item_iE_Extensions__item_,
        _CompleteFailureCauseInformation_Item_iE_Extensions,
        CompleteFailureCauseInformation_Item,
        CompleteFailureCauseInformation_Item_ExtIEs,
        ____ResourceStatusUpdate_protocolIEs__item__id_tab,
        _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_0,
        _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_1,
        _____ResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_2,
        ___ResourceStatusUpdate_protocolIEs__item__id,
        ___ResourceStatusUpdate_protocolIEs__item__criticality,
        ___ResourceStatusUpdate_protocolIEs__item__value,
        __ResourceStatusUpdate_protocolIEs__item_,
        _ResourceStatusUpdate_protocolIEs,
        ResourceStatusUpdate,
        ResourceStatusUpdate_IEs,
        _ResourceStatusUpdate_IEs_val_Value_0,
        _ResourceStatusUpdate_IEs_val_Value_1,
        _ResourceStatusUpdate_IEs_val_Value_2,
        ___CellMeasurementResult_List__item__id_tab,
        ____CellMeasurementResult_List__item__id_tab_val_Value_0,
        __CellMeasurementResult_List__item__id,
        __CellMeasurementResult_List__item__criticality,
        __CellMeasurementResult_List__item__value,
        _CellMeasurementResult_List__item_,
        CellMeasurementResult_List,
        CellMeasurementResult_ItemIEs,
        _CellMeasurementResult_ItemIEs_val_Value_0,
        _CellMeasurementResult_Item_cell_ID,
        _CellMeasurementResult_Item_hWLoadIndicator,
        _CellMeasurementResult_Item_s1TNLLoadIndicator,
        _CellMeasurementResult_Item_radioResourceStatus,
        ____CellMeasurementResult_Item_iE_Extensions__item__id_tab,
        _____CellMeasurementResult_Item_iE_Extensions__item__id_tab_val_Extension_0,
        _____CellMeasurementResult_Item_iE_Extensions__item__id_tab_val_Extension_1,
        _____CellMeasurementResult_Item_iE_Extensions__item__id_tab_val_Extension_2,
        _____CellMeasurementResult_Item_iE_Extensions__item__id_tab_val_Extension_3,
        _____CellMeasurementResult_Item_iE_Extensions__item__id_tab_val_Extension_4,
        _____CellMeasurementResult_Item_iE_Extensions__item__id_tab_val_Extension_5,
        ___CellMeasurementResult_Item_iE_Extensions__item__id,
        ___CellMeasurementResult_Item_iE_Extensions__item__criticality,
        ___CellMeasurementResult_Item_iE_Extensions__item__extensionValue,
        __CellMeasurementResult_Item_iE_Extensions__item_,
        _CellMeasurementResult_Item_iE_Extensions,
        CellMeasurementResult_Item,
        CellMeasurementResult_Item_ExtIEs,
        _CellMeasurementResult_Item_ExtIEs_val_Extension_0,
        _CellMeasurementResult_Item_ExtIEs_val_Extension_1,
        _CellMeasurementResult_Item_ExtIEs_val_Extension_2,
        _CellMeasurementResult_Item_ExtIEs_val_Extension_3,
        _CellMeasurementResult_Item_ExtIEs_val_Extension_4,
        _CellMeasurementResult_Item_ExtIEs_val_Extension_5,
        ____PrivateMessage_privateIEs__item__id_tab,
        ___PrivateMessage_privateIEs__item__id,
        ____PrivateMessage_privateIEs__item__criticality_tab,
        ___PrivateMessage_privateIEs__item__criticality,
        ____PrivateMessage_privateIEs__item__value_tab,
        ___PrivateMessage_privateIEs__item__value,
        __PrivateMessage_privateIEs__item_,
        _PrivateMessage_privateIEs,
        PrivateMessage,
        PrivateMessage_IEs,
        ____MobilityChangeRequest_protocolIEs__item__id_tab,
        _____MobilityChangeRequest_protocolIEs__item__id_tab_val_Value_0,
        _____MobilityChangeRequest_protocolIEs__item__id_tab_val_Value_1,
        _____MobilityChangeRequest_protocolIEs__item__id_tab_val_Value_2,
        _____MobilityChangeRequest_protocolIEs__item__id_tab_val_Value_3,
        _____MobilityChangeRequest_protocolIEs__item__id_tab_val_Value_4,
        ___MobilityChangeRequest_protocolIEs__item__id,
        ___MobilityChangeRequest_protocolIEs__item__criticality,
        ___MobilityChangeRequest_protocolIEs__item__value,
        __MobilityChangeRequest_protocolIEs__item_,
        _MobilityChangeRequest_protocolIEs,
        MobilityChangeRequest,
        MobilityChangeRequest_IEs,
        _MobilityChangeRequest_IEs_val_Value_0,
        _MobilityChangeRequest_IEs_val_Value_1,
        _MobilityChangeRequest_IEs_val_Value_2,
        _MobilityChangeRequest_IEs_val_Value_3,
        _MobilityChangeRequest_IEs_val_Value_4,
        ____MobilityChangeAcknowledge_protocolIEs__item__id_tab,
        _____MobilityChangeAcknowledge_protocolIEs__item__id_tab_val_Value_0,
        _____MobilityChangeAcknowledge_protocolIEs__item__id_tab_val_Value_1,
        _____MobilityChangeAcknowledge_protocolIEs__item__id_tab_val_Value_2,
        ___MobilityChangeAcknowledge_protocolIEs__item__id,
        ___MobilityChangeAcknowledge_protocolIEs__item__criticality,
        ___MobilityChangeAcknowledge_protocolIEs__item__value,
        __MobilityChangeAcknowledge_protocolIEs__item_,
        _MobilityChangeAcknowledge_protocolIEs,
        MobilityChangeAcknowledge,
        MobilityChangeAcknowledge_IEs,
        _MobilityChangeAcknowledge_IEs_val_Value_0,
        _MobilityChangeAcknowledge_IEs_val_Value_1,
        _MobilityChangeAcknowledge_IEs_val_Value_2,
        ____MobilityChangeFailure_protocolIEs__item__id_tab,
        _____MobilityChangeFailure_protocolIEs__item__id_tab_val_Value_0,
        _____MobilityChangeFailure_protocolIEs__item__id_tab_val_Value_1,
        _____MobilityChangeFailure_protocolIEs__item__id_tab_val_Value_2,
        _____MobilityChangeFailure_protocolIEs__item__id_tab_val_Value_3,
        _____MobilityChangeFailure_protocolIEs__item__id_tab_val_Value_4,
        ___MobilityChangeFailure_protocolIEs__item__id,
        ___MobilityChangeFailure_protocolIEs__item__criticality,
        ___MobilityChangeFailure_protocolIEs__item__value,
        __MobilityChangeFailure_protocolIEs__item_,
        _MobilityChangeFailure_protocolIEs,
        MobilityChangeFailure,
        MobilityChangeFailure_IEs,
        _MobilityChangeFailure_IEs_val_Value_0,
        _MobilityChangeFailure_IEs_val_Value_1,
        _MobilityChangeFailure_IEs_val_Value_2,
        _MobilityChangeFailure_IEs_val_Value_3,
        _MobilityChangeFailure_IEs_val_Value_4,
        ____RLFIndication_protocolIEs__item__id_tab,
        _____RLFIndication_protocolIEs__item__id_tab_val_Value_0,
        _____RLFIndication_protocolIEs__item__id_tab_val_Value_1,
        _____RLFIndication_protocolIEs__item__id_tab_val_Value_2,
        _____RLFIndication_protocolIEs__item__id_tab_val_Value_3,
        _____RLFIndication_protocolIEs__item__id_tab_val_Value_4,
        _____RLFIndication_protocolIEs__item__id_tab_val_Value_5,
        _____RLFIndication_protocolIEs__item__id_tab_val_Value_6,
        _____RLFIndication_protocolIEs__item__id_tab_val_Value_7,
        _____RLFIndication_protocolIEs__item__id_tab_val_Value_8,
        ___RLFIndication_protocolIEs__item__id,
        ___RLFIndication_protocolIEs__item__criticality,
        ___RLFIndication_protocolIEs__item__value,
        __RLFIndication_protocolIEs__item_,
        _RLFIndication_protocolIEs,
        RLFIndication,
        RLFIndication_IEs,
        _RLFIndication_IEs_val_Value_0,
        _RLFIndication_IEs_val_Value_1,
        _RLFIndication_IEs_val_Value_2,
        _RLFIndication_IEs_val_Value_3,
        _RLFIndication_IEs_val_Value_4,
        _RLFIndication_IEs_val_Value_5,
        _RLFIndication_IEs_val_Value_6,
        _RLFIndication_IEs_val_Value_7,
        _RLFIndication_IEs_val_Value_8,
        ____CellActivationRequest_protocolIEs__item__id_tab,
        _____CellActivationRequest_protocolIEs__item__id_tab_val_Value_0,
        ___CellActivationRequest_protocolIEs__item__id,
        ___CellActivationRequest_protocolIEs__item__criticality,
        ___CellActivationRequest_protocolIEs__item__value,
        __CellActivationRequest_protocolIEs__item_,
        _CellActivationRequest_protocolIEs,
        CellActivationRequest,
        CellActivationRequest_IEs,
        _CellActivationRequest_IEs_val_Value_0,
        _ServedCellsToActivate__item_,
        ServedCellsToActivate,
        _ServedCellsToActivate_Item_ecgi,
        ____ServedCellsToActivate_Item_iE_Extensions__item__id_tab,
        ___ServedCellsToActivate_Item_iE_Extensions__item__id,
        ____ServedCellsToActivate_Item_iE_Extensions__item__criticality_tab,
        ___ServedCellsToActivate_Item_iE_Extensions__item__criticality,
        ____ServedCellsToActivate_Item_iE_Extensions__item__extensionValue_tab,
        ___ServedCellsToActivate_Item_iE_Extensions__item__extensionValue,
        __ServedCellsToActivate_Item_iE_Extensions__item_,
        _ServedCellsToActivate_Item_iE_Extensions,
        ServedCellsToActivate_Item,
        ServedCellsToActivate_Item_ExtIEs,
        ____CellActivationResponse_protocolIEs__item__id_tab,
        _____CellActivationResponse_protocolIEs__item__id_tab_val_Value_0,
        _____CellActivationResponse_protocolIEs__item__id_tab_val_Value_1,
        ___CellActivationResponse_protocolIEs__item__id,
        ___CellActivationResponse_protocolIEs__item__criticality,
        ___CellActivationResponse_protocolIEs__item__value,
        __CellActivationResponse_protocolIEs__item_,
        _CellActivationResponse_protocolIEs,
        CellActivationResponse,
        CellActivationResponse_IEs,
        _CellActivationResponse_IEs_val_Value_0,
        _CellActivationResponse_IEs_val_Value_1,
        _ActivatedCellList__item_,
        ActivatedCellList,
        _ActivatedCellList_Item_ecgi,
        ____ActivatedCellList_Item_iE_Extensions__item__id_tab,
        ___ActivatedCellList_Item_iE_Extensions__item__id,
        ____ActivatedCellList_Item_iE_Extensions__item__criticality_tab,
        ___ActivatedCellList_Item_iE_Extensions__item__criticality,
        ____ActivatedCellList_Item_iE_Extensions__item__extensionValue_tab,
        ___ActivatedCellList_Item_iE_Extensions__item__extensionValue,
        __ActivatedCellList_Item_iE_Extensions__item_,
        _ActivatedCellList_Item_iE_Extensions,
        ActivatedCellList_Item,
        ActivatedCellList_Item_ExtIEs,
        ____CellActivationFailure_protocolIEs__item__id_tab,
        _____CellActivationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____CellActivationFailure_protocolIEs__item__id_tab_val_Value_1,
        ___CellActivationFailure_protocolIEs__item__id,
        ___CellActivationFailure_protocolIEs__item__criticality,
        ___CellActivationFailure_protocolIEs__item__value,
        __CellActivationFailure_protocolIEs__item_,
        _CellActivationFailure_protocolIEs,
        CellActivationFailure,
        CellActivationFailure_IEs,
        _CellActivationFailure_IEs_val_Value_0,
        _CellActivationFailure_IEs_val_Value_1,
        ____X2Release_protocolIEs__item__id_tab,
        _____X2Release_protocolIEs__item__id_tab_val_Value_0,
        ___X2Release_protocolIEs__item__id,
        ___X2Release_protocolIEs__item__criticality,
        ___X2Release_protocolIEs__item__value,
        __X2Release_protocolIEs__item_,
        _X2Release_protocolIEs,
        X2Release,
        X2Release_IEs,
        _X2Release_IEs_val_Value_0,
        ____X2APMessageTransfer_protocolIEs__item__id_tab,
        _____X2APMessageTransfer_protocolIEs__item__id_tab_val_Value_0,
        _____X2APMessageTransfer_protocolIEs__item__id_tab_val_Value_1,
        ___X2APMessageTransfer_protocolIEs__item__id,
        ___X2APMessageTransfer_protocolIEs__item__criticality,
        ___X2APMessageTransfer_protocolIEs__item__value,
        __X2APMessageTransfer_protocolIEs__item_,
        _X2APMessageTransfer_protocolIEs,
        X2APMessageTransfer,
        X2APMessageTransfer_IEs,
        _X2APMessageTransfer_IEs_val_Value_0,
        _X2APMessageTransfer_IEs_val_Value_1,
        _RNL_Header_source_GlobalENB_ID,
        _RNL_Header_target_GlobalENB_ID,
        ____RNL_Header_iE_Extensions__item__id_tab,
        ___RNL_Header_iE_Extensions__item__id,
        ____RNL_Header_iE_Extensions__item__criticality_tab,
        ___RNL_Header_iE_Extensions__item__criticality,
        ____RNL_Header_iE_Extensions__item__extensionValue_tab,
        ___RNL_Header_iE_Extensions__item__extensionValue,
        __RNL_Header_iE_Extensions__item_,
        _RNL_Header_iE_Extensions,
        RNL_Header,
        RNL_Header_Item_ExtIEs,
        X2AP_Message,
        ____SeNBAdditionRequest_protocolIEs__item__id_tab,
        _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_0,
        _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_1,
        _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_2,
        _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_3,
        _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_4,
        _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_5,
        _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_6,
        _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_7,
        _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_8,
        _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_9,
        _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_10,
        _____SeNBAdditionRequest_protocolIEs__item__id_tab_val_Value_11,
        ___SeNBAdditionRequest_protocolIEs__item__id,
        ___SeNBAdditionRequest_protocolIEs__item__criticality,
        ___SeNBAdditionRequest_protocolIEs__item__value,
        __SeNBAdditionRequest_protocolIEs__item_,
        _SeNBAdditionRequest_protocolIEs,
        SeNBAdditionRequest,
        SeNBAdditionRequest_IEs,
        _SeNBAdditionRequest_IEs_val_Value_0,
        _SeNBAdditionRequest_IEs_val_Value_1,
        _SeNBAdditionRequest_IEs_val_Value_2,
        _SeNBAdditionRequest_IEs_val_Value_3,
        _SeNBAdditionRequest_IEs_val_Value_4,
        _SeNBAdditionRequest_IEs_val_Value_5,
        _SeNBAdditionRequest_IEs_val_Value_6,
        _SeNBAdditionRequest_IEs_val_Value_7,
        _SeNBAdditionRequest_IEs_val_Value_8,
        _SeNBAdditionRequest_IEs_val_Value_9,
        _SeNBAdditionRequest_IEs_val_Value_10,
        _SeNBAdditionRequest_IEs_val_Value_11,
        ___E_RABs_ToBeAdded_List__item__id_tab,
        ____E_RABs_ToBeAdded_List__item__id_tab_val_Value_0,
        __E_RABs_ToBeAdded_List__item__id,
        __E_RABs_ToBeAdded_List__item__criticality,
        __E_RABs_ToBeAdded_List__item__value,
        _E_RABs_ToBeAdded_List__item_,
        E_RABs_ToBeAdded_List,
        E_RABs_ToBeAdded_ItemIEs,
        _E_RABs_ToBeAdded_ItemIEs_val_Value_0,
        _E_RABs_ToBeAdded_Item_sCG_Bearer,
        _E_RABs_ToBeAdded_Item_split_Bearer,
        E_RABs_ToBeAdded_Item,
        _E_RABs_ToBeAdded_Item_SCG_Bearer_e_RAB_ID,
        _E_RABs_ToBeAdded_Item_SCG_Bearer_e_RAB_Level_QoS_Parameters,
        _E_RABs_ToBeAdded_Item_SCG_Bearer_dL_Forwarding,
        _E_RABs_ToBeAdded_Item_SCG_Bearer_s1_UL_GTPtunnelEndpoint,
        ____E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id_tab,
        _____E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id_tab_val_Extension_0,
        _____E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id_tab_val_Extension_1,
        _____E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id_tab_val_Extension_2,
        _____E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id_tab_val_Extension_3,
        _____E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id_tab_val_Extension_4,
        ___E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id,
        ___E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__criticality,
        ___E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__extensionValue,
        __E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item_,
        _E_RABs_ToBeAdded_Item_SCG_Bearer_iE_Extensions,
        E_RABs_ToBeAdded_Item_SCG_Bearer,
        E_RABs_ToBeAdded_Item_SCG_BearerExtIEs,
        _E_RABs_ToBeAdded_Item_SCG_BearerExtIEs_val_Extension_0,
        _E_RABs_ToBeAdded_Item_SCG_BearerExtIEs_val_Extension_1,
        _E_RABs_ToBeAdded_Item_SCG_BearerExtIEs_val_Extension_2,
        _E_RABs_ToBeAdded_Item_SCG_BearerExtIEs_val_Extension_3,
        _E_RABs_ToBeAdded_Item_SCG_BearerExtIEs_val_Extension_4,
        _E_RABs_ToBeAdded_Item_Split_Bearer_e_RAB_ID,
        _E_RABs_ToBeAdded_Item_Split_Bearer_e_RAB_Level_QoS_Parameters,
        _E_RABs_ToBeAdded_Item_Split_Bearer_meNB_GTPtunnelEndpoint,
        ____E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__id_tab,
        _____E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__id_tab_val_Extension_0,
        ___E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__id,
        ___E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__criticality,
        ___E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__extensionValue,
        __E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions__item_,
        _E_RABs_ToBeAdded_Item_Split_Bearer_iE_Extensions,
        E_RABs_ToBeAdded_Item_Split_Bearer,
        E_RABs_ToBeAdded_Item_Split_BearerExtIEs,
        _E_RABs_ToBeAdded_Item_Split_BearerExtIEs_val_Extension_0,
        ____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab,
        _____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_0,
        _____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_1,
        _____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_2,
        _____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_3,
        _____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_4,
        _____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_5,
        _____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_6,
        _____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_7,
        _____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_8,
        _____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_9,
        _____SeNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_10,
        ___SeNBAdditionRequestAcknowledge_protocolIEs__item__id,
        ___SeNBAdditionRequestAcknowledge_protocolIEs__item__criticality,
        ___SeNBAdditionRequestAcknowledge_protocolIEs__item__value,
        __SeNBAdditionRequestAcknowledge_protocolIEs__item_,
        _SeNBAdditionRequestAcknowledge_protocolIEs,
        SeNBAdditionRequestAcknowledge,
        SeNBAdditionRequestAcknowledge_IEs,
        _SeNBAdditionRequestAcknowledge_IEs_val_Value_0,
        _SeNBAdditionRequestAcknowledge_IEs_val_Value_1,
        _SeNBAdditionRequestAcknowledge_IEs_val_Value_2,
        _SeNBAdditionRequestAcknowledge_IEs_val_Value_3,
        _SeNBAdditionRequestAcknowledge_IEs_val_Value_4,
        _SeNBAdditionRequestAcknowledge_IEs_val_Value_5,
        _SeNBAdditionRequestAcknowledge_IEs_val_Value_6,
        _SeNBAdditionRequestAcknowledge_IEs_val_Value_7,
        _SeNBAdditionRequestAcknowledge_IEs_val_Value_8,
        _SeNBAdditionRequestAcknowledge_IEs_val_Value_9,
        _SeNBAdditionRequestAcknowledge_IEs_val_Value_10,
        ___E_RABs_Admitted_ToBeAdded_List__item__id_tab,
        ____E_RABs_Admitted_ToBeAdded_List__item__id_tab_val_Value_0,
        __E_RABs_Admitted_ToBeAdded_List__item__id,
        __E_RABs_Admitted_ToBeAdded_List__item__criticality,
        __E_RABs_Admitted_ToBeAdded_List__item__value,
        _E_RABs_Admitted_ToBeAdded_List__item_,
        E_RABs_Admitted_ToBeAdded_List,
        E_RABs_Admitted_ToBeAdded_ItemIEs,
        _E_RABs_Admitted_ToBeAdded_ItemIEs_val_Value_0,
        _E_RABs_Admitted_ToBeAdded_Item_sCG_Bearer,
        _E_RABs_Admitted_ToBeAdded_Item_split_Bearer,
        E_RABs_Admitted_ToBeAdded_Item,
        _E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_e_RAB_ID,
        _E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_s1_DL_GTPtunnelEndpoint,
        _E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_dL_Forwarding_GTPtunnelEndpoint,
        _E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_uL_Forwarding_GTPtunnelEndpoint,
        ____E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id_tab,
        _____E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id_tab_val_Extension_0,
        ___E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__id,
        ___E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__criticality,
        ___E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item__extensionValue,
        __E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions__item_,
        _E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer_iE_Extensions,
        E_RABs_Admitted_ToBeAdded_Item_SCG_Bearer,
        E_RABs_Admitted_ToBeAdded_Item_SCG_BearerExtIEs,
        _E_RABs_Admitted_ToBeAdded_Item_SCG_BearerExtIEs_val_Extension_0,
        _E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_e_RAB_ID,
        _E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_seNB_GTPtunnelEndpoint,
        ____E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__id_tab,
        _____E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__id_tab_val_Extension_0,
        ___E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__id,
        ___E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__criticality,
        ___E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions__item__extensionValue,
        __E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions__item_,
        _E_RABs_Admitted_ToBeAdded_Item_Split_Bearer_iE_Extensions,
        E_RABs_Admitted_ToBeAdded_Item_Split_Bearer,
        E_RABs_Admitted_ToBeAdded_Item_Split_BearerExtIEs,
        _E_RABs_Admitted_ToBeAdded_Item_Split_BearerExtIEs_val_Extension_0,
        ____SeNBAdditionRequestReject_protocolIEs__item__id_tab,
        _____SeNBAdditionRequestReject_protocolIEs__item__id_tab_val_Value_0,
        _____SeNBAdditionRequestReject_protocolIEs__item__id_tab_val_Value_1,
        _____SeNBAdditionRequestReject_protocolIEs__item__id_tab_val_Value_2,
        _____SeNBAdditionRequestReject_protocolIEs__item__id_tab_val_Value_3,
        _____SeNBAdditionRequestReject_protocolIEs__item__id_tab_val_Value_4,
        _____SeNBAdditionRequestReject_protocolIEs__item__id_tab_val_Value_5,
        ___SeNBAdditionRequestReject_protocolIEs__item__id,
        ___SeNBAdditionRequestReject_protocolIEs__item__criticality,
        ___SeNBAdditionRequestReject_protocolIEs__item__value,
        __SeNBAdditionRequestReject_protocolIEs__item_,
        _SeNBAdditionRequestReject_protocolIEs,
        SeNBAdditionRequestReject,
        SeNBAdditionRequestReject_IEs,
        _SeNBAdditionRequestReject_IEs_val_Value_0,
        _SeNBAdditionRequestReject_IEs_val_Value_1,
        _SeNBAdditionRequestReject_IEs_val_Value_2,
        _SeNBAdditionRequestReject_IEs_val_Value_3,
        _SeNBAdditionRequestReject_IEs_val_Value_4,
        _SeNBAdditionRequestReject_IEs_val_Value_5,
        ____SeNBReconfigurationComplete_protocolIEs__item__id_tab,
        _____SeNBReconfigurationComplete_protocolIEs__item__id_tab_val_Value_0,
        _____SeNBReconfigurationComplete_protocolIEs__item__id_tab_val_Value_1,
        _____SeNBReconfigurationComplete_protocolIEs__item__id_tab_val_Value_2,
        _____SeNBReconfigurationComplete_protocolIEs__item__id_tab_val_Value_3,
        _____SeNBReconfigurationComplete_protocolIEs__item__id_tab_val_Value_4,
        ___SeNBReconfigurationComplete_protocolIEs__item__id,
        ___SeNBReconfigurationComplete_protocolIEs__item__criticality,
        ___SeNBReconfigurationComplete_protocolIEs__item__value,
        __SeNBReconfigurationComplete_protocolIEs__item_,
        _SeNBReconfigurationComplete_protocolIEs,
        SeNBReconfigurationComplete,
        SeNBReconfigurationComplete_IEs,
        _SeNBReconfigurationComplete_IEs_val_Value_0,
        _SeNBReconfigurationComplete_IEs_val_Value_1,
        _SeNBReconfigurationComplete_IEs_val_Value_2,
        _SeNBReconfigurationComplete_IEs_val_Value_3,
        _SeNBReconfigurationComplete_IEs_val_Value_4,
        _ResponseInformationSeNBReconfComp_success,
        _ResponseInformationSeNBReconfComp_reject_by_MeNB,
        ResponseInformationSeNBReconfComp,
        _ResponseInformationSeNBReconfComp_SuccessItem_meNBtoSeNBContainer,
        ____ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions__item__id_tab,
        ___ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions__item__id,
        ____ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions__item__criticality_tab,
        ___ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions__item__criticality,
        ____ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions__item__extensionValue_tab,
        ___ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions__item__extensionValue,
        __ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions__item_,
        _ResponseInformationSeNBReconfComp_SuccessItem_iE_Extensions,
        ResponseInformationSeNBReconfComp_SuccessItem,
        ResponseInformationSeNBReconfComp_SuccessItemExtIEs,
        _ResponseInformationSeNBReconfComp_RejectByMeNBItem_cause,
        _ResponseInformationSeNBReconfComp_RejectByMeNBItem_meNBtoSeNBContainer,
        ____ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions__item__id_tab,
        ___ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions__item__id,
        ____ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions__item__criticality_tab,
        ___ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions__item__criticality,
        ____ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions__item__extensionValue_tab,
        ___ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions__item__extensionValue,
        __ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions__item_,
        _ResponseInformationSeNBReconfComp_RejectByMeNBItem_iE_Extensions,
        ResponseInformationSeNBReconfComp_RejectByMeNBItem,
        ResponseInformationSeNBReconfComp_RejectByMeNBItemExtIEs,
        ____SeNBModificationRequest_protocolIEs__item__id_tab,
        _____SeNBModificationRequest_protocolIEs__item__id_tab_val_Value_0,
        _____SeNBModificationRequest_protocolIEs__item__id_tab_val_Value_1,
        _____SeNBModificationRequest_protocolIEs__item__id_tab_val_Value_2,
        _____SeNBModificationRequest_protocolIEs__item__id_tab_val_Value_3,
        _____SeNBModificationRequest_protocolIEs__item__id_tab_val_Value_4,
        _____SeNBModificationRequest_protocolIEs__item__id_tab_val_Value_5,
        _____SeNBModificationRequest_protocolIEs__item__id_tab_val_Value_6,
        _____SeNBModificationRequest_protocolIEs__item__id_tab_val_Value_7,
        _____SeNBModificationRequest_protocolIEs__item__id_tab_val_Value_8,
        _____SeNBModificationRequest_protocolIEs__item__id_tab_val_Value_9,
        ___SeNBModificationRequest_protocolIEs__item__id,
        ___SeNBModificationRequest_protocolIEs__item__criticality,
        ___SeNBModificationRequest_protocolIEs__item__value,
        __SeNBModificationRequest_protocolIEs__item_,
        _SeNBModificationRequest_protocolIEs,
        SeNBModificationRequest,
        SeNBModificationRequest_IEs,
        _SeNBModificationRequest_IEs_val_Value_0,
        _SeNBModificationRequest_IEs_val_Value_1,
        _SeNBModificationRequest_IEs_val_Value_2,
        _SeNBModificationRequest_IEs_val_Value_3,
        _SeNBModificationRequest_IEs_val_Value_4,
        _SeNBModificationRequest_IEs_val_Value_5,
        _SeNBModificationRequest_IEs_val_Value_6,
        _SeNBModificationRequest_IEs_val_Value_7,
        _SeNBModificationRequest_IEs_val_Value_8,
        _SeNBModificationRequest_IEs_val_Value_9,
        _UE_ContextInformationSeNBModReq_uE_SecurityCapabilities,
        _UE_ContextInformationSeNBModReq_seNB_SecurityKey,
        _UE_ContextInformationSeNBModReq_seNBUEAggregateMaximumBitRate,
        _UE_ContextInformationSeNBModReq_e_RABs_ToBeAdded,
        _UE_ContextInformationSeNBModReq_e_RABs_ToBeModified,
        _UE_ContextInformationSeNBModReq_e_RABs_ToBeReleased,
        ____UE_ContextInformationSeNBModReq_iE_Extensions__item__id_tab,
        ___UE_ContextInformationSeNBModReq_iE_Extensions__item__id,
        ____UE_ContextInformationSeNBModReq_iE_Extensions__item__criticality_tab,
        ___UE_ContextInformationSeNBModReq_iE_Extensions__item__criticality,
        ____UE_ContextInformationSeNBModReq_iE_Extensions__item__extensionValue_tab,
        ___UE_ContextInformationSeNBModReq_iE_Extensions__item__extensionValue,
        __UE_ContextInformationSeNBModReq_iE_Extensions__item_,
        _UE_ContextInformationSeNBModReq_iE_Extensions,
        UE_ContextInformationSeNBModReq,
        UE_ContextInformationSeNBModReqExtIEs,
        ___E_RABs_ToBeAdded_List_ModReq__item__id_tab,
        ____E_RABs_ToBeAdded_List_ModReq__item__id_tab_val_Value_0,
        __E_RABs_ToBeAdded_List_ModReq__item__id,
        __E_RABs_ToBeAdded_List_ModReq__item__criticality,
        __E_RABs_ToBeAdded_List_ModReq__item__value,
        _E_RABs_ToBeAdded_List_ModReq__item_,
        E_RABs_ToBeAdded_List_ModReq,
        E_RABs_ToBeAdded_ModReqItemIEs,
        _E_RABs_ToBeAdded_ModReqItemIEs_val_Value_0,
        _E_RABs_ToBeAdded_ModReqItem_sCG_Bearer,
        _E_RABs_ToBeAdded_ModReqItem_split_Bearer,
        E_RABs_ToBeAdded_ModReqItem,
        _E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_e_RAB_ID,
        _E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_e_RAB_Level_QoS_Parameters,
        _E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_dL_Forwarding,
        _E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_s1_UL_GTPtunnelEndpoint,
        ____E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item__id_tab,
        _____E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item__id_tab_val_Extension_0,
        _____E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item__id_tab_val_Extension_1,
        _____E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item__id_tab_val_Extension_2,
        _____E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item__id_tab_val_Extension_3,
        _____E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item__id_tab_val_Extension_4,
        ___E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item__id,
        ___E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item__criticality,
        ___E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item__extensionValue,
        __E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions__item_,
        _E_RABs_ToBeAdded_ModReqItem_SCG_Bearer_iE_Extensions,
        E_RABs_ToBeAdded_ModReqItem_SCG_Bearer,
        E_RABs_ToBeAdded_ModReqItem_SCG_BearerExtIEs,
        _E_RABs_ToBeAdded_ModReqItem_SCG_BearerExtIEs_val_Extension_0,
        _E_RABs_ToBeAdded_ModReqItem_SCG_BearerExtIEs_val_Extension_1,
        _E_RABs_ToBeAdded_ModReqItem_SCG_BearerExtIEs_val_Extension_2,
        _E_RABs_ToBeAdded_ModReqItem_SCG_BearerExtIEs_val_Extension_3,
        _E_RABs_ToBeAdded_ModReqItem_SCG_BearerExtIEs_val_Extension_4,
        _E_RABs_ToBeAdded_ModReqItem_Split_Bearer_e_RAB_ID,
        _E_RABs_ToBeAdded_ModReqItem_Split_Bearer_e_RAB_Level_QoS_Parameters,
        _E_RABs_ToBeAdded_ModReqItem_Split_Bearer_meNB_GTPtunnelEndpoint,
        ____E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions__item__id_tab,
        _____E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions__item__id_tab_val_Extension_0,
        ___E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions__item__id,
        ___E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions__item__criticality,
        ___E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions__item__extensionValue,
        __E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions__item_,
        _E_RABs_ToBeAdded_ModReqItem_Split_Bearer_iE_Extensions,
        E_RABs_ToBeAdded_ModReqItem_Split_Bearer,
        E_RABs_ToBeAdded_ModReqItem_Split_BearerExtIEs,
        _E_RABs_ToBeAdded_ModReqItem_Split_BearerExtIEs_val_Extension_0,
        ___E_RABs_ToBeModified_List_ModReq__item__id_tab,
        ____E_RABs_ToBeModified_List_ModReq__item__id_tab_val_Value_0,
        __E_RABs_ToBeModified_List_ModReq__item__id,
        __E_RABs_ToBeModified_List_ModReq__item__criticality,
        __E_RABs_ToBeModified_List_ModReq__item__value,
        _E_RABs_ToBeModified_List_ModReq__item_,
        E_RABs_ToBeModified_List_ModReq,
        E_RABs_ToBeModified_ModReqItemIEs,
        _E_RABs_ToBeModified_ModReqItemIEs_val_Value_0,
        _E_RABs_ToBeModified_ModReqItem_sCG_Bearer,
        _E_RABs_ToBeModified_ModReqItem_split_Bearer,
        E_RABs_ToBeModified_ModReqItem,
        _E_RABs_ToBeModified_ModReqItem_SCG_Bearer_e_RAB_ID,
        _E_RABs_ToBeModified_ModReqItem_SCG_Bearer_e_RAB_Level_QoS_Parameters,
        _E_RABs_ToBeModified_ModReqItem_SCG_Bearer_s1_UL_GTPtunnelEndpoint,
        ____E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions__item__id_tab,
        ___E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions__item__id,
        ____E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions__item__criticality_tab,
        ___E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions__item__criticality,
        ____E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions__item__extensionValue_tab,
        ___E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions__item__extensionValue,
        __E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions__item_,
        _E_RABs_ToBeModified_ModReqItem_SCG_Bearer_iE_Extensions,
        E_RABs_ToBeModified_ModReqItem_SCG_Bearer,
        E_RABs_ToBeModified_ModReqItem_SCG_BearerExtIEs,
        _E_RABs_ToBeModified_ModReqItem_Split_Bearer_e_RAB_ID,
        _E_RABs_ToBeModified_ModReqItem_Split_Bearer_e_RAB_Level_QoS_Parameters,
        _E_RABs_ToBeModified_ModReqItem_Split_Bearer_meNB_GTPtunnelEndpoint,
        ____E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions__item__id_tab,
        ___E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions__item__id,
        ____E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions__item__criticality_tab,
        ___E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions__item__criticality,
        ____E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions__item__extensionValue_tab,
        ___E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions__item__extensionValue,
        __E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions__item_,
        _E_RABs_ToBeModified_ModReqItem_Split_Bearer_iE_Extensions,
        E_RABs_ToBeModified_ModReqItem_Split_Bearer,
        E_RABs_ToBeModified_ModReqItem_Split_BearerExtIEs,
        ___E_RABs_ToBeReleased_List_ModReq__item__id_tab,
        ____E_RABs_ToBeReleased_List_ModReq__item__id_tab_val_Value_0,
        __E_RABs_ToBeReleased_List_ModReq__item__id,
        __E_RABs_ToBeReleased_List_ModReq__item__criticality,
        __E_RABs_ToBeReleased_List_ModReq__item__value,
        _E_RABs_ToBeReleased_List_ModReq__item_,
        E_RABs_ToBeReleased_List_ModReq,
        E_RABs_ToBeReleased_ModReqItemIEs,
        _E_RABs_ToBeReleased_ModReqItemIEs_val_Value_0,
        _E_RABs_ToBeReleased_ModReqItem_sCG_Bearer,
        _E_RABs_ToBeReleased_ModReqItem_split_Bearer,
        E_RABs_ToBeReleased_ModReqItem,
        _E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_e_RAB_ID,
        _E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_dL_Forwarding_GTPtunnelEndpoint,
        _E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_uL_Forwarding_GTPtunnelEndpoint,
        ____E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions__item__id_tab,
        ___E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions__item__id,
        ____E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions__item__criticality_tab,
        ___E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions__item__criticality,
        ____E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions__item__extensionValue_tab,
        ___E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions__item__extensionValue,
        __E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions__item_,
        _E_RABs_ToBeReleased_ModReqItem_SCG_Bearer_iE_Extensions,
        E_RABs_ToBeReleased_ModReqItem_SCG_Bearer,
        E_RABs_ToBeReleased_ModReqItem_SCG_BearerExtIEs,
        _E_RABs_ToBeReleased_ModReqItem_Split_Bearer_e_RAB_ID,
        _E_RABs_ToBeReleased_ModReqItem_Split_Bearer_dL_Forwarding_GTPtunnelEndpoint,
        ____E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions__item__id_tab,
        ___E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions__item__id,
        ____E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions__item__criticality_tab,
        ___E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions__item__criticality,
        ____E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions__item__extensionValue_tab,
        ___E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions__item__extensionValue,
        __E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions__item_,
        _E_RABs_ToBeReleased_ModReqItem_Split_Bearer_iE_Extensions,
        E_RABs_ToBeReleased_ModReqItem_Split_Bearer,
        E_RABs_ToBeReleased_ModReqItem_Split_BearerExtIEs,
        ____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab,
        _____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_0,
        _____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_1,
        _____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_2,
        _____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_3,
        _____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_4,
        _____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_5,
        _____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_6,
        _____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_7,
        _____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_8,
        _____SeNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_9,
        ___SeNBModificationRequestAcknowledge_protocolIEs__item__id,
        ___SeNBModificationRequestAcknowledge_protocolIEs__item__criticality,
        ___SeNBModificationRequestAcknowledge_protocolIEs__item__value,
        __SeNBModificationRequestAcknowledge_protocolIEs__item_,
        _SeNBModificationRequestAcknowledge_protocolIEs,
        SeNBModificationRequestAcknowledge,
        SeNBModificationRequestAcknowledge_IEs,
        _SeNBModificationRequestAcknowledge_IEs_val_Value_0,
        _SeNBModificationRequestAcknowledge_IEs_val_Value_1,
        _SeNBModificationRequestAcknowledge_IEs_val_Value_2,
        _SeNBModificationRequestAcknowledge_IEs_val_Value_3,
        _SeNBModificationRequestAcknowledge_IEs_val_Value_4,
        _SeNBModificationRequestAcknowledge_IEs_val_Value_5,
        _SeNBModificationRequestAcknowledge_IEs_val_Value_6,
        _SeNBModificationRequestAcknowledge_IEs_val_Value_7,
        _SeNBModificationRequestAcknowledge_IEs_val_Value_8,
        _SeNBModificationRequestAcknowledge_IEs_val_Value_9,
        ___E_RABs_Admitted_ToBeAdded_ModAckList__item__id_tab,
        ____E_RABs_Admitted_ToBeAdded_ModAckList__item__id_tab_val_Value_0,
        __E_RABs_Admitted_ToBeAdded_ModAckList__item__id,
        __E_RABs_Admitted_ToBeAdded_ModAckList__item__criticality,
        __E_RABs_Admitted_ToBeAdded_ModAckList__item__value,
        _E_RABs_Admitted_ToBeAdded_ModAckList__item_,
        E_RABs_Admitted_ToBeAdded_ModAckList,
        E_RABs_Admitted_ToBeAdded_ModAckItemIEs,
        _E_RABs_Admitted_ToBeAdded_ModAckItemIEs_val_Value_0,
        _E_RABs_Admitted_ToBeAdded_ModAckItem_sCG_Bearer,
        _E_RABs_Admitted_ToBeAdded_ModAckItem_split_Bearer,
        E_RABs_Admitted_ToBeAdded_ModAckItem,
        _E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_e_RAB_ID,
        _E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_s1_DL_GTPtunnelEndpoint,
        _E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_dL_Forwarding_GTPtunnelEndpoint,
        _E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_uL_Forwarding_GTPtunnelEndpoint,
        ____E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions__item__id_tab,
        _____E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions__item__id_tab_val_Extension_0,
        ___E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions__item__id,
        ___E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions__item__criticality,
        ___E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions__item__extensionValue,
        __E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions__item_,
        _E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer_iE_Extensions,
        E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_Bearer,
        E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_BearerExtIEs,
        _E_RABs_Admitted_ToBeAdded_ModAckItem_SCG_BearerExtIEs_val_Extension_0,
        _E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_e_RAB_ID,
        _E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_seNB_GTPtunnelEndpoint,
        ____E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions__item__id_tab,
        _____E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions__item__id_tab_val_Extension_0,
        ___E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions__item__id,
        ___E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions__item__criticality,
        ___E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions__item__extensionValue,
        __E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions__item_,
        _E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer_iE_Extensions,
        E_RABs_Admitted_ToBeAdded_ModAckItem_Split_Bearer,
        E_RABs_Admitted_ToBeAdded_ModAckItem_Split_BearerExtIEs,
        _E_RABs_Admitted_ToBeAdded_ModAckItem_Split_BearerExtIEs_val_Extension_0,
        ___E_RABs_Admitted_ToBeModified_ModAckList__item__id_tab,
        ____E_RABs_Admitted_ToBeModified_ModAckList__item__id_tab_val_Value_0,
        __E_RABs_Admitted_ToBeModified_ModAckList__item__id,
        __E_RABs_Admitted_ToBeModified_ModAckList__item__criticality,
        __E_RABs_Admitted_ToBeModified_ModAckList__item__value,
        _E_RABs_Admitted_ToBeModified_ModAckList__item_,
        E_RABs_Admitted_ToBeModified_ModAckList,
        E_RABs_Admitted_ToBeModified_ModAckItemIEs,
        _E_RABs_Admitted_ToBeModified_ModAckItemIEs_val_Value_0,
        _E_RABs_Admitted_ToBeModified_ModAckItem_sCG_Bearer,
        _E_RABs_Admitted_ToBeModified_ModAckItem_split_Bearer,
        E_RABs_Admitted_ToBeModified_ModAckItem,
        _E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_e_RAB_ID,
        _E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_s1_DL_GTPtunnelEndpoint,
        ____E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions__item__id_tab,
        ___E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions__item__id,
        ____E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions__item__criticality_tab,
        ___E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions__item__criticality,
        ____E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions__item__extensionValue_tab,
        ___E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions__item__extensionValue,
        __E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions__item_,
        _E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer_iE_Extensions,
        E_RABs_Admitted_ToBeModified_ModAckItem_SCG_Bearer,
        E_RABs_Admitted_ToBeModified_ModAckItem_SCG_BearerExtIEs,
        _E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_e_RAB_ID,
        _E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_seNB_GTPtunnelEndpoint,
        ____E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions__item__id_tab,
        ___E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions__item__id,
        ____E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions__item__criticality_tab,
        ___E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions__item__criticality,
        ____E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions__item__extensionValue_tab,
        ___E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions__item__extensionValue,
        __E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions__item_,
        _E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer_iE_Extensions,
        E_RABs_Admitted_ToBeModified_ModAckItem_Split_Bearer,
        E_RABs_Admitted_ToBeModified_ModAckItem_Split_BearerExtIEs,
        ___E_RABs_Admitted_ToBeReleased_ModAckList__item__id_tab,
        ____E_RABs_Admitted_ToBeReleased_ModAckList__item__id_tab_val_Value_0,
        __E_RABs_Admitted_ToBeReleased_ModAckList__item__id,
        __E_RABs_Admitted_ToBeReleased_ModAckList__item__criticality,
        __E_RABs_Admitted_ToBeReleased_ModAckList__item__value,
        _E_RABs_Admitted_ToBeReleased_ModAckList__item_,
        E_RABs_Admitted_ToBeReleased_ModAckList,
        E_RABs_Admitted_ToBeReleased_ModAckItemIEs,
        _E_RABs_Admitted_ToBeReleased_ModAckItemIEs_val_Value_0,
        _E_RABs_Admitted_ToReleased_ModAckItem_sCG_Bearer,
        _E_RABs_Admitted_ToReleased_ModAckItem_split_Bearer,
        E_RABs_Admitted_ToReleased_ModAckItem,
        _E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_e_RAB_ID,
        ____E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions__item__id_tab,
        ___E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions__item__id,
        ____E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions__item__criticality_tab,
        ___E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions__item__criticality,
        ____E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions__item__extensionValue_tab,
        ___E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions__item__extensionValue,
        __E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions__item_,
        _E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer_iE_Extensions,
        E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_Bearer,
        E_RABs_Admitted_ToBeReleased_ModAckItem_SCG_BearerExtIEs,
        _E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_e_RAB_ID,
        ____E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions__item__id_tab,
        ___E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions__item__id,
        ____E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions__item__criticality_tab,
        ___E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions__item__criticality,
        ____E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions__item__extensionValue_tab,
        ___E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions__item__extensionValue,
        __E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions__item_,
        _E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer_iE_Extensions,
        E_RABs_Admitted_ToBeReleased_ModAckItem_Split_Bearer,
        E_RABs_Admitted_ToBeReleased_ModAckItem_Split_BearerExtIEs,
        ____SeNBModificationRequestReject_protocolIEs__item__id_tab,
        _____SeNBModificationRequestReject_protocolIEs__item__id_tab_val_Value_0,
        _____SeNBModificationRequestReject_protocolIEs__item__id_tab_val_Value_1,
        _____SeNBModificationRequestReject_protocolIEs__item__id_tab_val_Value_2,
        _____SeNBModificationRequestReject_protocolIEs__item__id_tab_val_Value_3,
        _____SeNBModificationRequestReject_protocolIEs__item__id_tab_val_Value_4,
        _____SeNBModificationRequestReject_protocolIEs__item__id_tab_val_Value_5,
        ___SeNBModificationRequestReject_protocolIEs__item__id,
        ___SeNBModificationRequestReject_protocolIEs__item__criticality,
        ___SeNBModificationRequestReject_protocolIEs__item__value,
        __SeNBModificationRequestReject_protocolIEs__item_,
        _SeNBModificationRequestReject_protocolIEs,
        SeNBModificationRequestReject,
        SeNBModificationRequestReject_IEs,
        _SeNBModificationRequestReject_IEs_val_Value_0,
        _SeNBModificationRequestReject_IEs_val_Value_1,
        _SeNBModificationRequestReject_IEs_val_Value_2,
        _SeNBModificationRequestReject_IEs_val_Value_3,
        _SeNBModificationRequestReject_IEs_val_Value_4,
        _SeNBModificationRequestReject_IEs_val_Value_5,
        ____SeNBModificationRequired_protocolIEs__item__id_tab,
        _____SeNBModificationRequired_protocolIEs__item__id_tab_val_Value_0,
        _____SeNBModificationRequired_protocolIEs__item__id_tab_val_Value_1,
        _____SeNBModificationRequired_protocolIEs__item__id_tab_val_Value_2,
        _____SeNBModificationRequired_protocolIEs__item__id_tab_val_Value_3,
        _____SeNBModificationRequired_protocolIEs__item__id_tab_val_Value_4,
        _____SeNBModificationRequired_protocolIEs__item__id_tab_val_Value_5,
        _____SeNBModificationRequired_protocolIEs__item__id_tab_val_Value_6,
        _____SeNBModificationRequired_protocolIEs__item__id_tab_val_Value_7,
        ___SeNBModificationRequired_protocolIEs__item__id,
        ___SeNBModificationRequired_protocolIEs__item__criticality,
        ___SeNBModificationRequired_protocolIEs__item__value,
        __SeNBModificationRequired_protocolIEs__item_,
        _SeNBModificationRequired_protocolIEs,
        SeNBModificationRequired,
        SeNBModificationRequired_IEs,
        _SeNBModificationRequired_IEs_val_Value_0,
        _SeNBModificationRequired_IEs_val_Value_1,
        _SeNBModificationRequired_IEs_val_Value_2,
        _SeNBModificationRequired_IEs_val_Value_3,
        _SeNBModificationRequired_IEs_val_Value_4,
        _SeNBModificationRequired_IEs_val_Value_5,
        _SeNBModificationRequired_IEs_val_Value_6,
        _SeNBModificationRequired_IEs_val_Value_7,
        ___E_RABs_ToBeReleased_ModReqd__item__id_tab,
        ____E_RABs_ToBeReleased_ModReqd__item__id_tab_val_Value_0,
        __E_RABs_ToBeReleased_ModReqd__item__id,
        __E_RABs_ToBeReleased_ModReqd__item__criticality,
        __E_RABs_ToBeReleased_ModReqd__item__value,
        _E_RABs_ToBeReleased_ModReqd__item_,
        E_RABs_ToBeReleased_ModReqd,
        E_RABs_ToBeReleased_ModReqdItemIEs,
        _E_RABs_ToBeReleased_ModReqdItemIEs_val_Value_0,
        _E_RABs_ToBeReleased_ModReqdItem_e_RAB_ID,
        _E_RABs_ToBeReleased_ModReqdItem_cause,
        ____E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__id_tab,
        ___E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__id,
        ____E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__criticality_tab,
        ___E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__criticality,
        ____E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__extensionValue_tab,
        ___E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__extensionValue,
        __E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item_,
        _E_RABs_ToBeReleased_ModReqdItem_iE_Extensions,
        E_RABs_ToBeReleased_ModReqdItem,
        E_RABs_ToBeReleased_ModReqdItemExtIEs,
        ____SeNBModificationConfirm_protocolIEs__item__id_tab,
        _____SeNBModificationConfirm_protocolIEs__item__id_tab_val_Value_0,
        _____SeNBModificationConfirm_protocolIEs__item__id_tab_val_Value_1,
        _____SeNBModificationConfirm_protocolIEs__item__id_tab_val_Value_2,
        _____SeNBModificationConfirm_protocolIEs__item__id_tab_val_Value_3,
        _____SeNBModificationConfirm_protocolIEs__item__id_tab_val_Value_4,
        _____SeNBModificationConfirm_protocolIEs__item__id_tab_val_Value_5,
        ___SeNBModificationConfirm_protocolIEs__item__id,
        ___SeNBModificationConfirm_protocolIEs__item__criticality,
        ___SeNBModificationConfirm_protocolIEs__item__value,
        __SeNBModificationConfirm_protocolIEs__item_,
        _SeNBModificationConfirm_protocolIEs,
        SeNBModificationConfirm,
        SeNBModificationConfirm_IEs,
        _SeNBModificationConfirm_IEs_val_Value_0,
        _SeNBModificationConfirm_IEs_val_Value_1,
        _SeNBModificationConfirm_IEs_val_Value_2,
        _SeNBModificationConfirm_IEs_val_Value_3,
        _SeNBModificationConfirm_IEs_val_Value_4,
        _SeNBModificationConfirm_IEs_val_Value_5,
        ____SeNBModificationRefuse_protocolIEs__item__id_tab,
        _____SeNBModificationRefuse_protocolIEs__item__id_tab_val_Value_0,
        _____SeNBModificationRefuse_protocolIEs__item__id_tab_val_Value_1,
        _____SeNBModificationRefuse_protocolIEs__item__id_tab_val_Value_2,
        _____SeNBModificationRefuse_protocolIEs__item__id_tab_val_Value_3,
        _____SeNBModificationRefuse_protocolIEs__item__id_tab_val_Value_4,
        _____SeNBModificationRefuse_protocolIEs__item__id_tab_val_Value_5,
        _____SeNBModificationRefuse_protocolIEs__item__id_tab_val_Value_6,
        ___SeNBModificationRefuse_protocolIEs__item__id,
        ___SeNBModificationRefuse_protocolIEs__item__criticality,
        ___SeNBModificationRefuse_protocolIEs__item__value,
        __SeNBModificationRefuse_protocolIEs__item_,
        _SeNBModificationRefuse_protocolIEs,
        SeNBModificationRefuse,
        SeNBModificationRefuse_IEs,
        _SeNBModificationRefuse_IEs_val_Value_0,
        _SeNBModificationRefuse_IEs_val_Value_1,
        _SeNBModificationRefuse_IEs_val_Value_2,
        _SeNBModificationRefuse_IEs_val_Value_3,
        _SeNBModificationRefuse_IEs_val_Value_4,
        _SeNBModificationRefuse_IEs_val_Value_5,
        _SeNBModificationRefuse_IEs_val_Value_6,
        ____SeNBReleaseRequest_protocolIEs__item__id_tab,
        _____SeNBReleaseRequest_protocolIEs__item__id_tab_val_Value_0,
        _____SeNBReleaseRequest_protocolIEs__item__id_tab_val_Value_1,
        _____SeNBReleaseRequest_protocolIEs__item__id_tab_val_Value_2,
        _____SeNBReleaseRequest_protocolIEs__item__id_tab_val_Value_3,
        _____SeNBReleaseRequest_protocolIEs__item__id_tab_val_Value_4,
        _____SeNBReleaseRequest_protocolIEs__item__id_tab_val_Value_5,
        _____SeNBReleaseRequest_protocolIEs__item__id_tab_val_Value_6,
        _____SeNBReleaseRequest_protocolIEs__item__id_tab_val_Value_7,
        ___SeNBReleaseRequest_protocolIEs__item__id,
        ___SeNBReleaseRequest_protocolIEs__item__criticality,
        ___SeNBReleaseRequest_protocolIEs__item__value,
        __SeNBReleaseRequest_protocolIEs__item_,
        _SeNBReleaseRequest_protocolIEs,
        SeNBReleaseRequest,
        SeNBReleaseRequest_IEs,
        _SeNBReleaseRequest_IEs_val_Value_0,
        _SeNBReleaseRequest_IEs_val_Value_1,
        _SeNBReleaseRequest_IEs_val_Value_2,
        _SeNBReleaseRequest_IEs_val_Value_3,
        _SeNBReleaseRequest_IEs_val_Value_4,
        _SeNBReleaseRequest_IEs_val_Value_5,
        _SeNBReleaseRequest_IEs_val_Value_6,
        _SeNBReleaseRequest_IEs_val_Value_7,
        ___E_RABs_ToBeReleased_List_RelReq__item__id_tab,
        ____E_RABs_ToBeReleased_List_RelReq__item__id_tab_val_Value_0,
        __E_RABs_ToBeReleased_List_RelReq__item__id,
        __E_RABs_ToBeReleased_List_RelReq__item__criticality,
        __E_RABs_ToBeReleased_List_RelReq__item__value,
        _E_RABs_ToBeReleased_List_RelReq__item_,
        E_RABs_ToBeReleased_List_RelReq,
        E_RABs_ToBeReleased_RelReqItemIEs,
        _E_RABs_ToBeReleased_RelReqItemIEs_val_Value_0,
        _E_RABs_ToBeReleased_RelReqItem_sCG_Bearer,
        _E_RABs_ToBeReleased_RelReqItem_split_Bearer,
        E_RABs_ToBeReleased_RelReqItem,
        _E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_e_RAB_ID,
        _E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_uL_Forwarding_GTPtunnelEndpoint,
        _E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_dL_Forwarding_GTPtunnelEndpoint,
        ____E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions__item__id_tab,
        ___E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions__item__id,
        ____E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions__item__criticality_tab,
        ___E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions__item__criticality,
        ____E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions__item__extensionValue_tab,
        ___E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions__item__extensionValue,
        __E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions__item_,
        _E_RABs_ToBeReleased_RelReqItem_SCG_Bearer_iE_Extensions,
        E_RABs_ToBeReleased_RelReqItem_SCG_Bearer,
        E_RABs_ToBeReleased_RelReqItem_SCG_BearerExtIEs,
        _E_RABs_ToBeReleased_RelReqItem_Split_Bearer_e_RAB_ID,
        _E_RABs_ToBeReleased_RelReqItem_Split_Bearer_dL_Forwarding_GTPtunnelEndpoint,
        ____E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions__item__id_tab,
        ___E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions__item__id,
        ____E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions__item__criticality_tab,
        ___E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions__item__criticality,
        ____E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions__item__extensionValue_tab,
        ___E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions__item__extensionValue,
        __E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions__item_,
        _E_RABs_ToBeReleased_RelReqItem_Split_Bearer_iE_Extensions,
        E_RABs_ToBeReleased_RelReqItem_Split_Bearer,
        E_RABs_ToBeReleased_RelReqItem_Split_BearerExtIEs,
        ____SeNBReleaseRequired_protocolIEs__item__id_tab,
        _____SeNBReleaseRequired_protocolIEs__item__id_tab_val_Value_0,
        _____SeNBReleaseRequired_protocolIEs__item__id_tab_val_Value_1,
        _____SeNBReleaseRequired_protocolIEs__item__id_tab_val_Value_2,
        _____SeNBReleaseRequired_protocolIEs__item__id_tab_val_Value_3,
        _____SeNBReleaseRequired_protocolIEs__item__id_tab_val_Value_4,
        ___SeNBReleaseRequired_protocolIEs__item__id,
        ___SeNBReleaseRequired_protocolIEs__item__criticality,
        ___SeNBReleaseRequired_protocolIEs__item__value,
        __SeNBReleaseRequired_protocolIEs__item_,
        _SeNBReleaseRequired_protocolIEs,
        SeNBReleaseRequired,
        SeNBReleaseRequired_IEs,
        _SeNBReleaseRequired_IEs_val_Value_0,
        _SeNBReleaseRequired_IEs_val_Value_1,
        _SeNBReleaseRequired_IEs_val_Value_2,
        _SeNBReleaseRequired_IEs_val_Value_3,
        _SeNBReleaseRequired_IEs_val_Value_4,
        ____SeNBReleaseConfirm_protocolIEs__item__id_tab,
        _____SeNBReleaseConfirm_protocolIEs__item__id_tab_val_Value_0,
        _____SeNBReleaseConfirm_protocolIEs__item__id_tab_val_Value_1,
        _____SeNBReleaseConfirm_protocolIEs__item__id_tab_val_Value_2,
        _____SeNBReleaseConfirm_protocolIEs__item__id_tab_val_Value_3,
        _____SeNBReleaseConfirm_protocolIEs__item__id_tab_val_Value_4,
        _____SeNBReleaseConfirm_protocolIEs__item__id_tab_val_Value_5,
        ___SeNBReleaseConfirm_protocolIEs__item__id,
        ___SeNBReleaseConfirm_protocolIEs__item__criticality,
        ___SeNBReleaseConfirm_protocolIEs__item__value,
        __SeNBReleaseConfirm_protocolIEs__item_,
        _SeNBReleaseConfirm_protocolIEs,
        SeNBReleaseConfirm,
        SeNBReleaseConfirm_IEs,
        _SeNBReleaseConfirm_IEs_val_Value_0,
        _SeNBReleaseConfirm_IEs_val_Value_1,
        _SeNBReleaseConfirm_IEs_val_Value_2,
        _SeNBReleaseConfirm_IEs_val_Value_3,
        _SeNBReleaseConfirm_IEs_val_Value_4,
        _SeNBReleaseConfirm_IEs_val_Value_5,
        ___E_RABs_ToBeReleased_List_RelConf__item__id_tab,
        ____E_RABs_ToBeReleased_List_RelConf__item__id_tab_val_Value_0,
        __E_RABs_ToBeReleased_List_RelConf__item__id,
        __E_RABs_ToBeReleased_List_RelConf__item__criticality,
        __E_RABs_ToBeReleased_List_RelConf__item__value,
        _E_RABs_ToBeReleased_List_RelConf__item_,
        E_RABs_ToBeReleased_List_RelConf,
        E_RABs_ToBeReleased_RelConfItemIEs,
        _E_RABs_ToBeReleased_RelConfItemIEs_val_Value_0,
        _E_RABs_ToBeReleased_RelConfItem_sCG_Bearer,
        _E_RABs_ToBeReleased_RelConfItem_split_Bearer,
        E_RABs_ToBeReleased_RelConfItem,
        _E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_e_RAB_ID,
        _E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_uL_Forwarding_GTPtunnelEndpoint,
        _E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_dL_Forwarding_GTPtunnelEndpoint,
        ____E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions__item__id_tab,
        ___E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions__item__id,
        ____E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions__item__criticality_tab,
        ___E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions__item__criticality,
        ____E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions__item__extensionValue_tab,
        ___E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions__item__extensionValue,
        __E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions__item_,
        _E_RABs_ToBeReleased_RelConfItem_SCG_Bearer_iE_Extensions,
        E_RABs_ToBeReleased_RelConfItem_SCG_Bearer,
        E_RABs_ToBeReleased_RelConfItem_SCG_BearerExtIEs,
        _E_RABs_ToBeReleased_RelConfItem_Split_Bearer_e_RAB_ID,
        _E_RABs_ToBeReleased_RelConfItem_Split_Bearer_dL_Forwarding_GTPtunnelEndpoint,
        ____E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions__item__id_tab,
        ___E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions__item__id,
        ____E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions__item__criticality_tab,
        ___E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions__item__criticality,
        ____E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions__item__extensionValue_tab,
        ___E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions__item__extensionValue,
        __E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions__item_,
        _E_RABs_ToBeReleased_RelConfItem_Split_Bearer_iE_Extensions,
        E_RABs_ToBeReleased_RelConfItem_Split_Bearer,
        E_RABs_ToBeReleased_RelConfItem_Split_BearerExtIEs,
        ____SeNBCounterCheckRequest_protocolIEs__item__id_tab,
        _____SeNBCounterCheckRequest_protocolIEs__item__id_tab_val_Value_0,
        _____SeNBCounterCheckRequest_protocolIEs__item__id_tab_val_Value_1,
        _____SeNBCounterCheckRequest_protocolIEs__item__id_tab_val_Value_2,
        _____SeNBCounterCheckRequest_protocolIEs__item__id_tab_val_Value_3,
        _____SeNBCounterCheckRequest_protocolIEs__item__id_tab_val_Value_4,
        ___SeNBCounterCheckRequest_protocolIEs__item__id,
        ___SeNBCounterCheckRequest_protocolIEs__item__criticality,
        ___SeNBCounterCheckRequest_protocolIEs__item__value,
        __SeNBCounterCheckRequest_protocolIEs__item_,
        _SeNBCounterCheckRequest_protocolIEs,
        SeNBCounterCheckRequest,
        SeNBCounterCheckRequest_IEs,
        _SeNBCounterCheckRequest_IEs_val_Value_0,
        _SeNBCounterCheckRequest_IEs_val_Value_1,
        _SeNBCounterCheckRequest_IEs_val_Value_2,
        _SeNBCounterCheckRequest_IEs_val_Value_3,
        _SeNBCounterCheckRequest_IEs_val_Value_4,
        ___E_RABs_SubjectToCounterCheck_List__item__id_tab,
        ____E_RABs_SubjectToCounterCheck_List__item__id_tab_val_Value_0,
        __E_RABs_SubjectToCounterCheck_List__item__id,
        __E_RABs_SubjectToCounterCheck_List__item__criticality,
        __E_RABs_SubjectToCounterCheck_List__item__value,
        _E_RABs_SubjectToCounterCheck_List__item_,
        E_RABs_SubjectToCounterCheck_List,
        E_RABs_SubjectToCounterCheckItemIEs,
        _E_RABs_SubjectToCounterCheckItemIEs_val_Value_0,
        _E_RABs_SubjectToCounterCheckItem_e_RAB_ID,
        _E_RABs_SubjectToCounterCheckItem_uL_Count,
        _E_RABs_SubjectToCounterCheckItem_dL_Count,
        ____E_RABs_SubjectToCounterCheckItem_iE_Extensions__item__id_tab,
        ___E_RABs_SubjectToCounterCheckItem_iE_Extensions__item__id,
        ____E_RABs_SubjectToCounterCheckItem_iE_Extensions__item__criticality_tab,
        ___E_RABs_SubjectToCounterCheckItem_iE_Extensions__item__criticality,
        ____E_RABs_SubjectToCounterCheckItem_iE_Extensions__item__extensionValue_tab,
        ___E_RABs_SubjectToCounterCheckItem_iE_Extensions__item__extensionValue,
        __E_RABs_SubjectToCounterCheckItem_iE_Extensions__item_,
        _E_RABs_SubjectToCounterCheckItem_iE_Extensions,
        E_RABs_SubjectToCounterCheckItem,
        E_RABs_SubjectToCounterCheckItemExtIEs,
        ____X2RemovalRequest_protocolIEs__item__id_tab,
        _____X2RemovalRequest_protocolIEs__item__id_tab_val_Value_0,
        _____X2RemovalRequest_protocolIEs__item__id_tab_val_Value_1,
        ___X2RemovalRequest_protocolIEs__item__id,
        ___X2RemovalRequest_protocolIEs__item__criticality,
        ___X2RemovalRequest_protocolIEs__item__value,
        __X2RemovalRequest_protocolIEs__item_,
        _X2RemovalRequest_protocolIEs,
        X2RemovalRequest,
        X2RemovalRequest_IEs,
        _X2RemovalRequest_IEs_val_Value_0,
        _X2RemovalRequest_IEs_val_Value_1,
        ____X2RemovalResponse_protocolIEs__item__id_tab,
        _____X2RemovalResponse_protocolIEs__item__id_tab_val_Value_0,
        _____X2RemovalResponse_protocolIEs__item__id_tab_val_Value_1,
        ___X2RemovalResponse_protocolIEs__item__id,
        ___X2RemovalResponse_protocolIEs__item__criticality,
        ___X2RemovalResponse_protocolIEs__item__value,
        __X2RemovalResponse_protocolIEs__item_,
        _X2RemovalResponse_protocolIEs,
        X2RemovalResponse,
        X2RemovalResponse_IEs,
        _X2RemovalResponse_IEs_val_Value_0,
        _X2RemovalResponse_IEs_val_Value_1,
        ____X2RemovalFailure_protocolIEs__item__id_tab,
        _____X2RemovalFailure_protocolIEs__item__id_tab_val_Value_0,
        _____X2RemovalFailure_protocolIEs__item__id_tab_val_Value_1,
        ___X2RemovalFailure_protocolIEs__item__id,
        ___X2RemovalFailure_protocolIEs__item__criticality,
        ___X2RemovalFailure_protocolIEs__item__value,
        __X2RemovalFailure_protocolIEs__item_,
        _X2RemovalFailure_protocolIEs,
        X2RemovalFailure,
        X2RemovalFailure_IEs,
        _X2RemovalFailure_IEs_val_Value_0,
        _X2RemovalFailure_IEs_val_Value_1,
        ____RetrieveUEContextRequest_protocolIEs__item__id_tab,
        _____RetrieveUEContextRequest_protocolIEs__item__id_tab_val_Value_0,
        _____RetrieveUEContextRequest_protocolIEs__item__id_tab_val_Value_1,
        _____RetrieveUEContextRequest_protocolIEs__item__id_tab_val_Value_2,
        _____RetrieveUEContextRequest_protocolIEs__item__id_tab_val_Value_3,
        _____RetrieveUEContextRequest_protocolIEs__item__id_tab_val_Value_4,
        _____RetrieveUEContextRequest_protocolIEs__item__id_tab_val_Value_5,
        _____RetrieveUEContextRequest_protocolIEs__item__id_tab_val_Value_6,
        ___RetrieveUEContextRequest_protocolIEs__item__id,
        ___RetrieveUEContextRequest_protocolIEs__item__criticality,
        ___RetrieveUEContextRequest_protocolIEs__item__value,
        __RetrieveUEContextRequest_protocolIEs__item_,
        _RetrieveUEContextRequest_protocolIEs,
        RetrieveUEContextRequest,
        RetrieveUEContextRequest_IEs,
        _RetrieveUEContextRequest_IEs_val_Value_0,
        _RetrieveUEContextRequest_IEs_val_Value_1,
        _RetrieveUEContextRequest_IEs_val_Value_2,
        _RetrieveUEContextRequest_IEs_val_Value_3,
        _RetrieveUEContextRequest_IEs_val_Value_4,
        _RetrieveUEContextRequest_IEs_val_Value_5,
        _RetrieveUEContextRequest_IEs_val_Value_6,
        ____RetrieveUEContextResponse_protocolIEs__item__id_tab,
        _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_0,
        _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_1,
        _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_2,
        _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_3,
        _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_4,
        _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_5,
        _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_6,
        _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_7,
        _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_8,
        _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_9,
        _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_10,
        _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_11,
        _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_12,
        _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_13,
        _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_14,
        _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_15,
        _____RetrieveUEContextResponse_protocolIEs__item__id_tab_val_Value_16,
        ___RetrieveUEContextResponse_protocolIEs__item__id,
        ___RetrieveUEContextResponse_protocolIEs__item__criticality,
        ___RetrieveUEContextResponse_protocolIEs__item__value,
        __RetrieveUEContextResponse_protocolIEs__item_,
        _RetrieveUEContextResponse_protocolIEs,
        RetrieveUEContextResponse,
        RetrieveUEContextResponse_IEs,
        _RetrieveUEContextResponse_IEs_val_Value_0,
        _RetrieveUEContextResponse_IEs_val_Value_1,
        _RetrieveUEContextResponse_IEs_val_Value_2,
        _RetrieveUEContextResponse_IEs_val_Value_3,
        _RetrieveUEContextResponse_IEs_val_Value_4,
        _RetrieveUEContextResponse_IEs_val_Value_5,
        _RetrieveUEContextResponse_IEs_val_Value_6,
        _RetrieveUEContextResponse_IEs_val_Value_7,
        _RetrieveUEContextResponse_IEs_val_Value_8,
        _RetrieveUEContextResponse_IEs_val_Value_9,
        _RetrieveUEContextResponse_IEs_val_Value_10,
        _RetrieveUEContextResponse_IEs_val_Value_11,
        _RetrieveUEContextResponse_IEs_val_Value_12,
        _RetrieveUEContextResponse_IEs_val_Value_13,
        _RetrieveUEContextResponse_IEs_val_Value_14,
        _RetrieveUEContextResponse_IEs_val_Value_15,
        _RetrieveUEContextResponse_IEs_val_Value_16,
        _UE_ContextInformationRetrieve_mME_UE_S1AP_ID,
        _UE_ContextInformationRetrieve_uESecurityCapabilities,
        _UE_ContextInformationRetrieve_aS_SecurityInformation,
        _UE_ContextInformationRetrieve_uEaggregateMaximumBitRate,
        _UE_ContextInformationRetrieve_subscriberProfileIDforRFP,
        _UE_ContextInformationRetrieve_e_RABs_ToBeSetup_ListRetrieve,
        _UE_ContextInformationRetrieve_rRC_Context,
        _UE_ContextInformationRetrieve_handoverRestrictionList,
        _UE_ContextInformationRetrieve_locationReportingInformation,
        _UE_ContextInformationRetrieve_managBasedMDTallowed,
        _UE_ContextInformationRetrieve_managBasedMDTPLMNList,
        ____UE_ContextInformationRetrieve_iE_Extensions__item__id_tab,
        _____UE_ContextInformationRetrieve_iE_Extensions__item__id_tab_val_Extension_0,
        _____UE_ContextInformationRetrieve_iE_Extensions__item__id_tab_val_Extension_1,
        _____UE_ContextInformationRetrieve_iE_Extensions__item__id_tab_val_Extension_2,
        _____UE_ContextInformationRetrieve_iE_Extensions__item__id_tab_val_Extension_3,
        _____UE_ContextInformationRetrieve_iE_Extensions__item__id_tab_val_Extension_4,
        _____UE_ContextInformationRetrieve_iE_Extensions__item__id_tab_val_Extension_5,
        ___UE_ContextInformationRetrieve_iE_Extensions__item__id,
        ___UE_ContextInformationRetrieve_iE_Extensions__item__criticality,
        ___UE_ContextInformationRetrieve_iE_Extensions__item__extensionValue,
        __UE_ContextInformationRetrieve_iE_Extensions__item_,
        _UE_ContextInformationRetrieve_iE_Extensions,
        UE_ContextInformationRetrieve,
        UE_ContextInformationRetrieve_ExtIEs,
        _UE_ContextInformationRetrieve_ExtIEs_val_Extension_0,
        _UE_ContextInformationRetrieve_ExtIEs_val_Extension_1,
        _UE_ContextInformationRetrieve_ExtIEs_val_Extension_2,
        _UE_ContextInformationRetrieve_ExtIEs_val_Extension_3,
        _UE_ContextInformationRetrieve_ExtIEs_val_Extension_4,
        _UE_ContextInformationRetrieve_ExtIEs_val_Extension_5,
        ___E_RABs_ToBeSetup_ListRetrieve__item__id_tab,
        ____E_RABs_ToBeSetup_ListRetrieve__item__id_tab_val_Value_0,
        __E_RABs_ToBeSetup_ListRetrieve__item__id,
        __E_RABs_ToBeSetup_ListRetrieve__item__criticality,
        __E_RABs_ToBeSetup_ListRetrieve__item__value,
        _E_RABs_ToBeSetup_ListRetrieve__item_,
        E_RABs_ToBeSetup_ListRetrieve,
        E_RABs_ToBeSetupRetrieve_ItemIEs,
        _E_RABs_ToBeSetupRetrieve_ItemIEs_val_Value_0,
        _E_RABs_ToBeSetupRetrieve_Item_e_RAB_ID,
        _E_RABs_ToBeSetupRetrieve_Item_e_RAB_Level_QoS_Parameters,
        _E_RABs_ToBeSetupRetrieve_Item_bearerType,
        ____E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item__id_tab,
        _____E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item__id_tab_val_Extension_0,
        _____E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item__id_tab_val_Extension_1,
        _____E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item__id_tab_val_Extension_2,
        _____E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item__id_tab_val_Extension_3,
        ___E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item__id,
        ___E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item__criticality,
        ___E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item__extensionValue,
        __E_RABs_ToBeSetupRetrieve_Item_iE_Extensions__item_,
        _E_RABs_ToBeSetupRetrieve_Item_iE_Extensions,
        E_RABs_ToBeSetupRetrieve_Item,
        E_RABs_ToBeSetupRetrieve_ItemExtIEs,
        _E_RABs_ToBeSetupRetrieve_ItemExtIEs_val_Extension_0,
        _E_RABs_ToBeSetupRetrieve_ItemExtIEs_val_Extension_1,
        _E_RABs_ToBeSetupRetrieve_ItemExtIEs_val_Extension_2,
        _E_RABs_ToBeSetupRetrieve_ItemExtIEs_val_Extension_3,
        ____RetrieveUEContextFailure_protocolIEs__item__id_tab,
        _____RetrieveUEContextFailure_protocolIEs__item__id_tab_val_Value_0,
        _____RetrieveUEContextFailure_protocolIEs__item__id_tab_val_Value_1,
        _____RetrieveUEContextFailure_protocolIEs__item__id_tab_val_Value_2,
        _____RetrieveUEContextFailure_protocolIEs__item__id_tab_val_Value_3,
        ___RetrieveUEContextFailure_protocolIEs__item__id,
        ___RetrieveUEContextFailure_protocolIEs__item__criticality,
        ___RetrieveUEContextFailure_protocolIEs__item__value,
        __RetrieveUEContextFailure_protocolIEs__item_,
        _RetrieveUEContextFailure_protocolIEs,
        RetrieveUEContextFailure,
        RetrieveUEContextFailure_IEs,
        _RetrieveUEContextFailure_IEs_val_Value_0,
        _RetrieveUEContextFailure_IEs_val_Value_1,
        _RetrieveUEContextFailure_IEs_val_Value_2,
        _RetrieveUEContextFailure_IEs_val_Value_3,
        ____SgNBAdditionRequest_protocolIEs__item__id_tab,
        _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_0,
        _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_1,
        _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_2,
        _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_3,
        _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_4,
        _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_5,
        _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_6,
        _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_7,
        _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_8,
        _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_9,
        _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_10,
        _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_11,
        _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_12,
        _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_13,
        _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_14,
        _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_15,
        _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_16,
        _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_17,
        _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_18,
        _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_19,
        _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_20,
        _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_21,
        _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_22,
        _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_23,
        _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_24,
        _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_25,
        _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_26,
        _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_27,
        _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_28,
        _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_29,
        _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_30,
        _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_31,
        _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_32,
        _____SgNBAdditionRequest_protocolIEs__item__id_tab_val_Value_33,
        ___SgNBAdditionRequest_protocolIEs__item__id,
        ___SgNBAdditionRequest_protocolIEs__item__criticality,
        ___SgNBAdditionRequest_protocolIEs__item__value,
        __SgNBAdditionRequest_protocolIEs__item_,
        _SgNBAdditionRequest_protocolIEs,
        SgNBAdditionRequest,
        SgNBAdditionRequest_IEs,
        _SgNBAdditionRequest_IEs_val_Value_0,
        _SgNBAdditionRequest_IEs_val_Value_1,
        _SgNBAdditionRequest_IEs_val_Value_2,
        _SgNBAdditionRequest_IEs_val_Value_3,
        _SgNBAdditionRequest_IEs_val_Value_4,
        _SgNBAdditionRequest_IEs_val_Value_5,
        _SgNBAdditionRequest_IEs_val_Value_6,
        _SgNBAdditionRequest_IEs_val_Value_7,
        _SgNBAdditionRequest_IEs_val_Value_8,
        _SgNBAdditionRequest_IEs_val_Value_9,
        _SgNBAdditionRequest_IEs_val_Value_10,
        _SgNBAdditionRequest_IEs_val_Value_11,
        _SgNBAdditionRequest_IEs_val_Value_12,
        _SgNBAdditionRequest_IEs_val_Value_13,
        _SgNBAdditionRequest_IEs_val_Value_14,
        _SgNBAdditionRequest_IEs_val_Value_15,
        _SgNBAdditionRequest_IEs_val_Value_16,
        _SgNBAdditionRequest_IEs_val_Value_17,
        _SgNBAdditionRequest_IEs_val_Value_18,
        _SgNBAdditionRequest_IEs_val_Value_19,
        _SgNBAdditionRequest_IEs_val_Value_20,
        _SgNBAdditionRequest_IEs_val_Value_21,
        _SgNBAdditionRequest_IEs_val_Value_22,
        _SgNBAdditionRequest_IEs_val_Value_23,
        _SgNBAdditionRequest_IEs_val_Value_24,
        _SgNBAdditionRequest_IEs_val_Value_25,
        _SgNBAdditionRequest_IEs_val_Value_26,
        _SgNBAdditionRequest_IEs_val_Value_27,
        _SgNBAdditionRequest_IEs_val_Value_28,
        _SgNBAdditionRequest_IEs_val_Value_29,
        _SgNBAdditionRequest_IEs_val_Value_30,
        _SgNBAdditionRequest_IEs_val_Value_31,
        _SgNBAdditionRequest_IEs_val_Value_32,
        _SgNBAdditionRequest_IEs_val_Value_33,
        ___E_RABs_ToBeAdded_SgNBAddReqList__item__id_tab,
        ____E_RABs_ToBeAdded_SgNBAddReqList__item__id_tab_val_Value_0,
        __E_RABs_ToBeAdded_SgNBAddReqList__item__id,
        __E_RABs_ToBeAdded_SgNBAddReqList__item__criticality,
        __E_RABs_ToBeAdded_SgNBAddReqList__item__value,
        _E_RABs_ToBeAdded_SgNBAddReqList__item_,
        E_RABs_ToBeAdded_SgNBAddReqList,
        E_RABs_ToBeAdded_SgNBAddReq_ItemIEs,
        _E_RABs_ToBeAdded_SgNBAddReq_ItemIEs_val_Value_0,
        _E_RABs_ToBeAdded_SgNBAddReq_Item_e_RAB_ID,
        _E_RABs_ToBeAdded_SgNBAddReq_Item_drb_ID,
        _E_RABs_ToBeAdded_SgNBAddReq_Item_en_DC_ResourceConfiguration,
        __E_RABs_ToBeAdded_SgNBAddReq_Item_resource_configuration_sgNBPDCPpresent,
        __E_RABs_ToBeAdded_SgNBAddReq_Item_resource_configuration_sgNBPDCPnotpresent,
        _E_RABs_ToBeAdded_SgNBAddReq_Item_resource_configuration,
        ____E_RABs_ToBeAdded_SgNBAddReq_Item_iE_Extensions__item__id_tab,
        ___E_RABs_ToBeAdded_SgNBAddReq_Item_iE_Extensions__item__id,
        ____E_RABs_ToBeAdded_SgNBAddReq_Item_iE_Extensions__item__criticality_tab,
        ___E_RABs_ToBeAdded_SgNBAddReq_Item_iE_Extensions__item__criticality,
        ____E_RABs_ToBeAdded_SgNBAddReq_Item_iE_Extensions__item__extensionValue_tab,
        ___E_RABs_ToBeAdded_SgNBAddReq_Item_iE_Extensions__item__extensionValue,
        __E_RABs_ToBeAdded_SgNBAddReq_Item_iE_Extensions__item_,
        _E_RABs_ToBeAdded_SgNBAddReq_Item_iE_Extensions,
        E_RABs_ToBeAdded_SgNBAddReq_Item,
        E_RABs_ToBeAdded_SgNBAddReq_ItemExtIEs,
        _E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent_full_E_RAB_Level_QoS_Parameters,
        _E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent_max_MCG_admit_E_RAB_Level_QoS_Parameters,
        _E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent_dL_Forwarding,
        _E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent_meNB_DL_GTP_TEIDatMCG,
        _E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent_s1_UL_GTPtunnelEndpoint,
        ____E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab,
        _____E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_0,
        _____E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_1,
        _____E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_2,
        _____E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_3,
        _____E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_4,
        _____E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_5,
        ___E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent_iE_Extensions__item__id,
        ___E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent_iE_Extensions__item__criticality,
        ___E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue,
        __E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent_iE_Extensions__item_,
        _E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent_iE_Extensions,
        E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresent,
        E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresentExtIEs,
        _E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresentExtIEs_val_Extension_0,
        _E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresentExtIEs_val_Extension_1,
        _E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresentExtIEs_val_Extension_2,
        _E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresentExtIEs_val_Extension_3,
        _E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresentExtIEs_val_Extension_4,
        _E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPpresentExtIEs_val_Extension_5,
        _E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresent_requested_SCG_E_RAB_Level_QoS_Parameters,
        _E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresent_meNB_UL_GTP_TEIDatPDCP,
        _E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresent_secondary_meNB_UL_GTP_TEIDatPDCP,
        _E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresent_rlc_Mode,
        _E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresent_uL_Configuration,
        ____E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab,
        _____E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab_val_Extension_0,
        _____E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab_val_Extension_1,
        _____E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab_val_Extension_2,
        ___E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id,
        ___E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality,
        ___E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue,
        __E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresent_iE_Extensions__item_,
        _E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresent_iE_Extensions,
        E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresent,
        E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresentExtIEs,
        _E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresentExtIEs_val_Extension_0,
        _E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresentExtIEs_val_Extension_1,
        _E_RABs_ToBeAdded_SgNBAddReq_Item_SgNBPDCPnotpresentExtIEs_val_Extension_2,
        ____SgNBAdditionRequestAcknowledge_protocolIEs__item__id_tab,
        _____SgNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_0,
        _____SgNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_1,
        _____SgNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_2,
        _____SgNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_3,
        _____SgNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_4,
        _____SgNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_5,
        _____SgNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_6,
        _____SgNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_7,
        _____SgNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_8,
        _____SgNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_9,
        _____SgNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_10,
        _____SgNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_11,
        _____SgNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_12,
        _____SgNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_13,
        _____SgNBAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_14,
        ___SgNBAdditionRequestAcknowledge_protocolIEs__item__id,
        ___SgNBAdditionRequestAcknowledge_protocolIEs__item__criticality,
        ___SgNBAdditionRequestAcknowledge_protocolIEs__item__value,
        __SgNBAdditionRequestAcknowledge_protocolIEs__item_,
        _SgNBAdditionRequestAcknowledge_protocolIEs,
        SgNBAdditionRequestAcknowledge,
        SgNBAdditionRequestAcknowledge_IEs,
        _SgNBAdditionRequestAcknowledge_IEs_val_Value_0,
        _SgNBAdditionRequestAcknowledge_IEs_val_Value_1,
        _SgNBAdditionRequestAcknowledge_IEs_val_Value_2,
        _SgNBAdditionRequestAcknowledge_IEs_val_Value_3,
        _SgNBAdditionRequestAcknowledge_IEs_val_Value_4,
        _SgNBAdditionRequestAcknowledge_IEs_val_Value_5,
        _SgNBAdditionRequestAcknowledge_IEs_val_Value_6,
        _SgNBAdditionRequestAcknowledge_IEs_val_Value_7,
        _SgNBAdditionRequestAcknowledge_IEs_val_Value_8,
        _SgNBAdditionRequestAcknowledge_IEs_val_Value_9,
        _SgNBAdditionRequestAcknowledge_IEs_val_Value_10,
        _SgNBAdditionRequestAcknowledge_IEs_val_Value_11,
        _SgNBAdditionRequestAcknowledge_IEs_val_Value_12,
        _SgNBAdditionRequestAcknowledge_IEs_val_Value_13,
        _SgNBAdditionRequestAcknowledge_IEs_val_Value_14,
        ___E_RABs_Admitted_ToBeAdded_SgNBAddReqAckList__item__id_tab,
        ____E_RABs_Admitted_ToBeAdded_SgNBAddReqAckList__item__id_tab_val_Value_0,
        __E_RABs_Admitted_ToBeAdded_SgNBAddReqAckList__item__id,
        __E_RABs_Admitted_ToBeAdded_SgNBAddReqAckList__item__criticality,
        __E_RABs_Admitted_ToBeAdded_SgNBAddReqAckList__item__value,
        _E_RABs_Admitted_ToBeAdded_SgNBAddReqAckList__item_,
        E_RABs_Admitted_ToBeAdded_SgNBAddReqAckList,
        E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_ItemIEs,
        _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_ItemIEs_val_Value_0,
        _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_e_RAB_ID,
        _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_en_DC_ResourceConfiguration,
        __E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_resource_configuration_sgNBPDCPpresent,
        __E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_resource_configuration_sgNBPDCPnotpresent,
        _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_resource_configuration,
        ____E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_iE_Extensions__item__id_tab,
        ___E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_iE_Extensions__item__id,
        ____E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_iE_Extensions__item__criticality_tab,
        ___E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_iE_Extensions__item__criticality,
        ____E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_iE_Extensions__item__extensionValue_tab,
        ___E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_iE_Extensions__item__extensionValue,
        __E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_iE_Extensions__item_,
        _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_iE_Extensions,
        E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item,
        E_RABs_ToBeAdded_SgNBAddReqAck_ItemExtIEs,
        _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent_s1_DL_GTPtunnelEndpoint,
        _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent_sgNB_UL_GTP_TEIDatPDCP,
        _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent_rlc_Mode,
        _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent_dL_Forwarding_GTPtunnelEndpoint,
        _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent_uL_Forwarding_GTPtunnelEndpoint,
        _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent_mCG_E_RAB_Level_QoS_Parameters,
        _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent_uL_Configuration,
        ____E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab,
        _____E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_0,
        _____E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_1,
        _____E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_2,
        _____E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_3,
        ___E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent_iE_Extensions__item__id,
        ___E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent_iE_Extensions__item__criticality,
        ___E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue,
        __E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent_iE_Extensions__item_,
        _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent_iE_Extensions,
        E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresent,
        E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresentExtIEs,
        _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresentExtIEs_val_Extension_0,
        _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresentExtIEs_val_Extension_1,
        _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresentExtIEs_val_Extension_2,
        _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPpresentExtIEs_val_Extension_3,
        _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPnotpresent_sgNB_DL_GTP_TEIDatSCG,
        _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPnotpresent_secondary_sgNB_DL_GTP_TEIDatSCG,
        ____E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab,
        _____E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab_val_Extension_0,
        ___E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__id,
        ___E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality,
        ___E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue,
        __E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPnotpresent_iE_Extensions__item_,
        _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPnotpresent_iE_Extensions,
        E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPnotpresent,
        E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPnotpresentExtIEs,
        _E_RABs_Admitted_ToBeAdded_SgNBAddReqAck_Item_SgNBPDCPnotpresentExtIEs_val_Extension_0,
        ____SgNBAdditionRequestReject_protocolIEs__item__id_tab,
        _____SgNBAdditionRequestReject_protocolIEs__item__id_tab_val_Value_0,
        _____SgNBAdditionRequestReject_protocolIEs__item__id_tab_val_Value_1,
        _____SgNBAdditionRequestReject_protocolIEs__item__id_tab_val_Value_2,
        _____SgNBAdditionRequestReject_protocolIEs__item__id_tab_val_Value_3,
        _____SgNBAdditionRequestReject_protocolIEs__item__id_tab_val_Value_4,
        ___SgNBAdditionRequestReject_protocolIEs__item__id,
        ___SgNBAdditionRequestReject_protocolIEs__item__criticality,
        ___SgNBAdditionRequestReject_protocolIEs__item__value,
        __SgNBAdditionRequestReject_protocolIEs__item_,
        _SgNBAdditionRequestReject_protocolIEs,
        SgNBAdditionRequestReject,
        SgNBAdditionRequestReject_IEs,
        _SgNBAdditionRequestReject_IEs_val_Value_0,
        _SgNBAdditionRequestReject_IEs_val_Value_1,
        _SgNBAdditionRequestReject_IEs_val_Value_2,
        _SgNBAdditionRequestReject_IEs_val_Value_3,
        _SgNBAdditionRequestReject_IEs_val_Value_4,
        ____SgNBReconfigurationComplete_protocolIEs__item__id_tab,
        _____SgNBReconfigurationComplete_protocolIEs__item__id_tab_val_Value_0,
        _____SgNBReconfigurationComplete_protocolIEs__item__id_tab_val_Value_1,
        _____SgNBReconfigurationComplete_protocolIEs__item__id_tab_val_Value_2,
        _____SgNBReconfigurationComplete_protocolIEs__item__id_tab_val_Value_3,
        ___SgNBReconfigurationComplete_protocolIEs__item__id,
        ___SgNBReconfigurationComplete_protocolIEs__item__criticality,
        ___SgNBReconfigurationComplete_protocolIEs__item__value,
        __SgNBReconfigurationComplete_protocolIEs__item_,
        _SgNBReconfigurationComplete_protocolIEs,
        SgNBReconfigurationComplete,
        SgNBReconfigurationComplete_IEs,
        _SgNBReconfigurationComplete_IEs_val_Value_0,
        _SgNBReconfigurationComplete_IEs_val_Value_1,
        _SgNBReconfigurationComplete_IEs_val_Value_2,
        _SgNBReconfigurationComplete_IEs_val_Value_3,
        _ResponseInformationSgNBReconfComp_success_SgNBReconfComp,
        _ResponseInformationSgNBReconfComp_reject_by_MeNB_SgNBReconfComp,
        ResponseInformationSgNBReconfComp,
        _ResponseInformationSgNBReconfComp_SuccessItem_meNBtoSgNBContainer,
        ____ResponseInformationSgNBReconfComp_SuccessItem_iE_Extensions__item__id_tab,
        ___ResponseInformationSgNBReconfComp_SuccessItem_iE_Extensions__item__id,
        ____ResponseInformationSgNBReconfComp_SuccessItem_iE_Extensions__item__criticality_tab,
        ___ResponseInformationSgNBReconfComp_SuccessItem_iE_Extensions__item__criticality,
        ____ResponseInformationSgNBReconfComp_SuccessItem_iE_Extensions__item__extensionValue_tab,
        ___ResponseInformationSgNBReconfComp_SuccessItem_iE_Extensions__item__extensionValue,
        __ResponseInformationSgNBReconfComp_SuccessItem_iE_Extensions__item_,
        _ResponseInformationSgNBReconfComp_SuccessItem_iE_Extensions,
        ResponseInformationSgNBReconfComp_SuccessItem,
        ResponseInformationSgNBReconfComp_SuccessItemExtIEs,
        _ResponseInformationSgNBReconfComp_RejectByMeNBItem_cause,
        ____ResponseInformationSgNBReconfComp_RejectByMeNBItem_iE_Extensions__item__id_tab,
        ___ResponseInformationSgNBReconfComp_RejectByMeNBItem_iE_Extensions__item__id,
        ____ResponseInformationSgNBReconfComp_RejectByMeNBItem_iE_Extensions__item__criticality_tab,
        ___ResponseInformationSgNBReconfComp_RejectByMeNBItem_iE_Extensions__item__criticality,
        ____ResponseInformationSgNBReconfComp_RejectByMeNBItem_iE_Extensions__item__extensionValue_tab,
        ___ResponseInformationSgNBReconfComp_RejectByMeNBItem_iE_Extensions__item__extensionValue,
        __ResponseInformationSgNBReconfComp_RejectByMeNBItem_iE_Extensions__item_,
        _ResponseInformationSgNBReconfComp_RejectByMeNBItem_iE_Extensions,
        ResponseInformationSgNBReconfComp_RejectByMeNBItem,
        ResponseInformationSgNBReconfComp_RejectByMeNBItemExtIEs,
        ____SgNBModificationRequest_protocolIEs__item__id_tab,
        _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_0,
        _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_1,
        _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_2,
        _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_3,
        _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_4,
        _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_5,
        _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_6,
        _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_7,
        _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_8,
        _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_9,
        _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_10,
        _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_11,
        _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_12,
        _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_13,
        _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_14,
        _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_15,
        _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_16,
        _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_17,
        _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_18,
        _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_19,
        _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_20,
        _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_21,
        _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_22,
        _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_23,
        _____SgNBModificationRequest_protocolIEs__item__id_tab_val_Value_24,
        ___SgNBModificationRequest_protocolIEs__item__id,
        ___SgNBModificationRequest_protocolIEs__item__criticality,
        ___SgNBModificationRequest_protocolIEs__item__value,
        __SgNBModificationRequest_protocolIEs__item_,
        _SgNBModificationRequest_protocolIEs,
        SgNBModificationRequest,
        SgNBModificationRequest_IEs,
        _SgNBModificationRequest_IEs_val_Value_0,
        _SgNBModificationRequest_IEs_val_Value_1,
        _SgNBModificationRequest_IEs_val_Value_2,
        _SgNBModificationRequest_IEs_val_Value_3,
        _SgNBModificationRequest_IEs_val_Value_4,
        _SgNBModificationRequest_IEs_val_Value_5,
        _SgNBModificationRequest_IEs_val_Value_6,
        _SgNBModificationRequest_IEs_val_Value_7,
        _SgNBModificationRequest_IEs_val_Value_8,
        _SgNBModificationRequest_IEs_val_Value_9,
        _SgNBModificationRequest_IEs_val_Value_10,
        _SgNBModificationRequest_IEs_val_Value_11,
        _SgNBModificationRequest_IEs_val_Value_12,
        _SgNBModificationRequest_IEs_val_Value_13,
        _SgNBModificationRequest_IEs_val_Value_14,
        _SgNBModificationRequest_IEs_val_Value_15,
        _SgNBModificationRequest_IEs_val_Value_16,
        _SgNBModificationRequest_IEs_val_Value_17,
        _SgNBModificationRequest_IEs_val_Value_18,
        _SgNBModificationRequest_IEs_val_Value_19,
        _SgNBModificationRequest_IEs_val_Value_20,
        _SgNBModificationRequest_IEs_val_Value_21,
        _SgNBModificationRequest_IEs_val_Value_22,
        _SgNBModificationRequest_IEs_val_Value_23,
        _SgNBModificationRequest_IEs_val_Value_24,
        _UE_ContextInformation_SgNBModReq_nRUE_SecurityCapabilities,
        _UE_ContextInformation_SgNBModReq_sgNB_SecurityKey,
        _UE_ContextInformation_SgNBModReq_sgNBUEAggregateMaximumBitRate,
        _UE_ContextInformation_SgNBModReq_e_RABs_ToBeAdded,
        _UE_ContextInformation_SgNBModReq_e_RABs_ToBeModified,
        _UE_ContextInformation_SgNBModReq_e_RABs_ToBeReleased,
        ____UE_ContextInformation_SgNBModReq_iE_Extensions__item__id_tab,
        _____UE_ContextInformation_SgNBModReq_iE_Extensions__item__id_tab_val_Extension_0,
        _____UE_ContextInformation_SgNBModReq_iE_Extensions__item__id_tab_val_Extension_1,
        _____UE_ContextInformation_SgNBModReq_iE_Extensions__item__id_tab_val_Extension_2,
        ___UE_ContextInformation_SgNBModReq_iE_Extensions__item__id,
        ___UE_ContextInformation_SgNBModReq_iE_Extensions__item__criticality,
        ___UE_ContextInformation_SgNBModReq_iE_Extensions__item__extensionValue,
        __UE_ContextInformation_SgNBModReq_iE_Extensions__item_,
        _UE_ContextInformation_SgNBModReq_iE_Extensions,
        UE_ContextInformation_SgNBModReq,
        UE_ContextInformationSgNBModReqExtIEs,
        _UE_ContextInformationSgNBModReqExtIEs_val_Extension_0,
        _UE_ContextInformationSgNBModReqExtIEs_val_Extension_1,
        _UE_ContextInformationSgNBModReqExtIEs_val_Extension_2,
        ___E_RABs_ToBeAdded_SgNBModReq_List__item__id_tab,
        ____E_RABs_ToBeAdded_SgNBModReq_List__item__id_tab_val_Value_0,
        __E_RABs_ToBeAdded_SgNBModReq_List__item__id,
        __E_RABs_ToBeAdded_SgNBModReq_List__item__criticality,
        __E_RABs_ToBeAdded_SgNBModReq_List__item__value,
        _E_RABs_ToBeAdded_SgNBModReq_List__item_,
        E_RABs_ToBeAdded_SgNBModReq_List,
        E_RABs_ToBeAdded_SgNBModReq_ItemIEs,
        _E_RABs_ToBeAdded_SgNBModReq_ItemIEs_val_Value_0,
        _E_RABs_ToBeAdded_SgNBModReq_Item_e_RAB_ID,
        _E_RABs_ToBeAdded_SgNBModReq_Item_drb_ID,
        _E_RABs_ToBeAdded_SgNBModReq_Item_en_DC_ResourceConfiguration,
        __E_RABs_ToBeAdded_SgNBModReq_Item_resource_configuration_sgNBPDCPpresent,
        __E_RABs_ToBeAdded_SgNBModReq_Item_resource_configuration_sgNBPDCPnotpresent,
        _E_RABs_ToBeAdded_SgNBModReq_Item_resource_configuration,
        ____E_RABs_ToBeAdded_SgNBModReq_Item_iE_Extensions__item__id_tab,
        ___E_RABs_ToBeAdded_SgNBModReq_Item_iE_Extensions__item__id,
        ____E_RABs_ToBeAdded_SgNBModReq_Item_iE_Extensions__item__criticality_tab,
        ___E_RABs_ToBeAdded_SgNBModReq_Item_iE_Extensions__item__criticality,
        ____E_RABs_ToBeAdded_SgNBModReq_Item_iE_Extensions__item__extensionValue_tab,
        ___E_RABs_ToBeAdded_SgNBModReq_Item_iE_Extensions__item__extensionValue,
        __E_RABs_ToBeAdded_SgNBModReq_Item_iE_Extensions__item_,
        _E_RABs_ToBeAdded_SgNBModReq_Item_iE_Extensions,
        E_RABs_ToBeAdded_SgNBModReq_Item,
        E_RABs_ToBeAdded_SgNBModReq_ItemExtIEs,
        _E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresent_full_E_RAB_Level_QoS_Parameters,
        _E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresent_max_MN_admit_E_RAB_Level_QoS_Parameters,
        _E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresent_dL_Forwarding,
        _E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresent_meNB_DL_GTP_TEIDatMCG,
        _E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresent_s1_UL_GTPtunnelEndpoint,
        ____E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab,
        _____E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_0,
        _____E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_1,
        _____E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_2,
        _____E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_3,
        _____E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_4,
        ___E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__id,
        ___E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__criticality,
        ___E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue,
        __E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item_,
        _E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions,
        E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresent,
        E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresentExtIEs,
        _E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresentExtIEs_val_Extension_0,
        _E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresentExtIEs_val_Extension_1,
        _E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresentExtIEs_val_Extension_2,
        _E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresentExtIEs_val_Extension_3,
        _E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPpresentExtIEs_val_Extension_4,
        _E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresent_requested_SCG_E_RAB_Level_QoS_Parameters,
        _E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresent_meNB_UL_GTP_TEIDatPDCP,
        _E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresent_secondary_meNB_UL_GTP_TEIDatPDCP,
        _E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresent_rlc_Mode,
        _E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresent_uL_Configuration,
        ____E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab,
        _____E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab_val_Extension_0,
        _____E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab_val_Extension_1,
        _____E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab_val_Extension_2,
        ___E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id,
        ___E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality,
        ___E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue,
        __E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item_,
        _E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions,
        E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresent,
        E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresentExtIEs,
        _E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresentExtIEs_val_Extension_0,
        _E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresentExtIEs_val_Extension_1,
        _E_RABs_ToBeAdded_SgNBModReq_Item_SgNBPDCPnotpresentExtIEs_val_Extension_2,
        ___E_RABs_ToBeModified_SgNBModReq_List__item__id_tab,
        ____E_RABs_ToBeModified_SgNBModReq_List__item__id_tab_val_Value_0,
        __E_RABs_ToBeModified_SgNBModReq_List__item__id,
        __E_RABs_ToBeModified_SgNBModReq_List__item__criticality,
        __E_RABs_ToBeModified_SgNBModReq_List__item__value,
        _E_RABs_ToBeModified_SgNBModReq_List__item_,
        E_RABs_ToBeModified_SgNBModReq_List,
        E_RABs_ToBeModified_SgNBModReq_ItemIEs,
        _E_RABs_ToBeModified_SgNBModReq_ItemIEs_val_Value_0,
        _E_RABs_ToBeModified_SgNBModReq_Item_e_RAB_ID,
        _E_RABs_ToBeModified_SgNBModReq_Item_en_DC_ResourceConfiguration,
        __E_RABs_ToBeModified_SgNBModReq_Item_resource_configuration_sgNBPDCPpresent,
        __E_RABs_ToBeModified_SgNBModReq_Item_resource_configuration_sgNBPDCPnotpresent,
        _E_RABs_ToBeModified_SgNBModReq_Item_resource_configuration,
        ____E_RABs_ToBeModified_SgNBModReq_Item_iE_Extensions__item__id_tab,
        ___E_RABs_ToBeModified_SgNBModReq_Item_iE_Extensions__item__id,
        ____E_RABs_ToBeModified_SgNBModReq_Item_iE_Extensions__item__criticality_tab,
        ___E_RABs_ToBeModified_SgNBModReq_Item_iE_Extensions__item__criticality,
        ____E_RABs_ToBeModified_SgNBModReq_Item_iE_Extensions__item__extensionValue_tab,
        ___E_RABs_ToBeModified_SgNBModReq_Item_iE_Extensions__item__extensionValue,
        __E_RABs_ToBeModified_SgNBModReq_Item_iE_Extensions__item_,
        _E_RABs_ToBeModified_SgNBModReq_Item_iE_Extensions,
        E_RABs_ToBeModified_SgNBModReq_Item,
        E_RABs_ToBeModified_SgNBModReq_ItemExtIEs,
        _E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPpresent_full_E_RAB_Level_QoS_Parameters,
        _E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPpresent_max_MN_admit_E_RAB_Level_QoS_Parameters,
        _E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPpresent_meNB_DL_GTP_TEIDatMCG,
        _E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPpresent_s1_UL_GTPtunnelEndpoint,
        ____E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab,
        _____E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_0,
        ___E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__id,
        ___E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__criticality,
        ___E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue,
        __E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item_,
        _E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions,
        E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPpresent,
        E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPpresentExtIEs,
        _E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPpresentExtIEs_val_Extension_0,
        _E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPnotpresent_requested_SCG_E_RAB_Level_QoS_Parameters,
        _E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPnotpresent_meNB_UL_GTP_TEIDatPDCP,
        _E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPnotpresent_uL_Configuration,
        ____E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab,
        _____E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab_val_Extension_0,
        _____E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab_val_Extension_1,
        _____E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab_val_Extension_2,
        ___E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id,
        ___E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality,
        ___E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue,
        __E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item_,
        _E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions,
        E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPnotpresent,
        E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPnotpresentExtIEs,
        _E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPnotpresentExtIEs_val_Extension_0,
        _E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPnotpresentExtIEs_val_Extension_1,
        _E_RABs_ToBeModified_SgNBModReq_Item_SgNBPDCPnotpresentExtIEs_val_Extension_2,
        ___E_RABs_ToBeReleased_SgNBModReq_List__item__id_tab,
        ____E_RABs_ToBeReleased_SgNBModReq_List__item__id_tab_val_Value_0,
        __E_RABs_ToBeReleased_SgNBModReq_List__item__id,
        __E_RABs_ToBeReleased_SgNBModReq_List__item__criticality,
        __E_RABs_ToBeReleased_SgNBModReq_List__item__value,
        _E_RABs_ToBeReleased_SgNBModReq_List__item_,
        E_RABs_ToBeReleased_SgNBModReq_List,
        E_RABs_ToBeReleased_SgNBModReq_ItemIEs,
        _E_RABs_ToBeReleased_SgNBModReq_ItemIEs_val_Value_0,
        _E_RABs_ToBeReleased_SgNBModReq_Item_e_RAB_ID,
        _E_RABs_ToBeReleased_SgNBModReq_Item_en_DC_ResourceConfiguration,
        __E_RABs_ToBeReleased_SgNBModReq_Item_resource_configuration_sgNBPDCPpresent,
        __E_RABs_ToBeReleased_SgNBModReq_Item_resource_configuration_sgNBPDCPnotpresent,
        _E_RABs_ToBeReleased_SgNBModReq_Item_resource_configuration,
        ____E_RABs_ToBeReleased_SgNBModReq_Item_iE_Extensions__item__id_tab,
        ___E_RABs_ToBeReleased_SgNBModReq_Item_iE_Extensions__item__id,
        ____E_RABs_ToBeReleased_SgNBModReq_Item_iE_Extensions__item__criticality_tab,
        ___E_RABs_ToBeReleased_SgNBModReq_Item_iE_Extensions__item__criticality,
        ____E_RABs_ToBeReleased_SgNBModReq_Item_iE_Extensions__item__extensionValue_tab,
        ___E_RABs_ToBeReleased_SgNBModReq_Item_iE_Extensions__item__extensionValue,
        __E_RABs_ToBeReleased_SgNBModReq_Item_iE_Extensions__item_,
        _E_RABs_ToBeReleased_SgNBModReq_Item_iE_Extensions,
        E_RABs_ToBeReleased_SgNBModReq_Item,
        E_RABs_ToBeReleased_SgNBModReq_ItemExtIEs,
        _E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPpresent_dL_GTPtunnelEndpoint,
        _E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPpresent_uL_GTPtunnelEndpoint,
        ____E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab,
        ___E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__id,
        ____E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__criticality_tab,
        ___E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__criticality,
        ____E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue_tab,
        ___E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue,
        __E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions__item_,
        _E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPpresent_iE_Extensions,
        E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPpresent,
        E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPpresentExtIEs,
        ____E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab,
        ___E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id,
        ____E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality_tab,
        ___E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality,
        ____E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue_tab,
        ___E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue,
        __E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions__item_,
        _E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPnotpresent_iE_Extensions,
        E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPnotpresent,
        E_RABs_ToBeReleased_SgNBModReq_Item_SgNBPDCPnotpresentExtIEs,
        ____SgNBModificationRequestAcknowledge_protocolIEs__item__id_tab,
        _____SgNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_0,
        _____SgNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_1,
        _____SgNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_2,
        _____SgNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_3,
        _____SgNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_4,
        _____SgNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_5,
        _____SgNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_6,
        _____SgNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_7,
        _____SgNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_8,
        _____SgNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_9,
        _____SgNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_10,
        _____SgNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_11,
        _____SgNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_12,
        _____SgNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_13,
        _____SgNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_14,
        _____SgNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_15,
        _____SgNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_16,
        _____SgNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_17,
        _____SgNBModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_18,
        ___SgNBModificationRequestAcknowledge_protocolIEs__item__id,
        ___SgNBModificationRequestAcknowledge_protocolIEs__item__criticality,
        ___SgNBModificationRequestAcknowledge_protocolIEs__item__value,
        __SgNBModificationRequestAcknowledge_protocolIEs__item_,
        _SgNBModificationRequestAcknowledge_protocolIEs,
        SgNBModificationRequestAcknowledge,
        SgNBModificationRequestAcknowledge_IEs,
        _SgNBModificationRequestAcknowledge_IEs_val_Value_0,
        _SgNBModificationRequestAcknowledge_IEs_val_Value_1,
        _SgNBModificationRequestAcknowledge_IEs_val_Value_2,
        _SgNBModificationRequestAcknowledge_IEs_val_Value_3,
        _SgNBModificationRequestAcknowledge_IEs_val_Value_4,
        _SgNBModificationRequestAcknowledge_IEs_val_Value_5,
        _SgNBModificationRequestAcknowledge_IEs_val_Value_6,
        _SgNBModificationRequestAcknowledge_IEs_val_Value_7,
        _SgNBModificationRequestAcknowledge_IEs_val_Value_8,
        _SgNBModificationRequestAcknowledge_IEs_val_Value_9,
        _SgNBModificationRequestAcknowledge_IEs_val_Value_10,
        _SgNBModificationRequestAcknowledge_IEs_val_Value_11,
        _SgNBModificationRequestAcknowledge_IEs_val_Value_12,
        _SgNBModificationRequestAcknowledge_IEs_val_Value_13,
        _SgNBModificationRequestAcknowledge_IEs_val_Value_14,
        _SgNBModificationRequestAcknowledge_IEs_val_Value_15,
        _SgNBModificationRequestAcknowledge_IEs_val_Value_16,
        _SgNBModificationRequestAcknowledge_IEs_val_Value_17,
        _SgNBModificationRequestAcknowledge_IEs_val_Value_18,
        ___E_RABs_Admitted_ToBeAdded_SgNBModAckList__item__id_tab,
        ____E_RABs_Admitted_ToBeAdded_SgNBModAckList__item__id_tab_val_Value_0,
        __E_RABs_Admitted_ToBeAdded_SgNBModAckList__item__id,
        __E_RABs_Admitted_ToBeAdded_SgNBModAckList__item__criticality,
        __E_RABs_Admitted_ToBeAdded_SgNBModAckList__item__value,
        _E_RABs_Admitted_ToBeAdded_SgNBModAckList__item_,
        E_RABs_Admitted_ToBeAdded_SgNBModAckList,
        E_RABs_Admitted_ToBeAdded_SgNBModAck_ItemIEs,
        _E_RABs_Admitted_ToBeAdded_SgNBModAck_ItemIEs_val_Value_0,
        _E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_e_RAB_ID,
        _E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_en_DC_ResourceConfiguration,
        __E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_resource_configuration_sgNBPDCPpresent,
        __E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_resource_configuration_sgNBPDCPnotpresent,
        _E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_resource_configuration,
        ____E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_iE_Extensions__item__id_tab,
        ___E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_iE_Extensions__item__id,
        ____E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_iE_Extensions__item__criticality_tab,
        ___E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_iE_Extensions__item__criticality,
        ____E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_iE_Extensions__item__extensionValue_tab,
        ___E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_iE_Extensions__item__extensionValue,
        __E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_iE_Extensions__item_,
        _E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_iE_Extensions,
        E_RABs_Admitted_ToBeAdded_SgNBModAck_Item,
        E_RABs_Admitted_ToBeAdded_SgNBModAck_ItemExtIEs,
        _E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent_s1_DL_GTPtunnelEndpoint,
        _E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent_sgNB_UL_GTP_TEIDatPDCP,
        _E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent_rlc_Mode,
        _E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent_dL_Forwarding_GTPtunnelEndpoint,
        _E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent_uL_Forwarding_GTPtunnelEndpoint,
        _E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent_mCG_E_RAB_Level_QoS_Parameters,
        _E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent_uL_Configuration,
        ____E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab,
        _____E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_0,
        _____E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_1,
        _____E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_2,
        _____E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_3,
        ___E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__id,
        ___E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__criticality,
        ___E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue,
        __E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item_,
        _E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions,
        E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresent,
        E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresentExtIEs,
        _E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresentExtIEs_val_Extension_0,
        _E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresentExtIEs_val_Extension_1,
        _E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresentExtIEs_val_Extension_2,
        _E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPpresentExtIEs_val_Extension_3,
        _E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPnotpresent_sgNB_DL_GTP_TEIDatSCG,
        _E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPnotpresent_secondary_sgNB_DL_GTP_TEIDatSCG,
        ____E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab,
        _____E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab_val_Extension_0,
        ___E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__id,
        ___E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality,
        ___E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue,
        __E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item_,
        _E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions,
        E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPnotpresent,
        E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPnotpresentExtIEs,
        _E_RABs_Admitted_ToBeAdded_SgNBModAck_Item_SgNBPDCPnotpresentExtIEs_val_Extension_0,
        ___E_RABs_Admitted_ToBeModified_SgNBModAckList__item__id_tab,
        ____E_RABs_Admitted_ToBeModified_SgNBModAckList__item__id_tab_val_Value_0,
        __E_RABs_Admitted_ToBeModified_SgNBModAckList__item__id,
        __E_RABs_Admitted_ToBeModified_SgNBModAckList__item__criticality,
        __E_RABs_Admitted_ToBeModified_SgNBModAckList__item__value,
        _E_RABs_Admitted_ToBeModified_SgNBModAckList__item_,
        E_RABs_Admitted_ToBeModified_SgNBModAckList,
        E_RABs_Admitted_ToBeModified_SgNBModAck_ItemIEs,
        _E_RABs_Admitted_ToBeModified_SgNBModAck_ItemIEs_val_Value_0,
        _E_RABs_Admitted_ToBeModified_SgNBModAck_Item_e_RAB_ID,
        _E_RABs_Admitted_ToBeModified_SgNBModAck_Item_en_DC_ResourceConfiguration,
        __E_RABs_Admitted_ToBeModified_SgNBModAck_Item_resource_configuration_sgNBPDCPpresent,
        __E_RABs_Admitted_ToBeModified_SgNBModAck_Item_resource_configuration_sgNBPDCPnotpresent,
        _E_RABs_Admitted_ToBeModified_SgNBModAck_Item_resource_configuration,
        ____E_RABs_Admitted_ToBeModified_SgNBModAck_Item_iE_Extensions__item__id_tab,
        ___E_RABs_Admitted_ToBeModified_SgNBModAck_Item_iE_Extensions__item__id,
        ____E_RABs_Admitted_ToBeModified_SgNBModAck_Item_iE_Extensions__item__criticality_tab,
        ___E_RABs_Admitted_ToBeModified_SgNBModAck_Item_iE_Extensions__item__criticality,
        ____E_RABs_Admitted_ToBeModified_SgNBModAck_Item_iE_Extensions__item__extensionValue_tab,
        ___E_RABs_Admitted_ToBeModified_SgNBModAck_Item_iE_Extensions__item__extensionValue,
        __E_RABs_Admitted_ToBeModified_SgNBModAck_Item_iE_Extensions__item_,
        _E_RABs_Admitted_ToBeModified_SgNBModAck_Item_iE_Extensions,
        E_RABs_Admitted_ToBeModified_SgNBModAck_Item,
        E_RABs_ToBeAdded_SgNBModAck_ItemExtIEs,
        _E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPpresent_s1_DL_GTPtunnelEndpoint,
        _E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPpresent_sgNB_UL_GTP_TEIDatPDCP,
        _E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPpresent_mCG_E_RAB_Level_QoS_Parameters,
        _E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPpresent_uL_Configuration,
        ____E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab,
        _____E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_0,
        _____E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_1,
        ___E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__id,
        ___E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__criticality,
        ___E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue,
        __E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item_,
        _E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions,
        E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPpresent,
        E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPpresentExtIEs,
        _E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPpresentExtIEs_val_Extension_0,
        _E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPpresentExtIEs_val_Extension_1,
        _E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPnotpresent_sgNB_DL_GTP_TEIDatSCG,
        ____E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab,
        _____E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab_val_Extension_0,
        _____E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab_val_Extension_1,
        ___E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__id,
        ___E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality,
        ___E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue,
        __E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item_,
        _E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions,
        E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPnotpresent,
        E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPnotpresentExtIEs,
        _E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPnotpresentExtIEs_val_Extension_0,
        _E_RABs_Admitted_ToBeModified_SgNBModAck_Item_SgNBPDCPnotpresentExtIEs_val_Extension_1,
        ___E_RABs_Admitted_ToBeReleased_SgNBModAckList__item__id_tab,
        ____E_RABs_Admitted_ToBeReleased_SgNBModAckList__item__id_tab_val_Value_0,
        __E_RABs_Admitted_ToBeReleased_SgNBModAckList__item__id,
        __E_RABs_Admitted_ToBeReleased_SgNBModAckList__item__criticality,
        __E_RABs_Admitted_ToBeReleased_SgNBModAckList__item__value,
        _E_RABs_Admitted_ToBeReleased_SgNBModAckList__item_,
        E_RABs_Admitted_ToBeReleased_SgNBModAckList,
        E_RABs_Admitted_ToBeReleased_SgNBModAck_ItemIEs,
        _E_RABs_Admitted_ToBeReleased_SgNBModAck_ItemIEs_val_Value_0,
        _E_RABs_Admitted_ToReleased_SgNBModAck_Item_e_RAB_ID,
        _E_RABs_Admitted_ToReleased_SgNBModAck_Item_en_DC_ResourceConfiguration,
        __E_RABs_Admitted_ToReleased_SgNBModAck_Item_resource_configuration_sgNBPDCPpresent,
        __E_RABs_Admitted_ToReleased_SgNBModAck_Item_resource_configuration_sgNBPDCPnotpresent,
        _E_RABs_Admitted_ToReleased_SgNBModAck_Item_resource_configuration,
        ____E_RABs_Admitted_ToReleased_SgNBModAck_Item_iE_Extensions__item__id_tab,
        ___E_RABs_Admitted_ToReleased_SgNBModAck_Item_iE_Extensions__item__id,
        ____E_RABs_Admitted_ToReleased_SgNBModAck_Item_iE_Extensions__item__criticality_tab,
        ___E_RABs_Admitted_ToReleased_SgNBModAck_Item_iE_Extensions__item__criticality,
        ____E_RABs_Admitted_ToReleased_SgNBModAck_Item_iE_Extensions__item__extensionValue_tab,
        ___E_RABs_Admitted_ToReleased_SgNBModAck_Item_iE_Extensions__item__extensionValue,
        __E_RABs_Admitted_ToReleased_SgNBModAck_Item_iE_Extensions__item_,
        _E_RABs_Admitted_ToReleased_SgNBModAck_Item_iE_Extensions,
        E_RABs_Admitted_ToReleased_SgNBModAck_Item,
        E_RABs_ToBeReleased_SgNBModAck_ItemExtIEs,
        ____E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab,
        ___E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__id,
        ____E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__criticality_tab,
        ___E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__criticality,
        ____E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue_tab,
        ___E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue,
        __E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions__item_,
        _E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPpresent_iE_Extensions,
        E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPpresent,
        E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPpresentExtIEs,
        ____E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab,
        ___E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__id,
        ____E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality_tab,
        ___E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality,
        ____E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue_tab,
        ___E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue,
        __E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions__item_,
        _E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPnotpresent_iE_Extensions,
        E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPnotpresent,
        E_RABs_Admitted_ToBeReleased_SgNBModAck_Item_SgNBPDCPnotpresentExtIEs,
        ____SgNBModificationRequestReject_protocolIEs__item__id_tab,
        _____SgNBModificationRequestReject_protocolIEs__item__id_tab_val_Value_0,
        _____SgNBModificationRequestReject_protocolIEs__item__id_tab_val_Value_1,
        _____SgNBModificationRequestReject_protocolIEs__item__id_tab_val_Value_2,
        _____SgNBModificationRequestReject_protocolIEs__item__id_tab_val_Value_3,
        _____SgNBModificationRequestReject_protocolIEs__item__id_tab_val_Value_4,
        ___SgNBModificationRequestReject_protocolIEs__item__id,
        ___SgNBModificationRequestReject_protocolIEs__item__criticality,
        ___SgNBModificationRequestReject_protocolIEs__item__value,
        __SgNBModificationRequestReject_protocolIEs__item_,
        _SgNBModificationRequestReject_protocolIEs,
        SgNBModificationRequestReject,
        SgNBModificationRequestReject_IEs,
        _SgNBModificationRequestReject_IEs_val_Value_0,
        _SgNBModificationRequestReject_IEs_val_Value_1,
        _SgNBModificationRequestReject_IEs_val_Value_2,
        _SgNBModificationRequestReject_IEs_val_Value_3,
        _SgNBModificationRequestReject_IEs_val_Value_4,
        ____SgNBModificationRequired_protocolIEs__item__id_tab,
        _____SgNBModificationRequired_protocolIEs__item__id_tab_val_Value_0,
        _____SgNBModificationRequired_protocolIEs__item__id_tab_val_Value_1,
        _____SgNBModificationRequired_protocolIEs__item__id_tab_val_Value_2,
        _____SgNBModificationRequired_protocolIEs__item__id_tab_val_Value_3,
        _____SgNBModificationRequired_protocolIEs__item__id_tab_val_Value_4,
        _____SgNBModificationRequired_protocolIEs__item__id_tab_val_Value_5,
        _____SgNBModificationRequired_protocolIEs__item__id_tab_val_Value_6,
        _____SgNBModificationRequired_protocolIEs__item__id_tab_val_Value_7,
        _____SgNBModificationRequired_protocolIEs__item__id_tab_val_Value_8,
        _____SgNBModificationRequired_protocolIEs__item__id_tab_val_Value_9,
        _____SgNBModificationRequired_protocolIEs__item__id_tab_val_Value_10,
        _____SgNBModificationRequired_protocolIEs__item__id_tab_val_Value_11,
        _____SgNBModificationRequired_protocolIEs__item__id_tab_val_Value_12,
        _____SgNBModificationRequired_protocolIEs__item__id_tab_val_Value_13,
        _____SgNBModificationRequired_protocolIEs__item__id_tab_val_Value_14,
        ___SgNBModificationRequired_protocolIEs__item__id,
        ___SgNBModificationRequired_protocolIEs__item__criticality,
        ___SgNBModificationRequired_protocolIEs__item__value,
        __SgNBModificationRequired_protocolIEs__item_,
        _SgNBModificationRequired_protocolIEs,
        SgNBModificationRequired,
        SgNBModificationRequired_IEs,
        _SgNBModificationRequired_IEs_val_Value_0,
        _SgNBModificationRequired_IEs_val_Value_1,
        _SgNBModificationRequired_IEs_val_Value_2,
        _SgNBModificationRequired_IEs_val_Value_3,
        _SgNBModificationRequired_IEs_val_Value_4,
        _SgNBModificationRequired_IEs_val_Value_5,
        _SgNBModificationRequired_IEs_val_Value_6,
        _SgNBModificationRequired_IEs_val_Value_7,
        _SgNBModificationRequired_IEs_val_Value_8,
        _SgNBModificationRequired_IEs_val_Value_9,
        _SgNBModificationRequired_IEs_val_Value_10,
        _SgNBModificationRequired_IEs_val_Value_11,
        _SgNBModificationRequired_IEs_val_Value_12,
        _SgNBModificationRequired_IEs_val_Value_13,
        _SgNBModificationRequired_IEs_val_Value_14,
        ___E_RABs_ToBeReleased_SgNBModReqdList__item__id_tab,
        ____E_RABs_ToBeReleased_SgNBModReqdList__item__id_tab_val_Value_0,
        __E_RABs_ToBeReleased_SgNBModReqdList__item__id,
        __E_RABs_ToBeReleased_SgNBModReqdList__item__criticality,
        __E_RABs_ToBeReleased_SgNBModReqdList__item__value,
        _E_RABs_ToBeReleased_SgNBModReqdList__item_,
        E_RABs_ToBeReleased_SgNBModReqdList,
        E_RABs_ToBeReleased_SgNBModReqd_ItemIEs,
        _E_RABs_ToBeReleased_SgNBModReqd_ItemIEs_val_Value_0,
        _E_RABs_ToBeReleased_SgNBModReqd_Item_e_RAB_ID,
        _E_RABs_ToBeReleased_SgNBModReqd_Item_cause,
        ____E_RABs_ToBeReleased_SgNBModReqd_Item_iE_Extensions__item__id_tab,
        _____E_RABs_ToBeReleased_SgNBModReqd_Item_iE_Extensions__item__id_tab_val_Extension_0,
        ___E_RABs_ToBeReleased_SgNBModReqd_Item_iE_Extensions__item__id,
        ___E_RABs_ToBeReleased_SgNBModReqd_Item_iE_Extensions__item__criticality,
        ___E_RABs_ToBeReleased_SgNBModReqd_Item_iE_Extensions__item__extensionValue,
        __E_RABs_ToBeReleased_SgNBModReqd_Item_iE_Extensions__item_,
        _E_RABs_ToBeReleased_SgNBModReqd_Item_iE_Extensions,
        E_RABs_ToBeReleased_SgNBModReqd_Item,
        E_RABs_ToBeReleased_SgNBModReqd_ItemExtIEs,
        _E_RABs_ToBeReleased_SgNBModReqd_ItemExtIEs_val_Extension_0,
        ___E_RABs_ToBeModified_SgNBModReqdList__item__id_tab,
        ____E_RABs_ToBeModified_SgNBModReqdList__item__id_tab_val_Value_0,
        __E_RABs_ToBeModified_SgNBModReqdList__item__id,
        __E_RABs_ToBeModified_SgNBModReqdList__item__criticality,
        __E_RABs_ToBeModified_SgNBModReqdList__item__value,
        _E_RABs_ToBeModified_SgNBModReqdList__item_,
        E_RABs_ToBeModified_SgNBModReqdList,
        E_RABs_ToBeModified_SgNBModReqd_ItemIEs,
        _E_RABs_ToBeModified_SgNBModReqd_ItemIEs_val_Value_0,
        _E_RABs_ToBeModified_SgNBModReqd_Item_e_RAB_ID,
        _E_RABs_ToBeModified_SgNBModReqd_Item_en_DC_ResourceConfiguration,
        __E_RABs_ToBeModified_SgNBModReqd_Item_resource_configuration_sgNBPDCPpresent,
        __E_RABs_ToBeModified_SgNBModReqd_Item_resource_configuration_sgNBPDCPnotpresent,
        _E_RABs_ToBeModified_SgNBModReqd_Item_resource_configuration,
        ____E_RABs_ToBeModified_SgNBModReqd_Item_iE_Extensions__item__id_tab,
        ___E_RABs_ToBeModified_SgNBModReqd_Item_iE_Extensions__item__id,
        ____E_RABs_ToBeModified_SgNBModReqd_Item_iE_Extensions__item__criticality_tab,
        ___E_RABs_ToBeModified_SgNBModReqd_Item_iE_Extensions__item__criticality,
        ____E_RABs_ToBeModified_SgNBModReqd_Item_iE_Extensions__item__extensionValue_tab,
        ___E_RABs_ToBeModified_SgNBModReqd_Item_iE_Extensions__item__extensionValue,
        __E_RABs_ToBeModified_SgNBModReqd_Item_iE_Extensions__item_,
        _E_RABs_ToBeModified_SgNBModReqd_Item_iE_Extensions,
        E_RABs_ToBeModified_SgNBModReqd_Item,
        E_RABs_ToBeModified_SgNBModReqd_ItemExtIEs,
        _E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresent_requested_MCG_E_RAB_Level_QoS_Parameters,
        _E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresent_uL_Configuration,
        _E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresent_sgNB_UL_GTP_TEIDatPDCP,
        _E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresent_s1_DL_GTP_TEIDatSgNB,
        ____E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab,
        _____E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_0,
        _____E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_1,
        _____E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_2,
        ___E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresent_iE_Extensions__item__id,
        ___E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresent_iE_Extensions__item__criticality,
        ___E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue,
        __E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresent_iE_Extensions__item_,
        _E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresent_iE_Extensions,
        E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresent,
        E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresentExtIEs,
        _E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresentExtIEs_val_Extension_0,
        _E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresentExtIEs_val_Extension_1,
        _E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPpresentExtIEs_val_Extension_2,
        _E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPnotpresent_sgNB_DL_GTP_TEIDatSCG,
        _E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPnotpresent_secondary_sgNB_DL_GTP_TEIDatSCG,
        ____E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab,
        _____E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab_val_Extension_0,
        _____E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab_val_Extension_1,
        ___E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPnotpresent_iE_Extensions__item__id,
        ___E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality,
        ___E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue,
        __E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPnotpresent_iE_Extensions__item_,
        _E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPnotpresent_iE_Extensions,
        E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPnotpresent,
        E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPnotpresentExtIEs,
        _E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPnotpresentExtIEs_val_Extension_0,
        _E_RABs_ToBeModified_SgNBModReqd_Item_SgNBPDCPnotpresentExtIEs_val_Extension_1,
        ____SgNBModificationConfirm_protocolIEs__item__id_tab,
        _____SgNBModificationConfirm_protocolIEs__item__id_tab_val_Value_0,
        _____SgNBModificationConfirm_protocolIEs__item__id_tab_val_Value_1,
        _____SgNBModificationConfirm_protocolIEs__item__id_tab_val_Value_2,
        _____SgNBModificationConfirm_protocolIEs__item__id_tab_val_Value_3,
        _____SgNBModificationConfirm_protocolIEs__item__id_tab_val_Value_4,
        _____SgNBModificationConfirm_protocolIEs__item__id_tab_val_Value_5,
        _____SgNBModificationConfirm_protocolIEs__item__id_tab_val_Value_6,
        ___SgNBModificationConfirm_protocolIEs__item__id,
        ___SgNBModificationConfirm_protocolIEs__item__criticality,
        ___SgNBModificationConfirm_protocolIEs__item__value,
        __SgNBModificationConfirm_protocolIEs__item_,
        _SgNBModificationConfirm_protocolIEs,
        SgNBModificationConfirm,
        SgNBModificationConfirm_IEs,
        _SgNBModificationConfirm_IEs_val_Value_0,
        _SgNBModificationConfirm_IEs_val_Value_1,
        _SgNBModificationConfirm_IEs_val_Value_2,
        _SgNBModificationConfirm_IEs_val_Value_3,
        _SgNBModificationConfirm_IEs_val_Value_4,
        _SgNBModificationConfirm_IEs_val_Value_5,
        _SgNBModificationConfirm_IEs_val_Value_6,
        ___E_RABs_AdmittedToBeModified_SgNBModConfList__item__id_tab,
        ____E_RABs_AdmittedToBeModified_SgNBModConfList__item__id_tab_val_Value_0,
        __E_RABs_AdmittedToBeModified_SgNBModConfList__item__id,
        __E_RABs_AdmittedToBeModified_SgNBModConfList__item__criticality,
        __E_RABs_AdmittedToBeModified_SgNBModConfList__item__value,
        _E_RABs_AdmittedToBeModified_SgNBModConfList__item_,
        E_RABs_AdmittedToBeModified_SgNBModConfList,
        E_RABs_AdmittedToBeModified_SgNBModConf_ItemIEs,
        _E_RABs_AdmittedToBeModified_SgNBModConf_ItemIEs_val_Value_0,
        _E_RABs_AdmittedToBeModified_SgNBModConf_Item_e_RAB_ID,
        _E_RABs_AdmittedToBeModified_SgNBModConf_Item_en_DC_ResourceConfiguration,
        __E_RABs_AdmittedToBeModified_SgNBModConf_Item_resource_configuration_sgNBPDCPpresent,
        __E_RABs_AdmittedToBeModified_SgNBModConf_Item_resource_configuration_sgNBPDCPnotpresent,
        _E_RABs_AdmittedToBeModified_SgNBModConf_Item_resource_configuration,
        ____E_RABs_AdmittedToBeModified_SgNBModConf_Item_iE_Extensions__item__id_tab,
        ___E_RABs_AdmittedToBeModified_SgNBModConf_Item_iE_Extensions__item__id,
        ____E_RABs_AdmittedToBeModified_SgNBModConf_Item_iE_Extensions__item__criticality_tab,
        ___E_RABs_AdmittedToBeModified_SgNBModConf_Item_iE_Extensions__item__criticality,
        ____E_RABs_AdmittedToBeModified_SgNBModConf_Item_iE_Extensions__item__extensionValue_tab,
        ___E_RABs_AdmittedToBeModified_SgNBModConf_Item_iE_Extensions__item__extensionValue,
        __E_RABs_AdmittedToBeModified_SgNBModConf_Item_iE_Extensions__item_,
        _E_RABs_AdmittedToBeModified_SgNBModConf_Item_iE_Extensions,
        E_RABs_AdmittedToBeModified_SgNBModConf_Item,
        E_RABs_AdmittedToBeModified_SgNBModConf_ItemExtIEs,
        ____E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab,
        ___E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPpresent_iE_Extensions__item__id,
        ____E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPpresent_iE_Extensions__item__criticality_tab,
        ___E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPpresent_iE_Extensions__item__criticality,
        ____E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue_tab,
        ___E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue,
        __E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPpresent_iE_Extensions__item_,
        _E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPpresent_iE_Extensions,
        E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPpresent,
        E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPpresentExtIEs,
        _E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPnotpresent_secondary_meNB_UL_GTP_TEIDatPDCP,
        ____E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab,
        _____E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab_val_Extension_0,
        _____E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab_val_Extension_1,
        ___E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__id,
        ___E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality,
        ___E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue,
        __E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPnotpresent_iE_Extensions__item_,
        _E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPnotpresent_iE_Extensions,
        E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPnotpresent,
        E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPnotpresentExtIEs,
        _E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPnotpresentExtIEs_val_Extension_0,
        _E_RABs_AdmittedToBeModified_SgNBModConf_Item_SgNBPDCPnotpresentExtIEs_val_Extension_1,
        ____SgNBModificationRefuse_protocolIEs__item__id_tab,
        _____SgNBModificationRefuse_protocolIEs__item__id_tab_val_Value_0,
        _____SgNBModificationRefuse_protocolIEs__item__id_tab_val_Value_1,
        _____SgNBModificationRefuse_protocolIEs__item__id_tab_val_Value_2,
        _____SgNBModificationRefuse_protocolIEs__item__id_tab_val_Value_3,
        _____SgNBModificationRefuse_protocolIEs__item__id_tab_val_Value_4,
        _____SgNBModificationRefuse_protocolIEs__item__id_tab_val_Value_5,
        ___SgNBModificationRefuse_protocolIEs__item__id,
        ___SgNBModificationRefuse_protocolIEs__item__criticality,
        ___SgNBModificationRefuse_protocolIEs__item__value,
        __SgNBModificationRefuse_protocolIEs__item_,
        _SgNBModificationRefuse_protocolIEs,
        SgNBModificationRefuse,
        SgNBModificationRefuse_IEs,
        _SgNBModificationRefuse_IEs_val_Value_0,
        _SgNBModificationRefuse_IEs_val_Value_1,
        _SgNBModificationRefuse_IEs_val_Value_2,
        _SgNBModificationRefuse_IEs_val_Value_3,
        _SgNBModificationRefuse_IEs_val_Value_4,
        _SgNBModificationRefuse_IEs_val_Value_5,
        ____SgNBReleaseRequest_protocolIEs__item__id_tab,
        _____SgNBReleaseRequest_protocolIEs__item__id_tab_val_Value_0,
        _____SgNBReleaseRequest_protocolIEs__item__id_tab_val_Value_1,
        _____SgNBReleaseRequest_protocolIEs__item__id_tab_val_Value_2,
        _____SgNBReleaseRequest_protocolIEs__item__id_tab_val_Value_3,
        _____SgNBReleaseRequest_protocolIEs__item__id_tab_val_Value_4,
        _____SgNBReleaseRequest_protocolIEs__item__id_tab_val_Value_5,
        _____SgNBReleaseRequest_protocolIEs__item__id_tab_val_Value_6,
        _____SgNBReleaseRequest_protocolIEs__item__id_tab_val_Value_7,
        ___SgNBReleaseRequest_protocolIEs__item__id,
        ___SgNBReleaseRequest_protocolIEs__item__criticality,
        ___SgNBReleaseRequest_protocolIEs__item__value,
        __SgNBReleaseRequest_protocolIEs__item_,
        _SgNBReleaseRequest_protocolIEs,
        SgNBReleaseRequest,
        SgNBReleaseRequest_IEs,
        _SgNBReleaseRequest_IEs_val_Value_0,
        _SgNBReleaseRequest_IEs_val_Value_1,
        _SgNBReleaseRequest_IEs_val_Value_2,
        _SgNBReleaseRequest_IEs_val_Value_3,
        _SgNBReleaseRequest_IEs_val_Value_4,
        _SgNBReleaseRequest_IEs_val_Value_5,
        _SgNBReleaseRequest_IEs_val_Value_6,
        _SgNBReleaseRequest_IEs_val_Value_7,
        ___E_RABs_ToBeReleased_SgNBRelReqList__item__id_tab,
        ____E_RABs_ToBeReleased_SgNBRelReqList__item__id_tab_val_Value_0,
        __E_RABs_ToBeReleased_SgNBRelReqList__item__id,
        __E_RABs_ToBeReleased_SgNBRelReqList__item__criticality,
        __E_RABs_ToBeReleased_SgNBRelReqList__item__value,
        _E_RABs_ToBeReleased_SgNBRelReqList__item_,
        E_RABs_ToBeReleased_SgNBRelReqList,
        E_RABs_ToBeReleased_SgNBRelReq_ItemIEs,
        _E_RABs_ToBeReleased_SgNBRelReq_ItemIEs_val_Value_0,
        _E_RABs_ToBeReleased_SgNBRelReq_Item_e_RAB_ID,
        _E_RABs_ToBeReleased_SgNBRelReq_Item_en_DC_ResourceConfiguration,
        __E_RABs_ToBeReleased_SgNBRelReq_Item_resource_configuration_sgNBPDCPpresent,
        __E_RABs_ToBeReleased_SgNBRelReq_Item_resource_configuration_sgNBPDCPnotpresent,
        _E_RABs_ToBeReleased_SgNBRelReq_Item_resource_configuration,
        ____E_RABs_ToBeReleased_SgNBRelReq_Item_iE_Extensions__item__id_tab,
        ___E_RABs_ToBeReleased_SgNBRelReq_Item_iE_Extensions__item__id,
        ____E_RABs_ToBeReleased_SgNBRelReq_Item_iE_Extensions__item__criticality_tab,
        ___E_RABs_ToBeReleased_SgNBRelReq_Item_iE_Extensions__item__criticality,
        ____E_RABs_ToBeReleased_SgNBRelReq_Item_iE_Extensions__item__extensionValue_tab,
        ___E_RABs_ToBeReleased_SgNBRelReq_Item_iE_Extensions__item__extensionValue,
        __E_RABs_ToBeReleased_SgNBRelReq_Item_iE_Extensions__item_,
        _E_RABs_ToBeReleased_SgNBRelReq_Item_iE_Extensions,
        E_RABs_ToBeReleased_SgNBRelReq_Item,
        E_RABs_ToBeReleased_SgNBRelReq_ItemExtIEs,
        _E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPpresent_uL_GTPtunnelEndpoint,
        _E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPpresent_dL_GTPtunnelEndpoint,
        ____E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab,
        ___E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPpresent_iE_Extensions__item__id,
        ____E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPpresent_iE_Extensions__item__criticality_tab,
        ___E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPpresent_iE_Extensions__item__criticality,
        ____E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue_tab,
        ___E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue,
        __E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPpresent_iE_Extensions__item_,
        _E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPpresent_iE_Extensions,
        E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPpresent,
        E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPpresentExtIEs,
        ____E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab,
        ___E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__id,
        ____E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality_tab,
        ___E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality,
        ____E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue_tab,
        ___E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue,
        __E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPnotpresent_iE_Extensions__item_,
        _E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPnotpresent_iE_Extensions,
        E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPnotpresent,
        E_RABs_ToBeReleased_SgNBRelReq_Item_SgNBPDCPnotpresentExtIEs,
        ____SgNBReleaseRequestAcknowledge_protocolIEs__item__id_tab,
        _____SgNBReleaseRequestAcknowledge_protocolIEs__item__id_tab_val_Value_0,
        _____SgNBReleaseRequestAcknowledge_protocolIEs__item__id_tab_val_Value_1,
        _____SgNBReleaseRequestAcknowledge_protocolIEs__item__id_tab_val_Value_2,
        _____SgNBReleaseRequestAcknowledge_protocolIEs__item__id_tab_val_Value_3,
        _____SgNBReleaseRequestAcknowledge_protocolIEs__item__id_tab_val_Value_4,
        _____SgNBReleaseRequestAcknowledge_protocolIEs__item__id_tab_val_Value_5,
        ___SgNBReleaseRequestAcknowledge_protocolIEs__item__id,
        ___SgNBReleaseRequestAcknowledge_protocolIEs__item__criticality,
        ___SgNBReleaseRequestAcknowledge_protocolIEs__item__value,
        __SgNBReleaseRequestAcknowledge_protocolIEs__item_,
        _SgNBReleaseRequestAcknowledge_protocolIEs,
        SgNBReleaseRequestAcknowledge,
        SgNBReleaseRequestAcknowledge_IEs,
        _SgNBReleaseRequestAcknowledge_IEs_val_Value_0,
        _SgNBReleaseRequestAcknowledge_IEs_val_Value_1,
        _SgNBReleaseRequestAcknowledge_IEs_val_Value_2,
        _SgNBReleaseRequestAcknowledge_IEs_val_Value_3,
        _SgNBReleaseRequestAcknowledge_IEs_val_Value_4,
        _SgNBReleaseRequestAcknowledge_IEs_val_Value_5,
        ___E_RABs_Admitted_ToBeReleased_SgNBRelReqAckList__item__id_tab,
        ____E_RABs_Admitted_ToBeReleased_SgNBRelReqAckList__item__id_tab_val_Value_0,
        __E_RABs_Admitted_ToBeReleased_SgNBRelReqAckList__item__id,
        __E_RABs_Admitted_ToBeReleased_SgNBRelReqAckList__item__criticality,
        __E_RABs_Admitted_ToBeReleased_SgNBRelReqAckList__item__value,
        _E_RABs_Admitted_ToBeReleased_SgNBRelReqAckList__item_,
        E_RABs_Admitted_ToBeReleased_SgNBRelReqAckList,
        E_RABs_Admitted_ToBeReleased_SgNBRelReqAck_ItemIEs,
        _E_RABs_Admitted_ToBeReleased_SgNBRelReqAck_ItemIEs_val_Value_0,
        _E_RABs_Admitted_ToBeReleased_SgNBRelReqAck_Item_e_RAB_ID,
        _E_RABs_Admitted_ToBeReleased_SgNBRelReqAck_Item_rlc_Mode_transferred,
        ____E_RABs_Admitted_ToBeReleased_SgNBRelReqAck_Item_iE_Extensions__item__id_tab,
        ___E_RABs_Admitted_ToBeReleased_SgNBRelReqAck_Item_iE_Extensions__item__id,
        ____E_RABs_Admitted_ToBeReleased_SgNBRelReqAck_Item_iE_Extensions__item__criticality_tab,
        ___E_RABs_Admitted_ToBeReleased_SgNBRelReqAck_Item_iE_Extensions__item__criticality,
        ____E_RABs_Admitted_ToBeReleased_SgNBRelReqAck_Item_iE_Extensions__item__extensionValue_tab,
        ___E_RABs_Admitted_ToBeReleased_SgNBRelReqAck_Item_iE_Extensions__item__extensionValue,
        __E_RABs_Admitted_ToBeReleased_SgNBRelReqAck_Item_iE_Extensions__item_,
        _E_RABs_Admitted_ToBeReleased_SgNBRelReqAck_Item_iE_Extensions,
        E_RABs_Admitted_ToBeReleased_SgNBRelReqAck_Item,
        E_RABs_Admitted_ToBeReleased_SgNBRelReqAck_ItemExtIEs,
        ____SgNBReleaseRequestReject_protocolIEs__item__id_tab,
        _____SgNBReleaseRequestReject_protocolIEs__item__id_tab_val_Value_0,
        _____SgNBReleaseRequestReject_protocolIEs__item__id_tab_val_Value_1,
        _____SgNBReleaseRequestReject_protocolIEs__item__id_tab_val_Value_2,
        _____SgNBReleaseRequestReject_protocolIEs__item__id_tab_val_Value_3,
        _____SgNBReleaseRequestReject_protocolIEs__item__id_tab_val_Value_4,
        ___SgNBReleaseRequestReject_protocolIEs__item__id,
        ___SgNBReleaseRequestReject_protocolIEs__item__criticality,
        ___SgNBReleaseRequestReject_protocolIEs__item__value,
        __SgNBReleaseRequestReject_protocolIEs__item_,
        _SgNBReleaseRequestReject_protocolIEs,
        SgNBReleaseRequestReject,
        SgNBReleaseRequestReject_IEs,
        _SgNBReleaseRequestReject_IEs_val_Value_0,
        _SgNBReleaseRequestReject_IEs_val_Value_1,
        _SgNBReleaseRequestReject_IEs_val_Value_2,
        _SgNBReleaseRequestReject_IEs_val_Value_3,
        _SgNBReleaseRequestReject_IEs_val_Value_4,
        ____SgNBReleaseRequired_protocolIEs__item__id_tab,
        _____SgNBReleaseRequired_protocolIEs__item__id_tab_val_Value_0,
        _____SgNBReleaseRequired_protocolIEs__item__id_tab_val_Value_1,
        _____SgNBReleaseRequired_protocolIEs__item__id_tab_val_Value_2,
        _____SgNBReleaseRequired_protocolIEs__item__id_tab_val_Value_3,
        _____SgNBReleaseRequired_protocolIEs__item__id_tab_val_Value_4,
        _____SgNBReleaseRequired_protocolIEs__item__id_tab_val_Value_5,
        _____SgNBReleaseRequired_protocolIEs__item__id_tab_val_Value_6,
        ___SgNBReleaseRequired_protocolIEs__item__id,
        ___SgNBReleaseRequired_protocolIEs__item__criticality,
        ___SgNBReleaseRequired_protocolIEs__item__value,
        __SgNBReleaseRequired_protocolIEs__item_,
        _SgNBReleaseRequired_protocolIEs,
        SgNBReleaseRequired,
        SgNBReleaseRequired_IEs,
        _SgNBReleaseRequired_IEs_val_Value_0,
        _SgNBReleaseRequired_IEs_val_Value_1,
        _SgNBReleaseRequired_IEs_val_Value_2,
        _SgNBReleaseRequired_IEs_val_Value_3,
        _SgNBReleaseRequired_IEs_val_Value_4,
        _SgNBReleaseRequired_IEs_val_Value_5,
        _SgNBReleaseRequired_IEs_val_Value_6,
        ___E_RABs_ToBeReleased_SgNBRelReqdList__item__id_tab,
        ____E_RABs_ToBeReleased_SgNBRelReqdList__item__id_tab_val_Value_0,
        __E_RABs_ToBeReleased_SgNBRelReqdList__item__id,
        __E_RABs_ToBeReleased_SgNBRelReqdList__item__criticality,
        __E_RABs_ToBeReleased_SgNBRelReqdList__item__value,
        _E_RABs_ToBeReleased_SgNBRelReqdList__item_,
        E_RABs_ToBeReleased_SgNBRelReqdList,
        E_RABs_ToBeReleased_SgNBRelReqd_ItemIEs,
        _E_RABs_ToBeReleased_SgNBRelReqd_ItemIEs_val_Value_0,
        _E_RABs_ToBeReleased_SgNBRelReqd_Item_e_RAB_ID,
        _E_RABs_ToBeReleased_SgNBRelReqd_Item_rlc_Mode_transferred,
        ____E_RABs_ToBeReleased_SgNBRelReqd_Item_iE_Extensions__item__id_tab,
        ___E_RABs_ToBeReleased_SgNBRelReqd_Item_iE_Extensions__item__id,
        ____E_RABs_ToBeReleased_SgNBRelReqd_Item_iE_Extensions__item__criticality_tab,
        ___E_RABs_ToBeReleased_SgNBRelReqd_Item_iE_Extensions__item__criticality,
        ____E_RABs_ToBeReleased_SgNBRelReqd_Item_iE_Extensions__item__extensionValue_tab,
        ___E_RABs_ToBeReleased_SgNBRelReqd_Item_iE_Extensions__item__extensionValue,
        __E_RABs_ToBeReleased_SgNBRelReqd_Item_iE_Extensions__item_,
        _E_RABs_ToBeReleased_SgNBRelReqd_Item_iE_Extensions,
        E_RABs_ToBeReleased_SgNBRelReqd_Item,
        E_RABs_ToBeReleased_SgNBRelReqd_ItemExtIEs,
        ____SgNBReleaseConfirm_protocolIEs__item__id_tab,
        _____SgNBReleaseConfirm_protocolIEs__item__id_tab_val_Value_0,
        _____SgNBReleaseConfirm_protocolIEs__item__id_tab_val_Value_1,
        _____SgNBReleaseConfirm_protocolIEs__item__id_tab_val_Value_2,
        _____SgNBReleaseConfirm_protocolIEs__item__id_tab_val_Value_3,
        _____SgNBReleaseConfirm_protocolIEs__item__id_tab_val_Value_4,
        ___SgNBReleaseConfirm_protocolIEs__item__id,
        ___SgNBReleaseConfirm_protocolIEs__item__criticality,
        ___SgNBReleaseConfirm_protocolIEs__item__value,
        __SgNBReleaseConfirm_protocolIEs__item_,
        _SgNBReleaseConfirm_protocolIEs,
        SgNBReleaseConfirm,
        SgNBReleaseConfirm_IEs,
        _SgNBReleaseConfirm_IEs_val_Value_0,
        _SgNBReleaseConfirm_IEs_val_Value_1,
        _SgNBReleaseConfirm_IEs_val_Value_2,
        _SgNBReleaseConfirm_IEs_val_Value_3,
        _SgNBReleaseConfirm_IEs_val_Value_4,
        ___E_RABs_ToBeReleased_SgNBRelConfList__item__id_tab,
        ____E_RABs_ToBeReleased_SgNBRelConfList__item__id_tab_val_Value_0,
        __E_RABs_ToBeReleased_SgNBRelConfList__item__id,
        __E_RABs_ToBeReleased_SgNBRelConfList__item__criticality,
        __E_RABs_ToBeReleased_SgNBRelConfList__item__value,
        _E_RABs_ToBeReleased_SgNBRelConfList__item_,
        E_RABs_ToBeReleased_SgNBRelConfList,
        E_RABs_ToBeReleased_SgNBRelConf_ItemIEs,
        _E_RABs_ToBeReleased_SgNBRelConf_ItemIEs_val_Value_0,
        _E_RABs_ToBeReleased_SgNBRelConf_Item_e_RAB_ID,
        _E_RABs_ToBeReleased_SgNBRelConf_Item_en_DC_ResourceConfiguration,
        __E_RABs_ToBeReleased_SgNBRelConf_Item_resource_configuration_sgNBPDCPpresent,
        __E_RABs_ToBeReleased_SgNBRelConf_Item_resource_configuration_sgNBPDCPnotpresent,
        _E_RABs_ToBeReleased_SgNBRelConf_Item_resource_configuration,
        ____E_RABs_ToBeReleased_SgNBRelConf_Item_iE_Extensions__item__id_tab,
        ___E_RABs_ToBeReleased_SgNBRelConf_Item_iE_Extensions__item__id,
        ____E_RABs_ToBeReleased_SgNBRelConf_Item_iE_Extensions__item__criticality_tab,
        ___E_RABs_ToBeReleased_SgNBRelConf_Item_iE_Extensions__item__criticality,
        ____E_RABs_ToBeReleased_SgNBRelConf_Item_iE_Extensions__item__extensionValue_tab,
        ___E_RABs_ToBeReleased_SgNBRelConf_Item_iE_Extensions__item__extensionValue,
        __E_RABs_ToBeReleased_SgNBRelConf_Item_iE_Extensions__item_,
        _E_RABs_ToBeReleased_SgNBRelConf_Item_iE_Extensions,
        E_RABs_ToBeReleased_SgNBRelConf_Item,
        E_RABs_ToBeReleased_SgNBRelConf_ItemExtIEs,
        _E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPpresent_uL_GTPtunnelEndpoint,
        _E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPpresent_dL_GTPtunnelEndpoint,
        ____E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab,
        ___E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPpresent_iE_Extensions__item__id,
        ____E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPpresent_iE_Extensions__item__criticality_tab,
        ___E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPpresent_iE_Extensions__item__criticality,
        ____E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue_tab,
        ___E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue,
        __E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPpresent_iE_Extensions__item_,
        _E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPpresent_iE_Extensions,
        E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPpresent,
        E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPpresentExtIEs,
        ____E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab,
        ___E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__id,
        ____E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality_tab,
        ___E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality,
        ____E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue_tab,
        ___E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue,
        __E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPnotpresent_iE_Extensions__item_,
        _E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPnotpresent_iE_Extensions,
        E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPnotpresent,
        E_RABs_ToBeReleased_SgNBRelConf_Item_SgNBPDCPnotpresentExtIEs,
        ____SgNBCounterCheckRequest_protocolIEs__item__id_tab,
        _____SgNBCounterCheckRequest_protocolIEs__item__id_tab_val_Value_0,
        _____SgNBCounterCheckRequest_protocolIEs__item__id_tab_val_Value_1,
        _____SgNBCounterCheckRequest_protocolIEs__item__id_tab_val_Value_2,
        _____SgNBCounterCheckRequest_protocolIEs__item__id_tab_val_Value_3,
        ___SgNBCounterCheckRequest_protocolIEs__item__id,
        ___SgNBCounterCheckRequest_protocolIEs__item__criticality,
        ___SgNBCounterCheckRequest_protocolIEs__item__value,
        __SgNBCounterCheckRequest_protocolIEs__item_,
        _SgNBCounterCheckRequest_protocolIEs,
        SgNBCounterCheckRequest,
        SgNBCounterCheckRequest_IEs,
        _SgNBCounterCheckRequest_IEs_val_Value_0,
        _SgNBCounterCheckRequest_IEs_val_Value_1,
        _SgNBCounterCheckRequest_IEs_val_Value_2,
        _SgNBCounterCheckRequest_IEs_val_Value_3,
        ___E_RABs_SubjectToSgNBCounterCheck_List__item__id_tab,
        ____E_RABs_SubjectToSgNBCounterCheck_List__item__id_tab_val_Value_0,
        __E_RABs_SubjectToSgNBCounterCheck_List__item__id,
        __E_RABs_SubjectToSgNBCounterCheck_List__item__criticality,
        __E_RABs_SubjectToSgNBCounterCheck_List__item__value,
        _E_RABs_SubjectToSgNBCounterCheck_List__item_,
        E_RABs_SubjectToSgNBCounterCheck_List,
        E_RABs_SubjectToSgNBCounterCheck_ItemIEs,
        _E_RABs_SubjectToSgNBCounterCheck_ItemIEs_val_Value_0,
        _E_RABs_SubjectToSgNBCounterCheck_Item_e_RAB_ID,
        _E_RABs_SubjectToSgNBCounterCheck_Item_uL_Count,
        _E_RABs_SubjectToSgNBCounterCheck_Item_dL_Count,
        ____E_RABs_SubjectToSgNBCounterCheck_Item_iE_Extensions__item__id_tab,
        ___E_RABs_SubjectToSgNBCounterCheck_Item_iE_Extensions__item__id,
        ____E_RABs_SubjectToSgNBCounterCheck_Item_iE_Extensions__item__criticality_tab,
        ___E_RABs_SubjectToSgNBCounterCheck_Item_iE_Extensions__item__criticality,
        ____E_RABs_SubjectToSgNBCounterCheck_Item_iE_Extensions__item__extensionValue_tab,
        ___E_RABs_SubjectToSgNBCounterCheck_Item_iE_Extensions__item__extensionValue,
        __E_RABs_SubjectToSgNBCounterCheck_Item_iE_Extensions__item_,
        _E_RABs_SubjectToSgNBCounterCheck_Item_iE_Extensions,
        E_RABs_SubjectToSgNBCounterCheck_Item,
        E_RABs_SubjectToSgNBCounterCheck_ItemExtIEs,
        ____SgNBChangeRequired_protocolIEs__item__id_tab,
        _____SgNBChangeRequired_protocolIEs__item__id_tab_val_Value_0,
        _____SgNBChangeRequired_protocolIEs__item__id_tab_val_Value_1,
        _____SgNBChangeRequired_protocolIEs__item__id_tab_val_Value_2,
        _____SgNBChangeRequired_protocolIEs__item__id_tab_val_Value_3,
        _____SgNBChangeRequired_protocolIEs__item__id_tab_val_Value_4,
        _____SgNBChangeRequired_protocolIEs__item__id_tab_val_Value_5,
        _____SgNBChangeRequired_protocolIEs__item__id_tab_val_Value_6,
        _____SgNBChangeRequired_protocolIEs__item__id_tab_val_Value_7,
        ___SgNBChangeRequired_protocolIEs__item__id,
        ___SgNBChangeRequired_protocolIEs__item__criticality,
        ___SgNBChangeRequired_protocolIEs__item__value,
        __SgNBChangeRequired_protocolIEs__item_,
        _SgNBChangeRequired_protocolIEs,
        SgNBChangeRequired,
        SgNBChangeRequired_IEs,
        _SgNBChangeRequired_IEs_val_Value_0,
        _SgNBChangeRequired_IEs_val_Value_1,
        _SgNBChangeRequired_IEs_val_Value_2,
        _SgNBChangeRequired_IEs_val_Value_3,
        _SgNBChangeRequired_IEs_val_Value_4,
        _SgNBChangeRequired_IEs_val_Value_5,
        _SgNBChangeRequired_IEs_val_Value_6,
        _SgNBChangeRequired_IEs_val_Value_7,
        ____AccessAndMobilityIndication_protocolIEs__item__id_tab,
        _____AccessAndMobilityIndication_protocolIEs__item__id_tab_val_Value_0,
        ___AccessAndMobilityIndication_protocolIEs__item__id,
        ___AccessAndMobilityIndication_protocolIEs__item__criticality,
        ___AccessAndMobilityIndication_protocolIEs__item__value,
        __AccessAndMobilityIndication_protocolIEs__item_,
        _AccessAndMobilityIndication_protocolIEs,
        AccessAndMobilityIndication,
        AccessAndMobilityIndication_IEs,
        _AccessAndMobilityIndication_IEs_val_Value_0,
        ____SgNBChangeConfirm_protocolIEs__item__id_tab,
        _____SgNBChangeConfirm_protocolIEs__item__id_tab_val_Value_0,
        _____SgNBChangeConfirm_protocolIEs__item__id_tab_val_Value_1,
        _____SgNBChangeConfirm_protocolIEs__item__id_tab_val_Value_2,
        _____SgNBChangeConfirm_protocolIEs__item__id_tab_val_Value_3,
        _____SgNBChangeConfirm_protocolIEs__item__id_tab_val_Value_4,
        _____SgNBChangeConfirm_protocolIEs__item__id_tab_val_Value_5,
        _____SgNBChangeConfirm_protocolIEs__item__id_tab_val_Value_6,
        ___SgNBChangeConfirm_protocolIEs__item__id,
        ___SgNBChangeConfirm_protocolIEs__item__criticality,
        ___SgNBChangeConfirm_protocolIEs__item__value,
        __SgNBChangeConfirm_protocolIEs__item_,
        _SgNBChangeConfirm_protocolIEs,
        SgNBChangeConfirm,
        SgNBChangeConfirm_IEs,
        _SgNBChangeConfirm_IEs_val_Value_0,
        _SgNBChangeConfirm_IEs_val_Value_1,
        _SgNBChangeConfirm_IEs_val_Value_2,
        _SgNBChangeConfirm_IEs_val_Value_3,
        _SgNBChangeConfirm_IEs_val_Value_4,
        _SgNBChangeConfirm_IEs_val_Value_5,
        _SgNBChangeConfirm_IEs_val_Value_6,
        ___E_RABs_ToBeReleased_SgNBChaConfList__item__id_tab,
        ____E_RABs_ToBeReleased_SgNBChaConfList__item__id_tab_val_Value_0,
        __E_RABs_ToBeReleased_SgNBChaConfList__item__id,
        __E_RABs_ToBeReleased_SgNBChaConfList__item__criticality,
        __E_RABs_ToBeReleased_SgNBChaConfList__item__value,
        _E_RABs_ToBeReleased_SgNBChaConfList__item_,
        E_RABs_ToBeReleased_SgNBChaConfList,
        E_RABs_ToBeReleased_SgNBChaConf_ItemIEs,
        _E_RABs_ToBeReleased_SgNBChaConf_ItemIEs_val_Value_0,
        _E_RABs_ToBeReleased_SgNBChaConf_Item_e_RAB_ID,
        _E_RABs_ToBeReleased_SgNBChaConf_Item_en_DC_ResourceConfiguration,
        __E_RABs_ToBeReleased_SgNBChaConf_Item_resource_configuration_sgNBPDCPpresent,
        __E_RABs_ToBeReleased_SgNBChaConf_Item_resource_configuration_sgNBPDCPnotpresent,
        _E_RABs_ToBeReleased_SgNBChaConf_Item_resource_configuration,
        ____E_RABs_ToBeReleased_SgNBChaConf_Item_iE_Extensions__item__id_tab,
        ___E_RABs_ToBeReleased_SgNBChaConf_Item_iE_Extensions__item__id,
        ____E_RABs_ToBeReleased_SgNBChaConf_Item_iE_Extensions__item__criticality_tab,
        ___E_RABs_ToBeReleased_SgNBChaConf_Item_iE_Extensions__item__criticality,
        ____E_RABs_ToBeReleased_SgNBChaConf_Item_iE_Extensions__item__extensionValue_tab,
        ___E_RABs_ToBeReleased_SgNBChaConf_Item_iE_Extensions__item__extensionValue,
        __E_RABs_ToBeReleased_SgNBChaConf_Item_iE_Extensions__item_,
        _E_RABs_ToBeReleased_SgNBChaConf_Item_iE_Extensions,
        E_RABs_ToBeReleased_SgNBChaConf_Item,
        E_RABs_ToBeReleased_SgNBChaConf_ItemExtIEs,
        _E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPpresent_uL_GTPtunnelEndpoint,
        _E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPpresent_dL_GTPtunnelEndpoint,
        ____E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab,
        _____E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPpresent_iE_Extensions__item__id_tab_val_Extension_0,
        ___E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPpresent_iE_Extensions__item__id,
        ___E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPpresent_iE_Extensions__item__criticality,
        ___E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPpresent_iE_Extensions__item__extensionValue,
        __E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPpresent_iE_Extensions__item_,
        _E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPpresent_iE_Extensions,
        E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPpresent,
        E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPpresentExtIEs,
        _E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPpresentExtIEs_val_Extension_0,
        ____E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__id_tab,
        ___E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__id,
        ____E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality_tab,
        ___E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__criticality,
        ____E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue_tab,
        ___E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPnotpresent_iE_Extensions__item__extensionValue,
        __E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPnotpresent_iE_Extensions__item_,
        _E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPnotpresent_iE_Extensions,
        E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPnotpresent,
        E_RABs_ToBeReleased_SgNBChaConf_Item_SgNBPDCPnotpresentExtIEs,
        ____RRCTransfer_protocolIEs__item__id_tab,
        _____RRCTransfer_protocolIEs__item__id_tab_val_Value_0,
        _____RRCTransfer_protocolIEs__item__id_tab_val_Value_1,
        _____RRCTransfer_protocolIEs__item__id_tab_val_Value_2,
        _____RRCTransfer_protocolIEs__item__id_tab_val_Value_3,
        _____RRCTransfer_protocolIEs__item__id_tab_val_Value_4,
        _____RRCTransfer_protocolIEs__item__id_tab_val_Value_5,
        _____RRCTransfer_protocolIEs__item__id_tab_val_Value_6,
        ___RRCTransfer_protocolIEs__item__id,
        ___RRCTransfer_protocolIEs__item__criticality,
        ___RRCTransfer_protocolIEs__item__value,
        __RRCTransfer_protocolIEs__item_,
        _RRCTransfer_protocolIEs,
        RRCTransfer,
        RRCTransfer_IEs,
        _RRCTransfer_IEs_val_Value_0,
        _RRCTransfer_IEs_val_Value_1,
        _RRCTransfer_IEs_val_Value_2,
        _RRCTransfer_IEs_val_Value_3,
        _RRCTransfer_IEs_val_Value_4,
        _RRCTransfer_IEs_val_Value_5,
        _RRCTransfer_IEs_val_Value_6,
        ____SgNBChangeRefuse_protocolIEs__item__id_tab,
        _____SgNBChangeRefuse_protocolIEs__item__id_tab_val_Value_0,
        _____SgNBChangeRefuse_protocolIEs__item__id_tab_val_Value_1,
        _____SgNBChangeRefuse_protocolIEs__item__id_tab_val_Value_2,
        _____SgNBChangeRefuse_protocolIEs__item__id_tab_val_Value_3,
        _____SgNBChangeRefuse_protocolIEs__item__id_tab_val_Value_4,
        ___SgNBChangeRefuse_protocolIEs__item__id,
        ___SgNBChangeRefuse_protocolIEs__item__criticality,
        ___SgNBChangeRefuse_protocolIEs__item__value,
        __SgNBChangeRefuse_protocolIEs__item_,
        _SgNBChangeRefuse_protocolIEs,
        SgNBChangeRefuse,
        SgNBChangeRefuse_IEs,
        _SgNBChangeRefuse_IEs_val_Value_0,
        _SgNBChangeRefuse_IEs_val_Value_1,
        _SgNBChangeRefuse_IEs_val_Value_2,
        _SgNBChangeRefuse_IEs_val_Value_3,
        _SgNBChangeRefuse_IEs_val_Value_4,
        ____ENDCX2SetupRequest_protocolIEs__item__id_tab,
        _____ENDCX2SetupRequest_protocolIEs__item__id_tab_val_Value_0,
        _____ENDCX2SetupRequest_protocolIEs__item__id_tab_val_Value_1,
        _____ENDCX2SetupRequest_protocolIEs__item__id_tab_val_Value_2,
        ___ENDCX2SetupRequest_protocolIEs__item__id,
        ___ENDCX2SetupRequest_protocolIEs__item__criticality,
        ___ENDCX2SetupRequest_protocolIEs__item__value,
        __ENDCX2SetupRequest_protocolIEs__item_,
        _ENDCX2SetupRequest_protocolIEs,
        ENDCX2SetupRequest,
        ENDCX2SetupRequest_IEs,
        _ENDCX2SetupRequest_IEs_val_Value_0,
        _ENDCX2SetupRequest_IEs_val_Value_1,
        _ENDCX2SetupRequest_IEs_val_Value_2,
        ____InitiatingNodeType_EndcX2Setup_init_eNB__item__id_tab,
        _____InitiatingNodeType_EndcX2Setup_init_eNB__item__id_tab_val_Value_0,
        _____InitiatingNodeType_EndcX2Setup_init_eNB__item__id_tab_val_Value_1,
        _____InitiatingNodeType_EndcX2Setup_init_eNB__item__id_tab_val_Value_2,
        _____InitiatingNodeType_EndcX2Setup_init_eNB__item__id_tab_val_Value_3,
        ___InitiatingNodeType_EndcX2Setup_init_eNB__item__id,
        ___InitiatingNodeType_EndcX2Setup_init_eNB__item__criticality,
        ___InitiatingNodeType_EndcX2Setup_init_eNB__item__value,
        __InitiatingNodeType_EndcX2Setup_init_eNB__item_,
        _InitiatingNodeType_EndcX2Setup_init_eNB,
        ____InitiatingNodeType_EndcX2Setup_init_en_gNB__item__id_tab,
        _____InitiatingNodeType_EndcX2Setup_init_en_gNB__item__id_tab_val_Value_0,
        _____InitiatingNodeType_EndcX2Setup_init_en_gNB__item__id_tab_val_Value_1,
        _____InitiatingNodeType_EndcX2Setup_init_en_gNB__item__id_tab_val_Value_2,
        ___InitiatingNodeType_EndcX2Setup_init_en_gNB__item__id,
        ___InitiatingNodeType_EndcX2Setup_init_en_gNB__item__criticality,
        ___InitiatingNodeType_EndcX2Setup_init_en_gNB__item__value,
        __InitiatingNodeType_EndcX2Setup_init_en_gNB__item_,
        _InitiatingNodeType_EndcX2Setup_init_en_gNB,
        InitiatingNodeType_EndcX2Setup,
        ENB_ENDCX2SetupReqIEs,
        _ENB_ENDCX2SetupReqIEs_val_Value_0,
        _ENB_ENDCX2SetupReqIEs_val_Value_1,
        _ENB_ENDCX2SetupReqIEs_val_Value_2,
        _ENB_ENDCX2SetupReqIEs_val_Value_3,
        __ServedEUTRAcellsENDCX2ManagementList__item__servedEUTRACellInfo,
        __ServedEUTRAcellsENDCX2ManagementList__item__nrNeighbourInfo,
        _____ServedEUTRAcellsENDCX2ManagementList__item__iE_Extensions__item__id_tab,
        ____ServedEUTRAcellsENDCX2ManagementList__item__iE_Extensions__item__id,
        _____ServedEUTRAcellsENDCX2ManagementList__item__iE_Extensions__item__criticality_tab,
        ____ServedEUTRAcellsENDCX2ManagementList__item__iE_Extensions__item__criticality,
        _____ServedEUTRAcellsENDCX2ManagementList__item__iE_Extensions__item__extensionValue_tab,
        ____ServedEUTRAcellsENDCX2ManagementList__item__iE_Extensions__item__extensionValue,
        ___ServedEUTRAcellsENDCX2ManagementList__item__iE_Extensions__item_,
        __ServedEUTRAcellsENDCX2ManagementList__item__iE_Extensions,
        _ServedEUTRAcellsENDCX2ManagementList__item_,
        ServedEUTRAcellsENDCX2ManagementList,
        ServedEUTRAcellsENDCX2Management_ExtIEs,
        En_gNB_ENDCX2SetupReqIEs,
        _En_gNB_ENDCX2SetupReqIEs_val_Value_0,
        _En_gNB_ENDCX2SetupReqIEs_val_Value_1,
        _En_gNB_ENDCX2SetupReqIEs_val_Value_2,
        __ServedNRcellsENDCX2ManagementList__item__servedNRCellInfo,
        __ServedNRcellsENDCX2ManagementList__item__nRNeighbourInfo,
        _____ServedNRcellsENDCX2ManagementList__item__iE_Extensions__item__id_tab,
        ______ServedNRcellsENDCX2ManagementList__item__iE_Extensions__item__id_tab_val_Extension_0,
        ____ServedNRcellsENDCX2ManagementList__item__iE_Extensions__item__id,
        ____ServedNRcellsENDCX2ManagementList__item__iE_Extensions__item__criticality,
        ____ServedNRcellsENDCX2ManagementList__item__iE_Extensions__item__extensionValue,
        ___ServedNRcellsENDCX2ManagementList__item__iE_Extensions__item_,
        __ServedNRcellsENDCX2ManagementList__item__iE_Extensions,
        _ServedNRcellsENDCX2ManagementList__item_,
        ServedNRcellsENDCX2ManagementList,
        En_gNBServedCells_ExtIEs,
        _En_gNBServedCells_ExtIEs_val_Extension_0,
        _ServedNRCell_Information_nrpCI,
        _ServedNRCell_Information_nrCellID,
        _ServedNRCell_Information_fiveGS_TAC,
        _ServedNRCell_Information_configured_TAC,
        _ServedNRCell_Information_broadcastPLMNs,
        __ServedNRCell_Information_nrModeInfo_fdd,
        __ServedNRCell_Information_nrModeInfo_tdd,
        _ServedNRCell_Information_nrModeInfo,
        _ServedNRCell_Information_measurementTimingConfiguration,
        ____ServedNRCell_Information_iE_Extensions__item__id_tab,
        _____ServedNRCell_Information_iE_Extensions__item__id_tab_val_Extension_0,
        _____ServedNRCell_Information_iE_Extensions__item__id_tab_val_Extension_1,
        _____ServedNRCell_Information_iE_Extensions__item__id_tab_val_Extension_2,
        _____ServedNRCell_Information_iE_Extensions__item__id_tab_val_Extension_3,
        _____ServedNRCell_Information_iE_Extensions__item__id_tab_val_Extension_4,
        _____ServedNRCell_Information_iE_Extensions__item__id_tab_val_Extension_5,
        _____ServedNRCell_Information_iE_Extensions__item__id_tab_val_Extension_6,
        ___ServedNRCell_Information_iE_Extensions__item__id,
        ___ServedNRCell_Information_iE_Extensions__item__criticality,
        ___ServedNRCell_Information_iE_Extensions__item__extensionValue,
        __ServedNRCell_Information_iE_Extensions__item_,
        _ServedNRCell_Information_iE_Extensions,
        ServedNRCell_Information,
        ServedNRCell_Information_ExtIEs,
        _ServedNRCell_Information_ExtIEs_val_Extension_0,
        _ServedNRCell_Information_ExtIEs_val_Extension_1,
        _ServedNRCell_Information_ExtIEs_val_Extension_2,
        _ServedNRCell_Information_ExtIEs_val_Extension_3,
        _ServedNRCell_Information_ExtIEs_val_Extension_4,
        _ServedNRCell_Information_ExtIEs_val_Extension_5,
        _ServedNRCell_Information_ExtIEs_val_Extension_6,
        _FDD_InfoServedNRCell_Information_ul_NRFreqInfo,
        _FDD_InfoServedNRCell_Information_dl_NRFreqInfo,
        _FDD_InfoServedNRCell_Information_ul_NR_TxBW,
        _FDD_InfoServedNRCell_Information_dl_NR_TxBW,
        ____FDD_InfoServedNRCell_Information_iE_Extensions__item__id_tab,
        _____FDD_InfoServedNRCell_Information_iE_Extensions__item__id_tab_val_Extension_0,
        _____FDD_InfoServedNRCell_Information_iE_Extensions__item__id_tab_val_Extension_1,
        ___FDD_InfoServedNRCell_Information_iE_Extensions__item__id,
        ___FDD_InfoServedNRCell_Information_iE_Extensions__item__criticality,
        ___FDD_InfoServedNRCell_Information_iE_Extensions__item__extensionValue,
        __FDD_InfoServedNRCell_Information_iE_Extensions__item_,
        _FDD_InfoServedNRCell_Information_iE_Extensions,
        FDD_InfoServedNRCell_Information,
        FDD_InfoServedNRCell_Information_ExtIEs,
        _FDD_InfoServedNRCell_Information_ExtIEs_val_Extension_0,
        _FDD_InfoServedNRCell_Information_ExtIEs_val_Extension_1,
        _TDD_InfoServedNRCell_Information_nRFreqInfo,
        _TDD_InfoServedNRCell_Information_nR_TxBW,
        ____TDD_InfoServedNRCell_Information_iE_Extensions__item__id_tab,
        _____TDD_InfoServedNRCell_Information_iE_Extensions__item__id_tab_val_Extension_0,
        _____TDD_InfoServedNRCell_Information_iE_Extensions__item__id_tab_val_Extension_1,
        _____TDD_InfoServedNRCell_Information_iE_Extensions__item__id_tab_val_Extension_2,
        ___TDD_InfoServedNRCell_Information_iE_Extensions__item__id,
        ___TDD_InfoServedNRCell_Information_iE_Extensions__item__criticality,
        ___TDD_InfoServedNRCell_Information_iE_Extensions__item__extensionValue,
        __TDD_InfoServedNRCell_Information_iE_Extensions__item_,
        _TDD_InfoServedNRCell_Information_iE_Extensions,
        TDD_InfoServedNRCell_Information,
        TDD_InfoServedNRCell_Information_ExtIEs,
        _TDD_InfoServedNRCell_Information_ExtIEs_val_Extension_0,
        _TDD_InfoServedNRCell_Information_ExtIEs_val_Extension_1,
        _TDD_InfoServedNRCell_Information_ExtIEs_val_Extension_2,
        _CellandCapacityAssistInfo_maximumCellListSize,
        _CellandCapacityAssistInfo_cellAssistanceInformation,
        ____CellandCapacityAssistInfo_iE_Extensions__item__id_tab,
        ___CellandCapacityAssistInfo_iE_Extensions__item__id,
        ____CellandCapacityAssistInfo_iE_Extensions__item__criticality_tab,
        ___CellandCapacityAssistInfo_iE_Extensions__item__criticality,
        ____CellandCapacityAssistInfo_iE_Extensions__item__extensionValue_tab,
        ___CellandCapacityAssistInfo_iE_Extensions__item__extensionValue,
        __CellandCapacityAssistInfo_iE_Extensions__item_,
        _CellandCapacityAssistInfo_iE_Extensions,
        CellandCapacityAssistInfo,
        CellandCapacityAssistInfo_ExtIEs,
        _CellAssistanceInformation_limited_list,
        _CellAssistanceInformation_full_list,
        CellAssistanceInformation,
        __Limited_list__item__nrCellID,
        _____Limited_list__item__iE_Extensions__item__id_tab,
        ____Limited_list__item__iE_Extensions__item__id,
        _____Limited_list__item__iE_Extensions__item__criticality_tab,
        ____Limited_list__item__iE_Extensions__item__criticality,
        _____Limited_list__item__iE_Extensions__item__extensionValue_tab,
        ____Limited_list__item__iE_Extensions__item__extensionValue,
        ___Limited_list__item__iE_Extensions__item_,
        __Limited_list__item__iE_Extensions,
        _Limited_list__item_,
        Limited_list,
        Limited_list_ExtIEs,
        ____ENDCX2SetupResponse_protocolIEs__item__id_tab,
        _____ENDCX2SetupResponse_protocolIEs__item__id_tab_val_Value_0,
        _____ENDCX2SetupResponse_protocolIEs__item__id_tab_val_Value_1,
        _____ENDCX2SetupResponse_protocolIEs__item__id_tab_val_Value_2,
        ___ENDCX2SetupResponse_protocolIEs__item__id,
        ___ENDCX2SetupResponse_protocolIEs__item__criticality,
        ___ENDCX2SetupResponse_protocolIEs__item__value,
        __ENDCX2SetupResponse_protocolIEs__item_,
        _ENDCX2SetupResponse_protocolIEs,
        ENDCX2SetupResponse,
        ENDCX2SetupResponse_IEs,
        _ENDCX2SetupResponse_IEs_val_Value_0,
        _ENDCX2SetupResponse_IEs_val_Value_1,
        _ENDCX2SetupResponse_IEs_val_Value_2,
        ____RespondingNodeType_EndcX2Setup_respond_eNB__item__id_tab,
        _____RespondingNodeType_EndcX2Setup_respond_eNB__item__id_tab_val_Value_0,
        _____RespondingNodeType_EndcX2Setup_respond_eNB__item__id_tab_val_Value_1,
        _____RespondingNodeType_EndcX2Setup_respond_eNB__item__id_tab_val_Value_2,
        _____RespondingNodeType_EndcX2Setup_respond_eNB__item__id_tab_val_Value_3,
        ___RespondingNodeType_EndcX2Setup_respond_eNB__item__id,
        ___RespondingNodeType_EndcX2Setup_respond_eNB__item__criticality,
        ___RespondingNodeType_EndcX2Setup_respond_eNB__item__value,
        __RespondingNodeType_EndcX2Setup_respond_eNB__item_,
        _RespondingNodeType_EndcX2Setup_respond_eNB,
        ____RespondingNodeType_EndcX2Setup_respond_en_gNB__item__id_tab,
        _____RespondingNodeType_EndcX2Setup_respond_en_gNB__item__id_tab_val_Value_0,
        _____RespondingNodeType_EndcX2Setup_respond_en_gNB__item__id_tab_val_Value_1,
        _____RespondingNodeType_EndcX2Setup_respond_en_gNB__item__id_tab_val_Value_2,
        ___RespondingNodeType_EndcX2Setup_respond_en_gNB__item__id,
        ___RespondingNodeType_EndcX2Setup_respond_en_gNB__item__criticality,
        ___RespondingNodeType_EndcX2Setup_respond_en_gNB__item__value,
        __RespondingNodeType_EndcX2Setup_respond_en_gNB__item_,
        _RespondingNodeType_EndcX2Setup_respond_en_gNB,
        RespondingNodeType_EndcX2Setup,
        ENB_ENDCX2SetupReqAckIEs,
        _ENB_ENDCX2SetupReqAckIEs_val_Value_0,
        _ENB_ENDCX2SetupReqAckIEs_val_Value_1,
        _ENB_ENDCX2SetupReqAckIEs_val_Value_2,
        _ENB_ENDCX2SetupReqAckIEs_val_Value_3,
        En_gNB_ENDCX2SetupReqAckIEs,
        _En_gNB_ENDCX2SetupReqAckIEs_val_Value_0,
        _En_gNB_ENDCX2SetupReqAckIEs_val_Value_1,
        _En_gNB_ENDCX2SetupReqAckIEs_val_Value_2,
        ____ENDCX2SetupFailure_protocolIEs__item__id_tab,
        _____ENDCX2SetupFailure_protocolIEs__item__id_tab_val_Value_0,
        _____ENDCX2SetupFailure_protocolIEs__item__id_tab_val_Value_1,
        _____ENDCX2SetupFailure_protocolIEs__item__id_tab_val_Value_2,
        _____ENDCX2SetupFailure_protocolIEs__item__id_tab_val_Value_3,
        _____ENDCX2SetupFailure_protocolIEs__item__id_tab_val_Value_4,
        ___ENDCX2SetupFailure_protocolIEs__item__id,
        ___ENDCX2SetupFailure_protocolIEs__item__criticality,
        ___ENDCX2SetupFailure_protocolIEs__item__value,
        __ENDCX2SetupFailure_protocolIEs__item_,
        _ENDCX2SetupFailure_protocolIEs,
        ENDCX2SetupFailure,
        ENDCX2SetupFailure_IEs,
        _ENDCX2SetupFailure_IEs_val_Value_0,
        _ENDCX2SetupFailure_IEs_val_Value_1,
        _ENDCX2SetupFailure_IEs_val_Value_2,
        _ENDCX2SetupFailure_IEs_val_Value_3,
        _ENDCX2SetupFailure_IEs_val_Value_4,
        ____ENDCConfigurationUpdate_protocolIEs__item__id_tab,
        _____ENDCConfigurationUpdate_protocolIEs__item__id_tab_val_Value_0,
        _____ENDCConfigurationUpdate_protocolIEs__item__id_tab_val_Value_1,
        _____ENDCConfigurationUpdate_protocolIEs__item__id_tab_val_Value_2,
        _____ENDCConfigurationUpdate_protocolIEs__item__id_tab_val_Value_3,
        _____ENDCConfigurationUpdate_protocolIEs__item__id_tab_val_Value_4,
        _____ENDCConfigurationUpdate_protocolIEs__item__id_tab_val_Value_5,
        ___ENDCConfigurationUpdate_protocolIEs__item__id,
        ___ENDCConfigurationUpdate_protocolIEs__item__criticality,
        ___ENDCConfigurationUpdate_protocolIEs__item__value,
        __ENDCConfigurationUpdate_protocolIEs__item_,
        _ENDCConfigurationUpdate_protocolIEs,
        ENDCConfigurationUpdate,
        ENDCConfigurationUpdate_IEs,
        _ENDCConfigurationUpdate_IEs_val_Value_0,
        _ENDCConfigurationUpdate_IEs_val_Value_1,
        _ENDCConfigurationUpdate_IEs_val_Value_2,
        _ENDCConfigurationUpdate_IEs_val_Value_3,
        _ENDCConfigurationUpdate_IEs_val_Value_4,
        _ENDCConfigurationUpdate_IEs_val_Value_5,
        ____InitiatingNodeType_EndcConfigUpdate_init_eNB__item__id_tab,
        _____InitiatingNodeType_EndcConfigUpdate_init_eNB__item__id_tab_val_Value_0,
        _____InitiatingNodeType_EndcConfigUpdate_init_eNB__item__id_tab_val_Value_1,
        _____InitiatingNodeType_EndcConfigUpdate_init_eNB__item__id_tab_val_Value_2,
        _____InitiatingNodeType_EndcConfigUpdate_init_eNB__item__id_tab_val_Value_3,
        ___InitiatingNodeType_EndcConfigUpdate_init_eNB__item__id,
        ___InitiatingNodeType_EndcConfigUpdate_init_eNB__item__criticality,
        ___InitiatingNodeType_EndcConfigUpdate_init_eNB__item__value,
        __InitiatingNodeType_EndcConfigUpdate_init_eNB__item_,
        _InitiatingNodeType_EndcConfigUpdate_init_eNB,
        ____InitiatingNodeType_EndcConfigUpdate_init_en_gNB__item__id_tab,
        _____InitiatingNodeType_EndcConfigUpdate_init_en_gNB__item__id_tab_val_Value_0,
        _____InitiatingNodeType_EndcConfigUpdate_init_en_gNB__item__id_tab_val_Value_1,
        _____InitiatingNodeType_EndcConfigUpdate_init_en_gNB__item__id_tab_val_Value_2,
        ___InitiatingNodeType_EndcConfigUpdate_init_en_gNB__item__id,
        ___InitiatingNodeType_EndcConfigUpdate_init_en_gNB__item__criticality,
        ___InitiatingNodeType_EndcConfigUpdate_init_en_gNB__item__value,
        __InitiatingNodeType_EndcConfigUpdate_init_en_gNB__item_,
        _InitiatingNodeType_EndcConfigUpdate_init_en_gNB,
        InitiatingNodeType_EndcConfigUpdate,
        ENB_ENDCConfigUpdateIEs,
        _ENB_ENDCConfigUpdateIEs_val_Value_0,
        _ENB_ENDCConfigUpdateIEs_val_Value_1,
        _ENB_ENDCConfigUpdateIEs_val_Value_2,
        _ENB_ENDCConfigUpdateIEs_val_Value_3,
        __ServedEUTRAcellsToModifyListENDCConfUpd__item__old_ECGI,
        __ServedEUTRAcellsToModifyListENDCConfUpd__item__servedEUTRACellInfo,
        __ServedEUTRAcellsToModifyListENDCConfUpd__item__nrNeighbourInfo,
        _____ServedEUTRAcellsToModifyListENDCConfUpd__item__iE_Extensions__item__id_tab,
        ____ServedEUTRAcellsToModifyListENDCConfUpd__item__iE_Extensions__item__id,
        _____ServedEUTRAcellsToModifyListENDCConfUpd__item__iE_Extensions__item__criticality_tab,
        ____ServedEUTRAcellsToModifyListENDCConfUpd__item__iE_Extensions__item__criticality,
        _____ServedEUTRAcellsToModifyListENDCConfUpd__item__iE_Extensions__item__extensionValue_tab,
        ____ServedEUTRAcellsToModifyListENDCConfUpd__item__iE_Extensions__item__extensionValue,
        ___ServedEUTRAcellsToModifyListENDCConfUpd__item__iE_Extensions__item_,
        __ServedEUTRAcellsToModifyListENDCConfUpd__item__iE_Extensions,
        _ServedEUTRAcellsToModifyListENDCConfUpd__item_,
        ServedEUTRAcellsToModifyListENDCConfUpd,
        ServedEUTRAcellsToModifyListENDCConfUpd_ExtIEs,
        _ServedEUTRAcellsToDeleteListENDCConfUpd__item_,
        ServedEUTRAcellsToDeleteListENDCConfUpd,
        En_gNB_ENDCConfigUpdateIEs,
        _En_gNB_ENDCConfigUpdateIEs_val_Value_0,
        _En_gNB_ENDCConfigUpdateIEs_val_Value_1,
        _En_gNB_ENDCConfigUpdateIEs_val_Value_2,
        _ServedNRcellsToModifyENDCConfUpdList__item_,
        ServedNRcellsToModifyENDCConfUpdList,
        _ServedNRCellsToModify_Item_old_nrcgi,
        _ServedNRCellsToModify_Item_servedNRCellInformation,
        _ServedNRCellsToModify_Item_nrNeighbourInformation,
        _ServedNRCellsToModify_Item_nrDeactivationIndication,
        ____ServedNRCellsToModify_Item_iE_Extensions__item__id_tab,
        ___ServedNRCellsToModify_Item_iE_Extensions__item__id,
        ____ServedNRCellsToModify_Item_iE_Extensions__item__criticality_tab,
        ___ServedNRCellsToModify_Item_iE_Extensions__item__criticality,
        ____ServedNRCellsToModify_Item_iE_Extensions__item__extensionValue_tab,
        ___ServedNRCellsToModify_Item_iE_Extensions__item__extensionValue,
        __ServedNRCellsToModify_Item_iE_Extensions__item_,
        _ServedNRCellsToModify_Item_iE_Extensions,
        ServedNRCellsToModify_Item,
        ServedNRCellsToModify_Item_ExtIEs,
        _ServedNRcellsToDeleteENDCConfUpdList__item_,
        ServedNRcellsToDeleteENDCConfUpdList,
        ____ENDCConfigurationUpdateAcknowledge_protocolIEs__item__id_tab,
        _____ENDCConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_0,
        _____ENDCConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_1,
        _____ENDCConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_2,
        _____ENDCConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_3,
        _____ENDCConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_4,
        _____ENDCConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_5,
        ___ENDCConfigurationUpdateAcknowledge_protocolIEs__item__id,
        ___ENDCConfigurationUpdateAcknowledge_protocolIEs__item__criticality,
        ___ENDCConfigurationUpdateAcknowledge_protocolIEs__item__value,
        __ENDCConfigurationUpdateAcknowledge_protocolIEs__item_,
        _ENDCConfigurationUpdateAcknowledge_protocolIEs,
        ENDCConfigurationUpdateAcknowledge,
        ENDCConfigurationUpdateAcknowledge_IEs,
        _ENDCConfigurationUpdateAcknowledge_IEs_val_Value_0,
        _ENDCConfigurationUpdateAcknowledge_IEs_val_Value_1,
        _ENDCConfigurationUpdateAcknowledge_IEs_val_Value_2,
        _ENDCConfigurationUpdateAcknowledge_IEs_val_Value_3,
        _ENDCConfigurationUpdateAcknowledge_IEs_val_Value_4,
        _ENDCConfigurationUpdateAcknowledge_IEs_val_Value_5,
        ____RespondingNodeType_EndcConfigUpdate_respond_eNB__item__id_tab,
        ___RespondingNodeType_EndcConfigUpdate_respond_eNB__item__id,
        ____RespondingNodeType_EndcConfigUpdate_respond_eNB__item__criticality_tab,
        ___RespondingNodeType_EndcConfigUpdate_respond_eNB__item__criticality,
        ____RespondingNodeType_EndcConfigUpdate_respond_eNB__item__value_tab,
        ___RespondingNodeType_EndcConfigUpdate_respond_eNB__item__value,
        __RespondingNodeType_EndcConfigUpdate_respond_eNB__item_,
        _RespondingNodeType_EndcConfigUpdate_respond_eNB,
        ____RespondingNodeType_EndcConfigUpdate_respond_en_gNB__item__id_tab,
        _____RespondingNodeType_EndcConfigUpdate_respond_en_gNB__item__id_tab_val_Value_0,
        ___RespondingNodeType_EndcConfigUpdate_respond_en_gNB__item__id,
        ___RespondingNodeType_EndcConfigUpdate_respond_en_gNB__item__criticality,
        ___RespondingNodeType_EndcConfigUpdate_respond_en_gNB__item__value,
        __RespondingNodeType_EndcConfigUpdate_respond_en_gNB__item_,
        _RespondingNodeType_EndcConfigUpdate_respond_en_gNB,
        RespondingNodeType_EndcConfigUpdate,
        ENB_ENDCConfigUpdateAckIEs,
        En_gNB_ENDCConfigUpdateAckIEs,
        _En_gNB_ENDCConfigUpdateAckIEs_val_Value_0,
        ____ENDCConfigurationUpdateFailure_protocolIEs__item__id_tab,
        _____ENDCConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_0,
        _____ENDCConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_1,
        _____ENDCConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_2,
        _____ENDCConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_3,
        ___ENDCConfigurationUpdateFailure_protocolIEs__item__id,
        ___ENDCConfigurationUpdateFailure_protocolIEs__item__criticality,
        ___ENDCConfigurationUpdateFailure_protocolIEs__item__value,
        __ENDCConfigurationUpdateFailure_protocolIEs__item_,
        _ENDCConfigurationUpdateFailure_protocolIEs,
        ENDCConfigurationUpdateFailure,
        ENDCConfigurationUpdateFailure_IEs,
        _ENDCConfigurationUpdateFailure_IEs_val_Value_0,
        _ENDCConfigurationUpdateFailure_IEs_val_Value_1,
        _ENDCConfigurationUpdateFailure_IEs_val_Value_2,
        _ENDCConfigurationUpdateFailure_IEs_val_Value_3,
        ____ENDCCellActivationRequest_protocolIEs__item__id_tab,
        _____ENDCCellActivationRequest_protocolIEs__item__id_tab_val_Value_0,
        _____ENDCCellActivationRequest_protocolIEs__item__id_tab_val_Value_1,
        _____ENDCCellActivationRequest_protocolIEs__item__id_tab_val_Value_2,
        ___ENDCCellActivationRequest_protocolIEs__item__id,
        ___ENDCCellActivationRequest_protocolIEs__item__criticality,
        ___ENDCCellActivationRequest_protocolIEs__item__value,
        __ENDCCellActivationRequest_protocolIEs__item_,
        _ENDCCellActivationRequest_protocolIEs,
        ENDCCellActivationRequest,
        ENDCCellActivationRequest_IEs,
        _ENDCCellActivationRequest_IEs_val_Value_0,
        _ENDCCellActivationRequest_IEs_val_Value_1,
        _ENDCCellActivationRequest_IEs_val_Value_2,
        _ServedNRCellsToActivate__item_,
        ServedNRCellsToActivate,
        _ServedNRCellsToActivate_Item_nrCellID,
        ____ServedNRCellsToActivate_Item_iE_Extensions__item__id_tab,
        ___ServedNRCellsToActivate_Item_iE_Extensions__item__id,
        ____ServedNRCellsToActivate_Item_iE_Extensions__item__criticality_tab,
        ___ServedNRCellsToActivate_Item_iE_Extensions__item__criticality,
        ____ServedNRCellsToActivate_Item_iE_Extensions__item__extensionValue_tab,
        ___ServedNRCellsToActivate_Item_iE_Extensions__item__extensionValue,
        __ServedNRCellsToActivate_Item_iE_Extensions__item_,
        _ServedNRCellsToActivate_Item_iE_Extensions,
        ServedNRCellsToActivate_Item,
        ServedNRCellsToActivate_Item_ExtIEs,
        ____ENDCCellActivationResponse_protocolIEs__item__id_tab,
        _____ENDCCellActivationResponse_protocolIEs__item__id_tab_val_Value_0,
        _____ENDCCellActivationResponse_protocolIEs__item__id_tab_val_Value_1,
        _____ENDCCellActivationResponse_protocolIEs__item__id_tab_val_Value_2,
        _____ENDCCellActivationResponse_protocolIEs__item__id_tab_val_Value_3,
        ___ENDCCellActivationResponse_protocolIEs__item__id,
        ___ENDCCellActivationResponse_protocolIEs__item__criticality,
        ___ENDCCellActivationResponse_protocolIEs__item__value,
        __ENDCCellActivationResponse_protocolIEs__item_,
        _ENDCCellActivationResponse_protocolIEs,
        ENDCCellActivationResponse,
        ENDCCellActivationResponse_IEs,
        _ENDCCellActivationResponse_IEs_val_Value_0,
        _ENDCCellActivationResponse_IEs_val_Value_1,
        _ENDCCellActivationResponse_IEs_val_Value_2,
        _ENDCCellActivationResponse_IEs_val_Value_3,
        _ActivatedNRCellList__item_,
        ActivatedNRCellList,
        _ActivatedNRCellList_Item_nrCellID,
        ____ActivatedNRCellList_Item_iE_Extensions__item__id_tab,
        ___ActivatedNRCellList_Item_iE_Extensions__item__id,
        ____ActivatedNRCellList_Item_iE_Extensions__item__criticality_tab,
        ___ActivatedNRCellList_Item_iE_Extensions__item__criticality,
        ____ActivatedNRCellList_Item_iE_Extensions__item__extensionValue_tab,
        ___ActivatedNRCellList_Item_iE_Extensions__item__extensionValue,
        __ActivatedNRCellList_Item_iE_Extensions__item_,
        _ActivatedNRCellList_Item_iE_Extensions,
        ActivatedNRCellList_Item,
        ActivatedNRCellList_Item_ExtIEs,
        ____ENDCCellActivationFailure_protocolIEs__item__id_tab,
        _____ENDCCellActivationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____ENDCCellActivationFailure_protocolIEs__item__id_tab_val_Value_1,
        _____ENDCCellActivationFailure_protocolIEs__item__id_tab_val_Value_2,
        _____ENDCCellActivationFailure_protocolIEs__item__id_tab_val_Value_3,
        ___ENDCCellActivationFailure_protocolIEs__item__id,
        ___ENDCCellActivationFailure_protocolIEs__item__criticality,
        ___ENDCCellActivationFailure_protocolIEs__item__value,
        __ENDCCellActivationFailure_protocolIEs__item_,
        _ENDCCellActivationFailure_protocolIEs,
        ENDCCellActivationFailure,
        ENDCCellActivationFailure_IEs,
        _ENDCCellActivationFailure_IEs_val_Value_0,
        _ENDCCellActivationFailure_IEs_val_Value_1,
        _ENDCCellActivationFailure_IEs_val_Value_2,
        _ENDCCellActivationFailure_IEs_val_Value_3,
        ____ENDCResourceStatusRequest_protocolIEs__item__id_tab,
        _____ENDCResourceStatusRequest_protocolIEs__item__id_tab_val_Value_0,
        _____ENDCResourceStatusRequest_protocolIEs__item__id_tab_val_Value_1,
        _____ENDCResourceStatusRequest_protocolIEs__item__id_tab_val_Value_2,
        _____ENDCResourceStatusRequest_protocolIEs__item__id_tab_val_Value_3,
        _____ENDCResourceStatusRequest_protocolIEs__item__id_tab_val_Value_4,
        _____ENDCResourceStatusRequest_protocolIEs__item__id_tab_val_Value_5,
        _____ENDCResourceStatusRequest_protocolIEs__item__id_tab_val_Value_6,
        _____ENDCResourceStatusRequest_protocolIEs__item__id_tab_val_Value_7,
        ___ENDCResourceStatusRequest_protocolIEs__item__id,
        ___ENDCResourceStatusRequest_protocolIEs__item__criticality,
        ___ENDCResourceStatusRequest_protocolIEs__item__value,
        __ENDCResourceStatusRequest_protocolIEs__item_,
        _ENDCResourceStatusRequest_protocolIEs,
        ENDCResourceStatusRequest,
        ENDCResourceStatusRequest_IEs,
        _ENDCResourceStatusRequest_IEs_val_Value_0,
        _ENDCResourceStatusRequest_IEs_val_Value_1,
        _ENDCResourceStatusRequest_IEs_val_Value_2,
        _ENDCResourceStatusRequest_IEs_val_Value_3,
        _ENDCResourceStatusRequest_IEs_val_Value_4,
        _ENDCResourceStatusRequest_IEs_val_Value_5,
        _ENDCResourceStatusRequest_IEs_val_Value_6,
        _ENDCResourceStatusRequest_IEs_val_Value_7,
        ReportingPeriodicity_ENDC,
        ___CellToReport_NR_ENDC_List__item__id_tab,
        ____CellToReport_NR_ENDC_List__item__id_tab_val_Value_0,
        __CellToReport_NR_ENDC_List__item__id,
        __CellToReport_NR_ENDC_List__item__criticality,
        __CellToReport_NR_ENDC_List__item__value,
        _CellToReport_NR_ENDC_List__item_,
        CellToReport_NR_ENDC_List,
        CellToReport_NR_ENDC_ItemIEs,
        _CellToReport_NR_ENDC_ItemIEs_val_Value_0,
        _CellToReport_NR_ENDC_Item_nr_cell_ID,
        _CellToReport_NR_ENDC_Item_ssbToReport_List,
        ____CellToReport_NR_ENDC_Item_iE_Extensions__item__id_tab,
        ___CellToReport_NR_ENDC_Item_iE_Extensions__item__id,
        ____CellToReport_NR_ENDC_Item_iE_Extensions__item__criticality_tab,
        ___CellToReport_NR_ENDC_Item_iE_Extensions__item__criticality,
        ____CellToReport_NR_ENDC_Item_iE_Extensions__item__extensionValue_tab,
        ___CellToReport_NR_ENDC_Item_iE_Extensions__item__extensionValue,
        __CellToReport_NR_ENDC_Item_iE_Extensions__item_,
        _CellToReport_NR_ENDC_Item_iE_Extensions,
        CellToReport_NR_ENDC_Item,
        CellToReport_NR_ENDC_Item_ExtIEs,
        ___CellToReport_E_UTRA_ENDC_List__item__id_tab,
        ____CellToReport_E_UTRA_ENDC_List__item__id_tab_val_Value_0,
        __CellToReport_E_UTRA_ENDC_List__item__id,
        __CellToReport_E_UTRA_ENDC_List__item__criticality,
        __CellToReport_E_UTRA_ENDC_List__item__value,
        _CellToReport_E_UTRA_ENDC_List__item_,
        CellToReport_E_UTRA_ENDC_List,
        CellToReport_E_UTRA_ENDC_Item_IEs,
        _CellToReport_E_UTRA_ENDC_Item_IEs_val_Value_0,
        _CellToReport_E_UTRA_ENDC_Item_e_utra_cell_ID,
        ____CellToReport_E_UTRA_ENDC_Item_iE_Extensions__item__id_tab,
        ___CellToReport_E_UTRA_ENDC_Item_iE_Extensions__item__id,
        ____CellToReport_E_UTRA_ENDC_Item_iE_Extensions__item__criticality_tab,
        ___CellToReport_E_UTRA_ENDC_Item_iE_Extensions__item__criticality,
        ____CellToReport_E_UTRA_ENDC_Item_iE_Extensions__item__extensionValue_tab,
        ___CellToReport_E_UTRA_ENDC_Item_iE_Extensions__item__extensionValue,
        __CellToReport_E_UTRA_ENDC_Item_iE_Extensions__item_,
        _CellToReport_E_UTRA_ENDC_Item_iE_Extensions,
        CellToReport_E_UTRA_ENDC_Item,
        CellToReport_E_UTRA_ENDC_Item_ExtIEs,
        _SSBToReport_List__item_,
        SSBToReport_List,
        _SSBToReport_Item_ssbIndex,
        ____SSBToReport_Item_iE_Extensions__item__id_tab,
        ___SSBToReport_Item_iE_Extensions__item__id,
        ____SSBToReport_Item_iE_Extensions__item__criticality_tab,
        ___SSBToReport_Item_iE_Extensions__item__criticality,
        ____SSBToReport_Item_iE_Extensions__item__extensionValue_tab,
        ___SSBToReport_Item_iE_Extensions__item__extensionValue,
        __SSBToReport_Item_iE_Extensions__item_,
        _SSBToReport_Item_iE_Extensions,
        SSBToReport_Item,
        SSBToReport_Item_ExtIEs,
        ____ENDCResourceStatusResponse_protocolIEs__item__id_tab,
        _____ENDCResourceStatusResponse_protocolIEs__item__id_tab_val_Value_0,
        _____ENDCResourceStatusResponse_protocolIEs__item__id_tab_val_Value_1,
        _____ENDCResourceStatusResponse_protocolIEs__item__id_tab_val_Value_2,
        _____ENDCResourceStatusResponse_protocolIEs__item__id_tab_val_Value_3,
        ___ENDCResourceStatusResponse_protocolIEs__item__id,
        ___ENDCResourceStatusResponse_protocolIEs__item__criticality,
        ___ENDCResourceStatusResponse_protocolIEs__item__value,
        __ENDCResourceStatusResponse_protocolIEs__item_,
        _ENDCResourceStatusResponse_protocolIEs,
        ENDCResourceStatusResponse,
        ENDCResourceStatusResponse_IEs,
        _ENDCResourceStatusResponse_IEs_val_Value_0,
        _ENDCResourceStatusResponse_IEs_val_Value_1,
        _ENDCResourceStatusResponse_IEs_val_Value_2,
        _ENDCResourceStatusResponse_IEs_val_Value_3,
        ____ENDCResourceStatusFailure_protocolIEs__item__id_tab,
        _____ENDCResourceStatusFailure_protocolIEs__item__id_tab_val_Value_0,
        _____ENDCResourceStatusFailure_protocolIEs__item__id_tab_val_Value_1,
        _____ENDCResourceStatusFailure_protocolIEs__item__id_tab_val_Value_2,
        _____ENDCResourceStatusFailure_protocolIEs__item__id_tab_val_Value_3,
        _____ENDCResourceStatusFailure_protocolIEs__item__id_tab_val_Value_4,
        ___ENDCResourceStatusFailure_protocolIEs__item__id,
        ___ENDCResourceStatusFailure_protocolIEs__item__criticality,
        ___ENDCResourceStatusFailure_protocolIEs__item__value,
        __ENDCResourceStatusFailure_protocolIEs__item_,
        _ENDCResourceStatusFailure_protocolIEs,
        ENDCResourceStatusFailure,
        ENDCResourceStatusFailure_IEs,
        _ENDCResourceStatusFailure_IEs_val_Value_0,
        _ENDCResourceStatusFailure_IEs_val_Value_1,
        _ENDCResourceStatusFailure_IEs_val_Value_2,
        _ENDCResourceStatusFailure_IEs_val_Value_3,
        _ENDCResourceStatusFailure_IEs_val_Value_4,
        ____ENDCResourceStatusUpdate_protocolIEs__item__id_tab,
        _____ENDCResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_0,
        _____ENDCResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_1,
        _____ENDCResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_2,
        _____ENDCResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_3,
        _____ENDCResourceStatusUpdate_protocolIEs__item__id_tab_val_Value_4,
        ___ENDCResourceStatusUpdate_protocolIEs__item__id,
        ___ENDCResourceStatusUpdate_protocolIEs__item__criticality,
        ___ENDCResourceStatusUpdate_protocolIEs__item__value,
        __ENDCResourceStatusUpdate_protocolIEs__item_,
        _ENDCResourceStatusUpdate_protocolIEs,
        ENDCResourceStatusUpdate,
        ENDCResourceStatusUpdate_IEs,
        _ENDCResourceStatusUpdate_IEs_val_Value_0,
        _ENDCResourceStatusUpdate_IEs_val_Value_1,
        _ENDCResourceStatusUpdate_IEs_val_Value_2,
        _ENDCResourceStatusUpdate_IEs_val_Value_3,
        _ENDCResourceStatusUpdate_IEs_val_Value_4,
        ___CellMeasurementResult_NR_ENDC_List__item__id_tab,
        ____CellMeasurementResult_NR_ENDC_List__item__id_tab_val_Value_0,
        __CellMeasurementResult_NR_ENDC_List__item__id,
        __CellMeasurementResult_NR_ENDC_List__item__criticality,
        __CellMeasurementResult_NR_ENDC_List__item__value,
        _CellMeasurementResult_NR_ENDC_List__item_,
        CellMeasurementResult_NR_ENDC_List,
        CellMeasurementResult_NR_ENDC_ItemIEs,
        _CellMeasurementResult_NR_ENDC_ItemIEs_val_Value_0,
        _CellMeasurementResult_NR_ENDC_Item_nr_cell_ID,
        _CellMeasurementResult_NR_ENDC_Item_nr_radioResourceStatus,
        _CellMeasurementResult_NR_ENDC_Item_tnlCapacityIndicator,
        _CellMeasurementResult_NR_ENDC_Item_nr_compositeAvailableCapacityGroup,
        _CellMeasurementResult_NR_ENDC_Item_numberofActiveUEs,
        ____CellMeasurementResult_NR_ENDC_Item_iE_Extensions__item__id_tab,
        ___CellMeasurementResult_NR_ENDC_Item_iE_Extensions__item__id,
        ____CellMeasurementResult_NR_ENDC_Item_iE_Extensions__item__criticality_tab,
        ___CellMeasurementResult_NR_ENDC_Item_iE_Extensions__item__criticality,
        ____CellMeasurementResult_NR_ENDC_Item_iE_Extensions__item__extensionValue_tab,
        ___CellMeasurementResult_NR_ENDC_Item_iE_Extensions__item__extensionValue,
        __CellMeasurementResult_NR_ENDC_Item_iE_Extensions__item_,
        _CellMeasurementResult_NR_ENDC_Item_iE_Extensions,
        CellMeasurementResult_NR_ENDC_Item,
        CellMeasurementResult_NR_ENDC_Item_ExtIEs,
        ___CellMeasurementResult_E_UTRA_ENDC_List__item__id_tab,
        ____CellMeasurementResult_E_UTRA_ENDC_List__item__id_tab_val_Value_0,
        __CellMeasurementResult_E_UTRA_ENDC_List__item__id,
        __CellMeasurementResult_E_UTRA_ENDC_List__item__criticality,
        __CellMeasurementResult_E_UTRA_ENDC_List__item__value,
        _CellMeasurementResult_E_UTRA_ENDC_List__item_,
        CellMeasurementResult_E_UTRA_ENDC_List,
        CellMeasurementResult_E_UTRA_ENDC_ItemIEs,
        _CellMeasurementResult_E_UTRA_ENDC_ItemIEs_val_Value_0,
        _CellMeasurementResult_E_UTRA_ENDC_Item_e_utra_cell_ID,
        _CellMeasurementResult_E_UTRA_ENDC_Item_hWLoadIndicator,
        _CellMeasurementResult_E_UTRA_ENDC_Item_s1TNLLoadIndicator,
        _CellMeasurementResult_E_UTRA_ENDC_Item_radioResourceStatus,
        _CellMeasurementResult_E_UTRA_ENDC_Item_compositeAvailableCapacityGroup,
        ____CellMeasurementResult_E_UTRA_ENDC_Item_iE_Extensions__item__id_tab,
        ___CellMeasurementResult_E_UTRA_ENDC_Item_iE_Extensions__item__id,
        ____CellMeasurementResult_E_UTRA_ENDC_Item_iE_Extensions__item__criticality_tab,
        ___CellMeasurementResult_E_UTRA_ENDC_Item_iE_Extensions__item__criticality,
        ____CellMeasurementResult_E_UTRA_ENDC_Item_iE_Extensions__item__extensionValue_tab,
        ___CellMeasurementResult_E_UTRA_ENDC_Item_iE_Extensions__item__extensionValue,
        __CellMeasurementResult_E_UTRA_ENDC_Item_iE_Extensions__item_,
        _CellMeasurementResult_E_UTRA_ENDC_Item_iE_Extensions,
        CellMeasurementResult_E_UTRA_ENDC_Item,
        CellMeasurementResult_E_UTRA_ENDC_Item_ExtIEs,
        ____SecondaryRATDataUsageReport_protocolIEs__item__id_tab,
        _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_0,
        _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_1,
        _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_2,
        _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_3,
        ___SecondaryRATDataUsageReport_protocolIEs__item__id,
        ___SecondaryRATDataUsageReport_protocolIEs__item__criticality,
        ___SecondaryRATDataUsageReport_protocolIEs__item__value,
        __SecondaryRATDataUsageReport_protocolIEs__item_,
        _SecondaryRATDataUsageReport_protocolIEs,
        SecondaryRATDataUsageReport,
        SecondaryRATDataUsageReport_IEs,
        _SecondaryRATDataUsageReport_IEs_val_Value_0,
        _SecondaryRATDataUsageReport_IEs_val_Value_1,
        _SecondaryRATDataUsageReport_IEs_val_Value_2,
        _SecondaryRATDataUsageReport_IEs_val_Value_3,
        ____SgNBActivityNotification_protocolIEs__item__id_tab,
        _____SgNBActivityNotification_protocolIEs__item__id_tab_val_Value_0,
        _____SgNBActivityNotification_protocolIEs__item__id_tab_val_Value_1,
        _____SgNBActivityNotification_protocolIEs__item__id_tab_val_Value_2,
        _____SgNBActivityNotification_protocolIEs__item__id_tab_val_Value_3,
        _____SgNBActivityNotification_protocolIEs__item__id_tab_val_Value_4,
        ___SgNBActivityNotification_protocolIEs__item__id,
        ___SgNBActivityNotification_protocolIEs__item__criticality,
        ___SgNBActivityNotification_protocolIEs__item__value,
        __SgNBActivityNotification_protocolIEs__item_,
        _SgNBActivityNotification_protocolIEs,
        SgNBActivityNotification,
        SgNBActivityNotification_IEs,
        _SgNBActivityNotification_IEs_val_Value_0,
        _SgNBActivityNotification_IEs_val_Value_1,
        _SgNBActivityNotification_IEs_val_Value_2,
        _SgNBActivityNotification_IEs_val_Value_3,
        _SgNBActivityNotification_IEs_val_Value_4,
        ____ENDCPartialResetRequired_protocolIEs__item__id_tab,
        _____ENDCPartialResetRequired_protocolIEs__item__id_tab_val_Value_0,
        _____ENDCPartialResetRequired_protocolIEs__item__id_tab_val_Value_1,
        _____ENDCPartialResetRequired_protocolIEs__item__id_tab_val_Value_2,
        ___ENDCPartialResetRequired_protocolIEs__item__id,
        ___ENDCPartialResetRequired_protocolIEs__item__criticality,
        ___ENDCPartialResetRequired_protocolIEs__item__value,
        __ENDCPartialResetRequired_protocolIEs__item_,
        _ENDCPartialResetRequired_protocolIEs,
        ENDCPartialResetRequired,
        ENDCPartialResetRequired_IEs,
        _ENDCPartialResetRequired_IEs_val_Value_0,
        _ENDCPartialResetRequired_IEs_val_Value_1,
        _ENDCPartialResetRequired_IEs_val_Value_2,
        ____ENDCPartialResetConfirm_protocolIEs__item__id_tab,
        _____ENDCPartialResetConfirm_protocolIEs__item__id_tab_val_Value_0,
        _____ENDCPartialResetConfirm_protocolIEs__item__id_tab_val_Value_1,
        ___ENDCPartialResetConfirm_protocolIEs__item__id,
        ___ENDCPartialResetConfirm_protocolIEs__item__criticality,
        ___ENDCPartialResetConfirm_protocolIEs__item__value,
        __ENDCPartialResetConfirm_protocolIEs__item_,
        _ENDCPartialResetConfirm_protocolIEs,
        ENDCPartialResetConfirm,
        ENDCPartialResetConfirm_IEs,
        _ENDCPartialResetConfirm_IEs_val_Value_0,
        _ENDCPartialResetConfirm_IEs_val_Value_1,
        ____EUTRANRCellResourceCoordinationRequest_protocolIEs__item__id_tab,
        _____EUTRANRCellResourceCoordinationRequest_protocolIEs__item__id_tab_val_Value_0,
        _____EUTRANRCellResourceCoordinationRequest_protocolIEs__item__id_tab_val_Value_1,
        ___EUTRANRCellResourceCoordinationRequest_protocolIEs__item__id,
        ___EUTRANRCellResourceCoordinationRequest_protocolIEs__item__criticality,
        ___EUTRANRCellResourceCoordinationRequest_protocolIEs__item__value,
        __EUTRANRCellResourceCoordinationRequest_protocolIEs__item_,
        _EUTRANRCellResourceCoordinationRequest_protocolIEs,
        EUTRANRCellResourceCoordinationRequest,
        EUTRANRCellResourceCoordinationRequest_IEs,
        _EUTRANRCellResourceCoordinationRequest_IEs_val_Value_0,
        _EUTRANRCellResourceCoordinationRequest_IEs_val_Value_1,
        ____InitiatingNodeType_EutranrCellResourceCoordination_initiate_eNB__item__id_tab,
        _____InitiatingNodeType_EutranrCellResourceCoordination_initiate_eNB__item__id_tab_val_Value_0,
        _____InitiatingNodeType_EutranrCellResourceCoordination_initiate_eNB__item__id_tab_val_Value_1,
        _____InitiatingNodeType_EutranrCellResourceCoordination_initiate_eNB__item__id_tab_val_Value_2,
        ___InitiatingNodeType_EutranrCellResourceCoordination_initiate_eNB__item__id,
        ___InitiatingNodeType_EutranrCellResourceCoordination_initiate_eNB__item__criticality,
        ___InitiatingNodeType_EutranrCellResourceCoordination_initiate_eNB__item__value,
        __InitiatingNodeType_EutranrCellResourceCoordination_initiate_eNB__item_,
        _InitiatingNodeType_EutranrCellResourceCoordination_initiate_eNB,
        ____InitiatingNodeType_EutranrCellResourceCoordination_initiate_en_gNB__item__id_tab,
        _____InitiatingNodeType_EutranrCellResourceCoordination_initiate_en_gNB__item__id_tab_val_Value_0,
        _____InitiatingNodeType_EutranrCellResourceCoordination_initiate_en_gNB__item__id_tab_val_Value_1,
        _____InitiatingNodeType_EutranrCellResourceCoordination_initiate_en_gNB__item__id_tab_val_Value_2,
        _____InitiatingNodeType_EutranrCellResourceCoordination_initiate_en_gNB__item__id_tab_val_Value_3,
        ___InitiatingNodeType_EutranrCellResourceCoordination_initiate_en_gNB__item__id,
        ___InitiatingNodeType_EutranrCellResourceCoordination_initiate_en_gNB__item__criticality,
        ___InitiatingNodeType_EutranrCellResourceCoordination_initiate_en_gNB__item__value,
        __InitiatingNodeType_EutranrCellResourceCoordination_initiate_en_gNB__item_,
        _InitiatingNodeType_EutranrCellResourceCoordination_initiate_en_gNB,
        InitiatingNodeType_EutranrCellResourceCoordination,
        ENB_EUTRA_NRCellResourceCoordinationReqIEs,
        _ENB_EUTRA_NRCellResourceCoordinationReqIEs_val_Value_0,
        _ENB_EUTRA_NRCellResourceCoordinationReqIEs_val_Value_1,
        _ENB_EUTRA_NRCellResourceCoordinationReqIEs_val_Value_2,
        En_gNB_EUTRA_NRCellResourceCoordinationReqIEs,
        _En_gNB_EUTRA_NRCellResourceCoordinationReqIEs_val_Value_0,
        _En_gNB_EUTRA_NRCellResourceCoordinationReqIEs_val_Value_1,
        _En_gNB_EUTRA_NRCellResourceCoordinationReqIEs_val_Value_2,
        _En_gNB_EUTRA_NRCellResourceCoordinationReqIEs_val_Value_3,
        _ListofEUTRACellsinEUTRACoordinationReq__item_,
        ListofEUTRACellsinEUTRACoordinationReq,
        _ListofEUTRACellsinNRCoordinationReq__item_,
        ListofEUTRACellsinNRCoordinationReq,
        _ListofNRCellsinNRCoordinationReq__item_,
        ListofNRCellsinNRCoordinationReq,
        ____EUTRANRCellResourceCoordinationResponse_protocolIEs__item__id_tab,
        _____EUTRANRCellResourceCoordinationResponse_protocolIEs__item__id_tab_val_Value_0,
        _____EUTRANRCellResourceCoordinationResponse_protocolIEs__item__id_tab_val_Value_1,
        ___EUTRANRCellResourceCoordinationResponse_protocolIEs__item__id,
        ___EUTRANRCellResourceCoordinationResponse_protocolIEs__item__criticality,
        ___EUTRANRCellResourceCoordinationResponse_protocolIEs__item__value,
        __EUTRANRCellResourceCoordinationResponse_protocolIEs__item_,
        _EUTRANRCellResourceCoordinationResponse_protocolIEs,
        EUTRANRCellResourceCoordinationResponse,
        EUTRANRCellResourceCoordinationResponse_IEs,
        _EUTRANRCellResourceCoordinationResponse_IEs_val_Value_0,
        _EUTRANRCellResourceCoordinationResponse_IEs_val_Value_1,
        ____RespondingNodeType_EutranrCellResourceCoordination_respond_eNB__item__id_tab,
        _____RespondingNodeType_EutranrCellResourceCoordination_respond_eNB__item__id_tab_val_Value_0,
        _____RespondingNodeType_EutranrCellResourceCoordination_respond_eNB__item__id_tab_val_Value_1,
        _____RespondingNodeType_EutranrCellResourceCoordination_respond_eNB__item__id_tab_val_Value_2,
        ___RespondingNodeType_EutranrCellResourceCoordination_respond_eNB__item__id,
        ___RespondingNodeType_EutranrCellResourceCoordination_respond_eNB__item__criticality,
        ___RespondingNodeType_EutranrCellResourceCoordination_respond_eNB__item__value,
        __RespondingNodeType_EutranrCellResourceCoordination_respond_eNB__item_,
        _RespondingNodeType_EutranrCellResourceCoordination_respond_eNB,
        ____RespondingNodeType_EutranrCellResourceCoordination_respond_en_gNB__item__id_tab,
        _____RespondingNodeType_EutranrCellResourceCoordination_respond_en_gNB__item__id_tab_val_Value_0,
        _____RespondingNodeType_EutranrCellResourceCoordination_respond_en_gNB__item__id_tab_val_Value_1,
        _____RespondingNodeType_EutranrCellResourceCoordination_respond_en_gNB__item__id_tab_val_Value_2,
        ___RespondingNodeType_EutranrCellResourceCoordination_respond_en_gNB__item__id,
        ___RespondingNodeType_EutranrCellResourceCoordination_respond_en_gNB__item__criticality,
        ___RespondingNodeType_EutranrCellResourceCoordination_respond_en_gNB__item__value,
        __RespondingNodeType_EutranrCellResourceCoordination_respond_en_gNB__item_,
        _RespondingNodeType_EutranrCellResourceCoordination_respond_en_gNB,
        RespondingNodeType_EutranrCellResourceCoordination,
        ENB_EUTRA_NRCellResourceCoordinationReqAckIEs,
        _ENB_EUTRA_NRCellResourceCoordinationReqAckIEs_val_Value_0,
        _ENB_EUTRA_NRCellResourceCoordinationReqAckIEs_val_Value_1,
        _ENB_EUTRA_NRCellResourceCoordinationReqAckIEs_val_Value_2,
        En_gNB_EUTRA_NRCellResourceCoordinationReqAckIEs,
        _En_gNB_EUTRA_NRCellResourceCoordinationReqAckIEs_val_Value_0,
        _En_gNB_EUTRA_NRCellResourceCoordinationReqAckIEs_val_Value_1,
        _En_gNB_EUTRA_NRCellResourceCoordinationReqAckIEs_val_Value_2,
        _ListofEUTRACellsinEUTRACoordinationResp__item_,
        ListofEUTRACellsinEUTRACoordinationResp,
        _ListofNRCellsinNRCoordinationResp__item_,
        ListofNRCellsinNRCoordinationResp,
        ____ENDCX2RemovalRequest_protocolIEs__item__id_tab,
        _____ENDCX2RemovalRequest_protocolIEs__item__id_tab_val_Value_0,
        _____ENDCX2RemovalRequest_protocolIEs__item__id_tab_val_Value_1,
        ___ENDCX2RemovalRequest_protocolIEs__item__id,
        ___ENDCX2RemovalRequest_protocolIEs__item__criticality,
        ___ENDCX2RemovalRequest_protocolIEs__item__value,
        __ENDCX2RemovalRequest_protocolIEs__item_,
        _ENDCX2RemovalRequest_protocolIEs,
        ENDCX2RemovalRequest,
        ENDCX2RemovalRequest_IEs,
        _ENDCX2RemovalRequest_IEs_val_Value_0,
        _ENDCX2RemovalRequest_IEs_val_Value_1,
        ____InitiatingNodeType_EndcX2Removal_init_eNB__item__id_tab,
        _____InitiatingNodeType_EndcX2Removal_init_eNB__item__id_tab_val_Value_0,
        ___InitiatingNodeType_EndcX2Removal_init_eNB__item__id,
        ___InitiatingNodeType_EndcX2Removal_init_eNB__item__criticality,
        ___InitiatingNodeType_EndcX2Removal_init_eNB__item__value,
        __InitiatingNodeType_EndcX2Removal_init_eNB__item_,
        _InitiatingNodeType_EndcX2Removal_init_eNB,
        ____InitiatingNodeType_EndcX2Removal_init_en_gNB__item__id_tab,
        _____InitiatingNodeType_EndcX2Removal_init_en_gNB__item__id_tab_val_Value_0,
        ___InitiatingNodeType_EndcX2Removal_init_en_gNB__item__id,
        ___InitiatingNodeType_EndcX2Removal_init_en_gNB__item__criticality,
        ___InitiatingNodeType_EndcX2Removal_init_en_gNB__item__value,
        __InitiatingNodeType_EndcX2Removal_init_en_gNB__item_,
        _InitiatingNodeType_EndcX2Removal_init_en_gNB,
        InitiatingNodeType_EndcX2Removal,
        ENB_ENDCX2RemovalReqIEs,
        _ENB_ENDCX2RemovalReqIEs_val_Value_0,
        En_gNB_ENDCX2RemovalReqIEs,
        _En_gNB_ENDCX2RemovalReqIEs_val_Value_0,
        ____ENDCX2RemovalResponse_protocolIEs__item__id_tab,
        _____ENDCX2RemovalResponse_protocolIEs__item__id_tab_val_Value_0,
        _____ENDCX2RemovalResponse_protocolIEs__item__id_tab_val_Value_1,
        ___ENDCX2RemovalResponse_protocolIEs__item__id,
        ___ENDCX2RemovalResponse_protocolIEs__item__criticality,
        ___ENDCX2RemovalResponse_protocolIEs__item__value,
        __ENDCX2RemovalResponse_protocolIEs__item_,
        _ENDCX2RemovalResponse_protocolIEs,
        ENDCX2RemovalResponse,
        ENDCX2RemovalResponse_IEs,
        _ENDCX2RemovalResponse_IEs_val_Value_0,
        _ENDCX2RemovalResponse_IEs_val_Value_1,
        ____RespondingNodeType_EndcX2Removal_respond_eNB__item__id_tab,
        _____RespondingNodeType_EndcX2Removal_respond_eNB__item__id_tab_val_Value_0,
        ___RespondingNodeType_EndcX2Removal_respond_eNB__item__id,
        ___RespondingNodeType_EndcX2Removal_respond_eNB__item__criticality,
        ___RespondingNodeType_EndcX2Removal_respond_eNB__item__value,
        __RespondingNodeType_EndcX2Removal_respond_eNB__item_,
        _RespondingNodeType_EndcX2Removal_respond_eNB,
        ____RespondingNodeType_EndcX2Removal_respond_en_gNB__item__id_tab,
        _____RespondingNodeType_EndcX2Removal_respond_en_gNB__item__id_tab_val_Value_0,
        ___RespondingNodeType_EndcX2Removal_respond_en_gNB__item__id,
        ___RespondingNodeType_EndcX2Removal_respond_en_gNB__item__criticality,
        ___RespondingNodeType_EndcX2Removal_respond_en_gNB__item__value,
        __RespondingNodeType_EndcX2Removal_respond_en_gNB__item_,
        _RespondingNodeType_EndcX2Removal_respond_en_gNB,
        RespondingNodeType_EndcX2Removal,
        ENB_ENDCX2RemovalReqAckIEs,
        _ENB_ENDCX2RemovalReqAckIEs_val_Value_0,
        En_gNB_ENDCX2RemovalReqAckIEs,
        _En_gNB_ENDCX2RemovalReqAckIEs_val_Value_0,
        ____ENDCX2RemovalFailure_protocolIEs__item__id_tab,
        _____ENDCX2RemovalFailure_protocolIEs__item__id_tab_val_Value_0,
        _____ENDCX2RemovalFailure_protocolIEs__item__id_tab_val_Value_1,
        _____ENDCX2RemovalFailure_protocolIEs__item__id_tab_val_Value_2,
        ___ENDCX2RemovalFailure_protocolIEs__item__id,
        ___ENDCX2RemovalFailure_protocolIEs__item__criticality,
        ___ENDCX2RemovalFailure_protocolIEs__item__value,
        __ENDCX2RemovalFailure_protocolIEs__item_,
        _ENDCX2RemovalFailure_protocolIEs,
        ENDCX2RemovalFailure,
        ENDCX2RemovalFailure_IEs,
        _ENDCX2RemovalFailure_IEs_val_Value_0,
        _ENDCX2RemovalFailure_IEs_val_Value_1,
        _ENDCX2RemovalFailure_IEs_val_Value_2,
        ____DataForwardingAddressIndication_protocolIEs__item__id_tab,
        _____DataForwardingAddressIndication_protocolIEs__item__id_tab_val_Value_0,
        _____DataForwardingAddressIndication_protocolIEs__item__id_tab_val_Value_1,
        _____DataForwardingAddressIndication_protocolIEs__item__id_tab_val_Value_2,
        _____DataForwardingAddressIndication_protocolIEs__item__id_tab_val_Value_3,
        _____DataForwardingAddressIndication_protocolIEs__item__id_tab_val_Value_4,
        _____DataForwardingAddressIndication_protocolIEs__item__id_tab_val_Value_5,
        _____DataForwardingAddressIndication_protocolIEs__item__id_tab_val_Value_6,
        _____DataForwardingAddressIndication_protocolIEs__item__id_tab_val_Value_7,
        _____DataForwardingAddressIndication_protocolIEs__item__id_tab_val_Value_8,
        ___DataForwardingAddressIndication_protocolIEs__item__id,
        ___DataForwardingAddressIndication_protocolIEs__item__criticality,
        ___DataForwardingAddressIndication_protocolIEs__item__value,
        __DataForwardingAddressIndication_protocolIEs__item_,
        _DataForwardingAddressIndication_protocolIEs,
        DataForwardingAddressIndication,
        DataForwardingAddressIndication_IEs,
        _DataForwardingAddressIndication_IEs_val_Value_0,
        _DataForwardingAddressIndication_IEs_val_Value_1,
        _DataForwardingAddressIndication_IEs_val_Value_2,
        _DataForwardingAddressIndication_IEs_val_Value_3,
        _DataForwardingAddressIndication_IEs_val_Value_4,
        _DataForwardingAddressIndication_IEs_val_Value_5,
        _DataForwardingAddressIndication_IEs_val_Value_6,
        _DataForwardingAddressIndication_IEs_val_Value_7,
        _DataForwardingAddressIndication_IEs_val_Value_8,
        ___E_RABs_DataForwardingAddress_List__item__id_tab,
        ____E_RABs_DataForwardingAddress_List__item__id_tab_val_Value_0,
        __E_RABs_DataForwardingAddress_List__item__id,
        __E_RABs_DataForwardingAddress_List__item__criticality,
        __E_RABs_DataForwardingAddress_List__item__value,
        _E_RABs_DataForwardingAddress_List__item_,
        E_RABs_DataForwardingAddress_List,
        E_RABs_DataForwardingAddress_ItemIEs,
        _E_RABs_DataForwardingAddress_ItemIEs_val_Value_0,
        _E_RABs_DataForwardingAddress_Item_e_RAB_ID,
        _E_RABs_DataForwardingAddress_Item_dl_GTPtunnelEndpoint,
        ____E_RABs_DataForwardingAddress_Item_iE_Extensions__item__id_tab,
        ___E_RABs_DataForwardingAddress_Item_iE_Extensions__item__id,
        ____E_RABs_DataForwardingAddress_Item_iE_Extensions__item__criticality_tab,
        ___E_RABs_DataForwardingAddress_Item_iE_Extensions__item__criticality,
        ____E_RABs_DataForwardingAddress_Item_iE_Extensions__item__extensionValue_tab,
        ___E_RABs_DataForwardingAddress_Item_iE_Extensions__item__extensionValue,
        __E_RABs_DataForwardingAddress_Item_iE_Extensions__item_,
        _E_RABs_DataForwardingAddress_Item_iE_Extensions,
        E_RABs_DataForwardingAddress_Item,
        E_RABs_DataForwardingAddress_ItemExtIEs,
        ____GNBStatusIndication_protocolIEs__item__id_tab,
        _____GNBStatusIndication_protocolIEs__item__id_tab_val_Value_0,
        _____GNBStatusIndication_protocolIEs__item__id_tab_val_Value_1,
        ___GNBStatusIndication_protocolIEs__item__id,
        ___GNBStatusIndication_protocolIEs__item__criticality,
        ___GNBStatusIndication_protocolIEs__item__value,
        __GNBStatusIndication_protocolIEs__item_,
        _GNBStatusIndication_protocolIEs,
        GNBStatusIndication,
        GNBStatusIndicationIEs,
        _GNBStatusIndicationIEs_val_Value_0,
        _GNBStatusIndicationIEs_val_Value_1,
        ____ENDCConfigurationTransfer_protocolIEs__item__id_tab,
        _____ENDCConfigurationTransfer_protocolIEs__item__id_tab_val_Value_0,
        _____ENDCConfigurationTransfer_protocolIEs__item__id_tab_val_Value_1,
        ___ENDCConfigurationTransfer_protocolIEs__item__id,
        ___ENDCConfigurationTransfer_protocolIEs__item__criticality,
        ___ENDCConfigurationTransfer_protocolIEs__item__value,
        __ENDCConfigurationTransfer_protocolIEs__item_,
        _ENDCConfigurationTransfer_protocolIEs,
        ENDCConfigurationTransfer,
        ENDCConfigurationTransfer_IEs,
        _ENDCConfigurationTransfer_IEs_val_Value_0,
        _ENDCConfigurationTransfer_IEs_val_Value_1,
        ____TraceStart_protocolIEs__item__id_tab,
        _____TraceStart_protocolIEs__item__id_tab_val_Value_0,
        _____TraceStart_protocolIEs__item__id_tab_val_Value_1,
        _____TraceStart_protocolIEs__item__id_tab_val_Value_2,
        _____TraceStart_protocolIEs__item__id_tab_val_Value_3,
        ___TraceStart_protocolIEs__item__id,
        ___TraceStart_protocolIEs__item__criticality,
        ___TraceStart_protocolIEs__item__value,
        __TraceStart_protocolIEs__item_,
        _TraceStart_protocolIEs,
        TraceStart,
        TraceStartIEs,
        _TraceStartIEs_val_Value_0,
        _TraceStartIEs_val_Value_1,
        _TraceStartIEs_val_Value_2,
        _TraceStartIEs_val_Value_3,
        ____DeactivateTrace_protocolIEs__item__id_tab,
        _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_0,
        _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_1,
        _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_2,
        _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_3,
        ___DeactivateTrace_protocolIEs__item__id,
        ___DeactivateTrace_protocolIEs__item__criticality,
        ___DeactivateTrace_protocolIEs__item__value,
        __DeactivateTrace_protocolIEs__item_,
        _DeactivateTrace_protocolIEs,
        DeactivateTrace,
        DeactivateTraceIEs,
        _DeactivateTraceIEs_val_Value_0,
        _DeactivateTraceIEs_val_Value_1,
        _DeactivateTraceIEs_val_Value_2,
        _DeactivateTraceIEs_val_Value_3,
        ____CellTrafficTrace_protocolIEs__item__id_tab,
        _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_0,
        _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_1,
        _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_2,
        _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_3,
        _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_4,
        _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_5,
        ___CellTrafficTrace_protocolIEs__item__id,
        ___CellTrafficTrace_protocolIEs__item__criticality,
        ___CellTrafficTrace_protocolIEs__item__value,
        __CellTrafficTrace_protocolIEs__item_,
        _CellTrafficTrace_protocolIEs,
        CellTrafficTrace,
        CellTrafficTraceIEs,
        _CellTrafficTraceIEs_val_Value_0,
        _CellTrafficTraceIEs_val_Value_1,
        _CellTrafficTraceIEs_val_Value_2,
        _CellTrafficTraceIEs_val_Value_3,
        _CellTrafficTraceIEs_val_Value_4,
        _CellTrafficTraceIEs_val_Value_5,
        ____F1CTrafficTransfer_protocolIEs__item__id_tab,
        _____F1CTrafficTransfer_protocolIEs__item__id_tab_val_Value_0,
        _____F1CTrafficTransfer_protocolIEs__item__id_tab_val_Value_1,
        _____F1CTrafficTransfer_protocolIEs__item__id_tab_val_Value_2,
        _____F1CTrafficTransfer_protocolIEs__item__id_tab_val_Value_3,
        ___F1CTrafficTransfer_protocolIEs__item__id,
        ___F1CTrafficTransfer_protocolIEs__item__criticality,
        ___F1CTrafficTransfer_protocolIEs__item__value,
        __F1CTrafficTransfer_protocolIEs__item_,
        _F1CTrafficTransfer_protocolIEs,
        F1CTrafficTransfer,
        F1CTrafficTransfer_IEs,
        _F1CTrafficTransfer_IEs_val_Value_0,
        _F1CTrafficTransfer_IEs_val_Value_1,
        _F1CTrafficTransfer_IEs_val_Value_2,
        _F1CTrafficTransfer_IEs_val_Value_3,
        ____UERadioCapabilityIDMappingRequest_protocolIEs__item__id_tab,
        _____UERadioCapabilityIDMappingRequest_protocolIEs__item__id_tab_val_Value_0,
        ___UERadioCapabilityIDMappingRequest_protocolIEs__item__id,
        ___UERadioCapabilityIDMappingRequest_protocolIEs__item__criticality,
        ___UERadioCapabilityIDMappingRequest_protocolIEs__item__value,
        __UERadioCapabilityIDMappingRequest_protocolIEs__item_,
        _UERadioCapabilityIDMappingRequest_protocolIEs,
        UERadioCapabilityIDMappingRequest,
        UERadioCapabilityIDMappingRequestIEs,
        _UERadioCapabilityIDMappingRequestIEs_val_Value_0,
        ____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab,
        _____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab_val_Value_0,
        _____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab_val_Value_1,
        _____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab_val_Value_2,
        ___UERadioCapabilityIDMappingResponse_protocolIEs__item__id,
        ___UERadioCapabilityIDMappingResponse_protocolIEs__item__criticality,
        ___UERadioCapabilityIDMappingResponse_protocolIEs__item__value,
        __UERadioCapabilityIDMappingResponse_protocolIEs__item_,
        _UERadioCapabilityIDMappingResponse_protocolIEs,
        UERadioCapabilityIDMappingResponse,
        UERadioCapabilityIDMappingResponseIEs,
        _UERadioCapabilityIDMappingResponseIEs_val_Value_0,
        _UERadioCapabilityIDMappingResponseIEs_val_Value_1,
        _UERadioCapabilityIDMappingResponseIEs_val_Value_2,
        ____CPC_cancel_protocolIEs__item__id_tab,
        _____CPC_cancel_protocolIEs__item__id_tab_val_Value_0,
        _____CPC_cancel_protocolIEs__item__id_tab_val_Value_1,
        _____CPC_cancel_protocolIEs__item__id_tab_val_Value_2,
        _____CPC_cancel_protocolIEs__item__id_tab_val_Value_3,
        _____CPC_cancel_protocolIEs__item__id_tab_val_Value_4,
        ___CPC_cancel_protocolIEs__item__id,
        ___CPC_cancel_protocolIEs__item__criticality,
        ___CPC_cancel_protocolIEs__item__value,
        __CPC_cancel_protocolIEs__item_,
        _CPC_cancel_protocolIEs,
        CPC_cancel,
        CPC_cancel_IEs,
        _CPC_cancel_IEs_val_Value_0,
        _CPC_cancel_IEs_val_Value_1,
        _CPC_cancel_IEs_val_Value_2,
        _CPC_cancel_IEs_val_Value_3,
        _CPC_cancel_IEs_val_Value_4,
    ]

class X2AP_PDU_Descriptions:

    _name_  = 'X2AP-PDU-Descriptions'
    _oid_   = [0, 4, 0, 0, 21, 3, 2, 1, 0]
    
    _obj_ = [
        'X2AP-ELEMENTARY-PROCEDURE',
        'X2AP-PDU',
        'InitiatingMessage',
        'SuccessfulOutcome',
        'UnsuccessfulOutcome',
        'X2AP-ELEMENTARY-PROCEDURES',
        'X2AP-ELEMENTARY-PROCEDURES-CLASS-1',
        'X2AP-ELEMENTARY-PROCEDURES-CLASS-2',
        'handoverPreparation',
        'snStatusTransfer',
        'uEContextRelease',
        'handoverCancel',
        'handoverReport',
        'errorIndication',
        'reset',
        'x2Setup',
        'loadIndication',
        'eNBConfigurationUpdate',
        'resourceStatusReportingInitiation',
        'resourceStatusReporting',
        'rLFIndication',
        'privateMessage',
        'mobilitySettingsChange',
        'cellActivation',
        'x2Release',
        'x2APMessageTransfer',
        'seNBAdditionPreparation',
        'seNBReconfigurationCompletion',
        'meNBinitiatedSeNBModificationPreparation',
        'seNBinitiatedSeNBModification',
        'meNBinitiatedSeNBRelease',
        'seNBinitiatedSeNBRelease',
        'seNBCounterCheck',
        'x2Removal',
        'retrieveUEContext',
        'sgNBAdditionPreparation',
        'sgNBReconfigurationCompletion',
        'meNBinitiatedSgNBModificationPreparation',
        'sgNBinitiatedSgNBModification',
        'meNBinitiatedSgNBRelease',
        'sgNBinitiatedSgNBRelease',
        'sgNBCounterCheck',
        'sgNBChange',
        'rRCTransfer',
        'endcX2Setup',
        'endcConfigurationUpdate',
        'secondaryRATDataUsageReport',
        'endcCellActivation',
        'endcPartialReset',
        'eUTRANRCellResourceCoordination',
        'sgNBActivityNotification',
        'endcX2Removal',
        'dataForwardingAddressIndication',
        'gNBStatusIndication',
        'endcConfigurationTransfer',
        'deactivateTrace',
        'traceStart',
        'handoverSuccess',
        'earlyStatusTransfer',
        'conditionalHandoverCancel',
        'endcresourceStatusReportingInitiation',
        'endcresourceStatusReporting',
        'cellTrafficTrace',
        'f1CTrafficTransfer',
        'uERadioCapabilityIDMapping',
        'accessAndMobilityIndication',
        'cPC-cancel',
        ]
    _type_ = [
        'X2AP-ELEMENTARY-PROCEDURE',
        'X2AP-PDU',
        'InitiatingMessage',
        'SuccessfulOutcome',
        'UnsuccessfulOutcome',
        ]
    _set_ = [
        'X2AP-ELEMENTARY-PROCEDURES',
        'X2AP-ELEMENTARY-PROCEDURES-CLASS-1',
        'X2AP-ELEMENTARY-PROCEDURES-CLASS-2',
        ]
    _val_ = [
        'handoverPreparation',
        'snStatusTransfer',
        'uEContextRelease',
        'handoverCancel',
        'handoverReport',
        'errorIndication',
        'reset',
        'x2Setup',
        'loadIndication',
        'eNBConfigurationUpdate',
        'resourceStatusReportingInitiation',
        'resourceStatusReporting',
        'rLFIndication',
        'privateMessage',
        'mobilitySettingsChange',
        'cellActivation',
        'x2Release',
        'x2APMessageTransfer',
        'seNBAdditionPreparation',
        'seNBReconfigurationCompletion',
        'meNBinitiatedSeNBModificationPreparation',
        'seNBinitiatedSeNBModification',
        'meNBinitiatedSeNBRelease',
        'seNBinitiatedSeNBRelease',
        'seNBCounterCheck',
        'x2Removal',
        'retrieveUEContext',
        'sgNBAdditionPreparation',
        'sgNBReconfigurationCompletion',
        'meNBinitiatedSgNBModificationPreparation',
        'sgNBinitiatedSgNBModification',
        'meNBinitiatedSgNBRelease',
        'sgNBinitiatedSgNBRelease',
        'sgNBCounterCheck',
        'sgNBChange',
        'rRCTransfer',
        'endcX2Setup',
        'endcConfigurationUpdate',
        'secondaryRATDataUsageReport',
        'endcCellActivation',
        'endcPartialReset',
        'eUTRANRCellResourceCoordination',
        'sgNBActivityNotification',
        'endcX2Removal',
        'dataForwardingAddressIndication',
        'gNBStatusIndication',
        'endcConfigurationTransfer',
        'deactivateTrace',
        'traceStart',
        'handoverSuccess',
        'earlyStatusTransfer',
        'conditionalHandoverCancel',
        'endcresourceStatusReportingInitiation',
        'endcresourceStatusReporting',
        'cellTrafficTrace',
        'f1CTrafficTransfer',
        'uERadioCapabilityIDMapping',
        'accessAndMobilityIndication',
        'cPC-cancel',
        ]
    _class_ = [
        'X2AP-ELEMENTARY-PROCEDURE',
        'X2AP-ELEMENTARY-PROCEDURES',
        'X2AP-ELEMENTARY-PROCEDURES-CLASS-1',
        'X2AP-ELEMENTARY-PROCEDURES-CLASS-2',
        'handoverPreparation',
        'snStatusTransfer',
        'uEContextRelease',
        'handoverCancel',
        'handoverReport',
        'errorIndication',
        'reset',
        'x2Setup',
        'loadIndication',
        'eNBConfigurationUpdate',
        'resourceStatusReportingInitiation',
        'resourceStatusReporting',
        'rLFIndication',
        'privateMessage',
        'mobilitySettingsChange',
        'cellActivation',
        'x2Release',
        'x2APMessageTransfer',
        'seNBAdditionPreparation',
        'seNBReconfigurationCompletion',
        'meNBinitiatedSeNBModificationPreparation',
        'seNBinitiatedSeNBModification',
        'meNBinitiatedSeNBRelease',
        'seNBinitiatedSeNBRelease',
        'seNBCounterCheck',
        'x2Removal',
        'retrieveUEContext',
        'sgNBAdditionPreparation',
        'sgNBReconfigurationCompletion',
        'meNBinitiatedSgNBModificationPreparation',
        'sgNBinitiatedSgNBModification',
        'meNBinitiatedSgNBRelease',
        'sgNBinitiatedSgNBRelease',
        'sgNBCounterCheck',
        'sgNBChange',
        'rRCTransfer',
        'endcX2Setup',
        'endcConfigurationUpdate',
        'secondaryRATDataUsageReport',
        'endcCellActivation',
        'endcPartialReset',
        'eUTRANRCellResourceCoordination',
        'sgNBActivityNotification',
        'endcX2Removal',
        'dataForwardingAddressIndication',
        'gNBStatusIndication',
        'endcConfigurationTransfer',
        'deactivateTrace',
        'traceStart',
        'handoverSuccess',
        'earlyStatusTransfer',
        'conditionalHandoverCancel',
        'endcresourceStatusReportingInitiation',
        'endcresourceStatusReporting',
        'cellTrafficTrace',
        'f1CTrafficTransfer',
        'uERadioCapabilityIDMapping',
        'accessAndMobilityIndication',
        'cPC-cancel',
        ]
    _param_ = [
        ]
    
    #-----< X2AP-ELEMENTARY-PROCEDURE >-----#
    X2AP_ELEMENTARY_PROCEDURE = CLASS(name='X2AP-ELEMENTARY-PROCEDURE', mode=MODE_TYPE)
    _X2AP_ELEMENTARY_PROCEDURE_InitiatingMessage = OPEN(name='InitiatingMessage', mode=MODE_TYPE)
    _X2AP_ELEMENTARY_PROCEDURE_SuccessfulOutcome = OPEN(name='SuccessfulOutcome', mode=MODE_TYPE, opt=True)
    _X2AP_ELEMENTARY_PROCEDURE_UnsuccessfulOutcome = OPEN(name='UnsuccessfulOutcome', mode=MODE_TYPE, opt=True)
    _X2AP_ELEMENTARY_PROCEDURE_procedureCode = INT(name='procedureCode', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'ProcedureCode')), uniq=True)
    _X2AP_ELEMENTARY_PROCEDURE_criticality = ENUM(name='criticality', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-CommonDataTypes', 'Criticality')), default='ignore')
    X2AP_ELEMENTARY_PROCEDURE._cont = ASN1Dict([
        ('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURE_InitiatingMessage),
        ('SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURE_SuccessfulOutcome),
        ('UnsuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURE_UnsuccessfulOutcome),
        ('procedureCode', _X2AP_ELEMENTARY_PROCEDURE_procedureCode),
        ('criticality', _X2AP_ELEMENTARY_PROCEDURE_criticality),
        ])
    
    #-----< X2AP-PDU >-----#
    X2AP_PDU = CHOICE(name='X2AP-PDU', mode=MODE_TYPE)
    _X2AP_PDU_initiatingMessage = SEQ(name='initiatingMessage', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'InitiatingMessage')))
    _X2AP_PDU_successfulOutcome = SEQ(name='successfulOutcome', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'SuccessfulOutcome')))
    _X2AP_PDU_unsuccessfulOutcome = SEQ(name='unsuccessfulOutcome', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'UnsuccessfulOutcome')))
    X2AP_PDU._cont = ASN1Dict([
        ('initiatingMessage', _X2AP_PDU_initiatingMessage),
        ('successfulOutcome', _X2AP_PDU_successfulOutcome),
        ('unsuccessfulOutcome', _X2AP_PDU_unsuccessfulOutcome),
        ])
    X2AP_PDU._ext = []
    
    #-----< InitiatingMessage >-----#
    InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE)
    _InitiatingMessage_procedureCode = INT(name='procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE'), ['procedureCode']))
    __InitiatingMessage_procedureCode_tab = CLASS(name='_tab_X2AP-ELEMENTARY-PROCEDURE', mode=MODE_SET, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'HandoverRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_0 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'HandoverRequestAcknowledge')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_0 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'HandoverPreparationFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResetRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_1 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResetResponse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2SetupRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_2 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2SetupResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_2 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2SetupFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResourceStatusRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_3 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResourceStatusResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_3 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResourceStatusFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENBConfigurationUpdate')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_4 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENBConfigurationUpdateAcknowledge')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_4 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENBConfigurationUpdateFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'MobilityChangeRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_5 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'MobilityChangeAcknowledge')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_5 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'MobilityChangeFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_6 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellActivationRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_6 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellActivationResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_6 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellActivationFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_7 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBAdditionRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_7 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBAdditionRequestAcknowledge')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_7 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBAdditionRequestReject')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_8 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_8 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationRequestAcknowledge')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_8 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationRequestReject')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_9 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationRequired')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_9 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationConfirm')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_9 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationRefuse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_10 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBReleaseRequired')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_10 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBReleaseConfirm')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_11 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2RemovalRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_11 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2RemovalResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_11 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2RemovalFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_12 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'RetrieveUEContextRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_12 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'RetrieveUEContextResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_12 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'RetrieveUEContextFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_13 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBAdditionRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_13 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBAdditionRequestAcknowledge')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_13 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBAdditionRequestReject')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_14 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBModificationRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_14 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBModificationRequestAcknowledge')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_14 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBModificationRequestReject')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_15 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBModificationRequired')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_15 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBModificationConfirm')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_15 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBModificationRefuse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_16 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBReleaseRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_16 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBReleaseRequestAcknowledge')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_16 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBReleaseRequestReject')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_17 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBReleaseRequired')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_17 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBReleaseConfirm')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_18 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBChangeRequired')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_18 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBChangeConfirm')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_18 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBChangeRefuse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_19 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCX2SetupRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_19 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCX2SetupResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_19 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCX2SetupFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_20 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCConfigurationUpdate')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_20 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCConfigurationUpdateAcknowledge')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_20 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCConfigurationUpdateFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_21 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCCellActivationRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_21 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCCellActivationResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_21 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCCellActivationFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_22 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCPartialResetRequired')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_22 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCPartialResetConfirm')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_23 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'EUTRANRCellResourceCoordinationRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_23 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'EUTRANRCellResourceCoordinationResponse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_24 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCX2RemovalRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_24 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCX2RemovalResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_24 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCX2RemovalFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_25 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCResourceStatusRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_25 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCResourceStatusResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_25 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCResourceStatusFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_26 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'UERadioCapabilityIDMappingRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_26 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'UERadioCapabilityIDMappingResponse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_27 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SNStatusTransfer')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_28 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'UEContextRelease')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_29 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'HandoverCancel')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_30 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ErrorIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_31 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResourceStatusUpdate')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_32 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'LoadInformation')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_33 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'PrivateMessage')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_34 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'RLFIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_35 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'HandoverReport')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_36 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2Release')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_37 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2APMessageTransfer')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_38 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBReconfigurationComplete')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_39 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBReleaseRequest')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_40 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBCounterCheckRequest')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_41 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBReconfigurationComplete')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_42 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBCounterCheckRequest')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_43 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'RRCTransfer')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_44 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SecondaryRATDataUsageReport')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_45 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBActivityNotification')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_46 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'DataForwardingAddressIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_47 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'GNBStatusIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_48 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCConfigurationTransfer')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_49 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'DeactivateTrace')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_50 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'TraceStart')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_51 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'HandoverSuccess')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_52 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'EarlyStatusTransfer')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_53 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ConditionalHandoverCancel')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_54 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCResourceStatusUpdate')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_55 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellTrafficTrace')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_56 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'F1CTrafficTransfer')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_57 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'AccessAndMobilityIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_58 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CPC-cancel')))
    __InitiatingMessage_procedureCode_tab._val = ASN1Set(rv=[dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_0), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_0), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_0), ('procedureCode', 0), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_1), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_1), ('procedureCode', 7), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_2), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_2), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_2), ('procedureCode', 6), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_3), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_3), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_3), ('procedureCode', 9), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_4), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_4), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_4), ('procedureCode', 8), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_5), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_5), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_5), ('procedureCode', 12), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_6), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_6), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_6), ('procedureCode', 15), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_7), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_7), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_7), ('procedureCode', 19), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_8), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_8), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_8), ('procedureCode', 21), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_9), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_9), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_9), ('procedureCode', 22), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_10), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_10), ('procedureCode', 24), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_11), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_11), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_11), ('procedureCode', 18), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_12), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_12), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_12), ('procedureCode', 26), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_13), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_13), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_13), ('procedureCode', 27), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_14), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_14), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_14), ('procedureCode', 29), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_15), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_15), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_15), ('procedureCode', 30), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_16), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_16), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_16), ('procedureCode', 31), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_17), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_17), ('procedureCode', 32), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_18), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_18), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_18), ('procedureCode', 34), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_19), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_19), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_19), ('procedureCode', 36), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_20), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_20), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_20), ('procedureCode', 37), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_21), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_21), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_21), ('procedureCode', 39), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_22), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_22), ('procedureCode', 40), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_23), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_23), ('procedureCode', 41), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_24), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_24), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_24), ('procedureCode', 43), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_25), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_25), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_25), ('procedureCode', 54), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_26), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_26), ('procedureCode', 56), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_27), ('procedureCode', 4), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_28), ('procedureCode', 5), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_29), ('procedureCode', 1), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_30), ('procedureCode', 3), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_31), ('procedureCode', 10), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_32), ('procedureCode', 2), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_33), ('procedureCode', 11), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_34), ('procedureCode', 13), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_35), ('procedureCode', 14), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_36), ('procedureCode', 16), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_37), ('procedureCode', 17), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_38), ('procedureCode', 20), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_39), ('procedureCode', 23), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_40), ('procedureCode', 25), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_41), ('procedureCode', 28), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_42), ('procedureCode', 33), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_43), ('procedureCode', 35), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_44), ('procedureCode', 38), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_45), ('procedureCode', 42), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_46), ('procedureCode', 44), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_47), ('procedureCode', 45), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_48), ('procedureCode', 48), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_49), ('procedureCode', 46), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_50), ('procedureCode', 47), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_51), ('procedureCode', 49), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_52), ('procedureCode', 51), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_53), ('procedureCode', 50), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_54), ('procedureCode', 53), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_55), ('procedureCode', 52), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_56), ('procedureCode', 55), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_57), ('procedureCode', 57), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_58), ('procedureCode', 59), ('criticality', 'ignore')])], rr=[], ev=None, er=[])
    _InitiatingMessage_procedureCode._const_tab = __InitiatingMessage_procedureCode_tab
    _InitiatingMessage_procedureCode._const_tab_at = None
    _InitiatingMessage_procedureCode._const_tab_id = 'procedureCode'
    _InitiatingMessage_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE'), ['criticality']))
    _InitiatingMessage_criticality._const_tab = __InitiatingMessage_procedureCode_tab
    _InitiatingMessage_criticality._const_tab_at = ('..', 'procedureCode')
    _InitiatingMessage_criticality._const_tab_id = 'criticality'
    _InitiatingMessage_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE'), ['InitiatingMessage']))
    _InitiatingMessage_value._const_tab = __InitiatingMessage_procedureCode_tab
    _InitiatingMessage_value._const_tab_at = ('..', 'procedureCode')
    _InitiatingMessage_value._const_tab_id = 'InitiatingMessage'
    InitiatingMessage._cont = ASN1Dict([
        ('procedureCode', _InitiatingMessage_procedureCode),
        ('criticality', _InitiatingMessage_criticality),
        ('value', _InitiatingMessage_value),
        ])
    InitiatingMessage._ext = None
    
    #-----< SuccessfulOutcome >-----#
    SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE)
    _SuccessfulOutcome_procedureCode = INT(name='procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE'), ['procedureCode']))
    __SuccessfulOutcome_procedureCode_tab = CLASS(name='_tab_X2AP-ELEMENTARY-PROCEDURE', mode=MODE_SET, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'HandoverRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'HandoverRequestAcknowledge')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'HandoverPreparationFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResetRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResetResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2SetupRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2SetupResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2SetupFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResourceStatusRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResourceStatusResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_3 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResourceStatusFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENBConfigurationUpdate')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENBConfigurationUpdateAcknowledge')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_4 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENBConfigurationUpdateFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'MobilityChangeRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'MobilityChangeAcknowledge')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_5 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'MobilityChangeFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellActivationRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellActivationResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellActivationFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBAdditionRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBAdditionRequestAcknowledge')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_7 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBAdditionRequestReject')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationRequestAcknowledge')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_8 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationRequestReject')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationRequired')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_9 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationConfirm')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_9 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationRefuse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBReleaseRequired')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_10 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBReleaseConfirm')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2RemovalRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_11 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2RemovalResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_11 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2RemovalFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'RetrieveUEContextRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_12 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'RetrieveUEContextResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_12 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'RetrieveUEContextFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBAdditionRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_13 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBAdditionRequestAcknowledge')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_13 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBAdditionRequestReject')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBModificationRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_14 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBModificationRequestAcknowledge')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_14 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBModificationRequestReject')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBModificationRequired')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_15 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBModificationConfirm')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_15 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBModificationRefuse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBReleaseRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_16 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBReleaseRequestAcknowledge')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_16 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBReleaseRequestReject')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBReleaseRequired')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_17 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBReleaseConfirm')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBChangeRequired')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_18 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBChangeConfirm')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_18 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBChangeRefuse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCX2SetupRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_19 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCX2SetupResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_19 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCX2SetupFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCConfigurationUpdate')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_20 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCConfigurationUpdateAcknowledge')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_20 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCConfigurationUpdateFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCCellActivationRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_21 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCCellActivationResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_21 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCCellActivationFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_22 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCPartialResetRequired')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_22 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCPartialResetConfirm')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_23 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'EUTRANRCellResourceCoordinationRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_23 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'EUTRANRCellResourceCoordinationResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_24 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCX2RemovalRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_24 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCX2RemovalResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_24 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCX2RemovalFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_25 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCResourceStatusRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_25 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCResourceStatusResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_25 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCResourceStatusFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_26 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'UERadioCapabilityIDMappingRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_26 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'UERadioCapabilityIDMappingResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_27 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SNStatusTransfer')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_28 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'UEContextRelease')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_29 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'HandoverCancel')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_30 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ErrorIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_31 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResourceStatusUpdate')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_32 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'LoadInformation')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_33 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'PrivateMessage')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_34 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'RLFIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_35 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'HandoverReport')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_36 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2Release')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_37 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2APMessageTransfer')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_38 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBReconfigurationComplete')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_39 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBReleaseRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_40 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBCounterCheckRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_41 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBReconfigurationComplete')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_42 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBCounterCheckRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_43 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'RRCTransfer')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_44 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SecondaryRATDataUsageReport')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_45 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBActivityNotification')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_46 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'DataForwardingAddressIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_47 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'GNBStatusIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_48 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCConfigurationTransfer')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_49 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'DeactivateTrace')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_50 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'TraceStart')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_51 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'HandoverSuccess')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_52 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'EarlyStatusTransfer')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_53 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ConditionalHandoverCancel')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_54 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCResourceStatusUpdate')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_55 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellTrafficTrace')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_56 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'F1CTrafficTransfer')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_57 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'AccessAndMobilityIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_58 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CPC-cancel')))
    __SuccessfulOutcome_procedureCode_tab._val = ASN1Set(rv=[dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0), ('procedureCode', 0), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1), ('procedureCode', 7), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2), ('procedureCode', 6), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_3), ('procedureCode', 9), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_4), ('procedureCode', 8), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_5), ('procedureCode', 12), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6), ('procedureCode', 15), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_7), ('procedureCode', 19), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_8), ('procedureCode', 21), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_9), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_9), ('procedureCode', 22), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_10), ('procedureCode', 24), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_11), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_11), ('procedureCode', 18), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_12), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_12), ('procedureCode', 26), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_13), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_13), ('procedureCode', 27), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_14), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_14), ('procedureCode', 29), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_15), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_15), ('procedureCode', 30), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_16), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_16), ('procedureCode', 31), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_17), ('procedureCode', 32), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_18), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_18), ('procedureCode', 34), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_19), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_19), ('procedureCode', 36), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_20), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_20), ('procedureCode', 37), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_21), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_21), ('procedureCode', 39), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_22), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_22), ('procedureCode', 40), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_23), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_23), ('procedureCode', 41), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_24), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_24), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_24), ('procedureCode', 43), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_25), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_25), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_25), ('procedureCode', 54), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_26), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_26), ('procedureCode', 56), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_27), ('procedureCode', 4), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_28), ('procedureCode', 5), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_29), ('procedureCode', 1), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_30), ('procedureCode', 3), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_31), ('procedureCode', 10), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_32), ('procedureCode', 2), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_33), ('procedureCode', 11), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_34), ('procedureCode', 13), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_35), ('procedureCode', 14), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_36), ('procedureCode', 16), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_37), ('procedureCode', 17), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_38), ('procedureCode', 20), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_39), ('procedureCode', 23), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_40), ('procedureCode', 25), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_41), ('procedureCode', 28), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_42), ('procedureCode', 33), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_43), ('procedureCode', 35), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_44), ('procedureCode', 38), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_45), ('procedureCode', 42), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_46), ('procedureCode', 44), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_47), ('procedureCode', 45), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_48), ('procedureCode', 48), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_49), ('procedureCode', 46), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_50), ('procedureCode', 47), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_51), ('procedureCode', 49), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_52), ('procedureCode', 51), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_53), ('procedureCode', 50), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_54), ('procedureCode', 53), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_55), ('procedureCode', 52), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_56), ('procedureCode', 55), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_57), ('procedureCode', 57), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_58), ('procedureCode', 59), ('criticality', 'ignore')])], rr=[], ev=None, er=[])
    _SuccessfulOutcome_procedureCode._const_tab = __SuccessfulOutcome_procedureCode_tab
    _SuccessfulOutcome_procedureCode._const_tab_at = None
    _SuccessfulOutcome_procedureCode._const_tab_id = 'procedureCode'
    _SuccessfulOutcome_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE'), ['criticality']))
    _SuccessfulOutcome_criticality._const_tab = __SuccessfulOutcome_procedureCode_tab
    _SuccessfulOutcome_criticality._const_tab_at = ('..', 'procedureCode')
    _SuccessfulOutcome_criticality._const_tab_id = 'criticality'
    _SuccessfulOutcome_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE'), ['SuccessfulOutcome']))
    _SuccessfulOutcome_value._const_tab = __SuccessfulOutcome_procedureCode_tab
    _SuccessfulOutcome_value._const_tab_at = ('..', 'procedureCode')
    _SuccessfulOutcome_value._const_tab_id = 'SuccessfulOutcome'
    SuccessfulOutcome._cont = ASN1Dict([
        ('procedureCode', _SuccessfulOutcome_procedureCode),
        ('criticality', _SuccessfulOutcome_criticality),
        ('value', _SuccessfulOutcome_value),
        ])
    SuccessfulOutcome._ext = None
    
    #-----< UnsuccessfulOutcome >-----#
    UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE)
    _UnsuccessfulOutcome_procedureCode = INT(name='procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE'), ['procedureCode']))
    __UnsuccessfulOutcome_procedureCode_tab = CLASS(name='_tab_X2AP-ELEMENTARY-PROCEDURE', mode=MODE_SET, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'HandoverRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'HandoverRequestAcknowledge')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'HandoverPreparationFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResetRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResetResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2SetupRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2SetupResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2SetupFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResourceStatusRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResourceStatusResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_3 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResourceStatusFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENBConfigurationUpdate')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENBConfigurationUpdateAcknowledge')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_4 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENBConfigurationUpdateFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'MobilityChangeRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'MobilityChangeAcknowledge')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_5 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'MobilityChangeFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellActivationRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellActivationResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellActivationFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBAdditionRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBAdditionRequestAcknowledge')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_7 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBAdditionRequestReject')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationRequestAcknowledge')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_8 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationRequestReject')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationRequired')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_9 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationConfirm')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_9 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationRefuse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBReleaseRequired')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_10 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBReleaseConfirm')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2RemovalRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_11 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2RemovalResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_11 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2RemovalFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'RetrieveUEContextRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_12 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'RetrieveUEContextResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_12 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'RetrieveUEContextFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBAdditionRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_13 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBAdditionRequestAcknowledge')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_13 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBAdditionRequestReject')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBModificationRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_14 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBModificationRequestAcknowledge')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_14 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBModificationRequestReject')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBModificationRequired')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_15 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBModificationConfirm')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_15 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBModificationRefuse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBReleaseRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_16 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBReleaseRequestAcknowledge')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_16 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBReleaseRequestReject')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBReleaseRequired')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_17 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBReleaseConfirm')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBChangeRequired')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_18 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBChangeConfirm')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_18 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBChangeRefuse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCX2SetupRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_19 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCX2SetupResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_19 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCX2SetupFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCConfigurationUpdate')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_20 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCConfigurationUpdateAcknowledge')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_20 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCConfigurationUpdateFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCCellActivationRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_21 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCCellActivationResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_21 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCCellActivationFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_22 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCPartialResetRequired')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_22 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCPartialResetConfirm')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_23 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'EUTRANRCellResourceCoordinationRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_23 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'EUTRANRCellResourceCoordinationResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_24 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCX2RemovalRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_24 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCX2RemovalResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_24 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCX2RemovalFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_25 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCResourceStatusRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_25 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCResourceStatusResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_25 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCResourceStatusFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_26 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'UERadioCapabilityIDMappingRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_26 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'UERadioCapabilityIDMappingResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_27 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SNStatusTransfer')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_28 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'UEContextRelease')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_29 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'HandoverCancel')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_30 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ErrorIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_31 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResourceStatusUpdate')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_32 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'LoadInformation')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_33 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'PrivateMessage')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_34 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'RLFIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_35 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'HandoverReport')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_36 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2Release')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_37 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2APMessageTransfer')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_38 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBReconfigurationComplete')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_39 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBReleaseRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_40 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBCounterCheckRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_41 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBReconfigurationComplete')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_42 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBCounterCheckRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_43 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'RRCTransfer')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_44 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SecondaryRATDataUsageReport')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_45 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBActivityNotification')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_46 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'DataForwardingAddressIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_47 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'GNBStatusIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_48 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCConfigurationTransfer')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_49 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'DeactivateTrace')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_50 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'TraceStart')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_51 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'HandoverSuccess')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_52 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'EarlyStatusTransfer')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_53 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ConditionalHandoverCancel')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_54 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCResourceStatusUpdate')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_55 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellTrafficTrace')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_56 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'F1CTrafficTransfer')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_57 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'AccessAndMobilityIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_58 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CPC-cancel')))
    __UnsuccessfulOutcome_procedureCode_tab._val = ASN1Set(rv=[dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0), ('procedureCode', 0), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1), ('procedureCode', 7), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2), ('procedureCode', 6), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_3), ('procedureCode', 9), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_4), ('procedureCode', 8), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_5), ('procedureCode', 12), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6), ('procedureCode', 15), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_7), ('procedureCode', 19), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_8), ('procedureCode', 21), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_9), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_9), ('procedureCode', 22), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_10), ('procedureCode', 24), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_11), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_11), ('procedureCode', 18), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_12), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_12), ('procedureCode', 26), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_13), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_13), ('procedureCode', 27), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_14), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_14), ('procedureCode', 29), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_15), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_15), ('procedureCode', 30), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_16), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_16), ('procedureCode', 31), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_17), ('procedureCode', 32), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_18), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_18), ('procedureCode', 34), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_19), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_19), ('procedureCode', 36), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_20), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_20), ('procedureCode', 37), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_21), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_21), ('procedureCode', 39), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_22), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_22), ('procedureCode', 40), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_23), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_23), ('procedureCode', 41), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_24), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_24), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_24), ('procedureCode', 43), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_25), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_25), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_25), ('procedureCode', 54), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_26), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_26), ('procedureCode', 56), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_27), ('procedureCode', 4), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_28), ('procedureCode', 5), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_29), ('procedureCode', 1), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_30), ('procedureCode', 3), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_31), ('procedureCode', 10), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_32), ('procedureCode', 2), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_33), ('procedureCode', 11), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_34), ('procedureCode', 13), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_35), ('procedureCode', 14), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_36), ('procedureCode', 16), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_37), ('procedureCode', 17), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_38), ('procedureCode', 20), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_39), ('procedureCode', 23), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_40), ('procedureCode', 25), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_41), ('procedureCode', 28), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_42), ('procedureCode', 33), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_43), ('procedureCode', 35), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_44), ('procedureCode', 38), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_45), ('procedureCode', 42), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_46), ('procedureCode', 44), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_47), ('procedureCode', 45), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_48), ('procedureCode', 48), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_49), ('procedureCode', 46), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_50), ('procedureCode', 47), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_51), ('procedureCode', 49), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_52), ('procedureCode', 51), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_53), ('procedureCode', 50), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_54), ('procedureCode', 53), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_55), ('procedureCode', 52), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_56), ('procedureCode', 55), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_57), ('procedureCode', 57), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_58), ('procedureCode', 59), ('criticality', 'ignore')])], rr=[], ev=None, er=[])
    _UnsuccessfulOutcome_procedureCode._const_tab = __UnsuccessfulOutcome_procedureCode_tab
    _UnsuccessfulOutcome_procedureCode._const_tab_at = None
    _UnsuccessfulOutcome_procedureCode._const_tab_id = 'procedureCode'
    _UnsuccessfulOutcome_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE'), ['criticality']))
    _UnsuccessfulOutcome_criticality._const_tab = __UnsuccessfulOutcome_procedureCode_tab
    _UnsuccessfulOutcome_criticality._const_tab_at = ('..', 'procedureCode')
    _UnsuccessfulOutcome_criticality._const_tab_id = 'criticality'
    _UnsuccessfulOutcome_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE'), ['UnsuccessfulOutcome']))
    _UnsuccessfulOutcome_value._const_tab = __UnsuccessfulOutcome_procedureCode_tab
    _UnsuccessfulOutcome_value._const_tab_at = ('..', 'procedureCode')
    _UnsuccessfulOutcome_value._const_tab_id = 'UnsuccessfulOutcome'
    UnsuccessfulOutcome._cont = ASN1Dict([
        ('procedureCode', _UnsuccessfulOutcome_procedureCode),
        ('criticality', _UnsuccessfulOutcome_criticality),
        ('value', _UnsuccessfulOutcome_value),
        ])
    UnsuccessfulOutcome._ext = None
    
    #-----< X2AP-ELEMENTARY-PROCEDURES >-----#
    X2AP_ELEMENTARY_PROCEDURES = CLASS(name='X2AP-ELEMENTARY-PROCEDURES', mode=MODE_SET, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'HandoverRequest')))
    _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_0 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'HandoverRequestAcknowledge')))
    _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_0 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'HandoverPreparationFailure')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResetRequest')))
    _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_1 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResetResponse')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2SetupRequest')))
    _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_2 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2SetupResponse')))
    _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_2 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2SetupFailure')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResourceStatusRequest')))
    _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_3 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResourceStatusResponse')))
    _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_3 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResourceStatusFailure')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENBConfigurationUpdate')))
    _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_4 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENBConfigurationUpdateAcknowledge')))
    _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_4 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENBConfigurationUpdateFailure')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'MobilityChangeRequest')))
    _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_5 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'MobilityChangeAcknowledge')))
    _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_5 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'MobilityChangeFailure')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_6 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellActivationRequest')))
    _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_6 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellActivationResponse')))
    _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_6 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellActivationFailure')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_7 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBAdditionRequest')))
    _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_7 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBAdditionRequestAcknowledge')))
    _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_7 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBAdditionRequestReject')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_8 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationRequest')))
    _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_8 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationRequestAcknowledge')))
    _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_8 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationRequestReject')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_9 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationRequired')))
    _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_9 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationConfirm')))
    _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_9 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationRefuse')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_10 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBReleaseRequired')))
    _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_10 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBReleaseConfirm')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_11 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2RemovalRequest')))
    _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_11 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2RemovalResponse')))
    _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_11 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2RemovalFailure')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_12 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'RetrieveUEContextRequest')))
    _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_12 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'RetrieveUEContextResponse')))
    _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_12 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'RetrieveUEContextFailure')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_13 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBAdditionRequest')))
    _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_13 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBAdditionRequestAcknowledge')))
    _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_13 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBAdditionRequestReject')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_14 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBModificationRequest')))
    _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_14 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBModificationRequestAcknowledge')))
    _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_14 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBModificationRequestReject')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_15 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBModificationRequired')))
    _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_15 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBModificationConfirm')))
    _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_15 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBModificationRefuse')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_16 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBReleaseRequest')))
    _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_16 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBReleaseRequestAcknowledge')))
    _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_16 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBReleaseRequestReject')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_17 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBReleaseRequired')))
    _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_17 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBReleaseConfirm')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_18 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBChangeRequired')))
    _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_18 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBChangeConfirm')))
    _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_18 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBChangeRefuse')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_19 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCX2SetupRequest')))
    _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_19 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCX2SetupResponse')))
    _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_19 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCX2SetupFailure')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_20 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCConfigurationUpdate')))
    _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_20 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCConfigurationUpdateAcknowledge')))
    _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_20 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCConfigurationUpdateFailure')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_21 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCCellActivationRequest')))
    _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_21 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCCellActivationResponse')))
    _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_21 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCCellActivationFailure')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_22 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCPartialResetRequired')))
    _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_22 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCPartialResetConfirm')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_23 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'EUTRANRCellResourceCoordinationRequest')))
    _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_23 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'EUTRANRCellResourceCoordinationResponse')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_24 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCX2RemovalRequest')))
    _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_24 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCX2RemovalResponse')))
    _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_24 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCX2RemovalFailure')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_25 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCResourceStatusRequest')))
    _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_25 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCResourceStatusResponse')))
    _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_25 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCResourceStatusFailure')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_26 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'UERadioCapabilityIDMappingRequest')))
    _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_26 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'UERadioCapabilityIDMappingResponse')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_27 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SNStatusTransfer')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_28 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'UEContextRelease')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_29 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'HandoverCancel')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_30 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ErrorIndication')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_31 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResourceStatusUpdate')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_32 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'LoadInformation')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_33 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'PrivateMessage')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_34 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'RLFIndication')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_35 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'HandoverReport')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_36 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2Release')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_37 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2APMessageTransfer')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_38 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBReconfigurationComplete')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_39 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBReleaseRequest')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_40 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBCounterCheckRequest')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_41 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBReconfigurationComplete')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_42 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBCounterCheckRequest')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_43 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'RRCTransfer')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_44 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SecondaryRATDataUsageReport')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_45 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBActivityNotification')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_46 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'DataForwardingAddressIndication')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_47 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'GNBStatusIndication')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_48 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCConfigurationTransfer')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_49 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'DeactivateTrace')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_50 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'TraceStart')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_51 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'HandoverSuccess')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_52 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'EarlyStatusTransfer')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_53 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ConditionalHandoverCancel')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_54 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCResourceStatusUpdate')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_55 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellTrafficTrace')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_56 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'F1CTrafficTransfer')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_57 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'AccessAndMobilityIndication')))
    _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_58 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CPC-cancel')))
    X2AP_ELEMENTARY_PROCEDURES._val = ASN1Set(rv=[dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_0), ('SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_0), ('UnsuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_0), ('procedureCode', 0), ('criticality', 'reject')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_1), ('SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_1), ('procedureCode', 7), ('criticality', 'reject')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_2), ('SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_2), ('UnsuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_2), ('procedureCode', 6), ('criticality', 'reject')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_3), ('SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_3), ('UnsuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_3), ('procedureCode', 9), ('criticality', 'reject')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_4), ('SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_4), ('UnsuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_4), ('procedureCode', 8), ('criticality', 'reject')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_5), ('SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_5), ('UnsuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_5), ('procedureCode', 12), ('criticality', 'reject')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_6), ('SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_6), ('UnsuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_6), ('procedureCode', 15), ('criticality', 'reject')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_7), ('SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_7), ('UnsuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_7), ('procedureCode', 19), ('criticality', 'reject')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_8), ('SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_8), ('UnsuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_8), ('procedureCode', 21), ('criticality', 'reject')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_9), ('SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_9), ('UnsuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_9), ('procedureCode', 22), ('criticality', 'reject')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_10), ('SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_10), ('procedureCode', 24), ('criticality', 'reject')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_11), ('SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_11), ('UnsuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_11), ('procedureCode', 18), ('criticality', 'reject')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_12), ('SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_12), ('UnsuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_12), ('procedureCode', 26), ('criticality', 'reject')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_13), ('SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_13), ('UnsuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_13), ('procedureCode', 27), ('criticality', 'reject')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_14), ('SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_14), ('UnsuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_14), ('procedureCode', 29), ('criticality', 'reject')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_15), ('SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_15), ('UnsuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_15), ('procedureCode', 30), ('criticality', 'reject')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_16), ('SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_16), ('UnsuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_16), ('procedureCode', 31), ('criticality', 'ignore')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_17), ('SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_17), ('procedureCode', 32), ('criticality', 'reject')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_18), ('SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_18), ('UnsuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_18), ('procedureCode', 34), ('criticality', 'reject')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_19), ('SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_19), ('UnsuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_19), ('procedureCode', 36), ('criticality', 'reject')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_20), ('SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_20), ('UnsuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_20), ('procedureCode', 37), ('criticality', 'reject')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_21), ('SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_21), ('UnsuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_21), ('procedureCode', 39), ('criticality', 'reject')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_22), ('SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_22), ('procedureCode', 40), ('criticality', 'reject')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_23), ('SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_23), ('procedureCode', 41), ('criticality', 'reject')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_24), ('SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_24), ('UnsuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_24), ('procedureCode', 43), ('criticality', 'reject')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_25), ('SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_25), ('UnsuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_25), ('procedureCode', 54), ('criticality', 'reject')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_26), ('SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_26), ('procedureCode', 56), ('criticality', 'reject')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_27), ('procedureCode', 4), ('criticality', 'ignore')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_28), ('procedureCode', 5), ('criticality', 'ignore')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_29), ('procedureCode', 1), ('criticality', 'ignore')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_30), ('procedureCode', 3), ('criticality', 'ignore')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_31), ('procedureCode', 10), ('criticality', 'ignore')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_32), ('procedureCode', 2), ('criticality', 'ignore')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_33), ('procedureCode', 11), ('criticality', 'ignore')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_34), ('procedureCode', 13), ('criticality', 'ignore')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_35), ('procedureCode', 14), ('criticality', 'ignore')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_36), ('procedureCode', 16), ('criticality', 'reject')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_37), ('procedureCode', 17), ('criticality', 'reject')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_38), ('procedureCode', 20), ('criticality', 'ignore')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_39), ('procedureCode', 23), ('criticality', 'ignore')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_40), ('procedureCode', 25), ('criticality', 'reject')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_41), ('procedureCode', 28), ('criticality', 'ignore')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_42), ('procedureCode', 33), ('criticality', 'reject')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_43), ('procedureCode', 35), ('criticality', 'reject')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_44), ('procedureCode', 38), ('criticality', 'reject')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_45), ('procedureCode', 42), ('criticality', 'reject')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_46), ('procedureCode', 44), ('criticality', 'ignore')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_47), ('procedureCode', 45), ('criticality', 'ignore')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_48), ('procedureCode', 48), ('criticality', 'ignore')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_49), ('procedureCode', 46), ('criticality', 'ignore')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_50), ('procedureCode', 47), ('criticality', 'ignore')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_51), ('procedureCode', 49), ('criticality', 'ignore')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_52), ('procedureCode', 51), ('criticality', 'ignore')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_53), ('procedureCode', 50), ('criticality', 'ignore')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_54), ('procedureCode', 53), ('criticality', 'ignore')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_55), ('procedureCode', 52), ('criticality', 'ignore')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_56), ('procedureCode', 55), ('criticality', 'ignore')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_57), ('procedureCode', 57), ('criticality', 'ignore')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_58), ('procedureCode', 59), ('criticality', 'ignore')])], rr=[], ev=[], er=[])
    
    #-----< X2AP-ELEMENTARY-PROCEDURES-CLASS-1 >-----#
    X2AP_ELEMENTARY_PROCEDURES_CLASS_1 = CLASS(name='X2AP-ELEMENTARY-PROCEDURES-CLASS-1', mode=MODE_SET, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'HandoverRequest')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_0 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'HandoverRequestAcknowledge')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_0 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'HandoverPreparationFailure')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResetRequest')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_1 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResetResponse')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2SetupRequest')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_2 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2SetupResponse')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_2 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2SetupFailure')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResourceStatusRequest')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_3 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResourceStatusResponse')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_3 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResourceStatusFailure')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENBConfigurationUpdate')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_4 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENBConfigurationUpdateAcknowledge')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_4 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENBConfigurationUpdateFailure')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'MobilityChangeRequest')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_5 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'MobilityChangeAcknowledge')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_5 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'MobilityChangeFailure')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_6 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellActivationRequest')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_6 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellActivationResponse')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_6 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellActivationFailure')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_7 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBAdditionRequest')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_7 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBAdditionRequestAcknowledge')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_7 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBAdditionRequestReject')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_8 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationRequest')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_8 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationRequestAcknowledge')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_8 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationRequestReject')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_9 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationRequired')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_9 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationConfirm')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_9 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationRefuse')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_10 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBReleaseRequired')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_10 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBReleaseConfirm')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_11 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2RemovalRequest')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_11 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2RemovalResponse')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_11 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2RemovalFailure')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_12 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'RetrieveUEContextRequest')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_12 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'RetrieveUEContextResponse')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_12 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'RetrieveUEContextFailure')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_13 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBAdditionRequest')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_13 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBAdditionRequestAcknowledge')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_13 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBAdditionRequestReject')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_14 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBModificationRequest')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_14 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBModificationRequestAcknowledge')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_14 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBModificationRequestReject')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_15 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBModificationRequired')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_15 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBModificationConfirm')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_15 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBModificationRefuse')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_16 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBReleaseRequest')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_16 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBReleaseRequestAcknowledge')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_16 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBReleaseRequestReject')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_17 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBReleaseRequired')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_17 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBReleaseConfirm')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_18 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBChangeRequired')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_18 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBChangeConfirm')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_18 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBChangeRefuse')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_19 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCX2SetupRequest')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_19 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCX2SetupResponse')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_19 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCX2SetupFailure')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_20 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCConfigurationUpdate')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_20 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCConfigurationUpdateAcknowledge')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_20 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCConfigurationUpdateFailure')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_21 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCCellActivationRequest')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_21 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCCellActivationResponse')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_21 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCCellActivationFailure')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_22 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCPartialResetRequired')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_22 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCPartialResetConfirm')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_23 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'EUTRANRCellResourceCoordinationRequest')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_23 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'EUTRANRCellResourceCoordinationResponse')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_24 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCX2RemovalRequest')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_24 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCX2RemovalResponse')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_24 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCX2RemovalFailure')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_25 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCResourceStatusRequest')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_25 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCResourceStatusResponse')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_25 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCResourceStatusFailure')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_26 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'UERadioCapabilityIDMappingRequest')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_26 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'UERadioCapabilityIDMappingResponse')))
    X2AP_ELEMENTARY_PROCEDURES_CLASS_1._val = ASN1Set(rv=[dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_0), ('SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_0), ('UnsuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_0), ('procedureCode', 0), ('criticality', 'reject')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_1), ('SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_1), ('procedureCode', 7), ('criticality', 'reject')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_2), ('SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_2), ('UnsuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_2), ('procedureCode', 6), ('criticality', 'reject')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_3), ('SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_3), ('UnsuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_3), ('procedureCode', 9), ('criticality', 'reject')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_4), ('SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_4), ('UnsuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_4), ('procedureCode', 8), ('criticality', 'reject')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_5), ('SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_5), ('UnsuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_5), ('procedureCode', 12), ('criticality', 'reject')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_6), ('SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_6), ('UnsuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_6), ('procedureCode', 15), ('criticality', 'reject')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_7), ('SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_7), ('UnsuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_7), ('procedureCode', 19), ('criticality', 'reject')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_8), ('SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_8), ('UnsuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_8), ('procedureCode', 21), ('criticality', 'reject')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_9), ('SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_9), ('UnsuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_9), ('procedureCode', 22), ('criticality', 'reject')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_10), ('SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_10), ('procedureCode', 24), ('criticality', 'reject')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_11), ('SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_11), ('UnsuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_11), ('procedureCode', 18), ('criticality', 'reject')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_12), ('SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_12), ('UnsuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_12), ('procedureCode', 26), ('criticality', 'reject')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_13), ('SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_13), ('UnsuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_13), ('procedureCode', 27), ('criticality', 'reject')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_14), ('SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_14), ('UnsuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_14), ('procedureCode', 29), ('criticality', 'reject')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_15), ('SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_15), ('UnsuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_15), ('procedureCode', 30), ('criticality', 'reject')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_16), ('SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_16), ('UnsuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_16), ('procedureCode', 31), ('criticality', 'ignore')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_17), ('SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_17), ('procedureCode', 32), ('criticality', 'reject')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_18), ('SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_18), ('UnsuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_18), ('procedureCode', 34), ('criticality', 'reject')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_19), ('SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_19), ('UnsuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_19), ('procedureCode', 36), ('criticality', 'reject')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_20), ('SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_20), ('UnsuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_20), ('procedureCode', 37), ('criticality', 'reject')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_21), ('SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_21), ('UnsuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_21), ('procedureCode', 39), ('criticality', 'reject')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_22), ('SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_22), ('procedureCode', 40), ('criticality', 'reject')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_23), ('SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_23), ('procedureCode', 41), ('criticality', 'reject')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_24), ('SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_24), ('UnsuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_24), ('procedureCode', 43), ('criticality', 'reject')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_25), ('SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_25), ('UnsuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_25), ('procedureCode', 54), ('criticality', 'reject')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_26), ('SuccessfulOutcome', _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_26), ('procedureCode', 56), ('criticality', 'reject')])], rr=[], ev=[], er=[])
    
    #-----< X2AP-ELEMENTARY-PROCEDURES-CLASS-2 >-----#
    X2AP_ELEMENTARY_PROCEDURES_CLASS_2 = CLASS(name='X2AP-ELEMENTARY-PROCEDURES-CLASS-2', mode=MODE_SET, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SNStatusTransfer')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'UEContextRelease')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'HandoverCancel')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ErrorIndication')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResourceStatusUpdate')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'LoadInformation')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_6 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'PrivateMessage')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_7 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'RLFIndication')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_8 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'HandoverReport')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_9 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2Release')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_10 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2APMessageTransfer')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_11 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBReconfigurationComplete')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_12 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBReleaseRequest')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_13 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBCounterCheckRequest')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_14 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBReconfigurationComplete')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_15 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBCounterCheckRequest')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_16 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'RRCTransfer')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_17 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SecondaryRATDataUsageReport')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_18 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBActivityNotification')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_19 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'DataForwardingAddressIndication')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_20 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'GNBStatusIndication')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_21 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCConfigurationTransfer')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_22 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'DeactivateTrace')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_23 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'TraceStart')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_24 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'HandoverSuccess')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_25 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'EarlyStatusTransfer')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_26 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ConditionalHandoverCancel')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_27 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCResourceStatusUpdate')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_28 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellTrafficTrace')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_29 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'F1CTrafficTransfer')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_30 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'AccessAndMobilityIndication')))
    _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_31 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CPC-cancel')))
    X2AP_ELEMENTARY_PROCEDURES_CLASS_2._val = ASN1Set(rv=[dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_0), ('procedureCode', 4), ('criticality', 'ignore')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_1), ('procedureCode', 5), ('criticality', 'ignore')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_2), ('procedureCode', 1), ('criticality', 'ignore')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_3), ('procedureCode', 3), ('criticality', 'ignore')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_4), ('procedureCode', 10), ('criticality', 'ignore')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_5), ('procedureCode', 2), ('criticality', 'ignore')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_6), ('procedureCode', 11), ('criticality', 'ignore')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_7), ('procedureCode', 13), ('criticality', 'ignore')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_8), ('procedureCode', 14), ('criticality', 'ignore')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_9), ('procedureCode', 16), ('criticality', 'reject')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_10), ('procedureCode', 17), ('criticality', 'reject')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_11), ('procedureCode', 20), ('criticality', 'ignore')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_12), ('procedureCode', 23), ('criticality', 'ignore')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_13), ('procedureCode', 25), ('criticality', 'reject')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_14), ('procedureCode', 28), ('criticality', 'ignore')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_15), ('procedureCode', 33), ('criticality', 'reject')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_16), ('procedureCode', 35), ('criticality', 'reject')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_17), ('procedureCode', 38), ('criticality', 'reject')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_18), ('procedureCode', 42), ('criticality', 'reject')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_19), ('procedureCode', 44), ('criticality', 'ignore')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_20), ('procedureCode', 45), ('criticality', 'ignore')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_21), ('procedureCode', 48), ('criticality', 'ignore')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_22), ('procedureCode', 46), ('criticality', 'ignore')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_23), ('procedureCode', 47), ('criticality', 'ignore')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_24), ('procedureCode', 49), ('criticality', 'ignore')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_25), ('procedureCode', 51), ('criticality', 'ignore')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_26), ('procedureCode', 50), ('criticality', 'ignore')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_27), ('procedureCode', 53), ('criticality', 'ignore')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_28), ('procedureCode', 52), ('criticality', 'ignore')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_29), ('procedureCode', 55), ('criticality', 'ignore')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_30), ('procedureCode', 57), ('criticality', 'ignore')]), dict([('InitiatingMessage', _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_31), ('procedureCode', 59), ('criticality', 'ignore')])], rr=[], ev=[], er=[])
    
    #-----< handoverPreparation >-----#
    handoverPreparation = CLASS(name='handoverPreparation', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _handoverPreparation_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'HandoverRequest')))
    _handoverPreparation_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'HandoverRequestAcknowledge')))
    _handoverPreparation_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'HandoverPreparationFailure')))
    handoverPreparation._val = dict([('InitiatingMessage', _handoverPreparation_val_InitiatingMessage), ('SuccessfulOutcome', _handoverPreparation_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _handoverPreparation_val_UnsuccessfulOutcome), ('procedureCode', 0), ('criticality', 'reject')])
    
    #-----< snStatusTransfer >-----#
    snStatusTransfer = CLASS(name='snStatusTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _snStatusTransfer_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SNStatusTransfer')))
    snStatusTransfer._val = dict([('InitiatingMessage', _snStatusTransfer_val_InitiatingMessage), ('procedureCode', 4), ('criticality', 'ignore')])
    
    #-----< uEContextRelease >-----#
    uEContextRelease = CLASS(name='uEContextRelease', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _uEContextRelease_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'UEContextRelease')))
    uEContextRelease._val = dict([('InitiatingMessage', _uEContextRelease_val_InitiatingMessage), ('procedureCode', 5), ('criticality', 'ignore')])
    
    #-----< handoverCancel >-----#
    handoverCancel = CLASS(name='handoverCancel', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _handoverCancel_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'HandoverCancel')))
    handoverCancel._val = dict([('InitiatingMessage', _handoverCancel_val_InitiatingMessage), ('procedureCode', 1), ('criticality', 'ignore')])
    
    #-----< handoverReport >-----#
    handoverReport = CLASS(name='handoverReport', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _handoverReport_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'HandoverReport')))
    handoverReport._val = dict([('InitiatingMessage', _handoverReport_val_InitiatingMessage), ('procedureCode', 14), ('criticality', 'ignore')])
    
    #-----< errorIndication >-----#
    errorIndication = CLASS(name='errorIndication', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _errorIndication_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ErrorIndication')))
    errorIndication._val = dict([('InitiatingMessage', _errorIndication_val_InitiatingMessage), ('procedureCode', 3), ('criticality', 'ignore')])
    
    #-----< reset >-----#
    reset = CLASS(name='reset', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _reset_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResetRequest')))
    _reset_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResetResponse')))
    reset._val = dict([('InitiatingMessage', _reset_val_InitiatingMessage), ('SuccessfulOutcome', _reset_val_SuccessfulOutcome), ('procedureCode', 7), ('criticality', 'reject')])
    
    #-----< x2Setup >-----#
    x2Setup = CLASS(name='x2Setup', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _x2Setup_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2SetupRequest')))
    _x2Setup_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2SetupResponse')))
    _x2Setup_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2SetupFailure')))
    x2Setup._val = dict([('InitiatingMessage', _x2Setup_val_InitiatingMessage), ('SuccessfulOutcome', _x2Setup_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _x2Setup_val_UnsuccessfulOutcome), ('procedureCode', 6), ('criticality', 'reject')])
    
    #-----< loadIndication >-----#
    loadIndication = CLASS(name='loadIndication', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _loadIndication_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'LoadInformation')))
    loadIndication._val = dict([('InitiatingMessage', _loadIndication_val_InitiatingMessage), ('procedureCode', 2), ('criticality', 'ignore')])
    
    #-----< eNBConfigurationUpdate >-----#
    eNBConfigurationUpdate = CLASS(name='eNBConfigurationUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _eNBConfigurationUpdate_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENBConfigurationUpdate')))
    _eNBConfigurationUpdate_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENBConfigurationUpdateAcknowledge')))
    _eNBConfigurationUpdate_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENBConfigurationUpdateFailure')))
    eNBConfigurationUpdate._val = dict([('InitiatingMessage', _eNBConfigurationUpdate_val_InitiatingMessage), ('SuccessfulOutcome', _eNBConfigurationUpdate_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _eNBConfigurationUpdate_val_UnsuccessfulOutcome), ('procedureCode', 8), ('criticality', 'reject')])
    
    #-----< resourceStatusReportingInitiation >-----#
    resourceStatusReportingInitiation = CLASS(name='resourceStatusReportingInitiation', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _resourceStatusReportingInitiation_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResourceStatusRequest')))
    _resourceStatusReportingInitiation_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResourceStatusResponse')))
    _resourceStatusReportingInitiation_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResourceStatusFailure')))
    resourceStatusReportingInitiation._val = dict([('InitiatingMessage', _resourceStatusReportingInitiation_val_InitiatingMessage), ('SuccessfulOutcome', _resourceStatusReportingInitiation_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _resourceStatusReportingInitiation_val_UnsuccessfulOutcome), ('procedureCode', 9), ('criticality', 'reject')])
    
    #-----< resourceStatusReporting >-----#
    resourceStatusReporting = CLASS(name='resourceStatusReporting', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _resourceStatusReporting_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ResourceStatusUpdate')))
    resourceStatusReporting._val = dict([('InitiatingMessage', _resourceStatusReporting_val_InitiatingMessage), ('procedureCode', 10), ('criticality', 'ignore')])
    
    #-----< rLFIndication >-----#
    rLFIndication = CLASS(name='rLFIndication', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _rLFIndication_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'RLFIndication')))
    rLFIndication._val = dict([('InitiatingMessage', _rLFIndication_val_InitiatingMessage), ('procedureCode', 13), ('criticality', 'ignore')])
    
    #-----< privateMessage >-----#
    privateMessage = CLASS(name='privateMessage', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _privateMessage_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'PrivateMessage')))
    privateMessage._val = dict([('InitiatingMessage', _privateMessage_val_InitiatingMessage), ('procedureCode', 11), ('criticality', 'ignore')])
    
    #-----< mobilitySettingsChange >-----#
    mobilitySettingsChange = CLASS(name='mobilitySettingsChange', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _mobilitySettingsChange_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'MobilityChangeRequest')))
    _mobilitySettingsChange_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'MobilityChangeAcknowledge')))
    _mobilitySettingsChange_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'MobilityChangeFailure')))
    mobilitySettingsChange._val = dict([('InitiatingMessage', _mobilitySettingsChange_val_InitiatingMessage), ('SuccessfulOutcome', _mobilitySettingsChange_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _mobilitySettingsChange_val_UnsuccessfulOutcome), ('procedureCode', 12), ('criticality', 'reject')])
    
    #-----< cellActivation >-----#
    cellActivation = CLASS(name='cellActivation', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _cellActivation_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellActivationRequest')))
    _cellActivation_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellActivationResponse')))
    _cellActivation_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellActivationFailure')))
    cellActivation._val = dict([('InitiatingMessage', _cellActivation_val_InitiatingMessage), ('SuccessfulOutcome', _cellActivation_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _cellActivation_val_UnsuccessfulOutcome), ('procedureCode', 15), ('criticality', 'reject')])
    
    #-----< x2Release >-----#
    x2Release = CLASS(name='x2Release', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _x2Release_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2Release')))
    x2Release._val = dict([('InitiatingMessage', _x2Release_val_InitiatingMessage), ('procedureCode', 16), ('criticality', 'reject')])
    
    #-----< x2APMessageTransfer >-----#
    x2APMessageTransfer = CLASS(name='x2APMessageTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _x2APMessageTransfer_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2APMessageTransfer')))
    x2APMessageTransfer._val = dict([('InitiatingMessage', _x2APMessageTransfer_val_InitiatingMessage), ('procedureCode', 17), ('criticality', 'reject')])
    
    #-----< seNBAdditionPreparation >-----#
    seNBAdditionPreparation = CLASS(name='seNBAdditionPreparation', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _seNBAdditionPreparation_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBAdditionRequest')))
    _seNBAdditionPreparation_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBAdditionRequestAcknowledge')))
    _seNBAdditionPreparation_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBAdditionRequestReject')))
    seNBAdditionPreparation._val = dict([('InitiatingMessage', _seNBAdditionPreparation_val_InitiatingMessage), ('SuccessfulOutcome', _seNBAdditionPreparation_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _seNBAdditionPreparation_val_UnsuccessfulOutcome), ('procedureCode', 19), ('criticality', 'reject')])
    
    #-----< seNBReconfigurationCompletion >-----#
    seNBReconfigurationCompletion = CLASS(name='seNBReconfigurationCompletion', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _seNBReconfigurationCompletion_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBReconfigurationComplete')))
    seNBReconfigurationCompletion._val = dict([('InitiatingMessage', _seNBReconfigurationCompletion_val_InitiatingMessage), ('procedureCode', 20), ('criticality', 'ignore')])
    
    #-----< meNBinitiatedSeNBModificationPreparation >-----#
    meNBinitiatedSeNBModificationPreparation = CLASS(name='meNBinitiatedSeNBModificationPreparation', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _meNBinitiatedSeNBModificationPreparation_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationRequest')))
    _meNBinitiatedSeNBModificationPreparation_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationRequestAcknowledge')))
    _meNBinitiatedSeNBModificationPreparation_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationRequestReject')))
    meNBinitiatedSeNBModificationPreparation._val = dict([('InitiatingMessage', _meNBinitiatedSeNBModificationPreparation_val_InitiatingMessage), ('SuccessfulOutcome', _meNBinitiatedSeNBModificationPreparation_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _meNBinitiatedSeNBModificationPreparation_val_UnsuccessfulOutcome), ('procedureCode', 21), ('criticality', 'reject')])
    
    #-----< seNBinitiatedSeNBModification >-----#
    seNBinitiatedSeNBModification = CLASS(name='seNBinitiatedSeNBModification', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _seNBinitiatedSeNBModification_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationRequired')))
    _seNBinitiatedSeNBModification_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationConfirm')))
    _seNBinitiatedSeNBModification_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBModificationRefuse')))
    seNBinitiatedSeNBModification._val = dict([('InitiatingMessage', _seNBinitiatedSeNBModification_val_InitiatingMessage), ('SuccessfulOutcome', _seNBinitiatedSeNBModification_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _seNBinitiatedSeNBModification_val_UnsuccessfulOutcome), ('procedureCode', 22), ('criticality', 'reject')])
    
    #-----< meNBinitiatedSeNBRelease >-----#
    meNBinitiatedSeNBRelease = CLASS(name='meNBinitiatedSeNBRelease', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _meNBinitiatedSeNBRelease_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBReleaseRequest')))
    meNBinitiatedSeNBRelease._val = dict([('InitiatingMessage', _meNBinitiatedSeNBRelease_val_InitiatingMessage), ('procedureCode', 23), ('criticality', 'ignore')])
    
    #-----< seNBinitiatedSeNBRelease >-----#
    seNBinitiatedSeNBRelease = CLASS(name='seNBinitiatedSeNBRelease', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _seNBinitiatedSeNBRelease_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBReleaseRequired')))
    _seNBinitiatedSeNBRelease_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBReleaseConfirm')))
    seNBinitiatedSeNBRelease._val = dict([('InitiatingMessage', _seNBinitiatedSeNBRelease_val_InitiatingMessage), ('SuccessfulOutcome', _seNBinitiatedSeNBRelease_val_SuccessfulOutcome), ('procedureCode', 24), ('criticality', 'reject')])
    
    #-----< seNBCounterCheck >-----#
    seNBCounterCheck = CLASS(name='seNBCounterCheck', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _seNBCounterCheck_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SeNBCounterCheckRequest')))
    seNBCounterCheck._val = dict([('InitiatingMessage', _seNBCounterCheck_val_InitiatingMessage), ('procedureCode', 25), ('criticality', 'reject')])
    
    #-----< x2Removal >-----#
    x2Removal = CLASS(name='x2Removal', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _x2Removal_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2RemovalRequest')))
    _x2Removal_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2RemovalResponse')))
    _x2Removal_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'X2RemovalFailure')))
    x2Removal._val = dict([('InitiatingMessage', _x2Removal_val_InitiatingMessage), ('SuccessfulOutcome', _x2Removal_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _x2Removal_val_UnsuccessfulOutcome), ('procedureCode', 18), ('criticality', 'reject')])
    
    #-----< retrieveUEContext >-----#
    retrieveUEContext = CLASS(name='retrieveUEContext', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _retrieveUEContext_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'RetrieveUEContextRequest')))
    _retrieveUEContext_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'RetrieveUEContextResponse')))
    _retrieveUEContext_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'RetrieveUEContextFailure')))
    retrieveUEContext._val = dict([('InitiatingMessage', _retrieveUEContext_val_InitiatingMessage), ('SuccessfulOutcome', _retrieveUEContext_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _retrieveUEContext_val_UnsuccessfulOutcome), ('procedureCode', 26), ('criticality', 'reject')])
    
    #-----< sgNBAdditionPreparation >-----#
    sgNBAdditionPreparation = CLASS(name='sgNBAdditionPreparation', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _sgNBAdditionPreparation_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBAdditionRequest')))
    _sgNBAdditionPreparation_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBAdditionRequestAcknowledge')))
    _sgNBAdditionPreparation_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBAdditionRequestReject')))
    sgNBAdditionPreparation._val = dict([('InitiatingMessage', _sgNBAdditionPreparation_val_InitiatingMessage), ('SuccessfulOutcome', _sgNBAdditionPreparation_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _sgNBAdditionPreparation_val_UnsuccessfulOutcome), ('procedureCode', 27), ('criticality', 'reject')])
    
    #-----< sgNBReconfigurationCompletion >-----#
    sgNBReconfigurationCompletion = CLASS(name='sgNBReconfigurationCompletion', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _sgNBReconfigurationCompletion_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBReconfigurationComplete')))
    sgNBReconfigurationCompletion._val = dict([('InitiatingMessage', _sgNBReconfigurationCompletion_val_InitiatingMessage), ('procedureCode', 28), ('criticality', 'ignore')])
    
    #-----< meNBinitiatedSgNBModificationPreparation >-----#
    meNBinitiatedSgNBModificationPreparation = CLASS(name='meNBinitiatedSgNBModificationPreparation', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _meNBinitiatedSgNBModificationPreparation_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBModificationRequest')))
    _meNBinitiatedSgNBModificationPreparation_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBModificationRequestAcknowledge')))
    _meNBinitiatedSgNBModificationPreparation_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBModificationRequestReject')))
    meNBinitiatedSgNBModificationPreparation._val = dict([('InitiatingMessage', _meNBinitiatedSgNBModificationPreparation_val_InitiatingMessage), ('SuccessfulOutcome', _meNBinitiatedSgNBModificationPreparation_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _meNBinitiatedSgNBModificationPreparation_val_UnsuccessfulOutcome), ('procedureCode', 29), ('criticality', 'reject')])
    
    #-----< sgNBinitiatedSgNBModification >-----#
    sgNBinitiatedSgNBModification = CLASS(name='sgNBinitiatedSgNBModification', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _sgNBinitiatedSgNBModification_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBModificationRequired')))
    _sgNBinitiatedSgNBModification_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBModificationConfirm')))
    _sgNBinitiatedSgNBModification_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBModificationRefuse')))
    sgNBinitiatedSgNBModification._val = dict([('InitiatingMessage', _sgNBinitiatedSgNBModification_val_InitiatingMessage), ('SuccessfulOutcome', _sgNBinitiatedSgNBModification_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _sgNBinitiatedSgNBModification_val_UnsuccessfulOutcome), ('procedureCode', 30), ('criticality', 'reject')])
    
    #-----< meNBinitiatedSgNBRelease >-----#
    meNBinitiatedSgNBRelease = CLASS(name='meNBinitiatedSgNBRelease', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _meNBinitiatedSgNBRelease_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBReleaseRequest')))
    _meNBinitiatedSgNBRelease_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBReleaseRequestAcknowledge')))
    _meNBinitiatedSgNBRelease_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBReleaseRequestReject')))
    meNBinitiatedSgNBRelease._val = dict([('InitiatingMessage', _meNBinitiatedSgNBRelease_val_InitiatingMessage), ('SuccessfulOutcome', _meNBinitiatedSgNBRelease_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _meNBinitiatedSgNBRelease_val_UnsuccessfulOutcome), ('procedureCode', 31), ('criticality', 'ignore')])
    
    #-----< sgNBinitiatedSgNBRelease >-----#
    sgNBinitiatedSgNBRelease = CLASS(name='sgNBinitiatedSgNBRelease', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _sgNBinitiatedSgNBRelease_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBReleaseRequired')))
    _sgNBinitiatedSgNBRelease_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBReleaseConfirm')))
    sgNBinitiatedSgNBRelease._val = dict([('InitiatingMessage', _sgNBinitiatedSgNBRelease_val_InitiatingMessage), ('SuccessfulOutcome', _sgNBinitiatedSgNBRelease_val_SuccessfulOutcome), ('procedureCode', 32), ('criticality', 'reject')])
    
    #-----< sgNBCounterCheck >-----#
    sgNBCounterCheck = CLASS(name='sgNBCounterCheck', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _sgNBCounterCheck_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBCounterCheckRequest')))
    sgNBCounterCheck._val = dict([('InitiatingMessage', _sgNBCounterCheck_val_InitiatingMessage), ('procedureCode', 33), ('criticality', 'reject')])
    
    #-----< sgNBChange >-----#
    sgNBChange = CLASS(name='sgNBChange', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _sgNBChange_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBChangeRequired')))
    _sgNBChange_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBChangeConfirm')))
    _sgNBChange_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBChangeRefuse')))
    sgNBChange._val = dict([('InitiatingMessage', _sgNBChange_val_InitiatingMessage), ('SuccessfulOutcome', _sgNBChange_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _sgNBChange_val_UnsuccessfulOutcome), ('procedureCode', 34), ('criticality', 'reject')])
    
    #-----< rRCTransfer >-----#
    rRCTransfer = CLASS(name='rRCTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _rRCTransfer_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'RRCTransfer')))
    rRCTransfer._val = dict([('InitiatingMessage', _rRCTransfer_val_InitiatingMessage), ('procedureCode', 35), ('criticality', 'reject')])
    
    #-----< endcX2Setup >-----#
    endcX2Setup = CLASS(name='endcX2Setup', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _endcX2Setup_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCX2SetupRequest')))
    _endcX2Setup_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCX2SetupResponse')))
    _endcX2Setup_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCX2SetupFailure')))
    endcX2Setup._val = dict([('InitiatingMessage', _endcX2Setup_val_InitiatingMessage), ('SuccessfulOutcome', _endcX2Setup_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _endcX2Setup_val_UnsuccessfulOutcome), ('procedureCode', 36), ('criticality', 'reject')])
    
    #-----< endcConfigurationUpdate >-----#
    endcConfigurationUpdate = CLASS(name='endcConfigurationUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _endcConfigurationUpdate_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCConfigurationUpdate')))
    _endcConfigurationUpdate_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCConfigurationUpdateAcknowledge')))
    _endcConfigurationUpdate_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCConfigurationUpdateFailure')))
    endcConfigurationUpdate._val = dict([('InitiatingMessage', _endcConfigurationUpdate_val_InitiatingMessage), ('SuccessfulOutcome', _endcConfigurationUpdate_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _endcConfigurationUpdate_val_UnsuccessfulOutcome), ('procedureCode', 37), ('criticality', 'reject')])
    
    #-----< secondaryRATDataUsageReport >-----#
    secondaryRATDataUsageReport = CLASS(name='secondaryRATDataUsageReport', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _secondaryRATDataUsageReport_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SecondaryRATDataUsageReport')))
    secondaryRATDataUsageReport._val = dict([('InitiatingMessage', _secondaryRATDataUsageReport_val_InitiatingMessage), ('procedureCode', 38), ('criticality', 'reject')])
    
    #-----< endcCellActivation >-----#
    endcCellActivation = CLASS(name='endcCellActivation', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _endcCellActivation_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCCellActivationRequest')))
    _endcCellActivation_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCCellActivationResponse')))
    _endcCellActivation_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCCellActivationFailure')))
    endcCellActivation._val = dict([('InitiatingMessage', _endcCellActivation_val_InitiatingMessage), ('SuccessfulOutcome', _endcCellActivation_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _endcCellActivation_val_UnsuccessfulOutcome), ('procedureCode', 39), ('criticality', 'reject')])
    
    #-----< endcPartialReset >-----#
    endcPartialReset = CLASS(name='endcPartialReset', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _endcPartialReset_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCPartialResetRequired')))
    _endcPartialReset_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCPartialResetConfirm')))
    endcPartialReset._val = dict([('InitiatingMessage', _endcPartialReset_val_InitiatingMessage), ('SuccessfulOutcome', _endcPartialReset_val_SuccessfulOutcome), ('procedureCode', 40), ('criticality', 'reject')])
    
    #-----< eUTRANRCellResourceCoordination >-----#
    eUTRANRCellResourceCoordination = CLASS(name='eUTRANRCellResourceCoordination', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _eUTRANRCellResourceCoordination_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'EUTRANRCellResourceCoordinationRequest')))
    _eUTRANRCellResourceCoordination_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'EUTRANRCellResourceCoordinationResponse')))
    eUTRANRCellResourceCoordination._val = dict([('InitiatingMessage', _eUTRANRCellResourceCoordination_val_InitiatingMessage), ('SuccessfulOutcome', _eUTRANRCellResourceCoordination_val_SuccessfulOutcome), ('procedureCode', 41), ('criticality', 'reject')])
    
    #-----< sgNBActivityNotification >-----#
    sgNBActivityNotification = CLASS(name='sgNBActivityNotification', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _sgNBActivityNotification_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'SgNBActivityNotification')))
    sgNBActivityNotification._val = dict([('InitiatingMessage', _sgNBActivityNotification_val_InitiatingMessage), ('procedureCode', 42), ('criticality', 'reject')])
    
    #-----< endcX2Removal >-----#
    endcX2Removal = CLASS(name='endcX2Removal', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _endcX2Removal_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCX2RemovalRequest')))
    _endcX2Removal_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCX2RemovalResponse')))
    _endcX2Removal_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCX2RemovalFailure')))
    endcX2Removal._val = dict([('InitiatingMessage', _endcX2Removal_val_InitiatingMessage), ('SuccessfulOutcome', _endcX2Removal_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _endcX2Removal_val_UnsuccessfulOutcome), ('procedureCode', 43), ('criticality', 'reject')])
    
    #-----< dataForwardingAddressIndication >-----#
    dataForwardingAddressIndication = CLASS(name='dataForwardingAddressIndication', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _dataForwardingAddressIndication_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'DataForwardingAddressIndication')))
    dataForwardingAddressIndication._val = dict([('InitiatingMessage', _dataForwardingAddressIndication_val_InitiatingMessage), ('procedureCode', 44), ('criticality', 'ignore')])
    
    #-----< gNBStatusIndication >-----#
    gNBStatusIndication = CLASS(name='gNBStatusIndication', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _gNBStatusIndication_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'GNBStatusIndication')))
    gNBStatusIndication._val = dict([('InitiatingMessage', _gNBStatusIndication_val_InitiatingMessage), ('procedureCode', 45), ('criticality', 'ignore')])
    
    #-----< endcConfigurationTransfer >-----#
    endcConfigurationTransfer = CLASS(name='endcConfigurationTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _endcConfigurationTransfer_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCConfigurationTransfer')))
    endcConfigurationTransfer._val = dict([('InitiatingMessage', _endcConfigurationTransfer_val_InitiatingMessage), ('procedureCode', 48), ('criticality', 'ignore')])
    
    #-----< deactivateTrace >-----#
    deactivateTrace = CLASS(name='deactivateTrace', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _deactivateTrace_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'DeactivateTrace')))
    deactivateTrace._val = dict([('InitiatingMessage', _deactivateTrace_val_InitiatingMessage), ('procedureCode', 46), ('criticality', 'ignore')])
    
    #-----< traceStart >-----#
    traceStart = CLASS(name='traceStart', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _traceStart_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'TraceStart')))
    traceStart._val = dict([('InitiatingMessage', _traceStart_val_InitiatingMessage), ('procedureCode', 47), ('criticality', 'ignore')])
    
    #-----< handoverSuccess >-----#
    handoverSuccess = CLASS(name='handoverSuccess', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _handoverSuccess_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'HandoverSuccess')))
    handoverSuccess._val = dict([('InitiatingMessage', _handoverSuccess_val_InitiatingMessage), ('procedureCode', 49), ('criticality', 'ignore')])
    
    #-----< earlyStatusTransfer >-----#
    earlyStatusTransfer = CLASS(name='earlyStatusTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _earlyStatusTransfer_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'EarlyStatusTransfer')))
    earlyStatusTransfer._val = dict([('InitiatingMessage', _earlyStatusTransfer_val_InitiatingMessage), ('procedureCode', 51), ('criticality', 'ignore')])
    
    #-----< conditionalHandoverCancel >-----#
    conditionalHandoverCancel = CLASS(name='conditionalHandoverCancel', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _conditionalHandoverCancel_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ConditionalHandoverCancel')))
    conditionalHandoverCancel._val = dict([('InitiatingMessage', _conditionalHandoverCancel_val_InitiatingMessage), ('procedureCode', 50), ('criticality', 'ignore')])
    
    #-----< endcresourceStatusReportingInitiation >-----#
    endcresourceStatusReportingInitiation = CLASS(name='endcresourceStatusReportingInitiation', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _endcresourceStatusReportingInitiation_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCResourceStatusRequest')))
    _endcresourceStatusReportingInitiation_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCResourceStatusResponse')))
    _endcresourceStatusReportingInitiation_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCResourceStatusFailure')))
    endcresourceStatusReportingInitiation._val = dict([('InitiatingMessage', _endcresourceStatusReportingInitiation_val_InitiatingMessage), ('SuccessfulOutcome', _endcresourceStatusReportingInitiation_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _endcresourceStatusReportingInitiation_val_UnsuccessfulOutcome), ('procedureCode', 54), ('criticality', 'reject')])
    
    #-----< endcresourceStatusReporting >-----#
    endcresourceStatusReporting = CLASS(name='endcresourceStatusReporting', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _endcresourceStatusReporting_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'ENDCResourceStatusUpdate')))
    endcresourceStatusReporting._val = dict([('InitiatingMessage', _endcresourceStatusReporting_val_InitiatingMessage), ('procedureCode', 53), ('criticality', 'ignore')])
    
    #-----< cellTrafficTrace >-----#
    cellTrafficTrace = CLASS(name='cellTrafficTrace', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _cellTrafficTrace_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CellTrafficTrace')))
    cellTrafficTrace._val = dict([('InitiatingMessage', _cellTrafficTrace_val_InitiatingMessage), ('procedureCode', 52), ('criticality', 'ignore')])
    
    #-----< f1CTrafficTransfer >-----#
    f1CTrafficTransfer = CLASS(name='f1CTrafficTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _f1CTrafficTransfer_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'F1CTrafficTransfer')))
    f1CTrafficTransfer._val = dict([('InitiatingMessage', _f1CTrafficTransfer_val_InitiatingMessage), ('procedureCode', 55), ('criticality', 'ignore')])
    
    #-----< uERadioCapabilityIDMapping >-----#
    uERadioCapabilityIDMapping = CLASS(name='uERadioCapabilityIDMapping', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _uERadioCapabilityIDMapping_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'UERadioCapabilityIDMappingRequest')))
    _uERadioCapabilityIDMapping_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'UERadioCapabilityIDMappingResponse')))
    uERadioCapabilityIDMapping._val = dict([('InitiatingMessage', _uERadioCapabilityIDMapping_val_InitiatingMessage), ('SuccessfulOutcome', _uERadioCapabilityIDMapping_val_SuccessfulOutcome), ('procedureCode', 56), ('criticality', 'reject')])
    
    #-----< accessAndMobilityIndication >-----#
    accessAndMobilityIndication = CLASS(name='accessAndMobilityIndication', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _accessAndMobilityIndication_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'AccessAndMobilityIndication')))
    accessAndMobilityIndication._val = dict([('InitiatingMessage', _accessAndMobilityIndication_val_InitiatingMessage), ('procedureCode', 57), ('criticality', 'ignore')])
    
    #-----< cPC-cancel >-----#
    cPC_cancel = CLASS(name='cPC-cancel', mode=MODE_VALUE, typeref=ASN1RefType(('X2AP-PDU-Descriptions', 'X2AP-ELEMENTARY-PROCEDURE')))
    _cPC_cancel_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('X2AP-PDU-Contents', 'CPC-cancel')))
    cPC_cancel._val = dict([('InitiatingMessage', _cPC_cancel_val_InitiatingMessage), ('procedureCode', 59), ('criticality', 'ignore')])
    
    _all_ = [
        _X2AP_ELEMENTARY_PROCEDURE_InitiatingMessage,
        _X2AP_ELEMENTARY_PROCEDURE_SuccessfulOutcome,
        _X2AP_ELEMENTARY_PROCEDURE_UnsuccessfulOutcome,
        _X2AP_ELEMENTARY_PROCEDURE_procedureCode,
        _X2AP_ELEMENTARY_PROCEDURE_criticality,
        X2AP_ELEMENTARY_PROCEDURE,
        _X2AP_PDU_initiatingMessage,
        _X2AP_PDU_successfulOutcome,
        _X2AP_PDU_unsuccessfulOutcome,
        X2AP_PDU,
        __InitiatingMessage_procedureCode_tab,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_0,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_0,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_0,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_1,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_1,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_2,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_2,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_2,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_3,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_3,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_3,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_4,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_4,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_4,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_5,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_5,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_5,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_6,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_6,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_6,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_7,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_7,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_7,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_8,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_8,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_8,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_9,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_9,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_9,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_10,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_10,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_11,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_11,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_11,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_12,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_12,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_12,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_13,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_13,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_13,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_14,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_14,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_14,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_15,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_15,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_15,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_16,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_16,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_16,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_17,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_17,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_18,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_18,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_18,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_19,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_19,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_19,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_20,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_20,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_20,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_21,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_21,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_21,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_22,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_22,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_23,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_23,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_24,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_24,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_24,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_25,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_25,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_25,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_26,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_26,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_27,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_28,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_29,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_30,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_31,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_32,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_33,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_34,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_35,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_36,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_37,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_38,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_39,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_40,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_41,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_42,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_43,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_44,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_45,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_46,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_47,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_48,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_49,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_50,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_51,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_52,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_53,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_54,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_55,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_56,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_57,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_58,
        _InitiatingMessage_procedureCode,
        _InitiatingMessage_criticality,
        _InitiatingMessage_value,
        InitiatingMessage,
        __SuccessfulOutcome_procedureCode_tab,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_3,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_4,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_5,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_7,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_8,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_9,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_9,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_10,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_11,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_11,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_12,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_12,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_13,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_13,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_14,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_14,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_15,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_15,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_16,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_16,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_17,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_18,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_18,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_19,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_19,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_20,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_20,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_21,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_21,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_22,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_22,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_23,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_23,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_24,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_24,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_24,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_25,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_25,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_25,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_26,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_26,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_27,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_28,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_29,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_30,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_31,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_32,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_33,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_34,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_35,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_36,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_37,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_38,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_39,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_40,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_41,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_42,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_43,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_44,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_45,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_46,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_47,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_48,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_49,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_50,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_51,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_52,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_53,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_54,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_55,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_56,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_57,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_58,
        _SuccessfulOutcome_procedureCode,
        _SuccessfulOutcome_criticality,
        _SuccessfulOutcome_value,
        SuccessfulOutcome,
        __UnsuccessfulOutcome_procedureCode_tab,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_3,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_4,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_5,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_7,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_8,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_9,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_9,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_10,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_11,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_11,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_12,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_12,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_13,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_13,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_14,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_14,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_15,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_15,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_16,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_16,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_17,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_18,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_18,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_19,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_19,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_20,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_20,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_21,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_21,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_22,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_22,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_23,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_23,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_24,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_24,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_24,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_25,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_25,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_25,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_26,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_26,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_27,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_28,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_29,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_30,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_31,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_32,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_33,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_34,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_35,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_36,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_37,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_38,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_39,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_40,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_41,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_42,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_43,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_44,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_45,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_46,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_47,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_48,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_49,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_50,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_51,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_52,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_53,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_54,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_55,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_56,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_57,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_58,
        _UnsuccessfulOutcome_procedureCode,
        _UnsuccessfulOutcome_criticality,
        _UnsuccessfulOutcome_value,
        UnsuccessfulOutcome,
        X2AP_ELEMENTARY_PROCEDURES,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_0,
        _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_0,
        _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_0,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_1,
        _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_1,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_2,
        _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_2,
        _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_2,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_3,
        _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_3,
        _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_3,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_4,
        _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_4,
        _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_4,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_5,
        _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_5,
        _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_5,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_6,
        _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_6,
        _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_6,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_7,
        _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_7,
        _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_7,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_8,
        _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_8,
        _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_8,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_9,
        _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_9,
        _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_9,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_10,
        _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_10,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_11,
        _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_11,
        _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_11,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_12,
        _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_12,
        _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_12,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_13,
        _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_13,
        _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_13,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_14,
        _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_14,
        _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_14,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_15,
        _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_15,
        _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_15,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_16,
        _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_16,
        _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_16,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_17,
        _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_17,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_18,
        _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_18,
        _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_18,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_19,
        _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_19,
        _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_19,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_20,
        _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_20,
        _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_20,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_21,
        _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_21,
        _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_21,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_22,
        _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_22,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_23,
        _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_23,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_24,
        _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_24,
        _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_24,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_25,
        _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_25,
        _X2AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_25,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_26,
        _X2AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_26,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_27,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_28,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_29,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_30,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_31,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_32,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_33,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_34,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_35,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_36,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_37,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_38,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_39,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_40,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_41,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_42,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_43,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_44,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_45,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_46,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_47,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_48,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_49,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_50,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_51,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_52,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_53,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_54,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_55,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_56,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_57,
        _X2AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_58,
        X2AP_ELEMENTARY_PROCEDURES_CLASS_1,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_0,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_0,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_0,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_1,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_1,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_2,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_2,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_2,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_3,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_3,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_3,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_4,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_4,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_4,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_5,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_5,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_5,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_6,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_6,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_6,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_7,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_7,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_7,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_8,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_8,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_8,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_9,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_9,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_9,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_10,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_10,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_11,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_11,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_11,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_12,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_12,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_12,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_13,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_13,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_13,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_14,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_14,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_14,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_15,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_15,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_15,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_16,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_16,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_16,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_17,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_17,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_18,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_18,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_18,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_19,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_19,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_19,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_20,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_20,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_20,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_21,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_21,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_21,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_22,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_22,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_23,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_23,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_24,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_24,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_24,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_25,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_25,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_25,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_26,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_26,
        X2AP_ELEMENTARY_PROCEDURES_CLASS_2,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_0,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_1,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_2,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_3,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_4,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_5,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_6,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_7,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_8,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_9,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_10,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_11,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_12,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_13,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_14,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_15,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_16,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_17,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_18,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_19,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_20,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_21,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_22,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_23,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_24,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_25,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_26,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_27,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_28,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_29,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_30,
        _X2AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_31,
        handoverPreparation,
        _handoverPreparation_val_InitiatingMessage,
        _handoverPreparation_val_SuccessfulOutcome,
        _handoverPreparation_val_UnsuccessfulOutcome,
        snStatusTransfer,
        _snStatusTransfer_val_InitiatingMessage,
        uEContextRelease,
        _uEContextRelease_val_InitiatingMessage,
        handoverCancel,
        _handoverCancel_val_InitiatingMessage,
        handoverReport,
        _handoverReport_val_InitiatingMessage,
        errorIndication,
        _errorIndication_val_InitiatingMessage,
        reset,
        _reset_val_InitiatingMessage,
        _reset_val_SuccessfulOutcome,
        x2Setup,
        _x2Setup_val_InitiatingMessage,
        _x2Setup_val_SuccessfulOutcome,
        _x2Setup_val_UnsuccessfulOutcome,
        loadIndication,
        _loadIndication_val_InitiatingMessage,
        eNBConfigurationUpdate,
        _eNBConfigurationUpdate_val_InitiatingMessage,
        _eNBConfigurationUpdate_val_SuccessfulOutcome,
        _eNBConfigurationUpdate_val_UnsuccessfulOutcome,
        resourceStatusReportingInitiation,
        _resourceStatusReportingInitiation_val_InitiatingMessage,
        _resourceStatusReportingInitiation_val_SuccessfulOutcome,
        _resourceStatusReportingInitiation_val_UnsuccessfulOutcome,
        resourceStatusReporting,
        _resourceStatusReporting_val_InitiatingMessage,
        rLFIndication,
        _rLFIndication_val_InitiatingMessage,
        privateMessage,
        _privateMessage_val_InitiatingMessage,
        mobilitySettingsChange,
        _mobilitySettingsChange_val_InitiatingMessage,
        _mobilitySettingsChange_val_SuccessfulOutcome,
        _mobilitySettingsChange_val_UnsuccessfulOutcome,
        cellActivation,
        _cellActivation_val_InitiatingMessage,
        _cellActivation_val_SuccessfulOutcome,
        _cellActivation_val_UnsuccessfulOutcome,
        x2Release,
        _x2Release_val_InitiatingMessage,
        x2APMessageTransfer,
        _x2APMessageTransfer_val_InitiatingMessage,
        seNBAdditionPreparation,
        _seNBAdditionPreparation_val_InitiatingMessage,
        _seNBAdditionPreparation_val_SuccessfulOutcome,
        _seNBAdditionPreparation_val_UnsuccessfulOutcome,
        seNBReconfigurationCompletion,
        _seNBReconfigurationCompletion_val_InitiatingMessage,
        meNBinitiatedSeNBModificationPreparation,
        _meNBinitiatedSeNBModificationPreparation_val_InitiatingMessage,
        _meNBinitiatedSeNBModificationPreparation_val_SuccessfulOutcome,
        _meNBinitiatedSeNBModificationPreparation_val_UnsuccessfulOutcome,
        seNBinitiatedSeNBModification,
        _seNBinitiatedSeNBModification_val_InitiatingMessage,
        _seNBinitiatedSeNBModification_val_SuccessfulOutcome,
        _seNBinitiatedSeNBModification_val_UnsuccessfulOutcome,
        meNBinitiatedSeNBRelease,
        _meNBinitiatedSeNBRelease_val_InitiatingMessage,
        seNBinitiatedSeNBRelease,
        _seNBinitiatedSeNBRelease_val_InitiatingMessage,
        _seNBinitiatedSeNBRelease_val_SuccessfulOutcome,
        seNBCounterCheck,
        _seNBCounterCheck_val_InitiatingMessage,
        x2Removal,
        _x2Removal_val_InitiatingMessage,
        _x2Removal_val_SuccessfulOutcome,
        _x2Removal_val_UnsuccessfulOutcome,
        retrieveUEContext,
        _retrieveUEContext_val_InitiatingMessage,
        _retrieveUEContext_val_SuccessfulOutcome,
        _retrieveUEContext_val_UnsuccessfulOutcome,
        sgNBAdditionPreparation,
        _sgNBAdditionPreparation_val_InitiatingMessage,
        _sgNBAdditionPreparation_val_SuccessfulOutcome,
        _sgNBAdditionPreparation_val_UnsuccessfulOutcome,
        sgNBReconfigurationCompletion,
        _sgNBReconfigurationCompletion_val_InitiatingMessage,
        meNBinitiatedSgNBModificationPreparation,
        _meNBinitiatedSgNBModificationPreparation_val_InitiatingMessage,
        _meNBinitiatedSgNBModificationPreparation_val_SuccessfulOutcome,
        _meNBinitiatedSgNBModificationPreparation_val_UnsuccessfulOutcome,
        sgNBinitiatedSgNBModification,
        _sgNBinitiatedSgNBModification_val_InitiatingMessage,
        _sgNBinitiatedSgNBModification_val_SuccessfulOutcome,
        _sgNBinitiatedSgNBModification_val_UnsuccessfulOutcome,
        meNBinitiatedSgNBRelease,
        _meNBinitiatedSgNBRelease_val_InitiatingMessage,
        _meNBinitiatedSgNBRelease_val_SuccessfulOutcome,
        _meNBinitiatedSgNBRelease_val_UnsuccessfulOutcome,
        sgNBinitiatedSgNBRelease,
        _sgNBinitiatedSgNBRelease_val_InitiatingMessage,
        _sgNBinitiatedSgNBRelease_val_SuccessfulOutcome,
        sgNBCounterCheck,
        _sgNBCounterCheck_val_InitiatingMessage,
        sgNBChange,
        _sgNBChange_val_InitiatingMessage,
        _sgNBChange_val_SuccessfulOutcome,
        _sgNBChange_val_UnsuccessfulOutcome,
        rRCTransfer,
        _rRCTransfer_val_InitiatingMessage,
        endcX2Setup,
        _endcX2Setup_val_InitiatingMessage,
        _endcX2Setup_val_SuccessfulOutcome,
        _endcX2Setup_val_UnsuccessfulOutcome,
        endcConfigurationUpdate,
        _endcConfigurationUpdate_val_InitiatingMessage,
        _endcConfigurationUpdate_val_SuccessfulOutcome,
        _endcConfigurationUpdate_val_UnsuccessfulOutcome,
        secondaryRATDataUsageReport,
        _secondaryRATDataUsageReport_val_InitiatingMessage,
        endcCellActivation,
        _endcCellActivation_val_InitiatingMessage,
        _endcCellActivation_val_SuccessfulOutcome,
        _endcCellActivation_val_UnsuccessfulOutcome,
        endcPartialReset,
        _endcPartialReset_val_InitiatingMessage,
        _endcPartialReset_val_SuccessfulOutcome,
        eUTRANRCellResourceCoordination,
        _eUTRANRCellResourceCoordination_val_InitiatingMessage,
        _eUTRANRCellResourceCoordination_val_SuccessfulOutcome,
        sgNBActivityNotification,
        _sgNBActivityNotification_val_InitiatingMessage,
        endcX2Removal,
        _endcX2Removal_val_InitiatingMessage,
        _endcX2Removal_val_SuccessfulOutcome,
        _endcX2Removal_val_UnsuccessfulOutcome,
        dataForwardingAddressIndication,
        _dataForwardingAddressIndication_val_InitiatingMessage,
        gNBStatusIndication,
        _gNBStatusIndication_val_InitiatingMessage,
        endcConfigurationTransfer,
        _endcConfigurationTransfer_val_InitiatingMessage,
        deactivateTrace,
        _deactivateTrace_val_InitiatingMessage,
        traceStart,
        _traceStart_val_InitiatingMessage,
        handoverSuccess,
        _handoverSuccess_val_InitiatingMessage,
        earlyStatusTransfer,
        _earlyStatusTransfer_val_InitiatingMessage,
        conditionalHandoverCancel,
        _conditionalHandoverCancel_val_InitiatingMessage,
        endcresourceStatusReportingInitiation,
        _endcresourceStatusReportingInitiation_val_InitiatingMessage,
        _endcresourceStatusReportingInitiation_val_SuccessfulOutcome,
        _endcresourceStatusReportingInitiation_val_UnsuccessfulOutcome,
        endcresourceStatusReporting,
        _endcresourceStatusReporting_val_InitiatingMessage,
        cellTrafficTrace,
        _cellTrafficTrace_val_InitiatingMessage,
        f1CTrafficTransfer,
        _f1CTrafficTransfer_val_InitiatingMessage,
        uERadioCapabilityIDMapping,
        _uERadioCapabilityIDMapping_val_InitiatingMessage,
        _uERadioCapabilityIDMapping_val_SuccessfulOutcome,
        accessAndMobilityIndication,
        _accessAndMobilityIndication_val_InitiatingMessage,
        cPC_cancel,
        _cPC_cancel_val_InitiatingMessage,
    ]

init_modules(X2AP_CommonDataTypes, X2AP_Constants, X2AP_Containers, X2AP_IEs, X2AP_PDU_Contents, X2AP_PDU_Descriptions)
